	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	p 5
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\arch\bl2105\bl2105.c' 0 11 9 26 10 32
;1 //----- bl2105.c ----- 10/25/12 -----(03/26/06)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  Hardware-specific code to implement standard operations for a ZWorld
;5 //  BL21xx series SBC (Single Board Computer )
;6 //-------------------------------------------------------------------------
;7 //  Update log (most recent first):
;8 //
;9 //
;10 //  2012-10-25 - Mark Davis (*)
;11 //               - Cleaned up hdwInit() so it works reliably for softReset
;12 //                 mode.  Prior to this it would sometimes do a CPU reset i
;13 //                 the middle of the call.
;14 //
;15 //  2012-09-11 - Mark Davis
;16 //               - Commented out code that initializes the analog outputs
;17 //                 to 0 so soft resets (restarting w/o affecting the state 
;18 //                 the digital and analog output signals) will work.
;19 //
;20 //  2011-02-15 - Mark Davis
;21 //               - Changed inefficient WrPortI() and WrPortE() calls to use
;22 //                 outi() and oute() (with assignment statements for the 2n
;23 //                 parameter to update the shadow registers).  This creates
;24 //                 much smaller, faster code for these operations.
;25 //
;26 //  2010-02-16 - Mark Davis
;27 //               - Removed call to digOutConfig() (which seems to set the
;28 //                 outputs BACKWARDS from what is requested?!?!) and added
;29 //                 the code to hdwInit() to enable the external high-curren
;30 //                 outputs.
;31 //
;32 //  2009-05-27 - Mark Davis
;33 //               - Added code to check for failed return value from anaInDr
;34 //
;35 //  2009-04-29 - Mark Davis
;36 //               - Added code to support RS-485 interface
;37 //
;38 //  2009-04-22 - Mark Davis
;39 //               - Fixes to get the ADC/DAC read/write values correct again
;40 //
;41 //  2007-03-17 - Mark Davis
;42 //               - reworking the analog input functions to drastically redu
;43 //                 the number of CPU cycles used
;44 //
;45 //-------------------------------------------------------------------------
;46 //  Notes on reading analog inputs:
;47 //
;48 //    One I/O cycle for the TLC2543 ADC consists of telling the chip which
;49 //    input to do a conversion on and then reading the data for the channel
;50 //    specified during the previous I/O cycle.
;51 //
;52 //    The DC-style functions treat the process of reading each input as an
;53 //    independent operation.  When reading more than one input, this is ver
;54 //    wasteful, as it nearly doubles the number of cycles required.
;55 //
;56 //    When multiple inputs are to be read, a much faster approach is to rea
;57 //    them in a sequence of n+1 cycles, where n is the number of inputs to
;58 //    be read.  This works as follows:
;59 //
;60 //    - cycle 1:  specify the 1st input to read and throw away the data
;61 //                read from the chip (it is outdated or garbage)
;62 //
;63 //    - cycle 2:  specify the 2nd input to read and save the data read as t
;64 //                value for the 1st input
;65 //
;66 //    - cycle n:  specify the nth input to read and save the data read as t
;67 //                value for input n-1
;68 //
;69 //    - cycle n+1: specify any input to read and save the data read as the
;70 //                value for input n
;71 //
;72 //    Also, the current code appears to do the serial I/O "manually" - i.e.
;73 //    rather than use the Rabbit's serial capabilities, it toggles digital
;74 //    outputs manually and reads the inputs manually - all of which is
;75 //    probably MUCH slower than using the clocked serial capability of the
;76 //    processor.  Unfortunately, I think the signals they choose to use are
;77 //    NOT ones that can be used by any of the serial ports (at least not in
;78 //    a clocked mode), so we are stuck with this slow approach for this
;79 //    hardware.
;80 //-------------------------------------------------------------------------
;81 
;82 #include <common.h>
;83 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
;84 #include <sys/types.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;85 #include <unistd.h>
;86 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
_LIN2SEG	.macro

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

sub 0x0E

or a

rr hl

scf

rr hl

scf

rr hl

scf

rr hl

.endm

	.cseg
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
;87 #include <sys/backup.h>
;88 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
;89 #include <sys/spi.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\spi.h' 12 54 10 3 8 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
;90 #include <sys/hdwDefs.h>
;91 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
;92 #include <busybox.h>
;93 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
;94 #include <Rabbit.h>
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
;95 #include <dcdefs.h>
;96 
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
;97 #include <stcpip.h>
;98 
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
;99 #include <sys/socket.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
;100 #include <sys/srfs.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\srfs.h' 6 17 10 7 4 28
;101 #include <sys/flashFile.h>
;102 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\flashFile.h' 15 56 20 12 3 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;103 
;104 #include <sys/farprintf.h>
;105 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
;106 //--- see hdwInit() for Digital I/O pin usage ---
;107 
;108 const char ArchName[] = { "BL2105" };
	.defseg	CONST
	.seg	CONST
_ArchName::
	.db	"BL2105",0
	.debug	G _ArchName 32 0
;109 
;110 #define  NUM_ADC   11
;111 #define  NUM_DAC    4
;112 
;113 #define  MAX_DIN   25
;114 #define  MAX_DOUT  16
;115 
;116 
;117 //--- these values can be set LOWER by the application ---
;118 const uint  NumHdwADC = NUM_ADC;
_NumHdwADC::
	.dw	0xb
	.debug	G _NumHdwADC 7 0
;119 const uint  NumHdwDAC = NUM_DAC;
_NumHdwDAC::
	.dw	0x4
	.debug	G _NumHdwDAC 7 0
;120 
;121 const uint  MaxDIN =  MAX_DIN;
_MaxDIN::
	.dw	0x19
	.debug	G _MaxDIN 7 0
;122 const uint  MaxDOUT = MAX_DOUT;
_MaxDOUT::
	.dw	0x10
	.debug	G _MaxDOUT 7 0
;123 
;124 
;125 unsigned char  __brdInitFlag;
;126 
;127 #include <hdwDefs.c>
;128 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\arch\hdwDefs.c' 10 49 8 19 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\applic.h' 28 10 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.dseg
_IntVectDesc::
	.dw	word (phys @1)
	.dw	phys @1 >> 16
	.dw	word (phys @1+15)
	.dw	phys @1+15 >> 16
	.dw	word (phys @1+29)
	.dw	phys @1+29 >> 16
	.dw	word (phys @1+36)
	.dw	phys @1+36 >> 16
	.dw	word (phys @1+43)
	.dw	phys @1+43 >> 16
	.dw	word (phys @1+50)
	.dw	phys @1+50 >> 16
	.dw	word (phys @1+57)
	.dw	phys @1+57 >> 16
	.dw	word (phys @1+65)
	.dw	phys @1+65 >> 16
	.dw	word (phys @1+72)
	.dw	phys @1+72 >> 16
	.dw	word (phys @1+83)
	.dw	phys @1+83 >> 16
	.dw	word (phys @1+97)
	.dw	phys @1+97 >> 16
	.dw	word (phys @1+105)
	.dw	phys @1+105 >> 16
	.dw	word (phys @1+113)
	.dw	phys @1+113 >> 16
	.dw	word (phys @1+122)
	.dw	phys @1+122 >> 16
	.dw	word (phys @1+131)
	.dw	phys @1+131 >> 16
	.dw	word (phys @1+140)
	.dw	phys @1+140 >> 16
	.dw	word (phys @1+149)
	.dw	phys @1+149 >> 16
	.dw	word (phys @1+154)
	.dw	phys @1+154 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+159)
	.dw	phys @1+159 >> 16
	.dw	word (phys @1+163)
	.dw	phys @1+163 >> 16
	.dw	word (phys @1+178)
	.dw	phys @1+178 >> 16
	.dw	word (phys @1+191)
	.dw	phys @1+191 >> 16
	.dw	word (phys @1+205)
	.dw	phys @1+205 >> 16
	.dw	word (phys @1+217)
	.dw	phys @1+217 >> 16
	.dw	word (phys @1+226)
	.dw	phys @1+226 >> 16
	.debug	G _IntVectDesc 33 0
	.defseg	FARCONST
	.seg	FARCONST
_hdwCfgParams::
	.dw	0x1
	.dw	0x2c
	.dw	0
	.dl	phys _adcGain
	.dl	phys @1+235
	.dw	0
	.dw	0x2
	.dw	0x2c
	.dw	0
	.dl	phys _adcOffset
	.dl	phys @1+243
	.dw	0
	.dw	0x3
	.dw	0x10
	.dw	0
	.dl	phys _dacGain
	.dl	phys @1+253
	.dw	0
	.dw	0x4
	.dw	0x10
	.dw	0
	.dl	phys _dacOffset
	.dl	phys @1+261
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
	.ds	2,0
	.debug	G _hdwCfgParams 35 8
	.defseg	FARCODE
	.seg	FARCODE
	.align	4
$$newDACCalib::
	ex	(sp),iy
$newDACCalib::
	.debug	G $newDACCalib 37 9
	.debug	{ $newDACCalib 37 193 @4 @3
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jp	nc,@3
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMinRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMaxRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsub##
	jp	m,@6
	jr	z,@6
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
@6:
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_setOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_setGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_setOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_setGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__fsub##
	jp	m,@9
	jr	z,@9
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@9:
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _setValMin)
	ld	c,phys _setValMin >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _setValMax)
	ld	c,phys _setValMax >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ld	de,_updateAOut
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	call	_KUNLOCK
@3:
	.debug	} @3 218

@2	equ	20
	ld	sp,ix
	pop	ix
	lret
@4	equ	22
	.align	4
$$newADCCalib::
	ex	(sp),iy
$newADCCalib::
	.debug	G $newADCCalib 37 9
	.debug	{ $newADCCalib 37 224 @14 @13
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@13
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMinRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMaxRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsub##
	jp	m,@16
	jr	z,@16
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
@16:
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_readOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_readOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__fsub##
	jp	m,@19
	jr	z,@19
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@19:
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_ainMin
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_ainMax
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _readValMin)
	ld	c,phys _readValMin >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _readValMax)
	ld	c,phys _readValMax >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ld	de,_updateAIn
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	call	_KUNLOCK
@13:
	.debug	} @13 249

@12	equ	20
	ld	sp,ix
	pop	ix
	lret
@14	equ	22
	.align	4
$$setStateDAC::
	ex	(sp),iy
$setStateDAC::
	.debug	G $setStateDAC 38 9
	.debug	{ $setStateDAC 38 254 @24 @23
	push	ix
	ld	ix,0
	add	ix,sp
	ld	a,(ix+11)
	or	a,a
	jr	z,@25
	ld	hl,(ix+5)
	ld	de,_dacForced
	add	hl,de
	xor	a,a
	ld	(hl),a
	jr	@26
@25:
	ld	hl,(ix+5)
	ld	de,_dacForced
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_dacForcedVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@26:
	ld	hl,(ix+5)
	ld	de,_updateAOut
	add	hl,de
	ld	a,0x1
	ld	(hl),a
@23:
	.debug	} @23 262

@22	equ	0
	pop	ix
	lret
@24	equ	2
$initIOvalues::
	.debug	G $initIOvalues 39 9
	.debug	{ $initIOvalues 39 273 @31 @30
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	push	bc
	push	de
	lcall	$readAnalogInputs
	add	sp,4
	lcall	$ReadDigInputs
	ld	(_digitalIn),de
	ld	(_digitalIn+2),bc
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@34:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@35
	ld	hl,(ix-2)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-6),hl
	ld	h,d
	ld	l,e
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-8),hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(ix-2)
	ld	de,_newRdg
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ld	hl,(ix-8)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-8)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	h,b
	ld	l,c
	ex	de,hl
	call	__uitof##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_anaIn
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@39
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_readOffset
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsubr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_readVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@39:
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xc8
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _adcRawHist)
	ld	c,phys _adcRawHist >> 16
	call	__ladd##
	ld	hl,(ix-4)
	call	__farst2##
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	e,c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-6)
	ld	de,0x6
	add	hl,de
	ld	de,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-6)
	ld	de,0x8
	add	hl,de
	ld	de,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xc8
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setAvgPeriodADC
	add	sp,4
	ld	hl,0x7d0
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setNoisePeriodADC
	add	sp,4
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@34
@35:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@42:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@43
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_lastAnaOut
	add	hl,de
	ld	de,0x3f9a
	ld	bc,0xc61c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@42
@43:
@30:
	.debug	} @30 316

@29	equ	8
	ld	sp,ix
	pop	ix
	lret
@31	equ	10
$resetAvgDataADC::
	.debug	G $resetAvgDataADC 37 9
	.debug	{ $resetAvgDataADC 37 321 @47 @46
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-2),hl
	.seg	FARCODE
	ld	h,d
	ld	l,e
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@46
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xc8
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _adcRawHist)
	ld	c,phys _adcRawHist >> 16
	call	__ladd##
	ld	hl,(hl)
	call	__farst2##
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ld	de,0x4
	add	hl,de
	ld	e,c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	ld	de,0x8
	add	hl,de
	ld	de,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	ld	c,e
	ld	de,0x6
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	call	_KUNLOCK
@46:
	.debug	} @46 333

@45	equ	2
	ld	sp,ix
	pop	ix
	lret
@47	equ	4
$setAvgPeriodADC::
	.debug	G $setAvgPeriodADC 40 9
	.debug	{ $setAvgPeriodADC 40 339 @51 @50
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@52
	ld	hl,0x1
	jr	@50
@52:
	ld	hl,(_SchedMS)
	or	a,a
	rr	hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	de,(_SchedMS)
	call	__uidiv##
	ld	(ix-2),hl
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nc,@53
	ld	h,d
	ld	l,e
	ld	(ix-2),hl
@53:
	ld	hl,(ix-2)
	ld	de,0x64
	or	a,a
	sbc	hl,de
	jr	c,@54
	jr	z,@54
	ld	h,d
	ld	l,e
	ld	(ix-2),hl
@54:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	de,0xa
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
	ld	h,d
	ld	l,e
	ld	de,(_SchedMS)
	ld	bc,hl
	mul
	ld	de,bc
	ex	de,hl
@50:
	.debug	} @50 355

@49	equ	2
	ld	sp,ix
	pop	ix
	lret
@51	equ	4
$getAvgPeriodADC::
	.debug	G $getAvgPeriodADC 41 9
	.debug	{ $getAvgPeriodADC 41 361 @57 @56
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@58
	ld	hl,0x1
	jr	@56
@58:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	de,0xa
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ipres
	ld	de,(_SchedMS)
	ld	bc,hl
	mul
	ld	de,bc
	ex	de,hl
@56:
	.debug	} @56 372

@55	equ	2
	ld	sp,ix
	pop	ix
	lret
@57	equ	4
$getAvgSamplesADC::
	.debug	G $getAvgSamplesADC 41 9
	.debug	{ $getAvgSamplesADC 41 379 @61 @60
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@62
	ld	hl,0x1
	jr	@60
@62:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	de,0xa
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ipres
@60:
	.debug	} @60 390

@59	equ	2
	ld	sp,ix
	pop	ix
	lret
@61	equ	4
$getAvgdRawIn::
	.debug	G $getAvgdRawIn 42 9
	.debug	{ $getAvgdRawIn 42 397 @65 @64
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@66
	ld	de,0
	ld	c,e
	ld	b,e
	jr	@64
@66:
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-8),hl
	ipset	2
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-8)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	ld	(ix-6),hl
	ipres
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ultof##
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	call	__uitof##
	call	__fdiv##
@64:
	.debug	} @64 413

@63	equ	8
	ld	sp,ix
	pop	ix
	lret
@65	equ	10
$getAvgdAnaIn::
	.debug	G $getAvgdAnaIn 42 9
	.debug	{ $getAvgdAnaIn 42 419 @69 @68
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@70
	ld	de,0
	ld	c,e
	ld	b,e
	jp	@68
@70:
	ld	hl,(ix+5)
	ld	de,_adcForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@71
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_adcForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@68
@71:
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-8),hl
	ipset	2
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-8)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	ld	(ix-6),hl
	ipres
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ultof##
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	call	__uitof##
	call	__fdiv##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
@68:
	.debug	} @68 437

@67	equ	8
	ld	sp,ix
	pop	ix
	lret
@69	equ	10
$updateAvgsADC::
	.debug	G $updateAvgsADC 39 9
	.debug	{ $updateAvgsADC 39 447 @74 @73
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-14
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ex	de,hl
	ld	(ix-6),hl
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@77:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@78
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xc8
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _adcRawHist)
	ld	c,phys _adcRawHist >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-12),hl
	ld	h,d
	ld	l,e
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-14),hl
@82:
	ld	hl,(ix-12)
	ld	de,0x8
	add	hl,de
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xa
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	c,@83
	ld	hl,(ix-12)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-12)
	push	hl
	ld	bc,0
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-12)
	ld	de,0x4
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0x64
	or	a,a
	sbc	hl,de
	jr	nz,@86
	ld	hl,(ix-12)
	ld	de,0x4
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@86:
	ld	hl,(ix-12)
	ld	de,0x8
	add	hl,de
	push	hl
	ld	hl,(hl)
	dec	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jp	@82
@83:
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(ix-12)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__ladd##
	ld	hl,(ix-4)
	call	__farst2##
	ex	de,hl
	ld	bc,0
	ld	hl,(ix-12)
	push	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-12)
	ld	de,0x6
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0x64
	or	a,a
	sbc	hl,de
	jr	nz,@87
	ld	hl,(ix-12)
	ld	de,0x6
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@87:
	ld	hl,(ix-12)
	ld	de,0x8
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-14)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-4)
	or	a,a
	sbc	hl,de
	jr	nc,@88
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@88:
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-4)
	or	a,a
	sbc	hl,de
	jr	c,@89
	jr	z,@89
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@89:
	ld	hl,(ix-14)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-6)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,bc
	or	a,a
	sbc	hl,de
	jr	c,@90
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-14)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x6
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	h,d
	ld	l,e
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-14)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-14)
	ld	de,0x8
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@90:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@77
@78:
@73:
	.debug	} @73 485

@72	equ	14
	ld	sp,ix
	pop	ix
	lret
@74	equ	16
$setNoisePeriodADC::
	.debug	G $setNoisePeriodADC 40 9
	.debug	{ $setNoisePeriodADC 40 490 @95 @94
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@96
	bool	hl
	ld	l,h
	jr	@94
@96:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
	ld	h,d
	ld	l,e
@94:
	.debug	} @94 497

@93	equ	0
	pop	ix
	lret
@95	equ	2
$getNoisePeriodADC::
	.debug	G $getNoisePeriodADC 41 9
	.debug	{ $getNoisePeriodADC 41 502 @99 @98
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@100
	bool	hl
	ld	l,h
	jr	@98
@100:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ipres
@98:
	.debug	} @98 511

@97	equ	2
	ld	sp,ix
	pop	ix
	lret
@99	equ	4
$getNoiseADC::
	.debug	G $getNoiseADC 43 9
	.debug	{ $getNoiseADC 43 522 @103 @102
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@104
	bool	hl
	ld	l,h
	jr	@102
@104:
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-4),hl
	ipset	2
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ld	hl,(ix+7)
	bool	hl
	jr	z,@105
	ld	hl,(ix-4)
	ld	e,0x8
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
@105:
	ipres
	ld	hl,(ix-2)
@102:
	.debug	} @102 537

@101	equ	4
	ld	sp,ix
	pop	ix
	lret
@103	equ	6
$resetNoiseDataADC::
	.debug	G $resetNoiseDataADC 37 9
	.debug	{ $resetNoiseDataADC 37 542 @108 @107
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@107
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-2),hl
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	inc	de
	inc	de
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	ld	(hl),e
	inc	hl
	ld	(hl),d
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-2)
	ld	bc,de
	ld	de,0x8
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	call	_KUNLOCK
@107:
	.debug	} @107 557

@106	equ	2
	ld	sp,ix
	pop	ix
	lret
@108	equ	4
;129 
;130 //=========================================================================
;131 _nearcall float adcGetRaw(uint ui)  { return (float) adcRaw[ui]; }
	.align	4
$$adcGetRaw::
	ex	(sp),iy
$adcGetRaw::
	.debug	G $adcGetRaw 42 9
	.debug	{ $adcGetRaw 42 131 @112 @111
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
@111:
	.debug	} @111 131

@110	equ	0
	pop	ix
	lret
@112	equ	2
;132 
;133 _nearcall float adcMinRaw(uint ui)  { return (float)0xfff; }
	.align	4
$$adcMinRaw::
	ex	(sp),iy
$adcMinRaw::
	.debug	G $adcMinRaw 42 9
	.debug	{ $adcMinRaw 42 133 @115 @114
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0xf000
	ld	bc,0x457f
@114:
	.debug	} @114 133

@113	equ	0
	pop	ix
	lret
@115	equ	2
;134 _nearcall float adcMaxRaw(uint ui)  { return 0.0; }
	.align	4
$$adcMaxRaw::
	ex	(sp),iy
$adcMaxRaw::
	.debug	G $adcMaxRaw 42 9
	.debug	{ $adcMaxRaw 42 134 @118 @117
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0
	ld	c,e
	ld	b,e
@117:
	.debug	} @117 134

@116	equ	0
	pop	ix
	lret
@118	equ	2
;135 
;136 _nearcall void adcDefaults(uint ui, float *gain, float *offset)
;137 { *gain = -0.00495;  *offset = 2055.0; }
	.align	4
$$adcDefaults::
	ex	(sp),iy
$adcDefaults::
	.debug	G $adcDefaults 44 9
	.debug	{ $adcDefaults 44 136 @121 @120
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0x339c
	ld	bc,0xbba2
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0x7000
	ld	bc,0x4500
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@120:
	.debug	} @120 137

@119	equ	0
	pop	ix
	lret
@121	equ	2
;138 
;139 _nearcall void adcCalibPoints(uint ui, float *low, float *high)
;140 { *low = -9.5;  *high = 9.5; }
	.align	4
$$adcCalibPoints::
	ex	(sp),iy
$adcCalibPoints::
	.debug	G $adcCalibPoints 44 9
	.debug	{ $adcCalibPoints 44 139 @124 @123
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@123:
	.debug	} @123 140

@122	equ	0
	pop	ix
	lret
@124	equ	2
;141 
;142 _nearcall char *adcUnits(uint ui, char *buf)  { return "V"; }
	.align	4
$$adcUnits::
	ex	(sp),iy
$adcUnits::
	.debug	G $adcUnits 45 9
	.debug	{ $adcUnits 45 142 @127 @126
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,@128
@126:
	.debug	} @126 142

@125	equ	0
	pop	ix
	lret
@127	equ	2
;143 
;144 
;145 //=========================================================================
;146 _nearcall float dacGetRaw(uint ui)  { return (float) dacRaw[ui]; }
	.align	4
$$dacGetRaw::
	ex	(sp),iy
$dacGetRaw::
	.debug	G $dacGetRaw 42 9
	.debug	{ $dacGetRaw 42 146 @131 @130
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_dacRaw
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
@130:
	.debug	} @130 146

@129	equ	0
	pop	ix
	lret
@131	equ	2
;147 
;148 _nearcall float dacMinRaw(uint ui)  { return (float)0xfff; }
	.align	4
$$dacMinRaw::
	ex	(sp),iy
$dacMinRaw::
	.debug	G $dacMinRaw 42 9
	.debug	{ $dacMinRaw 42 148 @134 @133
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0xf000
	ld	bc,0x457f
@133:
	.debug	} @133 148

@132	equ	0
	pop	ix
	lret
@134	equ	2
;149 _nearcall float dacMaxRaw(uint ui)  { return 0.0; }
	.align	4
$$dacMaxRaw::
	ex	(sp),iy
$dacMaxRaw::
	.debug	G $dacMaxRaw 42 9
	.debug	{ $dacMaxRaw 42 149 @137 @136
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0
	ld	c,e
	ld	b,e
@136:
	.debug	} @136 149

@135	equ	0
	pop	ix
	lret
@137	equ	2
;150 
;151 _nearcall void dacDefaults(uint ui, float *gain, float *offset)
;152 {  *gain = -0.002485;  *offset = 4110.0;  }
	.align	4
$$dacDefaults::
	ex	(sp),iy
$dacDefaults::
	.debug	G $dacDefaults 44 9
	.debug	{ $dacDefaults 44 151 @140 @139
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0xdb62
	ld	bc,0xbb22
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0x7000
	ld	bc,0x4580
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@139:
	.debug	} @139 152

@138	equ	0
	pop	ix
	lret
@140	equ	2
;153 
;154 _nearcall void dacCalibPoints(uint ui, float *low, float *high)
;155   {  *low = 0.5;  *high = 9.5; }
	.align	4
$$dacCalibPoints::
	ex	(sp),iy
$dacCalibPoints::
	.debug	G $dacCalibPoints 44 9
	.debug	{ $dacCalibPoints 44 154 @143 @142
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0
	ld	bc,0x3f00
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	bc,0x4118
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@142:
	.debug	} @142 155

@141	equ	0
	pop	ix
	lret
@143	equ	2
;156 
;157 _nearcall char *dacUnits(uint ui, char *buf)  { return "V"; }
	.align	4
$$dacUnits::
	ex	(sp),iy
$dacUnits::
	.debug	G $dacUnits 45 9
	.debug	{ $dacUnits 45 157 @146 @145
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,@128
@145:
	.debug	} @145 157

@144	equ	0
	pop	ix
	lret
@146	equ	2
;158 
;159 //=========================================================================
;160 
;161 
;162 unsigned char PE0Shadow, DOUTLShadow, DOUTHShadow, LEDShadow;
;163 
;164 // LCD LED
;165 #define LCDLEDADDR      0xE00B
;166 #define LCDLEDREG           0xE008
;167 
;168 // Use Port E bit 7 for LCD strobe
;169 #define LCDSTROBE           0x80
;170 #define LCDCSREGISTER   IB7CR
;171 #define LCDCSSHADOW     IB7CRShadow
;172 #define LCDCSCONFIG     0x78
;173 
;174 
;175 
;176 // Speed control bit, 1=fast mode, 0=slow mode
;177 #define DACSCB          6
;178 
;179 // Power control bit, 1=power down, 0=normal operation
;180 #define DACPCB          5
;181 
;182 // Write data to dac B and buffer mask
;183 #define WRDACB          0xA0
;184 
;185 // Write data to dac A and update dac B with buffer content mask
;186 #define WRDACA          0x80
;187 
;188 //#define DAC_CLK_SHADOW  _srPDDR     // DAC CLK line shadow register
;189 #define DAC_CLK_SHADOW  _srPDDR ## !!    // DAC CLK line shadow register
;190 #define DACCLK          3                   // DAC CLK bit
;191 
;192 #define DAC_SD_SHADOW   _srPBDR ## !!       // DAC SDO line shadow register
;193 #define DACDATA             7                   // DAC data bit
;194 
;195 #define DAC_CS_SHADOW   _PE0Shadow    // Shadow reg for external latch
;196 #define DACCS0          5                   // Chip select 0...channels 0 a
;197 #define DACCS1          6                   // Chip select 1...channels 2 a
;198 
;199 #define SLOW_MODE       0                   // DAC low power mode
;200 #define FAST_MODE       1              // DAC fast access mode
;201 
;202 #define POWER_NORMAL    0                   // DAC normal operation mode
;203 #define POWER_DOWN      1                   // DAC power-down mode
;204 
;205 
;206 
;207 #define AD_CLK_SHADOW   _srPDDR ## !!   //ADC CLK line, shadow register
;208 #define AD_CLK              3               //ADC CLK line, Port D bit 3
;209 
;210 #define AD_SD_SHADOW    _srPBDR ## !!  //Serial SDI line, shadow register
;211 #define AD_SDI          7               //Serial SDI line, Port B bit 7
;212 #define AD_SDO              0               //Serial SDO line, Port B bit 0
;213 
;214 #define AD_CS_SHADOW     _PE0Shadow    //ADC chip-select, shadow register
;215 #define AD_CS               7           //ADC chip-select, external reg bit
;216 #define AD_CS_EXTADDR   0x0004      //Addr of the external latch for bit 4
;217 
;218 #define AD12BITS        0   // number of output bits for the TLC2543
;219 #define AD8BITS     1  //   "            "
;220 
;221 #define MSB_FIRST   0
;222 #define UNIPOLAR    0
;223 
;224 
;225 //-------------------------------------------------------------------------
;226 
;227 /* START FUNCTION DESCRIPTION ********************************************
;228 digOutConfig                <BL21XX.LIB>
;229 
;230 SYNTAX:         void digOutConfig(unsigned int outputMode);
;231 
;232 DESCRIPTION:    The BL2100 high-current outputs have both sinking and
;233                 sourcing capability for channels 0 - 15. This function
;234                 must be executed at the start of your application to
;235                 initially set channels 0-15 to be OFF for the type of
;236                 circuit that you have, either sinking or sourcing.
;237 
;238                 To properly set your high-current outputs you'll need to
;239                 decide for each channel whether the output is sinking or
;240                 sourcing. The function will then assure that each output
;241                 remains OFF when the digital output control interface is
;242                 initialized.
;243 
;244                 Note: The brdInit function must be executed before calling
;245                       this function.
;246 
;247 PARAMETER1:    outputMode is a 16 bit parameter for which each bit
;248                corresponds to one of the high-current outputs.
;249 
;250                     Bit 15 = high-current output channel OUT15
;251                     Bit 14 = high-current output channel OUT14
;252                     Bit 13 = high-current output channel OUT13
;253                     Bit 12 = high-current output channel OUT12
;254                     Bit 11 = high-current output channel OUT11
;255                     Bit 10 = high-current output channel OUT10
;256                     Bit 9  = high-current output channel OUT09
;257                     Bit 8  = high-current output channel OUT08
;258                     Bit 7  = high-current output channel OUT07
;259                     Bit 6  = high-current output channel OUT06
;260                     Bit 5  = high-current output channel OUT05
;261                     Bit 4  = high-current output channel OUT04
;262                     Bit 3  = high-current output channel OUT03
;263                     Bit 2  = high-current output channel OUT02
;264                     Bit 1  = high-current output channel OUT01
;265                     Bit 0  = high-current output channel OUT00
;266 
;267                     To set the outputs set the corresponding bit to one of
;268                     the following states:
;269 
;270                     0 = Sinking type circuit
;271                     1 = Sourcing type circuit
;272 
;273                EXAMPLE:
;274                --------
;275                outputMode = 0x0ff1; // Outputs OUT15 - 12  = Sinking
;276                                     // Outputs OUT11 - 08  = Sourcing
;277                                     // Outputs OUT07 - 04  = Sourcing
;278                                     // Outputs OUT03 - 01  = Sinking
;279                                     // Output  OUT00       = Sourcing
;280 
;281 RETURN VALUE:   None.
;282 
;283 SEE ALSO:       brdInit, digOut
;284 
;285 END DESCRIPTION **********************************************************/
;286 
;287 void digOutConfig(ulong outputMode)
;288 {
$digOutConfig::
	.debug	G $digOutConfig 47 9
	.debug	{ $digOutConfig 47 287 @149 @148
	push	ix
	ld	ix,0
	add	ix,sp
;289   if (! __brdInitFlag)  return;
	ld	a,(___brdInitFlag)
	or	a,a
	jr	z,@148
;290 
;291 //--- initialize the shadow registers for the high-current outputs ---
;292   oute(0x0001, DOUTLShadow = (char) ~outputMode);
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lnot##
	ld	a,e
	ld	(_DOUTLShadow),a
	ioe ld	(1),a
;293   oute(0x0003, DOUTHShadow = (char) ~(outputMode >> 8) );
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	e,d
	ld	d,c
	ld	c,b
	ld	b,0
	call	__lnot##
	ld	a,e
	ld	(_DOUTHShadow),a
	ioe ld	(3),a
;294 
;295 //--- enable the external high-current data latch (0-7) ---
;296   oute(0x0004, PE0Shadow &= ~0x02);
	ld	a,(_PE0Shadow)
	and	a,253
	ld	(_PE0Shadow),a
	ioe ld	(4),a
;297 
;298 //--- enable the external high-current data latch (8-15) ---
;299   oute(0x0004, PE0Shadow &= ~0x04);
	ld	a,(_PE0Shadow)
	and	a,251
	ld	(_PE0Shadow),a
	ioe ld	(4),a
;300 }
@148:
	.debug	} @148 300

@147	equ	0
	pop	ix
	lret
@149	equ	2
;301 
;302 
;303 //-------------------------------------------------------------------------
;304 
;305 /* START FUNCTION DESCRIPTION ********************************************
;306 Function: int _readExtioPort ( int port );
;307 
;308 NOTE:
;309 This function is setup to provide additional hold time when
;310 accessing external I/O addresses 0000 and 0002. This routine
;311 must stay and not be changed, for the additional address
;312 hold-time to be valid.
;313 
;314 Improved by Softools to not require a copy to RAM because
;315 real tools have align and other stuff for real programmers.
;316 ************************************************************/
;317 #pragma warn -764  // turn off warning about not returning a value
;318 
;319 unsigned readExtIO (unsigned port)      // Port is 0 or 2
;320 {
$readExtIO::
	.debug	G $readExtIO 41 9
	.debug	{ $readExtIO 41 319 @153 @152
	push	ix
	ld	ix,0
	add	ix,sp
;321 #asm
push    ip

ipset   3

ld      a,l

and     a,0x03

jr      z,..read0

jr      ..skip

.align  4           

..read0:

nop

nop

ioe     ld l,(hl)   

pop     ip          

jr      ..exit

.align  4           

..skip:

ioe     ld l,(hl)   

pop     ip          

..exit:

	.seg	FARCODE
;343 }
@152:
	.debug	} @152 343

@151	equ	0
	pop	ix
	lret
@153	equ	2
;344 
;345 
;346 //-------------------------------------------------------------------------
;347 //  Determine the device ID based on external hardware settings
;348 //
;349 //  Assumes digital inputs 08-15 are connected to switches with the other
;350 //  side of each switch connected to ground
;351 //-------------------------------------------------------------------------
;352 ulong ReadDeviceID()
;353 {
$ReadDeviceID::
	.debug	G $ReadDeviceID 48 9
	.debug	{ $ReadDeviceID 48 352 @156 @155
;354   return (ulong) (~(uchar)readExtIO(2));
	ld	hl,0x2
	push	hl
	lcall	$readExtIO
	pop	de
	ld	a,l
	cpl	a
	ld	e,a
	ld	bc,0
	ld	d,c
;355 }
@155:
	.debug	} @155 355

@154	equ	0
	lret
@156	equ	0
;356 
;357 //-------------------------------------------------------------------------
;358 //  return the current state of the digital inputs
;359 //-------------------------------------------------------------------------
;360 ulong ReadDigInputs()
;361 {
$ReadDigInputs::
	.debug	G $ReadDigInputs 48 9
	.debug	{ $ReadDigInputs 48 360 @159 @158
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;362   ulong inBits;
;363 
;364   inBits  = (ulong) readExtIO(0);
	bool	hl
	ld	l,h
	push	hl
	lcall	$readExtIO
	pop	de
	ex	de,hl
	ld	hl,0
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;365   inBits |= (ulong) readExtIO(2) << 8;
	ld	l,0x2
	push	hl
	lcall	$readExtIO
	pop	de
	ex	de,hl
	ld	bc,0
	ld	c,d
	ld	d,e
	ld	e,b
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lor##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;366   inBits |= (ulong) RdPortI(PADR) << 16;
	ioi ld	a,(48)
	ld	bc,0
	ld	c,a
	ld	d,b
	ld	e,b
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lor##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;367 
;368   inBits = (inBits & ~forcedDigInMask) | forcedDigInBits;
	ld	de,(_forcedDigInMask)
	ld	bc,(_forcedDigInMask+2)
	call	__lnot##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__land##
	push	bc
	push	de
	ld	de,(_forcedDigInBits)
	ld	bc,(_forcedDigInBits+2)
	call	__lor##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;369 
;370   return inBits;
;371 }
@158:
	.debug	} @158 371

@157	equ	4
	ld	sp,ix
	pop	ix
	lret
@159	equ	6
;372 
;373 //-------------------------------------------------------------------------
;374 //  set the state of the digital outputs
;375 //-------------------------------------------------------------------------
;376 void WriteDigOutputs(ulong digOut)
;377 {
$WriteDigOutputs::
	.debug	G $WriteDigOutputs 47 9
	.debug	{ $WriteDigOutputs 47 376 @162 @161
	push	ix
	ld	ix,0
	add	ix,sp
;378   digOut = (digOut & ~forcedDigOutMask) | forcedDigOutBits;
	ld	de,(_forcedDigOutMask)
	ld	bc,(_forcedDigOutMask+2)
	call	__lnot##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__land##
	push	bc
	push	de
	ld	de,(_forcedDigOutBits)
	ld	bc,(_forcedDigOutBits+2)
	call	__lor##
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;379 
;380   oute(1, DOUTLShadow = (uchar)(digOut) );
	ld	a,(ix+5)
	ld	(_DOUTLShadow),a
	ioe ld	(1),a
;381   oute(3, DOUTHShadow = (uchar)(digOut >> 8) );
	ld	e,d
	ld	d,c
	ld	c,b
	ld	b,0
	ld	a,e
	ld	(_DOUTHShadow),a
	ioe ld	(3),a
;382 }
@161:
	.debug	} @161 382

@160	equ	0
	pop	ix
	lret
@162	equ	2
;383 
;384 
;385 //-------------------------------------------------------------------------
;386 
;387 /* START FUNCTION DESCRIPTION ********************************************
;388 anaInDriver                 <BL21XX.LIB>
;389 
;390 SYNTAX:         uint anaInDriver(uchar cmd, uchar len)
;391 
;392 DESCRIPTION:    Reads the voltage of an analog input channel by serial
;393                     clocking out an 8 bit command to the A/D device of the
;394                     following formats: This function is non-reentrant
;395 
;396 
;397 PARAMETER1:     The cmd parameter is as follows:
;398 
;399                     TLC2543 command
;400                   -------------------
;401                   D7-D4  D3-D2  D1 D0
;402                    |      |      |  |
;403                    |      |      |  +- Mode of operation
;404                    |      |      |      0 Unipolar (normally used as defaul
;405                    |      |      |      1 Bipolar
;406                    |      |      |
;407                    |      |      +---- Output data format
;408                    |      |             0 MSB first
;409                    |      |             1 LSB first (not supported by drive
;410                    |      |
;411                    |      +----------- Output data length
;412                    |                    01 8 bits
;413                    |                    00 12 bits (normally used as defaul
;414                    |                    11 16 bits (not supported by driver
;415                    |
;416                    +----------------- Channel 0 - 10
;417                                       Channel 11 = (Vref+  -  Vref-)/2
;418                                       Channel 12 = Vref-
;419                                       Channel 13 = Vref+
;420                                       Channel 14 = Software power-down
;421 
;422 PARAMETER2:    Output data length
;423                   0  = 12 bit mode
;424                   1 =  8 bit mode
;425 
;426 RETURN VALUE:   A value corresponding to the voltage on the analog input
;427                     channel, which will be:
;428 
;429                     0-4095   for 12 bit A/D conversions
;430                     0-255    for  8 bit A/D conversions
;431                     -1       indicates an EOC timeout error
;432 
;433 SEE ALSO:       anaIn, anaInVolts, brdInit
;434 
;435 END DESCRIPTION **********************************************************/
;436 
;437 //------------------------------------------------------------------------
;438 //  This driver has been designed for TI's TLC2543 ADC.
;439 // - TLC2543 using Timing for 12-Clock transfer using CS with MSB first
;440 // - TLC2543 using Timing for  8-Clock transfer using CS with MSB first
;441 //
;442 //  For complete detailed timing information, please refer to the data
;443 //  sheets.
;444 //------------------------------------------------------------------------
;445 //
;446 //    A/D DRIVER INFOR:
;447 //
;448 //      Primary Registers                           Alternate Registers
;449 //    -----------------                         -------------------
;450 //    af = General access                       af' = Port D shadow registe
;451 //    b  = Counter/timing                       bc' = Not used
;452 //    c  = External latch shadow register
;453 //    de = PDDR address                         de' = ADC rawcount
;454 //    hl = Used to return ADC rawcount          hl' = ADC CLK shadow regist
;455 //
;456 //    iy = External latch address and as a counter
;457 //    ix = PBDR address
;458 //
;459 //    Shadow Register usage:
;460 //    ----------------------
;461 //    AD_CLK_SHADOW  = PDDRShadow  (standard register)
;462 //    AD_SD_SHADOW   = PBDRShadow  (standard register)
;463 //    AD_CS_SHADOW   = PE0Shadow   (created for external latch)
;464 //
;465 //------------------------------------------------------------------------
;466 #pragma offset_labels on
;467 //    uint anaInDriver(uchar cmd, uchar len)
;468     uint anaInDriver(unsigned char cmd, unsigned char len)
;469 {
$anaInDriver::
	.debug	G $anaInDriver 49 9
	.debug	{ $anaInDriver 49 468 @165 @164
	push	ix
	ld	ix,0
	add	ix,sp
.cmd = 5
.len = 7
;470 #asm
.checkeoc:

ld      b,14               

.eocdelay:

ioi ld  a,(0x40)           

and     0x04               

jr      nz,.adcdriver      

djnz    .eocdelay          

ld      hl,-1              

jp      .exit_routine

.adcdriver:

push    ip                 

ipset   1                  

ld      hl,_srPDDR!!   

ld      a,(hl)             

ld      de,0               

exx                        

ex      af,af'             ; save-off port D shadow register


ld      a,(_srPBDR!!)   

ld      c,a                

ex      af,af'             ; retrieve port D shadow register


ld      de,0x60            

res     3,a           

ioi ld  (de),a             

ex      af,af'             ; save-off copy of port D shadow register


ld      iy,0x0004   

ld      a,(_PE0Shadow)   

res     7,a            

ld      (_PE0Shadow),a   

ioe ld  (iy),a             

ld      l,(ix+.cmd)        

ld      b,7               

.delay1:

djnz    .delay1           

ld      a,(ix+.len)       

cp      0x00              

jr      nz,.shift8Bit     

.shift12Bit:

ld      b,4               

ld      iy,0x08           

ld      ix,0x40           

.shiftMSBain:

exx                       

ioi ld  a,(ix)            

and     0x01              

or      d                 

ld      d,a               

rr      iy                

jr      c,.bypass1        

sla     d                 

.bypass1:

exx                       

sla     l                 

jr      nc,.clrbit1ain    

ld      a,c               

set     7,a          

ioi ld  (ix),a            

ld      c,a               

jr      .clkdata1an       

.clrbit1ain:

ld      a,c               

res     7,a          

ioi ld  (ix),a            

ld      c,a               

.clkdata1an:

ex      af,af'            ; retrieve copy of port D shadow register


set     3,a          

ioi ld  (de),a            

res     3,a          

ioi ld  (de),a            

ex      af,af'            ; save-off copy of port D shadow reg


djnz    .shiftMSBain      

.shift8Bit:

ld      b,8               

ld      iy,0x80           

ld      ix,0x40           

.shiftLSBain:

exx                       

ioi ld  a,(ix)            

and     0x01              

or      e                 

ld      e,a               

rr      iy                

jr      c,.bypass2        

sla e                     

.bypass2:

exx                       

sla     l                 

jr      nc,.clrbit2ain    

ld      a,c               

set     7,a          

ioi ld  (ix),a            

ld      c,a               

jr      .clkdata2ain      

.clrbit2ain:

ld      a,c               

res     7,a          

ioi     ld (ix),a         

ld      c,a               

.clkdata2ain:

ex      af,af'            ; retrieve copy of port D shadow reg


set     3,a          

ioi ld  (de),a            

res     3,a          

ioi ld  (de),a            

ex      af,af'            ; save-off copy of port D shadow reg


djnz    .shiftLSBain      

ld      (_srPBDR!!),a  

exx                       

ex      af,af'            ; retrieve copy of port D shadow reg


ld      (hl),a            

ld      iy,0x0004  

ld      a,(_PE0Shadow)  

set     7,a           

ld      (_PE0Shadow),a  

ioe ld  (iy),a            

ex      de,hl

ld      b,0xff

.waiteoc:

ioi     ld a,(0x40)       

and     0x04              

jr      z,.done           

djnz    .waiteoc          

ld      hl,-1

.done:

pop ip                    

.exit_routine:

	.seg	FARCODE
;640 }
@164:
	.debug	} @164 640

@163	equ	0
	pop	ix
	lret
@165	equ	2
;641 
;642 
;643 //-------------------------------------------------------------------------
;644 
;645 /* START FUNCTION DESCRIPTION ********************************************
;646 anaIn                           <BL21XX.LIB>
;647 
;648 SYNTAX:         int anaIn(unsigned int channel)
;649 
;650 DESCRIPTION:    Reads the state of an analog input channel. This function
;651                     is non-reentrant.
;652 
;653 PARAMETER1:     The analog input channel 0 - 10 to read.
;654 
;655 RETURN VALUE:   A value corresponding to the voltage on the analog input
;656                     channel, which will be:
;657 
;658                     0-4095  for 12 bit A/D conversions
;659 
;660 SEE ALSO:       anaInVolts, anaInCalib, anaInfast, brdInit
;661 
;662 END DESCRIPTION **********************************************************/
;663 
;664 /*
;665 uint anaIn(uint chan)
;666 {
;667   uchar  len, adcCmd, bitorder, mode;
;668 
;669 
;670   if (!__brdInitFlag OR (chan > 13))  return 2048;
;671 
;672 //--- setup the A/D command ---
;673   len = AD12BITS;
;674   bitorder = MSB_FIRST;
;675   mode = UNIPOLAR;
;676   adcCmd = (chan<<4) + (len<<2) + (bitorder<<1) + mode;
;677 
;678 //--- tell the ADC which signal to convert and read the result from the ---
;679 //--- conversion (which is useless here) ---
;680   anaInDriver(adcCmd, len);
;681 
;682 //--- now do it again, only this time the "last" conversion was the one ---
;683 //--- done for the above call, so the data will be recent and for the ---
;684 //--- desired signal ---
;685   return (anaInDriver(adcCmd, len));
;686 }
;687 */
;688 
;689 //-------------------------------------------------------------------------
;690 
;691 /* START FUNCTION DESCRIPTION ********************************************
;692 anaOutDriver                <BL21XX.LIB>
;693 
;694 SYNTAX:         void anaOutDriver(int power_control, int speed_control,
;695                                  int channel, unsigned int rawcount)
;696 
;697 DESCRIPTION:   Sets the voltage of an analog output channel by serial
;698                clocking in 16-bits to a DAC device of the following
;699                format: (This function is non-reentrant)
;700 
;701                     D15 D14 D13 D12 D11-D0
;702                      |   |   |   |   |  |
;703                      |   |   |   |   +--+---- data bits, msb-lsb (0-4095)
;704                      |   |   |   |
;705                      |   |   +---|----------- power control
;706                      |   |       |              0 = normal (default)
;707                      |   |       |              1 = power down
;708                      |   |       |
;709                      |   +-------|----------- speed control,
;710                      |           |              0 = slow
;711                      |           |              1 = fast (default)
;712                      |           |
;713                      |           +----------- register R0
;714                      +----------------------- register R1
;715                                              R1 R0
;716                                               0  0  write data to dacB
;717                                               0  1  write data to buffer
;718                                               1  0  write data to dacA
;719                                               1  1  reserved
;720 
;721 PARAMETER1:    DAC power mode option (0 or 1)
;722                     0 = Normal operation
;723                     1 = Power-down mode
;724 
;725                     When the power-down mode is selected, the only other
;726                     parameter that is used is the DAC channel (PARAMETER3).
;727                     All other parameters are don't cares.
;728 
;729                     Also when putting a DAC output in power-down or normal
;730                     mode, two DACchannels are affected, for example:
;731 
;732                     POWER-DOWN MODE:
;733                     ----------------
;734                     a) When power_control equals 1 and PARAMETER3 is channe
;735                        0 or 1, then both DAC channels 0 and 1 are put in po
;736                        down mode. (channels 2 and 3 not affected)
;737 
;738                     b) When power_control equals 1 and PARAMETER3 is channe
;739                        2 or 3, then both DAC channels 2 and 3 are put in po
;740                        down mode. (channels 0 and 1 not affected)
;741 
;742                     NORMAL OPERATION MODE:
;743                     ----------------------
;744                     a) When power_control equals 0 and PARAMETER3 is channe
;745                        0 or 1, then both DAC channels 0 and 1 are put in no
;746                        operational mode. (channels 2 and 3 not affected)
;747 
;748                     b) When power_control equals 0 and PARAMETER3 is channe
;749                        2 or 3, then both DAC channels 2 and 3 are put in no
;750                        operational mode. (channels 0 and 1 not affected)
;751 
;752 PARAMETER2:    DAC speed control (0 or 1)
;753 
;754                     Mode of operation  Speed versus power dissipation
;755                     ----------------   ------------------------------
;756                     0 = Slow mode        12us access vs. 1 mA (see Note)
;757                     1 = Fast mode         3us access vs. 2.3 mA (see Note)
;758 
;759                Note: Test conditions from TI's data sheet for the speed
;760                      control option:
;761                      - No load.
;762                      - All inputs are at GND or VDD.
;763                      - DAC latch = 0x800.
;764 
;765 PARAMETER3:     The DAC output channel to write (0-3).
;766 PARAMETER4:     A data value corresponding to the desired voltage on the
;767                analog output channel (0-4095).
;768 
;769 
;770 RETURN VALUE:   None
;771 
;772 SEE ALSO:       anaOut, anaOutVolts, anaOutCalib
;773 
;774 END DESCRIPTION **********************************************************/
;775 
;776 #pragma offset_labels on
;777            void anaOutDriver(int power_control, int speed_control,
;778                               int channel, unsigned int rawcount)
;779 {
$anaOutDriver::
	.debug	G $anaOutDriver 50 9
	.debug	{ $anaOutDriver 50 777 @168 @167
	push	ix
	ld	ix,0
	add	ix,sp
.power_control = 5
.speed_control = 7
.channel = 9
.rawcount = 11
;780 //------------------------------------------------------------------------
;781 //  This driver has been designed for TI's TLV5618A DAC chip.
;782 //
;783 //    Note: Upon power-up the DAC A and DAC B are in normal operational
;784 //          mode and the outputs will be at approx zero volts.
;785 //
;786 //------------------------------------------------------------------------
;787 //
;788 //    DAC DRIVER INFOR:
;789 //
;790 //    Primary Registers                    Alternate Registers
;791 //    -----------------                    -------------------
;792 //    af = General access                  af' = Not used
;793 //    b  = Used as a counter               b'  = Not used
;794 //    c  = DAC CLK shadow register         c'  = External latch shadow reg
;795 //    de = DAC CLK Port D address          de' = External latch address
;796 //    hl = DAC command word                hl' = Not used
;797 //
;798 //    iy = DAC SD port B address
;799 //    ix = Index for function parameters
;800 //
;801 //    Shadow Register usage:
;802 //    ----------------------
;803 //    DAC_CLK_SHADOW  = PDDRShadow  (standard register)
;804 //    DAC_SD_SHADOW   = PBDRShadow  (standard register)
;805 //    DAC_CS_SHADOW   = PE0Shadow   (created for external latch)
;806 //
;807 //------------------------------------------------------------------------
;808 #asm
push  ip                    

ipset   1                   

ld    de,0x0004             

ld    a,(_PE0Shadow)     

ld    c,a

exx                         

ld    a,(_srPDDR!!)    

ld    c,a

ld    de,0x60               

ld    iy,0x40               

ld      hl,(ix+.rawcount)   

.speedcntrl:

ld    a,(ix+.speed_control) 

cp    0                     

jr    z,.slow               

set 6,h                

jr    .powercntrl           

.slow:

res   6,h              

.powercntrl:

ld    a,(ix+.power_control) 

cp    0                     

jr    nz,.powerdown         

res 5,h                

jr    .dacselect            

.powerdown:

set   5,h              

.dacselect:

ld      a,(ix+.channel)     

and 0x01                    

cp    0                     

jr      z,.wrtoa            

ld    a,h                   

and     0x5f                

jp      .clockhigh          

.wrtoa:

ld  a,h                     

or      0x80              

.clockhigh:

ld  h,a                     

ld    a,c                   

set 3,a                

ioi ld (de),a               

ld    c,a                   

.chipselect:

exx                         

ld      a,(ix+.channel)     

srl a                       

cp      0                   

jr      nz,.cs1             

res 5,c                

jr      .assertcs           

.cs1:

res 6,c                

.assertcs:

ld    a,c

ioe   ld (de),a             

.shiftdataMSB:

exx                         

ld      b,8                 

ld    a,(_srPBDR!!)     

.shiftMSB:

sla h

jr      nc,.clrbit1         

set 7,a               

jp      .wrdata1            

.clrbit1:

res 7,a               

.wrdata1:

ioi ld (iy),a               

.clkdata1:

ex      af,af'


ld    a,c

res 3,a                

ioi ld (de),a               

set 3,a                

ioi ld (de),a               

ld    c,a

ex      af,af'


djnz    .shiftMSB           

.shiftdataLSB:

ld      b,8                 

.shiftLSB:

sla l                       

jr      nc,.clrbit2         

set 7,a               

jp      .wrdata2            

.clrbit2:

res 7,a               

.wrdata2:

ioi ld (iy),a               

.clkdata2:

ex      af,af'


ld     c,a

res 3,a                

ioi ld (de),a               

set 3,a                

ioi ld (de),a               

ld    c,a

ex      af,af'


djnz    .shiftLSB           

.cshigh:

ex      af,af'


ld    (_srPBDR!!),a     

ld    a,c                   

ld    (_srPDDR!!),a    

exx                         

ld      a,c                 

set   5,a              

set     6,a

ioe ld (de),a               

ld    (_PE0Shadow),a     

pop ip                      

	.seg	FARCODE
;952 }
@167:
	.debug	} @167 952

@166	equ	0
	pop	ix
	lret
@168	equ	2
;953 
;954 
;955 
;956 //-------------------------------------------------------------------------
;957 
;958 /* START FUNCTION DESCRIPTION ********************************************
;959 anaOut                      <BL21XX.LIB>
;960 
;961 SYNTAX:         int anaOut(unsigned int channel, unsigned int rawcount)
;962 
;963 DESCRIPTION:    Sets the voltage on a given analog output channel. This
;964                function is non-reentrant.
;965 
;966 PARAMETER1:     The DAC output channel to write (0 - 3).
;967 PARAMETER2:     A data value corresponding to the desired voltage on the
;968                analog output channel (0-4095).
;969 
;970 RETURN VALUE:   0 if successful
;971                     -1 if rawcount parameter is greater than 4095
;972 
;973 SEE ALSO:       anaOutDriver, anaOutVolts, anaOutCalib
;974 
;975 END DESCRIPTION **********************************************************/
;976 
;977 int anaOut_(unsigned int channel, unsigned int rawcount)
;978 {
$anaOut_::
	.debug	G $anaOut_ 51 9
	.debug	{ $anaOut_ 51 977 @171 @170
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
.channel = 5
.rawcount = 7
;979     auto unsigned int power_control, speed_control;
.power_control = -2
.speed_control = -4
;980 
;981     if (!__brdInitFlag OR (channel > 3))  return -1;
	ld	a,(___brdInitFlag)
	or	a,a
	jr	z,@172
	ld	hl,(ix+5)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	c,@173
	jr	z,@173
@172:
	ld	hl,0xffff
	jr	@170
;982 
;983     if (rawcount > 4095)  return -1;
@173:
	ld	hl,(ix+7)
	ld	de,0xfff
	or	a,a
	sbc	hl,de
	jr	c,@174
	jr	z,@174
	ld	h,e
	ld	l,e
	jr	@170
;984 
;985     power_control = POWER_NORMAL;
@174:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;986     speed_control = FAST_MODE;
	inc	l
	ld	(ix-4),hl
;987     anaOutDriver(power_control, speed_control, channel, rawcount);
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$anaOutDriver
	add	sp,8
;988 }
@170:
	.debug	} @170 988

@169	equ	4
	ld	sp,ix
	pop	ix
	lret
@171	equ	6
;989 
;990 #pragma warn 764  // turn back on warning about not returning a value
;991 
;992 
;993 //-------------------------------------------------------------------------
;994 //  Read 1 or more analog inputs.  Each input is represented by a bit in th
;995 //  mask parameter.  For each non-zero bit, the corresponding ADC signal is
;996 //  read and the resulting raw value stored in the adcRaw[] array.
;997 //-------------------------------------------------------------------------
;998 void readAnalogInputs(ulong mask)
;999 {
$readAnalogInputs::
	.debug	G $readAnalogInputs 47 9
	.debug	{ $readAnalogInputs 47 998 @177 @176
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
.mask = 5
;1000   uchar  len, adcCmd, bitorder, mode;
.len = -1
.adcCmd = -2
.bitorder = -3
.mode = -4
;1001   uint  i, prevIdx, rawVal, bitTest;
.i = -6
.prevIdx = -8
.rawVal = -10
.bitTest = -12
;1002 
;1003 
;1004   if (!__brdInitFlag OR !mask)  return;
	ld	a,(___brdInitFlag)
	or	a,a
	jr	z,@178
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	or	hl,de
	jr	nz,@179
@178:
;1005 
;1006 //--- setup the A/D command ---
;1007   len = AD12BITS;
	jp	@176
@179:
	xor	a,a
	ld	(ix-1),a
;1008   bitorder = MSB_FIRST;
	xor	a,a
	ld	(ix-3),a
;1009   mode = UNIPOLAR;
	xor	a,a
	ld	(ix-4),a
;1010   adcCmd = (len<<2) + (bitorder<<1) + mode;
	bool	hl
	ld	l,(ix-1)
	add	hl,hl
	add	hl,hl
	ld	d,0
	ld	e,(ix-3)
	ex	de,hl
	add	hl,hl
	add	hl,de
	ld	d,0
	ld	e,a
	add	hl,de
	ld	(ix-2),l
;1011 
;1012 //--- Each I/O cycle on the ADC consists of telling it which signal to read
;1013 //--- and convert (starting at the end of the cycle) and reading the result
;1014 //--- of the previous conversion.  Therefore, we have to do n+1 I/O cycles 
;1015 //---- to read n signals ---
;1016   prevIdx = 255;
	ld	hl,0xff
	ld	(ix-8),hl
;1017   for (i=0,bitTest=1; i<NUM_ADC; ++i,bitTest<<=1)  {
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	inc	l
	ld	(ix-12),hl
@182:
	ld	hl,(ix-6)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jr	nc,@183
;1018     if (!(bitTest & (uint)mask))
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	and	hl,de
	jr	nz,@187
;1019       adcRaw[i] = 0;
	ld	hl,(ix-6)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1020     else  {
	jr	@188
@187:
;1021       adcCmd = (i << 4) | (adcCmd & 0x0f);
	ld	hl,(ix-6)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	a,(ix-2)
	and	a,15
	ld	d,0
	ld	e,a
	or	hl,de
	ld	(ix-2),l
;1022       rawVal = anaInDriver(adcCmd, len);
	bool	hl
	ld	l,(ix-1)
	push	hl
	bool	hl
	ld	l,(ix-2)
	push	hl
	lcall	$anaInDriver
	add	sp,4
	ld	(ix-10),hl
;1023       if ((prevIdx < NUM_ADC) AND !(rawVal & 0xF000)) adcRaw[prevIdx] = raw
	ld	hl,(ix-8)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jr	nc,@192
	ld	hl,(ix-10)
	ld	de,0xf000
	and	hl,de
	jr	nz,@192
	ld	hl,(ix-8)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1024       prevIdx = i;
@192:
	ld	hl,(ix-6)
	ld	(ix-8),hl
;1025     }
;1026   }
@188:
;1027   if (prevIdx < NUM_ADC) {
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	ld	hl,(ix-12)
	add	hl,hl
	ld	(ix-12),hl
	jr	@182
@183:
	ld	hl,(ix-8)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jr	nc,@193
;1028     rawVal = anaInDriver(adcCmd, len);
	bool	hl
	ld	l,(ix-1)
	push	hl
	bool	hl
	ld	l,(ix-2)
	push	hl
	lcall	$anaInDriver
	add	sp,4
	ld	(ix-10),hl
;1029     if (!(rawVal & 0xF000))  adcRaw[prevIdx] = rawVal;
	ld	de,0xf000
	and	hl,de
	jr	nz,@196
	ld	hl,(ix-8)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1030   }
@196:
;1031 
;1032 }
@193:
@176:
	.debug	} @176 1032

@175	equ	12
	ld	sp,ix
	pop	ix
	lret
@177	equ	14
;1033 
;1034 //-------------------------------------------------------------------------
;1035 void writeAnalogOutputs(ulong mask)
;1036 {
$writeAnalogOutputs::
	.debug	G $writeAnalogOutputs 47 9
	.debug	{ $writeAnalogOutputs 47 1035 @199 @198
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
.mask = 5
;1037   uint  i, bitTest;
.i = -2
.bitTest = -4
;1038 
;1039   for (i=0,bitTest=1; i<NumHdwDAC; ++i,bitTest<<=1)
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	inc	l
	ld	(ix-4),hl
@202:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@203
;1040     if (bitTest & (uint)mask)  anaOut_(i, dacRaw[i]);
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	and	hl,de
	jr	z,@205
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_dacRaw
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$anaOut_
	add	sp,4
;1041 }
@205:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-4)
	add	hl,hl
	ld	(ix-4),hl
	jr	@202
@203:
@198:
	.debug	} @198 1041

@197	equ	4
	ld	sp,ix
	pop	ix
	lret
@199	equ	6
;1042 
;1043 
;1044 //-------------------------------------------------------------------------
;1045 /*
;1046 float ADCtoVolts(uchar chan, uint rawADC)
;1047 {
;1048   return (ADCOffset(chan) - (float)(rawADC)) * ADCGain(chan);
;1049 
;1050 //  return  (float) (((long)(adcOffset_[chan]-(int)(rawADC)) * adcGain_[cha
;1051 //                   / 4194304.0;
;1052 }
;1053 */
;1054 
;1055 //-------------------------------------------------------------------------
;1056 //  Set an External 2/4-wire RS-485 adapter to transmit mode
;1057 //-------------------------------------------------------------------------
;1058 void setExt485Tx(void)
;1059 {
$setExt485Tx::
	.debug	G $setExt485Tx 39 9
	.debug	{ $setExt485Tx 39 1058 @208 @207
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;1060   ulong  digOut;
.digOut = -4
;1061 
;1062   _EnterCritical_();
	ipset	2
;1063 
;1064 //--- set external 2/4-wire adapter to Transmit mode (uses DO-07) ---
;1065   forcedDigOutMask |= 0x000000C0L;
	ld	de,(_forcedDigOutMask)
	ld	bc,(_forcedDigOutMask+2)
	set	6,e
	set	7,e
	ld	(_forcedDigOutMask),de
	ld	(_forcedDigOutMask+2),bc
;1066   forcedDigOutBits = forcedDigOutBits & 0xFFFF3FL | 0x00000080L;
	ld	de,(_forcedDigOutBits)
	ld	bc,(_forcedDigOutBits+2)
	push	bc
	push	de
	ld	de,0xff3f
	ld	bc,0xff
	call	__land##
	set	7,e
	ld	(_forcedDigOutBits),de
	ld	(_forcedDigOutBits+2),bc
;1067 
;1068 //  WriteDigOutputs(digitalOut);
;1069 
;1070   digOut = (digitalOut & ~forcedDigOutMask) | forcedDigOutBits;
	ld	de,(_forcedDigOutMask)
	ld	bc,(_forcedDigOutMask+2)
	call	__lnot##
	push	bc
	push	de
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	call	__land##
	push	bc
	push	de
	ld	de,(_forcedDigOutBits)
	ld	bc,(_forcedDigOutBits+2)
	call	__lor##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1071 
;1072   oute(1, DOUTLShadow = (uchar)(digOut) );
	ld	a,(ix-4)
	ld	(_DOUTLShadow),a
	ioe ld	(1),a
;1073 //  oute(3, DOUTHShadow = (uchar)((uint)digOut >> 8) );
;1074 
;1075   _ExitCritical_();
	ipres
;1076 }
@207:
	.debug	} @207 1076

@206	equ	4
	ld	sp,ix
	pop	ix
	lret
@208	equ	6
;1077 
;1078 
;1079 //-------------------------------------------------------------------------
;1080 //  Functions to enable/disable the transmitter for an RS-485 connection.
;1081 //
;1082 //  WARNING:
;1083 //    These functions are called from an interrupt handler, so they must be
;1084 //    short and sweet!
;1085 //-------------------------------------------------------------------------
;1086 
;1087 #pragma offset_labels on
;1088 
;1089 #define  EXT_485_RX      0x000040  // 06: enable Tx on extern 2/4-wire adap
;1090 #define  EXT_485_TX      0x000080  // 07: enable Rx on extern 2/4-wire adap
;1091 
;1092 #define  EXT_485_RX_TX      0x0000C0  // both Tx and Rx bits
;1093 #define  NOT_EXT_485_RX_TX  0x00003F  // all BUT Tx & Rx bits (for 8-bit va
;1094 
;1095 extern ulong digitalOut;
;1096 
;1097 
;1098 //------------------------------------------
;1099 void _nearcall SerSetDirA(int enableXmit)  {  }
	.align	4
$$SerSetDirA::
	ex	(sp),iy
$SerSetDirA::
	.debug	G $SerSetDirA 52 9
	.debug	{ $SerSetDirA 52 1099 @211 @210
	push	ix
	ld	ix,0
	add	ix,sp
.enableXmit = 5
@210:
	.debug	} @210 1099

@209	equ	0
	pop	ix
	lret
@211	equ	2
;1100 
;1101 //------------------------------------------
;1102 void _nearcall SerSetDirB(int enableXmit)  {  }
	.align	4
$$SerSetDirB::
	ex	(sp),iy
$SerSetDirB::
	.debug	G $SerSetDirB 52 9
	.debug	{ $SerSetDirB 52 1102 @214 @213
	push	ix
	ld	ix,0
	add	ix,sp
.enableXmit = 5
@213:
	.debug	} @213 1102

@212	equ	0
	pop	ix
	lret
@214	equ	2
;1103 
;1104 //------------------------------------------
;1105 void _nearcall SerSetDirC(int enableXmit)  {  }
	.align	4
$$SerSetDirC::
	ex	(sp),iy
$SerSetDirC::
	.debug	G $SerSetDirC 52 9
	.debug	{ $SerSetDirC 52 1105 @217 @216
	push	ix
	ld	ix,0
	add	ix,sp
.enableXmit = 5
@216:
	.debug	} @216 1105

@215	equ	0
	pop	ix
	lret
@217	equ	2
;1106 
;1107 //-------------------------------------------
;1108 //  uses Digital Outputs 6 and 7 to ctl
;1109 //  xmit and rcv modes on extern 2/4 adapter
;1110 //  WARNING:
;1111 //    Usually called by a _fastint function so
;1112 //    save all registers used!!!
;1113 //-------------------------------------------
;1114 void _nearcall SerSetDirD(int enableXmit)
;1115 {
	.align	4
$$SerSetDirD::
	ex	(sp),iy
$SerSetDirD::
	.debug	G $SerSetDirD 52 9
	.debug	{ $SerSetDirD 52 1114 @220 @219
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
.enableXmit = 5
;1116   ulong  digOut;
.digOut = -4
;1117 
;1118   INT_SAVE_ALL();
push ix
push iy
push hl
push de
push bc
push af
exx
push hl
push de
push bc
exx
ex af,af'
push af
ex af,af'
;1119 
;1120   _EnterCritical_();
	ipset	2
;1121 
;1122   if (enableXmit)  {
	ld	hl,(ix+5)
	bool	hl
	jr	z,@221
;1123   //--- enable the driver in the on-board SP483EN transceiver ---
;1124     oute(0x0004, PE0Shadow |= 0x01);
	ld	a,(_PE0Shadow)
	or	a,1
	ld	(_PE0Shadow),a
	ioe ld	(4),a
;1125 //    ioSetBitE(0x0004, 1);
;1126 
;1127   //--- set external 2/4-wire adapter to Transmit mode (uses DO-07) ---
;1128 /* for some odd timing reason I don't yet understand, this actually takes
;1129    effect LATER (?!?!?!?) so for now it is in setExt485Tx() which must be
;1130    called before actually writing new data to the serial port
;1131     forcedDigOutMask |= 0x000000C0L;
;1132     forcedDigOutBits = forcedDigOutBits & 0xFFFF3FL | 0x00000080L;
;1133 
;1134     digOut = (digitalOut & ~forcedDigOutMask) | forcedDigOutBits;
;1135 
;1136     oute(1, DOUTLShadow = (uchar)(digOut) );
;1137 */
;1138   }
;1139   else  {  // called by serial lib's isrSendCommon() ISR
	jr	@224
@221:
;1140   //--- disable the driver in the on-board SP483EN transceiver ---
;1141     oute(0x0004, PE0Shadow &= 0xfe);
	ld	a,(_PE0Shadow)
	and	a,254
	ld	(_PE0Shadow),a
	ioe ld	(4),a
;1142 //    ioClearBitE(0x0004, 1);
;1143 
;1144   //--- set external 2/4-wire adapter to Receive mode (uses DO-06) ---
;1145     forcedDigOutMask |= 0x000000C0L;
	ld	de,(_forcedDigOutMask)
	ld	bc,(_forcedDigOutMask+2)
	set	6,e
	set	7,e
	ld	(_forcedDigOutMask),de
	ld	(_forcedDigOutMask+2),bc
;1146     forcedDigOutBits = forcedDigOutBits & 0xFFFF3FL | 0x00000040L;
	ld	de,(_forcedDigOutBits)
	ld	bc,(_forcedDigOutBits+2)
	push	bc
	push	de
	ld	de,0xff3f
	ld	bc,0xff
	call	__land##
	set	6,e
	ld	(_forcedDigOutBits),de
	ld	(_forcedDigOutBits+2),bc
;1147 
;1148     digOut = (digitalOut & ~forcedDigOutMask) | forcedDigOutBits;
	ld	de,(_forcedDigOutMask)
	ld	bc,(_forcedDigOutMask+2)
	call	__lnot##
	push	bc
	push	de
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	call	__land##
	push	bc
	push	de
	ld	de,(_forcedDigOutBits)
	ld	bc,(_forcedDigOutBits+2)
	call	__lor##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1149 
;1150     oute(1, DOUTLShadow = (uchar)(digOut) );
	ld	a,(ix-4)
	ld	(_DOUTLShadow),a
	ioe ld	(1),a
;1151   }
;1152 
;1153   _ExitCritical_();
@224:
	ipres
;1154 
;1155   INT_RESTORE_ALL();
ex af,af'
pop af
ex af,af'
exx
pop bc
pop de
pop hl
exx
pop af
pop bc
pop de
pop hl
pop iy
pop ix
;1156 
;1157 /*
;1158   if (enableXmit)  {  ;
;1159 #asm
;1160     push  ip                ; Save off IP state
;1161     ipset  2                ; Set interrupt priority to level 2
;1162 
;1163 ;;--- enable the driver in the on-board SP843EN transceiver ---
;1164     ld    a,(_PE0Shadow)    ; Get copy of shadow register
;1165     or    01h               ; Set shadow register bit 0
;1166     ld    (_PE0Shadow),a    ; Update shadow register
;1167     ld    bc, 0x0004        ; Load BC w/ext addr of the control latch
;1168     ioe ld  (bc),a          ; Set bit 0 on ext latch via addr 0x0004
;1169 
;1170     pop   ip                ; Restore IP to the previous state
;1171 #endasm
;1172   }
;1173   else  {  ;
;1174 #asm
;1175     push  ip                ; Save off IP state
;1176     ipset  2                ; Set interrupt priority to level 2
;1177 #endasm
;1178 
;1179   //--- set external 2/4-wire adapter to Transmit mode ---
;1180     forcedDigOutMask |= 0x000000C0L;
;1181     forcedDigOutBits = forcedDigOutBits & 0xFFFF3FL | 0x00000040L;
;1182 
;1183     digOut = (digitalOut & ~forcedDigOutMask) | forcedDigOutBits;
;1184 
;1185     oute(1, DOUTLShadow = (uchar)(digOut) );
;1186     oute(3, DOUTHShadow = (uchar)((uint)digOut >> 8) );
;1187     ;
;1188 #asm
;1189 ;;--- disable the driver in the on-board SP483EN transceiver ---
;1190     ld    a,(_PE0Shadow)    ; Get copy of shadow reg
;1191     and ~0x01               ; Clear shadow register bit 0
;1192     ld    (_PE0Shadow),a    ; Update shadow reg
;1193     ld    bc,0x0004         ; Load BC w/addr of external control latch
;1194     ioe ld  (bc),a          ; Set bit 0 low on ext latch at addr 0x0004
;1195 
;1196     pop   ip                ; Restore IP to the previous state
;1197 #endasm
;1198   }
;1199 */
;1200 }
@219:
	.debug	} @219 1200

@218	equ	4
	ld	sp,ix
	pop	ix
	lret
@220	equ	6
;1201 
;1202 //-------------------------------------------------------------------------
;1203 /*
;1204 SYNTAX:         void hdwInit(unsigned long digOutState);
;1205 
;1206 DESCRIPTION:    Call this function at the beginning of application code.
;1207                     1.Initializes the system I/O ports.
;1208                     2.Loads all the A/D and DAC calibration constants from
;1209                       flash and puts them into memory, ready for applicatio
;1210                       program use.
;1211                     3.Will turn-off LED DS1 to indicate that the controller
;1212                       was successfully initialized. This only applies if th
;1213                       LCD/KEYPAD module is installed.
;1214 
;1215                    Note: This function is non-reentrant.
;1216 
;1217                *** Rabbit Ports A, B, C, D, and E Initialization ***
;1218 
;1219                Port  IO   Function               I/O State
;1220                ----  ---  ------------------     ------------
;1221                PA.0  In   Digital input,IN16     Pulled-up
;1222                PA.1  In   Digital input,IN17     Pulled-up
;1223                PA.2  In   Digital input,IN18     Pulled-up
;1224                PA.3  In   Digital input,IN19     Pulled-up
;1225                PA.4  In   Digital input,IN20     Pulled-up
;1226                PA.5  In   Digital input,IN21     Pulled-up
;1227                PA.6  In   Digital input,IN22     Pulled-up
;1228                PA.7  In   Digital input,IN23     Pulled-up
;1229 
;1230                ----  ---  ------------------     ------------
;1231                PB.0  In   DAC_ADC_SDO            Pulled-up
;1232                PB.1  In   Not used               Pulled-up
;1233                PB.2  In   ADC EOC line           Driven by ADC
;1234                PB.3  In   Not used               Pulled-up
;1235                PB.4  In   I/O config option      1 = standard  (JP2)
;1236                "     In   "                      0 = custom
;1237                PB.5  In   Analog circuit option  1 = installed (JP3)
;1238                "     In   "                      0 = not installed
;1239                PB.6  Out  Not used               Low
;1240                "     Out  LED control (RCM2300)  Low...led OFF
;1241                PB.7  Out  DAC_ADC_SDI            high
;1242 
;1243                ----  ---  ------------------     ------------
;1244                PC.0  Out  TXD (RS485)            Inactive high
;1245                PC.1  In   RXD (RS485)            Inactive high
;1246                PC.2  Out  TXC (RS232)            Inactive high
;1247                PC.3  In   RXC (RS232)            Inactive high
;1248                PC.4  Out  Realtek reset          Initial'ed by sock_init()
;1249                PC.5  In   Realtek INT0           Pulled-up
;1250                PC.6  Out  TXA                    Inactive high
;1251                PC.7  In   RXA                    Inactive high
;1252 
;1253                ----  ---  ------------------     ------------
;1254                PD.0  In   Realtek CLK (RCM2200)  Initial'ed by sock_init()
;1255                PD.1  In   Realtek SDO (RCM2200)  Initial'ed by sock_init()
;1256                PD.2  Out  Not used               High
;1257                PD.3  Out  DAC CLK line           High
;1258                PD.4  Out  ATXB (RS232)           Inactive high
;1259                PD.5  In   ARXB (RS232)           Inactive high
;1260                PD.6  Out  Not used               High
;1261                PD.7  Out  Not used               High
;1262 
;1263                ----  ---  ------------------     ------------
;1264                PE.0  Out  Digital I/O strobe     High
;1265                PE.1  Out  External I/O enable    High
;1266                PE.2  N/A  Realtek IORB strobe    Initial'ed by sock_init()
;1267                PE.3  N/A  Realtek SDI line       Initial'ed by sock_init()
;1268                PE.4  In   INT0B                  Tied to PE5 via 1k resisto
;1269                PE.5  In   INT1B                  User interrupt input **
;1270                PE.6  N/A  Realtek IOWB strobe    Initial'ed by sock_init()
;1271                PE.7  Out  LCD_KEYPAD strobe      High
;1272 
;1273                ** PE5 is driven by PE4, if the interrupt is not being used.
;1274 
;1275 PARAMETER:      None
;1276 
;1277 RETURN VALUE:   None
;1278 
;1279 END DESCRIPTION **********************************************************/
;1280 
;1281 //-------------------------------------------------------------------------
;1282 void hdwInit(ulong digOutState)
;1283 {
$hdwInit::
	.debug	G $hdwInit 47 9
	.debug	{ $hdwInit 47 1282 @229 @228
	push	ix
	ld	ix,0
	add	ix,sp
.digOutState = 5
;1284   hdwType = HT_BL2105;
	ld	hl,0x1
	ld	(_hdwType),hl
;1285 
;1286   __brdInitFlag = TRUE;
	ld	a,l
	ld	(___brdInitFlag),a
;1287 
;1288 // Initialize variables using the global initialization chain
;1289   PE0Shadow = 0xEE;
	ld	a,0xee
	ld	(_PE0Shadow),a
;1290   DOUTLShadow = 0x00;
	xor	a,a
	ld	(_DOUTLShadow),a
;1291   DOUTHShadow = 0x00;
	xor	a,a
	ld	(_DOUTHShadow),a
;1292   LEDShadow = 0x00;
	xor	a,a
	ld	(_LEDShadow),a
;1293 
;1294 // (NI) = Normal Input
;1295 // (NO) = Normal Output
;1296 // (AI) = Alternate Input
;1297 // (AO) = Alternate Output
;1298 // (xx) = Used by ZWorld core - do not change
;1299 
;1300   //--- Port A ---
;1301   //  PA7 - (NI)  DI-23                  (pulled up)
;1302   //  PA6 - (NI)  DI-22                  (pulled up)
;1303   //  PA5 - (NI)  DI-21                  (pulled up)
;1304   //  PA4 - (NI)  DI-20                  (pulled up)
;1305   //  PA3 - (NI)  DI-19                  (pulled up)
;1306   //  PA2 - (NI)  DI-18                  (pulled up)
;1307   //  PA1 - (NI)  DI-17                  (pulled up)
;1308   //  PA0 - (NI)  DI-16                  (pulled up)
;1309     outi(SPCR, srSPCR = 0x80);      // PortA: byte input
	ld	a,0x80
	ld	(_srSPCR),a
	ioi ld	(36),a
;1310 
;1311   //--- Port B ---
;1312   //  PB7 - (-O)  DAC_ADC_SDI            (high)
;1313   //  PB6 - (-O)  ---not used---         (low)
;1314   //  PB5 - (-I)  Analog circuit option  (1 = installed) (JP3)
;1315   //  PB4 - (-I)  I/O config option      (1 = standard)  (JP2)
;1316   //  PB3 - (-I)  ---not used---         (pulled up)
;1317   //  PB2 - (-I)  ADC EOC line           (driven by ADC)
;1318   //  PB1 - (-I)  ---not used---         (pulled up)
;1319   //  PB0 - (-I)  DAC_ADC_SDO            (pulled up)
;1320     outi(PBDR, srPBDR |= 0x80);    // SDI line high
	ld	a,(_srPBDR)
	or	a,128
	ld	(_srPBDR),a
	ioi ld	(64),a
;1321 
;1322   //--- Port C ---
;1323   //  PC7 - (-I)  Serial-A receive        (Diag/Prog/Console port)
;1324   //  PC6 - (AO)  Serial-A transmit       (Diag/Prog/Console port)
;1325   //  PC5 - (-I)  Realtek INT0            (pulled up)
;1326   //  PC4 - (NO)  Realtek Ethernet RESET  (initialized by sock_init())
;1327   //  PC3 - (-I)  Serial-C receive        (RS-232)
;1328   //  PC2 - (AO)  Serial-C transmit       (RS-232)
;1329   //  PC1 - (-I)  Serial-D receive        (RS-485)
;1330   //  PC0 - (AO)  Serial-D transmit       (RS-485)
;1331     outi(PCFR, srPCFR = 0x45);  // func: xAxN-xAxA
	ld	a,0x45
	ld	(_srPCFR),a
	ioi ld	(85),a
;1332 
;1333   //--- Port D ---
;1334   //  PD7 - (NO)  --- not used ---        (high)
;1335   //  PD6 - (NO)  --- not used ---        (high)
;1336   //  PD5 - (NI)  Serial-B receive        (RS-232)
;1337   //  PD4 - (AO)  Serial-B transmit       (RS-232)
;1338   //  PD3 - (NO)  DAC CLK line            (high)
;1339   //  PD2 - (NO)  --- not used ---        (high)
;1340   //  PD1 - (NI)  Realtek SDO             (initialized by sock_init())
;1341   //  PD0 - (NI)  Realtek CLK             (initialized by sock_init())
;1342     outi(PDCR,  srPDCR = 0x00);      // outputs CLK'ed by PCLK/2
	xor	a,a
	ld	(_srPDCR),a
	ioi ld	(100),a
;1343     outi(PDDDR, srPDDDR = 0xDC);     // dir:  OOIO-OOII
	ld	a,0xdc
	ld	(_srPDDDR),a
	ioi ld	(103),a
;1344     outi(PDFR,  srPDFR = 0x10);      // func: NNNA-NNNN
	ld	a,0x10
	ld	(_srPDFR),a
	ioi ld	(101),a
;1345     outi(PDDR,  srPDDR |= 0xDC);     // all outputs will start high
	ld	a,(_srPDDR)
	or	a,220
	ld	(_srPDDR),a
	ioi ld	(96),a
;1346 
;1347   //--- Port E ---
;1348   //  PE7 - (AO)  LCD_KEYPAD strobe      (high)
;1349   //  PE6 - (xx)  Realtek IOWB strobe    (initialized by sock_init())
;1350   //  PE5 - (NI)  INT1B (Ext. interrupt) (input)
;1351   //  PE4 - (NO)  --- not used ---       (tied to PE5 via 1K resistor)
;1352   //  PE3 - (xx)  Realtek SDI line       (initialized by sock_init())
;1353   //  PE2 - (xx)  Realtek IORB strobe    (initialized by sock_init())
;1354   //  PE1 - (NO)  External I/O enable    (high)
;1355   //  PE0 - (AO)  Digital I/O strobe     (high)
;1356   // ** PE5 is driven by PE4, if the interrupt is not being used.
;1357 
;1358     outi(PEDDR, srPEDDR = (srPEDDR & 0x4C) | 0x93);   // dir:  OxIO-xxOO
	ld	a,(_srPEDDR)
	and	a,76
	or	a,147
	ld	(_srPEDDR),a
	ioi ld	(119),a
;1359     outi(PEFR,  srPEFR  = (srPEFR  & 0x4C) | 0x81);   // func: NxNN-xxNA
	ld	a,(_srPEFR)
	and	a,76
	or	a,129
	ld	(_srPEFR),a
	ioi ld	(117),a
;1360     outi(IB0CR, srIB0CR = 0xF8);    // PE0: 1WS, I/O Strobe, writes enabled
	ld	a,0xf8
	ld	(_srIB0CR),a
	ioi ld	(128),a
;1361     outi(PECR,  srPECR  = 0x00);    // outputs CLK'ed by PCLK/2
	xor	a,a
	ld	(_srPECR),a
	ioi ld	(116),a
;1362 
;1363 
;1364 //--- all parallel port outputs driven hi/lo (no open-drain outputs) ---
;1365   outi(PDDCR, srPDDCR = 0x00);
	xor	a,a
	ld	(_srPDDCR),a
	ioi ld	(102),a
;1366   outi(PFDCR, srPFDCR = 0x00);
	xor	a,a
	ld	(_srPFDCR),a
	ioi ld	(62),a
;1367   outi(PGDCR, srPGDCR = 0x00);
	xor	a,a
	ld	(_srPGDCR),a
	ioi ld	(78),a
;1368 
;1369 
;1370 
;1371   //---------------------------------------------------------------------
;1372   // Initialize external latch
;1373   //---------------------------------------------------------------------
;1374   // set RS485 TX control low all others high
;1375   oute(0x0004, PE0Shadow &= ~0x01);
	ld	a,(_PE0Shadow)
	and	a,254
	ld	(_PE0Shadow),a
	ioe ld	(4),a
;1376 
;1377   // enable external latch
;1378   outi(PEDR, srPEDR &= ~0x02);
	ld	a,(_srPEDR)
	and	a,253
	ld	(_srPEDR),a
	ioi ld	(112),a
;1379 
;1380   // Preset all analog channel low before enabling the analog power supply
;1381   if (ini(PBDR) & 0x20) {
	ioi ld	a,(64)
	and	a,32
	jr	z,@230
;1382 //    anaOutDriver(POWER_NORMAL, FAST_MODE, 0, 4095);
;1383 //    anaOutDriver(POWER_NORMAL, FAST_MODE, 1, 4095);
;1384 //    anaOutDriver(POWER_NORMAL, FAST_MODE, 2, 4095);
;1385 //    anaOutDriver(POWER_NORMAL, FAST_MODE, 3, 4095);
;1386 
;1387     // Set RS485 TX off, and turn-on DAC power supply
;1388     oute(0x0004, PE0Shadow &= ~0x11);
	ld	a,(_PE0Shadow)
	and	a,238
	ld	(_PE0Shadow),a
	ioe ld	(4),a
;1389   }
;1390 
;1391 
;1392   //---------------------------------------------------------------------
;1393   // Initialize PE7 to turn OFF the bad CPU indicator
;1394   //---------------------------------------------------------------------
;1395   // Initialize Port E bit to be a chip select.
;1396   // Set to be a I/O Read and Write strobe with 7 wait states.
;1397   // and writes allowed.
;1398 
;1399   outi(LCDCSREGISTER, LCDCSSHADOW = LCDCSCONFIG);
@230:
	ld	a,0x78
	ld	(_srIB7CR),a
	ioi ld	(135),a
;1400 
;1401   // Turn-off the CPU bad indicator
;1402   oute(LCDLEDADDR, LEDShadow = 0x00);
	xor	a,a
	ld	(_LEDShadow),a
	ioe ld	(57355),a
;1403 
;1404   // Enable LED control register
;1405   oute(LCDLEDREG, 0x00);
	xor	a,a
	ioe ld	(57352),a
;1406 
;1407 //--- enable the external high-current data latch (0-7) ---
;1408   oute(0x0004, PE0Shadow &= ~0x02);
	ld	a,(_PE0Shadow)
	and	a,253
	ld	(_PE0Shadow),a
	ioe ld	(4),a
;1409 
;1410 //--- enable the external high-current data latch (8-15) ---
;1411   oute(0x0004, PE0Shadow &= ~0x04);
	ld	a,(_PE0Shadow)
	and	a,251
	ld	(_PE0Shadow),a
	ioe ld	(4),a
;1412 
;1413   WriteDigOutputs(digOutState);
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
;1414 
;1415 
;1416   flashSize = 524288L;
	ld	de,0
	ld	bc,0x8
	ld	(_flashSize),de
	ld	(_flashSize+2),bc
;1417 
;1418   printf("\r\nInitialized %s hardware\r\n", ArchName);
	ld	hl,_ArchName
	push	hl
	ld	de,word (phys @1+271)
	ld	c,phys @1+271 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1419 }
@228:
	.debug	} @228 1419

@227	equ	0
	pop	ix
	lret
@229	equ	2
;1420 
;1421 
;1422 //-------------------------------------------------------------------------
;1423 //  Initialize and register hardware-dependent file systems
;1424 //-------------------------------------------------------------------------
;1425 void registerFileSystems(void)
;1426 {
$registerFileSystems::
	.debug	G $registerFileSystems 39 9
	.debug	{ $registerFileSystems 39 1425 @235 @234
;1427   socketInit_();
	lcall	$socketInit_
;1428   srfsInit_();
	lcall	$srfsInit_
;1429   serialInit_();
	lcall	$serialInit_
;1430 
;1431   flashFileInit_();
	lcall	$flashFileInit_
;1432 }
@234:
	.debug	} @234 1432

@233	equ	0
	lret
@235	equ	0
;1433 
;1434 //-------------------------------------------------------------------------
;1435 //  Initialize the network hardware
;1436 //-------------------------------------------------------------------------
;1437 void netHdwInit()
;1438 {
$netHdwInit::
	.debug	G $netHdwInit 53 9
	.debug	{ $netHdwInit 53 1437 @238 @237
;1439 //  Select ethernet hardware:
;1440 //  usingAsix, usingDevKit, usingRealtek, usingSMSC
;1441 //  usingAll() can be used to support all cmd core modules, but req's more 
;1442 
;1443   usingRealtek();
	lcall	$usingRealtek
;1444 }
@237:
	.debug	} @237 1444

@236	equ	0
	lret
@238	equ	0
;1445 
;1446 
;1447 //-------------------------------------------------------------------------
;1448 //  allocate any resources that should be owned by the kernel process
;1449 //-------------------------------------------------------------------------
;1450 void hdwInit2(void)
;1451 {
$hdwInit2::
	.debug	G $hdwInit2 39 9
	.debug	{ $hdwInit2 39 1450 @241 @240
;1452 
;1453 }
@240:
	.debug	} @240 1453

@239	equ	0
	lret
@241	equ	0
;1454 
;1455 
;1456 //-------------------------------------------------------------------------
;1457 
	.extern	_SchedMS 7
	.extern	$farprintf 54
	.extern	_srSPCR 3
	.extern	_srPBDR 3
	.extern	_srPCFR 3
	.extern	_srPDDR 3
	.extern	_srPDCR 3
	.extern	_srPDFR 3
	.extern	_srPDDCR 3
	.extern	_srPDDDR 3
	.extern	_srPEDR 3
	.extern	_srPECR 3
	.extern	_srPEFR 3
	.extern	_srPEDDR 3
	.extern	_srIB0CR 3
	.extern	_srIB7CR 3
	.extern	_srPFDCR 3
	.extern	_srPGDCR 3
	.extern	__TimerMilliSeconds 55
	.bseg
___brdInitFlag::
	.ds	1
	.debug	G ___brdInitFlag 3 0
_ramSize::
	.ds	4
	.debug	G _ramSize 9 0
_flashSize::
	.ds	4
	.debug	G _flashSize 9 0
_qdCount::
	.ds	2
	.debug	G _qdCount 6 0
_updateAIn::
	.ds	11
	.debug	G _updateAIn 56 0
_updateAOut::
	.ds	4
	.debug	G _updateAOut 57 0
_adcGain::
	.ds	44
	.debug	G _adcGain 58 0
_adcOffset::
	.ds	44
	.debug	G _adcOffset 58 0
_dacGain::
	.ds	16
	.debug	G _dacGain 59 0
_dacOffset::
	.ds	16
	.debug	G _dacOffset 59 0
_ainMin::
	.ds	44
	.debug	G _ainMin 58 0
_ainMax::
	.ds	44
	.debug	G _ainMax 58 0
_aoutMin::
	.ds	16
	.debug	G _aoutMin 59 0
_aoutMax::
	.ds	16
	.debug	G _aoutMax 59 0
	.defseg	FARBSS
	.seg	FARBSS
_setValMin::
	.ds	16
	.debug	G _setValMin 59 8
_setValMax::
	.ds	16
	.debug	G _setValMax 59 8
_readValMin::
	.ds	44
	.debug	G _readValMin 58 8
_readValMax::
	.ds	44
	.debug	G _readValMax 58 8
	.bseg
_anaIn::
	.ds	44
	.debug	G _anaIn 58 0
_anaOut::
	.ds	16
	.debug	G _anaOut 59 0
_lastAnaOut::
	.ds	16
	.debug	G _lastAnaOut 59 0
_adcRaw::
	.ds	22
	.debug	G _adcRaw 60 0
_dacRaw::
	.ds	8
	.debug	G _dacRaw 61 0
_lastadcRaw::
	.ds	22
	.debug	G _lastadcRaw 60 0
_newRdg::
	.ds	11
	.debug	G _newRdg 56 0
_adcForced::
	.ds	11
	.debug	G _adcForced 56 0
_dacForced::
	.ds	4
	.debug	G _dacForced 57 0
_adcForcedVal::
	.ds	44
	.debug	G _adcForcedVal 58 0
_dacForcedVal::
	.ds	16
	.debug	G _dacForcedVal 59 0
	.seg	FARBSS
_adcRawHist::
	.ds	2200
	.debug	G _adcRawHist 62 8
	.bseg
_adcAvgData::
	.ds	132
	.debug	G _adcAvgData 64 0
_adcNoiseData::
	.ds	110
	.debug	G _adcNoiseData 66 0
	.extern	_readGain 68
	.extern	_readOffset 68
	.extern	_setGain 68
	.extern	_setOffset 68
	.extern	_readVal 68
_digitalIn::
	.ds	4
	.debug	G _digitalIn 9 0
_digitalOut::
	.ds	4
	.debug	G _digitalOut 9 0
_forcedDigInMask::
	.ds	4
	.debug	G _forcedDigInMask 9 0
_forcedDigInBits::
	.ds	4
	.debug	G _forcedDigInBits 9 0
_forcedDigOutMask::
	.ds	4
	.debug	G _forcedDigOutMask 9 0
_forcedDigOutBits::
	.ds	4
	.debug	G _forcedDigOutBits 9 0
_extraIn::
	.ds	4
	.debug	G _extraIn 9 0
_forcedExtraInMask::
	.ds	4
	.debug	G _forcedExtraInMask 9 0
_forcedExtraInBits::
	.ds	4
	.debug	G _forcedExtraInBits 9 0
	.cseg
_newDACCalib:
	pop	iy
	lcall	$$newDACCalib
_newADCCalib:
	pop	iy
	lcall	$$newADCCalib
_setStateDAC:
	pop	iy
	lcall	$$setStateDAC
	.extern	_KLOCK 39
	.extern	_KUNLOCK 39
	.extern	_hdwType 7
	.extern	$serialInit_ 39
	.extern	$usingRealtek 39
	.extern	$socketInit_ 39
	.extern	$srfsInit_ 39
	.extern	$flashFileInit_ 39
	.extern	_NumApplAIN 7
	.extern	_ADC_Mask 9
_adcGetRaw:
	pop	iy
	lcall	$$adcGetRaw
_adcMinRaw:
	pop	iy
	lcall	$$adcMinRaw
_adcMaxRaw:
	pop	iy
	lcall	$$adcMaxRaw
_adcDefaults:
	pop	iy
	lcall	$$adcDefaults
_adcCalibPoints:
	pop	iy
	lcall	$$adcCalibPoints
_dacGetRaw:
	pop	iy
	lcall	$$dacGetRaw
_dacMinRaw:
	pop	iy
	lcall	$$dacMinRaw
_dacMaxRaw:
	pop	iy
	lcall	$$dacMaxRaw
_dacDefaults:
	pop	iy
	lcall	$$dacDefaults
_dacCalibPoints:
	pop	iy
	lcall	$$dacCalibPoints
	.bseg
_PE0Shadow::
	.ds	1
	.debug	G _PE0Shadow 3 0
_DOUTLShadow::
	.ds	1
	.debug	G _DOUTLShadow 3 0
_DOUTHShadow::
	.ds	1
	.debug	G _DOUTHShadow 3 0
_LEDShadow::
	.ds	1
	.debug	G _LEDShadow 3 0
	.cseg
_SerSetDirA:
	pop	iy
	lcall	$$SerSetDirA
_SerSetDirB:
	pop	iy
	lcall	$$SerSetDirB
_SerSetDirC:
	pop	iy
	lcall	$$SerSetDirC
_SerSetDirD:
	pop	iy
	lcall	$$SerSetDirD
	.debug	T	0900012000070003000700
	.debug	T	0900012100780022001E00
	.debug	T	070008220004000300
	.debug	T	0900012300500024000500
.id = 0
.size = 2
.gran = 4
.data = 6
.name = 10
.restoreVal = 14
	.debug	T	49000324001000060001000400000003696400040002000573697A
	.debug	T	650004000400056772616E004500060005646174610022000A
	.debug	T	00056E616D650046000E000B726573746F726556616C00
	.debug	T	0B000225000100010007000000
	.debug	T	130002260003000100070000000A00020003000600
	.debug	T	0B000227000100010001000000
	.debug	T	0F00022800020007000700000007000200
	.debug	T	0B000229000100070007000000
	.debug	T	0B00022A0001000A0007000000
	.debug	T	0F00022B00020007000700000048000200
	.debug	T	1300022C0003000100070000004900020049000400
	.debug	T	0F00022D0002002E00070000002E000200
	.debug	T	0700002E0002000300
	.debug	T	0B00022F000100010009000000
	.debug	T	070002300000000900
	.debug	T	0F00023100020007000300000003000200
	.debug	T	17000232000400010006000000060002000600040007000600
	.debug	T	0F00023300020006000700000007000200
	.debug	T	0B000234000100010006000000
	.debug	T	070002350000000100
	.debug	T	0F0002360002000600220000000D000000
	.debug	T	0900013700080009000200
	.debug	T	09000138000B0003000B00
	.debug	T	0900013900040003000400
	.debug	T	0900013A002C000A000B00
	.debug	T	0900013B0010000A000400
	.debug	T	0900013C00160007000B00
	.debug	T	0900013D00080007000400
	.debug	T	0900013E0098083F000B00
	.debug	T	0900013F00C80007006400
	.debug	T	0900014000840041000B00
.sum = 0
.oldest = 4
.next = 6
.curNumSamples = 8
.useNumSamples = 10
	.debug	T	4E000341000C0005000100090000000473756D0007000400076F6C
	.debug	T	646573740007000600056E65787400070008000E6375724E75
	.debug	T	6D53616D706C65730007000A000E7573654E756D53616D706C
	.debug	T	657300
	.debug	T	09000142006E0043000B00
.rawMin = 0
.rawMax = 2
.noisePeriod = 4
.rawNoise = 6
.noiseTimeMS = 8
	.debug	T	51000343000A000500010007000000077261774D696E0007000200
	.debug	T	077261774D617800070004000C6E6F697365506572696F6400
	.debug	T	07000600097261774E6F69736500070008000C6E6F69736554
	.debug	T	696D654D5300
	.debug	T	090001440000000A000000
	.debug	T	070008450004000100
	.debug	T	070000460002004700
	.debug	T	130002470003000100450000002E00040007000600
	.debug	T	070000480002000700
	.debug	T	070000490002000A00
	.seg	CONST
@128:
	.db	"V",0
	.seg	FARCONST
@1:
	.db	"Periodic Timer",0,"Secondary WDT",0,"RST 10",0,"RST 18",0,"RST 20",0,"RST 28",0,"Syscall",0,"RST 38",0,"Slave Port",0,"Wr"
	.db	"ite Protect",0,"Timer A",0,"Timer B",0,"Serial A",0,"Serial B",0,"Serial C",0,"Serial D",0,"INT0",0,"INT1",0,"PWM",0,"Mode Vi"
	.db	"olation",0,"Quad Decoder",0,"Input capture",0,"Stack Limit",0,"Serial E",0,"Serial F",0,"adcGain",0,"adcOffset",0,"da"
	.db	"cGain",0,"dacOffset",0,13,10,"Initialized %s hardware",13,10,0
	.end
