	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	p 5
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\arch\nscl16\nscl16.c' 3 41 6 3 10 32
;1 //----- nscl16.c ----- 10/02/12 -----(03/26/06)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  Code to handle hardware-specific implementation of generic hdw function
;5 //-------------------------------------------------------------------------
;6 //
;7 //  2012-10-02 - Mark Davis (*)
;8 //               - Reduced the threshold for excessive nested scheduler loc
;9 //                 (used to detect excessive knob interrupts) from 50 to 30
;10 //                 Prior to this there was at least one instance of a stack
;11 //                 overflow that occured around the 50 level.  Also, the
;12 //                 source of the interrupt is not reenabled until the appli
;13 //                 task has run at least 20 times since the interrupt was
;14 //                 disabled (to reduce the affect on other tasks).
;15 //
;16 //  2011-12-22 - Mark Davis (*)
;17 //               - Changed IP for knob interrupt from 3 to 1 so the knob
;18 //                 interrupt is not immune to critical section locks.
;19 //               - Changed the patch that checks for excessive knob interru
;20 //                 so it is based only on the level of nested scheduler loc
;21 //
;22 //  2011-10-27 - Mark Davis (*)
;23 //               - Fixed 2011-09-29 change so it works.  Prior to this it w
;24 //                 using the value of the stack pointer in the task struct
;25 //                 to check for stack overflow, but that doesn't work becau
;26 //                 that value is only updated during a call to schedule(). 
;27 //                 code now uses the ACTUAL SP value to check to see if the
;28 //                 current task is about to run out of stack space.
;29 //
;30 //  2011-09-29 - Mark Davis (*)
;31 //               - Modified check for runaway INT1 occurances so that it no
;32 //                 directly protects against what it was meant to:  Overflo
;33 //                 the stack of the current process.  The previous version 
;34 //                 not a guarantee against this and would temporarily disab
;35 //                 the interrupt under conditions it did not need to.
;36 //
;37 //  2011-09-26 - Mark Davis (*)
;38 //               - Added code to detect the conditions that may indicate
;39 //                 runaway INT1 occurances and to temporarily disable INT1
;40 //                 until the situation is cleaned up.
;41 //
;42 //  2011-04-15 - Mark Davis (*)
;43 //               - Removed critical section in qdPulse() ISR.  The only pur
;44 //                 it served was to protect the qdCount value from access b
;45 //                 OTHER ISRs (which I don't do), so this isn't really
;46 //                 necessary and just adds a bit of overhead, which slightl
;47 //                 increases the risk of a rapid series of the interrupts
;48 //                 causing a stack overflow (by repeatedly interrupting the
;49 //                 ISR vector code before IT returns).
;50 //
;51 //  2010-02-07 - Mark Davis -
;52 //               - Fixes to convertADS7825() to avoid race conditions
;53 //
;54 //-------------------------------------------------------------------------
;55 
;56 #include <common.h>
;57 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
;58 #include <sys/types.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;59 #include <sys/stat.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
;60 #include <unistd.h>
;61 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
_LIN2SEG	.macro

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

sub 0x0E

or a

rr hl

scf

rr hl

scf

rr hl

scf

rr hl

.endm

	.cseg
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
;62 #include <sys/backup.h>
;63 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
;64 #include <sys/spi.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\spi.h' 12 54 10 3 8 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
;65 #include <sys/hdwDefs.h>
;66 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
;67 #include <busybox.h>
;68 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
;69 #include <Rabbit.h>
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
;70 #include <dcdefs.h>
;71 
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
;72 #include <stcpip.h>
;73 
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
;74 #include <sys/socket.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
;75 #include <sys/srfs.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\srfs.h' 6 17 10 7 4 28
;76 #include <sys/flashFile.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\flashFile.h' 15 56 20 12 3 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;77 #ifdef ASFLASH
;81 #include <sys/farprintf.h>
;82 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
;83 //--- see hdwInit() for Digital I/O pin usage ---
;84 
;85 const char ArchName[] = { "NSCL16" };
	.defseg	CONST
	.seg	CONST
_ArchName::
	.db	"NSCL16",0
	.debug	G _ArchName 32 0
;86 
;87 #define  NUM_ADC    8  // supports 8, but really only 4 on the board itself
;88 #define  NUM_DAC    2
;89 
;90 #define  MAX_DIN   12
;91 #define  MAX_DOUT  11
;92 
;93 
;94 //--- these values can be set LOWER by the application ---
;95 const uint  NumHdwADC = NUM_ADC;
_NumHdwADC::
	.dw	0x8
	.debug	G _NumHdwADC 7 0
;96 const uint  NumHdwDAC = NUM_DAC;
_NumHdwDAC::
	.dw	0x2
	.debug	G _NumHdwDAC 7 0
;97 
;98 const uint  MaxDIN =  MAX_DIN;
_MaxDIN::
	.dw	0xc
	.debug	G _MaxDIN 7 0
;99 const uint  MaxDOUT = MAX_DOUT;
_MaxDOUT::
	.dw	0xb
	.debug	G _MaxDOUT 7 0
;100 
;101 
;102 
;103 //--- NSCL 16-bit analog RCM3200-based ctlrs use port B for SPI to ADCs, DA
;104 #define  ADC_DAC_SPIPort  1  // for most RCM3200-based NSCL ctlr's w/Analog
;105 
;106 
;107 
;108 unsigned char  __brdInitFlag;
;109 
;110 #include <hdwDefs.c>
;111 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\arch\hdwDefs.c' 10 49 8 19 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\applic.h' 28 10 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.dseg
_IntVectDesc::
	.dw	word (phys @1)
	.dw	phys @1 >> 16
	.dw	word (phys @1+15)
	.dw	phys @1+15 >> 16
	.dw	word (phys @1+29)
	.dw	phys @1+29 >> 16
	.dw	word (phys @1+36)
	.dw	phys @1+36 >> 16
	.dw	word (phys @1+43)
	.dw	phys @1+43 >> 16
	.dw	word (phys @1+50)
	.dw	phys @1+50 >> 16
	.dw	word (phys @1+57)
	.dw	phys @1+57 >> 16
	.dw	word (phys @1+65)
	.dw	phys @1+65 >> 16
	.dw	word (phys @1+72)
	.dw	phys @1+72 >> 16
	.dw	word (phys @1+83)
	.dw	phys @1+83 >> 16
	.dw	word (phys @1+97)
	.dw	phys @1+97 >> 16
	.dw	word (phys @1+105)
	.dw	phys @1+105 >> 16
	.dw	word (phys @1+113)
	.dw	phys @1+113 >> 16
	.dw	word (phys @1+122)
	.dw	phys @1+122 >> 16
	.dw	word (phys @1+131)
	.dw	phys @1+131 >> 16
	.dw	word (phys @1+140)
	.dw	phys @1+140 >> 16
	.dw	word (phys @1+149)
	.dw	phys @1+149 >> 16
	.dw	word (phys @1+154)
	.dw	phys @1+154 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+14)
	.dw	phys @1+14 >> 16
	.dw	word (phys @1+159)
	.dw	phys @1+159 >> 16
	.dw	word (phys @1+163)
	.dw	phys @1+163 >> 16
	.dw	word (phys @1+178)
	.dw	phys @1+178 >> 16
	.dw	word (phys @1+191)
	.dw	phys @1+191 >> 16
	.dw	word (phys @1+205)
	.dw	phys @1+205 >> 16
	.dw	word (phys @1+217)
	.dw	phys @1+217 >> 16
	.dw	word (phys @1+226)
	.dw	phys @1+226 >> 16
	.debug	G _IntVectDesc 33 0
	.defseg	FARCONST
	.seg	FARCONST
_hdwCfgParams::
	.dw	0x1
	.dw	0x20
	.dw	0
	.dl	phys _adcGain
	.dl	phys @1+235
	.dw	0
	.dw	0x2
	.dw	0x20
	.dw	0
	.dl	phys _adcOffset
	.dl	phys @1+243
	.dw	0
	.dw	0x3
	.dw	0x8
	.dw	0
	.dl	phys _dacGain
	.dl	phys @1+253
	.dw	0
	.dw	0x4
	.dw	0x8
	.dw	0
	.dl	phys _dacOffset
	.dl	phys @1+261
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
	.ds	2,0
	.debug	G _hdwCfgParams 35 8
	.defseg	FARCODE
	.seg	FARCODE
	.align	4
$$newDACCalib::
	ex	(sp),iy
$newDACCalib::
	.debug	G $newDACCalib 37 9
	.debug	{ $newDACCalib 37 193 @4 @3
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jp	nc,@3
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMinRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMaxRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsub##
	jp	m,@6
	jr	z,@6
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
@6:
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_setOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_setGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_setOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_setGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__fsub##
	jp	m,@9
	jr	z,@9
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@9:
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _setValMin)
	ld	c,phys _setValMin >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _setValMax)
	ld	c,phys _setValMax >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ld	de,_updateAOut
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	call	_KUNLOCK
@3:
	.debug	} @3 218

@2	equ	20
	ld	sp,ix
	pop	ix
	lret
@4	equ	22
	.align	4
$$newADCCalib::
	ex	(sp),iy
$newADCCalib::
	.debug	G $newADCCalib 37 9
	.debug	{ $newADCCalib 37 224 @14 @13
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@13
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMinRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMaxRaw
	pop	hl
	call	__ftol##
	call	__uitof##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsub##
	jp	m,@16
	jr	z,@16
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
@16:
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_readOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_readOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__fsub##
	jp	m,@19
	jr	z,@19
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@19:
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_ainMin
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_ainMax
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _readValMin)
	ld	c,phys _readValMin >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _readValMax)
	ld	c,phys _readValMax >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__farst4d##
	ld	hl,(ix+5)
	ld	de,_updateAIn
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	call	_KUNLOCK
@13:
	.debug	} @13 249

@12	equ	20
	ld	sp,ix
	pop	ix
	lret
@14	equ	22
	.align	4
$$setStateDAC::
	ex	(sp),iy
$setStateDAC::
	.debug	G $setStateDAC 38 9
	.debug	{ $setStateDAC 38 254 @24 @23
	push	ix
	ld	ix,0
	add	ix,sp
	ld	a,(ix+11)
	or	a,a
	jr	z,@25
	ld	hl,(ix+5)
	ld	de,_dacForced
	add	hl,de
	xor	a,a
	ld	(hl),a
	jr	@26
@25:
	ld	hl,(ix+5)
	ld	de,_dacForced
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_dacForcedVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@26:
	ld	hl,(ix+5)
	ld	de,_updateAOut
	add	hl,de
	ld	a,0x1
	ld	(hl),a
@23:
	.debug	} @23 262

@22	equ	0
	pop	ix
	lret
@24	equ	2
$initIOvalues::
	.debug	G $initIOvalues 39 9
	.debug	{ $initIOvalues 39 273 @31 @30
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	push	bc
	push	de
	lcall	$readAnalogInputs
	add	sp,4
	lcall	$ReadDigInputs
	ld	(_digitalIn),de
	ld	(_digitalIn+2),bc
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@34:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@35
	ld	hl,(ix-2)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-6),hl
	ld	h,d
	ld	l,e
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-8),hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(ix-2)
	ld	de,_newRdg
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ld	hl,(ix-8)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-8)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	h,b
	ld	l,c
	ex	de,hl
	call	__uitof##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_anaIn
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@39
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_readOffset
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsubr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_readVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@39:
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xc8
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _adcRawHist)
	ld	c,phys _adcRawHist >> 16
	call	__ladd##
	ld	hl,(ix-4)
	call	__farst2##
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	e,c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-6)
	ld	de,0x6
	add	hl,de
	ld	de,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-6)
	ld	de,0x8
	add	hl,de
	ld	de,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xc8
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setAvgPeriodADC
	add	sp,4
	ld	hl,0x7d0
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setNoisePeriodADC
	add	sp,4
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@34
@35:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@42:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@43
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_lastAnaOut
	add	hl,de
	ld	de,0x3f9a
	ld	bc,0xc61c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@42
@43:
@30:
	.debug	} @30 316

@29	equ	8
	ld	sp,ix
	pop	ix
	lret
@31	equ	10
$resetAvgDataADC::
	.debug	G $resetAvgDataADC 37 9
	.debug	{ $resetAvgDataADC 37 321 @47 @46
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-2),hl
	.seg	FARCODE
	ld	h,d
	ld	l,e
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@46
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xc8
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _adcRawHist)
	ld	c,phys _adcRawHist >> 16
	call	__ladd##
	ld	hl,(hl)
	call	__farst2##
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ld	de,0x4
	add	hl,de
	ld	e,c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	ld	de,0x8
	add	hl,de
	ld	de,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	ld	c,e
	ld	de,0x6
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	call	_KUNLOCK
@46:
	.debug	} @46 333

@45	equ	2
	ld	sp,ix
	pop	ix
	lret
@47	equ	4
$setAvgPeriodADC::
	.debug	G $setAvgPeriodADC 40 9
	.debug	{ $setAvgPeriodADC 40 339 @51 @50
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@52
	ld	hl,0x1
	jr	@50
@52:
	ld	hl,(_SchedMS)
	or	a,a
	rr	hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	de,(_SchedMS)
	call	__uidiv##
	ld	(ix-2),hl
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nc,@53
	ld	h,d
	ld	l,e
	ld	(ix-2),hl
@53:
	ld	hl,(ix-2)
	ld	de,0x64
	or	a,a
	sbc	hl,de
	jr	c,@54
	jr	z,@54
	ld	h,d
	ld	l,e
	ld	(ix-2),hl
@54:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	de,0xa
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
	ld	h,d
	ld	l,e
	ld	de,(_SchedMS)
	ld	bc,hl
	mul
	ld	de,bc
	ex	de,hl
@50:
	.debug	} @50 355

@49	equ	2
	ld	sp,ix
	pop	ix
	lret
@51	equ	4
$getAvgPeriodADC::
	.debug	G $getAvgPeriodADC 41 9
	.debug	{ $getAvgPeriodADC 41 361 @57 @56
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@58
	ld	hl,0x1
	jr	@56
@58:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	de,0xa
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ipres
	ld	de,(_SchedMS)
	ld	bc,hl
	mul
	ld	de,bc
	ex	de,hl
@56:
	.debug	} @56 372

@55	equ	2
	ld	sp,ix
	pop	ix
	lret
@57	equ	4
$getAvgSamplesADC::
	.debug	G $getAvgSamplesADC 41 9
	.debug	{ $getAvgSamplesADC 41 379 @61 @60
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@62
	ld	hl,0x1
	jr	@60
@62:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	de,0xa
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ipres
@60:
	.debug	} @60 390

@59	equ	2
	ld	sp,ix
	pop	ix
	lret
@61	equ	4
$getAvgdRawIn::
	.debug	G $getAvgdRawIn 42 9
	.debug	{ $getAvgdRawIn 42 397 @65 @64
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@66
	ld	de,0
	ld	c,e
	ld	b,e
	jr	@64
@66:
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-8),hl
	ipset	2
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-8)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	ld	(ix-6),hl
	ipres
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ultof##
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	call	__uitof##
	call	__fdiv##
@64:
	.debug	} @64 413

@63	equ	8
	ld	sp,ix
	pop	ix
	lret
@65	equ	10
$getAvgdAnaIn::
	.debug	G $getAvgdAnaIn 42 9
	.debug	{ $getAvgdAnaIn 42 419 @69 @68
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@70
	ld	de,0
	ld	c,e
	ld	b,e
	jp	@68
@70:
	ld	hl,(ix+5)
	ld	de,_adcForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@71
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_adcForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@68
@71:
	ld	hl,(ix+5)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-8),hl
	ipset	2
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-8)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	ld	(ix-6),hl
	ipres
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ultof##
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	call	__uitof##
	call	__fdiv##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
@68:
	.debug	} @68 437

@67	equ	8
	ld	sp,ix
	pop	ix
	lret
@69	equ	10
$updateAvgsADC::
	.debug	G $updateAvgsADC 39 9
	.debug	{ $updateAvgsADC 39 447 @74 @73
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-14
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ex	de,hl
	ld	(ix-6),hl
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@77:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@78
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0xc8
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _adcRawHist)
	ld	c,phys _adcRawHist >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,0xc
	ex	de,hl
	mul
	ld	hl,_adcAvgData
	add	hl,bc
	ld	(ix-12),hl
	ld	h,d
	ld	l,e
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-14),hl
@82:
	ld	hl,(ix-12)
	ld	de,0x8
	add	hl,de
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xa
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	c,@83
	ld	hl,(ix-12)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-12)
	push	hl
	ld	bc,0
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-12)
	ld	de,0x4
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0x64
	or	a,a
	sbc	hl,de
	jr	nz,@86
	ld	hl,(ix-12)
	ld	de,0x4
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@86:
	ld	hl,(ix-12)
	ld	de,0x8
	add	hl,de
	push	hl
	ld	hl,(hl)
	dec	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jp	@82
@83:
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(ix-12)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__ladd##
	ld	hl,(ix-4)
	call	__farst2##
	ex	de,hl
	ld	bc,0
	ld	hl,(ix-12)
	push	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-12)
	ld	de,0x6
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0x64
	or	a,a
	sbc	hl,de
	jr	nz,@87
	ld	hl,(ix-12)
	ld	de,0x6
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
@87:
	ld	hl,(ix-12)
	ld	de,0x8
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-14)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-4)
	or	a,a
	sbc	hl,de
	jr	nc,@88
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@88:
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-4)
	or	a,a
	sbc	hl,de
	jr	c,@89
	jr	z,@89
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@89:
	ld	hl,(ix-14)
	ld	de,0x8
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-6)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,bc
	or	a,a
	sbc	hl,de
	jr	c,@90
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-14)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x6
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	h,d
	ld	l,e
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-14)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-14)
	ld	de,0x8
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@90:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@77
@78:
@73:
	.debug	} @73 485

@72	equ	14
	ld	sp,ix
	pop	ix
	lret
@74	equ	16
$setNoisePeriodADC::
	.debug	G $setNoisePeriodADC 40 9
	.debug	{ $setNoisePeriodADC 40 490 @95 @94
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@96
	bool	hl
	ld	l,h
	jr	@94
@96:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
	ld	h,d
	ld	l,e
@94:
	.debug	} @94 497

@93	equ	0
	pop	ix
	lret
@95	equ	2
$getNoisePeriodADC::
	.debug	G $getNoisePeriodADC 41 9
	.debug	{ $getNoisePeriodADC 41 502 @99 @98
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@100
	bool	hl
	ld	l,h
	jr	@98
@100:
	ipset	2
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ipres
@98:
	.debug	} @98 511

@97	equ	2
	ld	sp,ix
	pop	ix
	lret
@99	equ	4
$getNoiseADC::
	.debug	G $getNoiseADC 43 9
	.debug	{ $getNoiseADC 43 522 @103 @102
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	c,@104
	bool	hl
	ld	l,h
	jr	@102
@104:
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-4),hl
	ipset	2
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ld	hl,(ix+7)
	bool	hl
	jr	z,@105
	ld	hl,(ix-4)
	ld	e,0x8
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
@105:
	ipres
	ld	hl,(ix-2)
@102:
	.debug	} @102 537

@101	equ	4
	ld	sp,ix
	pop	ix
	lret
@103	equ	6
$resetNoiseDataADC::
	.debug	G $resetNoiseDataADC 37 9
	.debug	{ $resetNoiseDataADC 37 542 @108 @107
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@107
	ld	hl,(ix+5)
	ld	bc,0xa
	ex	de,hl
	mul
	ld	hl,_adcNoiseData
	add	hl,bc
	ld	(ix-2),hl
	call	_KLOCK
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	inc	de
	inc	de
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-2)
	ld	(hl),e
	inc	hl
	ld	(hl),d
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-2)
	ld	bc,de
	ld	de,0x8
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	call	_KUNLOCK
@107:
	.debug	} @107 557

@106	equ	2
	ld	sp,ix
	pop	ix
	lret
@108	equ	4
;112 
;113 SerialInfo  *spiPort;
;114 
;115 uchar  restoreI1CR;
;116 
;117 
;118 //=========================================================================
;119 _nearcall float adcGetRaw(uint ui)  { return (float) adcRaw[ui]; }
	.align	4
$$adcGetRaw::
	ex	(sp),iy
$adcGetRaw::
	.debug	G $adcGetRaw 42 9
	.debug	{ $adcGetRaw 42 119 @112 @111
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
@111:
	.debug	} @111 119

@110	equ	0
	pop	ix
	lret
@112	equ	2
;120 
;121 _nearcall float adcMinRaw(uint ui)  { return 0.0; }
	.align	4
$$adcMinRaw::
	ex	(sp),iy
$adcMinRaw::
	.debug	G $adcMinRaw 42 9
	.debug	{ $adcMinRaw 42 121 @115 @114
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0
	ld	c,e
	ld	b,e
@114:
	.debug	} @114 121

@113	equ	0
	pop	ix
	lret
@115	equ	2
;122 _nearcall float adcMaxRaw(uint ui)  { return (float)0xffff; }
	.align	4
$$adcMaxRaw::
	ex	(sp),iy
$adcMaxRaw::
	.debug	G $adcMaxRaw 42 9
	.debug	{ $adcMaxRaw 42 122 @118 @117
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0xff00
	ld	bc,0x477f
@117:
	.debug	} @117 122

@116	equ	0
	pop	ix
	lret
@118	equ	2
;123 
;124 _nearcall void adcDefaults(uint ui, float *gain, float *offset)
;125 { *gain = 0.0003046;  *offset = 32786.0; }
	.align	4
$$adcDefaults::
	ex	(sp),iy
$adcDefaults::
	.debug	G $adcDefaults 44 9
	.debug	{ $adcDefaults 44 124 @121 @120
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0xb2b8
	ld	bc,0x399f
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0x1200
	ld	bc,0x4700
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@120:
	.debug	} @120 125

@119	equ	0
	pop	ix
	lret
@121	equ	2
;126 
;127 _nearcall void adcCalibPoints(uint ui, float *low, float *high)
;128 { *low = -9.5;  *high = 9.5; }
	.align	4
$$adcCalibPoints::
	ex	(sp),iy
$adcCalibPoints::
	.debug	G $adcCalibPoints 44 9
	.debug	{ $adcCalibPoints 44 127 @124 @123
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@123:
	.debug	} @123 128

@122	equ	0
	pop	ix
	lret
@124	equ	2
;129 
;130 _nearcall char *adcUnits(uint ui, char *buf)  { return "V"; }
	.align	4
$$adcUnits::
	ex	(sp),iy
$adcUnits::
	.debug	G $adcUnits 45 9
	.debug	{ $adcUnits 45 130 @127 @126
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,@128
@126:
	.debug	} @126 130

@125	equ	0
	pop	ix
	lret
@127	equ	2
;131 
;132 //=========================================================================
;133 _nearcall float dacGetRaw(uint ui)  { return (float) dacRaw[ui]; }
	.align	4
$$dacGetRaw::
	ex	(sp),iy
$dacGetRaw::
	.debug	G $dacGetRaw 42 9
	.debug	{ $dacGetRaw 42 133 @131 @130
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+5)
	add	hl,hl
	ld	de,_dacRaw
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
@130:
	.debug	} @130 133

@129	equ	0
	pop	ix
	lret
@131	equ	2
;134 
;135 _nearcall float dacMinRaw(uint ui)  { return 0.0; }
	.align	4
$$dacMinRaw::
	ex	(sp),iy
$dacMinRaw::
	.debug	G $dacMinRaw 42 9
	.debug	{ $dacMinRaw 42 135 @134 @133
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0
	ld	c,e
	ld	b,e
@133:
	.debug	} @133 135

@132	equ	0
	pop	ix
	lret
@134	equ	2
;136 _nearcall float dacMaxRaw(uint ui)  { return (float)0xffffL; }
	.align	4
$$dacMaxRaw::
	ex	(sp),iy
$dacMaxRaw::
	.debug	G $dacMaxRaw 42 9
	.debug	{ $dacMaxRaw 42 136 @137 @136
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0xff00
	ld	bc,0x477f
@136:
	.debug	} @136 136

@135	equ	0
	pop	ix
	lret
@137	equ	2
;137 
;138 _nearcall void dacDefaults(uint ui, float *gain, float *offset)
;139 {  *gain = 0.000311;  *offset = 32768.0;  }
	.align	4
$$dacDefaults::
	ex	(sp),iy
$dacDefaults::
	.debug	G $dacDefaults 44 9
	.debug	{ $dacDefaults 44 138 @140 @139
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0xdb7
	ld	bc,0x39a3
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0
	ld	bc,0x4700
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@139:
	.debug	} @139 139

@138	equ	0
	pop	ix
	lret
@140	equ	2
;140 
;141 _nearcall void dacCalibPoints(uint ui, float *low, float *high)
;142   {  *low = -9.5;  *high = 9.5; }
	.align	4
$$dacCalibPoints::
	ex	(sp),iy
$dacCalibPoints::
	.debug	G $dacCalibPoints 44 9
	.debug	{ $dacCalibPoints 44 141 @143 @142
	push	ix
	ld	ix,0
	add	ix,sp
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@142:
	.debug	} @142 142

@141	equ	0
	pop	ix
	lret
@143	equ	2
;143 
;144 _nearcall char *dacUnits(uint ui, char *buf)  { return "V"; }
	.align	4
$$dacUnits::
	ex	(sp),iy
$dacUnits::
	.debug	G $dacUnits 45 9
	.debug	{ $dacUnits 45 144 @146 @145
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,@128
@145:
	.debug	} @145 144

@144	equ	0
	pop	ix
	lret
@146	equ	2
;145 
;146 //=========================================================================
;147 
;148 
;149 //-------------------------------------------------------------------------
;150 
;151 /* START FUNCTION DESCRIPTION ********************************************
;152 Function: int _readExtioPort ( int port );
;153 
;154 Note:
;155 This function is setup to provide additional hold time when
;156 accessing external I/O addresses 0000 and 0002. This routine
;157 must stay         and not be changed, for the additional
;158 address hold-time to be valid.
;159 
;160 Improved by Softools to not require a copy to RAM because
;161 real tools have align and other stuff for real programmers.
;162 ************************************************************/
;163 /*
;164 unsigned readExtIO (unsigned port)      // Port is 0 or 2
;165 {
;166 #asm
;167     push    ip
;168     ipset   3
;169     ld      a,l
;170     and     a,0x03
;171     jr      z,..read0
;172     jr      ..skip
;173     .align  4           ; Align to clear A0 & A1
;174 ..read0:
;175     nop                 ; A0 = 0, A1 = 0
;176     nop                 ; A0 = 1, A1 = 0
;177     ioe     ld l,(hl)   ; A0 = 0, A1 = 1
;178     pop     ip          ; A0 = 0, A1 = 0
;179     jr      ..exit
;180     .align  4           ; Align to clear A0 & A1
;181 ..skip:
;182     ioe     ld l,(hl)   ; A0 = 0, A1 = 0 (2 bytes)
;183     pop     ip          ; A0 = 0, A1 = 1
;184 ..exit:
;185 #endasm
;186 }
;187 */
;188 
;189 //-------------------------------------------------------------------------
;190 //  determine the device ID based on external hardware settings
;191 //-------------------------------------------------------------------------
;192 ulong ReadDeviceID()
;193 {
$ReadDeviceID::
	.debug	G $ReadDeviceID 47 9
	.debug	{ $ReadDeviceID 47 192 @149 @148
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;194   uchar  inA, devID;
;195 
;196 
;197   inA = RdPortI(PADR);
	ioi ld	a,(48)
	ld	(ix-1),a
;198 
;199 //--- device ID comes from 8-bit switch input ----
;200   devID = ((inA & 0x02) << 6)
;201         | ((inA & 0x01) << 6)
;202         | ((inA & 0x08) << 2)
;203         | ((inA & 0x04) << 2)
;204         | ((inA & 0x20) >> 2)
;205         | ((inA & 0x10) >> 2)
;206         | ((inA & 0x80) >> 6)
;207         | ((inA & 0x40) >> 6);
	and	a,2
	bool	hl
	ld	l,a
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	a,(ix-1)
	and	a,1
	ld	d,0
	ld	e,a
	ex	de,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	or	hl,de
	ld	a,(ix-1)
	and	a,8
	ld	d,0
	ld	e,a
	ex	de,hl
	add	hl,hl
	add	hl,hl
	or	hl,de
	ld	a,(ix-1)
	and	a,4
	ld	d,0
	ld	e,a
	ex	de,hl
	add	hl,hl
	add	hl,hl
	or	hl,de
	ld	a,(ix-1)
	and	a,32
	ld	d,0
	ld	e,a
	ex	de,hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	hl,de
	ld	a,(ix-1)
	and	a,16
	ld	d,0
	ld	e,a
	ex	de,hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	hl,de
	ld	a,(ix-1)
	and	a,128
	ld	d,0
	ld	e,a
	ex	de,hl
	ld	a,0x6
	call	__uishr##
	or	hl,de
	ld	a,(ix-1)
	and	a,64
	ld	d,0
	ld	e,a
	ex	de,hl
	ld	a,0x6
	call	__uishr##
	or	hl,de
	ld	(ix-2),l
;208   devID = ~devID;
	ld	a,l
	cpl	a
	ld	(ix-2),a
;209 
;210   return (ulong) devID;
	ld	e,a
	ld	bc,0
	ld	d,c
;211 }
@148:
	.debug	} @148 211

@147	equ	2
	ld	sp,ix
	pop	ix
	lret
@149	equ	4
;212 
;213 //-------------------------------------------------------------------------
;214 //  return the current state of the digital inputs
;215 //-------------------------------------------------------------------------
;216 ulong ReadDigInputs()
;217 {
$ReadDigInputs::
	.debug	G $ReadDigInputs 47 9
	.debug	{ $ReadDigInputs 47 216 @152 @151
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
;218   uchar  inB, inC, inD, inF;
;219   ulong  inBits;
;220 
;221 
;222 //--- read state of each of the digital inputs we need bits from ---
;223   inB = RdPortI(PBDR);
	ioi ld	a,(64)
	ld	(ix-1),a
;224   inC = RdPortI(PCDR);
	ioi ld	a,(80)
	ld	(ix-2),a
;225   inD = RdPortI(PDDR);
	ioi ld	a,(96)
	ld	(ix-3),a
;226   inF = RdPortI(PFDR);
	ioi ld	a,(56)
	ld	(ix-4),a
;227 
;228 //--- PortF: xxxx-xx##  ==>  inBits: xxxx-xxxx xxxx-xxxx xxxx-xx## ---
;229   inBits  = (uint)inF & 0x03;
	bool	hl
	ld	l,a
	ld	de,0x3
	and	hl,de
	ex	de,hl
	ld	b,h
	ld	c,h
	ld	l,c
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;230 
;231 //--- PortB: xxx#-##xx  ==>  inBits: xxxx-xxxx xxxx-xxxx xxx#-##xx
;232   inBits |= (uint)inB & 0x1c;
	ld	a,(ix-1)
	ld	l,a
	ld	de,0x1c
	and	hl,de
	ex	de,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lor##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;233 
;234 //--- PortC: xxxx-#xxx  ==>  inBits: xxxx-xxxx xxxx-xxxx xx#x-xxxx
;235   inBits |= ((uint)inC & 0x08) << 2;
	ld	a,(ix-2)
	bool	hl
	ld	l,a
	ld	de,0x8
	and	hl,de
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lor##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;236 
;237 //--- PortD: xx##-xxxx  ==>  inBits: xxxx-xxxx xxxx-xxxx ##xx-xxxx
;238   inBits |= ((uint)inD & 0x30) << 2;
	ld	a,(ix-3)
	bool	hl
	ld	l,a
	ld	de,0x30
	and	hl,de
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lor##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;239 
;240 //--- PortF: ####-xxxx  ==>  inBits: xxxx-xxxx xxxx-#### xxxx-xxxx
;241   inBits |= ((uint)inF & 0xf0) << 4;
	ld	a,(ix-4)
	bool	hl
	ld	l,a
	ld	de,0xf0
	and	hl,de
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lor##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;242 
;243   inBits = (inBits & ~forcedDigInMask) | forcedDigInBits;
	ld	de,(_forcedDigInMask)
	ld	bc,(_forcedDigInMask+2)
	call	__lnot##
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__land##
	push	bc
	push	de
	ld	de,(_forcedDigInBits)
	ld	bc,(_forcedDigInBits+2)
	call	__lor##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;244 
;245   return inBits;
;246 }
@151:
	.debug	} @151 246

@150	equ	8
	ld	sp,ix
	pop	ix
	lret
@152	equ	10
;247 
;248 
;249 //-------------------------------------------------------------------------
;250 //  set the state of the digital outputs
;251 //-------------------------------------------------------------------------
;252 void WriteDigOutputs(ulong digOut_)
;253 {
$WriteDigOutputs::
	.debug	G $WriteDigOutputs 48 9
	.debug	{ $WriteDigOutputs 48 252 @155 @154
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;254   ulong  digOut;
;255 
;256 
;257   digOut = (digOut_ & ~forcedDigOutMask) | forcedDigOutBits;
	ld	de,(_forcedDigOutMask)
	ld	bc,(_forcedDigOutMask+2)
	call	__lnot##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__land##
	push	bc
	push	de
	ld	de,(_forcedDigOutBits)
	ld	bc,(_forcedDigOutBits+2)
	call	__lor##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;258 
;259   digOut = ~digOut;
	call	__lnot##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;260 
;261 //--- digOut: xxxx-xxxx xxxx-xxxx ####-####  ==>  PortG: ####-####
;262   outi(PGDR, srPGDR = (uchar)digOut);
	ld	a,(ix-4)
	ld	(_srPGDR),a
	ioi ld	(72),a
;263 
;264 //--- digOut: xxxx-xxxx xxxx-x### xxxx-xxxx  ==>  PortB: ###x-xxxx
;265   outi(PBDR, srPBDR = (srPBDR & 0x1F) | (uint)((digOut & 0x0700) >> 3) );
	ld	a,(_srPBDR)
	and	a,31
	ld	l,a
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x700
	ld	c,e
	ld	b,e
	call	__land##
	ld	a,0x3
	call	__ulshr##
	ld	h,0
	or	hl,de
	ld	a,l
	ld	(_srPBDR),a
	ioi ld	(64),a
;266 }
@154:
	.debug	} @154 266

@153	equ	4
	ld	sp,ix
	pop	ix
	lret
@155	equ	6
;267 
;268 
;269 //-------------------------------------------------------------------------
;270 //  Function to communicate with an ADS7825 chip (a 4-channel, 16-bit ADC)
;271 //
;272 //  Call:
;273 //    convertADS7825(uint nextChan)
;274 //
;275 //    Input:
;276 //       nextChan: Channel # to sample between calls and to do conversion
;277 //                 on during the next call.
;278 //
;279 //    Result:
;280 //       The raw value for the channel specified during the previous call
;281 //       is updated.
;282 //
;283 //
;284 //  To maximize the conversion rate, the ADS7825 begins acquiring/sampling
;285 //  the signal to be converted as soon as the previous conversion is
;286 //  completed.  This requires that it already know what channel to begin
;287 //  sampling, so you have to tell it what channel to sample for the NEXT
;288 //  conversion, NOT the current conversion.
;289 //
;290 //  NOTE that this does NOT mean that the conversion initiated by this call
;291 //  is for outdated data.  The ADS7825 is sampling the channel specified
;292 //  during the last call right up to the time it is told to start the
;293 //  conversion.  The only catch is you have to know what channel that was
;294 //  so when you read the conversion data you know what channel it is for.
;295 //
;296 //  The ADC7825 is fairly unique in that it has a TAG input that allows
;297 //  multiple ADC's to be connected in a daisy-chain configuration, allowing
;298 //  you to initiate a conversion on multiple chips at the same time and the
;299 //  read the results from all of them in a single operation.  This greatly
;300 //  decreases the additonal time needed to support more than 4 channels whe
;301 //  the chips are connected in this manner.
;302 //
;303 //  NOTE:  The downside, of course, is the cost per input, both in $ and in
;304 //         board space.  Only 4 inputs means never more than 4 passes to
;305 //         read any # of channels.  It also means one more (expensive) chip
;306 //         for each additional group of 4 channels.
;307 //
;308 //-------------------------------------------------------------------------
;309 void convertADS7825(uint nextChan)
;310 {
$convertADS7825::
	.debug	G $convertADS7825 37 9
	.debug	{ $convertADS7825 37 309 @158 @157
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
;311   uchar  buf[10];
;312   static uint  prevChan = 0;
	.dseg
@159:
	.dw	0
	.seg	FARCODE
;313 
;314 
;315   nextChan &= 3;
	ld	hl,(ix+5)
	ld	de,0x3
	and	hl,de
	ld	(ix+5),hl
;316 
;317 //--- Set the bits that will tell the ADC which channel to sample between -
;318 //--- calls to this func, and to hold and convert during the next call ---
;319 //--- (PE6 and PE7 are connected to ADR0 and ADR1 on all ADC's) ---
;320 //--- NOTE:  PE6/7 are also used for CS- on two of the DAC's.  Because ---
;321 //--- the ADC input selection bits are latched when a conversion starts, --
;322 //--- we can get away with this, so long as we don't generate any SPI ---
;323 //--- clock pulses for the ADC chip while a DAC chip is selected ---
;324   outi(PEDR, srPEDR = (srPEDR & 0x3F) | (nextChan << 6));
	ld	a,(_srPEDR)
	and	a,63
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	e,a
	or	hl,de
	ld	a,l
	ld	(_srPEDR),a
	ioi ld	(112),a
;325 
;326 //--- set R/C- low first so we can use CS- to start conversion ---
;327 //--- NOTE:  PE4 also used for CS- on one of the DAC's ---
;328   outi(PEDR, srPEDR &= 0xEF);  // R/C- (PE4) low (convert)
	ld	a,(_srPEDR)
	and	a,239
	ld	(_srPEDR),a
	ioi ld	(112),a
;329 
;330 //--- Toggle /CS low then high very quickly.  This starts the conversion --
;331 //--- on the previously specified input and latches the input # to be used 
;332 //--- for the next conversion.  /CS must be low for at least 40ns, but must
;333 //--- go high again before BUSY does (aprox 25us).  If /CS is still low whe
;334 //--- BUSY goes high, the next conversion will start and the results of the
;335 //--- previous one will be lost ---
;336   _EnterCritical_();
	ipset	2
;337   outi(PFDR, srPFDR &= 0xFB);  // /CS (PF2) low
	ld	a,(_srPFDR)
	and	a,251
	ld	(_srPFDR),a
	ioi ld	(56),a
;338   outi(PFDR, srPFDR |= 0x04);  // /CS (PF2) high
	ld	a,(_srPFDR)
	or	a,4
	ld	(_srPFDR),a
	ioi ld	(56),a
;339   _ExitCritical_();
	ipres
;340 
;341 //--- set R/C- high to enable read mode ---
;342   outi(PEDR, srPEDR |= 0x10);  // R/C- (PE4) high
	ld	a,(_srPEDR)
	or	a,16
	ld	(_srPEDR),a
	ioi ld	(112),a
;343 
;344 //--- The design did not include the ability to read the BUSY signal, so --
;345 //--- add a short delay to avoid trying to read the data before it is ready
;346   for (uint xx=0; xx<20; ++xx);
	bool	hl
	ld	l,h
	ld	(ix-12),hl
	.seg	FARCODE
@162:
	ld	hl,(ix-12)
	ld	de,0x14
	or	a,a
	sbc	hl,de
	jr	nc,@163
;347 
;348 //--- set both addr lines (shared with DAC CS- lines) back high ---
;349 //--- to avoid having any DAC's reacting to the serial clock pulses ---
;350 //--- about to be generated ---
;351   outi(PEDR, srPEDR |= 0xC0);
	ld	hl,(ix-12)
	inc	hl
	ld	(ix-12),hl
	jr	@162
@163:
	ld	a,(_srPEDR)
	or	a,192
	ld	(_srPEDR),a
	ioi ld	(112),a
;352 
;353 //--- set /CS low again to enable transmission of data ---
;354   outi(PFDR, srPFDR &= 0xFB);  // /CS (PF2) low
	ld	a,(_srPFDR)
	and	a,251
	ld	(_srPFDR),a
	ioi ld	(56),a
;355 
;356 //--- The NSCL16 controller supports an external ADC chained to the one on 
;357 //--- the SBC, so we will get values for 2 channels (the same one from each
;358 //--- ADC) at once: ---
;359 //--- NOTE: Each ADC sends 17 bits (for a total of 34 bits, or 4.25 bytes).
;360 //---       The first bit of each 17 is NOT part of the data ---
;361   _spiRead_(spiPort, buf, 5, false);
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x5
	push	hl
	ld	hl,-6+@156
	add	hl,sp
	push	hl
	ld	hl,(_spiPort)
	push	hl
	lcall	$_spiRead_
	add	sp,8
;362 
;363 //--- set /CS high so ADC does not react to clock pulses not meant for it -
;364   outi(PFDR, srPFDR |= 0x04);  // /CS (PF2) high
	ld	a,(_srPFDR)
	or	a,4
	ld	(_srPFDR),a
	ioi ld	(56),a
;365 
;366 //--- extract the raw value from the bytes just read ---
;367   adcRaw[prevChan] = (uint) (0x8000 ^ (
;368       ((uint)buf[0] << 9) |
;369       ((uint)buf[1] << 1) |
;370       ((uint)buf[2] >> 7)
;371     ) );
	bool	hl
	ld	h,(ix-10)
	ld	l,0
	add	hl,hl
	ld	d,0
	ld	e,(ix-9)
	ex	de,hl
	add	hl,hl
	or	hl,de
	ld	d,0
	ld	e,(ix-8)
	ex	de,hl
	ld	a,0x7
	call	__uishr##
	or	hl,de
	ld	a,h
	xor	a,128
	ld	h,a
	ld	de,(@159)
	ex	de,hl
	add	hl,hl
	ld	bc,de
	ld	de,_adcRaw
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;372   adcRaw[prevChan+4] = (uint) (0x8000 ^ (
;373     ((uint)buf[2] << 10) |
;374     ((uint)buf[3] << 2) |
;375     ((uint)buf[4] >> 6)
;376   ) );
	bool	hl
	ld	h,(ix-8)
	ld	l,0
	add	hl,hl
	add	hl,hl
	ld	d,0
	ld	e,(ix-7)
	ex	de,hl
	add	hl,hl
	add	hl,hl
	or	hl,de
	ld	d,0
	ld	e,(ix-6)
	ex	de,hl
	ld	a,0x6
	call	__uishr##
	or	hl,de
	ld	a,h
	xor	a,128
	ld	h,a
	ld	de,(@159)
	ld	bc,hl
	ld	hl,0x4
	add	hl,de
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;377 
;378 //--- keep track of what channel we started the conversion on, because that
;379 //--- is the channel whose value will be read during the next call ---
;380   prevChan = nextChan;
	ld	hl,(ix+5)
	ld	(@159),hl
;381 }
@157:
	.debug	} @157 381

@156	equ	12
	ld	sp,ix
	pop	ix
	lret
@158	equ	14
;382 
;383 
;384 //-------------------------------------------------------------------------
;385 //  Read analog inputs.  The PS8Rack controller has 4 ADS7825 ADC's.  Each
;386 //  ADC has 4 16-bit inputs and the 4 chips are daisy-chained together so
;387 //  data can be read from all 4 chips in a single operation.
;388 //-------------------------------------------------------------------------
;389 void readAnalogInputs(ulong mask)
;390 {
$readAnalogInputs::
	.debug	G $readAnalogInputs 48 9
	.debug	{ $readAnalogInputs 48 389 @167 @166
	push	ix
	ld	ix,0
	add	ix,sp
;391   static uint  waitTicks = 20, lastLogged = 0;
	.dseg
@168:
	.dw	0x14
	.seg	FARCODE
	.dseg
@169:
	.dw	0
	.seg	FARCODE
;392 
;393 
;394 //--- We use the fact that this is called periodically but NOT by ISRs. --
;395 //--- This allows us to check for a temporarily disabled INT1 ISR ---
;396 //--- and re-enable it (after a bunch of nested INTs have "unwound") ---
;397   if (restoreI1CR)  if (--waitTicks == 0)  {
	ld	a,(_restoreI1CR)
	or	a,a
	jr	z,@170
	ld	hl,(@168)
	dec	hl
	ld	(@168),hl
	bool	hl
	jr	nz,@171
;398     if (msSince_(lastLogged) > 30000)  {
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(@169)
	or	a,a
	sbc	hl,de
	ld	de,0x7530
	or	a,a
	sbc	hl,de
	jr	c,@174
	jr	z,@174
;399       printf("*** Excessive INT1 occurances detected ***\r\n");
	ld	de,word (phys @1+271)
	ld	c,phys @1+271 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;400       lastLogged = GetMS_();
	ld	hl,(__TimerMilliSeconds+4)
	ld	(@169),hl
;401     }
;402     _EnterCritical_();
@174:
	ipset	2
;403     outi(I1CR, srI1CR = restoreI1CR);  // reenable INT1
	ld	a,(_restoreI1CR)
	ld	(_srI1CR),a
	ioi ld	(153),a
;404     restoreI1CR = 0;  waitTicks = 20;
	xor	a,a
	ld	(_restoreI1CR),a
	ld	hl,0x14
	ld	(@168),hl
;405     _ExitCritical_();
	ipres
;406   }
;407 
;408 
;409   if (! spiPort)  return;
@171:
@170:
	ld	hl,(_spiPort)
	bool	hl
	jr	z,@166
;410 
;411 //--- Remember we have to tell the ADC which channel's data we will read --
;412 //--- NEXT time we call it, so consistently using the sequence 1, 2, 3, 0 -
;413 //--- each time means we get the data for 0, 1, 2, 3.  Also remember that -
;414 //--- this means channel 0 will be continously sampled (READY for conversio
;415 //--- between calls to this function ---
;416 
;417   _spiConfig_(spiPort, CLK_1MHz, NORM_LOW_LATCH_FALL);
	ld	l,0x1
	push	hl
	ld	l,0xa
	push	hl
	ld	hl,(_spiPort)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
;418 
;419   convertADS7825(1);  // chan to convert NEXT call
	ld	hl,0x1
	push	hl
	lcall	$convertADS7825
	pop	hl
;420   convertADS7825(2);  // chan to convert NEXT call
	ld	hl,0x2
	push	hl
	lcall	$convertADS7825
	pop	hl
;421   convertADS7825(3);  // chan to convert NEXT call
	ld	hl,0x3
	push	hl
	lcall	$convertADS7825
	pop	hl
;422   convertADS7825(0);  // chan to convert NEXT call
	bool	hl
	ld	l,h
	push	hl
	lcall	$convertADS7825
	pop	hl
;423 }
@166:
	.debug	} @166 423

@165	equ	0
	pop	ix
	lret
@167	equ	2
;424 
;425 
;426 //-------------------------------------------------------------------------
;427 //  Update the state of the AD5542 DAC chips
;428 //-------------------------------------------------------------------------
;429 void writeAnalogOutputs(ulong mask)
;430 {
$writeAnalogOutputs::
	.debug	G $writeAnalogOutputs 48 9
	.debug	{ $writeAnalogOutputs 48 429 @180 @179
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-7
;431   uchar  buf[2];
;432   uint   rawVal, bitTest;
;433   uchar  i;
;434   static const uchar  DAC_CS[4] = { 0x08, 0x10, 0x40, 0x80 };
	.seg	CONST
@181:
	.db	0x8
	.db	0x10
	.db	0x40
	.db	0x80
	.seg	FARCODE
;435 
;436 
;437   if (! spiPort)  return;
	ld	hl,(_spiPort)
	bool	hl
	jp	z,@179
;438 
;439 //--- set SPI clock mode ---
;440   _spiConfig_(spiPort, CLK_1MHz, NORM_LOW_LATCH_RISE);
	bool	hl
	ld	l,h
	push	hl
	ld	l,0xa
	push	hl
	ld	hl,(_spiPort)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
;441 
;442   for (i=0,bitTest=1; i<NUM_DAC; ++i,bitTest<<=1)  if (bitTest & (uint)mask
	xor	a,a
	ld	(ix-7),a
	ld	hl,0x1
	ld	(ix-6),hl
@185:
	ld	a,(ix-7)
	sub	a,2
	jr	nc,@186
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	and	hl,de
	jr	z,@188
;443 
;444   //--- set /CS low for appropriate chip ---
;445     outi(PEDR, srPEDR &= ~DAC_CS[i]);
	bool	hl
	ld	l,(ix-7)
	ld	de,@181
	add	hl,de
	ld	a,(hl)
	cpl	a
	ld	l,a
	ld	a,(_srPEDR)
	and	a,l
	ld	(_srPEDR),a
	ioi ld	(112),a
;446 
;447   //--- send cmd to DAC chip ---
;448     rawVal = dacRaw[i];  buf[0] = rawVal >> 8;  buf[1] = rawVal & 0xff;
	bool	hl
	ld	l,(ix-7)
	add	hl,hl
	ld	de,_dacRaw
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	l,h
	ld	(ix-2),l
	ld	hl,(ix-4)
	ld	h,0
	ld	(ix-1),l
;449     _spiWrite_(spiPort, buf, 2, false);
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x2
	push	hl
	ld	hl,2+@178
	add	hl,sp
	push	hl
	ld	hl,(_spiPort)
	push	hl
	lcall	$_spiWrite_
	add	sp,8
;450 
;451   //--- set /CS high for appropriate chip ---
;452     outi(PEDR, srPEDR |= DAC_CS[i]);
	bool	hl
	ld	l,(ix-7)
	ld	de,@181
	add	hl,de
	ld	l,(hl)
	ld	a,(_srPEDR)
	or	a,l
	ld	(_srPEDR),a
	ioi ld	(112),a
;453   }
;454 
;455 }
@188:
	ld	a,(ix-7)
	inc	a
	ld	(ix-7),a
	ld	hl,(ix-6)
	add	hl,hl
	ld	(ix-6),hl
	jr	@185
@186:
@179:
	.debug	} @179 455

@178	equ	7
	ld	sp,ix
	pop	ix
	lret
@180	equ	9
;456 
;457 
;458 //-------------------------------------------------------------------------
;459 /*
;460 float ADCtoVolts(uchar chan, uint rawADC)
;461 {
;462   return (ADCOffset(chan) - (float)(rawADC)) * ADCGain(chan);
;463 }
;464 */
;465 
;466 //-------------------------------------------------------------------------
;467 //  Interrupt Service Routine to catch state of IQ optical encoder.
;468 //  Assumes that A is tied to an input bit and B is tied to the INT-PE5 inp
;469 //  (and triggered the interrupt that called this func)
;470 //-------------------------------------------------------------------------
;471 void _int qdPulse()
;472 {
	.cseg
_qdPulse::
	.debug	G _qdPulse 49 3
	.debug	{ _qdPulse 49 471 @193 @192
	push	ip
	push	hl
	push	de
	push	bc
	push	af
	exx
	push	hl
	push	de
	push	bc
	exx
	push	iy
	push	ix
;473 /*
;474   If the same interrupt occurs again before the ISR shim that called this I
;475   returns to the interrupted code, the next instance will cause this ISR to
;476   be called right after the ipres/ret at the end of this ISR.  This means t
;477   ISR shim which called this ISR will not return to the originally interrup
;478   code before this ISR is invoked again.  If this happens too many times in
;479   row, the stack of the originally interrupted task will overflow.
;480 
;481   To guard against this possibility, we check to see if the level of nested
;482   scheduler locks has gotten unreasonably large.  If it has, this ISR disab
;483   the interrupt that calls it, which (if the above IS the cause of the
;484   scheduler not running), will allow all the previous occurances to return.
;485 
;486   Once all the previous occurances have finished, the scheduler will be act
;487   again and the application task will run.  One of the functions that the
;488   application task calls is used to check to see if the interrupt was disab
;489   If it was, it reenables it, and things will be back to normal (unless, of
;490   couse, we are still getting a continuous stream of interrupts, in which c
;491   the cycle keeps repeating.
;492 
;493   While this can hurt performance, that is still far better than allowing t
;494   OS to crash and reboot.  And experience has shown that this situation is
;495   often temporary, and can easily be stopped just by touching the knob on t
;496   front of the controller.
;497 */
;498 //  uint  stackLeft;
;499 
;500 //  stackLeft = CurSP() - (uint) current->stack_start;
;501 
;502 //  if ((stackLeft < 100) AND (_disabled > 30))  {
;503   if (_disabled > 30)  {  // _disabled is incr by the ISR shim...
	ld	a,(__disabled)
	sub	a,30
	jr	c,@194
	jr	z,@194
;504     restoreI1CR = srI1CR;  // save the value that will reenable this ISR
	ld	a,(_srI1CR)
	ld	(_restoreI1CR),a
;505     outi(I1CR, srI1CR = 0x00);  // disable INT1
	xor	a,a
	ld	(_srI1CR),a
	ioi ld	(153),a
;506   }
;507 
;508 //--- got here because B just went high - if A already high (i.e. A leads B
;509 //--- then knob was turned clockwise and count should be increased ---
;510   if (ini(PFDR) & 0x08)  ++qdCount;  else  --qdCount;   // A tied to PE3
@194:
	ioi ld	a,(56)
	and	a,8
	jr	z,@197
	ld	hl,(_qdCount)
	inc	hl
	ld	(_qdCount),hl
	jr	@198
@197:
	ld	hl,(_qdCount)
	dec	hl
	ld	(_qdCount),hl
;511 }
@198:
@192:
	.debug	} @192 511

@191	equ	0
	pop	ix
	pop	iy
	exx
	pop	bc
	pop	de
	pop	hl
	exx
	pop	af
	pop	bc
	pop	de
	pop	hl
	pop	ip
	ipres
	ret
@193	equ	2
;512 
;513 
;514 //-------------------------------------------------------------------------
;515 //  Set an External 2/4-wire RS-485 adapter to transmit mode
;516 //-------------------------------------------------------------------------
;517 void setExt485Tx(void)
;518 {
	.seg	FARCODE
$setExt485Tx::
	.debug	G $setExt485Tx 39 9
	.debug	{ $setExt485Tx 39 517 @201 @200
;519 }
@200:
	.debug	} @200 519

@199	equ	0
	lret
@201	equ	0
;520 //-------------------------------------------------------------------------
;521 //  Set an External 2/4-wire RS-485 adapter to receive mode
;522 //-------------------------------------------------------------------------
;523 void setExt485Rx(void)
;524 {
$setExt485Rx::
	.debug	G $setExt485Rx 39 9
	.debug	{ $setExt485Rx 39 523 @204 @203
;525 }
@203:
	.debug	} @203 525

@202	equ	0
	lret
@204	equ	0
;526 
;527 //-------------------------------------------------------------------------
;528 //  functions to enable/disable the transmitter for an RS-485 connection
;529 //-------------------------------------------------------------------------
;530 void _nearcall SerSetDirA(int enableXmit)  {  }
	.align	4
$$SerSetDirA::
	ex	(sp),iy
$SerSetDirA::
	.debug	G $SerSetDirA 50 9
	.debug	{ $SerSetDirA 50 530 @207 @206
	push	ix
	ld	ix,0
	add	ix,sp
@206:
	.debug	} @206 530

@205	equ	0
	pop	ix
	lret
@207	equ	2
;531 void _nearcall SerSetDirB(int enableXmit)  {  }
	.align	4
$$SerSetDirB::
	ex	(sp),iy
$SerSetDirB::
	.debug	G $SerSetDirB 50 9
	.debug	{ $SerSetDirB 50 531 @210 @209
	push	ix
	ld	ix,0
	add	ix,sp
@209:
	.debug	} @209 531

@208	equ	0
	pop	ix
	lret
@210	equ	2
;532 void _nearcall SerSetDirC(int enableXmit)  {  }
	.align	4
$$SerSetDirC::
	ex	(sp),iy
$SerSetDirC::
	.debug	G $SerSetDirC 50 9
	.debug	{ $SerSetDirC 50 532 @213 @212
	push	ix
	ld	ix,0
	add	ix,sp
@212:
	.debug	} @212 532

@211	equ	0
	pop	ix
	lret
@213	equ	2
;533 void _nearcall SerSetDirD(int enableXmit)
;534 {  // PE1 controls RS-485 line driver for port D(3) RS-485 connections
	.align	4
$$SerSetDirD::
	ex	(sp),iy
$SerSetDirD::
	.debug	G $SerSetDirD 50 9
	.debug	{ $SerSetDirD 50 533 @216 @215
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
;535   char  val;
;536   val = enableXmit ? (srPEDR | 0x02) : (srPEDR & ~0x02);
	ld	hl,(ix+5)
	bool	hl
	jr	z,@217
	ld	a,(_srPEDR)
	or	a,2
	jr	@218
@217:
	ld	a,(_srPEDR)
	and	a,253
@218:
	ld	(ix-1),a
;537   outi(PEDR, srPEDR = val);
	ld	(_srPEDR),a
	ioi ld	(112),a
;538 }
@215:
	.debug	} @215 538

@214	equ	1
	ld	sp,ix
	pop	ix
	lret
@216	equ	3
;539 
;540 
;541 //-------------------------------------------------------------------------
;542 void hdwInit(ulong digOutState)
;543 {
$hdwInit::
	.debug	G $hdwInit 48 9
	.debug	{ $hdwInit 48 542 @221 @220
	push	ix
	ld	ix,0
	add	ix,sp
;544   hdwType = HT_NSCL16;
	ld	hl,0x2
	ld	(_hdwType),hl
;545 
;546   __brdInitFlag = TRUE;
	ld	a,0x1
	ld	(___brdInitFlag),a
;547 
;548 // (NI) = Normal Input
;549 // (NO) = Normal Output
;550 // (AI) = Alternate Input
;551 // (AO) = Alternate Output
;552 // (xx) = Used by ZWorld core - do not change
;553 
;554   //--- Port A --- (*must be inputs due to bug in earlier Rabbit 3000's)
;555   //  PA0 - (NI)  DI-16*
;556   //  PA1 - (NI)  DI-17*
;557   //  PA2 - (NI)  DI-18*
;558   //  PA3 - (NI)  DI-19*
;559   //  PA4 - (NI)  DI-20*
;560   //  PA5 - (NI)  DI-21*
;561   //  PA6 - (NI)  DI-22*
;562   //  PA7 - (NI)  DI-23*
;563     outi(SPCR, srSPCR &= ~0x0c);  // PortA: byte input
	ld	a,(_srSPCR)
	and	a,243
	ld	(_srSPCR),a
	ioi ld	(36),a
;564 
;565   //--- Port B ---
;566   //  PB0 - (--)  Serial-B (SPI) clock (output)
;567   //  PB1 - (--)  Serial-A (Diag/Prog) clock (output)
;568   //  PB2 - (NI)  DI-02
;569   //  PB3 - (NI)  DI-03
;570   //  PB4 - (NI)  DI-04
;571   //  PB5 - (NO)  DO-08
;572   //  PB6 - (NO)  DO-09
;573   //  PB7 - (NO)  DO-10
;574     outi(PBDDR, srPBDDR = (srPBDDR | 0xE0) & ~0x1C); // dir: OOOI-IIxx
	ld	a,(_srPBDDR)
	or	a,224
	and	a,227
	ld	(_srPBDDR),a
	ioi ld	(71),a
;575 
;576   //--- Port C ---
;577   //  PC0 - (AO)  Serial-D transmit
;578   //  PC1 - (--)  Serial-D receive
;579   //  PC2 - (NO)  enable/disable Digital I/O buffers (output)
;580   //  PC3 - (--)  DI-05
;581   //  PC4 - (AO)  Serial-B (SPI) transmit
;582   //  PC5 - (--)  Serial-B (SPI) receive
;583   //  PC6 - (AO)  Serial-A (Diag/Prog) transmit
;584   //  PC7 - (--)  Serial-A (Diag/Prog) receive
;585     outi(PCFR, srPCFR = 0x51);  // func: xAxA-xOxA
	ld	a,0x51
	ld	(_srPCFR),a
	ioi ld	(85),a
;586 
;587   //--- Port D ---
;588   //  PD0 - (xx)  Ethernet Controller Reset (output)
;589   //  PD1 - (xx)  Not Avail (pulled high - otherwise not connected???)
;590   //  PD2 - (xx)  Ethernet Controller (TPOUT-)
;591   //  PD3 - (xx)  Ethernet Controller (TPOUT+)
;592   //  PD4 - (NI)  DI-06
;593   //  PD5 - (NI)  DI-07
;594   //  PD6 - (xx)  Ethernet Controller (TPIN-)
;595   //  PD7 - (xx)  Ethernet Controller (TPIN+)
;596     outi(PDDDR, srPDDDR &= ~0x30);  // dir:  xxII-xxxx
	ld	a,(_srPDDDR)
	and	a,207
	ld	(_srPDDDR),a
	ioi ld	(103),a
;597     outi(PDFR, srPDFR &= ~0x30);    // func: xxNN-xxxx
	ld	a,(_srPDFR)
	and	a,207
	ld	(_srPDFR),a
	ioi ld	(101),a
;598 
;599   //--- Port E ---
;600   //  PE0 - (xx)  Ethernet Controller Interrupt (input)
;601   //  PE1 - (NO)  RS485 xmit/driver enable (output)
;602   //  PE2 - (xx)  Ethernet Controller Chip Select (output)
;603   //  PE3 - (NO)  DAC-00 chip select (output)
;604   //  PE4 - (NO)  DAC-01 chip select (output)
;605   //  PE5 - (AI)  External interrupt (input)
;606   //  PE6 - (NO)  DAC-02 chip select (output)
;607   //  PE7 - (NO)  DAC-03 chip select (output)
;608     outi(PEDDR, srPEDDR = (srPEDDR & ~0x20) | 0xDA); // dir:  OOIO-OxOx
	ld	a,(_srPEDDR)
	and	a,223
	or	a,218
	ld	(_srPEDDR),a
	ioi ld	(119),a
;609     outi(PEFR, srPEFR = (srPEFR | 0x20) & ~0xDA);    // func: NNAN-NxNx
	ld	a,(_srPEFR)
	or	a,32
	and	a,37
	ld	(_srPEFR),a
	ioi ld	(117),a
;610 
;611   //--- Port F ---
;612   //  PF0 - (NI)  DI-00
;613   //  PF1 - (NI)  DI-01
;614   //  PF2 - (NO)  ADC Chip Select (output)
;615   //  PF3 - (NI)  ADC Ready (input)
;616   //  PF4 - (NI)  DI-08
;617   //  PF5 - (NI)  DI-09
;618   //  PF6 - (NI)  DI-10
;619   //  PF7 - (NI)  DI-11
;620     outi(PFDDR, srPFDDR = 0x04);  // dir:  IIII-IOII
	ld	a,0x4
	ld	(_srPFDDR),a
	ioi ld	(63),a
;621     outi(PFFR, srPFFR = 0x00);    // func: NNNN-NNNN
	xor	a,a
	ld	(_srPFFR),a
	ioi ld	(61),a
;622 
;623   //--- Port G ---
;624   //  PG0 - (NO)  DO-00
;625   //  PG1 - (NO)  DO-01
;626   //  PG2 - (NO)  D0-02
;627   //  PG3 - (NO)  DO-03
;628   //  PG4 - (NO)  DO-04
;629   //  PG5 - (NO)  DO-05
;630   //  PG6 - (NO)  DO-06
;631   //  PG7 - (NO)  DO-07
;632     outi(PGDDR, srPGDDR = 0xFF);  // dir:  OOOO-OOOO
	ld	a,0xff
	ld	(_srPGDDR),a
	ioi ld	(79),a
;633     outi(PGFR, srPGFR = 0x00);    // func: NNNN-NNNN
	xor	a,a
	ld	(_srPGFR),a
	ioi ld	(77),a
;634 
;635 
;636   //--- all parallel port outputs driven hi/lo (no open-drain outputs) ---
;637     outi(PDDCR, srPDDCR = 0x00);
	xor	a,a
	ld	(_srPDDCR),a
	ioi ld	(102),a
;638     outi(PFDCR, srPFDCR = 0x00);
	xor	a,a
	ld	(_srPFDCR),a
	ioi ld	(62),a
;639     outi(PGDCR, srPGDCR = 0x00);
	xor	a,a
	ld	(_srPGDCR),a
	ioi ld	(78),a
;640 
;641   //--- set state of digital outputs ---
;642     digitalOut = digOutState;  WriteDigOutputs(digOutState);
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
;643 
;644   //--- enable input and output buffers ---
;645     outi(PCDR, srPCDR &= ~0x04);  // bring PC2 low
	ld	a,(_srPCDR)
	and	a,251
	ld	(_srPCDR),a
	ioi ld	(80),a
;646 
;647   //--- deselect all DAC's ---
;648     outi(PEDR, srPEDR |= 0xD8);  // set PE3,4,6,7 high
	ld	a,(_srPEDR)
	or	a,216
	ld	(_srPEDR),a
	ioi ld	(112),a
;649 
;650 //    ser485Rx();  // disable the RS485 transmitter
;651 //    setExt485Rx();  // set external 2/4-wire RS-485 adapter to Rx mode
;652 
;653     spiPort = NULL;  // set later by a call from the kernel process
	bool	hl
	ld	l,h
	ld	(_spiPort),hl
;654 
;655 
;656 //--- set INT1B interrupt handler for rising edge on PE5 using priority 1 -
;657   qdCount = 0;  restoreI1CR = 0;
	ld	(_qdCount),hl
	xor	a,a
	ld	(_restoreI1CR),a
;658   setInterruptHandler(INT_INT1, qdPulse);
	ld	hl,_qdPulse
	push	hl
	ld	hl,0x11
	push	hl
	lcall	$setInterruptHandler
	add	sp,4
;659   outi(I1CR, srI1CR = 0x21);  // enable extern INT1B on PE5, rising edge, I
	ld	a,0x21
	ld	(_srI1CR),a
	ioi ld	(153),a
;660 
;661 
;662   flashSize = 524288L;
	ld	de,0
	ld	bc,0x8
	ld	(_flashSize),de
	ld	(_flashSize+2),bc
;663 
;664   printf("\r\nInitialized %s hardware\r\n", ArchName);
	ld	hl,_ArchName
	push	hl
	ld	de,word (phys @1+316)
	ld	c,phys @1+316 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;665 }
@220:
	.debug	} @220 665

@219	equ	0
	pop	ix
	lret
@221	equ	2
;666 
;667 
;668 //-------------------------------------------------------------------------
;669 //  Initialize and register hardware-dependent file systems
;670 //-------------------------------------------------------------------------
;671 void registerFileSystems(void)
;672 {
$registerFileSystems::
	.debug	G $registerFileSystems 39 9
	.debug	{ $registerFileSystems 39 671 @224 @223
;673   socketInit_();
	lcall	$socketInit_
;674   srfsInit_();
	lcall	$srfsInit_
;675   serialInit_();
	lcall	$serialInit_
;676 #ifdef ASFLASH
;680   flashFileInit_();
	lcall	$flashFileInit_
;681 }
@223:
	.debug	} @223 681

@222	equ	0
	lret
@224	equ	0
;682 
;683 //-------------------------------------------------------------------------
;684 //  Initialize the network hardware
;685 //-------------------------------------------------------------------------
;686 void netHdwInit()
;687 {
$netHdwInit::
	.debug	G $netHdwInit 49 9
	.debug	{ $netHdwInit 49 686 @227 @226
;688 //  Select ethernet hardware:
;689 //  usingAsix, usingDevKit, usingRealtek, usingSMSC
;690 //  usingAll() can be used to support all cmd core modules, but req's more 
;691 
;692   usingAsix();
	lcall	$usingAsix
;693 }
@226:
	.debug	} @226 693

@225	equ	0
	lret
@227	equ	0
;694 
;695 
;696 //-------------------------------------------------------------------------
;697 //  allocate any resources that should be owned by the kernel process
;698 //
;699 //  To be called ONLY by the kernel process!!!!
;700 //-------------------------------------------------------------------------
;701 void hdwInit2(void)
;702 {
$hdwInit2::
	.debug	G $hdwInit2 39 9
	.debug	{ $hdwInit2 39 701 @230 @229
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;703 //  char  *argv_[3];
;704 //  uint  argc_;
;705   fd_t  spifd;
;706 
;707 
;708   spifd = _serial_(ADC_DAC_SPIPort, 0, SER_SPI, SER_NO_FLOW);
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x4
	push	hl
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	lcall	$_serial_
	add	sp,8
	ld	(ix-2),hl
;709 
;710   spiPort = _FileFromFD_(spifd)->ioDev;
	push	hl
	lcall	$_FileFromFD_
	pop	hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	(_spiPort),de
;711 
;712   printf("spiPort: %04lX (%d)\r\n", (ulong)spiPort, spiPort->port);  //tdeb
	ld	h,d
	ld	l,e
	inc	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	h,d
	ld	l,e
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys @1+344)
	ld	c,phys @1+344 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;713 
;714 //  argv_[0] = "getty";  argv_[1] = "19200";  argv_[2] = "tty3";  argc_ = 3
;715 //  createProc(getty, 5, argc_, argv_);
;716 }
@229:
	.debug	} @229 716

@228	equ	2
	ld	sp,ix
	pop	ix
	lret
@230	equ	4
;717 
;718 //-------------------------------------------------------------------------
;719 
	.extern	__disabled 3
	.extern	_SchedMS 7
	.extern	$farprintf 51
	.extern	_srSPCR 3
	.extern	_srPBDR 3
	.extern	_srPCDR 3
	.extern	_srPCFR 3
	.extern	_srPDFR 3
	.extern	_srPDDCR 3
	.extern	_srPDDDR 3
	.extern	_srPEDR 3
	.extern	_srPEFR 3
	.extern	_srPEDDR 3
	.extern	_srI1CR 3
	.extern	_srPFDR 3
	.extern	_srPFFR 3
	.extern	_srPFDCR 3
	.extern	_srPFDDR 3
	.extern	_srPBDDR 3
	.extern	_srPGDR 3
	.extern	_srPGFR 3
	.extern	_srPGDCR 3
	.extern	_srPGDDR 3
	.extern	$setInterruptHandler 52
	.extern	__TimerMilliSeconds 53
	.bseg
___brdInitFlag::
	.ds	1
	.debug	G ___brdInitFlag 3 0
_ramSize::
	.ds	4
	.debug	G _ramSize 9 0
_flashSize::
	.ds	4
	.debug	G _flashSize 9 0
_qdCount::
	.ds	2
	.debug	G _qdCount 6 0
_updateAIn::
	.ds	8
	.debug	G _updateAIn 54 0
_updateAOut::
	.ds	2
	.debug	G _updateAOut 55 0
_adcGain::
	.ds	32
	.debug	G _adcGain 56 0
_adcOffset::
	.ds	32
	.debug	G _adcOffset 56 0
_dacGain::
	.ds	8
	.debug	G _dacGain 57 0
_dacOffset::
	.ds	8
	.debug	G _dacOffset 57 0
_ainMin::
	.ds	32
	.debug	G _ainMin 56 0
_ainMax::
	.ds	32
	.debug	G _ainMax 56 0
_aoutMin::
	.ds	8
	.debug	G _aoutMin 57 0
_aoutMax::
	.ds	8
	.debug	G _aoutMax 57 0
	.defseg	FARBSS
	.seg	FARBSS
_setValMin::
	.ds	8
	.debug	G _setValMin 57 8
_setValMax::
	.ds	8
	.debug	G _setValMax 57 8
_readValMin::
	.ds	32
	.debug	G _readValMin 56 8
_readValMax::
	.ds	32
	.debug	G _readValMax 56 8
	.bseg
_anaIn::
	.ds	32
	.debug	G _anaIn 56 0
_anaOut::
	.ds	8
	.debug	G _anaOut 57 0
_lastAnaOut::
	.ds	8
	.debug	G _lastAnaOut 57 0
_adcRaw::
	.ds	16
	.debug	G _adcRaw 58 0
_dacRaw::
	.ds	4
	.debug	G _dacRaw 59 0
_lastadcRaw::
	.ds	16
	.debug	G _lastadcRaw 58 0
_newRdg::
	.ds	8
	.debug	G _newRdg 54 0
_adcForced::
	.ds	8
	.debug	G _adcForced 54 0
_dacForced::
	.ds	2
	.debug	G _dacForced 55 0
_adcForcedVal::
	.ds	32
	.debug	G _adcForcedVal 56 0
_dacForcedVal::
	.ds	8
	.debug	G _dacForcedVal 57 0
	.seg	FARBSS
_adcRawHist::
	.ds	1600
	.debug	G _adcRawHist 60 8
	.bseg
_adcAvgData::
	.ds	96
	.debug	G _adcAvgData 62 0
_adcNoiseData::
	.ds	80
	.debug	G _adcNoiseData 64 0
	.extern	_readGain 66
	.extern	_readOffset 66
	.extern	_setGain 66
	.extern	_setOffset 66
	.extern	_readVal 66
_digitalIn::
	.ds	4
	.debug	G _digitalIn 9 0
_digitalOut::
	.ds	4
	.debug	G _digitalOut 9 0
_forcedDigInMask::
	.ds	4
	.debug	G _forcedDigInMask 9 0
_forcedDigInBits::
	.ds	4
	.debug	G _forcedDigInBits 9 0
_forcedDigOutMask::
	.ds	4
	.debug	G _forcedDigOutMask 9 0
_forcedDigOutBits::
	.ds	4
	.debug	G _forcedDigOutBits 9 0
_extraIn::
	.ds	4
	.debug	G _extraIn 9 0
_forcedExtraInMask::
	.ds	4
	.debug	G _forcedExtraInMask 9 0
_forcedExtraInBits::
	.ds	4
	.debug	G _forcedExtraInBits 9 0
	.cseg
_newDACCalib:
	pop	iy
	lcall	$$newDACCalib
_newADCCalib:
	pop	iy
	lcall	$$newADCCalib
_setStateDAC:
	pop	iy
	lcall	$$setStateDAC
	.extern	$_FileFromFD_ 67
	.extern	_KLOCK 39
	.extern	_KUNLOCK 39
	.extern	_hdwType 7
	.extern	$serialInit_ 39
	.extern	$_serial_ 70
	.extern	$_spiConfig_ 71
	.extern	$_spiRead_ 72
	.extern	$_spiWrite_ 72
	.extern	$usingAsix 39
	.extern	$socketInit_ 39
	.extern	$srfsInit_ 39
	.extern	$flashFileInit_ 39
	.extern	_NumApplAIN 7
	.extern	_ADC_Mask 9
_adcGetRaw:
	pop	iy
	lcall	$$adcGetRaw
_adcMinRaw:
	pop	iy
	lcall	$$adcMinRaw
_adcMaxRaw:
	pop	iy
	lcall	$$adcMaxRaw
_adcDefaults:
	pop	iy
	lcall	$$adcDefaults
_adcCalibPoints:
	pop	iy
	lcall	$$adcCalibPoints
_dacGetRaw:
	pop	iy
	lcall	$$dacGetRaw
_dacMinRaw:
	pop	iy
	lcall	$$dacMinRaw
_dacMaxRaw:
	pop	iy
	lcall	$$dacMaxRaw
_dacDefaults:
	pop	iy
	lcall	$$dacDefaults
_dacCalibPoints:
	pop	iy
	lcall	$$dacCalibPoints
	.bseg
_spiPort::
	.ds	2
	.debug	G _spiPort 73 0
_restoreI1CR::
	.ds	1
	.debug	G _restoreI1CR 3 0
	.cseg
_SerSetDirA:
	pop	iy
	lcall	$$SerSetDirA
_SerSetDirB:
	pop	iy
	lcall	$$SerSetDirB
_SerSetDirC:
	pop	iy
	lcall	$$SerSetDirC
_SerSetDirD:
	pop	iy
	lcall	$$SerSetDirD
	.debug	T	0900012000070003000700
	.debug	T	0900012100780022001E00
	.debug	T	070008220004000300
	.debug	T	0900012300500024000500
	.debug	T	49000324001000060001000400000003696400040002000573697A
	.debug	T	650004000400056772616E004B00060005646174610022000A
	.debug	T	00056E616D65004C000E000B726573746F726556616C00
	.debug	T	0B000225000100010007000000
	.debug	T	130002260003000100070000000A00020003000600
	.debug	T	0B000227000100010001000000
	.debug	T	0F00022800020007000700000007000200
	.debug	T	0B000229000100070007000000
	.debug	T	0B00022A0001000A0007000000
	.debug	T	0F00022B0002000700070000004E000200
	.debug	T	1300022C0003000100070000004F0002004F000400
	.debug	T	0F00022D0002002E00070000002E000200
	.debug	T	0700002E0002000300
	.debug	T	0700022F0000000900
	.debug	T	0B000230000100010009000000
	.debug	T	070002310000000100
	.debug	T	0B000232000100010006000000
	.debug	T	0F0002330002000600220000000D000000
	.debug	T	0F00023400020001005000000051000200
	.debug	T	0900013500080009000200
	.debug	T	0900013600080003000800
	.debug	T	0900013700020003000200
	.debug	T	090001380020000A000800
	.debug	T	090001390008000A000200
	.debug	T	0900013A00100007000800
	.debug	T	0900013B00040007000200
	.debug	T	0900013C0040063D000800
	.debug	T	0900013D00C80007006400
	.debug	T	0900013E0060003F000800
	.debug	T	4E00033F000C0005000100090000000473756D0007000400076F6C
	.debug	T	646573740007000600056E65787400070008000E6375724E75
	.debug	T	6D53616D706C65730007000A000E7573654E756D53616D706C
	.debug	T	657300
	.debug	T	0900014000500041000800
	.debug	T	51000341000A000500010007000000077261774D696E0007000200
	.debug	T	077261774D617800070004000C6E6F697365506572696F6400
	.debug	T	07000600097261774E6F69736500070008000C6E6F69736554
	.debug	T	696D654D5300
	.debug	T	090001420000000A000000
	.debug	T	0B000243000100440006000000
	.debug	T	070008440004004500
	.debug	T	0B01034500270013000100060000000A6F70656E436F756E740052
	.debug	T	00020008696F46756E6373005400040006696F446576005500
	.debug	T	06000B776169745175657565730006000A0006666C61677300
	.debug	T	06000C00056D6F64650009000E000A72656164436F756E7400
	.debug	T	060012000D7264496E50726F67726573730006001400077264
	.debug	T	53746174000600160006726445727200030018000D646F6E74
	.debug	T	43616C6C5265616400090019000B7772697465436F756E7400
	.debug	T	06001D000D7772496E50726F67726573730006001F00077772
	.debug	T	53746174000600210006777245727200030023000E646F6E74
	.debug	T	43616C6C5772697465000300240004656F6600030025000669
	.debug	T	7374747900030026000773686172656400
	.debug	T	17000246000400060003000000030002000300040003000600
	.debug	T	130002470003000600540000000300020003000400
	.debug	T	170002480004000600540000002E0002000600040003000600
	.debug	T	070000490002004A00
	.debug	T	E700034A001800110001000300000006696E557365000300010005
	.debug	T	706F7274005400020005734465760003000400056D6F646500
	.debug	T	0300050008666C6F7743746C000300060007636C6F73656400
	.debug	T	0300070008706B744D6F646500090008000962617564526174
	.debug	T	650003000C0008636C6B4D6F64650006000D0007636C6B4469
	.debug	T	760003000F000B7365724461746152656700030010000A7365
	.debug	T	7243746C52656700030011000B736572537461745265670003
	.debug	T	0012000A736572457874526567002E0013000A705368457874
	.debug	T	526567000300150007544154526567002E0016000A70544154
	.debug	T	736852656700
	.debug	T	0700084B0004000100
	.debug	T	0700004C0002004D00
	.debug	T	1300024D00030001004B0000002E00040007000600
	.debug	T	0700004E0002000700
	.debug	T	0700004F0002000A00
	.debug	T	EC0109500001001F00010000000A494E545F54494D45520001000D
	.debug	T	494E545F4E4F545F555345440002000A494E545F5253543130
	.debug	T	0003000A494E545F52535431380004000A494E545F52535432
	.debug	T	300005000A494E545F52535432380006000E494E545F4E4F54
	.debug	T	5F55534544320007000A494E545F52535433380008000F494E
	.debug	T	545F534C4156455F504F52540009000E494E545F4E4F545F55
	.debug	T	53454433000A000C494E545F54494D45525F41000B000C494E
	.debug	T	545F54494D45525F42000C000D494E545F53455249414C5F41
	.debug	T	000D000D494E545F53455249414C5F42000E000D494E545F53
	.debug	T	455249414C5F43000F000D494E545F53455249414C5F440010
	.debug	T	0009494E545F494E543000110009494E545F494E5431001200
	.debug	T	0E494E545F4E4F545F55534544340013000E494E545F4E4F54
	.debug	T	5F55534544350014000E494E545F4E4F545F55534544360015
	.debug	T	000E494E545F4E4F545F55534544370016000E494E545F4E4F
	.debug	T	545F55534544380017000E494E545F4E4F545F555345443900
	.debug	T	18000F494E545F4E4F545F55534544313000190011494E545F
	.debug	T	515541445F4445434F444552001A000E494E545F494E505554
	.debug	T	5F434150001B000F494E545F4E4F545F555345443131001C00
	.debug	T	0D494E545F53455249414C5F45001D000D494E545F53455249
	.debug	T	414C5F46001E0009494E545F4C41535400
	.debug	T	070000510002002700
	.debug	T	070000520002005300
	.debug	T	640003530010000800010056000000057265616400560002000677
	.debug	T	72697465005700040006636C6F73650059000600066C736565
	.debug	T	6B005B000800066673746174005D000A0006696F63746C005F
	.debug	T	000C000664657363720061000E000A67657451756575657300
	.debug	T	070000540002000100
	.debug	T	2800035500040002000100630000000A7265616451756575650063
	.debug	T	0002000B7772697465517565756500
	.debug	T	070000560002004800
	.debug	T	070000570002005800
	.debug	T	0B000258000100060054000000
	.debug	T	070000590002005A00
	.debug	T	1300025A0003000900540000000900020006000600
	.debug	T	0700005B0002005C00
	.debug	T	0F00025C00020006005400000065000200
	.debug	T	0700005D0002005E00
	.debug	T	1300025E0003000600540000000600020054000400
	.debug	T	0700005F0002006000
	.debug	T	130002600003002E00540000002E00020006000400
	.debug	T	070000610002006200
	.debug	T	0F00026200020006005400000067000200
	.debug	T	070000630002006400
	.debug	T	280003640004000100125F5F776169745F71756575655F68656164
	.debug	T	0068000000096C6973744865616400
	.debug	T	070000650002006600
	.debug	T	BB000366002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	070008670004005500
	.debug	T	2600036800040002000A6C6973745F686561640069000000056E65
	.debug	T	78740069000200057072657600
	.debug	T	070000690002006800
	.seg	CONST
@128:
	.db	"V",0
	.seg	FARCONST
@1:
	.db	"Periodic Timer",0,"Secondary WDT",0,"RST 10",0,"RST 18",0,"RST 20",0,"RST 28",0,"Syscall",0,"RST 38",0,"Slave Port",0,"Wr"
	.db	"ite Protect",0,"Timer A",0,"Timer B",0,"Serial A",0,"Serial B",0,"Serial C",0,"Serial D",0,"INT0",0,"INT1",0,"PWM",0,"Mode Vi"
	.db	"olation",0,"Quad Decoder",0,"Input capture",0,"Stack Limit",0,"Serial E",0,"Serial F",0,"adcGain",0,"adcOffset",0,"da"
	.db	"cGain",0,"dacOffset",0,"*** Excessive INT1 occurances detected ***",13,10,0,13,10,"Initialized %s hardwar"
	.db	"e",13,10,0,"spiPort: %04lX (%d)",13,10,0
	.end
