@rem ----- makeall.bat ----- 10/21/11 -----(03/09/07)-----

  @echo off

rem ===========================================================================
rem  Command Shell script to automate making all the Softools C projects in
rem  a directory tree
rem ===========================================================================
rem  Update Log (most recent first)
rem
rem
rem  2011-10-21 - Mark Davis
rem               - modified to work with broken Windows 7 handling which
rem                 considers the following to be true:
rem                    file  name.prj-save in the set (*.prj)
rem
rem  2007-03-09 - Mark Davis
rem               - original version
rem
rem ===========================================================================

  setlocal

  set sc="C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Softools WinIDE.exe"

  set cleanFlag=
  set parDir=.

  if /I "%1" gtr ""  set parDir=%1

  if /I exist makelist  for /F %%d in (makelist) do call :ProcDir %%d

  call :getDirName

  for %%f in (*.prj) do if /I "%%~xf" equ ".prj" call :MakeProj %%~nf

  exit /b




rem ===========================================================================
rem  Change to the specified directory and then recursively process all
rem  subdirectories before processing the specified directory
rem ===========================================================================
rem  call :ProcDir(childDir)

:ProcDir
  cd %1%
  call :getDirName
  if /I "%curDir%"=="%1"  goto :dirok

  echo ***** Couldn't process: "%parDir%\%1" *****
  echo.
  goto :eof

:dirok
  call makeall %parDir%\%curDir%

  cd ..
  goto :eof



rem ===========================================================================
rem  process the project file in the current directory (passed as %1)
rem ===========================================================================
rem  call :MakeProj(projFile)

:MakeProj
  if /I not exist %1.prj  goto :eof
  echo.
  @echo ==========[%parDir%]===[%1.prj]==========

  if /I "%cleanflag%" neq "clean"  goto :doMake

  if /I exist obj (
    echo cleaning *.obj
    del *.obj /s
  )
  if /I exist %1.lib  (
    echo deleting %1.lib
    del %1.lib
  )
  echo.
  goto :eof

:doMake
rem  echo making [%1.prj]
rem  %sc% -m %1.prj
  cmd /C %sc% -m %1.prj
rem  start "%1" /WAIT /B %sc% -m %1.prj
rem  start "%1" /MIN /WAIT softc.bat %1.prj
rem  start "%1" /MIN /WAIT /B softc.bat %1.prj
  if /I exist %1.err (
    more %1.err
rem    pause
    echo.
  )
  echo.
  goto :eof


rem ===========================================================================
rem  get the name of the current directory without the path portion
rem ===========================================================================
:getDirName
  set tname=%CD%
  set curDir=
:nextch
  if /I "%tname%" leq "" goto :eof
  set lastCh=%tname:~-1%
  set tname=%tname:~0,-1%
  set curDir=%lastCh%%curDir%
  if %lastCh% neq \ goto :nextch
  set curDir=%curDir:~1%
  goto :eof
