//----- LLRF2.h ----- 11/16/12 -----(09/19/11)----

//-----------------------------------------------------------------------------
//  Declarations and definitions for things in the hardware-specific platform
//  module that the application code needs to know about.
//-----------------------------------------------------------------------------
//  Update log (most recent first):
//
//
//  2012-11-16 - Mark Davis
//               - Added write_FPGA_Regs()
//
//  2012-11-15 - Mark Davis
//               - Added read_FPGA_Regs()
//
//  2011-09-19 - Mark Davis
//               - Created by extracting pieces from the LLRF2_Appl.c file.
//
//-----------------------------------------------------------------------------


#ifndef _LLRF2_H_
#define _LLRF2_H_


#include <common.h>

#include <unistd.h>
#include <sys/types.h>



int getLockDSP(ulong timeOut);
int releaseLockDSP(void);

int resetDSP(void);

int stop_DSP_FPGA(void);
int restart_DSP_FPGA(ulong waitMS);

int writeDSPRegQuick(ulong regNum, ulong value);
int writeDSPReg(ulong regNum, ulong regVal, bool showErrs);

int readDSPReg(ulong regNum, ulong *regVal);

int readPlot(ulong regNum, ulong far *rcvBuf, uint rcvCount);

int read_DSP_Regs(const RD_DSP_REG far *rdDSPregs);
int write_DSP_Regs(const WR_DSP_REG far *wrDSPregs);


int readFPGA(uint regNum);
int writeFPGA(uint regNum, uint regVal);

int read_FPGA_Regs(U16 *regVal[], uint firstReg, uint numRegs);
int write_FPGA_Regs(U16 *regVal[], uint firstReg, uint numRegs);


int updateEEPROM(uint romNum, fd_t fromfd, ulong stopAt,
                 bool showProgress, bool verify);

//--- values for romNum ---
#define  FPGA_EEPROM   0
#define  DSP_EEPROM    1



void _task dspRead(int argc, char **argv);
void _task dspWrite(int argc, char **argv);


#endif

