//----- inetd.h ----- 05/12/10 -----(03/14/06)-----

#ifndef _inetdH_
#define _inetdH_



typedef struct {
  char     *srvName;
  uint      port;
  char      protocol;
  ProcMain  procMain;   // addr of process' "main" func
  uchar     priority;   // default priority for new instances
  fd_t      devfd;      // fd for active listener (-1 if no listner)
  void     *cfgParams;  // any additional configuration params
  int       lastErr;
  ulong     lastErrTime;
} ServiceInfo;


//--- values for ServiceInfo.protocol ---
#define  ProtoUDP  1
#define  ProtoTCP  2
#define  ASYNC     3


//--- structures used for cfgParams ---
typedef struct {
  ulong  baud;
  int    mode;
} AsyncParams;


extern ServiceInfo inetdConf[];
extern const int  NumServices;



fd_t getListener(ServiceInfo *srv);


void _task inetd(int argc, char **argv);


#endif
