//----- sys/serial.h ----- 04/23/10 -----(04/26/06)-----

#ifndef _sys_serialH_
#define _sys_serialH_


#include <sys/types.h>



#define  NumSerialPorts  4    // ports A-D


typedef   struct  {
  bool      inUse;       // this entry is in use
  uchar     port;        // port # (0-3)
  void     *sDev;        // ptr to Softools device structure
  char      mode;        // transmission format
  char      flowCtl;     // method of flow control
  bool      closed;      // port has been closed
  bool      pktMode;     // port xmits in packets
  ulong     baudRate;    // for async mode
//  WaitQueue  wrBlocked;   // processes waiting to write to this port
//  WaitQueue  rdBlocked;   // processes waiting to read from this port
  //--- values used for SPI mode ---
  uchar     clkMode;       // SPI clock mode (0-3)
  int       clkDiv;        // clock divider to set bit rate
  uchar     serDataReg;    // serial Data Register
  uchar     serCtlReg;     // serial Control Register
  uchar     serStatReg;    // serial Status Register
  uchar     serExtReg;     // serial Extended Register
  const uchar *pShExtReg;  // pointer to "shadow" for serial Extended Register
  uchar     TATReg;        // Timer A Time constant register (timer divider)
  const uchar *pTATshReg;  // pointer to "shadow" for Time constant register
} SerialInfo;


extern SerialInfo  serPort[NumSerialPorts];


//--- values for SerialInfo.mode (and table of allowed modes for each port) ---
#define  SER_RS232     0x01
#define  SER_RS485     0x02
#define  SER_SPI       0x04

//--- values for SerialInfo.flowCtl ---
#define  SER_NO_FLOW   0x00
#define  SER_XON_XOFF  0x01
#define  SER_RTS_CTS   0x02



void serialInit_(void);


fd_t _serial_(uchar port, uchar rateIdx, uchar mode, uchar flowCtl);


//--- functions for the serial console ---
void initConsole(void);

void flushConsole(void);

#define  getcConsole()  ( SerialGetcA() )


#endif
