#ifndef __ZW_IDBLOCK_H
#define __ZW_IDBLOCK_H
// ZW idblock
typedef struct {
	int	tableVersion;		// version number for this table layout
	int	productID;			// Z-World part #
	int	vendorID;			// 1 = Z-World
	char	timestamp[7];		//	YY/M/D H:M:S
	long	flashID;				// Z-World part #
	int	flashType;			// Write method
	int	flashSize;			// in 1000h pages
	int	sectorSize;			// size of flash sector in bytes
	int	numSectors;			// number of sectors
	int	flashSpeed;			// in nanoseconds
	long	flash2ID;			// Z-World part #, 2nd flash
	int	flash2Type;			// Write method, 2nd flash
	int	flash2Size;			// in 1000h pages, 2nd flash
	int	sector2Size;		// size of 2nd flash's sectors in bytes
	int	num2Sectors;		// number of sectors
	int	flash2Speed;		// in nanoseconds, 2nd flash
	long	ramID;				// Z-World part #
	int	ramSize;				// in 1000h pages
	int	ramSpeed;			// in nanoseconds
	int	cpuID;				// CPU type identification
	long	crystalFreq;		// in Hertz
	char	macAddr[6];			// Media Access Control (MAC) address
	char	serialNumber[24];	// device serial number
	char	productName[30];	// null-terminated string
	char	reserved[1];		// reserved for later use -- can grow in size
	long	idBlockSize;		// size of the SysIDBlock struct
	int	userBlockSize;		// size of user block (directly below ID block)
	int	userBlockLoc;		// offset of start of user block from start of ID block
	int	idBlockCRC;			// CRC of this block (with this field set to zero)
	char	marker[6];			// should be 0x55 0xAA 0x55 0xAA 0x55 0xAA 0x55 0xAA
} ZWorldIDBlock;

#endif
