//----- strrchr.c ----- 03/01/11 -----(03/01/11)-----

//-----------------------------------------------------------------------------
//  A version of strrchr() that works (the Softools one is missing the code
//  that sets BC = -strlen(str)
//-----------------------------------------------------------------------------
//  Version log (most recent first):
//
//
//  2011-03-01 - Mark Davis
//               - First version of replacement for Softools strrchr().
//
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
//unsigned char * near strrchr (const unsigned char *__str, unsigned char __ch)

#asm
    .cseg

_strrchr::

;; Assumptions about contents of registers on entry:
;;   HL = addr of string to search
;;   char to search for is pushed on the stack before the call
;;     (putting it at (ix+6) after this func saves ix on the stack
;;     and sets ix = sp)

; stack frame offsets
.ch    equ     6     ; ch to locate

       push   ix
       ld     ix,0
       add    ix,sp

;; locate the nul char at the end of the string and set BC = -length
       xor    a
       ld     b,a
       ld     c,a
       dec    hl
@1:    dec    bc
       inc    hl
       cp    (hl)
       jr     nz,@1

;; search backwards looking for the specified char
       ld     e,(ix+.ch)
@2:    dec    hl
       inc    bc       ;; reached start of string?
       ld     a,b
       or     c
       jr     z,@3     ;; yep!

       ld     a,(hl)
       cp     e
       jr     z,@4     ;; done if we found a match
       jr     @2

@3:    ld     h,a
       ld     l,a

@4:    pop    ix
       ret

#endasm

//-----------------------------------------------------------------------------

