	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\daemons\configd.c' 11 12 9 23 3 32
;1 //----- configd.c ----- 03/23/12 -----(08/24/06)-----
;2 
;3 /*-------------------------------------------------------------------------
;4   Copyright (c) 2004-2010, NSCL and Mark Davis.  All rights reserved.
;5  --------------------------------------------------------------------------
;6   Process to manage the auto configuration process.
;7 
;8   The basic operation of this process is as follows:
;9 
;10   - Periodically send broadcast packets to announce the presence and the
;11     configuration of the controller
;12 
;13   - Listen for and process Announcement packets sent by other controllers
;14     looking for conflicts
;15 
;16   - Listen for and process Configuration packets sent by the control system
;17     and maintenance/diagnostic applications
;18 
;19  --------------------------------------------------------------------------
;20   Version log:
;21 
;22   2012-03-23 - Mark Davis
;23                - Changed NameSize from 16 to HostNameLen.  Prior to this, t
;24                  max length hostname that could be handled was 15 character
;25                - Added MaxPktSize macro and set it to 512 (max prior to thi
;26                  was 400).
;27 
;28   2010-03-12 - Mark Davis
;29                - Now checks the state of the network interface before bothe
;30                  to try to use any socket connections.  This eliminates
;31                  pointless and frequent messages in the log.
;32 
;33   2010-03-03 - Mark Davis
;34                - Changed so UDP socket is normally set to non-blocking mode
;35                  changing it to blocking mode only when sending a packet.
;36 
;37   2010-03-02 - Mark Davis
;38                - Changes to use a single UDP broadcast socket for sending a
;39                  receiving all packets.
;40 
;41   2009-11-05 - Mark Davis
;42                - added resetAnnounceInterval()
;43                - The kernel task is now responsible for calling this functi
;44                  when the DeviceID changes (rather than this module being
;45                  responsible for detecting thd change).
;46 
;47   2009-08-13 - Mark Davis
;48                - extractParams() now returns -1 if it encounters an invalid
;49                  mode or parameter ID so the caller doesn't try to process
;50                  a corrupt or incomplete packet.
;51 
;52   2009-05-04 - Mark Davis
;53                - The announcement packet interval is now set to 500ms rathe
;54                  than 0 in response to a terminate signal.
;55 
;56   2009-04-28 - Mark Davis
;57                - The announcement packet interval is now reset when we get 
;58                  terminate signal, causing the controller to send one or
;59                  more packets as it is shutting down.
;60 
;61   2009-04-15 - Mark Davis
;62                - Added PID_UPSECS, providing the # of seconds the device ha
;63                  been running since it was last booted
;64 
;65   2009-04-14 - Mark Davis
;66                - Added PID_CMD_STR, providing ability to execute a command
;67                  via the config service
;68 
;69   2009-03-23 - Mark Davis
;70                - Changed max interval between announcement packets from 120
;71                  seconds to 60 seconds.
;72                - A message is now generated when the announcement interval
;73                  is reset to the minimum value if the appropriate "diag msg
;74                  bit is set
;75                - Added checking of announce packets for conflicts with this
;76                  controller's configuration.
;77 
;78   2009-03-11 - Mark Davis
;79                - Disabled changes made to support using different ports for
;80                  sending and receiving broadcasts when I realized that ARP
;81                  has nothing to do with this, and the change eliminated the
;82                  possibility of having controllers check for conflicts
;83                  themselves.
;84 
;85   2009-02-20 - Mark Davis
;86                - Changed to use a different port to send announce packets
;87                  so controllers don't process all the announce packets from
;88                  other controllers (an approach that caused lots of thrashi
;89                  of the small ARP tables in the controllers and generated l
;90                  of ARP traffic on the network).
;91                - Changed to NOT ask for the from addr for broadcast packets
;92                  unless diagnostic info is requested (to avoid thrashing of
;93                  the ARP table)
;94 
;95   2008-01-11 - Mark Davis
;96                - devCfg table now initialized on startup
;97 
;98   2007-10-02 - Mark Davis
;99                - increased max packet size from 128 bytes to 400 bytes
;100 
;101   2007-08-03 - Mark Davis
;102                - added PID_APPL_DTS parameter, PID_RTOS_DTS
;103 
;104   2007-02-02 - Mark Davis
;105                - added some checks for invalid values
;106 
;107   2006-09-05 - Mark Davis
;108                - adapted from earlier autoConfig.c version
;109 
;110 ---------------------------------------------------------------------------
;111 
;112 
;113 #include <common.h>
;114 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;115 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;116 #include <unistd.h>
;117 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;118 #include <sys/socket.h>
;119 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
;120 #include <fcntl.h>
;121 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;122 #include <netinet/in.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
;123 #include <arpa/inet.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\arpa\inet.h' 14 56 20 12 3 27
	.debug	I
;124 #include <errno.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I
;125 #include <stdio.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
;126 #include <services.h>
;127 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\services.h' 2 22 6 20 2 29
	.debug	I
;128 #include <string.h>
;129 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
;130 #include <time.h>
;131 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
;132 #include <tsh.h>
;133 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\tsh.h' 3 45 16 21 3 28
	.debug	I
;134 
;135 
;136 #ifdef RABBIT
;137   #include <sys/farprintf.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;138   #include <SHD_DLM.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;139   extern ulong  applVersTime, rtosVersTime, srfsIPAddr;
;140 #endif
;141 
;142 
;143 #define  ShowProcess  (DiagFlags & 0x00000001)
;144 #define  ShowPackets  (DiagFlags & 0x00000002)
;145 
;146 
;147 
;148 /*----------------- Platform-specific definitions ---------------*/
;149 
;150 #define  MaxDevices  1  /* max # devices the config service can handle */
;151 
;152 
;153 typedef  struct in_addr      INET_ADDR;
;154 typedef  struct sockaddr    *SAP;
;155 typedef  struct sockaddr_in  SAI;
;156 
;157 typedef  struct ether_addr  EtherAddr;
;158 
;159 
;160 #define  SleepSec(sec)                sleep(sec)
;161 #define  SleepMS(ms)                  sleepMS(ms)
;162 #define  Socket(domain, type, prot)   socket(domain, type, prot)
;163 //#define  Close(sock)                  close(sock)
;164 
;165 
;166 #ifdef RABBIT
;167   #define  Sethostname(nam)  SetHostName((nam), strlen(nam))
;168   #define  FAR  far
;169   #define  SIN_ADDR  sin_addr
;170 #else  //finish
;216 /*--------------------------------------------------------------*/
;217 
;218 
;219 
;220 #define  PktFmtVers     1
;221 
;222 /*--- max time between announcement packets ---*/
;223 #define  MaxInterval    60000L  /* Max age for event data (60 seconds) */
;224 #define  MinCmdInterval  5000   /* Time between cmds for non-responding ctl
;225 
;226 #define DefaultIP  0xC0A8FAFA   /* 192.168.250.250 */
;227 
;228 
;229 /*------------
;230   Each NSCL configuration packet starts with a 4 byte header that specifies
;231   the packet-format version and type of packet.  The header is followed by 
;232   series of parameterized values:
;233 
;234     pktVers:  2 bytes
;235     pktType:  2 bytes  (ANOUNCE, SET, or QUERY)
;236     ------------------
;237     paramID:  2 bytes
;238     valSize:  2 bytes
;239     value:    valSize bytes
;240     ------------------
;241     ... repeat parameterized values as needed ...
;242 
;243     A parameter with an id and length of 0 is used to end the list.
;244 
;245     For ANNOUNCE packets, all parameter values are the current values in us
;246     by the controller that sent the packet.
;247 
;248     For QUERY packets, all parameter values specify a condition.  Each
;249     controller whose values match the given ones is expected to respond wit
;250     an ANNOUNCE packet giving its current in-use values.  NOTE: In the
;251     future I may refine this to specify what values should be included in t
;252     response (probably by including parameters without values to specify
;253     which values are to be in the response packet).
;254 
;255     For SET packets, parameter values can be part of the settings or part o
;256     the conditions that specify which controllers are the target for the ne
;257     settings.  In fact, the same parameter could be included in both the
;258     settings and the conditions with different values.
;259 
;260     To control which parameter values are conditions and which are settings
;261     a special MODE parameter is provided.  A MODE parameter specifies the
;262     context of all parameters received after it (up to the next MODE parame
;263 
;264 ------------*/
;265 
;266 /*--- values for "pktType" ---*/
;267 /*--- tells client what to do for each parameter ---*/
;268 #define  PT_ANNOUNCE  1   /* simply announcing an active configuration */
;269 #define  PT_SET       2   /* apply values where relevant */
;270 #define  PT_QUERY     3   /* request annnouncement pkts from 1 or more ctlr
;271 
;272 static char *pktTypeName[3] = { "ANNOUNCE", "SET", "QUERY" };
	.dseg
_pktTypeName:
	.dw	@1
	.dw	@1+9
	.dw	@1+13
	.debug	F _pktTypeName 32 0
;273 
;274 /*--- values for "paramID" ---*/
;275 #define  PID_END_PARAMS  0  /* indicates end of params for a pkt */
;276 #define  PID_MODE        1  /* sets context for params until next PID_MODE 
;277 #define  PID_DEVTYPE     2
;278 #define  PID_DEVID       3
;279 #define  PID_MACADDR     4
;280 #define  PID_IPADDR      5
;281 #define  PID_NETMASK     6
;282 #define  PID_GATEWAY     7
;283 #define  PID_NAME        8
;284 #define  PID_TIMEZONE    9
;285 #define  PID_APPL_DTS   10  /* Application Date/Time Stamp */
;286 #define  PID_RTOS_DTS   11  /* RTOS Date/Time Stamp */
;287 #define  PID_SRFS_ADDR  12  /* IPv4 Addr of SRFS server */
;288 #define  PID_CMD_STR    13  /* cmd to execute (PT_SET packets only) */
;289 #define  PID_UPSECS     14  /* # of seconds since last hard (re)boot */
;290 /* NOTE:  paramID values must not exceed 31 !!! */
;291 
;292 /*--- indexes in to DeviceConfig.event[] ---*/
;293 #define  LAST_SEEN           0   /* time we last heard from controller */
;294 #define  CTLR_ID_CONFLICT    1   /* multiple ctlrs using same type+ID */
;295 #define  CTLR_ADDR_CONFLICT  2   /* multiple ctlrs using same IP Addr */
;296 #define  CTLR_NAME_CONFLICT  3   /* multiple ctlrs using same name */
;297 #define  CSYS_ID_CONFLICT    4   /* typ+ID conflict in ctl sys database */
;298 #define  CSYS_ADDR_CONFLICT  5   /* IP Addr conflict in ctl sys database */
;299 #define  CSYS_NAME_CONFLICT  6   /* ctlr name conflict in ctl sys database 
;300 /*-------------------------------*/
;301 #define  NumEvents           7
;302 
;303 static char *EventName[NumEvents] = {
;304   "LAST SEEN",
_EventName:
	.dw	@1+19
;305   "CTLR ID", "CTLR ADDR", "CTLR NAME",
	.dw	@1+29
	.dw	@1+37
	.dw	@1+47
;306   "CSYS ID", "CSYS ADDR", "CSYS NAME"
	.dw	@1+57
	.dw	@1+65
;307 };
	.dw	@1+75
	.debug	F _EventName 34 0
;308 
;309 
;310 /*--- values for PID_MODE parameter ---*/
;311 #define  MODE_ANNOUNCE  0
;312 #define  MODE_MATCH     1
;313 #define  MODE_SET       2
;314 
;315 
;316 #define  MaxPktSize  512   // This is on the stack so can't be much larger!
;317 
;318 //#define  NameSize  16
;319 #define  NameSize  HostNameLen
;320 
;321 typedef struct {
;322   ulong  time;           /* time packet was rcvd */
;323   ulong  sentCmdTime;    /* time cmd pkt was sent to deal with conflict */
;324   short  devType;        /* dev type from sender */
;325   ulong  devID;          /* dev id from sender */
;326   uchar  macAddr[6];     /* MAC addr of sender */
;327   ulong  ipAddr;         /* ip addr of sender */
;328   ulong  netmask;        /* netmask in use by sender */
;329   ulong  gateway;        /* gateway in use by sender */
;330   char   name[NameSize]; /* name used by sender */
;331   short  timeZone;       /* offset (in hours) from UMT time */
;332   ulong  paramMask;      /* bitmask: which params were in the pkt */
;333   ulong  applTime;       /* date/time stamp for application code */
;334   ulong  rtosTime;       /* date/time stamp for RTOS code */
;335   ulong  srfsAddr;       /* IPv4 addr of SRFS server */
;336   char  *cmdStr;         /* a string command */
;337 }  EventData;
;338 
;339 typedef struct {
;340   bool   inUse;           /* this slot is in use */
;341   char   name[NameSize];  /* name associated with target device */
;342   short  devType;         /* device type of target device */
;343   ulong  devID;           /* device ID of target device */
;344   ulong  ipAddr;          /* IP addr controller should be using */
;345   ulong  netmask;         /* netmask controller should be using */
;346   int    plcNum;          /* handle assigned by modrdrTaskCreatePLC() */
;347   ulong  timeAdded;       /* time device was added to the list */
;348   EventData  event[NumEvents];  /* timestamp/etc for various events */
;349 }  DeviceConfig;
;350 
;351 
;352 
;353 static int setAddr(int *sockfd,
;354                    ulong ipAddr, EventData FAR *event, uchar *buf, short bu
;355 
;356 static int sendQuery(DeviceConfig FAR *dc, uchar *buf, short bufSize);
;357 
;358 static bool conditionsMatch(EventData FAR *matchVals);
;359 
;360 
;361 /*-------------------------------------------------------------------------
;362  *  Global variables
;363  *-------------------------------------------------------------------------
;364 
;365 EventData  FAR pktData[3];
;366 
;367 DeviceConfig  FAR devCfg[MaxDevices];
;368 
;369 ulong  announceInterval, intervalOffset;
;370 static bool  configSent, resetInterval;
;371 
;372 
;373 
;374 /*=========================================================================
;375 /*=========== Common funcs with platform-specific implementations =========
;376 /*=========================================================================
;377 
;378 /*-------------------------------------------------------------------------
;379  *  Update the # of seconds between announcement packets
;380  *-------------------------------------------------------------------------
;381 void resetAnnounceInterval(void)
;382 {
	.defseg	FARCODE
	.seg	FARCODE
$resetAnnounceInterval::
	.debug	G $resetAnnounceInterval 35 9
	.debug	{ $resetAnnounceInterval 35 381 @4 @3
;383   _EnterCritical_();  resetInterval = true;  _ExitCritical_();
	.debug	# 383
	ipset	2
	ld	a,0x1
	ld	(_resetInterval),a
	ipres
;384 }
@3:
	.debug	} @3 384

@2	equ	0
	lret
@4	equ	0
;385 
;386 /*-------------------------------------------------------------------------
;387  *  Update the # of seconds between announcement packets
;388  *-------------------------------------------------------------------------
;389 void updateInterval(void)
;390 {
$updateInterval::
	.debug	G $updateInterval 35 9
	.debug	{ $updateInterval 35 389 @7 @6
;391 
;392 //--- reset the Interval between announce packets if flag set ---
;393   if (resetInterval)  {
	.debug	# 393
	ld	a,(_resetInterval)
	or	a,a
	jr	z,@8
;394     announceInterval = 1000 + intervalOffset;
@9:
	.debug	< @9 @10
	.debug	# 394
	ld	de,(_intervalOffset)
	ld	bc,(_intervalOffset+2)
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__ladd##
	ld	(_announceInterval),de
	ld	(_announceInterval+2),bc
;395     configSent = resetInterval = false;
	.debug	# 395
	xor	a,a
	ld	(_resetInterval),a
	ld	(_configSent),a
;396     if (ShowProcess)  printf("Reset Announcement interval\r\n");
	.debug	# 396
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@6
	ld	de,word (phys @12)
	ld	c,phys @12 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;397     return;
	.debug	# 397
;398   }
	jr	@6
@10:
	.debug	>
;399 
;400 //--- if last change to the announcement interval expired, then lengthen --
;401 //--- the interval (up to a maximum) ---
;402   if (configSent)  {
@8:
	.debug	# 402
	ld	a,(_configSent)
	or	a,a
	jr	z,@13
;403     announceInterval = announceInterval + announceInterval/2 + intervalOffs
@14:
	.debug	< @14 @15
	.debug	# 403
	ld	de,(_announceInterval)
	ld	bc,(_announceInterval+2)
	ld	a,0x1
	call	__ulshr##
	push	bc
	push	de
	ld	de,(_announceInterval)
	ld	bc,(_announceInterval+2)
	call	__ladd##
	push	bc
	push	de
	ld	de,(_intervalOffset)
	ld	bc,(_intervalOffset+2)
	call	__ladd##
	ld	(_announceInterval),de
	ld	(_announceInterval+2),bc
;404     if (announceInterval > MaxInterval)  announceInterval = MaxInterval;
	.debug	# 404
	push	bc
	push	de
	ld	de,0xea60
	ld	bc,0
	call	__lsub##
	jr	c,@16
	jr	z,@16
	ld	de,0xea60
	ld	bc,0
	ld	(_announceInterval),de
	ld	(_announceInterval+2),bc
;405     configSent = false;
@16:
	.debug	# 405
	xor	a,a
	ld	(_configSent),a
;406   }
@15:
	.debug	>
;407 
;408 }
@13:
@6:
	.debug	} @6 408

@5	equ	0
	lret
@7	equ	0
;409 
;410 
;411 /*-------------------------------------------------------------------------
;412  *  Update the status of entries in our list of devices based on the data
;413  *  from a just-received packet
;414  *-------------------------------------------------------------------------
;415 static int processAnnouncePkt(EventData FAR paramVals[3])
;416 {
$processAnnouncePkt:
	.debug	F $processAnnouncePkt 36 9
	.debug	{ $processAnnouncePkt 36 415 @19 @18
	ld	hl,-149
	call	__fent##
	.debug	A paramVals 5 37
;417   ulong  paramMask;
	.debug	L paramMask -4 9
;418   bool   gotType, gotID, gotIP, gotName;
	.debug	L gotType -5 3
	.debug	L gotID -6 3
	.debug	L gotIP -7 3
	.debug	L gotName -8 3
;419   EventData annVals;
	.debug	L annVals -92 38
;420   IFConfig  ifConfig;
	.debug	L ifConfig -117 39
;421   char  temp[32];
	.debug	L temp -149 40
;422 
;423 
;424   annVals = *paramVals;
	.debug	# 424
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,-92+@17
	add	hl,sp
	push	bc
	push	de
	ex	de,hl
	call	__farcvp##
	ld	hl,84
	call	__farcopy##
	add	sp,4
;425 
;426   paramMask = annVals.paramMask;
	.debug	# 426
	ld	hl,(ix-26)
	ex	de,hl
	ld	hl,(ix-24)
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;427 
;428   gotType = BOOL(paramMask & (1 << PID_DEVTYPE));
	.debug	# 428
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@20
	ld	a,0x1
	jr	@21
@20:
	xor	a,a
@21:
	ld	(ix-5),a
;429   gotID   = BOOL(paramMask & (1 << PID_DEVID));
	.debug	# 429
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@22
	ld	a,0x1
	jr	@23
@22:
	xor	a,a
@23:
	ld	(ix-6),a
;430 //  gotMAC  = BOOL(paramMask & (1 << PID_MACADDR));
;431   gotIP   = BOOL(paramMask & (1 << PID_IPADDR));
	.debug	# 431
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@24
	ld	a,0x1
	jr	@25
@24:
	xor	a,a
@25:
	ld	(ix-7),a
;432   gotName = BOOL(paramMask & (1 << PID_NAME));
	.debug	# 432
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x100
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@26
	ld	a,0x1
	jr	@27
@26:
	xor	a,a
@27:
	ld	(ix-8),a
;433 
;434 
;435 //--- Check to see if the configuration conflicts with ours ---
;436   if (gotIP)  {
	.debug	# 436
	ld	a,(ix-7)
	or	a,a
	jr	z,@28
;437     getIFConfig(IF_ETH0, &ifConfig);
@29:
	.debug	< @29 @30
	.debug	# 437
	ld	hl,-117+@17
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$getIFConfig
	add	sp,4
;438     if (annVals.ipAddr == ifConfig.ipAddr)
	.debug	# 438
	ld	hl,(ix-72)
	ex	de,hl
	ld	hl,(ix-70)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-117)
	ex	de,hl
	ld	hl,(ix-115)
	ld	bc,hl
	call	__lsub##
	jr	nz,@31
;439       printf("IP Address conflict from: %s\n",
;440              mactoa(temp, annVals.macAddr) );
	.debug	# 440
	ld	hl,-78+@17
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,-145+@17
	add	hl,sp
	push	hl
	lcall	$mactoa
	add	sp,6
	push	hl
	ld	de,word (phys @12+30)
	ld	c,phys @12+30 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;441   }
@31:
@30:
	.debug	>
;442 
;443   if (gotType AND gotID)  {
@28:
	.debug	# 443
	ld	a,(ix-5)
	or	a,a
	jr	z,@33
	ld	a,(ix-6)
	or	a,a
	jr	z,@33
;444     if ((annVals.devType == devType) AND (annVals.devID == deviceID))
@34:
	.debug	< @34 @35
	.debug	# 444
	ld	hl,(ix-84)
	ld	de,(_devType)
	or	a,a
	sbc	hl,de
	jr	nz,@37
	ld	hl,(ix-82)
	ex	de,hl
	ld	hl,(ix-80)
	ld	bc,hl
	push	bc
	push	de
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	call	__lsub##
	jr	nz,@37
;445       printf("Device Type + ID conflict from: %s\r\n",
;446              mactoa(temp, annVals.macAddr) );
	.debug	# 446
	ld	hl,-78+@17
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,-145+@17
	add	hl,sp
	push	hl
	lcall	$mactoa
	add	sp,6
	push	hl
	ld	de,word (phys @12+60)
	ld	c,phys @12+60 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;447   }
@37:
@35:
	.debug	>
;448 
;449   if (gotName)  if (! StriEq(annVals.name, "unknown"))  {
@33:
	.debug	# 449
	ld	a,(ix-8)
	or	a,a
	jr	z,@38
	ld	hl,@1+85
	push	hl
	ld	hl,-58+@17
	add	hl,sp
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	z,@39
;450     gethostname(temp, sizeof(temp));  temp[sizeof(temp)-1] = 0;
@40:
	.debug	< @40 @41
	.debug	# 450
	ld	l,0x20
	push	hl
	ld	hl,-147+@17
	add	hl,sp
	push	hl
	lcall	$gethostname
	add	sp,4
	xor	a,a
	ld	(ix-118),a
;451     if (strncmp(temp, annVals.name, NameSize) == 0)
	.debug	# 451
	ld	hl,0x20
	push	hl
	ld	hl,-58+@17
	add	hl,sp
	push	hl
	ld	hl,-145+@17
	add	hl,sp
	push	hl
	call	_strncmp
	add	sp,6
	bool	hl
	jr	nz,@42
;452       printf("Device Name conflict from: %s\r\n",
;453              mactoa(temp, annVals.macAddr) );
	.debug	# 453
	ld	hl,-78+@17
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,-145+@17
	add	hl,sp
	push	hl
	lcall	$mactoa
	add	sp,6
	push	hl
	ld	de,word (phys @12+97)
	ld	c,phys @12+97 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;454   }
@42:
@41:
	.debug	>
;455 
;456   return 0;
@39:
@38:
	.debug	# 456
	bool	hl
	ld	l,h
;457 }
@18:
	.debug	} @18 457

@17	equ	149
	ld	sp,ix
	pop	ix
	lret
@19	equ	151
;458 
;459 
;460 /*-------------------------------------------------------------------------
;461  *  If the conditions in the query match this controller, then respond with
;462  *  the requested values (for now it just resets the announce interval, whi
;463  *  will send a broadcast pkt with all our values)
;464  *-------------------------------------------------------------------------
;465 static int processQueryPkt(EventData FAR paramVals[3])
;466 {
$processQueryPkt:
	.debug	F $processQueryPkt 36 9
	.debug	{ $processQueryPkt 36 465 @45 @44
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A paramVals 5 37
;467   if (! conditionsMatch(paramVals + MODE_MATCH))  return 0;
	.debug	# 467
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x54
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	lcall	$conditionsMatch
	add	sp,4
	or	a,a
	jr	nz,@46
	bool	hl
	ld	l,h
	jr	@44
;468 
;469   resetAnnounceInterval();
@46:
	.debug	# 469
	lcall	$resetAnnounceInterval
;470 
;471   return 0;
	.debug	# 471
	bool	hl
	ld	l,h
;472 }
@44:
	.debug	} @44 472

@43	equ	0
	pop	ix
	lret
@45	equ	2
;473 
;474 
;475 /*-------------------------------------------------------------------------
;476  *  If the conditions for these settings match this controller, then apply
;477  *  the settings
;478  *-------------------------------------------------------------------------
;479 static int processSetPkt(EventData FAR paramVals[3])
;480 {
$processSetPkt:
	.debug	F $processSetPkt 36 9
	.debug	{ $processSetPkt 36 479 @49 @48
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-71
	.debug	A paramVals 5 37
;481   short  i, apply;
	.debug	L i -2 4
	.debug	L apply -4 4
;482   ulong  mask;
	.debug	L mask -8 9
;483   bool  settingsOK;
	.debug	L settingsOK -9 3
;484   EventData  FAR *setData;
	.debug	L setData -13 37
;485   IFConfig  ifConfig;
	.debug	L ifConfig -38 39
;486   char  hname[NameSize+1];
	.debug	L hname -71 41
;487 
;488 
;489   if (! conditionsMatch(paramVals + MODE_MATCH))  return 0;
	.debug	# 489
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x54
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	lcall	$conditionsMatch
	add	sp,4
	or	a,a
	jr	nz,@50
	bool	hl
	ld	l,h
	jp	@48
;490 
;491   resetAnnounceInterval();  // shorten time between announce pkts to minimu
@50:
	.debug	# 491
	lcall	$resetAnnounceInterval
;492 
;493   getIFConfig(IF_ETH0, &ifConfig);
	.debug	# 493
	ld	hl,-38+@47
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$getIFConfig
	add	sp,4
;494   gethostname(hname, sizeof(hname));  hname[sizeof(hname)-1] = 0;
	.debug	# 494
	ld	hl,0x21
	push	hl
	ld	hl,-69+@47
	add	hl,sp
	push	hl
	lcall	$gethostname
	add	sp,4
	xor	a,a
	ld	(ix-39),a
;495 
;496   setData = paramVals + MODE_SET;  settingsOK = true;
	.debug	# 496
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
	ld	(ix-9),0x1
;497 
;498 /*--- do 2 passes - 1st one to verify all settings are valid, 2nd to ---*/
;499 /*--- actually apply the settings ---*/
;500 
;501   for (apply=0; apply<2; ++apply)  {
@51:
	.debug	< @51 @52
	.debug	# 501
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@53:
	ld	hl,(ix-4)
	ld	de,0x8002
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@54
;502     for (mask=4,i=2; i<31; ++i,mask<<=1)  {
@56:
	.debug	< @56 @57
@58:
	.debug	< @58 @59
	.debug	# 502
	ld	de,0x4
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	inc	l
	inc	l
	ld	(ix-2),hl
@60:
	ld	hl,(ix-2)
	ld	de,0x801f
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@61
;503       if (setData->paramMask & mask)  switch (i)  {
@63:
	.debug	< @63 @64
	.debug	# 503
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x42
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jp	z,@65
	ld	hl,(ix-2)
	jp	@66
;504 
;505         case PID_IPADDR:
@68:
	.debug	< @68 @69
;506           if (setData->ipAddr != ifConfig.ipAddr)
	.debug	# 506
@70:
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-38)
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	call	__lsub##
	jr	z,@71
;507             if ( (!(paramVals[MODE_MATCH].paramMask & (1 << PID_MACADDR)))
;508                 OR FixedAddr() )  {
	.debug	# 508
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x54
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	de,0x42
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@72
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	push	bc
	push	de
	ld	de,0xffe0
	ld	bc,0
	call	__land##
	push	bc
	push	de
	ld	de,0xff20
	ld	c,d
	ld	b,d
	call	__ladd##
	jr	nz,@73
@72:
;509               settingsOK = false;  break;  }
@74:
	.debug	< @74 @75
	.debug	# 509
	jp	@327
@75:
	.debug	>
;510           if (apply)  chgIPAddr(IF_ETH0, setData->ipAddr);
@73:
@71:
	.debug	# 510
	ld	hl,(ix-4)
	bool	hl
	jr	z,@76
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	lcall	$chgIPAddr
	add	sp,6
;511           break;
@76:
	.debug	# 511
;512 
;513         case PID_NAME:
	jp	@67
;514           if (! *setData->name)  { settingsOK = false;  break; }
	.debug	# 514
@77:
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jp	z,@327
@79:
	.debug	< @79 @80
@80:
	.debug	>
;515           if (apply)  {
	.debug	# 515
	ld	hl,(ix-4)
	bool	hl
	jr	z,@81
;516             printf("Set hostname to: %.*s\r\n", NameSize, setData->name);
@82:
	.debug	< @82 @83
	.debug	# 516
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	hl,0x20
	push	hl
	ld	de,word (phys @12+129)
	ld	c,phys @12+129 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;517             strcpyfn(hname, setData->name);  Sethostname(hname);
	.debug	# 517
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	hl,-67+@47
	add	hl,sp
	push	hl
	call	_strcpyfn
	add	sp,6
	ld	hl,-71+@47
	add	hl,sp
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,-69+@47
	add	hl,sp
	push	hl
	lcall	$SetHostName
	add	sp,4
;518           }
@83:
	.debug	>
;519           break;
@81:
	.debug	# 519
;520 
;521         case PID_TIMEZONE:
	jp	@67
;522           if ((setData->timeZone < -12) OR (setData->timeZone > 12))  {
	.debug	# 522
@84:
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x40
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x7ff4
	ex	de,hl
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@327
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x40
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x800c
	ex	de,hl
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@86
	jr	nz,@327
;523             settingsOK = false;  break; }
@87:
	.debug	< @87 @88
	.debug	# 523
@88:
	.debug	>
;524           if (apply)  {
@86:
	.debug	# 524
	ld	hl,(ix-4)
	bool	hl
	jr	z,@89
;525             printf("Set timeZone to: %d\r\n", setData->timeZone);
@90:
	.debug	< @90 @91
	.debug	# 525
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x40
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	de,word (phys @12+153)
	ld	c,phys @12+153 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;526             timeZone = setData->timeZone;  //finish - safe/std method to ch
	.debug	# 526
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x40
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	(_timeZone),de
;527           }
@91:
	.debug	>
;528           break;
@89:
	.debug	# 528
;529 
;530         case PID_CMD_STR:
	jp	@67
;531           if (! *setData->cmdStr)  { settingsOK = false;  break; }
	.debug	# 531
@92:
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x52
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,(de)
	or	a,a
	jr	nz,@93
@94:
	.debug	< @94 @95
@327:
	xor	a,a
	ld	(ix-9),a
	jr	@67
@95:
	.debug	>
;532           if (apply)  {
@93:
	.debug	# 532
	ld	hl,(ix-4)
	bool	hl
	jr	z,@67
;533             printf("Execute cmd: [%.256s]\r\n", setData->cmdStr);
@97:
	.debug	< @97 @98
	.debug	# 533
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x52
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	de,word (phys @12+175)
	ld	c,phys @12+175 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;534             cmdLine(setData->cmdStr);
	.debug	# 534
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x52
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ex	de,hl
	lcall	$cmdLine
	pop	hl
;535           }
@98:
	.debug	>
;536           break;
	.debug	# 536
;537       }
	jr	@67
@69:
	.debug	>
;538     }
@66:
	ex	de,hl
	ld	hl,0xfffffffb
	add	hl,de
	bool	hl
	jp	z,@70
	ld	hl,0xfffffff8
	add	hl,de
	bool	hl
	jp	z,@77
	ld	hl,0xfffffff7
	add	hl,de
	bool	hl
	jp	z,@84
	ld	hl,0xfffffff3
	add	hl,de
	bool	hl
	jp	z,@92
@67:
@65:
@64:
	.debug	>
;539 
;540     if (! settingsOK)  break;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	jp	@60
@61:
@59:
	.debug	>
	.debug	# 540
	ld	a,(ix-9)
	or	a,a
	jr	z,@54
;541   }
@57:
	.debug	>
;542 
;543 
;544   if (ShowProcess)
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jp	@53
@54:
@52:
	.debug	>
	.debug	# 544
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@100
;545     if (settingsOK)
	.debug	# 545
	ld	a,(ix-9)
	or	a,a
	jr	z,@101
;546       printf("New settings applied\r\n");
	.debug	# 546
	ld	de,word (phys @12+199)
	ld	c,phys @12+199 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;547     else
;548       printf("Invalid settings\r\n");
	jr	@102
@101:
	.debug	# 548
	ld	de,word (phys @12+222)
	ld	c,phys @12+222 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;549 
;550   return 0;
@102:
@100:
	.debug	# 550
	bool	hl
	ld	l,h
;551 }
@48:
	.debug	} @48 551

@47	equ	71
	ld	sp,ix
	pop	ix
	lret
@49	equ	73
;552 
;553 
;554 /*-------------------------------------------------------------------------
;555  *  Send commands as needed to deal with conflicts or to configure a new
;556  *  controller
;557  *-------------------------------------------------------------------------
;558 static int sendCmdPkts(uchar *buf, short bufSize)
;559 {
$sendCmdPkts:
	.debug	F $sendCmdPkts 42 9
	.debug	{ $sendCmdPkts 42 558 @105 @104
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A buf 5 33
	.debug	A bufSize 7 4
;560   return 0;
	.debug	# 560
	bool	hl
	ld	l,h
;561 }
@104:
	.debug	} @104 561

@103	equ	0
	pop	ix
	lret
@105	equ	2
;562 
;563 
;564 
;565 
;566 /*=========================================================================
;567 /*========== functions that share identical code on all platforms =========
;568 /*=========================================================================
;569 
;570 /*-------------------------------------------------------------------------
;571  *  Compare the given parameter values to our own.  Returns a non-0 value
;572  *  if they match, 0 if they do not.
;573  *-------------------------------------------------------------------------
;574 static bool conditionsMatch(EventData FAR *matchVals)
;575 {
$conditionsMatch:
	.debug	F $conditionsMatch 43 9
	.debug	{ $conditionsMatch 43 574 @108 @107
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-64
	.debug	A matchVals 5 37
;576   short  i;
	.debug	L i -2 4
;577   ulong  mask;
	.debug	L mask -6 9
;578   IFConfig  ifConfig;
	.debug	L ifConfig -31 39
;579   char  hname[NameSize+1];
	.debug	L hname -64 41
;580 
;581 
;582   getIFConfig(IF_ETH0, &ifConfig);
	.debug	# 582
	ld	hl,-31+@106
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$getIFConfig
	add	sp,4
;583   gethostname(hname, sizeof(hname));  hname[sizeof(hname)-1] = 0;
	.debug	# 583
	ld	hl,0x21
	push	hl
	ld	hl,-62+@106
	add	hl,sp
	push	hl
	lcall	$gethostname
	add	sp,4
	xor	a,a
	ld	(ix-32),a
;584 
;585   for (mask=4,i=2; i<31; ++i,mask<<=1)  if (matchVals->paramMask & mask)
@109:
	.debug	< @109 @110
	.debug	# 585
	ld	de,0x4
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	inc	l
	inc	l
	ld	(ix-2),hl
@111:
	ld	hl,(ix-2)
	ld	de,0x801f
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@112
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x42
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jp	z,@114
;586 
;587     switch (i)  {
	.debug	# 587
	ld	hl,(ix-2)
	jp	@115
;588       case PID_DEVTYPE:
@117:
	.debug	< @117 @118
;589         if (matchVals->devType != devType)  return false;
	.debug	# 589
@119:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(_devType)
	or	a,a
	sbc	hl,de
	jp	nz,@326
;590         break;
	.debug	# 590
;591 
;592       case PID_DEVID:
	jp	@116
;593         if (matchVals->devID != deviceID)  return false;
	.debug	# 593
@121:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	call	__lsub##
	jp	nz,@326
;594         break;
	.debug	# 594
;595 
;596       case PID_MACADDR:
	jp	@116
;597         if (fmemcmp(matchVals->macAddr, ifConfig.macAddr, 6))  return false
	.debug	# 597
@123:
	ld	de,0x6
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,-11+@106
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xe
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	_fmemcmp
	add	sp,12
	bool	hl
	jp	nz,@326
;598         break;
	.debug	# 598
;599 
;600       case PID_IPADDR:
	jp	@116
;601         if (matchVals->ipAddr != ifConfig.ipAddr)  return false;
	.debug	# 601
@125:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-31)
	ex	de,hl
	ld	hl,(ix-29)
	ld	bc,hl
	call	__lsub##
	jp	nz,@326
;602         break;
	.debug	# 602
;603 
;604       case PID_NAME:
	jp	@116
;605         if (fstrcmp(matchVals->name, hname))  return false;
	.debug	# 605
@127:
	ld	hl,-64+@106
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@326
;606         break;
	.debug	# 606
;607 
;608       case PID_APPL_DTS:
	jp	@116
;609         if (matchVals->applTime != applVersTime)  return false;
	.debug	# 609
@129:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x46
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,(_applVersTime)
	ld	bc,(_applVersTime+2)
	call	__lsub##
	jr	z,@116
	jr	@326
;610         break;
	.debug	# 610
;611 
;612       case PID_RTOS_DTS:
;613         if (matchVals->rtosTime != rtosVersTime)  return false;
	.debug	# 613
@131:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4a
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,(_rtosVersTime)
	ld	bc,(_rtosVersTime+2)
	call	__lsub##
	jr	z,@116
	jr	@326
;614         break;
	.debug	# 614
;615 
;616       case PID_SRFS_ADDR:
;617         if (matchVals->srfsAddr != srfsIPAddr)  return false;
	.debug	# 617
@133:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4e
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,(_srfsIPAddr)
	ld	bc,(_srfsIPAddr+2)
	call	__lsub##
	jr	z,@116
@326:
	xor	a,a
	jr	@107
;618         break;
	.debug	# 618
;619     }
@118:
	.debug	>
;620 
;621    if (ShowProcess)  printf("Conditions match\r\n");
@115:
	dec	hl
	dec	hl
	ld	bc,hl
	ld	de,-11
	add	hl,de
	jr	c,@116
	ld	hl,@135
	add	hl,bc
	add	hl,bc
	ld	hl,(hl)
	jp	(hl)
	.seg	FARCODE
@135:
	dw	@119
	dw	@121
	dw	@123
	dw	@125
	dw	@116
	dw	@116
	dw	@127
	dw	@116
	dw	@129
	dw	@131
	dw	@133
	.seg	FARCODE
@116:
@114:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	jp	@111
@112:
@110:
	.debug	>
	.debug	# 621
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@136
	ld	de,word (phys @12+241)
	ld	c,phys @12+241 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;622 
;623    return true;
@136:
	.debug	# 623
	ld	a,0x1
;624 }
@107:
	.debug	} @107 624

@106	equ	64
	ld	sp,ix
	pop	ix
	lret
@108	equ	66
;625 
;626 /*-------------------------------------------------------------------------
;627  *  If we have not recently sent a command packet to the ctlr indicated in
;628  *  the given event, then send one now to set its IP address
;629  *-------------------------------------------------------------------------
;630 /*
;631 static int setAddr(int *sockfd, ulong ipAddr, EventData FAR *event,
;632                    uchar *buf, short bufSize)
;633 {
;634   short  count;
;635   int  stat;
;636   uchar  *ptr;
;637   IFConfig  ifConfig;
;638   char  macAddr[6];
;639 
;640 
;641   if (event->sentCmdTime)
;642     if (msSince(event->sentCmdTime) < MinCmdInterval)  return 0;
;643 
;644 
;645   fmemcpy(macAddr, event->macAddr, 6);
;646 
;647   if (ShowProcess)  {
;648     printf("set IP address for %ls  %s to %s\n",
;649            event->name, mactoa(buf, event->macAddr),
;650            inet_htop(AF_INET, &ipAddr, buf+20, bufSize-20) );
;651   }
;652 
;653   getIFConfig(IF_ETH0, &ifConfig);
;654 
;655   ptr = buf;
;656 
;657   addShort(&ptr, PktFmtVers);  addShort(&ptr, PT_SET);
;658 
;659   addShortParam(&ptr, PID_MODE,     MODE_MATCH);
;660   addStrParam(&ptr,   PID_MACADDR,  macAddr, 6);
;661   addShortParam(&ptr, PID_MODE,     MODE_SET);
;662   addLongParam(&ptr,  PID_IPADDR,   ntohl(ipAddr));
;663 
;664   addShort(&ptr, 0);  addShort(&ptr, 0);  // id,len == 0 ends the list
;665 
;666   count = ptr - buf;
;667 
;668   stat = sendBCastPkt(sockfd, CFG_CMD_PORT, ifConfig.bcAddr, buf, count);
;669 
;670   if (stat == 0)  event->sentCmdTime = GetMS();
;671 
;672   return stat;
;673 }
;674 */
;675 
;676 /*-------------------------------------------------------------------------
;677  *  Send a query to try to get a specific controller to respond
;678  *-------------------------------------------------------------------------
;679 /*
;680 static int sendQuery(int *sockfd,
;681                      DeviceConfig FAR *dc, uchar *buf, short bufSize)
;682 {
;683   short  count;
;684   int  stat;
;685   uchar  *ptr;
;686   IFConfig  ifConfig;
;687   EventData  FAR *event;
;688 
;689 
;690   event = dc->event + LAST_SEEN;
;691 
;692   if (event->sentCmdTime)
;693     if (msSince(event->sentCmdTime) < MinCmdInterval)  return 0;
;694 
;695   if (ShowProcess)
;696     printf("send query for device: %ls  %02X:%04lX\r\n",
;697            dc->name, dc->devType, dc->devID);
;698 
;699   getIFConfig(IF_ETH0, &ifConfig);
;700 
;701   ptr = buf;
;702 
;703   addShort(&ptr, PktFmtVers);  addShort(&ptr, PT_QUERY);
;704 
;705   addShortParam(&ptr, PID_MODE,     MODE_MATCH);
;706   addShortParam(&ptr, PID_DEVTYPE,  ntohs(dc->devType));
;707   addLongParam(&ptr,  PID_DEVID,    ntohl(dc->devID));
;708 
;709   addShort(&ptr, 0);  addShort(&ptr, 0);  // id,len == 0 ends the list
;710 
;711   count = ptr - buf;
;712 
;713   stat = sendBCastPkt(sockfd, CFG_CMD_PORT, ifConfig.bcAddr, buf, count);
;714 
;715   if (stat == 0)  event->sentCmdTime = GetMS();
;716 
;717   return stat;
;718 }
;719 */
;720 
;721 /*-------------------------------------------------------------------------
;722  *  Send a packet with the controller or server's configuration
;723  *-------------------------------------------------------------------------
;724 static int announceConfig(int *sockfd, uchar *buf, short bufSize)
;725 {
$announceConfig:
	.debug	F $announceConfig 44 9
	.debug	{ $announceConfig 44 724 @139 @138
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-64
	.debug	A sockfd 5 45
	.debug	A buf 7 33
	.debug	A bufSize 9 4
;726   short  count;
	.debug	L count -2 4
;727   int  stat;
	.debug	L stat -4 6
;728   uchar  *ptr;
	.debug	L ptr -6 33
;729   IFConfig  ifConfig;
	.debug	L ifConfig -31 39
;730   char  hname[NameSize+1];
	.debug	L hname -64 41
;731 
;732 
;733   gethostname(hname, sizeof(hname));  hname[sizeof(hname)-1] = 0;
	.debug	# 733
	ld	hl,0x21
	push	hl
	ld	hl,-62+@137
	add	hl,sp
	push	hl
	lcall	$gethostname
	add	sp,4
	xor	a,a
	ld	(ix-32),a
;734 
;735   getIFConfig(IF_ETH0, &ifConfig);
	.debug	# 735
	ld	hl,-31+@137
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$getIFConfig
	add	sp,4
;736 
;737   ptr = buf;
	.debug	# 737
	ld	hl,(ix+7)
	ld	(ix-6),hl
;738 
;739   addShort(&ptr, PktFmtVers);  addShort(&ptr, PT_ANNOUNCE);
	.debug	# 739
	ld	hl,0x1
	push	hl
	ld	hl,-4+@137
	add	hl,sp
	push	hl
	lcall	$addShort
	add	sp,4
	ld	hl,0x1
	push	hl
	ld	hl,-4+@137
	add	hl,sp
	push	hl
	lcall	$addShort
	add	sp,4
;740 
;741   addShortParam(&ptr, PID_DEVTYPE,   devType);
	.debug	# 741
	ld	hl,(_devType)
	push	hl
	ld	hl,0x2
	push	hl
	ld	hl,-2+@137
	add	hl,sp
	push	hl
	lcall	$addShortParam
	add	sp,6
;742   addLongParam(&ptr,  PID_DEVID,     deviceID);
	.debug	# 742
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	push	bc
	push	de
	ld	hl,0x3
	push	hl
	ld	hl,0+@137
	add	hl,sp
	push	hl
	lcall	$addLongParam
	add	sp,8
;743   addStrParam(&ptr,   PID_MACADDR,   ifConfig.macAddr, 6);
	.debug	# 743
	ld	hl,0x6
	push	hl
	ld	hl,-13+@137
	add	hl,sp
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,0+@137
	add	hl,sp
	push	hl
	lcall	$addStrParam
	add	sp,8
;744   addLongParam(&ptr,  PID_IPADDR,    ifConfig.ipAddr);
	.debug	# 744
	ld	hl,(ix-31)
	ex	de,hl
	ld	hl,(ix-29)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,0x5
	push	hl
	ld	hl,0+@137
	add	hl,sp
	push	hl
	lcall	$addLongParam
	add	sp,8
;745   addLongParam(&ptr,  PID_NETMASK,   ifConfig.netmask);
	.debug	# 745
	ld	hl,(ix-23)
	ex	de,hl
	ld	hl,(ix-21)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,0x6
	push	hl
	ld	hl,0+@137
	add	hl,sp
	push	hl
	lcall	$addLongParam
	add	sp,8
;746   addStrParam(&ptr,   PID_NAME,      hname, strlen(hname));
	.debug	# 746
	ld	hl,-64+@137
	add	hl,sp
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,-62+@137
	add	hl,sp
	push	hl
	ld	hl,0x8
	push	hl
	ld	hl,0+@137
	add	hl,sp
	push	hl
	lcall	$addStrParam
	add	sp,8
;747   addShortParam(&ptr, PID_TIMEZONE,  timeZone);
	.debug	# 747
	ld	hl,(_timeZone)
	push	hl
	ld	hl,0x9
	push	hl
	ld	hl,-2+@137
	add	hl,sp
	push	hl
	lcall	$addShortParam
	add	sp,6
;748   addLongParam(&ptr,  PID_APPL_DTS,  applVersTime);
	.debug	# 748
	ld	de,(_applVersTime)
	ld	bc,(_applVersTime+2)
	push	bc
	push	de
	ld	hl,0xa
	push	hl
	ld	hl,0+@137
	add	hl,sp
	push	hl
	lcall	$addLongParam
	add	sp,8
;749   addLongParam(&ptr,  PID_RTOS_DTS,  rtosVersTime);
	.debug	# 749
	ld	de,(_rtosVersTime)
	ld	bc,(_rtosVersTime+2)
	push	bc
	push	de
	ld	hl,0xb
	push	hl
	ld	hl,0+@137
	add	hl,sp
	push	hl
	lcall	$addLongParam
	add	sp,8
;750   addLongParam(&ptr,  PID_SRFS_ADDR, srfsIPAddr);
	.debug	# 750
	ld	de,(_srfsIPAddr)
	ld	bc,(_srfsIPAddr+2)
	push	bc
	push	de
	ld	hl,0xc
	push	hl
	ld	hl,0+@137
	add	hl,sp
	push	hl
	lcall	$addLongParam
	add	sp,8
;751   addLongParam(&ptr,  PID_UPSECS,    getSeconds());
	.debug	# 751
ipset 3
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
ipres
	push	bc
	push	de
	ld	hl,0xe
	push	hl
	ld	hl,0+@137
	add	hl,sp
	push	hl
	lcall	$addLongParam
	add	sp,8
;752 
;753   addShort(&ptr, 0);  addShort(&ptr, 0);  /* id,len == 0 ends the list */
	.debug	# 753
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-4+@137
	add	hl,sp
	push	hl
	lcall	$addShort
	add	sp,4
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-4+@137
	add	hl,sp
	push	hl
	lcall	$addShort
	add	sp,4
;754 
;755   count = ptr - buf;
	.debug	# 755
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-2),hl
;756 
;757   stat = sendBCastPkt(sockfd, CFG_CMD_PORT, ifConfig.bcAddr, buf, count);
	.debug	# 757
	push	hl
	ld	h,d
	ld	l,e
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-27)
	ex	de,hl
	ld	hl,(ix-25)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,0x7d1
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$sendBCastPkt
	add	sp,14
	ld	(ix-4),hl
;758 
;759   if (stat == 0)  configSent = true;
	.debug	# 759
	bool	hl
	jr	nz,@140
	ld	a,0x1
	ld	(_configSent),a
;760 
;761 /*--- adjust the offset used to spread out the timing of packets from ---*/
;762 /*--- different controllers ---*/
;763   intervalOffset = GetMS() & 0x000003FFl;
@140:
	.debug	# 763
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,0x3ff
	ld	bc,0
	call	__land##
	ld	(_intervalOffset),de
	ld	(_intervalOffset+2),bc
;764 
;765   return stat;
	.debug	# 765
	ld	hl,(ix-4)
;766 }
@138:
	.debug	} @138 766

@137	equ	64
	ld	sp,ix
	pop	ix
	lret
@139	equ	66
;767 
;768 
;769 /*-------------------------------------------------------------------------
;770  *  Extract parameter values from a packet, sorted by mode
;771  *
;772  *  Parameters:
;773  *    paramVals[3]: An array for storing parameter values extracted from
;774  *                  a packet.  Each of the 3 elements corresponds to 1 of
;775  *                  the 3 possible modes for parameter values:
;776  *                    MODE_ANNOUNCE, MODE_MATCH, MODE_SET
;777  *
;778  *    pkt:  a buffer containing the packet just received
;779  *
;780  *    pktSize:  The length of the packet pointed to by pkt
;781  *
;782  *
;783  *  On Return:
;784  *    If an error detected:
;785  *    - return value < 0
;786  *
;787  *    If no errors detected:
;788  *    - return value = type of packet (PT_ANNONCE, PT_SET, PT_QUERY)
;789  *
;790  *    - paramVals[3] contains any values corresponding to parameter values
;791  *      found in the packet, sorted by mode
;792  *
;793  *-------------------------------------------------------------------------
;794 static int extractParams(EventData FAR paramVals[3], char *pkt, short pktSi
;795 {
$extractParams:
	.debug	F $extractParams 46 9
	.debug	{ $extractParams 46 794 @143 @142
	ld	hl,-140
	call	__fent##
	.debug	A paramVals 5 37
	.debug	A pkt 9 33
	.debug	A pktSize 11 4
;796   ulong  curTime;
	.debug	L curTime -4 9
;797   short  i, pktVers, pktType, id, size, mode, offset;
	.debug	L i -6 4
	.debug	L pktVers -8 4
	.debug	L pktType -10 4
	.debug	L id -12 4
	.debug	L size -14 4
	.debug	L mode -16 4
	.debug	L offset -18 4
;798   uchar  *ptr, *endPkt, *valPtr;
	.debug	L ptr -20 33
	.debug	L endPkt -22 33
	.debug	L valPtr -24 33
;799   static struct tm  tms;
	.bseg
@144:
	.ds	18
	.debug	S tms @144 47
	.seg	FARCODE
;800   uchar  temp[32];
	.debug	L temp -56 40
;801   EventData  modeVals;
	.debug	L modeVals -140 38
;802 
;803 
;804   fmemset(paramVals, 0, sizeof(EventData)*3);
	.debug	# 804
	ld	de,0xfc
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;805 
;806   curTime = GetMS();
	.debug	# 806
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;807   for (i=0; i<3; ++i)  paramVals[i].time = curTime;
@145:
	.debug	< @145 @146
	.debug	# 807
	bool	hl
	ld	l,h
	ld	(ix-6),hl
@147:
	ld	hl,(ix-6)
	ld	de,0x8003
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@148
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix-6)
	push	bc
	push	de
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	de,0x54
	ld	c,d
	ld	b,d
	call	__ulmlt##
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__farst4d##
;808 
;809   ptr = pkt;  endPkt = ptr + pktSize;  mode = MODE_ANNOUNCE;
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	jr	@147
@148:
@146:
	.debug	>
	.debug	# 809
	ld	hl,(ix+9)
	ld	(ix-20),hl
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	add	hl,de
	ld	(ix-22),hl
	bool	hl
	ld	l,h
	ld	(ix-16),hl
;810 
;811   pktVers = getShort(&ptr);  pktType = getShort(&ptr);
	.debug	# 811
	ld	hl,-20+@141
	add	hl,sp
	push	hl
	lcall	$getShort
	pop	de
	ld	(ix-8),hl
	ld	hl,-20+@141
	add	hl,sp
	push	hl
	lcall	$getShort
	pop	de
	ld	(ix-10),hl
;812 
;813   if (pktVers > 1)  {
	.debug	# 813
	ld	hl,(ix-8)
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@150
	jr	z,@150
;814     printf("Unknown packet-format version: %d\r\n", pktVers);  return -1;  
@151:
	.debug	< @151 @152
	.debug	# 814
	ld	hl,(ix-8)
	push	hl
	ld	de,word (phys @12+260)
	ld	c,phys @12+260 >> 16
	jp	@325
@152:
	.debug	>
;815   if ((pktType < PT_ANNOUNCE) OR (pktType > PT_QUERY))  {
@150:
	.debug	# 815
	ld	hl,(ix-10)
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@153
	ld	hl,(ix-10)
	ld	e,0x3
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@154
	jr	z,@154
@153:
;816     printf("Unknown packet type: %d\r\n", pktType);    return -1;  }
@155:
	.debug	< @155 @156
	.debug	# 816
	ld	hl,(ix-10)
	push	hl
	ld	de,word (phys @12+296)
	ld	c,phys @12+296 >> 16
	jp	@325
@156:
	.debug	>
;817 
;818   if (ShowPackets)
@154:
	.debug	# 818
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@157
;819     printf("  pktVers: %d, pktType: %.9s\r\n", pktVers, pktTypeName[pktType
	.debug	# 819
	ld	hl,(ix-10)
	dec	hl
	add	hl,hl
	ld	de,_pktTypeName
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-8)
	push	hl
	ld	de,word (phys @12+322)
	ld	c,phys @12+322 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;820 
;821 
;822   while (ptr < endPkt)  {
@157:
@158:
	.debug	# 822
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-22)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@159
;823     if ((mode < 0) OR (mode > 2))  {
@160:
	.debug	< @160 @161
	.debug	# 823
	ld	hl,(ix-16)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@162
	ld	hl,(ix-16)
	ld	e,0x2
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@163
	jr	z,@163
@162:
;824       printf("Invalid parameter mode: %d\r\n", mode);  return -1;  }
@164:
	.debug	< @164 @165
	.debug	# 824
	ld	hl,(ix-16)
	push	hl
	ld	de,word (phys @12+353)
	ld	c,phys @12+353 >> 16
	jr	@325
@165:
	.debug	>
;825 
;826     fmemcpy(&modeVals, paramVals + mode, sizeof(EventData));
@163:
	.debug	# 826
	ld	de,0x54
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix-16)
	push	bc
	push	de
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	de,0x54
	ld	c,d
	ld	b,d
	call	__ulmlt##
	call	__ladd##
	push	bc
	push	de
	ld	hl,-132+@141
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;827 
;828     if ((id = getShort(&ptr)) == 0)  break;  /* id == 0: end of parameters 
	.debug	# 828
	ld	hl,-20+@141
	add	hl,sp
	push	hl
	lcall	$getShort
	pop	de
	ld	(ix-12),hl
	bool	hl
	jp	z,@159
;829 
;830     if ((id < 0) OR (id > 31))  {
	.debug	# 830
	ld	hl,(ix-12)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@167
	ld	hl,(ix-12)
	ld	e,0x1f
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@168
	jr	z,@168
@167:
;831       printf("Invalid parameter ID: %d\r\n", id);  return -1; }
@169:
	.debug	< @169 @170
	.debug	# 831
	ld	hl,(ix-12)
	push	hl
	ld	de,word (phys @12+382)
	ld	c,phys @12+382 >> 16
@325:
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	jr	@174
@170:
	.debug	>
;832 
;833     size = getShort(&ptr);
@168:
	.debug	# 833
	ld	hl,-20+@141
	add	hl,sp
	push	hl
	lcall	$getShort
	pop	de
	ld	(ix-14),hl
;834     if (ptr+size >= endPkt)  {
	.debug	# 834
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-22)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@171
;835       if (ShowErrors)
@172:
	.debug	< @172 @173
	.debug	# 835
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@174
;836         printf("invalid/unusable param size: ID:%d, size:%d\r\n", id, size)
	.debug	# 836
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix-12)
	push	hl
	ld	de,word (phys @12+409)
	ld	c,phys @12+409 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;837       return -1;
@174:
	.debug	# 837
	ld	hl,0xffff
	jp	@142
;838     }
@173:
	.debug	>
;839     valPtr = ptr;
@171:
	.debug	# 839
	ld	hl,(ix-20)
	ld	(ix-24),hl
;840 
;841     modeVals.paramMask |= (1 << id);  /* keep track of which params we got 
	.debug	# 841
	ld	hl,0x1
	ld	a,(ix-12)
	or	a,a
	jr	z,@175
	ld	b,a
@176:
	add	hl,hl
	djnz	@176
@175:
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix-74)
	ex	de,hl
	ld	hl,(ix-72)
	ld	bc,hl
	call	__lor##
	ld	hl,bc
	ld	(ix-72),hl
	ex	de,hl
	ld	(ix-74),hl
	ex	de,hl
;842 /*
;843     allZeroValue = false;
;844     for (i=0; i<size; ++i)  if (valPtr[i])  allZeroValue = false;
;845 */
;846     switch (id)  {
	.debug	# 846
	ld	hl,(ix-12)
	jp	@177
;847 
;848       case PID_MODE:
@179:
	.debug	< @179 @180
;849         mode =  getShort(&valPtr);
	.debug	# 849
@181:
	ld	hl,-24+@141
	add	hl,sp
	push	hl
	lcall	$getShort
	pop	de
	ld	(ix-16),hl
;850         if (ShowPackets)  printf("  mode: %d\r\n", mode);
	.debug	# 850
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@182
	ld	hl,(ix-16)
	push	hl
	ld	de,word (phys @12+455)
	ld	c,phys @12+455 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;851         break;
@182:
	.debug	# 851
;852 
;853       case PID_DEVTYPE:
	jp	@178
;854         modeVals.devType = getShort(&valPtr);
	.debug	# 854
@183:
	ld	hl,-24+@141
	add	hl,sp
	push	hl
	lcall	$getShort
	pop	de
	ex	de,hl
	ld	hl,-132+@141
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;855         if (ShowPackets)  printf("  devType: 0x%02X\r\n", modeVals.devType)
	.debug	# 855
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@184
	ld	hl,-132+@141
	add	hl,sp
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @12+468)
	ld	c,phys @12+468 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;856         break;
@184:
	.debug	# 856
;857 
;858       case PID_DEVID:
	jp	@178
;859         modeVals.devID = getLong(&valPtr);
	.debug	# 859
@185:
	ld	hl,-24+@141
	add	hl,sp
	push	hl
	lcall	$getLong
	pop	hl
	ld	hl,-130+@141
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;860         if (ShowPackets)  printf("  devID: 0x%04lX\r\n", modeVals.devID);
	.debug	# 860
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@186
	ld	hl,-130+@141
	add	hl,sp
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @12+488)
	ld	c,phys @12+488 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;861         break;
@186:
	.debug	# 861
;862 
;863       case PID_MACADDR:
	jp	@178
;864         fmemcpy(modeVals.macAddr, valPtr, 6);
	.debug	# 864
@187:
	ld	de,0x6
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-24)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,-118+@141
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;865         if (ShowPackets)
	.debug	# 865
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@188
;866           printf("  MAC Addr: %s\r\n", mactoa(temp, modeVals.macAddr));
	.debug	# 866
	ld	hl,-126+@141
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,-52+@141
	add	hl,sp
	push	hl
	lcall	$mactoa
	add	sp,6
	push	hl
	ld	de,word (phys @12+507)
	ld	c,phys @12+507 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;867         for (i=0; i<6 AND !valPtr[i]; ++i);  /* all 0 MAC value? */
@188:
@189:
	.debug	< @189 @190
	.debug	# 867
	bool	hl
	ld	l,h
	ld	(ix-6),hl
@191:
	ld	hl,(ix-6)
	ld	de,0x8006
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@193
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-24)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@193
;868         if (i == 6)  modeVals.paramMask &= ~(1 << PID_MACADDR);
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	jr	@191
@193:
@190:
	.debug	>
	.debug	# 868
	ld	hl,(ix-6)
	ld	de,0x6
	or	a,a
	sbc	hl,de
	jr	nz,@196
	ld	hl,(ix-74)
	ex	de,hl
	ld	hl,(ix-72)
	ld	bc,hl
	res	4,e
	ld	(ix-72),hl
	ex	de,hl
	ld	(ix-74),hl
	ex	de,hl
;869         break;
@196:
	.debug	# 869
;870 
;871       case PID_IPADDR:
	jp	@178
;872         modeVals.ipAddr = getLong(&valPtr);
	.debug	# 872
@197:
	ld	hl,-24+@141
	add	hl,sp
	push	hl
	lcall	$getLong
	pop	hl
	ld	hl,bc
	ld	(ix-118),hl
	ex	de,hl
	ld	(ix-120),hl
	ex	de,hl
;873         if (ShowPackets)  {
	.debug	# 873
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@198
;874           inet_htop(AF_INET, &modeVals.ipAddr, temp, sizeof(temp));
@199:
	.debug	< @199 @200
	.debug	# 874
	ld	hl,0x20
	push	hl
	ld	hl,-54+@141
	add	hl,sp
	push	hl
	ld	hl,-116+@141
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_htop
	add	sp,8
;875           printf("  IP Addr: %.20s\r\n", temp);
	.debug	# 875
	ld	hl,-56+@141
	add	hl,sp
	push	hl
	ld	de,word (phys @12+524)
	ld	c,phys @12+524 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;876         }
@200:
	.debug	>
;877         break;
@198:
	.debug	# 877
;878 
;879       case PID_NETMASK:
	jp	@178
;880         modeVals.netmask = getLong(&valPtr);
	.debug	# 880
@201:
	ld	hl,-24+@141
	add	hl,sp
	push	hl
	lcall	$getLong
	pop	hl
	ld	hl,bc
	ld	(ix-114),hl
	ex	de,hl
	ld	(ix-116),hl
	ex	de,hl
;881         if (ShowPackets)  {
	.debug	# 881
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@202
;882           inet_htop(AF_INET, &modeVals.netmask, temp, sizeof(temp));
@203:
	.debug	< @203 @204
	.debug	# 882
	ld	hl,0x20
	push	hl
	ld	hl,-54+@141
	add	hl,sp
	push	hl
	ld	hl,-112+@141
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_htop
	add	sp,8
;883           printf("  Netmask: %.20s\r\n", temp);
	.debug	# 883
	ld	hl,-56+@141
	add	hl,sp
	push	hl
	ld	de,word (phys @12+543)
	ld	c,phys @12+543 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;884         }
@204:
	.debug	>
;885         break;
@202:
	.debug	# 885
;886 
;887       case PID_GATEWAY:
	jp	@178
;888         modeVals.gateway = getLong(&valPtr);
	.debug	# 888
@205:
	ld	hl,-24+@141
	add	hl,sp
	push	hl
	lcall	$getLong
	pop	hl
	ld	hl,bc
	ld	(ix-110),hl
	ex	de,hl
	ld	(ix-112),hl
	ex	de,hl
;889         if (ShowPackets)  {
	.debug	# 889
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@206
;890           inet_htop(AF_INET, &modeVals.gateway, temp, sizeof(temp));
@207:
	.debug	< @207 @208
	.debug	# 890
	ld	hl,0x20
	push	hl
	ld	hl,-54+@141
	add	hl,sp
	push	hl
	ld	hl,-108+@141
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_htop
	add	sp,8
;891           printf("  Gateway: %.20s\r\n", temp);
	.debug	# 891
	ld	hl,-56+@141
	add	hl,sp
	push	hl
	ld	de,word (phys @12+562)
	ld	c,phys @12+562 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;892         }
@208:
	.debug	>
;893         break;
@206:
	.debug	# 893
;894 
;895       case PID_NAME:
	jp	@178
;896         if (size > NameSize-1)  size = NameSize-1;
	.debug	# 896
@209:
	ld	hl,(ix-14)
	ld	de,0x801f
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@210
	jr	z,@210
	ld	hl,0x1f
	ld	(ix-14),hl
;897         memcpy(modeVals.name, valPtr, size);  modeVals.name[size] = 0;
@210:
	.debug	# 897
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix-24)
	push	hl
	ld	hl,-104+@141
	add	hl,sp
	push	hl
	call	_memcpy
	add	sp,6
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,-108+@141
	add	hl,sp
	add	hl,de
	xor	a,a
	ld	(hl),a
;898         if (ShowPackets)  printf("  Name: %.*s\r\n", NameSize, modeVals.nam
	.debug	# 898
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@211
	ld	hl,-108+@141
	add	hl,sp
	push	hl
	ld	hl,0x20
	push	hl
	ld	de,word (phys @12+581)
	ld	c,phys @12+581 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;899         break;
@211:
	.debug	# 899
;900 
;901       case PID_TIMEZONE:
	jp	@178
;902         modeVals.timeZone = getShort(&valPtr);
	.debug	# 902
@212:
	ld	hl,-24+@141
	add	hl,sp
	push	hl
	lcall	$getShort
	pop	de
	ld	(ix-76),hl
;903         if (ShowPackets)
	.debug	# 903
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@213
;904           printf("  timeZone: %d\r\n", modeVals.timeZone);
	.debug	# 904
	ld	hl,(ix-76)
	push	hl
	ld	de,word (phys @12+596)
	ld	c,phys @12+596 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;905         break;
@213:
	.debug	# 905
;906 
;907       case PID_APPL_DTS:
	jp	@178
;908         modeVals.applTime = getLong(&valPtr);
	.debug	# 908
@214:
	ld	hl,-24+@141
	add	hl,sp
	push	hl
	lcall	$getLong
	pop	hl
	ld	hl,bc
	ld	(ix-68),hl
	ex	de,hl
	ld	(ix-70),hl
	ex	de,hl
;909         if (ShowPackets)  {
	.debug	# 909
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@215
;910           localtime_r(&modeVals.applTime, &tms);
@216:
	.debug	< @216 @217
	.debug	# 910
	ld	hl,@144
	push	hl
	ld	hl,-68+@141
	add	hl,sp
	push	hl
	lcall	$localtime_r
	add	sp,4
;911           printf("  applTime: %04d-%02d-%02d %02d:%02d:%02d (%lu)\r\n",
;912                 tms.tm_year+1900, tms.tm_mon+1, tms.tm_mday,
;913                 tms.tm_hour, tms.tm_min, tms.tm_sec, modeVals.applTime);
	.debug	# 913
	ld	hl,(ix-70)
	ex	de,hl
	ld	hl,(ix-68)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(@144)
	push	hl
	ld	hl,(@144+2)
	push	hl
	ld	hl,(@144+4)
	push	hl
	ld	hl,(@144+6)
	push	hl
	ld	hl,(@144+8)
	inc	hl
	push	hl
	ld	hl,(@144+10)
	ld	de,0x76c
	add	hl,de
	push	hl
	ld	de,word (phys @12+613)
	ld	c,phys @12+613 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,20
;914         }
@217:
	.debug	>
;915         break;
@215:
	.debug	# 915
;916 
;917       case PID_RTOS_DTS:
	jp	@178
;918         modeVals.rtosTime = getLong(&valPtr);
	.debug	# 918
@218:
	ld	hl,-24+@141
	add	hl,sp
	push	hl
	lcall	$getLong
	pop	hl
	ld	hl,bc
	ld	(ix-64),hl
	ex	de,hl
	ld	(ix-66),hl
	ex	de,hl
;919         if (ShowPackets)  {
	.debug	# 919
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@219
;920           localtime_r(&modeVals.rtosTime, &tms);
@220:
	.debug	< @220 @221
	.debug	# 920
	ld	hl,@144
	push	hl
	ld	hl,-64+@141
	add	hl,sp
	push	hl
	lcall	$localtime_r
	add	sp,4
;921           printf("  rtosTime: %04d-%02d-%02d %02d:%02d:%02d (%lu)\r\n",
;922                 tms.tm_year+1900, tms.tm_mon+1, tms.tm_mday,
;923                 tms.tm_hour, tms.tm_min, tms.tm_sec, modeVals.rtosTime);
	.debug	# 923
	ld	hl,(ix-66)
	ex	de,hl
	ld	hl,(ix-64)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(@144)
	push	hl
	ld	hl,(@144+2)
	push	hl
	ld	hl,(@144+4)
	push	hl
	ld	hl,(@144+6)
	push	hl
	ld	hl,(@144+8)
	inc	hl
	push	hl
	ld	hl,(@144+10)
	ld	de,0x76c
	add	hl,de
	push	hl
	ld	de,word (phys @12+663)
	ld	c,phys @12+663 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,20
;924         }
@221:
	.debug	>
;925         break;
@219:
	.debug	# 925
;926 
;927       case PID_SRFS_ADDR:
	jp	@178
;928         modeVals.srfsAddr = getLong(&valPtr);
	.debug	# 928
@222:
	ld	hl,-24+@141
	add	hl,sp
	push	hl
	lcall	$getLong
	pop	hl
	ld	hl,bc
	ld	(ix-60),hl
	ex	de,hl
	ld	(ix-62),hl
	ex	de,hl
;929         if (ShowPackets)  {
	.debug	# 929
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@223
;930           inet_htop(AF_INET, &modeVals.srfsAddr, temp, sizeof(temp));
@224:
	.debug	< @224 @225
	.debug	# 930
	ld	hl,0x20
	push	hl
	ld	hl,-54+@141
	add	hl,sp
	push	hl
	ld	hl,-58+@141
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_htop
	add	sp,8
;931           printf("  SRFS Addr: %.20s\r\n", temp);
	.debug	# 931
	ld	hl,-56+@141
	add	hl,sp
	push	hl
	ld	de,word (phys @12+713)
	ld	c,phys @12+713 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;932         }
@225:
	.debug	>
;933         break;
@223:
	.debug	# 933
;934 
;935       case PID_CMD_STR:  /* must be a 0-terminated string */
	jp	@178
;936         offset = valPtr - pkt;
	.debug	# 936
@226:
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-18),hl
;937         if (offset + size > pktSize)  size = pktSize - offset;
	.debug	# 937
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	call	__icmp##
	jr	c,@227
	jr	z,@227
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix-18)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-14),hl
;938         modeVals.cmdStr = valPtr;  valPtr[size-1] = 0;
@227:
	.debug	# 938
	ld	hl,(ix-24)
	ld	(ix-58),hl
	ld	hl,(ix-14)
	dec	hl
	ex	de,hl
	ld	hl,(ix-24)
	ex	de,hl
	add	hl,de
	xor	a,a
	ld	(hl),a
;939         if (ShowPackets)
	.debug	# 939
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@178
;940           printf("  Cmd Str: [%.*s]\r\n", size, modeVals.cmdStr);
	.debug	# 940
	ld	hl,(ix-58)
	push	hl
	ld	hl,(ix-14)
	push	hl
	ld	de,word (phys @12+734)
	ld	c,phys @12+734 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;941         break;
	.debug	# 941
;942     }
	jr	@178
@180:
	.debug	>
;943 
;944     ptr += size;
@177:
	dec	hl
	ld	bc,hl
	ld	de,-13
	add	hl,de
	jr	c,@178
	ld	hl,@229
	add	hl,bc
	add	hl,bc
	ld	hl,(hl)
	jp	(hl)
	.seg	FARCODE
@229:
	dw	@181
	dw	@183
	dw	@185
	dw	@187
	dw	@197
	dw	@201
	dw	@205
	dw	@209
	dw	@212
	dw	@214
	dw	@218
	dw	@222
	dw	@226
	.seg	FARCODE
@178:
	.debug	# 944
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	add	hl,de
	ld	(ix-20),hl
;945     fmemcpy(paramVals+mode, &modeVals, sizeof(EventData));
	.debug	# 945
	ld	de,0x54
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,-136+@141
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ld	hl,(ix-16)
	push	bc
	push	de
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	de,0x54
	ld	c,d
	ld	b,d
	call	__ulmlt##
	call	__ladd##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;946   }
@161:
	.debug	>
;947 
;948 
;949   return pktType;
	jp	@158
@159:
	.debug	# 949
	ld	hl,(ix-10)
;950 }
@142:
	.debug	} @142 950

@141	equ	140
	ld	sp,ix
	pop	ix
	lret
@143	equ	142
;951 
;952 /*-------------------------------------------------------------------------
;953 /*  check for and process any packets received on the specified socket     
;954 /*-------------------------------------------------------------------------
;955 void checkForPacket(int *sockfd, uchar *packetBuf, int bufSize)
;956 {
$checkForPacket::
	.debug	G $checkForPacket 48 9
	.debug	{ $checkForPacket 48 955 @232 @231
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-52
	.debug	A sockfd 5 45
	.debug	A packetBuf 7 33
	.debug	A bufSize 9 6
;957   int  stat, pktType;
	.debug	L stat -2 6
	.debug	L pktType -4 6
;958   struct sockaddr_in  fromAddr;
	.debug	L fromAddr -18 49
;959   socklen_t  addrLen;
	.debug	L addrLen -20 6
;960   uchar  temp[32];
	.debug	L temp -52 40
;961 
;962 
;963 /*--- check for a packet from a controller or a config server ---*/
;964   memset(packetBuf, 0, bufSize);
	.debug	# 964
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	push	hl
	call	_memset
	add	sp,6
;965 
;966   if (ShowPackets)  {
	.debug	# 966
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@233
;967     addrLen = sizeof(fromAddr);
@234:
	.debug	< @234 @235
	.debug	# 967
	ld	hl,0xe
	ld	(ix-20),hl
;968     stat = recvfrom(*sockfd, (void *)packetBuf, bufSize, 0,
;969                       (struct sockaddr *)&fromAddr, &addrLen);
	.debug	# 969
	ld	hl,-20+@230
	add	hl,sp
	push	hl
	ld	hl,-16+@230
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$recvfrom
	add	sp,14
	ld	(ix-2),hl
;970   }
@235:
	.debug	>
;971   else  {
	jr	@236
@233:
;972     addrLen = 0;
@237:
	.debug	< @237 @238
	.debug	# 972
	bool	hl
	ld	l,h
	ld	(ix-20),hl
;973     stat = recvfrom(*sockfd, (void *)packetBuf, bufSize, 0, NULL, &addrLen)
	.debug	# 973
	ld	hl,-20+@230
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$recvfrom
	add	sp,14
	ld	(ix-2),hl
;974   }
@238:
	.debug	>
;975 
;976 
;977   if (stat == 0)  {
@236:
	.debug	# 977
	ld	hl,(ix-2)
	bool	hl
	jr	nz,@239
;978     printf("UDP config socket closed by other end\r\n");
@240:
	.debug	< @240 @241
	.debug	# 978
	ld	de,word (phys @12+754)
	ld	c,phys @12+754 >> 16
	push	bc
	push	de
	lcall	$farprintf
	jr	@324
;979     close(*sockfd);  *sockfd = -1;  return;
	.debug	# 979
;980   }
@241:
	.debug	>
;981 
;982   if (stat < 0)  {
@239:
	.debug	# 982
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@242
;983     if (errno == EAGAIN)  { SleepMS(50);  return; }
@243:
	.debug	< @243 @244
	.debug	# 983
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	nz,@245
@246:
	.debug	< @246 @247
	ld	e,0x32
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	jp	@323
@247:
	.debug	>
;984     perror("recvfrom()");  close(*sockfd);  *sockfd = -1;  return;
@245:
	.debug	# 984
	ld	de,word (phys @12+794)
	ld	c,phys @12+794 >> 16
	push	bc
	push	de
	lcall	$perror
@324:
	add	sp,4
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$close
	pop	de
	ld	hl,0xffff
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;985   }
	jp	@231
@244:
	.debug	>
;986 
;987   if (ShowPackets)
@242:
	.debug	# 987
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@248
;988     printf("got %d byte packet from: %s\r\n", stat,
;989            inet_ntop(AF_INET, &fromAddr.sin_addr, temp, sizeof(temp)) );
	.debug	# 989
	ld	hl,0x20
	push	hl
	ld	hl,-50+@230
	add	hl,sp
	push	hl
	ld	hl,-10+@230
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ntop
	add	sp,8
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @12+805)
	ld	c,phys @12+805 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;990 
;991   {  /*tdebug
;992     int  i;
;993     printf("  ");
;994     for (i=0; i<stat; ++i)  {
;995       printf("%02x ", (uchar)packetBuf[i]);
;996       if ((i & 0x000f) == 0x000f)  printf("\r\n  ");
;997     }
;998     printf("\r\n\n");
;999     */
@248:
;1000   }
@249:
	.debug	< @249 @250
@250:
	.debug	>
;1001 
;1002   if (stat < 6)  { printf("incomplete packet\r\n");  return; }
	.debug	# 1002
	ld	hl,(ix-2)
	ld	de,0x8006
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@251
@252:
	.debug	< @252 @253
	ld	de,word (phys @12+835)
	ld	c,phys @12+835 >> 16
	push	bc
	push	de
	lcall	$farprintf
@323:
	add	sp,4
	jr	@231
@253:
	.debug	>
;1003 
;1004 //--- extract values from the packet just received ---
;1005   if ((pktType = extractParams(pktData, packetBuf, stat)) < 0)  return;
@251:
	.debug	# 1005
	ld	hl,(ix-2)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	de,word (phys _pktData)
	ld	c,phys _pktData >> 16
	push	bc
	push	de
	lcall	$extractParams
	add	sp,8
	ld	(ix-4),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@231
;1006 
;1007 //--- process the data from the packet ---
;1008   switch (pktType)  {
	.debug	# 1008
	ld	hl,(ix-4)
	jr	@255
;1009     case PT_ANNOUNCE:  processAnnouncePkt(pktData);  break;
@257:
	.debug	< @257 @258
	.debug	# 1009
@259:
	ld	de,word (phys _pktData)
	ld	c,phys _pktData >> 16
	push	bc
	push	de
	lcall	$processAnnouncePkt
	jr	@322
;1010     case PT_SET:       processSetPkt(pktData);  break;
	.debug	# 1010
@260:
	ld	de,word (phys _pktData)
	ld	c,phys _pktData >> 16
	push	bc
	push	de
	lcall	$processSetPkt
	jr	@322
;1011     case PT_QUERY:     processQueryPkt(pktData);  break;
	.debug	# 1011
@261:
	ld	de,word (phys _pktData)
	ld	c,phys _pktData >> 16
	push	bc
	push	de
	lcall	$processQueryPkt
@322:
	add	sp,4
;1012   }
	jr	@256
@258:
	.debug	>
;1013 
;1014 }
@255:
	ex	de,hl
	ld	hl,0xffffffff
	add	hl,de
	bool	hl
	jr	z,@259
	ld	hl,0xfffffffe
	add	hl,de
	bool	hl
	jr	z,@260
	ld	hl,0xfffffffd
	add	hl,de
	bool	hl
	jr	z,@261
@256:
@231:
	.debug	} @231 1014

@230	equ	52
	ld	sp,ix
	pop	ix
	lret
@232	equ	54
;1015 
;1016 
;1017 /*-------------------------------------------------------------------------
;1018 /*  Task to manage discovery and config of NSCL ethernet-based devices     
;1019 /*-------------------------------------------------------------------------
;1020 #ifdef EPICS
;1023   void _task configd(int argc, char **argv)
;1024 #endif
;1025 {
	.align	4
$$configd::
	ex	(sp),iy
$configd::
	.debug	G $configd 50 9
	.debug	{ $configd 50 1023 @264 @263
	ld	hl,-587
	call	__fent##
	.debug	A argc 5 6
	.debug	A argv 7 51
;1026   int  sockfd, fflags;
	.debug	L sockfd -2 6
	.debug	L fflags -4 6
;1027   short  i, j;
	.debug	L i -6 4
	.debug	L j -8 4
;1028 //  uint  sp;
;1029   ulong  lastAnnounceTime, lastCmdTime, curTime, terminateTime;
	.debug	L lastAnnounceTime -12 9
	.debug	L lastCmdTime -16 9
	.debug	L curTime -20 9
	.debug	L terminateTime -24 9
;1030   sigset_t  sigSet;
	.debug	L sigSet -28 9
;1031   DeviceConfig  FAR *dc;
	.debug	L dc -32 52
;1032   EventData  FAR *event;
	.debug	L event -36 37
;1033   struct sockaddr_in  locAddr;
	.debug	L locAddr -50 49
;1034   IFConfig  curConfig;
	.debug	L curConfig -75 39
;1035   uchar  packetBuf[MaxPktSize];
	.debug	L packetBuf -587 54
;1036 //  uint  dummyStackUseTest = 0xDEAD;
;1037 
;1038   static int  so_broadcast = TRUE;
	.dseg
@265:
	.dw	0x1
	.debug	S so_broadcast @265 6
	.seg	FARCODE
;1039 
;1040 
;1041 /*finish - don't allow more than 1 instance to run!!!!*/
;1042 
;1043 //--- block Terminate signal so we can send a packet just before exiting --
;1044   sigSet = sigmask(SIGTERM);  sigprocmask(SIG_BLOCK, &sigSet, NULL);
	.debug	# 1044
	ld	de,0x4000
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
	push	hl
	ld	hl,-26+@262
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$sigprocmask
	add	sp,6
;1045   terminateTime = 0;
	.debug	# 1045
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
;1046 
;1047   redirectStdio();  // so printf, perror, etc don't end up in data stream
	.debug	# 1047
	lcall	$redirectStdio
;1048 
;1049   fmemset(devCfg, 0, sizeof(devCfg));
	.debug	# 1049
	ld	de,0x281
	ld	bc,0
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	de,word (phys _devCfg)
	ld	c,phys _devCfg >> 16
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;1050 
;1051   #ifndef RABBIT
;1068 
;1069   sockfd = -1;  resetInterval = false;
	.debug	# 1069
	ld	hl,0xffff
	ld	(ix-2),hl
	xor	a,a
	ld	(_resetInterval),a
;1070 
;1071   lastAnnounceTime = GetMS();  announceInterval = 1000;  configSent = false
	.debug	# 1071
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	de,0x3e8
	ld	bc,0
	ld	(_announceInterval),de
	ld	(_announceInterval+2),bc
	xor	a,a
	ld	(_configSent),a
;1072   lastCmdTime = lastAnnounceTime;
	.debug	# 1072
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
;1073 
;1074 
;1075 /*--- processing for configuration announcement packets ---*/
;1076   for (;;)  {
@266:
	.debug	< @266 @267
@268:
@270:
;1077     sleepMS(20);
@271:
	.debug	< @271 @272
	.debug	# 1077
	ld	de,0x14
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;1078 
;1079   //--- Check for pending Terminate signal.  If we get a new one, ---
;1080   //--- then reset announceInterval and wait 4 seconds before terminating -
;1081     if (sigpending(&sigSet) == 0)  if (sigismember(&sigSet, SIGTERM))  {
	.debug	# 1081
	ld	hl,-28+@262
	add	hl,sp
	push	hl
	lcall	$sigpending
	pop	de
	bool	hl
	jp	nz,@273
	ld	l,0xf
	push	hl
	ld	hl,-26+@262
	add	hl,sp
	push	hl
	lcall	$sigismember
	add	sp,4
	bool	hl
	jp	z,@274
;1082       if (! terminateTime)  terminateTime = GetMS();
@275:
	.debug	< @275 @276
	.debug	# 1082
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	or	hl,de
	jp	nz,@277
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
;1083       announceInterval = 500;
@277:
	.debug	# 1083
	ld	de,0x1f4
	ld	bc,0
	ld	(_announceInterval),de
	ld	(_announceInterval+2),bc
;1084     }
@276:
	.debug	>
;1085     if (terminateTime AND (msSince(terminateTime) > 4000))  Exit(-1);
@274:
@273:
	.debug	# 1085
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	or	hl,de
	jp	z,@279
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0xfa0
	ld	bc,0
	call	__lsub##
	jr	c,@279
	jr	z,@279
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;1086 
;1087     errno = 0;
@279:
	.debug	# 1087
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1088 
;1089     getIFConfig(IF_ETH0, &curConfig);
	.debug	# 1089
	ld	hl,-75+@262
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$getIFConfig
	add	sp,4
;1090     if (curConfig.state != IF_UP)  { sleepMS(100);  continue; }
	.debug	# 1090
	ld	a,(ix-51)
	sub	a,2
	jr	z,@280
@281:
	.debug	< @281 @282
	ld	de,0x64
	ld	c,d
	ld	b,d
	jp	@321
@282:
	.debug	>
;1091 
;1092   //--- (re)create and bind socket to specific port, using broadcast mode -
;1093     if (sockfd < 0)  {
@280:
	.debug	# 1093
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@283
;1094     //--- settings for local "addr" for socket to receive broadcasts ---
;1095       locAddr.sin_family        = AF_INET;
@284:
	.debug	< @284 @285
	.debug	# 1095
	ld	hl,0x2
	ld	(ix-50),hl
;1096       locAddr.sin_port          = htons(CFG_CMD_PORT);
	.debug	# 1096
	ld	hl,0x7d1
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-48),hl
;1097       locAddr.SIN_ADDR          = htonl(INADDR_ANY);  /*htonl(bcIPv4);*/
	.debug	# 1097
	ld	de,0
	ld	c,e
	ld	b,e
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-44),hl
	ex	de,hl
	ld	(ix-46),hl
	ex	de,hl
;1098 
;1099       if ((sockfd = Socket(AF_INET, SOCK_DGRAM, 0)) < 0)  {
	.debug	# 1099
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	ld	l,0x2
	push	hl
	lcall	$socket
	add	sp,6
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@286
;1100         perror("sockfd socket() error");  SleepMS(10000);  continue; }
@287:
	.debug	< @287 @288
	.debug	# 1100
	ld	de,word (phys @12+855)
	ld	c,phys @12+855 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	jr	@320
@288:
	.debug	>
;1101 
;1102       if ((setsockopt(sockfd, SOL_SOCKET, SO_BROADCAST,
@286:
;1103                         (char *)&so_broadcast, sizeof(so_broadcast)) ) < 0)
	.debug	# 1103
	ld	hl,0x2
	push	hl
	ld	hl,@265
	push	hl
	ld	hl,0x6
	push	hl
	ld	l,0x1
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setsockopt
	add	sp,10
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@289
;1104         perror("setsockopt()");
@290:
	.debug	< @290 @291
	.debug	# 1104
	ld	de,word (phys @12+877)
	ld	c,phys @12+877 >> 16
	jr	@319
;1105         close(sockfd);  sockfd = -1;  SleepMS(10000);  continue;
	.debug	# 1105
;1106       }
@291:
	.debug	>
;1107 
;1108       if (bind(sockfd, (SAP)&locAddr, sizeof(locAddr)) < 0)  {
@289:
	.debug	# 1108
	ld	hl,0xe
	push	hl
	ld	hl,-48+@262
	add	hl,sp
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$bind
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@292
;1109         perror("sockfd bind() error");
@293:
	.debug	< @293 @294
	.debug	# 1109
	ld	de,word (phys @12+890)
	ld	c,phys @12+890 >> 16
@319:
	push	bc
	push	de
	lcall	$perror
	add	sp,4
;1110         close(sockfd);  sockfd = -1;  SleepMS(10000);  continue;
	.debug	# 1110
	ld	hl,(ix-2)
	push	hl
	lcall	$close
	pop	de
	ld	hl,0xffff
	ld	(ix-2),hl
@320:
	ld	de,0x2710
	ld	bc,0
@321:
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;1111       }
	jp	@270
@294:
	.debug	>
;1112 
;1113     //--- make socket non-blocking ---
;1114       fflags = fcntl(sockfd, F_GETFL, 0);
@292:
	.debug	# 1114
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$fcntl
	add	sp,6
	ld	(ix-4),hl
;1115       fcntl(sockfd, F_SETFL, fflags | O_NONBLOCK);
	.debug	# 1115
	set	5,l
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$fcntl
	add	sp,6
;1116 
;1117       printf("Created listener on UDP port %d\r\n", CFG_CMD_PORT);
	.debug	# 1117
	ld	hl,0x7d1
	push	hl
	ld	de,word (phys @12+910)
	ld	c,phys @12+910 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1118     }
@285:
	.debug	>
;1119 
;1120   /*--- announce our own configuration on occasion ---*/
;1121     updateInterval();
@283:
	.debug	# 1121
	lcall	$updateInterval
;1122     if (msSince(lastAnnounceTime)  > announceInterval)  {
	.debug	# 1122
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,(_announceInterval)
	ld	bc,(_announceInterval+2)
	call	__lsub##
	jp	c,@295
	jp	z,@295
;1123       announceConfig(&sockfd, packetBuf, sizeof(packetBuf));
@296:
	.debug	< @296 @297
	.debug	# 1123
	ld	hl,0x200
	push	hl
	ld	hl,-585+@262
	add	hl,sp
	push	hl
	ld	hl,2+@262
	add	hl,sp
	push	hl
	lcall	$announceConfig
	add	sp,6
;1124       lastAnnounceTime = GetMS();
	.debug	# 1124
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;1125     }
@297:
	.debug	>
;1126 
;1127   //--- periodically send cmd pkts to try to deal with conflicts ---
;1128     if (msSince(lastCmdTime) > 1000)  {
@295:
	.debug	# 1128
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__lsub##
	jp	c,@298
	jp	z,@298
;1129       sendCmdPkts(packetBuf, sizeof(packetBuf));  lastCmdTime = GetMS(); }
@299:
	.debug	< @299 @300
	.debug	# 1129
	ld	hl,0x200
	push	hl
	ld	hl,-585+@262
	add	hl,sp
	push	hl
	lcall	$sendCmdPkts
	add	sp,4
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@300:
	.debug	>
;1130 
;1131   //--- check the age of the event data for each device in the list ---
;1132     curTime = GetMS();
@298:
	.debug	# 1132
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
;1133     for (i=0; i<MaxDevices; ++i)  {
@301:
	.debug	< @301 @302
	.debug	# 1133
	bool	hl
	ld	l,h
	ld	(ix-6),hl
@303:
	ld	hl,(ix-6)
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@304
;1134       dc = devCfg + i;  if (! dc->inUse)  continue;
@306:
	.debug	< @306 @307
	.debug	# 1134
	ld	hl,(ix-6)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	de,0x281
	ld	bc,0
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _devCfg)
	ld	c,phys _devCfg >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-30),hl
	ex	de,hl
	ld	(ix-32),hl
	ex	de,hl
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jp	z,@305
;1135       for (j=0; j<NumEvents; ++j)  {
@309:
	.debug	< @309 @310
	.debug	# 1135
	bool	hl
	ld	l,h
	ld	(ix-8),hl
@311:
	ld	hl,(ix-8)
	ld	de,0x8007
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@312
;1136         event = dc->event + j;  if (! event->time)  continue;
@314:
	.debug	< @314 @315
	.debug	# 1136
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x35
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-8)
	push	bc
	push	de
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	de,0x54
	ld	c,d
	ld	b,d
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-34),hl
	ex	de,hl
	ld	(ix-36),hl
	ex	de,hl
	call	__farld4##
	ld	hl,bc
	or	hl,de
	jr	z,@313
;1137         if (msInterval(event->time, curTime) <= MaxInterval*2)  continue;
	.debug	# 1137
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	call	__lsubr##
	push	bc
	push	de
	ld	de,0xd4c0
	ld	bc,0x1
	call	__lsub##
	jr	z,@313
	jr	c,@313
;1138         fmemset(event, 0, sizeof(EventData));
	.debug	# 1138
	ld	de,0x54
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;1139       }
@315:
	.debug	>
;1140     }
@313:
	ld	hl,(ix-8)
	inc	hl
	ld	(ix-8),hl
	jp	@311
@312:
@310:
	.debug	>
@307:
	.debug	>
;1141 
;1142 
;1143   /*--- check for cmds/queries ---*/
;1144     checkForPacket(&sockfd, packetBuf, sizeof(packetBuf));
@305:
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	jp	@303
@304:
@302:
	.debug	>
	.debug	# 1144
	ld	hl,0x200
	push	hl
	ld	hl,-585+@262
	add	hl,sp
	push	hl
	ld	hl,2+@262
	add	hl,sp
	push	hl
	lcall	$checkForPacket
	add	sp,6
;1145 
;1146   //tdebug
;1147 /*
;1148     {
;1149       sp = _asm( [_HL], "ld hl,0", "add hl, sp", _HL );
;1150       printf("---%04X\r\n", sp);
;1151       computeMemCRCs(false, true);
;1152       sp = _asm( [_HL], "ld hl,0", "add hl, sp", _HL );
;1153       printf("   %04X\r\n", sp);
;1154     }
;1155 */
;1156   }
@272:
	.debug	>
;1157 
;1158 
;1159   #ifdef EPICS
;1162 }
	jp	@268
@267:
	.debug	>
@263:
	.debug	} @263 1162

@262	equ	587
	ld	sp,ix
	pop	ix
	lret
@264	equ	589
;1163 
;1164 /*-------------------------------------------------------------------------
;1165 
	.extern	_memcpy 55
	.extern	_memset 57
	.extern	_stricmp 58
	.extern	_strlen 59
	.extern	_strncmp 60
	.extern	_fmemcmp 61
	.extern	$fmemcpy 62
	.extern	_fmemset 64
	.extern	_fstrcmp 65
	.extern	_strcpyfn 66
	.extern	$redirectStdio 67
	.extern	$localtime_r 68
	.extern	$addShort 70
	.extern	$getShort 71
	.extern	$getLong 72
	.extern	$addShortParam 73
	.extern	$addLongParam 74
	.extern	$addStrParam 75
	.extern	$mactoa 76
	.extern	$sendBCastPkt 77
	.extern	$inet_htop 78
	.extern	$sigismember 79
	.extern	$sigprocmask 80
	.extern	$sigpending 81
	.extern	_current 82
	.extern	$farprintf 84
	.extern	__TimerSeconds 9
	.extern	__TimerMilliSeconds 85
	.extern	$close 86
	.extern	$fcntl 87
	.extern	_deviceID 9
	.extern	_devType 7
	.extern	_timeZone 6
	.extern	$sleepMS 88
	.extern	$Exit 89
	.extern	$SetHostName 90
	.extern	$gethostname 91
	.extern	$getIFConfig 92
	.extern	$chgIPAddr 93
	.extern	$bind 94
	.extern	$recvfrom 95
	.extern	$socket 87
	.extern	$setsockopt 96
	.extern	$inet_ntop 78
	.extern	$perror 97
	.extern	$cmdLine 98
	.extern	_applVersTime 9
	.extern	_rtosVersTime 9
	.extern	_srfsIPAddr 9
	.defseg	FARBSS
	.seg	FARBSS
_pktData::
	.ds	252
	.debug	G _pktData 99 8
_devCfg::
	.ds	641
	.debug	G _devCfg 100 8
	.bseg
_announceInterval::
	.ds	4
	.debug	G _announceInterval 9 0
_intervalOffset::
	.ds	4
	.debug	G _intervalOffset 9 0
_configSent:
	.ds	1
	.debug	F _configSent 3 0
_resetInterval:
	.ds	1
	.debug	F _resetInterval 3 0
	.cseg
_configd:
	pop	iy
	lcall	$$configd
	.debug	T	0900012000060021000300
	.debug	T	070000210002000300
	.debug	T	09000122000E0021000700
	.debug	T	0B000223000100010001000000
	.debug	T	0B000224000100060025000000
	.debug	T	070008250004002600
	.debug	T	CC0003260054000F000100090000000574696D6500090004000C73
	.debug	T	656E74436D6454696D65000400080008646576547970650009
	.debug	T	000A000664657649440065000E00086D616341646472000900
	.debug	T	1400076970416464720009001800086E65746D61736B000900
	.debug	T	1C0008676174657761790028002000056E616D650004004000
	.debug	T	0974696D655A6F6E6500090042000A706172616D4D61736B00
	.debug	T	09004600096170706C54696D650009004A000972746F735469
	.debug	T	6D650009004E00097372667341646472002100520007636D64
	.debug	T	53747200
	.debug	T	5C0003270019000700010009000000076970416464720009000400
	.debug	T	076263416464720009000800086E65746D61736B0009000C00
	.debug	T	08676174657761790065001000086D61634164647200070016
	.debug	T	00046D7475000300180006737461746500
	.debug	T	0900012800200003002000
	.debug	T	0900012900210003002100
	.debug	T	0F00022A00020006002100000004000200
	.debug	T	0B00022B000100030025000000
	.debug	T	1300022C00030006002D0000002100020004000400
	.debug	T	0700002D0002000600
	.debug	T	1300022E0003000600250000002100040004000600
	.debug	T	7E00032F001200090003746D000600000007746D5F736563000600
	.debug	T	020007746D5F6D696E000600040008746D5F686F7572000600
	.debug	T	060008746D5F6D646179000600080007746D5F6D6F6E000600
	.debug	T	0A0008746D5F796561720006000C0008746D5F776461790006
	.debug	T	000E0008746D5F79646179000600100009746D5F6973647374
	.debug	T	00
	.debug	T	1300023000030001002D0000002100020006000400
	.debug	T	41000331000E00040009736F636B61646472000500000007735F74
	.debug	T	797065000500020007735F706F7274000900040005735F6970
	.debug	T	006500080009735F73706172657300
	.debug	T	0F00023200020001000600000033000200
	.debug	T	070000330002002100
	.debug	T	070008340004003500
	.debug	T	75000335008102090001000300000006696E557365002800010005
	.debug	T	6E616D65000400210008646576547970650009002300066465
	.debug	T	7649440009002700076970416464720009002B00086E65746D
	.debug	T	61736B0006002F0007706C634E756D00090031000A74696D65
	.debug	T	41646465640066003500066576656E7400
	.debug	T	0900013600000203000002
	.debug	T	130002370003003800380000003800020007000400
	.debug	T	070000380002000100
	.debug	T	130002390003003800380000000600020007000400
	.debug	T	0F00023A00020006002100000021000200
	.debug	T	0B00023B000100060021000000
	.debug	T	1300023C0003000600210000002100020007000400
	.debug	T	1300023D00030006003F0000003F00040009000800
	.debug	T	1300023E0003003F003F0000003F00040009000800
	.debug	T	0700083F0004000100
	.debug	T	130002400003003F003F0000000600040009000600
	.debug	T	0F00024100020006006700000067000400
	.debug	T	0F00024200020001002100000067000200
	.debug	T	0B000243000100060001000000
	.debug	T	0F00024400020045006800000045000200
	.debug	T	070000450002002F00
	.debug	T	0F00024600020001003300000004000200
	.debug	T	0B000247000100040033000000
	.debug	T	0B000248000100080033000000
	.debug	T	130002490003000100330000000400020004000400
	.debug	T	1300024A0003000100330000000400020008000400
	.debug	T	1700024B000400010033000000040002002100040004000600
	.debug	T	0F00024C00020021002100000067000200
	.debug	T	1B00024D00050006002D0000000600020009000400670008000600
	.debug	T	0C00
	.debug	T	1700024E000400210006000000380002002100040006000600
	.debug	T	0F00024F00020006006800000006000200
	.debug	T	130002500003000600060000006800020068000400
	.debug	T	0B000251000100060068000000
	.debug	T	070000520002005300
	.debug	T	7702035300E8002D000C7461736B5F737472756374006900000006
	.debug	T	737461636B00690002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C6872006A000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465005200150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630033001A000561726776006B001C0005617267
	.debug	T	73006C009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773006D00B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74006700D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	0F0002540002000600670000000D000000
	.debug	T	0900015500080009000200
	.debug	T	0B000256000100060006000000
	.debug	T	130002570003000600060000000600020006000400
	.debug	T	0B000258000100090009000000
	.debug	T	0B000259000100010006000000
	.debug	T	0F00025A00020006002100000006000200
	.debug	T	0F00025B00020021002100000006000200
	.debug	T	0F00025C0002000600060000006E000200
	.debug	T	0F00025D00020001000600000009000200
	.debug	T	1300025E0003000600060000006F00020006000400
	.debug	T	1F00025F0006000600060000003F00020006000600060008006F00
	.debug	T	0A002D000C00
	.debug	T	1B0002600005000600060000000600020006000400380006000600
	.debug	T	0800
	.debug	T	0B000261000100010067000000
	.debug	T	0B000262000100010021000000
	.debug	T	0900016300FC0026000300
	.debug	T	0900016400810235000100
	.debug	T	0900016500060003000600
	.debug	T	09000166004C0226000700
	.debug	T	070008670004000300
	.debug	T	070000680002000900
	.debug	T	070000690002000700
	.debug	T	0700006A0002003F00
	.debug	T	0900016B00800003008000
	.debug	T	2800036C0004000100125F5F776169745F71756575655F68656164
	.debug	T	0070000000096C6973744865616400
	.debug	T	0700006D0002003200
	.debug	T	0700006E0002002700
	.debug	T	0700006F0002003100
	.debug	T	2600037000040002000A6C6973745F686561640071000000056E65
	.debug	T	78740071000200057072657600
	.debug	T	070000710002007000
	.defseg	CONST
	.seg	CONST
@1:
	.db	"ANNOUNCE",0,"SET",0,"QUERY",0,"LAST SEEN",0,"CTLR ID",0,"CTLR ADDR",0,"CTLR NAME",0,"CSYS ID",0,"CSYS ADDR",0,"CSYS NAME",0
	.db	"unknown",0
	.defseg	FARCONST
	.seg	FARCONST
@12:
	.db	"Reset Announcement interval",13,10,0,"IP Address conflict from: %s",10,0,"Device Type + ID conflict"
	.db	" from: %s",13,10,0,"Device Name conflict from: %s",13,10,0,"Set hostname to: %.*s",13,10,0,"Set timeZone to: "
	.db	"%d",13,10,0,"Execute cmd: [%.256s]",13,10,0,"New settings applied",13,10,0,"Invalid settings",13,10,0,"Conditions mat"
	.db	"ch",13,10,0,"Unknown packet-format version: %d",13,10,0,"Unknown packet type: %d",13,10,0,"  pktVers: %d, pkt"
	.db	"Type: %.9s",13,10,0,"Invalid parameter mode: %d",13,10,0,"Invalid parameter ID: %d",13,10,0,"invalid/unusable"
	.db	" param size: ID:%d, size:%d",13,10,0,"  mode: %d",13,10,0,"  devType: 0x%02X",13,10,0,"  devID: 0x%04lX",13,10,0,"  M"
	.db	"AC Addr: %s",13,10,0,"  IP Addr: %.20s",13,10,0,"  Netmask: %.20s",13,10,0,"  Gateway: %.20s",13,10,0,"  Name: %.*s",13,10
	.db	0,"  timeZone: %d",13,10,0,"  applTime: %04d-%02d-%02d %02d:%02d:%02d (%lu)",13,10,0,"  rtosTime: %04d-"
	.db	"%02d-%02d %02d:%02d:%02d (%lu)",13,10,0,"  SRFS Addr: %.20s",13,10,0,"  Cmd Str: [%.*s]",13,10,0,"UDP config "
	.db	"socket closed by other end",13,10,0,"recvfrom()",0,"got %d byte packet from: %s",13,10,0,"incomplete pack"
	.db	"et",13,10,0,"sockfd socket() error",0,"setsockopt()",0,"sockfd bind() error",0,"Created listener on UDP p"
	.db	"ort %d",13,10,0
	.end
