	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\kernel\sched.c' 19 40 7 12 6 32
;1 //----- sched.c ----- 06/12/12 -----(02/20/07)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  DEBROS implementation of the schedule() function, called directly by a
;5 //  user task or an interrupt handler (usually for the scheduler tick) to
;6 //  initiate a task switch.
;7 //-------------------------------------------------------------------------
;8 //  Update log (most recent first)
;9 //
;10 //
;11 //  2012-06-12 - Mark Davis
;12 //               - Minor tweaks to chooseTask() to eliminate some time-cons
;13 //                 long int operations.
;14 //
;15 //  2012-06-11 - Mark Davis
;16 //               - current->lastRunning is now set at the start of schedule
;17 //                 As calling schedule() is the only way to change which ta
;18 //                 has the CPU, this is the only place it is actually neede
;19 //
;20 //  2012-06-07 - Mark Davis
;21 //               - Added taskCounts() to return max and free counts for the
;22 //                 task table.
;23 //               - added schedCalls counter
;24 //
;25 //  2011-03-29 - Mark Davis (*)
;26 //               - Fixed bug in chooseTask() that could (under the right
;27 //                 conditions) cause a suspended task to stay suspended eve
;28 //                 when it is ready to run.
;29 //
;30 //  2011-03-25 - Mark Davis
;31 //               - Added setting of myAddr in task struct to support use of
;32 //                 the VALID() and INVALID() macros
;33 //
;34 //  2011-02-21 - Mark Davis
;35 //               - Added numReadyTasks
;36 //
;37 //  2010-08-02 - Mark Davis
;38 //               - Removed disable/enable of write protection during a task
;39 //                 switch (since it is not actually needed).
;40 //
;41 //  2010-07-15 - Mark Davis
;42 //               - Changes to memory usage to allow ALL of the FARCODE and
;43 //                 FARCONST segments to be write protected as well as all o
;44 //                 the CODE segment and most of the CONST segment.
;45 //
;46 //  2010-07-08 - Mark Davis
;47 //               - The ability to use 4K resolution on the memory protectio
;48 //                 for 2 of the 64K segments is now used to protect as much
;49 //                 as possible of the FARCONST and FARCODE segments.  Prior
;50 //                 to this they were used to write protect the stacks of mo
;51 //                 of the tasks and (when possible) the CODE and CONST segm
;52 //                 But this resulted in a larger amount of memory not being
;53 //                 protected so this change was made (although I may add
;54 //                 settings in the future to allow this to be configured
;55 //                 either at compile time or run time).
;56 //
;57 //  2010-06-29 - Mark Davis
;58 //               - Add log messages for memory allocations
;59 //
;60 //  2010-06-09 - Mark Davis
;61 //               - Basic stack and memory hdw protections implemented
;62 //
;63 //  2010-06-08 - Mark Davis
;64 //               - Software check for stack pointer over/underflow is now
;65 //                 skipped if the hdw supported method is available.
;66 //
;67 //  2010-06-07 - Mark Davis (*)
;68 //               - Hdw enforced Stack Limits are now used when possible
;69 //
;70 //  2010-05-14 - Mark Davis (*)
;71 //               - timeoutTicks is no longer set to 0 when resuming a task.
;72 //                 This caused schedule_timeout() to always return 0, which
;73 //                 would cause problems (or at least wasted effort) when
;74 //                 doing a blocking call with a timeout.
;75 //
;76 //  2010-05-07 - Mark Davis (*)
;77 //               - Corrected "fix" from 2009-06-28 regarding when sleepTick
;78 //                 and timeoutTicks are set to 0.  The fix was checking the
;79 //                 the state of the task that was running rather than the
;80 //                 one it is about to run.  Prior to this fix the problems
;81 //                 stated for the 2009-06-28 fix could still happen (i.e. a
;82 //                 resumed task whose state was not already RUNNING could
;83 //                 hang.  This probably explains why the output from the
;84 //                 scope command could still hang (and possibly other probl
;85 //                 I am not aware of).
;86 //               - Changed code so DATASEG is always the same as the ROOT
;87 //                 segment (0), rather than trying to follow the STACK segm
;88 //                 This is simpler, slightly faster. and avoids any possibi
;89 //                 of there being a problem if the schedule() function is
;90 //                 interrupted at just the wrong moment.
;91 //               - The timer_interrupt() is now disabled from the time just
;92 //                 before we choose what task to run next and actually maki
;93 //                 it the current task.  This avoids the possibility of the
;94 //                 timer_interrupt() happening between when have choosen a
;95 //                 new task and when we have switch to running that task.
;96 //
;97 //  2010-03-11 - Mark Davis (*)
;98 //               - chooseTask() now checks the state of the task that was
;99 //                 preempted to see if it has been corrupted in some fashio
;100 //                 we can easily detect.
;101 //
;102 //  2010-03-09 - Mark Davis (*)
;103 //               - Tasks with a run state of STOPPED are now ignored when
;104 //                 choosing a candidate for resuming.  This eliminates
;105 //                 additional CPU cycles spent considering such tasks and t
;106 //                 possibility of log messages repeatedly complaining about
;107 //                 the corrupted state of such tasks prior to properly
;108 //                 killing them off.
;109 //
;110 //  2010-03-06 - Mark Davis (*)
;111 //               - chooseTask() now checks to see if the task it has choose
;112 //                 to resume has had the last/top 2 bytes of its stack
;113 //                 overwritten, indicating either that it overflowed while
;114 //                 running, or was corrupted by something else writing to i
;115 //                 stack.
;116 //               - chooseTask() now checks to make sure the stack pointer
;117 //                 is within the valid range of values before resuming a
;118 //                 task. The previous check only checked to see if it was
;119 //                 LESS than the top of the stack, whereas it will now
;120 //                 catch one that has wrapped around, popped everything on
;121 //                 the stack, or just plain been corrupted.
;122 //
;123 //  2010-03-02 - Mark Davis (*)
;124 //               - chooseTask() now checks for a near stack overflow before
;125 //                 resuming a task.  If a task is about to overflow its sta
;126 //                 its run state is changed to STOPPED and it is sent a
;127 //                 TERMINATE signal so the kernel will clean it up (and of
;128 //                 course it chooses a differrent task to resume).
;129 //
;130 //  2010-02-14 - Mark Davis
;131 //               - Default SchedMS value now set to 20 for BL2105 hdw
;132 //
;133 //  2009-06-28 - Mark Davis (*)
;134 //               - sleepTicks and timeoutTicks are no longer set to 0 when
;135 //                 resuming a task unless its state is RUNNABLE.  Setting t
;136 //                 to 0 for a task whose state is not already RUNNABLE (e.g
;137 //                 one that was preempted) could result in a task that gets
;138 //                 hung (in the case of timeoutTicks) or one that wakes up
;139 //                 too early (in the case of sleepTicks).
;140 //
;141 //  2009-06-08 - Mark Davis
;142 //               - Added SchedMS so the scheduler tick interval could be
;143 //                 changed as needed for the hardware or the application
;144 //
;145 //  2007-06-17 - Mark Davis
;146 //               - began migration from simple periodic polling loops for
;147 //                 blocking to Linux-style wait queues (to reduce wasted CP
;148 //                 cycles, decrease average latency, improve response times
;149 //
;150 //  2007-02-20 - Mark Davis
;151 //               - work started on Linux-style method for managing task
;152 //                 switches.  Done to eliminate need for Softools' TurboTas
;153 //                 kernel and allow stacks to be located anywere in memory.
;154 //                 Based on "Simple Task Switcher" code from SH Design's.
;155 //
;156 //-------------------------------------------------------------------------
;157 
;158 
;159 #include <common.h>
;160 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;161 #include <unistd.h>
;162 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;163 #include <linux/sched.h>
;164 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
;165 #include <linux/wait.h>
;166 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
;167 #include <string.h>
;168 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
;169 #include <rabbit.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\rabbit.h' 24 40 11 19 5 30
	.debug	I
;170 #include <dcdefs.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
;171 #include <limits.h>
;172 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
;173 #include <sys/farprintf.h>
;174 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;175 
;176 char _disabled = 0;  // a non-0 value disables the scheduler
	.dseg
__disabled::
	.db	0
	.debug	G __disabled 3 0
;177 char _pending = 0;   // a non-0 value indicates schedule() needs to be call
__pending::
	.db	0
	.debug	G __pending 3 0
;178                      // as soon as the scheduler is re-enabled
;179 
;180 uint  schedCalls;    // # of calls to schedule() since last zeroed
;181 uint  taskSwitches;  // # of task switches since last zeroed
;182 
;183 
;184 task_t tasks[NUM_TASKS];
;185 
;186 static task_t  *next;
;187 task_t  *current = tasks;
_current::
	.dw	word _tasks
	.debug	G _current 32 0
;188 PIX    userPix;
;189 
;190 task_t  *endTasks = tasks + NUM_TASKS;
_endTasks::
	.dw	word _tasks+4640
	.debug	G _endTasks 32 0
;191 task_t  *idleTask, *applTask, *kernelTask, *inetTask;
;192 
;193 ulong  newTaskDiagFlags;   // diagFlags for new tasks
;194 
;195 uint  SchedMS;  // scheduler tick interval in ms
;196 uint  numReadyTasks;  // # tasks ready to run during last call to schedule(
;197 
;198 //--- set by init_tasks() ---
;199 static uchar far  *stackPool = (uchar far *)0l;
_stackPool:
	.dw	0, 0
	.debug	F _stackPool 34 0
;200 static long  stackPoolSize = 0l;
_stackPoolSize:
	.dw	0, 0
	.debug	F _stackPoolSize 8 0
;201 
;202 bool  stacksCross64K;
;203 byte  stackSegL, stackSegH, stackPageL, stackPageH;
;204 
;205 static uint  stackSize;
;206 
;207 static ulong  wpAllStacks;
;208 
;209 //void dummy()  { getMilliSeconds(); }  // to make compiler happy....
;210 
;211 
;212 //-------------------------------------------------------------------------
;213 //  Get the max and free counts for the table of all tasks
;214 //  The *ttl is set to the max, and the free count is the return value.
;215 //-------------------------------------------------------------------------
;216 uint taskCounts(uint *ttl)
;217 {
	.defseg	FARCODE
	.seg	FARCODE
	.align	4
$$taskCounts::
	ex	(sp),iy
$taskCounts::
	.debug	G $taskCounts 35 9
	.debug	{ $taskCounts 35 216 @3 @2
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ttl 5 36
;218   uint  freeCount = 0;
	.debug	L freeCount -2 7
	.debug	# 218
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	.seg	FARCODE
;219   task_t  *task;
	.debug	L task -4 32
;220 
;221 
;222   for (task=tasks; task!=endTasks; ++task)
@4:
	.debug	< @4 @5
	.debug	# 222
	ld	hl,_tasks
	ld	(ix-4),hl
@6:
	ld	hl,(_endTasks)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@7
;223     if (!task->inUse)  ++freeCount;
	.debug	# 223
	ld	h,d
	ld	l,e
	ld	de,0xaa
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@9
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
;224 
;225   *ttl = NUM_TASKS;
@9:
	ld	hl,(ix-4)
	ld	de,0xe8
	add	hl,de
	ld	(ix-4),hl
	jr	@6
@7:
@5:
	.debug	>
	.debug	# 225
	ld	hl,0x14
	ex	de,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;226 
;227   return freeCount;
	.debug	# 227
	ld	hl,(ix-2)
;228 }
@2:
	.debug	} @2 228

@1	equ	4
	ld	sp,ix
	pop	ix
	lret
@3	equ	6
;229 
;230 
;231 //-------------------------------------------------------------------------
;232 //  Test various aspects of the state of the specified task to see if it ha
;233 //  been corrupted.
;234 //-------------------------------------------------------------------------
;235 void checkTask(task_t *task)
;236 {
$checkTask::
	.debug	G $checkTask 37 9
	.debug	{ $checkTask 37 235 @12 @11
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A task 5 32
;237   uint far *stackStart;
	.debug	L stackStart -4 38
;238 
;239 //--- Check to see if the task's stack pointer is within the valid range --
;240   if (!hdwProtection AND
;241     ((task->stack < task->stack_start + 32)
;242       OR (task->stack > task->stack_start + task->stack_size)) ) {
	.debug	# 242
	ld	a,(_hdwProtection)
	or	a,a
	jp	nz,@14
	ld	hl,(ix+5)
	ex	de,hl
	ld	h,d
	ld	l,e
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	ld	bc,de
	ld	de,0x40
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	c,@17
	ld	hl,(ix+5)
	ex	de,hl
	ld	h,d
	ld	l,e
	inc	de
	inc	de
	ld	bc,hl
	ld	hl,(ix+5)
	push	bc
	ld	bc,de
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	add	hl,hl
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	add	hl,de
	pop	de
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	c,@14
	jr	z,@14
@17:
;243     fprintf(DiagLog, "***** %.32s[%d]: STACK POINTER OUT OF RANGE!!! *****\
@18:
	.debug	< @18 @19
;244             task->argv[0], task->pid);
	.debug	# 244
	ld	hl,(ix+5)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	ld	e,0x1a
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @20)
	ld	c,phys @20 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;245     if (KeyTask(task))  postMortem("Stack ptr out of range");
	.debug	# 245
	ld	hl,(ix+5)
	ld	de,_tasks
	or	a,a
	sbc	hl,de
	ld	de,0xe8
	call	__idiv##
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nc,@21
	ld	de,word (phys @20+54)
	ld	c,phys @20+54 >> 16
	push	bc
	push	de
	lcall	$postMortem
	add	sp,4
;246     task->state = TASK_STOPPED;  task->sig_pending |= sigmask(SIGKILL);
@21:
	.debug	# 246
	ld	hl,(ix+5)
	ld	de,0x13
	add	hl,de
	ld	e,0x4
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+5)
	ld	e,0xa0
	add	hl,de
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	set	0,d
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;247     return;
	.debug	# 247
;248   }
	jp	@11
@19:
	.debug	>
;249 
;250 //--- If the task we chose to resume has had its stack corrupted or it ---
;251 //--- overflowed while running (i.e. the top 2 bytes were written over) ---
;252 //--- then log a message, kill the task, and choose another ---
;253   stackStart = (uint far *)
@14:
;254      ((ulong)task->stack_start + (((ulong)task->sseg) << 12));
	.debug	# 254
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	e,(hl)
	ld	b,d
	ld	c,d
	ld	a,0xc
	call	__lshl##
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;255   if (*stackStart != 0xffff)  {
	.debug	# 255
	call	__farld2##
	ld	hl,0xffff
	or	a,a
	sbc	hl,de
	jr	z,@22
;256     fprintf(DiagLog, "***** %.32s[%d]: STACK CORRUPTED OR OVERFLOWED!!! ***
@23:
	.debug	< @23 @24
;257             task->argv[0], task->pid);
	.debug	# 257
	ld	hl,(ix+5)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	ld	e,0x1a
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @20+77)
	ld	c,phys @20+77 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;258     if (KeyTask(task))  postMortem("Stack Corrupted or Overflowed");
	.debug	# 258
	ld	hl,(ix+5)
	ld	de,_tasks
	or	a,a
	sbc	hl,de
	ld	de,0xe8
	call	__idiv##
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nc,@25
	ld	de,word (phys @20+134)
	ld	c,phys @20+134 >> 16
	push	bc
	push	de
	lcall	$postMortem
	add	sp,4
;259     task->state = TASK_STOPPED;  task->sig_pending |= sigmask(SIGKILL);
@25:
	.debug	# 259
	ld	hl,(ix+5)
	ld	de,0x13
	add	hl,de
	ld	e,0x4
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+5)
	ld	e,0xa0
	add	hl,de
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	set	0,d
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;260     return;
	.debug	# 260
;261   }
@24:
	.debug	>
;262 
;263 }
@22:
@11:
	.debug	} @11 263

@10	equ	4
	ld	sp,ix
	pop	ix
	lret
@12	equ	6
;264 
;265 
;266 //-------------------------------------------------------------------------
;267 //  called by schedule() to decide which process to resume
;268 //-------------------------------------------------------------------------
;269 void chooseTask(void)
;270 {
$chooseTask::
	.debug	G $chooseTask 39 9
	.debug	{ $chooseTask 39 269 @28 @27
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
;271   ulong  tickTime, msTime, ticksUsed;
	.debug	L tickTime -4 9
	.debug	L msTime -8 9
	.debug	L ticksUsed -12 9
;272   uint  readyCount, msSinceNextResumed, msSinceResumed;
	.debug	L readyCount -14 7
	.debug	L msSinceNextResumed -16 7
	.debug	L msSinceResumed -18 7
;273   task_t  *task;
	.debug	L task -20 32
;274 
;275 
;276 //--- check to see if the current task has been corrupted ---
;277   checkTask(current);
	.debug	# 277
	ld	hl,(_current)
	push	hl
	lcall	$checkTask
	pop	hl
;278 
;279 
;280 //--- starting with the process following the current one, scan the ----
;281 //--- process list determining which ones can be woken up and which is the 
;282 //--- next-in-line, ready-to-run of the highest priority ---
;283 //--- (crude, but adequate for now) ---
;284 
;285   next = idleTask;  task = current;  readyCount = 0;
	.debug	# 285
	ld	hl,(_idleTask)
	ld	(_next),hl
	ld	hl,(_current)
	ld	(ix-20),hl
	bool	hl
	ld	l,h
	ld	(ix-14),hl
;286   msSinceNextResumed = msSince_(next->lastResumed);
	.debug	# 286
	ld	hl,(_next)
	ld	de,0xbf
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(__TimerMilliSeconds+4)
	or	a,a
	sbc	hl,de
	ld	(ix-16),hl
;287 
;288   for (;;)  {
@29:
	.debug	< @29 @30
@33:
;289 
;290  /*------------------------------------------------------------------*
;291    Set the idle task as the default candidate for the next task to run
;292    run and then determine if there is a better choice based on the
;293    following:
;294     - task is ready to run (includes ones that were preempted)
;295     - priority >= current candidate
;296     - run less recently than current candidate
;297   *------------------------------------------------------------------*/
;298 
;299     for (;;)  {
@34:
	.debug	< @34 @35
@36:
	.debug	< @36 @37
@38:
;300       if (++task == endTasks)  task = tasks;
@41:
	.debug	< @41 @42
	.debug	# 300
	ld	hl,(ix-20)
	ld	de,0xe8
	add	hl,de
	ld	(ix-20),hl
	ld	de,(_endTasks)
	or	a,a
	sbc	hl,de
	jr	nz,@43
	ld	hl,_tasks
	ld	(ix-20),hl
;301 
;302   /*finish
;303       if (task->sig_pending)
;304         if ((task->state == TASK_RUNNING)
;305             OR (task->state == TASK_INTERRUPTIBLE))  {
;306           // ... check for signal handler for the task ...
;307         }
;308   */
;309       if (task->state != TASK_STOPPED)
@43:
	.debug	# 309
	ld	hl,(ix-20)
	ld	de,0x13
	add	hl,de
	ld	hl,(hl)
	ld	e,0x4
	or	a,a
	sbc	hl,de
	jp	z,@44
;310         if ((task->state == TASK_RUNNING) OR task->preempt_count)  {
	.debug	# 310
	ld	hl,(ix-20)
	ld	e,0x13
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@45
	ld	hl,(ix-20)
	ld	e,0xa8
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@46
@45:
;311           ++readyCount;
@47:
	.debug	< @47 @48
	.debug	# 311
	ld	hl,(ix-14)
	inc	hl
	ld	(ix-14),hl
;312           if ( (task->priority < next->priority) OR
;313             ((task->priority == next->priority)
;314                 AND (msSinceResumed = msSince_(task->lastResumed))
;315                      > msSinceNextResumed) )
	.debug	# 315
	ld	hl,(ix-20)
	ld	de,0xb8
	add	hl,de
	ld	de,(_next)
	ld	bc,hl
	ld	hl,0xb8
	add	hl,de
	ld	a,(hl)
	ld	de,bc
	ex	de,hl
	ld	l,(hl)
	ld	h,a
	ld	a,l
	ld	l,h
	sub	a,l
	jr	c,@49
	ld	hl,(ix-20)
	ld	de,0xb8
	add	hl,de
	ld	de,(_next)
	ld	bc,hl
	ld	hl,0xb8
	add	hl,de
	ld	a,(hl)
	ld	de,bc
	ex	de,hl
	ld	l,(hl)
	sub	a,l
	jr	nz,@50
	ld	hl,(ix-20)
	ld	de,0xbf
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(__TimerMilliSeconds+4)
	or	a,a
	sbc	hl,de
	ld	(ix-18),hl
	ex	de,hl
	ld	hl,(ix-16)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@50
	jr	z,@50
@49:
;316              if (ActiveTask(task))  {
	.debug	# 316
	ld	hl,(ix-20)
	ld	de,0x13
	add	hl,de
	ld	hl,(hl)
	ld	e,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@54
;317                next = task;  msSinceNextResumed = msSinceResumed; }
@55:
	.debug	< @55 @56
	.debug	# 317
	ld	hl,(ix-20)
	ld	(_next),hl
	ld	hl,(ix-18)
	ld	(ix-16),hl
@56:
	.debug	>
;318         }
@54:
@50:
@48:
	.debug	>
;319 
;320       if (task == current)  break;  // wrapped around to where we started
@46:
@44:
	.debug	# 320
	ld	hl,(_current)
	ex	de,hl
	ld	hl,(ix-20)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nz,@38
;321     }
@42:
	.debug	>
;322 
;323   //--- Make sure the task we choose is not obviously corrupted ---
;324     checkTask(next);  if (next->state >= TASK_STOPPED)  continue;
@37:
	.debug	>
	.debug	# 324
	ld	hl,(_next)
	push	hl
	lcall	$checkTask
	pop	hl
	ld	hl,(_next)
	ld	de,0x13
	add	hl,de
	ld	hl,(hl)
	ld	e,0x4
	or	a,a
	sbc	hl,de
	jp	nc,@33
;325 
;326 
;327   //--- If we are switching tasks, then update the CPU usage data ---
;328   //--- and set the current process info ---
;329 
;330     if (next != current)  {
	.debug	# 330
	ld	hl,(_current)
	ld	de,(_next)
	or	a,a
	sbc	hl,de
	jp	z,@32
;331       tickTime = clockTicks();  msTime = MS_TIMER;
@60:
	.debug	< @60 @61
	.debug	# 331
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;332 
;333       ++taskSwitches;
	.debug	# 333
	ld	hl,(_taskSwitches)
	inc	hl
	ld	(_taskSwitches),hl
;334 
;335       current->lastStopped = msTime;
	.debug	# 335
	ld	hl,(_current)
	ld	de,0xc3
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;336 
;337       if (current->lastResumed)  {
	.debug	# 337
	ld	hl,(_current)
	ld	de,0xbf
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jp	z,@62
;338         ticksUsed = UL_Interval(current->resumedTicks, tickTime);
@63:
	.debug	< @63 @64
	.debug	# 338
	ld	hl,(_current)
	ld	de,0xcb
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsubr##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;339         if (ticksUsed & 0xffff0000L)  // value > 2 secs unlikely
	.debug	# 339
	push	bc
	push	de
	ld	de,0
	ld	bc,0xffff
	call	__land##
	ld	hl,bc
	or	hl,de
	jp	z,@65
;340           current->msUsed += msSince(current->lastResumed);
	.debug	# 340
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(_current)
	push	bc
	push	de
	ld	de,0xbf
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	ld	hl,(_current)
	push	bc
	push	de
	ld	de,0xd3
	add	hl,de
	pop	iy
	pop	af
	push	hl
	push	af
	push	iy
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;341         else  {
	jr	@66
@65:
;342           current->ticksUsed += ticksUsed;
@67:
	.debug	< @67 @68
	.debug	# 342
	ld	hl,(_current)
	ld	de,0xcf
	add	hl,de
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;343           current->msUsed += current->ticksUsed >> 5;  // aprox the # of ms
	.debug	# 343
	ld	hl,(_current)
	ld	de,0xcf
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,0x5
	call	__ulshr##
	ld	hl,(_current)
	push	bc
	push	de
	ld	de,0xd3
	add	hl,de
	pop	iy
	pop	af
	push	hl
	push	af
	push	iy
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;344           current->ticksUsed &= 0x1f;  // remove the aprox ms portion
	.debug	# 344
	ld	hl,(_current)
	ld	de,0xcf
	add	hl,de
	push	hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x1f
	ld	c,d
	ld	b,d
	call	__land##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;345         }
@68:
	.debug	>
;346       }
@66:
@64:
	.debug	>
;347 
;348       next->lastResumed = msTime;
@62:
	.debug	# 348
	ld	hl,(_next)
	ld	de,0xbf
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;349       next->resumedTicks = tickTime;
	.debug	# 349
	ld	hl,(_next)
	ld	de,0xcb
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;350 
;351       if (next->state == TASK_RUNNING)  next->sleepTicks = 0;
	.debug	# 351
	ld	hl,(_next)
	ld	de,0x13
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@69
	ld	hl,(_next)
	ld	e,0xdc
	add	hl,de
	ld	e,d
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;352 
;353       current = next;  userPix = current - tasks;
@69:
	.debug	# 353
	ld	hl,(_next)
	ld	(_current),hl
	ld	de,_tasks
	or	a,a
	sbc	hl,de
	ld	de,0xe8
	call	__idiv##
	ld	(_userPix),hl
;354     }
@61:
	.debug	>
;355 
;356     break;
	.debug	# 356
;357   }
@35:
	.debug	>
;358 
;359   numReadyTasks = readyCount;  // for use in computing load averages
@32:
@30:
	.debug	>
	.debug	# 359
	ld	hl,(ix-14)
	ld	(_numReadyTasks),hl
;360 }
@27:
	.debug	} @27 360

@26	equ	20
	ld	sp,ix
	pop	ix
	lret
@28	equ	22
;361 
;362 
;363 //-------------------------------------------------------------------------
;364 
;365 #pragma offset_labels(task_t)
;366 
;367 /*-------------------------------------------------------------------------
;368   This is what schedule() pushes on to the stack of the calling task before
;369   suspends the task.  If this is changed, you must update the macro
;370   Schedule_PushCount in linux/sched.h:
;371 
;372   --- pushed by schedule() before suspending a task ---
;373   stackPtr[0]:    IX (LSB)
;374   stackPtr[1]:    IX (MSB)
;375 
;376   stackPtr[2]:    IY (LSB)
;377   stackPtr[3]:    IY (MSB)
;378 
;379   stackPtr[4]:    IP
;380 */
;381 //-------------------------------------------------------------------------
;382 //  Called either by timer_interrupt() or by the task itself.
;383 //
;384 //  In the 1st case, the task was Preempted by the periodic timer interrupt
;385 //
;386 //  In the 2nd case, schedule() was most likely called by some system fucnt
;387 //  that the task called and the task is blocked, waiting for some event to
;388 //  occur.
;389 //
;390 //                              ***** WARNING *****
;391 //   If you change what schedule() pushes on to the stack before suspending
;392 //   task then you must update the macro Schedule_PushCount (in linux/sched
;393 //   and the function postMortem() unistd.c
;394 //                              ***** WARNING *****
;395 //-------------------------------------------------------------------------
;396 void _nearcall schedule(void)
;397 {
	.align	4
$$schedule::
	ex	(sp),iy
$schedule::
	.debug	G $schedule 39 9
	.debug	{ $schedule 39 396 @72 @71
;398 //--- Save the state of the IP (Interrupt Priority) register on the stack -
;399 //--- of the process that called or was interrupted ---
;400   _asm( "push ip" );
	.debug	# 400
push ip
;401 
;402   StartInterval(TrackScheduler);
;403 
;404   current->lastRunning = GetMS();
	.debug	# 404
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(_current)
	push	de
	ld	de,0xc7
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;405 
;406 // IMPORTANT:  Caller must save all registers they might need on return exc
;407 //             for IY and IX (which are saved here on the stack of the curr
;408 //             process)
;409 
;410 #asm
	.debug	# 527
.sched_start:

	.debug	# 530
ipset 3

	.debug	# 533
ld      hl,(_schedCalls)

	.debug	# 534
inc     hl

	.debug	# 535
ld      (_schedCalls),hl

	.debug	# 538
ld      a,1

	.debug	# 539
ld      (__pending),a

	.debug	# 542
ld      hl,__disabled

	.debug	# 543
inc     (hl)

	.debug	# 544
ld      a,(hl)

	.debug	# 545
dec     a

	.debug	# 548
ipres

	.debug	# 551
jp      nz,.chk_pending

	.debug	# 554
ld      (__pending),a    

	.debug	# 556
push    iy

	.debug	# 557
push    ix

	.debug	# 560
ld      h,a                 

	.debug	# 561
ld      l,a

	.debug	# 562
add     hl,sp               

	.debug	# 563
ld      ix,(_current)       

	.debug	# 564
ld      (ix+0),hl   

	.debug	# 567
ipset 1

	.debug	# 570
lcall    $chooseTask

	.debug	# 573
ld      ix,(_current)           

	.debug	# 574
ld      hl,(ix+0)       

	.debug	# 575
ld      a,(ix+6)         

	.debug	# 578
ipset 3   

	.debug	# 580
ld      sp,HL         

	.debug	# 581
ioi ld  (0x11),a

	.debug	# 584
ld      a, (_hdwProtection)

	.debug	# 585
or      a

	.debug	# 586
jp      z,.skipHdwProtect

	.debug	# 589
ld      a,0x80

	.debug	# 590
ioi ld  (0x10),a

	.debug	# 598
ld      hl,(ix+7)  

	.debug	# 599
ioi ld  (0x0445),hl         

	.debug	# 604
ld      a,(ix+9)    

	.debug	# 605
ioi ld  (0x0480),a

	.debug	# 606
ld      hl,(ix+10)  

	.debug	# 607
ioi ld  (0x0481),hl         

	.debug	# 612
ld      a,(ix+12)    

	.debug	# 613
ioi ld  (0x0484),a

	.debug	# 614
ld      hl,(ix+13)  

	.debug	# 615
ioi ld  (0x0485),hl         

	.debug	# 622
xor     a

	.debug	# 623
ioi ld  (0x10),a

	.debug	# 627
.skipHdwProtect:

	.debug	# 629
ipres

	.debug	# 632
ipres

	.debug	# 637
pop     ix

	.debug	# 638
pop     iy

	.debug	# 640
ld      hl,__disabled

	.debug	# 643
.chk_pending:

	.debug	# 645
dec     (hl)

	.debug	# 646
jp      nz,.exit_ts_busy

	.debug	# 649
ld      a,(__pending)

	.debug	# 650
sla     a

	.debug	# 651
jp      nz,.sched_start

	.debug	# 654
.exit_ts_busy:

	.debug	# 657
pop     ip

;659 
	.seg	FARCODE
;660   EndInterval(TrackScheduler);
;661 }
@71:
	.debug	} @71 661

@70	equ	0
	lret
@72	equ	0
;662 
;663 
;664 #pragma offset_labels on
;665 
;666 //-------------------------------------------------------------------------
;667 //  This launches a new process by calling its main function with any
;668 //  arguments provided in the call to createProc()
;669 //-------------------------------------------------------------------------
;670 void near taskStart(int pix)
;671 {
	.cseg
_taskStart::
	.debug	G _taskStart 40 1
	.debug	{ _taskStart 40 670 @75 @74
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
.pix = 4
	.debug	A pix 4 6
;672   task_t  *task = tasks + pix;
.task = -2
	.debug	L task -2 32
	.debug	# 672
	ld	hl,(ix+4)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(ix-2),hl
	.cseg
;673 
;674 // printf("Launcing task %d...\r\n", pix);  //tdebug
;675 
;676 //finish - make task_ funcs return int rather than void?
;677   (task->procMain)(task->argc, task->argv);
	.debug	# 677
	ld	de,0x1a
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-2)
	ld	e,0x18
	add	hl,de
	ld	hl,(hl)
	push	hl
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xb2
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,4
;678 
;679   current->state = EXIT_DEAD;
	.debug	# 679
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x20
	ld	(hl),e
	inc	hl
	ld	(hl),d
;680   current->exit = -9999;  // indicates task returned rather than did an Exi
	.debug	# 680
	ld	hl,(_current)
	ld	e,0xab
	add	hl,de
	ld	a,0xf1
	ld	(hl),a
;681 
;682   schedule();  // should never return since this task is now DEAD
	.debug	# 682
	lcall	$schedule
;683 }
@74:
	.debug	} @74 683

@73	equ	2
	ld	sp,ix
	pop	ix
	ret
@75	equ	4
;684 
;685 //-------------------------------------------------------------------------
;686 //  Modify the write protect masks for the 2 4K resolution pages as follows
;687 //
;688 //  - The first is used to protect the start of the FARCODE/FARCONST segmen
;689 //    If the start is in the root page, then it is also used to protect as
;690 //    much of the CODE and CONST segments as possible (and the kernel's sta
;691 //    for all task's but the kernel's)
;692 //
;693 //  - The second is used to protect the end of the FARCODE/FARCONST segment
;694 //    Eventually, this may be expanded (when possible) to compute and use
;695 //    a seperate mask for a portion of the FARBSS values that are writable
;696 //    only by kernel functions.
;697 //
;698 //  While these values are curently the same for most tasks, this is called
;699 //  for each task to allow the possibility of an earlier approach where at
;700 //  least one of the 4K resolution pages was used to protect as many of the
;701 //  stacks as possible (i.e. those that don't belong to the currently runni
;702 //  task).
;703 //-------------------------------------------------------------------------
;704 void set4KwpMasks(task_t *task)
;705 {
	.seg	FARCODE
$set4KwpMasks::
	.debug	G $set4KwpMasks 37 9
	.debug	{ $set4KwpMasks 37 704 @78 @77
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
.task = 5
	.debug	A task 5 32
;706   uint  u, pageL, numPages, mask;
.u = -2
	.debug	L u -2 7
.pageL = -4
	.debug	L pageL -4 7
.numPages = -6
	.debug	L numPages -6 7
.mask = -8
	.debug	L mask -8 7
;707 
;708 
;709   if (!hdwProtection)  return;
	.debug	# 709
	ld	a,(_hdwProtection)
	or	a,a
	jp	z,@77
;710 
;711 //--- Use the 1st 4K resolution page to protect the beginning of the far --
;712 //--- segments.  Note that this asusmes that the first of the far segments 
;713 //--- starts on a 4K boundary (or at least does not share a 4K block with -
;714 //--- any other writeable data) ---
;715   task->wpsar = (uchar) MSWL(roStartFar);
	.debug	# 715
	ld	hl,(ix+5)
	ld	de,0x9
	add	hl,de
	ld	a,(_roStartFar+2)
	ld	(hl),a
;716   pageL = (uint)((roStartFar + 0x0FFF) >> 12) & 0x0F;  numPages = 16 - page
	.debug	# 716
	ld	de,(_roStartFar)
	ld	bc,(_roStartFar+2)
	push	bc
	push	de
	ld	de,0xfff
	ld	bc,0
	call	__ladd##
	ld	a,0xc
	call	__ulshr##
	ld	hl,0xf
	and	hl,de
	ld	(ix-4),hl
	ld	hl,0x10
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-6),hl
;717   mask = 1 << pageL;
	.debug	# 717
	ld	hl,0x1
	ld	a,(ix-4)
	or	a,a
	jr	z,@80
	ld	b,a
@81:
	add	hl,hl
	djnz	@81
@80:
	ld	(ix-8),hl
;718   for (u=1; u<numPages; ++u)  mask |= mask << 1;
@82:
	.debug	< @82 @83
	.debug	# 718
	ld	hl,0x1
	ld	(ix-2),hl
@84:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@85
	ld	hl,(ix-8)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	or	hl,de
	ld	(ix-8),hl
;719   task->wpsalhr = mask;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@84
@85:
@83:
	.debug	>
	.debug	# 719
	ld	hl,(ix+5)
	ld	de,0xa
	add	hl,de
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;720 
;721 //--- If the start of the far segments is in root, then we can also use the
;722 //--- first 4K resolution page to protect some of CODE and CONST (and the -
;723 //--- kernel's stack from all other tasks) ---
;724   if (task->wpsar == 0)  {
	.debug	# 724
	ld	hl,(ix+5)
	ld	de,0x9
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@87
;725     task->wpsalhr |= wpRootMask;
@88:
	.debug	< @88 @89
	.debug	# 725
	ld	hl,(ix+5)
	inc	e
	add	hl,de
	push	hl
	ld	hl,(hl)
	ld	de,(_wpRootMask)
	or	hl,de
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;726     if (task != tasks)  task->wpsalhr |= 0x2000;  // write protect kernel's
	.debug	# 726
	ld	hl,_tasks
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@90
	ld	h,d
	ld	l,e
	ld	de,0xa
	add	hl,de
	push	hl
	ld	hl,(hl)
	set	5,h
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;727   }
@90:
@89:
	.debug	>
;728 
;729 //--- This assumes that the 4K block that contains the end of the ReadOnly 
;730 //--- portion of extended memory does not contain any writable data (i.e. -
;731 //--- that the following segment starts at the next 4K boundary) ---
;732   task->wpsbr = (uchar) MSWL(roEndFar);
@87:
	.debug	# 732
	ld	hl,(ix+5)
	ld	de,0xc
	add	hl,de
	ld	a,(_roEndFar+2)
	ld	(hl),a
;733   numPages = ((uint)(roEndFar >> 12) & 0x0F) + 1;
	.debug	# 733
	ld	de,(_roEndFar)
	ld	bc,(_roEndFar+2)
	ld	a,0xc
	call	__ulshr##
	ld	hl,0xf
	and	hl,de
	inc	hl
	ld	(ix-6),hl
;734   if (numPages == 16)  {  // entire 64K segment?
	.debug	# 734
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	nz,@91
;735     wpSegMask |= 1 << task->wpsbr;  mask = 0;  }
@92:
	.debug	< @92 @93
	.debug	# 735
	ld	hl,(ix+5)
	ld	e,0xc
	add	hl,de
	ld	e,0x1
	ld	a,(hl)
	ex	de,hl
	or	a,a
	jr	z,@94
	ld	b,a
@95:
	add	hl,hl
	djnz	@95
@94:
	ld	de,(_wpSegMask)
	or	hl,de
	ld	(_wpSegMask),hl
	bool	hl
	ld	l,h
	ld	(ix-8),hl
@93:
	.debug	>
;736   else  {
	jr	@96
@91:
;737     mask = 1;
@97:
	.debug	< @97 @98
	.debug	# 737
	ld	hl,0x1
	ld	(ix-8),hl
;738     for (u=1; u<numPages; ++u)  mask |= mask << 1;
@99:
	.debug	< @99 @100
	.debug	# 738
	ld	(ix-2),hl
@101:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@102
	ld	hl,(ix-8)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	or	hl,de
	ld	(ix-8),hl
;739   }
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@101
@102:
@100:
	.debug	>
@98:
	.debug	>
;740   task->wpsblhr = mask;
@96:
	.debug	# 740
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;741 
;742 //  fprintf(DiagLog, "  Task %2d: %02X:%02X-%02X  %02X:%04X  %02X:%04X\r\n"
;743 //          task - tasks, task->sseg, task->stkllr, task->stkhlr,
;744 //          task->wpsar, task->wpsalhr,
;745 //          task->wpsbr, task->wpsblhr );
;746 }
@77:
	.debug	} @77 746

@76	equ	8
	ld	sp,ix
	pop	ix
	lret
@78	equ	10
;747 
;748 
;749 //-------------------------------------------------------------------------
;750 //  Prepare an entry in the task table to run a new task.  For entries that
;751 //  have never been used, assign a portion of the memory allocated for stac
;752 //  for use only by the specified task.
;753 //
;754 //  In either case, the stack is initialized with the values that will caus
;755 //  taskStart() to be executed when schedule() "resumes" the new task.
;756 //
;757 //  Returns the specified task number if successful, < 0 if an error
;758 //-------------------------------------------------------------------------
;759 int initTaskEntry(int tnum, unsigned stack_size)
;760 {
$initTaskEntry::
	.debug	G $initTaskEntry 41 9
	.debug	{ $initTaskEntry 41 759 @106 @105
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-23
.tnum = 5
	.debug	A tnum 5 6
.stack_size = 7
	.debug	A stack_size 7 7
;761   ulong  absAddrSP, startPage, endPage;  //, wpMask;
.absAddrSP = -4
	.debug	L absAddrSP -4 9
.startPage = -8
	.debug	L startPage -8 9
.endPage = -12
	.debug	L endPage -12 9
;762   uint  logAddrSP, wasted;
.logAddrSP = -14
	.debug	L logAddrSP -14 7
.wasted = -16
	.debug	L wasted -16 7
;763   uchar  stackSeg;  //, absPage;
.stackSeg = -17
	.debug	L stackSeg -17 3
;764   uint far  *stackPtr;
.stackPtr = -21
	.debug	L stackPtr -21 38
;765   task_t  *task;
.task = -23
	.debug	L task -23 32
;766 
;767 
;768   if (tnum >= NUM_TASKS)   return -1;
	.debug	# 768
	ld	hl,(ix+5)
	ld	de,0x8014
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@107
	ld	hl,0xffff
	jp	@105
;769 
;770   task = tasks + tnum;  task->myAddr = task;
@107:
	.debug	# 770
	ld	hl,(ix+5)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(ix-23),hl
	ld	de,0x15
	add	hl,de
	ex	de,hl
	ld	hl,(ix-23)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;771 
;772 //===== Reusing a task table entry that already has a stack allocated =====
;773   if (stack_size == 0) {  // this is a restart
	.debug	# 773
	ld	hl,(ix+7)
	bool	hl
	jr	nz,@108
;774     absAddrSP = (ulong) task->stack_start;
@109:
	.debug	< @109 @110
	.debug	# 774
	ld	h,d
	ld	l,e
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,0
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;775     absAddrSP += ((ulong) task->sseg) << 12;
	.debug	# 775
	ld	hl,(ix-23)
	ld	de,0x6
	add	hl,de
	ld	e,(hl)
	ld	b,d
	ld	c,d
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;776     stackPtr = (uint far *) absAddrSP;
	.debug	# 776
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
;777 
;778     stack_size = task->stack_size;
	.debug	# 778
	ld	hl,(ix-23)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	(ix+7),hl
;779   }
@110:
	.debug	>
;780 
;781 //===== Assign stack space for an entry that has never been used =====
;782   else  for (;;)  {
	jp	@111
@108:
@112:
	.debug	< @112 @113
@116:
;783     if (stackPoolSize < stack_size)  {
@117:
	.debug	< @117 @118
	.debug	# 783
	ld	hl,(ix+7)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_stackPoolSize)
	ld	bc,(_stackPoolSize+2)
	call	__lcmpr##
	jr	nc,@119
;784       printf("insufficient stack space left: %ld\r\n", stackPoolSize);
@120:
	.debug	< @120 @121
	.debug	# 784
	ld	de,(_stackPoolSize)
	ld	bc,(_stackPoolSize+2)
	push	bc
	push	de
	ld	de,word (phys @20+164)
	ld	c,phys @20+164 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;785       return -2;
	.debug	# 785
	ld	hl,0xfffe
	jp	@105
;786     }
@121:
	.debug	>
;787 
;788   //--- make sure stack starts on a 256 byte boundary if using hdw checks -
;789     if (hdwProtection)
@119:
	.debug	# 789
	ld	a,(_hdwProtection)
	or	a,a
	jr	z,@122
;790       stackPtr = (uint far *) (((ulong)stackPool + 0xFFL) & 0xFFF00L);
	.debug	# 790
	ld	de,(_stackPool)
	ld	bc,(_stackPool+2)
	ld	b,0
	push	bc
	push	de
	ld	de,0xff
	ld	c,d
	call	__ladd##
	push	bc
	push	de
	ld	de,0xff00
	ld	bc,0xf
	call	__land##
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
;791     else
;792       stackPtr = (uint far *) stackPool;
	jr	@123
@122:
	.debug	# 792
	ld	de,(_stackPool)
	ld	bc,(_stackPool+2)
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
;793 
;794   //--- compute start addr of the 4K pages the 1st & last bytes reside in -
;795     startPage = (ulong)stackPtr & 0xFF000L;
@123:
	.debug	# 795
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	ld	de,0xf000
	ld	c,0xf
	call	__land##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;796     endPage =  ((ulong)stackPtr + stack_size - 1L) & 0xFF000L;
	.debug	# 796
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	ld	b,0
	ld	hl,(ix+7)
	push	bc
	push	de
	ex	de,hl
	ld	c,b
	call	__ladd##
	call	__ldec##
	push	bc
	push	de
	ld	de,0xf000
	ld	bc,0xf
	call	__land##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;797 
;798   //--- if it crosses 4K boundary, then use space starting at next boundary
;799     if (startPage != endPage)  {  // does stack cross a 4K boundary?
	.debug	# 799
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__lsub##
	jr	z,@124
;800       wasted = 0x1000 - ((uint)stackPtr & 0xFFF);
@125:
	.debug	< @125 @126
	.debug	# 800
	ld	hl,(ix-21)
	ld	de,0xfff
	and	hl,de
	inc	de
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-16),hl
;801       stackPoolSize -= wasted;
	.debug	# 801
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_stackPoolSize)
	ld	bc,(_stackPoolSize+2)
	call	__lsubr##
	ld	(_stackPoolSize),de
	ld	(_stackPoolSize+2),bc
;802       stackPool += wasted; // advance ptr to next 4K boundary
	.debug	# 802
	ld	hl,(ix-16)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_stackPool)
	ld	bc,(_stackPool+2)
	call	__ladd##
	ld	(_stackPool),de
	ld	(_stackPool+2),bc
;803       continue;  // try again
	.debug	# 803
;804     }
	jp	@116
@126:
	.debug	>
;805 
;806 //    printf("  Task %2d: Stack %05lX - %05lX\r\n",  //tdebug
;807 //           tnum, (ulong)stackPtr, (ulong)stackPtr + stack_size - 1L);
;808 
;809   //--- update pointer and remaining byte count for next call ---
;810     stackPool += stack_size;  stackPoolSize -= stack_size;
@124:
	.debug	# 810
	ld	hl,(ix+7)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_stackPool)
	ld	bc,(_stackPool+2)
	call	__ladd##
	ld	(_stackPool),de
	ld	(_stackPool+2),bc
	ld	hl,(ix+7)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_stackPoolSize)
	ld	bc,(_stackPoolSize+2)
	call	__lsubr##
	ld	(_stackPoolSize),de
	ld	(_stackPoolSize+2),bc
;811 
;812     break;
	.debug	# 812
;813   }
@118:
	.debug	>
;814 
;815   if (stackPtr == NULL)   return -4;
@113:
	.debug	>
@111:
	.debug	# 815
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@127
	ld	hl,0xfffc
	jp	@105
;816 
;817 
;818 //--- compute STACKSEG and SP values from the abs addr of start of stack --
;819   stackSeg = (uchar)((ulong)stackPtr >> 12) - 0x0D;
@127:
	.debug	# 819
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	ld	b,0
	ld	a,0xc
	call	__ulshr##
	ld	a,0xf3
	add	a,e
	ld	(ix-17),a
;820   logAddrSP = 0xD000 | (((uint) stackPtr) & 0x0FFF);
	.debug	# 820
	ld	hl,(ix-21)
	ld	de,0xfff
	and	hl,de
	ld	de,-12288
	or	hl,de
	ld	(ix-14),hl
;821 
;822   task->sseg = (uchar) stackSeg;
	.debug	# 822
	ld	hl,(ix-23)
	ld	de,0x6
	add	hl,de
	ld	(hl),a
;823 
;824 //--- init values for stack limits if hdw supports it ---
;825   if (hdwProtection)  {
	.debug	# 825
	ld	a,(_hdwProtection)
	or	a,a
	jr	z,@128
;826     task->stkhlr = (uchar) ((logAddrSP + stack_size) >> 8);
@129:
	.debug	< @129 @130
	.debug	# 826
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	l,h
	ld	h,0
	ex	de,hl
	ld	hl,(ix-23)
	ex	de,hl
	ld	c,l
	ld	l,0x8
	add	hl,de
	ld	(hl),c
;827     task->stkllr = (uchar) (logAddrSP >> 8);
	.debug	# 827
	ld	hl,(ix-14)
	ld	l,h
	ld	h,0
	ld	c,l
	ld	l,0x7
	add	hl,de
	ld	(hl),c
;828 /*
;829     absPage = (uchar) ((ulong)stackPtr >> 12);  // absolute 4K page #
;830 
;831     wpMask = 1L <<
;832         ((uint)absPage - (uint)stackPageL + ((uint)stackPageL & 0x0F));
;833 
;834     task->wpsar = stackSegL;
;835     task->wpsalhr = LSWL(wpAllStacks) & ~LSWL(wpMask);
;836 
;837     if (stacksCross64K)  {
;838       task->wpsbr = stackSegH;
;839       task->wpsblhr = MSWL(wpAllStacks) & ~MSWL(wpMask);
;840     }
;841     else  {
;842       task->wpsbr = 0;
;843       task->wpsblhr = wpRootMask;
;844     }
;845 */
;846     set4KwpMasks(task);
	.debug	# 846
	ld	h,d
	ld	l,e
	push	hl
	lcall	$set4KwpMasks
	pop	hl
;847   }
@130:
	.debug	>
;848 
;849 
;850 //--- make size an even # of bytes (because its faster to use 16-bit instrs
;851   stack_size &= 0xFFFE; // make it an even #
@128:
	.debug	# 851
	ld	hl,(ix+7)
	res	0,l
	ld	(ix+7),hl
;852 
;853 //--- Filling a new task's stack with the value 0xFF gives us an easy way -
;854 //--- to scan it any time we want to see how many bytes were unused.  Of --
;855 //--- course its not guaranteed, but unless a task actually uses a ---
;856 //--- significant portion at the top of its stack for the value 0xFF, then 
;857 //--- its a pretty reliable way to check the peek usage.  The scheduler ---
;858 //--- also checks to make sure a task's stack pointer is within the valid -
;859 //--- range for a task before it will resume it ---
;860 
;861   KLOCK();
	.debug	# 861
	call	_KLOCK
;862 
;863 //  DisableWriteProtection();  // disable so we can write to stack
;864 
;865   fmemset(stackPtr, 0xff, stack_size);
	.debug	# 865
	ld	hl,(ix+7)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,0xff
	push	hl
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;866 
;867 //--- Now we fill in the stack with what is needed to "resume" the task ---
;868   stack_size >>= 1; // change size to # of words
	.debug	# 868
	ld	hl,(ix+7)
	or	a,a
	rr	hl
	ld	(ix+7),hl
;869   stackPtr += stack_size - 1;     // makes ttl unused 16 byes to avoid a fa
	.debug	# 869
	dec	hl
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
;870 
;871   *stackPtr-- = tnum;              // save task number
	.debug	# 871
	push	bc
	push	de
	ld	de,0xfffe
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+5)
	call	__farst2##
;872   *stackPtr-- = 0;                 // dummy return addr
	.debug	# 872
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xfffe
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	bool	hl
	ld	l,h
	call	__farst2##
;873 
;874   // so when schedule() does an LRET it will be executing taskStart()
;875   *stackPtr = 0;                  // XPC = 0
	.debug	# 875
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	ld	hl,(ix-21)
	ex	de,hl
	call	__farst2##
;876   stackPtr = (uint far *) (((char far *) stackPtr) - 1);  // --1 byte inste
	.debug	# 876
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	call	__ldec##
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
;877   *stackPtr-- = (uint) taskStart; // our startup routine
	.debug	# 877
	push	bc
	push	de
	ld	de,0xfffe
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,_taskStart
	call	__farst2##
;878 
;879   // values popped by schedule() when "resuming" a process
;880   *stackPtr = 0;                 // IP = 0
	.debug	# 880
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	ld	hl,(ix-21)
	ex	de,hl
	call	__farst2##
;881   stackPtr = (uint far *)(((char far *)stackPtr) - 1);    // --1 byte inste
	.debug	# 881
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	call	__ldec##
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
;882 // initial IX and IY values
;883   *stackPtr-- = 0; // initial IY value
	.debug	# 883
	push	bc
	push	de
	ld	de,0xfffe
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	bool	hl
	ld	l,h
	call	__farst2##
;884   *stackPtr-- = 0; // initial IX value
	.debug	# 884
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xfffe
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	bool	hl
	ld	l,h
	call	__farst2##
;885 
;886 //  EnableWriteProtection();  // reenable protection
;887 
;888   KUNLOCK();
	.debug	# 888
	call	_KUNLOCK
;889 
;890 //--- set values in the task's structure ---
;891   task->stack_start = (uint *) logAddrSP;
	.debug	# 891
	ld	hl,(ix-23)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;892   task->stack_size = stack_size << 1;  // change it back to # of bytes
	.debug	# 892
	ld	hl,(ix+7)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-23)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x4
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;893 
;894   absAddrSP = (ulong) ++stackPtr;  // incr so not pointing at LSB of IX val
	.debug	# 894
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
	ld	b,0
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;895   absAddrSP = (absAddrSP & 0x0FFFL) | 0xD000L;
	.debug	# 895
	push	bc
	push	de
	ld	de,0xfff
	ld	c,b
	call	__land##
	set	4,d
	set	6,d
	set	7,d
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;896   task->stack = (uint *) absAddrSP;
	.debug	# 896
	ld	hl,(ix-23)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;897 
;898 
;899 /*<<<<< The task's stack should now look like this >>>>>
;900 
;901   ..        (<=== task->stack)
;902 
;903 ===== must match what schedule() pushes on the stack =====
;904   IX (LSB)
;905   IX (MSB)
;906 
;907   IY (MSB)
;908   IY (MSB)
;909 
;910   IP
;911 
;912 ===== causes taskStart() to execute when schedule() does an LRET =====
;913   taskStart (LSB)
;914   taskStart (MSB)
;915 
;916   XPC   0
;917 
;918 ===== values taskStart() expects to be on the stack when it starts ====
;919   0     (LSB)      // dummy return address (taskStart() should never return
;920   0     (MSB)
;921 
;922   tnum  (LSB)      // argument for taskStart()
;923   tnum  (MSB)
;924 */
;925 
;926 
;927 
;928 #ifdef DEBUG
;933   return tnum;
	.debug	# 933
	ld	hl,(ix+5)
;934 }
@105:
	.debug	} @105 934

@104	equ	23
	ld	sp,ix
	pop	ix
	lret
@106	equ	25
;935 
;936 
;937 
;938 //-------------------------------------------------------------------------
;939 //  reinitialize the specified entry in the task table for use by a new tas
;940 //-------------------------------------------------------------------------
;941 int reset_task(int tasknum)
;942 {
$reset_task::
	.debug	G $reset_task 42 9
	.debug	{ $reset_task 42 941 @133 @132
	push	ix
	ld	ix,0
	add	ix,sp
.tasknum = 5
	.debug	A tasknum 5 6
;943   return  initTaskEntry(tasknum, 0);
	.debug	# 943
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$initTaskEntry
	add	sp,4
;944 }
@132:
	.debug	} @132 944

@131	equ	0
	pop	ix
	lret
@133	equ	2
;945 
;946 //-------------------------------------------------------------------------
;947 //  return the # of bytes on the stack of the specified task that have not
;948 //  been used yet
;949 //-------------------------------------------------------------------------
;950 int check_stack(int tasknum)
;951 {
$check_stack::
	.debug	G $check_stack 42 9
	.debug	{ $check_stack 42 950 @136 @135
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
.tasknum = 5
	.debug	A tasknum 5 6
;952    int words = 0;
.words = -2
	.debug	L words -2 6
	.debug	# 952
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	.seg	FARCODE
;953    uint far *stack;
.stack = -6
	.debug	L stack -6 38
;954 
;955    ulong absAddrSP = (ulong) tasks[tasknum].stack_start;
.absAddrSP = -10
	.debug	L absAddrSP -10 9
	.debug	# 955
	ld	hl,(ix+5)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,0
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	.seg	FARCODE
;956    absAddrSP += ((ulong) tasks[tasknum].sseg) << 12;
	.debug	# 956
	ld	hl,(ix+5)
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	de,0x6
	add	hl,de
	ld	e,(hl)
	ld	b,d
	ld	c,d
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;957 
;958    stack = (uint far *) absAddrSP;
	.debug	# 958
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;959 
;960    while (*stack++ == 0xffff)  words++;
@137:
	.debug	# 960
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0xfffe
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@138
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
;961 
;962    return words << 1;
	jr	@137
@138:
	.debug	# 962
	ld	hl,(ix-2)
	add	hl,hl
;963 }
@135:
	.debug	} @135 963

@134	equ	10
	ld	sp,ix
	pop	ix
	lret
@136	equ	12
;964 
;965 //-------------------------------------------------------------------------
;966 //  Allocate memory for all the tasks stacks and initialize each entry in
;967 //  the task table
;968 //-------------------------------------------------------------------------
;969 int init_tasks(void)
;970 {
$init_tasks::
	.debug	G $init_tasks 43 9
	.debug	{ $init_tasks 43 969 @141 @140
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-30
;971   uint  u, startBit, endBit, numFullPages, xmemAdjust, bytesToNextPage,
.u = -2
	.debug	L u -2 7
.startBit = -4
	.debug	L startBit -4 7
.endBit = -6
	.debug	L endBit -6 7
.numFullPages = -8
	.debug	L numFullPages -8 7
.xmemAdjust = -10
	.debug	L xmemAdjust -10 7
.bytesToNextPage = -12
	.debug	L bytesToNextPage -12 7
;972         numPages, pageOffset, numFilledPages;
.numPages = -14
	.debug	L numPages -14 7
.pageOffset = -16
	.debug	L pageOffset -16 7
.numFilledPages = -18
	.debug	L numFilledPages -18 7
;973   int  stat;
.stat = -20
	.debug	L stat -20 6
;974   ulong  stackPoolEnd, mask;
.stackPoolEnd = -24
	.debug	L stackPoolEnd -24 9
.mask = -28
	.debug	L mask -28 9
;975   task_t  *task;
.task = -30
	.debug	L task -30 32
;976 
;977 
;978   task = tasks + 1;
	.debug	# 978
	ld	hl,_tasks+232
	ld	(ix-30),hl
;979   for (u=1; u<NUM_TASKS; ++u,++task)  {
@142:
	.debug	< @142 @143
	.debug	# 979
	ld	hl,0x1
	ld	(ix-2),hl
@144:
	ld	hl,(ix-2)
	ld	de,0x14
	or	a,a
	sbc	hl,de
	jr	nc,@145
;980     task->state = TASK_UNUSED;
@147:
	.debug	< @147 @148
	.debug	# 980
	ld	hl,(ix-30)
	dec	e
	add	hl,de
	ld	de,0x8000
	ld	(hl),e
	inc	hl
	ld	(hl),d
;981     init_waitqueue_head(&task->waitQs);
	.debug	# 981
	ld	hl,(ix-30)
	ld	de,0x9c
	add	hl,de
	push	hl
	lcall	$init_waitqueue_head
	pop	hl
;982   }
@148:
	.debug	>
;983 
;984 
;985 //--- The hardware stack limit checking is limited to a resolution of 256 -
;986 //--- bytes.  In addition, DEBROS write protects all the 4K pages that ---
;987 //--- contain stacks other than the one with the currently running task's, 
;988 //--- which means the protected pages can't be allowed to have anything ---
;989 //--- BUT stacks in them (if they did, then we would be disabling writes --
;990 //--- to any other variables that were in the same page as some stacks!) --
;991 
;992 //--- Also keep in mind that the kernel task already has its own 4K stack -
;993 //--- and is not included in the stack pool used for all the other tasks --
;994 //--- (hence the use of (NUM_TASKS-1) below)
;995 
;996   xmemAdjust = 0;  pageOffset = (uint)_xmemHeap & 0x0FFF;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-30)
	ld	de,0xe8
	add	hl,de
	ld	(ix-30),hl
	jr	@144
@145:
@143:
	.debug	>
	.debug	# 996
	bool	hl
	ld	l,h
	ld	(ix-10),hl
	ld	hl,(__xmemHeap)
	ld	de,0xfff
	and	hl,de
	ld	(ix-16),hl
;997 
;998   bytesToNextPage = (pageOffset ? 0x1000 - pageOffset : 0);
	.debug	# 998
	bool	hl
	jr	z,@149
	ld	hl,0x1000
	ex	de,hl
	ld	hl,(ix-16)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	@150
@149:
	bool	hl
	ld	l,h
@150:
	ld	(ix-12),hl
;999 
;1000   if (hdwProtection)  {
	.debug	# 1000
	ld	a,(_hdwProtection)
	or	a,a
	jr	z,@151
;1001     stackSize = STACK_SIZE & 0x1F00;  // 256 byte resolution for hdw limits
@152:
	.debug	< @152 @153
	.debug	# 1001
	ld	hl,0x500
	ld	(_stackSize),hl
;1002     numFullPages = (((NUM_TASKS-1) + StacksPer4K - 1) / StacksPer4K);
	.debug	# 1002
	ld	hl,0x7
	ld	(ix-8),hl
;1003     stackPoolSize =  numFullPages * 0x1000;
	.debug	# 1003
	ld	h,l
	ld	l,0
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	bc,0
	ld	(_stackPoolSize),de
	ld	(_stackPoolSize+2),bc
;1004     // to insure xmem heap starts on a page boundary
;1005     if (pageOffset)  xmemAdjust = bytesToNextPage;
	.debug	# 1005
	ld	hl,(ix-16)
	bool	hl
	jr	z,@155
	ld	hl,(ix-12)
	ld	(ix-10),hl
;1006   }
@153:
	.debug	>
;1007   else  {
	jr	@155
@151:
;1008     stackSize = STACK_SIZE;
@156:
	.debug	< @156 @157
	.debug	# 1008
	ld	hl,0x554
	ld	(_stackSize),hl
;1009     numFilledPages = (NUM_TASKS-1) / StacksPer4K;
	.debug	# 1009
	ld	hl,0x6
	ld	(ix-18),hl
;1010     stackPoolSize = (numFilledPages * 0x1000)
;1011                   + ((NUM_TASKS-1) % StacksPer4K) * stackSize;
	.debug	# 1011
	ld	hl,(_stackSize)
	ex	de,hl
	ld	hl,(ix-18)
	ld	h,l
	ld	l,0
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	bc,0
	ld	(_stackPoolSize),de
	ld	(_stackPoolSize+2),bc
;1012     // adjust start of heap to skip any 1st page bytes that can't be used -
;1013     xmemAdjust = bytesToNextPage % stackSize;
	.debug	# 1013
	ld	hl,(ix-12)
	ld	de,(_stackSize)
	call	__uidiv##
	ex	de,hl
	ld	(ix-10),hl
;1014   }
@157:
	.debug	>
;1015 
;1016   _xmemHeap += xmemAdjust;  _xmemSize -= xmemAdjust;
@155:
	.debug	# 1016
	ld	hl,(ix-10)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(__xmemHeap)
	ld	bc,(__xmemHeap+2)
	call	__ladd##
	ld	(__xmemHeap),de
	ld	(__xmemHeap+2),bc
	ld	hl,(ix-10)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(__xmemSize)
	ld	bc,(__xmemSize+2)
	call	__lsubr##
	ld	(__xmemSize),de
	ld	(__xmemSize+2),bc
;1017 
;1018   printf("Stack size: %d (0x%04X) bytes\r\n"
;1019          "For stacks:\r\n", stackSize);
	.debug	# 1018
	ld	hl,(_stackSize)
	push	hl
	ld	de,word (phys @20+201)
	ld	c,phys @20+201 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1020   stackPool = (char far *) xalloc(stackPoolSize);
	.debug	# 1020
	ld	de,(_stackPoolSize)
	ld	bc,(_stackPoolSize+2)
	push	bc
	push	de
	lcall	$xalloc
	add	sp,4
	ld	(_stackPool),de
	ld	(_stackPool+2),bc
;1021   if (stackPool == (char far *)0l)  {
	.debug	# 1021
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@158
;1022     printf("***** Unable to allocate stacks!!! *****\r\n");  return -1;  }
@159:
	.debug	< @159 @160
	.debug	# 1022
	ld	de,word (phys @20+246)
	ld	c,phys @20+246 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	jp	@140
@160:
	.debug	>
;1023 
;1024   stackPoolEnd = (ulong)stackPool + stackPoolSize - 1;
@158:
	.debug	# 1024
	ld	de,(_stackPool)
	ld	bc,(_stackPool+2)
	ld	b,0
	push	bc
	push	de
	ld	de,(_stackPoolSize)
	ld	bc,(_stackPoolSize+2)
	call	__ladd##
	call	__ldec##
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
;1025 
;1026 
;1027 //--- first/last 4K pages used by stacks, relative to start of memory ---
;1028   stackPageL = (uchar) ((ulong)stackPool >> 12);
	.debug	# 1028
	ld	de,(_stackPool)
	ld	bc,(_stackPool+2)
	ld	b,0
	ld	a,0xc
	call	__ulshr##
	ld	a,e
	ld	(_stackPageL),a
;1029   stackPageH = (uchar) (stackPoolEnd >> 12);
	.debug	# 1029
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	ld	a,0xc
	call	__ulshr##
	ld	a,e
	ld	(_stackPageH),a
;1030 
;1031 //--- first/last 64K segments used by stacks, relative to start of memory -
;1032   stackSegL = (uchar) (stackPageL >> 4);
	.debug	# 1032
	ld	a,(_stackPageL)
	bool	hl
	ld	l,a
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ld	a,l
	ld	(_stackSegL),a
;1033   stackSegH = (uchar) (stackPageH >> 4);
	.debug	# 1033
	ld	a,(_stackPageH)
	bool	hl
	ld	l,a
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ld	a,l
	ld	(_stackSegH),a
;1034 
;1035 //--- first/last 4K pages relative to first page in first 64K segment ---
;1036   numPages = (uint)stackPageH - (uint)stackPageL + 1;
	.debug	# 1036
	ld	a,(_stackPageH)
	bool	hl
	ld	l,a
	ld	a,(_stackPageL)
	ld	d,h
	ld	e,a
	or	a,a
	sbc	hl,de
	inc	hl
	ld	(ix-14),hl
;1037   startBit = (uint)stackPageL & 0x0F;
	.debug	# 1037
	bool	hl
	ld	l,a
	ld	e,0xf
	and	hl,de
	ld	(ix-4),hl
;1038   endBit = startBit + numPages - 1;
	.debug	# 1038
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	add	hl,de
	dec	hl
	ld	(ix-6),hl
;1039 
;1040   stacksCross64K = (stackSegL != stackSegH);
	.debug	# 1040
	ld	a,(_stackSegL)
	ld	l,a
	ld	a,(_stackSegH)
	sub	a,l
	jr	z,@161
	ld	a,1
@161:
	ld	(_stacksCross64K),a
;1041 
;1042   if (hdwProtection)  {
	.debug	# 1042
	ld	a,(_hdwProtection)
	or	a,a
	jr	z,@162
;1043 //    if (stacksCross64K)
;1044 //      printf("***** Can't protect anything in root segment *****\r\n");
;1045 
;1046   //--- compute write-protect mask that covers ALL the 4K stack pages ---
;1047   //--- other than the kernel's ---
;1048     wpAllStacks = 0;  mask = 1 << startBit;
@163:
	.debug	< @163 @164
	.debug	# 1048
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_wpAllStacks),de
	ld	(_wpAllStacks+2),bc
	ld	hl,0x1
	ld	a,(ix-4)
	or	a,a
	jr	z,@165
	ld	b,a
@166:
	add	hl,hl
	djnz	@166
@165:
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
;1049     for (u=startBit; u<=endBit; ++u,mask<<=1)  wpAllStacks |= mask;
@167:
	.debug	< @167 @168
	.debug	# 1049
	ld	hl,(ix-4)
	ld	(ix-2),hl
@169:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@171
	jr	nc,@170
@171:
	ld	de,(_wpAllStacks)
	ld	bc,(_wpAllStacks+2)
	push	bc
	push	de
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__lor##
	ld	(_wpAllStacks),de
	ld	(_wpAllStacks+2),bc
;1050 
;1051 //    printf("wpAllStacks: 0x%08lX (%d pages: %02X-%02X)\r\n", //tdebug
;1052 //           wpAllStacks, numPages, stackPageL, stackPageH);
;1053 
;1054   //--- set values for kernel task ---
;1055   /*
;1056     tasks[0].wpsar = stackSegL;
;1057     tasks[0].wpsalhr = LSWL(wpAllStacks);
;1058 
;1059     if (stacksCross64K)  {
;1060       tasks[0].wpsbr = stackSegH;
;1061       tasks[0].wpsblhr = MSWL(wpAllStacks);
;1062     }
;1063     else  {
;1064       tasks[0].wpsbr = 0;
;1065       // clear bit for page at 0xD000 so the kernel can write to its own st
;1066       tasks[0].wpsblhr = wpRootMask & ~0x2000;
;1067     }
;1068   */
;1069     set4KwpMasks(tasks);  // for kernel task
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
	jr	@169
@170:
@168:
	.debug	>
	.debug	# 1069
	ld	hl,_tasks
	push	hl
	lcall	$set4KwpMasks
	pop	hl
;1070   }
@164:
	.debug	>
;1071 
;1072   newTaskDiagFlags = 0;
@162:
	.debug	# 1072
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_newTaskDiagFlags),de
	ld	(_newTaskDiagFlags+2),bc
;1073 
;1074 //--- set default scheduler interval in ms (can be changed later) ---
;1075   SchedMS = (hdwType == HT_BL2105 ? 20 : 10);
	.debug	# 1075
	ld	hl,(_hdwType)
	inc	e
	or	a,a
	sbc	hl,de
	jr	nz,@173
	ld	hl,0x14
	jr	@174
@173:
	ld	hl,0xa
@174:
	ld	(_SchedMS),hl
;1076 
;1077 //--- set fixed values and init stack for each task_t structure  ---
;1078   for (u=1; u<NUM_TASKS; ++u)
@175:
	.debug	< @175 @176
	.debug	# 1078
	ld	hl,0x1
	ld	(ix-2),hl
@177:
	ld	hl,(ix-2)
	ld	de,0x14
	or	a,a
	sbc	hl,de
	jr	nc,@178
;1079     if ((stat = initTaskEntry(u, stackSize)) != u)  {
	.debug	# 1079
	ld	hl,(_stackSize)
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$initTaskEntry
	add	sp,4
	ld	(ix-20),hl
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@180
;1080       printf("*****  Unable to initialize task #%u: %d *****\r\n", u, stat)
@181:
	.debug	< @181 @182
	.debug	# 1080
	ld	hl,(ix-20)
	push	hl
	ld	h,d
	ld	l,e
	push	hl
	ld	de,word (phys @20+289)
	ld	c,phys @20+289 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;1081       postMortem("initTaskEntry failure");
	.debug	# 1081
	ld	de,word (phys @20+338)
	ld	c,phys @20+338 >> 16
	push	bc
	push	de
	lcall	$postMortem
	add	sp,4
;1082     }
@182:
	.debug	>
;1083 
;1084 
;1085   return 0;
@180:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@177
@178:
@176:
	.debug	>
	.debug	# 1085
	bool	hl
	ld	l,h
;1086 }
@140:
	.debug	} @140 1086

@139	equ	30
	ld	sp,ix
	pop	ix
	lret
@141	equ	32
;1087 
;1088 
;1089 
;1090 //=========================================================================
;1091 //  portions borrowed from or based on standard Linux kernel/sched.c code
;1092 //=========================================================================
;1093 
;1094 //-------------------------------------------------------------------------
;1095 /***
;1096  * try_to_wake_up - wake up a thread
;1097  * @p: the to-be-woken-up thread
;1098  * @state: the mask of task states that can be woken
;1099  * @sync: do a synchronous wakeup?
;1100  *
;1101  * Put it on the run-queue if it's not already there. The "current"
;1102  * thread is always on the run-queue (except when the actual
;1103  * re-schedule is in progress), and as such you're allowed to do
;1104  * the simpler "current->state = TASK_RUNNING" to mark yourself
;1105  * runnable without the overhead of this.
;1106  *
;1107  * returns failure only if the task is already active.
;1108  */
;1109 //-------------------------------------------------------------------------
;1110 /*
;1111 static int try_to_wake_up(struct task_struct *p, unsigned int state, int sy
;1112 {
;1113     int cpu, this_cpu, success = 0;
;1114     unsigned long flags;
;1115     long old_state;
;1116     struct rq *rq;
;1117 
;1118     rq = task_rq_lock(p, &flags);
;1119     old_state = p->state;
;1120     if (!(old_state & state))  goto out;
;1121 
;1122     if (p->array)  goto out_running;
;1123 
;1124     cpu = task_cpu(p);
;1125     this_cpu = smp_processor_id();
;1126 
;1127   if (old_state == TASK_UNINTERRUPTIBLE)  rq->nr_uninterruptible--;
;1128 
;1129     activate_task(p, rq, cpu == this_cpu);
;1130     //
;1131     // Sync wakeups (i.e. those types of wakeups where the waker
;1132     // has indicated that it will leave the CPU in short order)
;1133     // don't trigger a preemption, if the woken up task will run on
;1134     // this cpu. (in this case the 'I will reschedule' promise of
;1135     // the waker guarantees that the freshly woken up task is going
;1136     // to be considered on this CPU.)
;1137     //
;1138     if (!sync || cpu != this_cpu) {
;1139         if (TASK_PREEMPTS_CURR(p, rq))
;1140             resched_task(rq->curr);
;1141     }
;1142     success = 1;
;1143 
;1144 out_running:
;1145     p->state = TASK_RUNNING;
;1146 out:
;1147     task_rq_unlock(rq, &flags);
;1148 
;1149     return success;
;1150 }
;1151 */
;1152 
;1153 //-------------------------------------------------------------------------
;1154 int default_wake_function(WaitQueueNode *curr, unsigned mode, int sync,
;1155               void *key)
;1156 {
$default_wake_function::
	.debug	G $default_wake_function 44 9
	.debug	{ $default_wake_function 44 1154 @185 @184
	push	ix
	ld	ix,0
	add	ix,sp
.curr = 5
	.debug	A curr 5 45
.mode = 7
	.debug	A mode 7 7
.sync = 9
	.debug	A sync 9 6
.key = 11
	.debug	A key 11 47
;1157 //  return try_to_wake_up(curr->private, mode, sync);
;1158   return 1;
	.debug	# 1158
	ld	hl,0x1
;1159 }
@184:
	.debug	} @184 1159

@183	equ	0
	pop	ix
	lret
@185	equ	2
;1160 EXPORT_SYMBOL(default_wake_function);
;1161 
;1162 //-------------------------------------------------------------------------
;1163 
	.extern	_fmemset 48
	.extern	$clockTicks 50
	.extern	$init_waitqueue_head 51
	.bseg
_schedCalls::
	.ds	2
	.debug	G _schedCalls 7 0
_taskSwitches::
	.ds	2
	.debug	G _taskSwitches 7 0
_tasks::
	.ds	4640
	.debug	G _tasks 52 0
_userPix::
	.ds	2
	.debug	G _userPix 6 0
_idleTask::
	.ds	2
	.debug	G _idleTask 32 0
_applTask::
	.ds	2
	.debug	G _applTask 32 0
_kernelTask::
	.ds	2
	.debug	G _kernelTask 32 0
_newTaskDiagFlags::
	.ds	4
	.debug	G _newTaskDiagFlags 9 0
_SchedMS::
	.ds	2
	.debug	G _SchedMS 7 0
_numReadyTasks::
	.ds	2
	.debug	G _numReadyTasks 7 0
_stacksCross64K::
	.ds	1
	.debug	G _stacksCross64K 3 0
_stackSegL::
	.ds	1
	.debug	G _stackSegL 3 0
_stackSegH::
	.ds	1
	.debug	G _stackSegH 3 0
_stackPageL::
	.ds	1
	.debug	G _stackPageL 3 0
_stackPageH::
	.ds	1
	.debug	G _stackPageH 3 0
	.cseg
_schedule:
	pop	iy
	lcall	$$schedule
	.extern	$farfprintf 53
	.extern	$farprintf 54
	.extern	__TimerMilliSeconds 55
	.extern	$xalloc 56
	.extern	_KLOCK 39
	.extern	_KUNLOCK 39
	.extern	_diagLog 57
	.extern	_hdwType 7
	.extern	_roStartFar 9
	.extern	_roEndFar 9
	.extern	_wpSegMask 7
	.extern	_wpRootMask 7
	.extern	_hdwProtection 3
	.extern	__xmemSize 9
	.extern	__xmemHeap 9
	.extern	$postMortem 58
	.bseg
_next:
	.ds	2
	.debug	F _next 32 0
_inetTask::
	.ds	2
	.debug	G _inetTask 32 0
_stackSize:
	.ds	2
	.debug	F _stackSize 7 0
_wpAllStacks:
	.ds	4
	.debug	F _wpAllStacks 9 0
	.debug	T	070000200002002100
.task_struct.stack = 0
.task_struct.stack_start = 2
.task_struct.stack_size = 4
.task_struct.sseg = 6
.task_struct.stkllr = 7
.task_struct.stkhlr = 8
.task_struct.wpsar = 9
.task_struct.wpsalhr = 10
.task_struct.wpsbr = 12
.task_struct.wpsblhr = 13
.task_struct.FDSet = 15
.task_struct.useCount = 17
.task_struct.claimed = 18
.task_struct.state = 19
.task_struct.myAddr = 21
.task_struct.zeroAfter = 23
.task_struct.argc = 24
.task_struct.argv = 26
.task_struct.args = 28
.task_struct.waitQs = 156
.task_struct.sig_pending = 160
.task_struct.sig_blocked = 164
.task_struct.preempt_count = 168
.task_struct.inUse = 170
.task_struct.exit = 171
.task_struct.logStdout = 172
.task_struct.redirStdio = 173
.task_struct.diagFlags = 174
.task_struct.procMain = 178
.task_struct.pid = 180
.task_struct.ppid = 182
.task_struct.priority = 184
.task_struct.lastErr = 185
.task_struct.started = 187
.task_struct.lastResumed = 191
.task_struct.lastStopped = 195
.task_struct.lastRunning = 199
.task_struct.resumedTicks = 203
.task_struct.ticksUsed = 207
.task_struct.msUsed = 211
.task_struct.outCount = 215
.task_struct.outPtr = 216
.task_struct.sleepTicks = 220
.task_struct.sleepStarted = 224
.task_struct.timeoutTicks = 228
	.debug	T	7702032100E8002D000C7461736B5F737472756374002400000006
	.debug	T	737461636B00240002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C6872003B000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465002000150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	000561726763003C001A000561726776003E001C0005617267
	.debug	T	73003F009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773004000B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74002200D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	070008220004000300
	.debug	T	0B000223000100070024000000
	.debug	T	070000240002000700
	.debug	T	0B000225000100010020000000
	.debug	T	070008260004000700
	.debug	T	0B000227000100010001000000
	.debug	T	0B000228000100010006000000
	.debug	T	0F00022900020006000600000007000200
	.debug	T	0B00022A000100060006000000
	.debug	T	0B00022B000100060001000000
	.debug	T	1700022C00040006002D00000007000200060004002F000600
	.debug	T	0700002D0002002E00
.__wait_queue_node.flags = 0
.__wait_queue_node.task = 2
.__wait_queue_node.obj = 4
.__wait_queue_node.removeFunc = 6
.__wait_queue_node.taskList = 8
.__wait_queue_node.queueList = 12
.__wait_queue_node.myAddr = 16
	.debug	T	7100032E0012000700125F5F776169745F71756575655F6E6F6465
	.debug	T	000700000006666C6167730020000200057461736B002F0004
	.debug	T	00046F626A00420006000B72656D6F766546756E6300440008
	.debug	T	00097461736B4C6973740044000C000A71756575654C697374
	.debug	T	002F001000076D794164647200
	.debug	T	0700002F0002000100
	.debug	T	130002300003003100310000000600040009000600
	.debug	T	070008310004000100
	.debug	T	0B000232000100090001000000
	.debug	T	0B000233000100010045000000
	.debug	T	0900013400201221001400
	.debug	T	13000235000300060046000000220002000D000000
	.debug	T	0F0002360002000600220000000D000000
	.debug	T	0900013700080009000200
	.debug	T	0B000238000100220009000000
.__out = 0
.__in = 2
.__write = 4
.__read = 6
.__unget = 8
.__userData = 10
	.debug	T	54000339000C000600010047000000065F5F6F7574004900020005
	.debug	T	5F5F696E004B000400085F5F7772697465004B000600075F5F
	.debug	T	726561640006000800085F5F756E676574002F000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	0B00023A000100010022000000
	.debug	T	0700003B0002003100
	.debug	T	0700003C0002003D00
	.debug	T	0700003D0002000300
	.debug	T	0900013E00800003008000
.__wait_queue_head.listHead = 0
	.debug	T	2800033F0004000100125F5F776169745F71756575655F68656164
	.debug	T	0044000000096C6973744865616400
	.debug	T	070000400002004100
	.debug	T	0F0002410002000100060000003C000200
	.debug	T	070000420002004300
	.debug	T	0B00024300010001002D000000
.list_head.next = 0
.list_head.prev = 2
	.debug	T	2600034400040002000A6C6973745F68656164004D000000056E65
	.debug	T	7874004D000200057072657600
	.debug	T	070000450002003F00
	.debug	T	070000460002003900
	.debug	T	070000470002004800
	.debug	T	0F0002480002000600030000002F000200
	.debug	T	070000490002004A00
	.debug	T	0B00024A00010006002F000000
	.debug	T	0700004B0002004C00
	.debug	T	1300024C000300080022000000080004002F000800
	.debug	T	0700004D0002004400
	.defseg	FARCONST
	.seg	FARCONST
@20:
	.db	"***** %.32s[%d]: STACK POINTER OUT OF RANGE!!! *****",10,0,"Stack ptr out of range",0,"***** %."
	.db	"32s[%d]: STACK CORRUPTED OR OVERFLOWED!!! *****",10,0,"Stack Corrupted or Overflowed",0,"insuff"
	.db	"icient stack space left: %ld",13,10,0,"Stack size: %d (0x%04X) bytes",13,10,"For stacks:",13,10,0,"***** Una"
	.db	"ble to allocate stacks!!! *****",13,10,0,"*****  Unable to initialize task #%u: %d *****",13,10,0,"in"
	.db	"itTaskEntry failure",0
	.end
