	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\drivers\serial.c' 1 29 12 21 9 32
;1 //----- serial.c ----- 03/21/12 -----(04/26/06)-----
;2 
;3 //-------------------------------------------------------------------------
;4 //  Wrapper to provide standard fcntl API to Softools interrupt-driven seri
;5 //  functions.
;6 //
;7 //  The individual port-specific functions in the Softools libs are mostly
;8 //  thin wrappers for a common set of functions used for all ports.  The
;9 //  port-specific functions set pointers to the port-specific funcs and dat
;10 //  structures and then call the generic routine to do the work.
;11 //
;12 //  One issue of particular note is that the Softools interface does not
;13 //  provide a means of enabling or disabling in-band (xon/xoff) flow contro
;14 //  on an already intitialized port.  Whether or not to use flow control mu
;15 //  be known at the time the port is initialized.
;16 //
;17 //  So, for the time being, specifying use of flow control on a port is
;18 //  handled in the fcntl layer by using the prefix ttyx rather than tty for
;19 //  the device file name.
;20 //
;21 //finish:
;22 //  Eventually, this should all be handled by supporting the standard
;23 //  termios(3) API.
;24 //
;25 //  For details on Softools code, see notes below.
;26 //
;27 //-------------------------------------------------------------------------
;28 //  Update Log (most recent first):
;29 //
;30 //
;31 //  2012-03-21 - Mark Davis
;32 //               - flushConsole() now ensures that interrupts are enabled
;33 //                 until it returns.  On return it restores the IP register
;34 //                 what it was before it was called.  Prior to this, the
;35 //                 function did nothing (except generate an error message) 
;36 //                 it was called during the portion of startup where interr
;37 //                 are normally disabled.
;38 //
;39 //  2012-02-08 - Mark Davis
;40 //               - errno is now set to EBADF rather than ENXIO when a funct
;41 //                 is passed an invalid device pointer.
;42 //
;43 //  2011-11-22 - Mark Davis
;44 //               - Removed the static specifier from several items so they
;45 //                 would show up in the map file.
;46 //
;47 //  2010-05-14 - Mark Davis
;48 //               - ioctl function now support FIONSPACE request.
;49 //
;50 //  2010-04-23 - Mark Davis
;51 //               - Added flushConsole() function to better encapsulate the
;52 //                 fact that serial port A is the console.
;53 //
;54 //  2010-03-04 - Mark Davis
;55 //               - set inUse flag for the port to true at start of _serial_
;56 //                 init function so the rest of the initialization process 
;57 //                 not return errors.  The flag is still cleared if an erro
;58 //                 occurs during the rest of the initialization.
;59 //
;60 //  2010-03-03 - Mark Davis
;61 //               - Changed SetSetDirX() funcs from near to _nearcall
;62 //
;63 //  2010-02-02 - Mark Davis
;64 //               - Added check for port B in the init function to set the
;65 //                 bits that use the alternate I/O pins PD4 and PD5 (since
;66 //                 the normal I/O pins for B are used for other things - in
;67 //                 particular PC4 is used for the Ethernet RSTDRV pin!)
;68 //
;69 //  2009-12-18 - Mark Davis
;70 //               - Made several near functions _nearcall to free up root sp
;71 //
;72 //  2009-05-11 - Mark Davis
;73 //               - The write func once again ignores any pending schedule()
;74 //                 calls for ports in packet mode (this minimizes the chanc
;75 //                 that task switches could result in a pause in the middle
;76 //                 of a packet transmission).  With this change, a pause sh
;77 //                 never happen if packets are small enough to fit in the
;78 //                 xmit buffer and a single write call is used for each pac
;79 //
;80 //  2009-05-08 - Mark Davis
;81 //               - improved efficiency of _serialRead_() and _serialWrite_(
;82 //                 and reduced their effect on scheduler latency.
;83 //
;84 //  2009-05-06 - Mark Davis
;85 //               - changes to address RS485 I/O issues
;86 //
;87 //  2009-03-26 - Mark Davis
;88 //               - Added placeholder unlink and rename functions
;89 //
;90 //  2009-03-24 - Mark Davis
;91 //               - added _SerialEntry_() function for getting info about se
;92 //                 driver fds
;93 //
;94 //  2006-04-26 - Mark Davis
;95 //               - started first version
;96 //
;97 //-------------------------------------------------------------------------
;98 //  To-Do:
;99 //
;100 //   - This module currently relies on the sleep wait queue for blocking
;101 //     operations.  It would be more efficient if it provided real wait que
;102 //     of its own.
;103 //
;104 //-------------------------------------------------------------------------
;105 
;106 
;107 /*-------------------------------------------------------------------------
;108 ************  Notes on Softools Rabbit serial lib code  **********
;109 
;110 Code located at:
;111     C:\Program Files\Softools WinIDE\Rabbit 1.70\Rabbit runtime\Rabbit seri
;112 
;113 
;114 PORT/DEVICE INDEPENDENT FUNCTIONS:
;115 
;116 ============
;117  serialIO.c
;118 ============
;119   _SerialPutc() - puts char in to device's xmit queue
;120 
;121   _SerialGetc() - removes char from device's rcv queue
;122 
;123 =============
;124  serialInt.c
;125 =============
;126   _serialIsr() - called for a rcv interrupt (when not using xon/xoff)
;127                - put rcvd char in to device's rcv queue
;128 
;129   _isrSendCommon() - called for an xmit interrupt
;130                - remove char from device's queue and xmit it
;131 
;132 ================
;133  serialIntXon.c
;134 ================
;135   _serialIsrXon() - called for a rcv interrupt (when using xon/xoff)
;136                   - put rcvd char in to device's rcv queue
;137                   - enables/disables xmit for Xon/Xoff chars
;138                   - xmits Xon/Xoff based on rcv queue space
;139 
;140 
;141 PORT-SPECIFIC FUNCTIONS
;142 
;143   ("A" specifies port 0, "B" port 1, ...)
;144 
;145 ==============
;146  serialAcom.c
;147 ==============
;148   SerialInitAcom() - initialization not related to Xon/Xoff mode
;149   + all the other funcs for using port A, all independent of Xoff/Xoff mode
;150 
;151 ===========
;152  serialA.c
;153 ===========
;154   SerialInitA() - initialization for port A without Xon/Xoff support
;155 
;156 
;157 ==============
;158  serialAxon.c
;159 ==============
;160   SerialInitAxon() - initialization for port A with Xon/Xoff xupport
;161 
;162 =================
;163  serialArtsCts.c
;164 =================
;165   SerialInitCtsRtsA() - set RTS/CTS flow control parameters
;166 
;167 ==============
;168  SerialA485.c
;169 ==============
;170   void  SerialInit485D(char myAddr, char use9thBit, void (*enableFunc)(int)
;171   int SerialStart485txD(char addr, int store)
;172   void SerialEnd485txD(void)
;173   void SerialEnd485rxD(void)
;174 
;175 
;176 
;177 
;178 ---------------------------------------------------------------------------
;179 
;180 // SerialInitAxon
;181 
;182 #include <serial.h>  // to get "Rabbit runtime\Rabbit serial\serial.h"
	.debug	I 'C:\program files (x86)\softools winide\rabbit 1.70\rabbit runtime\rabbit serial\serial.h' 8 53 0 2 3 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I
;183 
;184 #include <common.h>
;185 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;186 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;187 #include <fcntl.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;188 #include <sys/stat.h>
;189 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;190 #include <errno.h>
;191 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I
;192 #include <sys/serial.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;193 #include <sys/spi.h>
;194 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\spi.h' 12 54 10 3 8 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
	.debug	I
;195 #include <Rabbit.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
;196 #include <dcdefs.h>
;197 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
;198 #include <sys/farprintf.h>
;199 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;200 
;201 extern _serialDevice  __serialA;
;202 extern _serialDevice  __serialB;
;203 extern _serialDevice  __serialC;
;204 extern _serialDevice  __serialD;
;205 
;206 
;207 
;208 SerialInfo  serPort[NumSerialPorts];
;209 
;210 //--- modes allowed for each port ---
;211 static uchar   serModes[NumSerialPorts] = {
;212   #if (_CPU_ID_ >= R3000)
;213     SER_RS232 | SER_SPI,
	.dseg
_serModes:
	.db	0x5
;214     SER_RS232 | SER_SPI,
	.db	0x5
;215     SER_RS232 | SER_SPI,
	.db	0x5
;216     SER_RS232 | SER_SPI | SER_RS485
;217 #else
;223 };
	.db	0x7
	.debug	F _serModes 32 0
;224 
;225 
;226 IODEV_FUNCS(serial)
	.defseg	CONST
	.seg	CONST
_serialIOFuncs::
	.dw	word __serialRead_
	.dw	word __serialWrite_
	.dw	word __serialClose_
	.dw	word __serialLseek_
	.dw	word __serialFstat_
	.dw	word __serialioctl_
	.dw	word __serialDescr_
	.dw	word __serialGetQueues_
	.debug	G _serialIOFuncs 33 0
;227 IODEV_FUNCS(serial)
;228 FILESYS_FUNCS(serial)
_serialFSysFuncs::
	.dw	@1
	.dw	word _serialIOFuncs
	.dw	word __serialTick_
	.dw	word __serialEntry_
	.dw	word __serialOpen_
	.dw	word __serialUnlink_
	.dw	word __serialRename_
	.debug	G _serialFSysFuncs 34 0
;229 FILESYS_FUNCS(serial)
;230 extern IODevFuncs  spiIOFuncs;
;231 
;232 
;233 typedef  int (*GetCFunc)(void);
;234 typedef  int (*PutCFunc)(int ch);
;235 
;236 
;237 
;238 //--------- near functions to call lib's far funcs --------
;239 
;240 #define  NearInitFunc(PORT)  
;241   char _nearcall SerInit##PORT(serialRate rate, int mode, int ip,  
;242            char *rcvBuf, int rcvSize, char *xmitBuf, int xmitSize, int flow
;243 {  
;244   if (flow == SER_XON_XOFF)  {  
;245     printf("*** xon init ***\r\n");  
;246     return  
;247        SerialInit##PORT##xon(rate, mode, ip, 
;248                         rcvBuf, rcvSize,  rcvSize*7/8, rcvSize/8,  
;249                         xmitBuf, xmitSize);  
;250   }  
;251   
;252   return  
;253        SerialInit##PORT(rate, mode, ip, rcvBuf, rcvSize, xmitBuf, xmitSize)
;254 }
;255 NearInitFunc(A)
	.defseg	FARCODE
	.seg	FARCODE
	.align	4
$$SerInitA::
	ex	(sp),iy
$SerInitA::
	.debug	G $SerInitA 35 9
	.debug	{ $SerInitA 35 255 @4 @3
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A rate 5 9
	.debug	A mode 9 6
	.debug	A ip 11 6
	.debug	A rcvBuf 13 36
	.debug	A rcvSize 15 6
	.debug	A xmitBuf 17 36
	.debug	A xmitSize 19 6
	.debug	A flow 21 6
	.debug	# 255
	ld	hl,(ix+21)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@5
@6:
	.debug	< @6 @7
	ld	de,word (phys @8)
	ld	c,phys @8 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(ix+19)
	push	hl
	ld	hl,(ix+17)
	push	hl
	ld	hl,(ix+15)
	ld	b,3
@9:
	sra	h
	rr	l
	djnz	@9
	push	hl
	ld	hl,(ix+15)
	ld	bc,0x7
	ex	de,hl
	mul
	ld	a,0x3
	ld	de,bc
	ex	de,hl
	call	__ishr##
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$SerialInitAxon
	add	sp,20
	jr	@3
@7:
	.debug	>
@5:
	ld	hl,(ix+19)
	push	hl
	ld	hl,(ix+17)
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$SerialInitA
	add	sp,16
@3:
	.debug	} @3 255

@2	equ	0
	pop	ix
	lret
@4	equ	2
;256 arInitFunc(B)
	.align	4
$$SerInitB::
	ex	(sp),iy
$SerInitB::
	.debug	G $SerInitB 35 9
	.debug	{ $SerInitB 35 256 @12 @11
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A rate 5 9
	.debug	A mode 9 6
	.debug	A ip 11 6
	.debug	A rcvBuf 13 36
	.debug	A rcvSize 15 6
	.debug	A xmitBuf 17 36
	.debug	A xmitSize 19 6
	.debug	A flow 21 6
	.debug	# 256
	ld	hl,(ix+21)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@13
@14:
	.debug	< @14 @15
	ld	de,word (phys @8)
	ld	c,phys @8 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(ix+19)
	push	hl
	ld	hl,(ix+17)
	push	hl
	ld	hl,(ix+15)
	ld	b,3
@16:
	sra	h
	rr	l
	djnz	@16
	push	hl
	ld	hl,(ix+15)
	ld	bc,0x7
	ex	de,hl
	mul
	ld	a,0x3
	ld	de,bc
	ex	de,hl
	call	__ishr##
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$SerialInitBxon
	add	sp,20
	jr	@11
@15:
	.debug	>
@13:
	ld	hl,(ix+19)
	push	hl
	ld	hl,(ix+17)
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$SerialInitB
	add	sp,16
@11:
	.debug	} @11 256

@10	equ	0
	pop	ix
	lret
@12	equ	2
;257 arInitFunc(C)
	.align	4
$$SerInitC::
	ex	(sp),iy
$SerInitC::
	.debug	G $SerInitC 35 9
	.debug	{ $SerInitC 35 257 @19 @18
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A rate 5 9
	.debug	A mode 9 6
	.debug	A ip 11 6
	.debug	A rcvBuf 13 36
	.debug	A rcvSize 15 6
	.debug	A xmitBuf 17 36
	.debug	A xmitSize 19 6
	.debug	A flow 21 6
	.debug	# 257
	ld	hl,(ix+21)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@20
@21:
	.debug	< @21 @22
	ld	de,word (phys @8)
	ld	c,phys @8 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(ix+19)
	push	hl
	ld	hl,(ix+17)
	push	hl
	ld	hl,(ix+15)
	ld	b,3
@23:
	sra	h
	rr	l
	djnz	@23
	push	hl
	ld	hl,(ix+15)
	ld	bc,0x7
	ex	de,hl
	mul
	ld	a,0x3
	ld	de,bc
	ex	de,hl
	call	__ishr##
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$SerialInitCxon
	add	sp,20
	jr	@18
@22:
	.debug	>
@20:
	ld	hl,(ix+19)
	push	hl
	ld	hl,(ix+17)
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$SerialInitC
	add	sp,16
@18:
	.debug	} @18 257

@17	equ	0
	pop	ix
	lret
@19	equ	2
;258 arInitFunc(D)
	.align	4
$$SerInitD::
	ex	(sp),iy
$SerInitD::
	.debug	G $SerInitD 35 9
	.debug	{ $SerInitD 35 258 @26 @25
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A rate 5 9
	.debug	A mode 9 6
	.debug	A ip 11 6
	.debug	A rcvBuf 13 36
	.debug	A rcvSize 15 6
	.debug	A xmitBuf 17 36
	.debug	A xmitSize 19 6
	.debug	A flow 21 6
	.debug	# 258
	ld	hl,(ix+21)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@27
@28:
	.debug	< @28 @29
	ld	de,word (phys @8)
	ld	c,phys @8 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(ix+19)
	push	hl
	ld	hl,(ix+17)
	push	hl
	ld	hl,(ix+15)
	ld	b,3
@30:
	sra	h
	rr	l
	djnz	@30
	push	hl
	ld	hl,(ix+15)
	ld	bc,0x7
	ex	de,hl
	mul
	ld	a,0x3
	ld	de,bc
	ex	de,hl
	call	__ishr##
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$SerialInitDxon
	add	sp,20
	jr	@25
@29:
	.debug	>
@27:
	ld	hl,(ix+19)
	push	hl
	ld	hl,(ix+17)
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$SerialInitD
	add	sp,16
@25:
	.debug	} @25 258

@24	equ	0
	pop	ix
	lret
@26	equ	2
;259 arInitFunc(D)
;260 
;261 #define  NearSetPktModeFunc(PORT)  
;262   void _nearcall SerSetPktMode##PORT(  
;263        char startCh, char use9thBit, void (*enableFunc)(int) )  
;264   {  SerialInit485##PORT(startCh, use9thBit, enableFunc); }
;265 NearSetPktModeFunc(A)
	.align	4
$$SerSetPktModeA::
	ex	(sp),iy
$SerSetPktModeA::
	.debug	G $SerSetPktModeA 37 9
	.debug	{ $SerSetPktModeA 37 265 @33 @32
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A startCh 5 3
	.debug	A use9thBit 7 3
	.debug	A enableFunc 9 38
	.debug	# 265
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$SerialInit485A
	add	sp,6
@32:
	.debug	} @32 265

@31	equ	0
	pop	ix
	lret
@33	equ	2
;266 arSetPktModeFunc(B)
	.align	4
$$SerSetPktModeB::
	ex	(sp),iy
$SerSetPktModeB::
	.debug	G $SerSetPktModeB 37 9
	.debug	{ $SerSetPktModeB 37 266 @36 @35
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A startCh 5 3
	.debug	A use9thBit 7 3
	.debug	A enableFunc 9 38
	.debug	# 266
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$SerialInit485B
	add	sp,6
@35:
	.debug	} @35 266

@34	equ	0
	pop	ix
	lret
@36	equ	2
;267 arSetPktModeFunc(C)
	.align	4
$$SerSetPktModeC::
	ex	(sp),iy
$SerSetPktModeC::
	.debug	G $SerSetPktModeC 37 9
	.debug	{ $SerSetPktModeC 37 267 @39 @38
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A startCh 5 3
	.debug	A use9thBit 7 3
	.debug	A enableFunc 9 38
	.debug	# 267
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$SerialInit485C
	add	sp,6
@38:
	.debug	} @38 267

@37	equ	0
	pop	ix
	lret
@39	equ	2
;268 arSetPktModeFunc(D)
	.align	4
$$SerSetPktModeD::
	ex	(sp),iy
$SerSetPktModeD::
	.debug	G $SerSetPktModeD 37 9
	.debug	{ $SerSetPktModeD 37 268 @42 @41
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A startCh 5 3
	.debug	A use9thBit 7 3
	.debug	A enableFunc 9 38
	.debug	# 268
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$SerialInit485D
	add	sp,6
@41:
	.debug	} @41 268

@40	equ	0
	pop	ix
	lret
@42	equ	2
;269 arSetPktModeFunc(D)
;270 #define  NearEndPktRXFunc(PORT)  
;271    void _nearcall SerEndPktRX##PORT(void) { SerialEnd485rx##PORT(); }
;272 NearEndPktRXFunc(A)
	.align	4
$$SerEndPktRXA::
	ex	(sp),iy
$SerEndPktRXA::
	.debug	G $SerEndPktRXA 40 9
	.debug	{ $SerEndPktRXA 40 272 @45 @44
	.debug	# 272
	lcall	$SerialEnd485rxA
@44:
	.debug	} @44 272

@43	equ	0
	lret
@45	equ	0
;273 arEndPktRXFunc(B)
	.align	4
$$SerEndPktRXB::
	ex	(sp),iy
$SerEndPktRXB::
	.debug	G $SerEndPktRXB 40 9
	.debug	{ $SerEndPktRXB 40 273 @48 @47
	.debug	# 273
	lcall	$SerialEnd485rxB
@47:
	.debug	} @47 273

@46	equ	0
	lret
@48	equ	0
;274 arEndPktRXFunc(C)
	.align	4
$$SerEndPktRXC::
	ex	(sp),iy
$SerEndPktRXC::
	.debug	G $SerEndPktRXC 40 9
	.debug	{ $SerEndPktRXC 40 274 @51 @50
	.debug	# 274
	lcall	$SerialEnd485rxC
@50:
	.debug	} @50 274

@49	equ	0
	lret
@51	equ	0
;275 arEndPktRXFunc(D)
	.align	4
$$SerEndPktRXD::
	ex	(sp),iy
$SerEndPktRXD::
	.debug	G $SerEndPktRXD 40 9
	.debug	{ $SerEndPktRXD 40 275 @54 @53
	.debug	# 275
	lcall	$SerialEnd485rxD
@53:
	.debug	} @53 275

@52	equ	0
	lret
@54	equ	0
;276 arEndPktRXFunc(D)
;277 #define  NearStartPktTXFunc(PORT)  
;278   int _nearcall SetStartPktTX##PORT(char startCh, int store)  
;279   { return  SerialStart485tx##PORT(startCh, store);  }
;280 NearStartPktTXFunc(A)
	.align	4
$$SetStartPktTXA::
	ex	(sp),iy
$SetStartPktTXA::
	.debug	G $SetStartPktTXA 41 9
	.debug	{ $SetStartPktTXA 41 280 @57 @56
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A startCh 5 3
	.debug	A store 7 6
	.debug	# 280
	ld	hl,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$SerialStart485txA
	add	sp,4
@56:
	.debug	} @56 280

@55	equ	0
	pop	ix
	lret
@57	equ	2
;281 arStartPktTXFunc(B)
	.align	4
$$SetStartPktTXB::
	ex	(sp),iy
$SetStartPktTXB::
	.debug	G $SetStartPktTXB 41 9
	.debug	{ $SetStartPktTXB 41 281 @60 @59
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A startCh 5 3
	.debug	A store 7 6
	.debug	# 281
	ld	hl,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$SerialStart485txB
	add	sp,4
@59:
	.debug	} @59 281

@58	equ	0
	pop	ix
	lret
@60	equ	2
;282 arStartPktTXFunc(C)
	.align	4
$$SetStartPktTXC::
	ex	(sp),iy
$SetStartPktTXC::
	.debug	G $SetStartPktTXC 41 9
	.debug	{ $SetStartPktTXC 41 282 @63 @62
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A startCh 5 3
	.debug	A store 7 6
	.debug	# 282
	ld	hl,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$SerialStart485txC
	add	sp,4
@62:
	.debug	} @62 282

@61	equ	0
	pop	ix
	lret
@63	equ	2
;283 arStartPktTXFunc(D)
	.align	4
$$SetStartPktTXD::
	ex	(sp),iy
$SetStartPktTXD::
	.debug	G $SetStartPktTXD 41 9
	.debug	{ $SetStartPktTXD 41 283 @66 @65
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A startCh 5 3
	.debug	A store 7 6
	.debug	# 283
	ld	hl,(ix+7)
	push	hl
	bool	hl
	ld	l,(ix+5)
	push	hl
	lcall	$SerialStart485txD
	add	sp,4
@65:
	.debug	} @65 283

@64	equ	0
	pop	ix
	lret
@66	equ	2
;284 arStartPktTXFunc(D)
;285 #define  NearEndPktTXFunc(PORT)  
;286    void _nearcall SerEndPktTX##PORT(void) { SerialEnd485tx##PORT(); }
;287 NearEndPktTXFunc(A)
	.align	4
$$SerEndPktTXA::
	ex	(sp),iy
$SerEndPktTXA::
	.debug	G $SerEndPktTXA 40 9
	.debug	{ $SerEndPktTXA 40 287 @69 @68
	.debug	# 287
	lcall	$SerialEnd485txA
@68:
	.debug	} @68 287

@67	equ	0
	lret
@69	equ	0
;288 arEndPktTXFunc(B)
	.align	4
$$SerEndPktTXB::
	ex	(sp),iy
$SerEndPktTXB::
	.debug	G $SerEndPktTXB 40 9
	.debug	{ $SerEndPktTXB 40 288 @72 @71
	.debug	# 288
	lcall	$SerialEnd485txB
@71:
	.debug	} @71 288

@70	equ	0
	lret
@72	equ	0
;289 arEndPktTXFunc(C)
	.align	4
$$SerEndPktTXC::
	ex	(sp),iy
$SerEndPktTXC::
	.debug	G $SerEndPktTXC 40 9
	.debug	{ $SerEndPktTXC 40 289 @75 @74
	.debug	# 289
	lcall	$SerialEnd485txC
@74:
	.debug	} @74 289

@73	equ	0
	lret
@75	equ	0
;290 arEndPktTXFunc(D)
	.align	4
$$SerEndPktTXD::
	ex	(sp),iy
$SerEndPktTXD::
	.debug	G $SerEndPktTXD 40 9
	.debug	{ $SerEndPktTXD 40 290 @78 @77
	.debug	# 290
	lcall	$SerialEnd485txD
@77:
	.debug	} @77 290

@76	equ	0
	lret
@78	equ	0
;291 arEndPktTXFunc(D)
;292 
;293 #define  NearSet7O1Func(PORT)  
;294    void _nearcall SerSet7O1##PORT(void) {  
;295      printf("set format to 7O1\r\n"); 
;296    SerialSetOddParity##PORT(); }
;297 NearSet7O1Func(A)
	.align	4
$$SerSet7O1A::
	ex	(sp),iy
$SerSet7O1A::
	.debug	G $SerSet7O1A 40 9
	.debug	{ $SerSet7O1A 40 297 @81 @80
	.debug	# 297
	ld	de,word (phys @8+19)
	ld	c,phys @8+19 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSetOddParityA
@80:
	.debug	} @80 297

@79	equ	0
	lret
@81	equ	0
;298 arSet7O1Func(B)
	.align	4
$$SerSet7O1B::
	ex	(sp),iy
$SerSet7O1B::
	.debug	G $SerSet7O1B 40 9
	.debug	{ $SerSet7O1B 40 298 @84 @83
	.debug	# 298
	ld	de,word (phys @8+19)
	ld	c,phys @8+19 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSetOddParityB
@83:
	.debug	} @83 298

@82	equ	0
	lret
@84	equ	0
;299 arSet7O1Func(C)
	.align	4
$$SerSet7O1C::
	ex	(sp),iy
$SerSet7O1C::
	.debug	G $SerSet7O1C 40 9
	.debug	{ $SerSet7O1C 40 299 @87 @86
	.debug	# 299
	ld	de,word (phys @8+19)
	ld	c,phys @8+19 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSetOddParityC
@86:
	.debug	} @86 299

@85	equ	0
	lret
@87	equ	0
;300 arSet7O1Func(D)
	.align	4
$$SerSet7O1D::
	ex	(sp),iy
$SerSet7O1D::
	.debug	G $SerSet7O1D 40 9
	.debug	{ $SerSet7O1D 40 300 @90 @89
	.debug	# 300
	ld	de,word (phys @8+19)
	ld	c,phys @8+19 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSetOddParityD
@89:
	.debug	} @89 300

@88	equ	0
	lret
@90	equ	0
;301 arSet7O1Func(D)
;302 #define  NearSet7E1Func(PORT)  
;303    void _nearcall SerSet7E1##PORT(void) {  
;304      printf("set format to 7E1\r\n");  
;305    SerialSetEvenParity##PORT(); }
;306 NearSet7E1Func(A)
	.align	4
$$SerSet7E1A::
	ex	(sp),iy
$SerSet7E1A::
	.debug	G $SerSet7E1A 40 9
	.debug	{ $SerSet7E1A 40 306 @93 @92
	.debug	# 306
	ld	de,word (phys @8+39)
	ld	c,phys @8+39 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSetEvenParityA
@92:
	.debug	} @92 306

@91	equ	0
	lret
@93	equ	0
;307 arSet7E1Func(B)
	.align	4
$$SerSet7E1B::
	ex	(sp),iy
$SerSet7E1B::
	.debug	G $SerSet7E1B 40 9
	.debug	{ $SerSet7E1B 40 307 @96 @95
	.debug	# 307
	ld	de,word (phys @8+39)
	ld	c,phys @8+39 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSetEvenParityB
@95:
	.debug	} @95 307

@94	equ	0
	lret
@96	equ	0
;308 arSet7E1Func(C)
	.align	4
$$SerSet7E1C::
	ex	(sp),iy
$SerSet7E1C::
	.debug	G $SerSet7E1C 40 9
	.debug	{ $SerSet7E1C 40 308 @99 @98
	.debug	# 308
	ld	de,word (phys @8+39)
	ld	c,phys @8+39 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSetEvenParityC
@98:
	.debug	} @98 308

@97	equ	0
	lret
@99	equ	0
;309 arSet7E1Func(D)
	.align	4
$$SerSet7E1D::
	ex	(sp),iy
$SerSet7E1D::
	.debug	G $SerSet7E1D 40 9
	.debug	{ $SerSet7E1D 40 309 @102 @101
	.debug	# 309
	ld	de,word (phys @8+39)
	ld	c,phys @8+39 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSetEvenParityD
@101:
	.debug	} @101 309

@100	equ	0
	lret
@102	equ	0
;310 arSet7E1Func(D)
;311 #define  NearSet8O1Func(PORT)  
;312    void _nearcall SerSet8O1##PORT(void) {  
;313      printf("set format to 8O1\r\n");  
;314    SerialSet8OddParity##PORT(); }
;315 NearSet8O1Func(A)
	.align	4
$$SerSet8O1A::
	ex	(sp),iy
$SerSet8O1A::
	.debug	G $SerSet8O1A 40 9
	.debug	{ $SerSet8O1A 40 315 @105 @104
	.debug	# 315
	ld	de,word (phys @8+59)
	ld	c,phys @8+59 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSet8OddParityA
@104:
	.debug	} @104 315

@103	equ	0
	lret
@105	equ	0
;316 arSet8O1Func(B)
	.align	4
$$SerSet8O1B::
	ex	(sp),iy
$SerSet8O1B::
	.debug	G $SerSet8O1B 40 9
	.debug	{ $SerSet8O1B 40 316 @108 @107
	.debug	# 316
	ld	de,word (phys @8+59)
	ld	c,phys @8+59 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSet8OddParityB
@107:
	.debug	} @107 316

@106	equ	0
	lret
@108	equ	0
;317 arSet8O1Func(C)
	.align	4
$$SerSet8O1C::
	ex	(sp),iy
$SerSet8O1C::
	.debug	G $SerSet8O1C 40 9
	.debug	{ $SerSet8O1C 40 317 @111 @110
	.debug	# 317
	ld	de,word (phys @8+59)
	ld	c,phys @8+59 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSet8OddParityC
@110:
	.debug	} @110 317

@109	equ	0
	lret
@111	equ	0
;318 arSet8O1Func(D)
	.align	4
$$SerSet8O1D::
	ex	(sp),iy
$SerSet8O1D::
	.debug	G $SerSet8O1D 40 9
	.debug	{ $SerSet8O1D 40 318 @114 @113
	.debug	# 318
	ld	de,word (phys @8+59)
	ld	c,phys @8+59 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSet8OddParityD
@113:
	.debug	} @113 318

@112	equ	0
	lret
@114	equ	0
;319 arSet8O1Func(D)
;320 #define  NearSet8E1Func(PORT)  
;321    void _nearcall SerSet8E1##PORT(void) {  
;322      printf("set format to 8E1\r\n");  
;323    SerialSet8EvenParity##PORT(); }
;324 NearSet8E1Func(A)
	.align	4
$$SerSet8E1A::
	ex	(sp),iy
$SerSet8E1A::
	.debug	G $SerSet8E1A 40 9
	.debug	{ $SerSet8E1A 40 324 @117 @116
	.debug	# 324
	ld	de,word (phys @8+79)
	ld	c,phys @8+79 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSet8EvenParityA
@116:
	.debug	} @116 324

@115	equ	0
	lret
@117	equ	0
;325 arSet8E1Func(B)
	.align	4
$$SerSet8E1B::
	ex	(sp),iy
$SerSet8E1B::
	.debug	G $SerSet8E1B 40 9
	.debug	{ $SerSet8E1B 40 325 @120 @119
	.debug	# 325
	ld	de,word (phys @8+79)
	ld	c,phys @8+79 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSet8EvenParityB
@119:
	.debug	} @119 325

@118	equ	0
	lret
@120	equ	0
;326 arSet8E1Func(C)
	.align	4
$$SerSet8E1C::
	ex	(sp),iy
$SerSet8E1C::
	.debug	G $SerSet8E1C 40 9
	.debug	{ $SerSet8E1C 40 326 @123 @122
	.debug	# 326
	ld	de,word (phys @8+79)
	ld	c,phys @8+79 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSet8EvenParityC
@122:
	.debug	} @122 326

@121	equ	0
	lret
@123	equ	0
;327 arSet8E1Func(D)
	.align	4
$$SerSet8E1D::
	ex	(sp),iy
$SerSet8E1D::
	.debug	G $SerSet8E1D 40 9
	.debug	{ $SerSet8E1D 40 327 @126 @125
	.debug	# 327
	ld	de,word (phys @8+79)
	ld	c,phys @8+79 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$SerialSet8EvenParityD
@125:
	.debug	} @125 327

@124	equ	0
	lret
@126	equ	0
;328 arSet8E1Func(D)
;329 //--- defined in the hdw-platform-specific arch modules ---
;330 void _nearcall SerSetDirA(int enableXmit);
;331 void _nearcall SerSetDirB(int enableXmit);
;332 void _nearcall SerSetDirC(int enableXmit);
;333 void _nearcall SerSetDirD(int enableXmit);
;334 
;335 
;336 #define  NearXmitBufUsedFunc(PORT)  
;337   uint _nearcall XmitBufUsed##PORT(void)  
;338   { return  SerialSendCount##PORT();  }
;339 NearXmitBufUsedFunc(A)
	.align	4
$$XmitBufUsedA::
	ex	(sp),iy
$XmitBufUsedA::
	.debug	G $XmitBufUsedA 42 9
	.debug	{ $XmitBufUsedA 42 339 @129 @128
	.debug	# 339
	lcall	$SerialSendCountA
@128:
	.debug	} @128 339

@127	equ	0
	lret
@129	equ	0
;340 arXmitBufUsedFunc(B)
	.align	4
$$XmitBufUsedB::
	ex	(sp),iy
$XmitBufUsedB::
	.debug	G $XmitBufUsedB 42 9
	.debug	{ $XmitBufUsedB 42 340 @132 @131
	.debug	# 340
	lcall	$SerialSendCountB
@131:
	.debug	} @131 340

@130	equ	0
	lret
@132	equ	0
;341 arXmitBufUsedFunc(C)
	.align	4
$$XmitBufUsedC::
	ex	(sp),iy
$XmitBufUsedC::
	.debug	G $XmitBufUsedC 42 9
	.debug	{ $XmitBufUsedC 42 341 @135 @134
	.debug	# 341
	lcall	$SerialSendCountC
@134:
	.debug	} @134 341

@133	equ	0
	lret
@135	equ	0
;342 arXmitBufUsedFunc(D)
	.align	4
$$XmitBufUsedD::
	ex	(sp),iy
$XmitBufUsedD::
	.debug	G $XmitBufUsedD 42 9
	.debug	{ $XmitBufUsedD 42 342 @138 @137
	.debug	# 342
	lcall	$SerialSendCountD
@137:
	.debug	} @137 342

@136	equ	0
	lret
@138	equ	0
;343 arXmitBufUsedFunc(D)
;344 #define  NearFlushXmitFunc(PORT)  
;345   void _nearcall FlushXmit##PORT(void)  
;346   { SerialSendFlush##PORT();  }
;347 NearFlushXmitFunc(A)
	.align	4
$$FlushXmitA::
	ex	(sp),iy
$FlushXmitA::
	.debug	G $FlushXmitA 40 9
	.debug	{ $FlushXmitA 40 347 @141 @140
	.debug	# 347
	lcall	$SerialSendFlushA
@140:
	.debug	} @140 347

@139	equ	0
	lret
@141	equ	0
;348 arFlushXmitFunc(B)
	.align	4
$$FlushXmitB::
	ex	(sp),iy
$FlushXmitB::
	.debug	G $FlushXmitB 40 9
	.debug	{ $FlushXmitB 40 348 @144 @143
	.debug	# 348
	lcall	$SerialSendFlushB
@143:
	.debug	} @143 348

@142	equ	0
	lret
@144	equ	0
;349 arFlushXmitFunc(C)
	.align	4
$$FlushXmitC::
	ex	(sp),iy
$FlushXmitC::
	.debug	G $FlushXmitC 40 9
	.debug	{ $FlushXmitC 40 349 @147 @146
	.debug	# 349
	lcall	$SerialSendFlushC
@146:
	.debug	} @146 349

@145	equ	0
	lret
@147	equ	0
;350 arFlushXmitFunc(D)
	.align	4
$$FlushXmitD::
	ex	(sp),iy
$FlushXmitD::
	.debug	G $FlushXmitD 40 9
	.debug	{ $FlushXmitD 40 350 @150 @149
	.debug	# 350
	lcall	$SerialSendFlushD
@149:
	.debug	} @149 350

@148	equ	0
	lret
@150	equ	0
;351 arFlushXmitFunc(D)
;352 
;353 #define  NearRcvAvailFunc(PORT)  
;354   uint _nearcall RcvAvail##PORT(void)  
;355   { return  SerialRecvCount##PORT();  }
;356 NearRcvAvailFunc(A)
	.align	4
$$RcvAvailA::
	ex	(sp),iy
$RcvAvailA::
	.debug	G $RcvAvailA 42 9
	.debug	{ $RcvAvailA 42 356 @153 @152
	.debug	# 356
	lcall	$SerialRecvCountA
@152:
	.debug	} @152 356

@151	equ	0
	lret
@153	equ	0
;357 arRcvAvailFunc(B)
	.align	4
$$RcvAvailB::
	ex	(sp),iy
$RcvAvailB::
	.debug	G $RcvAvailB 42 9
	.debug	{ $RcvAvailB 42 357 @156 @155
	.debug	# 357
	lcall	$SerialRecvCountB
@155:
	.debug	} @155 357

@154	equ	0
	lret
@156	equ	0
;358 arRcvAvailFunc(C)
	.align	4
$$RcvAvailC::
	ex	(sp),iy
$RcvAvailC::
	.debug	G $RcvAvailC 42 9
	.debug	{ $RcvAvailC 42 358 @159 @158
	.debug	# 358
	lcall	$SerialRecvCountC
@158:
	.debug	} @158 358

@157	equ	0
	lret
@159	equ	0
;359 arRcvAvailFunc(D)
	.align	4
$$RcvAvailD::
	ex	(sp),iy
$RcvAvailD::
	.debug	G $RcvAvailD 42 9
	.debug	{ $RcvAvailD 42 359 @162 @161
	.debug	# 359
	lcall	$SerialRecvCountD
@161:
	.debug	} @161 359

@160	equ	0
	lret
@162	equ	0
;360 arRcvAvailFunc(D)
;361 #define  NearFlushRcvFunc(PORT)  
;362   void _nearcall FlushRcv##PORT(void)  
;363   { SerialRecvFlush##PORT();  }
;364 NearFlushRcvFunc(A)
	.align	4
$$FlushRcvA::
	ex	(sp),iy
$FlushRcvA::
	.debug	G $FlushRcvA 40 9
	.debug	{ $FlushRcvA 40 364 @165 @164
	.debug	# 364
	lcall	$SerialRecvFlushA
@164:
	.debug	} @164 364

@163	equ	0
	lret
@165	equ	0
;365 arFlushRcvFunc(B)
	.align	4
$$FlushRcvB::
	ex	(sp),iy
$FlushRcvB::
	.debug	G $FlushRcvB 40 9
	.debug	{ $FlushRcvB 40 365 @168 @167
	.debug	# 365
	lcall	$SerialRecvFlushB
@167:
	.debug	} @167 365

@166	equ	0
	lret
@168	equ	0
;366 arFlushRcvFunc(C)
	.align	4
$$FlushRcvC::
	ex	(sp),iy
$FlushRcvC::
	.debug	G $FlushRcvC 40 9
	.debug	{ $FlushRcvC 40 366 @171 @170
	.debug	# 366
	lcall	$SerialRecvFlushC
@170:
	.debug	} @170 366

@169	equ	0
	lret
@171	equ	0
;367 arFlushRcvFunc(D)
	.align	4
$$FlushRcvD::
	ex	(sp),iy
$FlushRcvD::
	.debug	G $FlushRcvD 40 9
	.debug	{ $FlushRcvD 40 367 @174 @173
	.debug	# 367
	lcall	$SerialRecvFlushD
@173:
	.debug	} @173 367

@172	equ	0
	lret
@174	equ	0
;368 arFlushRcvFunc(D)
;369 
;370 
;371 typedef struct  {
;372   char (*init)( serialRate rate, int mode, int ip,
;373                 char *recvBuffer, int recvSize,
;374                 char *tranBuffer, int tranSize, int flowCtl );
;375   int  (*getc)(void);
;376   int  (*putc)(int ch);
;377   void (*set7O1)(void);
;378   void (*set7E1)(void);
;379   void (*set8O1)(void);
;380   void (*set8E1)(void);
;381   void (*setPktMode)(char startCh, char use9thBit, void (*_enableFunc)(int)
;382   void (*setDir)(int);  // non-zero ==> xmit mode, 0 ==> rcv mode
;383   void (*endPktRX)(void);
;384   int  (*startPktTX)(char startCh, int store);
;385   void (*endPktTX)(void);
;386   uint (*xmitBufUsed)(void);
;387   void (*flushXmit)(void);
;388   uint (*rcvAvail)(void);
;389   void (*flushRcv)(void);
;390 } SerialFuncs;
;391 
;392 
;393 #define  SER_FUNCS(port)  {  
;394     SerInit##port, SerialGetc##port, SerialPutc##port,  
;395     SerSet7O1##port, SerSet7E1##port, SerSet8O1##port, SerSet8E1##port, 
;396     SerSetPktMode##port, SerSetDir##port, SerEndPktRX##port,  
;397     SetStartPktTX##port, SerEndPktTX##port,  
;398     XmitBufUsed##port, FlushXmit##port, RcvAvail##port, FlushRcv##port  
;399 }
;400 
;401 SerialFuncs  serFuncs[NumSerialPorts] =
;402 { SER_FUNCS(A), SER_FUNCS(B), SER_FUNCS(C), SER_FUNCS(D) };
	.dseg
_serFuncs::
	.dw	word _SerInitA
	.dw	word _SerialGetcA
	.dw	word _SerialPutcA
	.dw	word _SerSet7O1A
	.dw	word _SerSet7E1A
	.dw	word _SerSet8O1A
	.dw	word _SerSet8E1A
	.dw	word _SerSetPktModeA
	.dw	word _SerSetDirA
	.dw	word _SerEndPktRXA
	.dw	word _SetStartPktTXA
	.dw	word _SerEndPktTXA
	.dw	word _XmitBufUsedA
	.dw	word _FlushXmitA
	.dw	word _RcvAvailA
	.dw	word _FlushRcvA
	.dw	word _SerInitB
	.dw	word _SerialGetcB
	.dw	word _SerialPutcB
	.dw	word _SerSet7O1B
	.dw	word _SerSet7E1B
	.dw	word _SerSet8O1B
	.dw	word _SerSet8E1B
	.dw	word _SerSetPktModeB
	.dw	word _SerSetDirB
	.dw	word _SerEndPktRXB
	.dw	word _SetStartPktTXB
	.dw	word _SerEndPktTXB
	.dw	word _XmitBufUsedB
	.dw	word _FlushXmitB
	.dw	word _RcvAvailB
	.dw	word _FlushRcvB
	.dw	word _SerInitC
	.dw	word _SerialGetcC
	.dw	word _SerialPutcC
	.dw	word _SerSet7O1C
	.dw	word _SerSet7E1C
	.dw	word _SerSet8O1C
	.dw	word _SerSet8E1C
	.dw	word _SerSetPktModeC
	.dw	word _SerSetDirC
	.dw	word _SerEndPktRXC
	.dw	word _SetStartPktTXC
	.dw	word _SerEndPktTXC
	.dw	word _XmitBufUsedC
	.dw	word _FlushXmitC
	.dw	word _RcvAvailC
	.dw	word _FlushRcvC
	.dw	word _SerInitD
	.dw	word _SerialGetcD
	.dw	word _SerialPutcD
	.dw	word _SerSet7O1D
	.dw	word _SerSet7E1D
	.dw	word _SerSet8O1D
	.dw	word _SerSet8E1D
	.dw	word _SerSetPktModeD
	.dw	word _SerSetDirD
	.dw	word _SerEndPktRXD
	.dw	word _SetStartPktTXD
	.dw	word _SerEndPktTXD
	.dw	word _XmitBufUsedD
	.dw	word _FlushXmitD
	.dw	word _RcvAvailD
	.dw	word _FlushRcvD
	.debug	G _serFuncs 43 0
;403 
;404 serialPort serPortRef[] = { SER_A, SER_B, SER_C, SER_D };
_serPortRef::
	.db	0xc0
	.db	0xd0
	.db	0xe0
	.db	0xf0
	.debug	G _serPortRef 45 0
;405 
;406 
;407 #define SerOutBufSize  256
;408 #define SerInBufSize   512
;409 
;410 char serInBufs[NumSerialPorts][SerInBufSize],
;411      serOutBufs[NumSerialPorts][SerOutBufSize];
;412 
;413 
;414 #define SER   ((SerialInfo *)ioDev)
;415 #define SDEV  ((_serialDevice *)(SER->sDev))
;416 
;417 
;418 //-------------------------------------------------------------------------
;419 //  func called once by init process to initialize data structures
;420 //-------------------------------------------------------------------------
;421 void serialInit_()
;422 {
	.seg	FARCODE
$serialInit_::
	.debug	G $serialInit_ 47 9
	.debug	{ $serialInit_ 47 421 @177 @176
;423 //  uchar  i;
;424 
;425 
;426   BZERO(serPort);
	.debug	# 426
	ld	hl,0x60
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_serPort
	push	hl
	call	_memset
	add	sp,6
;427 
;428   serPort[0].sDev = &__serialA;
	.debug	# 428
	ld	hl,___serialA
	ld	(_serPort+2),hl
;429   serPort[1].sDev = &__serialB;
	.debug	# 429
	ld	hl,___serialB
	ld	(_serPort+26),hl
;430   serPort[2].sDev = &__serialC;
	.debug	# 430
	ld	hl,___serialC
	ld	(_serPort+50),hl
;431   serPort[3].sDev = &__serialD;
	.debug	# 431
	ld	hl,___serialD
	ld	(_serPort+74),hl
;432 
;433 /*
;434   for (i=0; i<NumSerialPorts; ++i)  {
;435     InitList(serPort[i].wrBlocked, blockedList);
;436     InitList(serPort[i].rdBlocked, blockedList);
;437   }
;438 */
;439 
;440   spiInUse = false;
	.debug	# 440
	xor	a,a
	ld	(_spiInUse),a
;441 
;442 //  serialFSysFuncs.tick = NULL;
;443 
;444   registerFileSys(&serialFSysFuncs);
	.debug	# 444
	ld	hl,_serialFSysFuncs
	push	hl
	lcall	$registerFileSys
	pop	de
;445 }
@176:
	.debug	} @176 445

@175	equ	0
	lret
@177	equ	0
;446 
;447 
;448 //-------------------------------------------------------------------------
;449 //  Returns true if provided pointer is a valid, in-use Serial device.
;450 //  Returns false if is not.
;451 //-------------------------------------------------------------------------
;452 bool  validSER(void *ioDev)
;453 {
$validSER::
	.debug	G $validSER 48 9
	.debug	{ $validSER 48 452 @180 @179
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 49
;454   if (ioDev)
	.debug	# 454
	ld	hl,(ix+5)
	bool	hl
	jr	z,@181
;455     if (SER == serPort + (int)(SER - serPort))
	.debug	# 455
	ld	hl,(ix+5)
	ld	de,_serPort
	or	a,a
	sbc	hl,de
	ld	de,0x18
	call	__idiv##
	ld	bc,0x18
	ex	de,hl
	mul
	ld	hl,_serPort
	add	hl,bc
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@182
;456       if (SER->inUse)  return true;
	.debug	# 456
	ld	h,d
	ld	l,e
	ld	a,(hl)
	or	a,a
	jr	z,@183
	ld	a,0x1
	jr	@179
;457 
;458   return false;
@183:
@182:
@181:
	.debug	# 458
	xor	a,a
;459 }
@179:
	.debug	} @179 459

@178	equ	0
	pop	ix
	lret
@180	equ	2
;460 
;461 //-------------------------------------------------------------------------
;462 //  Wait for the serial console buffer to empty.
;463 //
;464 //  NOTE this is called at startup before the timer interrupt is started so
;465 //  we can't use things like GetMS() or time() yet.  Also, it temporarily
;466 //  changes the IP register to ensure chars in the buffer CAN be sent, so
;467 //  do NOT call it at times when interrupts must be disabled!
;468 //-------------------------------------------------------------------------
;469 void flushConsole(void)
;470 {
$flushConsole::
	.debug	G $flushConsole 40 9
	.debug	{ $flushConsole 40 469 @186 @185
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
;471   int  charsLeft, lastCharsLeft, noProgressCount = 0;
	.debug	L charsLeft -2 6
	.debug	L lastCharsLeft -4 6
	.debug	L noProgressCount -6 6
	.debug	# 471
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	.seg	FARCODE
;472 
;473   WDT_2S();  charsLeft = lastCharsLeft = SerialSendCountA();
	.debug	# 473
  ld  a,0x5A
  ioi ld  (0x08),a
	lcall	$SerialSendCountA
	ld	(ix-4),hl
	ld	(ix-2),hl
;474 
;475   ipset1();
	.debug	# 475
	ipset	1
;476 
;477   while (charsLeft)  {
@187:
	.debug	# 477
	ld	hl,(ix-2)
	bool	hl
	jr	z,@188
;478     if (charsLeft == lastCharsLeft)
@189:
	.debug	< @189 @190
	.debug	# 478
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@191
;479       ++noProgressCount;
	.debug	# 479
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
;480     else  {
	jr	@192
@191:
;481       lastCharsLeft = charsLeft;  noProgressCount = 0;  }
@193:
	.debug	< @193 @194
	.debug	# 481
	ld	hl,(ix-2)
	ld	(ix-4),hl
	bool	hl
	ld	l,h
	ld	(ix-6),hl
@194:
	.debug	>
;482     if (noProgressCount > 2000)  {
@192:
	.debug	# 482
	ld	hl,(ix-6)
	ld	de,0x87d0
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@195
	jr	z,@195
;483       printf("flushConsole() failed\r\n");  break;  }
@196:
	.debug	< @196 @197
	.debug	# 483
	ld	de,word (phys @8+99)
	ld	c,phys @8+99 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jr	@188
@197:
	.debug	>
;484     charsLeft = SerialSendCountA();
@195:
	.debug	# 484
	lcall	$SerialSendCountA
	ld	(ix-2),hl
;485   }
@190:
	.debug	>
;486 
;487   ipres();
	jr	@187
@188:
	.debug	# 487
	ipres
;488 
;489 }
@185:
	.debug	} @185 489

@184	equ	6
	ld	sp,ix
	pop	ix
	lret
@186	equ	8
;490 
;491 //-------------------------------------------------------------------------
;492 void initConsole(void)
;493 {
$initConsole::
	.debug	G $initConsole 40 9
	.debug	{ $initConsole 40 492 @200 @199
;494   SerialInitA( BR_115200, SER_8BITS, SER_IP2,
;495                serInBufs[0], SerInBufSize,
;496                serOutBufs[0], SerOutBufSize );
	.debug	# 496
	ld	hl,0x100
	push	hl
	ld	hl,_serOutBufs
	push	hl
	ld	hl,0x200
	push	hl
	ld	hl,_serInBufs
	push	hl
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	de,0xc200
	ld	bc,0x1
	push	bc
	push	de
	lcall	$SerialInitA
	add	sp,16
;497   _stdio = SerialA;                        //  redirect printf to SerialA
	.debug	# 497
	ld	hl,_SerialA
	ld	(__stdio),hl
;498 
;499   printf("\r\n\n\n\n\n\n\n\n");  flushConsole();
	.debug	# 499
	ld	de,word (phys @8+123)
	ld	c,phys @8+123 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$flushConsole
;500 }
@199:
	.debug	} @199 500

@198	equ	0
	lret
@200	equ	0
;501 
;502 //-------------------------------------------------------------------------
;503 //  check for file name indicating a serial port and attempt to open it
;504 //-------------------------------------------------------------------------
;505 fd_t _serialOpen_(const char *path, int flags, int mode)
;506 {
	.align	4
$$_serialOpen_::
	ex	(sp),iy
$_serialOpen_::
	.debug	G $_serialOpen_ 50 9
	.debug	{ $_serialOpen_ 50 505 @203 @202
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A path 5 36
	.debug	A flags 7 6
	.debug	A mode 9 6
;507   char  *name;
	.debug	L name -2 36
;508 
;509   if (strncmp(path, "/dev/", 5))  { errno = ENXIO;  return -1; }
	.debug	# 509
	ld	hl,0x5
	push	hl
	ld	hl,@1+7
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_strncmp
	add	sp,6
	bool	hl
	jr	z,@204
@205:
	.debug	< @205 @206
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x6
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@202
@206:
	.debug	>
;510 
;511   name = (char *)path + 5;
@204:
	.debug	# 511
	ld	hl,(ix+5)
	ld	de,0x5
	add	hl,de
	ld	(ix-2),hl
;512 
;513   if (strncmp(name, "ttyx", 4) == 0)
	.debug	# 513
	ld	hl,0x4
	push	hl
	ld	hl,@1+13
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strncmp
	add	sp,6
	bool	hl
	jr	nz,@207
;514     return  _serial_(atoi(name+4), 0, SER_RS232, SER_XON_XOFF);
	.debug	# 514
	ld	l,0x1
	push	hl
	push	hl
	ld	l,h
	push	hl
	ld	l,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ld	de,0x4
	add	hl,de
	jr	@383
;515 
;516   if (strncmp(name, "tty", 3) == 0)
@207:
	.debug	# 516
	ld	hl,0x3
	push	hl
	ld	hl,@1+18
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strncmp
	add	sp,6
	bool	hl
	jr	nz,@208
;517     return  _serial_(atoi(name+3), 0, SER_RS232, SER_NO_FLOW);
	.debug	# 517
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	l,0xa
	jr	@382
;518 
;519   if (strncmp(name, "spi", 3) == 0)
@208:
	.debug	# 519
	ld	hl,0x3
	push	hl
	ld	hl,@1+22
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strncmp
	add	sp,6
	bool	hl
	jr	nz,@209
;520     return  _serial_(atoi(name+3), 0, SER_SPI, SER_NO_FLOW);
	.debug	# 520
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x4
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	l,0xa
@382:
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	inc	hl
	inc	hl
	inc	hl
@383:
	push	hl
	lcall	$strtoi
	add	sp,6
	push	hl
	lcall	$_serial_
	add	sp,8
	jr	@202
;521 
;522   errno = ENXIO;  return -1;
@209:
	.debug	# 522
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x6
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
;523 }
@202:
	.debug	} @202 523

@201	equ	2
	ld	sp,ix
	pop	ix
	lret
@203	equ	4
;524 
;525 //-------------------------------------------------------------------------
;526 //  func called each kernel tick to provide file system with CPU cycles
;527 //  Should ONLY be called by the kernel task!
;528 //-------------------------------------------------------------------------
;529 void _serialTick_(void)
;530 {
	.align	4
$$_serialTick_::
	ex	(sp),iy
$_serialTick_::
	.debug	G $_serialTick_ 40 9
	.debug	{ $_serialTick_ 40 529 @212 @211
;531 
;532 }
@211:
	.debug	} @211 532

@210	equ	0
	lret
@212	equ	0
;533 
;534 //-------------------------------------------------------------------------
;535 //  Return the state of the specified ioDev entry or NULL if not a valid
;536 //  entry #.
;537 //
;538 //  For valid entrys, the entryState struct is filled in
;539 //-------------------------------------------------------------------------
;540 void *_serialEntry_(uint idx, EntryState *entryState)
;541 {
	.align	4
$$_serialEntry_::
	ex	(sp),iy
$_serialEntry_::
	.debug	G $_serialEntry_ 51 9
	.debug	{ $_serialEntry_ 51 540 @215 @214
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A idx 5 7
	.debug	A entryState 7 52
;542   SerialInfo  *serDev;
	.debug	L serDev -2 54
;543 
;544   if (idx >= NumSerialPorts)  return NULL;
	.debug	# 544
	ld	hl,(ix+5)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	c,@216
	bool	hl
	ld	l,h
	jr	@214
;545 
;546   serDev = serPort + idx;
@216:
	.debug	# 546
	ld	hl,(ix+5)
	ld	bc,0x18
	ex	de,hl
	mul
	ld	hl,_serPort
	add	hl,bc
	ld	(ix-2),hl
;547 
;548   entryState->openCount = (serDev->inUse ? 1 : 0);
	.debug	# 548
	ld	a,(hl)
	or	a,a
	jr	z,@217
	ld	hl,0x1
	jr	@218
@217:
	bool	hl
	ld	l,h
@218:
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;549   entryState->unused = (entryState->openCount == 0);
	.debug	# 549
	ld	hl,(ix+7)
	ld	hl,(hl)
	bool	hl
	ld	l,h
	jr	nz,@219
	inc	l
@219:
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	(hl),e
;550 
;551   return serDev;
	.debug	# 551
	ld	hl,(ix-2)
;552 }
@214:
	.debug	} @214 552

@213	equ	2
	ld	sp,ix
	pop	ix
	lret
@215	equ	4
;553 
;554 //-------------------------------------------------------------------------
;555 //  Placeholder, do-nothing unlink function
;556 //
;557 //  To be called ONLY by fcntl functions
;558 //-------------------------------------------------------------------------
;559 int _serialUnlink_(char *path)
;560 {
	.align	4
$$_serialUnlink_::
	ex	(sp),iy
$_serialUnlink_::
	.debug	G $_serialUnlink_ 56 9
	.debug	{ $_serialUnlink_ 56 559 @222 @221
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A path 5 36
;561   return -1;
	.debug	# 561
	ld	hl,0xffff
;562 }
@221:
	.debug	} @221 562

@220	equ	0
	pop	ix
	lret
@222	equ	2
;563 
;564 
;565 //-------------------------------------------------------------------------
;566 //  Placeholder, do-nothing rename function
;567 //
;568 //  To be called ONLY by fcntl functions
;569 //-------------------------------------------------------------------------
;570 int _serialRename_(const char *oldPath, const char *newPath)
;571 {
	.align	4
$$_serialRename_::
	ex	(sp),iy
$_serialRename_::
	.debug	G $_serialRename_ 57 9
	.debug	{ $_serialRename_ 57 570 @225 @224
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A oldPath 5 36
	.debug	A newPath 7 36
;572   return -1;
	.debug	# 572
	ld	hl,0xffff
;573 }
@224:
	.debug	} @224 573

@223	equ	0
	pop	ix
	lret
@225	equ	2
;574 
;575 
;576 
;577 //-------------------------------------------------------------------------
;578 //  Kernel-space function to initialize a serial port and return a file
;579 //  descriptor for it
;580 //-------------------------------------------------------------------------
;581 fd_t _serial_(uchar port, uchar rateIdx, uchar mode, uchar flowCtl)
;582 {
$_serial_::
	.debug	G $_serial_ 58 9
	.debug	{ $_serial_ 58 581 @228 @227
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A port 5 3
	.debug	A rateIdx 7 3
	.debug	A mode 9 3
	.debug	A flowCtl 11 3
;583   int  stat, hdwMode;
	.debug	L stat -2 6
	.debug	L hdwMode -4 6
;584   fd_t  fd;
	.debug	L fd -6 6
;585   SerialInfo  *si;
	.debug	L si -8 54
;586 
;587 
;588   if (port >= NumSerialPorts)  { ERRNO = ENOENT;  return -1; }
	.debug	# 588
	ld	a,(ix+5)
	sub	a,4
	jr	c,@229
@230:
	.debug	< @230 @231
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	jr	@381
@231:
	.debug	>
;589   if (! (mode & serModes[port]))  { ERRNO = ENOENT;  return -1; }
@229:
	.debug	# 589
	bool	hl
	ld	l,(ix+5)
	ld	de,_serModes
	add	hl,de
	ld	a,(hl)
	ld	hl,(ix+9)
	and	a,l
	jr	nz,@232
@233:
	.debug	< @233 @234
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
@381:
	ld	e,0x2
	jp	@380
@234:
	.debug	>
;590 
;591   KLOCK();
@232:
	.debug	# 591
	call	_KLOCK
;592 
;593   if (serPort[port].inUse)  { KUNLOCK();  ERRNO = EBUSY;  return -1; }
	.debug	# 593
	ld	a,(ix+5)
	bool	hl
	ld	l,a
	ld	bc,0x18
	ex	de,hl
	mul
	ld	hl,_serPort
	add	hl,bc
	ld	a,(hl)
	or	a,a
	jr	z,@235
@236:
	.debug	< @236 @237
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x10
	jp	@380
@237:
	.debug	>
;594 
;595 //--- initialize the specified serial port ---
;596   si = serPort + port;
@235:
	.debug	# 596
	ld	a,(ix+5)
	bool	hl
	ld	l,a
	ld	bc,0x18
	ex	de,hl
	mul
	ld	hl,_serPort
	add	hl,bc
	ld	(ix-8),hl
;597 
;598   si->mode = mode;
	.debug	# 598
	ld	e,0x4
	add	hl,de
	ld	a,(ix+9)
	ld	(hl),a
;599   si->port = port;
	.debug	# 599
	ld	hl,(ix-8)
	inc	hl
	ld	a,(ix+5)
	ld	(hl),a
;600   si->flowCtl = flowCtl;
	.debug	# 600
	ld	hl,(ix-8)
	inc	e
	add	hl,de
	ld	a,(ix+11)
	ld	(hl),a
;601   si->closed = si->pktMode = false;
	.debug	# 601
	ld	hl,(ix-8)
	ld	e,0x7
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-8)
	dec	e
	add	hl,de
	ld	(hl),a
;602   si->inUse = true;  // needs to be true during rest of init
	.debug	# 602
	ld	hl,(ix-8)
	ld	a,0x1
	ld	(hl),a
;603 
;604   switch (mode)  {
	.debug	# 604
	ld	a,(ix+9)
	jp	@238
;605     case SER_RS232:
@240:
	.debug	< @240 @241
;606     case SER_RS485:
	.debug	# 606
@242:
;607       si->baudRate = 115200UL;  //finish
	.debug	# 607
@243:
	ld	hl,(ix-8)
	ld	de,0x8
	add	hl,de
	ld	de,0xc200
	ld	bc,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;608       if (port == 0)
	.debug	# 608
	ld	a,(ix+5)
	or	a,a
	jr	nz,@244
;609         stat = 1;
	.debug	# 609
	ld	h,b
	ld	l,c
	ld	(ix-2),hl
;610       else  {
	jr	@245
@244:
;611         hdwMode = SER_8BITS;
@246:
	.debug	< @246 @247
	.debug	# 611
	bool	hl
	ld	l,h
	ld	(ix-4),hl
;612         if ((hdwType == HT_BL2105) AND (port == 1))  hdwMode |= SER_USE_D;
	.debug	# 612
	ld	hl,(_hdwType)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@249
	ld	a,(ix+5)
	sub	a,1
	jr	nz,@249
	ld	hl,(ix-4)
	set	4,l
	ld	(ix-4),hl
;613         stat =  (serFuncs[port].init)(si->baudRate, hdwMode, SER_IP2,
@249:
;614                                       serInBufs[port], SerInBufSize,
;615                                       serOutBufs[port], SerOutBufSize, flow
	.debug	# 615
	bool	hl
	ld	l,(ix+11)
	push	hl
	ld	hl,0x100
	push	hl
	bool	hl
	ld	h,(ix+5)
	ld	l,0
	ld	de,_serOutBufs
	add	hl,de
	push	hl
	ld	hl,0x200
	push	hl
	bool	hl
	ld	h,(ix+5)
	ld	l,0
	add	hl,hl
	ld	de,_serInBufs
	add	hl,de
	push	hl
	ld	hl,0x2
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-8)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	a,(ix+5)
	bool	hl
	ld	l,a
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_serFuncs
	add	hl,de
	ld	hl,(hl)
	pop	de
	call	__callhl##
	add	sp,18
	bool	hl
	ld	l,a
	ld	(ix-2),hl
;616       }
@247:
	.debug	>
;617       if (! stat)  {
@245:
	.debug	# 617
	ld	hl,(ix-2)
	bool	hl
	jr	nz,@250
;618         si->inUse = false;  KUNLOCK();  ERRNO = EINVAL;  return -1; }
@251:
	.debug	< @251 @252
	.debug	# 618
	ld	hl,(ix-8)
	xor	a,a
	ld	(hl),a
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	jr	@380
@252:
	.debug	>
;619       if ((fd = _allocFile_(3, &serialIOFuncs, si)) < 0)  {
@250:
	.debug	# 619
	ld	hl,(ix-8)
	push	hl
	ld	hl,_serialIOFuncs
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$_allocFile_
	add	sp,6
	ld	(ix-6),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@239
;620         si->inUse = false;  KUNLOCK();  return -1;  }
@254:
	.debug	< @254 @255
	.debug	# 620
	jr	@379
@255:
	.debug	>
;621       break;
	.debug	# 621
;622 
;623     case SER_SPI:
;624       //finish - use rateIdx?
;625       if (! _spiInit_(si, CLK_1MHz, NORM_LOW_LATCH_RISE))  {
	.debug	# 625
@256:
	bool	hl
	ld	l,h
	push	hl
	ld	l,0xa
	push	hl
	ld	hl,(ix-8)
	push	hl
	lcall	$_spiInit_
	add	sp,6
	or	a,a
	jr	nz,@257
;626         si->inUse = false;  KUNLOCK();  ERRNO = EINVAL;  return -1; }
@258:
	.debug	< @258 @259
	.debug	# 626
	ld	hl,(ix-8)
	xor	a,a
	ld	(hl),a
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
@380:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@378
@259:
	.debug	>
;627       if ((fd = _allocFile_(3, &spiIOFuncs, si)) < 0)  {
@257:
	.debug	# 627
	ld	hl,(ix-8)
	push	hl
	ld	hl,_spiIOFuncs
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$_allocFile_
	add	sp,6
	ld	(ix-6),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@239
;628         si->inUse = false;  KUNLOCK();  return -1;  }
@261:
	.debug	< @261 @262
	.debug	# 628
@379:
@262:
	.debug	>
;629       break;
	.debug	# 629
;630 
;631     default:
;632       si->inUse = false;  KUNLOCK();  return -1;
	.debug	# 632
@263:
	ld	hl,(ix-8)
	xor	a,a
	ld	(hl),a
	call	_KUNLOCK
@378:
	ld	hl,0xffff
	jr	@227
;633   }
@241:
	.debug	>
;634 
;635   KUNLOCK();
@238:
	cp	0x1
	jp	z,@242
	cp	0x2
	jp	z,@243
	cp	0x4
	jr	z,@256
	jr	@263
@239:
	.debug	# 635
	call	_KUNLOCK
;636 
;637 //--- everything OK - return the descriptor assigned for this process ---
;638   return fd;
	.debug	# 638
	ld	hl,(ix-6)
;639 }
@227:
	.debug	} @227 639

@226	equ	8
	ld	sp,ix
	pop	ix
	lret
@228	equ	10
;640 
;641 
;642 //=========================================================================
;643 //  IODev interface functions (for use by fcntl module)
;644 //=========================================================================
;645 
;646 //-------------------------------------------------------------------------
;647 int _serialGetQueues_(void *ioDev, WaitQueues far *queues)
;648 {
	.align	4
$$_serialGetQueues_::
	ex	(sp),iy
$_serialGetQueues_::
	.debug	G $_serialGetQueues_ 59 9
	.debug	{ $_serialGetQueues_ 59 647 @266 @265
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 49
	.debug	A queues 7 60
;649   queues->readQueue = queues->writeQueue = &sleepQueue;
	.debug	# 649
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,_sleepQueue
	call	__farst2##
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__farst2##
;650   return 0;
	.debug	# 650
	bool	hl
	ld	l,h
;651 }
@265:
	.debug	} @265 651

@264	equ	0
	pop	ix
	lret
@266	equ	2
;652 
;653 //-------------------------------------------------------------------------
;654 //  Attempt to read bytes from a serial port
;655 //
;656 //  Should only be called from the fcntl.c/read() function!
;657 //
;658 //  RETURN VALUEs:
;659 //  - if bytes read: # of bytes read
;660 //  - if no bytes read:
;661 //    - if more possible in the future: -1 and ERRNO == EAGAIN
;662 //    - if no more possible (EOF):  0
;663 //-------------------------------------------------------------------------
;664 int _serialRead_(void *ioDev, char *buf, int numBytes, bool dontBlock)
;665 {
	.align	4
$$_serialRead_::
	ex	(sp),iy
$_serialRead_::
	.debug	G $_serialRead_ 62 9
	.debug	{ $_serialRead_ 62 664 @269 @268
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A ioDev 5 49
	.debug	A buf 7 36
	.debug	A numBytes 9 6
	.debug	A dontBlock 11 3
;666   int  i, ch;
	.debug	L i -2 6
	.debug	L ch -4 6
;667   char  *ptr;
	.debug	L ptr -6 36
;668   GetCFunc  getcFunc;
	.debug	L getcFunc -8 63
;669 
;670 
;671   KLOCK();
	.debug	# 671
	call	_KLOCK
;672 
;673   if (! validSER(ioDev))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 673
	ld	hl,(ix+5)
	push	hl
	lcall	$validSER
	pop	hl
	or	a,a
	jr	nz,@270
@271:
	.debug	< @271 @272
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jr	@377
@272:
	.debug	>
;674 
;675   if (SER->closed)  { KUNLOCK();  ERRNO = EPIPE;  return -1; }
@270:
	.debug	# 675
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@273
@274:
	.debug	< @274 @275
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x20
	jr	@377
@275:
	.debug	>
;676 
;677   getcFunc = SDEV->serialGetc;  ptr = buf;
@273:
	.debug	# 677
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	de,0x28
	add	hl,de
	ld	hl,(hl)
	ld	(ix-8),hl
	ld	hl,(ix+7)
	ld	(ix-6),hl
;678 
;679   for (i=0; i<numBytes; )  {
@276:
	.debug	< @276 @277
	.debug	# 679
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@278:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__icmp##
	jr	nc,@279
;680     ch = (*getcFunc)();  if (ch == -1)  break;
@280:
	.debug	< @280 @281
	.debug	# 680
	ld	hl,(ix-8)
	call	__callhl##
	ld	(ix-4),hl
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	z,@279
;681     *ptr++ = (uchar) ch;  ++i;
	.debug	# 681
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	dec	hl
	ld	a,(ix-4)
	ld	(hl),a
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
;682     if (_pending)  break;
	.debug	# 682
	ld	a,(__pending)
	or	a,a
	jr	z,@278
;683   }
@281:
	.debug	>
;684 
;685   KUNLOCK();
@279:
@277:
	.debug	>
	.debug	# 685
	call	_KUNLOCK
;686 
;687   if (!i)  { ERRNO = EAGAIN;  return -1; }
	.debug	# 687
	ld	hl,(ix-2)
	bool	hl
	jr	nz,@284
@285:
	.debug	< @285 @286
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
@377:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@268
@286:
	.debug	>
;688 
;689   return i;
@284:
	.debug	# 689
	ld	hl,(ix-2)
;690 }
@268:
	.debug	} @268 690

@267	equ	8
	ld	sp,ix
	pop	ix
	lret
@269	equ	10
;691 
;692 //-------------------------------------------------------------------------
;693 //  Attempt to write bytes to serial port
;694 //
;695 //  Should only be called from the fcntl.c/write() function!
;696 //
;697 //  RETURN VALUEs:
;698 //  - if bytes written: # of bytes written
;699 //  - if no bytes written:
;700 //    - if more possible in the future: -1 and ERRNO == EAGAIN
;701 //    - if no more possible (EOF):  0
;702 //-------------------------------------------------------------------------
;703 int _serialWrite_(void *ioDev, const char *buf, int numBytes, bool dontBloc
;704 {
	.align	4
$$_serialWrite_::
	ex	(sp),iy
$_serialWrite_::
	.debug	G $_serialWrite_ 62 9
	.debug	{ $_serialWrite_ 62 703 @289 @288
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-7
	.debug	A ioDev 5 49
	.debug	A buf 7 36
	.debug	A numBytes 9 6
	.debug	A dontBlock 11 3
;705   int  i;
	.debug	L i -2 6
;706   bool  pktMode;
	.debug	L pktMode -3 3
;707   const char  *ptr;
	.debug	L ptr -5 36
;708   PutCFunc  putcFunc;
	.debug	L putcFunc -7 65
;709 
;710 
;711   KLOCK();
	.debug	# 711
	call	_KLOCK
;712 
;713   if (! validSER(ioDev))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 713
	ld	hl,(ix+5)
	push	hl
	lcall	$validSER
	pop	hl
	or	a,a
	jr	nz,@290
@291:
	.debug	< @291 @292
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jp	@376
@292:
	.debug	>
;714 
;715   if (SER->closed)  { KUNLOCK();  ERRNO = EPIPE;  return -1; }
@290:
	.debug	# 715
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@293
@294:
	.debug	< @294 @295
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x20
	jr	@376
@295:
	.debug	>
;716 
;717   putcFunc = SDEV->serialPutc;  ptr = buf;  pktMode = SER->pktMode;
@293:
	.debug	# 717
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	de,0x2a
	add	hl,de
	ld	hl,(hl)
	ld	(ix-7),hl
	ld	hl,(ix+7)
	ld	(ix-5),hl
	ld	hl,(ix+5)
	ld	e,0x7
	add	hl,de
	ld	a,(hl)
	ld	(ix-3),a
;718 
;719   for (i=0; i<numBytes; )  {
@296:
	.debug	< @296 @297
	.debug	# 719
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@298:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__icmp##
	jr	nc,@299
;720     if (((*putcFunc)(*ptr++)) < 0)  break;
@300:
	.debug	< @300 @301
	.debug	# 720
	ld	hl,(ix-5)
	inc	hl
	ld	(ix-5),hl
	dec	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ex	de,hl
	ld	hl,(ix-7)
	ex	de,hl
	call	__callde##
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@299
;721     ++i;
	.debug	# 721
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
;722     if (_pending AND !pktMode) break;
	.debug	# 722
	ld	a,(__pending)
	or	a,a
	jr	z,@298
	ld	a,(ix-3)
	or	a,a
	jr	nz,@298
;723   }
@301:
	.debug	>
;724 
;725   KUNLOCK();
@299:
@297:
	.debug	>
	.debug	# 725
	call	_KUNLOCK
;726 
;727   if (!i)  { ERRNO = EAGAIN;  return -1; }
	.debug	# 727
	ld	hl,(ix-2)
	bool	hl
	jr	nz,@305
@306:
	.debug	< @306 @307
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
@376:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@288
@307:
	.debug	>
;728 
;729   return i;
@305:
	.debug	# 729
	ld	hl,(ix-2)
;730 }
@288:
	.debug	} @288 730

@287	equ	7
	ld	sp,ix
	pop	ix
	lret
@289	equ	9
;731 
;732 
;733 //-------------------------------------------------------------------------
;734 //  release a serial port for use by another process
;735 //-------------------------------------------------------------------------
;736 int _serialClose_(void *ioDev)
;737 {
	.align	4
$$_serialClose_::
	ex	(sp),iy
$_serialClose_::
	.debug	G $_serialClose_ 67 9
	.debug	{ $_serialClose_ 67 736 @310 @309
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 49
;738   KLOCK();
	.debug	# 738
	call	_KLOCK
;739 
;740   if (! validSER(ioDev))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 740
	ld	hl,(ix+5)
	push	hl
	lcall	$validSER
	pop	hl
	or	a,a
	jr	nz,@311
@312:
	.debug	< @312 @313
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jr	@375
@313:
	.debug	>
;741 
;742   if (SER->closed)  { KUNLOCK();  ERRNO = EPIPE;  return -1; }
@311:
	.debug	# 742
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@314
@315:
	.debug	< @315 @316
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x20
@375:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@309
@316:
	.debug	>
;743 
;744   SER->inUse = false;
@314:
	.debug	# 744
	ld	hl,(ix+5)
	xor	a,a
	ld	(hl),a
;745 
;746   KUNLOCK();
	.debug	# 746
	call	_KUNLOCK
;747 
;748   return 0;
	.debug	# 748
	bool	hl
	ld	l,h
;749 }
@309:
	.debug	} @309 749

@308	equ	0
	pop	ix
	lret
@310	equ	2
;750 
;751 //-------------------------------------------------------------------------
;752 //  Kernel-space function to reposition a file offset
;753 //
;754 //  WARNING!  To be called ONLY by KERNELFUNC functions (or functions calle
;755 //            KERNELFUNC functions) !!!!
;756 //-------------------------------------------------------------------------
;757 off_t  _serialLseek_(void *ioDev, off_t offset, int whence)
;758 {
	.align	4
$$_serialLseek_::
	ex	(sp),iy
$_serialLseek_::
	.debug	G $_serialLseek_ 68 9
	.debug	{ $_serialLseek_ 68 757 @319 @318
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 49
	.debug	A offset 7 9
	.debug	A whence 11 6
;759   KLOCK();
	.debug	# 759
	call	_KLOCK
;760 
;761   if (! validSER(ioDev))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 761
	ld	hl,(ix+5)
	push	hl
	lcall	$validSER
	pop	hl
	or	a,a
	jr	nz,@320
@321:
	.debug	< @321 @322
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	de,0xffff
	ld	c,e
	ld	b,e
	jr	@318
@322:
	.debug	>
;762 
;763   KUNLOCK();
@320:
	.debug	# 763
	call	_KUNLOCK
;764 
;765   ERRNO = ESPIPE;  return (off_t)-1;
	.debug	# 765
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x1d
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	de,0xffff
	ld	c,e
	ld	b,e
;766 }
@318:
	.debug	} @318 766

@317	equ	0
	pop	ix
	lret
@319	equ	2
;767 
;768 
;769 //-------------------------------------------------------------------------
;770 //  Get information about ...
;771 //-------------------------------------------------------------------------
;772 int  _serialFstat_(void *ioDev, struct stat *fsbuf)
;773 {
	.align	4
$$_serialFstat_::
	ex	(sp),iy
$_serialFstat_::
	.debug	G $_serialFstat_ 69 9
	.debug	{ $_serialFstat_ 69 772 @325 @324
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ioDev 5 49
	.debug	A fsbuf 7 70
;774   KLOCK();
	.debug	# 774
	call	_KLOCK
;775 
;776   if (! validSER(ioDev))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 776
	ld	hl,(ix+5)
	push	hl
	lcall	$validSER
	pop	hl
	or	a,a
	jr	nz,@326
@327:
	.debug	< @327 @328
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@324
@328:
	.debug	>
;777 
;778   fsbuf->st_mode = S_IFCHR | 00777;
@326:
	.debug	# 778
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ld	de,0x21ff
	ld	bc,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;779 
;780   KUNLOCK();
	.debug	# 780
	call	_KUNLOCK
;781 
;782   return 0;
	.debug	# 782
	bool	hl
	ld	l,h
;783 }
@324:
	.debug	} @324 783

@323	equ	0
	pop	ix
	lret
@325	equ	2
;784 
;785 extern void setExt485Tx(void);
;786 //-------------------------------------------------------------------------
;787 //  Kernel-space function to handle ioctl calls for serial ports.
;788 //
;789 //  Notes on Packet-mode interfaces:
;790 //
;791 //    The packet mode of operation provides a means to couple the control
;792 //    of the hardware interface for a serial bus (e.g. RS-485) to the timin
;793 //    of char transmission managed by the serial library.  This allows the
;794 //    serial library to meet the timing requirements of most serial
;795 //    interfaces.
;796 //
;797 //    This coupling is managed as follows:
;798 //
;799 //      - Set the packet mode for a serial connection (IOC_SET_PKTMODE).
;800 //        The argument given for this request is the char that signals the
;801 //        start of a received packet.  If non-zero, incoming data is ignore
;802 //        until the specified char is received.  If zero, all incoming data
;803 //        is saved.  For RS-485 connections, this character is often
;804 //        used to signify a node's "address".
;805 //
;806 //      - To transmit a packet, do the following:
;807 //          - Set IOC_START_PKT_TX mode
;808 //          - Write a packet of bytes to the device
;809 //          - Set IOC_END_PKT_TX mode
;810 //
;811 //      - To receive a packet, read characters from the device until an
;812 //        entire packet is received, a timeout or other error occurs, etc,
;813 //        and then set IOC_END_PKT_RX mode.
;814 //
;815 //    The purpose of the IOC_START_PKT_TX and IOC_END_PKT_TX modes are to
;816 //    get the serial lib to invoke a platform-specific callback function
;817 //    at the start and end of the transmission of the group of bytes that
;818 //    make up a packet.  The actual callback functions (one per port) are
;819 //    provided by the code for the specific hardware platform (the BSP, or
;820 //    Board Support Package, found under the "arch" branch).
;821 //
;822 //    If told to do so (using the above sequence), the serial lib ISR that
;823 //    handles transmitting characters will call the board-specific function
;824 //    just before transmitting the first character and just after sending
;825 //    the last character.  The function has one argument indicating if the
;826 //    interface should be set to xmit or rcv mode.
;827 //
;828 //    The callback function is usually (bot not always) called directly fro
;829 //    the ISR, so it must be fast, and it must save and restore any registe
;830 //    it uses.  Calling it from the ISR is what allows it to be called with
;831 //    very little latency (i.e. not so long before or after the bytes are
;832 //    transmitted that we risk losing data received).
;833 //
;834 //    Setting the IOC_END_PKT_RX mode for the device tells it that it shoul
;835 //    begin looking for the start of a new packet again.  If the start char
;836 //    given for packets was 0, this has no effect.  But for non-zero start
;837 //    characters, this allows the library to ignore received characters unt
;838 //    the start of a new packet, greatly reducing the number of CPU cycles 
;839 //    for incoming characters prior to the start char (i.e. the ISR doesn't
;840 //    have to save them in the queue, and the application code can simply
;841 //    block waiting for the next packet or an error, rather than having rea
;842 //    each character back out of the queue and check for the start characte
;843 //-------------------------------------------------------------------------
;844 int _serialioctl_(void *ioDev, int request, void *arg)
;845 {
	.align	4
$$_serialioctl_::
	ex	(sp),iy
$_serialioctl_::
	.debug	G $_serialioctl_ 72 9
	.debug	{ $_serialioctl_ 72 844 @331 @330
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A ioDev 5 49
	.debug	A request 7 6
	.debug	A arg 9 49
;846   int  stat;
	.debug	L stat -2 6
;847   uint  flowChars, used;
	.debug	L flowChars -4 7
	.debug	L used -6 7
;848   SerialFuncs  *funcs;
	.debug	L funcs -8 73
;849 
;850 #define CHAR_ARG   (*((char *)arg))
;851 #define INT_ARG    (*((int *)arg))
;852 #define UINT_ARG   (*((uint *)arg))
;853 #define ULONG_ARG  (*((ulong *)arg))
;854 
;855 
;856   KLOCK();
	.debug	# 856
	call	_KLOCK
;857 
;858   if (! validSER(ioDev))  { KUNLOCK();  ERRNO = EBADF;  return -1; }
	.debug	# 858
	ld	hl,(ix+5)
	push	hl
	lcall	$validSER
	pop	hl
	or	a,a
	jr	nz,@332
@333:
	.debug	< @333 @334
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@330
@334:
	.debug	>
;859 
;860   funcs = serFuncs + SER->port;  stat = -1;
@332:
	.debug	# 860
	ld	hl,(ix+5)
	inc	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_serFuncs
	add	hl,de
	ld	(ix-8),hl
	ld	hl,0xffff
	ld	(ix-2),hl
;861 
;862   switch (request)  {
	.debug	# 862
	ld	hl,(ix+7)
	jp	@335
;863 
;864     case FIONREAD:
@337:
	.debug	< @337 @338
;865       _EnterCritical_();  INT_ARG = (funcs->rcvAvail)();  _ExitCritical_();
	.debug	# 865
@339:
	ipset	2
	ld	hl,(ix-8)
	ld	de,0x1c
	add	hl,de
	ld	hl,(hl)
	call	__callhl##
	ex	de,hl
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
;866       stat = 0;  break;
	.debug	# 866
	jp	@372
;867 
;868     case FIONSPACE:  // return # of free bytes in the xmit buffer
;869       _EnterCritical_();  used = (funcs->xmitBufUsed)();  _ExitCritical_();
	.debug	# 869
@340:
	ipset	2
	ld	hl,(ix-8)
	ld	de,0x18
	add	hl,de
	ld	hl,(hl)
	call	__callhl##
	ld	(ix-6),hl
	ipres
;870       INT_ARG = SerOutBufSize - used;  stat = 0;  break;
	.debug	# 870
	ld	hl,0x100
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jp	@372
;871 
;872     case IOC_GET_BAUD:
;873       ULONG_ARG = SER->baudRate;   stat = 0;  break;
	.debug	# 873
@341:
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	jp	@372
;874 
;875     case IOC_SET_BAUD:
;876       SER->baudRate = ULONG_ARG;
	.debug	# 876
@342:
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+5)
	push	de
	ld	de,0x8
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;877       SerialSetRate(serPortRef[SER->port], SER->baudRate);
	.debug	# 877
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+5)
	inc	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	de,_serPortRef
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	lcall	$SerialSetRate
	add	sp,6
;878       stat = 0;  break;
	.debug	# 878
	jp	@372
;879 
;880   //--- Enable RS845 packet-mode on the port.  The argument is the 8-bit --
;881   //--- "address" that we want to receive packets for.  Incoming bytes are 
;882   //--- ignored until the specified char is received.  Once the specified -
;883   //--- char is received, the port enters receive mode and all subsequent -
;884   //--- bytes are saved in the input buffer until the application calls ---
;885   //--- ioctl() with the IOC_END_PKT_RX request ---
;886     case IOC_SET_PKTMODE:
;887       (funcs->setPktMode)(CHAR_ARG, 0, funcs->setDir);
	.debug	# 887
@343:
	ld	hl,(ix-8)
	ld	de,0x10
	add	hl,de
	ld	hl,(hl)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+9)
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	bc,hl
	ld	l,0xe
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,6
;888       SER->pktMode = true;  stat = 0;  break;
	.debug	# 888
	ld	hl,(ix+5)
	ld	de,0x7
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	jp	@372
;889 
;890   //--- Tells the serial port to stop saving bytes for the current packet. 
;891   //--- The application should read bytes as they come in looking for the -
;892   //--- end of a packet.  When it finds the end, or determines there is a -
;893   //--- problem with the packet, it should invoke this function to tell the
;894   //--- lib to stop saving bytes and go back to waiting for the char that -
;895   //--- signals the start of a new packet (our "address") ---
;896     case IOC_END_PKT_RX:
;897       (funcs->endPktRX)();  stat = 0;  break;
	.debug	# 897
@344:
	ld	hl,(ix-8)
	ld	de,0x12
	jr	@374
;898 
;899   //--- Prepare for the start of the transmission of a "packet".  This ---
;900   //--- tells the serial lib that, just before it transmits the next char, 
;901   //--- it must call the setDir() func given in the IOC_SET_PKTMODE request
;902   //--- to enable the hardware to xmit chars on the RS-485 bus.  This is --
;903   //--- done by the ISR that handles transmitting chars in a timely fashion
;904   //--- so the func must be fast and protect any registers it uses. ---
;905   //--- The
;906   //--- must do whatever is required to configure the hdw for xmit mode ---
;907     case IOC_START_PKT_TX:
;908       setExt485Tx();  // required to be here due to BL2105 I/O timing issue
	.debug	# 908
@345:
	lcall	$setExt485Tx
;909       (funcs->flushRcv)();
	.debug	# 909
	ld	hl,(ix-8)
	ld	de,0x1e
	add	hl,de
	ld	hl,(hl)
	call	__callhl##
;910       (funcs->startPktTX)(0,0);  stat = 0;  break;
	.debug	# 910
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x14
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	call	__callde##
	add	sp,4
	jp	@372
;911 
;912   //--- Tells the serial lib that, when the last byte of the current packet
;913   //--- has been transmitted, it should call the setDir() func given in ---
;914   //--- the IOC_SET_PKTMODE call (with a value of 0).  The called func is -
;915   //--- responsible for configuring the hdw so new packets can be rcvd ---
;916     case IOC_END_PKT_TX:
;917       (funcs->endPktTX)();  stat = 0;  break;
	.debug	# 917
@346:
	ld	hl,(ix-8)
	ld	de,0x16
@374:
	add	hl,de
	ld	hl,(hl)
	call	__callhl##
	jp	@372
;918 
;919     case IOC_SET_ASYNC_FMT:
;920       switch (UINT_ARG)  {
	.debug	# 920
@347:
	ld	hl,(ix+9)
	ld	hl,(hl)
	jr	@348
;921         case ASYNC_FMT_7O1:  (funcs->set7O1)();  stat = 0;  break;
@350:
	.debug	< @350 @351
	.debug	# 921
@352:
	ld	hl,(ix-8)
	ld	de,0x6
	jr	@373
;922         case ASYNC_FMT_7E1:  (funcs->set7E1)();  stat = 0;  break;
	.debug	# 922
@353:
	ld	hl,(ix-8)
	ld	de,0x8
	jr	@373
;923         case ASYNC_FMT_8O1:  (funcs->set8O1)();  stat = 0;  break;
	.debug	# 923
@354:
	ld	hl,(ix-8)
	ld	de,0xa
	jr	@373
;924         case ASYNC_FMT_8E1:  (funcs->set8E1)();  stat = 0;  break;
	.debug	# 924
@355:
	ld	hl,(ix-8)
	ld	de,0xc
@373:
	add	hl,de
	ld	hl,(hl)
	call	__callhl##
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;925       }
	jr	@349
@351:
	.debug	>
;926       break;
@348:
	ex	de,hl
	ld	hl,0xfffff8ef
	add	hl,de
	bool	hl
	jr	z,@352
	ld	hl,0xfffff8df
	add	hl,de
	bool	hl
	jr	z,@353
	ld	hl,0xfffff7ef
	add	hl,de
	bool	hl
	jr	z,@354
	ld	hl,0xfffff7df
	add	hl,de
	bool	hl
	jr	z,@355
@349:
	.debug	# 926
;927 
;928     case IOC_SET_FLOW_CHARS:
	jp	@336
;929       flowChars = (UINT_ARG);
	.debug	# 929
@356:
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(ix-4),hl
;930 printf("Before: XON: [%02X]  XOFF: [%02X]\r\n", SDEV->xOn, SDEV->xOff);  //
	.debug	# 930
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	de,0x33
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	dec	e
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @8+133)
	ld	c,phys @8+133 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;931       _EnterCritical_();
	.debug	# 931
	ipset	2
;932       SDEV->xOn = (uchar)(flowChars >> 8);
	.debug	# 932
	ld	hl,(ix-4)
	ld	l,h
	ld	h,0
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	ld	c,e
	ld	e,0x32
	add	hl,de
	ld	(hl),c
;933       SDEV->xOff = (uchar)flowChars;
	.debug	# 933
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	inc	e
	add	hl,de
	ld	a,(ix-4)
	ld	(hl),a
;934       _ExitCritical_();
	.debug	# 934
	ipres
;935 printf("After:  XON: [%02X]  XOFF: [%02X]\r\n", SDEV->xOn, SDEV->xOff);  //
	.debug	# 935
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	e,0x33
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	dec	e
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @8+169)
	ld	c,phys @8+169 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;936       stat = 0;  break;
	.debug	# 936
@372:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;937 
;938     default:
	jr	@336
;939       ERRNO = EINVAL;
	.debug	# 939
@357:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	ld	(hl),e
	inc	hl
	ld	(hl),d
;940   }
@338:
	.debug	>
;941 
;942   KUNLOCK();  return stat;
	jr	@336
@335:
	ex	de,hl
	ld	hl,0xfffffc17
	add	hl,de
	bool	hl
	jp	z,@341
	ld	hl,0xfffffc16
	add	hl,de
	bool	hl
	jp	z,@342
	ld	hl,0xfffffc15
	add	hl,de
	bool	hl
	jp	z,@343
	ld	hl,0xfffffc14
	add	hl,de
	bool	hl
	jp	z,@344
	ld	hl,0xfffffc13
	add	hl,de
	bool	hl
	jp	z,@345
	ld	hl,0xfffffc12
	add	hl,de
	bool	hl
	jp	z,@346
	ld	hl,0xfffffc11
	add	hl,de
	bool	hl
	jp	z,@347
	ld	hl,0xfffffc10
	add	hl,de
	bool	hl
	jp	z,@356
	ld	hl,0xffffabe5
	add	hl,de
	bool	hl
	jp	z,@339
	ld	hl,0xffffa000
	add	hl,de
	bool	hl
	jp	z,@340
	jr	@357
@336:
	.debug	# 942
	call	_KUNLOCK
	ld	hl,(ix-2)
;943 }
@330:
	.debug	} @330 943

@329	equ	8
	ld	sp,ix
	pop	ix
	lret
@331	equ	10
;944 
;945 
;946 //-------------------------------------------------------------------------
;947 //  Kernel-space function to return a description of the serial port
;948 //
;949 //  WARNING!  To be called ONLY by KERNELFUNC functions (or functions calle
;950 //            KERNELFUNC functions) !!!!
;951 //-------------------------------------------------------------------------
;952 char *_serialDescr_(void *ioDev, char *buf, int bufSize)
;953 {
	.align	4
$$_serialDescr_::
	ex	(sp),iy
$_serialDescr_::
	.debug	G $_serialDescr_ 74 9
	.debug	{ $_serialDescr_ 74 952 @360 @359
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ioDev 5 49
	.debug	A buf 7 36
	.debug	A bufSize 9 6
;954   char  *ptr, *suffix;
	.debug	L ptr -2 36
	.debug	L suffix -4 36
;955 
;956 
;957   sprintf(buf, "serial 0x%04lX ", (ulong)ioDev);
	.debug	# 957
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys @8+205)
	ld	c,phys @8+205 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
;958 
;959   ptr = buf + strlen(buf);  strcpy(ptr, "bad bad");
	.debug	# 959
	ld	hl,(ix+7)
	push	hl
	call	_strlen
	pop	de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	(ix-2),hl
	ld	hl,@1+26
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strcpy
	add	sp,4
;960 
;961 //finish: limit output to bufSize
;962 
;963   suffix = "";
	.debug	# 963
	ld	hl,@1+6
	ld	(ix-4),hl
;964   switch (SER->flowCtl)  {
	.debug	# 964
	ld	hl,(ix+5)
	ld	de,0x5
	add	hl,de
	ld	a,(hl)
	jr	@361
;965     case SER_XON_XOFF:  suffix = "x";  break;
@363:
	.debug	< @363 @364
	.debug	# 965
@365:
	ld	hl,@1+16
	jr	@371
;966     case SER_RTS_CTS:   suffix = "r";  break;
	.debug	# 966
@366:
	ld	hl,@1+34
@371:
	ld	(ix-4),hl
;967   }
	jr	@362
@364:
	.debug	>
;968 
;969   if (validSER(ioDev))
@361:
	cp	0x1
	jr	z,@365
	cp	0x2
	jr	z,@366
@362:
	.debug	# 969
	ld	hl,(ix+5)
	push	hl
	lcall	$validSER
	pop	hl
	or	a,a
	jr	z,@367
;970     sprintf(ptr, "ser[%d] /dev/tty%s%d %ld baud",
;971            (uint)(SER - serPort), suffix, SER->port, SER->baudRate);
	.debug	# 971
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+5)
	inc	hl
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+5)
	ld	de,_serPort
	or	a,a
	sbc	hl,de
	ld	de,0x18
	call	__idiv##
	push	hl
	ld	de,word (phys @8+221)
	ld	c,phys @8+221 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,18
;972 
;973   return buf;
@367:
	.debug	# 973
	ld	hl,(ix+7)
;974 }
@359:
	.debug	} @359 974

@358	equ	4
	ld	sp,ix
	pop	ix
	lret
@360	equ	6
;975 
;976 
;977 //-------------------------------------------------------------------------
;978 void _serialDumpObject_(uint port)
;979 {
$_serialDumpObject_::
	.debug	G $_serialDumpObject_ 75 9
	.debug	{ $_serialDumpObject_ 75 978 @370 @369
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A port 5 7
;980   _serialDevice  *sd;
	.debug	L sd -2 76
;981 
;982 
;983   sd = (_serialDevice *) serPort[port].sDev;
	.debug	# 983
	ld	hl,(ix+5)
	ld	bc,0x18
	ex	de,hl
	mul
	ld	hl,_serPort
	add	hl,bc
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	(ix-2),hl
;984 
;985   printf("Port: %u at [%04lx], dev at [%04lx]\r\n",
;986          port, (ulong)(serPort + port), (ulong)sd );
	.debug	# 986
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	c,0x18
	ex	de,hl
	mul
	ld	hl,_serPort
	add	hl,bc
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	push	hl
	ld	de,word (phys @8+251)
	ld	c,phys @8+251 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,14
;987 
;988   printf("  dPort: %02x\r\n", (uint)sd->dPort);
	.debug	# 988
	ld	hl,(ix-2)
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @8+289)
	ld	c,phys @8+289 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;989   printf("  sPort: %02x\r\n", (uint)sd->dPort);
	.debug	# 989
	ld	hl,(ix-2)
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @8+305)
	ld	c,phys @8+305 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;990   printf("  InQueue:\r\n");
	.debug	# 990
	ld	de,word (phys @8+321)
	ld	c,phys @8+321 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;991   printf("    in:    [%04x]\r\n", (uint)sd->serialInQueue.q_in    );
	.debug	# 991
	ld	hl,(ix-2)
	inc	hl
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+334)
	ld	c,phys @8+334 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;992   printf("    out:   [%04x]\r\n", (uint)sd->serialInQueue.q_out   );
	.debug	# 992
	ld	hl,(ix-2)
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+354)
	ld	c,phys @8+354 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;993   printf("    start: [%04x]\r\n", (uint)sd->serialInQueue.q_start );
	.debug	# 993
	ld	hl,(ix-2)
	ld	de,0x7+1+1
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+374)
	ld	c,phys @8+374 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;994   printf("    end:   [%04x]\r\n", (uint)sd->serialInQueue.q_end   );
	.debug	# 994
	ld	hl,(ix-2)
	ld	de,0x5+1+1
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+394)
	ld	c,phys @8+394 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;995   printf("    start_int: [%04x]\r\n", (uint)sd->serialInQueue.q_start_int )
	.debug	# 995
	ld	hl,(ix-2)
	ld	de,0x9+1+1
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+414)
	ld	c,phys @8+414 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;996   printf("    end_int:   [%04x]\r\n", (uint)sd->serialInQueue.q_end_int );
	.debug	# 996
	ld	hl,(ix-2)
	ld	de,0xb+1+1
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+438)
	ld	c,phys @8+438 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;997   printf("    flags: [%04x]\r\n", (uint)sd->serialInQueue.q_flags   );
	.debug	# 997
	ld	hl,(ix-2)
	ld	de,0xd+1+1
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @8+462)
	ld	c,phys @8+462 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;998   printf("  OutQueue:\r\n");
	.debug	# 998
	ld	de,word (phys @8+482)
	ld	c,phys @8+482 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;999   printf("    in:    [%04x]\r\n", (uint)sd->serialOutQueue.q_in    );
	.debug	# 999
	ld	hl,(ix-2)
	ld	de,0x10
	add	hl,de
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+334)
	ld	c,phys @8+334 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1000   printf("    out:   [%04x]\r\n", (uint)sd->serialOutQueue.q_out   );
	.debug	# 1000
	ld	hl,(ix-2)
	ld	de,0x10
	add	hl,de
	inc	hl
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+354)
	ld	c,phys @8+354 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1001   printf("    start: [%04x]\r\n", (uint)sd->serialOutQueue.q_start );
	.debug	# 1001
	ld	hl,(ix-2)
	ld	de,0x10+0x7
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+374)
	ld	c,phys @8+374 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1002   printf("    end:   [%04x]\r\n", (uint)sd->serialOutQueue.q_end   );
	.debug	# 1002
	ld	hl,(ix-2)
	ld	de,0x10+0x5
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+394)
	ld	c,phys @8+394 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1003   printf("    start_int: [%04x]\r\n", (uint)sd->serialOutQueue.q_start_int 
	.debug	# 1003
	ld	hl,(ix-2)
	ld	de,0x10+0x9
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+414)
	ld	c,phys @8+414 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1004   printf("    end_int:   [%04x]\r\n", (uint)sd->serialOutQueue.q_end_int );
	.debug	# 1004
	ld	hl,(ix-2)
	ld	de,0x10+0xb
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+438)
	ld	c,phys @8+438 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1005   printf("    flags: [%04x]\r\n", (uint)sd->serialOutQueue.q_flags   );
	.debug	# 1005
	ld	hl,(ix-2)
	ld	de,0x10+0xd
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @8+462)
	ld	c,phys @8+462 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1006   printf("  getc(): [%04x]\r\n", (uint)sd->serialGetc);
	.debug	# 1006
	ld	hl,(ix-2)
	ld	de,0x28
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+496)
	ld	c,phys @8+496 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1007   printf("  putc(): [%04x]\r\n", (uint)sd->serialPutc);
	.debug	# 1007
	ld	hl,(ix-2)
	ld	de,0x2a
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @8+515)
	ld	c,phys @8+515 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1008 }
@369:
	.debug	} @369 1008

@368	equ	2
	ld	sp,ix
	pop	ix
	lret
@370	equ	4
;1009 
;1010 //-------------------------------------------------------------------------
;1011 
	.extern	__stdio 78
	.extern	$farprintf 80
	.extern	$farsprintf 81
	.extern	$SerialSetRate 82
	.extern	$SerialInitA 83
	.extern	$SerialInitB 83
	.extern	$SerialInitC 83
	.extern	$SerialInitD 83
	.extern	$SerialInitAxon 84
	.extern	$SerialInitBxon 84
	.extern	$SerialInitCxon 84
	.extern	$SerialInitDxon 84
	.extern	$SerialRecvCountA 42
	.extern	$SerialRecvCountB 42
	.extern	$SerialRecvCountC 42
	.extern	$SerialRecvCountD 42
	.extern	$SerialSendCountA 42
	.extern	$SerialSendCountB 42
	.extern	$SerialSendCountC 42
	.extern	$SerialSendCountD 42
	.extern	$SerialRecvFlushA 40
	.extern	$SerialRecvFlushB 40
	.extern	$SerialRecvFlushC 40
	.extern	$SerialRecvFlushD 40
	.extern	$SerialSendFlushA 40
	.extern	$SerialSendFlushB 40
	.extern	$SerialSendFlushC 40
	.extern	$SerialSendFlushD 40
	.extern	_SerialGetcA 64
	.extern	_SerialGetcB 64
	.extern	_SerialGetcC 64
	.extern	_SerialGetcD 64
	.extern	_SerialPutcA 66
	.extern	_SerialPutcB 66
	.extern	_SerialPutcC 66
	.extern	_SerialPutcD 66
	.extern	$SerialSetEvenParityA 40
	.extern	$SerialSetEvenParityB 40
	.extern	$SerialSetEvenParityC 40
	.extern	$SerialSetEvenParityD 40
	.extern	$SerialSetOddParityA 40
	.extern	$SerialSetOddParityB 40
	.extern	$SerialSetOddParityC 40
	.extern	$SerialSetOddParityD 40
	.extern	$SerialSet8EvenParityA 40
	.extern	$SerialSet8EvenParityB 40
	.extern	$SerialSet8EvenParityC 40
	.extern	$SerialSet8EvenParityD 40
	.extern	$SerialSet8OddParityA 40
	.extern	$SerialSet8OddParityB 40
	.extern	$SerialSet8OddParityC 40
	.extern	$SerialSet8OddParityD 40
	.extern	$SerialInit485A 37
	.extern	$SerialInit485B 37
	.extern	$SerialInit485C 37
	.extern	$SerialInit485D 37
	.extern	$SerialStart485txA 41
	.extern	$SerialStart485txB 41
	.extern	$SerialStart485txC 41
	.extern	$SerialStart485txD 41
	.extern	$SerialEnd485txA 40
	.extern	$SerialEnd485txB 40
	.extern	$SerialEnd485txC 40
	.extern	$SerialEnd485txD 40
	.extern	$SerialEnd485rxA 40
	.extern	$SerialEnd485rxB 40
	.extern	$SerialEnd485rxC 40
	.extern	$SerialEnd485rxD 40
	.extern	_SerialA 85
	.extern	_memset 86
	.extern	_strcpy 87
	.extern	_strlen 56
	.extern	_strncmp 88
	.extern	__pending 3
	.extern	_current 89
	.extern	$strtoi 91
	.extern	$registerFileSys 92
	.extern	$_allocFile_ 93
	.extern	_KLOCK 40
	.extern	_KUNLOCK 40
	.extern	_hdwType 7
	.extern	_sleepQueue 94
	.bseg
_serPort::
	.ds	96
	.debug	G _serPort 95 0
	.extern	_spiInUse 3
	.extern	$_spiInit_ 96
	.extern	___serialA 77
	.extern	___serialB 77
	.extern	___serialC 77
	.extern	___serialD 77
	.cseg
__serialRead_:
	pop	iy
	lcall	$$_serialRead_
__serialWrite_:
	pop	iy
	lcall	$$_serialWrite_
__serialClose_:
	pop	iy
	lcall	$$_serialClose_
__serialLseek_:
	pop	iy
	lcall	$$_serialLseek_
__serialFstat_:
	pop	iy
	lcall	$$_serialFstat_
__serialioctl_:
	pop	iy
	lcall	$$_serialioctl_
__serialDescr_:
	pop	iy
	lcall	$$_serialDescr_
__serialGetQueues_:
	pop	iy
	lcall	$$_serialGetQueues_
__serialTick_:
	pop	iy
	lcall	$$_serialTick_
__serialEntry_:
	pop	iy
	lcall	$$_serialEntry_
__serialOpen_:
	pop	iy
	lcall	$$_serialOpen_
__serialUnlink_:
	pop	iy
	lcall	$$_serialUnlink_
__serialRename_:
	pop	iy
	lcall	$$_serialRename_
	.extern	_spiIOFuncs 33
_SerInitA:
	pop	iy
	lcall	$$SerInitA
_SerInitB:
	pop	iy
	lcall	$$SerInitB
_SerInitC:
	pop	iy
	lcall	$$SerInitC
_SerInitD:
	pop	iy
	lcall	$$SerInitD
_SerSetPktModeA:
	pop	iy
	lcall	$$SerSetPktModeA
_SerSetPktModeB:
	pop	iy
	lcall	$$SerSetPktModeB
_SerSetPktModeC:
	pop	iy
	lcall	$$SerSetPktModeC
_SerSetPktModeD:
	pop	iy
	lcall	$$SerSetPktModeD
_SerEndPktRXA:
	pop	iy
	lcall	$$SerEndPktRXA
_SerEndPktRXB:
	pop	iy
	lcall	$$SerEndPktRXB
_SerEndPktRXC:
	pop	iy
	lcall	$$SerEndPktRXC
_SerEndPktRXD:
	pop	iy
	lcall	$$SerEndPktRXD
_SetStartPktTXA:
	pop	iy
	lcall	$$SetStartPktTXA
_SetStartPktTXB:
	pop	iy
	lcall	$$SetStartPktTXB
_SetStartPktTXC:
	pop	iy
	lcall	$$SetStartPktTXC
_SetStartPktTXD:
	pop	iy
	lcall	$$SetStartPktTXD
_SerEndPktTXA:
	pop	iy
	lcall	$$SerEndPktTXA
_SerEndPktTXB:
	pop	iy
	lcall	$$SerEndPktTXB
_SerEndPktTXC:
	pop	iy
	lcall	$$SerEndPktTXC
_SerEndPktTXD:
	pop	iy
	lcall	$$SerEndPktTXD
_SerSet7O1A:
	pop	iy
	lcall	$$SerSet7O1A
_SerSet7O1B:
	pop	iy
	lcall	$$SerSet7O1B
_SerSet7O1C:
	pop	iy
	lcall	$$SerSet7O1C
_SerSet7O1D:
	pop	iy
	lcall	$$SerSet7O1D
_SerSet7E1A:
	pop	iy
	lcall	$$SerSet7E1A
_SerSet7E1B:
	pop	iy
	lcall	$$SerSet7E1B
_SerSet7E1C:
	pop	iy
	lcall	$$SerSet7E1C
_SerSet7E1D:
	pop	iy
	lcall	$$SerSet7E1D
_SerSet8O1A:
	pop	iy
	lcall	$$SerSet8O1A
_SerSet8O1B:
	pop	iy
	lcall	$$SerSet8O1B
_SerSet8O1C:
	pop	iy
	lcall	$$SerSet8O1C
_SerSet8O1D:
	pop	iy
	lcall	$$SerSet8O1D
_SerSet8E1A:
	pop	iy
	lcall	$$SerSet8E1A
_SerSet8E1B:
	pop	iy
	lcall	$$SerSet8E1B
_SerSet8E1C:
	pop	iy
	lcall	$$SerSet8E1C
_SerSet8E1D:
	pop	iy
	lcall	$$SerSet8E1D
_SerSetDirA:
	pop	iy
	lcall	$$SerSetDirA
	.extern	$$SerSetDirA
	.extern	$SerSetDirA 39
_SerSetDirB:
	pop	iy
	lcall	$$SerSetDirB
	.extern	$$SerSetDirB
	.extern	$SerSetDirB 39
_SerSetDirC:
	pop	iy
	lcall	$$SerSetDirC
	.extern	$$SerSetDirC
	.extern	$SerSetDirC 39
_SerSetDirD:
	pop	iy
	lcall	$$SerSetDirD
	.extern	$$SerSetDirD
	.extern	$SerSetDirD 39
_XmitBufUsedA:
	pop	iy
	lcall	$$XmitBufUsedA
_XmitBufUsedB:
	pop	iy
	lcall	$$XmitBufUsedB
_XmitBufUsedC:
	pop	iy
	lcall	$$XmitBufUsedC
_XmitBufUsedD:
	pop	iy
	lcall	$$XmitBufUsedD
_FlushXmitA:
	pop	iy
	lcall	$$FlushXmitA
_FlushXmitB:
	pop	iy
	lcall	$$FlushXmitB
_FlushXmitC:
	pop	iy
	lcall	$$FlushXmitC
_FlushXmitD:
	pop	iy
	lcall	$$FlushXmitD
_RcvAvailA:
	pop	iy
	lcall	$$RcvAvailA
_RcvAvailB:
	pop	iy
	lcall	$$RcvAvailB
_RcvAvailC:
	pop	iy
	lcall	$$RcvAvailC
_RcvAvailD:
	pop	iy
	lcall	$$RcvAvailD
_FlushRcvA:
	pop	iy
	lcall	$$FlushRcvA
_FlushRcvB:
	pop	iy
	lcall	$$FlushRcvB
_FlushRcvC:
	pop	iy
	lcall	$$FlushRcvC
_FlushRcvD:
	pop	iy
	lcall	$$FlushRcvD
	.bseg
_serInBufs::
	.ds	2048
	.debug	G _serInBufs 97 0
_serOutBufs::
	.ds	1024
	.debug	G _serOutBufs 99 0
	.extern	$setExt485Tx 40
	.debug	T	0900012000040003000400
	.debug	T	640003210010000800010065000000057265616400650002000677
	.debug	T	72697465006600040006636C6F73650067000600066C736565
	.debug	T	6B00680008000666737461740069000A0006696F63746C006A
	.debug	T	000C00066465736372006B000E000A67657451756575657300
	.debug	T	57000322000E000700010024000000056E616D65006C0002000869
	.debug	T	6F46756E6373006D000400057469636B006E00060006656E74
	.debug	T	7279006F000800056F70656E0070000A0007756E6C696E6B00
	.debug	T	71000C000772656E616D6500
	.debug	T	270002230008000300090000000600040006000600240008000600
	.debug	T	0A0024000C0006000E0006001000
	.debug	T	070000240002000300
	.debug	T	130002250003000100030000000300020026000400
	.debug	T	070000260002002700
	.debug	T	0B000227000100010006000000
	.debug	T	0B000228000100010001000000
	.debug	T	0F00022900020006000300000006000200
	.debug	T	0B00022A000100070001000000
	.debug	T	0900012B0080002C000400
	.debug	T	DB00032C002000100001007200000005696E6974003F0002000567
	.debug	T	65746300410004000570757463006D00060007736574374F31
	.debug	T	006D00080007736574374531006D000A0007736574384F3100
	.debug	T	6D000C00077365743845310073000E000B736574506B744D6F
	.debug	T	6465002600100007736574446972006D00120009656E64506B
	.debug	T	74525800740014000B7374617274506B745458006D00160009
	.debug	T	656E64506B74545800750018000C786D697442756655736564
	.debug	T	006D001A000A666C757368586D69740075001C000972637641
	.debug	T	7661696C006D001E0009666C75736852637600
	.debug	T	0900012D0004002E000400
	.debug	T	3F00092E00010006000100C000065345525F4100D000065345525F
	.debug	T	4200E000065345525F4300F000065345525F4400C800065345
	.debug	T	525F4500D800065345525F4600
	.debug	T	0700022F0000000100
	.debug	T	0B000230000100030031000000
	.debug	T	070000310002000100
	.debug	T	130002320003000600240000000600020006000400
	.debug	T	0F00023300020031000700000034000200
	.debug	T	070000340002003500
	.debug	T	2400033500030002000100060000000A6F70656E436F756E740003
	.debug	T	00020007756E7573656400
	.debug	T	070000360002003700
	.debug	T	E7000337001800110001000300000006696E557365000300010005
	.debug	T	706F7274003100020005734465760003000400056D6F646500
	.debug	T	0300050008666C6F7743746C000300060007636C6F73656400
	.debug	T	0300070008706B744D6F646500090008000962617564526174
	.debug	T	650003000C0008636C6B4D6F64650006000D0007636C6B4469
	.debug	T	760003000F000B7365724461746152656700030010000A7365
	.debug	T	7243746C52656700030011000B736572537461745265670003
	.debug	T	0012000A73657245787452656700240013000A705368457874
	.debug	T	52656700030015000754415452656700240016000A70544154
	.debug	T	736852656700
	.debug	T	0B000238000100060024000000
	.debug	T	0F00023900020006002400000024000200
	.debug	T	1700023A000400060003000000030002000300040003000600
	.debug	T	0F00023B0002000600310000003C000200
	.debug	T	0700083C0004003D00
	.debug	T	2800033D00040002000100760000000A7265616451756575650076
	.debug	T	0002000B7772697465517565756500
	.debug	T	1700023E000400060031000000240002000600040003000600
	.debug	T	0700003F0002004000
	.debug	T	0B000240000100060001000000
	.debug	T	070000410002004200
	.debug	T	0B000242000100060006000000
	.debug	T	0B000243000100060031000000
	.debug	T	130002440003000900310000000900020006000600
	.debug	T	0F00024500020006003100000046000200
	.debug	T	070000460002004700
	.debug	T	BB000347002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	130002480003000600310000000600020031000400
	.debug	T	070000490002002C00
	.debug	T	1300024A0003002400310000002400020006000400
	.debug	T	0B00024B000100010007000000
	.debug	T	0700004C0002004D00
	.debug	T	2402034D004C0023000100030000000664506F7274000300010006
	.debug	T	73506F727400770002000E73657269616C496E517565756500
	.debug	T	770010000F73657269616C4F757451756575650078001E0010
	.debug	T	73657269616C536574506172697479007A0020001273657269
	.debug	T	616C436865636B50617269747900780022001173657269616C
	.debug	T	53657450617269747938007A0024001373657269616C436865
	.debug	T	636B5061726974793800030026001173657269616C4572726F
	.debug	T	72466C61677300030027000E7478496E7473456E61626C6564
	.debug	T	003F0028000B73657269616C476574630041002A000B736572
	.debug	T	69616C507574630003002C0009784F666653656E740003002D
	.debug	T	000773656E6448530007002E000A784F66664C696D69740007
	.debug	T	00300009784F6E4C696D6974000300320004784F6E00030033
	.debug	T	0005784F6666000300340008637473506F7274000300350008
	.debug	T	6374734D61736B00030036000F637473506F6C6C456E61626C
	.debug	T	6564000300370008727473506F72740003003800087274734D
	.debug	T	61736B00240039000A727473506F727453520007003B000E72
	.debug	T	7473436C6561724C696D69740007003D000C7274735365744C
	.debug	T	696D69740003003F000672733438350003004000076D794164
	.debug	T	6472000300410007746F4164647200030042000A7573653974
	.debug	T	68426974000300430008727853746F726500260044000B656E
	.debug	T	61626C6546756E63006D004600097374617274343835002600
	.debug	T	480007656E643438350007004A0008727854696D657200
	.debug	T	0700004E0002004F00
	.debug	T	5400034F000C00060001007C000000065F5F6F7574006600020005
	.debug	T	5F5F696E007E000400085F5F7772697465007E000600075F5F
	.debug	T	726561640006000800085F5F756E6765740031000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	0F0002500002000600800000000D000000
	.debug	T	13000251000300060080000000800004000D000000
	.debug	T	0F00025200020003002E00000009000200
	.debug	T	230002530007000300090000000600040006000600240008000600
	.debug	T	0A0024000C0006000E00
	.debug	T	2B0002540009000300090000000600040006000600240008000600
	.debug	T	0A0006000C0006000E002400100006001200
	.debug	T	09000155000C004F000100
	.debug	T	130002560003003100310000000600020007000400
	.debug	T	0F00025700020024002400000024000200
	.debug	T	130002580003000600240000002400020007000400
	.debug	T	070000590002005A00
	.debug	T	7702035A00E8002D000C7461736B5F737472756374008100000006
	.debug	T	737461636B00810002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C68720082000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465005900150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630084001A0005617267760085001C0005617267
	.debug	T	73005E009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773008600B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74008000D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	1300025B0003000600240000008400020006000400
	.debug	T	0B00025C000100060088000000
	.debug	T	1300025D0003000600060000006C00020031000400
	.debug	T	2800035E0004000100125F5F776169745F71756575655F68656164
	.debug	T	0089000000096C6973744865616400
	.debug	T	0900015F00600037000400
	.debug	T	130002600003000300310000000300020003000400
	.debug	T	0900016100000862000400
	.debug	T	0900016200000203000002
	.debug	T	0900016300000464000400
	.debug	T	0900016400000103000001
	.debug	T	070000650002003E00
	.debug	T	070000660002004300
	.debug	T	070000670002004400
	.debug	T	070000680002004500
	.debug	T	070000690002004800
	.debug	T	0700006A0002004A00
	.debug	T	0700006B0002003B00
	.debug	T	0700006C0002002100
	.debug	T	0700006D0002002800
	.debug	T	0700006E0002003300
	.debug	T	0700006F0002003200
	.debug	T	070000700002003800
	.debug	T	070000710002003900
	.debug	T	070000720002002300
	.debug	T	070000730002002500
	.debug	T	070000740002002900
	.debug	T	070000750002002A00
	.debug	T	070000760002005E00
	.debug	T	71000377000E000800010003000000097265736572766564002400
	.debug	T	010005715F696E002400030006715F6F757400240005000671
	.debug	T	5F656E64002400070008715F7374617274008A0009000C715F
	.debug	T	73746172745F696E74008A000B000A715F656E645F696E7400
	.debug	T	03000D0008715F666C61677300
	.debug	T	070000780002007900
	.debug	T	0B000279000100070007000000
	.debug	T	0700007A0002007B00
	.debug	T	0B00027B000100030007000000
	.debug	T	0700007C0002007D00
	.debug	T	0F00027D00020006000300000031000200
	.debug	T	0700007E0002007F00
	.debug	T	1300027F0003000800800000000800040031000800
	.debug	T	070008800004000300
	.debug	T	070000810002000700
	.debug	T	070000820002008300
	.debug	T	070008830004000100
	.debug	T	070000840002002400
	.debug	T	0900018500800003008000
	.debug	T	070000860002008700
	.debug	T	0F00028700020001000600000084000200
	.debug	T	070000880002002200
	.debug	T	2600038900040002000A6C6973745F68656164008C000000056E65
	.debug	T	7874008C000200057072657600
	.debug	T	0700008A0002008B00
	.debug	T	0B00028B000100030001000000
	.debug	T	0700008C0002008900
	.seg	CONST
@1:
	.db	"serial",0,"/dev/",0,"ttyx",0,"tty",0,"spi",0,"bad bad",0,"r",0
	.defseg	FARCONST
	.seg	FARCONST
@8:
	.db	"*** xon init ***",13,10,0,"set format to 7O1",13,10,0,"set format to 7E1",13,10,0,"set format to 8O1",13,10,0,"set fo"
	.db	"rmat to 8E1",13,10,0,"flushConsole() failed",13,10,0,13,10,10,10,10,10,10,10,10,0,"Before: XON: [%02X]  XOFF: [%02X]",13,10,0,"A"
	.db	"fter:  XON: [%02X]  XOFF: [%02X]",13,10,0,"serial 0x%04lX ",0,"ser[%d] /dev/tty%s%d %ld baud",0,"Port"
	.db	": %u at [%04lx], dev at [%04lx]",13,10,0,"  dPort: %02x",13,10,0,"  sPort: %02x",13,10,0,"  InQueue:",13,10,0,"    in"
	.db	":    [%04x]",13,10,0,"    out:   [%04x]",13,10,0,"    start: [%04x]",13,10,0,"    end:   [%04x]",13,10,0,"    start_i"
	.db	"nt: [%04x]",13,10,0,"    end_int:   [%04x]",13,10,0,"    flags: [%04x]",13,10,0,"  OutQueue:",13,10,0,"  getc(): [%04"
	.db	"x]",13,10,0,"  putc(): [%04x]",13,10,0
	.end
