@rem ----- saveall.bat ----- 10/21/11 -----(03/09/07)-----

  @echo off

rem ===========================================================================
rem  Command Shell script to automate making all the Softools C projects in
rem  a directory tree
rem ===========================================================================
rem  Update Log (most recent first)
rem
rem
rem  2011-10-21 - Mark Davis
rem               - modified to work with broken Windows 7 handling which
rem                 considers the following to be true:
rem                    file  name.bin-old in the set (*.bin)
rem
rem  2009-04-15 - Mark Davis
rem               - commented out pieces that copy uncompressed files
rem
rem  2007-03-09 - Mark Davis
rem               - original version
rem
rem ===========================================================================

  setlocal

rem --- places to copy uncompressed version of boot images ---
rem  set destDir1=\\Icarus\ctlrdata\test
rem  set destDir2=\\Icarus\ctlrdata\release

rem --- NOTE: The compressed copy on the srfs server is updated by calling ---
rem ---       the  upfirm.bat  file 



  set cleanFlag=
  set parDir=.

  if /I "%1" gtr ""  set parDir=%1

  if /I exist savelist  for /F %%d in (savelist) do call :ProcDir %%d

  call :getDirName

  for %%f in (*.bin) do   if /I "%%~xf" equ ".bin"   call :CopyBin %%~nf

  exit /b

    


rem ===========================================================================
rem  Change to the specified directory and then recursively process all 
rem  subdirectories before processing the specified directory
rem ===========================================================================
rem  call :ProcDir(childDir)

:ProcDir
  cd %1%
  call :getDirName
  if /I "%curDir%"=="%1"  goto :dirok

  echo ***** Couldn't process: "%parDir%\%1" *****
  echo.
  goto :eof

:dirok
  call saveall %parDir%\%curDir%

  cd ..
  goto :eof

  

rem ===========================================================================
rem  process the project file in the current directory (passed as %1)
rem ===========================================================================
rem  call :CopyBin(binName)

:CopyBin
  if /I not exist %1.bin  goto :eof
  echo.
  echo ==========[%parDir%]===[%1.bin]==========

rem  copy %1.bin %destDir1%
rem  copy %1.bin %destDir2%
  call upfirm.bat
  echo.

  goto :eof


rem ===========================================================================
rem  get the name of the current directory without the path portion
rem ===========================================================================
:getDirName
  set tname=%CD%
  set curDir=
:nextch
  if /I "%tname%" leq "" goto :eof
  set lastCh=%tname:~-1%
  set tname=%tname:~0,-1%
  set curDir=%lastCh%%curDir%
  if %lastCh% neq \ goto :nextch
  set curDir=%curDir:~1%
rem echo [%parDir%][%curDir%]
  goto :eof
