//----- adc.c ----- 01/07/11 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2011-01-07 - Mark Davis
//               - Added locks around setting of global values
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  force/release a forced value for an ADC signal (Analog Digital Convertor)
//-----------------------------------------------------------------------------
void _task _adc(int argc, char **argv)
{
  uint  uidx;
  float  newAIn;
  char  temp[16];


  if (showHelp(2, argc, argv))  {
    printf("\nusage: adc # [value]\r\n");  Exit(-1); }

  uidx = atoi(argv[1]);
  if (uidx >= NumHdwADC)  {
    printf("Invalid signal #: %s\r\n\n", argv[1]);  Exit(-1); }

  if (argc < 3)  {  // if no value given, revert to non-forced mode
    adcForced[uidx] = false;  updateAIn[uidx] = true;
    printf("ADC # %u no longer using a forced value\r\n", uidx);
    Exit(0);
  }

  newAIn = atof(argv[2]);
  if (newAIn < ainMin[uidx])  newAIn = ainMin[uidx];
  if (newAIn > ainMax[uidx])  newAIn = ainMax[uidx];

  printf("ADC # %u now using forced value: %s\r\n",
         uidx, Engineering(newAIn, 4, temp) );

  KLOCK();
  adcForcedVal[uidx] = newAIn;
//  adcForcedRaw[uidx] = (uint) AIntoADC(ui, newAIn);
  adcForced[uidx] = updateAIn[uidx] = true;
  KUNLOCK();

  Exit(0);
}

//-----------------------------------------------------------------------------
