//----- dac.c ----- 12/07/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  set output for one of the DAC's (Digitial Analog Convertor)
//-----------------------------------------------------------------------------
void _task _dac(int argc, char **argv)
{
  uint  uidx;
  float  newAOut;
  char  temp[16];


  if (showHelp(2, argc, argv))  {
    printf("\nusage: dac # [value]\r\n");  Exit(-1); }

  uidx = atoi(argv[1]);
  if (uidx >= NumHdwDAC)  {
    printf("Invalid signal #: %s\r\n\n", argv[1]);  Exit(-1); }

  if (argc < 3)  {  // if no value given, revert to non-forced mode
    dacForced[uidx] = false;  updateAOut[uidx] = true;
    printf("DAC # %u no longer using a forced value\r\n", uidx);
    Exit(0);
  }

  newAOut = atof(argv[2]);
  if (newAOut < aoutMin[uidx])  newAOut = aoutMin[uidx];
  if (newAOut > aoutMax[uidx])  newAOut = aoutMax[uidx];

  printf("DAC # %u now using forced value: %s\r\n",
         uidx, Engineering(newAOut, 4, temp) );

  dacForced[uidx] = true;  dacForcedVal[uidx] = newAOut;
  updateAOut[uidx] = true;

  Exit(0);
}

//-----------------------------------------------------------------------------
