//----- date.c ----- 03/20/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  show the current date and time
//-----------------------------------------------------------------------------
void _task _date(int argc, char **argv)
{
  time_t  utcSecs;
  int  zone;
  bool  showUsage;
  char  timeStr[32];


  showUsage = false;

  for (;;)  {
    if (argc == 1)  break;
    if (showHelp(3, argc, argv))  { showUsage = true;  break; }
    if (strcmp(argv[1], "-z"))  { showUsage = true;  break; }
    zone = atoi(argv[2]);
    if ((zone < -12) OR (zone > 12))  { showUsage = true;  break; }
    timeZone = zone;  break;
  }

  if (showUsage)  {
    printf("\nusage:  date [-z <timezone>]\r\n");  Exit(-1);  }


  time(&utcSecs);  ctime_r(&utcSecs, timeStr);

  timeStr[strlen(timeStr)-1] = 0;  // get rid of trailing newline

  printf("%s (%d)\r\n", timeStr, timeZone);

  Exit(0);
}

//-----------------------------------------------------------------------------
