//----- ifconfig.c ----- 03/29/11 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2011-03-29 - Mark Davis
//               - Changed to use chgIPAddr()
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>


/* Sample output for ifconfig on Linux box:

eth0      Link encap:Ethernet  HWaddr 00:02:55:7a:ff:0e
          inet addr:35.9.58.217  Bcast:35.15.255.255  Mask:255.248.0.0
          inet6 addr: fe80::202:55ff:fe7a:ff0e/64 Scope:Link
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:20054597 errors:0 dropped:0 overruns:0 frame:0
          TX packets:7018940 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:3185752757 (3.1 GB)  TX bytes:524312659 (524.3 MB)

lo        Link encap:Local Loopback
          inet addr:127.0.0.1  Mask:255.0.0.0
          inet6 addr: ::1/128 Scope:Host
          UP LOOPBACK RUNNING  MTU:16436  Metric:1
          RX packets:884 errors:0 dropped:0 overruns:0 frame:0
          TX packets:884 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:0
          RX bytes:57665 (57.6 KB)  TX bytes:57665 (57.6 KB)
*/

//-----------------------------------------------------------------------------
void _task _ifconfig(int argc, char **argv)
{
  IFConfig  ifConfig;
  ulong  newAddr;


  if (showHelp(1, argc, argv))  {
    printf("\nusage:  ifconfig [newAddr]\r\n");  Exit(-1); }

  getIFConfig(IF_ETH0, &ifConfig);

  if (argc < 2)
    showNetState(IF_ETH0);
  else  {
    newAddr = 0;  inet_ptoh(AF_INET, argv[1], &newAddr);

    if (! newAddr)  {
      printf("Invalid IP address: %s\r\n", argv[1]);  Exit(-1);  }

    chgIPAddr(IF_ETH0, newAddr);
  }

  Exit(0);
}

//-----------------------------------------------------------------------------
