//----- label.c ----- 03/31/09 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  set or show labels for I/O signals
//-----------------------------------------------------------------------------
void _task _label(int argc, char **argv)
{
  uint  i;
  int  group, labelIdx;
  bool  validUsage, newLabel;
  char  temp[MAX_LABEL_LEN];

  static char *LabelGroups[] = { "ai", "ao", "di", "do", "ex" };
  static char far *LabelList[5];
  static uint const *MaxIdx[] = {
    &NumApplAIN, &NumApplAOUT, &NumApplDIN, &NumApplDOUT, &NumExtraIn };

#define LABEL(grp,idx)  (LabelList[(uint)grp]+MAX_LABEL_LEN*((uint)idx))


  if (showHelp(2, argc, argv))  {
    printf("\nusage: label ai|ao|di|do|ex|defaults [# new_label]\r\n\n");
    Exit(-1);
  }

  LabelList[0] = (char far *)ainLabel[0];
  LabelList[1] = (char far *)aoutLabel[0];
  LabelList[2] = (char far *)dinLabel[0];
  LabelList[3] = (char far *)doutLabel[0];
  LabelList[4] = (char far *)extraInLabel[0];

  if (argc == 2)  if (StriEq(argv[1], "defaults"))  {
    setGenericLabels();  setDefaultLabels();  Exit(0);  }

  validUsage = false;

  for (;;)  {
    if ((argc < 4) AND (argc != 2))  break;
    if ((group = strListIdx(LabelGroups, argv[1])) < 0)  break;

//--- new label # and label ---
    if (argc > 3)  {
      labelIdx = ATOI(argv[2]);
      if ((labelIdx < 0) OR ((uchar)labelIdx >= *MaxIdx[group]))  {
        printf("Invalid channel #: %s\r\n", argv[2]);  Exit(-1);  }

  //--- string together remaining arguments for new label ---
      *temp = 0;
      for (i=3; i<argc; ++i)  {
        if (strlen(temp) + strlen(argv[i]) + 1 >= MAX_LABEL_LEN)  {
          printf("New label > %d characters\r\n", MAX_LABEL_LEN);  Exit(-1); }
        if (*temp)  strcat(temp, " ");
        strcat(temp, argv[i]);
      }
      fstrcpy(LABEL(group,labelIdx), temp);  newLabel = true;
    }

  //--- show all the labels in the specified group ---
    for (i=0; i<*MaxIdx[group]; ++i)  {
      printf("  %s %2d: ", LabelGroups[group], i);  printf(LABEL(group,i));
      printf("\r\n");
    }
    validUsage = true;  break;
  }

  if (!validUsage)  {
    printf("\nusage: label ai|ao|di|do|defaults [# new_label]\r\n\n");
    Exit(-1);
  }

  if (newLabel)  {
    //finish:
  }

  Exit(0);
}


//-----------------------------------------------------------------------------
