//----- ping.c ----- 02/01/11 -----(01/28/11)-----

//-----------------------------------------------------------------------------
//  Update log (most recent first):
//
//
//  2011-02-01 - Mark Davis
//               - Now prints messages for errors when trying to send a packet.
//
//  2011-01-28 - Mark Davis
//               - new command
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
void _task _ping_(int argc, char **argv)
{
  byte  ttl = 64;
  int  stat;
  ulong  ul, remoteAddr, replyMS, seqNum, startedMS, lastSendMS;


  if (showHelp(2, argc, argv))  {
    printf("\nusage:  %s dest\r\n", argv[0]);  Exit(-1); }


  remoteAddr = 0;  inet_ptoh(AF_INET, argv[1], &remoteAddr);

  printf("\r\nPING %.32s:\r\n", argv[1]);

  for (ul=0; ; ++ul)  {
    printf(".");  //tdebug
    stat = _send_ping(remoteAddr, ul, ttl, IPTOS_DEFAULT, NULL);
    printf(".");  //tdebug
    lastSendMS = GetMS();

    switch (stat)  {

      case 1:
        printf("Unable to resolve hdw address\r\n");  break;

      case -1:
        printf("Unable to xmit ICMP request\r\n");  break;

      case 0:
        replyMS = 0xFFFFFFFFl;
        if (stat == 0)  for (startedMS=GetMS(); msSince(startedMS)<1000; )  {
          CheckETX();
          replyMS = _chk_ping(remoteAddr, &seqNum);
          if (replyMS == 0xFFFFFFFFl)  { sleepMS(100);  continue; }
          printf("?? bytes from %.32s: icmp_seq=%lu ttl=?? time=%lu ms\r\n",
                 argv[1], seqNum, replyMS);
          break;
        }
        if (replyMS == 0xFFFFFFFFl)
          printf("request timed out (icmp_seq=%lu)\r\n", ul);
    }

    while (msSince(lastSendMS) < 1000)  { CheckETX();  sleepMS(100); }
  }

}

//-----------------------------------------------------------------------------
