//----- rdflash.c ----- 05/21/10 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//  Change log (most recent first):
//
//
//  2010-05-21 - Mark Davis (*)
//               - Added scheduler lock around call to ReadFlash()
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
//  show contents of flash memory
//-----------------------------------------------------------------------------
void _task _rdflash(int argc, char **argv)
{
  uchar  i;
  FlDWord  endOfFlash, offset, count, remain;
  FlWord  sectorSize;
  char  msg[160], buf[16];


  if (showHelp(2, argc, argv))  {
    printf("\nusage: rdflash offset [count]\r\n");  Exit(-1); }

  offset = ATOUL(argv[1]);  count = ATOUL(argv[2]);
  if (argc > 2)  count = ATOUL(argv[2]);  else  count = 128;

//--- Get end of flash ---
  endOfFlash = GetFlashDeviceEnd( 0, &sectorSize );

  printf("sectorSize: %d, endOfFlash: %lu\r\n", sectorSize, endOfFlash);

  for (remain=count; remain>0; remain-=16)  {
    i = (uchar)((remain >= 16) ? 16 : remain);
    memset(buf, 0xbb, sizeof(buf));
    KLOCK();  ReadFlash((FlByte far *)offset, buf, (ulong)i);  KUNLOCK();
    fmtHexLine(msg, offset, buf, i);
    strcat(msg, "\r\n");  printf(msg);
    offset += 16;  if (remain < 16)  break;
    CheckETX();
  }

  Exit(0);
}

//-----------------------------------------------------------------------------
