//----- reboot.c ----- 02/10/11 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2011-02-10 - Mark Davis
//               - Added support for rebooting to backup bootimg
//
//  2010-12-06 - Mark Davis
//               - Added support for useSoftReset
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>

//-----------------------------------------------------------------------------
//  shutdown and restart the OS
//-----------------------------------------------------------------------------
void _task _reboot(int argc, char **argv)
{
  uint  u;


  if (showHelp(1, argc, argv))  {
    printf("\nusage:  reboot [soft] [backup]\r\n");  Exit(-1); }

  for (u=1; u<argc; ++u)  {
    if (StrEq(argv[u], "soft"))  useSoftReset = true;
    if (StrEq(argv[u], "backup"))  runBackup = true;
  }

  printf("shutting down and restarting OS...\r\n\n");
  doShutdown = doReboot = true;

  Exit(0);
}

//-----------------------------------------------------------------------------
