//----- tip.c ----- 05/11/10 -----(03/14/06)-----

//-----------------------------------------------------------------------------
//
//  2010-05-11 - Mark Davis
//               - Added -echo option for half-duplex devices that don't echo
//
//  2009-xx-xx - Mark Davis
//               - original version of ...
//
//-----------------------------------------------------------------------------

#include <time.h>
#include <common.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <errno.h>
#include <signal.h>
#include <utime.h>


#include <busybox.h>

#include <sys/hdwDefs.h>

#include <sys/srfs.h>

#include <dcdefs.h>

#include <ctype.h>
#include <limits.h>

#include <sys/SHD_headers.h>

#include <sys/modbus.h>

#include <tsh.h>

#include <applic.h>

#include <sys/farprintf.h>


//-----------------------------------------------------------------------------
//  cmd to connect stdio to the specified file/device
//-----------------------------------------------------------------------------
void _task _tip(int argc, char **argv)
{
  fd_t  devfd;
  bool  checkForETX, echo;
  int  stdinFlags, stdoutFlags, devFlags;
  uint  i;
  ulong  baudRate;


  if (showHelp(2, argc, argv))  {
    printf("\nusage: tip device [speed] [-etx] [-echo]\r\n");  Exit(-1); }

  if ((devfd = open(argv[1], O_RDWR, 0)) < 0)  {
    printf("Unable to open device: %s\r\n", argv[1]);  Exit(-2);  }

  if (argc > 2)  {
    baudRate = atol(argv[2]);  ioctl(devfd, IOC_SET_BAUD, &baudRate);  }

  checkForETX = echo = false;
  for (i=2; i<argc; ++i)  {
    if (StriEq(argv[i], "-etx"))  checkForETX = true;
    if (StriEq(argv[i], "-echo"))  echo = true;
  }

  stdinFlags = fcntl(0, F_GETFL, 0);
  stdoutFlags = fcntl(1, F_GETFL, 0);
  devFlags = fcntl(devfd, F_GETFL, 0);

  for (;;)  {
    if (copyData(0, stdinFlags, devfd, devFlags, checkForETX, echo) < 0)  break;
    if (copyData(devfd, devFlags, 1, stdoutFlags, false, false) < 0)  break;
    sleepMS(10);
  }

  Exit(0);
}


//-----------------------------------------------------------------------------
