	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	p 5
	.debug	N 'C:\work\dev\Rabbit_ST\appl\DVR\DVRAppl.c' 25 6 8 10 9 32
;1 //----- DVRAppl.c ----- 06/20/12 -----(03/05/06)----
;2 
;3 // EE Documents bundle # 045
;4 
;5 // Sections that typically require application-specific code are marked wit
;6 // the comment:  //APPLCODE
;7 
;8 //-------------------------------------------------------------------------
;9 //  Application specific code for the main application task that is run at
;10 //  a fixed interval and application specific commands run on demand.
;11 //
;12 //APPLCODE
;13 //  Application code to manage the D Voltage Regulator NIM module
;14 //-------------------------------------------------------------------------
;15 // Update log (most recent first);
;16 //
;17 //
;18 //  2012-06-20 - Mark Davis
;19 //               - Reduced time since last pass that acts as the threshold 
;20 //                 determining when the applic task should write log messag
;21 //                 for changes in the state of the digital I/O signals.  Th
;22 //                 should reduce the occurance of confusing logs that conta
;23 //                 a sequence of messages showing a change to one value but
;24 //                 not the other (so it looks like it is telling you over a
;25 //                 over the same value with no change).
;26 //
;27 //  2011-01-21 - Mark Davis
;28 //               - Minor tweaks to support soft resets
;29 //
;30 //  2010-04-30 - Mark Davis
;31 //               - Added hdwCfgVolts for diagnostic usage
;32 //
;33 //  2009-12-14 - Mark Davis
;34 //               - Changed order of param files to deal with problems cause
;35 //                 by the order in which they were restored at startup.
;36 //
;37 //  2009-06-23 - Mark Davis -
;38 //               - Added log messages for the Limited and Error LED states.
;39 //
;40 //  2009-06-22 - Mark Davis -
;41 //               - Reversed pressed/released messages for the INITIAL and
;42 //                 FINAL setpoint buttons so they are correct.
;43 //
;44 //  2009-04-15 - Mark Davis -
;45 //               - Corrected messages logged for RF ON/OFF digital input (t
;46 //                 were backwards)
;47 //
;48 //  2009-03-20 - Mark Davis -
;49 //               - Added digInDescr[] and digOutDescr[] to support the newe
;50 //                 generic method for logging changes of interest in the st
;51 //                 of the digital I/O signals.
;52 //
;53 //  2008-08-20 - Mark Davis -
;54 //               - new values for rfOnSetpoint and rfOffSetpoint now ignore
;55 //                 when in local mode
;56 //
;57 //  2008-03-06 - Mark Davis -
;58 //               - split updateState() into standard 4 separate func calls
;59 //                 (NO changes in the logic or actual code statements!)
;60 //               - added check for out-of-range hardware jumper config (hdw
;61 //                 values
;62 //
;63 //  2008-01-10 - Mark Davis -
;64 //               - added (hopefully temp) method of setting gains based on
;65 //                 on the hardware configuration.  The gains are currently
;66 //                 forced to default values if the resistor in the header
;67 //                 indicates a K500 or K1200 configuration.
;68 //
;69 //  2007-11-29 - Mark Davis -
;70 //               - started work on DVR module code
;71 //
;72 //-------------------------------------------------------------------------
;73 //
;74 //  The primary function of the controller is to monitor the ON/OFF status 
;75 //  the RF via a digital input and maintain the cavity voltage at one of tw
;76 //  setpoints:  One for the OFF or INITIAL/cold state, and one for the ON o
;77 //  FINAL/warm state.
;78 //
;79 //  Regulation of the cavity voltage is done by an analog feedback loop usi
;80 //  a setpoint voltage supplied by the control logic.  As long as the modul
;81 //  has power, one of the two setpoints (or a value in between) is applied 
;82 //  the feedback loop.
;83 //
;84 //  To avoid surges due to unmatched conditions, particularly when the RF i
;85 //  first turned on and still warming up, configurable delays and ramp rate
;86 //  are used to gradually ramp the setpoint from one value to another.
;87 //
;88 //  The front panel contains a knob, a digital meter, and switches for view
;89 //  the current operating voltage and making changes to the setpoints.  The
;90 //  values and all the other software configurable parameters can also be
;91 //  viewed and/or set via the control system software interface.
;92 //
;93 //-------------------------------------------------------------------------
;94 //  Run-time settings (values that change frequently - changes are
;95 //  automatically saved):
;96 //
;97 //  rfOffSetpoint:    INITIAL/COLD setpoint.  The setpoint to apply when th
;98 //                    is OFF.
;99 //
;100 //  rfOnSetpoint:     FINAL/WARM setpoint.  The setpoint to apply when the 
;101 //                    is ON.
;102 //
;103 //-------------------------------------------------------------------------
;104 //  Configuration values (normally set and left alone - changes are manuall
;105 //  saved using the command 'save devdata'):
;106 //
;107 //    coldRampRate:   The rate at which the active setpoint is ramped towar
;108 //                    rfOnSetpoint after offToOnDelay has been observed.
;109 //
;110 //    warmRampRate:   The rate at which the active setpoint is ramped towar
;111 //                    a new rfonSetpoint after the offToOnDelay has expired
;112 //                    the active setpoint has reached the previous rfOnSetp
;113 //
;114 //    offToOnDelay:   The # of ms to wait after the RF changes from OFF to 
;115 //                    before the active setpoint begins ramping toward the
;116 //                    rfOnSetpoint.
;117 //
;118 //    maxRegErr:      The maximum difference between the active setpoint an
;119 //                    the cavity voltage readback that is not considered an
;120 //                    error.
;121 //
;122 //    limiterActiveV: The maximum magnitude for the Limiter voltage that is
;123 //                    not considered an error.
;124 //
;125 //    knobRate:       The scaling factor for applying knob movement to one 
;126 //                    the setpoints
;127 //
;128 //    maxOffSetpoint: Maximum value for rfOffSetpoint
;129 //
;130 //    maxOnSetpoint:  Maximum value for rfOnSetpoint
;131 //
;132 //-------------------------------------------------------------------------
;133 //
;134 //  Theory of operation:
;135 //
;136 //  The two main features of the module are an analog feedback loop that
;137 //  controls the RF cavity voltage, and an embedded SBC (Single Board Compu
;138 //  whose primary tasks are to provide the setpoint for the feedback loop a
;139 //  monitor the RF cavity voltage and ON/OFF status.
;140 //
;141 //  The controller maintains two setpoints:  rfOffSetpoint (INITIAL/cold) a
;142 //  rfOnSetpoint (FINAL/warm).  These setpoints and the RF ON status determ
;143 //  the activeSetpoint applied to the feedback loop as follows:
;144 //
;145 //  RF is OFF
;146 //    (rampMode RAMP_OFF)
;147 //    The active setpoint is set to rfOffSetpoint
;148 //
;149 //  RF changes from OFF to ON
;150 //    (rampMode RAMP_WAIT):
;151 //    The active setpoint remains at the rfOffSetpoint for offToOnDelay ms.
;152 //
;153 //  RF ON for at least offToOnDelay ms, active setpoint != rfOnSetpoint
;154 //    (rampMode RAMP_COLD)
;155 //    The active setpoint is ramped toward rfOnSetpoint using coldRampRate
;156 //    (independent of any changes to rfOnSetpoint).
;157 //
;158 //  RF ON and active setpoint reaches rfOnSetpoint
;159 //    (rampMode RAMP_WARM)
;160 //    Any changes to the onSetPoint are applied using warmRampRate.
;161 //
;162 //
;163 //  The front panel contains the following controls and displays:
;164 //    - RF ON LED
;165 //    - LIMITED LED
;166 //    - ERROR LED
;167 //    - DEE VOLTAGE (digital voltage meter)
;168 //    - Optical encoder knob
;169 //    - FINAL pushbutton
;170 //    - INITIAL pushbutton
;171 //    - OPEN/CLOSED LOOP toggle switch
;172 //    - LOCAL/REMOTE toggle switch
;173 //    - RF ON/OFF (BNC connector)
;174 //    - RF IN (BNC connector) - to monitor Cavity Voltage
;175 //    - PEAK DETECTOR IN (BNC connector)
;176 //    - LIMITER (BNC connector)
;177 //    - RF OUT (BNC connector)
;178 //
;179 //  The RF ON LED indicates the state of the RF.  It is controlled directly
;180 //  by the RF ON/OFF input (i.e. the control logic cannot affect its state)
;181 //
;182 //  The LIMITED LED indicates whether or not the LIMITER voltage is within 
;183 //  normal operating range.  It is turned on if the LIMITER voltage exceeds
;184 //  the threshold defined by the Limiter Error parameter.
;185 //
;186 //  The ERROR LED indicates that the analog feedback loop is unable to
;187 //  properly regulate the Cavity Voltage.  The control logic monitors the
;188 //  difference between the Active Setpoint and Cavity Voltage and turns on
;189 //  the LED if the difference exceeds the threshold set by the Regulation
;190 //  Error parameter.
;191 //
;192 //  The DEE VOLTAGE digital voltage meter normally displays the RF Cavity
;193 //  Voltage.  Whenever the INITIAL or FINAL pushbutton is being pressed, th
;194 //  controller displays the RF-OFF or the RF-ON Setpoint, respectively.
;195 //
;196 //  The Optical encoder knob is used to change the RF-OFF Setpoint
;197 //  (INITIAL/cold) or RF-ON Setpoint (FINAL/warm) values as follows:
;198 //
;199 //   - The RF-OFF Setpoint can be adjusted via the front panel by turning
;200 //     the knob while pressing and holding the INITIAL button.  This operat
;201 //     is independent of the position of the LOCAL/REMOTE switch.
;202 //
;203 //   - The RF-ON Setpoint can be adjusted via the front panel by setting
;204 //     the LOCAL/REMOTE switch to the LOCAL position and turning the knob.
;205 //     NOTE that the meter continues to display the RF Cavity Voltage unles
;206 //     you are also pressing the FINAL button.
;207 //
;208 //  The OPEN/CLOSED LOOP toggle switch determines whether or not the analog
;209 //  feedback loop is operational.  In the OPEN position, the feedback loop
;210 //  is disabled and the difference between the Active Setpoint and the Cavi
;211 //  Voltage is not used to regulate the Cavity Voltage.
;212 //
;213 //  The RF ON/OFF input enables/disables the RF OUT signal, controls the
;214 //  state of the RF ON LED, and allows the control logic to monitor the
;215 //  ON/OFF state of the RF, which it uses to decide which of the two
;216 //  setpoints the Active Setpoint is ramped toward/set to.
;217 //
;218 //  The RF IN input provides the constant RF input signal.  This signal is
;219 //  amplitude modulated by the feedback loop regulation circuit and feed to
;220 //  the RF OUT connector when the RF is ON.  The amplitude of the resulting
;221 //  RF OUT signal ultimately determines the RF Cavity Voltage.
;222 //
;223 //  The PEAK DETECTOR IN is used along with the Attenuator switches on the
;224 //  front panel to derive the RF Cavity Voltage.
;225 //
;226 //-------------------------------------------------------------------------
;227 
;228 #include <common.h>
;229 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
;230 #include <unistd.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
_LIN2SEG	.macro

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

sub 0x0E

or a

rr hl

scf

rr hl

scf

rr hl

scf

rr hl

.endm

	.cseg
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
;231 #include <sys/types.h>
;232 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;233 
;234 //APPLCODE - change to match the name of this file
;235 #ifndef  ApplicSource
;236   #define  ApplicSource  "DVRAppl.c"
;237 #endif
;238 
;239 #ifndef DidRegDefs
;240   #define  DidRegDefs
;241   #include <modbusRegs.c>
	.debug	i 'C:\work\dev\Rabbit_ST\daemons\modbusRegs.c' 29 38 11 7 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\modbus.h' 21 56 10 7 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\DVR\DVRAppl.c' 25 6 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.dseg
_DoReboot_CoilInfo::
	.dw	word _DoReboot
	.db	0
	.dw	word (phys @1)
	.dw	phys @1 >> 16
	.dw	word _setCoil
	.db	0x2
	.debug	G _DoReboot_CoilInfo 32 0
_dlmVersTime_RegInfo::
	.dw	word _dlmVersTime
	.dw	0
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _dlmVersTime_ChgEventVal
	.dw	word _dlmVersTime_MinChg
	.debug	G _dlmVersTime_RegInfo 33 0
_rtosVersTime_RegInfo::
	.dw	word _rtosVersTime
	.dw	0x2
	.dw	word (phys @1+21)
	.dw	phys @1+21 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rtosVersTime_ChgEventVal
	.dw	word _rtosVersTime_MinChg
	.debug	G _rtosVersTime_RegInfo 33 0
_applVersTime_RegInfo::
	.dw	word _applVersTime
	.dw	0x4
	.dw	word (phys @1+34)
	.dw	phys @1+34 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _applVersTime_ChgEventVal
	.dw	word _applVersTime_MinChg
	.debug	G _applVersTime_RegInfo 33 0
_devType__RegInfo::
	.dw	word _devType_
	.dw	0x6
	.dw	word (phys @1+47)
	.dw	phys @1+47 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _devType__ChgEventVal
	.dw	word _devType__MinChg
	.debug	G _devType__RegInfo 33 0
_deviceID__RegInfo::
	.dw	word _deviceID_
	.dw	0x7
	.dw	word (phys @1+56)
	.dw	phys @1+56 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _deviceID__ChgEventVal
	.dw	word _deviceID__MinChg
	.debug	G _deviceID__RegInfo 33 0
_upSecs_RegInfo::
	.dw	word _upSecs
	.dw	0x9
	.dw	word (phys @1+66)
	.dw	phys @1+66 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _upSecs_ChgEventVal
	.dw	word _upSecs_MinChg
	.debug	G _upSecs_RegInfo 33 0
_percentIdle__RegInfo::
	.dw	word _percentIdle_
	.dw	0xb
	.dw	word (phys @1+73)
	.dw	phys @1+73 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _percentIdle__ChgEventVal
	.dw	word _percentIdle__MinChg
	.debug	G _percentIdle__RegInfo 33 0
_numChans_RegInfo::
	.dw	word _numChans
	.dw	0xc
	.dw	word (phys @1+86)
	.dw	phys @1+86 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _numChans_ChgEventVal
	.dw	word _numChans_MinChg
	.debug	G _numChans_RegInfo 33 0
_coilChanMult_RegInfo::
	.dw	word _coilChanMult
	.dw	0xd
	.dw	word (phys @1+95)
	.dw	phys @1+95 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _coilChanMult_ChgEventVal
	.dw	word _coilChanMult_MinChg
	.debug	G _coilChanMult_RegInfo 33 0
_reg3ChanMult_RegInfo::
	.dw	word _reg3ChanMult
	.dw	0xe
	.dw	word (phys @1+108)
	.dw	phys @1+108 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reg3ChanMult_ChgEventVal
	.dw	word _reg3ChanMult_MinChg
	.debug	G _reg3ChanMult_RegInfo 33 0
_reg4ChanMult_RegInfo::
	.dw	word _reg4ChanMult
	.dw	0xf
	.dw	word (phys @1+121)
	.dw	phys @1+121 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reg4ChanMult_ChgEventVal
	.dw	word _reg4ChanMult_MinChg
	.debug	G _reg4ChanMult_RegInfo 33 0
_digInBits_RegInfo::
	.dw	word _digInBits
	.dw	0x10
	.dw	word (phys @1+134)
	.dw	phys @1+134 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _digInBits_ChgEventVal
	.dw	word _digInBits_MinChg
	.debug	G _digInBits_RegInfo 33 0
_statusBitsStdA_RegInfo::
	.dw	word _statusBitsStdA
	.dw	0x12
	.dw	word (phys @1+144)
	.dw	phys @1+144 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsStdA_ChgEventVal
	.dw	word _statusBitsStdA_MinChg
	.debug	G _statusBitsStdA_RegInfo 33 0
_statusBitsStdB_RegInfo::
	.dw	word _statusBitsStdB
	.dw	0x13
	.dw	word (phys @1+159)
	.dw	phys @1+159 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsStdB_ChgEventVal
	.dw	word _statusBitsStdB_MinChg
	.debug	G _statusBitsStdB_RegInfo 33 0
_statusBitsAppl_RegInfo::
	.dw	word _statusBitsAppl
	.dw	0x14
	.dw	word (phys @1+174)
	.dw	phys @1+174 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsAppl_ChgEventVal
	.dw	word _statusBitsAppl_MinChg
	.debug	G _statusBitsAppl_RegInfo 33 0
_cavityVolts_RegInfo::
	.dw	word _cavityVolts
	.dw	0x16
	.dw	word (phys @1+189)
	.dw	phys @1+189 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavityVolts_ChgEventVal
	.dw	word _cavityVolts_MinChg
	.debug	G _cavityVolts_RegInfo 33 0
_activeSetpoint_RegInfo::
	.dw	word _activeSetpoint
	.dw	0x18
	.dw	word (phys @1+201)
	.dw	phys @1+201 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _activeSetpoint_ChgEventVal
	.dw	word _activeSetpoint_MinChg
	.debug	G _activeSetpoint_RegInfo 33 0
_regulationError_RegInfo::
	.dw	word _regulationError
	.dw	0x1a
	.dw	word (phys @1+216)
	.dw	phys @1+216 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _regulationError_ChgEventVal
	.dw	word _regulationError_MinChg
	.debug	G _regulationError_RegInfo 33 0
_limiterVolts_RegInfo::
	.dw	word _limiterVolts
	.dw	0x1c
	.dw	word (phys @1+232)
	.dw	phys @1+232 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _limiterVolts_ChgEventVal
	.dw	word _limiterVolts_MinChg
	.debug	G _limiterVolts_RegInfo 33 0
_rampMode_RegInfo::
	.dw	word _rampMode
	.dw	0x1e
	.dw	word (phys @1+245)
	.dw	phys @1+245 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rampMode_ChgEventVal
	.dw	word _rampMode_MinChg
	.debug	G _rampMode_RegInfo 33 0
_hdwCfg_RegInfo::
	.dw	word _hdwCfg
	.dw	0x1f
	.dw	word (phys @1+254)
	.dw	phys @1+254 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _hdwCfg_ChgEventVal
	.dw	word _hdwCfg_MinChg
	.debug	G _hdwCfg_RegInfo 33 0
_latency_RegInfo::
	.dw	word _latency
	.dw	0x20
	.dw	word (phys @1+261)
	.dw	phys @1+261 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _latency_ChgEventVal
	.dw	word _latency_MinChg
	.debug	G _latency_RegInfo 33 0
_tcpTickTime_RegInfo::
	.dw	word _tcpTickTime
	.dw	0x21
	.dw	word (phys @1+269)
	.dw	phys @1+269 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _tcpTickTime_ChgEventVal
	.dw	word _tcpTickTime_MinChg
	.debug	G _tcpTickTime_RegInfo 33 0
_applLoopTime_RegInfo::
	.dw	word _applLoopTime
	.dw	0x22
	.dw	word (phys @1+281)
	.dw	phys @1+281 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _applLoopTime_ChgEventVal
	.dw	word _applLoopTime_MinChg
	.debug	G _applLoopTime_RegInfo 33 0
_kernelLoopTime_RegInfo::
	.dw	word _kernelLoopTime
	.dw	0x23
	.dw	word (phys @1+294)
	.dw	phys @1+294 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _kernelLoopTime_ChgEventVal
	.dw	word _kernelLoopTime_MinChg
	.debug	G _kernelLoopTime_RegInfo 33 0
_hdwCfgVolts_RegInfo::
	.dw	word _hdwCfgVolts
	.dw	0x24
	.dw	word (phys @1+309)
	.dw	phys @1+309 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _hdwCfgVolts_ChgEventVal
	.dw	word _hdwCfgVolts_MinChg
	.debug	G _hdwCfgVolts_RegInfo 33 0
	.defseg	CONST
	.seg	CONST
_ModeDesc::
	.dw	@2
	.dw	@2+5
	.dw	@2+10
	.dw	@2+15
	.debug	G _ModeDesc 34 0
	.dseg
_timeZone__RegInfo::
	.dw	word _timeZone_
	.dw	0
	.dw	word (phys @1+321)
	.dw	phys @1+321 >> 16
	.dw	word _MB_timeZone
	.db	0
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _timeZone__ChgEventVal
	.dw	word _timeZone__MinChg
	.debug	G _timeZone__RegInfo 33 0
_curTime_RegInfo::
	.dw	word _curTime
	.dw	0x1
	.dw	word (phys @1+331)
	.dw	phys @1+331 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _curTime_ChgEventVal
	.dw	word _curTime_MinChg
	.debug	G _curTime_RegInfo 33 0
_ipAddr_RegInfo::
	.dw	word _ipAddr
	.dw	0x3
	.dw	word (phys @1+339)
	.dw	phys @1+339 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _ipAddr_ChgEventVal
	.dw	word _ipAddr_MinChg
	.debug	G _ipAddr_RegInfo 33 0
_netmask_RegInfo::
	.dw	word _netmask
	.dw	0x5
	.dw	word (phys @1+346)
	.dw	phys @1+346 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _netmask_ChgEventVal
	.dw	word _netmask_MinChg
	.debug	G _netmask_RegInfo 33 0
_gateway_RegInfo::
	.dw	word _gateway
	.dw	0x7
	.dw	word (phys @1+354)
	.dw	phys @1+354 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _gateway_ChgEventVal
	.dw	word _gateway_MinChg
	.debug	G _gateway_RegInfo 33 0
_setACoil_RegInfo::
	.dw	word _setACoil
	.dw	0x9
	.dw	word (phys @1+362)
	.dw	phys @1+362 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x3
	.db	0
	.db	0
	.dw	word _setACoil_ChgEventVal
	.dw	word _setACoil_MinChg
	.debug	G _setACoil_RegInfo 33 0
_resetACoil_RegInfo::
	.dw	word _resetACoil
	.dw	0xa
	.dw	word (phys @1+371)
	.dw	phys @1+371 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x3
	.db	0
	.db	0
	.dw	word _resetACoil_ChgEventVal
	.dw	word _resetACoil_MinChg
	.debug	G _resetACoil_RegInfo 33 0
_digOutBits_RegInfo::
	.dw	word _digOutBits
	.dw	0xb
	.dw	word (phys @1+382)
	.dw	phys @1+382 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _digOutBits_ChgEventVal
	.dw	word _digOutBits_MinChg
	.debug	G _digOutBits_RegInfo 33 0
_cmdBitsStd_RegInfo::
	.dw	word _cmdBitsStd
	.dw	0xd
	.dw	word (phys @1+393)
	.dw	phys @1+393 >> 16
	.dw	word _MB_cmdBitsStd
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cmdBitsStd_ChgEventVal
	.dw	word _cmdBitsStd_MinChg
	.debug	G _cmdBitsStd_RegInfo 33 0
_cmdBitsAppl_RegInfo::
	.dw	word _cmdBitsAppl
	.dw	0xf
	.dw	word (phys @1+404)
	.dw	phys @1+404 >> 16
	.dw	word _MB_cmdBitsAppl
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cmdBitsAppl_ChgEventVal
	.dw	word _cmdBitsAppl_MinChg
	.debug	G _cmdBitsAppl_RegInfo 33 0
_rfOnSetpoint_RegInfo::
	.dw	word _rfOnSetpoint
	.dw	0x11
	.dw	word (phys @1+416)
	.dw	phys @1+416 >> 16
	.dw	word _MB_rfOnSetpoint
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfOnSetpoint_ChgEventVal
	.dw	word _rfOnSetpoint_MinChg
	.debug	G _rfOnSetpoint_RegInfo 33 0
_rfOffSetpoint_RegInfo::
	.dw	word _rfOffSetpoint
	.dw	0x13
	.dw	word (phys @1+429)
	.dw	phys @1+429 >> 16
	.dw	word _MB_rfOffSetpoint
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfOffSetpoint_ChgEventVal
	.dw	word _rfOffSetpoint_MinChg
	.debug	G _rfOffSetpoint_RegInfo 33 0
_coldRampRate_RegInfo::
	.dw	word _coldRampRate
	.dw	0x15
	.dw	word (phys @1+443)
	.dw	phys @1+443 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _coldRampRate_ChgEventVal
	.dw	word _coldRampRate_MinChg
	.debug	G _coldRampRate_RegInfo 33 0
_warmRampRate_RegInfo::
	.dw	word _warmRampRate
	.dw	0x17
	.dw	word (phys @1+456)
	.dw	phys @1+456 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _warmRampRate_ChgEventVal
	.dw	word _warmRampRate_MinChg
	.debug	G _warmRampRate_RegInfo 33 0
_offToOnDelay_RegInfo::
	.dw	word _offToOnDelay
	.dw	0x19
	.dw	word (phys @1+469)
	.dw	phys @1+469 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _offToOnDelay_ChgEventVal
	.dw	word _offToOnDelay_MinChg
	.debug	G _offToOnDelay_RegInfo 33 0
_maxRegErr_RegInfo::
	.dw	word _maxRegErr
	.dw	0x1a
	.dw	word (phys @1+482)
	.dw	phys @1+482 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _maxRegErr_ChgEventVal
	.dw	word _maxRegErr_MinChg
	.debug	G _maxRegErr_RegInfo 33 0
_limiterActiveV_RegInfo::
	.dw	word _limiterActiveV
	.dw	0x1c
	.dw	word (phys @1+492)
	.dw	phys @1+492 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _limiterActiveV_ChgEventVal
	.dw	word _limiterActiveV_MinChg
	.debug	G _limiterActiveV_RegInfo 33 0
_knobRate_RegInfo::
	.dw	word _knobRate
	.dw	0x1e
	.dw	word (phys @1+507)
	.dw	phys @1+507 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _knobRate_ChgEventVal
	.dw	word _knobRate_MinChg
	.debug	G _knobRate_RegInfo 33 0
_maxOffSetpoint_RegInfo::
	.dw	word _maxOffSetpoint
	.dw	0x20
	.dw	word (phys @1+516)
	.dw	phys @1+516 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _maxOffSetpoint_ChgEventVal
	.dw	word _maxOffSetpoint_MinChg
	.debug	G _maxOffSetpoint_RegInfo 33 0
_maxOnSetpoint_RegInfo::
	.dw	word _maxOnSetpoint
	.dw	0x22
	.dw	word (phys @1+531)
	.dw	phys @1+531 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _maxOnSetpoint_ChgEventVal
	.dw	word _maxOnSetpoint_MinChg
	.debug	G _maxOnSetpoint_RegInfo 33 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\DVR\DVRAppl.c' 25 6 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\DVR\DVRAppl.c' 25 6 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\DVR\DVRAppl.c' 25 6 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\DVR\DVRAppl.c' 25 6 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_c0Coils::
	.dw	word _DoReboot_CoilInfo
	.dw	0
	.debug	G _c0Coils 36 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\DVR\DVRAppl.c' 25 6 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_r3Regs::
	.dw	word _dlmVersTime_RegInfo
	.dw	word _dlmVersTime_RegInfo
	.dw	word _rtosVersTime_RegInfo
	.dw	word _rtosVersTime_RegInfo
	.dw	word _applVersTime_RegInfo
	.dw	word _applVersTime_RegInfo
	.dw	word _devType__RegInfo
	.dw	word _deviceID__RegInfo
	.dw	word _deviceID__RegInfo
	.dw	word _upSecs_RegInfo
	.dw	word _upSecs_RegInfo
	.dw	word _percentIdle__RegInfo
	.dw	word _numChans_RegInfo
	.dw	word _coilChanMult_RegInfo
	.dw	word _reg3ChanMult_RegInfo
	.dw	word _reg4ChanMult_RegInfo
	.dw	word _digInBits_RegInfo
	.dw	word _digInBits_RegInfo
	.dw	word _statusBitsStdA_RegInfo
	.dw	word _statusBitsStdB_RegInfo
	.dw	word _statusBitsAppl_RegInfo
	.dw	word _statusBitsAppl_RegInfo
	.dw	word _cavityVolts_RegInfo
	.dw	word _cavityVolts_RegInfo
	.dw	word _activeSetpoint_RegInfo
	.dw	word _activeSetpoint_RegInfo
	.dw	word _regulationError_RegInfo
	.dw	word _regulationError_RegInfo
	.dw	word _limiterVolts_RegInfo
	.dw	word _limiterVolts_RegInfo
	.dw	word _rampMode_RegInfo
	.dw	word _hdwCfg_RegInfo
	.dw	word _latency_RegInfo
	.dw	word _tcpTickTime_RegInfo
	.dw	word _applLoopTime_RegInfo
	.dw	word _kernelLoopTime_RegInfo
	.dw	word _hdwCfgVolts_RegInfo
	.dw	word _hdwCfgVolts_RegInfo
	.dw	0
	.debug	G _r3Regs 38 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\DVR\DVRAppl.c' 25 6 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_r4Regs::
	.dw	word _timeZone__RegInfo
	.dw	word _curTime_RegInfo
	.dw	word _curTime_RegInfo
	.dw	word _ipAddr_RegInfo
	.dw	word _ipAddr_RegInfo
	.dw	word _netmask_RegInfo
	.dw	word _netmask_RegInfo
	.dw	word _gateway_RegInfo
	.dw	word _gateway_RegInfo
	.dw	word _setACoil_RegInfo
	.dw	word _resetACoil_RegInfo
	.dw	word _digOutBits_RegInfo
	.dw	word _digOutBits_RegInfo
	.dw	word _cmdBitsStd_RegInfo
	.dw	word _cmdBitsStd_RegInfo
	.dw	word _cmdBitsAppl_RegInfo
	.dw	word _cmdBitsAppl_RegInfo
	.dw	word _rfOnSetpoint_RegInfo
	.dw	word _rfOnSetpoint_RegInfo
	.dw	word _rfOffSetpoint_RegInfo
	.dw	word _rfOffSetpoint_RegInfo
	.dw	word _coldRampRate_RegInfo
	.dw	word _coldRampRate_RegInfo
	.dw	word _warmRampRate_RegInfo
	.dw	word _warmRampRate_RegInfo
	.dw	word _offToOnDelay_RegInfo
	.dw	word _maxRegErr_RegInfo
	.dw	word _maxRegErr_RegInfo
	.dw	word _limiterActiveV_RegInfo
	.dw	word _limiterActiveV_RegInfo
	.dw	word _knobRate_RegInfo
	.dw	word _knobRate_RegInfo
	.dw	word _maxOffSetpoint_RegInfo
	.dw	word _maxOffSetpoint_RegInfo
	.dw	word _maxOnSetpoint_RegInfo
	.dw	word _maxOnSetpoint_RegInfo
	.dw	0
	.debug	G _r4Regs 40 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\DVR\DVRAppl.c' 25 6 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_nonRegPVs::
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
	.db	0
	.db	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.debug	G _nonRegPVs 41 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\DVR\DVRAppl.c' 25 6 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;242 #endif
;243 #ifndef RegDefs
;244 
;245 
;246 //APPLCODE - change to the application name
;247 const char far applName[] = { "DVR" };
	.defseg	FARCONST
	.seg	FARCONST
_applName::
	.db	"DVR",0
	.debug	G _applName 43 8
;248 const char ApplAbbrev[] = { "DVR" };
	.seg	CONST
_ApplAbbrev::
	.db	"DVR",0
	.debug	G _ApplAbbrev 43 0
;249 
;250 //APPLCODE - add ID to unistd.h and place it here
;251 #define DeviceType  DT_DVR
;252 
;253 //APPLCODE - set the # of input and outputs used
;254 #define  NUM_APPL_AIN      4   // analog inputs used
;255 #define  NUM_APPL_AOUT     2   // analog outputs used
;256 #define  NUM_APPL_DIN      5   // digital inputs used
;257 #define  NUM_APPL_DOUT     2   // digital outputs used
;258 
;259 #define  ADC_MASK_APPL  0x0000000FL
;260 #define  DAC_MASK_APPL  0x00000003L
;261 
;262 //APPLCODE - set to state we want outputs in during initialization
;263 #define InitialDigOutState  ( 0 )
;264 
;265 
;266 #define SharedINC
;267 #include <sharedAppl.c>
;268 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\srfs.h' 6 17 10 7 4 28
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\spi.h' 12 54 10 3 8 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\epics_cad.h' 8 56 9 31 7 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\DLMiii.h' 3 21 14 4 6 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\inetd.h' 23 39 13 12 5 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\applic.h' 28 10 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\tsh.h' 3 45 16 21 3 28
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\ctype.h' 22 48 13 9 7 24
	.dseg
_consCfg::
	.dw	0xffffc200, 0x1
	.dw	0x1
	.debug	G _consCfg 44 0
	.seg	CONST
_NumApplAIN::
	.dw	0x4
	.debug	G _NumApplAIN 7 0
_NumApplAOUT::
	.dw	0x2
	.debug	G _NumApplAOUT 7 0
_NumApplDIN::
	.dw	0x5
	.debug	G _NumApplDIN 7 0
_NumApplDOUT::
	.dw	0x2
	.debug	G _NumApplDOUT 7 0
_NumExtraIn::
	.dw	0x20
	.debug	G _NumExtraIn 7 0
;269 
;270 
;271 //=========================================================================
;272 //  definitions related to use of the Digital and Analog I/O signals
;273 //=========================================================================
;274 
;275 //APPLCODE - define macros for each Digital bit and each Analog index
;276 
;277 //=============== digitalIn bit usage ===============
;278 #define  CLOSED_LOOP     0x00000001  // 0=Open Loop, 1=Closed Loop
;279 #define  FINAL_BTN       0x00000002  // 1=SET button being pushed
;280 #define  INITIAL_BTN     0x00000004  // 1=INITIAL button being pushed
;281 #define  RF_IS_OFF       0x00000008  // 1=RF is OFF, 0=RF is ON
;282 #define  LOC_REM_SW      0x00000010  // 1=Local, 0=Remote
;283 
;284 const uchar  LogicOrderDIn[NUM_APPL_DIN] =  { 0, 1, 2, 3, 4 };
_LogicOrderDIn::
	.db	0
	.db	0x1
	.db	0x2
	.db	0x3
	.db	0x4
	.debug	G _LogicOrderDIn 45 0
;285 
;286 #define  ClosedLoop(din)        ( (bool)((din) & CLOSED_LOOP) )
;287 #define  FinalBtnPushed(din)    ( (bool)((din) & FINAL_BTN) )
;288 #define  InitialBtnPushed(din)  ( (bool)((din) & INITIAL_BTN) )
;289 #define  RFisOff(din)           ( (bool)((din) & RF_IS_OFF) )
;290 #define  LocalMode(din)         ( (bool)((din) & LOC_REM_SW) )
;291 
;292 //--- msgs to log automatically when a digital input changes state ---
;293 //--- use NULL for bits that we don't want to log changes for ---
;294 const char far *digInDescr[NUM_APPL_DIN*2] = {
;295 //--0 state descr--                  --1 state descr--
;296   "OPEN Loop",                       "CLOSED Loop",
	.dseg
_digInDescr::
	.dw	word (phys @1+545)
	.dw	phys @1+545 >> 16
	.dw	word (phys @1+555)
	.dw	phys @1+555 >> 16
;297   "FINAL setpoint btn released",     "FINAL setpoint btn pressed",
	.dw	word (phys @1+567)
	.dw	phys @1+567 >> 16
	.dw	word (phys @1+595)
	.dw	phys @1+595 >> 16
;298   "INITIAL setpoint btn released",   "INITIAL setpoint btn pressed",
	.dw	word (phys @1+622)
	.dw	phys @1+622 >> 16
	.dw	word (phys @1+652)
	.dw	phys @1+652 >> 16
;299   "RF ON",                           "RF OFF",
	.dw	word (phys @1+681)
	.dw	phys @1+681 >> 16
	.dw	word (phys @1+687)
	.dw	phys @1+687 >> 16
;300   "REMOTE mode",                     "LOCAL mode"
	.dw	word (phys @1+694)
	.dw	phys @1+694 >> 16
;301 };
	.dw	word (phys @1+706)
	.dw	phys @1+706 >> 16
	.debug	G _digInDescr 46 0
;302 
;303 
;304 //=============== digitalOut bit usage ===============
;305 #define  LIMITED_LED     0x00000001   // 1=On, 0=Off
;306 #define  ERROR_LED       0x00000002   // 1=On, 0=Off
;307 #define  LED_BITS        0x00000003   // bits for all LEDs
;308 
;309 #define  ActivityLED     0x00000100L
;310 
;311 const uchar  LogicOrderDOut[NUM_APPL_DOUT] =  { 0, 1 };
	.seg	CONST
_LogicOrderDOut::
	.db	0
	.db	0x1
	.debug	G _LogicOrderDOut 48 0
;312 
;313 #define SetOffApplLEDs(dout)   ClearBits((dout), LED_BITS)
;314 
;315 #define SetOnLimitLED(dout)   SetBits((dout), LIMITED_LED)
;316 #define SetOnErrorLED(dout)   SetBits((dout), ERROR_LED)
;317 
;318 #define  TurnOnActivityLED()    ClearBits(Next.digitalOut, ActivityLED)
;319 #define  TurnOffActivityLED()   SetBits(Next.digitalOut, ActivityLED)
;320 
;321 //--- msgs to log automatically when a digital output changes state ---
;322 //--- use NULL for bits that we don't want to log changes for ---
;323 const char far *digOutDescr[NUM_APPL_DOUT*2] = {
;324 //--0 state descr--    --1 state descr--
;325   "Limited LED Off",   "Limited LED On",
	.dseg
_digOutDescr::
	.dw	word (phys @1+717)
	.dw	phys @1+717 >> 16
	.dw	word (phys @1+733)
	.dw	phys @1+733 >> 16
;326   "Error LED Off",     "Error LED On"
	.dw	word (phys @1+748)
	.dw	phys @1+748 >> 16
;327 };
	.dw	word (phys @1+762)
	.dw	phys @1+762 >> 16
	.debug	G _digOutDescr 49 0
;328 
;329 
;330 
;331 //=============== Analog inputs ===============
;332 #define  RF_CAV_VOLT      0  // RF cavity voltage
;333 #define  LIMITER_VOLT     1  // Setpoint Limiter voltage
;334 #define  UNUSED_V2        2
;335 #define  HDW_CFG          3  // Fixed volt indicating HD1 component set
;336 
;337 const uchar  LogicOrderAIn[NUM_APPL_AIN] = { 0, 1, 2, 3 };
	.seg	CONST
_LogicOrderAIn::
	.db	0
	.db	0x1
	.db	0x2
	.db	0x3
	.debug	G _LogicOrderAIn 43 0
;338 
;339 //--- 5.07V divided in to 8 steps ---
;340 #define  HdwConfig(ain)         ( (uint)(((5.07 - FABS(ain)) * 1.5779) + 0.
;341 /*
;342   Resistor bridge on HD1 that this reads:
;343 
;344   (0)  5.07V --   0K -- 100K -- Gnd  ==>  5.07V  (a short)
;345   (1)  5.07V --  15K -- 100K -- Gnd  ==>  4.4V
;346   (2)  5.07V --  33K -- 100K -- Gnd  ==>  3.8V
;347   (3)  5.07V --  62K -- 100K -- Gnd  ==>  3.13V
;348   (4)  5.07V -- 100K -- 100K -- Gnd  ==>  2.54V
;349   (5)  5.07V -- 167K -- 100K -- Gnd  ==>  1.90V
;350   (6)  5.07V -- 300K -- 100K -- Gnd  ==>  1.27V
;351   (7)  5.07V -- 700K -- 100K -- Gnd  ==>  0.63V
;352   (8)  5.07V -- open -- 100K -- Gnd  ==>  0.0V   (open)
;353 */
;354 static char *HdwCfgDesc[9] = { "RSVD0", "K500 ", "K1200", "RSVD3",
	.dseg
_HdwCfgDesc:
	.dw	@2+20
	.dw	@2+26
	.dw	@2+32
	.dw	@2+38
;355                                "RSVD4", "RSVD5", "RSVD6", "RSVD7", "ERROR" 
	.dw	@2+44
	.dw	@2+50
	.dw	@2+56
	.dw	@2+62
	.dw	@2+68
;356 
;357 //--- values for HdwConfig() ---
;358 #define  RSVD0_CFG        0   // not used
;359 #define  K500_CFG         1   // Header sets hdw gains for K500 use
;360 #define  K1200_CFG        2   // Header sets hdw gains for K1200 use
;361 #define  RSVD3_CFG        3   // reserved for future
;362 #define  RSVD4_CFG        4   // reserved for future
;363 #define  RSVD5_CFG        5   // reserved for future
;364 #define  RSVD6_CFG        6   // reserved for future
;365 #define  RSVD7_CFG        7   // reserved for future
;366 #define  ERROR_CFG        8   // no resistor
;367 
;368 
;369 //=============== Anlog outputs ===============
;370 #define  SETPOINT         0  // Setpoint for Cav Voltage Regulator circuit
;371 #define  FP_METER         1  // FrontPanel Meter if INITIAL or SET pressed
;372 
;373 const uchar  LogicOrderAOut[NUM_APPL_AOUT] = { 0, 1 };
	.seg	CONST
_LogicOrderAOut::
	.db	0
	.db	0x1
	.debug	G _LogicOrderAOut 48 0
;374 
;375 
;376 //=========================================================================
;377 //  Application-specific data structures and definitions
;378 //=========================================================================
;379 
;380 //-------------------------------------------------------------------------
;381 //  Each value in the ApplState structure should be throught of as represen
;382 //  a "signal" in a clocked logic circuit, with the "applic" task represent
;383 //  the logic implemented by the circuit elements such as gates, latches, e
;384 //
;385 //  The main "applic" task is the highest priority task and executes the co
;386 //  that implements the application logic on a real-time, periodic basis.
;387 //
;388 //                  ====== IMPORTANT NOTE on LOCKING ======
;389 //
;390 //  Remember to use a semaphore or some other form of locking mechanism to
;391 //  protect all access to shared values by more than one task.  The only
;392 //  exception to this is when the applic task needs to access a value prote
;393 //  by other tasks using only a scheduler/kernel lock (the KLOCK and KUNLOC
;394 //  macros).  Because the applic task is the only task that runs at the hig
;395 //  priority, no other task can preempt it, and if the scheduler is locked,
;396 //  the applic task cannot preempt another task.  But scheduler locks must 
;397 //  kept short to avoid creating large latency in the timely execution of o
;398 //  tasks (the applic task in particular).
;399 //
;400 //-------------------------------------------------------------------------
;401 // Values that belong in the ApplState structure:
;402 //
;403 //   - Ones that are required for a "soft" reset to work.  A soft reset is
;404 //     the same as a regular (hdw) reset except that it does not involve an
;405 //     actual CPU reset.  This allows properly constructed code to avoid
;406 //     changes to the analog and digital outputs during a reset, allowing
;407 //     certain otherwise unrecoverable problems to be handled with a minimu
;408 //     amount of disruption to operations.  The 3 instances of the ApplStat
;409 //     structure are saved and restored for all applications that support
;410 //     soft resets.
;411 //
;412 //     The problem experienced at the NSCL this was created to address is
;413 //     controllers in which the values write-protected portions of RAM can
;414 //     change (without causing a write protection fault!).  As this problem
;415 //     seems connected to the physical location of a controller (i.e.
;416 //     controllers running the same code in other areas do not have the
;417 //     problem), it is apparently being caused by some (as yet) unidentifie
;418 //     environmental condition (heat, power spikes, maybe even energetic
;419 //     particles).
;420 //
;421 //   - Values for which we need to be able to track changes between cycles
;422 //     (e.g. is curState.X different than prevState.X?)
;423 //
;424 //-------------------------------------------------------------------------
;425 
;426 typedef struct {
;427  //-----------------------------------------------------------------------
;428  // SOFTWARE SETTING INPUTS
;429  //
;430  //  These values represent Software Inputs to the application logic.
;431  //
;432  //  These values are set in the "Next" instance by tasks OTHER than the
;433  //  "applic" task to change some value used by the application logic.
;434  //  Remember that all tasks besides the main "applic" task must use a
;435  //  scheduler lock to protect reads and writes to these values.
;436  //
;437  //  Note that the application task may alter these values (e.g. to change
;438  //  an invalid value in to a valid one).
;439  //-----------------------------------------------------------------------
;440 
;441 
;442  //-----------------------------------------------------------------------
;443  // READINGS
;444  //
;445  //  These values represent "passive" inputs to the application logic.
;446  //
;447  //  These values are set in the "Next" instance by the applic task just
;448  //  after reading the state of the hardware inputs.
;449  //
;450  //  These values generally come from one of two sources:
;451  //    - The just-read state of analog and/or digital hardware inputs
;452  //    - Values maintained by other tasks
;453  //
;454  //  While some of these values are simply copies of "external" values,
;455  //  including them in the ApplState structure allows us to see how
;456  //  they change between cycles.  Also, some of these values are the result
;457  //  of applying logic to "external" values.  Applying that logic once at
;458  //  at the beginning of the applic loop and saving the result eliminates
;459  //  the need to repeat the same logic in multiple blocks of code later on,
;460  //  avoiding unnecessary redundancy.
;461  //-----------------------------------------------------------------------
;462   ulong  digitalIn;
;463 
;464   ulong  processTime;  // ms time applic loop started on applic-specific co
;465 
;466   bool   rfIsOn;       // RF ON digital input
;467 
;468   bool   localMode;    // LOCAL/REMOTE switch is in LOCAL position
;469   bool   closedLoop;   // OPEN/CLOSED LOOP switch is in CLOSED position
;470 
;471  //-----------------------------------------------------------------------
;472  // OUTPUTS from UN-CLOCKED (asynchronous, gate-level) LOGIC ELEMENTS
;473  //
;474  //  These values are outputs from one of the blocks of code in the applic
;475  //  task that represent a non-clocked logic element (such as a gate).
;476  //
;477  //  Each value here is set by one (and ONLY one) of the blocks of code in
;478  //  the applic task.  This group contains ONLY values that are set by a
;479  //  block of code that represents a NON-clocked logic element.
;480  //
;481  //  These values are set in the "Next" instance by the applic task just
;482  //  after reading the state of the hardware inputs.  These values must
;483  //  NOT be altered by other tasks (although they can read them as long
;484  //  as they use appropriate locking to do so).
;485  //
;486  //  Because these values represent the outputs of un-clocked logic element
;487  //  and such elements often need to be cascaded (the outputs used as input
;488  //  to other non-clocked elements), the result is often dependent on the
;489  //  order of execution of the blocks of code.
;490  //-----------------------------------------------------------------------
;491 
;492 
;493  //-----------------------------------------------------------------------
;494  // OUTPUTS from CLOCKED (latched inputs and outputs) LOGIC ELEMENTS
;495  //
;496  //  These values are outputs from one of the blocks of code in the applic
;497  //  task that represent a clocked logic element (such as latches).
;498  //
;499  //  Each value here is set by one (and ONLY one) of the blocks of code in
;500  //  the applic task.  This group contains only values that are set by a
;501  //  block of code that represents a CLOCKED logic element.
;502  //
;503  //  These values are set in the "Next" instance by the applic task AFTER
;504  //  all the other ApplState values are set.  Because they represent only
;505  //  the clocked logic elements, and each block of code reads only values
;506  //  from the Cur instance, the blocks can be executed in any order and the
;507  //  result will always be the same.
;508  //
;509  //  These values are used as inputs by other blocks and/or to set values
;510  //  used by other tasks (such as values read by the ModBus server task).
;511  //
;512  //  Again, these values must NOT be altered by other tasks (although they
;513  //  can read them as long as they use appropriate locking to do so).
;514  //-----------------------------------------------------------------------
;515   ulong  digitalOut;      // state for digital outputs
;516 
;517   float  activeSetpoint;  // value applied to regulation circuit
;518 
;519   float  rfOnSetpoint;    // warm/final setpoint
;520   float  rfOffSetpoint;   // cold/initial setpoint
;521 
;522 } ApplState;
;523 
;524 
;525 ApplState  prevState, curState, nextState;
;526 
;527 #define  Prev  prevState
;528 #define  Cur   curState
;529 #define  Next  nextState
;530 
;531 const uint ApplStateDataSize =  ( sizeof(ApplState)*3 + sizeof(setVal) );
_ApplStateDataSize::
	.dw	0x59
	.debug	G _ApplStateDataSize 7 0
;532 
;533 
;534 
;535 int  knobTicks;
;536 
;537 float  diff, maxChg;
;538 
;539 ulong  msSincePrev;
;540 
;541 bool  initialBtnPressed, finalBtnPressed, limited, regErr;
;542 
;543 ulong  rfOnTime;   // time RF turned on (in milliseconds)
;544 
;545 float  regulationError;  // diff between setpoint and readback
;546 
;547 
;548 //----------------------------------------------------
;549 // Values that
;550 
;551 //=========================================================================
;552 //  List of daemon processes.  The inetd process listens for connection
;553 //  requests on each port in the list and creates a new instance of the
;554 //  specified process to service each new connection.
;555 //=========================================================================
;556 #include <services.h>
;557 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\services.h' 2 22 6 20 2 29
;558 //APPLCODE - add tasks that service network clients
;559 
;560 //--- service funcs declared the same as standard command funcs:
;561 //     e.g.:   void _task fastdatad(int argc, char **argv);
;562 
;563 void _task tsh(int argc, char **argv);
;564 
;565 
;566 ServiceInfo inetdConf[] = {
;567 //--- add any application-specific inetd-type network services here ---
;568 //--- (add port # names to services.h) ---
;569 //  NAME          PORT           PROTOCOL  FUNC       PRI  -1  Config Param
;570 //  ------------  -------------  --------  ---------- ---  --  ------------
;571 
;572 //--- standard ones defined in sharedAppl.c ---
;573 //{ "console",    TTY0,          ASYNC,    tsh,        10, -1, &consCfg },
;574 //{ "fastdatad",  FASTDATA_PORT, ProtoTCP, fastdatad,   5, -1, NULL },
;575 //{ "modbusTCPd", MODBUS_PORT,   ProtoTCP, modbusTCPd,  6, -1, NULL },
;576 //{ "tsh",        TELNET_PORT,   ProtoTCP, tsh,        10, -1, NULL }
;577 
;578   #define SharedServices
;579   #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.dseg
_inetdConf::
	.dw	@2+74
	.dw	0
	.db	0x3
	.dw	word _tsh
	.db	0xa
	.dw	0xffff
	.dw	word _consCfg
	.ds	6,0
	.dw	@2+82
	.dw	0x7d3
	.db	0x2
	.dw	word _fastdatad
	.db	0x5
	.dw	0xffff
	.dw	0
	.ds	6,0
	.dw	@2+92
	.dw	0x1f6
	.db	0x2
	.dw	word _modbusTCPd
	.db	0x6
	.dw	0xffff
	.dw	0
	.ds	6,0
	.dw	@2+103
	.dw	0x17
	.db	0x2
	.dw	word _tsh
	.db	0xa
	.dw	0xffff
	.dw	0
;580 };
	.ds	6,0
	.debug	G _inetdConf 50 0
;581 
;582 const int  NumServices = sizeof(inetdConf) / sizeof(ServiceInfo);
	.seg	CONST
_NumServices::
	.dw	0x4
	.debug	G _NumServices 6 0
;583 
;584 
;585 
;586 
;587 
;588 //=========================================================================
;589 //  Defintions for variables that are accessable as ModBus registers
;590 //=========================================================================
;591 #else  // end of before-RegDefs portion
;834 #ifndef RegDefs // start of after-RegDefs portion
;835 
;836 
;837 
;838 
;839 //=========================================================================
;840 //  defintions for "parameterized" data values - lists of values that we wa
;841 //  to be "persistent" (i.e. saved to a file and restored on startup)
;842 //=========================================================================
;843 //APPLCODE - settings/values we want saved to/restored from files
;844 
;845 
;846 //--- parameter ID's for data in Device Data/calibration file ---
;847 //-------------------------------------------------------------------------
;848 // WARNING:  ID's can be added, but existing ID's (and the format of the
;849 //           data they represent) should NEVER change!  NOTE:  Existing one
;850 //           can be "eliminated" by changing their name and no longer
;851 //           using them, but never REUSE an old one for something new!!!
;852 //-------------------------------------------------------------------------
;853 //  NOTE:  ID's >= 1000 are rsvd for values shared by most applications
;854 //-------------------------------------------------------------------------
;855 
;856 /*--- examples from sharedAppl.c ---*
;857 #define  AIN_LABELS     1000
;858 #define  AOUT_LABELS    1001
;859 #define  DIN_LABELS     1002
;860 #define  DOUT_LABELS    1003
;861 
;862 #define  TIME_ZONE      1004
;863 #define  SRFS_IP_ADDR   1005
;864 
;865 #define  READ_GAINS     1006
;866 #define  READ_OFFSETS   1007
;867 #define  SET_GAINS      1008
;868 #define  SET_OFFSETS    1009
;869 *-----------------------------------*/
;870 
;871 const ParamData far  devDataParams[] = {
;872 //APPLDATA
;873 //                ID   ---value---  --restoredFunc--
;874   PERSISTENT_VAR(  1,  coldRampRate,    NULL ),
	.seg	FARCONST
_devDataParams::
	.dw	0x1
	.dw	0x4
	.dw	0
	.dl	phys _coldRampRate
	.dl	phys @1+443
	.dw	0
;875   PERSISTENT_VAR(  2,  warmRampRate,    NULL ),
	.dw	0x2
	.dw	0x4
	.dw	0
	.dl	phys _warmRampRate
	.dl	phys @1+456
	.dw	0
;876   PERSISTENT_VAR(  3,  offToOnDelay,    NULL ),
	.dw	0x3
	.dw	0x2
	.dw	0
	.dl	phys _offToOnDelay
	.dl	phys @1+469
	.dw	0
;877   PERSISTENT_VAR(  4,  maxRegErr,       NULL ),
	.dw	0x4
	.dw	0x4
	.dw	0
	.dl	phys _maxRegErr
	.dl	phys @1+482
	.dw	0
;878   PERSISTENT_VAR(  6,  limiterActiveV,  NULL ),
	.dw	0x6
	.dw	0x4
	.dw	0
	.dl	phys _limiterActiveV
	.dl	phys @1+492
	.dw	0
;879   PERSISTENT_VAR(  7,  knobRate,        NULL ),
	.dw	0x7
	.dw	0x4
	.dw	0
	.dl	phys _knobRate
	.dl	phys @1+507
	.dw	0
;880 //  PERSISTENT_VAR(  8,  rfOffSetpoint,   NULL ),  // now in settings
;881 //  PERSISTENT_VAR(  9,  rfOnSetpoint,    NULL ),  // now in settings
;882   PERSISTENT_VAR( 10,  maxOnSetpoint,   NULL ),
	.dw	0xa
	.dw	0x4
	.dw	0
	.dl	phys _maxOnSetpoint
	.dl	phys @1+531
	.dw	0
;883   PERSISTENT_VAR( 11,  maxOffSetpoint,  NULL ),
	.dw	0xb
	.dw	0x4
	.dw	0
	.dl	phys _maxOffSetpoint
	.dl	phys @1+516
	.dw	0
;884 
;885 
;886   #define SharedDevParams
;887   #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.dw	0x3ec
	.dw	0x2
	.dw	0
	.dl	phys _timeZone
	.dl	phys @1+775
	.dw	0
	.dw	0x3ed
	.dw	0x4
	.dw	0
	.dl	phys _srfsIPAddr
	.dl	phys @1+784
	.dw	0
	.dw	0x3e8
	.dw	0x60
	.dw	0x18
	.dl	phys _ainLabel
	.dl	phys @1+795
	.dw	0
	.dw	0x3e9
	.dw	0x30
	.dw	0x18
	.dl	phys _aoutLabel
	.dl	phys @1+804
	.dw	0
	.dw	0x3ea
	.dw	0x78
	.dw	0x18
	.dl	phys _dinLabel
	.dl	phys @1+814
	.dw	0
	.dw	0x3eb
	.dw	0x30
	.dw	0x18
	.dl	phys _doutLabel
	.dl	phys @1+823
	.dw	0
	.dw	0x3ee
	.dw	0x10
	.dw	0
	.dl	phys _readGain
	.dl	phys @1+833
	.dw	0
	.dw	0x3ef
	.dw	0x10
	.dw	0
	.dl	phys _readOffset
	.dl	phys @1+842
	.dw	0
	.dw	0x3f0
	.dw	0x8
	.dw	0
	.dl	phys _setGain
	.dl	phys @1+853
	.dw	0
	.dw	0x3f1
	.dw	0x8
	.dw	0
	.dl	phys _setOffset
	.dl	phys @1+861
	.dw	word _ReadSetCalibsRestore
	.dw	0x3f2
	.dw	0x20
	.dw	0
	.dl	phys _hostName
	.dl	phys @1+871
	.dw	word _hostNameRestore
	.dw	0x3f3
	.dw	0x4
	.dw	0
	.dl	phys _srfsAltAddr
	.dl	phys @1+880
	.dw	0
	.dw	0x3f4
	.dw	0x300
	.dw	0x18
	.dl	phys _extraInLabel
	.dl	phys @1+892
	.dw	0
	.dw	0x3f5
	.dw	0x4
	.dw	0
	.dl	phys _netmask
	.dl	phys @1+346
	.dw	0
	.dw	0x3f6
	.dw	0x4
	.dw	0
	.dl	phys _gateway
	.dl	phys @1+354
	.dw	0
;888 /* Examples from the SharedDevParams entries in sharedAppl.c:
;889   PERSISTENT_VAR( TIME_ZONE,     timeZone,   NULL ),
;890   PERSISTENT_VAR( SRFS_IP_ADDR,  srfsIPAddr, NULL ),
;891 
;892   PERSISTENT_TBL( AIN_LABELS,    ainLabel,  MAX_LABEL_LEN, NULL ),
;893   PERSISTENT_TBL( AOUT_LABELS,   aoutLabel, MAX_LABEL_LEN, NULL ),
;894   PERSISTENT_TBL( DIN_LABELS,    dinLabel,  MAX_LABEL_LEN, NULL ),
;895   PERSISTENT_TBL( DOUT_LABELS,   doutLabel, MAX_LABEL_LEN, NULL ),
;896 
;897   PERSISTENT_TBL( READ_GAINS,    readGain   ,0, NULL ),
;898   PERSISTENT_TBL( READ_OFFSETS,  readOffset ,0, NULL ),
;899   PERSISTENT_TBL( SET_GAINS,     setGain    ,0, NULL ),
;900   PERSISTENT_TBL( SET_OFFSETS,   setOffset  ,0, NULL ),
;901 */
;902   END_PARAM_DATA
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;903 
	.ds	2,0
	.debug	G _devDataParams 52 8
;904 
;905 //----------------------------------------------------
;906 const ParamData far  settingsParams[] = {
;907 //APPLDATA
;908 //                ID   ---value---  --restoredFunc--
;909   PERSISTENT_VAR(  1,  rfOffSetpoint,   NULL ),
_settingsParams::
	.dw	0x1
	.dw	0x4
	.dw	0
	.dl	phys _rfOffSetpoint
	.dl	phys @1+429
	.dw	0
;910   PERSISTENT_VAR(  2,  rfOnSetpoint,    NULL ),
	.dw	0x2
	.dw	0x4
	.dw	0
	.dl	phys _rfOnSetpoint
	.dl	phys @1+416
	.dw	0
;911 
;912   END_PARAM_DATA
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;913 
	.ds	2,0
	.debug	G _settingsParams 54 8
;914 
;915 
;916 //-----------------------------------------------------------------
;917 //  Application-specific values needed to restore the state of the
;918 //  controller following a "soft" reset (i.e. a restart without a
;919 //  CPU reset)
;920 //-----------------------------------------------------------------
;921 //RESTORE_FUNC(myApplStateVar)
;922 
;923 const ParamData far  ctlrStateParams[] = {
;924 // sample values from sharedAppl.c, common to all applications
;925 //                   --ID--  ---value,granularity---  --restoreFunc--
;926 //    PERSISTENT_VARx(  1000,  prevState,               NULL ),
;927 //    PERSISTENT_VARx(  1001,  curState,                NULL ),
;928 //    PERSISTENT_VARx(  1002,  nextState,               NULL ),
;929 //    PERSISTENT_TBL (  1003,  setVal,4,                NULL ),
;930 // // PERSISTENT_TBL (  1004,  shadowRegValues,4,       NULL ),
;931 
;932 //APPLDATA
;933 //    PERSISTENT_VAR (  1,  myApplStateVar,        PVRF(myApplStateVar) ),
;934 
;935 
;936   #define SharedCtlrStateParams
;937   #include <sharedAppl.c>
;938 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;939   END_PARAM_DATA
_ctlrStateParams::
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;940 
	.ds	2,0
	.debug	G _ctlrStateParams 55 8
;941 
;942 
;943 //-------------------------------------------------------------------------
;944 //  A list of parameterized "persistent" data.  Backup copies of such value
;945 //  are stored in files and restored on startup.
;946 //-------------------------------------------------------------------------
;947 
;948 //    Base File Name    Category  ParamData
;949 //    ----------------  --------  ---------
;950 //--- add any application-specific parameterized file defs here ---
;951 //ParamFile  myAppCfgFile =
;952 //  { "myFileName",     PDC_CTLR, myCfgParams     };
;953 
;954 ParamFile  settingsFile =
;955     { "settings",       PDC_SET,  settingsParams  };
	.dseg
_settingsFile::
	.dw	@2+107
	.db	0x4
	.dl	phys _settingsParams
	.ds	42,0
	.debug	G _settingsFile 56 0
;956 
;957 
;958 #define SharedParams
;959 #include <sharedAppl.c>
;960 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_devDataFile::
	.dw	@2+116
	.db	0x3
	.dl	phys _devDataParams
	.dw	0
	.ds	30,0
	.ds	10,0
	.debug	G _devDataFile 56 0
_hdwCfgFile::
	.dw	@2+124
	.db	0x1
	.dl	phys _hdwCfgParams
	.dw	0
	.ds	30,0
	.ds	10,0
	.debug	G _hdwCfgFile 56 0
;961 
;962 ParamFile *paramFiles[] = {
;963   #define SharedParamsList
;964   #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_paramFiles::
	.dw	word _hdwCfgFile
	.dw	word _devDataFile
;965 //--- add any application-specific ParamData references here ---
;966 //  &myAppCfgFile,
;967   &settingsFile
;968 };
	.dw	word _settingsFile
	.debug	G _paramFiles 57 0
;969 
;970 const int NumParamFiles = sizeof(paramFiles) / sizeof(paramFiles[0]);
	.seg	CONST
_NumParamFiles::
	.dw	0x3
	.debug	G _NumParamFiles 6 0
;971 
;972 
;973 //=========================================================================
;974 //  Definitions for event msgs.  Event msgs are the means that other proces
;975 //  use to inform the application process of an event that it needs to hand
;976 //
;977 //  In general, allowing multiple processes to concurrently modify the stat
;978 //  of the controller is a sure recipie for chaos.  By restricting all such
;979 //  changes to the context of a single process, and sending messages to tha
;980 //  process to request changes, we eliminate all such concurrency issues (n
;981 //  the least of which is keeping track of the order of events).
;982 //
;983 //  The most common event is a request for change of state that corresponds
;984 //  a message received from an external client via a protocol like ModBus.
;985 //=========================================================================
;986 
;987 //EVENT_DEF( myEventX )
;988 //EVENT_DEF( myEventY )
;989 
;990 
;991 
;992 //=========================================================================
;993 //  This is where misc global variables should be defined
;994 //=========================================================================
;995 #define SharedGlobals
;996 #include <sharedAppl.c>
;997 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_DigOutInitState::
	.dw	0, 0
	.debug	G _DigOutInitState 9 0
	.dseg
_applicReady::
	.db	0
	.debug	G _applicReady 3 0
_restoredApplState::
	.db	0
	.debug	G _restoredApplState 3 0
_allowSoftReset::
	.db	0
	.debug	G _allowSoftReset 3 0
_startupComplete::
	.db	0
	.debug	G _startupComplete 3 0
;998 //APPLCODE
;999 //--- add definitions for application-specific global variables here ---
;1000 
;1001 
;1002 
;1003 //=========================================================================
;1004 //  Functions referenced in the Modbus register definitions to handle write
;1005 //  specific global values defined as ModBus registers
;1006 //=========================================================================
;1007 
;1008 //APPLCODE - add functions to process writes to ModBus register values
;1009 
;1010 //-------------------------------------------------------------------------
;1011 //  External ModBus client sent a new value for "cmdBitsAppl"
;1012 //
;1013 //  Check the bits that were set and trigger the corresponding events as
;1014 //  appropriate (but do NOT save the new value - just use it to trigger
;1015 //  events)
;1016 //-------------------------------------------------------------------------
;1017 bool _nearcall MB_cmdBitsAppl(SetRegFuncParams)
;1018 {
	.defseg	FARCODE
	.seg	FARCODE
	.align	4
$$MB_cmdBitsAppl::
	ex	(sp),iy
$MB_cmdBitsAppl::
	.debug	G $MB_cmdBitsAppl 59 9
	.debug	{ $MB_cmdBitsAppl 59 1017 @5 @4
	push	ix
	ld	ix,0
	add	ix,sp
;1019 /*
;1020   ulong  cmdBits;
;1021   EventData  eventMsg;  // used by EVENT macro
;1022 
;1023 
;1024   cmdBits = *((ulong *)newVal);
;1025 
;1026   if (cmdBits & x)  EVENT(MyEventX, chan, newVal, sizeof(int)); // w/ data
;1027   if (cmdBits & y)  EVENT(MyEVentY, chan, NULL, 0);             // w/o data
;1028 */
;1029 
;1030   return true;
	ld	a,0x1
;1031 }
@4:
	.debug	} @4 1031

@3	equ	0
	pop	ix
	lret
@5	equ	2
;1032 
;1033 
;1034 //-------------------------------------------------------------------------
;1035 //  External ModBus client sent a new value for the rfOnSetpoint register
;1036 //
;1037 //  Check the new setting and alter output values as appropriate
;1038 //-------------------------------------------------------------------------
;1039 bool MB_rfOnSetpoint(SetRegFuncParams)
;1040 {
	.align	4
$$MB_rfOnSetpoint::
	ex	(sp),iy
$MB_rfOnSetpoint::
	.debug	G $MB_rfOnSetpoint 59 9
	.debug	{ $MB_rfOnSetpoint 59 1039 @8 @7
	push	ix
	ld	ix,0
	add	ix,sp
;1041   if (Cur.localMode)  return false;
	ld	a,(_curState+9)
	or	a,a
	jr	z,@9
	xor	a,a
	jr	@7
;1042 
;1043   _EnterCritical_();  rfOnSetpoint = MB_VAL(float);  _ExitCritical_();
@9:
	ipset	2
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	(_rfOnSetpoint),de
	ld	(_rfOnSetpoint+2),bc
	ipres
;1044 
;1045   return true;
	ld	a,0x1
;1046 }
@7:
	.debug	} @7 1046

@6	equ	0
	pop	ix
	lret
@8	equ	2
;1047 
;1048 
;1049 //-------------------------------------------------------------------------
;1050 //  External ModBus client sent a new value for the rfOffSetpoint register
;1051 //
;1052 //  Check the new setting and alter output values as appropriate
;1053 //-------------------------------------------------------------------------
;1054 bool MB_rfOffSetpoint(SetRegFuncParams)
;1055 {
	.align	4
$$MB_rfOffSetpoint::
	ex	(sp),iy
$MB_rfOffSetpoint::
	.debug	G $MB_rfOffSetpoint 59 9
	.debug	{ $MB_rfOffSetpoint 59 1054 @12 @11
	push	ix
	ld	ix,0
	add	ix,sp
;1056   if (Cur.localMode)  return false;
	ld	a,(_curState+9)
	or	a,a
	jr	z,@13
	xor	a,a
	jr	@11
;1057 
;1058   _EnterCritical_();  rfOffSetpoint = MB_VAL(float);  _ExitCritical_();
@13:
	ipset	2
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	(_rfOffSetpoint),de
	ld	(_rfOffSetpoint+2),bc
	ipres
;1059 
;1060   return true;
	ld	a,0x1
;1061 }
@11:
	.debug	} @11 1061

@10	equ	0
	pop	ix
	lret
@12	equ	2
;1062 
;1063 
;1064 
;1065 //-------------------------------------------------------------------------
;1066 #define SharedFuncs
;1067 #include <sharedAppl.c>
;1068 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
$initModBusRegs::
	.debug	G $initModBusRegs 60 9
	.debug	{ $initModBusRegs 60 454 @16 @15
	ld	hl,0x64
	ld	(_C0ChanMult),hl
	ld	l,0x1
	ld	(_NumC0Chans),hl
	ld	l,0x64
	ld	(_R3ChanMult),hl
	ld	l,0x1
	ld	(_NumR3Chans),hl
	ld	l,0x64
	ld	(_R4ChanMult),hl
	ld	l,0x1
	ld	(_NumR4Chans),hl
	lcall	$pvInitLists
	bool	hl
	jr	z,@17
	ld	a,0x1
	ld	(_doShutdown),a
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@20
	ld	a,0x1
	ld	(_runBackup),a
	ld	(_doReboot),a
@20:
@17:
@15:
	.debug	} @15 464

@14	equ	0
	lret
@16	equ	0
	.align	4
$$MB_timeZone::
	ex	(sp),iy
$MB_timeZone::
	.debug	G $MB_timeZone 59 9
	.debug	{ $MB_timeZone 59 470 @23 @22
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(ix-2),hl
	ld	de,0x7ff4
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@24
	ld	hl,(ix-2)
	ld	de,0x800c
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@25
	jr	z,@25
@24:
	xor	a,a
	jr	@22
@25:
	ld	hl,(ix-2)
	ld	(_timeZone),hl
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@26
	push	hl
	ld	de,word (phys @1+905)
	ld	c,phys @1+905 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
@26:
	ipset	2
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	d,0
	ld	e,(ix+7)
	ex	de,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
	ld	a,0x1
@22:
	.debug	} @22 486

@21	equ	2
	ld	sp,ix
	pop	ix
	lret
@23	equ	4
	.align	4
$$MB_cmdBitsStd::
	ex	(sp),iy
$MB_cmdBitsStd::
	.debug	G $MB_cmdBitsStd 59 9
	.debug	{ $MB_cmdBitsStd 59 494 @29 @28
	ld	hl,-132
	call	__fent##
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@30
	ld	a,0x1
	ld	(_doReboot),a
	ld	(_doShutdown),a
@30:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@31
	ld	a,0x1
	ld	(_doShutdown),a
@31:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@32
	ld	hl,0x1
	push	hl
	ld	hl,_devDataFile
	push	hl
	ld	hl,0x80
	push	hl
	ld	hl,-126+@27
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
@32:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@33
	ld	hl,_devDataFile
	push	hl
	lcall	$loadParamsMsg
	pop	de
@33:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@34
	ld	hl,0x1
	push	hl
	ld	hl,_hdwCfgFile
	push	hl
	ld	hl,0x80
	push	hl
	ld	hl,-126+@27
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
@34:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@35
	ld	hl,_hdwCfgFile
	push	hl
	lcall	$loadParamsMsg
	pop	de
@35:
	ld	a,0x1
@28:
	.debug	} @28 524

@27	equ	132
	ld	sp,ix
	pop	ix
	lret
@29	equ	134
$rwIO::
	.debug	G $rwIO 60 9
	.debug	{ $rwIO 60 531 @38 @37
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-28
	.bseg
@39:
	.ds	2
	.seg	FARCODE
	ld	hl,(@39)
	inc	hl
	ld	(@39),hl
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	inc	l
	ld	(ix-6),hl
	ld	de,(_DAC_Mask)
	ld	bc,(_DAC_Mask+2)
	ld	hl,bc
	or	hl,de
	jp	z,@40
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@43:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jp	nc,@44
	ld	hl,(ix-2)
	ld	de,_updateAOut
	add	hl,de
	ld	(ix-12),hl
	ld	hl,(ix-2)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nc,@48
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_lastSetVal
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fequ##
	jr	z,@49
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_lastSetVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-12)
	ld	(hl),0x1
@49:
@48:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaOut
	add	hl,de
	ex	de,hl
	call	__farcvp##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_lastAnaOut
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fequ##
	jr	z,@52
	ld	hl,(ix-12)
	ld	(hl),0x1
@52:
	ld	hl,(ix-12)
	ld	a,(hl)
	or	a,a
	jp	z,@45
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-2)
	ld	de,_dacForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@54
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_dacForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
	jr	@55
@54:
	ld	hl,(ix-2)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@56
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_setGain
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fdivr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_setOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fadd##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@56:
@55:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fsubr##
	jp	p,@57
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@57:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fsubr##
	jp	m,@58
	jr	z,@58
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@58:
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_lastAnaOut
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fdivr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fadd##
	call	__ftol##
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_dacRaw
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	hl,de
	ld	(ix-4),hl
@45:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	add	hl,hl
	ld	(ix-6),hl
	jp	@43
@44:
@40:
	ld	hl,(_hdwType)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@59
	ld	hl,(@39)
	ld	e,0x1f
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@60
	ld	b,a
@61:
	add	hl,hl
	djnz	@61
@60:
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	hl,de
	ld	(ix-4),hl
@59:
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastReadTime),hl
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	ld	hl,bc
	or	hl,de
	jr	z,@62
	push	bc
	push	de
	lcall	$readAnalogInputs
	add	sp,4
@62:
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	lcall	$ReadDigInputs
	ld	(_digitalIn),de
	ld	(_digitalIn+2),bc
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	ld	(_readTicks),de
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	de,(_DAC_Mask)
	ld	bc,(_DAC_Mask+2)
	ld	hl,bc
	or	hl,de
	jr	z,@63
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	d,h
	ld	e,l
	ld	bc,(_DAC_Mask+2)
	call	__land##
	push	bc
	push	de
	lcall	$writeAnalogOutputs
	add	sp,4
@63:
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	ld	(_writeTicks),de
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	ld	hl,bc
	or	hl,de
	jp	z,@64
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@67:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@68
	ld	hl,(ix-2)
	ld	de,_updateAIn
	add	hl,de
	ld	(ix-12),hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@72
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-12)
	ld	(hl),0x1
@72:
	ld	hl,(ix-12)
	ld	a,(hl)
	or	a,a
	jp	z,@69
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-2)
	ld	de,_adcForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@76
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_adcForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@77
@76:
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
@77:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_anaIn
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@78
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_readOffset
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsubr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_readVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@78:
	ld	hl,(ix-2)
	ld	de,_newRdg
	add	hl,de
	ld	a,0x1
	ld	(hl),a
@69:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@67
@68:
@64:
	lcall	$updateAvgsADC
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
	push	bc
	push	de
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	call	__lsub##
	ld	(_rwTicks),de
@37:
	.debug	} @37 607

@36	equ	28
	ld	sp,ix
	pop	ix
	lret
@38	equ	30
$logDigIOChgs::
	.debug	G $logDigIOChgs 61 9
	.debug	{ $logDigIOChgs 61 613 @81 @80
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	ld	de,(_curState)
	ld	bc,(_curState+2)
	push	bc
	push	de
	ld	de,(_prevState)
	ld	bc,(_prevState+2)
	call	__lxor##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	.seg	FARCODE
	ld	de,(_curState+11)
	ld	bc,(_curState+13)
	push	bc
	push	de
	ld	de,(_prevState+11)
	ld	bc,(_prevState+13)
	call	__lxor##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	.seg	FARCODE
	ld	a,(ix+5)
	or	a,a
	jr	z,@82
	ld	de,word (phys @1+929)
	ld	c,phys @1+929 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@82:
	ld	a,(ix+5)
	or	a,a
	jr	nz,@83
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	or	hl,de
	jp	z,@84
@83:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-2),hl
@87:
	ld	hl,(ix-2)
	ld	de,(_NumApplDIN)
	or	a,a
	sbc	hl,de
	jp	nc,@88
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@92
	ld	a,(ix+5)
	or	a,a
	jr	z,@93
@92:
	ld	hl,(ix-2)
	add	hl,hl
	ld	(ix-4),hl
	ld	de,(_curState)
	ld	bc,(_curState+2)
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@96
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
@96:
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ld	de,_digInDescr
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@97
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+974)
	ld	c,phys @1+974 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
@97:
@93:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@87
@88:
@84:
	ld	a,(ix+5)
	or	a,a
	jr	z,@98
	ld	de,word (phys @1+980)
	ld	c,phys @1+980 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@98:
	ld	a,(ix+5)
	or	a,a
	jr	nz,@99
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	or	hl,de
	jp	z,@100
@99:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-2),hl
@103:
	ld	hl,(ix-2)
	ld	de,(_NumApplDOUT)
	or	a,a
	sbc	hl,de
	jp	nc,@104
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@108
	ld	a,(ix+5)
	or	a,a
	jr	z,@109
@108:
	ld	hl,(ix-2)
	add	hl,hl
	ld	(ix-4),hl
	ld	de,(_curState+11)
	ld	bc,(_curState+13)
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@112
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
@112:
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ld	de,_digOutDescr
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@113
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+974)
	ld	c,phys @1+974 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
@113:
@109:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@103
@104:
@100:
	ld	a,(ix+5)
	or	a,a
	jr	z,@114
	ld	de,word (phys @1+971)
	ld	c,phys @1+971 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@114:
@80:
	.debug	} @80 648

@79	equ	20
	ld	sp,ix
	pop	ix
	lret
@81	equ	22
	.align	4
$$EVENT_RestoredParamFile::
	ex	(sp),iy
$EVENT_RestoredParamFile::
	.debug	G $EVENT_RestoredParamFile 62 9
	.debug	{ $EVENT_RestoredParamFile 62 654 @117 @116
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	add	hl,hl
	ld	de,_paramFiles
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+1026)
	ld	c,phys @1+1026 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,0x100
	push	hl
	ld	hl,_applBuf
	push	hl
	lcall	$loadParams
	add	sp,8
@116:
	.debug	} @116 666

@115	equ	4
	ld	sp,ix
	pop	ix
	lret
@117	equ	6
	.align	4
$$hostNameRestore::
	ex	(sp),iy
$hostNameRestore::
	.debug	G $hostNameRestore 63 9
	.debug	{ $hostNameRestore 63 671 @120 @119
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+9)
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$SetHostName
	add	sp,4
@119:
	.debug	} @119 674

@118	equ	0
	pop	ix
	lret
@120	equ	2
	.align	4
$$ReadSetCalibsRestore::
	ex	(sp),iy
$ReadSetCalibsRestore::
	.debug	G $ReadSetCalibsRestore 63 9
	.debug	{ $ReadSetCalibsRestore 63 679 @123 @122
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	call	_KLOCK
	ld	hl,(ix+11)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	call	_KUNLOCK
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@126:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@127
	ld	hl,(ix-2)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@126
@127:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@131:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@132
	ld	hl,(ix-2)
	push	hl
	lcall	$newDACCalib
	pop	hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@131
@132:
@122:
	.debug	} @122 689

@121	equ	2
	ld	sp,ix
	pop	ix
	lret
@123	equ	4
$setApplDTM::
	.debug	G $setApplDTM 60 9
	.debug	{ $setApplDTM 60 694 @136 @135
	ld	hl,@2+131
	push	hl
	ld	hl,@2+140
	push	hl
	ld	de,word (phys @1+1058)
	ld	c,phys @1+1058 >> 16
	push	bc
	push	de
	ld	de,word (phys _applDTM)
	ld	c,phys _applDTM >> 16
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
	ld	hl,@2+131
	push	hl
	ld	hl,@2+140
	push	hl
	lcall	$compileTime
	add	sp,4
	ld	(_applVersTime),de
	ld	(_applVersTime+2),bc
@135:
	.debug	} @135 699

@134	equ	0
	lret
@136	equ	0
$saveApplState::
	.debug	G $saveApplState 64 9
	.debug	{ $saveApplState 64 709 @139 @138
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@140
	ld	hl,0xffff
	jp	@138
@140:
	call	_KLOCK
	ld	de,word (phys @1+1064)
	ld	c,phys @1+1064 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
	ld	hl,(_ApplStateDataSize)
	ld	(ix-2),hl
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x1b
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_prevState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1b
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x1b
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_curState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1b
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x1b
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_nextState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1b
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x8
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_setVal
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-2)
	call	__farst2##
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$memCRC16
	add	sp,8
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-10)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst2##
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
	call	_KUNLOCK
	bool	hl
	ld	l,h
@138:
	.debug	} @138 746

@137	equ	10
	ld	sp,ix
	pop	ix
	lret
@139	equ	12
$restoreApplState::
	.debug	G $restoreApplState 64 9
	.debug	{ $restoreApplState 64 764 @143 @142
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@144
	ld	hl,0xffff
	jp	@142
@144:
	ld	hl,(_ApplStateDataSize)
	ld	(ix-2),hl
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	call	__farld2##
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	z,@145
	ld	hl,0x1
	jp	@142
@145:
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__lsub##
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	c,@146
	jr	z,@146
	ld	hl,0x2
	jp	@142
@146:
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$memCRC16
	add	sp,8
	pop	de
	or	a,a
	sbc	hl,de
	jr	z,@147
	ld	hl,0x3
	jp	@142
@147:
	ld	de,0x1b
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_prevState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1b
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x1b
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_curState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1b
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x1b
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_nextState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x1b
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x8
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_setVal
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState),de
	ld	(_nextState+2),bc
	ld	(_curState),de
	ld	(_curState+2),bc
	ld	de,(_curState+11)
	ld	bc,(_curState+13)
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	ld	de,word (phys @1+1091)
	ld	c,phys @1+1091 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	bool	hl
	ld	l,h
@142:
	.debug	} @142 801

@141	equ	10
	ld	sp,ix
	pop	ix
	lret
@143	equ	12
$setGenericLabels::
	.debug	G $setGenericLabels 60 9
	.debug	{ $setGenericLabels 60 806 @150 @149
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@153:
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@154
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1131)
	ld	c,phys @1+1131 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@153
@154:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@160:
	ld	hl,(ix-2)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@161
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1138)
	ld	c,phys @1+1138 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@160
@161:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@167:
	ld	hl,(ix-2)
	ld	de,(_NumApplDIN)
	or	a,a
	sbc	hl,de
	jr	nc,@168
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1146)
	ld	c,phys @1+1146 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@167
@168:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@174:
	ld	hl,(ix-2)
	ld	de,(_NumApplDOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@175
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1153)
	ld	c,phys @1+1153 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@174
@175:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@181:
	ld	hl,(ix-2)
	ld	de,(_NumExtraIn)
	or	a,a
	sbc	hl,de
	jr	nc,@182
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _extraInLabel)
	ld	c,phys _extraInLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1161)
	ld	c,phys @1+1161 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _extraInLabel)
	ld	c,phys _extraInLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@181
@182:
@149:
	.debug	} @149 831

@148	equ	2
	ld	sp,ix
	pop	ix
	lret
@150	equ	4
;1069 
;1070 //=========================================================================
;1071 //  Misc Application-specific functions
;1072 //=========================================================================
;1073 //APPLCODE
;1074 
;1075 
;1076 
;1077 //=========================================================================
;1078 //  Task functions to handle application-specific commands
;1079 //=========================================================================
;1080 //APPLCODE
;1081 
;1082 //-------------------------------------------------------------------------
;1083 //  example func to process a command entered via a user shell
;1084 //-------------------------------------------------------------------------
;1085 /*
;1086 void _task miscTest(int argc, char **argv)
;1087 {
;1088   int  idx;
;1089   bool  validCmd;
;1090 
;1091 //used by EVENT macro
;1092   fd_t  eventsfd = -1;
;1093   EventMsg  eventMsg;
;1094 
;1095 
;1096   validCmd = false;
;1097 
;1098   for (;;)  {
;1099     if (argc < 3)  break;
;1100     if (! isdigit(argv[1][0]))  break;
;1101 
;1102     idx = atoi(argv[1]);
;1103     if ((idx < 1) OR (idx > NumChan))  {
;1104       printf("Invalid chan #\n");  Exit(-2); }
;1105 
;1106     --idx;  validCmd = true;
;1107 
;1108     if (StriEq(argv[2], "x"))     { EVENT(MyEventX, idx, NULL, 0);  break; 
;1109     if (StriEq(argv[2], "y"))     { EVENT(MyEventY, idx, NULL, 0);  break; 
;1110 
;1111     validCmd = false;  break;
;1112   }
;1113 
;1114   if (! validCmd)  { printf("Usage:  misc # x|y\r\n");  Exit(-1); }
;1115 
;1116   Exit(0);
;1117 }
;1118 */
;1119 
;1120 //=========================================================================
;1121 //  Generic structure to handle application-specific presentation of the
;1122 //  digital and analog input/output values.  Code to handle additional
;1123 //  formatting that cannot be handled in this generic manner should be
;1124 //  placed in the showState() task routine.
;1125 //=========================================================================
;1126 //APPLCODE - text and formatting info for application state summary
;1127 
;1128 //-------------------------------------------------------------------------
;1129 _nearcall char *fmtMode(DispElem far *elem, char *buf)
;1130 {
	.align	4
$$fmtMode::
	ex	(sp),iy
$fmtMode::
	.debug	G $fmtMode 65 9
	.debug	{ $fmtMode 65 1129 @188 @187
	push	ix
	ld	ix,0
	add	ix,sp
;1131   return (char *) ModeDesc[ELEM_VAL(U16)];
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_ModeDesc
	add	hl,de
	ld	hl,(hl)
;1132 }
@187:
	.debug	} @187 1132

@186	equ	0
	pop	ix
	lret
@188	equ	2
;1133 
;1134 //-------------------------------------------------------------------------
;1135 _nearcall char *fmtHdwCfg(DispElem far *elem, char *buf)
;1136 {
	.align	4
$$fmtHdwCfg::
	ex	(sp),iy
$fmtHdwCfg::
	.debug	G $fmtHdwCfg 65 9
	.debug	{ $fmtHdwCfg 65 1135 @191 @190
	push	ix
	ld	ix,0
	add	ix,sp
;1137   return (char *) HdwCfgDesc[ELEM_VAL(U16)];
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_HdwCfgDesc
	add	hl,de
	ld	hl,(hl)
;1138 }
@190:
	.debug	} @190 1138

@189	equ	0
	pop	ix
	lret
@191	equ	2
;1139 
;1140 //-------------------------------------------------------------------------
;1141   const char far DevStateStr[] = {
;1142 "Cavity Voltage: -###.### kV    Open/Closed: ######    HdwConfig: ##### \r\
;1143 "Active setpoint: ###.### kV    RF On/Off:   ### \r\n"
;1144 "Error:          -###.### kV    Loc/Rem:     ###### \r\n"
;1145 " \r\n"
;1146 "Limiter Voltage: -##.### V     Limited:     ### \r\n"
;1147 "                               Regulation:  ##### \r\n"
;1148 "RF OFF setpoint: ###.### kV \r\n"
;1149 "RF ON setpoint:  ###.### kV    Ramp Mode:   #### \r\n"
;1150 " \r\n"
;1151 };
	.seg	FARCONST
_DevStateStr::
	.db	"Cavity Voltage: -###.### kV    Open/Closed: ######    HdwConfig: ##### ",13,10,"Active setpo"
	.db	"int: ###.### kV    RF On/Off:   ### ",13,10,"Error:          -###.### kV    Loc/Rem:     ###"
	.db	"### ",13,10," ",13,10,"Limiter Voltage: -##.### V     Limited:     ### ",13,10,"                         "
	.db	"      Regulation:  ##### ",13,10,"RF OFF setpoint: ###.### kV ",13,10,"RF ON setpoint:  ###.### kV"
	.db	"    Ramp Mode:   #### ",13,10," ",13,10,0
	.debug	G _DevStateStr 66 8
;1152 
;1153 const DispElem  far dispElems[] = {
;1154   { 16, 3, VFPV(cavityVolts),     DARK_BLUE, fmtF32,    8,3 },
_dispElems::
	.db	0x10
	.db	0x3
	.dl	phys _cavityVolts
	.dw	@2+156
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x3
;1155   { 17, 4, VFPV(activeSetpoint),  DARK_BLUE, fmtF32,    7,3 },
	.db	0x11
	.db	0x4
	.dl	phys _activeSetpoint
	.dw	@2+156
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;1156   { 16, 5, VFPV(regulationError), DARK_BLUE, fmtF32,    8,3 },
	.db	0x10
	.db	0x5
	.dl	phys _regulationError
	.dw	@2+156
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x3
;1157 
;1158   { 17, 7, VFPV(limiterVolts),    DARK_BLUE, fmtF32,    7,3 },
	.db	0x11
	.db	0x7
	.dl	phys _limiterVolts
	.dw	@2+156
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;1159 
;1160   { 17, 9, VFPV(rfOffSetpoint),   DARK_BLUE, fmtF32,    7,3 },
	.db	0x11
	.db	0x9
	.dl	phys _rfOffSetpoint
	.dw	@2+156
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;1161   { 17,10, VFPV(rfOnSetpoint),    DARK_BLUE, fmtF32,    7,3 },
	.db	0x11
	.db	0xa
	.dl	phys _rfOnSetpoint
	.dw	@2+156
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x3
;1162 
;1163   { 44,10, VFPV(rampMode),        DARK_BLUE, fmtMode,   4,4 },
	.db	0x2c
	.db	0xa
	.dl	phys _rampMode
	.dw	@2+156
	.dw	word _fmtMode
	.dw	0x4
	.dw	0x4
;1164 
;1165   { 65, 3, VFPV(hdwCfg),          DARK_BLUE, fmtHdwCfg, 5,5 },
	.db	0x41
	.db	0x3
	.dl	phys _hdwCfg
	.dw	@2+156
	.dw	word _fmtHdwCfg
	.dw	0x5
	.dw	0x5
;1166 
;1167   { 0,0, NULL, NULL, NULL, 0,0 }
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;1168 };
	.debug	G _dispElems 67 8
;1169 
;1170 
;1171 const DigDispElem far digInElems[] = {
;1172   { 44, 3,  CLOSED_LOOP,  "OPEN  ",DARK_RED,   "CLOSED",DARK_BLUE },
_digInElems::
	.db	0x2c
	.db	0x3
	.dw	0x1, 0
	.dw	@2+158
	.dw	@2+165
	.dw	@2+167
	.dw	@2+156
;1173   { 44, 4,  RF_IS_OFF,    "ON ",DARK_BLUE,     "OFF",DARK_RED },
	.db	0x2c
	.db	0x4
	.dw	0x8, 0
	.dw	@2+174
	.dw	@2+156
	.dw	@2+178
	.dw	@2+165
;1174   { 44, 5,  LOC_REM_SW,   "REMOTE",DARK_BLUE,  "LOCAL ",DARK_BLUE },
	.db	0x2c
	.db	0x5
	.dw	0x10, 0
	.dw	@2+182
	.dw	@2+156
	.dw	@2+189
	.dw	@2+156
;1175 
;1176   { 0,0, 0, NULL,NULL, NULL,NULL }
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;1177 };
	.debug	G _digInElems 69 8
;1178 
;1179 const DigDispElem far digOutElems[] = {
;1180   { 44, 7,  LIMITED_LED,   "NO ",  DARK_BLUE,  "YES",  DARK_RED },
_digOutElems::
	.db	0x2c
	.db	0x7
	.dw	0x1, 0
	.dw	@2+196
	.dw	@2+156
	.dw	@2+200
	.dw	@2+165
;1181   { 44, 8,  ERROR_LED,     "OK   ",DARK_BLUE,  "ERROR",DARK_RED },
	.db	0x2c
	.db	0x8
	.dw	0x2, 0
	.dw	@2+204
	.dw	@2+156
	.dw	@2+68
	.dw	@2+165
;1182 
;1183   { 0,0,  0,  NULL,NULL,  NULL,NULL }
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;1184 };
	.debug	G _digOutElems 71 8
;1185 
;1186 
;1187 //---- older style - do not use for newer applications -----
;1188 const DigFmtInfo digInFmt[] = {
;1189 //{ xx,yy, "0-str"  ,1,  "1-str" ,0 },  //  descr
;1190 
;1191   { -1,-1, "",0, "",0 }
	.seg	CONST
_digInFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	@2+4
	.db	0
	.dw	@2+4
	.db	0
;1192 };
	.debug	G _digInFmt 72 0
;1193 
;1194 const DigFmtInfo digOutFmt[] = {
;1195 //{ xx,yy, "0-str"  ,1,  "1-str" ,0 },  //  descr
;1196 
;1197   { -1,-1, "",0, "",0 }
_digOutFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	@2+4
	.db	0
	.dw	@2+4
	.db	0
;1198 };
	.debug	G _digOutFmt 72 0
;1199 
;1200 
;1201 const AnalogFmtInfo  adcFmt[] = {
;1202   { -1,-1, 0,0 }
_adcFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	0
	.dw	0
;1203 };
	.debug	G _adcFmt 74 0
;1204 
;1205 const AnalogFmtInfo  dacFmt[] = {
;1206   { -1,-1, 0,0 }
_dacFmt::
	.dw	0xffff
	.dw	0xffff
	.dw	0
	.dw	0
;1207 };
	.debug	G _dacFmt 74 0
;1208 
;1209 
;1210 //-------------------------------------------------------------------------
;1211 //  "state":  Show continuously updated state of the system
;1212 //-------------------------------------------------------------------------
;1213 void _task showState(int argc, char **argv)
;1214 {
	.seg	FARCODE
	.align	4
$$showState::
	ex	(sp),iy
$showState::
	.debug	G $showState 76 9
	.debug	{ $showState 76 1213 @194 @193
	ld	hl,-129
	call	__fent##
;1215   bool  blinkOff;
;1216   char  temp[128];
;1217 
;1218 
;1219   printf(clsCmd);  blinkOff = false;
	ld	hl,_clsCmd
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	xor	a,a
	ld	(ix-1),a
;1220 
;1221   CursorTo(0, 3);  printf(DevStateStr);
	ld	hl,0x1
	push	hl
	ld	l,0x4
	push	hl
	ld	de,word (phys @1+1172)
	ld	c,phys @1+1172 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	de,word (phys _DevStateStr)
	ld	c,phys _DevStateStr >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1222 
;1223   for (;;)  {
@197:
;1224     CursorTo(0, 0);  blinkOff = !blinkOff;
	ld	hl,0x1
	push	hl
	push	hl
	ld	de,word (phys @1+1172)
	ld	c,phys @1+1172 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	a,(ix-1)
	or	a,a
	ld	a,0
	jr	nz,@202
	inc	a
@202:
	ld	(ix-1),a
;1225 
;1226     stdHeader();  displayElems((DispElem far *)dispElems, blinkOff, temp);
	lcall	$stdHeader
	ld	hl,-129+@192
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _dispElems)
	ld	c,phys _dispElems >> 16
	push	bc
	push	de
	lcall	$displayElems
	add	sp,8
;1227 
;1228     displayDigElems(digitalIn, (DigDispElem far *)digInElems, blinkOff, tem
	ld	hl,-129+@192
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _digInElems)
	ld	c,phys _digInElems >> 16
	push	bc
	push	de
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	push	bc
	push	de
	lcall	$displayDigElems
	add	sp,12
;1229     displayDigElems(digitalOut, (DigDispElem far *)digOutElems, blinkOff, t
	ld	hl,-129+@192
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _digOutElems)
	ld	c,phys _digOutElems >> 16
	push	bc
	push	de
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$displayDigElems
	add	sp,12
;1230 
;1231     CursorTo(0,22);  fflush(stdout);  CheckETX();  sleepMS(500);
	ld	hl,0x1
	push	hl
	ld	l,0x17
	push	hl
	ld	de,word (phys @1+1172)
	ld	c,phys @1+1172 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
	lcall	$CheckETX
	ld	de,0x1f4
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;1232   }
;1233 
;1234 }
	jp	@197
@193:
	.debug	} @193 1234

@192	equ	129
	ld	sp,ix
	pop	ix
	lret
@194	equ	131
;1235 
;1236 
;1237 
;1238 //=========================================================================
;1239 //  Event-Handler functions called by the appl task to process event messag
;1240 //=========================================================================
;1241 //APPLCODE
;1242 
;1243 //-------------------------------------------------------------------------
;1244 //  Event-Handler for a request to ...
;1245 //-------------------------------------------------------------------------
;1246 /*
;1247 void EVENT_MyEvent(EventMsg *event)
;1248 {
;1249   uint  idx;
;1250   float  setpoint;
;1251   char  temp[16];
;1252 
;1253 
;1254   idx = event->chanNum;
;1255 
;1256   if (error)  {
;1257     fprintf(DiagLog, "error msg, chan:\n", idx+1);
;1258     return;
;1259   }
;1260 
;1261   setpoint = *((float *)event->data);
;1262 
;1263   fprintf(DiagLog, "New SetPoint for PS%d: %s\n",
;1264      idx+1, fmtFloat(setpoint, 8,3, temp) );
;1265 
;1266   *((float *)((&iSet_1_RegInfo + idx)->regVal)) = setpoint;
;1267 
;1268   anaOut[idx] = ISETtoVolts(idx, setpoint);
;1269 }
;1270 */
;1271 
;1272 
;1273 //=========================================================================
;1274 //  Update the the state of the application logic in well-defined phases
;1275 //=========================================================================
;1276 // IMPORTANT NOTES and RULES:
;1277 //
;1278 //  - The code to change ANY value must be in ONE place.  NEVER spread the
;1279 //    logic for updating a single value around.  There should be ONE place
;1280 //    to look to see how a value gets set.
;1281 //
;1282 //  - "cur" values are basically "inputs" - literally (they are set based
;1283 //    on the just-read state of a digital or analog input) and/or figurativ
;1284 //    (they hold a value set by some external source, such as a cmd from a
;1285 //    remote client or another user-interface task).
;1286 //
;1287 //  - "next" values are basically "outputs" - literally (they determine the
;1288 //    next state of a digital or analog output) and/or figuratively (they
;1289 //    can affect the state of the logic for the next pass).
;1290 //
;1291 //  - The "cur" OR the "next" instance of a value may be changed - NEVER
;1292 //    both of them (with the exception of the first step below that copies
;1293 //    all of cur to prev and next to cur).
;1294 //
;1295 //  - A value MUST be in the ApplState struct if one of the following appli
;1296 //     - The application logic is dependent on if or how much the value has
;1297 //       changed between passes.
;1298 //     - The value is used as both input (used in in a conditional and/or i
;1299 //       an expression that can affect the result of an assignment) and out
;1300 //       (the target of an assignment).
;1301 //
;1302 //  - Variables that are NOT in the ApplState struct but are USED (in
;1303 //    conditionals or other expressions) by the application logic must be
;1304 //    treated just like "cur" values.  Variables SET (the target in an
;1305 //    assignment statement) by the application logic must be treated just
;1306 //    like "next" values.
;1307 //
;1308 //  - When the logic requires comparing an "input" to a related "output", b
;1309 //    sure to use the "cur" value for the "input", and the "prev" value for
;1310 //    the "output".
;1311 //
;1312 //    This is because during the processing of the loop, the "cur" values
;1313 //    represent the input values just read (what they are "now") and the
;1314 //    "prev" values represent the values the outputs were set to at the
;1315 //    beginning of the prev pass (i.e. they are the values that "caused"
;1316 //    the inputs to have their "cur" values).
;1317 //
;1318 //    During a pass the output values in "cur" represent what the outputs
;1319 //    where set to AFTER the "cur" inputs were updated, so comparing them
;1320 //    makes no sense.  Doing so is the equivalent of comparing a past respo
;1321 //    to a condition that didn't exist at the time.
;1322 //=========================================================================
;1323 
;1324 
;1325 //=========================================================================
;1326 //  Definitions for functions that handle setting "next" values that serve
;1327 //  as inputs to the application control logic (run by the "applic" task in
;1328 //  a periodically executed loop).
;1329 //
;1330 //  While care must be taken in these functions to use locks to avoid the
;1331 //  possibility of being preempted in the middle of an operation, such lock
;1332 //  must be kept to as short a time as possible to avoid excessive latency
;1333 //  in the main control loop.
;1334 //
;1335 //  For REALLY short locks, using a critical section is best, because this
;1336 //  has the least overhead (but it has to be REALLY short to avoid causing
;1337 //  problems for interrupt handlers).
;1338 //
;1339 //  For longer locks (ones that involve anything but the most trivial
;1340 //  conditional logic), use either KLOCK() and KUNLOCK() (which disable the
;1341 //  scheduler) or a more specific global semaphore/mutex lock.
;1342 //=========================================================================
;1343 
;1344 /*Examples
;1345 //-------------------------------------------------------------------------
;1346 void onRequest(void)
;1347 {
;1348   _EnterCritical_();
;1349   Next.onRequest = true;  Next.offRequest = false;
;1350   _ExitCritical_();
;1351 
;1352   fprintf(DiagLog, "ON request\n");
;1353 }
;1354 
;1355 //-------------------------------------------------------------------------
;1356 void offRequest(void)
;1357 {
;1358   _EnterCritical_();
;1359   Next.offRequest = true;  Next.onRequest = false;
;1360   _ExitCritical_();
;1361 
;1362   fprintf(DiagLog, "OFF request\n");
;1363 }
;1364 
;1365 //-------------------------------------------------------------------------
;1366 void resetRequest(void)
;1367 {
;1368   _EnterCritical_();  Next.resetRequest = true;  _ExitCritical_();
;1369 
;1370   fprintf(DiagLog, "RESET request\n");
;1371 }
;1372 
;1373 //-------------------------------------------------------------------------
;1374 void newSetpoint(float newAmps)
;1375 {
;1376   char  temp[16];
;1377 
;1378 
;1379   KLOCK();
;1380 
;1381   if (FABS(newAmps) > maxAmpSet)  newAmps = (float)SIGN(newAmps) * maxAmpSe
;1382 
;1383   Next.ampSet = newAmps;
;1384 
;1385   KUNLOCK();
;1386 
;1387   fprintf(DiagLog, "New Setpoint: %s\n", fmtFloat(newAmps, 10,3, temp) );
;1388 }
;1389 
;1390 //-------------------------------------------------------------------------
;1391 */
;1392 
;1393 
;1394 
;1395 /*
;1396 =========== NOTES on Locking ============
;1397 
;1398 The applic task runs at the highest priority (even above the kernel), so it
;1399 cannot be preempted by any other task.  As long as this is true, the applic
;1400 task does not need to use locks when accessing global variables.
;1401 
;1402 However, all other tasks MUST disable the scheduler when accessing values
;1403 used by the applic task to avoid being preempted while doing so.  Care must
;1404 be taken to keep these times short to avoid latency issues.
;1405 
;1406 For REALLY short times, a critical section can be used as this is much more
;1407 efficient than disabling and reenabling the scheduler.  But critical sectio
;1408 disable all interrupts, so it is not practical in most cases.
;1409 
;1410 */
;1411 
;1412 //=========================================================================
;1413 //  Update the "Cur"rent state of the controller
;1414 //
;1415 //  Be sure to read the "NOTES on Locking" section above....
;1416 //=========================================================================
;1417 //
;1418 //  Just before this function is called, readings were taken of the current
;1419 //  state of the hardware, and any changes to the output states specified b
;1420 //  the last pass were applied (just after taking the readings).  These val
;1421 //  are copied to Next as needed and constitute the Hardware Inputs.
;1422 //
;1423 //  Other tasks can affect the state of the control logic by changing value
;1424 //  in Next as well.  These values constitute Software Inputs.
;1425 //
;1426 //  This function is responsible for the Asynchronous logic that is applied
;1427 //  each pass.  It updates values in Next (or other global variables) based
;1428 //  on the Software and Hardware Input values in Next.  This portion of the
;1429 //  logic is analogous to unclocked gates in an electronic circuit.
;1430 //
;1431 //  After the Asychronous logic is applied, we set Prev = Cur and Cur = Nex
;1432 //  The result is that Prev contains the controller state as it was during 
;1433 //  previous pass, and Cur indicates the current state of the controller.
;1434 //
;1435 //  Also, see the "NOTES on Locking" section above....
;1436 //=========================================================================
;1437 void updateCurState(void)
;1438 {
$updateCurState::
	.debug	G $updateCurState 60 9
	.debug	{ $updateCurState 60 1437 @205 @204
;1439 
;1440   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@204
;1441 
;1442 //-----------------------------------------------------------------
;1443 // The following conditions exist at this point:
;1444 // - The analog and digital hardware inputs have just been read
;1445 // - The outputs were just set to values computed during the last pass
;1446 // - "Cur" contains the state the inputs were in at the START of
;1447 //   of the previous pass, and the state the outputs were in DURING
;1448 //   the previous pass
;1449 // - "Next" contains the values that the outputs were just set
;1450 //   to and any "input" values that were changed by other tasks
;1451 //------------------------------------------------------------------
;1452 
;1453 // Now we update the values in "Next" that are based solely on the
;1454 // state of the hardware inputs we just read and values maintained by
;1455 // by other tasks (basically, we deal with READINGS here: Values that
;1456 // we need but are not written to "Next" by another task)
;1457 
;1458   Next.processTime = GetMS();  curTime = time(NULL);
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	ld	(_curTime),de
	ld	(_curTime+2),bc
;1459 
;1460   msSincePrev = msSince(Cur.processTime);
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_curState+4)
	ld	bc,(_curState+6)
	call	__lsub##
	ld	(_msSincePrev),de
	ld	(_msSincePrev+2),bc
;1461 
;1462   Next.digitalIn = digitalIn;
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState),de
	ld	(_nextState+2),bc
;1463 
;1464 
;1465 //APPLCODE
;1466   initialBtnPressed = InitialBtnPushed(Next.digitalIn);
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__land##
	ld	a,e
	ld	(_initialBtnPressed),a
;1467   finalBtnPressed = FinalBtnPushed(Next.digitalIn);
	ld	de,(_nextState)
	ld	bc,(_nextState+2)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	a,e
	ld	(_finalBtnPressed),a
;1468   hdwCfg = HdwConfig(readVal[HDW_CFG]);
	ld	de,(_readVal+12)
	ld	bc,(_readVal+14)
	push	bc
	push	de
	call	_fabs
	add	sp,4
	push	bc
	push	de
	ld	de,0x3d71
	ld	bc,0x40a2
	call	__fsubr##
	push	bc
	push	de
	ld	de,0xf8a1
	ld	bc,0x3fc9
	call	__fmlt##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x3f00
	call	__fadd##
	call	__ftol##
	ld	(_hdwCfg),de
;1469 
;1470   if (hdwCfg > 7)  hdwCfg = ERROR_CFG;
	ld	h,d
	ld	l,e
	ld	de,0x7
	or	a,a
	sbc	hl,de
	jr	c,@207
	jr	z,@207
	ld	hl,0x8
	ld	(_hdwCfg),hl
;1471 
;1472   // (ignore if both buttons being pressed)
;1473   if (initialBtnPressed AND finalBtnPressed)
@207:
	ld	a,(_initialBtnPressed)
	or	a,a
	jr	z,@209
	ld	a,(_finalBtnPressed)
	or	a,a
	jr	z,@209
;1474     initialBtnPressed = finalBtnPressed = false;
	xor	a,a
	ld	(_finalBtnPressed),a
	ld	(_initialBtnPressed),a
;1475 
;1476 
;1477   cavityVolts = readVal[RF_CAV_VOLT];
@209:
	ld	de,(_readVal)
	ld	bc,(_readVal+2)
	ld	(_cavityVolts),de
	ld	(_cavityVolts+2),bc
;1478   limiterVolts = readVal[LIMITER_VOLT];
	ld	de,(_readVal+4)
	ld	bc,(_readVal+6)
	ld	(_limiterVolts),de
	ld	(_limiterVolts+2),bc
;1479 
;1480   Next.rfIsOn = !RFisOff(Next.digitalIn);
	ld	de,(_nextState)
	ld	bc,(_nextState+2)
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__land##
	inc	e
	dec	e
	ld	e,0
	jr	nz,@210
	inc	e
@210:
	ld	a,e
	ld	(_nextState+8),a
;1481 
;1482   Next.localMode = LocalMode(Next.digitalIn);
	ld	de,(_nextState)
	ld	bc,(_nextState+2)
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	a,e
	ld	(_nextState+9),a
;1483   Next.closedLoop = ClosedLoop(Next.digitalIn);
	ld	de,(_nextState)
	ld	bc,(_nextState+2)
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	a,e
	ld	(_nextState+10),a
;1484 
;1485 
;1486   regulationError = cavityVolts - Prev.activeSetpoint;
	ld	de,(_cavityVolts)
	ld	bc,(_cavityVolts+2)
	push	bc
	push	de
	ld	de,(_prevState+15)
	ld	bc,(_prevState+17)
	call	__fsub##
	ld	(_regulationError),de
	ld	(_regulationError+2),bc
;1487 
;1488   limited = (FABS(limiterVolts) > limiterActiveV);
	ld	de,(_limiterVolts)
	ld	bc,(_limiterVolts+2)
	push	bc
	push	de
	call	_fabs
	add	sp,4
	push	bc
	push	de
	ld	de,(_limiterActiveV)
	ld	bc,(_limiterActiveV+2)
	call	__fsub##
	ld	de,0
	jp	m,@211
	jr	z,@211
	inc	e
@211:
	ld	a,e
	ld	(_limited),a
;1489   regErr = ((FABS(regulationError) > maxRegErr) AND Next.rfIsOn);
	ld	de,(_regulationError)
	ld	bc,(_regulationError+2)
	push	bc
	push	de
	call	_fabs
	add	sp,4
	push	bc
	push	de
	ld	de,(_maxRegErr)
	ld	bc,(_maxRegErr+2)
	call	__fsub##
	jp	m,@213
	jr	z,@213
	ld	a,(_nextState+8)
	or	a,a
	jr	z,@213
	ld	a,1
	jr	@214
@213:
	xor	a
@214:
	ld	(_regErr),a
;1490 
;1491   _EnterCritical_();  knobTicks = qdCount;  qdCount = 0;  _ExitCritical_();
	ipset	2
	ld	hl,(_qdCount)
	ld	(_knobTicks),hl
	bool	hl
	ld	l,h
	ld	(_qdCount),hl
	ipres
;1492 
;1493 
;1494 
;1495 // Next we make a copy of the application state before we apply all the
;1496 // logic that updates the overall state.  This allows us to have a copy of
;1497 // all the relevant values that remain unchanged during the processing,
;1498 // avoiding all kinds of order-of-execution dependencies.
;1499 
;1500 // We also make a copy of the state from last time before overwriting it
;1501 // so we can see if/how values have changed since the last pass
;1502 
;1503 // Note that a copy is done (rather than just switching pointer values) to
;1504 // insure all values are set in both the source and destination.  If we
;1505 // simply kept pointers and swapped the pointer values, then EVERY value
;1506 // would have to be updated independently by the code, which is a pain to
;1507 // program, adds overhead and code, and is a VERY easy way to introduce odd
;1508 // bugs.  Overall, copying everything here is actually faster overall,
;1509 // simpler, and much safer (and is now required by the new softReset code).
;1510 
;1511   Prev = Cur;  Cur = Next;
	ld	hl,_curState
	ld	de,_prevState
	push	hl
	ld	bc,27
	ldir
	pop	hl
	ld	hl,_nextState
	ld	de,_curState
	push	hl
	ld	bc,27
	ldir
	pop	hl
;1512 
;1513 //--- At this point the Cur copy contains what the inputs were at the start
;1514 //--- of this pass, and the Prev copy contains the output values from the -
;1515 //--- the previous pass (i.e. the output values that resulted in the input 
;1516 //--- values in Cur) ---
;1517 
;1518 //--- log msgs for bit chgs only if not starving other processes for cycles
;1519   if (applLoopTime < 6)  logDigIOChgs(false);
	ld	hl,(_applLoopTime)
	ld	de,0x6
	or	a,a
	sbc	hl,de
	jr	nc,@215
	bool	hl
	ld	l,h
	push	hl
	lcall	$logDigIOChgs
	pop	hl
;1520 
;1521 
;1522 
;1523 
;1524 //--- At this point the Cur copy contains what the inputs were at the start
;1525 //--- of this pass, and the Prev copy contains the output values from the -
;1526 //--- the previous pass (i.e. the output values that resulted in the input 
;1527 //--- values in Cur) ---
;1528 
;1529 
;1530 
;1531 //--------------------------------------------------------------------
;1532 // Next we update the rest of the "cur" values needed by the control
;1533 // logic (the ones that do NOT come from "next" values set by other
;1534 // tasks)
;1535 //
;1536 // NOTES:
;1537 //  - This portion of the logic has order-of-execution dependencies,
;1538 //    so be sure that all values referenced in an expression are ones
;1539 //    set before they are used.
;1540 //
;1541 //  - References to "prev" values are always safe since they are just
;1542 //    a copy of values from the last pass
;1543 //--------------------------------------------------------------------
;1544 
;1545  //------------------------------------------------------------------
;1546  // rampMode, rfOnTime
;1547  //    Description:
;1548  //       Specifies how changes to Next.activeSetpoint should be
;1549  //       handled.
;1550  //
;1551  //       If the RF is OFF, then it is set to rfOffSetpoint.
;1552  //
;1553  //       If the RF just changed from OFF to ON, then an interlval
;1554  //       of offToOnDelay ms must pass before any changes are made.
;1555  //
;1556  //       If the RF is ON and offToOnDelay ms have passed, then
;1557  //       it is ramped toward the rfOnSetpoint at the rate specified
;1558  //       by coldRampRate.
;1559  //
;1560  //       If the RF is ON, the activeSetpoint has reached the
;1561  //       rfOnSetpoint, then any difference between rfOnSetpoint and
;1562  //       activeSetepoint is reduced at the rate specified by
;1563  //       warmRampRate.
;1564  //
;1565  //    Inputs:
;1566  //       offToOnDelay
;1567  //       rampMode
;1568  //       Cur.activeSetpoint
;1569  //       Cur.rfOnSetpoint
;1570  //       Prev.rfIsOff
;1571  //       Cur.rfIsOff
;1572  //------------------------------------------------------------------
;1573   if (!Cur.rfIsOn)  rampMode = RAMP_OFF;
@215:
	ld	a,(_curState+8)
	or	a,a
	jr	nz,@216
	bool	hl
	ld	l,h
	ld	(_rampMode),hl
;1574 
;1575   switch (rampMode)  {
@216:
	ld	hl,(_rampMode)
	jp	@217
;1576     case RAMP_OFF:  // waiting for RF ON
;1577       if (Cur.rfIsOn)  {
@221:
	ld	a,(_curState+8)
	or	a,a
	jp	z,@222
;1578         rampMode = RAMP_WAIT;  rfOnTime = GetMS();
	ld	hl,0x1
	ld	(_rampMode),hl
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_rfOnTime),de
	ld	(_rfOnTime+2),bc
;1579         printf("Starting OFF-to-ON delay\r\n");
	ld	de,word (phys @1+1185)
	ld	c,phys @1+1185 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1580       }
;1581       break;
@222:
;1582 
;1583     case RAMP_WAIT: // waiting for offToOnDelay to finish
	jp	@218
;1584       if (msSince(rfOnTime) >= offToOnDelay)  {
@225:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_rfOnTime)
	ld	bc,(_rfOnTime+2)
	call	__lsub##
	ld	hl,(_offToOnDelay)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__lsub##
	jr	c,@218
;1585         rampMode = RAMP_COLD;
	ld	hl,0x2
	ld	(_rampMode),hl
;1586         printf("Ramping using COLD rate\r\n");
	ld	de,word (phys @1+1212)
	ld	c,phys @1+1212 >> 16
	jr	@457
;1587       }
;1588       break;
;1589 
;1590     case RAMP_COLD:  // waiting for cold-mode ramping to finish
;1591       if (Cur.activeSetpoint == Cur.rfOnSetpoint)  {
@229:
	ld	de,(_curState+15)
	ld	bc,(_curState+17)
	push	bc
	push	de
	ld	de,(_curState+19)
	ld	bc,(_curState+21)
	call	__fequ##
	jr	nz,@218
;1592         rampMode = RAMP_WARM;
	ld	hl,0x3
	ld	(_rampMode),hl
;1593         printf("Using WARM rate for changes\r\n");
	ld	de,word (phys @1+1238)
	ld	c,phys @1+1238 >> 16
@457:
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1594       }
;1595       break;
;1596   }
	jr	@218
;1597 
;1598 }
@217:
	ex	de,hl
	ld	a,d
	or	a,e
	jp	z,@221
	ld	hl,0xffffffff
	add	hl,de
	bool	hl
	jp	z,@225
	ld	hl,0xfffffffe
	add	hl,de
	bool	hl
	jr	z,@229
@218:
@204:
	.debug	} @204 1598

@203	equ	0
	lret
@205	equ	0
;1599 
;1600 
;1601 //=========================================================================
;1602 //  Now we update the values in "next" based on the "cur" and "prev"
;1603 //  values.
;1604 //=========================================================================
;1605 //  All values changed by updateNextState() are "outputs" from this func.
;1606 //  All other values referenced in this function are "inputs" to this func.
;1607 //
;1608 //  All the values in "next" provide information about the next logical sta
;1609 //  for the controller:  Values to be applied during the next pass of the
;1610 //  control logic.  All "next" values fall in to one of 2 categories:
;1611 //
;1612 //    - They are set/updated ONLY by this function (which is executed only
;1613 //      by the "applic" task)
;1614 //
;1615 //    - They are set ONLY by other tasks (within a lock), and possibly
;1616 //      reset/cleared by the "applic" task in updateCurState() (after copyi
;1617 //      "next" to "cur")
;1618 //
;1619 //
;1620 //  All values that act as input to this func must fall in to one of these
;1621 //  categories:
;1622 //
;1623 //    - "prev" values
;1624 //
;1625 //    - "cur" values updated directly by statements in updateCurState()
;1626 //
;1627 //    - "cur" values updated indirectly by updateCurState() due to the copy
;1628 //      of "next" to "cur", which includes the values in "next" that are
;1629 //      set by other tasks
;1630 //
;1631 //    - a shared/global value that is the equivalent of a "cur" value but
;1632 //      for which we don't need to track changes
;1633 //
;1634 //
;1635 //  All "outputs" from this function must be altered ONLY within this funct
;1636 //
;1637 //  All "inputs" to this function must NEVER be altered within this functio
;1638 //
;1639 //  Each output value (or VERY small "set" of ouput values) must be updated
;1640 //  in a single, self-contained block of code.  NO output may be referenced
;1641 //  OR altered in ANOTHER block of code:  This is a declarative style of
;1642 //  programming and has multiple advantages:
;1643 //
;1644 //     - There are no order-of-execution dependencies across nodes/blocks
;1645 //       within a pass.  They can be executed in any order and the result
;1646 //       will be the same (get used to it - this method will be the norm as
;1647 //       computer languages and hardware add support for atomic transaction
;1648 //       and computers evolve in to neural-net-like processor arrays - FPGA
;1649 //       are just the beginning of this trend).
;1650 //
;1651 //     - Encapsulating all logic for an output within a single node/block
;1652 //       leaves just one place to start when tracking a problem backward fr
;1653 //       the result (far simpler than guessing at the possible causes and
;1654 //       trying to work forward, looking for paths to the observed result).
;1655 //
;1656 //     - Drastically reduces the complexity of the code by greatly reducing
;1657 //       the number of possible paths through the code.  This simplifies
;1658 //       testing and verification processes.
;1659 //
;1660 //  Each node/block-of-code should be prefaced with the following informati
;1661 //   - The names of the values it modifies
;1662 //   - A descr of the meaning of the values and the logic used to set them
;1663 //   - A list of the values that serve as "inputs" to the node
;1664 //
;1665 //=========================================================================
;1666 void updateNextState(void)
;1667 {
$updateNextState::
	.debug	G $updateNextState 60 9
	.debug	{ $updateNextState 60 1666 @235 @234
;1668 //  char  temp[64];
;1669 
;1670 //--------------------------------------------------------------------
;1671 // Next.activeSetpoint
;1672 //    Description:
;1673 //       Determines the setpoint to be applied to the regulation
;1674 //       circuit at the beginning of the next pass.
;1675 //       See rampMode for a description of how changes are handled
;1676 //    Inputs:
;1677 //       rampMode
;1678 //       msSincePrev
;1679 //       Cur.activeSetpoint
;1680 //       Cur.rfOffSetpoint
;1681 //       Cur.rfOnSetpoint
;1682 //       coldRampRate
;1683 //       warmRampRate
;1684 //----------------------------------------------------------------------
;1685   switch (rampMode)  {
	ld	hl,(_rampMode)
	jp	@236
;1686     case RAMP_OFF:  // RF is OFF - use rfOffSetpoint
;1687       Next.activeSetpoint = Cur.rfOffSetpoint;  break;
@240:
	ld	de,(_curState+23)
	ld	bc,(_curState+25)
	jp	@455
;1688 
;1689     case RAMP_WAIT: // delay after recent OFF-to-ON
;1690       Next.activeSetpoint = Cur.activeSetpoint;  break;
@241:
	jr	@456
;1691 
;1692     case RAMP_COLD: // use the (presumably) slower cold rate
;1693     case RAMP_WARM: // use the (presumably) faster warm rate
@242:
;1694       if ((diff = Cur.rfOnSetpoint - Cur.activeSetpoint) == 0.0)  {
@243:
	ld	de,(_curState+19)
	ld	bc,(_curState+21)
	push	bc
	push	de
	ld	de,(_curState+15)
	ld	bc,(_curState+17)
	call	__fsub##
	ld	(_diff),de
	ld	(_diff+2),bc
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	nz,@244
;1695         Next.activeSetpoint = Cur.activeSetpoint;  break;  }
@456:
	ld	de,(_curState+15)
	ld	bc,(_curState+17)
	jp	@455
;1696       maxChg =
@244:
;1697         (rampMode == RAMP_COLD ? coldRampRate : warmRampRate);
	ld	hl,(_rampMode)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@247
	ld	de,(_coldRampRate)
	ld	bc,(_coldRampRate+2)
	jr	@248
@247:
	ld	de,(_warmRampRate)
	ld	bc,(_warmRampRate+2)
@248:
	ld	(_maxChg),de
	ld	(_maxChg+2),bc
;1698       maxChg = maxChg * (float)msSincePrev / 1000.0;
	ld	de,(_msSincePrev)
	ld	bc,(_msSincePrev+2)
	call	__ultof##
	push	bc
	push	de
	ld	de,(_maxChg)
	ld	bc,(_maxChg+2)
	call	__fmlt##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x447a
	call	__fdiv##
	ld	(_maxChg),de
	ld	(_maxChg+2),bc
;1699       if (FABS(diff) > maxChg)  diff = (diff < 0.0 ? -maxChg : maxChg);
	ld	de,(_diff)
	ld	bc,(_diff+2)
	push	bc
	push	de
	call	_fabs
	add	sp,4
	push	bc
	push	de
	ld	de,(_maxChg)
	ld	bc,(_maxChg+2)
	call	__fsub##
	jp	m,@249
	jr	z,@249
	ld	de,(_diff)
	ld	bc,(_diff+2)
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@250
	ld	de,(_maxChg)
	ld	bc,(_maxChg+2)
	ld	a,b
	xor	a,0x80
	ld	b,a
	jr	@251
@250:
	ld	de,(_maxChg)
	ld	bc,(_maxChg+2)
@251:
	ld	(_diff),de
	ld	(_diff+2),bc
;1700       Next.activeSetpoint = Cur.activeSetpoint + diff;
@249:
	ld	de,(_curState+15)
	ld	bc,(_curState+17)
	push	bc
	push	de
	ld	de,(_diff)
	ld	bc,(_diff+2)
	call	__fadd##
@455:
	ld	(_nextState+15),de
	ld	(_nextState+17),bc
;1701       break;
;1702   }
	jr	@237
;1703 
;1704 
;1705 //--------------------------------------------------------------------
;1706 // Next.rfOffSetpoint
;1707 //    Description:
;1708 //       The setpoint used whenever the RF is OFF.  Can be set by
;1709 //       remote clients or the Front Panel knob.
;1710 //    Inputs:
;1711 //       knobTicks
;1712 //       initialBtnPressed
;1713 //       rfOffSetpoint (Modbus register)
;1714 //----------------------------------------------------------------------
;1715   Next.rfOffSetpoint = rfOffSetpoint;
@236:
	ld	bc,hl
	ld	de,-4
	add	hl,de
	jr	c,@237
	ld	hl,@252
	add	hl,bc
	add	hl,bc
	ld	hl,(hl)
	jp	(hl)
	.seg	FARCODE
@252:
	dw	@240
	dw	@241
	dw	@242
	dw	@243
	.seg	FARCODE
@237:
	ld	de,(_rfOffSetpoint)
	ld	bc,(_rfOffSetpoint+2)
	ld	(_nextState+23),de
	ld	(_nextState+25),bc
;1716 
;1717   if (knobTicks AND initialBtnPressed)  {
	ld	hl,(_knobTicks)
	bool	hl
	jr	z,@254
	ld	a,(_initialBtnPressed)
	or	a,a
	jr	z,@254
;1718     Next.rfOffSetpoint = Cur.rfOffSetpoint + (float) knobTicks * knobRate;
	ld	hl,(_knobTicks)
	ex	de,hl
	call	__itof##
	push	bc
	push	de
	ld	de,(_knobRate)
	ld	bc,(_knobRate+2)
	call	__fmlt##
	push	bc
	push	de
	ld	de,(_curState+23)
	ld	bc,(_curState+25)
	call	__fadd##
	ld	(_nextState+23),de
	ld	(_nextState+25),bc
;1719 //    printf("Knob change to rfOffSetpoint\r\n");
;1720   }
;1721 
;1722   if (Next.rfOffSetpoint < 0.0)
@254:
	ld	de,(_nextState+23)
	ld	bc,(_nextState+25)
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@257
;1723     Next.rfOffSetpoint = 0.0;
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_nextState+23),de
	ld	(_nextState+25),bc
;1724   if (Next.rfOffSetpoint > maxOffSetpoint)
@257:
	ld	de,(_nextState+23)
	ld	bc,(_nextState+25)
	push	bc
	push	de
	ld	de,(_maxOffSetpoint)
	ld	bc,(_maxOffSetpoint+2)
	call	__fsub##
	jp	m,@258
	jr	z,@258
;1725     Next.rfOffSetpoint = maxOffSetpoint;
	ld	de,(_maxOffSetpoint)
	ld	bc,(_maxOffSetpoint+2)
	ld	(_nextState+23),de
	ld	(_nextState+25),bc
;1726 
;1727 //  if (Next.rfOffSetpoint != rfOffSetpoint)
;1728 //    printf("rfOffSetpoint changed to %s\r\n",
;1729 //           fmtFloat(Next.rfOffSetpoint, 7, 3, temp));
;1730 
;1731 
;1732 //--------------------------------------------------------------------
;1733 // Next.rfOnSetpoint
;1734 //    Description:
;1735 //       The setpoint toward which the active setpoint is adjusted
;1736 //       whenever the RF is ON.
;1737 //    Inputs:
;1738 //       knobTicks
;1739 //       finalBtnPressed
;1740 //       Cur.localMode
;1741 //       Cur.rfOffSetpoint
;1742 //       maxOnSetpoint (Modbus register)
;1743 //       rfOnSetpoint (Modbus register)
;1744 //----------------------------------------------------------------------
;1745   Next.rfOnSetpoint = rfOnSetpoint;
@258:
	ld	de,(_rfOnSetpoint)
	ld	bc,(_rfOnSetpoint+2)
	ld	(_nextState+19),de
	ld	(_nextState+21),bc
;1746 
;1747   if (knobTicks AND Cur.localMode)  {
	ld	hl,(_knobTicks)
	bool	hl
	jr	z,@260
	ld	a,(_curState+9)
	or	a,a
	jr	z,@260
;1748     Next.rfOnSetpoint = Cur.rfOnSetpoint + (float) knobTicks * knobRate;
	ld	hl,(_knobTicks)
	ex	de,hl
	call	__itof##
	push	bc
	push	de
	ld	de,(_knobRate)
	ld	bc,(_knobRate+2)
	call	__fmlt##
	push	bc
	push	de
	ld	de,(_curState+19)
	ld	bc,(_curState+21)
	call	__fadd##
	ld	(_nextState+19),de
	ld	(_nextState+21),bc
;1749 //    printf("Knob change to rfOnSetpoint\r\n");
;1750   }
;1751 
;1752   if (Next.rfOnSetpoint < Cur.rfOffSetpoint)
@260:
	ld	de,(_nextState+19)
	ld	bc,(_nextState+21)
	push	bc
	push	de
	ld	de,(_curState+23)
	ld	bc,(_curState+25)
	call	__fsub##
	jp	p,@263
;1753     Next.rfOnSetpoint = Cur.rfOffSetpoint;
	ld	de,(_curState+23)
	ld	bc,(_curState+25)
	ld	(_nextState+19),de
	ld	(_nextState+21),bc
;1754   if (Next.rfOnSetpoint > maxOnSetpoint)
@263:
	ld	de,(_nextState+19)
	ld	bc,(_nextState+21)
	push	bc
	push	de
	ld	de,(_maxOnSetpoint)
	ld	bc,(_maxOnSetpoint+2)
	call	__fsub##
	jp	m,@264
	jr	z,@264
;1755     Next.rfOnSetpoint = maxOnSetpoint;
	ld	de,(_maxOnSetpoint)
	ld	bc,(_maxOnSetpoint+2)
	ld	(_nextState+19),de
	ld	(_nextState+21),bc
;1756 
;1757 //  if (Next.rfOnSetpoint != rfOnSetpoint)
;1758 //    printf("rfOnSetpoint changed to %s\r\n",
;1759 //           fmtFloat(Next.rfOnSetpoint, 7, 3, temp));
;1760 }
@264:
@234:
	.debug	} @234 1760

@233	equ	0
	lret
@235	equ	0
;1761 
;1762 
;1763 //=========================================================================
;1764 //  Next we update output signal values to be written to the outputs at
;1765 //  the beginning of the next pass (just after the inputs are read).
;1766 //=========================================================================
;1767 void updateOutputState(void)
;1768 {
$updateOutputState::
	.debug	G $updateOutputState 60 9
	.debug	{ $updateOutputState 60 1767 @267 @266
;1769 
;1770 //--- update output values that are based on current conditions (values ---
;1771 //--- in "cur" or any values used in a conditional in the applic logic) ---
;1772   // (insured earlier that only ONE of these can be true when setting them)
;1773   if (initialBtnPressed)  setVal[FP_METER] = rfOffSetpoint;  else
	ld	a,(_initialBtnPressed)
	or	a,a
	jr	z,@268
	ld	de,(_rfOffSetpoint)
	ld	bc,(_rfOffSetpoint+2)
	ld	(_setVal+4),de
	ld	(_setVal+6),bc
;1774   if (finalBtnPressed)    setVal[FP_METER] = rfOnSetpoint;  else
	jr	@269
@268:
	ld	a,(_finalBtnPressed)
	or	a,a
	jr	z,@270
	ld	de,(_rfOnSetpoint)
	ld	bc,(_rfOnSetpoint+2)
	ld	(_setVal+4),de
	ld	(_setVal+6),bc
;1775                           setVal[FP_METER] = cavityVolts;
	jr	@271
@270:
	ld	de,(_cavityVolts)
	ld	bc,(_cavityVolts+2)
	ld	(_setVal+4),de
	ld	(_setVal+6),bc
;1776 
;1777 
;1778   SetOffApplLEDs(Next.digitalOut);
@271:
@269:
	ld	de,(_nextState+11)
	ld	bc,(_nextState+13)
	res	0,e
	res	1,e
	ld	(_nextState+11),de
	ld	(_nextState+13),bc
;1779 
;1780   if (limited)  SetOnLimitLED(Next.digitalOut);
	ld	a,(_limited)
	or	a,a
	jr	z,@272
	set	0,e
	ld	(_nextState+11),de
	ld	(_nextState+13),bc
;1781   if (regErr)   SetOnErrorLED(Next.digitalOut);
@272:
	ld	a,(_regErr)
	or	a,a
	jr	z,@273
	ld	de,(_nextState+11)
	ld	bc,(_nextState+13)
	set	1,e
	ld	(_nextState+11),de
	ld	(_nextState+13),bc
;1782 
;1783 
;1784 //--- update output values based on values that were set by the application
;1785 //--- logic (e.g. values in "next" or variables that are the target of an -
;1786 //--- assignment statement in the application logic) ---
;1787   setVal[SETPOINT] = Next.activeSetpoint;
@273:
	ld	de,(_nextState+15)
	ld	bc,(_nextState+17)
	ld	(_setVal),de
	ld	(_setVal+2),bc
;1788 
;1789 }
@266:
	.debug	} @266 1789

@265	equ	0
	lret
@267	equ	0
;1790 
;1791 
;1792 
;1793 //=========================================================================
;1794 // The last thing we do is update values read by other tasks
;1795 //=========================================================================
;1796 // IMPORTANT NOTES and WARNINGS:
;1797 //
;1798 //   To avoid concurrency issues, other tasks need to use locks when readin
;1799 //   values set here.  But be careful to keep such locks short to avoid
;1800 //   delaying the timing of the main application task.  If necessary, split
;1801 //   such code in to sections, getting and releasing the lock(s) in each
;1802 //   section to avoid increasing latency for the main application task.
;1803 //
;1804 //   Values in the "next" instance of the application state fall in to 2
;1805 //   categories:  Inputs and Outputs.
;1806 //
;1807 //   The "next" Outputs are those that may be changed in updateOutputState(
;1808 //   The reset are Inputs, and may be changed by other tasks within a lock.
;1809 //
;1810 //   Since each pass through the application logic starts by setting
;1811 //   cur = next, any "next" values set by other tasks become part of the
;1812 //   "cur" instance used by the rest of the applic logic.  Because the
;1813 //   "applic" task at a higher priority than any other real-time task, the
;1814 //   changes to "next" values by other tasks can ONLY happen between passes
;1815 //   through the applic logic loop.
;1816 //
;1817 //   NOTES:
;1818 //     - Some of these "next" input values values must be initialized in
;1819 //       updateCurState() in order to tell when a value is set by another
;1820 //       task.  For example, if we have a boolean flag that is set when we
;1821 //       get an ON command, then (after its "next" value is copied to "cur"
;1822 //       we have to clear the flag in order to tell if another ON command i
;1823 //       received between passes.
;1824 //
;1825 //     - As with reads to these values, other tasks must use locks when
;1826 //       writing to the "next" input values to insure they are not preempte
;1827 //       by the "applic" task in the middle of a write.
;1828 //
;1829 //=========================================================================
;1830 void updateExternals(void)
;1831 {
$updateExternals::
	.debug	G $updateExternals 60 9
	.debug	{ $updateExternals 60 1830 @276 @275
;1832 //--- update settings based on values that were USED by the application ---
;1833 //--- logic (i.e. "cur" values that serve as "inputs" to the logic) ---
;1834   activeSetpoint = Cur.activeSetpoint;
	ld	de,(_curState+15)
	ld	bc,(_curState+17)
	ld	(_activeSetpoint),de
	ld	(_activeSetpoint+2),bc
;1835 
;1836   statusBitsAppl = 0;
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;1837   if (Cur.rfIsOn)      statusBitsAppl |= STAT_RF_ON;
	ld	a,(_curState+8)
	or	a,a
	jr	z,@277
	set	0,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;1838   if (limited)         statusBitsAppl |= STAT_LIMITED;
@277:
	ld	a,(_limited)
	or	a,a
	jr	z,@278
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	1,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;1839   if (regErr)          statusBitsAppl |= STAT_REG_ERR;
@278:
	ld	a,(_regErr)
	or	a,a
	jr	z,@279
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	2,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;1840   if (!Cur.localMode)  statusBitsAppl |= STAT_REMOTE;
@279:
	ld	a,(_curState+9)
	or	a,a
	jr	nz,@280
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	3,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;1841   if (Cur.closedLoop)  statusBitsAppl |= STAT_CLOSED;
@280:
	ld	a,(_curState+10)
	or	a,a
	jr	z,@281
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	4,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;1842 
;1843 
;1844 //--- update settings based on values that were UPDATED by the application 
;1845 //--- logic (i.e. "next" values that serve as "outputs" from the logic) ---
;1846   rfOffSetpoint = Next.rfOffSetpoint;
@281:
	ld	de,(_nextState+23)
	ld	bc,(_nextState+25)
	ld	(_rfOffSetpoint),de
	ld	(_rfOffSetpoint+2),bc
;1847   rfOnSetpoint = Next.rfOnSetpoint;
	ld	de,(_nextState+19)
	ld	bc,(_nextState+21)
	ld	(_rfOnSetpoint),de
	ld	(_rfOnSetpoint+2),bc
;1848 
;1849 
;1850 //--- temp method of setting read/set gains based on hardware config ---
;1851   switch (hdwCfg)  {
	ld	hl,(_hdwCfg)
	jr	@282
;1852     case K500_CFG:
;1853       readGain[RF_CAV_VOLT] = 10.0;
@286:
	ld	de,0
	ld	bc,0x4120
	jr	@454
;1854       setGain[SETPOINT] = setGain[FP_METER] = 10.0;
;1855       break;
;1856 
;1857     case K1200_CFG:
;1858       readGain[RF_CAV_VOLT] = 20.0;
@287:
	ld	de,0
	ld	bc,0x41a0
@454:
	ld	(_readGain),de
	ld	(_readGain+2),bc
;1859       setGain[SETPOINT] = setGain[FP_METER] = 20.0;
	ld	(_setGain+4),de
	ld	(_setGain+6),bc
	ld	(_setGain),de
	ld	(_setGain+2),bc
;1860       break;
;1861   }
	jr	@283
;1862 
;1863   hdwCfgVolts = readVal[HDW_CFG];
@282:
	ex	de,hl
	ld	hl,0xffffffff
	add	hl,de
	bool	hl
	jr	z,@286
	ld	hl,0xfffffffe
	add	hl,de
	bool	hl
	jr	z,@287
@283:
	ld	de,(_readVal+12)
	ld	bc,(_readVal+14)
	ld	(_hdwCfgVolts),de
	ld	(_hdwCfgVolts+2),bc
;1864 }
@275:
	.debug	} @275 1864

@274	equ	0
	lret
@276	equ	0
;1865 
;1866 
;1867 
;1868 //=========================================================================
;1869 _nearcall float readGetRaw(uint ui)  {
	.align	4
$$readGetRaw::
	ex	(sp),iy
$readGetRaw::
	.debug	G $readGetRaw 77 9
	.debug	{ $readGetRaw 77 1869 @290 @289
	push	ix
	ld	ix,0
	add	ix,sp
;1870   return (ui < NumHdwADC ? anaIn[ui] : 0.0);  }
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@291
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@289
@291:
	ld	de,0
	ld	c,e
	ld	b,e
@289:
	.debug	} @289 1870

@288	equ	0
	pop	ix
	lret
@290	equ	2
;1871 
;1872 _nearcall float readMinRaw(uint ui)  {
	.align	4
$$readMinRaw::
	ex	(sp),iy
$readMinRaw::
	.debug	G $readMinRaw 77 9
	.debug	{ $readMinRaw 77 1872 @295 @294
	push	ix
	ld	ix,0
	add	ix,sp
;1873   return (ui < NumHdwADC) ? (adcMinRaw(ui) - adcOffset[ui]) * adcGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@296
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMinRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@294
@296:
	ld	de,0
	ld	c,e
	ld	b,e
@294:
	.debug	} @294 1873

@293	equ	0
	pop	ix
	lret
@295	equ	2
;1874 
;1875 _nearcall float readMaxRaw(uint ui)  {
	.align	4
$$readMaxRaw::
	ex	(sp),iy
$readMaxRaw::
	.debug	G $readMaxRaw 77 9
	.debug	{ $readMaxRaw 77 1875 @300 @299
	push	ix
	ld	ix,0
	add	ix,sp
;1876   return (ui < NumHdwADC) ? (adcMaxRaw(ui) - adcOffset[ui]) * adcGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@301
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMaxRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@299
@301:
	ld	de,0xcccd
	ld	bc,0x411c
@299:
	.debug	} @299 1876

@298	equ	0
	pop	ix
	lret
@300	equ	2
;1877 
;1878 _nearcall void readDefaults(uint ui, float *gain, float *offset)  {
	.align	4
$$readDefaults::
	ex	(sp),iy
$readDefaults::
	.debug	G $readDefaults 78 9
	.debug	{ $readDefaults 78 1878 @305 @304
	push	ix
	ld	ix,0
	add	ix,sp
;1879   *gain = ((ui == 0) ? 10.0 : 1.0);  *offset = 0.0; }
	ld	hl,(ix+5)
	bool	hl
	jr	nz,@306
	ld	d,h
	ld	e,h
	ld	bc,0x4120
	jr	@307
@306:
	ld	de,0
	ld	bc,0x3f80
@307:
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@304:
	.debug	} @304 1879

@303	equ	0
	pop	ix
	lret
@305	equ	2
;1880 
;1881 _nearcall void readCalibPoints(uint ui, float *low, float *high)  {
	.align	4
$$readCalibPoints::
	ex	(sp),iy
$readCalibPoints::
	.debug	G $readCalibPoints 78 9
	.debug	{ $readCalibPoints 78 1881 @310 @309
	push	ix
	ld	ix,0
	add	ix,sp
;1882   *low = 0.0;  *high = 90.0; }
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	bc,0x42b4
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@309:
	.debug	} @309 1882

@308	equ	0
	pop	ix
	lret
@310	equ	2
;1883 
;1884 _nearcall char *readUnits(uint ui, char *buf)  { return "kV"; }
	.align	4
$$readUnits::
	ex	(sp),iy
$readUnits::
	.debug	G $readUnits 79 9
	.debug	{ $readUnits 79 1884 @313 @312
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,@2+210
@312:
	.debug	} @312 1884

@311	equ	0
	pop	ix
	lret
@313	equ	2
;1885 
;1886 
;1887 //=========================================================================
;1888 _nearcall float setGetRaw(uint ui)  {
	.align	4
$$setGetRaw::
	ex	(sp),iy
$setGetRaw::
	.debug	G $setGetRaw 77 9
	.debug	{ $setGetRaw 77 1888 @316 @315
	push	ix
	ld	ix,0
	add	ix,sp
;1889   return (ui < NumHdwADC ? anaOut[ui] : 0.0);  }
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@317
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_anaOut
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@315
@317:
	ld	de,0
	ld	c,e
	ld	b,e
@315:
	.debug	} @315 1889

@314	equ	0
	pop	ix
	lret
@316	equ	2
;1890 
;1891 _nearcall float setMinRaw(uint ui)  {
	.align	4
$$setMinRaw::
	ex	(sp),iy
$setMinRaw::
	.debug	G $setMinRaw 77 9
	.debug	{ $setMinRaw 77 1891 @321 @320
	push	ix
	ld	ix,0
	add	ix,sp
;1892   return (ui < NumHdwDAC) ? (dacMinRaw(ui) - dacOffset[ui]) * dacGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@322
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMinRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@320
@322:
	ld	de,0
	ld	c,e
	ld	b,e
@320:
	.debug	} @320 1892

@319	equ	0
	pop	ix
	lret
@321	equ	2
;1893 
;1894 _nearcall float setMaxRaw(uint ui)  {
	.align	4
$$setMaxRaw::
	ex	(sp),iy
$setMaxRaw::
	.debug	G $setMaxRaw 77 9
	.debug	{ $setMaxRaw 77 1894 @326 @325
	push	ix
	ld	ix,0
	add	ix,sp
;1895   return (ui < NumHdwDAC) ? (dacMaxRaw(ui) - dacOffset[ui]) * dacGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@327
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMaxRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@325
@327:
	ld	de,0xcccd
	ld	bc,0x411c
@325:
	.debug	} @325 1895

@324	equ	0
	pop	ix
	lret
@326	equ	2
;1896 
;1897 _nearcall void setDefaults(uint ui, float *gain, float *offset)  {
	.align	4
$$setDefaults::
	ex	(sp),iy
$setDefaults::
	.debug	G $setDefaults 78 9
	.debug	{ $setDefaults 78 1897 @331 @330
	push	ix
	ld	ix,0
	add	ix,sp
;1898   *gain = ((ui < 2) ? 10.0 : 1.0);  *offset = 0.0; }
	ld	hl,(ix+5)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nc,@332
	ld	e,d
	ld	bc,0x4120
	jr	@333
@332:
	ld	de,0
	ld	bc,0x3f80
@333:
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@330:
	.debug	} @330 1898

@329	equ	0
	pop	ix
	lret
@331	equ	2
;1899 
;1900 _nearcall void setCalibPoints(uint ui, float *low, float *high)  {
	.align	4
$$setCalibPoints::
	ex	(sp),iy
$setCalibPoints::
	.debug	G $setCalibPoints 78 9
	.debug	{ $setCalibPoints 78 1900 @336 @335
	push	ix
	ld	ix,0
	add	ix,sp
;1901   *low = 0.0;  *high = 90.0;  }
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	bc,0x42b4
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@335:
	.debug	} @335 1901

@334	equ	0
	pop	ix
	lret
@336	equ	2
;1902 
;1903 _nearcall char *setUnits(uint ui, char *buf)  { return "kV"; }
	.align	4
$$setUnits::
	ex	(sp),iy
$setUnits::
	.debug	G $setUnits 79 9
	.debug	{ $setUnits 79 1903 @339 @338
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,@2+210
@338:
	.debug	} @338 1903

@337	equ	0
	pop	ix
	lret
@339	equ	2
;1904 
;1905 
;1906 //=========================================================================
;1907 //  Set default labels for all the I/O signals
;1908 //=========================================================================
;1909 void setDefaultLabels(void)
;1910 {
$setDefaultLabels::
	.debug	G $setDefaultLabels 60 9
	.debug	{ $setDefaultLabels 60 1909 @342 @341
;1911   printf("Setting default labels for I/O signals\r\n");
	ld	de,word (phys @1+1268)
	ld	c,phys @1+1268 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1912 
;1913 //--- set application-appropriate default labels ---
;1914 //APPLCODE
;1915 
;1916 //--- set default labels for the I/O signals ---
;1917   fstrcpy(ainLabel[0], "RF_Cavity");
	ld	de,word (phys @1+1309)
	ld	c,phys @1+1309 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1918   fstrcpy(ainLabel[1], "Limiter");
	ld	de,word (phys @1+1319)
	ld	c,phys @1+1319 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+24)
	ld	c,phys _ainLabel+24 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1919   fstrcpy(ainLabel[2], "<unused>");
	ld	de,word (phys @1+1327)
	ld	c,phys @1+1327 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+48)
	ld	c,phys _ainLabel+48 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1920   fstrcpy(ainLabel[3], "HdwConfig");
	ld	de,word (phys @1+1336)
	ld	c,phys @1+1336 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+72)
	ld	c,phys _ainLabel+72 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1921 
;1922   fstrcpy(aoutLabel[0], "Setpoint");
	ld	de,word (phys @1+207)
	ld	c,phys @1+207 >> 16
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1923   fstrcpy(aoutLabel[1], "FP_Meter");
	ld	de,word (phys @1+1346)
	ld	c,phys @1+1346 >> 16
	push	bc
	push	de
	ld	de,word (phys _aoutLabel+24)
	ld	c,phys _aoutLabel+24 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1924 
;1925   fstrcpy(dinLabel[0], "Closed_Loop");
	ld	de,word (phys @1+1355)
	ld	c,phys @1+1355 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1926   fstrcpy(dinLabel[1], "FINAL_btn");
	ld	de,word (phys @1+1367)
	ld	c,phys @1+1367 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+24)
	ld	c,phys _dinLabel+24 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1927   fstrcpy(dinLabel[2], "INITIAL_btn");
	ld	de,word (phys @1+1377)
	ld	c,phys @1+1377 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+48)
	ld	c,phys _dinLabel+48 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1928   fstrcpy(dinLabel[3], "RF_OFF");
	ld	de,word (phys @1+1389)
	ld	c,phys @1+1389 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+72)
	ld	c,phys _dinLabel+72 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1929   fstrcpy(dinLabel[4], "Local_mode");
	ld	de,word (phys @1+1396)
	ld	c,phys @1+1396 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+96)
	ld	c,phys _dinLabel+96 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1930 
;1931   fstrcpy(doutLabel[0], "Limited_LED");
	ld	de,word (phys @1+1407)
	ld	c,phys @1+1407 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1932   fstrcpy(doutLabel[1], "Error_LED");
	ld	de,word (phys @1+1419)
	ld	c,phys @1+1419 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+24)
	ld	c,phys _doutLabel+24 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1933   fstrcpy(doutLabel[8], "Activity_LED");
	ld	de,word (phys @1+1429)
	ld	c,phys @1+1429 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+192)
	ld	c,phys _doutLabel+192 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1934 }
@341:
	.debug	} @341 1934

@340	equ	0
	lret
@342	equ	0
;1935 
;1936 
;1937 //=========================================================================
;1938 //  This function is called to force software configurable values to defaul
;1939 //  values.
;1940 //=========================================================================
;1941 void setDefaultConfig(void)
;1942 {
$setDefaultConfig::
	.debug	G $setDefaultConfig 60 9
	.debug	{ $setDefaultConfig 60 1941 @345 @344
;1943   printf("Setting in-RAM device config to default values\r\n");
	ld	de,word (phys @1+1442)
	ld	c,phys @1+1442 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1944 
;1945 //===== set default values for persistent data values =====
;1946 //APPLCODE
;1947 
;1948   coldRampRate =  50.0;  // in kV/sec
	ld	de,0
	ld	bc,0x4248
	ld	(_coldRampRate),de
	ld	(_coldRampRate+2),bc
;1949   warmRampRate = 100.0;  // in kV/sec
	ld	c,0xc8
	ld	(_warmRampRate),de
	ld	(_warmRampRate+2),bc
;1950 
;1951   offToOnDelay = 250;     // in milliseconds
	ld	hl,0xfa
	ld	(_offToOnDelay),hl
;1952 
;1953   maxRegErr = 1.0;    // in kV
	ld	bc,0x3f80
	ld	(_maxRegErr),de
	ld	(_maxRegErr+2),bc
;1954 
;1955   hdwCfg = HdwConfig(digitalIn);
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	call	__ultof##
	push	bc
	push	de
	call	_fabs
	add	sp,4
	push	bc
	push	de
	ld	de,0x3d71
	ld	bc,0x40a2
	call	__fsubr##
	push	bc
	push	de
	ld	de,0xf8a1
	ld	bc,0x3fc9
	call	__fmlt##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x3f00
	call	__fadd##
	call	__ftol##
	ld	(_hdwCfg),de
;1956 
;1957   switch (hdwCfg)  {
	ld	h,d
	ld	l,e
	jr	@346
;1958     case K500_CFG:
;1959       limiterActiveV = 0.310;  // in kV
@350:
	ld	de,0xb852
	ld	bc,0x3e9e
	ld	(_limiterActiveV),de
	ld	(_limiterActiveV+2),bc
;1960       maxOffSetpoint = 30.0;   // in kV
	ld	de,0
	ld	bc,0x41f0
	ld	(_maxOffSetpoint),de
	ld	(_maxOffSetpoint+2),bc
;1961       maxOnSetpoint = 100.0;   // in kV
	ld	bc,0x42c8
	jr	@453
;1962       break;
;1963 
;1964     case K1200_CFG:
;1965       limiterActiveV = 0.310; // in kV
;1966       maxOffSetpoint = 60.0;  // in kV
;1967       maxOnSetpoint = 200.0;  // in kV
;1968       break;
;1969 
;1970     default:
;1971       limiterActiveV = 0.310; // in kV
@352:
	ld	de,0xb852
	ld	bc,0x3e9e
	ld	(_limiterActiveV),de
	ld	(_limiterActiveV+2),bc
;1972       maxOffSetpoint = 60.0;  // in kV
	ld	de,0
	ld	bc,0x4270
	ld	(_maxOffSetpoint),de
	ld	(_maxOffSetpoint+2),bc
;1973       maxOnSetpoint = 200.0;  // in kV
	ld	bc,0x4348
@453:
	ld	(_maxOnSetpoint),de
	ld	(_maxOnSetpoint+2),bc
;1974   }
;1975 
;1976   knobRate = 0.05;
	jr	@347
@346:
	ex	de,hl
	ld	hl,0xffffffff
	add	hl,de
	bool	hl
	jr	z,@350
	ld	hl,0xfffffffe
	add	hl,de
	bool	hl
	jr	z,@352
	jr	@352
@347:
	ld	de,0xcccd
	ld	bc,0x3d4c
	ld	(_knobRate),de
	ld	(_knobRate+2),bc
;1977 }
@344:
	.debug	} @344 1977

@343	equ	0
	lret
@345	equ	0
;1978 
;1979 
;1980 //=========================================================================
;1981 //  This function is called by the application loop just before a shutdown.
;1982 //  The appliation must do whatever is necessary for a clean shutdown and
;1983 //  then exit
;1984 //=========================================================================
;1985 void applicShutdown(void)
;1986 {
$applicShutdown::
	.debug	G $applicShutdown 60 9
	.debug	{ $applicShutdown 60 1985 @355 @354
;1987   printf("Application prepping for shutdown\r\n");  fflush(stdout);
	ld	de,word (phys @1+1491)
	ld	c,phys @1+1491 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
;1988 
;1989 
;1990   Exit(0);
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;1991 }
@354:
	.debug	} @354 1991

@353	equ	0
	lret
@355	equ	0
;1992 
;1993 
;1994 //=========================================================================
;1995 //  This is the highest priority task, usually resumed at a regular interva
;1996 //  so that it can do what it needs and sleep again until the start of the
;1997 //  next interval.
;1998 //=========================================================================
;1999 void _task applic(int argc, char **argv)
;2000 {
	.align	4
$$applic::
	ex	(sp),iy
$applic::
	.debug	G $applic 76 9
	.debug	{ $applic 76 1999 @358 @357
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-114
;2001   #define SharedApplLocals
;2002   #include <sharedAppl.c>
;2003 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;2004 //--- add local variable definitions here ---
;2005 
;2006 
;2007   #define SharedApplLocals2
;2008   #include <sharedAppl.c>
;2009 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;2010 //--- add local array definitions here ---
;2011 
;2012 
;2013 //--- place code here to set initial default values ---
;2014   allowSoftReset = true;
	ld	a,0x1
	ld	(_allowSoftReset),a
;2015 
;2016 
;2017   #define SharedApplInit
;2018   #include <sharedAppl.c>
;2019 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_prevState
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_curState
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_nextState
	push	hl
	call	_memset
	add	sp,6
	bool	hl
	ld	l,h
	ld	(_numScopeRegs),hl
	lcall	$resetWDT
	ld	de,0xf
	ld	c,d
	ld	b,d
	ld	(_ADC_Mask),de
	ld	(_ADC_Mask+2),bc
	ld	de,0x3
	ld	(_DAC_Mask),de
	ld	(_DAC_Mask+2),bc
	ld	e,c
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@361:
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@362
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_adcOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_adcGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$adcDefaults
	add	sp,6
	ld	hl,(ix-24)
	add	hl,hl
	ld	de,_lastadcRaw
	add	hl,de
	ld	de,0xbad
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@361
@362:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@368:
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@369
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_dacOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_dacGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$dacDefaults
	add	sp,6
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@368
@369:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@375:
	ld	hl,(ix-24)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@376
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$readDefaults
	add	sp,6
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readVal
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	z,@381
	jr	nc,@380
@381:
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
@380:
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@375
@376:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@384:
	ld	hl,(ix-24)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@385
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$setDefaults
	add	sp,6
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	z,@390
	jr	nc,@389
@390:
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
@389:
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@384
@385:
	lcall	$setGenericLabels
	ld	de,0x4000
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-46),hl
	ex	de,hl
	ld	(ix-48),hl
	ex	de,hl
	push	hl
	ld	hl,-46+@356
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$sigprocmask
	add	sp,6
	ld	de,word (phys @1+1527)
	ld	c,phys @1+1527 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$initModBusRegs
	ld	hl,0x52
	ld	(_devType),hl
	ld	hl,_netmask
	push	hl
	ld	hl,@2+213
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ptoh
	add	sp,6
	ld	hl,_gateway
	push	hl
	ld	hl,@2+225
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ptoh
	add	sp,6
	bool	hl
	ld	l,h
	push	hl
	ld	hl,@2+237
	push	hl
	lcall	$mkfifo
	add	sp,4
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x21
	push	hl
	ld	hl,@2+237
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-38),hl
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastIdleTime),hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_lastIdleMS),de
	ld	(_lastIdleMS+2),bc
	bool	hl
	ld	l,h
	ld	(_ctlLoopTicks),hl
	ld	(_lastCtlLoopTime),hl
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	lcall	$setDefaultLabels
	lcall	$setDefaultConfig
	lcall	$initIOvalues
	ld	de,word (phys _prevLogInfo+116)
	ld	c,phys _prevLogInfo+116 >> 16
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@391
	lcall	$restoreApplState
	ld	(ix-36),hl
	bool	hl
	jr	z,@394
	ld	hl,(ix-36)
	push	hl
	ld	de,word (phys @1+1552)
	ld	c,phys @1+1552 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@397
	xor	a,a
	ld	(_runBackup),a
@397:
	ld	hl,0x1
	push	hl
	lcall	$REBOOT
	pop	hl
@394:
	ld	a,0x1
	ld	(_restoredApplState),a
@391:
	ld	hl,0x100
	push	hl
	ld	hl,_applBuf
	push	hl
	lcall	$initParamModule
	add	sp,4
	ld	a,(_restoredApplState)
	or	a,a
	jr	nz,@398
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState),de
	ld	(_nextState+2),bc
	ld	(_curState),de
	ld	(_curState+2),bc
	ld	(_prevState),de
	ld	(_prevState+2),bc
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	ld	(_nextState+11),de
	ld	(_nextState+13),bc
	ld	(_curState+11),de
	ld	(_curState+13),bc
	ld	(_prevState+11),de
	ld	(_prevState+13),bc
@398:
	bool	hl
	ld	l,h
	push	hl
	lcall	$startNetUp
	pop	de
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
@401:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x2710
	ld	bc,0
	call	__lsub##
	jr	nc,@403
	bool	hl
	ld	l,h
	push	hl
	lcall	$ifpending
	pop	de
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@403
	lcall	$resetWDT
	jp	@401
@403:
	bool	hl
	ld	l,h
	push	hl
	lcall	$ifpending
	pop	de
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@404
	ld	de,word (phys @1+1611)
	ld	c,phys @1+1611 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jr	@405
@404:
	bool	hl
	ld	l,h
	push	hl
	lcall	$showNetState
	pop	hl
@405:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@408:
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@409
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@408
@409:
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@413:
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@414
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
;2020 //--- add application initialization code here ---
;2021 
;2022 
;2023   #define SharedApplInit2
;2024   #include <sharedAppl.c>
;2025 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@413
@414:
	lcall	$resetWDT
	ld	hl,0x1
	push	hl
	lcall	$logDigIOChgs
	pop	hl
	ld	hl,@2+248
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@356
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,_inetd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+254
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@356
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x7
	push	hl
	ld	hl,_configd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+262
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@356
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,_backupd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+270
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@356
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0xb
	push	hl
	ld	hl,_ca_tcpd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,0x5dc
	ld	(ix-34),hl
	lcall	$resetWDT
	bool	hl
	ld	l,h
	ld	(_applicTicks),hl
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-26),hl
	bool	hl
	ld	l,h
	ld	(_applLoopTime),hl
	lcall	$xavail
	push	bc
	push	de
	ld	de,word (phys @1+1652)
	ld	c,phys @1+1652 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	a,0x1
	ld	(_startupComplete),a
;2026 
;2027 //--- The following loop is run at a periodic interval (normally 100 times 
;2028 //--- per second, or every 10ms).  The application process normally ---
;2029 //--- consists of reading the current state of the digital and analog ---
;2030 //--- inputs, changing the state of the analog and digital outputs to the -
;2031 //--- values computed during the previous pass, then computing new values -
;2032 //--- for the outputs and updating values that outside clients can view ---
;2033 //--- (currently accessable as a set of ModBus registers) ---
;2034 
;2035   for (;;)  {
@418:
;2036     #define SharedApplLoopStart
;2037     #include <sharedAppl.c>
;2038 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	ld	hl,(_applicTicks)
	inc	hl
	ld	(_applicTicks),hl
	ld	hl,(ix-34)
	bool	hl
	jr	z,@423
	ld	hl,(ix-34)
	dec	hl
	ld	(ix-34),hl
	bool	hl
	jr	nz,@424
	xor	a,a
	ld	(_runBackup),a
@424:
@423:
	lcall	$resetWDT
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	hl,(ix-26)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(_applLoopTime),hl
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
	lcall	$schedule
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-26),hl
	ipset	2
	ld	a,(_intTicks)
	bool	hl
	ld	l,a
	ld	(_latency),hl
	ipres
	ld	hl,(_ctlLoopTicks)
	inc	hl
	ld	(_ctlLoopTicks),hl
	ld	hl,(ix-26)
	ld	de,(_lastCtlLoopTime)
	or	a,a
	sbc	hl,de
	ld	de,0x7d0
	or	a,a
	sbc	hl,de
	jr	c,@425
	ld	hl,(_ctlLoopTicks)
	or	a,a
	rr	hl
	ld	(_ctlLoopTicksPerSec),hl
	bool	hl
	ld	l,h
	ld	(_ctlLoopTicks),hl
	ld	hl,(ix-26)
	ld	(_lastCtlLoopTime),hl
;2039   //--- read the current state of the analog and digital Input signals, and
;2040   //--- write the values computed at the end of the last pass ---
;2041     digitalOut = Next.digitalOut;  rwIO();
@425:
	ld	de,(_nextState+11)
	ld	bc,(_nextState+13)
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	lcall	$rwIO
;2042 
;2043   //--- process next event message (if any) ---
;2044     processMsg(eventsfd, (EventMsg *)buf, sizeof(buf));
	ld	hl,0x40
	push	hl
	ld	hl,-112+@356
	add	hl,sp
	push	hl
	ld	hl,(ix-38)
	push	hl
	lcall	$processMsg
	add	sp,6
;2045 
;2046   //--- update the current state and determine the next state ---
;2047     updateCurState();  updateNextState();
	lcall	$updateCurState
	lcall	$updateNextState
;2048     updateOutputState();  updateExternals();
	lcall	$updateOutputState
	lcall	$updateExternals
;2049 
;2050 
;2051     #define SharedApplLoopEnd
;2052     #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	lcall	$ReadDeviceID
	ld	(_deviceID),de
	ld	(_deviceID+2),bc
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastIdleTime)
	or	a,a
	sbc	hl,de
	ld	(ix-28),hl
	ld	de,0xbb8
	or	a,a
	sbc	hl,de
	jr	c,@428
	ld	hl,(_idleTask)
	ld	de,0xd3
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,(_lastIdleMS)
	ld	bc,(_lastIdleMS+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x64
	ld	c,d
	ld	b,d
	call	__ulmlt##
	ld	hl,(ix-28)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__uldiv##
	ld	(_percentIdle),de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	(_lastIdleMS),de
	ld	(_lastIdleMS+2),bc
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastIdleTime),hl
@428:
	ld	hl,(_devType)
	ld	(_devType_),hl
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	ld	(_deviceID_),de
	ld	(_deviceID_+2),bc
ipset 3
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
ipres
	ld	(_upSecs),de
	ld	(_upSecs+2),bc
	ld	hl,(_percentIdle)
	ld	(_percentIdle_),hl
	ld	hl,(_timeZone)
	ld	(_timeZone_),hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	ld	(_curTime),de
	ld	(_curTime+2),bc
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_digInBits),de
	ld	(_digInBits+2),bc
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	ld	(_digOutBits),de
	ld	(_digOutBits+2),bc
	ld	hl,-48+@356
	add	hl,sp
	push	hl
	lcall	$sigpending
	pop	de
	bool	hl
	jp	nz,@431
	ld	l,0xf
	push	hl
	ld	hl,-46+@356
	add	hl,sp
	push	hl
	lcall	$sigismember
	add	sp,4
	bool	hl
	jp	z,@432
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	or	hl,de
	jp	nz,@433
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@433:
@432:
@431:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	or	hl,de
	jp	z,@435
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x1f40
	ld	bc,0
	call	__lsub##
	jr	c,@435
	jr	z,@435
	lcall	$applicShutdown
@435:
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,0x40
	and	hl,de
	jr	z,@436
	ld	de,(_nextState+11)
	ld	bc,(_nextState+13)
	res	0,d
	ld	(_nextState+11),de
	ld	(_nextState+13),bc
	jr	@437
@436:
	ld	de,(_nextState+11)
	ld	bc,(_nextState+13)
	set	0,d
	ld	(_nextState+11),de
	ld	(_nextState+13),bc
@437:
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	ld	a,e
	or	a,d
	or	a,c
	jp	z,@438
	ipset	2
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(_milliTicks)
	ld	(ix-32),hl
	ipres
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x4240
	ld	c,0xf
	call	__ulmlt##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	bool	hl
	ld	l,h
	ld	(ix-22),hl
	ld	hl,(_scopeList)
	ld	(ix-50),hl
@443:
	ld	hl,(ix-22)
	ld	de,(_numScopeRegs)
	or	a,a
	sbc	hl,de
	jp	nc,@444
	ld	hl,(ix-50)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ld	(ix-30),hl
	ld	e,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@448
	ld	hl,(ix-50)
	ld	hl,(hl)
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst2##
	jp	@449
@448:
	ld	hl,(ix-50)
	ld	hl,(hl)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
@449:
	ld	hl,(ix-30)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	ld	hl,(ix-22)
	inc	hl
	ld	(ix-22),hl
	add	hl,hl
	ld	de,_scopeList
	add	hl,de
	ld	hl,(hl)
	ld	(ix-50),hl
	jp	@443
@444:
	ld	de,(_captureCount)
	ld	bc,(_captureCount+2)
	call	__linc##
	ld	(_captureCount),de
	ld	(_captureCount+2),bc
	ld	hl,(_captureIdx)
	inc	hl
	ld	(_captureIdx),hl
	ld	de,(_scopeBufSampleSize)
	or	a,a
	sbc	hl,de
	jr	nz,@450
	bool	hl
	ld	l,h
	ld	(_captureIdx),hl
	ld	de,(_scopeBuf)
	ld	bc,(_scopeBuf+2)
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
@450:
@438:
	ld	a,0x1
	ld	(_applicReady),a
;2053   }
;2054 
;2055 }
	jp	@418
@357:
	.debug	} @357 2055

@356	equ	114
	ld	sp,ix
	pop	ix
	lret
@358	equ	116
;2056 
;2057 
;2058 //=========================================================================
;2059 //  list of application-specific commands that are normally entered via a
;2060 //  user shell
;2061 //=========================================================================
;2062 //void _task nsclSeriald(int argc, char **argv);
;2063 
;2064 //--- add any application-specific commands here ---
;2065 //APPLCODE
;2066 const CmdInfo far applCmds[] = {
;2067 //  { "misc",        miscTest,       "..." },
;2068   { "state",     showState,   "Show state of controller" }
	.seg	CONST
_applCmds::
	.dw	word (phys @1+1671)
	.dw	phys @1+1671 >> 16
	.dw	word _showState
	.dw	word (phys @1+1677)
	.dw	phys @1+1677 >> 16
;2069 };
	.debug	G _applCmds 80 8
;2070 
;2071 int const NumApplCmds = ( sizeof(applCmds) / sizeof(CmdInfo) );
_NumApplCmds::
	.dw	0x1
	.debug	G _NumApplCmds 6 0
;2072 
;2073 //-------------------------------------------------------------------------
;2074 
;2075 #endif
	.extern	$time 82
	.extern	_memset 83
	.extern	_strlen 85
	.extern	$fmemcpy 86
	.extern	_fmemset 88
	.extern	_fstrcpy 89
	.extern	_fabs 90
	.extern	$clockTicks 91
	.extern	$memCRC16 92
	.extern	$stdHeader 60
	.extern	$showNetState 93
	.extern	$CheckETX 64
	.extern	$compileTime 94
	.extern	$processMsg 95
	.extern	$inet_ptoh 96
	.extern	_clsCmd 97
	.extern	$sigismember 98
	.extern	$sigprocmask 99
	.extern	$sigpending 100
	.extern	_current 101
	.extern	_idleTask 101
	.extern	_applTask 101
	.cseg
_schedule:
	pop	iy
	lcall	$$schedule
	.extern	$$schedule
	.extern	$schedule 60
	.extern	__stdio 103
	.extern	$farfprintf 105
	.extern	$farprintf 106
	.extern	$farsprintf 107
	.extern	__TimerSeconds 9
	.extern	__TimerMilliSeconds 108
	.extern	$xavail 91
	.extern	_qdCount 6
	.extern	_updateAIn 97
	.extern	_updateAOut 97
	.extern	_adcGain 109
	.extern	_adcOffset 109
	.extern	_dacGain 109
	.extern	_dacOffset 109
	.extern	_aoutMin 109
	.extern	_aoutMax 109
	.extern	_anaIn 109
	.extern	_anaOut 109
	.extern	_lastAnaOut 109
	.extern	_adcRaw 110
	.extern	_dacRaw 110
	.extern	_lastadcRaw 110
	.extern	_newRdg 97
	.extern	_adcForced 97
	.extern	_dacForced 97
	.extern	_adcForcedVal 109
	.extern	_dacForcedVal 109
	.extern	_NumHdwADC 7
	.extern	_NumHdwDAC 7
	.bseg
_readGain::
	.ds	16
	.debug	G _readGain 111 0
_readOffset::
	.ds	16
	.debug	G _readOffset 111 0
_setGain::
	.ds	8
	.debug	G _setGain 112 0
_setOffset::
	.ds	8
	.debug	G _setOffset 112 0
_readVal::
	.ds	16
	.debug	G _readVal 111 0
_setVal::
	.ds	8
	.debug	G _setVal 112 0
_lastSetVal::
	.ds	8
	.debug	G _lastSetVal 112 0
	.extern	_digitalIn 9
	.extern	_digitalOut 9
	.defseg	FARBSS
	.seg	FARBSS
_ainLabel::
	.ds	96
	.debug	G _ainLabel 113 8
_aoutLabel::
	.ds	48
	.debug	G _aoutLabel 115 8
_dinLabel::
	.ds	120
	.debug	G _dinLabel 116 8
_doutLabel::
	.ds	48
	.debug	G _doutLabel 115 8
_extraInLabel::
	.ds	768
	.debug	G _extraInLabel 117 8
	.extern	$initIOvalues 60
	.extern	$ReadDigInputs 91
	.extern	$WriteDigOutputs 118
	.extern	$ReadDeviceID 91
	.cseg
_newDACCalib:
	pop	iy
	lcall	$$newDACCalib
	.extern	$$newDACCalib
	.extern	$newDACCalib 119
_newADCCalib:
	pop	iy
	lcall	$$newADCCalib
	.extern	$$newADCCalib
	.extern	$newADCCalib 119
	.extern	$writeAnalogOutputs 118
	.extern	$readAnalogInputs 118
	.extern	$updateAvgsADC 60
	.extern	$open 120
	.extern	$fflush 121
	.extern	_KLOCK 60
	.extern	_KUNLOCK 60
	.extern	$resetWDT 60
	.extern	_hostName 122
	.bseg
_ctlLoopTicksPerSec::
	.ds	2
	.debug	G _ctlLoopTicksPerSec 7 0
	.extern	_prevLogInfo 123
	.extern	_runBackup 3
	.extern	_runningPrimary 3
	.extern	_doReboot 3
	.extern	_doShutdown 3
	.extern	_diagLog 104
	.extern	_intTicks 3
	.extern	_milliTicks 7
	.extern	_hdwResetTime 9
	.extern	_applicTicks 7
	.extern	_deviceID 9
	.extern	_devType 7
	.extern	_hdwType 7
	.extern	_percentIdle 7
	.extern	_timeZone 6
	.extern	$REBOOT 61
	.extern	$createProc 124
	.extern	$sleepMS 125
	.extern	$Exit 93
	.extern	$SetHostName 126
_C0ChanMult::
	.ds	2
	.debug	G _C0ChanMult 7 0
_NumC0Chans::
	.ds	2
	.debug	G _NumC0Chans 7 0
_R3ChanMult::
	.ds	2
	.debug	G _R3ChanMult 7 0
_NumR3Chans::
	.ds	2
	.debug	G _NumR3Chans 7 0
_R4ChanMult::
	.ds	2
	.debug	G _R4ChanMult 7 0
_NumR4Chans::
	.ds	2
	.debug	G _NumR4Chans 7 0
	.extern	_numScopeRegs 7
	.extern	_captureIdx 7
	.extern	_scopeBufSampleSize 7
	.extern	_captureCount 9
	.extern	_scopeList 127
	.extern	_scopeBuf 47
	.extern	_capturePtr 47
	.cseg
_setU16:
	pop	iy
	lcall	$$setU16
	.extern	$$setU16
	.extern	$setU16 59
_setU32:
	pop	iy
	lcall	$$setU32
	.extern	$$setU32
	.extern	$setU32 59
_setF32:
	pop	iy
	lcall	$$setF32
	.extern	$$setF32
	.extern	$setF32 59
	.extern	$pvInitLists 64
_modbusTCPd:
	pop	iy
	lcall	$$modbusTCPd
	.extern	$$modbusTCPd
	.extern	$modbusTCPd 76
	.bseg
_DoReboot::
	.ds	1
	.debug	G _DoReboot 3 0
	.cseg
_setCoil:
	pop	iy
	lcall	$$setCoil
	.extern	$$setCoil
	.extern	$setCoil 128
	.bseg
_dlmVersTime::
	.ds	4
	.debug	G _dlmVersTime 9 0
_dlmVersTime_ChgEventVal::
	.ds	4
	.debug	G _dlmVersTime_ChgEventVal 9 0
_dlmVersTime_MinChg::
	.ds	4
	.debug	G _dlmVersTime_MinChg 9 0
_rtosVersTime::
	.ds	4
	.debug	G _rtosVersTime 9 0
_rtosVersTime_ChgEventVal::
	.ds	4
	.debug	G _rtosVersTime_ChgEventVal 9 0
_rtosVersTime_MinChg::
	.ds	4
	.debug	G _rtosVersTime_MinChg 9 0
_applVersTime::
	.ds	4
	.debug	G _applVersTime 9 0
_applVersTime_ChgEventVal::
	.ds	4
	.debug	G _applVersTime_ChgEventVal 9 0
_applVersTime_MinChg::
	.ds	4
	.debug	G _applVersTime_MinChg 9 0
_devType_::
	.ds	2
	.debug	G _devType_ 5 0
_devType__ChgEventVal::
	.ds	2
	.debug	G _devType__ChgEventVal 5 0
_devType__MinChg::
	.ds	2
	.debug	G _devType__MinChg 5 0
_deviceID_::
	.ds	4
	.debug	G _deviceID_ 9 0
_deviceID__ChgEventVal::
	.ds	4
	.debug	G _deviceID__ChgEventVal 9 0
_deviceID__MinChg::
	.ds	4
	.debug	G _deviceID__MinChg 9 0
_upSecs::
	.ds	4
	.debug	G _upSecs 9 0
_upSecs_ChgEventVal::
	.ds	4
	.debug	G _upSecs_ChgEventVal 9 0
_upSecs_MinChg::
	.ds	4
	.debug	G _upSecs_MinChg 9 0
_percentIdle_::
	.ds	2
	.debug	G _percentIdle_ 5 0
_percentIdle__ChgEventVal::
	.ds	2
	.debug	G _percentIdle__ChgEventVal 5 0
_percentIdle__MinChg::
	.ds	2
	.debug	G _percentIdle__MinChg 5 0
_numChans::
	.ds	2
	.debug	G _numChans 5 0
_numChans_ChgEventVal::
	.ds	2
	.debug	G _numChans_ChgEventVal 5 0
_numChans_MinChg::
	.ds	2
	.debug	G _numChans_MinChg 5 0
_coilChanMult::
	.ds	2
	.debug	G _coilChanMult 5 0
_coilChanMult_ChgEventVal::
	.ds	2
	.debug	G _coilChanMult_ChgEventVal 5 0
_coilChanMult_MinChg::
	.ds	2
	.debug	G _coilChanMult_MinChg 5 0
_reg3ChanMult::
	.ds	2
	.debug	G _reg3ChanMult 5 0
_reg3ChanMult_ChgEventVal::
	.ds	2
	.debug	G _reg3ChanMult_ChgEventVal 5 0
_reg3ChanMult_MinChg::
	.ds	2
	.debug	G _reg3ChanMult_MinChg 5 0
_reg4ChanMult::
	.ds	2
	.debug	G _reg4ChanMult 5 0
_reg4ChanMult_ChgEventVal::
	.ds	2
	.debug	G _reg4ChanMult_ChgEventVal 5 0
_reg4ChanMult_MinChg::
	.ds	2
	.debug	G _reg4ChanMult_MinChg 5 0
_digInBits::
	.ds	4
	.debug	G _digInBits 9 0
_digInBits_ChgEventVal::
	.ds	4
	.debug	G _digInBits_ChgEventVal 9 0
_digInBits_MinChg::
	.ds	4
	.debug	G _digInBits_MinChg 9 0
_statusBitsStdA::
	.ds	2
	.debug	G _statusBitsStdA 5 0
_statusBitsStdA_ChgEventVal::
	.ds	2
	.debug	G _statusBitsStdA_ChgEventVal 5 0
_statusBitsStdA_MinChg::
	.ds	2
	.debug	G _statusBitsStdA_MinChg 5 0
_statusBitsStdB::
	.ds	2
	.debug	G _statusBitsStdB 5 0
_statusBitsStdB_ChgEventVal::
	.ds	2
	.debug	G _statusBitsStdB_ChgEventVal 5 0
_statusBitsStdB_MinChg::
	.ds	2
	.debug	G _statusBitsStdB_MinChg 5 0
_statusBitsAppl::
	.ds	4
	.debug	G _statusBitsAppl 9 0
_statusBitsAppl_ChgEventVal::
	.ds	4
	.debug	G _statusBitsAppl_ChgEventVal 9 0
_statusBitsAppl_MinChg::
	.ds	4
	.debug	G _statusBitsAppl_MinChg 9 0
_cavityVolts::
	.ds	4
	.debug	G _cavityVolts 10 0
_cavityVolts_ChgEventVal::
	.ds	4
	.debug	G _cavityVolts_ChgEventVal 10 0
_cavityVolts_MinChg::
	.ds	4
	.debug	G _cavityVolts_MinChg 10 0
_activeSetpoint::
	.ds	4
	.debug	G _activeSetpoint 10 0
_activeSetpoint_ChgEventVal::
	.ds	4
	.debug	G _activeSetpoint_ChgEventVal 10 0
_activeSetpoint_MinChg::
	.ds	4
	.debug	G _activeSetpoint_MinChg 10 0
_regulationError::
	.ds	4
	.debug	G _regulationError 10 0
_regulationError_ChgEventVal::
	.ds	4
	.debug	G _regulationError_ChgEventVal 10 0
_regulationError_MinChg::
	.ds	4
	.debug	G _regulationError_MinChg 10 0
_limiterVolts::
	.ds	4
	.debug	G _limiterVolts 10 0
_limiterVolts_ChgEventVal::
	.ds	4
	.debug	G _limiterVolts_ChgEventVal 10 0
_limiterVolts_MinChg::
	.ds	4
	.debug	G _limiterVolts_MinChg 10 0
_rampMode::
	.ds	2
	.debug	G _rampMode 5 0
_rampMode_ChgEventVal::
	.ds	2
	.debug	G _rampMode_ChgEventVal 5 0
_rampMode_MinChg::
	.ds	2
	.debug	G _rampMode_MinChg 5 0
_hdwCfg::
	.ds	2
	.debug	G _hdwCfg 5 0
_hdwCfg_ChgEventVal::
	.ds	2
	.debug	G _hdwCfg_ChgEventVal 5 0
_hdwCfg_MinChg::
	.ds	2
	.debug	G _hdwCfg_MinChg 5 0
_latency::
	.ds	2
	.debug	G _latency 5 0
_latency_ChgEventVal::
	.ds	2
	.debug	G _latency_ChgEventVal 5 0
_latency_MinChg::
	.ds	2
	.debug	G _latency_MinChg 5 0
_tcpTickTime::
	.ds	2
	.debug	G _tcpTickTime 5 0
_tcpTickTime_ChgEventVal::
	.ds	2
	.debug	G _tcpTickTime_ChgEventVal 5 0
_tcpTickTime_MinChg::
	.ds	2
	.debug	G _tcpTickTime_MinChg 5 0
_applLoopTime::
	.ds	2
	.debug	G _applLoopTime 5 0
_applLoopTime_ChgEventVal::
	.ds	2
	.debug	G _applLoopTime_ChgEventVal 5 0
_applLoopTime_MinChg::
	.ds	2
	.debug	G _applLoopTime_MinChg 5 0
_kernelLoopTime::
	.ds	2
	.debug	G _kernelLoopTime 5 0
_kernelLoopTime_ChgEventVal::
	.ds	2
	.debug	G _kernelLoopTime_ChgEventVal 5 0
_kernelLoopTime_MinChg::
	.ds	2
	.debug	G _kernelLoopTime_MinChg 5 0
_hdwCfgVolts::
	.ds	4
	.debug	G _hdwCfgVolts 10 0
_hdwCfgVolts_ChgEventVal::
	.ds	4
	.debug	G _hdwCfgVolts_ChgEventVal 10 0
_hdwCfgVolts_MinChg::
	.ds	4
	.debug	G _hdwCfgVolts_MinChg 10 0
_timeZone_::
	.ds	2
	.debug	G _timeZone_ 4 0
_timeZone__ChgEventVal::
	.ds	2
	.debug	G _timeZone__ChgEventVal 4 0
_timeZone__MinChg::
	.ds	2
	.debug	G _timeZone__MinChg 4 0
	.cseg
_MB_timeZone:
	pop	iy
	lcall	$$MB_timeZone
	.bseg
_curTime::
	.ds	4
	.debug	G _curTime 9 0
_curTime_ChgEventVal::
	.ds	4
	.debug	G _curTime_ChgEventVal 9 0
_curTime_MinChg::
	.ds	4
	.debug	G _curTime_MinChg 9 0
_ipAddr::
	.ds	4
	.debug	G _ipAddr 9 0
_ipAddr_ChgEventVal::
	.ds	4
	.debug	G _ipAddr_ChgEventVal 9 0
_ipAddr_MinChg::
	.ds	4
	.debug	G _ipAddr_MinChg 9 0
_netmask::
	.ds	4
	.debug	G _netmask 9 0
_netmask_ChgEventVal::
	.ds	4
	.debug	G _netmask_ChgEventVal 9 0
_netmask_MinChg::
	.ds	4
	.debug	G _netmask_MinChg 9 0
_gateway::
	.ds	4
	.debug	G _gateway 9 0
_gateway_ChgEventVal::
	.ds	4
	.debug	G _gateway_ChgEventVal 9 0
_gateway_MinChg::
	.ds	4
	.debug	G _gateway_MinChg 9 0
_setACoil::
	.ds	2
	.debug	G _setACoil 129 0
_setACoil_ChgEventVal::
	.ds	2
	.debug	G _setACoil_ChgEventVal 129 0
_setACoil_MinChg::
	.ds	2
	.debug	G _setACoil_MinChg 129 0
_resetACoil::
	.ds	2
	.debug	G _resetACoil 129 0
_resetACoil_ChgEventVal::
	.ds	2
	.debug	G _resetACoil_ChgEventVal 129 0
_resetACoil_MinChg::
	.ds	2
	.debug	G _resetACoil_MinChg 129 0
_digOutBits::
	.ds	4
	.debug	G _digOutBits 9 0
_digOutBits_ChgEventVal::
	.ds	4
	.debug	G _digOutBits_ChgEventVal 9 0
_digOutBits_MinChg::
	.ds	4
	.debug	G _digOutBits_MinChg 9 0
_cmdBitsStd::
	.ds	4
	.debug	G _cmdBitsStd 9 0
_cmdBitsStd_ChgEventVal::
	.ds	4
	.debug	G _cmdBitsStd_ChgEventVal 9 0
_cmdBitsStd_MinChg::
	.ds	4
	.debug	G _cmdBitsStd_MinChg 9 0
	.cseg
_MB_cmdBitsStd:
	pop	iy
	lcall	$$MB_cmdBitsStd
	.bseg
_cmdBitsAppl::
	.ds	4
	.debug	G _cmdBitsAppl 9 0
_cmdBitsAppl_ChgEventVal::
	.ds	4
	.debug	G _cmdBitsAppl_ChgEventVal 9 0
_cmdBitsAppl_MinChg::
	.ds	4
	.debug	G _cmdBitsAppl_MinChg 9 0
	.cseg
_MB_cmdBitsAppl:
	pop	iy
	lcall	$$MB_cmdBitsAppl
	.bseg
_rfOnSetpoint::
	.ds	4
	.debug	G _rfOnSetpoint 10 0
_rfOnSetpoint_ChgEventVal::
	.ds	4
	.debug	G _rfOnSetpoint_ChgEventVal 10 0
_rfOnSetpoint_MinChg::
	.ds	4
	.debug	G _rfOnSetpoint_MinChg 10 0
	.cseg
_MB_rfOnSetpoint:
	pop	iy
	lcall	$$MB_rfOnSetpoint
	.bseg
_rfOffSetpoint::
	.ds	4
	.debug	G _rfOffSetpoint 10 0
_rfOffSetpoint_ChgEventVal::
	.ds	4
	.debug	G _rfOffSetpoint_ChgEventVal 10 0
_rfOffSetpoint_MinChg::
	.ds	4
	.debug	G _rfOffSetpoint_MinChg 10 0
	.cseg
_MB_rfOffSetpoint:
	pop	iy
	lcall	$$MB_rfOffSetpoint
	.bseg
_coldRampRate::
	.ds	4
	.debug	G _coldRampRate 10 0
_coldRampRate_ChgEventVal::
	.ds	4
	.debug	G _coldRampRate_ChgEventVal 10 0
_coldRampRate_MinChg::
	.ds	4
	.debug	G _coldRampRate_MinChg 10 0
_warmRampRate::
	.ds	4
	.debug	G _warmRampRate 10 0
_warmRampRate_ChgEventVal::
	.ds	4
	.debug	G _warmRampRate_ChgEventVal 10 0
_warmRampRate_MinChg::
	.ds	4
	.debug	G _warmRampRate_MinChg 10 0
_offToOnDelay::
	.ds	2
	.debug	G _offToOnDelay 5 0
_offToOnDelay_ChgEventVal::
	.ds	2
	.debug	G _offToOnDelay_ChgEventVal 5 0
_offToOnDelay_MinChg::
	.ds	2
	.debug	G _offToOnDelay_MinChg 5 0
_maxRegErr::
	.ds	4
	.debug	G _maxRegErr 10 0
_maxRegErr_ChgEventVal::
	.ds	4
	.debug	G _maxRegErr_ChgEventVal 10 0
_maxRegErr_MinChg::
	.ds	4
	.debug	G _maxRegErr_MinChg 10 0
_limiterActiveV::
	.ds	4
	.debug	G _limiterActiveV 10 0
_limiterActiveV_ChgEventVal::
	.ds	4
	.debug	G _limiterActiveV_ChgEventVal 10 0
_limiterActiveV_MinChg::
	.ds	4
	.debug	G _limiterActiveV_MinChg 10 0
_knobRate::
	.ds	4
	.debug	G _knobRate 10 0
_knobRate_ChgEventVal::
	.ds	4
	.debug	G _knobRate_ChgEventVal 10 0
_knobRate_MinChg::
	.ds	4
	.debug	G _knobRate_MinChg 10 0
_maxOffSetpoint::
	.ds	4
	.debug	G _maxOffSetpoint 10 0
_maxOffSetpoint_ChgEventVal::
	.ds	4
	.debug	G _maxOffSetpoint_ChgEventVal 10 0
_maxOffSetpoint_MinChg::
	.ds	4
	.debug	G _maxOffSetpoint_MinChg 10 0
_maxOnSetpoint::
	.ds	4
	.debug	G _maxOnSetpoint 10 0
_maxOnSetpoint_ChgEventVal::
	.ds	4
	.debug	G _maxOnSetpoint_ChgEventVal 10 0
_maxOnSetpoint_MinChg::
	.ds	4
	.debug	G _maxOnSetpoint_MinChg 10 0
	.extern	$ifpending 130
	.extern	$startNetUp 130
	.extern	$mkfifo 126
	.extern	_hdwCfgParams 131
	.extern	$initParamModule 132
	.extern	$saveParams 133
	.extern	$loadParams 133
	.extern	$loadParamsMsg 134
	.cseg
_backupd:
	pop	iy
	lcall	$$backupd
	.extern	$$backupd
	.extern	$backupd 76
	.extern	_srfsIPAddr 9
	.extern	_srfsAltAddr 9
_ca_tcpd:
	pop	iy
	lcall	$$ca_tcpd
	.extern	$$ca_tcpd
	.extern	$ca_tcpd 76
_inetd:
	pop	iy
	lcall	$$inetd
	.extern	$$inetd
	.extern	$inetd 76
	.extern	$displayElems 135
	.extern	$displayDigElems 136
_fmtF32:
	pop	iy
	lcall	$$fmtF32
	.extern	$$fmtF32
	.extern	$fmtF32 65
	.seg	FARBSS
_applDTM::
	.ds	32
	.debug	G _applDTM 122 8
	.bseg
_ctlLoopTicks::
	.ds	2
	.debug	G _ctlLoopTicks 7 0
_lastCtlLoopTime::
	.ds	2
	.debug	G _lastCtlLoopTime 7 0
_lastReadTime::
	.ds	2
	.debug	G _lastReadTime 7 0
_readTicks::
	.ds	2
	.debug	G _readTicks 7 0
_writeTicks::
	.ds	2
	.debug	G _writeTicks 7 0
_rwTicks::
	.ds	2
	.debug	G _rwTicks 7 0
_ADC_Mask::
	.ds	4
	.debug	G _ADC_Mask 9 0
_DAC_Mask::
	.ds	4
	.debug	G _DAC_Mask 9 0
_stateDataBuf::
	.ds	4
	.debug	G _stateDataBuf 87 0
	.cseg
_EVENT_RestoredParamFile:
	pop	iy
	lcall	$$EVENT_RestoredParamFile
_adcMinRaw:
	pop	iy
	lcall	$$adcMinRaw
	.extern	$$adcMinRaw
	.extern	$adcMinRaw 77
_adcMaxRaw:
	pop	iy
	lcall	$$adcMaxRaw
	.extern	$$adcMaxRaw
	.extern	$adcMaxRaw 77
_adcDefaults:
	pop	iy
	lcall	$$adcDefaults
	.extern	$$adcDefaults
	.extern	$adcDefaults 78
_dacMinRaw:
	pop	iy
	lcall	$$dacMinRaw
	.extern	$$dacMinRaw
	.extern	$dacMinRaw 77
_dacMaxRaw:
	pop	iy
	lcall	$$dacMaxRaw
	.extern	$$dacMaxRaw
	.extern	$dacMaxRaw 77
_dacDefaults:
	pop	iy
	lcall	$$dacDefaults
	.extern	$$dacDefaults
	.extern	$dacDefaults 78
_readGetRaw:
	pop	iy
	lcall	$$readGetRaw
_readMinRaw:
	pop	iy
	lcall	$$readMinRaw
_readMaxRaw:
	pop	iy
	lcall	$$readMaxRaw
_readDefaults:
	pop	iy
	lcall	$$readDefaults
_readCalibPoints:
	pop	iy
	lcall	$$readCalibPoints
_setGetRaw:
	pop	iy
	lcall	$$setGetRaw
_setMinRaw:
	pop	iy
	lcall	$$setMinRaw
_setMaxRaw:
	pop	iy
	lcall	$$setMaxRaw
_setDefaults:
	pop	iy
	lcall	$$setDefaults
_setCalibPoints:
	pop	iy
	lcall	$$setCalibPoints
_applic:
	pop	iy
	lcall	$$applic
_tsh:
	pop	iy
	lcall	$$tsh
	.extern	$$tsh
	.extern	$tsh 76
_configd:
	pop	iy
	lcall	$$configd
	.extern	$$configd
	.extern	$configd 76
_fastdatad:
	pop	iy
	lcall	$$fastdatad
	.extern	$$fastdatad
	.extern	$fastdatad 76
_ReadSetCalibsRestore:
	pop	iy
	lcall	$$ReadSetCalibsRestore
_hostNameRestore:
	pop	iy
	lcall	$$hostNameRestore
	.bseg
_prevState::
	.ds	27
	.debug	G _prevState 137 0
_curState::
	.ds	27
	.debug	G _curState 137 0
_nextState::
	.ds	27
	.debug	G _nextState 137 0
_knobTicks::
	.ds	2
	.debug	G _knobTicks 6 0
_diff::
	.ds	4
	.debug	G _diff 10 0
_maxChg::
	.ds	4
	.debug	G _maxChg 10 0
_msSincePrev::
	.ds	4
	.debug	G _msSincePrev 9 0
_initialBtnPressed::
	.ds	1
	.debug	G _initialBtnPressed 3 0
_finalBtnPressed::
	.ds	1
	.debug	G _finalBtnPressed 3 0
_limited::
	.ds	1
	.debug	G _limited 3 0
_regErr::
	.ds	1
	.debug	G _regErr 3 0
_rfOnTime::
	.ds	4
	.debug	G _rfOnTime 9 0
_lastIdleMS:
	.ds	4
_lastIdleTime:
	.ds	2
_applBuf::
	.ds	256
	.debug	G _applBuf 138 0
	.cseg
_fmtMode:
	pop	iy
	lcall	$$fmtMode
_fmtHdwCfg:
	pop	iy
	lcall	$$fmtHdwCfg
_showState:
	pop	iy
	lcall	$$showState
	.debug	T	49000320000A00050001002300000008636F696C56616C00030002
	.debug	T	0008636F696C4E756D002F000300056E616D65008B0007000C
	.debug	T	736574436F696C46756E63000300090006666C61677300
	.debug	T	AD0003210014000C0001008C0000000772656756616C0005000200
	.debug	T	077265674E756D002F000400056E616D65008D0008000B7365
	.debug	T	7452656746756E630003000A00096461746154797065000300
	.debug	T	0B00086E756D526567730003000C000777724D61736B000300
	.debug	T	0D0006666C6167730003000E000C636865636B4576656E7473
	.debug	T	0003000F000E6576656E74734F63637572656400540010000B
	.debug	T	6C61737443686756616C0054001200076D696E43686700
	.debug	T	0900012200080023000400
	.debug	T	070000230002000300
	.debug	T	0900012400040025000200
	.debug	T	070000250002002000
	.debug	T	09000126004E0027002700
	.debug	T	070000270002002100
	.debug	T	09000128004A0027002500
	.debug	T	09000129001D002A000100
	.debug	T	8A00032A001D0009000950565F446573635F008E00000007707649
	.debug	T	6E666F0057000D000476616C00070011000876616C53697A65
	.debug	T	00030013000A6E65774576656E747300030014000E6576656E
	.debug	T	74734F636375726564008F0015000A75706461746556616C00
	.debug	T	91001700086C6F636B56616C00930019000873656E6456616C
	.debug	T	0093001B000772637656616C00
	.debug	T	0900012B00040003000400
	.debug	T	1D00032C000600020001000900000005626175640006000400056D
	.debug	T	6F646500
	.debug	T	0900012D00050003000500
	.debug	T	0900012E0028002F000A00
	.debug	T	0700082F0004000300
	.debug	T	0900013000020003000200
	.debug	T	090001310010002F000400
	.debug	T	0900013200480033000400
	.debug	T	820003330012000900010023000000087372764E616D6500070002
	.debug	T	0005706F727400030004000970726F746F636F6C0095000500
	.debug	T	0970726F634D61696E0003000700097072696F726974790006
	.debug	T	0008000664657666640054000A000A636667506172616D7300
	.debug	T	06000C00086C6173744572720009000E000C6C617374457272
	.debug	T	54696D6500
	.debug	T	0900013400800135001800
	.debug	T	49000335001000060001000400000003696400040002000573697A
	.debug	T	650004000400056772616E00570006000564617461002F000A
	.debug	T	00056E616D650096000E000B726573746F726556616C00
	.debug	T	0900013600300035000300
	.debug	T	0900013700100035000100
	.debug	T	72000338003100080001002300000009626173654E616D65000300
	.debug	T	02000963617465676F7279009700030007706172616D730098
	.debug	T	0007000B7772697465436F756E740006002700036664009900
	.debug	T	29000962626D43616368650007002D000A636163686553697A
	.debug	T	650007002F00076F666673657400
	.debug	T	090001390006003A000300
	.debug	T	0700003A0002003800
	.debug	T	1700023B000400030054000000030002005400040006000600
	.debug	T	0B00023C000100010001000000
	.debug	T	0B00023D000100010003000000
	.debug	T	0B00023E00010001009B000000
	.debug	T	1300023F0003000100570000002300040007000600
	.debug	T	0B000240000100060001000000
	.debug	T	0F00024100020023009D00000023000400
	.debug	T	09000142006E0103006E01
	.debug	T	09000143007E0044000900
	.debug	T	56000344000E0007000A44697370456C656D5F0003000000027800
	.debug	T	03000100027900570002000476616C00230006000661747472
	.debug	T	73009E00080008666D7446756E630006000A00067769647468
	.debug	T	0006000C00057072656300
	.debug	T	0900014500380046000400
	.debug	T	4B000346000E000700010003000000027800030001000279000900
	.debug	T	0200056D61736B002300060005737472300023000800066174
	.debug	T	7472300023000A0005737472310023000C0006617474723100
	.debug	T	09000147002A0046000300
	.debug	T	09000148000A0049000100
	.debug	T	53000349000A00060011646967466D74496E666F53747275637400
	.debug	T	04000000027800040002000279002300040005737472300003
	.debug	T	00060007626C696E6B30002300070005737472310003000900
	.debug	T	07626C696E6B3100
	.debug	T	0900014A0008004B000100
	.debug	T	3D00034B000800040014616E616C6F67466D74496E666F53747275
	.debug	T	637400040000000278000400020002790004000400046C656E
	.debug	T	0004000600057072656300
	.debug	T	0F00024C0002000100060000009F000200
	.debug	T	0B00024D0001000A0007000000
	.debug	T	1300024E000300010007000000A0000200A0000400
	.debug	T	0F00024F00020023000700000023000200
	.debug	T	09000150000A0051000100
	.debug	T	2F000351000A00030001002F00000008636D644E616D6500950004
	.debug	T	000970726F634D61696E002F00060006646573637200
	.debug	T	0B0002520001000900A1000000
	.debug	T	130002530003005400540000000600020007000400
	.debug	T	070000540002000100
	.debug	T	0B000255000100060023000000
	.debug	T	130002560003005700570000005700040009000800
	.debug	T	070008570004000100
	.debug	T	130002580003005700570000000600040009000600
	.debug	T	0F00025900020001002F0000002F000400
	.debug	T	0B00025A0001000B000B000000
	.debug	T	0B00025B000100090001000000
	.debug	T	0F00025C00020007000900000009000400
	.debug	T	0B00025D000100010006000000
	.debug	T	0F00025E00020009002300000023000200
	.debug	T	1300025F0003000100060000009B00020006000400
	.debug	T	130002600003000600060000002300020054000400
	.debug	T	0900016100000003000000
	.debug	T	0F0002620002000600A100000006000200
	.debug	T	13000263000300060006000000A1000200A1000400
	.debug	T	0B0002640001000600A1000000
	.debug	T	070000650002006600
	.debug	T	7702036600E8002D000C7461736B5F73747275637400A200000006
	.debug	T	737461636B00A20002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C687200A3000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465006500150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	000561726763009F001A00056172677600A4001C0005617267
	.debug	T	7300A5009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773009500B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74002F00D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	070000670002006800
	.debug	T	54000368000C0006000100A6000000065F5F6F757400A800020005
	.debug	T	5F5F696E00AA000400085F5F777269746500AA000600075F5F
	.debug	T	726561640006000800085F5F756E6765740054000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	130002690003000600670000002F0002000D000000
	.debug	T	0F00026A00020006002F0000000D000000
	.debug	T	1300026B00030006002F0000002F0004000D000000
	.debug	T	0900016C00080009000200
	.debug	T	0900016D0000000A000000
	.debug	T	0900016E00000007000000
	.debug	T	0900016F0010000A000400
	.debug	T	090001700008000A000200
	.debug	T	0900017100600072000400
	.debug	T	0900017200180003001800
	.debug	T	0900017300300072000200
	.debug	T	0900017400780072000500
	.debug	T	0900017500000372002000
	.debug	T	0B000276000100010009000000
	.debug	T	0B000277000100010007000000
	.debug	T	130002780003000600230000000600020006000400
	.debug	T	0B000279000100060067000000
	.debug	T	0900017A00200003002000
	.debug	T	2701037B00F900140001000900000008696E666F4B657900090004
	.debug	T	00086262436F756E74000700080006746F4964780007000A00
	.debug	T	0866726F6D4964780003000C0008777261707065640003000D
	.debug	T	000D63746C6453687574646F776E0007000E00097764745469
	.debug	T	636B730009001000087365636F6E647300070014000A6D696C
	.debug	T	6C69536563730009001600076D7354696D6500AC001A000866
	.debug	T	696C6C6572310006006A0003747A0009006C000D6864775265
	.debug	T	73657454696D6500090070000B7265626F6F7454696D650003
	.debug	T	0074000D646964536F6674526573657400090075000C646967
	.debug	T	4F7574537461746500090079000972746F7356657273000900
	.debug	T	7D000D74696D65725365636F6E647300090081000B696E7649
	.debug	T	6E666F4B657900AD0085000866696C6C65723200
	.debug	T	2300027C00070006009500000003000200060004009F0006000600
	.debug	T	080006000A0006000C00
	.debug	T	0B00027D000100090009000000
	.debug	T	0F00027E00020006002300000006000200
	.debug	T	0900017F00200027001000
	.debug	T	17000280000400030054000000030002000300040006000600
	.debug	T	0900018100020005000100
	.debug	T	0B000282000100060006000000
	.debug	T	0900018300000035000000
	.debug	T	0F00028400020006002300000007000200
	.debug	T	17000285000400060023000000070002003A00040003000600
	.debug	T	0B00028600010006003A000000
	.debug	T	1300028700030001009D0000000300040023000600
	.debug	T	17000288000400010009000000AE0004000300080023000A00
	.debug	T	9D000389001B0009000100090000000A6469676974616C496E0009
	.debug	T	0004000C70726F6365737354696D6500030008000772664973
	.debug	T	4F6E00030009000A6C6F63616C4D6F64650003000A000B636C
	.debug	T	6F7365644C6F6F700009000B000B6469676974616C4F757400
	.debug	T	0A000F000F616374697665536574706F696E74000A0013000D
	.debug	T	72664F6E536574706F696E74000A0017000E72664F66665365
	.debug	T	74706F696E7400
	.debug	T	0900018A00000103000001
	.debug	T	0700008B0002008000
	.debug	T	0700008C0002000400
	.debug	T	0700008D0002003B00
	.debug	T	5200038E000D00060001002F000000056E616D6500030004000964
	.debug	T	6174615479706500070005000573697A65000700070009656C
	.debug	T	656D53697A650007000900096E756D456C656D730007000B00
	.debug	T	06666C61677300
	.debug	T	0700008F0002009000
	.debug	T	0B0002900001000600AF000000
	.debug	T	070000910002009200
	.debug	T	130002920003000600AF0000000600020006000400
	.debug	T	070000930002009400
	.debug	T	170002940004000600060000000700020054000400B0000600
	.debug	T	070000950002004C00
	.debug	T	070000960002003F00
	.debug	T	070008970004003500
	.debug	T	0900019800200007001000
	.debug	T	070008990004009A00
	.debug	T	3300039A000A0004000100090000000574696D6500070004000573
	.debug	T	697A6500070006000864657654797065000700080004637263
	.debug	T	00
	.debug	T	0700009B0002009C00
	.debug	T	3C00039C001600040001000700000008646174614C656E00540002
	.debug	T	000A6576656E7446756E630006000400086368616E4E756D00
	.debug	T	B2000600056461746100
	.debug	T	0700089D0004004400
	.debug	T	0700009E0002004100
	.debug	T	0700009F0002002300
	.debug	T	070000A00002000A00
	.debug	T	070000A10002000900
	.debug	T	070000A20002000700
	.debug	T	070000A30002005700
	.debug	T	090001A400800003008000
	.debug	T	280003A50004000100125F5F776169745F71756575655F68656164
	.debug	T	00B3000000096C6973744865616400
	.debug	T	070000A6000200A700
	.debug	T	0F0002A700020006000300000054000200
	.debug	T	070000A8000200A900
	.debug	T	0B0002A9000100060054000000
	.debug	T	070000AA000200AB00
	.debug	T	130002AB00030008002F0000000800040054000800
	.debug	T	090001AC00500003005000
	.debug	T	090001AD00740003007400
	.debug	T	070008AE0004004600
	.debug	T	070000AF0002002A00
	.debug	T	070000B0000200B100
	.debug	T	130002B10003000600540000005700020007000600
	.debug	T	090001B200100003001000
	.debug	T	260003B300040002000A6C6973745F6865616400B4000000056E65
	.debug	T	787400B4000200057072657600
	.debug	T	070000B4000200B300
	.seg	CONST
@2:
	.db	"OFF ",0,"WAIT",0,"COLD",0,"WARM",0,"RSVD0",0,"K500 ",0,"K1200",0,"RSVD3",0,"RSVD4",0,"RSVD5",0,"RSVD6",0,"RSVD7",0,"ERROR",0,"console",0,"fas"
	.db	"tdatad",0,"modbusTCPd",0,"tsh",0,"settings",0,"devData",0,"hdwcfg",0,"16:38:55",0,"Fri Jan 11 2013",0,34,0,"OPEN  ",0,31,0,"CLOS"
	.db	"ED",0,"ON ",0,"OFF",0,"REMOTE",0,"LOCAL ",0,"NO ",0,"YES",0,"OK   ",0,"kV",0,"255.255.0.0",0,"192.168.0.1",0,"fifoEvents",0,"inetd",0,"co"
	.db	"nfigd",0,"backupd",0,"ca_tcpd",0
	.seg	FARCONST
@1:
	.db	"DoReboot",0,"dlmVersTime",0,"rtosVersTime",0,"applVersTime",0,"devType_",0,"deviceID_",0,"upSecs",0,"percentIdle_"
	.db	0,"numChans",0,"coilChanMult",0,"reg3ChanMult",0,"reg4ChanMult",0,"digInBits",0,"statusBitsStdA",0,"statusBitsS"
	.db	"tdB",0,"statusBitsAppl",0,"cavityVolts",0,"activeSetpoint",0,"regulationError",0,"limiterVolts",0,"rampMode",0,"h"
	.db	"dwCfg",0,"latency",0,"tcpTickTime",0,"applLoopTime",0,"kernelLoopTime",0,"hdwCfgVolts",0,"timeZone_",0,"curTime",0,"i"
	.db	"pAddr",0,"netmask",0,"gateway",0,"setACoil",0,"resetACoil",0,"digOutBits",0,"cmdBitsStd",0,"cmdBitsAppl",0,"rfOnSetpo"
	.db	"int",0,"rfOffSetpoint",0,"coldRampRate",0,"warmRampRate",0,"offToOnDelay",0,"maxRegErr",0,"limiterActiveV",0,"kno"
	.db	"bRate",0,"maxOffSetpoint",0,"maxOnSetpoint",0,"OPEN Loop",0,"CLOSED Loop",0,"FINAL setpoint btn released",0
	.db	"FINAL setpoint btn pressed",0,"INITIAL setpoint btn released",0,"INITIAL setpoint btn pressed"
	.db	0,"RF ON",0,"RF OFF",0,"REMOTE mode",0,"LOCAL mode",0,"Limited LED Off",0,"Limited LED On",0,"Error LED Off",0,"Err"
	.db	"or LED On",0,"timeZone",0,"srfsIPAddr",0,"ainLabel",0,"aoutLabel",0,"dinLabel",0,"doutLabel",0,"readGain",0,"readOffs"
	.db	"et",0,"setGain",0,"setOffset",0,"hostName",0,"srfsAltAddr",0,"extraInLabel",0,"new timezone value: %d",10,0,13,10,"===="
	.db	"= Initial Digital Input states =====",13,10,0,"%ls",13,10,0,13,10,"===== Initial Digital Output states =="
	.db	"===",13,10,0,"restore from param file: %.24s",10,0,"%s %s",0,"*** Saving ApplState ***",13,10,0,13,10,"*** Restored"
	.db	" Application State ***",13,10,10,0,"AIN-%u",0,"AOUT-%u",0,"DIN-%u",0,"DOUT-%u",0,"ExtraIN-%u",0,27,"[%02d;%02dH",0,"Start"
	.db	"ing OFF-to-ON delay",13,10,0,"Ramping using COLD rate",13,10,0,"Using WARM rate for changes",13,10,0,"Setting"
	.db	" default labels for I/O signals",13,10,0,"RF_Cavity",0,"Limiter",0,"<unused>",0,"HdwConfig",0,"FP_Meter",0,"Close"
	.db	"d_Loop",0,"FINAL_btn",0,"INITIAL_btn",0,"RF_OFF",0,"Local_mode",0,"Limited_LED",0,"Error_LED",0,"Activity_LED",0,"Set"
	.db	"ting in-RAM device config to default values",13,10,0,"Application prepping for shutdown",13,10,0,"app"
	.db	"lic process started",13,10,0,"*** restoreApplState() failed (%d):  Doing CPU reset ***",13,10,0,13,10,"**"
	.db	"*** Network did not come up! *****",13,10,0,"free memory: %ld",13,10,0,"state",0,"Show state of controlle"
	.db	"r",0
	.end
