	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	p 5
	.debug	N 'C:\work\dev\Rabbit_ST\appl\ECROven\ECROvenAppl.c' 8 43 10 18 10 32
;1 //----- ECROvenAppl.c ----- 10/01/12 -----(03/05/06)----
;2 
;3 // EE Documents bundle # 100
;4 
;5 
;6 // Sections that typically require application-specific code are marked wit
;7 // the comment:  //APPLCODE
;8 
;9 //-------------------------------------------------------------------------
;10 //
;11 //  Copyright (c) 2005-2010 National Superconducting Cyclotron Laboratory,
;12 //            Michigan State University, and Mark Davis
;13 //
;14 //-------------------------------------------------------------------------
;15 //  Application specific code for the main application task that is run at
;16 //  a fixed interval and application specific commands run on demand.
;17 //
;18 //APPLCODE
;19 //  Program to control serveral power supplies that drive an induction heat
;20 //  oven for the Electron Cyclotron Resonance (ECR) facility.
;21 //-------------------------------------------------------------------------
;22 //
;23 //  2012-10-01 - Mark Davis
;24 //               - Added support for sputter interlock input (including
;25 //                 adding the SPTR_INTERLOCK bit to statusBitsAppl).
;26 //
;27 //  2012-09-26 - Mark Davis (*)
;28 //               - Change ovenCom() so it uses blocking mode when writing t
;29 //                 the fd for the serial port.  Prior to this some of the d
;30 //                 might not have been written to the port's buffer causing
;31 //                 the supply to get incomplete commands.
;32 //
;33 //  2012-09-11 - Mark Davis (*)
;34 //               - Added support for the softReset mode.  While this keeps 
;35 //                 outputs from changing state during a soft reset, it does
;36 //                 NOT continue to generate pulses for the external watchdo
;37 //                 timer, so any supplies that were on when the soft reset
;38 //                 began will temporarily loose power during the reset (whi
;39 //                 should be a period of less than 30 seconds).  This chang
;40 //                 was done because the original ECROven box had its memory
;41 //                 corrupted at least once.
;42 //
;43 //  2011-03-31 - Mark Davis
;44 //               - Eliminated a typo that was causing the formatting of
;45 //                 values obtained via the serial connections to the oven
;46 //                 supplies to be messed up when they are logged because an
;47 //                 error was reported by the PS.
;48 //               - Modified the wording of the logged descriptions of the
;49 //                 Alarm Status Register bits to agree with the wording in
;50 //                 the manual for the Lambda (OVEN) supplies.
;51 //
;52 //  2011-02-16 - Mark Davis
;53 //               - Changed the formatting of some of the numeric values fro
;54 //                 a fixed-point floating format to an "engineering" one
;55 //                 because the values often would not fit in the allotted
;56 //                 space for the fixed format.
;57 //
;58 //  2010-03-01 - Mark Davis
;59 //               - Fixed a bug in ovenCom() that could cause it to write pa
;60 //                 the end of the buffer it uses to accumulate the response
;61 //                 from the power supply.
;62 //
;63 //  2010-02-23 - Mark Davis
;64 //               - The "state" command now shows the Sputter supply current
;65 //                 in mA rather than Amps.
;66 //               - Changed the logical order for displaying the state of th
;67 //                 digital outputs (used by the "ios" command).
;68 //
;69 //  2010-02-16 - Mark Davis
;70 //               - Changed ovenCom() so it will only send the OUT0/1 comman
;71 //                 if the output state is different than the desired one.  
;72 //                 should eliminate the problem where the Oven supply
;73 //                 occasionally turns its output off for 1 second when the
;74 //                 serial connection is active (this assumes that the reaso
;75 //                 for this is that the commands are somehow getting garble
;76 //                 once in a while).
;77 //
;78 //  2010-02-15 - Mark Davis
;79 //               - Changed ovenCom() to use readBufCh() to avoid the overhe
;80 //                 incured by using the fcntl layer to buffer single-char
;81 //                 reads.  This changed allowed me to increase the rate of
;82 //                 polling a little bit while still reducing the CPU usage.
;83 //
;84 //  2010-02-10 - Mark Davis
;85 //               - Changed the rate of the pulses for the external watchdog
;86 //                 timer to 10Hz (it was 5Hz)
;87 //               - Removed the code that was setting the setpoints for all
;88 //                 4 supplies to 0 AFTER their values were restored from th
;89 //                 settings file.
;90 //
;91 //  2010-02-01 - Mark Davis
;92 //               - Removed RF Gen supply, added 2nd Oven supply
;93 //
;94 //  2009-12-14 - Mark Davis
;95 //               - Changed order of param files to deal with problems cause
;96 //                 by the order in which they were restored at startup.
;97 //
;98 //  2009-07-15 - Mark Davis -
;99 //               - Corrected count for writing :DCL; command to reset alarm
;100 //                 states.  Basically harmless as the old count simply caus
;101 //                 the terminating 0 byte to be written as well.
;102 //
;103 //  2009-06-11 - Mark Davis -
;104 //               - Added checks to compare on/off commands to the current
;105 //                 state and log msgs for on/off commands that have no effe
;106 //
;107 //  2009-06-10 - Mark Davis -
;108 //               - The power for the Oven supply is now handled as follows:
;109 //                  - When turning ON, the power is enabled, and then (afte
;110 //                    a few seconds) the output is enabled.
;111 //                  - When turning OFF, the output is disabled and the cont
;112 //                    voltage set to 0.  Then, after a (configurable) delay
;113 //                    period has passed, the power is disabled.
;114 //                  This is more like the old code, but avoids "yanking" th
;115 //                  power while the supply has an active output.
;116 //               - The on, off, and reset commands for each supply are now
;117 //                 logged (independent of any msgs indicating whether or no
;118 //                 they had any effect).
;119 //
;120 //  2009-06-08 - Mark Davis -
;121 //               - "Invalid" and "Mangled" syslog entries for the Oven PS a
;122 //                 now supressed unless there are several consequtive bad
;123 //                 reponses from the supply (indicating more than just the
;124 //                 occasional dropped char or string of chars).
;125 //
;126 //  2009-06-05 - Mark Davis -
;127 //               - Reset cmd for the Oven supply is now ignored unless the
;128 //                 output is off or an interlock exists.
;129 //
;130 //  2009-06-04 - Mark Davis -
;131 //               - Stopped logging what appears to be unexpected msgs
;132 //               - Added OVEN_OUT_INTLK bit to statusBitsAppl
;133 //               - ovenOutErrInterlock is not longer reset if the error goe
;134 //                 away (i.e. it is now a latched interlock)
;135 //               - A xxxMaxErrMS value of 0 disables the comparison between
;136 //                 the setting and the reading for the associated supply.
;137 //
;138 //  2009-06-01 - Mark Davis -
;139 //               NOTE:  Most of this is to deal with the fact that the seri
;140 //               driver has no hdw buffer so chars can often be "lost"
;141 //               before the ISR can read them.
;142 //               - Serial link to Oven PS is not considered "active" unless
;143 //                 we are getting readable responses back (it was considere
;144 //                 valid if we were getting pretty much any response).
;145 //               - Increased max time between valid responses before flaggi
;146 //                 the serial link as inactive from 2 to 3 seconds.
;147 //               - What appears to be unasked-for messages from the Oven
;148 //                 supply are ignored unless preceeded by a valid reply.
;149 //
;150 //  2009-05-27 - Mark Davis -
;151 //               - First installed version
;152 //
;153 //  2009-04-18 - Mark Davis -
;154 //               - Began port to DEBROS platform
;155 //
;156 //-------------------------------------------------------------------------
;157 //  NOTES:
;158 //
;159 //    - The RF GEN Power Supply is external to the big metal box.  As of th
;160 //      writing, it is either a HotShot 1-2kW or a NovaStar 3-5kW supply.
;161 //
;162 //    - A 2/4-wire RS-485 adapter is used to connect the 2-wire RS-485
;163 //      interface on the ZWorld with the 4-wire RS-485 interface on the
;164 //      RF Gen Power Supply.  The direction of data transfer on the 2-wire
;165 //      portion of the 2/4-wire adapter is manually controlled by the
;166 //      ZWorld using 2 digital outputs (one enable Tx mode the other Rx mod
;167 //
;168 //    - The OVEN supply is a Lambda ZUP60-7 (60V, 7A) supply inside the box
;169 //
;170 //    - The SPUTTER and BIAS supplies are EMCO 4010N (-1kV, 10ma), inside t
;171 //      box
;172 //
;173 //    - In addition to the usual software/hardware WatchDog timer on the
;174 //      ZWorld, there is a stand-alone WatchDog timer that the ZWorld must
;175 //      send a pulse to periodically or the power to the OVEN, SPUTTER, and
;176 //      BIAS supplies will be cut off.
;177 //
;178 //-------------------------------------------------------------------------
;179 //  Original Oven box and code vs actual/planned changes:
;180 //
;181 //  Implemented changes:
;182 //
;183 //    - This code.  In other words, a new version of the basic ECROven
;184 //      application that runs on the DEBROS RTOS platform.  This platform
;185 //      provides far more flexibility, functionality, and smaller code size
;186 //      than can be achieved with the older Dynamic-C, single-threaded mode
;187 //      The shared code for all DEBROS-based controllers provides far more
;188 //      in diagnostic and other capabilities, including a continuosly backe
;189 //      up copy of the run-time log, as well as eliminating many of the iss
;190 //      with the Dynamic-C code (such as the device effectively being "deaa
;191 //      for several seconds whenever it updates values in the flash memory)
;192 //
;193 //    - Added serial connection to Lambda ZUP (Oven) supply to provide some
;194 //      actual feedback as to the state of the supply.  Readable state incl
;195 //      setpoints and actual (readings) for the voltage and current, the
;196 //      mode (constant voltage or constant current), and the state of vario
;197 //      error conditions (overvoltage, overcurrent, invalid setpoints, etc)
;198 //
;199 //      The serial connection also allows the software to control the suppl
;200 //      in ways that formerly required getting physical access to it (the
;201 //      most prevalent of which was the occasional need to reenable the out
;202 //      by pressing the "OUT" button on the front of the supply).
;203 //
;204 //
;205 //  Suggested/planned changes:
;206 //
;207 //    - Change the method for enabling the output of the Oven supply to
;208 //      the same method used for the Bias and Sputter supplies.
;209 //
;210 //      Currently, a relay (K1) controlled by the ZWorld is connected in
;211 //      series with the dedicated watchdog timer module that shuts off all
;212 //      the supplies if it stops getting reset pulses from the ZWorld.
;213 //
;214 //      This means the only method the ZWorld currently has of controlling
;215 //      whether the Oven supply is providing voltage is to enable or disabl
;216 //      the AC power to the supply.  A "gentler" way of controlling the
;217 //      output from the supply would be the same way it is done for the Bia
;218 //      and Sputter supplies:  Connect this relay between the COM and On/Of
;219 //      connections on the back of the supply.
;220 //
;221 //      This would would have no effect on the WatchDog timer's ability to
;222 //      shut off the supply, but it would avoid the need to power-cycle the
;223 //      supply just to enable/disable its output.
;224 //
;225 //      NOTE:  The output can also be enabled/disabled via commands sent
;226 //             over the serial connection, and the new software currently
;227 //             sends the appropriate commands via the serial link, but the
;228 //             relay is a much more reliable and faster method.
;229 //
;230 //    - Whenever the serial link to the Lambda (Oven) supply is active,
;231 //      compare the analog readbacks to the values read from the supply via
;232 //      the serial link.  If they vary by more than some configurable amoun
;233 //      for more than a configurable period of time, treat it as an Interlo
;234 //      condition and disable the output.
;235 //
;236 //    - For all supplies, compare the voltage setpoints to their readback
;237 //      values.  If they vary by more than some configurable amount for mor
;238 //      than a configurable period of time, treat it as an Interlock condit
;239 //      and disable the output of the offending supply.
;240 //
;241 //  NOTES:
;242 //    - The RF Gen supply is apparently NEVER used with the ECROven box, so
;243 //      the testing of the related portion of the code in this newer versio
;244 //      will not be completed.  In addition, the instructions for creating
;245 //      the task responsible for communicating with the RF Gen supply via a
;246 //      serial connection will be commented out to save on CPU cycles.
;247 //
;248 //    - Settings for numeric values apparently must be EXACTLY the right
;249 //      number of digits.  For example, on the Lambda 60-7 we use, the comm
;250 //      to read the current limit (:CUR!;) returns the value in 4.3 format
;251 //      (e.g. SA2.012).  So, setting the current limit only works if you
;252 //      send the new value in the same format (e.g. :CUR3.000; works while
;253 //      :CUR3.0; does NOT!)
;254 //
;255 //-------------------------------------------------------------------------
;256 
;257 #include <common.h>
;258 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
;259 #include <unistd.h>
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
_LIN2SEG	.macro

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

add hl,hl

rla

sub 0x0E

or a

rr hl

scf

rr hl

scf

rr hl

scf

rr hl

.endm

	.cseg
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
;260 #include <sys/types.h>
;261 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;262 
;263 //APPLCODE - change to match the name of this file
;264 #ifndef  ApplicSource
;265   #define  ApplicSource  "ECROvenAppl.c"
;266 #endif
;267 
;268 #ifndef DidRegDefs
;269   #define  DidRegDefs
;270   #include <modbusRegs.c>
	.debug	i 'C:\work\dev\Rabbit_ST\daemons\modbusRegs.c' 29 38 11 7 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\modbus.h' 21 56 10 7 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ECROven\ECROvenAppl.c' 8 43 10 18 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.dseg
_DoReboot_CoilInfo::
	.dw	word _DoReboot
	.db	0
	.dw	word (phys @1)
	.dw	phys @1 >> 16
	.dw	word _setCoil
	.db	0x2
	.debug	G _DoReboot_CoilInfo 32 0
_dlmVersTime_RegInfo::
	.dw	word _dlmVersTime
	.dw	0
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _dlmVersTime_ChgEventVal
	.dw	word _dlmVersTime_MinChg
	.debug	G _dlmVersTime_RegInfo 33 0
_rtosVersTime_RegInfo::
	.dw	word _rtosVersTime
	.dw	0x2
	.dw	word (phys @1+21)
	.dw	phys @1+21 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rtosVersTime_ChgEventVal
	.dw	word _rtosVersTime_MinChg
	.debug	G _rtosVersTime_RegInfo 33 0
_applVersTime_RegInfo::
	.dw	word _applVersTime
	.dw	0x4
	.dw	word (phys @1+34)
	.dw	phys @1+34 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _applVersTime_ChgEventVal
	.dw	word _applVersTime_MinChg
	.debug	G _applVersTime_RegInfo 33 0
_devType__RegInfo::
	.dw	word _devType_
	.dw	0x6
	.dw	word (phys @1+47)
	.dw	phys @1+47 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _devType__ChgEventVal
	.dw	word _devType__MinChg
	.debug	G _devType__RegInfo 33 0
_deviceID__RegInfo::
	.dw	word _deviceID_
	.dw	0x7
	.dw	word (phys @1+56)
	.dw	phys @1+56 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _deviceID__ChgEventVal
	.dw	word _deviceID__MinChg
	.debug	G _deviceID__RegInfo 33 0
_upSecs_RegInfo::
	.dw	word _upSecs
	.dw	0x9
	.dw	word (phys @1+66)
	.dw	phys @1+66 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _upSecs_ChgEventVal
	.dw	word _upSecs_MinChg
	.debug	G _upSecs_RegInfo 33 0
_percentIdle__RegInfo::
	.dw	word _percentIdle_
	.dw	0xb
	.dw	word (phys @1+73)
	.dw	phys @1+73 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _percentIdle__ChgEventVal
	.dw	word _percentIdle__MinChg
	.debug	G _percentIdle__RegInfo 33 0
_numChans_RegInfo::
	.dw	word _numChans
	.dw	0xc
	.dw	word (phys @1+86)
	.dw	phys @1+86 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _numChans_ChgEventVal
	.dw	word _numChans_MinChg
	.debug	G _numChans_RegInfo 33 0
_coilChanMult_RegInfo::
	.dw	word _coilChanMult
	.dw	0xd
	.dw	word (phys @1+95)
	.dw	phys @1+95 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _coilChanMult_ChgEventVal
	.dw	word _coilChanMult_MinChg
	.debug	G _coilChanMult_RegInfo 33 0
_reg3ChanMult_RegInfo::
	.dw	word _reg3ChanMult
	.dw	0xe
	.dw	word (phys @1+108)
	.dw	phys @1+108 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reg3ChanMult_ChgEventVal
	.dw	word _reg3ChanMult_MinChg
	.debug	G _reg3ChanMult_RegInfo 33 0
_reg4ChanMult_RegInfo::
	.dw	word _reg4ChanMult
	.dw	0xf
	.dw	word (phys @1+121)
	.dw	phys @1+121 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reg4ChanMult_ChgEventVal
	.dw	word _reg4ChanMult_MinChg
	.debug	G _reg4ChanMult_RegInfo 33 0
_digInBits_RegInfo::
	.dw	word _digInBits
	.dw	0x10
	.dw	word (phys @1+134)
	.dw	phys @1+134 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _digInBits_ChgEventVal
	.dw	word _digInBits_MinChg
	.debug	G _digInBits_RegInfo 33 0
_statusBitsStdA_RegInfo::
	.dw	word _statusBitsStdA
	.dw	0x12
	.dw	word (phys @1+144)
	.dw	phys @1+144 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsStdA_ChgEventVal
	.dw	word _statusBitsStdA_MinChg
	.debug	G _statusBitsStdA_RegInfo 33 0
_statusBitsStdB_RegInfo::
	.dw	word _statusBitsStdB
	.dw	0x13
	.dw	word (phys @1+159)
	.dw	phys @1+159 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsStdB_ChgEventVal
	.dw	word _statusBitsStdB_MinChg
	.debug	G _statusBitsStdB_RegInfo 33 0
_statusBitsAppl_RegInfo::
	.dw	word _statusBitsAppl
	.dw	0x14
	.dw	word (phys @1+174)
	.dw	phys @1+174 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsAppl_ChgEventVal
	.dw	word _statusBitsAppl_MinChg
	.debug	G _statusBitsAppl_RegInfo 33 0
_rfSupplyType_RegInfo::
	.dw	word _rfSupplyType
	.dw	0x16
	.dw	word (phys @1+189)
	.dw	phys @1+189 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfSupplyType_ChgEventVal
	.dw	word _rfSupplyType_MinChg
	.debug	G _rfSupplyType_RegInfo 33 0
_sptrReadV_RegInfo::
	.dw	word _sptrReadV
	.dw	0x17
	.dw	word (phys @1+202)
	.dw	phys @1+202 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _sptrReadV_ChgEventVal
	.dw	word _sptrReadV_MinChg
	.debug	G _sptrReadV_RegInfo 33 0
_sptrReadA_RegInfo::
	.dw	word _sptrReadA
	.dw	0x19
	.dw	word (phys @1+212)
	.dw	phys @1+212 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _sptrReadA_ChgEventVal
	.dw	word _sptrReadA_MinChg
	.debug	G _sptrReadA_RegInfo 33 0
_biasReadV_RegInfo::
	.dw	word _biasReadV
	.dw	0x1b
	.dw	word (phys @1+222)
	.dw	phys @1+222 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _biasReadV_ChgEventVal
	.dw	word _biasReadV_MinChg
	.debug	G _biasReadV_RegInfo 33 0
_biasReadA_RegInfo::
	.dw	word _biasReadA
	.dw	0x1d
	.dw	word (phys @1+232)
	.dw	phys @1+232 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _biasReadA_ChgEventVal
	.dw	word _biasReadA_MinChg
	.debug	G _biasReadA_RegInfo 33 0
_oven1ReadV_RegInfo::
	.dw	word _oven1ReadV
	.dw	0x1f
	.dw	word (phys @1+242)
	.dw	phys @1+242 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven1ReadV_ChgEventVal
	.dw	word _oven1ReadV_MinChg
	.debug	G _oven1ReadV_RegInfo 33 0
_oven1ReadA_RegInfo::
	.dw	word _oven1ReadA
	.dw	0x21
	.dw	word (phys @1+253)
	.dw	phys @1+253 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven1ReadA_ChgEventVal
	.dw	word _oven1ReadA_MinChg
	.debug	G _oven1ReadA_RegInfo 33 0
_rfgenReadV_RegInfo::
	.dw	word _rfgenReadV
	.dw	0x23
	.dw	word (phys @1+264)
	.dw	phys @1+264 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfgenReadV_ChgEventVal
	.dw	word _rfgenReadV_MinChg
	.debug	G _rfgenReadV_RegInfo 33 0
_rfgenReadA_RegInfo::
	.dw	word _rfgenReadA
	.dw	0x25
	.dw	word (phys @1+275)
	.dw	phys @1+275 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfgenReadA_ChgEventVal
	.dw	word _rfgenReadA_MinChg
	.debug	G _rfgenReadA_RegInfo 33 0
_rfgenReadW_RegInfo::
	.dw	word _rfgenReadW
	.dw	0x27
	.dw	word (phys @1+286)
	.dw	phys @1+286 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfgenReadW_ChgEventVal
	.dw	word _rfgenReadW_MinChg
	.debug	G _rfgenReadW_RegInfo 33 0
_serOven1ReadV_RegInfo::
	.dw	word _serOven1ReadV
	.dw	0x29
	.dw	word (phys @1+297)
	.dw	phys @1+297 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _serOven1ReadV_ChgEventVal
	.dw	word _serOven1ReadV_MinChg
	.debug	G _serOven1ReadV_RegInfo 33 0
_serOven1ReadA_RegInfo::
	.dw	word _serOven1ReadA
	.dw	0x2b
	.dw	word (phys @1+311)
	.dw	phys @1+311 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _serOven1ReadA_ChgEventVal
	.dw	word _serOven1ReadA_MinChg
	.debug	G _serOven1ReadA_RegInfo 33 0
_oven1Status_RegInfo::
	.dw	word _oven1Status
	.dw	0x2d
	.dw	word (phys @1+325)
	.dw	phys @1+325 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven1Status_ChgEventVal
	.dw	word _oven1Status_MinChg
	.debug	G _oven1Status_RegInfo 33 0
_latency_RegInfo::
	.dw	word _latency
	.dw	0x2f
	.dw	word (phys @1+337)
	.dw	phys @1+337 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _latency_ChgEventVal
	.dw	word _latency_MinChg
	.debug	G _latency_RegInfo 33 0
_tcpTickTime_RegInfo::
	.dw	word _tcpTickTime
	.dw	0x30
	.dw	word (phys @1+345)
	.dw	phys @1+345 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _tcpTickTime_ChgEventVal
	.dw	word _tcpTickTime_MinChg
	.debug	G _tcpTickTime_RegInfo 33 0
_applLoopTime_RegInfo::
	.dw	word _applLoopTime
	.dw	0x31
	.dw	word (phys @1+357)
	.dw	phys @1+357 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _applLoopTime_ChgEventVal
	.dw	word _applLoopTime_MinChg
	.debug	G _applLoopTime_RegInfo 33 0
_nonKernelLocks_RegInfo::
	.dw	word _nonKernelLocks
	.dw	0x32
	.dw	word (phys @1+370)
	.dw	phys @1+370 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _nonKernelLocks_ChgEventVal
	.dw	word _nonKernelLocks_MinChg
	.debug	G _nonKernelLocks_RegInfo 33 0
_failedLocks_RegInfo::
	.dw	word _failedLocks
	.dw	0x33
	.dw	word (phys @1+385)
	.dw	phys @1+385 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _failedLocks_ChgEventVal
	.dw	word _failedLocks_MinChg
	.debug	G _failedLocks_RegInfo 33 0
_duplicateLocks_RegInfo::
	.dw	word _duplicateLocks
	.dw	0x34
	.dw	word (phys @1+397)
	.dw	phys @1+397 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _duplicateLocks_ChgEventVal
	.dw	word _duplicateLocks_MinChg
	.debug	G _duplicateLocks_RegInfo 33 0
_oven1NumMsgs_RegInfo::
	.dw	word _oven1NumMsgs
	.dw	0x35
	.dw	word (phys @1+412)
	.dw	phys @1+412 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven1NumMsgs_ChgEventVal
	.dw	word _oven1NumMsgs_MinChg
	.debug	G _oven1NumMsgs_RegInfo 33 0
_oven1GoodMsgs_RegInfo::
	.dw	word _oven1GoodMsgs
	.dw	0x36
	.dw	word (phys @1+425)
	.dw	phys @1+425 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven1GoodMsgs_ChgEventVal
	.dw	word _oven1GoodMsgs_MinChg
	.debug	G _oven1GoodMsgs_RegInfo 33 0
_oven1BadMsgs_RegInfo::
	.dw	word _oven1BadMsgs
	.dw	0x37
	.dw	word (phys @1+439)
	.dw	phys @1+439 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven1BadMsgs_ChgEventVal
	.dw	word _oven1BadMsgs_MinChg
	.debug	G _oven1BadMsgs_RegInfo 33 0
_adc00_RegInfo::
	.dw	word _adc00
	.dw	0x38
	.dw	word (phys @1+452)
	.dw	phys @1+452 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _adc00_ChgEventVal
	.dw	word _adc00_MinChg
	.debug	G _adc00_RegInfo 33 0
_adc01_RegInfo::
	.dw	word _adc01
	.dw	0x39
	.dw	word (phys @1+458)
	.dw	phys @1+458 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _adc01_ChgEventVal
	.dw	word _adc01_MinChg
	.debug	G _adc01_RegInfo 33 0
_adc02_RegInfo::
	.dw	word _adc02
	.dw	0x3a
	.dw	word (phys @1+464)
	.dw	phys @1+464 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _adc02_ChgEventVal
	.dw	word _adc02_MinChg
	.debug	G _adc02_RegInfo 33 0
_adc03_RegInfo::
	.dw	word _adc03
	.dw	0x3b
	.dw	word (phys @1+470)
	.dw	phys @1+470 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _adc03_ChgEventVal
	.dw	word _adc03_MinChg
	.debug	G _adc03_RegInfo 33 0
_adc04_RegInfo::
	.dw	word _adc04
	.dw	0x3c
	.dw	word (phys @1+476)
	.dw	phys @1+476 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _adc04_ChgEventVal
	.dw	word _adc04_MinChg
	.debug	G _adc04_RegInfo 33 0
_adc05_RegInfo::
	.dw	word _adc05
	.dw	0x3d
	.dw	word (phys @1+482)
	.dw	phys @1+482 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _adc05_ChgEventVal
	.dw	word _adc05_MinChg
	.debug	G _adc05_RegInfo 33 0
_adc06_RegInfo::
	.dw	word _adc06
	.dw	0x3e
	.dw	word (phys @1+488)
	.dw	phys @1+488 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _adc06_ChgEventVal
	.dw	word _adc06_MinChg
	.debug	G _adc06_RegInfo 33 0
_adc07_RegInfo::
	.dw	word _adc07
	.dw	0x3f
	.dw	word (phys @1+494)
	.dw	phys @1+494 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _adc07_ChgEventVal
	.dw	word _adc07_MinChg
	.debug	G _adc07_RegInfo 33 0
_oven2ReadV_RegInfo::
	.dw	word _oven2ReadV
	.dw	0x40
	.dw	word (phys @1+500)
	.dw	phys @1+500 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven2ReadV_ChgEventVal
	.dw	word _oven2ReadV_MinChg
	.debug	G _oven2ReadV_RegInfo 33 0
_oven2ReadA_RegInfo::
	.dw	word _oven2ReadA
	.dw	0x42
	.dw	word (phys @1+511)
	.dw	phys @1+511 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven2ReadA_ChgEventVal
	.dw	word _oven2ReadA_MinChg
	.debug	G _oven2ReadA_RegInfo 33 0
_serOven2ReadV_RegInfo::
	.dw	word _serOven2ReadV
	.dw	0x44
	.dw	word (phys @1+522)
	.dw	phys @1+522 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _serOven2ReadV_ChgEventVal
	.dw	word _serOven2ReadV_MinChg
	.debug	G _serOven2ReadV_RegInfo 33 0
_serOven2ReadA_RegInfo::
	.dw	word _serOven2ReadA
	.dw	0x46
	.dw	word (phys @1+536)
	.dw	phys @1+536 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _serOven2ReadA_ChgEventVal
	.dw	word _serOven2ReadA_MinChg
	.debug	G _serOven2ReadA_RegInfo 33 0
_oven2Status_RegInfo::
	.dw	word _oven2Status
	.dw	0x48
	.dw	word (phys @1+550)
	.dw	phys @1+550 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven2Status_ChgEventVal
	.dw	word _oven2Status_MinChg
	.debug	G _oven2Status_RegInfo 33 0
_oven2NumMsgs_RegInfo::
	.dw	word _oven2NumMsgs
	.dw	0x4a
	.dw	word (phys @1+562)
	.dw	phys @1+562 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven2NumMsgs_ChgEventVal
	.dw	word _oven2NumMsgs_MinChg
	.debug	G _oven2NumMsgs_RegInfo 33 0
_oven2GoodMsgs_RegInfo::
	.dw	word _oven2GoodMsgs
	.dw	0x4b
	.dw	word (phys @1+575)
	.dw	phys @1+575 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven2GoodMsgs_ChgEventVal
	.dw	word _oven2GoodMsgs_MinChg
	.debug	G _oven2GoodMsgs_RegInfo 33 0
_oven2BadMsgs_RegInfo::
	.dw	word _oven2BadMsgs
	.dw	0x4c
	.dw	word (phys @1+589)
	.dw	phys @1+589 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven2BadMsgs_ChgEventVal
	.dw	word _oven2BadMsgs_MinChg
	.debug	G _oven2BadMsgs_RegInfo 33 0
_kernelLoopTime_RegInfo::
	.dw	word _kernelLoopTime
	.dw	0x4d
	.dw	word (phys @1+602)
	.dw	phys @1+602 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _kernelLoopTime_ChgEventVal
	.dw	word _kernelLoopTime_MinChg
	.debug	G _kernelLoopTime_RegInfo 33 0
	.defseg	CONST
	.seg	CONST
_SupplyTypeDesc::
	.dw	@2
	.dw	@2+9
	.dw	@2+18
	.debug	G _SupplyTypeDesc 34 0
	.dseg
_timeZone__RegInfo::
	.dw	word _timeZone_
	.dw	0
	.dw	word (phys @1+617)
	.dw	phys @1+617 >> 16
	.dw	word _MB_timeZone
	.db	0
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _timeZone__ChgEventVal
	.dw	word _timeZone__MinChg
	.debug	G _timeZone__RegInfo 33 0
_curTime_RegInfo::
	.dw	word _curTime
	.dw	0x1
	.dw	word (phys @1+627)
	.dw	phys @1+627 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _curTime_ChgEventVal
	.dw	word _curTime_MinChg
	.debug	G _curTime_RegInfo 33 0
_ipAddr_RegInfo::
	.dw	word _ipAddr
	.dw	0x3
	.dw	word (phys @1+635)
	.dw	phys @1+635 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _ipAddr_ChgEventVal
	.dw	word _ipAddr_MinChg
	.debug	G _ipAddr_RegInfo 33 0
_netmask_RegInfo::
	.dw	word _netmask
	.dw	0x5
	.dw	word (phys @1+642)
	.dw	phys @1+642 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _netmask_ChgEventVal
	.dw	word _netmask_MinChg
	.debug	G _netmask_RegInfo 33 0
_gateway_RegInfo::
	.dw	word _gateway
	.dw	0x7
	.dw	word (phys @1+650)
	.dw	phys @1+650 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _gateway_ChgEventVal
	.dw	word _gateway_MinChg
	.debug	G _gateway_RegInfo 33 0
_setACoil_RegInfo::
	.dw	word _setACoil
	.dw	0x9
	.dw	word (phys @1+658)
	.dw	phys @1+658 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x3
	.db	0
	.db	0
	.dw	word _setACoil_ChgEventVal
	.dw	word _setACoil_MinChg
	.debug	G _setACoil_RegInfo 33 0
_resetACoil_RegInfo::
	.dw	word _resetACoil
	.dw	0xa
	.dw	word (phys @1+667)
	.dw	phys @1+667 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x3
	.db	0
	.db	0
	.dw	word _resetACoil_ChgEventVal
	.dw	word _resetACoil_MinChg
	.debug	G _resetACoil_RegInfo 33 0
_digOutBits_RegInfo::
	.dw	word _digOutBits
	.dw	0xb
	.dw	word (phys @1+678)
	.dw	phys @1+678 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _digOutBits_ChgEventVal
	.dw	word _digOutBits_MinChg
	.debug	G _digOutBits_RegInfo 33 0
_cmdBitsStd_RegInfo::
	.dw	word _cmdBitsStd
	.dw	0xd
	.dw	word (phys @1+689)
	.dw	phys @1+689 >> 16
	.dw	word _MB_cmdBitsStd
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cmdBitsStd_ChgEventVal
	.dw	word _cmdBitsStd_MinChg
	.debug	G _cmdBitsStd_RegInfo 33 0
_cmdBitsAppl_RegInfo::
	.dw	word _cmdBitsAppl
	.dw	0xf
	.dw	word (phys @1+700)
	.dw	phys @1+700 >> 16
	.dw	word _MB_cmdBitsAppl
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cmdBitsAppl_ChgEventVal
	.dw	word _cmdBitsAppl_MinChg
	.debug	G _cmdBitsAppl_RegInfo 33 0
_sptrSetV_RegInfo::
	.dw	word _sptrSetV
	.dw	0x11
	.dw	word (phys @1+712)
	.dw	phys @1+712 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _sptrSetV_ChgEventVal
	.dw	word _sptrSetV_MinChg
	.debug	G _sptrSetV_RegInfo 33 0
_biasSetV_RegInfo::
	.dw	word _biasSetV
	.dw	0x13
	.dw	word (phys @1+721)
	.dw	phys @1+721 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _biasSetV_ChgEventVal
	.dw	word _biasSetV_MinChg
	.debug	G _biasSetV_RegInfo 33 0
_oven1SetV_RegInfo::
	.dw	word _oven1SetV
	.dw	0x15
	.dw	word (phys @1+730)
	.dw	phys @1+730 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven1SetV_ChgEventVal
	.dw	word _oven1SetV_MinChg
	.debug	G _oven1SetV_RegInfo 33 0
_rfgenSetV_RegInfo::
	.dw	word _rfgenSetV
	.dw	0x17
	.dw	word (phys @1+740)
	.dw	phys @1+740 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfgenSetV_ChgEventVal
	.dw	word _rfgenSetV_MinChg
	.debug	G _rfgenSetV_RegInfo 33 0
_serOven1SetV_RegInfo::
	.dw	word _serOven1SetV
	.dw	0x19
	.dw	word (phys @1+750)
	.dw	phys @1+750 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _serOven1SetV_ChgEventVal
	.dw	word _serOven1SetV_MinChg
	.debug	G _serOven1SetV_RegInfo 33 0
_serOven1SetA_RegInfo::
	.dw	word _serOven1SetA
	.dw	0x1b
	.dw	word (phys @1+763)
	.dw	phys @1+763 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _serOven1SetA_ChgEventVal
	.dw	word _serOven1SetA_MinChg
	.debug	G _serOven1SetA_RegInfo 33 0
_sptrMaxErrV_RegInfo::
	.dw	word _sptrMaxErrV
	.dw	0x1d
	.dw	word (phys @1+776)
	.dw	phys @1+776 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _sptrMaxErrV_ChgEventVal
	.dw	word _sptrMaxErrV_MinChg
	.debug	G _sptrMaxErrV_RegInfo 33 0
_sptrMaxErrMS_RegInfo::
	.dw	word _sptrMaxErrMS
	.dw	0x1f
	.dw	word (phys @1+788)
	.dw	phys @1+788 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _sptrMaxErrMS_ChgEventVal
	.dw	word _sptrMaxErrMS_MinChg
	.debug	G _sptrMaxErrMS_RegInfo 33 0
_biasMaxErrV_RegInfo::
	.dw	word _biasMaxErrV
	.dw	0x21
	.dw	word (phys @1+801)
	.dw	phys @1+801 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _biasMaxErrV_ChgEventVal
	.dw	word _biasMaxErrV_MinChg
	.debug	G _biasMaxErrV_RegInfo 33 0
_biasMaxErrMS_RegInfo::
	.dw	word _biasMaxErrMS
	.dw	0x23
	.dw	word (phys @1+813)
	.dw	phys @1+813 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _biasMaxErrMS_ChgEventVal
	.dw	word _biasMaxErrMS_MinChg
	.debug	G _biasMaxErrMS_RegInfo 33 0
_oven1MaxErrV_RegInfo::
	.dw	word _oven1MaxErrV
	.dw	0x25
	.dw	word (phys @1+826)
	.dw	phys @1+826 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven1MaxErrV_ChgEventVal
	.dw	word _oven1MaxErrV_MinChg
	.debug	G _oven1MaxErrV_RegInfo 33 0
_oven1MaxErrMS_RegInfo::
	.dw	word _oven1MaxErrMS
	.dw	0x27
	.dw	word (phys @1+839)
	.dw	phys @1+839 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven1MaxErrMS_ChgEventVal
	.dw	word _oven1MaxErrMS_MinChg
	.debug	G _oven1MaxErrMS_RegInfo 33 0
_forceOvenErr_RegInfo::
	.dw	word _forceOvenErr
	.dw	0x29
	.dw	word (phys @1+853)
	.dw	phys @1+853 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _forceOvenErr_ChgEventVal
	.dw	word _forceOvenErr_MinChg
	.debug	G _forceOvenErr_RegInfo 33 0
_oven1PwrOffDelay_RegInfo::
	.dw	word _oven1PwrOffDelay
	.dw	0x2a
	.dw	word (phys @1+866)
	.dw	phys @1+866 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven1PwrOffDelay_ChgEventVal
	.dw	word _oven1PwrOffDelay_MinChg
	.debug	G _oven1PwrOffDelay_RegInfo 33 0
_oven2SetV_RegInfo::
	.dw	word _oven2SetV
	.dw	0x2b
	.dw	word (phys @1+883)
	.dw	phys @1+883 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven2SetV_ChgEventVal
	.dw	word _oven2SetV_MinChg
	.debug	G _oven2SetV_RegInfo 33 0
_serOven2SetV_RegInfo::
	.dw	word _serOven2SetV
	.dw	0x2d
	.dw	word (phys @1+893)
	.dw	phys @1+893 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _serOven2SetV_ChgEventVal
	.dw	word _serOven2SetV_MinChg
	.debug	G _serOven2SetV_RegInfo 33 0
_serOven2SetA_RegInfo::
	.dw	word _serOven2SetA
	.dw	0x2f
	.dw	word (phys @1+906)
	.dw	phys @1+906 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _serOven2SetA_ChgEventVal
	.dw	word _serOven2SetA_MinChg
	.debug	G _serOven2SetA_RegInfo 33 0
_oven2MaxErrV_RegInfo::
	.dw	word _oven2MaxErrV
	.dw	0x31
	.dw	word (phys @1+919)
	.dw	phys @1+919 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven2MaxErrV_ChgEventVal
	.dw	word _oven2MaxErrV_MinChg
	.debug	G _oven2MaxErrV_RegInfo 33 0
_oven2MaxErrMS_RegInfo::
	.dw	word _oven2MaxErrMS
	.dw	0x33
	.dw	word (phys @1+932)
	.dw	phys @1+932 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven2MaxErrMS_ChgEventVal
	.dw	word _oven2MaxErrMS_MinChg
	.debug	G _oven2MaxErrMS_RegInfo 33 0
_oven2PwrOffDelay_RegInfo::
	.dw	word _oven2PwrOffDelay
	.dw	0x35
	.dw	word (phys @1+946)
	.dw	phys @1+946 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _oven2PwrOffDelay_ChgEventVal
	.dw	word _oven2PwrOffDelay_MinChg
	.debug	G _oven2PwrOffDelay_RegInfo 33 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ECROven\ECROvenAppl.c' 8 43 10 18 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ECROven\ECROvenAppl.c' 8 43 10 18 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ECROven\ECROvenAppl.c' 8 43 10 18 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ECROven\ECROvenAppl.c' 8 43 10 18 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_c0Coils::
	.dw	word _DoReboot_CoilInfo
	.dw	0
	.debug	G _c0Coils 36 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ECROven\ECROvenAppl.c' 8 43 10 18 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_r3Regs::
	.dw	word _dlmVersTime_RegInfo
	.dw	word _dlmVersTime_RegInfo
	.dw	word _rtosVersTime_RegInfo
	.dw	word _rtosVersTime_RegInfo
	.dw	word _applVersTime_RegInfo
	.dw	word _applVersTime_RegInfo
	.dw	word _devType__RegInfo
	.dw	word _deviceID__RegInfo
	.dw	word _deviceID__RegInfo
	.dw	word _upSecs_RegInfo
	.dw	word _upSecs_RegInfo
	.dw	word _percentIdle__RegInfo
	.dw	word _numChans_RegInfo
	.dw	word _coilChanMult_RegInfo
	.dw	word _reg3ChanMult_RegInfo
	.dw	word _reg4ChanMult_RegInfo
	.dw	word _digInBits_RegInfo
	.dw	word _digInBits_RegInfo
	.dw	word _statusBitsStdA_RegInfo
	.dw	word _statusBitsStdB_RegInfo
	.dw	word _statusBitsAppl_RegInfo
	.dw	word _statusBitsAppl_RegInfo
	.dw	word _rfSupplyType_RegInfo
	.dw	word _sptrReadV_RegInfo
	.dw	word _sptrReadV_RegInfo
	.dw	word _sptrReadA_RegInfo
	.dw	word _sptrReadA_RegInfo
	.dw	word _biasReadV_RegInfo
	.dw	word _biasReadV_RegInfo
	.dw	word _biasReadA_RegInfo
	.dw	word _biasReadA_RegInfo
	.dw	word _oven1ReadV_RegInfo
	.dw	word _oven1ReadV_RegInfo
	.dw	word _oven1ReadA_RegInfo
	.dw	word _oven1ReadA_RegInfo
	.dw	word _rfgenReadV_RegInfo
	.dw	word _rfgenReadV_RegInfo
	.dw	word _rfgenReadA_RegInfo
	.dw	word _rfgenReadA_RegInfo
	.dw	word _rfgenReadW_RegInfo
	.dw	word _rfgenReadW_RegInfo
	.dw	word _serOven1ReadV_RegInfo
	.dw	word _serOven1ReadV_RegInfo
	.dw	word _serOven1ReadA_RegInfo
	.dw	word _serOven1ReadA_RegInfo
	.dw	word _oven1Status_RegInfo
	.dw	word _oven1Status_RegInfo
	.dw	word _latency_RegInfo
	.dw	word _tcpTickTime_RegInfo
	.dw	word _applLoopTime_RegInfo
	.dw	word _nonKernelLocks_RegInfo
	.dw	word _failedLocks_RegInfo
	.dw	word _duplicateLocks_RegInfo
	.dw	word _oven1NumMsgs_RegInfo
	.dw	word _oven1GoodMsgs_RegInfo
	.dw	word _oven1BadMsgs_RegInfo
	.dw	word _adc00_RegInfo
	.dw	word _adc01_RegInfo
	.dw	word _adc02_RegInfo
	.dw	word _adc03_RegInfo
	.dw	word _adc04_RegInfo
	.dw	word _adc05_RegInfo
	.dw	word _adc06_RegInfo
	.dw	word _adc07_RegInfo
	.dw	word _oven2ReadV_RegInfo
	.dw	word _oven2ReadV_RegInfo
	.dw	word _oven2ReadA_RegInfo
	.dw	word _oven2ReadA_RegInfo
	.dw	word _serOven2ReadV_RegInfo
	.dw	word _serOven2ReadV_RegInfo
	.dw	word _serOven2ReadA_RegInfo
	.dw	word _serOven2ReadA_RegInfo
	.dw	word _oven2Status_RegInfo
	.dw	word _oven2Status_RegInfo
	.dw	word _oven2NumMsgs_RegInfo
	.dw	word _oven2GoodMsgs_RegInfo
	.dw	word _oven2BadMsgs_RegInfo
	.dw	word _kernelLoopTime_RegInfo
	.dw	0
	.debug	G _r3Regs 38 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ECROven\ECROvenAppl.c' 8 43 10 18 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_r4Regs::
	.dw	word _timeZone__RegInfo
	.dw	word _curTime_RegInfo
	.dw	word _curTime_RegInfo
	.dw	word _ipAddr_RegInfo
	.dw	word _ipAddr_RegInfo
	.dw	word _netmask_RegInfo
	.dw	word _netmask_RegInfo
	.dw	word _gateway_RegInfo
	.dw	word _gateway_RegInfo
	.dw	word _setACoil_RegInfo
	.dw	word _resetACoil_RegInfo
	.dw	word _digOutBits_RegInfo
	.dw	word _digOutBits_RegInfo
	.dw	word _cmdBitsStd_RegInfo
	.dw	word _cmdBitsStd_RegInfo
	.dw	word _cmdBitsAppl_RegInfo
	.dw	word _cmdBitsAppl_RegInfo
	.dw	word _sptrSetV_RegInfo
	.dw	word _sptrSetV_RegInfo
	.dw	word _biasSetV_RegInfo
	.dw	word _biasSetV_RegInfo
	.dw	word _oven1SetV_RegInfo
	.dw	word _oven1SetV_RegInfo
	.dw	word _rfgenSetV_RegInfo
	.dw	word _rfgenSetV_RegInfo
	.dw	word _serOven1SetV_RegInfo
	.dw	word _serOven1SetV_RegInfo
	.dw	word _serOven1SetA_RegInfo
	.dw	word _serOven1SetA_RegInfo
	.dw	word _sptrMaxErrV_RegInfo
	.dw	word _sptrMaxErrV_RegInfo
	.dw	word _sptrMaxErrMS_RegInfo
	.dw	word _sptrMaxErrMS_RegInfo
	.dw	word _biasMaxErrV_RegInfo
	.dw	word _biasMaxErrV_RegInfo
	.dw	word _biasMaxErrMS_RegInfo
	.dw	word _biasMaxErrMS_RegInfo
	.dw	word _oven1MaxErrV_RegInfo
	.dw	word _oven1MaxErrV_RegInfo
	.dw	word _oven1MaxErrMS_RegInfo
	.dw	word _oven1MaxErrMS_RegInfo
	.dw	word _forceOvenErr_RegInfo
	.dw	word _oven1PwrOffDelay_RegInfo
	.dw	word _oven2SetV_RegInfo
	.dw	word _oven2SetV_RegInfo
	.dw	word _serOven2SetV_RegInfo
	.dw	word _serOven2SetV_RegInfo
	.dw	word _serOven2SetA_RegInfo
	.dw	word _serOven2SetA_RegInfo
	.dw	word _oven2MaxErrV_RegInfo
	.dw	word _oven2MaxErrV_RegInfo
	.dw	word _oven2MaxErrMS_RegInfo
	.dw	word _oven2MaxErrMS_RegInfo
	.dw	word _oven2PwrOffDelay_RegInfo
	.dw	0
	.debug	G _r4Regs 40 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ECROven\ECROvenAppl.c' 8 43 10 18 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
_nonRegPVs::
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
	.db	0
	.db	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.debug	G _nonRegPVs 41 0
	.debug	i 'C:\work\dev\Rabbit_ST\appl\ECROven\ECROvenAppl.c' 8 43 10 18 10 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
;271 #endif
;272 #ifndef RegDefs
;273 
;274 
;275 
;276 //APPLCODE - change to the application name
;277 const char far applName[] = { "ECROven" };
	.defseg	FARCONST
	.seg	FARCONST
_applName::
	.db	"ECROven",0
	.debug	G _applName 43 8
;278 const char ApplAbbrev[] = { "ECROven" };
	.seg	CONST
_ApplAbbrev::
	.db	"ECROven",0
	.debug	G _ApplAbbrev 43 0
;279 
;280 //APPLCODE - add ID to unistd.h and place it here
;281 #define DeviceType  DT_ECROven
;282 
;283 //APPLCODE - set the # of input and outputs used
;284 #define  NUM_APPL_AIN      8   // analog inputs
;285 #define  NUM_APPL_AOUT     4   // analog outputs
;286 #define  NUM_APPL_DIN     22   // digital inputs
;287 #define  NUM_APPL_DOUT    16   // digital outputs
;288 
;289 #define  ADC_MASK_APPL  0x000000FFL
;290 #define  DAC_MASK_APPL  0x0000000FL
;291 
;292 #define SharedINC
;293 #include <sharedAppl.c>
;294 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\srfs.h' 6 17 10 7 4 28
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\spi.h' 12 54 10 3 8 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\epics_cad.h' 8 56 9 31 7 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\DLMiii.h' 3 21 14 4 6 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\inetd.h' 23 39 13 12 5 30
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\applic.h' 28 10 10 5 12 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\tsh.h' 3 45 16 21 3 28
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	i 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\ctype.h' 22 48 13 9 7 24
	.dseg
_consCfg::
	.dw	0xffffc200, 0x1
	.dw	0x1
	.debug	G _consCfg 44 0
	.seg	CONST
_NumApplAIN::
	.dw	0x8
	.debug	G _NumApplAIN 7 0
_NumApplAOUT::
	.dw	0x4
	.debug	G _NumApplAOUT 7 0
_NumApplDIN::
	.dw	0x16
	.debug	G _NumApplDIN 7 0
_NumApplDOUT::
	.dw	0x10
	.debug	G _NumApplDOUT 7 0
_NumExtraIn::
	.dw	0x20
	.debug	G _NumExtraIn 7 0
;295 
;296 #define  RELAY_PULSE_LEN  500  // ms to energize relays for momentary conta
;297 
;298 
;299 //--- the 8 least significant bits are for appl/cmd-specific events ---
;300 #define  PacketsBits       0x02L
;301 
;302 #define  ShowPackets       (DiagFlags & PacketsBits)
;303 
;304 
;305 //=========================================================================
;306 //  definitions related to use of the Digital and Analog I/O signals
;307 //=========================================================================
;308 
;309 //APPLCODE - define macros for each Digital bit and each Analog index
;310 
;311 //=============== digitalIn bit usage ===============
;312 #define  UNUSED_DI_00       0x000001  // 00:
;313 #define  UNUSED_DI_01       0x000002  // 01:
;314 #define  UNUSED_DI_02       0x000004  // 02:
;315 #define  UNUSED_DI_03       0x000008  // 03:
;316 #define  UNUSED_DI_04       0x000010  // 04:
;317 #define  UNUSED_DI_05       0x000020  // 05:
;318 #define  UNUSED_DI_06       0x000040  // 06:
;319 #define  UNUSED_DI_07       0x000080  // 07:
;320 #define  ID_SW_00           0x000100  // 08: ID_SW_00
;321 #define  ID_SW_01           0x000200  // 09: ID_SW_01
;322 #define  ID_SW_02           0x000400  // 10: ID_SW_02
;323 #define  ID_SW_03           0x000800  // 11: ID_SW_03
;324 #define  ID_SW_04           0x001000  // 12: ID_SW_04
;325 #define  ID_SW_05           0x002000  // 13: ID_SW_05
;326 #define  ID_SW_06           0x004000  // 14: ID_SW_06
;327 #define  ID_SW_07           0x008000  // 15: ID_SW_07
;328 #define  SPTR_INTLK_OK      0x010000L // 16: 0 = interlock, 1 = NO interloc
;329 #define  RF_PS_HotShot      0x020000L // 17: 0 = HotShot (2kW) Serial PS
;330 #define  RF_PS_NovaStar     0x040000L // 18: 0 = NovaStar (3kW) Serial PS
;331 #define  RF_PS_NOT_FAULT    0x080000L // 19: 0 = RF PS Fault (K7A)
;332 #define  RF_PS_NOT_HEAT_ON  0x100000L // 20: 0 = RF PS Heat ON (K6A)
;333 #define  RF_PS_NOT_READY    0x200000L // 21: 0 = RF PS Ready (K5A)
;334 
;335 
;336 
;337 const uchar  LogicOrderDIn[NUM_APPL_DIN] =  {
;338    0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
_LogicOrderDIn::
	.db	0
	.db	0x1
	.db	0x2
	.db	0x3
	.db	0x4
	.db	0x5
	.db	0x6
	.db	0x7
	.db	0x8
	.db	0x9
	.db	0xa
	.db	0xb
	.db	0xc
	.db	0xd
	.db	0xe
	.db	0xf
;339   16, 17, 18, 19, 20, 21 };
	.db	0x10
	.db	0x11
	.db	0x12
	.db	0x13
	.db	0x14
	.db	0x15
	.debug	G _LogicOrderDIn 45 0
;340 
;341 /*EXAMPLE:
;342 #define  ClosedLoop(din)        ( (bool)((din) & CLOSED_LOOP) )
;343 #define  FinalBtnPushed(din)    ( (bool)((din) & FINAL_BTN) )
;344 #define  InitialBtnPushed(din)  ( (bool)((din) & INITIAL_BTN) )
;345 #define  RFisOff(din)           ( (bool)((din) & RF_IS_OFF) )
;346 #define  LocalMode(din)         ( (bool)((din) & LOC_REM_SW) )
;347 */
;348 
;349 
;350 //--- msgs to log automatically when a digital input changes state ---
;351 //--- use NULL for bits that we don't want to log changes for ---
;352 const char far *digInDescr[NUM_APPL_DIN*2] = {
;353 //--0 state descr--           --1 state descr--
;354    NULL,                       NULL,                   // 00:
	.dseg
_digInDescr::
	.dw	0, 0
	.dw	0, 0
;355    NULL,                       NULL,                   // 01:
	.dw	0, 0
	.dw	0, 0
;356    NULL,                       NULL,                   // 02:
	.dw	0, 0
	.dw	0, 0
;357    NULL,                       NULL,                   // 03:
	.dw	0, 0
	.dw	0, 0
;358    NULL,                       NULL,                   // 04:
	.dw	0, 0
	.dw	0, 0
;359    NULL,                       NULL,                   // 05:
	.dw	0, 0
	.dw	0, 0
;360    NULL,                       NULL,                   // 06:
	.dw	0, 0
	.dw	0, 0
;361    NULL,                       NULL,                   // 07:
	.dw	0, 0
	.dw	0, 0
;362    NULL,                       NULL,                   // 08: ID_SW_00
	.dw	0, 0
	.dw	0, 0
;363    NULL,                       NULL,                   // 09: ID_SW_01
	.dw	0, 0
	.dw	0, 0
;364    NULL,                       NULL,                   // 10: ID_SW_02
	.dw	0, 0
	.dw	0, 0
;365    NULL,                       NULL,                   // 11: ID_SW_03
	.dw	0, 0
	.dw	0, 0
;366    NULL,                       NULL,                   // 12: ID_SW_04
	.dw	0, 0
	.dw	0, 0
;367    NULL,                       NULL,                   // 13: ID_SW_05
	.dw	0, 0
	.dw	0, 0
;368    NULL,                       NULL,                   // 14: ID_SW_06
	.dw	0, 0
	.dw	0, 0
;369    NULL,                       NULL,                   // 15: ID_SW_07
	.dw	0, 0
	.dw	0, 0
;370    "Sptr Interlock ASSERTED", "Sptr Interlock CLEARED", // 16: SPTR Interlo
	.dw	word (phys @1+963)
	.dw	phys @1+963 >> 16
	.dw	word (phys @1+987)
	.dw	phys @1+987 >> 16
;371    NULL,                       NULL,                   // 17:
	.dw	0, 0
	.dw	0, 0
;372 //"HotShot 2kW RF PS",        "NOT HotShot 2kW RF PS", // 17: type of RF su
;373    NULL,                       NULL,                   // 18:
	.dw	0, 0
	.dw	0, 0
;374 //"NovaStar 3kW RF PS",       "NOT NovaStar 3kW RF PS",// 18: type of RF su
;375    NULL,                       NULL,                   // 19:
	.dw	0, 0
	.dw	0, 0
;376 //"RF PS Fault",              "RF PS Fault Cleared",   // 19: RF PS Fault
;377    NULL,                       NULL,                   // 20:
	.dw	0, 0
	.dw	0, 0
;378 //"RF PS Heat ON",            "RF PS Heat OFF",        // 20: RF PS Heat
;379    NULL,                       NULL                    // 21:
	.dw	0, 0
;380 //"RF PS Ready",              "RF PS NOT Ready"        // 21: RF PS Ready
;381 };
	.dw	0, 0
	.debug	G _digInDescr 46 0
;382 
;383 
;384 //=============== digitalOut bit usage ===============
;385 // driven by K1, connected to +24 VDC
;386 #define  ActivityLED     0x000001  // 00: which bit is used for the activit
;387 #define  UNUSED_DO_01    0x000002  // 01:
;388 #define  UNUSED_DO_02    0x000004  // 02:
;389 #define  OVEN2_OUT_ALT   0x000008  // 03: mirror of 05
;390 
;391 #define  OVEN2_PS_OFF    0x000010  // 04: 0 = Oven2 PS ON (K?)
;392 #define  OVEN2_OUT_OFF   0x000028  // 05 & 03: 0 = Enable Oven2 PS Output
;393 //#define  OVEN2_OUT_OFF   0x000020  // 05: 0 = Enable Oven2 PS Output
;394 //#define  EXT_485_RX      0x000040  // 06: enable Tx on extern 2/4-wire ad
;395 //#define  EXT_485_TX      0x000080  // 07: enable Rx on extern 2/4-wire ad
;396 
;397 // driven by bl2105 K2 input, connected to +24 VDC
;398 #define  OVEN1_OUT_OFF   0x000100  // 08: 0 = Enable Oven PS Output
;399 #define  RF_PS_RESET     0x000200  // 09: Reset pulse for some RF PwrSupply
;400 #define  RF_PS_STOP      0x000400  // 10: Stop pulse for some RF PwrSupply'
;401 #define  EXT_WD_TIMER    0x000800  // 11: Extern Watchdog timer restart
;402 
;403 #define  OVEN1_PS_OFF    0x001000  // 12: 0 = Oven1 PS ON (K1)
;404 #define  BIAS_PS_OFF     0x002000  // 13: 0 = Bias PS ON (K2)
;405 #define  SPTR_PS_OFF     0x004000  // 14: 0 = Sptr PS ON (K3)
;406 #define  RF_PS_START     0x008000  // 15: 0 = RF Gen PS start Pulse active 
;407 
;408 const uchar  LogicOrderDOut[NUM_APPL_DOUT] =  {
;409   12, 8, 4, 5, 13, 14, 11, 1, 2, 3, 6, 7, 9, 10, 15, 0 };
	.seg	CONST
_LogicOrderDOut::
	.db	0xc
	.db	0x8
	.db	0x4
	.db	0x5
	.db	0xd
	.db	0xe
	.db	0xb
	.db	0x1
	.db	0x2
	.db	0x3
	.db	0x6
	.db	0x7
	.db	0x9
	.db	0xa
	.db	0xf
	.db	0
	.debug	G _LogicOrderDOut 48 0
;410 
;411 //APPLCODE - set to state we want outputs in during initialization
;412 #define InitialDigOutState  ( 0x00FF70L )
;413 
;414 
;415 #define  TurnOnActivityLED()    ClearBits(Next.digitalOut, ActivityLED)
;416 #define  TurnOffActivityLED()   SetBits(Next.digitalOut, ActivityLED)
;417 
;418 #define  EXT_485_CTL     // explicity control Tx on external 2/4 wire adapt
;419 #define  EXT_485_RX_TX      0x0000C0  // both Tx and Rx bits
;420 #define  NOT_EXT_485_RX_TX  0x00003F  // all BUT Tx & Rx bits (for 8-bit va
;421 
;422 
;423 //--- msgs to log automatically when a digital output changes state ---
;424 //--- use NULL for bits that we don't want to log changes for ---
;425 const char far *digOutDescr[NUM_APPL_DOUT*2] = {
;426 //--0 state descr--              --1 state descr--
;427    NULL,                          NULL,                          // 00:
	.dseg
_digOutDescr::
	.dw	0, 0
	.dw	0, 0
;428    NULL,                          NULL,                          // 01:
	.dw	0, 0
	.dw	0, 0
;429    NULL,                          NULL,                          // 02:
	.dw	0, 0
	.dw	0, 0
;430    NULL,                          NULL,                          // 03:
	.dw	0, 0
	.dw	0, 0
;431   "Enable Power to Oven2 PS",    "Disable Power to Oven2 PS",    // 04:
	.dw	word (phys @1+1010)
	.dw	phys @1+1010 >> 16
	.dw	word (phys @1+1035)
	.dw	phys @1+1035 >> 16
;432   "Enable Oven2 PS Output",      "Disable Oven2 PS Output",      // 05:
	.dw	word (phys @1+1061)
	.dw	phys @1+1061 >> 16
	.dw	word (phys @1+1084)
	.dw	phys @1+1084 >> 16
;433    NULL,                          NULL,                          // 06:
	.dw	0, 0
	.dw	0, 0
;434    NULL,                          NULL,                          // 07:
	.dw	0, 0
	.dw	0, 0
;435   "Enable Oven1 PS Output",      "Disable Oven1 PS Output",      // 08:
	.dw	word (phys @1+1108)
	.dw	phys @1+1108 >> 16
	.dw	word (phys @1+1131)
	.dw	phys @1+1131 >> 16
;436    NULL,                          NULL,                          // 09:
	.dw	0, 0
	.dw	0, 0
;437 //  "Begin RF Gen PS Reset Pulse", "End RF Gen PS Reset Pulse",    // 09:
;438   NULL,                          NULL,                           // 10:
	.dw	0, 0
	.dw	0, 0
;439 //  "Begin RF Gen PS Stop Pulse",  "End RF Gen PS Stop Pulse",     // 10:
;440   NULL,                          NULL,                           // 11:
	.dw	0, 0
	.dw	0, 0
;441   "Enable Power to Oven1 PS",    "Disable Power to Oven1 PS",    // 12:
	.dw	word (phys @1+1155)
	.dw	phys @1+1155 >> 16
	.dw	word (phys @1+1180)
	.dw	phys @1+1180 >> 16
;442   "Assert Bias PS ON",           "Assert Bias PS OFF",           // 13:
	.dw	word (phys @1+1206)
	.dw	phys @1+1206 >> 16
	.dw	word (phys @1+1224)
	.dw	phys @1+1224 >> 16
;443   "Assert Sptr PS ON",           "Assert Sptr PS OFF",           // 14:
	.dw	word (phys @1+1243)
	.dw	phys @1+1243 >> 16
	.dw	word (phys @1+1261)
	.dw	phys @1+1261 >> 16
;444   NULL,                          NULL                            // 15:
	.dw	0, 0
;445 //  "Begin RF Gen PS Start Pulse", "End RF Gen PS Start Pulse"     // 15:
;446  };
	.dw	0, 0
	.debug	G _digOutDescr 49 0
;447 
;448 
;449 
;450 //=============== Analog inputs ===============
;451 //--- indexes for anaIn[] and readVal[] ---
;452 #define  OVEN1_READ_V     0  // Oven1 PS Voltage
;453 #define  BIAS_READ_V      1  // Bias PS Voltage
;454 #define  SPTR_READ_V      2  // Sputter PS Voltage
;455 #define  SPTR_READ_A      3  // Sputter PS Current
;456 #define  BIAS_READ_A      4  // Bias PS Current
;457 #define  OVEN1_READ_A     5  // Oven1 PS Current
;458 #define  OVEN2_READ_V     6  // Oven2 PS Voltage
;459 #define  OVEN2_READ_A     7  // Oven2 PS Current
;460 
;461 
;462 const uchar  LogicOrderAIn[NUM_APPL_AIN] = { 0, 5, 1, 4, 2, 3, 6, 7 };
	.seg	CONST
_LogicOrderAIn::
	.db	0
	.db	0x5
	.db	0x1
	.db	0x4
	.db	0x2
	.db	0x3
	.db	0x6
	.db	0x7
	.debug	G _LogicOrderAIn 43 0
;463 
;464 
;465 //=============== Analog outputs ===============
;466 //--- indexes for anaOut[] and setVal[] ---
;467 #define  OVEN1_SET_V      0  // Oven PS Voltage control
;468 #define  BIAS_SET_V       1  // Bias PS Voltage control
;469 #define  SPTR_SET_V       2  // Sputter PS Voltage control
;470 //#define  RFGEN_SET_V      3  // RF Gen PS Voltage control
;471 #define  OVEN2_SET_V      3  // Oven2 PS Voltage control
;472 
;473 const uchar  LogicOrderAOut[NUM_APPL_AOUT] = { 0, 1, 2, 3 };
_LogicOrderAOut::
	.db	0
	.db	0x1
	.db	0x2
	.db	0x3
	.debug	G _LogicOrderAOut 50 0
;474 
;475 
;476 //=========================================================================
;477 //  Application-specific data structures and definitions
;478 //=========================================================================
;479 
;480 // Each value in the ApplState structure should be throught of as represent
;481 // a "signal" in a clocked logic circuit, with the "applic" task representi
;482 // the logic implemented by the circuit elements such as gates, latches, et
;483 
;484 // The main "applic" task is the highest priority task and executes the cod
;485 // that implements the application logic on a real-time, periodic basis.
;486 
;487 //                 ====== IMPORTANT NOTE on LOCKING ======
;488 // Remember to use a semaphore or some other form of locking mechanism to
;489 // protect all access to shared values by more than one task.  The only
;490 // exception to this is when the applic task needs to access a value protec
;491 // by other tasks using only a scheduler/kernel lock (the KLOCK and KUNLOCK
;492 // macros).  Because the applic task is the only task that runs at the high
;493 // priority, no other task can preempt it, and if the scheduler is locked,
;494 // the applic task cannot preempt another task.  But scheduler locks must b
;495 // kept short to avoid creating large latency in the timely execution of ot
;496 // tasks (the applic task in particular).
;497 
;498 
;499 typedef struct {
;500  //-----------------------------------------------------------------------
;501  // SOFTWARE SETTING INPUTS
;502  //
;503  //  These values represent Software Inputs to the application logic.
;504  //
;505  //  These values are set in the "Next" instance by tasks OTHER than the
;506  //  "applic" task to change some value used by the application logic.
;507  //  Remember that all tasks besides the main "applic" task must use a
;508  //  scheduler lock to protect reads and writes to these values.
;509  //
;510  //  Note that the application task may alter these values (e.g. to change
;511  //  an invalid value in to a valid one).
;512  //-----------------------------------------------------------------------
;513   float  ovenSetV[2];     // most recent setpoint for Oven PS
;514   float  biasSetV;        // most recent setpoint for Bias PS
;515   float  sptrSetV;        // most recent setpoint for Sputter PS
;516 //  float  rfgenSetV;       // most recent setpoint for RF Gen PS
;517 
;518  //-----------------------------------------------------------------------
;519  // READINGS
;520  //
;521  //  These values represent "passive" inputs to the application logic.
;522  //
;523  //  These values are set in the "Next" instance by the applic task just
;524  //  after reading the state of the hardware inputs.
;525  //
;526  //  These values generally come from one of two sources:
;527  //    - The just-read state of analog and/or digital hardware inputs
;528  //    - Values maintained by other tasks
;529  //
;530  //  While some of these values are simply copies of "external" values,
;531  //  including them in the ApplState structure allows us to see how
;532  //  they change between cycles.  Also, some of these values are the result
;533  //  of applying logic to "external" values.  Applying that logic once at
;534  //  at the beginning of the applic loop and saving the result eliminates
;535  //  the need to repeat the same logic in multiple blocks of code later on,
;536  //  avoiding unnecessary redundancy.
;537  //-----------------------------------------------------------------------
;538   ulong  digitalIn;       // state of digital inputs
;539 
;540 //  bool  rfgenFault;
;541 //  bool  rfgenHeatOn;
;542 //  bool  rfgenReady;
;543 
;544 //  bool  rfgenInactive;    // RF PS not responding via RS-485 link
;545   bool  ovenInactive[2];   // Oven (Lambda) PS not responding via RS-232 li
;546 
;547   bool  ovenRuntimeErr[2]; // Error detected in Oven PS operation
;548   bool  biasRuntimeErr;    // Error detected in Bias PS operation
;549   bool  sptrRuntimeErr;    // Error detected in Sputter PS operation
;550 
;551 //  float  rfgenReadV;
;552 //  float  rfgenReadA;
;553 //  float  rfgenReadW;
;554 
;555 //  int  rfSupplyType;
;556 
;557   float  ovenReadV[2], serOvenReadV[2];
;558   float  ovenReadA[2], serOvenReadA[2];
;559 
;560   uint  ovenOpStatus[2], ovenAlarmStatus[2], ovenProgStatus[2];
;561 
;562   float  biasReadV;
;563   float  biasReadA;
;564 
;565   float  sptrReadV;
;566   float  sptrReadA;
;567 
;568 
;569  //-----------------------------------------------------------------------
;570  // OUTPUTS from UN-CLOCKED (asynchronous, gate-level) LOGIC ELEMENTS
;571  //
;572  //  These values are outputs from one of the blocks of code in the applic
;573  //  task that represent a non-clocked logic element (such as a gate).
;574  //
;575  //  Each value here is set by one (and ONLY one) of the blocks of code in
;576  //  the applic task.  This group contains ONLY values that are set by a
;577  //  block of code that represents a NON-clocked logic element.
;578  //
;579  //  These values are set in the "Next" instance of ApplState by the applic
;580  //  task just after reading the state of the hardware inputs.  These value
;581  //  must  NOT be altered by other tasks (although they can read them as lo
;582  //  as they use appropriate locking to do so).
;583  //
;584  //  Because these values represent the outputs of un-clocked logic element
;585  //  and such elements often need to be cascaded (the outputs used as input
;586  //  to other non-clocked elements), the result is often dependent on the
;587  //  order of execution of the blocks of code.
;588  //-----------------------------------------------------------------------
;589   bool   ovenModeOn[2];           // Turn on power, enable output soon afte
;590   bool   ovenOutErrInterlock[2];  // Oven PS Output state was wrong
;591   ulong  ovenOutErrStartTime[2];  // start of period of Output state error
;592   bool   sptrInterlock;           // Sputter PS power disabled by ext inter
;593 
;594  //-----------------------------------------------------------------------
;595  // OUTPUTS from CLOCKED (latched inputs and outputs) LOGIC ELEMENTS
;596  //
;597  //  These values are outputs from one of the blocks of code in the applic
;598  //  task that represent a clocked logic element (such as latches).
;599  //
;600  //  Each value here is set by one (and ONLY one) of the blocks of code in
;601  //  the applic task.  This group contains only values that are set by a
;602  //  block of code that represents a CLOCKED logic element.
;603  //
;604  //  These values are set in the "Next" instance of ApplState by the applic
;605  //  task AFTER all the other ApplState values are set.  Because they repre
;606  //  only the clocked logic elements, and each block of code reads only val
;607  //  from the Cur instance, the blocks can be executed in any order and the
;608  //  result will always be the same.
;609  //
;610  //  These values are used as inputs by other blocks and/or to set values
;611  //  used by other tasks (such as values read by the ModBus server task).
;612  //
;613  //  Again, these values must NOT be altered by other tasks (although they
;614  //  can read them as long as they use appropriate locking to do so).
;615  //-----------------------------------------------------------------------
;616   ulong  digitalOut;      // state for digital outputs
;617 
;618   bool   enableOvenPower[2];   // enable power to the Oven PS except for re
;619   bool   enableOvenOutput[2];  // enable the Oven PS output
;620   float  ovenSetVassert[2];    // actual in-use setpoint for Oven PS
;621   float  serOvenSetV[2];       // setpoint according to Oven PS
;622   float  serOvenSetA[2];       // setpoint according to Oven PS
;623 
;624   bool   assertOnBiasPS;  // enable the Bias PS
;625   float  biasSetVassert;  // actual in-use setpoint for Bias PS
;626 
;627   bool   assertOnSptrPS;  // enable the Sputter PS
;628   float  sptrSetVassert;  // actual in-use setpoint for Sputter PS
;629 
;630 //  ulong  rfgenStartTime;  // start time (in ms) of RF Gen Start Pulse
;631 //  ulong  rfgenStopTime;   // start time (in ms) of RF Gen Stop pulse
;632 //  ulong  rfgenResetTime;  // start time (in ms) of RF Gen Reset pulse
;633 //  float  rfgenSetVassert; // actual in-use setpoint for RF Gen PS
;634 
;635 } ApplState;
;636 
;637 
;638 //--- Event flags that are treated as "pulses" (i.e. some task sets the ---
;639 //--- value of one or more of them (as an atomic operation) to indicate ---
;640 //--- some event that the applic logic needs to deal with ---
;641 bool    // rfgenStartCmd, rfgenStopCmd, rfgenResetCmd,
;642         biasOnCmd, biasOffCmd, sptrOnCmd, sptrOffCmd,
;643         ovenOnCmd[2], ovenOffCmd[2], ovenResetCmd[2], newOvenResp[2];
;644 
;645 ulong  //rfgenLastRespTime,       // last time we got a resp from the RF Ge
;646        //rfgenReadErrStartTime,   // time existing read/set error first det
;647        ovenLastRespTime[2],     // last time we got a valid resp from Oven 
;648        ovenReadErrStartTime[2], // time existing read/set error first detec
;649        ovenOffCmdTime[2],       // time last active off cmd rcvd
;650        ovenPowerOnTime[2],      // time Oven PS power was enabled
;651        sptrReadErrStartTime,    // time existing read/set error first detec
;652        biasReadErrStartTime,    // time existing read/set error first detec
;653        wdPulseChanged;          // last time extern WatchDog timer pulse ch
;654 
;655 ulong  ovenRespAge[2];      // # ms since last valid response from Oven PS
;656 
;657 uint  postOvenResetMsgs[2]; // # of valid resps from Oven PS since a reset
;658 
;659 
;660 ApplState  prevState, curState, nextState;
;661 
;662 #define  Prev  prevState
;663 #define  Cur   curState
;664 #define  Next  nextState
;665 
;666 const uint ApplStateDataSize =  ( sizeof(ApplState)*3 + sizeof(setVal) );
_ApplStateDataSize::
	.dw	0x1b7
	.debug	G _ApplStateDataSize 7 0
;667 
;668 
;669 //--- bit values for ovenOpStatus ---
;670 #define  OOS_ConstVolt      0x80
;671 #define  OOS_FoldbackProt   0x40
;672 #define  OOS_AutoRestart    0x20
;673 #define  OOS_OutputOn       0x10
;674 #define  OOS_FoldbackSRQ    0x08
;675 #define  OOS_OverVoltSRQ    0x04
;676 #define  OOS_OverTempSRQ    0x02
;677 #define  OOS_AlarmBitSet    0x01
;678 
;679 
;680 //=========================================================================
;681 //  List of daemon processes.  The inetd process listens for connection
;682 //  requests on each port in the list and creates a new instance of the
;683 //  specified process to service each new connection.
;684 //=========================================================================
;685 #include <services.h>
;686 
	.debug	i 'C:\work\dev\Rabbit_ST\rtos\include\services.h' 2 22 6 20 2 29
;687 //APPLCODE - add tasks that service network clients
;688 
;689 //--- service funcs declared the same as standard command funcs:
;690 //     e.g.:   void _task fastdatad(int argc, char **argv);
;691 
;692 void _task tsh(int argc, char **argv);
;693 
;694 
;695 ServiceInfo inetdConf[] = {
;696 //--- add any application-specific inetd-type network services here ---
;697 //--- (add port # names to services.h) ---
;698 //  NAME          PORT           PROTOCOL  FUNC       PRI  -1  Config Param
;699 //  ------------  -------------  --------  ---------- ---  --  ------------
;700 
;701 //--- standard ones defined in sharedAppl.c ---
;702 //{ "console",    TTY0,          ASYNC,    tsh,        10, -1, &consCfg },
;703 //{ "fastdatad",  FASTDATA_PORT, ProtoTCP, fastdatad,   5, -1, NULL },
;704 //{ "modbusTCPd", MODBUS_PORT,   ProtoTCP, modbusTCPd,  6, -1, NULL },
;705 //{ "tsh",        TELNET_PORT,   ProtoTCP, tsh,        10, -1, NULL }
;706 
;707   #define SharedServices
;708   #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.dseg
_inetdConf::
	.dw	@2+27
	.dw	0
	.db	0x3
	.dw	word _tsh
	.db	0xa
	.dw	0xffff
	.dw	word _consCfg
	.ds	6,0
	.dw	@2+35
	.dw	0x7d3
	.db	0x2
	.dw	word _fastdatad
	.db	0x5
	.dw	0xffff
	.dw	0
	.ds	6,0
	.dw	@2+45
	.dw	0x1f6
	.db	0x2
	.dw	word _modbusTCPd
	.db	0x6
	.dw	0xffff
	.dw	0
	.ds	6,0
	.dw	@2+56
	.dw	0x17
	.db	0x2
	.dw	word _tsh
	.db	0xa
	.dw	0xffff
	.dw	0
;709 };
	.ds	6,0
	.debug	G _inetdConf 51 0
;710 
;711 const int  NumServices = sizeof(inetdConf) / sizeof(ServiceInfo);
	.seg	CONST
_NumServices::
	.dw	0x4
	.debug	G _NumServices 6 0
;712 
;713 
;714 
;715 //=========================================================================
;716 //  Defintions for variables that are accessable as ModBus registers
;717 //=========================================================================
;718 #else  // end of before-RegDefs portion
;1136 #ifndef RegDefs // start of after-RegDefs portion
;1137 
;1138 //--- definitions for cmdBitsAppl ---
;1139 #define  CBA_DoReboot     0x00000001
;1140 #define  CBA_DoInit       0x00000002
;1141 
;1142 #define  CBA_Oven1On      0x00000010
;1143 #define  CBA_Oven1Off     0x00000020
;1144 #define  CBA_BiasOn       0x00000040
;1145 #define  CBA_BiasOff      0x00000080
;1146 #define  CBA_SptrOn       0x00000100
;1147 #define  CBA_SptrOff      0x00000200
;1148 //#define  CBA_RFGenStart   0x00000400
;1149 //#define  CBA_RFGenStop    0x00000800
;1150 //#define  CBA_RFGenReset   0x00001000
;1151 #define  CBA_Oven1Reset   0x00002000
;1152 #define  CBA_Oven2On      0x00004000
;1153 #define  CBA_Oven2Off     0x00008000
;1154 #define  CBA_Oven2Reset   0x00010000L
;1155 
;1156 //#define  CBA_RFGenCmds   (CBA_RFGenStart | CBA_RFGenStop | CBA_RFGenReset
;1157 
;1158 
;1159 //=========================================================================
;1160 //  defintions for "parameterized" data values - lists of values that we wa
;1161 //  to be "persistent" (i.e. saved to a file and restored on startup)
;1162 //=========================================================================
;1163 //APPLCODE - settings/values we want saved to/restored from files
;1164 
;1165 
;1166 //--- parameter ID's for data in Device Data/calibration file ---
;1167 //-------------------------------------------------------------------------
;1168 // WARNING:  ID's can be added, but existing ID's (and the format of the
;1169 //           data they represent) should NEVER change!  NOTE:  Existing one
;1170 //           can be "eliminated" by changing their name and no longer
;1171 //           using them, but never REUSE an old one for something new!!!
;1172 //-------------------------------------------------------------------------
;1173 //  NOTE:  ID's >= 1000 are rsvd for values shared by most applications
;1174 //-------------------------------------------------------------------------
;1175 
;1176 const ParamData far  devDataParams[] = {
;1177 //APPLDATA
;1178 //                ID   ---value---  --restoreFunc--
;1179 //PERSISTENT_VAR(  1,  myVarName,     NULL ),
;1180 //                ID   ---value---  granularity  --restoreFunc--
;1181 //PERSISTENT_TBL(  2   myArrayName, elemSize,     NULL ),
;1182 
;1183   PERSISTENT_VAR(  1,  oven1MaxErrV,       NULL ),
	.seg	FARCONST
_devDataParams::
	.dw	0x1
	.dw	0x4
	.dw	0
	.dl	phys _oven1MaxErrV
	.dl	phys @1+826
	.dw	0
;1184   PERSISTENT_VAR(  2,  oven1MaxErrMS,      NULL ),
	.dw	0x2
	.dw	0x4
	.dw	0
	.dl	phys _oven1MaxErrMS
	.dl	phys @1+839
	.dw	0
;1185   PERSISTENT_VAR(  3,  sptrMaxErrV,        NULL ),
	.dw	0x3
	.dw	0x4
	.dw	0
	.dl	phys _sptrMaxErrV
	.dl	phys @1+776
	.dw	0
;1186   PERSISTENT_VAR(  4,  sptrMaxErrMS,       NULL ),
	.dw	0x4
	.dw	0x4
	.dw	0
	.dl	phys _sptrMaxErrMS
	.dl	phys @1+788
	.dw	0
;1187   PERSISTENT_VAR(  5,  biasMaxErrV,        NULL ),
	.dw	0x5
	.dw	0x4
	.dw	0
	.dl	phys _biasMaxErrV
	.dl	phys @1+801
	.dw	0
;1188   PERSISTENT_VAR(  6,  biasMaxErrMS,       NULL ),
	.dw	0x6
	.dw	0x4
	.dw	0
	.dl	phys _biasMaxErrMS
	.dl	phys @1+813
	.dw	0
;1189   PERSISTENT_VAR(  7,  oven1PwrOffDelay,   NULL ),
	.dw	0x7
	.dw	0x2
	.dw	0
	.dl	phys _oven1PwrOffDelay
	.dl	phys @1+866
	.dw	0
;1190   PERSISTENT_VAR(  8,  oven2MaxErrV,       NULL ),
	.dw	0x8
	.dw	0x4
	.dw	0
	.dl	phys _oven2MaxErrV
	.dl	phys @1+919
	.dw	0
;1191   PERSISTENT_VAR(  9,  oven2MaxErrMS,      NULL ),
	.dw	0x9
	.dw	0x4
	.dw	0
	.dl	phys _oven2MaxErrMS
	.dl	phys @1+932
	.dw	0
;1192   PERSISTENT_VAR( 10,  oven2PwrOffDelay,   NULL ),
	.dw	0xa
	.dw	0x2
	.dw	0
	.dl	phys _oven2PwrOffDelay
	.dl	phys @1+946
	.dw	0
;1193 
;1194   #define SharedDevParams
;1195   #include <sharedAppl.c>
;1196 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.dw	0x3ec
	.dw	0x2
	.dw	0
	.dl	phys _timeZone
	.dl	phys @1+1280
	.dw	0
	.dw	0x3ed
	.dw	0x4
	.dw	0
	.dl	phys _srfsIPAddr
	.dl	phys @1+1289
	.dw	0
	.dw	0x3e8
	.dw	0xc0
	.dw	0x18
	.dl	phys _ainLabel
	.dl	phys @1+1300
	.dw	0
	.dw	0x3e9
	.dw	0x60
	.dw	0x18
	.dl	phys _aoutLabel
	.dl	phys @1+1309
	.dw	0
	.dw	0x3ea
	.dw	0x210
	.dw	0x18
	.dl	phys _dinLabel
	.dl	phys @1+1319
	.dw	0
	.dw	0x3eb
	.dw	0x180
	.dw	0x18
	.dl	phys _doutLabel
	.dl	phys @1+1328
	.dw	0
	.dw	0x3ee
	.dw	0x20
	.dw	0
	.dl	phys _readGain
	.dl	phys @1+1338
	.dw	0
	.dw	0x3ef
	.dw	0x20
	.dw	0
	.dl	phys _readOffset
	.dl	phys @1+1347
	.dw	0
	.dw	0x3f0
	.dw	0x10
	.dw	0
	.dl	phys _setGain
	.dl	phys @1+1358
	.dw	0
	.dw	0x3f1
	.dw	0x10
	.dw	0
	.dl	phys _setOffset
	.dl	phys @1+1366
	.dw	word _ReadSetCalibsRestore
	.dw	0x3f2
	.dw	0x20
	.dw	0
	.dl	phys _hostName
	.dl	phys @1+1376
	.dw	word _hostNameRestore
	.dw	0x3f3
	.dw	0x4
	.dw	0
	.dl	phys _srfsAltAddr
	.dl	phys @1+1385
	.dw	0
	.dw	0x3f4
	.dw	0x300
	.dw	0x18
	.dl	phys _extraInLabel
	.dl	phys @1+1397
	.dw	0
	.dw	0x3f5
	.dw	0x4
	.dw	0
	.dl	phys _netmask
	.dl	phys @1+642
	.dw	0
	.dw	0x3f6
	.dw	0x4
	.dw	0
	.dl	phys _gateway
	.dl	phys @1+650
	.dw	0
;1197   END_PARAM_DATA
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;1198 
	.ds	2,0
	.debug	G _devDataParams 53 8
;1199 
;1200 
;1201 //----------------------------------------------------
;1202 const ParamData far  settingsParams[] = {
;1203 //APPLDATA
;1204 //_nearcall void ampSetRestore(void far *curVal, char *newVal, uint count);
;1205 //
;1206 //                ID   ---value---  --restoreFunc--
;1207   PERSISTENT_VAR(  1,  sptrSetV,     NULL ),
_settingsParams::
	.dw	0x1
	.dw	0x4
	.dw	0
	.dl	phys _sptrSetV
	.dl	phys @1+712
	.dw	0
;1208   PERSISTENT_VAR(  2,  biasSetV,     NULL ),
	.dw	0x2
	.dw	0x4
	.dw	0
	.dl	phys _biasSetV
	.dl	phys @1+721
	.dw	0
;1209   PERSISTENT_VAR(  3,  oven1SetV,    NULL ),
	.dw	0x3
	.dw	0x4
	.dw	0
	.dl	phys _oven1SetV
	.dl	phys @1+730
	.dw	0
;1210 //  PERSISTENT_VAR(  4,  rfgenSetV,    NULL ),
;1211   PERSISTENT_VAR(  5,  oven2SetV,    NULL ),
	.dw	0x5
	.dw	0x4
	.dw	0
	.dl	phys _oven2SetV
	.dl	phys @1+883
	.dw	0
;1212 
;1213   END_PARAM_DATA
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;1214 
	.ds	2,0
	.debug	G _settingsParams 55 8
;1215 
;1216 
;1217 //-----------------------------------------------------------------
;1218 //  Application-specific values needed to restore the state of the
;1219 //  controller following a "soft" reset (i.e. a restart without a
;1220 //  CPU reset)
;1221 //-----------------------------------------------------------------
;1222 const ParamData far  ctlrStateParams[] = {
;1223 // sample values from sharedAppl.c, common to all applications
;1224 //                   --ID--  ---value,granularity---  --restoreFunc--
;1225 //    PERSISTENT_VARx(  1000,  prevState,               NULL ),
;1226 //    PERSISTENT_VARx(  1001,  curState,                NULL ),
;1227 //    PERSISTENT_VARx(  1002,  nextState,               NULL ),
;1228 //    PERSISTENT_TBL (  1003,  setVal,4,                NULL ),
;1229 // // PERSISTENT_TBL (  1004,  shadowRegValues,4,       NULL ),
;1230 
;1231 //APPLDATA
;1232 //    PERSISTENT_VAR(  1,  myApplStateVar,        NULL ),
;1233 
;1234 
;1235   #define SharedCtlrStateParams
;1236   #include <sharedAppl.c>
;1237 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;1238   END_PARAM_DATA
_ctlrStateParams::
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;1239 
	.ds	2,0
	.debug	G _ctlrStateParams 56 8
;1240 
;1241 
;1242 //-------------------------------------------------------------------------
;1243 //  A list of parameterized "persistent" data.  Backup copies of such value
;1244 //  are stored in files and restored on startup.
;1245 //-------------------------------------------------------------------------
;1246 
;1247 //    Base File Name    Category  ParamData
;1248 //    ----------------  --------  ---------
;1249 //--- add any application-specific parameterized file defs here ---
;1250 //ParamFile  myAppCfgFile =
;1251 //  { "myFileName",     PDC_CTLR, myCfgParams,   0 };
;1252 
;1253 ParamFile  settingsFile =
;1254     { "settings",       PDC_SET,  settingsParams  };
	.dseg
_settingsFile::
	.dw	@2+60
	.db	0x4
	.dl	phys _settingsParams
	.ds	42,0
	.debug	G _settingsFile 57 0
;1255 
;1256 
;1257 #define SharedParams
;1258 #include <sharedAppl.c>
;1259 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_devDataFile::
	.dw	@2+69
	.db	0x3
	.dl	phys _devDataParams
	.dw	0
	.ds	30,0
	.ds	10,0
	.debug	G _devDataFile 57 0
_hdwCfgFile::
	.dw	@2+77
	.db	0x1
	.dl	phys _hdwCfgParams
	.dw	0
	.ds	30,0
	.ds	10,0
	.debug	G _hdwCfgFile 57 0
;1260 
;1261 ParamFile *paramFiles[] = {
;1262   #define SharedParamsList
;1263   #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_paramFiles::
	.dw	word _hdwCfgFile
	.dw	word _devDataFile
;1264 //--- add any application-specific ParamData references here ---
;1265 //  &myAppCfgFile,
;1266   &settingsFile
;1267 };
	.dw	word _settingsFile
	.debug	G _paramFiles 58 0
;1268 
;1269 const int NumParamFiles = sizeof(paramFiles) / sizeof(paramFiles[0]);
	.seg	CONST
_NumParamFiles::
	.dw	0x3
	.debug	G _NumParamFiles 6 0
;1270 
;1271 
;1272 //=========================================================================
;1273 //  Declarations for functions that handle setting "Next" values that serve
;1274 //  as inputs to the application control logic (run by the "applic" task in
;1275 //  a periodically executed loop).
;1276 //
;1277 //  While care must be taken in these functions to use locks to avoid the
;1278 //  possibility of being preempted in the middle of an operation, such lock
;1279 //  must be kept to as short a time as possible to avoid excessively latenc
;1280 //  in the main control loop.
;1281 //=========================================================================
;1282 
;1283 //void onCmd(void);
;1284 //void offCmd(void);
;1285 //void resetCmd(void);
;1286 
;1287 //void newSetpoint(float newAmps);
;1288 
;1289 
;1290 //=========================================================================
;1291 //  This is where misc global variables should be defined
;1292 //=========================================================================
;1293 #define SharedGlobals
;1294 #include <sharedAppl.c>
;1295 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_DigOutInitState::
	.dw	0xffffff70, 0
	.debug	G _DigOutInitState 9 0
	.dseg
_applicReady::
	.db	0
	.debug	G _applicReady 3 0
_restoredApplState::
	.db	0
	.debug	G _restoredApplState 3 0
_allowSoftReset::
	.db	0
	.debug	G _allowSoftReset 3 0
_startupComplete::
	.db	0
	.debug	G _startupComplete 3 0
;1296 //APPLCODE
;1297 //--- add definitions for application-specific global variables here ---
;1298 char  // rfgenCmd[32], rfgenResp[128],
;1299       ovenCmd[2][32], ovenResp[2][64];
;1300 
;1301 
;1302 //=========================================================================
;1303 //  Functions referenced in the Modbus register definitions to handle write
;1304 //  specific global values defined as ModBus registers
;1305 //=========================================================================
;1306 
;1307 //APPLCODE - add functions to process writes to ModBus register values
;1308 
;1309 //-------------------------------------------------------------------------
;1310 //  External ModBus client sent a new value for "cmdBitsAppl"
;1311 //
;1312 //  Check the bits that where set and trigger the corresponding events as
;1313 //  appropriate (but do NOT save the new value - just use it to trigger
;1314 //  events)
;1315 //-------------------------------------------------------------------------
;1316 bool _nearcall MB_cmdBitsAppl(SetRegFuncParams)
;1317 {
	.defseg	FARCODE
	.seg	FARCODE
	.align	4
$$MB_cmdBitsAppl::
	ex	(sp),iy
$MB_cmdBitsAppl::
	.debug	G $MB_cmdBitsAppl 60 9
	.debug	{ $MB_cmdBitsAppl 60 1316 @5 @4
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;1318   ulong  cmdBits;
;1319 
;1320 
;1321   cmdBits = *((ulong *)newVal);
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1322 
;1323   KLOCK();
	call	_KLOCK
;1324 
;1325   if (cmdBits & CBA_Oven1On)   { ovenOnCmd[0] = true;   ovenOffCmd[0] = fal
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@6
	ld	a,0x1
	ld	(_ovenOnCmd),a
	xor	a,a
	ld	(_ovenOffCmd),a
;1326   if (cmdBits & CBA_Oven1Off)  { ovenOnCmd[0] = false;  ovenOffCmd[0] = tru
@6:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@9
	xor	a,a
	ld	(_ovenOnCmd),a
	ld	a,0x1
	ld	(_ovenOffCmd),a
;1327   if (cmdBits & CBA_Oven1Reset) ovenResetCmd[0] = true;
@9:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2000
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@12
	ld	a,0x1
	ld	(_ovenResetCmd),a
;1328 
;1329   if (cmdBits & CBA_Oven2On)   { ovenOnCmd[1] = true;   ovenOffCmd[1] = fal
@12:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4000
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@13
	ld	a,0x1
	ld	(_ovenOnCmd+1),a
	xor	a,a
	ld	(_ovenOffCmd+1),a
;1330   if (cmdBits & CBA_Oven2Off)  { ovenOnCmd[1] = false;  ovenOffCmd[1] = tru
@13:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8000
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@16
	xor	a,a
	ld	(_ovenOnCmd+1),a
	ld	a,0x1
	ld	(_ovenOffCmd+1),a
;1331   if (cmdBits & CBA_Oven2Reset) ovenResetCmd[1] = true;
@16:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x1
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@19
	ld	a,0x1
	ld	(_ovenResetCmd+1),a
;1332 
;1333   if (cmdBits & CBA_BiasOn)   { biasOnCmd = true;   biasOffCmd = false; }
@19:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x40
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@20
	ld	a,0x1
	ld	(_biasOnCmd),a
	xor	a,a
	ld	(_biasOffCmd),a
;1334   if (cmdBits & CBA_BiasOff)  { biasOnCmd = false;  biasOffCmd = true;  }
@20:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x80
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@23
	xor	a,a
	ld	(_biasOnCmd),a
	ld	a,0x1
	ld	(_biasOffCmd),a
;1335 
;1336   if (cmdBits & CBA_SptrOn)   { sptrOnCmd = true;   sptrOffCmd = false; }
@23:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x100
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@26
	ld	a,0x1
	ld	(_sptrOnCmd),a
	xor	a,a
	ld	(_sptrOffCmd),a
;1337   if (cmdBits & CBA_SptrOff)  { sptrOnCmd = false;  sptrOffCmd = true;  }
@26:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x200
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@29
	xor	a,a
	ld	(_sptrOnCmd),a
	ld	a,0x1
	ld	(_sptrOffCmd),a
;1338 
;1339 //  if (cmdBits & CBA_RFGenStart) { rfgenStartCmd = true;  rfgenStopCmd = f
;1340 //  if (cmdBits & CBA_RFGenStop)  { rfgenStartCmd = false; rfgenStopCmd = t
;1341 //  if (cmdBits & CBA_RFGenReset) rfgenResetCmd = true;
;1342 
;1343   cmdBitsAppl = 0;
@29:
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_cmdBitsAppl),de
	ld	(_cmdBitsAppl+2),bc
;1344 
;1345   KUNLOCK();
	call	_KUNLOCK
;1346 
;1347 
;1348   return true;
	ld	a,0x1
;1349 }
@4:
	.debug	} @4 1349

@3	equ	4
	ld	sp,ix
	pop	ix
	lret
@5	equ	6
;1350 
;1351 
;1352 //-------------------------------------------------------------------------
;1353 //  External ModBus client sent a new setpoint
;1354 //
;1355 //  Check the new setting and alter output values as appropriate
;1356 //-------------------------------------------------------------------------
;1357 /*EXAMPLE
;1358 bool MB_ampSet(SetRegFuncParams)
;1359 {
;1360   newSetpoint(MB_VAL(float));
;1361 
;1362   return true;
;1363 }
;1364 */
;1365 
;1366 
;1367 //=========================================================================
;1368 //  functions to handle restoration of saved "persistent" values
;1369 //=========================================================================
;1370 
;1371 /*
;1372 //-------------------------------------------------------------------------
;1373 //  one of the setpoint values needs restoring from the settings file
;1374 //-------------------------------------------------------------------------
;1375 _nearcall void myValRestore(void far *curVal, char *newVal, uint count)
;1376 {
;1377   uint  u;
;1378   float  fval;
;1379   char  temp[32];
;1380 
;1381   for (u=0; u<NumPS; ++u)  if (curVal == (void far *) &ISET(u))  {
;1382     fval = *(float far *)newVal;
;1383     printf("restoring iSet_%u to: %s\r\n", u, fmtFloat(fval, 8,2, temp));
;1384     newSetpoint(u, fval);
;1385   }
;1386 
;1387 }
;1388 
;1389 //-------------------------------------------------------------------------
;1390 //  restore an ampSet value from the settings file
;1391 //-------------------------------------------------------------------------
;1392 _nearcall void ampSetRestore(void far *curVal, char *newVal, uint count)
;1393 {
;1394   newSetpoint(NEW_VAL(float));
;1395 }
;1396 
;1397 
;1398 */
;1399 
;1400 //-------------------------------------------------------------------------
;1401 
;1402 
;1403 //-------------------------------------------------------------------------
;1404 #define SharedFuncs
;1405 #include <sharedAppl.c>
;1406 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
$initModBusRegs::
	.debug	G $initModBusRegs 61 9
	.debug	{ $initModBusRegs 61 454 @34 @33
	ld	hl,0x64
	ld	(_C0ChanMult),hl
	ld	l,0x1
	ld	(_NumC0Chans),hl
	ld	l,0x64
	ld	(_R3ChanMult),hl
	ld	l,0x1
	ld	(_NumR3Chans),hl
	ld	l,0x64
	ld	(_R4ChanMult),hl
	ld	l,0x1
	ld	(_NumR4Chans),hl
	lcall	$pvInitLists
	bool	hl
	jr	z,@35
	ld	a,0x1
	ld	(_doShutdown),a
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@38
	ld	a,0x1
	ld	(_runBackup),a
	ld	(_doReboot),a
@38:
@35:
@33:
	.debug	} @33 464

@32	equ	0
	lret
@34	equ	0
	.align	4
$$MB_timeZone::
	ex	(sp),iy
$MB_timeZone::
	.debug	G $MB_timeZone 60 9
	.debug	{ $MB_timeZone 60 470 @41 @40
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(ix-2),hl
	ld	de,0x7ff4
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@42
	ld	hl,(ix-2)
	ld	de,0x800c
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@43
	jr	z,@43
@42:
	xor	a,a
	jr	@40
@43:
	ld	hl,(ix-2)
	ld	(_timeZone),hl
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@44
	push	hl
	ld	de,word (phys @1+1410)
	ld	c,phys @1+1410 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
@44:
	ipset	2
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	d,0
	ld	e,(ix+7)
	ex	de,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ipres
	ld	a,0x1
@40:
	.debug	} @40 486

@39	equ	2
	ld	sp,ix
	pop	ix
	lret
@41	equ	4
	.align	4
$$MB_cmdBitsStd::
	ex	(sp),iy
$MB_cmdBitsStd::
	.debug	G $MB_cmdBitsStd 60 9
	.debug	{ $MB_cmdBitsStd 60 494 @47 @46
	ld	hl,-132
	call	__fent##
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@48
	ld	a,0x1
	ld	(_doReboot),a
	ld	(_doShutdown),a
@48:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@49
	ld	a,0x1
	ld	(_doShutdown),a
@49:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@50
	ld	hl,0x1
	push	hl
	ld	hl,_devDataFile
	push	hl
	ld	hl,0x80
	push	hl
	ld	hl,-126+@45
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
@50:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@51
	ld	hl,_devDataFile
	push	hl
	lcall	$loadParamsMsg
	pop	de
@51:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@52
	ld	hl,0x1
	push	hl
	ld	hl,_hdwCfgFile
	push	hl
	ld	hl,0x80
	push	hl
	ld	hl,-126+@45
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
@52:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@53
	ld	hl,_hdwCfgFile
	push	hl
	lcall	$loadParamsMsg
	pop	de
@53:
	ld	a,0x1
@46:
	.debug	} @46 524

@45	equ	132
	ld	sp,ix
	pop	ix
	lret
@47	equ	134
$rwIO::
	.debug	G $rwIO 61 9
	.debug	{ $rwIO 61 531 @56 @55
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-28
	.bseg
@57:
	.ds	2
	.seg	FARCODE
	ld	hl,(@57)
	inc	hl
	ld	(@57),hl
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	inc	l
	ld	(ix-6),hl
	ld	de,(_DAC_Mask)
	ld	bc,(_DAC_Mask+2)
	ld	hl,bc
	or	hl,de
	jp	z,@58
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@61:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jp	nc,@62
	ld	hl,(ix-2)
	ld	de,_updateAOut
	add	hl,de
	ld	(ix-12),hl
	ld	hl,(ix-2)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@66
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_lastSetVal
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fequ##
	jr	z,@67
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_lastSetVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-12)
	ld	(hl),0x1
@67:
@66:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaOut
	add	hl,de
	ex	de,hl
	call	__farcvp##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_lastAnaOut
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fequ##
	jr	z,@70
	ld	hl,(ix-12)
	ld	(hl),0x1
@70:
	ld	hl,(ix-12)
	ld	a,(hl)
	or	a,a
	jp	z,@63
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-2)
	ld	de,_dacForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@72
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_dacForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
	jr	@73
@72:
	ld	hl,(ix-2)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@74
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_setGain
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fdivr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_setOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fadd##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@74:
@73:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fsubr##
	jp	p,@75
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@75:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fsubr##
	jp	m,@76
	jr	z,@76
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@76:
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_lastAnaOut
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fdivr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fadd##
	call	__ftol##
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_dacRaw
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	hl,de
	ld	(ix-4),hl
@63:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	add	hl,hl
	ld	(ix-6),hl
	jp	@61
@62:
@58:
	ld	hl,(_hdwType)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@77
	ld	hl,(@57)
	ld	e,0x1f
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@78
	ld	b,a
@79:
	add	hl,hl
	djnz	@79
@78:
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	hl,de
	ld	(ix-4),hl
@77:
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastReadTime),hl
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	ld	hl,bc
	or	hl,de
	jr	z,@80
	push	bc
	push	de
	lcall	$readAnalogInputs
	add	sp,4
@80:
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	lcall	$ReadDigInputs
	ld	(_digitalIn),de
	ld	(_digitalIn+2),bc
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	ld	(_readTicks),de
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	de,(_DAC_Mask)
	ld	bc,(_DAC_Mask+2)
	ld	hl,bc
	or	hl,de
	jr	z,@81
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	d,h
	ld	e,l
	ld	bc,(_DAC_Mask+2)
	call	__land##
	push	bc
	push	de
	lcall	$writeAnalogOutputs
	add	sp,4
@81:
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	ld	(_writeTicks),de
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	ld	hl,bc
	or	hl,de
	jp	z,@82
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@85:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@86
	ld	hl,(ix-2)
	ld	de,_updateAIn
	add	hl,de
	ld	(ix-12),hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@90
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-12)
	ld	(hl),0x1
@90:
	ld	hl,(ix-12)
	ld	a,(hl)
	or	a,a
	jp	z,@87
	xor	a,a
	ld	(hl),a
	ld	hl,(ix-2)
	ld	de,_adcForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@94
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_adcForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@95
@94:
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
@95:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_anaIn
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@96
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_readOffset
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsubr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_readVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@96:
	ld	hl,(ix-2)
	ld	de,_newRdg
	add	hl,de
	ld	a,0x1
	ld	(hl),a
@87:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@85
@86:
@82:
	lcall	$updateAvgsADC
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
	push	bc
	push	de
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	call	__lsub##
	ld	(_rwTicks),de
@55:
	.debug	} @55 607

@54	equ	28
	ld	sp,ix
	pop	ix
	lret
@56	equ	30
$logDigIOChgs::
	.debug	G $logDigIOChgs 62 9
	.debug	{ $logDigIOChgs 62 613 @99 @98
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	ld	de,(_curState+16)
	ld	bc,(_curState+18)
	push	bc
	push	de
	ld	de,(_prevState+16)
	ld	bc,(_prevState+18)
	call	__lxor##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	.seg	FARCODE
	ld	de,(_curState+99)
	ld	bc,(_curState+101)
	push	bc
	push	de
	ld	de,(_prevState+99)
	ld	bc,(_prevState+101)
	call	__lxor##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	.seg	FARCODE
	ld	a,(ix+5)
	or	a,a
	jr	z,@100
	ld	de,word (phys @1+1434)
	ld	c,phys @1+1434 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@100:
	ld	a,(ix+5)
	or	a,a
	jr	nz,@101
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	or	hl,de
	jp	z,@102
@101:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-2),hl
@105:
	ld	hl,(ix-2)
	ld	de,(_NumApplDIN)
	or	a,a
	sbc	hl,de
	jp	nc,@106
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@110
	ld	a,(ix+5)
	or	a,a
	jr	z,@111
@110:
	ld	hl,(ix-2)
	add	hl,hl
	ld	(ix-4),hl
	ld	de,(_curState+16)
	ld	bc,(_curState+18)
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@114
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
@114:
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ld	de,_digInDescr
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@115
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+1479)
	ld	c,phys @1+1479 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
@115:
@111:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@105
@106:
@102:
	ld	a,(ix+5)
	or	a,a
	jr	z,@116
	ld	de,word (phys @1+1485)
	ld	c,phys @1+1485 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@116:
	ld	a,(ix+5)
	or	a,a
	jr	nz,@117
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	or	hl,de
	jp	z,@118
@117:
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-2),hl
@121:
	ld	hl,(ix-2)
	ld	de,(_NumApplDOUT)
	or	a,a
	sbc	hl,de
	jp	nc,@122
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@126
	ld	a,(ix+5)
	or	a,a
	jr	z,@127
@126:
	ld	hl,(ix-2)
	add	hl,hl
	ld	(ix-4),hl
	ld	de,(_curState+99)
	ld	bc,(_curState+101)
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@130
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
@130:
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ld	de,_digOutDescr
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@131
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+1479)
	ld	c,phys @1+1479 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
@131:
@127:
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@121
@122:
@118:
	ld	a,(ix+5)
	or	a,a
	jr	z,@132
	ld	de,word (phys @1+1476)
	ld	c,phys @1+1476 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@132:
@98:
	.debug	} @98 648

@97	equ	20
	ld	sp,ix
	pop	ix
	lret
@99	equ	22
	.align	4
$$EVENT_RestoredParamFile::
	ex	(sp),iy
$EVENT_RestoredParamFile::
	.debug	G $EVENT_RestoredParamFile 63 9
	.debug	{ $EVENT_RestoredParamFile 63 654 @135 @134
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	add	hl,hl
	ld	de,_paramFiles
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+1531)
	ld	c,phys @1+1531 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,0x100
	push	hl
	ld	hl,_applBuf
	push	hl
	lcall	$loadParams
	add	sp,8
@134:
	.debug	} @134 666

@133	equ	4
	ld	sp,ix
	pop	ix
	lret
@135	equ	6
	.align	4
$$hostNameRestore::
	ex	(sp),iy
$hostNameRestore::
	.debug	G $hostNameRestore 64 9
	.debug	{ $hostNameRestore 64 671 @138 @137
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,(ix+9)
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$SetHostName
	add	sp,4
@137:
	.debug	} @137 674

@136	equ	0
	pop	ix
	lret
@138	equ	2
	.align	4
$$ReadSetCalibsRestore::
	ex	(sp),iy
$ReadSetCalibsRestore::
	.debug	G $ReadSetCalibsRestore 64 9
	.debug	{ $ReadSetCalibsRestore 64 679 @141 @140
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	call	_KLOCK
	ld	hl,(ix+11)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	call	_KUNLOCK
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@144:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@145
	ld	hl,(ix-2)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@144
@145:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@149:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@150
	ld	hl,(ix-2)
	push	hl
	lcall	$newDACCalib
	pop	hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@149
@150:
@140:
	.debug	} @140 689

@139	equ	2
	ld	sp,ix
	pop	ix
	lret
@141	equ	4
$setApplDTM::
	.debug	G $setApplDTM 61 9
	.debug	{ $setApplDTM 61 694 @154 @153
	ld	hl,@2+84
	push	hl
	ld	hl,@2+93
	push	hl
	ld	de,word (phys @1+1563)
	ld	c,phys @1+1563 >> 16
	push	bc
	push	de
	ld	de,word (phys _applDTM)
	ld	c,phys _applDTM >> 16
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
	ld	hl,@2+84
	push	hl
	ld	hl,@2+93
	push	hl
	lcall	$compileTime
	add	sp,4
	ld	(_applVersTime),de
	ld	(_applVersTime+2),bc
@153:
	.debug	} @153 699

@152	equ	0
	lret
@154	equ	0
$saveApplState::
	.debug	G $saveApplState 65 9
	.debug	{ $saveApplState 65 709 @157 @156
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@158
	ld	hl,0xffff
	jp	@156
@158:
	call	_KLOCK
	ld	de,word (phys @1+1569)
	ld	c,phys @1+1569 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
	ld	hl,(_ApplStateDataSize)
	ld	(ix-2),hl
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x8d
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_prevState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8d
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x8d
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_curState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8d
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x8d
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_nextState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8d
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x10
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_setVal
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-2)
	call	__farst2##
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$memCRC16
	add	sp,8
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-10)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst2##
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
	call	_KUNLOCK
	bool	hl
	ld	l,h
@156:
	.debug	} @156 746

@155	equ	10
	ld	sp,ix
	pop	ix
	lret
@157	equ	12
$restoreApplState::
	.debug	G $restoreApplState 65 9
	.debug	{ $restoreApplState 65 764 @161 @160
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@162
	ld	hl,0xffff
	jp	@160
@162:
	ld	hl,(_ApplStateDataSize)
	ld	(ix-2),hl
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	call	__farld2##
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	z,@163
	ld	hl,0x1
	jp	@160
@163:
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__lsub##
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	c,@164
	jr	z,@164
	ld	hl,0x2
	jp	@160
@164:
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$memCRC16
	add	sp,8
	pop	de
	or	a,a
	sbc	hl,de
	jr	z,@165
	ld	hl,0x3
	jp	@160
@165:
	ld	de,0x8d
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_prevState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8d
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x8d
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_curState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8d
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x8d
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_nextState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8d
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x10
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_setVal
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState+16),de
	ld	(_nextState+18),bc
	ld	(_curState+16),de
	ld	(_curState+18),bc
	ld	de,(_curState+99)
	ld	bc,(_curState+101)
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	ld	de,word (phys @1+1596)
	ld	c,phys @1+1596 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	bool	hl
	ld	l,h
@160:
	.debug	} @160 801

@159	equ	10
	ld	sp,ix
	pop	ix
	lret
@161	equ	12
$setGenericLabels::
	.debug	G $setGenericLabels 61 9
	.debug	{ $setGenericLabels 61 806 @168 @167
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@171:
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@172
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1636)
	ld	c,phys @1+1636 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@171
@172:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@178:
	ld	hl,(ix-2)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@179
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1643)
	ld	c,phys @1+1643 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@178
@179:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@185:
	ld	hl,(ix-2)
	ld	de,(_NumApplDIN)
	or	a,a
	sbc	hl,de
	jr	nc,@186
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1651)
	ld	c,phys @1+1651 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@185
@186:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@192:
	ld	hl,(ix-2)
	ld	de,(_NumApplDOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@193
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1658)
	ld	c,phys @1+1658 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@192
@193:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@199:
	ld	hl,(ix-2)
	ld	de,(_NumExtraIn)
	or	a,a
	sbc	hl,de
	jr	nc,@200
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _extraInLabel)
	ld	c,phys _extraInLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1666)
	ld	c,phys @1+1666 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _extraInLabel)
	ld	c,phys _extraInLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@199
@200:
@167:
	.debug	} @167 831

@166	equ	2
	ld	sp,ix
	pop	ix
	lret
@168	equ	4
;1407 
;1408 //=========================================================================
;1409 //  Misc Application-specific functions
;1410 //=========================================================================
;1411 //APPLCODE
;1412 
;1413 
;1414 
;1415 //=========================================================================
;1416 //  Task functions to handle application-specific commands
;1417 //=========================================================================
;1418 //APPLCODE
;1419 
;1420 //-------------------------------------------------------------------------
;1421 //  example func to process a command entered via a user shell
;1422 //-------------------------------------------------------------------------
;1423 /*
;1424 void _task miscTest(int argc, char **argv)
;1425 {
;1426   int  idx;
;1427   bool  validCmd;
;1428 
;1429 //used by EVENT macro
;1430   fd_t  eventsfd = -1;
;1431   EventMsg  eventMsg;
;1432 
;1433 
;1434   validCmd = false;
;1435 
;1436   for (;;)  {
;1437     if (argc < 3)  break;
;1438     if (! isdigit(argv[1][0]))  break;
;1439 
;1440     idx = atoi(argv[1]);
;1441     if ((idx < 1) OR (idx > NumChan))  {
;1442       printf("Invalid chan #\n");  Exit(-2); }
;1443 
;1444     --idx;  validCmd = true;
;1445 
;1446     if (StriEq(argv[2], "x"))     { EVENT(MyEventX, idx, NULL, 0);  break; 
;1447     if (StriEq(argv[2], "y"))     { EVENT(MyEventY, idx, NULL, 0);  break; 
;1448 
;1449     validCmd = false;  break;
;1450   }
;1451 
;1452   if (! validCmd)  { printf("Usage:  misc # x|y\r\n");  Exit(-1); }
;1453 
;1454   Exit(0);
;1455 }
;1456 */
;1457 
;1458 //=========================================================================
;1459 //  Generic structure to handle application-specific presentation of the
;1460 //  digital and analog input/output values.  Code to handle additional
;1461 //  formatting that cannot be handled in this generic manner should be
;1462 //  placed in the showState() task routine.
;1463 //=========================================================================
;1464 //APPLCODE - text and formatting info for application state summary
;1465 
;1466 #define  RedText  "\033[31m"
;1467 #define  BlueText "\033[34m"
;1468 
;1469 //-------------------------------------------------------------------------
;1470 _nearcall char *fmtSupType(DispElem far *elem, char *buf)
;1471 {
	.align	4
$$fmtSupType::
	ex	(sp),iy
$fmtSupType::
	.debug	G $fmtSupType 66 9
	.debug	{ $fmtSupType 66 1470 @206 @205
	push	ix
	ld	ix,0
	add	ix,sp
;1472   return (char *) SupplyTypeDesc[ELEM_VAL(U16)];
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_SupplyTypeDesc
	add	hl,de
	ld	hl,(hl)
;1473 }
@205:
	.debug	} @205 1473

@204	equ	0
	pop	ix
	lret
@206	equ	2
;1474 
;1475 //-------------------------------------------------------------------------
;1476 _nearcall char *fmtInactive(DispElem far *elem, char *buf)
;1477 {
	.align	4
$$fmtInactive::
	ex	(sp),iy
$fmtInactive::
	.debug	G $fmtInactive 66 9
	.debug	{ $fmtInactive 66 1476 @209 @208
	push	ix
	ld	ix,0
	add	ix,sp
;1478   return (ELEM_VAL(bool) ? RedText" NO" : BlueText"YES");
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@210
	ld	hl,@2+109
	jr	@208
@210:
	ld	hl,@2+118
;1479 }
@208:
	.debug	} @208 1479

@207	equ	0
	pop	ix
	lret
@209	equ	2
;1480 
;1481 //-------------------------------------------------------------------------
;1482 _nearcall char *fmtF32ser1(DispElem far *elem, char *buf)
;1483 {
	.align	4
$$fmtF32ser1::
	ex	(sp),iy
$fmtF32ser1::
	.debug	G $fmtF32ser1 66 9
	.debug	{ $fmtF32ser1 66 1482 @215 @214
	push	ix
	ld	ix,0
	add	ix,sp
;1484   strcpy(buf, (Cur.ovenInactive[0] ? RedText : BlueText));
	ld	a,(_curState+20)
	or	a,a
	jr	z,@216
	ld	hl,@2+127
	jr	@217
@216:
	ld	hl,@2+133
@217:
	push	hl
	ld	hl,(ix+9)
	push	hl
	call	_strcpy
	add	sp,4
;1485   fmtFloat(ELEM_VAL(float), elem->width, elem->prec, buf+5);
	ld	hl,(ix+9)
	ld	de,0x5
	add	hl,de
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld4##
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
;1486   return buf;
	ld	hl,(ix+9)
;1487 }
@214:
	.debug	} @214 1487

@213	equ	0
	pop	ix
	lret
@215	equ	2
;1488 //---------------------------------------------------------------
;1489 _nearcall char *fmtF32ser2(DispElem far *elem, char *buf)
;1490 {
	.align	4
$$fmtF32ser2::
	ex	(sp),iy
$fmtF32ser2::
	.debug	G $fmtF32ser2 66 9
	.debug	{ $fmtF32ser2 66 1489 @221 @220
	push	ix
	ld	ix,0
	add	ix,sp
;1491   strcpy(buf, (Cur.ovenInactive[1] ? RedText : BlueText));
	ld	a,(_curState+21)
	or	a,a
	jr	z,@222
	ld	hl,@2+127
	jr	@223
@222:
	ld	hl,@2+133
@223:
	push	hl
	ld	hl,(ix+9)
	push	hl
	call	_strcpy
	add	sp,4
;1492   fmtFloat(ELEM_VAL(float), elem->width, elem->prec, buf+5);
	ld	hl,(ix+9)
	ld	de,0x5
	add	hl,de
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld4##
	push	bc
	push	de
	lcall	$fmtFloat
	add	sp,10
;1493   return buf;
	ld	hl,(ix+9)
;1494 }
@220:
	.debug	} @220 1494

@219	equ	0
	pop	ix
	lret
@221	equ	2
;1495 
;1496 //-------------------------------------------------------------------------
;1497 _nearcall char *fmtBinary1(DispElem far *elem, char *buf)
;1498 {
	.align	4
$$fmtBinary1::
	ex	(sp),iy
$fmtBinary1::
	.debug	G $fmtBinary1 66 9
	.debug	{ $fmtBinary1 66 1497 @227 @226
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;1499   uint  val;
;1500 
;1501   strcpy(buf, (Cur.ovenInactive[0] ? RedText : BlueText));
	ld	a,(_curState+20)
	or	a,a
	jr	z,@228
	ld	hl,@2+127
	jr	@229
@228:
	ld	hl,@2+133
@229:
	push	hl
	ld	hl,(ix+9)
	push	hl
	call	_strcpy
	add	sp,4
;1502   val = ELEM_VAL(uint);  val >>= elem->width;
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	ld	hl,(ix-2)
	call	__uishr##
	ld	(ix-2),hl
;1503   LongToBinMS1st((ulong)val, buf+5, elem->prec);
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+9)
	ld	de,0x5
	add	hl,de
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	lcall	$LongToBinMS1st
	add	sp,8
;1504   return buf;
	ld	hl,(ix+9)
;1505 }
@226:
	.debug	} @226 1505

@225	equ	2
	ld	sp,ix
	pop	ix
	lret
@227	equ	4
;1506 //--------------------------------------------------------------
;1507 _nearcall char *fmtBinary2(DispElem far *elem, char *buf)
;1508 {
	.align	4
$$fmtBinary2::
	ex	(sp),iy
$fmtBinary2::
	.debug	G $fmtBinary2 66 9
	.debug	{ $fmtBinary2 66 1507 @233 @232
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;1509   uint  val;
;1510 
;1511   strcpy(buf, (Cur.ovenInactive[1] ? RedText : BlueText));
	ld	a,(_curState+21)
	or	a,a
	jr	z,@234
	ld	hl,@2+127
	jr	@235
@234:
	ld	hl,@2+133
@235:
	push	hl
	ld	hl,(ix+9)
	push	hl
	call	_strcpy
	add	sp,4
;1512   val = ELEM_VAL(uint);  val >>= elem->width;
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	ld	hl,(ix-2)
	call	__uishr##
	ld	(ix-2),hl
;1513   LongToBinMS1st((ulong)val, buf+5, elem->prec);
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix+9)
	ld	de,0x5
	add	hl,de
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	lcall	$LongToBinMS1st
	add	sp,8
;1514   return buf;
	ld	hl,(ix+9)
;1515 }
@232:
	.debug	} @232 1515

@231	equ	2
	ld	sp,ix
	pop	ix
	lret
@233	equ	4
;1516 
;1517 //-------------------------------------------------------------------------
;1518 _nearcall char *fmtOvenState1(DispElem far *elem, char *buf)
;1519 {
	.align	4
$$fmtOvenState1::
	ex	(sp),iy
$fmtOvenState1::
	.debug	G $fmtOvenState1 66 9
	.debug	{ $fmtOvenState1 66 1518 @239 @238
	push	ix
	ld	ix,0
	add	ix,sp
;1520   strcpy(buf, (Cur.enableOvenOutput[0] ? BlueText : RedText));
	ld	a,(_curState+105)
	or	a,a
	jr	z,@240
	ld	hl,@2+133
	jr	@241
@240:
	ld	hl,@2+127
@241:
	push	hl
	ld	hl,(ix+9)
	push	hl
	call	_strcpy
	add	sp,4
;1521 
;1522   if (Cur.ovenOutErrInterlock[0])
	ld	a,(_curState+88)
	or	a,a
	jr	z,@243
;1523     strcat(buf, "INTLK");
	ld	hl,@2+139
	push	hl
	ld	hl,(ix+9)
	push	hl
	call	_strcat
	add	sp,4
;1524   else
;1525     strcat(buf, ((digitalOut & OVEN1_OUT_OFF) ? "  OFF" : "   ON") );
	jr	@244
@243:
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	ld	de,0x100
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@245
	ld	hl,@2+145
	jr	@246
@245:
	ld	hl,@2+151
@246:
	push	hl
	ld	hl,(ix+9)
	push	hl
	call	_strcat
	add	sp,4
;1526 
;1527   return buf;
@244:
	ld	hl,(ix+9)
;1528 }
@238:
	.debug	} @238 1528

@237	equ	0
	pop	ix
	lret
@239	equ	2
;1529 //--------------------------------------------------------------
;1530 _nearcall char *fmtOvenState2(DispElem far *elem, char *buf)
;1531 {
	.align	4
$$fmtOvenState2::
	ex	(sp),iy
$fmtOvenState2::
	.debug	G $fmtOvenState2 66 9
	.debug	{ $fmtOvenState2 66 1530 @250 @249
	push	ix
	ld	ix,0
	add	ix,sp
;1532   strcpy(buf, (Cur.enableOvenOutput[1] ? BlueText : RedText));
	ld	a,(_curState+106)
	or	a,a
	jr	z,@251
	ld	hl,@2+133
	jr	@252
@251:
	ld	hl,@2+127
@252:
	push	hl
	ld	hl,(ix+9)
	push	hl
	call	_strcpy
	add	sp,4
;1533 
;1534   if (Cur.ovenOutErrInterlock[1])
	ld	a,(_curState+89)
	or	a,a
	jr	z,@254
;1535     strcat(buf, "INTLK");
	ld	hl,@2+139
	push	hl
	ld	hl,(ix+9)
	push	hl
	call	_strcat
	add	sp,4
;1536   else
;1537     strcat(buf, ((digitalOut & OVEN2_OUT_OFF) ? "  OFF" : "   ON") );
	jr	@255
@254:
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	ld	de,0x28
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@256
	ld	hl,@2+145
	jr	@257
@256:
	ld	hl,@2+151
@257:
	push	hl
	ld	hl,(ix+9)
	push	hl
	call	_strcat
	add	sp,4
;1538 
;1539   return buf;
@255:
	ld	hl,(ix+9)
;1540 }
@249:
	.debug	} @249 1540

@248	equ	0
	pop	ix
	lret
@250	equ	2
;1541 
;1542 //-------------------------------------------------------------------------
;1543 float biasReadmA, sptrReadmA;
;1544 
;1545 const char far DevStateStr[] = {
;1546 /*
;1547 "----- RF Gen Supply -----     ----- Bias Supply -----   ---- Oven Status -
;1548 " Readback:     -####.# V       Readback:  -####.## V     Const.Cur Mode:  
;1549 " Setpoint:     -####.# V       Setpoint:  -####.## V     Foldback Protect:
;1550 " Current:      -####.# A       Current:   -####.## A     Auto Restart:    
;1551 " Watts:        -####.# W       Assert ON:      ###       Output ON:       
;1552 " \r\n"
;1553 " HotShot PS:       ###        --- Sputter Disk PS ---    OverVolt Error:  
;1554 " NovaStar PS:      ###         Readback:  -####.## V     OverTemp Error:  
;1555 "                               Setpoint:  -####.## V     Input Volt Error:
;1556 " RF PS Fault:    #####         Current:   -####.## A     Foldback Error:  
;1557 " RF PS Heat:       ###         Assert ON:      ###       Prog/Com Stat:x##
;1558 " RF PS Ready:      ### \r\n"
;1559 " Serial Com OK:    ###        ----- Oven Supply -----   --(via Serial)--\r
;1560 "                               Readback:  -####.## V     -##.### V \r\n"
;1561 " Reset Pulse:      ###         Setpoint:  -####.## V     -##.### V,-##.###
;1562 " Stop Pulse        ###         Current:   -####.## A     -##.### A \r\n"
;1563 " Start Pulse:      ###         State:        ##### \r\n"
;1564 "                               Serial Com OK:  ### \r\n"
;1565 "\r\n"
;1566 */
;1567 
;1568 "----- Oven1/Oven2 Status -----       ----- Bias Supply ----- \r\n"
;1569 " Const.Cur Mode:      #      #        Readback:  -####.## V \r\n"
;1570 " Foldback Protect:    #      #        Setpoint:  -####.## V \r\n"
;1571 " Auto Restart:        #      #        Current:   -####.## mA \r\n"
;1572 " Output ON:           #      #        Assert ON:      ### \r\n"
;1573 " OverVolt Error:      #      # \r\n"
;1574 " OverTemp Error:      #      #       --- Sputter Disk PS --- \r\n"
;1575 " Input Volt Error:    #      #        Readback:  -####.## V \r\n"
;1576 " Foldback Error:      #      #        Setpoint:  -####.## V \r\n"
;1577 " Prog/Com Stat:   x####  x####        Current:   -####.## mA \r\n"
;1578 "                                      Ext. Interlock: ### \r\n"
;1579 " Serial Settings:-##.## -##.## V      Assert ON:      ### \r\n"
;1580 "                 -##.## -##.## A \r\n"
;1581 " Serial Readback:-##.## -##.## V \r\n"
;1582 "                 -##.## -##.## A \r\n"
;1583 "\r\n"
;1584 " Analog Setpoint:-##.## -##.## V \r\n"
;1585 " Analog Readback:-##.## -##.## V \r\n"
;1586 "                 -##.## -##.## A \r\n"
;1587 " State:           #####  ##### \r\n"
;1588 "\r\n"
;1589 };
	.seg	FARCONST
_DevStateStr::
	.db	"----- Oven1/Oven2 Status -----       ----- Bias Supply ----- ",13,10," Const.Cur Mode:      "
	.db	"#      #        Readback:  -####.## V ",13,10," Foldback Protect:    #      #        Setpoin"
	.db	"t:  -####.## V ",13,10," Auto Restart:        #      #        Current:   -####.## mA ",13,10," Out"
	.db	"put ON:           #      #        Assert ON:      ### ",13,10," OverVolt Error:      #      "
	.db	"# ",13,10," OverTemp Error:      #      #       --- Sputter Disk PS --- ",13,10," Input Volt Error"
	.db	":    #      #        Readback:  -####.## V ",13,10," Foldback Error:      #      #        Se"
	.db	"tpoint:  -####.## V ",13,10," Prog/Com Stat:   x####  x####        Current:   -####.## mA ",13
	.db	10,"                                      Ext. Interlock: ### ",13,10," Serial Settings:-##.##"
	.db	" -##.## V      Assert ON:      ### ",13,10,"                 -##.## -##.## A ",13,10," Serial Read"
	.db	"back:-##.## -##.## V ",13,10,"                 -##.## -##.## A ",13,10,13,10," Analog Setpoint:-##.## "
	.db	"-##.## V ",13,10," Analog Readback:-##.## -##.## V ",13,10,"                 -##.## -##.## A ",13,10," St"
	.db	"ate:           #####  ##### ",13,10,13,10,0
	.debug	G _DevStateStr 67 8
;1590 
;1591 const DispElem  far dispElems[] = {
;1592 //  { 15, 4, VFPV(rfgenReadV),    BLUE, fmtF32,    7,1 },
;1593 //  { 15, 5, VFPV(rfgenSetV),     BLUE, fmtF32,    7,1 },
;1594 //  { 15, 6, VFPV(rfgenReadA),    BLUE, fmtF32,    7,1 },
;1595 //  { 15, 7, VFPV(rfgenReadW),    BLUE, fmtF32,    7,1 },
;1596 
;1597 //  { 19,15, VFPV(Cur.rfgenInactive), "", fmtInactive, 3,3 },
;1598 
;1599   { 22, 3, VFPV(Cur.ovenOpStatus[0]),     "", fmtBinary1, 7,1 },
_dispElems::
	.db	0x16
	.db	0x3
	.dl	phys _curState+58
	.dw	@2+8
	.dw	word _fmtBinary1
	.dw	0x7
	.dw	0x1
;1600   { 22, 4, VFPV(Cur.ovenOpStatus[0]),     "", fmtBinary1, 6,1 },
	.db	0x16
	.db	0x4
	.dl	phys _curState+58
	.dw	@2+8
	.dw	word _fmtBinary1
	.dw	0x6
	.dw	0x1
;1601   { 22, 5, VFPV(Cur.ovenOpStatus[0]),     "", fmtBinary1, 5,1 },
	.db	0x16
	.db	0x5
	.dl	phys _curState+58
	.dw	@2+8
	.dw	word _fmtBinary1
	.dw	0x5
	.dw	0x1
;1602   { 22, 6, VFPV(Cur.ovenOpStatus[0]),     "", fmtBinary1, 4,1 },
	.db	0x16
	.db	0x6
	.dl	phys _curState+58
	.dw	@2+8
	.dw	word _fmtBinary1
	.dw	0x4
	.dw	0x1
;1603   { 22, 7, VFPV(Cur.ovenAlarmStatus[0]),  "", fmtBinary1, 4,1 },
	.db	0x16
	.db	0x7
	.dl	phys _curState+62
	.dw	@2+8
	.dw	word _fmtBinary1
	.dw	0x4
	.dw	0x1
;1604   { 22, 8, VFPV(Cur.ovenAlarmStatus[0]),  "", fmtBinary1, 3,1 },
	.db	0x16
	.db	0x8
	.dl	phys _curState+62
	.dw	@2+8
	.dw	word _fmtBinary1
	.dw	0x3
	.dw	0x1
;1605   { 22, 9, VFPV(Cur.ovenAlarmStatus[0]),  "", fmtBinary1, 2,1 },
	.db	0x16
	.db	0x9
	.dl	phys _curState+62
	.dw	@2+8
	.dw	word _fmtBinary1
	.dw	0x2
	.dw	0x1
;1606   { 22,10, VFPV(Cur.ovenAlarmStatus[0]),  "", fmtBinary1, 1,1 },
	.db	0x16
	.db	0xa
	.dl	phys _curState+62
	.dw	@2+8
	.dw	word _fmtBinary1
	.dw	0x1
	.dw	0x1
;1607   { 19,11, VFPV(Cur.ovenProgStatus[0]),   "", fmtBinary1, 0,4 },
	.db	0x13
	.db	0xb
	.dl	phys _curState+66
	.dw	@2+8
	.dw	word _fmtBinary1
	.dw	0
	.dw	0x4
;1608 
;1609   { 17,13, VFPV(serOven1SetV),   "", fmtF32ser1,   6,2 },
	.db	0x11
	.db	0xd
	.dl	phys _serOven1SetV
	.dw	@2+8
	.dw	word _fmtF32ser1
	.dw	0x6
	.dw	0x2
;1610   { 17,14, VFPV(serOven1SetA),   "", fmtF32ser1,   6,2 },
	.db	0x11
	.db	0xe
	.dl	phys _serOven1SetA
	.dw	@2+8
	.dw	word _fmtF32ser1
	.dw	0x6
	.dw	0x2
;1611   { 17,15, VFPV(serOven1ReadV),  "", fmtF32ser1,   6,2 },
	.db	0x11
	.db	0xf
	.dl	phys _serOven1ReadV
	.dw	@2+8
	.dw	word _fmtF32ser1
	.dw	0x6
	.dw	0x2
;1612   { 17,16, VFPV(serOven1ReadA),  "", fmtF32ser1,   6,2 },
	.db	0x11
	.db	0x10
	.dl	phys _serOven1ReadA
	.dw	@2+8
	.dw	word _fmtF32ser1
	.dw	0x6
	.dw	0x2
;1613 
;1614   { 17,18, VFPV(oven1SetV),      BLUE, fmtF32,    6,2 },
	.db	0x11
	.db	0x12
	.dl	phys _oven1SetV
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x2
;1615   { 17,19, VFPV(oven1ReadV),     BLUE, fmtF32,    6,2 },
	.db	0x11
	.db	0x13
	.dl	phys _oven1ReadV
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x2
;1616   { 17,20, VFPV(oven1ReadA),     BLUE, fmtF32,    6,2 },
	.db	0x11
	.db	0x14
	.dl	phys _oven1ReadA
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x2
;1617   { 18,21, VFPV(digitalOut),        "", fmtOvenState1, 5,5 },
	.db	0x12
	.db	0x15
	.dl	phys _digitalOut
	.dw	@2+8
	.dw	word _fmtOvenState1
	.dw	0x5
	.dw	0x5
;1618 //  { 47,20, VFPV(Cur.ovenInactive[0]),  "", fmtInactive,  3,3 },
;1619 
;1620   { 29, 3, VFPV(Cur.ovenOpStatus[1]),     "", fmtBinary2, 7,1 },
	.db	0x1d
	.db	0x3
	.dl	phys _curState+60
	.dw	@2+8
	.dw	word _fmtBinary2
	.dw	0x7
	.dw	0x1
;1621   { 29, 4, VFPV(Cur.ovenOpStatus[1]),     "", fmtBinary2, 6,1 },
	.db	0x1d
	.db	0x4
	.dl	phys _curState+60
	.dw	@2+8
	.dw	word _fmtBinary2
	.dw	0x6
	.dw	0x1
;1622   { 29, 5, VFPV(Cur.ovenOpStatus[1]),     "", fmtBinary2, 5,1 },
	.db	0x1d
	.db	0x5
	.dl	phys _curState+60
	.dw	@2+8
	.dw	word _fmtBinary2
	.dw	0x5
	.dw	0x1
;1623   { 29, 6, VFPV(Cur.ovenOpStatus[1]),     "", fmtBinary2, 4,1 },
	.db	0x1d
	.db	0x6
	.dl	phys _curState+60
	.dw	@2+8
	.dw	word _fmtBinary2
	.dw	0x4
	.dw	0x1
;1624   { 29, 7, VFPV(Cur.ovenAlarmStatus[1]),  "", fmtBinary2, 4,1 },
	.db	0x1d
	.db	0x7
	.dl	phys _curState+64
	.dw	@2+8
	.dw	word _fmtBinary2
	.dw	0x4
	.dw	0x1
;1625   { 29, 8, VFPV(Cur.ovenAlarmStatus[1]),  "", fmtBinary2, 3,1 },
	.db	0x1d
	.db	0x8
	.dl	phys _curState+64
	.dw	@2+8
	.dw	word _fmtBinary2
	.dw	0x3
	.dw	0x1
;1626   { 29, 9, VFPV(Cur.ovenAlarmStatus[1]),  "", fmtBinary2, 2,1 },
	.db	0x1d
	.db	0x9
	.dl	phys _curState+64
	.dw	@2+8
	.dw	word _fmtBinary2
	.dw	0x2
	.dw	0x1
;1627   { 29,10, VFPV(Cur.ovenAlarmStatus[1]),  "", fmtBinary2, 1,1 },
	.db	0x1d
	.db	0xa
	.dl	phys _curState+64
	.dw	@2+8
	.dw	word _fmtBinary2
	.dw	0x1
	.dw	0x1
;1628   { 26,11, VFPV(Cur.ovenProgStatus[1]),   "", fmtBinary2, 0,4 },
	.db	0x1a
	.db	0xb
	.dl	phys _curState+68
	.dw	@2+8
	.dw	word _fmtBinary2
	.dw	0
	.dw	0x4
;1629 
;1630   { 24,13, VFPV(serOven2SetV),   "", fmtF32ser2,   6,2 },
	.db	0x18
	.db	0xd
	.dl	phys _serOven2SetV
	.dw	@2+8
	.dw	word _fmtF32ser2
	.dw	0x6
	.dw	0x2
;1631   { 24,14, VFPV(serOven2SetA),   "", fmtF32ser2,   6,2 },
	.db	0x18
	.db	0xe
	.dl	phys _serOven2SetA
	.dw	@2+8
	.dw	word _fmtF32ser2
	.dw	0x6
	.dw	0x2
;1632   { 24,15, VFPV(serOven2ReadV),  "", fmtF32ser2,   6,2 },
	.db	0x18
	.db	0xf
	.dl	phys _serOven2ReadV
	.dw	@2+8
	.dw	word _fmtF32ser2
	.dw	0x6
	.dw	0x2
;1633   { 24,16, VFPV(serOven2ReadA),  "", fmtF32ser2,   6,2 },
	.db	0x18
	.db	0x10
	.dl	phys _serOven2ReadA
	.dw	@2+8
	.dw	word _fmtF32ser2
	.dw	0x6
	.dw	0x2
;1634 
;1635   { 24,18, VFPV(oven2SetV),      BLUE, fmtF32,    6,2 },
	.db	0x18
	.db	0x12
	.dl	phys _oven2SetV
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x2
;1636   { 24,19, VFPV(oven2ReadV),     BLUE, fmtF32,    6,2 },
	.db	0x18
	.db	0x13
	.dl	phys _oven2ReadV
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x2
;1637   { 24,20, VFPV(oven2ReadA),     BLUE, fmtF32,    6,2 },
	.db	0x18
	.db	0x14
	.dl	phys _oven2ReadA
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x2
;1638   { 25,21, VFPV(digitalOut),        "", fmtOvenState2, 5,5 },
	.db	0x19
	.db	0x15
	.dl	phys _digitalOut
	.dw	@2+8
	.dw	word _fmtOvenState2
	.dw	0x5
	.dw	0x5
;1639 
;1640   { 49, 3, VFPV(biasReadV),     BLUE, fmtF32,    8,2 },
	.db	0x31
	.db	0x3
	.dl	phys _biasReadV
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;1641   { 49, 4, VFPV(biasSetV),      BLUE, fmtF32,    8,2 },
	.db	0x31
	.db	0x4
	.dl	phys _biasSetV
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;1642   { 49, 5, VFPV(biasReadmA),    BLUE, fmtF32,    8,2 },
	.db	0x31
	.db	0x5
	.dl	phys _biasReadmA
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;1643 
;1644   { 49, 9, VFPV(sptrReadV),     BLUE, fmtF32,    8,2 },
	.db	0x31
	.db	0x9
	.dl	phys _sptrReadV
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;1645   { 49,10, VFPV(sptrSetV),      BLUE, fmtF32,    8,2 },
	.db	0x31
	.db	0xa
	.dl	phys _sptrSetV
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;1646   { 49,11, VFPV(sptrReadmA),    BLUE, fmtF32,    8,2 },
	.db	0x31
	.db	0xb
	.dl	phys _sptrReadmA
	.dw	@2+157
	.dw	word _fmtF32
	.dw	0x8
	.dw	0x2
;1647 
;1648   { 0,0, NULL, NULL, NULL, 0,0 }
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;1649 };
	.debug	G _dispElems 68 8
;1650 
;1651 //--- ATTR_NAME macros currently defined in fcntl.h ---
;1652 const DigDispElem far digInElems[] = {
;1653 //{ xx,yy,  BIT_MASK,          "0STR",ATTR_NAME,  "1STR",ATTR_NAME },
;1654   { 54,12,  SPTR_INTLK_OK,     "YES",RED,         " NO",BLUE   },
_digInElems::
	.db	0x36
	.db	0xc
	.dw	0, 0x1
	.dw	@2+123
	.dw	@2+159
	.dw	@2+114
	.dw	@2+157
;1655 //{ 19, 9,  RF_PS_HotShot,     "YES",BLUE,        " NO",RED    },
;1656 //{ 19,10,  RF_PS_NovaStar,    "YES" ,BLUE,       " NO",RED    },
;1657 //{ 17,12,  RF_PS_NOT_FAULT,   "FAULT",RED,       "   NO",BLUE },
;1658 //{ 19,13,  RF_PS_NOT_HEAT_ON, " ON",BLUE,        "OFF",RED    },
;1659 //{ 19,14,  RF_PS_NOT_READY,   "YES",BLUE,        " NO",RED    },
;1660 
;1661   { 0,0, 0, NULL,NULL, NULL,NULL }
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;1662 };
	.debug	G _digInElems 70 8
;1663 
;1664 const DigDispElem far digOutElems[] = {
;1665 //{ xx,yy,  BIT_MASK,      "0STR",ATTR_NAME,  "1STR",ATTR_NAME },
;1666 //{ 19,17,  RF_PS_RESET,   "YES",RED,     " NO",BLUE },
;1667 //{ 19,18,  RF_PS_STOP,    "YES",RED,     " NO",BLUE },
;1668 //{ 19,19,  RF_PS_START,   "YES",RED,     " NO",BLUE },
;1669   { 54, 6,  BIAS_PS_OFF,   " ON",BLUE,    "OFF",RED  },
_digOutElems::
	.db	0x36
	.db	0x6
	.dw	0x2000, 0
	.dw	@2+153
	.dw	@2+157
	.dw	@2+147
	.dw	@2+159
;1670   { 54,13,  SPTR_PS_OFF,   " ON",BLUE,    "OFF",RED  },
	.db	0x36
	.db	0xd
	.dw	0x4000, 0
	.dw	@2+153
	.dw	@2+157
	.dw	@2+147
	.dw	@2+159
;1671 //{ 47,19,  OVEN_OUT_OFF,  " ON",BLUE,    "OFF",RED  },
;1672 
;1673   { 0,0,  0,  NULL,NULL,  NULL,NULL }
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;1674 };
	.debug	G _digOutElems 72 8
;1675 
;1676 
;1677 //-------------------------------------------------------------------------
;1678 //  "state":  Show continuously updated state of the system
;1679 //-------------------------------------------------------------------------
;1680 void _task showState(int argc, char **argv)
;1681 {
	.seg	FARCODE
	.align	4
$$showState::
	ex	(sp),iy
$showState::
	.debug	G $showState 73 9
	.debug	{ $showState 73 1680 @261 @260
	ld	hl,-129
	call	__fent##
;1682   bool  blinkOff;
;1683   char  temp[128];
;1684 
;1685 
;1686   printf(clsCmd);  blinkOff = false;
	ld	hl,_clsCmd
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	xor	a,a
	ld	(ix-1),a
;1687 
;1688   CursorTo(0, 2);  printf(DevStateStr);
	ld	hl,0x1
	push	hl
	ld	l,0x3
	push	hl
	ld	de,word (phys @1+1677)
	ld	c,phys @1+1677 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	de,word (phys _DevStateStr)
	ld	c,phys _DevStateStr >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1689 
;1690   for (;;)  {
@264:
;1691     CursorTo(0, 0);  blinkOff = !blinkOff;
	ld	hl,0x1
	push	hl
	push	hl
	ld	de,word (phys @1+1677)
	ld	c,phys @1+1677 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	a,(ix-1)
	or	a,a
	ld	a,0
	jr	nz,@269
	inc	a
@269:
	ld	(ix-1),a
;1692 
;1693     stdHeader();  displayElems((DispElem far *)dispElems, blinkOff, temp);
	lcall	$stdHeader
	ld	hl,-129+@259
	add	hl,sp
	push	hl
	ld	a,(ix-1)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys _dispElems)
	ld	c,phys _dispElems >> 16
	push	bc
	push	de
	lcall	$displayElems
	add	sp,8
;1694 
;1695     biasReadmA = fmult(Next.biasReadA, 1000.0);
	ld	de,(_nextState+74)
	ld	bc,(_nextState+76)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x447a
	call	__fmlt##
	ld	(_biasReadmA),de
	ld	(_biasReadmA+2),bc
;1696     sptrReadmA = fmult(Next.sptrReadA, 1000.0);
	ld	de,(_nextState+82)
	ld	bc,(_nextState+84)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x447a
	call	__fmlt##
	ld	(_sptrReadmA),de
	ld	(_sptrReadmA+2),bc
;1697 
;1698     displayDigElems(digitalIn, (DigDispElem far *)digInElems, blinkOff, tem
	ld	hl,-129+@259
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _digInElems)
	ld	c,phys _digInElems >> 16
	push	bc
	push	de
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	push	bc
	push	de
	lcall	$displayDigElems
	add	sp,12
;1699     displayDigElems(digitalOut, (DigDispElem far *)digOutElems, blinkOff, t
	ld	hl,-129+@259
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _digOutElems)
	ld	c,phys _digOutElems >> 16
	push	bc
	push	de
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$displayDigElems
	add	sp,12
;1700 
;1701     CursorTo(0,22);  fflush(stdout);  CheckETX();  sleepMS(500);
	ld	hl,0x1
	push	hl
	ld	l,0x17
	push	hl
	ld	de,word (phys @1+1677)
	ld	c,phys @1+1677 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
	lcall	$CheckETX
	ld	de,0x1f4
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;1702   }
;1703 
;1704 }
	jp	@264
@260:
	.debug	} @260 1704

@259	equ	129
	ld	sp,ix
	pop	ix
	lret
@261	equ	131
;1705 
;1706 
;1707 //-------------------------------------------------------------------------
;1708 //  Application-specific commands
;1709 //-------------------------------------------------------------------------
;1710 #pragma warn -775
;1711 
;1712 void _task cmd(int argc, char **argv)
;1713 {
	.align	4
$$cmd::
	ex	(sp),iy
$cmd::
	.debug	G $cmd 73 9
	.debug	{ $cmd 73 1712 @272 @271
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-11
;1714   bool  validCmd;
;1715   int  i;
;1716   uint  idx;
;1717   char  *psName, *cmdStr;
;1718   float  *setV;
;1719 
;1720 
;1721 #define SetTrue(val)  { 
;1722   _EnterCritical_();  val = true;  _ExitCritical_();  
;1723   validCmd = true;  break; 
;1724 }
;1725 #define SetVal(val)  { 
;1726   KLOCK();  val = atof(argv[3]);  KUNLOCK();  
;1727   validCmd = true;  break; 
;1728 }
;1729 
;1730 
;1731   validCmd = false;
	xor	a,a
	ld	(ix-1),a
;1732 
;1733   do  {
;1734     if (argc < 3)  break;
	ld	hl,(ix+5)
	ld	de,0x8003
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@274
;1735 
;1736     psName = argv[1];  cmdStr = argv[2];
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	(ix-7),hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-9),hl
;1737 
;1738     if (StriEq(cmdStr, "set") AND (argc < 4))  break;
	ld	hl,@2+161
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@280
	ld	hl,(ix+5)
	ld	de,0x8004
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@274
;1739 /*
;1740     if (StriEq(psName, "rfgen"))   {
;1741       if (StriEq(cmdStr, "start"))  SetTrue(rfgenStartCmd);
;1742       if (StriEq(cmdStr, "stop"))   SetTrue(rfgenStopCmd);
;1743       if (StriEq(cmdStr, "reset"))  SetTrue(rfgenResetCmd);
;1744       if (StriEq(cmdStr, "set"))    SetVal(rfgenSetV);
;1745       if (StriEq(cmdStr, "send"))  if (argc > 3)  {
;1746         KLOCK();
;1747         *rfgenResp = 0;
;1748         strncpy(rfgenCmd, argv[3], sizeof(rfgenCmd)-1);
;1749         KUNLOCK();
;1750         for (i=0; i<20; ++i)  {
;1751           if (*rfgenResp)  { printf("[%.128s]\r\n", rfgenResp);  break; }
;1752           sleepMS(100);
;1753         }
;1754         validCmd = true;
;1755       }
;1756     }
;1757 */
;1758     if (StriEq(psName, "bias"))   {
@280:
	ld	hl,@2+165
	push	hl
	ld	hl,(ix-7)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@281
;1759       if (StriEq(cmdStr, "on"))     SetTrue(biasOnCmd);
	ld	hl,@2+170
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@284
	ipset	2
	ld	a,0x1
	ld	(_biasOnCmd),a
	jp	@879
@284:
;1760       if (StriEq(cmdStr, "off"))    SetTrue(biasOffCmd);
	ld	hl,@2+173
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@287
	ipset	2
	ld	a,0x1
	ld	(_biasOffCmd),a
	jp	@879
@287:
;1761       if (StriEq(cmdStr, "set"))    SetVal(biasSetV);
	ld	hl,@2+161
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@290
	call	_KLOCK
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	(_biasSetV),de
	ld	(_biasSetV+2),bc
	jp	@877
@290:
;1762     }
;1763 
;1764     if (StriEq(psName, "sptr"))   {
@281:
	ld	hl,@2+177
	push	hl
	ld	hl,(ix-7)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@293
;1765       if (StriEq(cmdStr, "on"))     SetTrue(sptrOnCmd);
	ld	hl,@2+170
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@296
	ipset	2
	ld	a,0x1
	ld	(_sptrOnCmd),a
	jp	@879
@296:
;1766       if (StriEq(cmdStr, "off"))    SetTrue(sptrOffCmd);
	ld	hl,@2+173
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@299
	ipset	2
	ld	a,0x1
	ld	(_sptrOffCmd),a
	jp	@879
@299:
;1767       if (StriEq(cmdStr, "set"))    SetVal(sptrSetV);
	ld	hl,@2+161
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@302
	call	_KLOCK
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	(_sptrSetV),de
	ld	(_sptrSetV+2),bc
	jp	@877
@302:
;1768     }
;1769 
;1770     if (StriEq(psName, "oven1") OR StriEq(psName, "oven2"))   {
@293:
	ld	hl,@2+182
	push	hl
	ld	hl,(ix-7)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	z,@305
	ld	hl,@2+188
	push	hl
	ld	hl,(ix-7)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jp	nz,@306
@305:
;1771       idx = (uint)psName[4] - '1';
	ld	hl,(ix-7)
	ld	de,0x4
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	de,0xffcf
	add	hl,de
	ld	(ix-5),hl
;1772       setV = (idx ? &oven2SetV : &oven1SetV);
	bool	hl
	jr	z,@309
	ld	hl,_oven2SetV
	jr	@310
@309:
	ld	hl,_oven1SetV
@310:
	ld	(ix-11),hl
;1773       if (StriEq(cmdStr, "on"))     SetTrue(ovenOnCmd[idx]);
	ld	hl,@2+170
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@311
	ipset	2
	ld	hl,(ix-5)
	ld	de,_ovenOnCmd
	jr	@878
@311:
;1774       if (StriEq(cmdStr, "off"))    SetTrue(ovenOffCmd[idx]);
	ld	hl,@2+173
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@314
	ipset	2
	ld	hl,(ix-5)
	ld	de,_ovenOffCmd
	jr	@878
@314:
;1775       if (StriEq(cmdStr, "reset"))  SetTrue(ovenResetCmd[idx]);
	ld	hl,@2+194
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@317
	ipset	2
	ld	hl,(ix-5)
	ld	de,_ovenResetCmd
@878:
	add	hl,de
	ld	a,0x1
	ld	(hl),a
@879:
	ipres
	jr	@876
@317:
;1776       if (StriEq(cmdStr, "set"))    SetVal(*setV);
	ld	hl,@2+161
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@320
	call	_KLOCK
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,(ix-11)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@877:
	call	_KUNLOCK
	ld	a,0x1
@876:
	ld	(ix-1),a
	jp	@274
@320:
;1777       if (StriEq(cmdStr, "send"))  if (argc > 3)  {
	ld	hl,@2+200
	push	hl
	ld	hl,(ix-9)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jp	nz,@323
	ld	hl,(ix+5)
	ld	de,0x8003
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@324
	jp	z,@324
;1778         KLOCK();
	call	_KLOCK
;1779         *ovenResp[idx] = 0;
	ld	hl,(ix-5)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_ovenResp
	add	hl,de
	xor	a,a
	ld	(hl),a
;1780         strncpy(ovenCmd[idx], argv[3], sizeof(ovenCmd[idx])-1);
	ld	hl,0x1f
	push	hl
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-5)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_ovenCmd
	add	hl,de
	push	hl
	call	_strncpy
	add	sp,6
;1781         KUNLOCK();
	call	_KUNLOCK
;1782         for (i=0; i<20; ++i)  {
	bool	hl
	ld	l,h
	ld	(ix-3),hl
@329:
	ld	hl,(ix-3)
	ld	de,0x8014
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@330
;1783           if (*ovenResp[idx])  {
	ld	hl,(ix-5)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_ovenResp
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@334
;1784             printf("[%.128s]\r\n", ovenResp[idx]);  break; }
	ld	hl,(ix-5)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,de
	push	hl
	ld	de,word (phys @1+1690)
	ld	c,phys @1+1690 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	jr	@330
;1785           sleepMS(100);
@334:
	ld	de,0x64
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;1786         }
;1787         validCmd = true;
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	jr	@329
@330:
	ld	(ix-1),0x1
;1788       }
;1789     }
@324:
@323:
;1790 
;1791   }  while(0);
@306:
;1792 
;1793   if (! validCmd)  {
@274:
	ld	a,(ix-1)
	or	a,a
	jr	nz,@337
;1794     printf("\r\n"
;1795            "Usage:  cmd bias|sptr| on|off|set #\r\n"
;1796            "            oven1 on|off|reset|set #|send <str>\r\n"
;1797            "            oven2 on|off|reset|set #|send <str>\r\n"
;1798 //           "            rfgen start|stop|reset|set #\r\n"
;1799 //           "            rfgen|oven send <str>\r\n"
;1800           );
	ld	de,word (phys @1+1701)
	ld	c,phys @1+1701 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1801     Exit(-1);
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;1802   }
;1803 
;1804   Exit(0);
@337:
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;1805 }
@271:
	.debug	} @271 1805

@270	equ	11
	ld	sp,ix
	pop	ix
	lret
@272	equ	13
;1806 
;1807 #pragma warn 775
;1808 
;1809 //=========================================================================
;1810 //  Event-Handler functions called by the appl task to process event messag
;1811 //=========================================================================
;1812 //APPLCODE
;1813 
;1814 //-------------------------------------------------------------------------
;1815 //  Event-Handler for a request to ...
;1816 //-------------------------------------------------------------------------
;1817 /*
;1818 void EVENT_MyEvent(EventMsg *event)
;1819 {
;1820   uint  idx;
;1821   float  setpoint;
;1822   char  temp[16];
;1823 
;1824 
;1825   idx = event->chanNum;
;1826 
;1827   if (error)  {
;1828     fprintf(DiagLog, "error msg, chan:\n", idx+1);
;1829     return;
;1830   }
;1831 
;1832   setpoint = *((float *)event->data);
;1833 
;1834   fprintf(DiagLog, "New SetPoint for PS%d: %s\n",
;1835      idx+1, fmtFloat(setpoint, 8,3, temp) );
;1836 
;1837   *((float *)((&iSet_1_RegInfo + idx)->regVal)) = setpoint;
;1838 
;1839   anaOut[idx] = ISETtoVolts(idx, setpoint);
;1840 }
;1841 */
;1842 
;1843 
;1844 //=========================================================================
;1845 //  Update the the state of the application logic in well-defined phases
;1846 //=========================================================================
;1847 // IMPORTANT NOTES and RULES:
;1848 //
;1849 //  - The code to change ANY value must be in ONE place.  NEVER spread the
;1850 //    logic for updating a single value around.  There should be ONE place
;1851 //    to look to see how a value gets set.
;1852 //
;1853 //  - "Cur" values are basically "inputs" - literally (they are set based
;1854 //    on the just-read state of a digital or analog input) and/or figurativ
;1855 //    (they hold a value set by some external source, such as a cmd from a
;1856 //    remote client or another user-interface task).
;1857 //
;1858 //  - "Next" values are basically "outputs" - literally (they determine the
;1859 //    next state of a digital or analog output) and/or figuratively (they
;1860 //    can affect the state of the logic for the next pass).
;1861 //
;1862 //  - The "Cur" OR the "Next" instance of a value may be changed - NEVER
;1863 //    both of them (with the exception of the first step below that copies
;1864 //    all of cur to prev and next to cur).
;1865 //
;1866 //  - A value MUST be in the ApplState struct if one of the following appli
;1867 //     - The application logic is dependent on if or how much the value has
;1868 //       changed between passes.
;1869 //     - The value is used as both input (used in in a conditional and/or i
;1870 //       an expression that can affect the result of an assignment) and out
;1871 //       (the target of an assignment).
;1872 //
;1873 //  - Variables that are NOT in the ApplState struct but are USED (in
;1874 //    conditionals or other expressions) by the application logic must be
;1875 //    treated just like "Cur" values.  Variables SET (the target in an
;1876 //    assignment statement) by the application logic must be treated just
;1877 //    like "Next" values.
;1878 //
;1879 //  - When the logic requires comparing an "input" to a related "output", b
;1880 //    sure to use the "Cur" value for the "input", and the "Prev" value for
;1881 //    the "output".
;1882 //
;1883 //    This is because during the processing of the loop, the "Cur" values
;1884 //    represent the input values just read (what they are "now") and the
;1885 //    "Prev" values represent the values the outputs were set to at the
;1886 //    beginning of the prev pass (i.e. they are the values that "caused"
;1887 //    the inputs to have their "Cur" values).
;1888 //
;1889 //    During a pass the output values in "Cur" represent what the outputs
;1890 //    where set to AFTER the "Cur" inputs were updated, so comparing them
;1891 //    makes no sense.  Doing so is the equivalent of comparing a past respo
;1892 //    to a condition that didn't exist at the time.
;1893 //=========================================================================
;1894 
;1895 
;1896 //=========================================================================
;1897 //  Definitions for functions that handle setting "Next" values that serve
;1898 //  as inputs to the application control logic (run by the "applic" task in
;1899 //  a periodically executed loop).
;1900 //
;1901 //  While care must be taken in these functions to use locks to avoid the
;1902 //  possibility of being preempted in the middle of an operation, such lock
;1903 //  must be kept to as short a time as possible to avoid excessive latency
;1904 //  in the main control loop.
;1905 //
;1906 //  For REALLY short locks, using a critical section is best, because this
;1907 //  has the least overhead (but it has to be REALLY short to avoid causing
;1908 //  problems for interrupt handlers).
;1909 //
;1910 //  For longer locks (ones that involve anything but the most trivial
;1911 //  conditional logic), use either KLOCK() and KUNLOCK() (which disable the
;1912 //  scheduler) or a more specific global semaphore/mutex lock.
;1913 //=========================================================================
;1914 
;1915 /*Examples
;1916 //-------------------------------------------------------------------------
;1917 void onCmd(void)
;1918 {
;1919   _EnterCritical_();
;1920   Next.onCmd = true;  Next.offCmd = false;
;1921   _ExitCritical_();
;1922 
;1923   fprintf(DiagLog, "ON Cmd\n");
;1924 }
;1925 
;1926 //-------------------------------------------------------------------------
;1927 void offCmd(void)
;1928 {
;1929   _EnterCritical_();
;1930   Next.offCmd = true;  Next.onCmd = false;
;1931   _ExitCritical_();
;1932 
;1933   fprintf(DiagLog, "OFF Cmd\n");
;1934 }
;1935 
;1936 //-------------------------------------------------------------------------
;1937 void resetCmd(void)
;1938 {
;1939   _EnterCritical_();  Next.resetCmd = true;  _ExitCritical_();
;1940 
;1941   fprintf(DiagLog, "RESET Cmd\n");
;1942 }
;1943 
;1944 //-------------------------------------------------------------------------
;1945 void newSetpoint(float newAmps)
;1946 {
;1947   char  temp[16];
;1948 
;1949 
;1950   KLOCK();
;1951 
;1952   if (FABS(newAmps) > maxAmpSet)  newAmps = (float)SIGN(newAmps) * maxAmpSe
;1953 
;1954   Next.ampSet = newAmps;
;1955 
;1956   KUNLOCK();
;1957 
;1958   fprintf(DiagLog, "New Setpoint: %s\n", fmtFloat(newAmps, 10,3, temp) );
;1959 }
;1960 
;1961 //-------------------------------------------------------------------------
;1962 */
;1963 
;1964 
;1965 
;1966 //-------------------------------------------------------------------------
;1967 //  Check the range of a new setVal[] value
;1968 //-------------------------------------------------------------------------
;1969 void checkSetValRange(float *regVal, float *applVal, uint dacIdx)
;1970 {
$checkSetValRange::
	.debug	G $checkSetValRange 74 9
	.debug	{ $checkSetValRange 74 1969 @342 @341
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
;1971   float  min, max;
;1972 
;1973 
;1974   if (dacIdx >= NumHdwDAC)  return;
	ld	hl,(ix+9)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jp	nc,@341
;1975 
;1976   min = setValMin[dacIdx];  if (*regVal < min)  *regVal = min;
	ld	hl,(ix+9)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _setValMin)
	ld	c,phys _setValMin >> 16
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fsub##
	jp	p,@344
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1977 
;1978   max = setValMax[dacIdx];  if (*regVal > max)  *regVal = max;
@344:
	ld	hl,(ix+9)
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _setValMax)
	ld	c,phys _setValMax >> 16
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fsub##
	jp	m,@345
	jr	z,@345
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1979 
;1980   *applVal = *regVal;
@345:
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1981 }
@341:
	.debug	} @341 1981

@340	equ	8
	ld	sp,ix
	pop	ix
	lret
@342	equ	10
;1982 
;1983 
;1984 //-------------------------------------------------------------------------
;1985 //  Check for read/set difference exceeding thresholds
;1986 //-------------------------------------------------------------------------
;1987 void checkThresholds(char *name, ulong *readErrStartTime,
;1988                      bool *runtimeErr, bool prevRuntimeErr,
;1989                      float maxErrV, ulong maxErrMS,
;1990                      float setV, float readV, float readA)
;1991 {
$checkThresholds::
	.debug	G $checkThresholds 75 9
	.debug	{ $checkThresholds 75 1987 @348 @347
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-52
;1992   float  err;
;1993   char  temp[48];
;1994 
;1995 
;1996   if (!maxErrMS)  return;
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	or	hl,de
	jp	z,@347
;1997 
;1998   err = setV - readV;
	ld	hl,(ix+21)
	ex	de,hl
	ld	hl,(ix+23)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+25)
	ex	de,hl
	ld	hl,(ix+27)
	ld	bc,hl
	call	__fsub##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1999   if (FABS(err) <= maxErrV)  {
	push	bc
	push	de
	call	_fabs
	add	sp,4
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	ld	hl,(ix+15)
	ld	bc,hl
	call	__fsub##
	jr	z,@351
	jp	p,@350
@351:
;2000     *readErrStartTime = 0;  *runtimeErr = false;  }
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	xor	a,a
	ld	hl,(ix+9)
	ld	(hl),a
;2001   else  {
	jp	@354
@350:
;2002     if (!*readErrStartTime)  *readErrStartTime = GetMS();
	ld	hl,(ix+7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jp	nz,@357
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2003     if (msSince(*readErrStartTime) > maxErrMS)  *runtimeErr = true;
@357:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix+7)
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	push	bc
	push	de
	ld	hl,(ix+17)
	ex	de,hl
	ld	hl,(ix+19)
	ld	bc,hl
	call	__lsub##
	jr	c,@358
	jr	z,@358
	ld	hl,(ix+9)
	ld	(hl),0x1
;2004   }
@358:
;2005 
;2006   if (*runtimeErr == prevRuntimeErr)  return;
@354:
	ld	hl,(ix+9)
	ld	a,(hl)
	ld	hl,(ix+11)
	sub	a,l
	jr	z,@347
;2007 
;2008   if (*runtimeErr)
	ld	hl,(ix+9)
	ld	a,(hl)
	or	a,a
	jr	z,@360
;2009     printf("%s Set/Read error exceeded thresholds:\r\n"
;2010            "  Analog:  Volts: %.16s  SetV: %.16s  Amps: %.16s\r\n",
;2011                   name, Engineering(readV, 6, temp),
;2012                   Engineering(setV, 6, temp+16),
;2013                   Engineering(readA, 6, temp+32)
;2014           );
	ld	hl,-20+@346
	add	hl,sp
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix+29)
	ex	de,hl
	ld	hl,(ix+31)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,-34+@346
	add	hl,sp
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix+21)
	ex	de,hl
	ld	hl,(ix+23)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,-48+@346
	add	hl,sp
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix+25)
	ex	de,hl
	ld	hl,(ix+27)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @1+1839)
	ld	c,phys @1+1839 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;2015   else
;2016     printf("%s Set/Read error now within thresholds\r\n", name);
	jr	@361
@360:
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @1+1931)
	ld	c,phys @1+1931 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2017 }
@361:
@347:
	.debug	} @347 2017

@346	equ	52
	ld	sp,ix
	pop	ix
	lret
@348	equ	54
;2018 
;2019 
;2020 //=========================================================================
;2021 //  Update the "Cur"rent state of the controller
;2022 //=========================================================================
;2023 //
;2024 //  Just before this function is called, readings were taken of the current
;2025 //  state of the hardware, and any changes to the output states specified b
;2026 //  the last pass were applied (just after taking the readings).  These val
;2027 //  are copied to Next as needed and constitute the Hardware Inputs.
;2028 //
;2029 //  Other tasks can affect the state of the control logic by changing value
;2030 //  in Next as well.  These values constitute Software Inputs.
;2031 //
;2032 //  This function is responsible for the Asynchronous logic that is applied
;2033 //  each pass.  It updates values in Next (or other global variables) based
;2034 //  on the Software and Hardware Input values in Next.  This portion of the
;2035 //  logic is analogous to unclocked gates in an electronic circuit.
;2036 //
;2037 //  After the Asychronous logic is applied, we set Prev = Cur and Cur = Nex
;2038 //  The result is that Prev contains the controller state as it was during 
;2039 //  previous pass, and Cur indicates the current state of the controller.
;2040 //
;2041 //=========================================================================
;2042 void updateCurState(void)
;2043 {
$updateCurState::
	.debug	G $updateCurState 61 9
	.debug	{ $updateCurState 61 2042 @364 @363
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;2044   uint  idx;
;2045 
;2046 
;2047   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@363
;2048 
;2049 //-----------------------------------------------------------------
;2050 // The following conditions exist at this point:
;2051 // - The analog and digital hardware inputs have just been read
;2052 // - The outputs were just set to values computed during the last pass
;2053 // - "Cur" contains the state the inputs were in at the START of
;2054 //   of the previous pass, and the state the outputs were in DURING
;2055 //   the previous pass
;2056 // - "Next" contains the values that the outputs were just set
;2057 //   to and any "input" values that were changed by other tasks
;2058 //------------------------------------------------------------------
;2059 
;2060 // Now we update the values in "Next" that are based solely on the
;2061 // state of the hardware inputs we just read and values maintained by
;2062 // by other tasks (basically, we deal with READINGS here: Values that
;2063 // we need but are not written to "Next" by another task)
;2064 
;2065   Next.digitalIn = digitalIn;
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState+16),de
	ld	(_nextState+18),bc
;2066 
;2067 //APPLCODE
;2068 
;2069   Next.sptrInterlock = !(digitalIn & SPTR_INTLK_OK);
	push	bc
	push	de
	ld	de,0
	ld	bc,0x1
	call	__land##
	ld	hl,bc
	or	hl,de
	ld	de,0
	jr	nz,@366
	inc	e
@366:
	ld	a,e
	ld	(_nextState+98),a
;2070 
;2071 //  if (!(digitalIn & RF_PS_HotShot))
;2072 //    Next.rfSupplyType = RF_TYPE_HotShot;   else
;2073 //  if (!(digitalIn & RF_PS_NovaStar))
;2074 //    Next.rfSupplyType = RF_TYPE_NovaStar;
;2075 //  else
;2076 //    Next.rfSupplyType = RF_TYPE_UNKNOWN;
;2077 
;2078 //  Next.rfgenReadV = rfgenReadV;
;2079 //  Next.rfgenReadA = rfgenReadA;
;2080 //  Next.rfgenReadW = rfgenReadW;
;2081 
;2082 //  Next.rfgenFault =  !(digitalIn & RF_PS_NOT_FAULT);
;2083 //  Next.rfgenHeatOn = !(digitalIn & RF_PS_NOT_HEAT_ON);
;2084 //  Next.rfgenReady =  !(digitalIn & RF_PS_NOT_READY);
;2085 
;2086   ovenRespAge[0] = msSince(ovenLastRespTime[0]);
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_ovenLastRespTime)
	ld	bc,(_ovenLastRespTime+2)
	call	__lsub##
	ld	(_ovenRespAge),de
	ld	(_ovenRespAge+2),bc
;2087   ovenRespAge[1] = msSince(ovenLastRespTime[1]);
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_ovenLastRespTime+4)
	ld	bc,(_ovenLastRespTime+6)
	call	__lsub##
	ld	(_ovenRespAge+4),de
	ld	(_ovenRespAge+6),bc
;2088 
;2089   Next.ovenInactive[0] = (ovenRespAge[0] > 3000);
	ld	de,(_ovenRespAge)
	ld	bc,(_ovenRespAge+2)
	push	bc
	push	de
	ld	de,0xbb8
	ld	bc,0
	call	__lsub##
	ld	de,0
	jr	c,@367
	jr	z,@367
	inc	e
@367:
	ld	a,e
	ld	(_nextState+20),a
;2090   Next.ovenInactive[1] = (ovenRespAge[1] > 3000);
	ld	de,(_ovenRespAge+4)
	ld	bc,(_ovenRespAge+6)
	push	bc
	push	de
	ld	de,0xbb8
	ld	bc,0
	call	__lsub##
	ld	de,0
	jr	c,@368
	jr	z,@368
	inc	e
@368:
	ld	a,e
	ld	(_nextState+21),a
;2091 //  Next.rfgenInactive = (msSince(rfgenLastRespTime) > 3000);
;2092 
;2093   Next.ovenReadV[0] = readVal[OVEN1_READ_V];
	ld	de,(_readVal)
	ld	bc,(_readVal+2)
	ld	(_nextState+26),de
	ld	(_nextState+28),bc
;2094   Next.ovenReadA[0] = readVal[OVEN1_READ_A];
	ld	de,(_readVal+20)
	ld	bc,(_readVal+22)
	ld	(_nextState+42),de
	ld	(_nextState+44),bc
;2095 
;2096   Next.ovenReadV[1] = readVal[OVEN2_READ_V];
	ld	de,(_readVal+24)
	ld	bc,(_readVal+26)
	ld	(_nextState+30),de
	ld	(_nextState+32),bc
;2097   Next.ovenReadA[1] = readVal[OVEN2_READ_A];
	ld	de,(_readVal+28)
	ld	bc,(_readVal+30)
	ld	(_nextState+46),de
	ld	(_nextState+48),bc
;2098 
;2099   Next.biasReadV = readVal[BIAS_READ_V];
	ld	de,(_readVal+4)
	ld	bc,(_readVal+6)
	ld	(_nextState+70),de
	ld	(_nextState+72),bc
;2100   Next.biasReadA = readVal[BIAS_READ_A];
	ld	de,(_readVal+16)
	ld	bc,(_readVal+18)
	ld	(_nextState+74),de
	ld	(_nextState+76),bc
;2101 
;2102   Next.sptrReadV = readVal[SPTR_READ_V];
	ld	de,(_readVal+8)
	ld	bc,(_readVal+10)
	ld	(_nextState+78),de
	ld	(_nextState+80),bc
;2103   Next.sptrReadA = readVal[SPTR_READ_A];
	ld	de,(_readVal+12)
	ld	bc,(_readVal+14)
	ld	(_nextState+82),de
	ld	(_nextState+84),bc
;2104 
;2105   Next.biasSetV = biasSetV;
	ld	de,(_biasSetV)
	ld	bc,(_biasSetV+2)
	ld	(_nextState+8),de
	ld	(_nextState+10),bc
;2106   Next.sptrSetV = sptrSetV;
	ld	de,(_sptrSetV)
	ld	bc,(_sptrSetV+2)
	ld	(_nextState+12),de
	ld	(_nextState+14),bc
;2107 //  Next.rfgenSetV = rfgenSetV;
;2108 
;2109 
;2110 //--- apply range limits to new settings ---
;2111   checkSetValRange(&oven1SetV,  &Next.ovenSetV[0],  OVEN1_SET_V);
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_nextState
	push	hl
	ld	hl,_oven1SetV
	push	hl
	lcall	$checkSetValRange
	add	sp,6
;2112   checkSetValRange(&oven2SetV,  &Next.ovenSetV[1],  OVEN2_SET_V);
	ld	hl,0x3
	push	hl
	ld	hl,_nextState+4
	push	hl
	ld	hl,_oven2SetV
	push	hl
	lcall	$checkSetValRange
	add	sp,6
;2113   checkSetValRange(&biasSetV,  &Next.biasSetV,  BIAS_SET_V);
	ld	hl,0x1
	push	hl
	ld	hl,_nextState+8
	push	hl
	ld	hl,_biasSetV
	push	hl
	lcall	$checkSetValRange
	add	sp,6
;2114   checkSetValRange(&sptrSetV,  &Next.sptrSetV,  SPTR_SET_V);
	ld	hl,0x2
	push	hl
	ld	hl,_nextState+12
	push	hl
	ld	hl,_sptrSetV
	push	hl
	lcall	$checkSetValRange
	add	sp,6
;2115 //  checkSetValRange(&rfgenSetV, &Next.rfgenSetV, RFGEN_SET_V);
;2116 
;2117 
;2118 #define CheckThresholds(name, prefix)  
;2119   checkThresholds(name, 
;2120                   &prefix##ReadErrStartTime,  
;2121                   &Next.prefix##RuntimeErr, 
;2122                   Cur.prefix##RuntimeErr,  
;2123                   prefix##MaxErrV, 
;2124                   prefix##MaxErrMS,  
;2125                   Cur.prefix##SetVassert, 
;2126                   Next.prefix##ReadV, 
;2127                   Next.prefix##ReadA)
;2128 
;2129 #define CheckOvenThresholds(name, prefix, idx)  
;2130   checkThresholds(name, 
;2131                   &ovenReadErrStartTime[idx],  
;2132                   &Next.ovenRuntimeErr[idx], 
;2133                   Cur.ovenRuntimeErr[idx],  
;2134                   prefix##MaxErrV, 
;2135                   prefix##MaxErrMS,  
;2136                   Cur.ovenSetVassert[idx], 
;2137                   Next.ovenReadV[idx], 
;2138                   Next.ovenReadA[idx])
;2139 
;2140 //--- check set/read error against allowed thresholds ---
;2141 //--- (these checks are very time consuming at present) ---
;2142   CheckOvenThresholds("Oven1", oven1, 0);
	ld	de,(_nextState+42)
	ld	bc,(_nextState+44)
	push	bc
	push	de
	ld	de,(_nextState+26)
	ld	bc,(_nextState+28)
	push	bc
	push	de
	ld	de,(_curState+107)
	ld	bc,(_curState+109)
	push	bc
	push	de
	ld	de,(_oven1MaxErrMS)
	ld	bc,(_oven1MaxErrMS+2)
	push	bc
	push	de
	ld	de,(_oven1MaxErrV)
	ld	bc,(_oven1MaxErrV+2)
	push	bc
	push	de
	ld	a,(_curState+22)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,_nextState+22
	push	hl
	ld	hl,_ovenReadErrStartTime
	push	hl
	ld	hl,@2+205
	push	hl
	lcall	$checkThresholds
	add	sp,28
;2143   CheckOvenThresholds("Oven2", oven2, 1);
	ld	de,(_nextState+46)
	ld	bc,(_nextState+48)
	push	bc
	push	de
	ld	de,(_nextState+30)
	ld	bc,(_nextState+32)
	push	bc
	push	de
	ld	de,(_curState+111)
	ld	bc,(_curState+113)
	push	bc
	push	de
	ld	de,(_oven2MaxErrMS)
	ld	bc,(_oven2MaxErrMS+2)
	push	bc
	push	de
	ld	de,(_oven2MaxErrV)
	ld	bc,(_oven2MaxErrV+2)
	push	bc
	push	de
	ld	a,(_curState+23)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,_nextState+23
	push	hl
	ld	hl,_ovenReadErrStartTime+4
	push	hl
	ld	hl,@2+211
	push	hl
	lcall	$checkThresholds
	add	sp,28
;2144   CheckThresholds("Bias", bias);
	ld	de,(_nextState+74)
	ld	bc,(_nextState+76)
	push	bc
	push	de
	ld	de,(_nextState+70)
	ld	bc,(_nextState+72)
	push	bc
	push	de
	ld	de,(_curState+132)
	ld	bc,(_curState+134)
	push	bc
	push	de
	ld	de,(_biasMaxErrMS)
	ld	bc,(_biasMaxErrMS+2)
	push	bc
	push	de
	ld	de,(_biasMaxErrV)
	ld	bc,(_biasMaxErrV+2)
	push	bc
	push	de
	ld	a,(_curState+24)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,_nextState+24
	push	hl
	ld	hl,_biasReadErrStartTime
	push	hl
	ld	hl,@2+217
	push	hl
	lcall	$checkThresholds
	add	sp,28
;2145   CheckThresholds("Sputter", sptr);
	ld	de,(_nextState+82)
	ld	bc,(_nextState+84)
	push	bc
	push	de
	ld	de,(_nextState+78)
	ld	bc,(_nextState+80)
	push	bc
	push	de
	ld	de,(_curState+137)
	ld	bc,(_curState+139)
	push	bc
	push	de
	ld	de,(_sptrMaxErrMS)
	ld	bc,(_sptrMaxErrMS+2)
	push	bc
	push	de
	ld	de,(_sptrMaxErrV)
	ld	bc,(_sptrMaxErrV+2)
	push	bc
	push	de
	ld	a,(_curState+25)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,_nextState+25
	push	hl
	ld	hl,_sptrReadErrStartTime
	push	hl
	ld	hl,@2+222
	push	hl
	lcall	$checkThresholds
	add	sp,28
;2146 
;2147 
;2148 // Next we do the asynchronous/gate-level type logic.  This logic often has
;2149 // order of execution dependencies so be careful!
;2150 
;2151 //--- oven1PowerOnTime ---
;2152   if (digitalOut & OVEN1_PS_OFF)
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	ld	de,0x1000
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@369
;2153     ovenPowerOnTime[0] = 0;
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_ovenPowerOnTime),de
	ld	(_ovenPowerOnTime+2),bc
;2154   else
;2155     if (!ovenPowerOnTime[0])  ovenPowerOnTime[0] = GetMS();
	jp	@370
@369:
	ld	de,(_ovenPowerOnTime)
	ld	bc,(_ovenPowerOnTime+2)
	ld	hl,bc
	or	hl,de
	jp	nz,@371
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_ovenPowerOnTime),de
	ld	(_ovenPowerOnTime+2),bc
;2156 //--- oven2PowerOnTime ---
;2157   if (digitalOut & OVEN2_PS_OFF)
@371:
@370:
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@372
;2158     ovenPowerOnTime[1] = 0;
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_ovenPowerOnTime+4),de
	ld	(_ovenPowerOnTime+6),bc
;2159   else
;2160     if (!ovenPowerOnTime[1])  ovenPowerOnTime[1] = GetMS();
	jp	@373
@372:
	ld	de,(_ovenPowerOnTime+4)
	ld	bc,(_ovenPowerOnTime+6)
	ld	hl,bc
	or	hl,de
	jp	nz,@374
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_ovenPowerOnTime+4),de
	ld	(_ovenPowerOnTime+6),bc
;2161 
;2162   for (idx=0; idx<2; ++idx)  {
@374:
@373:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@377:
	ld	hl,(ix-2)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nc,@378
;2163   //--- Next.ovenModeOn[] ---
;2164     if (Next.ovenOutErrInterlock[idx])  {
	ld	hl,(ix-2)
	ld	de,_nextState+88
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@382
;2165       Next.ovenModeOn[idx] = false;
	ld	hl,(ix-2)
	ld	de,_nextState+86
	add	hl,de
	xor	a,a
	ld	(hl),a
;2166       if (ovenOnCmd[idx])
	ld	hl,(ix-2)
	ld	de,_ovenOnCmd
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@386
;2167         printf("Oven%d ON cmd ignored while Interlock exists\n", idx+1);
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+1973)
	ld	c,phys @1+1973 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2168     }
;2169     else  {
	jr	@386
@382:
;2170       if (ovenOnCmd[idx])  Next.ovenModeOn[idx] = true;
	ld	hl,(ix-2)
	ld	de,_ovenOnCmd
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@389
	ld	hl,(ix-2)
	ld	de,_nextState+86
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;2171       if (ovenOffCmd[idx])  Next.ovenModeOn[idx] = false;
@389:
	ld	hl,(ix-2)
	ld	de,_ovenOffCmd
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@390
	ld	hl,(ix-2)
	ld	de,_nextState+86
	add	hl,de
	xor	a,a
	ld	(hl),a
;2172     }
@390:
;2173   //--- ovenOffCmdTime[] ---
;2174     if (ovenOnCmd[idx])  ovenOffCmdTime[idx] = 0;
@386:
	ld	hl,(ix-2)
	ld	de,_ovenOnCmd
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@391
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_ovenOffCmdTime
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2175     if (ovenOffCmd[idx])
@391:
	ld	hl,(ix-2)
	ld	de,_ovenOffCmd
	add	hl,de
	ld	a,(hl)
	or	a,a
	jp	z,@392
;2176       if (!ovenOffCmdTime[idx])  ovenOffCmdTime[idx] = GetMS();
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_ovenOffCmdTime
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jp	nz,@393
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_ovenOffCmdTime
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2177   }
@393:
@392:
;2178 
;2179 
;2180 
;2181 
;2182 
;2183 // Next we make a copy of the application state before we apply all the
;2184 // logic that updates the overall state.  This allows us to have a copy of
;2185 // all the relevant values that remain unchanged during the processing,
;2186 // avoiding all kinds of order-of-execution dependencies.
;2187 
;2188 // We also make a copy of the state from last time before overwriting it
;2189 // so we can see if/how values have changed since the last pass
;2190 
;2191 // Note that a copy is done (rather than just switching pointer values) to
;2192 // insure all values are set in both the source and destination.  If we
;2193 // simply kept pointers and swapped the pointer values, then EVERY value
;2194 // would have to be updated independently by the code, which is a pain to
;2195 // program, adds overhead and code, and is a VERY easy way to introduce odd
;2196 // bugs.  Overall, copying everything here is actually faster overall,
;2197 // simpler, and much safer.
;2198 
;2199   Prev = Cur;  Cur = Next;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@377
@378:
	ld	hl,_curState
	ld	de,_prevState
	push	hl
	ld	bc,141
	ldir
	pop	hl
	ld	hl,_nextState
	ld	de,_curState
	push	hl
	ld	bc,141
	ldir
	pop	hl
;2200 
;2201 //--- At this point the Cur copy contains what the inputs were at the start
;2202 //--- of this pass, and the Prev copy contains the output values from the -
;2203 //--- the previous pass (i.e. the output values that resulted in the input 
;2204 //--- values in Cur) ---
;2205 
;2206 
;2207 //--- log msgs for bit chgs only if not starving other processes for cycles
;2208   /* if (applLoopTime < 15) */  logDigIOChgs(false);
	bool	hl
	ld	l,h
	push	hl
	lcall	$logDigIOChgs
	pop	hl
;2209 
;2210 //  if (Cur.rfgenInactive != Prev.rfgenInactive)
;2211 //    printf("RF Gen PS %s responding\n",
;2212 //           Cur.rfgenInactive ? "NOT" : "started");
;2213 
;2214   for (idx=0; idx<2; ++idx)  {
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@396:
	ld	hl,(ix-2)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nc,@397
;2215     if (Cur.ovenInactive[idx] != Prev.ovenInactive[idx])
	ld	hl,(ix-2)
	ld	de,_curState+20
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,hl
	ld	hl,_prevState+20
	add	hl,de
	ld	a,(hl)
	ld	de,bc
	ex	de,hl
	ld	l,(hl)
	sub	a,l
	jr	z,@401
;2216       printf("Oven%d PS %s responding\n",
;2217              idx+1, Cur.ovenInactive[idx] ? "NOT" : "started");
	ld	hl,(ix-2)
	ld	de,_curState+20
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@402
	ld	hl,@2+230
	jr	@403
@402:
	ld	hl,@2+234
@403:
	push	hl
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+2019)
	ld	c,phys @1+2019 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;2218     if (ovenOnCmd[idx])  {
@401:
	ld	hl,(ix-2)
	ld	de,_ovenOnCmd
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@405
;2219       printf("Oven%d PS ON request\n", idx+1);
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+2044)
	ld	c,phys @1+2044 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2220       if (Cur.enableOvenOutput[idx])  printf("Oven%d PS already ON\n", idx+
	ld	hl,(ix-2)
	ld	de,_curState+105
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@408
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+2066)
	ld	c,phys @1+2066 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2221     }
@408:
;2222     if (ovenOffCmd[idx])  {
@405:
	ld	hl,(ix-2)
	ld	de,_ovenOffCmd
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@409
;2223       printf("Oven%d PS OFF request\n", idx+1);
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+2088)
	ld	c,phys @1+2088 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2224       if (!Cur.enableOvenOutput[idx])  printf("Oven%d PS already OFF\n", id
	ld	hl,(ix-2)
	ld	de,_curState+105
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@412
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+2111)
	ld	c,phys @1+2111 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2225     }
@412:
;2226     if (ovenResetCmd[idx])  printf("Oven%d PS RESET request\n", idx+1);
@409:
	ld	hl,(ix-2)
	ld	de,_ovenResetCmd
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@413
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+2134)
	ld	c,phys @1+2134 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2227   }
@413:
;2228 
;2229 //  if (rfgenStartCmd)  {
;2230 //    printf("Start RF Gen PS request\n");
;2231 //    if (Cur.rfgenReady)  printf("RF Gen PS already ON\n");
;2232 //  }
;2233 //  if (rfgenStopCmd)  {
;2234 //    printf("Stop RF Gen PS request\n");
;2235 //    if (!Cur.rfgenHeatOn AND !Cur.rfgenReady)
;2236 //      printf("RF Gen PS already OFF\n");
;2237 //  }
;2238 //  if (rfgenResetCmd)  printf("Reset RF Gen PS request\n");
;2239 
;2240   if (biasOnCmd)  {
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@396
@397:
	ld	a,(_biasOnCmd)
	or	a,a
	jr	z,@414
;2241     printf("Bias PS ON request\n");
	ld	de,word (phys @1+2159)
	ld	c,phys @1+2159 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2242     if (Cur.assertOnBiasPS)  printf("Bias PS already ON\n");
	ld	a,(_curState+131)
	or	a,a
	jr	z,@417
	ld	de,word (phys @1+2179)
	ld	c,phys @1+2179 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2243   }
@417:
;2244   if (biasOffCmd)  {
@414:
	ld	a,(_biasOffCmd)
	or	a,a
	jr	z,@418
;2245     printf("Bias PS OFF request\n");
	ld	de,word (phys @1+2199)
	ld	c,phys @1+2199 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2246     if (!Cur.assertOnBiasPS)  printf("Bias PS already OFF\n");
	ld	a,(_curState+131)
	or	a,a
	jr	nz,@421
	ld	de,word (phys @1+2220)
	ld	c,phys @1+2220 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2247   }
@421:
;2248 
;2249   if (sptrOnCmd)  {
@418:
	ld	a,(_sptrOnCmd)
	or	a,a
	jr	z,@422
;2250     printf("Sputter PS ON request\n");
	ld	de,word (phys @1+2241)
	ld	c,phys @1+2241 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2251     if (Cur.assertOnSptrPS)  printf("Sputter PS already ON\n");
	ld	a,(_curState+136)
	or	a,a
	jr	z,@425
	ld	de,word (phys @1+2264)
	ld	c,phys @1+2264 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2252     if (Cur.sptrInterlock)  printf("Ext interlock still asserted\n");
@425:
	ld	a,(_curState+98)
	or	a,a
	jr	z,@426
	ld	de,word (phys @1+2287)
	ld	c,phys @1+2287 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2253   }
@426:
;2254   if (sptrOffCmd)  {
@422:
	ld	a,(_sptrOffCmd)
	or	a,a
	jr	z,@427
;2255      printf("Sputter PS OFF request\n");
	ld	de,word (phys @1+2317)
	ld	c,phys @1+2317 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2256      if (!Cur.assertOnSptrPS)  printf("Sputter PS already OFF\n");
	ld	a,(_curState+136)
	or	a,a
	jr	nz,@430
	ld	de,word (phys @1+2341)
	ld	c,phys @1+2341 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2257   }
@430:
;2258 
;2259 
;2260 }
@427:
@363:
	.debug	} @363 2260

@362	equ	2
	ld	sp,ix
	pop	ix
	lret
@364	equ	4
;2261 
;2262 
;2263 //=========================================================================
;2264 //  Update the values in "Next" based on the "Cur" and "Prev" values.
;2265 //
;2266 //  Be sure to read the "NOTES on Locking" section above....
;2267 //=========================================================================
;2268 //
;2269 //  This function contains the Synchronous logic used to compute the next
;2270 //  state we want the controller to be in.
;2271 //
;2272 //  A few simple rules that apply to all the values used by this function:
;2273 //
;2274 //    - All values changed within this function are "outputs"
;2275 //
;2276 //    - Every value read by this function is an "input"
;2277 //
;2278 //    - There must be no overlap between inputs and outputs
;2279 //
;2280 //    - The output values from this function must not be altered outside of
;2281 //      this function.
;2282 //
;2283 //  Any global variable can be an input OR an output, but they must NEVER
;2284 //  serve both purposes.  Most inputs come from Prev or Cur, while most
;2285 //  outputs are in Next.  If the logic requires detecting a change in a
;2286 //  value between passes (edge-triggered logic), then the value should be
;2287 //  part of the ApplState structure so we can compare its Prev and Cur valu
;2288 //
;2289 //  Following these simple rules allows the code to be organized as small,
;2290 //  self-contained blocks, with well-defined inputs and outputs.  Furthermo
;2291 //  there are no order-of-execution dependencies between blocks of code.  T
;2292 //  blocks can be executed in any order:  The result will always be the sam
;2293 //
;2294 //
;2295 //  Each output value (or VERY small "set" of output values) must be update
;2296 //  in a single, self-contained block of code.  NO output may be referenced
;2297 //  OR altered in ANOTHER block of code:  This is a declarative, data-orien
;2298 //  style of programming and has many advantages including:
;2299 //
;2300 //     - There are no order-of-execution dependencies across nodes/blocks
;2301 //       within a pass.  They can be executed in any order and the result
;2302 //       will be the same (get used to it - this method will be the norm as
;2303 //       computer languages and hardware add support for atomic transaction
;2304 //       and computers evolve in to neural-net-like processor arrays - FPGA
;2305 //       are just the beginning of this trend).
;2306 //
;2307 //     - Encapsulating all logic for an output within a single node/block
;2308 //       leaves just one place to start when tracking a problem backward fr
;2309 //       the result.  Far simpler than debugging code structured around the
;2310 //       traditional process/event-driven approach which can contain numero
;2311 //       independent paths of execution leading to an observed result.
;2312 //
;2313 //  Each node/block-of-code should be prefaced with the following informati
;2314 //   - The name(s) of the value(s) it modifies
;2315 //   - A descr of the meaning of the value(s) and the logic used
;2316 //   - A list of the values that serve as "inputs" to the node
;2317 //
;2318 //=========================================================================
;2319 void updateNextState(void)
;2320 {
$updateNextState::
	.debug	G $updateNextState 61 9
	.debug	{ $updateNextState 61 2319 @433 @432
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
;2321   uint  idx;
;2322 
;2323 
;2324   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@432
;2325 
;2326 //APPLCODE
;2327 
;2328  //--------------------------------------------------------------------
;2329  // Next.enableOvenPower[]
;2330  //    Description:
;2331  //       Determines if the output that enables the AC power to the Oven
;2332  //       supply should be asserted.  The power to the Oven supply is
;2333  //       turned off immediately if an Interlock occurs or oven#PwrOffDelay
;2334  //       ms after an off command is received.
;2335  //    Inputs:
;2336  //       ovenOnCmd[]
;2337  //       ovenOffCmdTime[]
;2338  //--------------------------------------------------------------------
;2339   for (idx=0; idx<2; ++idx)  {
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@437:
	ld	hl,(ix-2)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nc,@438
;2340     uint offDelay = idx ? oven1PwrOffDelay : oven2PwrOffDelay;
	ld	hl,(ix-2)
	bool	hl
	jr	z,@442
	ld	hl,(_oven1PwrOffDelay)
	jr	@443
@442:
	ld	hl,(_oven2PwrOffDelay)
@443:
	ld	(ix-4),hl
	.seg	FARCODE
;2341     if (Cur.ovenOutErrInterlock[idx]
;2342         OR (ovenOffCmdTime[idx] AND (msSince(ovenOffCmdTime[idx]) > offDela
	ld	hl,(ix-2)
	ld	de,_curState+88
	add	hl,de
	ld	a,(hl)
	or	a,a
	jp	nz,@444
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_ovenOffCmdTime
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jp	z,@445
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_ovenOffCmdTime
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	ld	hl,(ix-4)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__lsub##
	jr	c,@445
	jr	z,@445
@444:
;2343       Next.enableOvenPower[idx] = false;
	ld	hl,(ix-2)
	ld	de,_nextState+103
	add	hl,de
	xor	a,a
	ld	(hl),a
;2344     else
;2345       if (Cur.ovenModeOn[idx])  Next.enableOvenPower[idx] = true;
	jr	@449
@445:
	ld	hl,(ix-2)
	ld	de,_curState+86
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@450
	ld	hl,(ix-2)
	ld	de,_nextState+103
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;2346   }
@450:
@449:
;2347 
;2348  //--------------------------------------------------------------------
;2349  // Next.enableOvenOutput[]
;2350  //    Description:
;2351  //       Determines if the output from the Oven PS should be enabled.
;2352  //       The output is enabled a short time after the power to the
;2353  //       supply is enabled.  The output is disabled if we get an Off
;2354  //       command, the power is disabled, or an uncleared interlock
;2355  //       exists.
;2356  //    Inputs:
;2357  //       ovenPowerOnTime
;2358  //       Cur.ovenModeOn
;2359  //       Cur.enableOvenPower
;2360  //       Cur.ovenOutErrInterlock
;2361  //--------------------------------------------------------------------
;2362   for (idx=0; idx<2; ++idx)  {
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@437
@438:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@453:
	ld	hl,(ix-2)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nc,@454
;2363     if (!Cur.ovenModeOn[idx] OR !Cur.enableOvenPower[idx]
;2364         OR Cur.ovenOutErrInterlock[idx])
	ld	hl,(ix-2)
	ld	de,_curState+86
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@458
	ld	hl,(ix-2)
	ld	de,_curState+103
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@458
	ld	hl,(ix-2)
	ld	de,_curState+88
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@459
@458:
;2365       Next.enableOvenOutput[idx] = false;
	ld	hl,(ix-2)
	ld	de,_nextState+105
	add	hl,de
	xor	a,a
	ld	(hl),a
;2366     else
;2367       if (ovenPowerOnTime[idx])  if (msSince(ovenPowerOnTime[idx]) > 2000)
	jp	@460
@459:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_ovenPowerOnTime
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jp	z,@461
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_ovenPowerOnTime
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x7d0
	ld	bc,0
	call	__lsub##
	jr	c,@462
	jr	z,@462
;2368         Next.enableOvenOutput[idx] = true;
	ld	hl,(ix-2)
	ld	de,_nextState+105
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;2369   }
@462:
@461:
@460:
;2370 
;2371  //--------------------------------------------------------------------
;2372  // Next.ovenOutErrStartTime[0]
;2373  //    Description:
;2374  //       Keeps track of the beginning of a period during which the
;2375  //       Oven PS reports that the state of its output is different
;2376  //       than what we told it to be.
;2377  //    Inputs:
;2378  //       Cur.enableOvenOutput[]
;2379  //       Cur.ovenOpStatus[]
;2380  //       ovenResetCmd[]
;2381  //--------------------------------------------------------------------
;2382   {
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@453
@454:
;2383     bool  shouldBeOn, isOn;
;2384 
;2385     for (idx=0; idx<2; ++idx)  {
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@467:
	ld	hl,(ix-2)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nc,@468
;2386       if (ovenResetCmd[idx])  {
	ld	hl,(ix-2)
	ld	de,_ovenResetCmd
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@472
;2387         Next.ovenOutErrStartTime[idx] = 0;  postOvenResetMsgs[idx] = 0;
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_nextState+90
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_postOvenResetMsgs
	add	hl,de
	ld	d,b
	ld	e,c
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2388         forceOvenErr = 0;  //tdebug
	bool	hl
	ld	l,h
	ld	(_forceOvenErr),hl
;2389       }
;2390       else  {
	jp	@475
@472:
;2391         // NOTE: The newOvenResp[] and postOvenResetMsgs[] values are neede
;2392         //       to insure the data read from the Oven PS is recent and
;2393         //       not something that was "in the pipeline" at the time
;2394         //       we got the reset command.
;2395         if (newOvenResp[idx] AND (postOvenResetMsgs[idx] > 4))  {
	ld	hl,(ix-2)
	ld	de,_newOvenResp
	add	hl,de
	ld	a,(hl)
	or	a,a
	jp	z,@479
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_postOvenResetMsgs
	add	hl,de
	ld	hl,(hl)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	c,@479
	jp	z,@479
;2396           shouldBeOn = BOOL(Cur.enableOvenOutput[idx]);
	ld	hl,(ix-2)
	ld	de,_curState+105
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@482
	ld	a,0x1
	jr	@483
@482:
	xor	a,a
@483:
	ld	(ix-3),a
;2397           isOn = BOOL(Cur.ovenOpStatus[idx] & OOS_OutputOn);
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_curState+58
	add	hl,de
	ld	hl,(hl)
	ld	de,0x10
	and	hl,de
	jr	z,@484
	ld	a,0x1
	jr	@485
@484:
	xor	a,a
@485:
	ld	(ix-4),a
;2398           if (shouldBeOn == isOn)
	ld	a,(ix-3)
	ld	hl,(ix-4)
	sub	a,l
	jr	nz,@486
;2399             Next.ovenOutErrStartTime[idx] = 0;
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_nextState+90
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2400           else
;2401             if (!Next.ovenOutErrStartTime[idx])
	jp	@487
@486:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_nextState+90
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jp	nz,@488
;2402               Next.ovenOutErrStartTime[idx] = GetMS();
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_nextState+90
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2403         }
@488:
@487:
;2404       }
@479:
;2405     }
@475:
;2406   }
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@467
@468:
;2407 
;2408  //--------------------------------------------------------------------
;2409  // Next.ovenOutErrInterlock[]
;2410  //    Description:
;2411  //       Indicates that the Oven PS says that the on/off state of its
;2412  //       output has been consistenly different (for several seconds)
;2413  //       than what we been asserting via a hdw signal.
;2414  //    Inputs:
;2415  //       ovenResetCmd[]
;2416  //       Cur.ovenOutErrStartTime[]
;2417  //--------------------------------------------------------------------
;2418   for (idx=0; idx<2; ++idx)  {
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@491:
	ld	hl,(ix-2)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nc,@492
;2419     if (ovenResetCmd[idx])
	ld	hl,(ix-2)
	ld	de,_ovenResetCmd
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@496
;2420       Next.ovenOutErrInterlock[idx] = false;
	ld	hl,(ix-2)
	ld	de,_nextState+88
	add	hl,de
	xor	a,a
	ld	(hl),a
;2421     else
;2422       if (Cur.ovenOutErrStartTime[idx])
	jp	@497
@496:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_curState+90
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jp	z,@498
;2423         if (msSince(Cur.ovenOutErrStartTime[idx]) > 4000)
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_curState+90
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	push	bc
	push	de
	ld	de,0xfa0
	ld	bc,0
	call	__lsub##
	jr	c,@499
	jr	z,@499
;2424           Next.ovenOutErrInterlock[idx] = true;
	ld	hl,(ix-2)
	ld	de,_nextState+88
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;2425 
;2426     if (Next.ovenOutErrInterlock[idx] != Cur.ovenOutErrInterlock[idx])
@499:
@498:
@497:
	ld	hl,(ix-2)
	ld	de,_nextState+88
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,hl
	ld	hl,_curState+88
	add	hl,de
	ld	a,(hl)
	ld	de,bc
	ex	de,hl
	ld	l,(hl)
	sub	a,l
	jr	z,@500
;2427       printf("Oven%d Output State error Interlock %s\n",
;2428              idx+1, Next.ovenOutErrInterlock[idx] ? "Asserted" : "Cleared")
	ld	hl,(ix-2)
	ld	de,_nextState+88
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@501
	ld	hl,@2+242
	jr	@502
@501:
	ld	hl,@2+251
@502:
	push	hl
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+2365)
	ld	c,phys @1+2365 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;2429   }
@500:
;2430 
;2431  //--------------------------------------------------------------------
;2432  // Next.ovenSetVassert[]
;2433  //    Description:
;2434  //       The setpoint to actually apply to the Oven supply
;2435  //    Inputs:
;2436  //       Cur.enableOvenOutput[]
;2437  //       Cur.ovenSetV[]
;2438  //--------------------------------------------------------------------
;2439   for (idx=0; idx<2; ++idx)
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@491
@492:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@506:
	ld	hl,(ix-2)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nc,@507
;2440     Next.ovenSetVassert[idx] =
;2441       (Cur.enableOvenOutput[idx] ? Cur.ovenSetV[idx] : 0.0);
	ld	hl,(ix-2)
	ld	de,_curState+105
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@509
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_curState
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@510
@509:
	ld	de,0
	ld	c,e
	ld	b,e
@510:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_nextState+107
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2442 
;2443 
;2444 
;2445  //--------------------------------------------------------------------
;2446  // Next.assertOnBiasPS
;2447  //    Description:
;2448  //       Determines if the output that enables the Bias supply should
;2449  //       be asserted.
;2450  //    Inputs:
;2451  //       biasOnCmd
;2452  //       biasOffCmd
;2453  //--------------------------------------------------------------------
;2454   if (biasOnCmd)   Next.assertOnBiasPS = true;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@506
@507:
	ld	a,(_biasOnCmd)
	or	a,a
	jr	z,@511
	ld	a,0x1
	ld	(_nextState+131),a
;2455   if (biasOffCmd)  Next.assertOnBiasPS = false;
@511:
	ld	a,(_biasOffCmd)
	or	a,a
	jr	z,@512
	xor	a,a
	ld	(_nextState+131),a
;2456 
;2457  //--------------------------------------------------------------------
;2458  // Next.biasSetVassert
;2459  //    Description:
;2460  //       The setpoint to actually apply to the Bias supply
;2461  //    Inputs:
;2462  //       Cur.assertOnBiasPS
;2463  //       Cur.biasSetV
;2464  //--------------------------------------------------------------------
;2465   Next.biasSetVassert = Cur.assertOnBiasPS ? Cur.biasSetV : 0.0;
@512:
	ld	a,(_curState+131)
	or	a,a
	jr	z,@513
	ld	de,(_curState+8)
	ld	bc,(_curState+10)
	jr	@514
@513:
	ld	de,0
	ld	c,e
	ld	b,e
@514:
	ld	(_nextState+132),de
	ld	(_nextState+134),bc
;2466 
;2467 
;2468  //--------------------------------------------------------------------
;2469  // Next.assertOnSptrPS
;2470  //    Description:
;2471  //       Determines if the output that enables the Sputter supply should
;2472  //       be asserted.
;2473  //    Inputs:
;2474  //       sptrOnCmd
;2475  //       sptrOffCmd
;2476  //--------------------------------------------------------------------
;2477   if (sptrOnCmd AND !Cur.sptrInterlock)  Next.assertOnSptrPS = true;
	ld	a,(_sptrOnCmd)
	or	a,a
	jr	z,@516
	ld	a,(_curState+98)
	or	a,a
	jr	nz,@516
	ld	a,0x1
	ld	(_nextState+136),a
;2478   if (sptrOffCmd OR Cur.sptrInterlock)  Next.assertOnSptrPS = false;
@516:
	ld	a,(_sptrOffCmd)
	or	a,a
	jr	nz,@517
	ld	a,(_curState+98)
	or	a,a
	jr	z,@518
@517:
	xor	a,a
	ld	(_nextState+136),a
;2479 
;2480  //--------------------------------------------------------------------
;2481  // Next.sptrSetVassert
;2482  //    Description:
;2483  //       The setpoint to actually apply to the Sputter supply
;2484  //    Inputs:
;2485  //       Cur.assertOnSptrPS
;2486  //       Cur.sptrSetV
;2487  //--------------------------------------------------------------------
;2488   Next.sptrSetVassert = Cur.assertOnSptrPS ? Cur.sptrSetV : 0.0;
@518:
	ld	a,(_curState+136)
	or	a,a
	jr	z,@519
	ld	de,(_curState+12)
	ld	bc,(_curState+14)
	jr	@520
@519:
	ld	de,0
	ld	c,e
	ld	b,e
@520:
	ld	(_nextState+137),de
	ld	(_nextState+139),bc
;2489 
;2490 
;2491  //--------------------------------------------------------------------
;2492  // Next.rfgenStartTime
;2493  //    Description:
;2494  //       The time a pulse was started to turn ON the RF Gen supply.
;2495  //    Inputs:
;2496  //       rfgenStartCmd
;2497  //--------------------------------------------------------------------
;2498 //  if (rfgenStartCmd)  Next.rfgenStartTime = GetMS();
;2499 //  if (msSince(Next.rfgenStartTime) >= 500)  Next.rfgenStartTime = 0;
;2500 
;2501  //--------------------------------------------------------------------
;2502  // Next.rfgenStopTime
;2503  //    Description:
;2504  //       The time a pulse was started to turn OFF the RF Gen supply.
;2505  //    Inputs:
;2506  //       rgfenStopCmd
;2507  //--------------------------------------------------------------------
;2508 //  if (rfgenStopCmd)  Next.rfgenStopTime = GetMS();
;2509 //  if (msSince(Next.rfgenStopTime) >= 500)  Next.rfgenStopTime = 0;
;2510 
;2511  //--------------------------------------------------------------------
;2512  // Next.rfgenResetTime
;2513  //    Description:
;2514  //       The time a pulse was started to RESET the RF Gen supply.
;2515  //    Inputs:
;2516  //       rfgenResetCmd
;2517  //--------------------------------------------------------------------
;2518 //  if (rfgenResetCmd)  Next.rfgenResetTime = GetMS();
;2519 //  if (msSince(Next.rfgenResetTime) >= 500)  Next.rfgenResetTime = 0;
;2520 
;2521 
;2522  //--------------------------------------------------------------------
;2523  // Next.rfgenSetVassert
;2524  //    Description:
;2525  //       The setpoint to actually apply to the RF Gen supply
;2526  //    Inputs:
;2527  //       Cur.rfgenReady
;2528  //       Cur.rfgenSetV
;2529  //--------------------------------------------------------------------
;2530 //  Next.rfgenSetVassert = Cur.rfgenReady ? Cur.rfgenSetV : 0.0;
;2531 
;2532 
;2533 
;2534 //--- we are done with the event flags now so clear them all ---
;2535 //  rfgenStartCmd = rfgenStopCmd = rfgenResetCmd =
;2536   biasOnCmd = biasOffCmd = sptrOnCmd = sptrOffCmd =
;2537   ovenOnCmd[0] = ovenOffCmd[0] = ovenResetCmd[0] = newOvenResp[0] =
;2538   ovenOnCmd[1] = ovenOffCmd[1] = ovenResetCmd[1] = newOvenResp[1] = false;
	xor	a,a
	ld	(_newOvenResp+1),a
	ld	(_ovenResetCmd+1),a
	ld	(_ovenOffCmd+1),a
	ld	(_ovenOnCmd+1),a
	ld	(_newOvenResp),a
	ld	(_ovenResetCmd),a
	ld	(_ovenOffCmd),a
	ld	(_ovenOnCmd),a
	ld	(_sptrOffCmd),a
	ld	(_sptrOnCmd),a
	ld	(_biasOffCmd),a
	ld	(_biasOnCmd),a
;2539 }
@432:
	.debug	} @432 2539

@431	equ	4
	ld	sp,ix
	pop	ix
	lret
@433	equ	6
;2540 
;2541 
;2542 
;2543 //=========================================================================
;2544 //  Next we update output signal values to be written to the outputs at
;2545 //  the beginning of the next pass (just after the inputs are read).
;2546 //
;2547 //  Be sure to read the "NOTES on Locking" section above....
;2548 //=========================================================================
;2549 void updateOutputState(void)
;2550 {
$updateOutputState::
	.debug	G $updateOutputState 61 9
	.debug	{ $updateOutputState 61 2549 @523 @522
;2551   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@522
;2552 
;2553 //APPLCODE
;2554 
;2555 //--- update output values that are based on current conditions (values ---
;2556 //--- in "Cur" or any values used in a conditional in the applic logic) ---
;2557 
;2558 #define  Set(bits)    SetBits(Next.digitalOut, (bits))
;2559 #define  Clear(bits)  ClearBits(Next.digitalOut, (bits))
;2560 
;2561 //  if (Next.rfgenStartTime)   Clear(RF_PS_START);   else  Set(RF_PS_START)
;2562 //  if (Next.rfgenStopTime)    Clear(RF_PS_STOP);    else  Set(RF_PS_STOP);
;2563 //  if (Next.rfgenResetTime)   Clear(RF_PS_RESET);   else  Set(RF_PS_RESET)
;2564 
;2565   if (Next.assertOnBiasPS)   Clear(BIAS_PS_OFF);   else  Set(BIAS_PS_OFF);
	ld	a,(_nextState+131)
	or	a,a
	jr	z,@525
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	res	5,d
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
	jr	@526
@525:
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	set	5,d
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
;2566 
;2567   if (Next.assertOnSptrPS)   Clear(SPTR_PS_OFF);   else  Set(SPTR_PS_OFF);
@526:
	ld	a,(_nextState+136)
	or	a,a
	jr	z,@527
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	res	6,d
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
	jr	@528
@527:
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	set	6,d
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
;2568 
;2569   if (Next.enableOvenOutput[0])  Clear(OVEN1_OUT_OFF); else  Set(OVEN1_OUT_
@528:
	ld	a,(_nextState+105)
	or	a,a
	jr	z,@529
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	res	0,d
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
	jr	@530
@529:
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	set	0,d
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
;2570   if (Next.enableOvenPower[0])   Clear(OVEN1_PS_OFF);  else  Set(OVEN1_PS_O
@530:
	ld	a,(_nextState+103)
	or	a,a
	jr	z,@531
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	res	4,d
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
	jr	@532
@531:
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	set	4,d
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
;2571 
;2572   if (Next.enableOvenOutput[1])  Clear(OVEN2_OUT_OFF); else  Set(OVEN2_OUT_
@532:
	ld	a,(_nextState+106)
	or	a,a
	jr	z,@533
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	res	3,e
	res	5,e
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
	jr	@534
@533:
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	set	3,e
	set	5,e
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
;2573   if (Next.enableOvenPower[1])   Clear(OVEN2_PS_OFF);  else  Set(OVEN2_PS_O
@534:
	ld	a,(_nextState+104)
	or	a,a
	jr	z,@535
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	res	4,e
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
	jr	@536
@535:
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	set	4,e
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
;2574 
;2575 //--- toggle external WD timer pulse state every 50ms (for ~10Hz sq wave) -
;2576   if (msSince(wdPulseChanged) >= 50)  {
@536:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_wdPulseChanged)
	ld	bc,(_wdPulseChanged+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x32
	ld	c,d
	ld	b,d
	call	__lsub##
	jp	c,@537
;2577     wdPulseChanged = GetMS();
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_wdPulseChanged),de
	ld	(_wdPulseChanged+2),bc
;2578     if (Next.digitalOut & EXT_WD_TIMER)
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	push	bc
	push	de
	ld	de,0x800
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@540
;2579       Clear(EXT_WD_TIMER);
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	res	3,d
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
;2580     else
;2581       Set(EXT_WD_TIMER);
	jr	@541
@540:
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	set	3,d
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
;2582   }
@541:
;2583 
;2584   setVal[OVEN1_SET_V] =  Next.ovenSetVassert[0];
@537:
	ld	de,(_nextState+107)
	ld	bc,(_nextState+109)
	ld	(_setVal),de
	ld	(_setVal+2),bc
;2585   setVal[OVEN2_SET_V] =  Next.ovenSetVassert[1];
	ld	de,(_nextState+111)
	ld	bc,(_nextState+113)
	ld	(_setVal+12),de
	ld	(_setVal+14),bc
;2586   setVal[BIAS_SET_V] =  Next.biasSetVassert;
	ld	de,(_nextState+132)
	ld	bc,(_nextState+134)
	ld	(_setVal+4),de
	ld	(_setVal+6),bc
;2587   setVal[SPTR_SET_V] =  Next.sptrSetVassert;
	ld	de,(_nextState+137)
	ld	bc,(_nextState+139)
	ld	(_setVal+8),de
	ld	(_setVal+10),bc
;2588 //  setVal[RFGEN_SET_V] = Next.rfgenSetVassert;
;2589 }
@522:
	.debug	} @522 2589

@521	equ	0
	lret
@523	equ	0
;2590 
;2591 
;2592 
;2593 
;2594 //=========================================================================
;2595 // The last thing we do is update values read by other tasks
;2596 //
;2597 //  Be sure to read the "NOTES on Locking" section above....
;2598 //=========================================================================
;2599 void updateExternals(void)
;2600 {
$updateExternals::
	.debug	G $updateExternals 61 9
	.debug	{ $updateExternals 61 2599 @544 @543
;2601   if (current != applTask)  return;  // must only be called by "applic" tas
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@543
;2602 
;2603   digInBits = Cur.digitalIn;
	ld	de,(_curState+16)
	ld	bc,(_curState+18)
	ld	(_digInBits),de
	ld	(_digInBits+2),bc
;2604   digOutBits = Cur.digitalOut;
	ld	de,(_curState+99)
	ld	bc,(_curState+101)
	ld	(_digOutBits),de
	ld	(_digOutBits+2),bc
;2605 
;2606 //APPLCODE
;2607 
;2608   statusBitsAppl = 0;
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;2609 
;2610 //  if (Cur.rfgenFault)   statusBitsAppl |= RF_PS_FAULT;
;2611 //  if (Cur.rfgenHeatOn)  statusBitsAppl |= RF_PS_HEAT_ON;
;2612 //  if (Cur.rfgenReady)   statusBitsAppl |= RF_PS_READY;
;2613 
;2614 //  if (Cur.rfgenInactive)  statusBitsAppl |= RF_PS_INACTIVE;
;2615   if (Cur.ovenInactive[0])   statusBitsAppl |= OVEN1_PS_INACTIVE;
	ld	a,(_curState+20)
	or	a,a
	jr	z,@546
	set	7,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;2616   if (Cur.ovenInactive[1])   statusBitsAppl |= OVEN2_PS_INACTIVE;
@546:
	ld	a,(_curState+21)
	or	a,a
	jr	z,@547
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	3,d
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;2617 
;2618   if (Next.enableOvenOutput[0])  statusBitsAppl |= OVEN1_PS_ENABLED;
@547:
	ld	a,(_nextState+105)
	or	a,a
	jr	z,@548
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	3,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;2619   if (Next.enableOvenOutput[1])  statusBitsAppl |= OVEN2_PS_ENABLED;
@548:
	ld	a,(_nextState+106)
	or	a,a
	jr	z,@549
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	2,d
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;2620   if (Next.assertOnBiasPS)    statusBitsAppl |= BIAS_PS_ENABLED;
@549:
	ld	a,(_nextState+131)
	or	a,a
	jr	z,@550
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	4,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;2621   if (Next.assertOnSptrPS)    statusBitsAppl |= SPTR_PS_ENABLED;
@550:
	ld	a,(_nextState+136)
	or	a,a
	jr	z,@551
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	5,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;2622 
;2623   if (Cur.ovenOutErrInterlock[0])  statusBitsAppl |= OVEN1_OUT_INTLK;
@551:
	ld	a,(_curState+88)
	or	a,a
	jr	z,@552
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	0,d
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;2624   if (Cur.ovenOutErrInterlock[1])  statusBitsAppl |= OVEN2_OUT_INTLK;
@552:
	ld	a,(_curState+89)
	or	a,a
	jr	z,@553
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	4,d
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;2625 
;2626   if (Cur.sptrInterlock)  statusBitsAppl |= SPTR_INTERLOCK;
@553:
	ld	a,(_curState+98)
	or	a,a
	jr	z,@554
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	6,d
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;2627 
;2628   sptrReadV = Cur.sptrReadV;
@554:
	ld	de,(_curState+78)
	ld	bc,(_curState+80)
	ld	(_sptrReadV),de
	ld	(_sptrReadV+2),bc
;2629   sptrReadA = Cur.sptrReadA;
	ld	de,(_curState+82)
	ld	bc,(_curState+84)
	ld	(_sptrReadA),de
	ld	(_sptrReadA+2),bc
;2630 
;2631   biasReadV = Cur.biasReadV;
	ld	de,(_curState+70)
	ld	bc,(_curState+72)
	ld	(_biasReadV),de
	ld	(_biasReadV+2),bc
;2632   biasReadA = Cur.biasReadA;
	ld	de,(_curState+74)
	ld	bc,(_curState+76)
	ld	(_biasReadA),de
	ld	(_biasReadA+2),bc
;2633 
;2634   oven1ReadV = Cur.ovenReadV[0];  oven2ReadV = Cur.ovenReadV[1];
	ld	de,(_curState+26)
	ld	bc,(_curState+28)
	ld	(_oven1ReadV),de
	ld	(_oven1ReadV+2),bc
	ld	de,(_curState+30)
	ld	bc,(_curState+32)
	ld	(_oven2ReadV),de
	ld	(_oven2ReadV+2),bc
;2635   oven1ReadA = Cur.ovenReadA[0];  oven2ReadA = Cur.ovenReadA[1];
	ld	de,(_curState+42)
	ld	bc,(_curState+44)
	ld	(_oven1ReadA),de
	ld	(_oven1ReadA+2),bc
	ld	de,(_curState+46)
	ld	bc,(_curState+48)
	ld	(_oven2ReadA),de
	ld	(_oven2ReadA+2),bc
;2636 
;2637   serOven1SetV = Cur.serOvenSetV[0];    serOven2SetV = Cur.serOvenSetV[1];
	ld	de,(_curState+115)
	ld	bc,(_curState+117)
	ld	(_serOven1SetV),de
	ld	(_serOven1SetV+2),bc
	ld	de,(_curState+119)
	ld	bc,(_curState+121)
	ld	(_serOven2SetV),de
	ld	(_serOven2SetV+2),bc
;2638   serOven1SetA = Cur.serOvenSetA[0];    serOven2SetA = Cur.serOvenSetA[1];
	ld	de,(_curState+123)
	ld	bc,(_curState+125)
	ld	(_serOven1SetA),de
	ld	(_serOven1SetA+2),bc
	ld	de,(_curState+127)
	ld	bc,(_curState+129)
	ld	(_serOven2SetA),de
	ld	(_serOven2SetA+2),bc
;2639   serOven1ReadV = Cur.serOvenReadV[0];  serOven2ReadV = Cur.serOvenReadV[1]
	ld	de,(_curState+34)
	ld	bc,(_curState+36)
	ld	(_serOven1ReadV),de
	ld	(_serOven1ReadV+2),bc
	ld	de,(_curState+38)
	ld	bc,(_curState+40)
	ld	(_serOven2ReadV),de
	ld	(_serOven2ReadV+2),bc
;2640   serOven1ReadA = Cur.serOvenReadA[0];  serOven2ReadA = Cur.serOvenReadA[1]
	ld	de,(_curState+50)
	ld	bc,(_curState+52)
	ld	(_serOven1ReadA),de
	ld	(_serOven1ReadA+2),bc
	ld	de,(_curState+54)
	ld	bc,(_curState+56)
	ld	(_serOven2ReadA),de
	ld	(_serOven2ReadA+2),bc
;2641 
;2642 //  rfgenReadV = Cur.rfgenReadV;
;2643 //  rfgenReadA = Cur.rfgenReadA;
;2644 //  rfgenReadW = Cur.rfgenReadW;
;2645 
;2646 //  rfSupplyType = Cur.rfSupplyType;
;2647 
;2648   oven1Status = (ulong) Cur.ovenOpStatus[0] |
;2649                 ((ulong) Cur.ovenAlarmStatus[0] << 8) |
;2650                 ((ulong) Cur.ovenProgStatus[0] << 16);
	ld	hl,(_curState+58)
	ex	de,hl
	ld	bc,0
	ld	hl,(_curState+62)
	push	bc
	push	de
	ex	de,hl
	ld	c,d
	ld	d,e
	ld	e,b
	call	__lor##
	ld	hl,(_curState+66)
	push	bc
	push	de
	ex	de,hl
	ld	b,d
	ld	c,e
	ld	de,0
	call	__lor##
	ld	(_oven1Status),de
	ld	(_oven1Status+2),bc
;2651 
;2652   oven2Status = (ulong) Cur.ovenOpStatus[1] |
;2653                 ((ulong) Cur.ovenAlarmStatus[1] << 8) |
;2654                 ((ulong) Cur.ovenProgStatus[1] << 16);
	ld	hl,(_curState+60)
	ex	de,hl
	ld	bc,0
	ld	hl,(_curState+64)
	push	bc
	push	de
	ex	de,hl
	ld	c,d
	ld	d,e
	ld	e,b
	call	__lor##
	ld	hl,(_curState+68)
	push	bc
	push	de
	ex	de,hl
	ld	b,d
	ld	c,e
	ld	de,0
	call	__lor##
	ld	(_oven2Status),de
	ld	(_oven2Status+2),bc
;2655 
;2656   adc00 = adcRaw[0];
	ld	hl,(_adcRaw)
	ld	(_adc00),hl
;2657   adc01 = adcRaw[1];
	ld	hl,(_adcRaw+2)
	ld	(_adc01),hl
;2658   adc02 = adcRaw[2];
	ld	hl,(_adcRaw+4)
	ld	(_adc02),hl
;2659   adc03 = adcRaw[3];
	ld	hl,(_adcRaw+6)
	ld	(_adc03),hl
;2660   adc04 = adcRaw[4];
	ld	hl,(_adcRaw+8)
	ld	(_adc04),hl
;2661   adc05 = adcRaw[5];
	ld	hl,(_adcRaw+10)
	ld	(_adc05),hl
;2662 }
@543:
	.debug	} @543 2662

@542	equ	0
	lret
@544	equ	0
;2663 
;2664 
;2665 
;2666 //-------------------------------------------------------------------------
;2667 //  Parse the response from the Ameritherm Power Supply
;2668 //-------------------------------------------------------------------------
;2669 /*
;2670 void Process_RF_PS_Resp(char *resp)
;2671 {
;2672   char  *ptr;
;2673   int  len;
;2674   float  watts, amps, volts;
;2675 
;2676 
;2677   KLOCK();
;2678   watts = rfgenReadW;  amps = rfgenReadA;  volts = rfgenReadV;
;2679   KUNLOCK();
;2680 
;2681   switch  (rfSupplyType)  {
;2682 
;2683   // sample response to command "1,data":
;2684   //  (2 lines?)
;2685     case RF_TYPE_HotShot:
;2686       // scan bkwds from end for 1st space char
;2687       for (ptr = resp+strlen(resp)-1; (ptr > resp) AND (*ptr > ' '); --ptr)
;2688 
;2689       if (strncmp(resp, "Power Out", 9) == 0)  watts = atof(ptr);  else
;2690       if (strncmp(resp, "Amps Out", 8) == 0)  amps = atof(ptr);
;2691 
;2692       volts = (amps == 0.0) ? 0.0 : (watts / amps);
;2693 
;2694       break;
;2695 
;2696 
;2697   // sample response to command "r001":
;2698   //   0049%V 14%A 7%W 317 KHZ 0.0000 Sec HEAT ON GO 0005 CYC 38
;2699     case RF_TYPE_NovaStar:
;2700       ptr = strtok(resp, " ");
;2701       while (ptr)  {
;2702         if ((len = strlen(ptr)) < 1)  break;
;2703         while (*ptr AND (*ptr == '0'))  { ++ptr;  --len; } // skip any lead
;2704 
;2705         switch (ptr[len-1])  {
;2706           case 'V':  volts = atof(ptr);  break;
;2707           case 'A':  amps = atof(ptr);  break;
;2708           case 'W':  watts = atof(ptr);  break;
;2709         }
;2710 
;2711         if (ptr)  ptr = strtok(NULL, " ");
;2712       }
;2713       break;
;2714 
;2715   }
;2716 
;2717   KLOCK();
;2718   rfgenReadW = watts;  rfgenReadA = amps;  rfgenReadV = volts;
;2719   KUNLOCK();
;2720 }
;2721 */
;2722 
;2723 //-------------------------------------------------------------------------
;2724 //  Process to manage comunications with the external RF Gen power supply
;2725 //-------------------------------------------------------------------------
;2726 /*
;2727 void _task rfgenCom(int argc, char **argv)
;2728 {
;2729   int  i, stat, psType, newType, fflags;
;2730   fd_t  devfd;
;2731   char  pktStartChar;
;2732   ulong  baudRate, lastRcvTime;
;2733   char  *nextCmd;
;2734   char  buf[128];
;2735 
;2736 
;2737   redirectStdio();
;2738 
;2739   devfd = 0;  psType = 0;  rfgenLastRespTime = 0;
;2740 
;2741   for (;;)  {
;2742     _EnterCritical_();  newType = rfSupplyType;  _ExitCritical_();
;2743 
;2744     if (newType != psType)  {
;2745       if (devfd)  { close(devfd);  devfd = 0; }
;2746       psType = newType;
;2747     }
;2748 
;2749     if (! psType)  { sleepMS(500);  continue; }
;2750 
;2751   //--- (re)open and initialize port for communicating with the RF Gen PS -
;2752     if (!devfd)  {
;2753       if ((devfd = open("/dev/tty3", O_RDWR, 0)) < 0)  {
;2754         printf("Unable to open port for RF PS\n");  Exit(-3); }
;2755 
;2756       fflags = fcntl(devfd, F_GETFL, 0);
;2757       fcntl(devfd, F_SETFL, fflags | O_NONBLOCK);
;2758 
;2759       baudRate = (psType == RF_TYPE_HotShot) ? 38400 : 9600;
;2760       ioctl(devfd, IOC_SET_BAUD, &baudRate);
;2761 
;2762     //--- set serial driver to use packet mode, waiting for a LF char to --
;2763     //--- indicate the start of each packet ---
;2764       pktStartChar = 0x0a;  // PS packets start with a LF
;2765       ioctl(devfd, IOC_SET_PKTMODE, &pktStartChar);
;2766     }
;2767 
;2768 
;2769   //--- send a command ---
;2770   //HotShot cmd fmt:  #,<cmd>[,arg]
;2771   //NovaStar cmd fmt:  <cmd>[###][,arg]
;2772     if (*rfgenCmd)
;2773       nextCmd = rfgenCmd;
;2774     else
;2775       nextCmd = (psType == RF_TYPE_HotShot) ? "1,data\r" : "r001\r";
;2776     ioctl(devfd, IOC_START_PKT_TX, NULL);
;2777     write(devfd, nextCmd, strlen(nextCmd));
;2778     ioctl(devfd, IOC_END_PKT_TX, NULL);
;2779     *rfgenCmd = 0;
;2780 
;2781   //--- wait for response packet ---
;2782     lastRcvTime = GetMS();  *buf = 0;
;2783     for (i=0; i<sizeof(buf)-1; )  {
;2784       stat = read(devfd, buf+i, 1);
;2785       if (stat > 0)  {
;2786 //        printf("<%02x>", buf[i]);  //tdebug
;2787         buf[i] &= 0x7f;  lastRcvTime  = GetMS();
;2788         if (buf[i] == 0x0D)  break;
;2789         ++i;  continue;
;2790       }
;2791       if ((stat < 0) AND (errno != EAGAIN))  {
;2792         perror("error reading serial packet");  break; }
;2793       if (msSince(lastRcvTime) > 1000)  break;
;2794       sleepMS(50);
;2795     }
;2796     ioctl(devfd, IOC_END_PKT_RX, NULL);
;2797 
;2798     if (i == 0)  continue;
;2799 
;2800     if (buf[i] != 0x0D)  {
;2801       printf("incomplete packet: [%.128s]\r\n", buf);  continue; }
;2802 
;2803     buf[i] = 0;
;2804 
;2805   //--- process the response ---
;2806     if (ShowPackets)  printf("[%.128s]\r\n", buf);
;2807     _EnterCritical_();  rfgenLastRespTime = GetMS();  _ExitCritical_();
;2808     Process_RF_PS_Resp(buf);  sleepMS(330);
;2809   }
;2810 
;2811 }
;2812 */
;2813 
;2814 //-------------------------------------------------------------------------
;2815 //  Parse the response from the Ameritherm Power Supply
;2816 //-------------------------------------------------------------------------
;2817 int Process_Oven_PS_Resp(char *resp, fd_t devfd, uint idx)
;2818 {
$Process_Oven_PS_Resp::
	.debug	G $Process_Oven_PS_Resp 76 9
	.debug	{ $Process_Oven_PS_Resp 76 2817 @557 @556
	ld	hl,-136
	call	__fent##
;2819   char  *ptrAV, *ptrSV, *ptrAA, *ptrSA, *ptrOS, *ptrAL, *ptrPS,
;2820         *ptrEnd, *newline, *msg;
;2821   bool  resetAlarms, forceErr;
;2822   float  actualVolts, setVolts, actualAmps, setAmps,
;2823          anaVolts, anaSetVolts, anaAmps;
;2824   uint  opStatus, alarmStatus, progStatus;
;2825   char  temp[80];
;2826 
;2827 
;2828 // sample responses to ":STT?;" command:
;2829 //   AV00.000SV00.000AA00.000SA20.081OS00010001AL00101PS01100  (20-20)
;2830 //   AV10.26SV05.30AA1.999SA2.012OS11010000AL00100PS00000      (60-7?)
;2831 
;2832 //--- Some basic sanity checks on the response ---
;2833   ptrAV = strstr(resp, "AV");   if (ptrAV != resp)  return -1;
	ld	hl,@2+259
	push	hl
	ld	hl,(ix+5)
	push	hl
	call	_strstr
	add	sp,4
	ld	(ix-2),hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@875
;2834   ptrSV = strstr(ptrAV, "SV");  if (!ptrSV)  return -1;
	ld	hl,@2+262
	push	hl
	ld	hl,(ix-2)
	push	hl
	call	_strstr
	add	sp,4
	ld	(ix-4),hl
	bool	hl
	jr	nz,@559
@875:
	ld	hl,0xffff
	jp	@556
;2835   ptrAA = strstr(ptrSV, "AA");  if (!ptrAA)  return -2;
@559:
	ld	hl,@2+265
	push	hl
	ld	hl,(ix-4)
	push	hl
	call	_strstr
	add	sp,4
	ld	(ix-6),hl
	bool	hl
	jr	nz,@560
	ld	hl,0xfffe
	jp	@556
;2836   ptrSA = strstr(ptrAA, "SA");  if (!ptrSA)  return -3;
@560:
	ld	hl,@2+268
	push	hl
	ld	hl,(ix-6)
	push	hl
	call	_strstr
	add	sp,4
	ld	(ix-8),hl
	bool	hl
	jr	nz,@561
	ld	hl,0xfffd
	jp	@556
;2837   ptrOS = strstr(ptrSA, "OS");  if (!ptrOS)  return -4;
@561:
	ld	hl,@2+271
	push	hl
	ld	hl,(ix-8)
	push	hl
	call	_strstr
	add	sp,4
	ld	(ix-10),hl
	bool	hl
	jr	nz,@562
	ld	hl,0xfffc
	jp	@556
;2838   ptrAL = strstr(ptrOS, "AL");  if (!ptrAL)  return -5;
@562:
	ld	hl,@2+274
	push	hl
	ld	hl,(ix-10)
	push	hl
	call	_strstr
	add	sp,4
	ld	(ix-12),hl
	bool	hl
	jr	nz,@563
	ld	hl,0xfffb
	jp	@556
;2839   ptrPS = strstr(ptrAL, "PS");  if (!ptrPS)  return -6;
@563:
	ld	hl,@2+277
	push	hl
	ld	hl,(ix-12)
	push	hl
	call	_strstr
	add	sp,4
	ld	(ix-14),hl
	bool	hl
	jr	nz,@564
	ld	hl,0xfffa
	jp	@556
;2840 
;2841   ptrEnd = resp + strlen(resp);
@564:
	ld	hl,(ix+5)
	push	hl
	call	_strlen
	pop	de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	(ix-16),hl
;2842 
;2843   if (ptrEnd - ptrPS != 7)  return -7;
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	de,0x7
	or	a,a
	sbc	hl,de
	jr	z,@565
	ld	hl,0xfff9
	jp	@556
;2844   if (ptrPS - ptrAL != 7)  return -8;
@565:
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	de,0x7
	or	a,a
	sbc	hl,de
	jr	z,@566
	ld	hl,0xfff8
	jp	@556
;2845   if (ptrAL - ptrOS != 10)  return -9;
@566:
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	z,@567
	ld	hl,0xfff7
	jp	@556
;2846 
;2847   KLOCK();
@567:
	call	_KLOCK
;2848 
;2849   anaVolts = Cur.ovenReadV[idx];
	ld	hl,(ix+9)
	add	hl,hl
	add	hl,hl
	ld	de,_curState+26
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-40),hl
	ex	de,hl
	ld	(ix-42),hl
	ex	de,hl
;2850   anaSetVolts = Cur.ovenSetV[idx];
	ld	hl,(ix+9)
	add	hl,hl
	add	hl,hl
	ld	de,_curState
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-44),hl
	ex	de,hl
	ld	(ix-46),hl
	ex	de,hl
;2851   anaAmps = Cur.ovenReadA[idx];
	ld	hl,(ix+9)
	add	hl,hl
	add	hl,hl
	ld	de,_curState+42
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-48),hl
	ex	de,hl
	ld	(ix-50),hl
	ex	de,hl
;2852 
;2853   KUNLOCK();
	call	_KUNLOCK
;2854 
;2855 
;2856   actualVolts = atof(ptrAV+2);
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	inc	hl
	inc	hl
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-24),hl
	ex	de,hl
	ld	(ix-26),hl
	ex	de,hl
;2857   setVolts = atof(ptrSV+2);
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-4)
	inc	hl
	inc	hl
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-28),hl
	ex	de,hl
	ld	(ix-30),hl
	ex	de,hl
;2858 
;2859   actualAmps = atof(ptrAA+2);
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-32),hl
	ex	de,hl
	ld	(ix-34),hl
	ex	de,hl
;2860   setAmps = atof(ptrSA+2);
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-8)
	inc	hl
	inc	hl
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-36),hl
	ex	de,hl
	ld	(ix-38),hl
	ex	de,hl
;2861 
;2862   opStatus = strtoi(ptrOS+2, NULL, 2);
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-10)
	inc	hl
	inc	hl
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-52),hl
;2863   alarmStatus = strtoi(ptrAL+2, NULL, 2);
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-12)
	inc	hl
	inc	hl
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-54),hl
;2864   progStatus = strtoi(ptrPS+2, NULL, 2);
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-14)
	inc	hl
	inc	hl
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-56),hl
;2865 
;2866 //tdebug
;2867   _EnterCritical_();  forceErr = (forceOvenErr == 0x0BAD);  _ExitCritical_(
	ipset	2
	ld	hl,(_forceOvenErr)
	ld	de,0xbad
	or	a,a
	sbc	hl,de
	ld	hl,0
	jr	nz,@568
	inc	l
@568:
	ld	(ix-22),l
	ipres
;2868   if (forceErr)  opStatus ^= OOS_OutputOn;
	ld	a,l
	or	a,a
	jr	z,@569
	ld	hl,(ix-52)
	ld	a,l
	xor	a,16
	ld	l,a
	ld	(ix-52),hl
;2869 
;2870   resetAlarms = false;  newline = "\r\n";  msg = resp;
@569:
	xor	a,a
	ld	(ix-21),a
	ld	hl,@2+280
	ld	(ix-18),hl
	ld	hl,(ix+5)
	ld	(ix-20),hl
;2871 
;2872   if ((opStatus ^ Next.ovenOpStatus[idx]) & 0xFE)  {
	ld	hl,(ix+9)
	add	hl,hl
	ld	de,_nextState+58
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-52)
	ex	de,hl
	ld	a,e
	xor	a,l
	ld	l,a
	ld	a,d
	xor	a,h
	ld	h,a
	ld	de,0xfe
	and	hl,de
	jp	z,@570
;2873     printf("%s%s%sOven%d OP Status: [%.8s]\r\n",
;2874            newline, msg, newline, idx+1, LongToBinMS1st(opStatus, temp, 8))
	ld	hl,0x8
	push	hl
	ld	hl,-134+@555
	add	hl,sp
	push	hl
	ld	hl,(ix-52)
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	lcall	$LongToBinMS1st
	add	sp,8
	push	hl
	ld	hl,(ix+9)
	inc	hl
	push	hl
	ld	hl,(ix-18)
	push	hl
	ld	hl,(ix-20)
	push	hl
	ld	hl,(ix-18)
	push	hl
	ld	de,word (phys @1+2405)
	ld	c,phys @1+2405 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,14
;2875     printf("  Constant Voltage: %d\r\n"
;2876            "  Foldback Protection: %d\r\n"
;2877            "  Auto-restart: %d\r\n"
;2878            "  Output ON: %d\r\n"
;2879            "  Foldback SRQ: %d\r\n"
;2880            "  Over voltage SRQ: %d\r\n"
;2881            "  Over temp SRQ: %d\r\n",
;2882            BOOL(opStatus & OOS_ConstVolt),   BOOL(opStatus & OOS_FoldbackPr
;2883            BOOL(opStatus & OOS_AutoRestart), BOOL(opStatus & OOS_OutputOn),
;2884            BOOL(opStatus & OOS_FoldbackSRQ), BOOL(opStatus & OOS_OverVoltSR
;2885            BOOL(opStatus & OOS_OverTempSRQ)
;2886        );
	ld	hl,(ix-52)
	ld	de,0x2
	and	hl,de
	jr	z,@573
	ld	a,0x1
	jr	@574
@573:
	xor	a,a
@574:
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	push	hl
	ld	hl,(ix-52)
	ld	de,0x4
	and	hl,de
	jr	z,@575
	ld	a,0x1
	jr	@576
@575:
	xor	a,a
@576:
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	push	hl
	ld	hl,(ix-52)
	ld	de,0x8
	and	hl,de
	jr	z,@577
	ld	a,0x1
	jr	@578
@577:
	xor	a,a
@578:
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	push	hl
	ld	hl,(ix-52)
	ld	de,0x10
	and	hl,de
	jr	z,@579
	ld	a,0x1
	jr	@580
@579:
	xor	a,a
@580:
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	push	hl
	ld	hl,(ix-52)
	ld	de,0x20
	and	hl,de
	jr	z,@581
	ld	a,0x1
	jr	@582
@581:
	xor	a,a
@582:
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	push	hl
	ld	hl,(ix-52)
	ld	de,0x40
	and	hl,de
	jr	z,@583
	ld	a,0x1
	jr	@584
@583:
	xor	a,a
@584:
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	push	hl
	ld	hl,(ix-52)
	ld	de,0x80
	and	hl,de
	jr	z,@585
	ld	a,0x1
	jr	@586
@585:
	xor	a,a
@586:
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	push	hl
	ld	de,word (phys @1+2438)
	ld	c,phys @1+2438 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,18
;2887     resetAlarms = true;  newline = msg = "";
	ld	(ix-21),0x1
	ld	hl,@2+8
	ld	(ix-20),hl
	ld	(ix-18),hl
;2888   }
;2889 
;2890   if ((alarmStatus & 0x1E) AND
@570:
;2891     ((alarmStatus ^ Next.ovenAlarmStatus[idx]) & 0x1E))  {
	ld	hl,(ix-54)
	ld	de,0x1e
	and	hl,de
	jp	z,@588
	ld	hl,(ix+9)
	add	hl,hl
	ld	de,_nextState+62
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-54)
	ex	de,hl
	ld	a,e
	xor	a,l
	ld	l,a
	ld	a,d
	xor	a,h
	ld	h,a
	ld	de,0x1e
	and	hl,de
	jp	z,@588
;2892     printf("%s%s%sOven%d Alarm Status: [%.8s]\r\n",
;2893            newline, msg, newline, idx+1, LongToBinMS1st(alarmStatus, temp, 
	ld	hl,0x5
	push	hl
	ld	hl,-134+@555
	add	hl,sp
	push	hl
	ld	hl,(ix-54)
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	lcall	$LongToBinMS1st
	add	sp,8
	push	hl
	ld	hl,(ix+9)
	inc	hl
	push	hl
	ld	hl,(ix-18)
	push	hl
	ld	hl,(ix-20)
	push	hl
	ld	hl,(ix-18)
	push	hl
	ld	de,word (phys @1+2592)
	ld	c,phys @1+2592 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,14
;2894     if (alarmStatus & 0x10)  printf("  *** Overvoltage Protection tripped *
	ld	hl,(ix-54)
	ld	de,0x10
	and	hl,de
	jr	z,@591
	ld	de,word (phys @1+2628)
	ld	c,phys @1+2628 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2895     if (alarmStatus & 0x08)  printf("  *** Overtemp Protection tripped ***\
@591:
	ld	hl,(ix-54)
	ld	de,0x8
	and	hl,de
	jr	z,@592
	ld	de,word (phys @1+2671)
	ld	c,phys @1+2671 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2896     if (alarmStatus & 0x04)  printf("  *** Input Voltage Supply Failure ***
@592:
	ld	hl,(ix-54)
	ld	de,0x4
	and	hl,de
	jr	z,@593
	ld	de,word (phys @1+2711)
	ld	c,phys @1+2711 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2897     if (alarmStatus & 0x02)  printf("  *** Foldback Protection tripped ***\
@593:
	ld	hl,(ix-54)
	ld	de,0x2
	and	hl,de
	jr	z,@594
	ld	de,word (phys @1+2752)
	ld	c,phys @1+2752 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2898     if (alarmStatus & 0x01)  printf("  *** Cmd Error ***\r\n");
@594:
	ld	hl,(ix-54)
	ld	de,0x1
	and	hl,de
	jr	z,@595
	ld	de,word (phys @1+2792)
	ld	c,phys @1+2792 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2899     resetAlarms = true;  newline = msg = "";
@595:
	ld	(ix-21),0x1
	ld	hl,@2+8
	ld	(ix-20),hl
	ld	(ix-18),hl
;2900     if (alarmStatus ^ Next.ovenAlarmStatus[idx])
	ld	hl,(ix+9)
	add	hl,hl
	ld	de,_nextState+62
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-54)
	ex	de,hl
	ld	a,e
	xor	a,l
	ld	l,a
	ld	a,d
	xor	a,h
	ld	h,a
	bool	hl
	jp	z,@596
;2901       printf("  Analog:  Volts: %.16s  SetV: %.16s  Amps: %.16s\r\n"
;2902              "  Serial:  Volts: %.16s  SetV: %.16s  Amps: %.16s\r\n",
;2903              Engineering(anaVolts, 4, temp),
;2904              Engineering(anaSetVolts, 4, temp+12),
;2905              Engineering(anaAmps, 4, temp+24),
;2906              Engineering(actualVolts, 4, temp+36),
;2907              Engineering(setVolts, 4, temp+48),
;2908              Engineering(actualAmps, 4, temp+60)
;2909             );
	ld	hl,-76+@555
	add	hl,sp
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-34)
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,-86+@555
	add	hl,sp
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-30)
	ex	de,hl
	ld	hl,(ix-28)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,-96+@555
	add	hl,sp
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-26)
	ex	de,hl
	ld	hl,(ix-24)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,-106+@555
	add	hl,sp
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-50)
	ex	de,hl
	ld	hl,(ix-48)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,-116+@555
	add	hl,sp
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-46)
	ex	de,hl
	ld	hl,(ix-44)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	hl,-126+@555
	add	hl,sp
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-42)
	ex	de,hl
	ld	hl,(ix-40)
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	de,word (phys @1+2814)
	ld	c,phys @1+2814 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;2910   }
@596:
;2911 
;2912   if (progStatus & (progStatus != Next.ovenProgStatus[idx])) {
@588:
	ld	hl,(ix+9)
	add	hl,hl
	ld	de,_nextState+66
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-56)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@597
	ld	hl,1
@597:
	ex	de,hl
	ld	hl,(ix-56)
	ex	de,hl
	and	hl,de
	jp	z,@598
;2913     printf("%s%s%sOven%d Serial Status: [%.8s]\r\n",
;2914            newline, msg, newline, idx+1, LongToBinMS1st(progStatus, temp, 5
	ld	hl,0x5
	push	hl
	ld	hl,-134+@555
	add	hl,sp
	push	hl
	ld	h,d
	ld	l,e
	ld	bc,0
	push	bc
	push	de
	lcall	$LongToBinMS1st
	add	sp,8
	push	hl
	ld	hl,(ix+9)
	inc	hl
	push	hl
	ld	hl,(ix-18)
	push	hl
	ld	hl,(ix-20)
	push	hl
	ld	hl,(ix-18)
	push	hl
	ld	de,word (phys @1+2917)
	ld	c,phys @1+2917 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,14
;2915     if (progStatus & 0x08)  printf("  Unrecognized command\r\n");
	ld	hl,(ix-56)
	ld	de,0x8
	and	hl,de
	jr	z,@601
	ld	de,word (phys @1+2954)
	ld	c,phys @1+2954 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2916     if (progStatus & 0x04)  printf("  Buffer Overflow\r\n");
@601:
	ld	hl,(ix-56)
	ld	de,0x4
	and	hl,de
	jr	z,@602
	ld	de,word (phys @1+2979)
	ld	c,phys @1+2979 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2917     if (progStatus & 0x02)  printf("  Req Voltage out of range\r\n");
@602:
	ld	hl,(ix-56)
	ld	de,0x2
	and	hl,de
	jr	z,@603
	ld	de,word (phys @1+2999)
	ld	c,phys @1+2999 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2918     if (progStatus & 0x01)  printf("  Req Current out of range\r\n");
@603:
	ld	hl,(ix-56)
	ld	de,0x1
	and	hl,de
	jr	z,@604
	ld	de,word (phys @1+3028)
	ld	c,phys @1+3028 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2919     resetAlarms = true;  newline = msg = "";
@604:
	ld	(ix-21),0x1
	ld	hl,@2+8
	ld	(ix-20),hl
	ld	(ix-18),hl
;2920   }
;2921 
;2922   if (resetAlarms)  { write(devfd, ":DCL;", 5);  sleepMS(30);  }
@598:
	ld	a,(ix-21)
	or	a,a
	jr	z,@605
	ld	hl,0x5
	push	hl
	ld	hl,@2+283
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$write
	add	sp,6
	ld	de,0x1e
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;2923 
;2924 
;2925   KLOCK();
@605:
	call	_KLOCK
;2926 
;2927   Next.serOvenReadV[idx] = actualVolts;
	ld	hl,(ix+9)
	add	hl,hl
	add	hl,hl
	ld	de,_nextState+34
	add	hl,de
	ex	de,hl
	ld	hl,(ix-24)
	ld	bc,hl
	ld	hl,(ix-26)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2928   Next.serOvenSetV[idx] = setVolts;
	ld	hl,(ix+9)
	add	hl,hl
	add	hl,hl
	ld	de,_nextState+115
	add	hl,de
	ex	de,hl
	ld	hl,(ix-28)
	ld	bc,hl
	ld	hl,(ix-30)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2929   Next.serOvenReadA[idx] = actualAmps;
	ld	hl,(ix+9)
	add	hl,hl
	add	hl,hl
	ld	de,_nextState+50
	add	hl,de
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	ld	hl,(ix-34)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2930   Next.serOvenSetA[idx] = setAmps;
	ld	hl,(ix+9)
	add	hl,hl
	add	hl,hl
	ld	de,_nextState+123
	add	hl,de
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	ld	hl,(ix-38)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2931   Next.ovenOpStatus[idx] = opStatus;
	ld	hl,(ix+9)
	add	hl,hl
	ld	de,_nextState+58
	add	hl,de
	ex	de,hl
	ld	hl,(ix-52)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2932   Next.ovenAlarmStatus[idx] = alarmStatus;
	ld	hl,(ix+9)
	add	hl,hl
	ld	de,_nextState+62
	add	hl,de
	ex	de,hl
	ld	hl,(ix-54)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2933   Next.ovenProgStatus[idx] = progStatus;
	ld	hl,(ix+9)
	add	hl,hl
	ld	de,_nextState+66
	add	hl,de
	ex	de,hl
	ld	hl,(ix-56)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2934 
;2935   KUNLOCK();
	call	_KUNLOCK
;2936 
;2937   return 0;
	bool	hl
	ld	l,h
;2938 }
@556:
	.debug	} @556 2938

@555	equ	136
	ld	sp,ix
	pop	ix
	lret
@557	equ	138
;2939 
;2940 //-------------------------------------------------------------------------
;2941 //  Process to manage comunications with the Lambda ZUP Power Supply that i
;2942 //  inside the big metal box
;2943 //-------------------------------------------------------------------------
;2944 void _task ovenCom(int argc, char **argv)
;2945 {
	.align	4
$$ovenCom::
	ex	(sp),iy
$ovenCom::
	.debug	G $ovenCom 73 9
	.debug	{ $ovenCom 73 2944 @610 @609
	ld	hl,-297
	call	__fent##
;2946   int  i, stat, fflags, ch;
;2947   uint  idx;
;2948   fd_t  devfd;
;2949   bool  gotValidResp, shouldBeOn, isOn;
;2950   U16  *numMsgs, *goodMsgs, *badMsgs;
;2951   ulong  baudRate, lastRcvTime;
;2952   char  *nextCmd;
;2953   BufInfo  bufInfo;
;2954   char  buf[128], readBuf[128];
;2955 
;2956 
;2957   redirectStdio();
	lcall	$redirectStdio
;2958 
;2959   if (argc < 2)  Exit(-1);
	ld	hl,(ix+5)
	ld	de,0x8002
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@611
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;2960 
;2961   idx = (uint)argv[1][0] - '1';  if (idx > 1)  Exit(-2);
@611:
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	a,(hl)
	bool	hl
	ld	l,a
	ld	de,0xffcf
	add	hl,de
	ld	(ix-10),hl
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	c,@612
	jr	z,@612
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
;2962 
;2963   ovenLastRespTime[idx] = 0;  gotValidResp = false;
@612:
	ld	hl,(ix-10)
	add	hl,hl
	add	hl,hl
	ld	de,_ovenLastRespTime
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	xor	a,a
	ld	(ix-13),a
;2964   if (!idx)  {
	ld	hl,(ix-10)
	bool	hl
	jr	nz,@613
;2965     numMsgs = &oven1NumMsgs;
	ld	hl,_oven1NumMsgs
	ld	(ix-17),hl
;2966     goodMsgs = &oven1GoodMsgs;
	ld	hl,_oven1GoodMsgs
	ld	(ix-19),hl
;2967     badMsgs = &oven1BadMsgs;
	ld	hl,_oven1BadMsgs
	ld	(ix-21),hl
;2968   }
;2969   else  {
	jr	@616
@613:
;2970     numMsgs = &oven2NumMsgs;
	ld	hl,_oven2NumMsgs
	ld	(ix-17),hl
;2971     goodMsgs = &oven2GoodMsgs;
	ld	hl,_oven2GoodMsgs
	ld	(ix-19),hl
;2972     badMsgs = &oven2BadMsgs;
	ld	hl,_oven2BadMsgs
	ld	(ix-21),hl
;2973   }
;2974 
;2975   *numMsgs = *goodMsgs = *badMsgs = 0;
@616:
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,(ix-21)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-19)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-17)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2976 
;2977 
;2978 //--- (re)open and initialize port for communicating with the RF Gen PS ---
;2979 //--- idx == 0: oven1, /dev/tty2;  idx == 1: oven2, /dev/tty1 ---
;2980   sprintf(buf, "/dev/tty%d", idx ? 1 : 2);
	ld	hl,(ix-10)
	bool	hl
	jr	z,@619
	ld	a,0x1
	jr	@620
@619:
	ld	a,0x2
@620:
	ld	l,a
	rlca
	sbc	a,a
	ld	h,a
	push	hl
	ld	de,word (phys @1+3057)
	ld	c,phys @1+3057 >> 16
	push	bc
	push	de
	ld	hl,-163+@608
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;2981   if ((devfd = open(buf, O_RDWR, 0)) < 0)  {
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x2
	push	hl
	ld	hl,-165+@608
	add	hl,sp
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-12),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@621
;2982     printf("Unable to open %s for Oven%d PS\r\n", buf, idx+1);  Exit(-3); }
	ld	hl,(ix-10)
	inc	hl
	push	hl
	ld	hl,-167+@608
	add	hl,sp
	push	hl
	ld	de,word (phys @1+3068)
	ld	c,phys @1+3068 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	hl,0xfffd
	push	hl
	lcall	$Exit
	pop	hl
;2983 
;2984   fflags = fcntl(devfd, F_GETFL, 0);
@621:
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,(ix-12)
	push	hl
	lcall	$fcntl
	add	sp,6
	ld	(ix-6),hl
;2985   fcntl(devfd, F_SETFL, fflags | O_NONBLOCK);
	set	5,l
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-12)
	push	hl
	lcall	$fcntl
	add	sp,6
;2986 
;2987   baudRate = 9600;  ioctl(devfd, IOC_SET_BAUD, &baudRate);
	ld	de,0x2580
	ld	hl,0
	ld	(ix-23),hl
	ex	de,hl
	ld	(ix-25),hl
	ex	de,hl
	ld	hl,-25+@608
	add	hl,sp
	push	hl
	ld	hl,0x3ea
	push	hl
	ld	hl,(ix-12)
	push	hl
	lcall	$ioctl
	add	sp,6
;2988 
;2989   *buf = 0;
	xor	a,a
	ld	hl,-169+@608
	add	hl,sp
	ld	(hl),a
;2990 
;2991   bufInfo.buf = readBuf;  bufInfo.bufSize = sizeof(readBuf);
	ld	hl,-297+@608
	add	hl,sp
	ld	(ix-41),hl
	ld	hl,0x80
	ld	(ix-37),hl
;2992   bufInfo.fd = devfd;  bufInfo.nextOut = bufInfo.count = 0;
	ld	hl,(ix-12)
	ld	(ix-39),hl
	bool	hl
	ld	l,h
	ld	(ix-33),hl
	ld	(ix-35),hl
;2993 
;2994 
;2995   for (;;)  {
@626:
@628:
;2996     KLOCK();
	call	_KLOCK
;2997     if (!*buf)
	ld	hl,-169+@608
	add	hl,sp
	ld	a,(hl)
	or	a,a
	jr	nz,@631
;2998       *goodMsgs = *badMsgs = postOvenResetMsgs[idx] = 0;
	ld	hl,(ix-10)
	add	hl,hl
	ld	de,_postOvenResetMsgs
	add	hl,de
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-21)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-19)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2999     else  {
	jr	@632
@631:
;3000       ++*numMsgs;
	ld	hl,(ix-17)
	ld	hl,(hl)
	inc	hl
	ex	de,hl
	ld	hl,(ix-17)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3001       if (gotValidResp)  {
	ld	a,(ix-13)
	or	a,a
	jr	z,@635
;3002         ++*goodMsgs;  ++postOvenResetMsgs[idx];  *badMsgs = 0;  }
	ld	hl,(ix-19)
	ld	hl,(hl)
	inc	hl
	ex	de,hl
	ld	hl,(ix-19)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-10)
	add	hl,hl
	ld	de,_postOvenResetMsgs
	add	hl,de
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,(ix-21)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3003       else  {
	jr	@638
@635:
;3004         *goodMsgs = postOvenResetMsgs[idx] = 0;  ++*badMsgs;  }
	ld	hl,(ix-10)
	add	hl,hl
	ld	de,_postOvenResetMsgs
	add	hl,de
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-19)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-21)
	ld	hl,(hl)
	inc	hl
	ex	de,hl
	ld	hl,(ix-21)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3005     }
@638:
;3006     KUNLOCK();
@632:
	call	_KUNLOCK
;3007 
;3008   //--- read any existing msg in the buffer ---
;3009     for (i=0;;)  {
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@643:
;3010       if ((stat = readBufCh(&bufInfo)) < 0)  break;
	ld	hl,-41+@608
	add	hl,sp
	push	hl
	lcall	$readBufCh
	pop	de
	ld	(ix-4),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@644
;3011       ch = stat & 0x7f;  if (ch == 0x0D)  break;
	ld	hl,(ix-4)
	ld	de,0x7f
	and	hl,de
	ld	(ix-8),hl
	ld	e,0xd
	or	a,a
	sbc	hl,de
	jr	z,@644
;3012       if (ch > ' ')  ++i;
	ld	hl,(ix-8)
	ld	de,0x8020
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@643
	jr	z,@643
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
;3013     }
;3014     if (i) continue;
	jr	@643
@644:
	ld	hl,(ix-2)
	bool	hl
	jp	nz,@628
;3015 
;3016   //--- specify which supply we want to talk to ---
;3017     write(devfd, ":ADR01;", 7);  sleepMS(50);
	ld	l,0x7
	push	hl
	ld	hl,@2+289
	push	hl
	ld	hl,(ix-12)
	push	hl
	lcall	$write
	add	sp,6
	ld	de,0x32
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3018   //--- help insure Remote mode is not disabled by accident ---
;3019     write(devfd, ":RMT2;", 6);  sleepMS(50);
	ld	hl,0x6
	push	hl
	ld	hl,@2+297
	push	hl
	ld	hl,(ix-12)
	push	hl
	lcall	$write
	add	sp,6
	ld	de,0x32
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3020 
;3021   //--- set state of output ---
;3022     shouldBeOn = BOOL(Cur.enableOvenOutput[idx]);
	ld	hl,(ix-10)
	ld	de,_curState+105
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@652
	ld	a,0x1
	jr	@653
@652:
	xor	a,a
@653:
	ld	(ix-14),a
;3023     isOn = BOOL(Cur.ovenOpStatus[idx] & OOS_OutputOn);
	ld	hl,(ix-10)
	add	hl,hl
	ld	de,_curState+58
	add	hl,de
	ld	hl,(hl)
	ld	de,0x10
	and	hl,de
	jr	z,@654
	ld	a,0x1
	jr	@655
@654:
	xor	a,a
@655:
	ld	(ix-15),a
;3024     if (shouldBeOn != isOn)  {
	ld	a,(ix-14)
	ld	hl,(ix-15)
	sub	a,l
	jr	z,@656
;3025       write(devfd, (Cur.enableOvenOutput[idx] ? ":OUT1;" : ":OUT0;"), 6);
	ld	hl,0x6
	push	hl
	ld	hl,(ix-10)
	ld	de,_curState+105
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@659
	ld	hl,@2+304
	jr	@660
@659:
	ld	hl,@2+311
@660:
	push	hl
	ld	hl,(ix-12)
	push	hl
	lcall	$write
	add	sp,6
;3026       sleepMS(50);
	ld	de,0x32
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3027     }
;3028 
;3029   //--- request the complete status ---
;3030     nextCmd = (*ovenCmd[idx] ? ovenCmd[idx] : ":STT?;");
@656:
	ld	hl,(ix-10)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_ovenCmd
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@662
	ld	hl,(ix-10)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,de
	jr	@663
@662:
	ld	hl,@2+318
@663:
	ld	(ix-31),hl
;3031     fcntl(devfd, F_SETFL, fflags);
	ld	hl,(ix-6)
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-12)
	push	hl
	lcall	$fcntl
	add	sp,6
;3032     write(devfd, nextCmd, strlen(nextCmd));  sleepMS(100);
	ld	hl,(ix-31)
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,(ix-31)
	push	hl
	ld	hl,(ix-12)
	push	hl
	lcall	$write
	add	sp,6
	ld	de,0x64
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3033     fcntl(devfd, F_SETFL, fflags | O_NONBLOCK);
	ld	hl,(ix-6)
	set	5,l
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-12)
	push	hl
	lcall	$fcntl
	add	sp,6
;3034     *ovenCmd[idx] = 0;  gotValidResp = false;
	ld	hl,(ix-10)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_ovenCmd
	add	hl,de
	xor	a,a
	ld	(hl),a
	xor	a,a
	ld	(ix-13),a
;3035 
;3036   //--- wait for response ---
;3037     lastRcvTime = GetMS();  *buf = 0;
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-27),hl
	ex	de,hl
	ld	(ix-29),hl
	ex	de,hl
	xor	a,a
	ld	hl,-169+@608
	add	hl,sp
	ld	(hl),a
;3038     for (i=0; i<sizeof(buf)-2; )  {
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@667:
	ld	hl,(ix-2)
	ld	de,0x807e
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@668
;3039       stat = readBufCh(&bufInfo);
	ld	hl,-41+@608
	add	hl,sp
	push	hl
	lcall	$readBufCh
	pop	de
	ld	(ix-4),hl
;3040       if (stat > 0)  {
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@671
	jp	z,@671
;3041 //        printf("<%02x>", buf[i]);  //tdebug
;3042         buf[i] = (uint)stat & 0x7f;  lastRcvTime  = GetMS();
	ld	hl,(ix-4)
	ld	de,0x7f
	and	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,hl
	ld	hl,-169+@608
	add	hl,sp
	add	hl,de
	ld	(hl),c
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-27),hl
	ex	de,hl
	ld	(ix-29),hl
	ex	de,hl
;3043         if (buf[i] == 0x0D)  break;
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,-169+@608
	add	hl,sp
	add	hl,de
	ld	a,(hl)
	sub	a,13
	jp	z,@668
;3044         ++i;  continue;
	ld	h,d
	ld	l,e
	inc	hl
	ld	(ix-2),hl
;3045       }
	jp	@667
;3046       if ((stat < 0) AND (errno != EAGAIN))  {
@671:
	ld	hl,(ix-4)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@676
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	z,@676
;3047         perror("error reading resp from Oven supply");  break; }
	ld	de,word (phys @1+3102)
	ld	c,phys @1+3102 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	jp	@668
;3048       if (msSince(lastRcvTime) > 1000)  break;
@676:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-29)
	ex	de,hl
	ld	hl,(ix-27)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__lsub##
	jr	c,@679
	jr	nz,@668
;3049       sleepMS(50);
@679:
	ld	de,0x32
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3050     }
;3051     if (!i)  continue;
	jp	@667
@668:
	ld	hl,(ix-2)
	bool	hl
	jp	z,@628
;3052 
;3053     if (buf[i] != 0x0D)  {
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,-169+@608
	add	hl,sp
	add	hl,de
	ld	a,(hl)
	sub	a,13
	jr	z,@681
;3054       buf[i+1] = 0;
	ld	h,d
	ld	l,e
	inc	hl
	ex	de,hl
	ld	hl,-169+@608
	add	hl,sp
	add	hl,de
	xor	a,a
	ld	(hl),a
;3055       if (*badMsgs > 2)  printf("mangled response: [%.128s]\r\n", buf);
	ld	hl,(ix-21)
	ld	hl,(hl)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	c,@684
	jr	z,@684
	ld	hl,-169+@608
	add	hl,sp
	push	hl
	ld	de,word (phys @1+3138)
	ld	c,phys @1+3138 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3056       continue;
@684:
;3057     }
	jp	@628
;3058 
;3059     buf[i] = 0;
@681:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,-169+@608
	add	hl,sp
	add	hl,de
	xor	a,a
	ld	(hl),a
;3060 
;3061   //--- process the response ---
;3062     if (ShowPackets)  printf("[%.128s]\r\n", buf);
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@685
	ld	hl,-169+@608
	add	hl,sp
	push	hl
	ld	de,word (phys @1+1690)
	ld	c,phys @1+1690 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3063 
;3064     if (nextCmd == ovenCmd[idx])  {
@685:
	ld	hl,(ix-10)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_ovenCmd
	add	hl,de
	ex	de,hl
	ld	hl,(ix-31)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@686
;3065       KLOCK();  strncpy(ovenResp[idx], buf, sizeof(ovenResp[0])-1);  KUNLOC
	call	_KLOCK
	ld	hl,0x3f
	push	hl
	ld	hl,-167+@608
	add	hl,sp
	push	hl
	ld	hl,(ix-10)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_ovenResp
	add	hl,de
	push	hl
	call	_strncpy
	add	sp,6
	call	_KUNLOCK
;3066       gotValidResp = true;
	ld	a,0x1
	ld	(ix-13),a
;3067     }
;3068     else
;3069       if (Process_Oven_PS_Resp(buf, devfd, idx))  {
	jp	@689
@686:
	ld	hl,(ix-10)
	push	hl
	ld	hl,(ix-12)
	push	hl
	ld	hl,-165+@608
	add	hl,sp
	push	hl
	lcall	$Process_Oven_PS_Resp
	add	sp,6
	bool	hl
	jr	z,@690
;3070         if (*badMsgs > 2) printf("Invalid resp: [%.128s]\r\n", buf);  }
	ld	hl,(ix-21)
	ld	hl,(hl)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	c,@694
	jp	z,@694
	ld	hl,-169+@608
	add	hl,sp
	push	hl
	ld	de,word (phys @1+3167)
	ld	c,phys @1+3167 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3071       else  {
	jp	@694
@690:
;3072         _EnterCritical_();
	ipset	2
;3073         ovenLastRespTime[idx] = GetMS();  newOvenResp[idx] = true;
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-10)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_ovenLastRespTime
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-10)
	ld	de,_newOvenResp
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;3074         _ExitCritical_();
	ipres
;3075         gotValidResp = true;
	ld	(ix-13),0x1
;3076       }
;3077 
;3078     sleepMS(200);
@694:
@689:
	ld	de,0xc8
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3079   }
;3080 
;3081 }
	jp	@626
@609:
	.debug	} @609 3081

@608	equ	297
	ld	sp,ix
	pop	ix
	lret
@610	equ	299
;3082 
;3083 
;3084 
;3085 //=========================================================================
;3086 _nearcall float readGetRaw(uint ui)  {
	.align	4
$$readGetRaw::
	ex	(sp),iy
$readGetRaw::
	.debug	G $readGetRaw 77 9
	.debug	{ $readGetRaw 77 3086 @699 @698
	push	ix
	ld	ix,0
	add	ix,sp
;3087   return (ui < NumHdwADC ? anaIn[ui] : 0.0);  }
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@700
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@698
@700:
	ld	de,0
	ld	c,e
	ld	b,e
@698:
	.debug	} @698 3087

@697	equ	0
	pop	ix
	lret
@699	equ	2
;3088 
;3089 _nearcall float readMinRaw(uint ui)  {
	.align	4
$$readMinRaw::
	ex	(sp),iy
$readMinRaw::
	.debug	G $readMinRaw 77 9
	.debug	{ $readMinRaw 77 3089 @704 @703
	push	ix
	ld	ix,0
	add	ix,sp
;3090   return (ui < NumHdwADC) ? (adcMinRaw(ui) - adcOffset[ui]) * adcGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@705
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMinRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@703
@705:
	ld	de,0
	ld	c,e
	ld	b,e
@703:
	.debug	} @703 3090

@702	equ	0
	pop	ix
	lret
@704	equ	2
;3091 
;3092 _nearcall float readMaxRaw(uint ui)  {
	.align	4
$$readMaxRaw::
	ex	(sp),iy
$readMaxRaw::
	.debug	G $readMaxRaw 77 9
	.debug	{ $readMaxRaw 77 3092 @709 @708
	push	ix
	ld	ix,0
	add	ix,sp
;3093   return (ui < NumHdwADC) ? (adcMaxRaw(ui) - adcOffset[ui]) * adcGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@710
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMaxRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@708
@710:
	ld	de,0xcccd
	ld	bc,0x411c
@708:
	.debug	} @708 3093

@707	equ	0
	pop	ix
	lret
@709	equ	2
;3094 
;3095 _nearcall void readDefaults(uint ui, float *gain, float *offset)  {
	.align	4
$$readDefaults::
	ex	(sp),iy
$readDefaults::
	.debug	G $readDefaults 78 9
	.debug	{ $readDefaults 78 3095 @714 @713
	push	ix
	ld	ix,0
	add	ix,sp
;3096   *gain = 1.0;  *offset = 0.0; }
	ld	de,0
	ld	bc,0x3f80
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	c,e
	ld	b,e
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@713:
	.debug	} @713 3096

@712	equ	0
	pop	ix
	lret
@714	equ	2
;3097 
;3098 _nearcall void readCalibPoints(uint ui, float *low, float *high)  {
	.align	4
$$readCalibPoints::
	ex	(sp),iy
$readCalibPoints::
	.debug	G $readCalibPoints 78 9
	.debug	{ $readCalibPoints 78 3098 @717 @716
	push	ix
	ld	ix,0
	add	ix,sp
;3099   *low = -9.5;  *high = 9.5; }
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@716:
	.debug	} @716 3099

@715	equ	0
	pop	ix
	lret
@717	equ	2
;3100 
;3101 _nearcall char *readUnits(uint ui, char *buf)  { return "V"; }
	.align	4
$$readUnits::
	ex	(sp),iy
$readUnits::
	.debug	G $readUnits 79 9
	.debug	{ $readUnits 79 3101 @720 @719
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,@2+260
@719:
	.debug	} @719 3101

@718	equ	0
	pop	ix
	lret
@720	equ	2
;3102 
;3103 
;3104 //=========================================================================
;3105 _nearcall float setGetRaw(uint ui)  {
	.align	4
$$setGetRaw::
	ex	(sp),iy
$setGetRaw::
	.debug	G $setGetRaw 77 9
	.debug	{ $setGetRaw 77 3105 @723 @722
	push	ix
	ld	ix,0
	add	ix,sp
;3106   return (ui < NumHdwADC ? anaOut[ui] : 0.0);  }
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@724
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_anaOut
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@722
@724:
	ld	de,0
	ld	c,e
	ld	b,e
@722:
	.debug	} @722 3106

@721	equ	0
	pop	ix
	lret
@723	equ	2
;3107 
;3108 _nearcall float setMinRaw(uint ui)  {
	.align	4
$$setMinRaw::
	ex	(sp),iy
$setMinRaw::
	.debug	G $setMinRaw 77 9
	.debug	{ $setMinRaw 77 3108 @728 @727
	push	ix
	ld	ix,0
	add	ix,sp
;3109   return (ui < NumHdwDAC) ? (dacMinRaw(ui) - dacOffset[ui]) * dacGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@729
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMinRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@727
@729:
	ld	de,0
	ld	c,e
	ld	b,e
@727:
	.debug	} @727 3109

@726	equ	0
	pop	ix
	lret
@728	equ	2
;3110 
;3111 _nearcall float setMaxRaw(uint ui)  {
	.align	4
$$setMaxRaw::
	ex	(sp),iy
$setMaxRaw::
	.debug	G $setMaxRaw 77 9
	.debug	{ $setMaxRaw 77 3111 @733 @732
	push	ix
	ld	ix,0
	add	ix,sp
;3112   return (ui < NumHdwDAC) ? (dacMaxRaw(ui) - dacOffset[ui]) * dacGain[ui] :
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@734
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMaxRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@732
@734:
	ld	de,0xcccd
	ld	bc,0x411c
@732:
	.debug	} @732 3112

@731	equ	0
	pop	ix
	lret
@733	equ	2
;3113 
;3114 _nearcall void setDefaults(uint ui, float *gain, float *offset)  {
	.align	4
$$setDefaults::
	ex	(sp),iy
$setDefaults::
	.debug	G $setDefaults 78 9
	.debug	{ $setDefaults 78 3114 @738 @737
	push	ix
	ld	ix,0
	add	ix,sp
;3115   *gain = 1.0;  *offset = 0.0;  }
	ld	de,0
	ld	bc,0x3f80
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	c,e
	ld	b,e
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@737:
	.debug	} @737 3115

@736	equ	0
	pop	ix
	lret
@738	equ	2
;3116 
;3117 _nearcall void setCalibPoints(uint ui, float *low, float *high)  {
	.align	4
$$setCalibPoints::
	ex	(sp),iy
$setCalibPoints::
	.debug	G $setCalibPoints 78 9
	.debug	{ $setCalibPoints 78 3117 @741 @740
	push	ix
	ld	ix,0
	add	ix,sp
;3118   *low = -9.5;  *high = 9.5;  }
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@740:
	.debug	} @740 3118

@739	equ	0
	pop	ix
	lret
@741	equ	2
;3119 
;3120 _nearcall char *setUnits(uint ui, char *buf)  { return "V"; }
	.align	4
$$setUnits::
	ex	(sp),iy
$setUnits::
	.debug	G $setUnits 79 9
	.debug	{ $setUnits 79 3120 @744 @743
	push	ix
	ld	ix,0
	add	ix,sp
	ld	hl,@2+260
@743:
	.debug	} @743 3120

@742	equ	0
	pop	ix
	lret
@744	equ	2
;3121 
;3122 
;3123 //=========================================================================
;3124 //  Set default labels for all the I/O signals
;3125 //=========================================================================
;3126 void setDefaultLabels(void)
;3127 {
$setDefaultLabels::
	.debug	G $setDefaultLabels 61 9
	.debug	{ $setDefaultLabels 61 3126 @747 @746
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;3128   uint  u;
;3129 
;3130 
;3131   printf("Setting default labels for I/O signals\r\n");
	ld	de,word (phys @1+3192)
	ld	c,phys @1+3192 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3132 
;3133 //--- set application-appropriate default labels ---
;3134 //APPLCODE
;3135 
;3136 //--- set default labels for the I/O signals ---
;3137 //--- Fixed size arrays are used so the values can be changed at run time -
;3138 //--- (i.e. if pointers where used instead, and initialized to const string
;3139 //--- values, then we couldn't change them at run time) ---
;3140 /*
;3141   fstrcpy(ainLabel[0], "ai0-Descr");
;3142   fstrcpy(ainLabel[1], "ai1-Descr");
;3143 
;3144   fstrcpy(aoutLabel[0], "ao0-Descr");
;3145   fstrcpy(aoutLabel[1], "ao1-Descr");
;3146 
;3147   fstrcpy(dinLabel[0], "di0-Descr");
;3148   fstrcpy(dinLabel[1], "di1-Descr");
;3149 
;3150   fstrcpy(doutLabel[0], "do0-Descr");
;3151   fstrcpy(doutLabel[1], "do1-Descr");
;3152 */
;3153 
;3154   for (u=0; u<NUM_APPL_DIN; ++u)
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@750:
	ld	hl,(ix-2)
	ld	de,0x16
	or	a,a
	sbc	hl,de
	jr	nc,@751
;3155     farsprintf((char far *)dinLabel[u], "unused DI-%02u", u);
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+3233)
	ld	c,phys @1+3233 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;3156   for (u=8; (u<NUM_APPL_DIN) AND (u<16); ++u)
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@750
@751:
	ld	hl,0x8
	ld	(ix-2),hl
@755:
	ld	hl,(ix-2)
	ld	de,0x16
	or	a,a
	sbc	hl,de
	jr	nc,@757
	ld	hl,(ix-2)
	ld	e,0x10
	or	a,a
	sbc	hl,de
	jr	nc,@757
;3157     farsprintf((char far *)dinLabel[u], "ID_SW_%02u", u-8);
	ld	hl,(ix-2)
	ld	de,0xfff8
	add	hl,de
	push	hl
	ld	de,word (phys @1+3248)
	ld	c,phys @1+3248 >> 16
	push	bc
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;3158   for (u=0; u<NUM_APPL_DOUT; ++u)
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@755
@757:
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@762:
	ld	hl,(ix-2)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	nc,@763
;3159     farsprintf((char far *)doutLabel[u], "unused DO-%02u", u);
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+3259)
	ld	c,phys @1+3259 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
;3160 
;3161   fstrcpy(dinLabel[16], "Sputter Interlock OK");
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@762
@763:
	ld	de,word (phys @1+3274)
	ld	c,phys @1+3274 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+384)
	ld	c,phys _dinLabel+384 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3162   fstrcpy(dinLabel[17], "Not HotShot RF PS");
	ld	de,word (phys @1+3295)
	ld	c,phys @1+3295 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+408)
	ld	c,phys _dinLabel+408 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3163   fstrcpy(dinLabel[18], "Not NovaStar RF PS");
	ld	de,word (phys @1+3313)
	ld	c,phys @1+3313 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+432)
	ld	c,phys _dinLabel+432 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3164 //  fstrcpy(dinLabel[19], "RF PS Fault OK");
;3165 //  fstrcpy(dinLabel[20], "RF PS Heat OFF");
;3166 //  fstrcpy(dinLabel[21], "RF PS NOT Ready");
;3167 
;3168 
;3169   fstrcpy(doutLabel[0], "Activity LED");
	ld	de,word (phys @1+3332)
	ld	c,phys @1+3332 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3170 
;3171   fstrcpy(doutLabel[4], "Oven2 PS Power OFF");
	ld	de,word (phys @1+3345)
	ld	c,phys @1+3345 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+96)
	ld	c,phys _doutLabel+96 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3172   fstrcpy(doutLabel[5], "Oven2 Output Disabled");
	ld	de,word (phys @1+3364)
	ld	c,phys @1+3364 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+120)
	ld	c,phys _doutLabel+120 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3173 //  fstrcpy(doutLabel[6], "Enable Ext RS-485 Rx");
;3174 //  fstrcpy(doutLabel[7], "Enable Ext RS-485 Tx");
;3175   fstrcpy(doutLabel[8], "Oven1 Output Disabled");
	ld	de,word (phys @1+3386)
	ld	c,phys @1+3386 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+192)
	ld	c,phys _doutLabel+192 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3176 //  fstrcpy(doutLabel[9], "RF PS Reset Pulse");
;3177 //  fstrcpy(doutLabel[10], "RF PS Stop Pulse");
;3178   fstrcpy(doutLabel[11], "Extern Watchdog Timer");
	ld	de,word (phys @1+3408)
	ld	c,phys @1+3408 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+264)
	ld	c,phys _doutLabel+264 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3179   fstrcpy(doutLabel[12], "Oven1 PS Power OFF");
	ld	de,word (phys @1+3430)
	ld	c,phys @1+3430 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+288)
	ld	c,phys _doutLabel+288 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3180   fstrcpy(doutLabel[13], "Bias PS Power OFF");
	ld	de,word (phys @1+3449)
	ld	c,phys @1+3449 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+312)
	ld	c,phys _doutLabel+312 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3181   fstrcpy(doutLabel[14], "Sputter PS Power OFF");
	ld	de,word (phys @1+3467)
	ld	c,phys @1+3467 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+336)
	ld	c,phys _doutLabel+336 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3182 //  fstrcpy(doutLabel[15], "RF Gen PS Start Pulse");
;3183 
;3184 
;3185   fstrcpy(ainLabel[0], "Oven1 Read V");
	ld	de,word (phys @1+3488)
	ld	c,phys @1+3488 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3186   fstrcpy(ainLabel[1], "Bias Read V");
	ld	de,word (phys @1+3501)
	ld	c,phys @1+3501 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+24)
	ld	c,phys _ainLabel+24 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3187   fstrcpy(ainLabel[2], "Sputter Read V");
	ld	de,word (phys @1+3513)
	ld	c,phys @1+3513 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+48)
	ld	c,phys _ainLabel+48 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3188   fstrcpy(ainLabel[3], "Sputter Read A");
	ld	de,word (phys @1+3528)
	ld	c,phys @1+3528 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+72)
	ld	c,phys _ainLabel+72 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3189   fstrcpy(ainLabel[4], "Bias Read A");
	ld	de,word (phys @1+3543)
	ld	c,phys @1+3543 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+96)
	ld	c,phys _ainLabel+96 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3190   fstrcpy(ainLabel[5], "Oven1 Read A");
	ld	de,word (phys @1+3555)
	ld	c,phys @1+3555 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+120)
	ld	c,phys _ainLabel+120 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3191   fstrcpy(ainLabel[6], "Oven2 Read V");
	ld	de,word (phys @1+3568)
	ld	c,phys @1+3568 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+144)
	ld	c,phys _ainLabel+144 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3192   fstrcpy(ainLabel[7], "Oven2 Read A");
	ld	de,word (phys @1+3581)
	ld	c,phys @1+3581 >> 16
	push	bc
	push	de
	ld	de,word (phys _ainLabel+168)
	ld	c,phys _ainLabel+168 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3193 
;3194   fstrcpy(aoutLabel[0], "Oven1 Set V");
	ld	de,word (phys @1+3594)
	ld	c,phys @1+3594 >> 16
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3195   fstrcpy(aoutLabel[1], "Bias Set V");
	ld	de,word (phys @1+3606)
	ld	c,phys @1+3606 >> 16
	push	bc
	push	de
	ld	de,word (phys _aoutLabel+24)
	ld	c,phys _aoutLabel+24 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3196   fstrcpy(aoutLabel[2], "Sputter Set V");
	ld	de,word (phys @1+3617)
	ld	c,phys @1+3617 >> 16
	push	bc
	push	de
	ld	de,word (phys _aoutLabel+48)
	ld	c,phys _aoutLabel+48 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3197 //  fstrcpy(aoutLabel[3], "RF Gen Set V");
;3198   fstrcpy(aoutLabel[3], "Oven2 Set V");
	ld	de,word (phys @1+3631)
	ld	c,phys @1+3631 >> 16
	push	bc
	push	de
	ld	de,word (phys _aoutLabel+72)
	ld	c,phys _aoutLabel+72 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3199 }
@746:
	.debug	} @746 3199

@745	equ	2
	ld	sp,ix
	pop	ix
	lret
@747	equ	4
;3200 
;3201 
;3202 
;3203 
;3204 //=========================================================================
;3205 //  This function is called to force software configurable values to defaul
;3206 //  values.
;3207 //=========================================================================
;3208 void setDefaultConfig(void)
;3209 {
$setDefaultConfig::
	.debug	G $setDefaultConfig 61 9
	.debug	{ $setDefaultConfig 61 3208 @767 @766
;3210   printf("Setting in-RAM device config to default values\r\n");
	ld	de,word (phys @1+3643)
	ld	c,phys @1+3643 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3211 
;3212 //===== set default values for persistent data values =====
;3213 //APPLCODE
;3214 
;3215   sptrMaxErrV = 50.0;  // max diff between Sputter setpoint and readback
	ld	de,0
	ld	bc,0x4248
	ld	(_sptrMaxErrV),de
	ld	(_sptrMaxErrV+2),bc
;3216   sptrMaxErrMS = 5000;  // max time read/set err can exceed sptrMaxErrV
	ld	de,0x1388
	ld	bc,0
	ld	(_sptrMaxErrMS),de
	ld	(_sptrMaxErrMS+2),bc
;3217 
;3218   biasMaxErrV = 50.0;  // max diff between Bias setpoint and readback
	ld	d,b
	ld	e,c
	ld	bc,0x4248
	ld	(_biasMaxErrV),de
	ld	(_biasMaxErrV+2),bc
;3219   biasMaxErrMS = 5000;  // max time read/set err can exceed biasMaxErrV
	ld	de,0x1388
	ld	bc,0
	ld	(_biasMaxErrMS),de
	ld	(_biasMaxErrMS+2),bc
;3220 
;3221   oven1MaxErrV = 2.0;  // max diff between oven setpoint and readback
	ld	d,b
	ld	e,c
	ld	bc,0x4000
	ld	(_oven1MaxErrV),de
	ld	(_oven1MaxErrV+2),bc
;3222   oven1MaxErrMS = 3000;  // max time read/set err can exceed ovenMaxErrV
	ld	de,0xbb8
	ld	b,c
	ld	(_oven1MaxErrMS),de
	ld	(_oven1MaxErrMS+2),bc
;3223   oven1PwrOffDelay = 3000;  // # ms from off cmd to Oven PS AC power cutoff
	ld	h,d
	ld	l,e
	ld	(_oven1PwrOffDelay),hl
;3224 
;3225   oven2MaxErrV = 2.0;  // max diff between oven setpoint and readback
	ld	d,b
	ld	e,c
	ld	bc,0x4000
	ld	(_oven2MaxErrV),de
	ld	(_oven2MaxErrV+2),bc
;3226   oven2MaxErrMS = 3000;  // max time read/set err can exceed ovenMaxErrV
	ld	d,h
	ld	e,l
	ld	b,c
	ld	(_oven2MaxErrMS),de
	ld	(_oven2MaxErrMS+2),bc
;3227   oven2PwrOffDelay = 3000;  // # ms from off cmd to Oven PS AC power cutoff
	ld	(_oven2PwrOffDelay),hl
;3228 }
@766:
	.debug	} @766 3228

@765	equ	0
	lret
@767	equ	0
;3229 
;3230 
;3231 //=========================================================================
;3232 //  This function is called by the application loop just before a shutdown.
;3233 //  The appliation must do whatever is necessary for a clean shutdown and
;3234 //  then exit
;3235 //=========================================================================
;3236 void applicShutdown(void)
;3237 {
$applicShutdown::
	.debug	G $applicShutdown 61 9
	.debug	{ $applicShutdown 61 3236 @770 @769
;3238   printf("Application prepping for shutdown\r\n");  fflush(stdout);
	ld	de,word (phys @1+3692)
	ld	c,phys @1+3692 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
;3239 
;3240 //APPLCODE
;3241 
;3242 
;3243   Exit(0);
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;3244 }
@769:
	.debug	} @769 3244

@768	equ	0
	lret
@770	equ	0
;3245 
;3246 
;3247 //=========================================================================
;3248 //  This is the highest priority task, usually resumed at a regular interva
;3249 //  so that it can do what it needs and sleep again until the start of the
;3250 //  next interval.
;3251 //=========================================================================
;3252 void _task applic(int argc, char **argv)
;3253 {
	.align	4
$$applic::
	ex	(sp),iy
$applic::
	.debug	G $applic 73 9
	.debug	{ $applic 73 3252 @773 @772
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-116
;3254   uint  idx;
;3255 
;3256   #define SharedApplLocals
;3257   #include <sharedAppl.c>
;3258 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;3259 //--- add local variable definitions here ---
;3260 //APPLCODE
;3261 
;3262 
;3263   #define SharedApplLocals2
;3264   #include <sharedAppl.c>
;3265 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
;3266 
;3267 
;3268   #define SharedApplInit
;3269   #include <sharedAppl.c>
;3270 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_prevState
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_curState
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_nextState
	push	hl
	call	_memset
	add	sp,6
	bool	hl
	ld	l,h
	ld	(_numScopeRegs),hl
	lcall	$resetWDT
	ld	de,0xff
	ld	c,d
	ld	b,d
	ld	(_ADC_Mask),de
	ld	(_ADC_Mask+2),bc
	ld	de,0xf
	ld	(_DAC_Mask),de
	ld	(_DAC_Mask+2),bc
	ld	e,c
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	bool	hl
	ld	l,h
	ld	(ix-26),hl
@776:
	ld	hl,(ix-26)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@777
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_adcOffset
	add	hl,de
	push	hl
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_adcGain
	add	hl,de
	push	hl
	ld	hl,(ix-26)
	push	hl
	lcall	$adcDefaults
	add	sp,6
	ld	hl,(ix-26)
	add	hl,hl
	ld	de,_lastadcRaw
	add	hl,de
	ld	de,0xbad
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-26)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-26)
	inc	hl
	ld	(ix-26),hl
	jr	@776
@777:
	bool	hl
	ld	l,h
	ld	(ix-26),hl
@783:
	ld	hl,(ix-26)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@784
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_dacOffset
	add	hl,de
	push	hl
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_dacGain
	add	hl,de
	push	hl
	ld	hl,(ix-26)
	push	hl
	lcall	$dacDefaults
	add	sp,6
	ld	hl,(ix-26)
	push	hl
	lcall	$newDACCalib
	pop	hl
	ld	hl,(ix-26)
	inc	hl
	ld	(ix-26),hl
	jr	@783
@784:
	bool	hl
	ld	l,h
	ld	(ix-26),hl
@790:
	ld	hl,(ix-26)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@791
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_readOffset
	add	hl,de
	push	hl
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_readGain
	add	hl,de
	push	hl
	ld	hl,(ix-26)
	push	hl
	lcall	$readDefaults
	add	sp,6
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_readVal
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-26)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	z,@796
	jr	nc,@795
@796:
	ld	hl,(ix-26)
	push	hl
	lcall	$newADCCalib
	pop	hl
@795:
	ld	hl,(ix-26)
	inc	hl
	ld	(ix-26),hl
	jr	@790
@791:
	bool	hl
	ld	l,h
	ld	(ix-26),hl
@799:
	ld	hl,(ix-26)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@800
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_setOffset
	add	hl,de
	push	hl
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_setGain
	add	hl,de
	push	hl
	ld	hl,(ix-26)
	push	hl
	lcall	$setDefaults
	add	sp,6
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-26)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	z,@805
	jr	nc,@804
@805:
	ld	hl,(ix-26)
	push	hl
	lcall	$newDACCalib
	pop	hl
@804:
	ld	hl,(ix-26)
	inc	hl
	ld	(ix-26),hl
	jr	@799
@800:
	lcall	$setGenericLabels
	ld	de,0x4000
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-48),hl
	ex	de,hl
	ld	(ix-50),hl
	ex	de,hl
	push	hl
	ld	hl,-48+@771
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$sigprocmask
	add	sp,6
	ld	de,word (phys @1+3728)
	ld	c,phys @1+3728 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	lcall	$initModBusRegs
	ld	hl,0x2d
	ld	(_devType),hl
	ld	hl,_netmask
	push	hl
	ld	hl,@2+325
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ptoh
	add	sp,6
	ld	hl,_gateway
	push	hl
	ld	hl,@2+337
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ptoh
	add	sp,6
	bool	hl
	ld	l,h
	push	hl
	ld	hl,@2+349
	push	hl
	lcall	$mkfifo
	add	sp,4
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x21
	push	hl
	ld	hl,@2+349
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-40),hl
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastIdleTime),hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_lastIdleMS),de
	ld	(_lastIdleMS+2),bc
	bool	hl
	ld	l,h
	ld	(_ctlLoopTicks),hl
	ld	(_lastCtlLoopTime),hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
	lcall	$setDefaultLabels
	lcall	$setDefaultConfig
	lcall	$initIOvalues
	ld	de,word (phys _prevLogInfo+116)
	ld	c,phys _prevLogInfo+116 >> 16
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@806
	lcall	$restoreApplState
	ld	(ix-38),hl
	bool	hl
	jr	z,@809
	ld	hl,(ix-38)
	push	hl
	ld	de,word (phys @1+3753)
	ld	c,phys @1+3753 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@812
	xor	a,a
	ld	(_runBackup),a
@812:
	ld	hl,0x1
	push	hl
	lcall	$REBOOT
	pop	hl
@809:
	ld	a,0x1
	ld	(_restoredApplState),a
@806:
	ld	hl,0x100
	push	hl
	ld	hl,_applBuf
	push	hl
	lcall	$initParamModule
	add	sp,4
	ld	a,(_restoredApplState)
	or	a,a
	jr	nz,@813
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState+16),de
	ld	(_nextState+18),bc
	ld	(_curState+16),de
	ld	(_curState+18),bc
	ld	(_prevState+16),de
	ld	(_prevState+18),bc
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
	ld	(_curState+99),de
	ld	(_curState+101),bc
	ld	(_prevState+99),de
	ld	(_prevState+101),bc
@813:
	bool	hl
	ld	l,h
	push	hl
	lcall	$startNetUp
	pop	de
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
@816:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x2710
	ld	bc,0
	call	__lsub##
	jr	nc,@818
	bool	hl
	ld	l,h
	push	hl
	lcall	$ifpending
	pop	de
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@818
	lcall	$resetWDT
	jp	@816
@818:
	bool	hl
	ld	l,h
	push	hl
	lcall	$ifpending
	pop	de
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@819
	ld	de,word (phys @1+3812)
	ld	c,phys @1+3812 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jr	@820
@819:
	bool	hl
	ld	l,h
	push	hl
	lcall	$showNetState
	pop	hl
@820:
	bool	hl
	ld	l,h
	ld	(ix-26),hl
@823:
	ld	hl,(ix-26)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@824
	ld	hl,(ix-26)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-26)
	inc	hl
	ld	(ix-26),hl
	jr	@823
@824:
	bool	hl
	ld	l,h
	ld	(ix-26),hl
@828:
	ld	hl,(ix-26)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@829
	ld	hl,(ix-26)
	push	hl
	lcall	$newDACCalib
	pop	hl
;3271   _EnterCritical_();  SchedMS = 20;  _ExitCritical_();
	ld	hl,(ix-26)
	inc	hl
	ld	(ix-26),hl
	jr	@828
@829:
	ipset	2
	ld	hl,0x14
	ld	(_SchedMS),hl
	ipres
;3272 
;3273 //--- At this point generic initialization has been done which includes ---
;3274 //--- the following: ---
;3275 //      - The Prev, Cur, and Next ApplState objects have been zeroed
;3276 //      -
;3277 
;3278 //--- add application initialization code here ---
;3279 //APPLCODE
;3280   allowSoftReset = true;
	ld	a,0x1
	ld	(_allowSoftReset),a
;3281 
;3282   //BZERO(rfgenCmd);  BZERO(rfgenResp);
;3283 
;3284 //  rfgenLastRespTime = rfgenReadErrStartTime =
;3285   sptrReadErrStartTime = biasReadErrStartTime = 0;
	ld	d,h
	ld	e,h
	ld	c,e
	ld	b,e
	ld	(_biasReadErrStartTime),de
	ld	(_biasReadErrStartTime+2),bc
	ld	(_sptrReadErrStartTime),de
	ld	(_sptrReadErrStartTime+2),bc
;3286 
;3287   BZERO((void*)ovenCmd);  BZERO((void *)ovenResp);
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_ovenCmd
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_ovenResp
	push	hl
	call	_memset
	add	sp,6
;3288 
;3289   for (idx=0; idx<2; ++idx)  {
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@833:
	ld	hl,(ix-2)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nc,@834
;3290     ovenRespAge[idx] = 0;  newOvenResp[idx] = false;
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_ovenRespAge
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ld	de,_newOvenResp
	add	hl,de
	xor	a,a
	ld	(hl),a
;3291     postOvenResetMsgs[idx] = 0;
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_postOvenResetMsgs
	add	hl,de
	ld	d,b
	ld	e,c
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3292     ovenLastRespTime[idx] = ovenReadErrStartTime[idx] =
;3293     ovenOffCmdTime[idx] = ovenPowerOnTime[idx] = 0;
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_ovenPowerOnTime
	add	hl,de
	ld	d,b
	ld	e,c
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_ovenOffCmdTime
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_ovenReadErrStartTime
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_ovenLastRespTime
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3294   }
;3295 
;3296   wdPulseChanged = GetMS();
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@833
@834:
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_wdPulseChanged),de
	ld	(_wdPulseChanged+2),bc
;3297 
;3298 
;3299   #define SharedApplInit2
;3300   #include <sharedAppl.c>
;3301 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	lcall	$resetWDT
	ld	hl,0x1
	push	hl
	lcall	$logDigIOChgs
	pop	hl
	ld	hl,@2+360
	ld	(ix-46),hl
	bool	hl
	ld	l,h
	ld	(ix-44),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-40+@771
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,_inetd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+366
	ld	(ix-46),hl
	bool	hl
	ld	l,h
	ld	(ix-44),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-40+@771
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x7
	push	hl
	ld	hl,_configd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+374
	ld	(ix-46),hl
	bool	hl
	ld	l,h
	ld	(ix-44),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-40+@771
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,_backupd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,@2+382
	ld	(ix-46),hl
	bool	hl
	ld	l,h
	ld	(ix-44),hl
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-40+@771
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0xb
	push	hl
	ld	hl,_ca_tcpd
	push	hl
	lcall	$createProc
	add	sp,14
	ld	hl,0x5dc
	ld	(ix-36),hl
	lcall	$resetWDT
	bool	hl
	ld	l,h
	ld	(_applicTicks),hl
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-28),hl
	bool	hl
	ld	l,h
	ld	(_applLoopTime),hl
	lcall	$xavail
	push	bc
	push	de
	ld	de,word (phys @1+3853)
	ld	c,phys @1+3853 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	a,0x1
	ld	(_startupComplete),a
;3302 //--- start processes to communicate with supplies with a serial connection
;3303 
;3304 //  argv_[0] = "rfgenCom";  argv_[1] = NULL;
;3305 //  createProc(rfgenCom, 4, 1, argv_, 0, 1, 2);
;3306 
;3307 //--- task for serial com to oven1 (uses /dev/tty2) ---
;3308   argv_[0] = "ovenCom";  argv_[1] = "1";  argv_[2] = NULL;
	ld	hl,@2+390
	ld	(ix-46),hl
	ld	hl,@2+186
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
;3309   createProc(ovenCom, 4, 2, argv_, 0, 1, 2);
	ld	l,0x2
	push	hl
	ld	l,a
	push	hl
	ld	l,h
	push	hl
	ld	hl,-40+@771
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,_ovenCom
	push	hl
	lcall	$createProc
	add	sp,14
;3310 
;3311 //--- task for serial com to oven2 (uses /dev/tty1) ---
;3312   argv_[0] = "ovenCom";  argv_[1] = "2";  argv_[2] = NULL;
	ld	hl,@2+390
	ld	(ix-46),hl
	ld	hl,@2+192
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
;3313   createProc(ovenCom, 4, 2, argv_, 0, 1, 2);
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-40+@771
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,_ovenCom
	push	hl
	lcall	$createProc
	add	sp,14
;3314 
;3315 
;3316 //--- The following loop is run at a periodic interval (normally 100 times 
;3317 //--- per second, or every 10ms).  The application process normally ---
;3318 //--- consists of reading the current state of the digital and analog ---
;3319 //--- inputs, changing the state of the analog and digital outputs to the -
;3320 //--- values computed during the previous pass, then computing new values -
;3321 //--- for the outputs and updating values that outside clients can view ---
;3322 //--- (currently accessable as a set of ModBus registers) ---
;3323 
;3324   for (;;)  {
@840:
;3325     #define SharedApplLoopStart
;3326     #include <sharedAppl.c>
;3327 
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	ld	hl,(_applicTicks)
	inc	hl
	ld	(_applicTicks),hl
	ld	hl,(ix-36)
	bool	hl
	jr	z,@845
	ld	hl,(ix-36)
	dec	hl
	ld	(ix-36),hl
	bool	hl
	jr	nz,@846
	xor	a,a
	ld	(_runBackup),a
@846:
@845:
	lcall	$resetWDT
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	hl,(ix-28)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(_applLoopTime),hl
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
	lcall	$schedule
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-28),hl
	ipset	2
	ld	a,(_intTicks)
	bool	hl
	ld	l,a
	ld	(_latency),hl
	ipres
	ld	hl,(_ctlLoopTicks)
	inc	hl
	ld	(_ctlLoopTicks),hl
	ld	hl,(ix-28)
	ld	de,(_lastCtlLoopTime)
	or	a,a
	sbc	hl,de
	ld	de,0x7d0
	or	a,a
	sbc	hl,de
	jr	c,@847
	ld	hl,(_ctlLoopTicks)
	or	a,a
	rr	hl
	ld	(_ctlLoopTicksPerSec),hl
	bool	hl
	ld	l,h
	ld	(_ctlLoopTicks),hl
	ld	hl,(ix-28)
	ld	(_lastCtlLoopTime),hl
;3328 
;3329   //--- read the current state of the analog and digital Input signals, and
;3330   //--- write the values computed at the end of the last pass ---
;3331     digitalOut = Next.digitalOut;  rwIO();
@847:
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	lcall	$rwIO
;3332 
;3333   //--- process next event message (if any) ---
;3334     processMsg(eventsfd, (EventMsg *)buf, sizeof(buf));
	ld	hl,0x40
	push	hl
	ld	hl,-114+@771
	add	hl,sp
	push	hl
	ld	hl,(ix-40)
	push	hl
	lcall	$processMsg
	add	sp,6
;3335 
;3336   //--- update the current state and determine the next state ---
;3337     updateCurState();  updateNextState();
	lcall	$updateCurState
	lcall	$updateNextState
;3338     updateOutputState();  updateExternals();
	lcall	$updateOutputState
	lcall	$updateExternals
;3339 
;3340 
;3341     #define SharedApplLoopEnd
;3342     #include <sharedAppl.c>
	.debug	i 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	lcall	$ReadDeviceID
	ld	(_deviceID),de
	ld	(_deviceID+2),bc
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastIdleTime)
	or	a,a
	sbc	hl,de
	ld	(ix-30),hl
	ld	de,0xbb8
	or	a,a
	sbc	hl,de
	jr	c,@850
	ld	hl,(_idleTask)
	ld	de,0xd3
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,(_lastIdleMS)
	ld	bc,(_lastIdleMS+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x64
	ld	c,d
	ld	b,d
	call	__ulmlt##
	ld	hl,(ix-30)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__uldiv##
	ld	(_percentIdle),de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	(_lastIdleMS),de
	ld	(_lastIdleMS+2),bc
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastIdleTime),hl
@850:
	ld	hl,(_devType)
	ld	(_devType_),hl
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	ld	(_deviceID_),de
	ld	(_deviceID_+2),bc
ipset 3
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
ipres
	ld	(_upSecs),de
	ld	(_upSecs+2),bc
	ld	hl,(_percentIdle)
	ld	(_percentIdle_),hl
	ld	hl,(_timeZone)
	ld	(_timeZone_),hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	ld	(_curTime),de
	ld	(_curTime+2),bc
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_digInBits),de
	ld	(_digInBits+2),bc
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	ld	(_digOutBits),de
	ld	(_digOutBits+2),bc
	ld	hl,-50+@771
	add	hl,sp
	push	hl
	lcall	$sigpending
	pop	de
	bool	hl
	jp	nz,@853
	ld	l,0xf
	push	hl
	ld	hl,-48+@771
	add	hl,sp
	push	hl
	lcall	$sigismember
	add	sp,4
	bool	hl
	jp	z,@854
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	or	hl,de
	jp	nz,@855
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
@855:
@854:
@853:
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	or	hl,de
	jp	z,@857
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x1f40
	ld	bc,0
	call	__lsub##
	jr	c,@857
	jr	z,@857
	lcall	$applicShutdown
@857:
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,0x40
	and	hl,de
	jr	z,@858
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	res	0,e
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
	jr	@859
@858:
	ld	de,(_nextState+99)
	ld	bc,(_nextState+101)
	set	0,e
	ld	(_nextState+99),de
	ld	(_nextState+101),bc
@859:
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	ld	a,e
	or	a,d
	or	a,c
	jp	z,@860
	ipset	2
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	ld	hl,(_milliTicks)
	ld	(ix-34),hl
	ipres
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x4240
	ld	c,0xf
	call	__ulmlt##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	bool	hl
	ld	l,h
	ld	(ix-24),hl
	ld	hl,(_scopeList)
	ld	(ix-52),hl
@865:
	ld	hl,(ix-24)
	ld	de,(_numScopeRegs)
	or	a,a
	sbc	hl,de
	jp	nc,@866
	ld	hl,(ix-52)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ld	(ix-32),hl
	ld	e,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@870
	ld	hl,(ix-52)
	ld	hl,(hl)
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst2##
	jp	@871
@870:
	ld	hl,(ix-52)
	ld	hl,(hl)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
@871:
	ld	hl,(ix-32)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	add	hl,hl
	ld	de,_scopeList
	add	hl,de
	ld	hl,(hl)
	ld	(ix-52),hl
	jp	@865
@866:
	ld	de,(_captureCount)
	ld	bc,(_captureCount+2)
	call	__linc##
	ld	(_captureCount),de
	ld	(_captureCount+2),bc
	ld	hl,(_captureIdx)
	inc	hl
	ld	(_captureIdx),hl
	ld	de,(_scopeBufSampleSize)
	or	a,a
	sbc	hl,de
	jr	nz,@872
	bool	hl
	ld	l,h
	ld	(_captureIdx),hl
	ld	de,(_scopeBuf)
	ld	bc,(_scopeBuf+2)
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
@872:
@860:
	ld	a,0x1
	ld	(_applicReady),a
;3343   }
;3344 
;3345 }
	jp	@840
@772:
	.debug	} @772 3345

@771	equ	116
	ld	sp,ix
	pop	ix
	lret
@773	equ	118
;3346 
;3347 
;3348 //=========================================================================
;3349 //  list of application-specific commands that are normally entered via a
;3350 //  user shell
;3351 //=========================================================================
;3352 //void _task nsclSeriald(int argc, char **argv);
;3353 
;3354 //--- add any application-specific commands here ---
;3355 //APPLCODE
;3356 const CmdInfo far applCmds[] = {
;3357 //  { "misc",        miscTest,       "..." },
;3358   { "cmd",       cmd,         "Application-specific commands" },
	.seg	CONST
_applCmds::
	.dw	word (phys @1+3872)
	.dw	phys @1+3872 >> 16
	.dw	word _cmd
	.dw	word (phys @1+3876)
	.dw	phys @1+3876 >> 16
;3359   { "ovenCom",   ovenCom,     "Lambda/Oven PS serial link" },
	.dw	word (phys @1+3906)
	.dw	phys @1+3906 >> 16
	.dw	word _ovenCom
	.dw	word (phys @1+3914)
	.dw	phys @1+3914 >> 16
;3360 //  { "rfgenCom",  rfgenCom,    "RF Gen PS serial link" },
;3361   { "state",     showState,   "Show state of controller" }
	.dw	word (phys @1+3941)
	.dw	phys @1+3941 >> 16
	.dw	word _showState
	.dw	word (phys @1+3947)
	.dw	phys @1+3947 >> 16
;3362 };
	.debug	G _applCmds 80 8
;3363 
;3364 int const NumApplCmds = ( sizeof(applCmds) / sizeof(CmdInfo) );
_NumApplCmds::
	.dw	0x3
	.debug	G _NumApplCmds 6 0
;3365 
;3366 //-------------------------------------------------------------------------
;3367 
;3368 #endif
	.extern	$time 82
	.extern	_memset 83
	.extern	_strcat 85
	.extern	_strcpy 85
	.extern	_stricmp 86
	.extern	_strlen 87
	.extern	_strncpy 88
	.extern	_strstr 85
	.extern	$fmemcpy 89
	.extern	_fmemset 91
	.extern	_fstrcpy 92
	.extern	_fabs 93
	.extern	$redirectStdio 65
	.extern	$clockTicks 94
	.extern	$memCRC16 95
	.extern	$Engineering 96
	.extern	$fmtFloat 97
	.extern	$stdHeader 61
	.extern	$showNetState 98
	.extern	$CheckETX 65
	.extern	$compileTime 99
	.extern	$readBufCh 100
	.extern	$LongToBinMS1st 101
	.extern	$processMsg 102
	.extern	$inet_ptoh 103
	.extern	_clsCmd 104
	.extern	$sigismember 105
	.extern	$sigprocmask 106
	.extern	$sigpending 107
	.extern	_current 108
	.extern	_idleTask 108
	.extern	_applTask 108
	.extern	_SchedMS 7
	.cseg
_schedule:
	pop	iy
	lcall	$$schedule
	.extern	$$schedule
	.extern	$schedule 61
	.extern	__stdio 110
	.extern	$farfprintf 112
	.extern	$farprintf 113
	.extern	$farsprintf 114
	.extern	__TimerSeconds 9
	.extern	__TimerMilliSeconds 115
	.extern	$xavail 94
	.extern	_strtod 116
	.extern	$strtoi 117
	.extern	_updateAIn 104
	.extern	_updateAOut 104
	.extern	_adcGain 118
	.extern	_adcOffset 118
	.extern	_dacGain 118
	.extern	_dacOffset 118
	.extern	_aoutMin 118
	.extern	_aoutMax 118
	.extern	_setValMin 118
	.extern	_setValMax 118
	.extern	_anaIn 118
	.extern	_anaOut 118
	.extern	_lastAnaOut 118
	.extern	_adcRaw 119
	.extern	_dacRaw 119
	.extern	_lastadcRaw 119
	.extern	_newRdg 104
	.extern	_adcForced 104
	.extern	_dacForced 104
	.extern	_adcForcedVal 118
	.extern	_dacForcedVal 118
	.extern	_NumHdwADC 7
	.extern	_NumHdwDAC 7
	.bseg
_readGain::
	.ds	32
	.debug	G _readGain 120 0
_readOffset::
	.ds	32
	.debug	G _readOffset 120 0
_setGain::
	.ds	16
	.debug	G _setGain 121 0
_setOffset::
	.ds	16
	.debug	G _setOffset 121 0
_readVal::
	.ds	32
	.debug	G _readVal 120 0
_setVal::
	.ds	16
	.debug	G _setVal 121 0
_lastSetVal::
	.ds	16
	.debug	G _lastSetVal 121 0
	.extern	_digitalIn 9
	.extern	_digitalOut 9
	.defseg	FARBSS
	.seg	FARBSS
_ainLabel::
	.ds	192
	.debug	G _ainLabel 122 8
_aoutLabel::
	.ds	96
	.debug	G _aoutLabel 124 8
_dinLabel::
	.ds	528
	.debug	G _dinLabel 125 8
_doutLabel::
	.ds	384
	.debug	G _doutLabel 126 8
_extraInLabel::
	.ds	768
	.debug	G _extraInLabel 127 8
	.extern	$initIOvalues 61
	.extern	$ReadDigInputs 94
	.extern	$WriteDigOutputs 128
	.extern	$ReadDeviceID 94
	.cseg
_newDACCalib:
	pop	iy
	lcall	$$newDACCalib
	.extern	$$newDACCalib
	.extern	$newDACCalib 129
_newADCCalib:
	pop	iy
	lcall	$$newADCCalib
	.extern	$$newADCCalib
	.extern	$newADCCalib 129
	.extern	$writeAnalogOutputs 128
	.extern	$readAnalogInputs 128
	.extern	$updateAvgsADC 61
	.extern	$open 130
	.extern	$write 131
	.extern	$fcntl 132
	.extern	$fflush 133
	.extern	$ioctl 134
	.extern	_KLOCK 61
	.extern	_KUNLOCK 61
	.extern	$resetWDT 61
	.extern	_hostName 135
	.bseg
_ctlLoopTicksPerSec::
	.ds	2
	.debug	G _ctlLoopTicksPerSec 7 0
	.extern	_prevLogInfo 136
	.extern	_runBackup 3
	.extern	_runningPrimary 3
	.extern	_doReboot 3
	.extern	_doShutdown 3
	.extern	_diagLog 111
	.extern	_intTicks 3
	.extern	_milliTicks 7
	.extern	_hdwResetTime 9
	.extern	_applicTicks 7
	.extern	_deviceID 9
	.extern	_devType 7
	.extern	_hdwType 7
	.extern	_percentIdle 7
	.extern	_timeZone 6
	.extern	$REBOOT 62
	.extern	$createProc 137
	.extern	$sleepMS 138
	.extern	$Exit 98
	.extern	$SetHostName 139
_C0ChanMult::
	.ds	2
	.debug	G _C0ChanMult 7 0
_NumC0Chans::
	.ds	2
	.debug	G _NumC0Chans 7 0
_R3ChanMult::
	.ds	2
	.debug	G _R3ChanMult 7 0
_NumR3Chans::
	.ds	2
	.debug	G _NumR3Chans 7 0
_R4ChanMult::
	.ds	2
	.debug	G _R4ChanMult 7 0
_NumR4Chans::
	.ds	2
	.debug	G _NumR4Chans 7 0
	.extern	_numScopeRegs 7
	.extern	_captureIdx 7
	.extern	_scopeBufSampleSize 7
	.extern	_captureCount 9
	.extern	_scopeList 140
	.extern	_scopeBuf 47
	.extern	_capturePtr 47
	.cseg
_setU16:
	pop	iy
	lcall	$$setU16
	.extern	$$setU16
	.extern	$setU16 60
_setU32:
	pop	iy
	lcall	$$setU32
	.extern	$$setU32
	.extern	$setU32 60
_setF32:
	pop	iy
	lcall	$$setF32
	.extern	$$setF32
	.extern	$setF32 60
	.extern	$pvInitLists 65
_modbusTCPd:
	pop	iy
	lcall	$$modbusTCPd
	.extern	$$modbusTCPd
	.extern	$modbusTCPd 73
	.bseg
_DoReboot::
	.ds	1
	.debug	G _DoReboot 3 0
	.cseg
_setCoil:
	pop	iy
	lcall	$$setCoil
	.extern	$$setCoil
	.extern	$setCoil 141
	.bseg
_dlmVersTime::
	.ds	4
	.debug	G _dlmVersTime 9 0
_dlmVersTime_ChgEventVal::
	.ds	4
	.debug	G _dlmVersTime_ChgEventVal 9 0
_dlmVersTime_MinChg::
	.ds	4
	.debug	G _dlmVersTime_MinChg 9 0
_rtosVersTime::
	.ds	4
	.debug	G _rtosVersTime 9 0
_rtosVersTime_ChgEventVal::
	.ds	4
	.debug	G _rtosVersTime_ChgEventVal 9 0
_rtosVersTime_MinChg::
	.ds	4
	.debug	G _rtosVersTime_MinChg 9 0
_applVersTime::
	.ds	4
	.debug	G _applVersTime 9 0
_applVersTime_ChgEventVal::
	.ds	4
	.debug	G _applVersTime_ChgEventVal 9 0
_applVersTime_MinChg::
	.ds	4
	.debug	G _applVersTime_MinChg 9 0
_devType_::
	.ds	2
	.debug	G _devType_ 5 0
_devType__ChgEventVal::
	.ds	2
	.debug	G _devType__ChgEventVal 5 0
_devType__MinChg::
	.ds	2
	.debug	G _devType__MinChg 5 0
_deviceID_::
	.ds	4
	.debug	G _deviceID_ 9 0
_deviceID__ChgEventVal::
	.ds	4
	.debug	G _deviceID__ChgEventVal 9 0
_deviceID__MinChg::
	.ds	4
	.debug	G _deviceID__MinChg 9 0
_upSecs::
	.ds	4
	.debug	G _upSecs 9 0
_upSecs_ChgEventVal::
	.ds	4
	.debug	G _upSecs_ChgEventVal 9 0
_upSecs_MinChg::
	.ds	4
	.debug	G _upSecs_MinChg 9 0
_percentIdle_::
	.ds	2
	.debug	G _percentIdle_ 5 0
_percentIdle__ChgEventVal::
	.ds	2
	.debug	G _percentIdle__ChgEventVal 5 0
_percentIdle__MinChg::
	.ds	2
	.debug	G _percentIdle__MinChg 5 0
_numChans::
	.ds	2
	.debug	G _numChans 5 0
_numChans_ChgEventVal::
	.ds	2
	.debug	G _numChans_ChgEventVal 5 0
_numChans_MinChg::
	.ds	2
	.debug	G _numChans_MinChg 5 0
_coilChanMult::
	.ds	2
	.debug	G _coilChanMult 5 0
_coilChanMult_ChgEventVal::
	.ds	2
	.debug	G _coilChanMult_ChgEventVal 5 0
_coilChanMult_MinChg::
	.ds	2
	.debug	G _coilChanMult_MinChg 5 0
_reg3ChanMult::
	.ds	2
	.debug	G _reg3ChanMult 5 0
_reg3ChanMult_ChgEventVal::
	.ds	2
	.debug	G _reg3ChanMult_ChgEventVal 5 0
_reg3ChanMult_MinChg::
	.ds	2
	.debug	G _reg3ChanMult_MinChg 5 0
_reg4ChanMult::
	.ds	2
	.debug	G _reg4ChanMult 5 0
_reg4ChanMult_ChgEventVal::
	.ds	2
	.debug	G _reg4ChanMult_ChgEventVal 5 0
_reg4ChanMult_MinChg::
	.ds	2
	.debug	G _reg4ChanMult_MinChg 5 0
_digInBits::
	.ds	4
	.debug	G _digInBits 9 0
_digInBits_ChgEventVal::
	.ds	4
	.debug	G _digInBits_ChgEventVal 9 0
_digInBits_MinChg::
	.ds	4
	.debug	G _digInBits_MinChg 9 0
_statusBitsStdA::
	.ds	2
	.debug	G _statusBitsStdA 5 0
_statusBitsStdA_ChgEventVal::
	.ds	2
	.debug	G _statusBitsStdA_ChgEventVal 5 0
_statusBitsStdA_MinChg::
	.ds	2
	.debug	G _statusBitsStdA_MinChg 5 0
_statusBitsStdB::
	.ds	2
	.debug	G _statusBitsStdB 5 0
_statusBitsStdB_ChgEventVal::
	.ds	2
	.debug	G _statusBitsStdB_ChgEventVal 5 0
_statusBitsStdB_MinChg::
	.ds	2
	.debug	G _statusBitsStdB_MinChg 5 0
_statusBitsAppl::
	.ds	4
	.debug	G _statusBitsAppl 9 0
_statusBitsAppl_ChgEventVal::
	.ds	4
	.debug	G _statusBitsAppl_ChgEventVal 9 0
_statusBitsAppl_MinChg::
	.ds	4
	.debug	G _statusBitsAppl_MinChg 9 0
_rfSupplyType::
	.ds	2
	.debug	G _rfSupplyType 5 0
_rfSupplyType_ChgEventVal::
	.ds	2
	.debug	G _rfSupplyType_ChgEventVal 5 0
_rfSupplyType_MinChg::
	.ds	2
	.debug	G _rfSupplyType_MinChg 5 0
_sptrReadV::
	.ds	4
	.debug	G _sptrReadV 10 0
_sptrReadV_ChgEventVal::
	.ds	4
	.debug	G _sptrReadV_ChgEventVal 10 0
_sptrReadV_MinChg::
	.ds	4
	.debug	G _sptrReadV_MinChg 10 0
_sptrReadA::
	.ds	4
	.debug	G _sptrReadA 10 0
_sptrReadA_ChgEventVal::
	.ds	4
	.debug	G _sptrReadA_ChgEventVal 10 0
_sptrReadA_MinChg::
	.ds	4
	.debug	G _sptrReadA_MinChg 10 0
_biasReadV::
	.ds	4
	.debug	G _biasReadV 10 0
_biasReadV_ChgEventVal::
	.ds	4
	.debug	G _biasReadV_ChgEventVal 10 0
_biasReadV_MinChg::
	.ds	4
	.debug	G _biasReadV_MinChg 10 0
_biasReadA::
	.ds	4
	.debug	G _biasReadA 10 0
_biasReadA_ChgEventVal::
	.ds	4
	.debug	G _biasReadA_ChgEventVal 10 0
_biasReadA_MinChg::
	.ds	4
	.debug	G _biasReadA_MinChg 10 0
_oven1ReadV::
	.ds	4
	.debug	G _oven1ReadV 10 0
_oven1ReadV_ChgEventVal::
	.ds	4
	.debug	G _oven1ReadV_ChgEventVal 10 0
_oven1ReadV_MinChg::
	.ds	4
	.debug	G _oven1ReadV_MinChg 10 0
_oven1ReadA::
	.ds	4
	.debug	G _oven1ReadA 10 0
_oven1ReadA_ChgEventVal::
	.ds	4
	.debug	G _oven1ReadA_ChgEventVal 10 0
_oven1ReadA_MinChg::
	.ds	4
	.debug	G _oven1ReadA_MinChg 10 0
_rfgenReadV::
	.ds	4
	.debug	G _rfgenReadV 10 0
_rfgenReadV_ChgEventVal::
	.ds	4
	.debug	G _rfgenReadV_ChgEventVal 10 0
_rfgenReadV_MinChg::
	.ds	4
	.debug	G _rfgenReadV_MinChg 10 0
_rfgenReadA::
	.ds	4
	.debug	G _rfgenReadA 10 0
_rfgenReadA_ChgEventVal::
	.ds	4
	.debug	G _rfgenReadA_ChgEventVal 10 0
_rfgenReadA_MinChg::
	.ds	4
	.debug	G _rfgenReadA_MinChg 10 0
_rfgenReadW::
	.ds	4
	.debug	G _rfgenReadW 10 0
_rfgenReadW_ChgEventVal::
	.ds	4
	.debug	G _rfgenReadW_ChgEventVal 10 0
_rfgenReadW_MinChg::
	.ds	4
	.debug	G _rfgenReadW_MinChg 10 0
_serOven1ReadV::
	.ds	4
	.debug	G _serOven1ReadV 10 0
_serOven1ReadV_ChgEventVal::
	.ds	4
	.debug	G _serOven1ReadV_ChgEventVal 10 0
_serOven1ReadV_MinChg::
	.ds	4
	.debug	G _serOven1ReadV_MinChg 10 0
_serOven1ReadA::
	.ds	4
	.debug	G _serOven1ReadA 10 0
_serOven1ReadA_ChgEventVal::
	.ds	4
	.debug	G _serOven1ReadA_ChgEventVal 10 0
_serOven1ReadA_MinChg::
	.ds	4
	.debug	G _serOven1ReadA_MinChg 10 0
_oven1Status::
	.ds	4
	.debug	G _oven1Status 9 0
_oven1Status_ChgEventVal::
	.ds	4
	.debug	G _oven1Status_ChgEventVal 9 0
_oven1Status_MinChg::
	.ds	4
	.debug	G _oven1Status_MinChg 9 0
_latency::
	.ds	2
	.debug	G _latency 5 0
_latency_ChgEventVal::
	.ds	2
	.debug	G _latency_ChgEventVal 5 0
_latency_MinChg::
	.ds	2
	.debug	G _latency_MinChg 5 0
_tcpTickTime::
	.ds	2
	.debug	G _tcpTickTime 5 0
_tcpTickTime_ChgEventVal::
	.ds	2
	.debug	G _tcpTickTime_ChgEventVal 5 0
_tcpTickTime_MinChg::
	.ds	2
	.debug	G _tcpTickTime_MinChg 5 0
_applLoopTime::
	.ds	2
	.debug	G _applLoopTime 5 0
_applLoopTime_ChgEventVal::
	.ds	2
	.debug	G _applLoopTime_ChgEventVal 5 0
_applLoopTime_MinChg::
	.ds	2
	.debug	G _applLoopTime_MinChg 5 0
_nonKernelLocks::
	.ds	2
	.debug	G _nonKernelLocks 5 0
_nonKernelLocks_ChgEventVal::
	.ds	2
	.debug	G _nonKernelLocks_ChgEventVal 5 0
_nonKernelLocks_MinChg::
	.ds	2
	.debug	G _nonKernelLocks_MinChg 5 0
_failedLocks::
	.ds	2
	.debug	G _failedLocks 5 0
_failedLocks_ChgEventVal::
	.ds	2
	.debug	G _failedLocks_ChgEventVal 5 0
_failedLocks_MinChg::
	.ds	2
	.debug	G _failedLocks_MinChg 5 0
_duplicateLocks::
	.ds	2
	.debug	G _duplicateLocks 5 0
_duplicateLocks_ChgEventVal::
	.ds	2
	.debug	G _duplicateLocks_ChgEventVal 5 0
_duplicateLocks_MinChg::
	.ds	2
	.debug	G _duplicateLocks_MinChg 5 0
_oven1NumMsgs::
	.ds	2
	.debug	G _oven1NumMsgs 5 0
_oven1NumMsgs_ChgEventVal::
	.ds	2
	.debug	G _oven1NumMsgs_ChgEventVal 5 0
_oven1NumMsgs_MinChg::
	.ds	2
	.debug	G _oven1NumMsgs_MinChg 5 0
_oven1GoodMsgs::
	.ds	2
	.debug	G _oven1GoodMsgs 5 0
_oven1GoodMsgs_ChgEventVal::
	.ds	2
	.debug	G _oven1GoodMsgs_ChgEventVal 5 0
_oven1GoodMsgs_MinChg::
	.ds	2
	.debug	G _oven1GoodMsgs_MinChg 5 0
_oven1BadMsgs::
	.ds	2
	.debug	G _oven1BadMsgs 5 0
_oven1BadMsgs_ChgEventVal::
	.ds	2
	.debug	G _oven1BadMsgs_ChgEventVal 5 0
_oven1BadMsgs_MinChg::
	.ds	2
	.debug	G _oven1BadMsgs_MinChg 5 0
_adc00::
	.ds	2
	.debug	G _adc00 5 0
_adc00_ChgEventVal::
	.ds	2
	.debug	G _adc00_ChgEventVal 5 0
_adc00_MinChg::
	.ds	2
	.debug	G _adc00_MinChg 5 0
_adc01::
	.ds	2
	.debug	G _adc01 5 0
_adc01_ChgEventVal::
	.ds	2
	.debug	G _adc01_ChgEventVal 5 0
_adc01_MinChg::
	.ds	2
	.debug	G _adc01_MinChg 5 0
_adc02::
	.ds	2
	.debug	G _adc02 5 0
_adc02_ChgEventVal::
	.ds	2
	.debug	G _adc02_ChgEventVal 5 0
_adc02_MinChg::
	.ds	2
	.debug	G _adc02_MinChg 5 0
_adc03::
	.ds	2
	.debug	G _adc03 5 0
_adc03_ChgEventVal::
	.ds	2
	.debug	G _adc03_ChgEventVal 5 0
_adc03_MinChg::
	.ds	2
	.debug	G _adc03_MinChg 5 0
_adc04::
	.ds	2
	.debug	G _adc04 5 0
_adc04_ChgEventVal::
	.ds	2
	.debug	G _adc04_ChgEventVal 5 0
_adc04_MinChg::
	.ds	2
	.debug	G _adc04_MinChg 5 0
_adc05::
	.ds	2
	.debug	G _adc05 5 0
_adc05_ChgEventVal::
	.ds	2
	.debug	G _adc05_ChgEventVal 5 0
_adc05_MinChg::
	.ds	2
	.debug	G _adc05_MinChg 5 0
_adc06::
	.ds	2
	.debug	G _adc06 5 0
_adc06_ChgEventVal::
	.ds	2
	.debug	G _adc06_ChgEventVal 5 0
_adc06_MinChg::
	.ds	2
	.debug	G _adc06_MinChg 5 0
_adc07::
	.ds	2
	.debug	G _adc07 5 0
_adc07_ChgEventVal::
	.ds	2
	.debug	G _adc07_ChgEventVal 5 0
_adc07_MinChg::
	.ds	2
	.debug	G _adc07_MinChg 5 0
_oven2ReadV::
	.ds	4
	.debug	G _oven2ReadV 10 0
_oven2ReadV_ChgEventVal::
	.ds	4
	.debug	G _oven2ReadV_ChgEventVal 10 0
_oven2ReadV_MinChg::
	.ds	4
	.debug	G _oven2ReadV_MinChg 10 0
_oven2ReadA::
	.ds	4
	.debug	G _oven2ReadA 10 0
_oven2ReadA_ChgEventVal::
	.ds	4
	.debug	G _oven2ReadA_ChgEventVal 10 0
_oven2ReadA_MinChg::
	.ds	4
	.debug	G _oven2ReadA_MinChg 10 0
_serOven2ReadV::
	.ds	4
	.debug	G _serOven2ReadV 10 0
_serOven2ReadV_ChgEventVal::
	.ds	4
	.debug	G _serOven2ReadV_ChgEventVal 10 0
_serOven2ReadV_MinChg::
	.ds	4
	.debug	G _serOven2ReadV_MinChg 10 0
_serOven2ReadA::
	.ds	4
	.debug	G _serOven2ReadA 10 0
_serOven2ReadA_ChgEventVal::
	.ds	4
	.debug	G _serOven2ReadA_ChgEventVal 10 0
_serOven2ReadA_MinChg::
	.ds	4
	.debug	G _serOven2ReadA_MinChg 10 0
_oven2Status::
	.ds	4
	.debug	G _oven2Status 9 0
_oven2Status_ChgEventVal::
	.ds	4
	.debug	G _oven2Status_ChgEventVal 9 0
_oven2Status_MinChg::
	.ds	4
	.debug	G _oven2Status_MinChg 9 0
_oven2NumMsgs::
	.ds	2
	.debug	G _oven2NumMsgs 5 0
_oven2NumMsgs_ChgEventVal::
	.ds	2
	.debug	G _oven2NumMsgs_ChgEventVal 5 0
_oven2NumMsgs_MinChg::
	.ds	2
	.debug	G _oven2NumMsgs_MinChg 5 0
_oven2GoodMsgs::
	.ds	2
	.debug	G _oven2GoodMsgs 5 0
_oven2GoodMsgs_ChgEventVal::
	.ds	2
	.debug	G _oven2GoodMsgs_ChgEventVal 5 0
_oven2GoodMsgs_MinChg::
	.ds	2
	.debug	G _oven2GoodMsgs_MinChg 5 0
_oven2BadMsgs::
	.ds	2
	.debug	G _oven2BadMsgs 5 0
_oven2BadMsgs_ChgEventVal::
	.ds	2
	.debug	G _oven2BadMsgs_ChgEventVal 5 0
_oven2BadMsgs_MinChg::
	.ds	2
	.debug	G _oven2BadMsgs_MinChg 5 0
_kernelLoopTime::
	.ds	2
	.debug	G _kernelLoopTime 5 0
_kernelLoopTime_ChgEventVal::
	.ds	2
	.debug	G _kernelLoopTime_ChgEventVal 5 0
_kernelLoopTime_MinChg::
	.ds	2
	.debug	G _kernelLoopTime_MinChg 5 0
_timeZone_::
	.ds	2
	.debug	G _timeZone_ 4 0
_timeZone__ChgEventVal::
	.ds	2
	.debug	G _timeZone__ChgEventVal 4 0
_timeZone__MinChg::
	.ds	2
	.debug	G _timeZone__MinChg 4 0
	.cseg
_MB_timeZone:
	pop	iy
	lcall	$$MB_timeZone
	.bseg
_curTime::
	.ds	4
	.debug	G _curTime 9 0
_curTime_ChgEventVal::
	.ds	4
	.debug	G _curTime_ChgEventVal 9 0
_curTime_MinChg::
	.ds	4
	.debug	G _curTime_MinChg 9 0
_ipAddr::
	.ds	4
	.debug	G _ipAddr 9 0
_ipAddr_ChgEventVal::
	.ds	4
	.debug	G _ipAddr_ChgEventVal 9 0
_ipAddr_MinChg::
	.ds	4
	.debug	G _ipAddr_MinChg 9 0
_netmask::
	.ds	4
	.debug	G _netmask 9 0
_netmask_ChgEventVal::
	.ds	4
	.debug	G _netmask_ChgEventVal 9 0
_netmask_MinChg::
	.ds	4
	.debug	G _netmask_MinChg 9 0
_gateway::
	.ds	4
	.debug	G _gateway 9 0
_gateway_ChgEventVal::
	.ds	4
	.debug	G _gateway_ChgEventVal 9 0
_gateway_MinChg::
	.ds	4
	.debug	G _gateway_MinChg 9 0
_setACoil::
	.ds	2
	.debug	G _setACoil 142 0
_setACoil_ChgEventVal::
	.ds	2
	.debug	G _setACoil_ChgEventVal 142 0
_setACoil_MinChg::
	.ds	2
	.debug	G _setACoil_MinChg 142 0
_resetACoil::
	.ds	2
	.debug	G _resetACoil 142 0
_resetACoil_ChgEventVal::
	.ds	2
	.debug	G _resetACoil_ChgEventVal 142 0
_resetACoil_MinChg::
	.ds	2
	.debug	G _resetACoil_MinChg 142 0
_digOutBits::
	.ds	4
	.debug	G _digOutBits 9 0
_digOutBits_ChgEventVal::
	.ds	4
	.debug	G _digOutBits_ChgEventVal 9 0
_digOutBits_MinChg::
	.ds	4
	.debug	G _digOutBits_MinChg 9 0
_cmdBitsStd::
	.ds	4
	.debug	G _cmdBitsStd 9 0
_cmdBitsStd_ChgEventVal::
	.ds	4
	.debug	G _cmdBitsStd_ChgEventVal 9 0
_cmdBitsStd_MinChg::
	.ds	4
	.debug	G _cmdBitsStd_MinChg 9 0
	.cseg
_MB_cmdBitsStd:
	pop	iy
	lcall	$$MB_cmdBitsStd
	.bseg
_cmdBitsAppl::
	.ds	4
	.debug	G _cmdBitsAppl 9 0
_cmdBitsAppl_ChgEventVal::
	.ds	4
	.debug	G _cmdBitsAppl_ChgEventVal 9 0
_cmdBitsAppl_MinChg::
	.ds	4
	.debug	G _cmdBitsAppl_MinChg 9 0
	.cseg
_MB_cmdBitsAppl:
	pop	iy
	lcall	$$MB_cmdBitsAppl
	.bseg
_sptrSetV::
	.ds	4
	.debug	G _sptrSetV 10 0
_sptrSetV_ChgEventVal::
	.ds	4
	.debug	G _sptrSetV_ChgEventVal 10 0
_sptrSetV_MinChg::
	.ds	4
	.debug	G _sptrSetV_MinChg 10 0
_biasSetV::
	.ds	4
	.debug	G _biasSetV 10 0
_biasSetV_ChgEventVal::
	.ds	4
	.debug	G _biasSetV_ChgEventVal 10 0
_biasSetV_MinChg::
	.ds	4
	.debug	G _biasSetV_MinChg 10 0
_oven1SetV::
	.ds	4
	.debug	G _oven1SetV 10 0
_oven1SetV_ChgEventVal::
	.ds	4
	.debug	G _oven1SetV_ChgEventVal 10 0
_oven1SetV_MinChg::
	.ds	4
	.debug	G _oven1SetV_MinChg 10 0
_rfgenSetV::
	.ds	4
	.debug	G _rfgenSetV 10 0
_rfgenSetV_ChgEventVal::
	.ds	4
	.debug	G _rfgenSetV_ChgEventVal 10 0
_rfgenSetV_MinChg::
	.ds	4
	.debug	G _rfgenSetV_MinChg 10 0
_serOven1SetV::
	.ds	4
	.debug	G _serOven1SetV 10 0
_serOven1SetV_ChgEventVal::
	.ds	4
	.debug	G _serOven1SetV_ChgEventVal 10 0
_serOven1SetV_MinChg::
	.ds	4
	.debug	G _serOven1SetV_MinChg 10 0
_serOven1SetA::
	.ds	4
	.debug	G _serOven1SetA 10 0
_serOven1SetA_ChgEventVal::
	.ds	4
	.debug	G _serOven1SetA_ChgEventVal 10 0
_serOven1SetA_MinChg::
	.ds	4
	.debug	G _serOven1SetA_MinChg 10 0
_sptrMaxErrV::
	.ds	4
	.debug	G _sptrMaxErrV 10 0
_sptrMaxErrV_ChgEventVal::
	.ds	4
	.debug	G _sptrMaxErrV_ChgEventVal 10 0
_sptrMaxErrV_MinChg::
	.ds	4
	.debug	G _sptrMaxErrV_MinChg 10 0
_sptrMaxErrMS::
	.ds	4
	.debug	G _sptrMaxErrMS 9 0
_sptrMaxErrMS_ChgEventVal::
	.ds	4
	.debug	G _sptrMaxErrMS_ChgEventVal 9 0
_sptrMaxErrMS_MinChg::
	.ds	4
	.debug	G _sptrMaxErrMS_MinChg 9 0
_biasMaxErrV::
	.ds	4
	.debug	G _biasMaxErrV 10 0
_biasMaxErrV_ChgEventVal::
	.ds	4
	.debug	G _biasMaxErrV_ChgEventVal 10 0
_biasMaxErrV_MinChg::
	.ds	4
	.debug	G _biasMaxErrV_MinChg 10 0
_biasMaxErrMS::
	.ds	4
	.debug	G _biasMaxErrMS 9 0
_biasMaxErrMS_ChgEventVal::
	.ds	4
	.debug	G _biasMaxErrMS_ChgEventVal 9 0
_biasMaxErrMS_MinChg::
	.ds	4
	.debug	G _biasMaxErrMS_MinChg 9 0
_oven1MaxErrV::
	.ds	4
	.debug	G _oven1MaxErrV 10 0
_oven1MaxErrV_ChgEventVal::
	.ds	4
	.debug	G _oven1MaxErrV_ChgEventVal 10 0
_oven1MaxErrV_MinChg::
	.ds	4
	.debug	G _oven1MaxErrV_MinChg 10 0
_oven1MaxErrMS::
	.ds	4
	.debug	G _oven1MaxErrMS 9 0
_oven1MaxErrMS_ChgEventVal::
	.ds	4
	.debug	G _oven1MaxErrMS_ChgEventVal 9 0
_oven1MaxErrMS_MinChg::
	.ds	4
	.debug	G _oven1MaxErrMS_MinChg 9 0
_forceOvenErr::
	.ds	2
	.debug	G _forceOvenErr 5 0
_forceOvenErr_ChgEventVal::
	.ds	2
	.debug	G _forceOvenErr_ChgEventVal 5 0
_forceOvenErr_MinChg::
	.ds	2
	.debug	G _forceOvenErr_MinChg 5 0
_oven1PwrOffDelay::
	.ds	2
	.debug	G _oven1PwrOffDelay 5 0
_oven1PwrOffDelay_ChgEventVal::
	.ds	2
	.debug	G _oven1PwrOffDelay_ChgEventVal 5 0
_oven1PwrOffDelay_MinChg::
	.ds	2
	.debug	G _oven1PwrOffDelay_MinChg 5 0
_oven2SetV::
	.ds	4
	.debug	G _oven2SetV 10 0
_oven2SetV_ChgEventVal::
	.ds	4
	.debug	G _oven2SetV_ChgEventVal 10 0
_oven2SetV_MinChg::
	.ds	4
	.debug	G _oven2SetV_MinChg 10 0
_serOven2SetV::
	.ds	4
	.debug	G _serOven2SetV 10 0
_serOven2SetV_ChgEventVal::
	.ds	4
	.debug	G _serOven2SetV_ChgEventVal 10 0
_serOven2SetV_MinChg::
	.ds	4
	.debug	G _serOven2SetV_MinChg 10 0
_serOven2SetA::
	.ds	4
	.debug	G _serOven2SetA 10 0
_serOven2SetA_ChgEventVal::
	.ds	4
	.debug	G _serOven2SetA_ChgEventVal 10 0
_serOven2SetA_MinChg::
	.ds	4
	.debug	G _serOven2SetA_MinChg 10 0
_oven2MaxErrV::
	.ds	4
	.debug	G _oven2MaxErrV 10 0
_oven2MaxErrV_ChgEventVal::
	.ds	4
	.debug	G _oven2MaxErrV_ChgEventVal 10 0
_oven2MaxErrV_MinChg::
	.ds	4
	.debug	G _oven2MaxErrV_MinChg 10 0
_oven2MaxErrMS::
	.ds	4
	.debug	G _oven2MaxErrMS 9 0
_oven2MaxErrMS_ChgEventVal::
	.ds	4
	.debug	G _oven2MaxErrMS_ChgEventVal 9 0
_oven2MaxErrMS_MinChg::
	.ds	4
	.debug	G _oven2MaxErrMS_MinChg 9 0
_oven2PwrOffDelay::
	.ds	2
	.debug	G _oven2PwrOffDelay 5 0
_oven2PwrOffDelay_ChgEventVal::
	.ds	2
	.debug	G _oven2PwrOffDelay_ChgEventVal 5 0
_oven2PwrOffDelay_MinChg::
	.ds	2
	.debug	G _oven2PwrOffDelay_MinChg 5 0
	.extern	$ifpending 143
	.extern	$startNetUp 143
	.extern	$mkfifo 139
	.extern	$perror 144
	.extern	_hdwCfgParams 145
	.extern	$initParamModule 146
	.extern	$saveParams 147
	.extern	$loadParams 147
	.extern	$loadParamsMsg 148
	.cseg
_backupd:
	pop	iy
	lcall	$$backupd
	.extern	$$backupd
	.extern	$backupd 73
	.extern	_srfsIPAddr 9
	.extern	_srfsAltAddr 9
_ca_tcpd:
	pop	iy
	lcall	$$ca_tcpd
	.extern	$$ca_tcpd
	.extern	$ca_tcpd 73
_inetd:
	pop	iy
	lcall	$$inetd
	.extern	$$inetd
	.extern	$inetd 73
	.extern	$displayElems 149
	.extern	$displayDigElems 150
_fmtF32:
	pop	iy
	lcall	$$fmtF32
	.extern	$$fmtF32
	.extern	$fmtF32 66
	.seg	FARBSS
_applDTM::
	.ds	32
	.debug	G _applDTM 135 8
	.bseg
_ctlLoopTicks::
	.ds	2
	.debug	G _ctlLoopTicks 7 0
_lastCtlLoopTime::
	.ds	2
	.debug	G _lastCtlLoopTime 7 0
_lastReadTime::
	.ds	2
	.debug	G _lastReadTime 7 0
_readTicks::
	.ds	2
	.debug	G _readTicks 7 0
_writeTicks::
	.ds	2
	.debug	G _writeTicks 7 0
_rwTicks::
	.ds	2
	.debug	G _rwTicks 7 0
_ADC_Mask::
	.ds	4
	.debug	G _ADC_Mask 9 0
_DAC_Mask::
	.ds	4
	.debug	G _DAC_Mask 9 0
_stateDataBuf::
	.ds	4
	.debug	G _stateDataBuf 90 0
	.cseg
_EVENT_RestoredParamFile:
	pop	iy
	lcall	$$EVENT_RestoredParamFile
_adcMinRaw:
	pop	iy
	lcall	$$adcMinRaw
	.extern	$$adcMinRaw
	.extern	$adcMinRaw 77
_adcMaxRaw:
	pop	iy
	lcall	$$adcMaxRaw
	.extern	$$adcMaxRaw
	.extern	$adcMaxRaw 77
_adcDefaults:
	pop	iy
	lcall	$$adcDefaults
	.extern	$$adcDefaults
	.extern	$adcDefaults 78
_dacMinRaw:
	pop	iy
	lcall	$$dacMinRaw
	.extern	$$dacMinRaw
	.extern	$dacMinRaw 77
_dacMaxRaw:
	pop	iy
	lcall	$$dacMaxRaw
	.extern	$$dacMaxRaw
	.extern	$dacMaxRaw 77
_dacDefaults:
	pop	iy
	lcall	$$dacDefaults
	.extern	$$dacDefaults
	.extern	$dacDefaults 78
_readGetRaw:
	pop	iy
	lcall	$$readGetRaw
_readMinRaw:
	pop	iy
	lcall	$$readMinRaw
_readMaxRaw:
	pop	iy
	lcall	$$readMaxRaw
_readDefaults:
	pop	iy
	lcall	$$readDefaults
_readCalibPoints:
	pop	iy
	lcall	$$readCalibPoints
_setGetRaw:
	pop	iy
	lcall	$$setGetRaw
_setMinRaw:
	pop	iy
	lcall	$$setMinRaw
_setMaxRaw:
	pop	iy
	lcall	$$setMaxRaw
_setDefaults:
	pop	iy
	lcall	$$setDefaults
_setCalibPoints:
	pop	iy
	lcall	$$setCalibPoints
_applic:
	pop	iy
	lcall	$$applic
_tsh:
	pop	iy
	lcall	$$tsh
	.extern	$$tsh
	.extern	$tsh 73
_configd:
	pop	iy
	lcall	$$configd
	.extern	$$configd
	.extern	$configd 73
_fastdatad:
	pop	iy
	lcall	$$fastdatad
	.extern	$$fastdatad
	.extern	$fastdatad 73
_ReadSetCalibsRestore:
	pop	iy
	lcall	$$ReadSetCalibsRestore
_hostNameRestore:
	pop	iy
	lcall	$$hostNameRestore
	.bseg
_biasOnCmd::
	.ds	1
	.debug	G _biasOnCmd 3 0
_biasOffCmd::
	.ds	1
	.debug	G _biasOffCmd 3 0
_sptrOnCmd::
	.ds	1
	.debug	G _sptrOnCmd 3 0
_sptrOffCmd::
	.ds	1
	.debug	G _sptrOffCmd 3 0
_ovenOnCmd::
	.ds	2
	.debug	G _ovenOnCmd 151 0
_ovenOffCmd::
	.ds	2
	.debug	G _ovenOffCmd 151 0
_ovenResetCmd::
	.ds	2
	.debug	G _ovenResetCmd 151 0
_newOvenResp::
	.ds	2
	.debug	G _newOvenResp 151 0
_ovenLastRespTime::
	.ds	8
	.debug	G _ovenLastRespTime 115 0
_ovenReadErrStartTime::
	.ds	8
	.debug	G _ovenReadErrStartTime 115 0
_ovenOffCmdTime::
	.ds	8
	.debug	G _ovenOffCmdTime 115 0
_ovenPowerOnTime::
	.ds	8
	.debug	G _ovenPowerOnTime 115 0
_sptrReadErrStartTime::
	.ds	4
	.debug	G _sptrReadErrStartTime 9 0
_biasReadErrStartTime::
	.ds	4
	.debug	G _biasReadErrStartTime 9 0
_wdPulseChanged::
	.ds	4
	.debug	G _wdPulseChanged 9 0
_ovenRespAge::
	.ds	8
	.debug	G _ovenRespAge 115 0
_postOvenResetMsgs::
	.ds	4
	.debug	G _postOvenResetMsgs 152 0
_prevState::
	.ds	141
	.debug	G _prevState 153 0
_curState::
	.ds	141
	.debug	G _curState 153 0
_nextState::
	.ds	141
	.debug	G _nextState 153 0
_lastIdleMS:
	.ds	4
_lastIdleTime:
	.ds	2
_applBuf::
	.ds	256
	.debug	G _applBuf 154 0
_ovenCmd::
	.ds	64
	.debug	G _ovenCmd 155 0
_ovenResp::
	.ds	128
	.debug	G _ovenResp 156 0
	.cseg
_fmtF32ser1:
	pop	iy
	lcall	$$fmtF32ser1
_fmtF32ser2:
	pop	iy
	lcall	$$fmtF32ser2
_fmtBinary1:
	pop	iy
	lcall	$$fmtBinary1
_fmtBinary2:
	pop	iy
	lcall	$$fmtBinary2
_fmtOvenState1:
	pop	iy
	lcall	$$fmtOvenState1
_fmtOvenState2:
	pop	iy
	lcall	$$fmtOvenState2
	.bseg
_biasReadmA::
	.ds	4
	.debug	G _biasReadmA 10 0
_sptrReadmA::
	.ds	4
	.debug	G _sptrReadmA 10 0
	.cseg
_showState:
	pop	iy
	lcall	$$showState
_cmd:
	pop	iy
	lcall	$$cmd
_ovenCom:
	pop	iy
	lcall	$$ovenCom
	.debug	T	49000320000A00050001002300000008636F696C56616C00030002
	.debug	T	0008636F696C4E756D002F000300056E616D65009E0007000C
	.debug	T	736574436F696C46756E63000300090006666C61677300
	.debug	T	AD0003210014000C0001009F0000000772656756616C0005000200
	.debug	T	077265674E756D002F000400056E616D6500A00008000B7365
	.debug	T	7452656746756E630003000A00096461746154797065000300
	.debug	T	0B00086E756D526567730003000C000777724D61736B000300
	.debug	T	0D0006666C6167730003000E000C636865636B4576656E7473
	.debug	T	0003000F000E6576656E74734F63637572656400540010000B
	.debug	T	6C61737443686756616C0054001200076D696E43686700
	.debug	T	0900012200060023000300
	.debug	T	070000230002000300
	.debug	T	0900012400040025000200
	.debug	T	070000250002002000
	.debug	T	09000126009E0027004F00
	.debug	T	070000270002002100
	.debug	T	09000128006E0027003700
	.debug	T	09000129001D002A000100
	.debug	T	8A00032A001D0009000950565F446573635F00A100000007707649
	.debug	T	6E666F005A000D000476616C00070011000876616C53697A65
	.debug	T	00030013000A6E65774576656E747300030014000E6576656E
	.debug	T	74734F63637572656400A20015000A75706461746556616C00
	.debug	T	A4001700086C6F636B56616C00A60019000873656E6456616C
	.debug	T	00A6001B000772637656616C00
	.debug	T	0900012B00080003000800
	.debug	T	1D00032C000600020001000900000005626175640006000400056D
	.debug	T	6F646500
	.debug	T	0900012D00160003001600
	.debug	T	0900012E00B0002F002C00
	.debug	T	0700082F0004000300
	.debug	T	0900013000100003001000
	.debug	T	090001310080002F002000
	.debug	T	0900013200040003000400
	.debug	T	0900013300480034000400
	.debug	T	820003340012000900010023000000087372764E616D6500070002
	.debug	T	0005706F727400030004000970726F746F636F6C00A8000500
	.debug	T	0970726F634D61696E0003000700097072696F726974790006
	.debug	T	0008000664657666640054000A000A636667506172616D7300
	.debug	T	06000C00086C6173744572720009000E000C6C617374457272
	.debug	T	54696D6500
	.debug	T	0900013500A00136001A00
	.debug	T	49000336001000060001000400000003696400040002000573697A
	.debug	T	650004000400056772616E005A0006000564617461002F000A
	.debug	T	00056E616D6500A9000E000B726573746F726556616C00
	.debug	T	0900013700500036000500
	.debug	T	0900013800100036000100
	.debug	T	72000339003100080001002300000009626173654E616D65000300
	.debug	T	02000963617465676F727900AA00030007706172616D7300AB
	.debug	T	0007000B7772697465436F756E74000600270003666400AC00
	.debug	T	29000962626D43616368650007002D000A636163686553697A
	.debug	T	650007002F00076F666673657400
	.debug	T	0900013A0006003B000300
	.debug	T	0700003B0002003900
	.debug	T	1700023C000400030054000000030002005400040006000600
	.debug	T	0B00023D000100010001000000
	.debug	T	0B00023E000100010003000000
	.debug	T	0B00023F0001000100AE000000
	.debug	T	1300024000030001005A0000002300040007000600
	.debug	T	0B000241000100060001000000
	.debug	T	0F0002420002002300B000000023000400
	.debug	T	0900014300C1030300C103
	.debug	T	09000144003E0245002900
	.debug	T	56000345000E0007000A44697370456C656D5F0003000000027800
	.debug	T	030001000279005A0002000476616C00230006000661747472
	.debug	T	7300B100080008666D7446756E630006000A00067769647468
	.debug	T	0006000C00057072656300
	.debug	T	09000146001C0047000200
	.debug	T	4B000347000E000700010003000000027800030001000279000900
	.debug	T	0200056D61736B002300060005737472300023000800066174
	.debug	T	7472300023000A0005737472310023000C0006617474723100
	.debug	T	09000148002A0047000300
	.debug	T	0F000249000200010006000000B2000200
	.debug	T	1300024A0003000100B3000000B300020007000400
	.debug	T	2B00024B000900010023000000B400020023000400030006000A00
	.debug	T	080009000C000A0010000A0014000A001800
	.debug	T	1300024C0003000600230000000600020007000400
	.debug	T	0B00024D0001000A0007000000
	.debug	T	1300024E000300010007000000B3000200B3000400
	.debug	T	0F00024F00020023000700000023000200
	.debug	T	09000150001E0051000300
	.debug	T	2F000351000A00030001002F00000008636D644E616D6500A80004
	.debug	T	000970726F634D61696E002F00060006646573637200
	.debug	T	0B0002520001000900B4000000
	.debug	T	130002530003005400540000000600020007000400
	.debug	T	070000540002000100
	.debug	T	0F00025500020023002300000023000200
	.debug	T	0F00025600020006002300000023000200
	.debug	T	0B000257000100060023000000
	.debug	T	130002580003002300230000002300020007000400
	.debug	T	130002590003005A005A0000005A00040009000800
	.debug	T	0700085A0004000100
	.debug	T	1300025B0003005A005A0000000600040009000600
	.debug	T	0F00025C00020001002F0000002F000400
	.debug	T	0B00025D0001000B000B000000
	.debug	T	0B00025E000100090001000000
	.debug	T	0F00025F00020007000900000009000400
	.debug	T	1300026000030023000A0000000600040023000600
	.debug	T	1700026100040023000A000000060004000600060023000800
	.debug	T	0B000262000100010006000000
	.debug	T	0F00026300020009002300000023000200
	.debug	T	0B0002640001000600B5000000
	.debug	T	130002650003002300080000002300040006000600
	.debug	T	13000266000300010006000000AE00020006000400
	.debug	T	130002670003000600060000002300020054000400
	.debug	T	0900016800000003000000
	.debug	T	0F0002690002000600B400000006000200
	.debug	T	1300026A000300060006000000B4000200B4000400
	.debug	T	0B00026B0001000600B4000000
	.debug	T	0700006C0002006D00
	.debug	T	7702036D00E8002D000C7461736B5F73747275637400B700000006
	.debug	T	737461636B00B70002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C687200B8000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465006C00150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	00056172676300B2001A00056172677600B9001C0005617267
	.debug	T	7300BA009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C61677300A800B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74002F00D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	0700006E0002006F00
	.debug	T	5400036F000C0006000100BB000000065F5F6F757400BD00020005
	.debug	T	5F5F696E00BF000400085F5F777269746500BF000600075F5F
	.debug	T	726561640006000800085F5F756E6765740054000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	1300027000030006006E0000002F0002000D000000
	.debug	T	0F00027100020006002F0000000D000000
	.debug	T	1300027200030006002F0000002F0004000D000000
	.debug	T	0900017300080009000200
	.debug	T	0F0002740002000B0023000000B2000200
	.debug	T	13000275000300060023000000B200020006000400
	.debug	T	090001760000000A000000
	.debug	T	0900017700000007000000
	.debug	T	090001780020000A000800
	.debug	T	090001790010000A000400
	.debug	T	0900017A00C0007B000800
	.debug	T	0900017B00180003001800
	.debug	T	0900017C0060007B000400
	.debug	T	0900017D0010027B001600
	.debug	T	0900017E0080017B001000
	.debug	T	0900017F0000037B002000
	.debug	T	0B000280000100010009000000
	.debug	T	0B000281000100010007000000
	.debug	T	130002820003000600230000000600020006000400
	.debug	T	130002830003000600060000005400020006000400
	.debug	T	130002840003000600060000000600020006000400
	.debug	T	0B00028500010006006E000000
	.debug	T	130002860003000600060000000600020054000400
	.debug	T	0900018700200003002000
	.debug	T	2701038800F900140001000900000008696E666F4B657900090004
	.debug	T	00086262436F756E74000700080006746F4964780007000A00
	.debug	T	0866726F6D4964780003000C0008777261707065640003000D
	.debug	T	000D63746C6453687574646F776E0007000E00097764745469
	.debug	T	636B730009001000087365636F6E647300070014000A6D696C
	.debug	T	6C69536563730009001600076D7354696D6500C1001A000866
	.debug	T	696C6C6572310006006A0003747A0009006C000D6864775265
	.debug	T	73657454696D6500090070000B7265626F6F7454696D650003
	.debug	T	0074000D646964536F6674526573657400090075000C646967
	.debug	T	4F7574537461746500090079000972746F7356657273000900
	.debug	T	7D000D74696D65725365636F6E647300090081000B696E7649
	.debug	T	6E666F4B657900C20085000866696C6C65723200
	.debug	T	230002890007000600A80000000300020006000400B20006000600
	.debug	T	080006000A0006000C00
	.debug	T	0B00028A000100090009000000
	.debug	T	0F00028B00020006002300000006000200
	.debug	T	0900018C00200027001000
	.debug	T	1700028D000400030054000000030002000300040006000600
	.debug	T	0900018E00020005000100
	.debug	T	0B00028F000100060006000000
	.debug	T	0B00029000010001002F000000
	.debug	T	0900019100000036000000
	.debug	T	0F00029200020006002300000007000200
	.debug	T	17000293000400060023000000070002003B00040003000600
	.debug	T	0B00029400010006003B000000
	.debug	T	130002950003000100B00000000300040023000600
	.debug	T	17000296000400010009000000C30004000300080023000A00
	.debug	T	0900019700020003000200
	.debug	T	0900019800040007000200
	.debug	T	5F020399008D0021000100C4000000096F76656E53657456000A00
	.debug	T	0800096269617353657456000A000C00097370747253657456
	.debug	T	00090010000A6469676974616C496E00970014000D6F76656E
	.debug	T	496E61637469766500970016000F6F76656E52756E74696D65
	.debug	T	45727200030018000F6269617352756E74696D654572720003
	.debug	T	0019000F7370747252756E74696D6545727200C4001A000A6F
	.debug	T	76656E526561645600C40022000D7365724F76656E52656164
	.debug	T	5600C4002A000A6F76656E526561644100C40032000D736572
	.debug	T	4F76656E52656164410098003A000D6F76656E4F7053746174
	.debug	T	75730098003E00106F76656E416C61726D5374617475730098
	.debug	T	0042000F6F76656E50726F67537461747573000A0046000A62
	.debug	T	6961735265616456000A004A000A626961735265616441000A
	.debug	T	004E000A737074725265616456000A0052000A737074725265
	.debug	T	61644100970056000B6F76656E4D6F64654F6E009700580014
	.debug	T	6F76656E4F7574457272496E7465726C6F636B0073005A0014
	.debug	T	6F76656E4F7574457272537461727454696D6500030062000E
	.debug	T	73707472496E7465726C6F636B00090063000B646967697461
	.debug	T	6C4F7574009700670010656E61626C654F76656E506F776572
	.debug	T	009700690011656E61626C654F76656E4F757470757400C400
	.debug	T	6B000F6F76656E5365745661737365727400C40073000C7365
	.debug	T	724F76656E5365745600C4007B000C7365724F76656E536574
	.debug	T	4100030083000F6173736572744F6E426961735053000A0084
	.debug	T	000F626961735365745661737365727400030088000F617373
	.debug	T	6572744F6E537074725053000A0089000F7370747253657456
	.debug	T	61737365727400
	.debug	T	0900019A00000103000001
	.debug	T	0900019B00400087000200
	.debug	T	0900019C0080009D000200
	.debug	T	0900019D00400003004000
	.debug	T	0700009E0002008D00
	.debug	T	0700009F0002000400
	.debug	T	070000A00002003C00
	.debug	T	520003A1000D00060001002F000000056E616D6500030004000964
	.debug	T	6174615479706500070005000573697A65000700070009656C
	.debug	T	656D53697A650007000900096E756D456C656D730007000B00
	.debug	T	06666C61677300
	.debug	T	070000A2000200A300
	.debug	T	0B0002A30001000600C5000000
	.debug	T	070000A4000200A500
	.debug	T	130002A50003000600C50000000600020006000400
	.debug	T	070000A6000200A700
	.debug	T	170002A70004000600060000000700020054000400C6000600
	.debug	T	070000A80002004900
	.debug	T	070000A90002004000
	.debug	T	070008AA0004003600
	.debug	T	090001AB00200007001000
	.debug	T	070008AC000400AD00
	.debug	T	330003AD000A0004000100090000000574696D6500070004000573
	.debug	T	697A6500070006000864657654797065000700080004637263
	.debug	T	00
	.debug	T	070000AE000200AF00
	.debug	T	3C0003AF001600040001000700000008646174614C656E00540002
	.debug	T	000A6576656E7446756E630006000400086368616E4E756D00
	.debug	T	30000600056461746100
	.debug	T	070008B00004004500
	.debug	T	070000B10002004200
	.debug	T	070000B20002002300
	.debug	T	070000B30002000A00
	.debug	T	070000B40002000900
	.debug	T	070000B5000200B600
	.debug	T	3F0003B6000A000500010023000000046275660006000200036664
	.debug	T	00070004000862756653697A650007000600086E6578744F75
	.debug	T	74000700080006636F756E7400
	.debug	T	070000B70002000700
	.debug	T	070000B80002005A00
	.debug	T	090001B900800003008000
	.debug	T	280003BA0004000100125F5F776169745F71756575655F68656164
	.debug	T	00C8000000096C6973744865616400
	.debug	T	070000BB000200BC00
	.debug	T	0F0002BC00020006000300000054000200
	.debug	T	070000BD000200BE00
	.debug	T	0B0002BE000100060054000000
	.debug	T	070000BF000200C000
	.debug	T	130002C000030008002F0000000800040054000800
	.debug	T	090001C100500003005000
	.debug	T	090001C200740003007400
	.debug	T	070008C30004004700
	.debug	T	090001C40008000A000200
	.debug	T	070000C50002002A00
	.debug	T	070000C6000200C700
	.debug	T	130002C70003000600540000005A00020007000600
	.debug	T	260003C800040002000A6C6973745F6865616400C9000000056E65
	.debug	T	787400C9000200057072657600
	.debug	T	070000C9000200C800
	.seg	CONST
@2:
	.db	"Unknown ",0,"NovaStar",0,"HotShot ",0,"console",0,"fastdatad",0,"modbusTCPd",0,"tsh",0,"settings",0,"devData",0,"hdwcfg",0,"1"
	.db	"6:38:56",0,"Fri Jan 11 2013",0,27,"[31m NO",0,27,"[34mYES",0,27,"[31m",0,27,"[34m",0,"INTLK",0,"  OFF",0,"   ON",0,34,0,31,0,"set",0,"bias",0,"o"
	.db	"n",0,"off",0,"sptr",0,"oven1",0,"oven2",0,"reset",0,"send",0,"Oven1",0,"Oven2",0,"Bias",0,"Sputter",0,"NOT",0,"started",0,"Asserted",0,"Clear"
	.db	"ed",0,"AV",0,"SV",0,"AA",0,"SA",0,"OS",0,"AL",0,"PS",0,13,10,0,":DCL;",0,":ADR01;",0,":RMT2;",0,":OUT1;",0,":OUT0;",0,":STT?;",0,"255.255.0.0",0,"192."
	.db	"168.0.1",0,"fifoEvents",0,"inetd",0,"configd",0,"backupd",0,"ca_tcpd",0,"ovenCom",0
	.seg	FARCONST
@1:
	.db	"DoReboot",0,"dlmVersTime",0,"rtosVersTime",0,"applVersTime",0,"devType_",0,"deviceID_",0,"upSecs",0,"percentIdle_"
	.db	0,"numChans",0,"coilChanMult",0,"reg3ChanMult",0,"reg4ChanMult",0,"digInBits",0,"statusBitsStdA",0,"statusBitsS"
	.db	"tdB",0,"statusBitsAppl",0,"rfSupplyType",0,"sptrReadV",0,"sptrReadA",0,"biasReadV",0,"biasReadA",0,"oven1ReadV",0,"ov"
	.db	"en1ReadA",0,"rfgenReadV",0,"rfgenReadA",0,"rfgenReadW",0,"serOven1ReadV",0,"serOven1ReadA",0,"oven1Status",0,"lat"
	.db	"ency",0,"tcpTickTime",0,"applLoopTime",0,"nonKernelLocks",0,"failedLocks",0,"duplicateLocks",0,"oven1NumMsgs",0
	.db	"oven1GoodMsgs",0,"oven1BadMsgs",0,"adc00",0,"adc01",0,"adc02",0,"adc03",0,"adc04",0,"adc05",0,"adc06",0,"adc07",0,"oven2ReadV"
	.db	0,"oven2ReadA",0,"serOven2ReadV",0,"serOven2ReadA",0,"oven2Status",0,"oven2NumMsgs",0,"oven2GoodMsgs",0,"oven2B"
	.db	"adMsgs",0,"kernelLoopTime",0,"timeZone_",0,"curTime",0,"ipAddr",0,"netmask",0,"gateway",0,"setACoil",0,"resetACoil",0,"di"
	.db	"gOutBits",0,"cmdBitsStd",0,"cmdBitsAppl",0,"sptrSetV",0,"biasSetV",0,"oven1SetV",0,"rfgenSetV",0,"serOven1SetV",0,"se"
	.db	"rOven1SetA",0,"sptrMaxErrV",0,"sptrMaxErrMS",0,"biasMaxErrV",0,"biasMaxErrMS",0,"oven1MaxErrV",0,"oven1MaxErr"
	.db	"MS",0,"forceOvenErr",0,"oven1PwrOffDelay",0,"oven2SetV",0,"serOven2SetV",0,"serOven2SetA",0,"oven2MaxErrV",0,"ove"
	.db	"n2MaxErrMS",0,"oven2PwrOffDelay",0,"Sptr Interlock ASSERTED",0,"Sptr Interlock CLEARED",0,"Enable Pow"
	.db	"er to Oven2 PS",0,"Disable Power to Oven2 PS",0,"Enable Oven2 PS Output",0,"Disable Oven2 PS Outp"
	.db	"ut",0,"Enable Oven1 PS Output",0,"Disable Oven1 PS Output",0,"Enable Power to Oven1 PS",0,"Disable Po"
	.db	"wer to Oven1 PS",0,"Assert Bias PS ON",0,"Assert Bias PS OFF",0,"Assert Sptr PS ON",0,"Assert Sptr PS"
	.db	" OFF",0,"timeZone",0,"srfsIPAddr",0,"ainLabel",0,"aoutLabel",0,"dinLabel",0,"doutLabel",0,"readGain",0,"readOffset",0,"se"
	.db	"tGain",0,"setOffset",0,"hostName",0,"srfsAltAddr",0,"extraInLabel",0,"new timezone value: %d",10,0,13,10,"===== Ini"
	.db	"tial Digital Input states =====",13,10,0,"%ls",13,10,0,13,10,"===== Initial Digital Output states =====",13,10
	.db	0,"restore from param file: %.24s",10,0,"%s %s",0,"*** Saving ApplState ***",13,10,0,13,10,"*** Restored Appl"
	.db	"ication State ***",13,10,10,0,"AIN-%u",0,"AOUT-%u",0,"DIN-%u",0,"DOUT-%u",0,"ExtraIN-%u",0,27,"[%02d;%02dH",0,"[%.128s]",13,10
	.db	0,13,10,"Usage:  cmd bias|sptr| on|off|set #",13,10,"            oven1 on|off|reset|set #|send <st"
	.db	"r>",13,10,"            oven2 on|off|reset|set #|send <str>",13,10,0,"%s Set/Read error exceeded thre"
	.db	"sholds:",13,10,"  Analog:  Volts: %.16s  SetV: %.16s  Amps: %.16s",13,10,0,"%s Set/Read error now wi"
	.db	"thin thresholds",13,10,0,"Oven%d ON cmd ignored while Interlock exists",10,0,"Oven%d PS %s respondi"
	.db	"ng",10,0,"Oven%d PS ON request",10,0,"Oven%d PS already ON",10,0,"Oven%d PS OFF request",10,0,"Oven%d PS alre"
	.db	"ady OFF",10,0,"Oven%d PS RESET request",10,0,"Bias PS ON request",10,0,"Bias PS already ON",10,0,"Bias PS OFF"
	.db	" request",10,0,"Bias PS already OFF",10,0,"Sputter PS ON request",10,0,"Sputter PS already ON",10,0,"Ext inte"
	.db	"rlock still asserted",10,0,"Sputter PS OFF request",10,0,"Sputter PS already OFF",10,0,"Oven%d Output S"
	.db	"tate error Interlock %s",10,0,"%s%s%sOven%d OP Status: [%.8s]",13,10,0,"  Constant Voltage: %d",13,10,"  F"
	.db	"oldback Protection: %d",13,10,"  Auto-restart: %d",13,10,"  Output ON: %d",13,10,"  Foldback SRQ: %d",13,10,"  O"
	.db	"ver voltage SRQ: %d",13,10,"  Over temp SRQ: %d",13,10,0,"%s%s%sOven%d Alarm Status: [%.8s]",13,10,0,"  *** "
	.db	"Overvoltage Protection tripped ***",13,10,0,"  *** Overtemp Protection tripped ***",13,10,0,"  *** In"
	.db	"put Voltage Supply Failure ***",13,10,0,"  *** Foldback Protection tripped ***",13,10,0,"  *** Cmd Er"
	.db	"ror ***",13,10,0,"  Analog:  Volts: %.16s  SetV: %.16s  Amps: %.16s",13,10,"  Serial:  Volts: %.16s "
	.db	" SetV: %.16s  Amps: %.16s",13,10,0,"%s%s%sOven%d Serial Status: [%.8s]",13,10,0,"  Unrecognized comma"
	.db	"nd",13,10,0,"  Buffer Overflow",13,10,0,"  Req Voltage out of range",13,10,0,"  Req Current out of range",13,10,0,"/d"
	.db	"ev/tty%d",0,"Unable to open %s for Oven%d PS",13,10,0,"error reading resp from Oven supply",0,"mangle"
	.db	"d response: [%.128s]",13,10,0,"Invalid resp: [%.128s]",13,10,0,"Setting default labels for I/O signal"
	.db	"s",13,10,0,"unused DI-%02u",0,"ID_SW_%02u",0,"unused DO-%02u",0,"Sputter Interlock OK",0,"Not HotShot RF PS",0,"N"
	.db	"ot NovaStar RF PS",0,"Activity LED",0,"Oven2 PS Power OFF",0,"Oven2 Output Disabled",0,"Oven1 Output "
	.db	"Disabled",0,"Extern Watchdog Timer",0,"Oven1 PS Power OFF",0,"Bias PS Power OFF",0,"Sputter PS Power "
	.db	"OFF",0,"Oven1 Read V",0,"Bias Read V",0,"Sputter Read V",0,"Sputter Read A",0,"Bias Read A",0,"Oven1 Read A",0,"O"
	.db	"ven2 Read V",0,"Oven2 Read A",0,"Oven1 Set V",0,"Bias Set V",0,"Sputter Set V",0,"Oven2 Set V",0,"Setting in-"
	.db	"RAM device config to default values",13,10,0,"Application prepping for shutdown",13,10,0,"applic proc"
	.db	"ess started",13,10,0,"*** restoreApplState() failed (%d):  Doing CPU reset ***",13,10,0,13,10,"***** Netw"
	.db	"ork did not come up! *****",13,10,0,"free memory: %ld",13,10,0,"cmd",0,"Application-specific commands",0,"ove"
	.db	"nCom",0,"Lambda/Oven PS serial link",0,"state",0,"Show state of controller",0
	.end
