	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\appl\PhaseCtlr\PhaseCtlrAppl.c' 29 29 16 8 1 33
;1 //----- PhaseCtlrAppl.c ----- 01/08/13 -----(03/05/06)----
;2 
;3 // scope 5 appllooptime latency tcpticktime kernellooptime fwdampl
;4 
;5 //-------------------------------------------------------------------------
;6 //  Application-specific code run at a regular interval
;7 //  Application code to measure and control phase of RF frequency signals.
;8 //  Incorporates the following hardware:
;9 //
;10 //  - Single Board Computer (RCM3200: 44 MHz 8-bit CPU, 768K RAM, 512K flas
;11 //  - Serial EEPROM (ATMEL AT26F004, 512K bytes)
;12 //  - LMK02002 (Precision Clock Conditioner with Integrated PLL)
;13 //  - Xilinx Spartan-II FPGA
;14 //  - DSP (make/model ?)
;15 //  - high-speed ADC (still using ADC644x?)
;16 //-------------------------------------------------------------------------
;17 //  Update log (most recent first):
;18 //
;19 //
;20 //  2013-01-08 - Mark Davis
;21 //               - updateCurState() now reads a waveform OR does the period
;22 //                 I/O in a pass, but not both.
;23 //
;24 //  2012-11-13 - Mark Davis
;25 //               - Added #defines for DSP registers CavHighIlkLevel and
;26 //                 FwdHighIlkLevel, entries in the table need to connect th
;27 //                 to the corresponding new registers, and added the regist
;28 //                 to the list of persistent values.
;29 //
;30 //  2012-09-26 - Mark Davis (test)
;31 //               - Added OUTI() macro to make it easy to switch between the
;32 //                 slower WrPortI() and faster outi() methods of writing to
;33 //                 an internal register value.
;34 //
;35 //  2012-09-21 - Mark Davis (test)
;36 //               - Went back to using a 1MHz clock for the progdsp command 
;37 //                 see if that allows it to work reliably again.
;38 //
;39 //  2012-09-10 - Mark Davis
;40 //               - Changed so setAtten no longer has any affect (per Nathan
;41 //
;42 //  2012-08-03 - Mark Davis
;43 //               - Modified readPlot() to use new variants on SPI interface
;44 //                 reduce overhead.
;45 //               - Incr clock freq for talking to DSP to 2 MHz which furthe
;46 //                 reduced the time needed to read the data for a waveform.
;47 //
;48 //  2012-08-01 - Mark Davis
;49 //               - Tweaking locking and timeouts to address performance iss
;50 //
;51 //  2012-07-27 - Mark Davis
;52 //               - Improved efficiency of PV_UpdateValWF() by having it tes
;53 //                 the time stamps before even attempting to get the locks.
;54 //
;55 //  2012-07-25 - Mark Davis
;56 //               - PV_UpdateValWF() now updates the size and numElems value
;57 //                 for the current PV value
;58 //               - For non HT_PHASE_CTLR hardware, readWaveform() now uses 
;59 //                 typical # of elements for each waveform that the DSP
;60 //                 specifies on HT_PHASE_CTLR hardware.
;61 //
;62 //  2012-07-23 - Mark Davis
;63 //               - The basic structural changes to support locking of "exte
;64 //                 PV values (ones non defined via the ModBus register macr
;65 //                 are now working.
;66 //               - Corrected the "simulated" 16-bit ampl/phase waveform val
;67 //                 computed for testing the code on non-PhCtlr module hardw
;68 //
;69 //  2012-07-09 - Mark Davis
;70 //               - Added code to allow basic testing of triggering and read
;71 //                 of fake CTF waveforms on non-PhaseCtlr hdw.
;72 //               - Added "finished" log msg for CTF calculation
;73 //
;74 //  2012-04-27 - Mark Davis
;75 //               - replaced the 16-bit signed stepperReadPos and stepperSet
;76 //                 registers with 32-bit signed registers
;77 //
;78 //  2012-04-19 - Mark Davis
;79 //               - Rewrote getLock() and modified releaseLock() to use unna
;80 //                 shared/global semaphores.  Prior to this there were stil
;81 //                 instances where the locks would not be correctly release
;82 //
;83 //  2012-04-18 - Mark Davis
;84 //               - Changed all WrPortI() calls to outi() calls which genera
;85 //                 smaller/faster code.
;86 //
;87 //  2012-04-02 - Mark Davis
;88 //               - Began adding structures to test use of extensions to new
;89 //                 interface that handle values other than those defined vi
;90 //                 the ModBus register macros.
;91 //
;92 //  2012-03-05 - Mark Davis
;93 //               - Updated default values for several settings per Nathan.
;94 //
;95 //  2012-01-16 - Mark Davis
;96 //               - Changed argument for releaseLock() to uint.  This is so 
;97 //                 is consistent with getLock() and to avoid any possible
;98 //                 compiler errors (and excess code) converting between uch
;99 //                 and uint.
;100 //               - Changed all getLock calls so a return value  of 0 is not
;101 //                 treated as meaning that it got the lock.  This shouldn't
;102 //                 possible, but better safe than sorry.
;103 //
;104 //  2010-12-01 - Mark Davis
;105 //               - Added Pulse_Ramp DSP RW and ModBus registers and made it
;106 //                 a persistent value.
;107 //
;108 //  2010-10-29 - Mark Davis
;109 //               - Added setDSPState to the saved settings file
;110 //
;111 //  2010-09-16 - Mark Davis
;112 //               - Added #defines for DSP registers FwdAmplGain and CavAmpl
;113 //                 and entries in the table need to connect them to the reg
;114 //                 values fwdAmplGain and cavAmplGain.
;115 //               - Added rfq_t1_offset and rfq_t2_offset to the list of
;116 //                 persistent values.
;117 //
;118 //  2010-08-26 - Mark Davis
;119 //               - The Mode for the DSP register values RFQ_T1_Offset and
;120 //                 RFQ_T2_Offset was changed from ONCE to EVERY
;121 //
;122 //  2010-06-15 - Mark Davis
;123 //               - Added a floating point version of the dspTemp register a
;124 //                 displayed the floating point vesion on the state screen.
;125 //
;126 //  2010-06-10 - Mark Davis
;127 //               - Added autocal command
;128 //
;129 //  2010-05-07 - Mark Davis
;130 //               - Moved initialization of FPGA to after the PLL init (per
;131 //                 Nathan, who said it isn't working the other way since I
;132 //                 fixed the sleepMS() func to work properly when called fr
;133 //                 the applic task).
;134 //
;135 //  2010-04-26 - Mark Davis
;136 //               - changes to accomodate updated wait queue interface
;137 //
;138 //  2010-04-20 - Mark Davis
;139 //               - Support for new registers that provide tuner-related val
;140 //                 that get forwarded to other devices via EPICS.
;141 //
;142 //  2010-03-31 - Mark Davis
;143 //               - Added resetfpga command
;144 //
;145 //  2010-02-18 - Mark Davis
;146 //               - Added maxOutAmplGain/Offset
;147 //
;148 //  2010-02-12 - Mark Davis
;149 //               - fwdCavOffset is now a PHASE type
;150 //               - all new phase values are now "wrapped" to 0 <= val < 360
;151 //               - added maxAmplSet register, made it persistent, and used 
;152 //                 to limit all ampl-related settings
;153 //               - added ability to use a pllInitSeq stored in a flash file
;154 //
;155 //  2010-02-08 - Mark Davis
;156 //               - Chgd piezoPos and stepperPos to piezoSetPos, piezoReadPo
;157 //                 stepperSetPos, stepperReadPos
;158 //
;159 //  2010-02-04 - Mark Davis
;160 //               - More tweaks, fixes to scaling logic and settings
;161 //               - Added dspcalib command to make calibrating the gain and
;162 //                 values easy (fixed new command on 2010-02-05)
;163 //
;164 //  2010-02-03 - Mark Davis
;165 //               - Tweaks, fixes to scaling logic and settings
;166 //
;167 //  2010-01-26 - Mark Davis
;168 //               - First reasonably complete vers with revamped DSP interfa
;169 //
;170 //  2009-12-14 - Mark Davis
;171 //               - Changed order of param files to deal with problems cause
;172 //                 by the order in which they were restored at startup.
;173 //
;174 //  2009-12-11 - Mark Davis
;175 //               - started changes to accomodate overhaul of DSP registers
;176 //
;177 //  2009-10-29 - Mark Davis
;178 //               - Updated pllInitSeq's from Dan Morris
;179 //
;180 //  2009-08-04 - Mark Davis
;181 //               - Changed ADC init sequence from 0400 0443  to 0400 0403
;182 //                 (in initDefaults() func)
;183 //
;184 //  2009-06-30 - Mark Davis
;185 //               - Changed pllInitSeq0[] again per Nathan
;186 //
;187 //  2009-06-26 - Mark Davis
;188 //               - Changed pllInitSeq0[] per Nathan
;189 //
;190 //  2009-06-23 - Mark Davis -
;191 //               - Changed all watchdog timer resets to call resetWDT() to
;192 //                 work with new reboot diagnostics.
;193 //
;194 //  2009-06-16 - Mark Davis -
;195 //               - Changed default value for pllInitIdx to 1
;196 //
;197 //  2009-06-08 - Mark Davis -
;198 //               - Added piezoPos and stepperPos values
;199 //
;200 //  2009-03-30 - Mark Davis -
;201 //               - Added new Modbus register values:
;202 //                 - Two floating-point and one int value for readings from
;203 //                   external device (updated by the control system)
;204 //                 - Two floating-point and one int value for settings for 
;205 //                   external device (forwarded to the device by the ctl sy
;206 //
;207 //  2009-03-21 - Mark Davis -
;208 //               - Added digInDescr[] and digOutDescr[] to support the newe
;209 //                 generic method for logging changes of interest in the st
;210 //                 of the digital I/O signals.
;211 //
;212 //  2009-03-02 - Mark Davis -
;213 //               - Added ability to use 1 of 2 different PLL init sequences
;214 //               - The DSP is now reset after the PLL, ADC initialization
;215 //
;216 //  2008-10-01 - Mark Davis -
;217 //               - added WriteDig() calls to resetDSP() so it works again..
;218 //
;219 //  2008-09-25 - Mark Davis -
;220 //               - moved init of PLL settings to after init of FPGA
;221 //
;222 //  2008-09-24 - Mark Davis -
;223 //               - corrrections to changes for new clock ctlr/PLL
;224 //
;225 //  2008-09-23 - Mark Davis -
;226 //               - removed outdate progfpga and related code
;227 //
;228 //  2008-09-22 - Mark Davis -
;229 //               - changes to fix FPGA download problems
;230 //
;231 //  2008-09-09 - Mark Davis -
;232 //               - changes to support new clock ctlr/PLL (National LMK02002
;233 //
;234 //  2008-05-21 - Mark Davis -
;235 //               - changes to support new ADC chip on 3rd prototype
;236 //
;237 //  2008-05-19 - Mark Davis -
;238 //               - changes to properly recognize when FPGA has initialized 
;239 //                 latest prototype
;240 //
;241 //  2008-04-30 - Mark Davis -
;242 //               - first set of changes for 3rd prototype with serial EEPRO
;243 //                 modified FPGA and DSP interfaces
;244 //
;245 //  2007-04-11 - Mark Davis -
;246 //               - adding logic to implement pulsed settings for tuning the
;247 //                 PID parameters
;248 //
;249 //  2007-03-16 - Mark Davis -
;250 //               - began adding application-specific data to Modbus registe
;251 //                 set
;252 //
;253 //  2007-03-14 - Mark Davis -
;254 //               - changed code to include (although commented out in this
;255 //                 application for now) a call to rwIO() (which reads and
;256 //                 writes the analog and digital I/O signals).
;257 //
;258 //  2007-03-13 - Mark Davis -
;259 //               - added DISABLE_AUTO_IO to disable the normal reading/writ
;260 //                 of digital and analog I/O signals by the shared applicat
;261 //                 code.
;262 //
;263 //  2007-03-04 - Mark Davis -
;264 //               - reworked X-Macro usage to allow application-specific
;265 //                 register definitions to reside in the same file as the
;266 //                 rest of the application-specific code.
;267 //
;268 //  2007-02-09 - Mark Davis -
;269 //               - made WrRdDSP more general and more capable to simplify t
;270 //                 funcs that call it
;271 //
;272 //  2007-02-02 - Mark Davis -
;273 //               - streamlined SPI communications with DSP
;274 //
;275 //  2006-10-05 - Mark Davis -
;276 //               - ported Adam Molzhan's old Dynamic-C version of code
;277 //                 and did major cleanup & reorganization to streamline it
;278 //                 (now manages 50 cycles/sec rather than 3)
;279 //
;280 //-------------------------------------------------------------------------
;281 /*
;282 NOTE:  CTF = Cavity Transfer Function (which is no longer supported...)
;283 
;284 Overview of the startup sequence:
;285 
;286   - The EEPROM contains the code for the FPGA.  On startup, one of the digi
;287     inputs to the FPGA (FPGA_SPI) is toggled, which causes it to take over 
;288     SPI connection to the EEPROM and load the binary image stored there.  A
;289     digital output from the FPGA is monitored to indicate when this has
;290     completed (it takes a little less than 2 seconds).
;291 
;292   - The code for the DSP is stored in the DSP itself.  Similar to how the
;293     DEBROS update command can be used to update the DEBROS boot image, the 
;294     code provides a mechanism for updating the copies of the DSP code store
;295     within the DSP.  When the DSP is running a working copy of the DSP code
;296     the progdsp command can be used to download a new copy of DSP code in t
;297     the DSP itself.
;298 
;299     So updating or storing the initial working copy of DSP code requires th
;300     a working copy of DSP code is already running in the DSP.  If a working
;301     copied is stored at the correct place within the DSP memory, then the D
;302     will load it and run it after being reset.  But if there isn't a workin
;303     copy in the DSP memory, then getting it to run a working copy can only 
;304     accomplished by running the appropriate development software on a deskt
;305     PC and use of a special cable between the PC and the controller (again,
;306     very similar to how the DLM is downloaded to a Rabbit Core Module).
;307 
;308 
;309 Communicating with the DSP:
;310 
;311   - Exchange of data with the DSP is done using a bi-directional (simultane
;312     send/recv) clocked SPI interface.  All data is exchanged in 32-bit (4-b
;313     packets.  While we are sending a 32-bit packet to the DSP, it is using 
;314     same clock pulses to simultaneously send a 32-bit packet in response.
;315 
;316     Each exchange of a 32-bit packet consists of setting the DSP /Enable si
;317     low, writing (while simultaneously reading) 32-bits of data, and then
;318     setting the DSP /Enable signal high.
;319 
;320     Due to the way the DSP buffers are set up, all responses from the DSP a
;321     always 2 packets "behind" the ones that contained the commands that the
;322     are a response to.  We can write as many commands as we want in a
;323     sequence of packets, but the response to each one will always be receiv
;324     2 packets later.  Given that we generally want to read the response to
;325     a set of commands as soon as possible, we normally have to add some
;326     dummy or filler packets to the sequence to get the desired response
;327     packets.  For extended responses (like reading of waveform data), we mu
;328     send lots of filler packets to get all the data.
;329 
;330 
;331 Revamped register conventions (Jan 2010):
;332 
;333   - Communication with the DSP is done by reading and writing "register"
;334     values, each of which has an "address".  Even numbered addresses are fo
;335     reading and odd numbered ones are for writing (i.e. the least significa
;336     bit specifies a read or write operation).
;337 
;338   - Reading a register value is done by sending the 4-byte address of the
;339     register and then reading (2 packets later) its 4 byte value.
;340 
;341   - Writing to a register is done by sending the 4-byte address and then th
;342     4-byte value.  The DSP responds (with the usual 2-packet delay) with th
;343     4-byte address and 4-byte value as a means of verifying that the we are
;344     communicating with the DSP and that it received the correct values.
;345 
;346     The meaning of the 4-byte value is dependent on the register.  The most
;347     common representations used are 32-bit floats, 32 and 16-bit integers,
;348     and bit-mapped values.  The values are always in network byte order (mo
;349     significant first).
;350 
;351 
;352   - Registers come in several varieties:
;353 
;354       Read-Only-and-Continuously:
;355          The value should be read each pass to keep track of the current st
;356 
;357       Write-Only-and-Continuously:
;358          These represent settings that we want asserted all the time.  If t
;359          DSP resets, these values will be quickly re-asserted because they 
;360          written to the DSP each pass.
;361 
;362       Write-Once, Read-never:
;363          Writing to the value triggers some action so writing to them each
;364          pass is not an option.  These registers generally provide the mean
;365          to write to one instance in a table of values maintained within th
;366          DSP itself, where the row written to is based on the current state
;367          of the DSP.
;368 
;369       Read/Write-continuously:
;370          Such registers have both a separate read and write register and of
;371          corresponding separate read and write ModBus values.  The usual ca
;372          is that the write value represents a setpoint and read value
;373          represents the current state or readback value.
;374 
;375       Read-Trigger:
;376          Reading from the register triggers some event such as starting or
;377          stopping a calculation, so it is done only when we want to trigger
;378          the corresponding process or event.
;379 
;380 
;381   - Most the DSP registers have a corresponding ModBus register.  Tables ar
;382     used to provide the information that links them together.  About 20 tim
;383     per second the main application task uses these tables to read and writ
;384     values from/to the DSP.
;385 
;386     The table for the read-only registers causes the ModBus register values
;387     that correspond to each DSP register to be updated.  The table for the
;388     writable registers is used to write the current value of each of the
;389     corresponding ModBus registers to the DSP.  This means that, if the DSP
;390     resets for any reason, the current state will be restored very quickly.
;391 
;392   - The dspread and dspwrite commands provide a mechanism to manually read
;393     values from and write values to the DSP.  Just be careful about using
;394     registers that trigger some event within the DSP as this can interfere
;395     with normal operation.
;396 
;397   - To facilitate testing, the normal periodic reading from and writing to 
;398     DSP registers can be disabled or enabled using the dspio command.
;399 
;400 
;401   - The register values provide information about the state of the DSP.
;402     One of the registers is a bit-mapped status value, with bits that
;403     indicate if new waveform data is available for reading.
;404 
;405     For each waveform we check to see if we have an open connection to a
;406     client for the waveform and if there is new data or a fixed interval
;407     of time has elapsed.  If these conditions are met, then we read the
;408     corresponding waveform data as follows:
;409 
;410       - Using the write/read 4-bytes methodology described above,
;411         read the # of 32-bit words of data available for the waveform.
;412 
;413       - Using the value 0x0010##00 for the 4 bytes we write each
;414         time (where ## indicates which waveform we want data for),
;415         use the write/read 4-bytes methodology to read the
;416         indicated # of 32-bit words of data.
;417 
;418     A couple of the waveforms take around 40 seconds to compute and the
;419     DSP must be told when to compute them.  For these an additional
;420     register provides the %complete the computation is so we can monitor
;421     the progress of the computation and determine when it is available
;422     for reading.
;423 
;424 
;425  - Some of the bit-mapped registers we can write to represent multiple valu
;426    each represented by more than one bit.  When writing to these registers,
;427    all 0's for a given group means do not change the value of any of the
;428    bits in that group.
;429 
;430    To insure that the DSP state is properly restored if it is reset, the la
;431    value of each bit-group within such registers must be kept track of.  Th
;432    minimizes problems caused by DSP resets.
;433 
;434 
;435  - The SPI interface used to communicate with the DSP is also used to
;436    communicate with the FPGA, the PLL, and the ADC's.  To allow multiple ta
;437    to communicate with with these devices, a locking mechanism is provided 
;438    insure that only one task is using the shared SPI connection and related
;439    data values at any given time.
;440 
;441 
;442  - The DSP xxxCalib value registers (0x0010022A - 0x001000239) are used
;443    to write a given value in to a table of values based on the current stat
;444    of another value (attenuations?), so they cannot be included in the set
;445    that is constantly being written to.  Writing to one of these registers
;446    is done just once when you need to write a value to the table stored in
;447    the DSP.  Saving the table is done by reading from the register at the
;448    end of that range (SaveCalibToDSP: 0x0010023A).
;449 
;450 ---------------------------------------------------------------------------
;451 
;452 
;453 //-------------------------------------------------------------------------
;454 //  TO-DO:
;455 //
;456 //  - Reading/writing the DSP registers takes around 15 ms (?) at present.
;457 //    Given the various imposed limits on how often we read/write the DSP
;458 //    registers and how often we read waveform data, I am not sure if the
;459 //    reading of waveform data can (and does) happen during the same pass.
;460 //    If it does, I should change it so it does NOT, which would reduce the
;461 //    time the applic loop runs during a pass that we are reading a wavefor
;462 //
;463 //  - Consider creating a faster version of readPlot() in assembly, as this
;464 //    is one of the functions that consumes much of the CPU time during man
;465 //    of the executions of the main applic task's loop.
;466 //
;467 //  - Same for read_DSP_Regs() and write_DSP_regs(), although these are a b
;468 //    trickier as they have to read-from-DSP/convert/save-to-PV or
;469 //    read-from-PV/convert/write-to-DSP for each value.
;470 //
;471 //  - If it turns out we don't need slower code for the setting/clearing th
;472 //    SPI-enable signal for the DSP, then consider making it even faster by
;473 //    using the set/reset internal reg bit macros ioSetBitI() and ioClearBi
;474 //
;475 //-------------------------------------------------------------------------
;476 //  Work in progress:
;477 //
;478 //  - Need to deal with multiple sources of R/W requests for the DSP.  The
;479 //    situation is not as simple as representing the DSP as a std streaming
;480 //    device that reads() and writes() can be interleaved on.  The followin
;481 //    constraints exist:
;482 //
;483 //    - SPI port 1 is connected to the FPGA, PLL, DSP, and ADC's
;484 //
;485 //    - Different control bits and clock modes are required for different
;486 //      devices
;487 //
;488 //    - Reads and Writes to the DSP are not independant.  In at least some
;489 //      cases, you have to know how many bytes to read from the DSP at the
;490 //      time you begin writing to it.
;491 //
;492 //    - Reads and Writes to the DSP always consist of an even number of byt
;493 //
;494 //    - Reads and Writes to the DSP require a control bit be toggled betwee
;495 //      each pair of bytes transferred
;496 //
;497 //
;498 //  Events/processes that require use of the SPI connection:
;499 //
;500 //  - Writing commands to the ADC's
;501 //
;502 //  - Writing commands to the FPGA
;503 //
;504 //  - Writing commands to and reading data from the DSP (where some of the
;505 //    responses can be up to 1024 bytes in length)
;506 //
;507 //  - Downloading a new config file to the FPGA (or the DSP?)
;508 //
;509 //  - A write to a Modbus register that mirrors a value in the DSP
;510 //
;511 //
;512 //  Two options and issues regarding sharing this single resource that many
;513 //  tasks need to use or affect:
;514 //
;515 //  - Extension of current approach:  Use a semaphore to limit access to a
;516 //    single task at a time.
;517 //
;518 //  - Limit all access to a single task and send msgs to the task requestin
;519 //    certain actions
;520 //
;521 //  The semaphore approach has one major drawback:  Tasks that cannot block
;522 //  (like the main applic process) must either give up on an action or keep
;523 //  data needed to process the request and retry until successful or an err
;524 //  occurs.  It has the advantage that it means less code for tasks that CA
;525 //  block without a problem.
;526 //
;527 //  The message approach has the advantage that a task can send a message a
;528 //  the request and pretty much forget about it.  The disadvantages are tha
;529 //  their is no easy way to provide feedback to the requesting task, and th
;530 //  all the work has to be done in one task.
;531 //
;532 //
;533 //  Basic problem scenario:
;534 //
;535 //    A command is issued to download a new image to the FPGA or the DSP.
;536 //    This can tie up the SPI for several seconds.  While this is going on,
;537 //    several Modbus writes to registers mirroring DSP values happen.  Thes
;538 //    writes cause event messages to be written to the main application's
;539 //    event msg queue.  The application loop, which is still running while
;540 //    the download to the FPGA is going on, cannot use the SPI line, so it
;541 //    cannot read values from the DSP to update its state data, much less
;542 //    process the messages to write new values to the DSP.  In order to
;543 //    not loose the write events, it has to stop processing the event
;544 //    messages, which means the queue could overflow, causing processes
;545 //    that write to the queue to block.
;546 //
;547 //  I don't see any way around this.  The SPI line serves several purposes
;548 //  and it is either in use or it is not.  If it is in use, a task that
;549 //  wishes to use it can either block or not.  For processes that cannot
;550 //  (or should not) block, they can either ignore/forget what they were
;551 //  going to do with the SPI connection or keep track of what they were
;552 //  about to do and keep polling periodically, waiting for their chance
;553 //  to use the SPI connection.
;554 //
;555 //  This is really nothing but the basic limitation of any resource that
;556 //  must be protected against concurrent usage.  A locking mechanism is
;557 //  required that insures only one user at a time, and tasks contending for
;558 //  the resource have 3 choices:
;559 //
;560 //  - block on the resource (and get woken up when it is available)
;561 //
;562 //  - poll in a loop, waiting until they get access, possibly doing other
;563 //    useful stuff that is not dependent on the the event that cannot be
;564 //    completed until the locked resource is available
;565 //
;566 //  - forget what they needed it for and continue on
;567 //
;568 //
;569 //  So, when the main application process needs the SPI line, it will eithe
;570 //  have to block on a wait queue, or simply suspend processing of event
;571 //  messages.  The advantage of the blocking approach is that the order of
;572 //  requests for the SPI line will be enforced by the wait queue.  On the
;573 //  other hand, I might want to grant access based on priority as well, whe
;574 //  higher priority tasks get unblocked before lower priority ones.  But as
;575 //  a general rule, ignoring the sequence of requests can lead to other
;576 //  problems.
;577 //
;578 //-------------------------------------------------------------------------
;579 //
;580 //  More notes on SPI port usage:
;581 //
;582 //  The model I am using for the SPI port is not right.  It should be treat
;583 //  more like a disk drive or a network connection.
;584 //
;585 //  When a serial port is used as a point-to-point connection between 2 dev
;586 //  it often makes sense to allow the application code to directly manage t
;587 //  connection.  But when there are multiple devices connected via the same
;588 //  communications medium, then the connection is a bus, and the connection
;589 //  needs to be handled by a driver that provides a layer of abstraction fo
;590 //  communicating with the devices attached to the bus.
;591 //
;592 //  In this case, something more like a device special file per device atta
;593 //  to the SPI port makes more sense, where the major device # is for the S
;594 //  port and the minor specifies which device on the "bus".  Then individua
;595 //  architecture modules can deal with them however I want (for devices tha
;596 //  a particular board does not have, it can either return errors for attem
;597 //  to access the device, or I could have a test mode where they mimic the
;598 //  device to some degree, or simply return no errors).
;599 //
;600 //-------------------------------------------------------------------------
;601 // Keeping Modbus register values (global variables) in sync with the DSP
;602 // settings vs reading waveform data after changing a setting (is this stil
;603 // or was it EVER true?  We read waveform data if/when it ):
;604 //
;605 //  - Ampl and phase values in DSP and ModBus register (global variable) va
;606 //    must be kept in sync
;607 //
;608 //  - When we want to read the waveform data from the DSP to see the effect
;609 //    of changing the ampl and/or phase value, we have to make the settings
;610 //    and read the waveform data as a single transaction
;611 //
;612 //  - Oone possibility is to read the waveform data EVERY time the ampl or
;613 //    phase setpoints are altered.  Then there is no distinction between "j
;614 //    setting" one of them vs setting-and-reading
;615 //    BUT:  The problem with that is it doesn't allow for changing BOTH the
;616 //    the phase and amplitude and reading the result.
;617 //
;618 //-------------------------------------------------------------------------
;619 //
;620 //  "Pulsed" tuning test mode:
;621 //
;622 //    The DSP normally controls the Amplitude and Phase values using a stan
;623 //    PID feedback-loop algorithm.  To facilitate the tuning of the PID wei
;624 //    used by the feedback loop, the DSP and controller provide a "pulsed"
;625 //    tuning/test mode where the DSP periodically cycles the Amplitude and/
;626 //    Phase setpoints between two settings and captures a portion of the
;627 //    resulting outputs in a buffer that the controller's CPU can read and
;628 //    send to a remote client for the purpose of providing a near real-time
;629 //    plot of the resulting waveforms.
;630 //
;631 //
;632 //  Basic operation:
;633 //
;634 //    The DSP contains all the logic and code for actually implementing the
;635 //    pulsed test functionality.  It requires the following values to be se
;636 //    before this mode is enabled:
;637 //
;638 //    - Nominal Amplitude and Phase setpoints:  These are the "normal"
;639 //      setpoints, used when the pulsed mode is not active.
;640 //
;641 //    - Pulsed Amplitude and Phase setpoints:  When the pulsed test mode is
;642 //      activated, the DSP toggles the setpoints between the Nominal values
;643 //      and Pulsed setpoints.
;644 //
;645 //    - Pulse Frequency:  Controls the # of times per second that the
;646 //      Amplitude and/or Phase setpoints are toggled between the 2 setpoint
;647 //
;648 //    - Trigger position:  Specifies the # of samples that should be taken
;649 //      before changing the setpoint(s).  This provides a simple means of
;650 //      specifying a trigger delay, or a sliding window around the trigger
;651 //      event.
;652 //
;653 //    The pulsed test mode is activated by setting one or both of the run b
;654 //    in the DSP's cmd word.  When activated, the DSP samples the outputs a
;655 //    writes the values to one of two buffers.  One buffer is for the sampl
;656 //    window around the rising edge, and one is for the window around the
;657 //    falling edge.  When the DSP has filled one of the buffers, it sets a 
;658 //    in the status word indicating the buffer contains new data to be read
;659 //    The DSP must then leave the contents of the buffer untouched until it
;660 //    has been read by the controller CPU (see next paragraph).
;661 //
;662 //    The controller CPU periodically reads the status word from the DSP.
;663 //    Whenever it sees that the new-data bit for one of the buffers is set,
;664 //    it reads the data for that buffer from the DSP and then sets a bit in
;665 //    the command word indicating it has read the contents of the buffer.
;666 //    To avoid having the controller CPU attempt to read the same data from
;667 //    the same buffer the next cycle, the DSP must respond by immeadiately
;668 //    resetting the new-data bit in the status word.
;669 //
;670 //    Once the new-data bit has been reset, the DSP is free to write new
;671 //    data to the buffer, repeating the above cycle.
;672 //
;673 //-------------------------------------------------------------------------
;674 
;675 
;676 //test
;677 #define  OUTI(reg, value)  
;678            outi(reg, reg##Shadow = (value))         //faster
;679 //           WrPortI(reg, &(reg##Shadow), (value))    //slower
;680 //           outi(reg, value)      // fastest, but doesn't update shadow va
;681 
;682 
;683 #include <common.h>
;684 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;685 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;686 #include <sys/types.h>
;687 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;688 #include <linux/wait.h>
;689 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
;690 #include <semaphore.h>
;691 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
;692 
;693 
;694 #ifndef  ApplicSource
;695   #define  ApplicSource  "PhaseCtlrAppl.c"
;696 #endif
;697 
;698 #ifndef DidRegDefs
;699   #define  DidRegDefs
;700   #include <modbusRegs.c>
	.debug	I 'C:\work\dev\Rabbit_ST\daemons\modbusRegs.c' 29 38 11 7 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\modbus.h' 21 56 10 7 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\appl\PhaseCtlr\PhaseCtlrAppl.c' 29 29 16 8 1 33
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I
	.dseg
_DoNothing_CoilInfo::
	.dw	word _DoNothing
	.db	0
	.dw	word (phys @1)
	.dw	phys @1 >> 16
	.dw	word _setCoil
	.db	0x2
	.debug	G _DoNothing_CoilInfo 32 0
_dlmVersTime_RegInfo::
	.dw	word _dlmVersTime
	.dw	0
	.dw	word (phys @1+10)
	.dw	phys @1+10 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _dlmVersTime_ChgEventVal
	.dw	word _dlmVersTime_MinChg
	.debug	G _dlmVersTime_RegInfo 33 0
_rtosVersTime_RegInfo::
	.dw	word _rtosVersTime
	.dw	0x2
	.dw	word (phys @1+22)
	.dw	phys @1+22 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rtosVersTime_ChgEventVal
	.dw	word _rtosVersTime_MinChg
	.debug	G _rtosVersTime_RegInfo 33 0
_applVersTime_RegInfo::
	.dw	word _applVersTime
	.dw	0x4
	.dw	word (phys @1+35)
	.dw	phys @1+35 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _applVersTime_ChgEventVal
	.dw	word _applVersTime_MinChg
	.debug	G _applVersTime_RegInfo 33 0
_devType__RegInfo::
	.dw	word _devType_
	.dw	0x6
	.dw	word (phys @1+48)
	.dw	phys @1+48 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _devType__ChgEventVal
	.dw	word _devType__MinChg
	.debug	G _devType__RegInfo 33 0
_deviceID__RegInfo::
	.dw	word _deviceID_
	.dw	0x7
	.dw	word (phys @1+57)
	.dw	phys @1+57 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _deviceID__ChgEventVal
	.dw	word _deviceID__MinChg
	.debug	G _deviceID__RegInfo 33 0
_upSecs_RegInfo::
	.dw	word _upSecs
	.dw	0x9
	.dw	word (phys @1+67)
	.dw	phys @1+67 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _upSecs_ChgEventVal
	.dw	word _upSecs_MinChg
	.debug	G _upSecs_RegInfo 33 0
_percentIdle__RegInfo::
	.dw	word _percentIdle_
	.dw	0xb
	.dw	word (phys @1+74)
	.dw	phys @1+74 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _percentIdle__ChgEventVal
	.dw	word _percentIdle__MinChg
	.debug	G _percentIdle__RegInfo 33 0
_numChans_RegInfo::
	.dw	word _numChans
	.dw	0xc
	.dw	word (phys @1+87)
	.dw	phys @1+87 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _numChans_ChgEventVal
	.dw	word _numChans_MinChg
	.debug	G _numChans_RegInfo 33 0
_coilChanMult_RegInfo::
	.dw	word _coilChanMult
	.dw	0xd
	.dw	word (phys @1+96)
	.dw	phys @1+96 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _coilChanMult_ChgEventVal
	.dw	word _coilChanMult_MinChg
	.debug	G _coilChanMult_RegInfo 33 0
_reg3ChanMult_RegInfo::
	.dw	word _reg3ChanMult
	.dw	0xe
	.dw	word (phys @1+109)
	.dw	phys @1+109 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reg3ChanMult_ChgEventVal
	.dw	word _reg3ChanMult_MinChg
	.debug	G _reg3ChanMult_RegInfo 33 0
_reg4ChanMult_RegInfo::
	.dw	word _reg4ChanMult
	.dw	0xf
	.dw	word (phys @1+122)
	.dw	phys @1+122 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reg4ChanMult_ChgEventVal
	.dw	word _reg4ChanMult_MinChg
	.debug	G _reg4ChanMult_RegInfo 33 0
_digInBits_RegInfo::
	.dw	word _digInBits
	.dw	0x10
	.dw	word (phys @1+135)
	.dw	phys @1+135 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _digInBits_ChgEventVal
	.dw	word _digInBits_MinChg
	.debug	G _digInBits_RegInfo 33 0
_statusBitsStdA_RegInfo::
	.dw	word _statusBitsStdA
	.dw	0x12
	.dw	word (phys @1+145)
	.dw	phys @1+145 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsStdA_ChgEventVal
	.dw	word _statusBitsStdA_MinChg
	.debug	G _statusBitsStdA_RegInfo 33 0
_statusBitsStdB_RegInfo::
	.dw	word _statusBitsStdB
	.dw	0x13
	.dw	word (phys @1+160)
	.dw	phys @1+160 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsStdB_ChgEventVal
	.dw	word _statusBitsStdB_MinChg
	.debug	G _statusBitsStdB_RegInfo 33 0
_statusBitsAppl_RegInfo::
	.dw	word _statusBitsAppl
	.dw	0x14
	.dw	word (phys @1+175)
	.dw	phys @1+175 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsAppl_ChgEventVal
	.dw	word _statusBitsAppl_MinChg
	.debug	G _statusBitsAppl_RegInfo 33 0
_fwdAmpl_RegInfo::
	.dw	word _fwdAmpl
	.dw	0x16
	.dw	word (phys @1+190)
	.dw	phys @1+190 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _fwdAmpl_ChgEventVal
	.dw	word _fwdAmpl_MinChg
	.debug	G _fwdAmpl_RegInfo 33 0
_reflAmpl_RegInfo::
	.dw	word _reflAmpl
	.dw	0x18
	.dw	word (phys @1+198)
	.dw	phys @1+198 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reflAmpl_ChgEventVal
	.dw	word _reflAmpl_MinChg
	.debug	G _reflAmpl_RegInfo 33 0
_cavAmpl_RegInfo::
	.dw	word _cavAmpl
	.dw	0x1a
	.dw	word (phys @1+207)
	.dw	phys @1+207 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavAmpl_ChgEventVal
	.dw	word _cavAmpl_MinChg
	.debug	G _cavAmpl_RegInfo 33 0
_refAmpl_RegInfo::
	.dw	word _refAmpl
	.dw	0x1c
	.dw	word (phys @1+215)
	.dw	phys @1+215 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _refAmpl_ChgEventVal
	.dw	word _refAmpl_MinChg
	.debug	G _refAmpl_RegInfo 33 0
_fwdPhase_RegInfo::
	.dw	word _fwdPhase
	.dw	0x1e
	.dw	word (phys @1+223)
	.dw	phys @1+223 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _fwdPhase_ChgEventVal
	.dw	word _fwdPhase_MinChg
	.debug	G _fwdPhase_RegInfo 33 0
_reflPhase_RegInfo::
	.dw	word _reflPhase
	.dw	0x20
	.dw	word (phys @1+232)
	.dw	phys @1+232 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _reflPhase_ChgEventVal
	.dw	word _reflPhase_MinChg
	.debug	G _reflPhase_RegInfo 33 0
_cavPhase_RegInfo::
	.dw	word _cavPhase
	.dw	0x22
	.dw	word (phys @1+242)
	.dw	phys @1+242 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavPhase_ChgEventVal
	.dw	word _cavPhase_MinChg
	.debug	G _cavPhase_RegInfo 33 0
_refPhase_RegInfo::
	.dw	word _refPhase
	.dw	0x24
	.dw	word (phys @1+251)
	.dw	phys @1+251 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _refPhase_ChgEventVal
	.dw	word _refPhase_MinChg
	.debug	G _refPhase_RegInfo 33 0
_dspLoad_RegInfo::
	.dw	word _dspLoad
	.dw	0x26
	.dw	word (phys @1+260)
	.dw	phys @1+260 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _dspLoad_ChgEventVal
	.dw	word _dspLoad_MinChg
	.debug	G _dspLoad_RegInfo 33 0
_dspTempInt_RegInfo::
	.dw	word _dspTempInt
	.dw	0x27
	.dw	word (phys @1+268)
	.dw	phys @1+268 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _dspTempInt_ChgEventVal
	.dw	word _dspTempInt_MinChg
	.debug	G _dspTempInt_RegInfo 33 0
_dspTemp_RegInfo::
	.dw	word _dspTemp
	.dw	0x28
	.dw	word (phys @1+279)
	.dw	phys @1+279 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _dspTemp_ChgEventVal
	.dw	word _dspTemp_MinChg
	.debug	G _dspTemp_RegInfo 33 0
_unused_30043_RegInfo::
	.dw	word _unused_30043
	.dw	0x2a
	.dw	word (phys @1+287)
	.dw	phys @1+287 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused_30043_ChgEventVal
	.dw	word _unused_30043_MinChg
	.debug	G _unused_30043_RegInfo 33 0
_unused_30045_RegInfo::
	.dw	word _unused_30045
	.dw	0x2c
	.dw	word (phys @1+300)
	.dw	phys @1+300 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused_30045_ChgEventVal
	.dw	word _unused_30045_MinChg
	.debug	G _unused_30045_RegInfo 33 0
_unused_30047_RegInfo::
	.dw	word _unused_30047
	.dw	0x2e
	.dw	word (phys @1+313)
	.dw	phys @1+313 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused_30047_ChgEventVal
	.dw	word _unused_30047_MinChg
	.debug	G _unused_30047_RegInfo 33 0
_unused_30049_RegInfo::
	.dw	word _unused_30049
	.dw	0x30
	.dw	word (phys @1+326)
	.dw	phys @1+326 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused_30049_ChgEventVal
	.dw	word _unused_30049_MinChg
	.debug	G _unused_30049_RegInfo 33 0
_unused_30051_RegInfo::
	.dw	word _unused_30051
	.dw	0x32
	.dw	word (phys @1+339)
	.dw	phys @1+339 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused_30051_ChgEventVal
	.dw	word _unused_30051_MinChg
	.debug	G _unused_30051_RegInfo 33 0
_unused_30053_RegInfo::
	.dw	word _unused_30053
	.dw	0x34
	.dw	word (phys @1+352)
	.dw	phys @1+352 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused_30053_ChgEventVal
	.dw	word _unused_30053_MinChg
	.debug	G _unused_30053_RegInfo 33 0
_unused_30055_RegInfo::
	.dw	word _unused_30055
	.dw	0x36
	.dw	word (phys @1+365)
	.dw	phys @1+365 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused_30055_ChgEventVal
	.dw	word _unused_30055_MinChg
	.debug	G _unused_30055_RegInfo 33 0
_unused_30057_RegInfo::
	.dw	word _unused_30057
	.dw	0x38
	.dw	word (phys @1+378)
	.dw	phys @1+378 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused_30057_ChgEventVal
	.dw	word _unused_30057_MinChg
	.debug	G _unused_30057_RegInfo 33 0
_unused_30059_RegInfo::
	.dw	word _unused_30059
	.dw	0x3a
	.dw	word (phys @1+391)
	.dw	phys @1+391 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused_30059_ChgEventVal
	.dw	word _unused_30059_MinChg
	.debug	G _unused_30059_RegInfo 33 0
_percentCTF_RegInfo::
	.dw	word _percentCTF
	.dw	0x3c
	.dw	word (phys @1+404)
	.dw	phys @1+404 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _percentCTF_ChgEventVal
	.dw	word _percentCTF_MinChg
	.debug	G _percentCTF_RegInfo 33 0
_percentFFT_RegInfo::
	.dw	word _percentFFT
	.dw	0x3d
	.dw	word (phys @1+415)
	.dw	phys @1+415 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _percentFFT_ChgEventVal
	.dw	word _percentFFT_MinChg
	.debug	G _percentFFT_RegInfo 33 0
_latency_RegInfo::
	.dw	word _latency
	.dw	0x3e
	.dw	word (phys @1+426)
	.dw	phys @1+426 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _latency_ChgEventVal
	.dw	word _latency_MinChg
	.debug	G _latency_RegInfo 33 0
_tcpTickTime_RegInfo::
	.dw	word _tcpTickTime
	.dw	0x3f
	.dw	word (phys @1+434)
	.dw	phys @1+434 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _tcpTickTime_ChgEventVal
	.dw	word _tcpTickTime_MinChg
	.debug	G _tcpTickTime_RegInfo 33 0
_applLoopTime_RegInfo::
	.dw	word _applLoopTime
	.dw	0x40
	.dw	word (phys @1+446)
	.dw	phys @1+446 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _applLoopTime_ChgEventVal
	.dw	word _applLoopTime_MinChg
	.debug	G _applLoopTime_RegInfo 33 0
_maxFwdAmpl_RegInfo::
	.dw	word _maxFwdAmpl
	.dw	0x41
	.dw	word (phys @1+459)
	.dw	phys @1+459 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _maxFwdAmpl_ChgEventVal
	.dw	word _maxFwdAmpl_MinChg
	.debug	G _maxFwdAmpl_RegInfo 33 0
_maxReflAmpl_RegInfo::
	.dw	word _maxReflAmpl
	.dw	0x43
	.dw	word (phys @1+470)
	.dw	phys @1+470 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _maxReflAmpl_ChgEventVal
	.dw	word _maxReflAmpl_MinChg
	.debug	G _maxReflAmpl_RegInfo 33 0
_maxCavAmpl_RegInfo::
	.dw	word _maxCavAmpl
	.dw	0x45
	.dw	word (phys @1+482)
	.dw	phys @1+482 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _maxCavAmpl_ChgEventVal
	.dw	word _maxCavAmpl_MinChg
	.debug	G _maxCavAmpl_RegInfo 33 0
_maxOutAmpl_RegInfo::
	.dw	word _maxOutAmpl
	.dw	0x47
	.dw	word (phys @1+493)
	.dw	phys @1+493 >> 16
	.dw	0
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _maxOutAmpl_ChgEventVal
	.dw	word _maxOutAmpl_MinChg
	.debug	G _maxOutAmpl_RegInfo 33 0
_statusBitsDSP_RegInfo::
	.dw	word _statusBitsDSP
	.dw	0x49
	.dw	word (phys @1+504)
	.dw	phys @1+504 >> 16
	.dw	0
	.db	0x3
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsDSP_ChgEventVal
	.dw	word _statusBitsDSP_MinChg
	.debug	G _statusBitsDSP_RegInfo 33 0
_statusBitsAFC_RegInfo::
	.dw	word _statusBitsAFC
	.dw	0x4b
	.dw	word (phys @1+518)
	.dw	phys @1+518 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _statusBitsAFC_ChgEventVal
	.dw	word _statusBitsAFC_MinChg
	.debug	G _statusBitsAFC_RegInfo 33 0
_writeStatus_RegInfo::
	.dw	word _writeStatus
	.dw	0x4c
	.dw	word (phys @1+532)
	.dw	phys @1+532 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _writeStatus_ChgEventVal
	.dw	word _writeStatus_MinChg
	.debug	G _writeStatus_RegInfo 33 0
_sizeCTF_RegInfo::
	.dw	word _sizeCTF
	.dw	0x4d
	.dw	word (phys @1+544)
	.dw	phys @1+544 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _sizeCTF_ChgEventVal
	.dw	word _sizeCTF_MinChg
	.debug	G _sizeCTF_RegInfo 33 0
_sizeFFT_RegInfo::
	.dw	word _sizeFFT
	.dw	0x4e
	.dw	word (phys @1+552)
	.dw	phys @1+552 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _sizeFFT_ChgEventVal
	.dw	word _sizeFFT_MinChg
	.debug	G _sizeFFT_RegInfo 33 0
_romProgErrs_RegInfo::
	.dw	word _romProgErrs
	.dw	0x4f
	.dw	word (phys @1+560)
	.dw	phys @1+560 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _romProgErrs_ChgEventVal
	.dw	word _romProgErrs_MinChg
	.debug	G _romProgErrs_RegInfo 33 0
_piezoReadPos_RegInfo::
	.dw	word _piezoReadPos
	.dw	0x50
	.dw	word (phys @1+572)
	.dw	phys @1+572 >> 16
	.dw	0
	.db	0
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _piezoReadPos_ChgEventVal
	.dw	word _piezoReadPos_MinChg
	.debug	G _piezoReadPos_RegInfo 33 0
_unused_30082_RegInfo::
	.dw	word _unused_30082
	.dw	0x51
	.dw	word (phys @1+585)
	.dw	phys @1+585 >> 16
	.dw	0
	.db	0
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused_30082_ChgEventVal
	.dw	word _unused_30082_MinChg
	.debug	G _unused_30082_RegInfo 33 0
_kernelLoopTime_RegInfo::
	.dw	word _kernelLoopTime
	.dw	0x52
	.dw	word (phys @1+598)
	.dw	phys @1+598 >> 16
	.dw	0
	.db	0x1
	.db	0x1
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _kernelLoopTime_ChgEventVal
	.dw	word _kernelLoopTime_MinChg
	.debug	G _kernelLoopTime_RegInfo 33 0
_stepperReadPos_RegInfo::
	.dw	word _stepperReadPos
	.dw	0x53
	.dw	word (phys @1+613)
	.dw	phys @1+613 >> 16
	.dw	0
	.db	0x2
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _stepperReadPos_ChgEventVal
	.dw	word _stepperReadPos_MinChg
	.debug	G _stepperReadPos_RegInfo 33 0
_timeZone__RegInfo::
	.dw	word _timeZone_
	.dw	0
	.dw	word (phys @1+628)
	.dw	phys @1+628 >> 16
	.dw	word _MB_timeZone
	.db	0
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _timeZone__ChgEventVal
	.dw	word _timeZone__MinChg
	.debug	G _timeZone__RegInfo 33 0
_curTime_RegInfo::
	.dw	word _curTime
	.dw	0x1
	.dw	word (phys @1+638)
	.dw	phys @1+638 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _curTime_ChgEventVal
	.dw	word _curTime_MinChg
	.debug	G _curTime_RegInfo 33 0
_ipAddr_RegInfo::
	.dw	word _ipAddr
	.dw	0x3
	.dw	word (phys @1+646)
	.dw	phys @1+646 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _ipAddr_ChgEventVal
	.dw	word _ipAddr_MinChg
	.debug	G _ipAddr_RegInfo 33 0
_netmask_RegInfo::
	.dw	word _netmask
	.dw	0x5
	.dw	word (phys @1+653)
	.dw	phys @1+653 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _netmask_ChgEventVal
	.dw	word _netmask_MinChg
	.debug	G _netmask_RegInfo 33 0
_gateway_RegInfo::
	.dw	word _gateway
	.dw	0x7
	.dw	word (phys @1+661)
	.dw	phys @1+661 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _gateway_ChgEventVal
	.dw	word _gateway_MinChg
	.debug	G _gateway_RegInfo 33 0
_setACoil_RegInfo::
	.dw	word _setACoil
	.dw	0x9
	.dw	word (phys @1+669)
	.dw	phys @1+669 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x3
	.db	0
	.db	0
	.dw	word _setACoil_ChgEventVal
	.dw	word _setACoil_MinChg
	.debug	G _setACoil_RegInfo 33 0
_resetACoil_RegInfo::
	.dw	word _resetACoil
	.dw	0xa
	.dw	word (phys @1+678)
	.dw	phys @1+678 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x3
	.db	0
	.db	0
	.dw	word _resetACoil_ChgEventVal
	.dw	word _resetACoil_MinChg
	.debug	G _resetACoil_RegInfo 33 0
_digOutBits_RegInfo::
	.dw	word _digOutBits
	.dw	0xb
	.dw	word (phys @1+689)
	.dw	phys @1+689 >> 16
	.dw	word _setU32
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _digOutBits_ChgEventVal
	.dw	word _digOutBits_MinChg
	.debug	G _digOutBits_RegInfo 33 0
_cmdBitsStd_RegInfo::
	.dw	word _cmdBitsStd
	.dw	0xd
	.dw	word (phys @1+700)
	.dw	phys @1+700 >> 16
	.dw	word _MB_cmdBitsStd
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cmdBitsStd_ChgEventVal
	.dw	word _cmdBitsStd_MinChg
	.debug	G _cmdBitsStd_RegInfo 33 0
_cmdBitsAppl_RegInfo::
	.dw	word _cmdBitsAppl
	.dw	0xf
	.dw	word (phys @1+711)
	.dw	phys @1+711 >> 16
	.dw	word _MB_cmdBitsAppl
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cmdBitsAppl_ChgEventVal
	.dw	word _cmdBitsAppl_MinChg
	.debug	G _cmdBitsAppl_RegInfo 33 0
_setAtten_RegInfo::
	.dw	word _setAtten
	.dw	0x11
	.dw	word (phys @1+723)
	.dw	phys @1+723 >> 16
	.dw	word _MB_setAtten
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _setAtten_ChgEventVal
	.dw	word _setAtten_MinChg
	.debug	G _setAtten_RegInfo 33 0
_trigPos_RegInfo::
	.dw	word _trigPos
	.dw	0x12
	.dw	word (phys @1+732)
	.dw	phys @1+732 >> 16
	.dw	word _MB_DSP_REG
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _trigPos_ChgEventVal
	.dw	word _trigPos_MinChg
	.debug	G _trigPos_RegInfo 33 0
_cmdBitsAppl3_RegInfo::
	.dw	word _cmdBitsAppl3
	.dw	0x13
	.dw	word (phys @1+740)
	.dw	phys @1+740 >> 16
	.dw	word _MB_cmdBitsAppl3
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cmdBitsAppl3_ChgEventVal
	.dw	word _cmdBitsAppl3_MinChg
	.debug	G _cmdBitsAppl3_RegInfo 33 0
_phaseSet_RegInfo::
	.dw	word _phaseSet
	.dw	0x14
	.dw	word (phys @1+753)
	.dw	phys @1+753 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _phaseSet_ChgEventVal
	.dw	word _phaseSet_MinChg
	.debug	G _phaseSet_RegInfo 33 0
_amplSet_RegInfo::
	.dw	word _amplSet
	.dw	0x16
	.dw	word (phys @1+762)
	.dw	phys @1+762 >> 16
	.dw	word _MB_maxAmpl
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _amplSet_ChgEventVal
	.dw	word _amplSet_MinChg
	.debug	G _amplSet_RegInfo 33 0
_oldPulseFreq_RegInfo::
	.dw	word _oldPulseFreq
	.dw	0x18
	.dw	word (phys @1+770)
	.dw	phys @1+770 >> 16
	.dw	word _MB_oldPulseFreq
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _oldPulseFreq_ChgEventVal
	.dw	word _oldPulseFreq_MinChg
	.debug	G _oldPulseFreq_RegInfo 33 0
_rf_P_RegInfo::
	.dw	word _rf_P
	.dw	0x19
	.dw	word (phys @1+783)
	.dw	phys @1+783 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rf_P_ChgEventVal
	.dw	word _rf_P_MinChg
	.debug	G _rf_P_RegInfo 33 0
_rf_I_RegInfo::
	.dw	word _rf_I
	.dw	0x1b
	.dw	word (phys @1+788)
	.dw	phys @1+788 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rf_I_ChgEventVal
	.dw	word _rf_I_MinChg
	.debug	G _rf_I_RegInfo 33 0
_rf_D_RegInfo::
	.dw	word _rf_D
	.dw	0x1d
	.dw	word (phys @1+793)
	.dw	phys @1+793 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rf_D_ChgEventVal
	.dw	word _rf_D_MinChg
	.debug	G _rf_D_RegInfo 33 0
_unusedreg2_RegInfo::
	.dw	word _unusedreg2
	.dw	0x1f
	.dw	word (phys @1+798)
	.dw	phys @1+798 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _unusedreg2_ChgEventVal
	.dw	word _unusedreg2_MinChg
	.debug	G _unusedreg2_RegInfo 33 0
_pulsedAmplSet_RegInfo::
	.dw	word _pulsedAmplSet
	.dw	0x21
	.dw	word (phys @1+809)
	.dw	phys @1+809 >> 16
	.dw	word _MB_maxAmpl
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _pulsedAmplSet_ChgEventVal
	.dw	word _pulsedAmplSet_MinChg
	.debug	G _pulsedAmplSet_RegInfo 33 0
_tuner_P_RegInfo::
	.dw	word _tuner_P
	.dw	0x23
	.dw	word (phys @1+823)
	.dw	phys @1+823 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _tuner_P_ChgEventVal
	.dw	word _tuner_P_MinChg
	.debug	G _tuner_P_RegInfo 33 0
_tuner_I_RegInfo::
	.dw	word _tuner_I
	.dw	0x25
	.dw	word (phys @1+831)
	.dw	phys @1+831 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _tuner_I_ChgEventVal
	.dw	word _tuner_I_MinChg
	.debug	G _tuner_I_RegInfo 33 0
_tuner_D_RegInfo::
	.dw	word _tuner_D
	.dw	0x27
	.dw	word (phys @1+839)
	.dw	phys @1+839 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _tuner_D_ChgEventVal
	.dw	word _tuner_D_MinChg
	.debug	G _tuner_D_RegInfo 33 0
_unusedreg3_RegInfo::
	.dw	word _unusedreg3
	.dw	0x29
	.dw	word (phys @1+847)
	.dw	phys @1+847 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _unusedreg3_ChgEventVal
	.dw	word _unusedreg3_MinChg
	.debug	G _unusedreg3_RegInfo 33 0
_pulsedPhaseSet_RegInfo::
	.dw	word _pulsedPhaseSet
	.dw	0x2b
	.dw	word (phys @1+858)
	.dw	phys @1+858 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _pulsedPhaseSet_ChgEventVal
	.dw	word _pulsedPhaseSet_MinChg
	.debug	G _pulsedPhaseSet_RegInfo 33 0
_setAFCsOnOff_RegInfo::
	.dw	word _setAFCsOnOff
	.dw	0x2d
	.dw	word (phys @1+873)
	.dw	phys @1+873 >> 16
	.dw	word _MB_setAFCsOnOff
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _setAFCsOnOff_ChgEventVal
	.dw	word _setAFCsOnOff_MinChg
	.debug	G _setAFCsOnOff_RegInfo 33 0
_afcFreq0_RegInfo::
	.dw	word _afcFreq0
	.dw	0x2f
	.dw	word (phys @1+886)
	.dw	phys @1+886 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcFreq0_ChgEventVal
	.dw	word _afcFreq0_MinChg
	.debug	G _afcFreq0_RegInfo 33 0
_afcFreq1_RegInfo::
	.dw	word _afcFreq1
	.dw	0x31
	.dw	word (phys @1+895)
	.dw	phys @1+895 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcFreq1_ChgEventVal
	.dw	word _afcFreq1_MinChg
	.debug	G _afcFreq1_RegInfo 33 0
_afcFreq2_RegInfo::
	.dw	word _afcFreq2
	.dw	0x33
	.dw	word (phys @1+904)
	.dw	phys @1+904 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcFreq2_ChgEventVal
	.dw	word _afcFreq2_MinChg
	.debug	G _afcFreq2_RegInfo 33 0
_afcFreq3_RegInfo::
	.dw	word _afcFreq3
	.dw	0x35
	.dw	word (phys @1+913)
	.dw	phys @1+913 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcFreq3_ChgEventVal
	.dw	word _afcFreq3_MinChg
	.debug	G _afcFreq3_RegInfo 33 0
_afcFreq4_RegInfo::
	.dw	word _afcFreq4
	.dw	0x37
	.dw	word (phys @1+922)
	.dw	phys @1+922 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcFreq4_ChgEventVal
	.dw	word _afcFreq4_MinChg
	.debug	G _afcFreq4_RegInfo 33 0
_afcFreq5_RegInfo::
	.dw	word _afcFreq5
	.dw	0x39
	.dw	word (phys @1+931)
	.dw	phys @1+931 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcFreq5_ChgEventVal
	.dw	word _afcFreq5_MinChg
	.debug	G _afcFreq5_RegInfo 33 0
_afcFreq6_RegInfo::
	.dw	word _afcFreq6
	.dw	0x3b
	.dw	word (phys @1+940)
	.dw	phys @1+940 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcFreq6_ChgEventVal
	.dw	word _afcFreq6_MinChg
	.debug	G _afcFreq6_RegInfo 33 0
_afcFreq7_RegInfo::
	.dw	word _afcFreq7
	.dw	0x3d
	.dw	word (phys @1+949)
	.dw	phys @1+949 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcFreq7_ChgEventVal
	.dw	word _afcFreq7_MinChg
	.debug	G _afcFreq7_RegInfo 33 0
_afcFreq8_RegInfo::
	.dw	word _afcFreq8
	.dw	0x3f
	.dw	word (phys @1+958)
	.dw	phys @1+958 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcFreq8_ChgEventVal
	.dw	word _afcFreq8_MinChg
	.debug	G _afcFreq8_RegInfo 33 0
_afcFreq9_RegInfo::
	.dw	word _afcFreq9
	.dw	0x41
	.dw	word (phys @1+967)
	.dw	phys @1+967 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcFreq9_ChgEventVal
	.dw	word _afcFreq9_MinChg
	.debug	G _afcFreq9_RegInfo 33 0
_warmLevel_RegInfo::
	.dw	word _warmLevel
	.dw	0x43
	.dw	word (phys @1+976)
	.dw	phys @1+976 >> 16
	.dw	word _MB_maxAmpl
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _warmLevel_ChgEventVal
	.dw	word _warmLevel_MinChg
	.debug	G _warmLevel_RegInfo 33 0
_warmMS_RegInfo::
	.dw	word _warmMS
	.dw	0x45
	.dw	word (phys @1+986)
	.dw	phys @1+986 >> 16
	.dw	word _MB_DSP_REG
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _warmMS_ChgEventVal
	.dw	word _warmMS_MinChg
	.debug	G _warmMS_RegInfo 33 0
_rampMS_RegInfo::
	.dw	word _rampMS
	.dw	0x46
	.dw	word (phys @1+993)
	.dw	phys @1+993 >> 16
	.dw	word _MB_DSP_REG
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rampMS_ChgEventVal
	.dw	word _rampMS_MinChg
	.debug	G _rampMS_RegInfo 33 0
_dspComErrors_RegInfo::
	.dw	word _dspComErrors
	.dw	0x47
	.dw	word (phys @1+1000)
	.dw	phys @1+1000 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _dspComErrors_ChgEventVal
	.dw	word _dspComErrors_MinChg
	.debug	G _dspComErrors_RegInfo 33 0
_dspProgNum_RegInfo::
	.dw	word _dspProgNum
	.dw	0x48
	.dw	word (phys @1+1013)
	.dw	phys @1+1013 >> 16
	.dw	word _MB_dspProgNum
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _dspProgNum_ChgEventVal
	.dw	word _dspProgNum_MinChg
	.debug	G _dspProgNum_RegInfo 33 0
_pllInitIdx_RegInfo::
	.dw	word _pllInitIdx
	.dw	0x49
	.dw	word (phys @1+1024)
	.dw	phys @1+1024 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _pllInitIdx_ChgEventVal
	.dw	word _pllInitIdx_MinChg
	.debug	G _pllInitIdx_RegInfo 33 0
_rfq_t1_feedback_RegInfo::
	.dw	word _rfq_t1_feedback
	.dw	0x4a
	.dw	word (phys @1+1035)
	.dw	phys @1+1035 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfq_t1_feedback_ChgEventVal
	.dw	word _rfq_t1_feedback_MinChg
	.debug	G _rfq_t1_feedback_RegInfo 33 0
_rfq_t2_feedback_RegInfo::
	.dw	word _rfq_t2_feedback
	.dw	0x4c
	.dw	word (phys @1+1051)
	.dw	phys @1+1051 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfq_t2_feedback_ChgEventVal
	.dw	word _rfq_t2_feedback_MinChg
	.debug	G _rfq_t2_feedback_RegInfo 33 0
_devStat1_RegInfo::
	.dw	word _devStat1
	.dw	0x4e
	.dw	word (phys @1+1067)
	.dw	phys @1+1067 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _devStat1_ChgEventVal
	.dw	word _devStat1_MinChg
	.debug	G _devStat1_RegInfo 33 0
_rfq_t1_output_RegInfo::
	.dw	word _rfq_t1_output
	.dw	0x4f
	.dw	word (phys @1+1076)
	.dw	phys @1+1076 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfq_t1_output_ChgEventVal
	.dw	word _rfq_t1_output_MinChg
	.debug	G _rfq_t1_output_RegInfo 33 0
_rfq_t2_output_RegInfo::
	.dw	word _rfq_t2_output
	.dw	0x51
	.dw	word (phys @1+1090)
	.dw	phys @1+1090 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfq_t2_output_ChgEventVal
	.dw	word _rfq_t2_output_MinChg
	.debug	G _rfq_t2_output_RegInfo 33 0
_devCtl1_RegInfo::
	.dw	word _devCtl1
	.dw	0x53
	.dw	word (phys @1+1104)
	.dw	phys @1+1104 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _devCtl1_ChgEventVal
	.dw	word _devCtl1_MinChg
	.debug	G _devCtl1_RegInfo 33 0
_devRdSet1_RegInfo::
	.dw	word _devRdSet1
	.dw	0x54
	.dw	word (phys @1+1112)
	.dw	phys @1+1112 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _devRdSet1_ChgEventVal
	.dw	word _devRdSet1_MinChg
	.debug	G _devRdSet1_RegInfo 33 0
_devRdSet2_RegInfo::
	.dw	word _devRdSet2
	.dw	0x56
	.dw	word (phys @1+1122)
	.dw	phys @1+1122 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _devRdSet2_ChgEventVal
	.dw	word _devRdSet2_MinChg
	.debug	G _devRdSet2_RegInfo 33 0
_devRdCtl1_RegInfo::
	.dw	word _devRdCtl1
	.dw	0x58
	.dw	word (phys @1+1132)
	.dw	phys @1+1132 >> 16
	.dw	word _setU16
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _devRdCtl1_ChgEventVal
	.dw	word _devRdCtl1_MinChg
	.debug	G _devRdCtl1_RegInfo 33 0
_piezoSetPos_RegInfo::
	.dw	word _piezoSetPos
	.dw	0x59
	.dw	word (phys @1+1142)
	.dw	phys @1+1142 >> 16
	.dw	word _MB_DSP_REG
	.db	0
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _piezoSetPos_ChgEventVal
	.dw	word _piezoSetPos_MinChg
	.debug	G _piezoSetPos_RegInfo 33 0
_unused_40091_RegInfo::
	.dw	word _unused_40091
	.dw	0x5a
	.dw	word (phys @1+1154)
	.dw	phys @1+1154 >> 16
	.dw	word _MB_DSP_REG
	.db	0
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _unused_40091_ChgEventVal
	.dw	word _unused_40091_MinChg
	.debug	G _unused_40091_RegInfo 33 0
_fwdAtten_RegInfo::
	.dw	word _fwdAtten
	.dw	0x5b
	.dw	word (phys @1+1167)
	.dw	phys @1+1167 >> 16
	.dw	word _MB_DSP_REG
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _fwdAtten_ChgEventVal
	.dw	word _fwdAtten_MinChg
	.debug	G _fwdAtten_RegInfo 33 0
_reflAtten_RegInfo::
	.dw	word _reflAtten
	.dw	0x5c
	.dw	word (phys @1+1176)
	.dw	phys @1+1176 >> 16
	.dw	word _MB_DSP_REG
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _reflAtten_ChgEventVal
	.dw	word _reflAtten_MinChg
	.debug	G _reflAtten_RegInfo 33 0
_cavAtten_RegInfo::
	.dw	word _cavAtten
	.dw	0x5d
	.dw	word (phys @1+1186)
	.dw	phys @1+1186 >> 16
	.dw	word _MB_DSP_REG
	.db	0x1
	.db	0x1
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavAtten_ChgEventVal
	.dw	word _cavAtten_MinChg
	.debug	G _cavAtten_RegInfo 33 0
_freqSearchAmpl_RegInfo::
	.dw	word _freqSearchAmpl
	.dw	0x5e
	.dw	word (phys @1+1195)
	.dw	phys @1+1195 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _freqSearchAmpl_ChgEventVal
	.dw	word _freqSearchAmpl_MinChg
	.debug	G _freqSearchAmpl_RegInfo 33 0
_cavLowIlkLevel_RegInfo::
	.dw	word _cavLowIlkLevel
	.dw	0x60
	.dw	word (phys @1+1210)
	.dw	phys @1+1210 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavLowIlkLevel_ChgEventVal
	.dw	word _cavLowIlkLevel_MinChg
	.debug	G _cavLowIlkLevel_RegInfo 33 0
_cavLowIlkTime_RegInfo::
	.dw	word _cavLowIlkTime
	.dw	0x62
	.dw	word (phys @1+1225)
	.dw	phys @1+1225 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavLowIlkTime_ChgEventVal
	.dw	word _cavLowIlkTime_MinChg
	.debug	G _cavLowIlkTime_RegInfo 33 0
_dvdt_IlkRate_RegInfo::
	.dw	word _dvdt_IlkRate
	.dw	0x64
	.dw	word (phys @1+1239)
	.dw	phys @1+1239 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _dvdt_IlkRate_ChgEventVal
	.dw	word _dvdt_IlkRate_MinChg
	.debug	G _dvdt_IlkRate_RegInfo 33 0
_vv_IlkRatio_RegInfo::
	.dw	word _vv_IlkRatio
	.dw	0x66
	.dw	word (phys @1+1252)
	.dw	phys @1+1252 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _vv_IlkRatio_ChgEventVal
	.dw	word _vv_IlkRatio_MinChg
	.debug	G _vv_IlkRatio_RegInfo 33 0
_fwdCavOffset_RegInfo::
	.dw	word _fwdCavOffset
	.dw	0x68
	.dw	word (phys @1+1264)
	.dw	phys @1+1264 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _fwdCavOffset_ChgEventVal
	.dw	word _fwdCavOffset_MinChg
	.debug	G _fwdCavOffset_RegInfo 33 0
_feedFwdPhase_RegInfo::
	.dw	word _feedFwdPhase
	.dw	0x6a
	.dw	word (phys @1+1277)
	.dw	phys @1+1277 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _feedFwdPhase_ChgEventVal
	.dw	word _feedFwdPhase_MinChg
	.debug	G _feedFwdPhase_RegInfo 33 0
_feedFwdGain_RegInfo::
	.dw	word _feedFwdGain
	.dw	0x6c
	.dw	word (phys @1+1290)
	.dw	phys @1+1290 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _feedFwdGain_ChgEventVal
	.dw	word _feedFwdGain_MinChg
	.debug	G _feedFwdGain_RegInfo 33 0
_ctfCalcRate_RegInfo::
	.dw	word _ctfCalcRate
	.dw	0x6e
	.dw	word (phys @1+1302)
	.dw	phys @1+1302 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _ctfCalcRate_ChgEventVal
	.dw	word _ctfCalcRate_MinChg
	.debug	G _ctfCalcRate_RegInfo 33 0
_fwdMagCalib_RegInfo::
	.dw	word _fwdMagCalib
	.dw	0x70
	.dw	word (phys @1+1314)
	.dw	phys @1+1314 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _fwdMagCalib_ChgEventVal
	.dw	word _fwdMagCalib_MinChg
	.debug	G _fwdMagCalib_RegInfo 33 0
_fwdPhaseCalib_RegInfo::
	.dw	word _fwdPhaseCalib
	.dw	0x72
	.dw	word (phys @1+1326)
	.dw	phys @1+1326 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _fwdPhaseCalib_ChgEventVal
	.dw	word _fwdPhaseCalib_MinChg
	.debug	G _fwdPhaseCalib_RegInfo 33 0
_reflMagCalib_RegInfo::
	.dw	word _reflMagCalib
	.dw	0x74
	.dw	word (phys @1+1340)
	.dw	phys @1+1340 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _reflMagCalib_ChgEventVal
	.dw	word _reflMagCalib_MinChg
	.debug	G _reflMagCalib_RegInfo 33 0
_reflPhaseCalib_RegInfo::
	.dw	word _reflPhaseCalib
	.dw	0x76
	.dw	word (phys @1+1353)
	.dw	phys @1+1353 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _reflPhaseCalib_ChgEventVal
	.dw	word _reflPhaseCalib_MinChg
	.debug	G _reflPhaseCalib_RegInfo 33 0
_cavMagCalib_RegInfo::
	.dw	word _cavMagCalib
	.dw	0x78
	.dw	word (phys @1+1368)
	.dw	phys @1+1368 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavMagCalib_ChgEventVal
	.dw	word _cavMagCalib_MinChg
	.debug	G _cavMagCalib_RegInfo 33 0
_cavPhaseCalib_RegInfo::
	.dw	word _cavPhaseCalib
	.dw	0x7a
	.dw	word (phys @1+1380)
	.dw	phys @1+1380 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavPhaseCalib_ChgEventVal
	.dw	word _cavPhaseCalib_MinChg
	.debug	G _cavPhaseCalib_RegInfo 33 0
_outMagCalib_RegInfo::
	.dw	word _outMagCalib
	.dw	0x7c
	.dw	word (phys @1+1394)
	.dw	phys @1+1394 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _outMagCalib_ChgEventVal
	.dw	word _outMagCalib_MinChg
	.debug	G _outMagCalib_RegInfo 33 0
_outPhaseCalib_RegInfo::
	.dw	word _outPhaseCalib
	.dw	0x7e
	.dw	word (phys @1+1406)
	.dw	phys @1+1406 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _outPhaseCalib_ChgEventVal
	.dw	word _outPhaseCalib_MinChg
	.debug	G _outPhaseCalib_RegInfo 33 0
_ctfTunerAmpl_RegInfo::
	.dw	word _ctfTunerAmpl
	.dw	0x80
	.dw	word (phys @1+1420)
	.dw	phys @1+1420 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _ctfTunerAmpl_ChgEventVal
	.dw	word _ctfTunerAmpl_MinChg
	.debug	G _ctfTunerAmpl_RegInfo 33 0
_setDSPState_RegInfo::
	.dw	word _setDSPState
	.dw	0x82
	.dw	word (phys @1+1433)
	.dw	phys @1+1433 >> 16
	.dw	word _MB_setDSPState
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _setDSPState_ChgEventVal
	.dw	word _setDSPState_MinChg
	.debug	G _setDSPState_RegInfo 33 0
_fwdAmplGain_RegInfo::
	.dw	word _fwdAmplGain
	.dw	0x84
	.dw	word (phys @1+1445)
	.dw	phys @1+1445 >> 16
	.dw	word _MB_setGain
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _fwdAmplGain_ChgEventVal
	.dw	word _fwdAmplGain_MinChg
	.debug	G _fwdAmplGain_RegInfo 33 0
_fwdAmplOffset_RegInfo::
	.dw	word _fwdAmplOffset
	.dw	0x86
	.dw	word (phys @1+1457)
	.dw	phys @1+1457 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _fwdAmplOffset_ChgEventVal
	.dw	word _fwdAmplOffset_MinChg
	.debug	G _fwdAmplOffset_RegInfo 33 0
_fwdPhaseGain_RegInfo::
	.dw	word _fwdPhaseGain
	.dw	0x88
	.dw	word (phys @1+1471)
	.dw	phys @1+1471 >> 16
	.dw	word _MB_setGain
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _fwdPhaseGain_ChgEventVal
	.dw	word _fwdPhaseGain_MinChg
	.debug	G _fwdPhaseGain_RegInfo 33 0
_fwdPhaseOffset_RegInfo::
	.dw	word _fwdPhaseOffset
	.dw	0x8a
	.dw	word (phys @1+1484)
	.dw	phys @1+1484 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _fwdPhaseOffset_ChgEventVal
	.dw	word _fwdPhaseOffset_MinChg
	.debug	G _fwdPhaseOffset_RegInfo 33 0
_reflAmplGain_RegInfo::
	.dw	word _reflAmplGain
	.dw	0x8c
	.dw	word (phys @1+1499)
	.dw	phys @1+1499 >> 16
	.dw	word _MB_setGain
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _reflAmplGain_ChgEventVal
	.dw	word _reflAmplGain_MinChg
	.debug	G _reflAmplGain_RegInfo 33 0
_reflAmplOffset_RegInfo::
	.dw	word _reflAmplOffset
	.dw	0x8e
	.dw	word (phys @1+1512)
	.dw	phys @1+1512 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _reflAmplOffset_ChgEventVal
	.dw	word _reflAmplOffset_MinChg
	.debug	G _reflAmplOffset_RegInfo 33 0
_reflPhaseGain_RegInfo::
	.dw	word _reflPhaseGain
	.dw	0x90
	.dw	word (phys @1+1527)
	.dw	phys @1+1527 >> 16
	.dw	word _MB_setGain
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _reflPhaseGain_ChgEventVal
	.dw	word _reflPhaseGain_MinChg
	.debug	G _reflPhaseGain_RegInfo 33 0
_reflPhaseOffset_RegInfo::
	.dw	word _reflPhaseOffset
	.dw	0x92
	.dw	word (phys @1+1541)
	.dw	phys @1+1541 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _reflPhaseOffset_ChgEventVal
	.dw	word _reflPhaseOffset_MinChg
	.debug	G _reflPhaseOffset_RegInfo 33 0
_cavAmplGain_RegInfo::
	.dw	word _cavAmplGain
	.dw	0x94
	.dw	word (phys @1+1557)
	.dw	phys @1+1557 >> 16
	.dw	word _MB_setGain
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavAmplGain_ChgEventVal
	.dw	word _cavAmplGain_MinChg
	.debug	G _cavAmplGain_RegInfo 33 0
_cavAmplOffset_RegInfo::
	.dw	word _cavAmplOffset
	.dw	0x96
	.dw	word (phys @1+1569)
	.dw	phys @1+1569 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavAmplOffset_ChgEventVal
	.dw	word _cavAmplOffset_MinChg
	.debug	G _cavAmplOffset_RegInfo 33 0
_cavPhaseGain_RegInfo::
	.dw	word _cavPhaseGain
	.dw	0x98
	.dw	word (phys @1+1583)
	.dw	phys @1+1583 >> 16
	.dw	word _MB_setGain
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavPhaseGain_ChgEventVal
	.dw	word _cavPhaseGain_MinChg
	.debug	G _cavPhaseGain_RegInfo 33 0
_cavPhaseOffset_RegInfo::
	.dw	word _cavPhaseOffset
	.dw	0x9a
	.dw	word (phys @1+1596)
	.dw	phys @1+1596 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavPhaseOffset_ChgEventVal
	.dw	word _cavPhaseOffset_MinChg
	.debug	G _cavPhaseOffset_RegInfo 33 0
_refAmplGain_RegInfo::
	.dw	word _refAmplGain
	.dw	0x9c
	.dw	word (phys @1+1611)
	.dw	phys @1+1611 >> 16
	.dw	word _MB_setGain
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _refAmplGain_ChgEventVal
	.dw	word _refAmplGain_MinChg
	.debug	G _refAmplGain_RegInfo 33 0
_refAmplOffset_RegInfo::
	.dw	word _refAmplOffset
	.dw	0x9e
	.dw	word (phys @1+1623)
	.dw	phys @1+1623 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _refAmplOffset_ChgEventVal
	.dw	word _refAmplOffset_MinChg
	.debug	G _refAmplOffset_RegInfo 33 0
_refPhaseGain_RegInfo::
	.dw	word _refPhaseGain
	.dw	0xa0
	.dw	word (phys @1+1637)
	.dw	phys @1+1637 >> 16
	.dw	word _MB_setGain
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _refPhaseGain_ChgEventVal
	.dw	word _refPhaseGain_MinChg
	.debug	G _refPhaseGain_RegInfo 33 0
_refPhaseOffset_RegInfo::
	.dw	word _refPhaseOffset
	.dw	0xa2
	.dw	word (phys @1+1650)
	.dw	phys @1+1650 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _refPhaseOffset_ChgEventVal
	.dw	word _refPhaseOffset_MinChg
	.debug	G _refPhaseOffset_RegInfo 33 0
_pulseFreq_RegInfo::
	.dw	word _pulseFreq
	.dw	0xa4
	.dw	word (phys @1+1665)
	.dw	phys @1+1665 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _pulseFreq_ChgEventVal
	.dw	word _pulseFreq_MinChg
	.debug	G _pulseFreq_RegInfo 33 0
_afcPhase0_RegInfo::
	.dw	word _afcPhase0
	.dw	0xa6
	.dw	word (phys @1+1675)
	.dw	phys @1+1675 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcPhase0_ChgEventVal
	.dw	word _afcPhase0_MinChg
	.debug	G _afcPhase0_RegInfo 33 0
_afcPhase1_RegInfo::
	.dw	word _afcPhase1
	.dw	0xa8
	.dw	word (phys @1+1685)
	.dw	phys @1+1685 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcPhase1_ChgEventVal
	.dw	word _afcPhase1_MinChg
	.debug	G _afcPhase1_RegInfo 33 0
_afcPhase2_RegInfo::
	.dw	word _afcPhase2
	.dw	0xaa
	.dw	word (phys @1+1695)
	.dw	phys @1+1695 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcPhase2_ChgEventVal
	.dw	word _afcPhase2_MinChg
	.debug	G _afcPhase2_RegInfo 33 0
_afcPhase3_RegInfo::
	.dw	word _afcPhase3
	.dw	0xac
	.dw	word (phys @1+1705)
	.dw	phys @1+1705 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcPhase3_ChgEventVal
	.dw	word _afcPhase3_MinChg
	.debug	G _afcPhase3_RegInfo 33 0
_afcPhase4_RegInfo::
	.dw	word _afcPhase4
	.dw	0xae
	.dw	word (phys @1+1715)
	.dw	phys @1+1715 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcPhase4_ChgEventVal
	.dw	word _afcPhase4_MinChg
	.debug	G _afcPhase4_RegInfo 33 0
_afcPhase5_RegInfo::
	.dw	word _afcPhase5
	.dw	0xb0
	.dw	word (phys @1+1725)
	.dw	phys @1+1725 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcPhase5_ChgEventVal
	.dw	word _afcPhase5_MinChg
	.debug	G _afcPhase5_RegInfo 33 0
_afcPhase6_RegInfo::
	.dw	word _afcPhase6
	.dw	0xb2
	.dw	word (phys @1+1735)
	.dw	phys @1+1735 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcPhase6_ChgEventVal
	.dw	word _afcPhase6_MinChg
	.debug	G _afcPhase6_RegInfo 33 0
_afcPhase7_RegInfo::
	.dw	word _afcPhase7
	.dw	0xb4
	.dw	word (phys @1+1745)
	.dw	phys @1+1745 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcPhase7_ChgEventVal
	.dw	word _afcPhase7_MinChg
	.debug	G _afcPhase7_RegInfo 33 0
_afcPhase8_RegInfo::
	.dw	word _afcPhase8
	.dw	0xb6
	.dw	word (phys @1+1755)
	.dw	phys @1+1755 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcPhase8_ChgEventVal
	.dw	word _afcPhase8_MinChg
	.debug	G _afcPhase8_RegInfo 33 0
_afcPhase9_RegInfo::
	.dw	word _afcPhase9
	.dw	0xb8
	.dw	word (phys @1+1765)
	.dw	phys @1+1765 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _afcPhase9_ChgEventVal
	.dw	word _afcPhase9_MinChg
	.debug	G _afcPhase9_RegInfo 33 0
_maxAmplSet_RegInfo::
	.dw	word _maxAmplSet
	.dw	0xba
	.dw	word (phys @1+1775)
	.dw	phys @1+1775 >> 16
	.dw	word _setF32
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _maxAmplSet_ChgEventVal
	.dw	word _maxAmplSet_MinChg
	.debug	G _maxAmplSet_RegInfo 33 0
_rfq_manTuneSet_RegInfo::
	.dw	word _rfq_manTuneSet
	.dw	0xbc
	.dw	word (phys @1+1786)
	.dw	phys @1+1786 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfq_manTuneSet_ChgEventVal
	.dw	word _rfq_manTuneSet_MinChg
	.debug	G _rfq_manTuneSet_RegInfo 33 0
_rfq_t1_offset_RegInfo::
	.dw	word _rfq_t1_offset
	.dw	0xbe
	.dw	word (phys @1+1801)
	.dw	phys @1+1801 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfq_t1_offset_ChgEventVal
	.dw	word _rfq_t1_offset_MinChg
	.debug	G _rfq_t1_offset_RegInfo 33 0
_rfq_t2_offset_RegInfo::
	.dw	word _rfq_t2_offset
	.dw	0xc0
	.dw	word (phys @1+1815)
	.dw	phys @1+1815 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _rfq_t2_offset_ChgEventVal
	.dw	word _rfq_t2_offset_MinChg
	.debug	G _rfq_t2_offset_RegInfo 33 0
_pulse_ramp_RegInfo::
	.dw	word _pulse_ramp
	.dw	0xc2
	.dw	word (phys @1+1829)
	.dw	phys @1+1829 >> 16
	.dw	word _MB_DSP_REG
	.db	0x3
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _pulse_ramp_ChgEventVal
	.dw	word _pulse_ramp_MinChg
	.debug	G _pulse_ramp_RegInfo 33 0
_stepperSetPos_RegInfo::
	.dw	word _stepperSetPos
	.dw	0xc4
	.dw	word (phys @1+1840)
	.dw	phys @1+1840 >> 16
	.dw	word _MB_DSP_REG
	.db	0x2
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _stepperSetPos_ChgEventVal
	.dw	word _stepperSetPos_MinChg
	.debug	G _stepperSetPos_RegInfo 33 0
_cavHighIlkLevel_RegInfo::
	.dw	word _cavHighIlkLevel
	.dw	0xc6
	.dw	word (phys @1+1854)
	.dw	phys @1+1854 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _cavHighIlkLevel_ChgEventVal
	.dw	word _cavHighIlkLevel_MinChg
	.debug	G _cavHighIlkLevel_RegInfo 33 0
_fwdHighIlkLevel_RegInfo::
	.dw	word _fwdHighIlkLevel
	.dw	0xc8
	.dw	word (phys @1+1870)
	.dw	phys @1+1870 >> 16
	.dw	word _MB_DSP_REG
	.db	0x4
	.db	0x2
	.db	0x1
	.db	0x2
	.db	0
	.db	0
	.dw	word _fwdHighIlkLevel_ChgEventVal
	.dw	word _fwdHighIlkLevel_MinChg
	.debug	G _fwdHighIlkLevel_RegInfo 33 0
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\appl\PhaseCtlr\PhaseCtlrAppl.c' 29 29 16 8 1 33
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I
_pvStrTest::
	.db	"....Initial Value....",0
	.debug	G _pvStrTest 34 0
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\appl\PhaseCtlr\PhaseCtlrAppl.c' 29 29 16 8 1 33
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\appl\PhaseCtlr\PhaseCtlrAppl.c' 29 29 16 8 1 33
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\appl\PhaseCtlr\PhaseCtlrAppl.c' 29 29 16 8 1 33
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I
_c0Coils::
	.dw	word _DoNothing_CoilInfo
	.debug	I
	.dw	0
	.debug	G _c0Coils 35 0
	.debug	I 'C:\work\dev\Rabbit_ST\appl\PhaseCtlr\PhaseCtlrAppl.c' 29 29 16 8 1 33
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I
_r3Regs::
	.dw	word _dlmVersTime_RegInfo
	.dw	word _dlmVersTime_RegInfo
	.dw	word _rtosVersTime_RegInfo
	.dw	word _rtosVersTime_RegInfo
	.dw	word _applVersTime_RegInfo
	.dw	word _applVersTime_RegInfo
	.dw	word _devType__RegInfo
	.dw	word _deviceID__RegInfo
	.dw	word _deviceID__RegInfo
	.dw	word _upSecs_RegInfo
	.dw	word _upSecs_RegInfo
	.dw	word _percentIdle__RegInfo
	.dw	word _numChans_RegInfo
	.dw	word _coilChanMult_RegInfo
	.dw	word _reg3ChanMult_RegInfo
	.dw	word _reg4ChanMult_RegInfo
	.dw	word _digInBits_RegInfo
	.dw	word _digInBits_RegInfo
	.dw	word _statusBitsStdA_RegInfo
	.dw	word _statusBitsStdB_RegInfo
	.dw	word _statusBitsAppl_RegInfo
	.dw	word _statusBitsAppl_RegInfo
	.dw	word _fwdAmpl_RegInfo
	.dw	word _fwdAmpl_RegInfo
	.dw	word _reflAmpl_RegInfo
	.dw	word _reflAmpl_RegInfo
	.dw	word _cavAmpl_RegInfo
	.dw	word _cavAmpl_RegInfo
	.dw	word _refAmpl_RegInfo
	.dw	word _refAmpl_RegInfo
	.dw	word _fwdPhase_RegInfo
	.dw	word _fwdPhase_RegInfo
	.dw	word _reflPhase_RegInfo
	.dw	word _reflPhase_RegInfo
	.dw	word _cavPhase_RegInfo
	.dw	word _cavPhase_RegInfo
	.dw	word _refPhase_RegInfo
	.dw	word _refPhase_RegInfo
	.dw	word _dspLoad_RegInfo
	.dw	word _dspTempInt_RegInfo
	.dw	word _dspTemp_RegInfo
	.dw	word _dspTemp_RegInfo
	.dw	word _unused_30043_RegInfo
	.dw	word _unused_30043_RegInfo
	.dw	word _unused_30045_RegInfo
	.dw	word _unused_30045_RegInfo
	.dw	word _unused_30047_RegInfo
	.dw	word _unused_30047_RegInfo
	.dw	word _unused_30049_RegInfo
	.dw	word _unused_30049_RegInfo
	.dw	word _unused_30051_RegInfo
	.dw	word _unused_30051_RegInfo
	.dw	word _unused_30053_RegInfo
	.dw	word _unused_30053_RegInfo
	.dw	word _unused_30055_RegInfo
	.dw	word _unused_30055_RegInfo
	.dw	word _unused_30057_RegInfo
	.dw	word _unused_30057_RegInfo
	.dw	word _unused_30059_RegInfo
	.dw	word _unused_30059_RegInfo
	.dw	word _percentCTF_RegInfo
	.dw	word _percentFFT_RegInfo
	.dw	word _latency_RegInfo
	.dw	word _tcpTickTime_RegInfo
	.dw	word _applLoopTime_RegInfo
	.dw	word _maxFwdAmpl_RegInfo
	.dw	word _maxFwdAmpl_RegInfo
	.dw	word _maxReflAmpl_RegInfo
	.dw	word _maxReflAmpl_RegInfo
	.dw	word _maxCavAmpl_RegInfo
	.dw	word _maxCavAmpl_RegInfo
	.dw	word _maxOutAmpl_RegInfo
	.dw	word _maxOutAmpl_RegInfo
	.dw	word _statusBitsDSP_RegInfo
	.dw	word _statusBitsDSP_RegInfo
	.dw	word _statusBitsAFC_RegInfo
	.dw	word _writeStatus_RegInfo
	.dw	word _sizeCTF_RegInfo
	.dw	word _sizeFFT_RegInfo
	.dw	word _romProgErrs_RegInfo
	.dw	word _piezoReadPos_RegInfo
	.dw	word _unused_30082_RegInfo
	.dw	word _kernelLoopTime_RegInfo
	.dw	word _stepperReadPos_RegInfo
	.dw	word _stepperReadPos_RegInfo
	.debug	I
	.dw	0
	.debug	G _r3Regs 37 0
	.debug	I 'C:\work\dev\Rabbit_ST\appl\PhaseCtlr\PhaseCtlrAppl.c' 29 29 16 8 1 33
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I
_r4Regs::
	.dw	word _timeZone__RegInfo
	.dw	word _curTime_RegInfo
	.dw	word _curTime_RegInfo
	.dw	word _ipAddr_RegInfo
	.dw	word _ipAddr_RegInfo
	.dw	word _netmask_RegInfo
	.dw	word _netmask_RegInfo
	.dw	word _gateway_RegInfo
	.dw	word _gateway_RegInfo
	.dw	word _setACoil_RegInfo
	.dw	word _resetACoil_RegInfo
	.dw	word _digOutBits_RegInfo
	.dw	word _digOutBits_RegInfo
	.dw	word _cmdBitsStd_RegInfo
	.dw	word _cmdBitsStd_RegInfo
	.dw	word _cmdBitsAppl_RegInfo
	.dw	word _cmdBitsAppl_RegInfo
	.dw	word _setAtten_RegInfo
	.dw	word _trigPos_RegInfo
	.dw	word _cmdBitsAppl3_RegInfo
	.dw	word _phaseSet_RegInfo
	.dw	word _phaseSet_RegInfo
	.dw	word _amplSet_RegInfo
	.dw	word _amplSet_RegInfo
	.dw	word _oldPulseFreq_RegInfo
	.dw	word _rf_P_RegInfo
	.dw	word _rf_P_RegInfo
	.dw	word _rf_I_RegInfo
	.dw	word _rf_I_RegInfo
	.dw	word _rf_D_RegInfo
	.dw	word _rf_D_RegInfo
	.dw	word _unusedreg2_RegInfo
	.dw	word _unusedreg2_RegInfo
	.dw	word _pulsedAmplSet_RegInfo
	.dw	word _pulsedAmplSet_RegInfo
	.dw	word _tuner_P_RegInfo
	.dw	word _tuner_P_RegInfo
	.dw	word _tuner_I_RegInfo
	.dw	word _tuner_I_RegInfo
	.dw	word _tuner_D_RegInfo
	.dw	word _tuner_D_RegInfo
	.dw	word _unusedreg3_RegInfo
	.dw	word _unusedreg3_RegInfo
	.dw	word _pulsedPhaseSet_RegInfo
	.dw	word _pulsedPhaseSet_RegInfo
	.dw	word _setAFCsOnOff_RegInfo
	.dw	word _setAFCsOnOff_RegInfo
	.dw	word _afcFreq0_RegInfo
	.dw	word _afcFreq0_RegInfo
	.dw	word _afcFreq1_RegInfo
	.dw	word _afcFreq1_RegInfo
	.dw	word _afcFreq2_RegInfo
	.dw	word _afcFreq2_RegInfo
	.dw	word _afcFreq3_RegInfo
	.dw	word _afcFreq3_RegInfo
	.dw	word _afcFreq4_RegInfo
	.dw	word _afcFreq4_RegInfo
	.dw	word _afcFreq5_RegInfo
	.dw	word _afcFreq5_RegInfo
	.dw	word _afcFreq6_RegInfo
	.dw	word _afcFreq6_RegInfo
	.dw	word _afcFreq7_RegInfo
	.dw	word _afcFreq7_RegInfo
	.dw	word _afcFreq8_RegInfo
	.dw	word _afcFreq8_RegInfo
	.dw	word _afcFreq9_RegInfo
	.dw	word _afcFreq9_RegInfo
	.dw	word _warmLevel_RegInfo
	.dw	word _warmLevel_RegInfo
	.dw	word _warmMS_RegInfo
	.dw	word _rampMS_RegInfo
	.dw	word _dspComErrors_RegInfo
	.dw	word _dspProgNum_RegInfo
	.dw	word _pllInitIdx_RegInfo
	.dw	word _rfq_t1_feedback_RegInfo
	.dw	word _rfq_t1_feedback_RegInfo
	.dw	word _rfq_t2_feedback_RegInfo
	.dw	word _rfq_t2_feedback_RegInfo
	.dw	word _devStat1_RegInfo
	.dw	word _rfq_t1_output_RegInfo
	.dw	word _rfq_t1_output_RegInfo
	.dw	word _rfq_t2_output_RegInfo
	.dw	word _rfq_t2_output_RegInfo
	.dw	word _devCtl1_RegInfo
	.dw	word _devRdSet1_RegInfo
	.dw	word _devRdSet1_RegInfo
	.dw	word _devRdSet2_RegInfo
	.dw	word _devRdSet2_RegInfo
	.dw	word _devRdCtl1_RegInfo
	.dw	word _piezoSetPos_RegInfo
	.dw	word _unused_40091_RegInfo
	.dw	word _fwdAtten_RegInfo
	.dw	word _reflAtten_RegInfo
	.dw	word _cavAtten_RegInfo
	.dw	word _freqSearchAmpl_RegInfo
	.dw	word _freqSearchAmpl_RegInfo
	.dw	word _cavLowIlkLevel_RegInfo
	.dw	word _cavLowIlkLevel_RegInfo
	.dw	word _cavLowIlkTime_RegInfo
	.dw	word _cavLowIlkTime_RegInfo
	.dw	word _dvdt_IlkRate_RegInfo
	.dw	word _dvdt_IlkRate_RegInfo
	.dw	word _vv_IlkRatio_RegInfo
	.dw	word _vv_IlkRatio_RegInfo
	.dw	word _fwdCavOffset_RegInfo
	.dw	word _fwdCavOffset_RegInfo
	.dw	word _feedFwdPhase_RegInfo
	.dw	word _feedFwdPhase_RegInfo
	.dw	word _feedFwdGain_RegInfo
	.dw	word _feedFwdGain_RegInfo
	.dw	word _ctfCalcRate_RegInfo
	.dw	word _ctfCalcRate_RegInfo
	.dw	word _fwdMagCalib_RegInfo
	.dw	word _fwdMagCalib_RegInfo
	.dw	word _fwdPhaseCalib_RegInfo
	.dw	word _fwdPhaseCalib_RegInfo
	.dw	word _reflMagCalib_RegInfo
	.dw	word _reflMagCalib_RegInfo
	.dw	word _reflPhaseCalib_RegInfo
	.dw	word _reflPhaseCalib_RegInfo
	.dw	word _cavMagCalib_RegInfo
	.dw	word _cavMagCalib_RegInfo
	.dw	word _cavPhaseCalib_RegInfo
	.dw	word _cavPhaseCalib_RegInfo
	.dw	word _outMagCalib_RegInfo
	.dw	word _outMagCalib_RegInfo
	.dw	word _outPhaseCalib_RegInfo
	.dw	word _outPhaseCalib_RegInfo
	.dw	word _ctfTunerAmpl_RegInfo
	.dw	word _ctfTunerAmpl_RegInfo
	.dw	word _setDSPState_RegInfo
	.dw	word _setDSPState_RegInfo
	.dw	word _fwdAmplGain_RegInfo
	.dw	word _fwdAmplGain_RegInfo
	.dw	word _fwdAmplOffset_RegInfo
	.dw	word _fwdAmplOffset_RegInfo
	.dw	word _fwdPhaseGain_RegInfo
	.dw	word _fwdPhaseGain_RegInfo
	.dw	word _fwdPhaseOffset_RegInfo
	.dw	word _fwdPhaseOffset_RegInfo
	.dw	word _reflAmplGain_RegInfo
	.dw	word _reflAmplGain_RegInfo
	.dw	word _reflAmplOffset_RegInfo
	.dw	word _reflAmplOffset_RegInfo
	.dw	word _reflPhaseGain_RegInfo
	.dw	word _reflPhaseGain_RegInfo
	.dw	word _reflPhaseOffset_RegInfo
	.dw	word _reflPhaseOffset_RegInfo
	.dw	word _cavAmplGain_RegInfo
	.dw	word _cavAmplGain_RegInfo
	.dw	word _cavAmplOffset_RegInfo
	.dw	word _cavAmplOffset_RegInfo
	.dw	word _cavPhaseGain_RegInfo
	.dw	word _cavPhaseGain_RegInfo
	.dw	word _cavPhaseOffset_RegInfo
	.dw	word _cavPhaseOffset_RegInfo
	.dw	word _refAmplGain_RegInfo
	.dw	word _refAmplGain_RegInfo
	.dw	word _refAmplOffset_RegInfo
	.dw	word _refAmplOffset_RegInfo
	.dw	word _refPhaseGain_RegInfo
	.dw	word _refPhaseGain_RegInfo
	.dw	word _refPhaseOffset_RegInfo
	.dw	word _refPhaseOffset_RegInfo
	.dw	word _pulseFreq_RegInfo
	.dw	word _pulseFreq_RegInfo
	.dw	word _afcPhase0_RegInfo
	.dw	word _afcPhase0_RegInfo
	.dw	word _afcPhase1_RegInfo
	.dw	word _afcPhase1_RegInfo
	.dw	word _afcPhase2_RegInfo
	.dw	word _afcPhase2_RegInfo
	.dw	word _afcPhase3_RegInfo
	.dw	word _afcPhase3_RegInfo
	.dw	word _afcPhase4_RegInfo
	.dw	word _afcPhase4_RegInfo
	.dw	word _afcPhase5_RegInfo
	.dw	word _afcPhase5_RegInfo
	.dw	word _afcPhase6_RegInfo
	.dw	word _afcPhase6_RegInfo
	.dw	word _afcPhase7_RegInfo
	.dw	word _afcPhase7_RegInfo
	.dw	word _afcPhase8_RegInfo
	.dw	word _afcPhase8_RegInfo
	.dw	word _afcPhase9_RegInfo
	.dw	word _afcPhase9_RegInfo
	.dw	word _maxAmplSet_RegInfo
	.dw	word _maxAmplSet_RegInfo
	.dw	word _rfq_manTuneSet_RegInfo
	.dw	word _rfq_manTuneSet_RegInfo
	.dw	word _rfq_t1_offset_RegInfo
	.dw	word _rfq_t1_offset_RegInfo
	.dw	word _rfq_t2_offset_RegInfo
	.dw	word _rfq_t2_offset_RegInfo
	.dw	word _pulse_ramp_RegInfo
	.dw	word _pulse_ramp_RegInfo
	.dw	word _stepperSetPos_RegInfo
	.dw	word _stepperSetPos_RegInfo
	.dw	word _cavHighIlkLevel_RegInfo
	.dw	word _cavHighIlkLevel_RegInfo
	.dw	word _fwdHighIlkLevel_RegInfo
	.dw	word _fwdHighIlkLevel_RegInfo
	.debug	I
	.dw	0
	.debug	G _r4Regs 39 0
	.debug	I 'C:\work\dev\Rabbit_ST\appl\PhaseCtlr\PhaseCtlrAppl.c' 29 29 16 8 1 33
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I
_nonRegPVs::
	.dw	word (phys @1+1886)
	.dw	phys @1+1886 >> 16
	.db	0x5
	.dw	0x16
	.dw	0x16
	.dw	0x1
	.dw	0x5
	.dl	phys _pvStrTest
	.dw	0x16
	.db	0
	.db	0
	.dw	word _PV_UpdateVal
	.dw	word _PV_LockVal
	.dw	word _PV_SendVal
	.dw	word _PV_RcvVal
	.dw	word (phys @1+1896)
	.dw	phys @1+1896 >> 16
	.db	0x3
	.dw	0x1000
	.dw	0x4
	.dw	0x400
	.dw	0x5
	.dl	phys _waveformData+4096
	.dw	0x1000
	.db	0
	.db	0
	.dw	word _PV_UpdateValWF
	.dw	word _PV_LockWave
	.dw	word _PV_SendVal
	.dw	word _PV_RcvVal
	.dw	word (phys @1+1910)
	.dw	phys @1+1910 >> 16
	.db	0x3
	.dw	0x1000
	.dw	0x4
	.dw	0x400
	.dw	0x5
	.dl	phys _waveformData+12288
	.dw	0x1000
	.db	0
	.db	0
	.dw	word _PV_UpdateValWF
	.dw	word _PV_LockWave
	.dw	word _PV_SendVal
	.dw	word _PV_RcvVal
	.dw	word (phys @1+422)
	.dw	phys @1+422 >> 16
	.db	0x4
	.dw	0x1000
	.dw	0x4
	.dw	0x400
	.dw	0x5
	.dl	phys _waveformData+20480
	.dw	0x1000
	.db	0
	.db	0
	.dw	word _PV_UpdateValWF
	.dw	word _PV_LockWave
	.dw	word _PV_SendVal
	.dw	word _PV_RcvVal
	.dw	word (phys @1+1925)
	.dw	phys @1+1925 >> 16
	.db	0x3
	.dw	0x1000
	.dw	0x4
	.dw	0x400
	.dw	0x5
	.dl	phys _waveformData+28672
	.dw	0x1000
	.db	0
	.db	0
	.dw	word _PV_UpdateValWF
	.dw	word _PV_LockWave
	.dw	word _PV_SendVal
	.dw	word _PV_RcvVal
	.dw	word (phys @1+1935)
	.dw	phys @1+1935 >> 16
	.db	0x4
	.dw	0x1000
	.dw	0x4
	.dw	0x400
	.dw	0x5
	.dl	phys _waveformData+36864
	.dw	0x1000
	.db	0
	.db	0
	.dw	word _PV_UpdateValWF
	.dw	word _PV_LockWave
	.dw	word _PV_SendVal
	.dw	word _PV_RcvVal
	.debug	I
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
	.db	0
	.db	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.debug	G _nonRegPVs 40 0
	.debug	I 'C:\work\dev\Rabbit_ST\appl\PhaseCtlr\PhaseCtlrAppl.c' 29 29 16 8 1 33
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\semaphore.h' 23 34 9 26 4 32
	.debug	I
	.defseg	CONST
	.seg	CONST
_PV_WF_Idx::
	.dw	0x1
	.dw	0x2
	.dw	0x3
	.dw	0x4
	.dw	0x5
	.debug	G _PV_WF_Idx 42 0
	.debug	I
	.debug	I
;701 #endif
;702 #ifndef RegDefs
;703 
;704 
;705 
;706 //APPLCODE - change to the application name
;707 const char far applName[] = { "Phase Controller" };
	.defseg	FARCONST
	.seg	FARCONST
_applName::
	.db	"Phase Controller",0
	.debug	G _applName 43 8
;708 const char ApplAbbrev[] = { "PhCtlr" };
	.seg	CONST
_ApplAbbrev::
	.db	"PhCtlr",0
	.debug	G _ApplAbbrev 44 0
;709 
;710 //APPLCODE - add ID to unistd.h and place it here
;711 #define DeviceType  DT_PhaseCtlr
;712 
;713 //APPLCODE - set the # of input and outputs used
;714 #define  NUM_APPL_AIN     1   // analog inputs
;715 #define  NUM_APPL_AOUT    1   // analog outputs
;716 #define  NUM_APPL_DIN    14   // digital inputs
;717 #define  NUM_APPL_DOUT   24   // digital outputs
;718 
;719 #define  ADC_MASK_APPL  0x00000000L
;720 #define  DAC_MASK_APPL  0x00000000L
;721 
;722 //APPLCODE - set to state we want outputs in during initialization
;723 #define InitialDigOutState  ( _ADC_CS | FPGA_SPI | _RESET_DSP )
;724 
;725 #define  RespOffset  2  // # packets DSP responses are delayed by
;726 
;727 #define SharedINC
;728 #include <sharedAppl.c>
;729 
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwDefs.h' 20 2 12 27 10 31
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\srfs.h' 6 17 10 7 4 28
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\spi.h' 12 54 10 3 8 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\serial.h' 29 2 10 30 4 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\epics_cad.h' 8 56 9 31 7 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMiii.h' 3 21 14 4 6 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\inetd.h' 23 39 13 12 5 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\applic.h' 28 10 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\tsh.h' 3 45 16 21 3 28
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\ctype.h' 22 48 13 9 7 24
	.debug	I
	.dseg
_consCfg::
	.dw	0xffffc200, 0x1
	.dw	0x1
	.debug	G _consCfg 45 0
	.seg	CONST
_NumApplAIN::
	.dw	0x1
	.debug	G _NumApplAIN 7 0
_NumApplAOUT::
	.dw	0x1
	.debug	G _NumApplAOUT 7 0
_NumApplDIN::
	.dw	0xe
	.debug	G _NumApplDIN 7 0
_NumApplDOUT::
	.dw	0x18
	.debug	G _NumApplDOUT 7 0
_NumExtraIn::
	.dw	0x20
	.debug	G _NumExtraIn 7 0
	.debug	I
;730 #include <math.h>
;731 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
;732 
;733 //--- definitions for enabling diagnostic messages ---
;734 #define  DSPErrorBits      0x80
;735 
;736 #define  ShowDSPErrors     (DiagFlags & DSPErrorBits)
;737 
;738 
;739 /*-------------------------------------------------
;740  NOTES:
;741    port B ("spi1")  connected to FPGA, PLL, ADC's, and DSP
;742    port C ("spi2")  connected to EEPROM
;743 ---------------------------------------------------*/
;744 
;745 //--- multipliers/divisors for converting between unsigned 16-bit int value
;746 //--- used by the DSP and engineering units (volts and degress in this case
;747 #define  AmplConvFactor   ( 0.0000426233445431 )
;748 //#define  PhaseConvFactor  ( 0.0054931640625 )  // 360 / 2^16
;749 #define  PhaseConvFactor  ( 0.0000000838190317 )  // ~ 360 / 2^32
;750 #define  FRACU16Divisor   ( 0.0000152590219 )  // div by this = mult by 655
;751 //#define  FreqConvFactor   (    0.0152590219 )  // scales 0-1000 -> 0-6553
;752 
;753 
;754 #define  DSP_Prog_File   "dspprog.bin"
;755 #define  FPGA_Prog_File  "/srfs/llrf.bin"
;756 
;757 
;758 
;759 //--- instruction codes for ATMEL SPI Serial EEPROMs ---
;760 #define  EEPROM_WRSR       0x01   // WRite Status Register
;761 #define  EEPROM_WRITE      0x02   // Write a page to memory
;762 #define  EEPROM_READ       0x03   // Read bytes from memory
;763 #define  EEPROM_WRDI       0x04   // WRite DIsable latch
;764 #define  EEPROM_RDSR       0x05   // ReaD Status Register
;765 #define  EEPROM_WREN       0x06   // WRite ENable
;766 #define  EEPROM_PROT       0x36   // PROTect sector
;767 #define  EEPROM_UNPR       0x39   // UNPRotect sector
;768 #define  EEPROM_ERASE_ALL  0x60   // Erase entire chip
;769 #define  EEPROM_RDID       0x9F   // Read device ID
;770 #define  EEPROM_SEQ_PROG   0xAF   // Write a sequence of bytes
;771 
;772 #define  EEPROM_Enable()   
;773     OUTI(PFDR, PFDRShadow & 0xFE)  // Chip Select (PF0) low
;774 #define  EEPROM_Disable()   
;775     OUTI(PFDR, PFDRShadow | 0x01)  // Chip Select (PF0) high
;776 
;777 
;778 
;779 #define  ReadDig()  { digitalIn = ReadDigInputs(); }
;780 #define  WriteDig()  {  WriteDigOutputs(digitalOut); }
;781 
;782 
;783 #define  WriteSPI1(buf, len)    _spiWrite_(spi1Port, buf, len, false)
;784 //#define  WriteSPI1(buf, len)   write(spi1fd, buf, len)
;785 #define  ReadSPI1(buf, len)     _spiRead_(spi1Port, buf, len, false)
;786 //#define  ReadSPI12(buf, len)    read(spi1fd, buf, len)
;787 
;788 #define  WriteSPI2(buf, len)    _spiWrite_(spi2Port, buf, len, false)
;789 //#define  WriteSPI2(buf, len)   write(spi2fd, buf, len)
;790 #define  ReadSPI2(buf, len)     _spiRead_(spi2Port, buf, len, false)
;791 //#define  ReadSPI2(buf, len)    read(spi2fd, buf, len)
;792 
;793 
;794 #define  PI_  3.1415926
;795 
;796 //-------------------------------------------------------------------------
;797 // data types and function prototypes:
;798 //-------------------------------------------------------------------------
;799 
;800 long fltofi(float value);
;801 float fitofl(long value);
;802 
;803 
;804 int initDSP(fd_t fromfd, uint progNum, ulong ttlBytes, bool showProgress);
;805 
;806 int updateFPGAfirmware(fd_t fromfd, bool showProgress, bool verify);
;807 
;808 //int writeFPGAParallel(uchar id, uchar val);
;809 
;810 int write_ADCReg(uint regNum, uint regVal);
;811 
;812 int write_Config(uint newConfig);
;813 
;814 
;815 int readPlot(ulong regNum, ulong far *rcvBuf, uint rcvCount);
;816 
;817 int writeDSPRegQuick(ulong regNum, ulong regVal);
;818 int writeDSPReg(ulong regNum, ulong regVal, bool showErrs);
;819 int readDSPReg(ulong regNum, ulong *regVal);
;820 
;821 int read_DSP_Regs(void);
;822 int write_DSP_Regs(void);
;823 
;824 
;825 void prepForReset(void);
;826 void resetDSP(void);
;827 
;828 
;829 bool MB_DSP_REG(SetRegFuncParams);
;830 
;831 
;832 int  getLock(uint id, ulong msTimeout);
;833 int  releaseLock(uint id);
;834 
;835 typedef struct  {
;836   int  count;
;837   PID  owner;
;838 //  WaitQueue  tasks;
;839   sem_t  sem;
;840 }  LockData;
;841 
;842 enum LockIDS { APPL_LOCK,
;843                WAVE_DATA_0, WAVE_DATA_1, WAVE_DATA_2, WAVE_DATA_3,
;844                WAVE_DATA_4, WAVE_DATA_5, WAVE_DATA_6, WAVE_DATA_7,
;845                WAVE_DATA_8, WAVE_DATA_9,
;846                NUM_LOCKS };
;847 
;848 
;849 #define  PLLInitSeqLen  40
;850 
;851 #define  PLLInitSeqFile  "pllInitSeqs"
;852 
;853 #define  NumFixedPLLSeqs  3
;854 
;855 const char pllInitSeqs[NumFixedPLLSeqs][PLLInitSeqLen] = {
;856   {  // 80.5 MHz
;857     0x80,0x00,0x00,0x00,
_pllInitSeqs::
	.db	0x80
	.db	0
	.db	0
	.db	0
;858     0x00,0x03,0x08,0x04,
	.db	0
	.db	0x3
	.db	0x8
	.db	0x4
;859     0x00,0x03,0x0a,0x05,
	.db	0
	.db	0x3
	.db	0xa
	.db	0x5
;860     0x00,0x03,0x03,0x06,
	.db	0
	.db	0x3
	.db	0x3
	.db	0x6
;861     0x00,0x03,0x03,0x07,
	.db	0
	.db	0x3
	.db	0x3
	.db	0x7
;862     0x10,0x00,0x09,0x08,
	.db	0x10
	.db	0
	.db	0x9
	.db	0x8
;863     0x00,0x82,0x00,0x0b,
	.db	0
	.db	0x82
	.db	0
	.db	0xb
;864     0x02,0x94,0x00,0x0d,
	.db	0x2
	.db	0x94
	.db	0
	.db	0xd
;865     0x08,0x30,0xa1,0x0e,
	.db	0x8
	.db	0x30
	.db	0xa1
	.db	0xe
;866     0xc8,0x06,0x40,0x0f
	.db	0xc8
	.db	0x6
	.db	0x40
;867   },
	.db	0xf
;868   {  // 161 MHz
;869     0x80,0x00,0x00,0x00,
	.db	0x80
	.db	0
	.db	0
	.db	0
;870     0x00,0x03,0x08,0x04,
	.db	0
	.db	0x3
	.db	0x8
	.db	0x4
;871     0x00,0x03,0x0a,0x05,
	.db	0
	.db	0x3
	.db	0xa
	.db	0x5
;872     0x00,0x03,0x03,0x06,
	.db	0
	.db	0x3
	.db	0x3
	.db	0x6
;873     0x00,0x03,0x03,0x07,
	.db	0
	.db	0x3
	.db	0x3
	.db	0x7
;874     0x10,0x00,0x09,0x08,
	.db	0x10
	.db	0
	.db	0x9
	.db	0x8
;875     0x00,0x82,0x00,0x0b,
	.db	0
	.db	0x82
	.db	0
	.db	0xb
;876     0x02,0xa8,0x40,0x0d,
	.db	0x2
	.db	0xa8
	.db	0x40
	.db	0xd
;877     0x08,0x30,0xa1,0x0e,
	.db	0x8
	.db	0x30
	.db	0xa1
	.db	0xe
;878     0xc8,0x03,0x20,0x0f
	.db	0xc8
	.db	0x3
	.db	0x20
;879   },
	.db	0xf
;880   {  // 241.5 MHz
;881     0x80,0x00,0x00,0x00,
	.db	0x80
	.db	0
	.db	0
	.db	0
;882     0x00,0x03,0x08,0x04,
	.db	0
	.db	0x3
	.db	0x8
	.db	0x4
;883     0x00,0x03,0x0a,0x05,
	.db	0
	.db	0x3
	.db	0xa
	.db	0x5
;884     0x00,0x03,0x03,0x06,
	.db	0
	.db	0x3
	.db	0x3
	.db	0x6
;885     0x00,0x03,0x03,0x07,
	.db	0
	.db	0x3
	.db	0x3
	.db	0x7
;886     0x10,0x00,0x09,0x08,
	.db	0x10
	.db	0
	.db	0x9
	.db	0x8
;887     0x00,0x82,0x00,0x0b,
	.db	0
	.db	0x82
	.db	0
	.db	0xb
;888     0x02,0xb2,0x00,0x0d,
	.db	0x2
	.db	0xb2
	.db	0
	.db	0xd
;889     0x08,0x31,0xe3,0x0e,
	.db	0x8
	.db	0x31
	.db	0xe3
	.db	0xe
;890     0xc8,0x06,0x40,0x0f
	.db	0xc8
	.db	0x6
	.db	0x40
;891   }
	.db	0xf
;892 };
	.debug	G _pllInitSeqs 46 0
;893 
;894 
;895 //=========================================================================
;896 //  definitions related to use of the Digital and Analog I/O signals
;897 //=========================================================================
;898 
;899 //======================= digitalIn usage ===========================
;900 #define  ID0          0x000001  // DI-00: PA0:  ID bit 0
;901 #define  ID1          0x000002  // DI-01: PA1:  ID bit 1
;902 #define  ID2          0x000004  // DI-02: PA2:  ID bit 2
;903 #define  ID3          0x000008  // DI-03: PA3:  ID bit 3
;904 //-----------------------------
;905 #define  ID4          0x000010  // DI-04: PA4:  ID bit 4
;906 #define  ID5          0x000020  // DI-05: PA5:  ID bit 5
;907 #define  ID6          0x000040  // DI-06: PA6:  ID bit 6
;908 #define  ID7          0x000080  // DI-07: PA7:  ID bit 7
;909 //-----------------------------
;910 #define  DSP_GP1      0x000100  // DI-08: PD4:
;911 #define  DSP_GP2      0x000200  // DI-09: PD5:
;912 #define  unused_i10   0x000400  // DI-10: PE3:
;913 #define  FPGA_DONE    0x000800  // DI-11: PE4:
;914 //-----------------------------
;915 #define  FPGA_CL2     0x001000  // DI-12: PF3:  ACK from FPGA (i.e. last pa
;916 #define  unused_i13   0x002000  // DI-13: PF4:  DSP is in Reset state
;917 //-----------------------------
;918 
;919 const uchar  LogicOrderDIn[NUM_APPL_DIN] = {
;920   0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13 };
_LogicOrderDIn::
	.db	0
	.db	0x1
	.db	0x2
	.db	0x3
	.db	0x4
	.db	0x5
	.db	0x6
	.db	0x7
	.db	0x8
	.db	0x9
	.db	0xa
	.db	0xb
	.db	0xc
	.db	0xd
	.debug	G _LogicOrderDIn 48 0
;921 
;922   //--- msgs to log automatically when a digital input changes state ---
;923 //--- use NULL for bits that we don't want to log changes for ---
;924 const char far *digInDescr[NUM_APPL_DIN*2] = {
;925 //--0 state descr--    --1 state descr--
;926   NULL,                NULL,
	.dseg
_digInDescr::
	.dw	0, 0
	.dw	0, 0
;927   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;928   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;929   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;930   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;931   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;932   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;933   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;934   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;935   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;936   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;937   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;938   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;939   NULL,                NULL
	.dw	0, 0
;940 
	.dw	0, 0
	.debug	G _digInDescr 49 0
;941 
;942 
;943 
;944 //====================== digitalOut usage ===========================
;945 
;946 //------------------------------
;947 #define  DSP_GP5      0x000001L  // DO-00: PG0:
;948 #define  DSP_GP6      0x000002L  // DO-01: PG1:
;949 #define  DSP_GP7      0x000004L  // DO-02: PG2:
;950 #define  DSP_GP8      0x000008L  // DO-03: PG3:
;951 //------------------------------
;952 #define  _DSP_WR_RD   0x000010L  // DO-04: PG4:  DSP SPI enable
;953 #define  DSP_GP9      0x000020L  // DO-05: PG5:
;954 #define  DSP_GP10     0x000040L  // DO-06: PG6:
;955 #define  DSP_GP11     0x000080L  // DO-07: PG7:
;956 //------------------------------
;957 #define  _RESET_DSP   0x000100L  // DO-08: PB2:  0=Reset DSP, 1=Run
;958 #define  ActivityLED  0x000200L  // DO-09: PB3:
;959 #define  READY_LED    0x000400L  // DO-10: PB4:  1 turns on CPU Ready LED
;960 #define  ON_OFF_LED   0x000800L  // DO-11: PB5:  1 turns on RF ON LED
;961 //------------------------------
;962 #define  DSP_NMI      0x001000L  // DO-12: PB6:
;963 #define  unused_o13   0x002000L  // DO-13: PB7:
;964 #define  FPGA_SPI     0x004000L  // DO-14: PE1:  low-to-high causes FPGA re
;965 #define  _ADC_CS      0x008000L  // DO-15: PE6:  ADC /CS (Chip Select)
;966 //------------------------------
;967 #define  PLL_LE       0x010000L  // DO-16: PE7:  PLL Load Enable
;968 #define  _EEPROM_CS   0x020000L  // DO-17: PF0   /CS on EEPROM
;969 #define  none_o18     0x040000L  // DO-18: ---   (ignored)
;970 #define  FPGA_CL1     0x080000L  // DO-19: PF2:  (now unused?)
;971 //------------------------------
;972 #define  none_o20     0x100000L  // DO-20: ---   (ignored)
;973 #define  unused_o21   0x200000L  // DO-21: PF5:
;974 #define  DSP_GP3      0x400000L  // DO-22: PF6:  LSB used to select DSP pro
;975 #define  DSP_GP4      0x800000L  // DO-23: PF7:  MSB used to select DSP pro
;976 //------------------------------
;977 const uchar  LogicOrderDOut[NUM_APPL_DOUT] = {
;978   0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12,
	.seg	CONST
_LogicOrderDOut::
	.db	0
	.db	0x1
	.db	0x2
	.db	0x3
	.db	0x4
	.db	0x5
	.db	0x6
	.db	0x7
	.db	0x8
	.db	0x9
	.db	0xa
	.db	0xb
	.db	0xc
;979   13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23
	.db	0xd
	.db	0xe
	.db	0xf
	.db	0x10
	.db	0x11
	.db	0x12
	.db	0x13
	.db	0x14
	.db	0x15
	.db	0x16
;980 };
	.db	0x17
	.debug	G _LogicOrderDOut 51 0
;981 
;982 #define  TurnOnActivityLED()    ClearBits(Next.digitalOut, ActivityLED)
;983 #define  TurnOffActivityLED()   SetBits(Next.digitalOut, ActivityLED)
;984 
;985 //--- msgs to log automatically when a digital output changes state ---
;986 //--- use NULL for bits that we don't want to log changes for ---
;987 const char far *digOutDescr[NUM_APPL_DOUT*2] = {
;988 //--0 state descr--    --1 state descr--
;989   NULL,                NULL,
	.dseg
_digOutDescr::
	.dw	0, 0
	.dw	0, 0
;990   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;991   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;992   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;993   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;994   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;995   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;996   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;997   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;998   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;999   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1000   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1001   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1002   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1003   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1004   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1005   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1006   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1007   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1008   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1009   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1010   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1011   NULL,                NULL,
	.dw	0, 0
	.dw	0, 0
;1012   NULL,                NULL
	.dw	0, 0
;1013 
	.dw	0, 0
	.debug	G _digOutDescr 52 0
;1014 
;1015 
;1016 //=============== Analog input usage ===============
;1017 const uchar  LogicOrderAIn[NUM_APPL_AIN] = { 0 };
	.seg	CONST
_LogicOrderAIn::
	.db	0
	.debug	G _LogicOrderAIn 53 0
;1018 
;1019 
;1020 //=============== Analog output usage ===============
;1021 const uchar  LogicOrderAOut[NUM_APPL_AOUT] = { 0 };
_LogicOrderAOut::
	.db	0
	.debug	G _LogicOrderAOut 53 0
;1022 
;1023 
;1024 
;1025 //=========================================================================
;1026 //  ID's for values sent to or read from the DSP
;1027 //  OR'ing an ID with 0x8000 allows reading without writing
;1028 //=========================================================================
;1029 
;1030 //--- DSP register numbers (without the 0x01000000 mask shared by all regs)
;1031 
;1032 
;1033 // Even # values used to read a register, Odd # values used to write to a r
;1034 
;1035 // P32 means the "PHASE" format, a 32-bit integer scaled to/from 0 to 360
;1036 
;1037 //===== Read-Only registers =====
;1038 #define  FwdPhase         0x00100000L  // P32: Forward Phase
;1039 #define  ReflPhase        0x00100002L  // P32: Reflected Phase
;1040 #define  CavPhase         0x00100004L  // P32: Cavity Phase
;1041 #define  RefPhase         0x00100006L  // P32: Reference Phase
;1042 
;1043 #define  FwdAmpl          0x00100008L  // F32: Forward Amplitude
;1044 #define  ReflAmpl         0x0010000AL  // F32: Reflected Amplitude
;1045 #define  CavAmpl          0x0010000CL  // F32: Cavity Amplitude
;1046 #define  RefAmpl          0x0010000EL  // F32: Reference Amplitude
;1047 
;1048 #define  MaxFwdAmpl       0x00100010L  // F32: Max Forward Amplitude
;1049 #define  MaxReflAmpl      0x00100012L  // F32: Max Reflected Amplitude
;1050 #define  MaxCavAmpl       0x00100014L  // F32: Max Cavity Amplitude
;1051 #define  MaxOutAmpl       0x00100016L  // F32: Max Output Amplitude
;1052 
;1053 #define  DSP_Status       0x00100018L  // Bits: misc DSP status
;1054 #define  AFC_State        0x0010001AL  // Bits: AFC state bits
;1055 
;1056 #define  DSP_Load         0x0010001CL  // F32: DSP load percentage
;1057 #define  PCB_Temp         0x0010001EL  // F32: PCB temperature
;1058 
;1059 
;1060 //===== R/W registers (the addresses shown are the read addresses) =====
;1061 #define  TriggerPos       0x00100100L  // U32: trigger position (tuning plo
;1062 
;1063 #define  WarmUpAmpl       0x00100102L  // F32: Warm-up Amplitude
;1064 #define  WarmUpTime       0x00100104L  // F32: time at warm-up Amplitude
;1065 #define  RampTime         0x00100106L  // F32: time to ramp to set-point
;1066 
;1067 #define  FwdAtten         0x00100108L  // U32: Forward Attenuator setting
;1068 #define  ReflAtten        0x0010010AL  // U32: Reflected Attenuator setting
;1069 #define  CavAtten         0x0010010CL  // U32: Cavity Attenuator setting
;1070 
;1071 #define  PhaseSet         0x0010010EL  // P32: Phase setpoint
;1072 #define  AmplSet          0x00100110L  // F32: Ammplitude setpoint
;1073 
;1074 #define  TunePulseFreq    0x00100112L  // F32: Tuning Pulse Freq
;1075 #define  FreqSearchAmpl   0x00100114L  // F32: Freq Search Amplitude setpoi
;1076 
;1077 #define  RF_P             0x00100116L  // F32: RF P value
;1078 #define  RF_I             0x00100118L  // F32: RF I value
;1079 #define  RF_D             0x0010011AL  // F32: RF D value
;1080 
;1081 #define  Tuner_P          0x0010011CL  // F32: Tuner P value
;1082 #define  Tuner_I          0x0010011EL  // F32: Tuner I value
;1083 #define  Tuner_D          0x00100120L  // F32: Tuner D value
;1084 
;1085 #define  PulsedAmplSet    0x00100122L  // F32: Pulsed Amplitude setpoint
;1086 #define  PulsedPhaseSet   0x00100124L  // P32: Pulsed Phase setpoint
;1087 
;1088 #define  AFC_Freq0        0x00100126L  // F32: AFC cancellation frequency 0
;1089 #define  AFC_Freq1        0x00100128L  // F32: AFC cancellation frequency 1
;1090 #define  AFC_Freq2        0x0010012AL  // F32: AFC cancellation frequency 2
;1091 #define  AFC_Freq3        0x0010012CL  // F32: AFC cancellation frequency 3
;1092 #define  AFC_Freq4        0x0010012EL  // F32: AFC cancellation frequency 4
;1093 #define  AFC_Freq5        0x00100130L  // F32: AFC cancellation frequency 5
;1094 #define  AFC_Freq6        0x00100132L  // F32: AFC cancellation frequency 6
;1095 #define  AFC_Freq7        0x00100134L  // F32: AFC cancellation frequency 7
;1096 #define  AFC_Freq8        0x00100136L  // F32: AFC cancellation frequency 8
;1097 #define  AFC_Freq9        0x00100138L  // F32: AFC cancellation frequency 9
;1098 
;1099 #define  CTFTunerAmpl     0x0010013AL  // F32: Trans Func Tuner Amplitude
;1100 
;1101 #define  CavLowIlkLevel   0x0010013CL  // F32: Cavity Low Interlock Level
;1102 #define  CavLowIlkTime    0x0010013EL  // F32: Cavity Log Interlock Time
;1103 #define  DvDt_IlkRate     0x00100140L  // F32: -dV/dT Interlock Rate
;1104 #define  VV_IlkRatio      0x00100142L  // F32: V+/V- Interlock Ratio
;1105 
;1106 #define  FwdCavOffset     0x00100144L  // U32: Forward Cavity Offset
;1107 #define  FeedFwdPhase     0x00100146L  // P32: Feed Forward Phase
;1108 #define  FeedFwdGain      0x00100148L  // F32: Feed Fwd Gain
;1109 
;1110 #define  AFC_Phase0       0x00100150L  // P32: AFC cancellation phase 0
;1111 #define  AFC_Phase1       0x00100152L  // P32: AFC cancellation phase 1
;1112 #define  AFC_Phase2       0x00100154L  // P32: AFC cancellation phase 2
;1113 #define  AFC_Phase3       0x00100156L  // P32: AFC cancellation phase 3
;1114 #define  AFC_Phase4       0x00100158L  // P32: AFC cancellation phase 4
;1115 #define  AFC_Phase5       0x0010015AL  // P32: AFC cancellation phase 5
;1116 #define  AFC_Phase6       0x0010015CL  // P32: AFC cancellation phase 6
;1117 #define  AFC_Phase7       0x0010015EL  // P32: AFC cancellation phase 7
;1118 #define  AFC_Phase8       0x00100160L  // P32: AFC cancellation phase 8
;1119 #define  AFC_Phase9       0x00100162L  // P32: AFC cancellation phase 9
;1120 
;1121 
;1122 //===== Registers for ADRC =====
;1123 #define  OBW_Ampl         0x00100164L  // (RW) F32: Observer Bandwidth
;1124 #define  CBW_Ampl         0x00100166L  // (RW) F32: Controller Bandwidth
;1125 #define  P_Gain_Ampl      0x00100168L  // (RO) F32: Proportional Gain
;1126 #define  D_Gain_Ampl      0x0010016AL  // (RO) F32: Derivative Gain
;1127 #define  X1_Ampl          0x0010016CL  // (RO) F32: x1 state value (estimat
;1128 #define  X2_Ampl          0x0010016EL  // (RO) F32: x2 state value (estimat
;1129 #define  X3_Ampl          0x00100170L  // (RO) F32: x3 state value (estimat
;1130 
;1131 #define  OBW_Phase        0x00100172L  // (RW) F32: Observer Bandwidth
;1132 #define  CBW_Phase        0x00100174L  // (RW) F32: Controller Bandwidth
;1133 #define  P_Gain_Phase     0x00100176L  // (RO) F32: Proportional Gain
;1134 #define  D_Gain_Phase     0x00100178L  // (RO) F32: Derivative Gain
;1135 #define  X1_Phase         0x0010017AL  // (RO) F32: x1 state value (estimat
;1136 #define  X2_Phase         0x0010017CL  // (RO) F32: x2 state value (estimat
;1137 #define  X3_Phase         0x0010017EL  // (RO) F32: x3 state value (estimat
;1138 
;1139 #define  DSP_Smpl_Rate    0x00100180L  // (RO) F32: DSP sample reate (Hz)
;1140 #define  DSP_Smpl_Period  0x00100182L  // (RO) F32: DSP sample period (secs
;1141 
;1142 #define  Beta_Ampl        0x00100184L  // (RO) F32: beta
;1143 #define  LC1_Ampl         0x00100186L  // (RO) F32: LC1
;1144 #define  LC2_Ampl         0x00100188L  // (RO) F32: LC2
;1145 #define  LC3_Ampl         0x0010018AL  // (RO) F32: LC3
;1146 
;1147 #define  Beta_Phase       0x0010018CL  // (RO) F32: beta
;1148 #define  LC1_Phase        0x0010018EL  // (RO) F32: LC1
;1149 #define  LC2_Phase        0x00100190L  // (RO) F32: LC2
;1150 #define  LC3_Phase        0x00100192L  // (RO) F32: LC3
;1151 
;1152 #define  B_param_Ampl     0x00100194L  // (RW) F32: B parameter (ampl ctl)
;1153 #define  B_param_Phase    0x00100196L  // (RW) F32: B parameter (phase ctl)
;1154 
;1155 
;1156 //===== RFQ Tuner values, some of which are forwarded by the control =====
;1157 //===== system to other devices/records =====
;1158 #define  RFQ_ManTuneSet   0x00100198L  // (RW) F32: manual tuner setpoint
;1159 
;1160 #define  RFQ_T1_Offset    0x0010019AL  // (RW) F32: tuner 1 calib offset
;1161 #define  RFQ_T2_Offset    0x0010019CL  // (RW) F32: tuner 2 calib offset
;1162 
;1163 #define  RFQ_T1_Output    0x0010019EL  // (RO) F32: tuner 1 output
;1164 #define  RFQ_T2_Output    0x001001A0L  // (RO) F32: tuner 2 output
;1165 
;1166 #define  RFQ_T1_Feedback  0x001001A2L  // (RW) F32: tuner 1 feedback
;1167 #define  RFQ_T2_Feedback  0x001001A4L  // (RW) F32: tuner 2 feedback
;1168 
;1169 #define  Pulse_Ramp       0x001001ABL  // (RW) U32: Pulse Ramp (rate?)
;1170 
;1171 //===== More R/W registers =====
;1172 #define  FwdAmplGain      0x001001ADL  // (RW) F32: Forward Amplitude Gain
;1173 #define  CavAmplGain      0x001001AFL  // (RW) F32: Cavity Amplitude Gain
;1174 
;1175 #define  CavHighIlkLevel  0x001001B5L  // (RW) F32: Cavity High Interlock L
;1176 #define  FwdHighIlkLevel  0x001001B7L  // (RW) F32: Forward High Interlock 
;1177 
;1178 
;1179 //===== Special Registers =====
;1180 #define  SetDSPState      0x00100200L  // (WO) Bits: set/reset DSP state bi
;1181 
;1182 #define  PiezoTunerPos    0x00100202L  // (RW) U32: piezo tuner position
;1183 #define  StepperPos       0x00100204L  // (RW) U32: stepper position
;1184 
;1185 #define  SetAFCsOnOff     0x00100206L  // (WO) Bits: turn AFC frequencies o
;1186 
;1187 #define  Unused_208       0x00100208L  //
;1188 
;1189 #define  Rd_L_Buf         0x0010020AL  // (RO) I16x2: read next tuning plot
;1190 #define  Rd_T_Buf         0x0010020CL  // (RO) I16x2: read next tuning plot
;1191 
;1192 #define  Reserved_20E     0x0010020EL  //
;1193 #define  Reserved_210     0x00100210L  //
;1194 
;1195 #define  WrMemBlock       0x00100212L  // (WO) U32: start prog mode for a m
;1196 #define  WriteStatus      0x00100214L  // (RO) I32: (% done or -1 ==> busy)
;1197 
;1198 #define  CalcCTF          0x00100216L  // (**) N/A: begin calc of Cavity Tr
;1199 #define  PercentCTF       0x00100218L  // (RO) U32: percent done for CTF ca
;1200 #define  AbortCTF         0x0010021AL  // (**) N/A: abort CTF calc; == -1 i
;1201 #define  SizeCTF          0x0010021CL  // (RO) U32: # of 32-bit words int p
;1202 #define  PhaseCTF         0x0010021EL  // (RO) P32: read next Phase value f
;1203 #define  AmplCTF          0x00100220L  // (RO) F32: read next Ampl value fr
;1204 
;1205 #define  PercentFFT       0x00100222L  // (RO) U32: percent done for FFT ca
;1206 #define  SizeFFT          0x00100224L  // (RO) U32: # of 32-bit words of in
;1207 #define  AmplFFT          0x00100226L  // (RO) F32: read next Ampl value fr
;1208 
;1209 #define  CTFCalcRate      0x00100228L  // (RW) F32: CTF calc rate
;1210 
;1211 #define  FwdMagCalib      0x0010022AL  // (RW) F32: Forward Mag calib value
;1212 #define  FwdPhaseCalib    0x0010022CL  // (RW) P32: Forward Phase calib val
;1213 #define  ReflMagCalib     0x0010022EL  // (RW) F32: Reflected Mag calib val
;1214 #define  ReflPhaseCalib   0x00100230L  // (RW) P32: Reflected Phase calib v
;1215 #define  CavMagCalib      0x00100232L  // (RW) F32: Cavity Mag calib value
;1216 #define  CavPhaseCalib    0x00100234L  // (RW) P32: Cavity Phase calib valu
;1217 #define  OutMagCalib      0x00100236L  // (RW) F32: Output Mag calib value
;1218 #define  OutPhaseCalib    0x00100238L  // (RW) P32: Output Phase calib valu
;1219 
;1220 #define  SaveCalibToDSP   0x0010023AL  // (**) N/A: Save calib to DSP's ROM
;1221 
;1222 #define  ROMProgErrs      0x0010023CL  // (RO) U32: ROM programming errors
;1223 
;1224 
;1225 //  (**) means a READ from the register triggers the stated functionality
;1226 
;1227 
;1228 //=========================================================================
;1229 //  List of daemon processes.  The inetd process listens for connection
;1230 //  requests on each port in the list and creates a new instance of the
;1231 //  specified process to service each new connection.
;1232 //=========================================================================
;1233 #include <services.h>
;1234 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\services.h' 2 22 6 20 2 29
	.debug	I
;1235 //--- service funcs declared the same as standard command funcs:
;1236 //     e.g.:   void _task fastdatad(int argc, char **argv);
;1237 void _task tsh(int argc, char **argv);
;1238 
;1239 void _task readWave(int argc, char **argv);
;1240 
;1241 
;1242 ServiceInfo inetdConf[] = {
;1243 //--- add any application-specific inetd-type network services here ---
;1244 //--- (add port # names to services.h) ---
;1245 //  NAME          PORT           PROTOCOL  FUNC        PRI -1  Config Param
;1246 //  ------------  -------------  --------  ----------- --- --  ------------
;1247   { "readWave",   READ_WAVE,     ProtoTCP, readWave,   12, -1, NULL },
	.dseg
_inetdConf::
	.dw	@2
	.dw	0x7d4
	.db	0x2
	.dw	word _readWave
	.db	0xc
	.dw	0xffff
	.dw	0
	.ds	6,0
;1248 
;1249 //--- standard ones defined in sharedAppl.c ---
;1250 //{ "console",    TTY0,          ASYNC,    tsh,        10, -1, &consCfg },
;1251 //{ "fastdatad",  FASTDATA_PORT, ProtoTCP, fastdatad,   5, -1, NULL },
;1252 //{ "modbusTCPd", MODBUS_PORT,   ProtoTCP, modbusTCPd,  6, -1, NULL },
;1253 //{ "tsh",        TELNET_PORT,   ProtoTCP, tsh,        10, -1, NULL }
;1254 
;1255   #define SharedServices
;1256   #include <sharedAppl.c>
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.dw	@2+9
	.dw	0
	.db	0x3
	.dw	word _tsh
	.db	0xa
	.dw	0xffff
	.dw	word _consCfg
	.ds	6,0
	.dw	@2+17
	.dw	0x7d3
	.db	0x2
	.dw	word _fastdatad
	.db	0x5
	.dw	0xffff
	.dw	0
	.ds	6,0
	.dw	@2+27
	.dw	0x1f6
	.db	0x2
	.dw	word _modbusTCPd
	.db	0x6
	.dw	0xffff
	.dw	0
	.ds	6,0
	.dw	@2+38
	.dw	0x17
	.db	0x2
	.dw	word _tsh
	.db	0xa
	.dw	0xffff
	.dw	0
	.debug	I
;1257 };
	.ds	6,0
	.debug	G _inetdConf 54 0
;1258 
;1259 const int  NumServices = sizeof(inetdConf) / sizeof(ServiceInfo);
	.seg	CONST
_NumServices::
	.dw	0x5
	.debug	G _NumServices 6 0
;1260 
;1261 
;1262 //=========================================================================
;1263 //  Application-specific data structures and definitions
;1264 //=========================================================================
;1265 
;1266 // values that can be different between prev/cur or cur/next during process
;1267 
;1268 typedef struct {
;1269 //--- values updated in "cur" instance at start of each pass ---
;1270   ulong  digitalIn;       // state of digital inputs
;1271 
;1272 //--- values updated in "next" instance at start of each pass ---
;1273   ulong  digitalOut;      // state for digital outputs
;1274 } ApplState;
;1275 
;1276 
;1277 ApplState  prevState, curState, nextState;
;1278 
;1279 #define  Prev  prevState
;1280 #define  Cur   curState
;1281 #define  Next  nextState
;1282 
;1283 const uint ApplStateDataSize =  ( sizeof(ApplState)*3 + sizeof(setVal) );
_ApplStateDataSize::
	.dw	0x1c
	.debug	G _ApplStateDataSize 7 0
;1284 
;1285 
;1286 //--- values and flags set by the 1st stage of the control loop when ---
;1287 //--- interpreting the state of the inputs and processing the next ---
;1288 //--- event msg ---
;1289 
;1290 ulong  calcStartTimeCTF;
;1291 
;1292 
;1293 //=========================================================================
;1294 //  Defintions for variables that are accessable as ModBus registers
;1295 //=========================================================================
;1296 #else  // end of before-RegDefs portion
;1901 
;1902 #ifndef RegDefs // start of after-RegDefs portion
;1903 
;1904 
;1905 
;1906 //---- bit usage for older cmdBitsAppl register ---
;1907 #define OLDC_AMPL_OPEN_LOOP     0x00000001  // disable Amplitude PID loop
;1908 #define OLDC_AMPL_CLOSED_LOOP   0x00000002  // enable  Amplitude PID loop
;1909 #define OLDC_PHASE_OPEN_LOOP    0x00000004  // disable Phase PID loop
;1910 #define OLDC_PHASE_CLOSED_LOOP  0x00000008  // enable  Phase PID loop
;1911 #define OLDC_AMPL_TUNE_RUN      0x00000010  // run  Ampl  PID tuning pulse 
;1912 #define OLDC_AMPL_TUNE_STOP     0x00000020  // stop Ampl  PID tuning pulse 
;1913 #define OLDC_PHASE_TUNE_RUN     0x00000040  // run  Phase PID tuning pulse 
;1914 #define OLDC_PHASE_TUNE_STOP    0x00000080  // stop Phase PID tuning pulse 
;1915 #define OLDC_RF_ON              0x00000100  // Turn RF On
;1916 #define OLDC_RF_OFF             0x00000200  // Turn RF Off
;1917 #define OLDC_L_DATA_READ        0x00000400  // Leading edge data buffer rea
;1918 #define OLDC_T_DATA_READ        0x00000800  // Trailing edge data buffer re
;1919 #define OLDC_CAV_TUNER_ON       0x00001000  // Turn Cavity Tuner On
;1920 #define OLDC_CAV_TUNER_OFF      0x00002000  // Turn Cavity Tuner Off
;1921 #define OLDC_FFT_DATA_READ      0x00004000  // FFT data buffer read complet
;1922 
;1923 //---- bit usage for setDSPState (DSP 0x00100201) ---
;1924 #define  CMD_AMPL_PID_OFF       0x00000001  // disable Ampl PID loop
;1925 #define  CMD_AMPL_PID_ON        0x00000002  // enable  Ampl PID loop
;1926 #define  CMD_AMPL_PID_BITS      0x00000003L
;1927 
;1928 #define  CMD_PHASE_CTL_OFF      0x00000004  // disable Phase PID loop
;1929 #define  CMD_PHASE_CTL_PID      0x00000008  // enable  Phase PID/disable SE
;1930 #define  CMD_PHASE_CTL_SEL      0x00000010  // enable SEL/disable phase PID
;1931 #define  CMD_PHASE_CTL_AUTO     0x00000020  // auto SEL/phase PID control
;1932 #define  CMD_PHASE_CTL_BITS     0x0000003CL
;1933 
;1934 #define  CMD_RF_PULSING_ON      0x00000040  // run  Phase PID tuning pulse 
;1935 #define  CMD_RF_PULSING_OFF     0x00000080  // stop Phase PID tuning pulse 
;1936 #define  CMD_RF_PULSING_BITS    0x000000C0L
;1937 
;1938 #define  CMD_UNUSED_8           0x00000100  //
;1939 #define  CMD_UNUSED_9           0x00000200  //
;1940 
;1941 #define  CMD_L_DATA_READ        0x00000400  // Done reading Leading edge pl
;1942 #define  CMD_T_DATA_READ        0x00000800  // Done reading Trailing edge p
;1943 
;1944 #define  CMD_AFC_ON             0x00001000  // turn AFC On
;1945 #define  CMD_AFC_OFF            0x00002000  // turn AFC Off
;1946 #define  CMD_AFC_BITS           0x00003000L
;1947 
;1948 #define  CMD_FFT_DATA_READ      0x00004000  // Done reading FFT plot
;1949 #define  CMD_UNUSED_15          0x00008000  //
;1950 
;1951 #define  CMD_TUNER_PID_OFF      0x00010000L // disable tuner PID
;1952 #define  CMD_TUNER_PID_ON       0x00020000L // enable tuner PID
;1953 #define  CMD_TUNER_PID_BITS     0x00030000L
;1954 
;1955 #define  CMD_UNUSED_18          0x00040000L //
;1956 #define  CMD_UNUSED_19          0x00080000L //
;1957 
;1958 #define  CMD_UNUSED_20          0x00100000L //
;1959 #define  CMD_UNUSED_21          0x00200000L //
;1960 #define  CMD_UNUSED_22          0x00400000L //
;1961 #define  CMD_UNUSED_23          0x00800000L //
;1962 
;1963 #define  CMD_UNUSED_24          0x01000000L //
;1964 #define  CMD_UNUSED_25          0x02000000L //
;1965 #define  CMD_UNUSED_26          0x04000000L //
;1966 #define  CMD_UNUSED_27          0x08000000L //
;1967 
;1968 #define  CMD_UNUSED_28          0x10000000L //
;1969 #define  CMD_UNUSED_29          0x20000000L //
;1970 #define  CMD_UNUSED_30          0x40000000L //
;1971 #define  CMD_UNUSED_31          0x80000000L //
;1972 
;1973 //--- bit-masks to determine which groups have a bit set ---
;1974 const ulong SetDSPStateMasks[] = {
;1975   CMD_AMPL_PID_BITS,   // enable/disable Amplitude PID loop bits
_SetDSPStateMasks::
	.dw	0x3, 0
;1976   CMD_PHASE_CTL_BITS,  // Phase control mode bits
	.dw	0x3c, 0
;1977   CMD_RF_PULSING_BITS, // RF pulsing start/stop bits
	.dw	0xc0, 0
;1978   CMD_AFC_BITS,        // Turn AFC On/Off biuts
	.dw	0x3000, 0
;1979   CMD_TUNER_PID_BITS,  // enable/disable Tuner PID loop bits
	.dw	0, 0x3
;1980   0  //indicates end of list
;1981 };
	.dw	0, 0
	.debug	G _SetDSPStateMasks 56 0
;1982 
;1983 
;1984 
;1985 const char far *SetDSPStateDesc[32] = {
;1986   "Ampl-PID Off",         "Ampl-PID On",
	.dseg
_SetDSPStateDesc::
	.dw	word (phys @1+1944)
	.dw	phys @1+1944 >> 16
	.dw	word (phys @1+1957)
	.dw	phys @1+1957 >> 16
;1987 
;1988   "Phase-PID Off",        "Phase-PID On",
	.dw	word (phys @1+1969)
	.dw	phys @1+1969 >> 16
	.dw	word (phys @1+1983)
	.dw	phys @1+1983 >> 16
;1989   "SEL mode enabled",     "Auto Phase-PID/SEL mode",
	.dw	word (phys @1+1996)
	.dw	phys @1+1996 >> 16
	.dw	word (phys @1+2013)
	.dw	phys @1+2013 >> 16
;1990 
;1991   "RF Pulsing On",        "RF Pulsing Off",
	.dw	word (phys @1+2037)
	.dw	phys @1+2037 >> 16
	.dw	word (phys @1+2051)
	.dw	phys @1+2051 >> 16
;1992 
;1993   "",                     "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;1994   "",                     "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;1995 
;1996   "AFC/Cavity Tuner On",  "AFC/Cavity Tuner Off",
	.dw	word (phys @1+2066)
	.dw	phys @1+2066 >> 16
	.dw	word (phys @1+2086)
	.dw	phys @1+2086 >> 16
;1997 
;1998   "",                     "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;1999 
;2000   "Tuner-PID Off",        "Tuner-PID On",
	.dw	word (phys @1+2107)
	.dw	phys @1+2107 >> 16
	.dw	word (phys @1+2121)
	.dw	phys @1+2121 >> 16
;2001 
;2002   "",                     "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2003   "",                     "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2004   "",                     "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2005   "",                     "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2006   "",                     "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2007   "",                     "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2008   "",                     ""
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2009 };
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.debug	G _SetDSPStateDesc 57 0
;2010 
;2011 //---- bit usage for setAFCsOnOff --- (DSP 0x0207)
;2012 #define  CMD_AFC_0_ON           0x00000001L  // Turn On  AFC freq 0
;2013 #define  CMD_AFC_0_OFF          0x00000002L  // Turn Off AFC freq 0
;2014 #define  CMD_AFC_1_ON           0x00000004L  // Turn On  AFC freq 1
;2015 #define  CMD_AFC_1_OFF          0x00000008L  // Turn Off AFC freq 1
;2016 #define  CMD_AFC_2_ON           0x00000010L  // Turn On  AFC freq 2
;2017 #define  CMD_AFC_2_OFF          0x00000020L  // Turn Off AFC freq 2
;2018 #define  CMD_AFC_3_ON           0x00000040L  // Turn On  AFC freq 3
;2019 #define  CMD_AFC_3_OFF          0x00000080L  // Turn Off AFC freq 3
;2020 #define  CMD_AFC_4_ON           0x00000100L  // Turn On  AFC freq 4
;2021 #define  CMD_AFC_4_OFF          0x00000200L  // Turn Off AFC freq 4
;2022 #define  CMD_AFC_5_ON           0x00000400L  // Turn On  AFC freq 5
;2023 #define  CMD_AFC_5_OFF          0x00000800L  // Turn Off AFC freq 5
;2024 #define  CMD_AFC_6_ON           0x00001000L  // Turn On  AFC freq 6
;2025 #define  CMD_AFC_6_OFF          0x00002000L  // Turn Off AFC freq 6
;2026 #define  CMD_AFC_7_ON           0x00004000L  // Turn On  AFC freq 7
;2027 #define  CMD_AFC_7_OFF          0x00008000L  // Turn Off AFC freq 7
;2028 #define  CMD_AFC_8_ON           0x00010000L  // Turn On  AFC freq 8
;2029 #define  CMD_AFC_8_OFF          0x00020000L  // Turn Off AFC freq 8
;2030 #define  CMD_AFC_9_ON           0x00040000L  // Turn On  AFC freq 9
;2031 #define  CMD_AFC_9_OFF          0x00080000L  // Turn Off AFC freq 9
;2032 
;2033 const char far *SetAFCsOnOffDesc[] = {
;2034   "AFC_0 On",  "AFC_0 Off",
_SetAFCsOnOffDesc::
	.dw	word (phys @1+2134)
	.dw	phys @1+2134 >> 16
	.dw	word (phys @1+2143)
	.dw	phys @1+2143 >> 16
;2035   "AFC_1 On",  "AFC_1 Off",
	.dw	word (phys @1+2153)
	.dw	phys @1+2153 >> 16
	.dw	word (phys @1+2162)
	.dw	phys @1+2162 >> 16
;2036   "AFC_2 On",  "AFC_2 Off",
	.dw	word (phys @1+2172)
	.dw	phys @1+2172 >> 16
	.dw	word (phys @1+2181)
	.dw	phys @1+2181 >> 16
;2037   "AFC_3 On",  "AFC_3 Off",
	.dw	word (phys @1+2191)
	.dw	phys @1+2191 >> 16
	.dw	word (phys @1+2200)
	.dw	phys @1+2200 >> 16
;2038   "AFC_4 On",  "AFC_4 Off",
	.dw	word (phys @1+2210)
	.dw	phys @1+2210 >> 16
	.dw	word (phys @1+2219)
	.dw	phys @1+2219 >> 16
;2039   "AFC_5 On",  "AFC_5 Off",
	.dw	word (phys @1+2229)
	.dw	phys @1+2229 >> 16
	.dw	word (phys @1+2238)
	.dw	phys @1+2238 >> 16
;2040   "AFC_6 On",  "AFC_6 Off",
	.dw	word (phys @1+2248)
	.dw	phys @1+2248 >> 16
	.dw	word (phys @1+2257)
	.dw	phys @1+2257 >> 16
;2041   "AFC_7 On",  "AFC_7 Off",
	.dw	word (phys @1+2267)
	.dw	phys @1+2267 >> 16
	.dw	word (phys @1+2276)
	.dw	phys @1+2276 >> 16
;2042   "AFC_8 On",  "AFC_8 Off",
	.dw	word (phys @1+2286)
	.dw	phys @1+2286 >> 16
	.dw	word (phys @1+2295)
	.dw	phys @1+2295 >> 16
;2043   "AFC_9 On",  "AFC_9 Off",
	.dw	word (phys @1+2305)
	.dw	phys @1+2305 >> 16
	.dw	word (phys @1+2314)
	.dw	phys @1+2314 >> 16
;2044   "",          "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2045   "",          "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2046   "",          "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2047   "",          "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2048   "",          "",
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2049   "",          ""
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
;2050 };
	.dw	word (phys @1+9)
	.dw	phys @1+9 >> 16
	.debug	G _SetAFCsOnOffDesc 57 0
;2051 
;2052 
;2053 //---- bit usage for cmdBitsAppl3 ---
;2054 #define  CMD_RESET_DSP          0x0001  // Reset the DSP
;2055 #define  CMD_CALC_CTF           0x0002  // begin CTF calculation
;2056 
;2057 
;2058 
;2059 //--- parameter ID's for data in PhaseCtlr Device Data file ---
;2060 //-------------------------------------------------------------------------
;2061 // WARNING:  ID's can be added, but existing ID's (and the format of the
;2062 //           data the represent) should NEVER change!  NOTE:  Existing ones
;2063 //           can be "eliminated" by changing their name and no longer
;2064 //           using them, but never REUSE an old one for something new!!!
;2065 //-------------------------------------------------------------------------
;2066 //  NOTE:  ID's >= 1000 are rsvd for values shared by most applications
;2067 //-------------------------------------------------------------------------
;2068 const ParamData far  devDataParams[] = {
;2069 //                ID   ---value---  --RESTORE_FUNC--
;2070 //  PERSISTENT_VAR(  1,  pidParams,      NULL ),
;2071 //  PERSISTENT_VAR(  2,  afcParams,      NULL ),
;2072 //  PERSISTENT_VAR(  3,  devSettings,    NULL ), // ID for older vers of st
;2073 //  PERSISTENT_VAR(  4,  warmUpParams,   NULL ),
;2074 
;2075   PERSISTENT_VAR(  5,  pllInitIdx,     NULL ),
	.seg	FARCONST
_devDataParams::
	.dw	0x5
	.dw	0x2
	.dw	0
	.dl	phys _pllInitIdx
	.dl	phys @1+1024
	.dw	0
;2076 
;2077 //  PERSISTENT_VAR(  6,  devSettings,    NULL ),
;2078 
;2079   PERSISTENT_VAR( 7,  trigPos,         NULL ),
	.dw	0x7
	.dw	0x2
	.dw	0
	.dl	phys _trigPos
	.dl	phys @1+732
	.dw	0
;2080 
;2081   PERSISTENT_VAR( 8,  warmLevel,       NULL ),
	.dw	0x8
	.dw	0x4
	.dw	0
	.dl	phys _warmLevel
	.dl	phys @1+976
	.dw	0
;2082   PERSISTENT_VAR( 9,  warmMS,          NULL ),
	.dw	0x9
	.dw	0x2
	.dw	0
	.dl	phys _warmMS
	.dl	phys @1+986
	.dw	0
;2083   PERSISTENT_VAR( 10, rampMS,          NULL ),
	.dw	0xa
	.dw	0x2
	.dw	0
	.dl	phys _rampMS
	.dl	phys @1+993
	.dw	0
;2084 
;2085   PERSISTENT_VAR( 11, fwdAtten,        NULL ),
	.dw	0xb
	.dw	0x2
	.dw	0
	.dl	phys _fwdAtten
	.dl	phys @1+1167
	.dw	0
;2086   PERSISTENT_VAR( 12, reflAtten,       NULL ),
	.dw	0xc
	.dw	0x2
	.dw	0
	.dl	phys _reflAtten
	.dl	phys @1+1176
	.dw	0
;2087   PERSISTENT_VAR( 13, cavAtten,        NULL ),
	.dw	0xd
	.dw	0x2
	.dw	0
	.dl	phys _cavAtten
	.dl	phys @1+1186
	.dw	0
;2088 
;2089 //  PERSISTENT_VAR( 14, phaseSet,        NULL ),  // moved to settings
;2090 //  PERSISTENT_VAR( 15, amplSet,         NULL ),  // moved to settings
;2091 //  PERSISTENT_VAR( 16, oldPulseFreq,    NULL ),  // replaced by float valu
;2092 
;2093   PERSISTENT_VAR( 17, freqSearchAmpl,  NULL ),
	.dw	0x11
	.dw	0x4
	.dw	0
	.dl	phys _freqSearchAmpl
	.dl	phys @1+1195
	.dw	0
;2094 
;2095   PERSISTENT_VAR( 18, rf_P,            NULL ),
	.dw	0x12
	.dw	0x4
	.dw	0
	.dl	phys _rf_P
	.dl	phys @1+783
	.dw	0
;2096   PERSISTENT_VAR( 19, rf_I,            NULL ),
	.dw	0x13
	.dw	0x4
	.dw	0
	.dl	phys _rf_I
	.dl	phys @1+788
	.dw	0
;2097   PERSISTENT_VAR( 20, rf_D,            NULL ),
	.dw	0x14
	.dw	0x4
	.dw	0
	.dl	phys _rf_D
	.dl	phys @1+793
	.dw	0
;2098 
;2099   PERSISTENT_VAR( 21, tuner_P,         NULL ),
	.dw	0x15
	.dw	0x4
	.dw	0
	.dl	phys _tuner_P
	.dl	phys @1+823
	.dw	0
;2100   PERSISTENT_VAR( 22, tuner_I,         NULL ),
	.dw	0x16
	.dw	0x4
	.dw	0
	.dl	phys _tuner_I
	.dl	phys @1+831
	.dw	0
;2101   PERSISTENT_VAR( 23, tuner_D,         NULL ),
	.dw	0x17
	.dw	0x4
	.dw	0
	.dl	phys _tuner_D
	.dl	phys @1+839
	.dw	0
;2102 
;2103   PERSISTENT_VAR( 24, pulsedAmplSet,   NULL ),
	.dw	0x18
	.dw	0x4
	.dw	0
	.dl	phys _pulsedAmplSet
	.dl	phys @1+809
	.dw	0
;2104   PERSISTENT_VAR( 25, pulsedPhaseSet,  NULL ),
	.dw	0x19
	.dw	0x4
	.dw	0
	.dl	phys _pulsedPhaseSet
	.dl	phys @1+858
	.dw	0
;2105 
;2106 //  PERSISTENT_VAR( 26, afcFreq0,       <write-once-reg-func> ),
;2107 //  PERSISTENT_VAR( 27, afcFreq1,       <write-once-reg-func> ),
;2108 //  PERSISTENT_VAR( 28, afcFreq2,       <write-once-reg-func> ),
;2109 //  PERSISTENT_VAR( 29, afcFreq3,       <write-once-reg-func> ),
;2110 //  PERSISTENT_VAR( 30, afcFreq4,       <write-once-reg-func> ),
;2111 //  PERSISTENT_VAR( 31, afcFreq5,       <write-once-reg-func> ),
;2112 //  PERSISTENT_VAR( 32, afcFreq6,       <write-once-reg-func> ),
;2113 //  PERSISTENT_VAR( 33, afcFreq7,       <write-once-reg-func> ),
;2114 //  PERSISTENT_VAR( 34, afcFreq8,       <write-once-reg-func> ),
;2115 //  PERSISTENT_VAR( 35, afcFreq9,       <write-once-reg-func> ),
;2116 
;2117   PERSISTENT_VAR( 36, cavLowIlkLevel,  NULL ),
	.dw	0x24
	.dw	0x4
	.dw	0
	.dl	phys _cavLowIlkLevel
	.dl	phys @1+1210
	.dw	0
;2118   PERSISTENT_VAR( 37, cavLowIlkTime,   NULL ),
	.dw	0x25
	.dw	0x4
	.dw	0
	.dl	phys _cavLowIlkTime
	.dl	phys @1+1225
	.dw	0
;2119   PERSISTENT_VAR( 38, dvdt_IlkRate,    NULL ),
	.dw	0x26
	.dw	0x4
	.dw	0
	.dl	phys _dvdt_IlkRate
	.dl	phys @1+1239
	.dw	0
;2120   PERSISTENT_VAR( 39, vv_IlkRatio,     NULL ),
	.dw	0x27
	.dw	0x4
	.dw	0
	.dl	phys _vv_IlkRatio
	.dl	phys @1+1252
	.dw	0
;2121 
;2122   PERSISTENT_VAR( 40, fwdCavOffset,    NULL ),
	.dw	0x28
	.dw	0x4
	.dw	0
	.dl	phys _fwdCavOffset
	.dl	phys @1+1264
	.dw	0
;2123   PERSISTENT_VAR( 41, feedFwdPhase,    NULL ),
	.dw	0x29
	.dw	0x4
	.dw	0
	.dl	phys _feedFwdPhase
	.dl	phys @1+1277
	.dw	0
;2124   PERSISTENT_VAR( 42, feedFwdGain,     NULL ),
	.dw	0x2a
	.dw	0x4
	.dw	0
	.dl	phys _feedFwdGain
	.dl	phys @1+1290
	.dw	0
;2125 
;2126   PERSISTENT_VAR( 43, ctfCalcRate,     NULL ),
	.dw	0x2b
	.dw	0x4
	.dw	0
	.dl	phys _ctfCalcRate
	.dl	phys @1+1302
	.dw	0
;2127 
;2128 //  PERSISTENT_VAR( 44, fwdMagCalib,     NULL ),  // not "single instance" 
;2129 //  PERSISTENT_VAR( 45, fwdPhaseCalib,   NULL ),
;2130 //  PERSISTENT_VAR( 46, reflMagCalib,    NULL ),
;2131 //  PERSISTENT_VAR( 47, reflPhaseCalib,  NULL ),
;2132 //  PERSISTENT_VAR( 48, cavMagCalib,     NULL ),
;2133 //  PERSISTENT_VAR( 49, cavPhaseCalib,   NULL ),
;2134 //  PERSISTENT_VAR( 50, outMagCalib,     NULL ),
;2135 //  PERSISTENT_VAR( 51, outPhaseCalib,   NULL ),
;2136 
;2137   PERSISTENT_VAR( 52, ctfTunerAmpl,    NULL ),
	.dw	0x34
	.dw	0x4
	.dw	0
	.dl	phys _ctfTunerAmpl
	.dl	phys @1+1420
	.dw	0
;2138 
;2139   PERSISTENT_VAR( 53, fwdAmplGain,     NULL ),
	.dw	0x35
	.dw	0x4
	.dw	0
	.dl	phys _fwdAmplGain
	.dl	phys @1+1445
	.dw	0
;2140   PERSISTENT_VAR( 54, fwdAmplOffset,   NULL ),
	.dw	0x36
	.dw	0x4
	.dw	0
	.dl	phys _fwdAmplOffset
	.dl	phys @1+1457
	.dw	0
;2141   PERSISTENT_VAR( 55, fwdPhaseGain,    NULL ),
	.dw	0x37
	.dw	0x4
	.dw	0
	.dl	phys _fwdPhaseGain
	.dl	phys @1+1471
	.dw	0
;2142   PERSISTENT_VAR( 56, fwdPhaseOffset,  NULL ),
	.dw	0x38
	.dw	0x4
	.dw	0
	.dl	phys _fwdPhaseOffset
	.dl	phys @1+1484
	.dw	0
;2143 
;2144   PERSISTENT_VAR( 57, reflAmplGain,    NULL ),
	.dw	0x39
	.dw	0x4
	.dw	0
	.dl	phys _reflAmplGain
	.dl	phys @1+1499
	.dw	0
;2145   PERSISTENT_VAR( 58, reflAmplOffset,  NULL ),
	.dw	0x3a
	.dw	0x4
	.dw	0
	.dl	phys _reflAmplOffset
	.dl	phys @1+1512
	.dw	0
;2146   PERSISTENT_VAR( 59, reflPhaseGain,   NULL ),
	.dw	0x3b
	.dw	0x4
	.dw	0
	.dl	phys _reflPhaseGain
	.dl	phys @1+1527
	.dw	0
;2147   PERSISTENT_VAR( 60, reflPhaseOffset, NULL ),
	.dw	0x3c
	.dw	0x4
	.dw	0
	.dl	phys _reflPhaseOffset
	.dl	phys @1+1541
	.dw	0
;2148 
;2149   PERSISTENT_VAR( 61, cavAmplGain,     NULL ),
	.dw	0x3d
	.dw	0x4
	.dw	0
	.dl	phys _cavAmplGain
	.dl	phys @1+1557
	.dw	0
;2150   PERSISTENT_VAR( 62, cavAmplOffset,   NULL ),
	.dw	0x3e
	.dw	0x4
	.dw	0
	.dl	phys _cavAmplOffset
	.dl	phys @1+1569
	.dw	0
;2151   PERSISTENT_VAR( 63, cavPhaseGain,    NULL ),
	.dw	0x3f
	.dw	0x4
	.dw	0
	.dl	phys _cavPhaseGain
	.dl	phys @1+1583
	.dw	0
;2152   PERSISTENT_VAR( 64, cavPhaseOffset,  NULL ),
	.dw	0x40
	.dw	0x4
	.dw	0
	.dl	phys _cavPhaseOffset
	.dl	phys @1+1596
	.dw	0
;2153 
;2154   PERSISTENT_VAR( 65, refAmplGain,     NULL ),
	.dw	0x41
	.dw	0x4
	.dw	0
	.dl	phys _refAmplGain
	.dl	phys @1+1611
	.dw	0
;2155   PERSISTENT_VAR( 66, refAmplOffset,   NULL ),
	.dw	0x42
	.dw	0x4
	.dw	0
	.dl	phys _refAmplOffset
	.dl	phys @1+1623
	.dw	0
;2156   PERSISTENT_VAR( 67, refPhaseGain,    NULL ),
	.dw	0x43
	.dw	0x4
	.dw	0
	.dl	phys _refPhaseGain
	.dl	phys @1+1637
	.dw	0
;2157   PERSISTENT_VAR( 68, refPhaseOffset,  NULL ),
	.dw	0x44
	.dw	0x4
	.dw	0
	.dl	phys _refPhaseOffset
	.dl	phys @1+1650
	.dw	0
;2158 
;2159   PERSISTENT_VAR( 69, pulseFreq,       NULL ),
	.dw	0x45
	.dw	0x4
	.dw	0
	.dl	phys _pulseFreq
	.dl	phys @1+1665
	.dw	0
;2160 
;2161   PERSISTENT_VAR( 70, maxAmplSet,      NULL ),
	.dw	0x46
	.dw	0x4
	.dw	0
	.dl	phys _maxAmplSet
	.dl	phys @1+1775
	.dw	0
;2162 
;2163   PERSISTENT_VAR( 71, rfq_t1_offset,   NULL ),
	.dw	0x47
	.dw	0x4
	.dw	0
	.dl	phys _rfq_t1_offset
	.dl	phys @1+1801
	.dw	0
;2164   PERSISTENT_VAR( 72, rfq_t2_offset,   NULL ),
	.dw	0x48
	.dw	0x4
	.dw	0
	.dl	phys _rfq_t2_offset
	.dl	phys @1+1815
	.dw	0
;2165 
;2166   PERSISTENT_VAR( 73, pulse_ramp,      NULL ),
	.dw	0x49
	.dw	0x4
	.dw	0
	.dl	phys _pulse_ramp
	.dl	phys @1+1829
	.dw	0
;2167 
;2168   PERSISTENT_VAR( 74, cavHighIlkLevel, NULL ),
	.dw	0x4a
	.dw	0x4
	.dw	0
	.dl	phys _cavHighIlkLevel
	.dl	phys @1+1854
	.dw	0
;2169   PERSISTENT_VAR( 75, fwdHighIlkLevel, NULL ),
	.dw	0x4b
	.dw	0x4
	.dw	0
	.dl	phys _fwdHighIlkLevel
	.dl	phys @1+1870
	.dw	0
;2170 
;2171 
;2172   #define SharedDevParams
;2173   #include <sharedAppl.c>
;2174 
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.dw	0x3ec
	.dw	0x2
	.dw	0
	.dl	phys _timeZone
	.dl	phys @1+2324
	.dw	0
	.dw	0x3ed
	.dw	0x4
	.dw	0
	.dl	phys _srfsIPAddr
	.dl	phys @1+2333
	.dw	0
	.dw	0x3e8
	.dw	0x18
	.dw	0x18
	.dl	phys _ainLabel
	.dl	phys @1+2344
	.dw	0
	.dw	0x3e9
	.dw	0x18
	.dw	0x18
	.dl	phys _aoutLabel
	.dl	phys @1+2353
	.dw	0
	.dw	0x3ea
	.dw	0x150
	.dw	0x18
	.dl	phys _dinLabel
	.dl	phys @1+2363
	.dw	0
	.dw	0x3eb
	.dw	0x240
	.dw	0x18
	.dl	phys _doutLabel
	.dl	phys @1+2372
	.dw	0
	.dw	0x3ee
	.dw	0x4
	.dw	0
	.dl	phys _readGain
	.dl	phys @1+2382
	.dw	0
	.dw	0x3ef
	.dw	0x4
	.dw	0
	.dl	phys _readOffset
	.dl	phys @1+2391
	.dw	0
	.dw	0x3f0
	.dw	0x4
	.dw	0
	.dl	phys _setGain
	.dl	phys @1+2402
	.dw	0
	.dw	0x3f1
	.dw	0x4
	.dw	0
	.dl	phys _setOffset
	.dl	phys @1+2410
	.dw	word _ReadSetCalibsRestore
	.dw	0x3f2
	.dw	0x20
	.dw	0
	.dl	phys _hostName
	.dl	phys @1+2420
	.dw	word _hostNameRestore
	.dw	0x3f3
	.dw	0x4
	.dw	0
	.dl	phys _srfsAltAddr
	.dl	phys @1+2429
	.dw	0
	.dw	0x3f4
	.dw	0x300
	.dw	0x18
	.dl	phys _extraInLabel
	.dl	phys @1+2441
	.dw	0
	.dw	0x3f5
	.dw	0x4
	.dw	0
	.dl	phys _netmask
	.dl	phys @1+653
	.dw	0
	.dw	0x3f6
	.dw	0x4
	.dw	0
	.dl	phys _gateway
	.dl	phys @1+661
	.dw	0
	.debug	I
;2175   END_PARAM_DATA
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;2176 
	.ds	2,0
	.debug	G _devDataParams 58 8
;2177 
;2178 //----------------------------------------------------
;2179 
;2180 //RESTORE_FUNC(xxxSet);
;2181 
;2182 const ParamData far  settingsParams[] = {
;2183 //APPLDATA
;2184 //                ID   ---value---  --RESTORE_FUNC--
;2185 //  PERSISTENT_VAR(  1,  xxxSet,     PVRF(xxxSet) ),
;2186   PERSISTENT_VAR(  1,  piezoSetPos,    NULL ),
_settingsParams::
	.dw	0x1
	.dw	0x2
	.dw	0
	.dl	phys _piezoSetPos
	.dl	phys @1+1142
	.dw	0
;2187 //  PERSISTENT_VAR(  2,  stepperSetPos,  NULL ),  // older S16 value
;2188   PERSISTENT_VAR(  3,  phaseSet,       NULL ),
	.dw	0x3
	.dw	0x4
	.dw	0
	.dl	phys _phaseSet
	.dl	phys @1+753
	.dw	0
;2189   PERSISTENT_VAR(  4,  amplSet,        NULL ),
	.dw	0x4
	.dw	0x4
	.dw	0
	.dl	phys _amplSet
	.dl	phys @1+762
	.dw	0
;2190   PERSISTENT_VAR(  5,  setDSPState,    NULL ),
	.dw	0x5
	.dw	0x4
	.dw	0
	.dl	phys _setDSPState
	.dl	phys @1+1433
	.dw	0
;2191   PERSISTENT_VAR(  6,  stepperSetPos,  NULL ),
	.dw	0x6
	.dw	0x4
	.dw	0
	.dl	phys _stepperSetPos
	.dl	phys @1+1840
	.dw	0
;2192 
;2193   END_PARAM_DATA
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;2194 
	.ds	2,0
	.debug	G _settingsParams 60 8
;2195 
;2196 
;2197 //-----------------------------------------------------------------
;2198 //  Application-specific values needed to restore the state of the
;2199 //  controller following a "soft" reset (i.e. a restart without a
;2200 //  CPU reset)
;2201 //-----------------------------------------------------------------
;2202 const ParamData far  ctlrStateParams[] = {
;2203 // sample values from sharedAppl.c, common to all applications
;2204 //                   --ID--  ---value,granularity---  --RESTORE_FUNC--
;2205 //    PERSISTENT_VARx(  1000,  prevState,               NULL ),
;2206 //    PERSISTENT_VARx(  1001,  curState,                NULL ),
;2207 //    PERSISTENT_VARx(  1002,  nextState,               NULL ),
;2208 //    PERSISTENT_TBL (  1003,  setVal,4,                NULL ),
;2209 // // PERSISTENT_TBL (  1004,  shadowRegValues,4,       NULL ),
;2210 
;2211 //APPLDATA
;2212 //    PERSISTENT_VAR(  1,  myApplStateVar,        NULL ),
;2213 
;2214 
;2215   #define SharedCtlrStateParams
;2216   #include <sharedAppl.c>
;2217 
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.debug	I
;2218   END_PARAM_DATA
_ctlrStateParams::
	.dw	0
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0, 0
;2219 
	.ds	2,0
	.debug	G _ctlrStateParams 61 8
;2220 
;2221 
;2222 //-------------------------------------------------------------------------
;2223 //  A list of parameterized "persistent" data.  Backup copies of such value
;2224 //  are stored in files and restored on startup.
;2225 //-------------------------------------------------------------------------
;2226 
;2227 //    Base File Name    Category  ParamData
;2228 //    ----------------  --------  ---------
;2229 //--- add any application-specific parameterized file defs here ---
;2230 //const ParamFile far  myAppCfgFile =
;2231 //  { "myFileName",     PDC_CTLR, myCfgParams,   0 };
;2232 
;2233 ParamFile  settingsFile =
;2234     { "settings",       PDC_SET,  settingsParams  };
	.dseg
_settingsFile::
	.dw	@2+42
	.db	0x4
	.dl	phys _settingsParams
	.ds	42,0
	.debug	G _settingsFile 62 0
;2235 
;2236 
;2237 #define SharedParams
;2238 #include <sharedAppl.c>
;2239 
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_devDataFile::
	.dw	@2+51
	.db	0x3
	.dl	phys _devDataParams
	.dw	0
	.ds	30,0
	.ds	10,0
	.debug	G _devDataFile 62 0
_hdwCfgFile::
	.dw	@2+59
	.db	0x1
	.dl	phys _hdwCfgParams
	.dw	0
	.ds	30,0
	.ds	10,0
	.debug	G _hdwCfgFile 62 0
	.debug	I
;2240 
;2241 ParamFile *paramFiles[] = {
;2242   #define SharedParamsList
;2243   #include <sharedAppl.c>
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
_paramFiles::
	.dw	word _hdwCfgFile
	.dw	word _devDataFile
	.debug	I
;2244 //--- add any application-specific ParamData references here ---
;2245 //  &myAppCfgFile
;2246   &settingsFile
;2247 };
	.dw	word _settingsFile
	.debug	G _paramFiles 63 0
;2248 
;2249 const int NumParamFiles = sizeof(paramFiles) / sizeof(paramFiles[0]);
	.seg	CONST
_NumParamFiles::
	.dw	0x3
	.debug	G _NumParamFiles 6 0
;2250 
;2251 //=========================================================================
;2252 //  Data structures for managing communication with the DSP and for keeping
;2253 //  ModBus register values in sync with the corresponding DSP registers.
;2254 //=========================================================================
;2255 
;2256 typedef struct {
;2257   ulong    id;         // DSP "address"
;2258   uchar    type;       // int32, float, bits, ...
;2259   RegInfo *mbReg;      // corresponding Modbus register
;2260   float   *gain;       // ptr to gain value or NULL
;2261   float   *offset;     // ptr to offset value or NULL
;2262   ulong    typical;    // for testing on other hdw
;2263   uint     percNoise;  // max noise as percentage of typical value
;2264 } RD_DSP_REG;
;2265 
;2266 typedef struct {
;2267   ulong    id;         // reg # in DSP to write value to (if applicable)
;2268   uchar    type;       // int32, float, bits, ...
;2269   RegInfo *mbReg;      // Modbus register info
;2270   float    minVal;     // minimum value allowed
;2271   float    maxVal;     // maximum value allowed
;2272   uchar    writeMode;  // how to handle writes
;2273   float   *gain;       // ptr to gain value or NULL
;2274   float   *offset;     // ptr to offset value or NULL
;2275 } WR_DSP_REG;
;2276 
;2277 float  ilkRatioGain, ilkRatioOffset, maxOutAmplGain, maxOutAmplOffset;
;2278 
;2279 
;2280 //--- values for WR_DSP_REG.writeMode ---
;2281 #define  WM_ONCE    0  // write new value only once at time it was received
;2282 #define  WM_EVERY   1  // write cur value every pass
;2283 
;2284 //--- values for RD_DSP_REG.type and WR_DSP_REG.type ---
;2285 #define  RT_BITS   DT_U32
;2286 #define  RT_S32    DT_S32
;2287 #define  RT_U32    DT_U32
;2288 #define  RT_F32    DT_F32
;2289 #define  RT_PHASE  99
;2290 
;2291 
;2292 
;2293 #define  DSP_RD( dspName, dspType, mbReg, gain, offset, typ, noise )  
;2294     { dspName, RT_##dspType, &mbReg##_RegInfo, gain, offset, typ, noise }
;2295 
;2296 
;2297 const RD_DSP_REG far rdDSPregs[] = {
;2298   //      DSP Reg ID      DSP fmt ModBus Reg      Gain            Offset
;2299   //      --------------  ------- --------------  --------------  ---------
;2300   DSP_RD( FwdPhase,       PHASE,  fwdPhase,       &fwdPhaseGain,  &fwdPhase
	.seg	FARCONST
_rdDSPregs::
	.dw	0, 0x10
	.db	0x63
	.dw	word _fwdPhase_RegInfo
	.dw	word _fwdPhaseGain
	.dw	word _fwdPhaseOffset
	.dw	0xffffd9e6, 0x8230
	.dw	0x5
;2301   DSP_RD( ReflPhase,      PHASE,  reflPhase,      &reflPhaseGain, &reflPhas
	.dw	0x2, 0x10
	.db	0x63
	.dw	word _reflPhase_RegInfo
	.dw	word _reflPhaseGain
	.dw	word _reflPhaseOffset
	.dw	0xffff88e8, 0xe642
	.dw	0x5
;2302   DSP_RD( CavPhase,       PHASE,  cavPhase,       &cavPhaseGain,  &cavPhase
	.dw	0x4, 0x10
	.db	0x63
	.dw	word _cavPhase_RegInfo
	.dw	word _cavPhaseGain
	.dw	word _cavPhaseOffset
	.dw	0xffffa22c, 0xda93
	.dw	0x5
;2303   DSP_RD( RefPhase,       PHASE,  refPhase,       &refPhaseGain,  &refPhase
	.dw	0x6, 0x10
	.db	0x63
	.dw	word _refPhase_RegInfo
	.dw	word _refPhaseGain
	.dw	word _refPhaseOffset
	.dw	0xffff809c, 0xebf0
	.dw	0x5
;2304 
;2305   DSP_RD( FwdAmpl,        F32,    fwdAmpl,        &fwdAmplGain,   &fwdAmplO
	.dw	0x8, 0x10
	.db	0x4
	.dw	word _fwdAmpl_RegInfo
	.dw	word _fwdAmplGain
	.dw	word _fwdAmplOffset
	.dw	0xba5, 0x3f8d
	.dw	0x5
;2306   DSP_RD( ReflAmpl,       F32,    reflAmpl,       &reflAmplGain,  &reflAmpl
	.dw	0xa, 0x10
	.db	0x4
	.dw	word _reflAmpl_RegInfo
	.dw	word _reflAmplGain
	.dw	word _reflAmplOffset
	.dw	0x6060, 0x3e60
	.dw	0x5
;2307   DSP_RD( CavAmpl,        F32,    cavAmpl,        &cavAmplGain,   &cavAmplO
	.dw	0xc, 0x10
	.db	0x4
	.dw	word _cavAmpl_RegInfo
	.dw	word _cavAmplGain
	.dw	word _cavAmplOffset
	.dw	0xffffa76b, 0x4013
	.dw	0x5
;2308   DSP_RD( RefAmpl,        F32,    refAmpl,        &refAmplGain,   &refAmplO
	.dw	0xe, 0x10
	.db	0x4
	.dw	word _refAmpl_RegInfo
	.dw	word _refAmplGain
	.dw	word _refAmplOffset
	.dw	0xfffffe6e, 0x3ee4
	.dw	0x5
;2309 
;2310   DSP_RD( MaxFwdAmpl,     F32,    maxFwdAmpl,     &fwdAmplGain,   &fwdAmplO
	.dw	0x10, 0x10
	.db	0x4
	.dw	word _maxFwdAmpl_RegInfo
	.dw	word _fwdAmplGain
	.dw	word _fwdAmplOffset
	.dw	0x18de, 0x4079
	.dw	0
;2311   DSP_RD( MaxReflAmpl,    F32,    maxReflAmpl,    &reflAmplGain,  &reflAmpl
	.dw	0x12, 0x10
	.db	0x4
	.dw	word _maxReflAmpl_RegInfo
	.dw	word _reflAmplGain
	.dw	word _reflAmplOffset
	.dw	0xffffc7ee, 0x3fe3
	.dw	0
;2312   DSP_RD( MaxCavAmpl,     F32,    maxCavAmpl,     &cavAmplGain,   &cavAmplO
	.dw	0x14, 0x10
	.db	0x4
	.dw	word _maxCavAmpl_RegInfo
	.dw	word _cavAmplGain
	.dw	word _cavAmplOffset
	.dw	0x6f19, 0x40df
	.dw	0
;2313   DSP_RD( MaxOutAmpl,     F32,    maxOutAmpl,     &maxOutAmplGain, &maxOutA
	.dw	0x16, 0x10
	.db	0x4
	.dw	word _maxOutAmpl_RegInfo
	.dw	word _maxOutAmplGain
	.dw	word _maxOutAmplOffset
	.dw	0x6fce, 0x3fcd
	.dw	0
;2314 
;2315   DSP_RD( CavHighIlkLevel,F32,    cavHighIlkLevel,&cavAmplGain,   &cavAmplO
	.dw	0x1b5, 0x10
	.db	0x4
	.dw	word _cavHighIlkLevel_RegInfo
	.dw	word _cavAmplGain
	.dw	word _cavAmplOffset
	.dw	0xffffa76b, 0x4013
	.dw	0x5
;2316   DSP_RD( FwdHighIlkLevel,F32,    fwdHighIlkLevel,&fwdAmplGain,   &fwdAmplO
	.dw	0x1b7, 0x10
	.db	0x4
	.dw	word _fwdHighIlkLevel_RegInfo
	.dw	word _fwdAmplGain
	.dw	word _fwdAmplOffset
	.dw	0xffffa76b, 0x4013
	.dw	0x5
;2317 
;2318   DSP_RD( DSP_Status,     BITS,   statusBitsDSP,  NULL,           NULL,    
	.dw	0x18, 0x10
	.db	0x3
	.dw	word _statusBitsDSP_RegInfo
	.dw	0
	.dw	0
	.dw	0x2088, 0x30
	.dw	0
;2319   DSP_RD( AFC_State,      BITS,   statusBitsAFC,  NULL,           NULL,    
	.dw	0x1a, 0x10
	.db	0x3
	.dw	word _statusBitsAFC_RegInfo
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
;2320 
;2321   DSP_RD( DSP_Load,       F32,    dspLoad,        NULL,           NULL,    
	.dw	0x1c, 0x10
	.db	0x4
	.dw	word _dspLoad_RegInfo
	.dw	0
	.dw	0
	.dw	0x6725, 0x4273
	.dw	0xa
;2322   DSP_RD( PCB_Temp,       F32,    dspTemp,        NULL,           NULL,    
	.dw	0x1e, 0x10
	.db	0x4
	.dw	word _dspTemp_RegInfo
	.dw	0
	.dw	0
	.dw	0xffffb886, 0x4284
	.dw	0x5
;2323 
;2324   DSP_RD( RFQ_T1_Output,  F32,    rfq_t1_output,  NULL,           NULL,    
	.dw	0x19e, 0x10
	.db	0x4
	.dw	word _rfq_t1_output_RegInfo
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
;2325   DSP_RD( RFQ_T2_Output,  F32,    rfq_t2_output,  NULL,           NULL,    
	.dw	0x1a0, 0x10
	.db	0x4
	.dw	word _rfq_t2_output_RegInfo
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
;2326 
;2327 //--- R/W registers that we want to read from each pass ---
;2328   DSP_RD( PiezoTunerPos,  U32,    piezoReadPos,   NULL,           NULL,    
	.dw	0x202, 0x10
	.db	0x3
	.dw	word _piezoReadPos_RegInfo
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
;2329   DSP_RD( StepperPos,     S32,    stepperReadPos, NULL,           NULL,    
	.dw	0x204, 0x10
	.db	0x2
	.dw	word _stepperReadPos_RegInfo
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
;2330 
;2331 //--- RO registers in "special" registers group ---
;2332   DSP_RD( WriteStatus,    U32,    writeStatus,    NULL,           NULL,    
	.dw	0x214, 0x10
	.db	0x3
	.dw	word _writeStatus_RegInfo
	.dw	0
	.dw	0
	.dw	0x64, 0
	.dw	0
;2333   DSP_RD( PercentCTF,     U32,    percentCTF,     NULL,           NULL,    
	.dw	0x218, 0x10
	.db	0x3
	.dw	word _percentCTF_RegInfo
	.dw	0
	.dw	0
	.dw	0x64, 0
	.dw	0
;2334   DSP_RD( SizeCTF,        U32,    sizeCTF,        NULL,           NULL,    
	.dw	0x21c, 0x10
	.db	0x3
	.dw	word _sizeCTF_RegInfo
	.dw	0
	.dw	0
	.dw	0x3e8, 0
	.dw	0
;2335   DSP_RD( PercentFFT,     U32,    percentFFT,     NULL,           NULL,    
	.dw	0x222, 0x10
	.db	0x3
	.dw	word _percentFFT_RegInfo
	.dw	0
	.dw	0
	.dw	0x64, 0
	.dw	0
;2336   DSP_RD( SizeFFT,        U32,    sizeFFT,        NULL,           NULL,    
	.dw	0x224, 0x10
	.db	0x3
	.dw	word _sizeFFT_RegInfo
	.dw	0
	.dw	0
	.dw	0x3e9, 0
	.dw	0
;2337   DSP_RD( ROMProgErrs,    U32,    romProgErrs,    NULL,           NULL,    
	.dw	0x23c, 0x10
	.db	0x3
	.dw	word _romProgErrs_RegInfo
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
;2338 
;2339 //--- R/W registers in "special" group that provide the current value from 
;2340 //--- a table of values ---
;2341   DSP_RD( FwdMagCalib,    F32,    fwdMagCalib,    NULL,           NULL,    
	.dw	0x22a, 0x10
	.db	0x4
	.dw	word _fwdMagCalib_RegInfo
	.dw	0
	.dw	0
	.dw	0x43d5, 0x3117
	.dw	0
;2342   DSP_RD( FwdPhaseCalib,  PHASE,  fwdPhaseCalib,  NULL,           NULL,    
	.dw	0x22c, 0x10
	.db	0x63
	.dw	word _fwdPhaseCalib_RegInfo
	.dw	0
	.dw	0
	.dw	0xffffafce, 0x8c7e
	.dw	0
;2343   DSP_RD( ReflMagCalib,   F32,    reflMagCalib,   NULL,           NULL,    
	.dw	0x22e, 0x10
	.db	0x4
	.dw	word _reflMagCalib_RegInfo
	.dw	0
	.dw	0
	.dw	0x5217, 0x308a
	.dw	0
;2344   DSP_RD( ReflPhaseCalib, PHASE,  reflPhaseCalib, NULL,           NULL,    
	.dw	0x230, 0x10
	.db	0x63
	.dw	word _reflPhaseCalib_RegInfo
	.dw	0
	.dw	0
	.dw	0xffffa5a2, 0x96f5
	.dw	0
;2345   DSP_RD( CavMagCalib,    F32,    cavMagCalib,    NULL,           NULL,    
	.dw	0x232, 0x10
	.db	0x4
	.dw	word _cavMagCalib_RegInfo
	.dw	0
	.dw	0
	.dw	0xffffae52, 0x3187
	.dw	0
;2346   DSP_RD( CavPhaseCalib,  PHASE,  cavPhaseCalib,  NULL,           NULL,    
	.dw	0x234, 0x10
	.db	0x63
	.dw	word _cavPhaseCalib_RegInfo
	.dw	0
	.dw	0
	.dw	0xffff91bc, 0x8f7f
	.dw	0
;2347   DSP_RD( OutMagCalib,    F32,    outMagCalib,    NULL,           NULL,    
	.dw	0x236, 0x10
	.db	0x4
	.dw	word _outMagCalib_RegInfo
	.dw	0
	.dw	0
	.dw	0x3dd5, 0x30a9
	.dw	0
;2348   DSP_RD( OutPhaseCalib,  PHASE,  outPhaseCalib,  NULL,           NULL,    
	.dw	0x238, 0x10
	.db	0x63
	.dw	word _outPhaseCalib_RegInfo
	.dw	0
	.dw	0
	.dw	0, 0
	.dw	0
;2349 
	.debug	G _rdDSPregs 65 8
;2350 
;2351 #define  NUM_RD_DSP_REGS  (sizeof(rdDSPregs) / sizeof(RD_DSP_REG))
;2352 
;2353 
;2354 #define  DSP_WR( dspName, dspType, mbReg, min, max, mode, gain, offset )  
;2355     { dspName, RT_##dspType, &mbReg##_RegInfo, min, max, WM_##mode, gain, o
;2356 
;2357 const WR_DSP_REG far wrDSPregs[] = {
;2358   //      DSP Reg ID      DSP fmt ModBus Reg       Min    Max     Mode  Gai
;2359   //      --------------  ------- --------------   ----   ------  ----  ---
;2360   DSP_WR( TriggerPos,     U32,    trigPos,         0,     1023,   EVERY, NU
_wrDSPregs::
	.dw	0x100, 0x10
	.db	0x3
	.dw	word _trigPos_RegInfo
	.dw	0, 0
	.dw	0xffffc000, 0x447f
	.db	0x1
	.dw	0
	.dw	0
;2361   DSP_WR( WarmUpAmpl,     F32,    warmLevel,       0.0,   0.0,    EVERY, &c
	.dw	0x102, 0x10
	.db	0x4
	.dw	word _warmLevel_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	word _cavAmplGain
	.dw	word _cavAmplOffset
;2362   DSP_WR( WarmUpTime,     F32,    warmMS,          0.0,   32767,  EVERY, NU
	.dw	0x104, 0x10
	.db	0x4
	.dw	word _warmMS_RegInfo
	.dw	0, 0
	.dw	0xfffffe00, 0x46ff
	.db	0x1
	.dw	0
	.dw	0
;2363   DSP_WR( RampTime,       F32,    rampMS,          0.0,   32767,  EVERY, NU
	.dw	0x106, 0x10
	.db	0x4
	.dw	word _rampMS_RegInfo
	.dw	0, 0
	.dw	0xfffffe00, 0x46ff
	.db	0x1
	.dw	0
	.dw	0
;2364 
;2365   DSP_WR( FwdAtten,       U32,    fwdAtten,        0,     63,     EVERY, NU
	.dw	0x108, 0x10
	.db	0x3
	.dw	word _fwdAtten_RegInfo
	.dw	0, 0
	.dw	0, 0x427c
	.db	0x1
	.dw	0
	.dw	0
;2366   DSP_WR( ReflAtten,      U32,    reflAtten,       0,     63,     EVERY, NU
	.dw	0x10a, 0x10
	.db	0x3
	.dw	word _reflAtten_RegInfo
	.dw	0, 0
	.dw	0, 0x427c
	.db	0x1
	.dw	0
	.dw	0
;2367   DSP_WR( CavAtten,       U32,    cavAtten,        0,     63,     EVERY, NU
	.dw	0x10c, 0x10
	.db	0x3
	.dw	word _cavAtten_RegInfo
	.dw	0, 0
	.dw	0, 0x427c
	.db	0x1
	.dw	0
	.dw	0
;2368 
;2369   DSP_WR( PhaseSet,       PHASE,  phaseSet,        0.0,   0.0,    EVERY, &c
	.dw	0x10e, 0x10
	.db	0x63
	.dw	word _phaseSet_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	word _cavPhaseGain
	.dw	word _cavPhaseOffset
;2370   DSP_WR( AmplSet,        F32,    amplSet,         0.0,   0.0,    EVERY, &c
	.dw	0x110, 0x10
	.db	0x4
	.dw	word _amplSet_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	word _cavAmplGain
	.dw	word _cavAmplOffset
;2371 
;2372   DSP_WR( TunePulseFreq,  F32,    pulseFreq,       0.0,   0.0,    EVERY, NU
	.dw	0x112, 0x10
	.db	0x4
	.dw	word _pulseFreq_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2373   DSP_WR( FreqSearchAmpl, F32,    freqSearchAmpl,  0.0,   0.0,    EVERY, &c
	.dw	0x114, 0x10
	.db	0x4
	.dw	word _freqSearchAmpl_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	word _cavAmplGain
	.dw	word _cavAmplOffset
;2374 
;2375   DSP_WR( RF_P,           F32,    rf_P,            0.0,   0.0,    EVERY, NU
	.dw	0x116, 0x10
	.db	0x4
	.dw	word _rf_P_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2376   DSP_WR( RF_I,           F32,    rf_I,            0.0,   0.0,    EVERY, NU
	.dw	0x118, 0x10
	.db	0x4
	.dw	word _rf_I_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2377   DSP_WR( RF_D,           F32,    rf_D,            0.0,   0.0,    EVERY, NU
	.dw	0x11a, 0x10
	.db	0x4
	.dw	word _rf_D_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2378 
;2379   DSP_WR( Tuner_P,        F32,    tuner_P,         0.0,   0.0,    EVERY, NU
	.dw	0x11c, 0x10
	.db	0x4
	.dw	word _tuner_P_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2380   DSP_WR( Tuner_I,        F32,    tuner_I,         0.0,   0.0,    EVERY, NU
	.dw	0x11e, 0x10
	.db	0x4
	.dw	word _tuner_I_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2381   DSP_WR( Tuner_D,        F32,    tuner_D,         0.0,   0.0,    EVERY, NU
	.dw	0x120, 0x10
	.db	0x4
	.dw	word _tuner_D_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2382 
;2383   DSP_WR( PulsedAmplSet,  F32,    pulsedAmplSet,   0.0,   0.0,    EVERY, &c
	.dw	0x122, 0x10
	.db	0x4
	.dw	word _pulsedAmplSet_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	word _cavAmplGain
	.dw	word _cavAmplOffset
;2384   DSP_WR( PulsedPhaseSet, PHASE,  pulsedPhaseSet,  0.0,   0.0,    EVERY, &c
	.dw	0x124, 0x10
	.db	0x63
	.dw	word _pulsedPhaseSet_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	word _cavPhaseGain
	.dw	word _cavPhaseOffset
;2385 
;2386   DSP_WR( AFC_Freq0,      F32,    afcFreq0,        0.0,   1000.0,  ONCE, NU
	.dw	0x126, 0x10
	.db	0x4
	.dw	word _afcFreq0_RegInfo
	.dw	0, 0
	.dw	0, 0x447a
	.db	0
	.dw	0
	.dw	0
;2387   DSP_WR( AFC_Freq1,      F32,    afcFreq1,        0.0,   1000.0,  ONCE, NU
	.dw	0x128, 0x10
	.db	0x4
	.dw	word _afcFreq1_RegInfo
	.dw	0, 0
	.dw	0, 0x447a
	.db	0
	.dw	0
	.dw	0
;2388   DSP_WR( AFC_Freq2,      F32,    afcFreq2,        0.0,   1000.0,  ONCE, NU
	.dw	0x12a, 0x10
	.db	0x4
	.dw	word _afcFreq2_RegInfo
	.dw	0, 0
	.dw	0, 0x447a
	.db	0
	.dw	0
	.dw	0
;2389   DSP_WR( AFC_Freq3,      F32,    afcFreq3,        0.0,   1000.0,  ONCE, NU
	.dw	0x12c, 0x10
	.db	0x4
	.dw	word _afcFreq3_RegInfo
	.dw	0, 0
	.dw	0, 0x447a
	.db	0
	.dw	0
	.dw	0
;2390   DSP_WR( AFC_Freq4,      F32,    afcFreq4,        0.0,   1000.0,  ONCE, NU
	.dw	0x12e, 0x10
	.db	0x4
	.dw	word _afcFreq4_RegInfo
	.dw	0, 0
	.dw	0, 0x447a
	.db	0
	.dw	0
	.dw	0
;2391   DSP_WR( AFC_Freq5,      F32,    afcFreq5,        0.0,   1000.0,  ONCE, NU
	.dw	0x130, 0x10
	.db	0x4
	.dw	word _afcFreq5_RegInfo
	.dw	0, 0
	.dw	0, 0x447a
	.db	0
	.dw	0
	.dw	0
;2392   DSP_WR( AFC_Freq6,      F32,    afcFreq6,        0.0,   1000.0,  ONCE, NU
	.dw	0x132, 0x10
	.db	0x4
	.dw	word _afcFreq6_RegInfo
	.dw	0, 0
	.dw	0, 0x447a
	.db	0
	.dw	0
	.dw	0
;2393   DSP_WR( AFC_Freq7,      F32,    afcFreq7,        0.0,   1000.0,  ONCE, NU
	.dw	0x134, 0x10
	.db	0x4
	.dw	word _afcFreq7_RegInfo
	.dw	0, 0
	.dw	0, 0x447a
	.db	0
	.dw	0
	.dw	0
;2394   DSP_WR( AFC_Freq8,      F32,    afcFreq8,        0.0,   1000.0,  ONCE, NU
	.dw	0x136, 0x10
	.db	0x4
	.dw	word _afcFreq8_RegInfo
	.dw	0, 0
	.dw	0, 0x447a
	.db	0
	.dw	0
	.dw	0
;2395   DSP_WR( AFC_Freq9,      F32,    afcFreq9,        0.0,   1000.0,  ONCE, NU
	.dw	0x138, 0x10
	.db	0x4
	.dw	word _afcFreq9_RegInfo
	.dw	0, 0
	.dw	0, 0x447a
	.db	0
	.dw	0
	.dw	0
;2396 
;2397   DSP_WR( CTFTunerAmpl,   F32,    ctfTunerAmpl,    0.0,   32767,  EVERY, NU
	.dw	0x13a, 0x10
	.db	0x4
	.dw	word _ctfTunerAmpl_RegInfo
	.dw	0, 0
	.dw	0xfffffe00, 0x46ff
	.db	0x1
	.dw	0
	.dw	0
;2398   DSP_WR( CavLowIlkLevel, F32,    cavLowIlkLevel,  0.0,   0.0,    EVERY, &c
	.dw	0x13c, 0x10
	.db	0x4
	.dw	word _cavLowIlkLevel_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	word _cavAmplGain
	.dw	word _cavAmplOffset
;2399   DSP_WR( CavLowIlkTime,  F32,    cavLowIlkTime,   0.0,   0.0,    EVERY, NU
	.dw	0x13e, 0x10
	.db	0x4
	.dw	word _cavLowIlkTime_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2400   DSP_WR( DvDt_IlkRate,   F32,    dvdt_IlkRate,    0.0,   0.0,    EVERY, &c
	.dw	0x140, 0x10
	.db	0x4
	.dw	word _dvdt_IlkRate_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	word _cavAmplGain
	.dw	word _cavAmplOffset
;2401   DSP_WR( VV_IlkRatio,    F32,    vv_IlkRatio,     0.0,   0.0,    EVERY, &i
	.dw	0x142, 0x10
	.db	0x4
	.dw	word _vv_IlkRatio_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	word _ilkRatioGain
	.dw	word _ilkRatioOffset
;2402 
;2403   DSP_WR( FwdCavOffset,   PHASE,  fwdCavOffset,    0.0,   0.0,    EVERY, NU
	.dw	0x144, 0x10
	.db	0x63
	.dw	word _fwdCavOffset_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2404   DSP_WR( FeedFwdPhase,   PHASE,  feedFwdPhase,    0.0,   0.0,    EVERY, NU
	.dw	0x146, 0x10
	.db	0x63
	.dw	word _feedFwdPhase_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2405   DSP_WR( FeedFwdGain,    F32,    feedFwdGain,     0.0,   0.0,    EVERY, NU
	.dw	0x148, 0x10
	.db	0x4
	.dw	word _feedFwdGain_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2406 
;2407   DSP_WR( AFC_Phase0,     PHASE,  afcPhase0,       0.0,   0.0,    ONCE,  NU
	.dw	0x150, 0x10
	.db	0x63
	.dw	word _afcPhase0_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2408   DSP_WR( AFC_Phase1,     PHASE,  afcPhase1,       0.0,   0.0,    ONCE,  NU
	.dw	0x152, 0x10
	.db	0x63
	.dw	word _afcPhase1_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2409   DSP_WR( AFC_Phase2,     PHASE,  afcPhase2,       0.0,   0.0,    ONCE,  NU
	.dw	0x154, 0x10
	.db	0x63
	.dw	word _afcPhase2_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2410   DSP_WR( AFC_Phase3,     PHASE,  afcPhase3,       0.0,   0.0,    ONCE,  NU
	.dw	0x156, 0x10
	.db	0x63
	.dw	word _afcPhase3_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2411   DSP_WR( AFC_Phase4,     PHASE,  afcPhase4,       0.0,   0.0,    ONCE,  NU
	.dw	0x158, 0x10
	.db	0x63
	.dw	word _afcPhase4_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2412   DSP_WR( AFC_Phase5,     PHASE,  afcPhase5,       0.0,   0.0,    ONCE,  NU
	.dw	0x15a, 0x10
	.db	0x63
	.dw	word _afcPhase5_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2413   DSP_WR( AFC_Phase6,     PHASE,  afcPhase6,       0.0,   0.0,    ONCE,  NU
	.dw	0x15c, 0x10
	.db	0x63
	.dw	word _afcPhase6_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2414   DSP_WR( AFC_Phase7,     PHASE,  afcPhase7,       0.0,   0.0,    ONCE,  NU
	.dw	0x15e, 0x10
	.db	0x63
	.dw	word _afcPhase7_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2415   DSP_WR( AFC_Phase8,     PHASE,  afcPhase8,       0.0,   0.0,    ONCE,  NU
	.dw	0x160, 0x10
	.db	0x63
	.dw	word _afcPhase8_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2416   DSP_WR( AFC_Phase9,     PHASE,  afcPhase9,       0.0,   0.0,    ONCE,  NU
	.dw	0x162, 0x10
	.db	0x63
	.dw	word _afcPhase9_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2417 
;2418   DSP_WR( RFQ_ManTuneSet, F32,    rfq_manTuneSet,  0.0,   0.0,    EVERY, NU
	.dw	0x198, 0x10
	.db	0x4
	.dw	word _rfq_manTuneSet_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2419   DSP_WR( RFQ_T1_Offset,  F32,    rfq_t1_offset,   0.0,   0.0,    EVERY, NU
	.dw	0x19a, 0x10
	.db	0x4
	.dw	word _rfq_t1_offset_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2420   DSP_WR( RFQ_T2_Offset,  F32,    rfq_t2_offset,   0.0,   0.0,    EVERY, NU
	.dw	0x19c, 0x10
	.db	0x4
	.dw	word _rfq_t2_offset_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2421   DSP_WR( RFQ_T1_Feedback,F32,    rfq_t1_feedback, 0.0,   0.0,    EVERY, NU
	.dw	0x1a2, 0x10
	.db	0x4
	.dw	word _rfq_t1_feedback_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2422   DSP_WR( RFQ_T2_Feedback,F32,    rfq_t2_feedback, 0.0,   0.0,    EVERY, NU
	.dw	0x1a4, 0x10
	.db	0x4
	.dw	word _rfq_t2_feedback_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2423 
;2424   DSP_WR( FwdAmplGain,    F32,    fwdAmplGain,     0.0,   0.0,    EVERY, NU
	.dw	0x1ad, 0x10
	.db	0x4
	.dw	word _fwdAmplGain_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2425   DSP_WR( CavAmplGain,    F32,    cavAmplGain,     0.0,   0.0,    EVERY, NU
	.dw	0x1af, 0x10
	.db	0x4
	.dw	word _cavAmplGain_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2426 
;2427 //--- WO registers in the "special" registers group ---
;2428   DSP_WR( SetDSPState,    U32,    setDSPState,     0,     0,      EVERY, NU
	.dw	0x200, 0x10
	.db	0x3
	.dw	word _setDSPState_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2429   DSP_WR( SetAFCsOnOff,   U32,    setAFCsOnOff,    0,     0,      EVERY, NU
	.dw	0x206, 0x10
	.db	0x3
	.dw	word _setAFCsOnOff_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2430 
;2431 //--- R/W registers in the "special" registers group ---
;2432   DSP_WR( PiezoTunerPos,  U32,    piezoSetPos,     0,     0,      EVERY, NU
	.dw	0x202, 0x10
	.db	0x3
	.dw	word _piezoSetPos_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2433   DSP_WR( StepperPos,     S32,    stepperSetPos,   0,     0,      EVERY, NU
	.dw	0x204, 0x10
	.db	0x2
	.dw	word _stepperSetPos_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2434   DSP_WR( CTFCalcRate,    F32,    ctfCalcRate,     0.0,   0.0,    EVERY, NU
	.dw	0x228, 0x10
	.db	0x4
	.dw	word _ctfCalcRate_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2435 
;2436   DSP_WR( Pulse_Ramp,     U32,    pulse_ramp,      0,     0,      EVERY, NU
	.dw	0x1ab, 0x10
	.db	0x3
	.dw	word _pulse_ramp_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0x1
	.dw	0
	.dw	0
;2437 
;2438 //--- R/W registers in "special" group that write a value into a table ---
;2439 //--- and cannot be continuously written to ---
;2440   DSP_WR( FwdMagCalib,    F32,    fwdMagCalib,     0.0,   0.0,     ONCE, NU
	.dw	0x22a, 0x10
	.db	0x4
	.dw	word _fwdMagCalib_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2441   DSP_WR( FwdPhaseCalib,  PHASE,  fwdPhaseCalib,   0.0,   0.0,     ONCE, NU
	.dw	0x22c, 0x10
	.db	0x63
	.dw	word _fwdPhaseCalib_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2442   DSP_WR( ReflMagCalib,   F32,    reflMagCalib,    0.0,   0.0,     ONCE, NU
	.dw	0x22e, 0x10
	.db	0x4
	.dw	word _reflMagCalib_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2443   DSP_WR( ReflPhaseCalib, PHASE,  reflPhaseCalib,  0.0,   0.0,     ONCE, NU
	.dw	0x230, 0x10
	.db	0x63
	.dw	word _reflPhaseCalib_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2444   DSP_WR( CavMagCalib,    F32,    cavMagCalib,     0.0,   0.0,     ONCE, NU
	.dw	0x232, 0x10
	.db	0x4
	.dw	word _cavMagCalib_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2445   DSP_WR( CavPhaseCalib,  PHASE,  cavPhaseCalib,   0.0,   0.0,     ONCE, NU
	.dw	0x234, 0x10
	.db	0x63
	.dw	word _cavPhaseCalib_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2446   DSP_WR( OutMagCalib,    F32,    outMagCalib,     0.0,   0.0,     ONCE, NU
	.dw	0x236, 0x10
	.db	0x4
	.dw	word _outMagCalib_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2447   DSP_WR( OutPhaseCalib,  PHASE,  outPhaseCalib,   0.0,   0.0,     ONCE, NU
	.dw	0x238, 0x10
	.db	0x63
	.dw	word _outPhaseCalib_RegInfo
	.dw	0, 0
	.dw	0, 0
	.db	0
	.dw	0
	.dw	0
;2448 
	.debug	G _wrDSPregs 67 8
;2449 
;2450 #define  NUM_WR_DSP_REGS  (sizeof(wrDSPregs) / sizeof(WR_DSP_REG))
;2451 
;2452 
;2453 //=========================================================================
;2454 //  Definitions for event msgs.  Event msgs are the means that other proces
;2455 //  use to inform the application process of an event that it needs to hand
;2456 //
;2457 //  In general, allowing multiple processes to concurrently modify the stat
;2458 //  of the controller is a sure recipie for chaos.  By restricting all such
;2459 //  changes to the context of a single process, and sending messages to tha
;2460 //  process to request changes, we eliminate all such concurrency issues (n
;2461 //  the least of which is keeping track of the order of events).
;2462 //
;2463 //  The most common event is a request for change of state that corresponds
;2464 //  a message received from an external client via a protocol like ModBus.
;2465 //=========================================================================
;2466 
;2467 //EVENT_DEF( myEvent )
;2468 
;2469 
;2470 //=========================================================================
;2471 //  This is where misc global variables should be defined
;2472 //=========================================================================
;2473 #define SharedGlobals
;2474 #include <sharedAppl.c>
;2475 
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.seg	CONST
_DigOutInitState::
	.dw	0xffffc100, 0
	.debug	G _DigOutInitState 9 0
	.dseg
_applicReady::
	.db	0
	.debug	G _applicReady 3 0
_restoredApplState::
	.db	0
	.debug	G _restoredApplState 3 0
_allowSoftReset::
	.db	0
	.debug	G _allowSoftReset 3 0
_startupComplete::
	.db	0
	.debug	G _startupComplete 3 0
	.debug	I
;2476 //--- add definitions for application-specific global variables here ---
;2477 
;2478 LockData  locks[NUM_LOCKS];
;2479 
;2480 
;2481 
;2482 fd_t  spi1fd, spi2fd;
;2483 SerialInfo  *spi1Port, *spi2Port;  // can't share fd's between processes ye
;2484 
;2485 
;2486 
;2487 bool  fpgaInitialized, pulseAmpl, pulsePhase;
;2488 
;2489 uint  ADCVal;
;2490 
;2491 bool  autoReadDSP, autoWriteDSP, showFiller, readWaves;
;2492 
;2493 bool  rfIsOn, rfPulsing, tunerPIDisON, rfAtWarm, rfRamping, afcEnabled,
;2494       cavLocked, amplPIDisON;
;2495 
;2496 uint  curProgNum, phaseMode, lastDSPioTime;
;2497 
;2498 const char *PhaseModeDesc[] = { "    OPEN", "     PID", "     SEL", "??????
	.seg	CONST
_PhaseModeDesc::
	.dw	@2+66
	.dw	@2+75
	.dw	@2+84
	.dw	@2+93
;2499                                 "FREQSRCH", "PID/AUTO", "SEL/AUTO", "??????
	.dw	@2+102
	.dw	@2+111
	.dw	@2+120
	.dw	@2+93
	.debug	G _PhaseModeDesc 69 0
;2500 
;2501 
;2502 //=========================================================================
;2503 //  Temporary functions to fill in for not-yet implemented system functions
;2504 //=========================================================================
;2505 
;2506 
;2507 #define LockOwnedBy(id)  ( locks[id].owner )
;2508 #define NotLockOwner(id)  (LockOwnedBy(id) != getpid())
;2509 
;2510 //-------------------------------------------------------------------------
;2511 //  Get the lock for the specified resource.
;2512 //
;2513 //  Returns:
;2514 //    If lock acquired:  depth of locks aquired by caller
;2515 //    On error:  < 0
;2516 //-------------------------------------------------------------------------
;2517 int  getLock(uint id, ulong msTimeout)
;2518 {
	.defseg	FARCODE
	.seg	FARCODE
$getLock::
	.debug	G $getLock 71 9
	.debug	{ $getLock 71 2517 @5 @4
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
	.debug	A id 5 7
	.debug	A msTimeout 7 9
;2519   PID  mypid, owner;
	.debug	L mypid -2 6
	.debug	L owner -4 6
;2520   int  stat, count;
	.debug	L stat -6 6
	.debug	L count -8 6
;2521   task_t  *task;
	.debug	L task -10 72
;2522   LockData  *lock;
	.debug	L lock -12 74
;2523 
;2524 
;2525   if (id >= NUM_LOCKS)  { errno = ENODEV;  return -1; }
	.debug	# 2525
	ld	hl,(ix+5)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jr	c,@6
@7:
	.debug	< @7 @8
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x13
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@4
@8:
	.debug	>
;2526 
;2527   mypid = getpid();   lock = locks + id;
@6:
	.debug	# 2527
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	ld	hl,(ix+5)
	ld	bc,0x1a
	ex	de,hl
	mul
	ld	hl,_locks
	add	hl,bc
	ld	(ix-12),hl
;2528 
;2529   _EnterCritical_();  owner = lock->owner;  _ExitCritical_();
	.debug	# 2529
	ipset	2
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	(ix-4),hl
	ipres
;2530 
;2531 //--- If we already own the lock, then just increment the count.  Since ---
;2532 //--- only the owner of the lock changes the count, we can safely incr ---
;2533 //--- and return the current value w/o worrying about preemption. ---
;2534   if (owner == mypid)  { ++lock->count;  return lock->count; }
	.debug	# 2534
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@9
@10:
	.debug	< @10 @11
	ld	hl,(ix-12)
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-12)
	ld	hl,(hl)
	jp	@4
@11:
	.debug	>
;2535 
;2536 //--- If we aren't the owner, then try to get the lock.  If the previous --
;2537 //--- owner died, then the LockData will be invalid but the semaphore for -
;2538 //--- the lock will have been released so another task will be able to get 
;2539 //--- it (and change the LockData values to indicate the new owner) ---
;2540   stat = sem_wait_(&lock->sem, msToTicks(msTimeout));
@9:
	.debug	# 2540
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	lcall	$msToTicks
	add	sp,4
	push	bc
	push	de
	ld	hl,(ix-12)
	ld	de,0x4
	add	hl,de
	push	hl
	lcall	$sem_wait_
	add	sp,6
	ld	(ix-6),hl
;2541 
;2542   if (stat < 0)  {
	.debug	# 2542
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@12
;2543     if (msTimeout > 100)  {
@13:
	.debug	< @13 @14
	.debug	# 2543
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x64
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	c,@15
	jr	z,@15
;2544       _EnterCritical_();
@16:
	.debug	< @16 @17
	.debug	# 2544
	ipset	2
;2545       owner = lock->owner;  count = lock->count;
	.debug	# 2545
	ld	hl,(ix-12)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	(ix-4),hl
	ld	hl,(ix-12)
	ld	hl,(hl)
	ld	(ix-8),hl
;2546       _ExitCritical_();
	.debug	# 2546
	ipres
;2547       task = tasks + _activeTaskIdx_(owner);
	.debug	# 2547
	ld	hl,(ix-4)
	push	hl
	lcall	$_activeTaskIdx_
	pop	de
	ld	bc,0xe8
	ex	de,hl
	mul
	ld	hl,_tasks
	add	hl,bc
	ld	(ix-10),hl
;2548       printf("Lock %d still held by %.15s[%d], count %d\r\n",
;2549               id, task->argv[0], owner, count );
	.debug	# 2549
	ld	hl,(ix-8)
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-10)
	ld	de,0x1a
	add	hl,de
	ld	hl,(hl)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @1+2454)
	ld	c,phys @1+2454 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;2550     }
@17:
	.debug	>
;2551     return stat;
@15:
	.debug	# 2551
	ld	hl,(ix-6)
	jr	@4
;2552   }
@14:
	.debug	>
;2553 
;2554 
;2555 //--- Again, if we got here, we own the lock and only the owner will change
;2556 //--- the LockData values ---
;2557   lock->owner = mypid;
@12:
	.debug	# 2557
	ld	hl,(ix-12)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2558   lock->count = 1;
	.debug	# 2558
	ld	hl,(ix-12)
	ld	de,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2559 
;2560 //  fprintf(DiagLog, "%u now has lock %d\n", mypid, id);  //tdebug
;2561 
;2562 
;2563   return lock->count;
	.debug	# 2563
	ld	hl,(ix-12)
	ld	hl,(hl)
;2564 }
@4:
	.debug	} @4 2564

@3	equ	12
	ld	sp,ix
	pop	ix
	lret
@5	equ	14
;2565 
;2566 
;2567 
;2568 //-------------------------------------------------------------------------
;2569 //  If the calling process owns the specified lock, then reduce its lock co
;2570 //  (or release the lock if no more counts)
;2571 //
;2572 //  Returns:
;2573 //    On success:  New lock depth held by caller
;2574 //    On error:  < 0
;2575 //-------------------------------------------------------------------------
;2576 int releaseLock(uint id)
;2577 {
$releaseLock::
	.debug	G $releaseLock 76 9
	.debug	{ $releaseLock 76 2576 @20 @19
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A id 5 7
;2578   uint  owner;
	.debug	L owner -2 7
;2579   LockData  *lock;
	.debug	L lock -4 74
;2580 
;2581 
;2582   if (id >= NUM_LOCKS)  {
	.debug	# 2582
	ld	hl,(ix+5)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jr	c,@21
;2583     fprintf(DiagLog, "*** releaseLock(%u): Invalid lock ID ***\n", id);
@22:
	.debug	< @22 @23
	.debug	# 2583
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @1+2498)
	ld	c,phys @1+2498 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;2584     return -1;
	.debug	# 2584
	jr	@1852
;2585   }
@23:
	.debug	>
;2586 
;2587   lock = locks + id;
@21:
	.debug	# 2587
	ld	hl,(ix+5)
	ld	bc,0x1a
	ex	de,hl
	mul
	ld	hl,_locks
	add	hl,bc
	ld	(ix-4),hl
;2588 
;2589   _EnterCritical_();  owner = lock->owner;  _ExitCritical_();
	.debug	# 2589
	ipset	2
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	(ix-2),hl
	ipres
;2590 
;2591   if (owner != getpid())  {
	.debug	# 2591
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@24
;2592     fprintf(DiagLog, "*** releaseLock(%u): Lock owned by: %u ***\n",
@25:
	.debug	< @25 @26
;2593             id, owner);
	.debug	# 2593
	ld	h,d
	ld	l,e
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @1+2540)
	ld	c,phys @1+2540 >> 16
	jr	@1851
;2594     return -1;
	.debug	# 2594
;2595   }
@26:
	.debug	>
;2596 
;2597   // At this point, we know we own the lock, so no other task will make cha
;2598   // to the values in the LockData structure until we release the semaphore
;2599 
;2600   if (lock->count < 1)  {
@24:
	.debug	# 2600
	ld	hl,(ix-4)
	ld	hl,(hl)
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@27
;2601     fprintf(DiagLog, "*** releaseLock(%u) with count of %u ***\n",
@28:
	.debug	< @28 @29
;2602             id, lock->count);
	.debug	# 2602
	ld	hl,(ix-4)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	de,word (phys @1+2584)
	ld	c,phys @1+2584 >> 16
@1851:
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;2603     return -1;
	.debug	# 2603
@1852:
	ld	hl,0xffff
	jr	@19
;2604   }
@29:
	.debug	>
;2605 
;2606   if (--lock->count == 0)  {
@27:
	.debug	# 2606
	ld	hl,(ix-4)
	push	hl
	ld	hl,(hl)
	dec	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	a,e
	or	a,d
	jr	nz,@30
;2607 //    fprintf(DiagLog, "%u releasing lock %d\n",  getpid(), id);  //tdebug
;2608     lock->owner = -1;  sem_post(&lock->sem);
@31:
	.debug	< @31 @32
	.debug	# 2608
	ld	hl,(ix-4)
	inc	hl
	inc	hl
	ld	de,0xffff
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-4)
	ld	de,0x4
	add	hl,de
	push	hl
	lcall	$sem_post
	pop	de
;2609   }
@32:
	.debug	>
;2610 
;2611   return lock->count;
@30:
	.debug	# 2611
	ld	hl,(ix-4)
	ld	hl,(hl)
;2612 }
@19:
	.debug	} @19 2612

@18	equ	4
	ld	sp,ix
	pop	ix
	lret
@20	equ	6
;2613 
;2614 
;2615 //-------------------------------------------------------------------------
;2616 //  Get the APPL_LOCK and initialize the SPI port used to talk to the DSP
;2617 //
;2618 //  Returns lock depth on success, < 0 if an error
;2619 //-------------------------------------------------------------------------
;2620 int getLockDSP(ulong timeOut)
;2621 {
$getLockDSP::
	.debug	G $getLockDSP 77 9
	.debug	{ $getLockDSP 77 2620 @35 @34
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-3
	.debug	A timeOut 5 9
;2622   uchar  clockMode = NORM_LOW_LATCH_RISE;
	.debug	L clockMode -1 3
	.debug	# 2622
	xor	a,a
	ld	(ix-1),a
	.seg	FARCODE
;2623   int  lockDepth;
	.debug	L lockDepth -3 6
;2624 
;2625 
;2626   if (hdwType == HT_PHASE_CTLR)  if (!spi1Port)  { errno = EBADF; return -1
	.debug	# 2626
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nz,@36
	ld	hl,(_spi1Port)
	bool	hl
	jr	nz,@37
@38:
	.debug	< @38 @39
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@34
@39:
	.debug	>
;2627 
;2628   lockDepth = getLock(APPL_LOCK, timeOut);
@37:
@36:
	.debug	# 2628
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	lcall	$getLock
	add	sp,6
	ld	(ix-3),hl
;2629   if (lockDepth <= 0)  return lockDepth;
	.debug	# 2629
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@41
	jr	nc,@40
@41:
	ld	hl,(ix-3)
	jr	@34
;2630 
;2631   if (hdwType == HT_PHASE_CTLR)  if (lockDepth == 1)
@40:
	.debug	# 2631
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nz,@42
	ld	hl,(ix-3)
	ld	e,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@43
;2632   //  ioctl(spi1fd, IOC_SET_CLK_MODE, &clockMode);
;2633     _spiConfig_(spi1Port, CLK_2MHz, clockMode);
	.debug	# 2633
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	hl,0x5
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
;2634 
;2635   return lockDepth;
@43:
@42:
	.debug	# 2635
	ld	hl,(ix-3)
;2636 }
@34:
	.debug	} @34 2636

@33	equ	3
	ld	sp,ix
	pop	ix
	lret
@35	equ	5
;2637 
;2638 //-------------------------------------------------------------------------
;2639 //  release the APPL_LOCK and allow other tasks to use the DSP interface
;2640 //
;2641 //  Returns 0 on success, < 0 if an error
;2642 //-------------------------------------------------------------------------
;2643 int releaseLockDSP(void)
;2644 {
$releaseLockDSP::
	.debug	G $releaseLockDSP 78 9
	.debug	{ $releaseLockDSP 78 2643 @46 @45
;2645   return releaseLock(APPL_LOCK);
	.debug	# 2645
	bool	hl
	ld	l,h
	push	hl
	lcall	$releaseLock
	pop	de
;2646 }
@45:
	.debug	} @45 2646

@44	equ	0
	lret
@46	equ	0
;2647 
;2648 
;2649 //=========================================================================
;2650 
;2651 
;2652 //-------------------------------------------------------------------------
;2653 //  Convert a new ModBus register value to a floating point number
;2654 //
;2655 //  Note that the size of the buffer pointed to by newVal must match the
;2656 //  size of the specified ModBus register value.
;2657 //-------------------------------------------------------------------------
;2658 float mb2float(void *newVal, RegInfo *mbRegInfo)
;2659 {
$mb2float::
	.debug	G $mb2float 79 9
	.debug	{ $mb2float 79 2658 @49 @48
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
	.debug	A newVal 5 80
	.debug	A mbRegInfo 7 38
;2660   uchar  type = mbRegInfo->dataType;
	.debug	L type -1 3
	.debug	# 2660
	ld	hl,(ix+7)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	ld	(ix-1),a
	.seg	FARCODE
;2661 
;2662   switch (type)  {
	.debug	# 2662
	jr	@50
;2663     case DT_S16:  return (float) MB_VAL(S16);
@52:
	.debug	< @52 @53
	.debug	# 2663
@54:
	ld	hl,(ix+5)
	ld	hl,(hl)
	ex	de,hl
	call	__itof##
	jr	@48
;2664     case DT_U16:  return (float) MB_VAL(U16);
	.debug	# 2664
@55:
	ld	hl,(ix+5)
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
	jr	@48
;2665     case DT_S32:  return (float) MB_VAL(S32);
	.debug	# 2665
@56:
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ltof##
	jr	@48
;2666     case DT_U32:  return (float) MB_VAL(U32);
	.debug	# 2666
@57:
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ultof##
	jr	@48
;2667     case DT_F32:  return         MB_VAL(F32);
	.debug	# 2667
@58:
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@48
;2668   }
@53:
	.debug	>
;2669 
;2670   return 0.0;
@50:
	or	a,a
	jr	z,@54
	cp	0x1
	jr	z,@55
	cp	0x2
	jr	z,@56
	cp	0x3
	jr	z,@57
	cp	0x4
	jr	z,@58
@51:
	.debug	# 2670
	ld	de,0
	ld	c,e
	ld	b,e
;2671 }
@48:
	.debug	} @48 2671

@47	equ	1
	ld	sp,ix
	pop	ix
	lret
@49	equ	3
;2672 
;2673 //-------------------------------------------------------------------------
;2674 //  Convert a new ModBus register value to a signed long number
;2675 //
;2676 //  Note that the size of the buffer pointed to by newVal must match the
;2677 //  size of the specified ModBus register value.
;2678 //-------------------------------------------------------------------------
;2679 S32 mb2S32(void *newVal, RegInfo *mbRegInfo)
;2680 {
$mb2S32::
	.debug	G $mb2S32 81 9
	.debug	{ $mb2S32 81 2679 @61 @60
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
	.debug	A newVal 5 80
	.debug	A mbRegInfo 7 38
;2681   uchar  type = mbRegInfo->dataType;
	.debug	L type -1 3
	.debug	# 2681
	ld	hl,(ix+7)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	ld	(ix-1),a
	.seg	FARCODE
;2682 
;2683   switch (type)  {
	.debug	# 2683
	jr	@62
;2684     case DT_S16:  return (S32) MB_VAL(S16);
@64:
	.debug	< @64 @65
	.debug	# 2684
@66:
	ld	hl,(ix+5)
	ld	hl,(hl)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	jr	@60
;2685     case DT_U16:  return (S32) MB_VAL(U16);
	.debug	# 2685
@67:
	ld	hl,(ix+5)
	ld	hl,(hl)
	ex	de,hl
	ld	bc,0
	jr	@60
;2686     case DT_S32:  return       MB_VAL(S32);
	.debug	# 2686
;2687     case DT_U32:  return (S32) MB_VAL(U32);
	.debug	# 2687
@69:
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@60
;2688     case DT_F32:  return (S32) MB_VAL(F32);
	.debug	# 2688
@70:
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ftol##
	jr	@60
;2689   }
@65:
	.debug	>
;2690 
;2691   return 0;
@62:
	or	a,a
	jr	z,@66
	cp	0x1
	jr	z,@67
	cp	0x2
	jr	z,@69
	cp	0x3
	jr	z,@69
	cp	0x4
	jr	z,@70
@63:
	.debug	# 2691
	ld	de,0
	ld	c,e
	ld	b,e
;2692 }
@60:
	.debug	} @60 2692

@59	equ	1
	ld	sp,ix
	pop	ix
	lret
@61	equ	3
;2693 
;2694 //-------------------------------------------------------------------------
;2695 //  Convert a new ModBus register value to an unsigned long number
;2696 //
;2697 //  Note that the size of the buffer pointed to by newVal must match the
;2698 //  size for the type of the specified ModBus register value.
;2699 //-------------------------------------------------------------------------
;2700 U32 mb2U32(void *newVal, RegInfo *mbRegInfo)
;2701 {
$mb2U32::
	.debug	G $mb2U32 82 9
	.debug	{ $mb2U32 82 2700 @73 @72
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
	.debug	A newVal 5 80
	.debug	A mbRegInfo 7 38
;2702   uchar  type = mbRegInfo->dataType;
	.debug	L type -1 3
	.debug	# 2702
	ld	hl,(ix+7)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	ld	(ix-1),a
	.seg	FARCODE
;2703 
;2704   switch (type)  {
	.debug	# 2704
	jr	@74
;2705     case DT_S16:  return (U32) MB_VAL(S16);
@76:
	.debug	< @76 @77
	.debug	# 2705
@78:
	ld	hl,(ix+5)
	ld	hl,(hl)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	jr	@72
;2706     case DT_U16:  return (U32) MB_VAL(U16);
	.debug	# 2706
@79:
	ld	hl,(ix+5)
	ld	hl,(hl)
	ex	de,hl
	ld	bc,0
	jr	@72
;2707     case DT_S32:  return (U32) MB_VAL(S32);
	.debug	# 2707
;2708     case DT_U32:  return       MB_VAL(U32);
	.debug	# 2708
@81:
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@72
;2709     case DT_F32:  return (U32) MB_VAL(F32);
	.debug	# 2709
@82:
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ftol##
	jr	@72
;2710   }
@77:
	.debug	>
;2711 
;2712   return 0;
@74:
	or	a,a
	jr	z,@78
	cp	0x1
	jr	z,@79
	cp	0x2
	jr	z,@81
	cp	0x3
	jr	z,@81
	cp	0x4
	jr	z,@82
@75:
	.debug	# 2712
	ld	de,0
	ld	c,e
	ld	b,e
;2713 }
@72:
	.debug	} @72 2713

@71	equ	1
	ld	sp,ix
	pop	ix
	lret
@73	equ	3
;2714 
;2715 //-------------------------------------------------------------------------
;2716 //  Convert a floating value to the format of the specified ModBus register
;2717 //
;2718 //  Note that the size of the buffer pointed to by newVal must match the
;2719 //  size of the specified ModBus register value.
;2720 //-------------------------------------------------------------------------
;2721 void float2mb(void *newVal, RegInfo *mbRegInfo, float fromVal)
;2722 {
$float2mb::
	.debug	G $float2mb 83 9
	.debug	{ $float2mb 83 2721 @85 @84
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
	.debug	A newVal 5 80
	.debug	A mbRegInfo 7 38
	.debug	A fromVal 9 10
;2723   uchar  type = mbRegInfo->dataType;
	.debug	L type -1 3
	.debug	# 2723
	ld	hl,(ix+7)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	ld	(ix-1),a
	.seg	FARCODE
;2724 
;2725   switch (type)  {
	.debug	# 2725
	jr	@86
;2726     case DT_S16:  MB_VAL(S16) = (int) fromVal;  break;
@88:
	.debug	< @88 @89
	.debug	# 2726
;2727     case DT_U16:  MB_VAL(U16) = (uint) fromVal;  break;
	.debug	# 2727
@91:
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__ftol##
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2728     case DT_S32:  MB_VAL(S32) = (long) fromVal;  break;
	jr	@87
	.debug	# 2728
@1850:
;2729     case DT_U32:  MB_VAL(U32) = (ulong) fromVal;  break;
	.debug	# 2729
@93:
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__ftol##
	jr	@1849
;2730     case DT_F32:  MB_VAL(float) = fromVal;  break;
	.debug	# 2730
@94:
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
@1849:
	ld	hl,(ix+5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2731   }
	jr	@87
@89:
	.debug	>
;2732 }
@86:
	or	a,a
	jr	z,@91
	cp	0x1
	jr	z,@91
	cp	0x2
	jr	z,@1850
	cp	0x3
	jr	z,@93
	cp	0x4
	jr	z,@94
@87:
@84:
	.debug	} @84 2732

@83	equ	1
	ld	sp,ix
	pop	ix
	lret
@85	equ	3
;2733 
;2734 //-------------------------------------------------------------------------
;2735 //  Convert a DSP register value to a format that is compatible with the
;2736 //  specified ModBus register (i.e. make sure it is a floating point or
;2737 //  an integer value as needed).
;2738 //-------------------------------------------------------------------------
;2739 void dsp2mb(RegInfo *mbReg, S16 *mbVal,
;2740             const RD_DSP_REG far *dspReg, ulong *dspVal)
;2741 {
$dsp2mb::
	.debug	G $dsp2mb 84 9
	.debug	{ $dsp2mb 84 2739 @97 @96
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-17
	.debug	A mbReg 5 38
	.debug	A mbVal 7 85
	.debug	A dspReg 9 86
	.debug	A dspVal 13 87
;2742   uchar  mbType = mbReg->dataType, dspType = dspReg->type;
	.debug	L mbType -1 3
	.debug	# 2742
	ld	hl,(ix+5)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	ld	(ix-1),a
	.seg	FARCODE
	.debug	L dspType -2 3
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	(ix-2),a
	.seg	FARCODE
;2743   bool  offset0, gain1, scaleIt;
	.debug	L offset0 -3 3
	.debug	L gain1 -4 3
	.debug	L scaleIt -5 3
;2744   float  gain, offset, fval;
	.debug	L gain -9 10
	.debug	L offset -13 10
	.debug	L fval -17 10
;2745 
;2746 
;2747 //--- if DSP value is a scaled PHASE value, rescale it into a float ---
;2748   if (dspType == RT_PHASE)  {
	.debug	# 2748
	sub	a,99
	jr	nz,@98
;2749     *(float *)dspVal = (float)*dspVal * PhaseConvFactor;  dspType = RT_F32;
@99:
	.debug	< @99 @100
	.debug	# 2749
	ld	hl,(ix+13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ultof##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x33b4
	call	__fmlt##
	ld	hl,(ix+13)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	(ix-2),0x4
@100:
	.debug	>
;2750 
;2751 
;2752 //--- determine if the value needs to be scaled ---
;2753   offset = (dspReg->offset ? *dspReg->offset : 0.0);  // NULL == no offset
@98:
	.debug	# 2753
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x9
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@101
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x9
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@102
@101:
	ld	de,0
	ld	c,e
	ld	b,e
@102:
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
;2754   gain = (dspReg->gain ? *dspReg->gain : 1.0);  // NULL == no gain
	.debug	# 2754
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@103
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@104
@103:
	ld	de,0
	ld	bc,0x3f80
@104:
	ld	hl,bc
	ld	(ix-7),hl
	ex	de,hl
	ld	(ix-9),hl
	ex	de,hl
;2755 
;2756   if (gain == 0.0)  gain = 1.0;
	.debug	# 2756
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	nz,@105
	ld	de,0
	ld	hl,0x3f80
	ld	(ix-7),hl
	ex	de,hl
	ld	(ix-9),hl
	ex	de,hl
;2757 
;2758   offset0 = (offset == 0.0);  gain1 = (gain == 1.0);
@105:
	.debug	# 2758
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	ld	de,0
	jr	nz,@106
	inc	e
@106:
	ld	(ix-3),e
	ld	hl,(ix-9)
	ex	de,hl
	ld	hl,(ix-7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x3f80
	call	__fequ##
	ld	de,0
	jr	nz,@107
	inc	e
@107:
	ld	(ix-4),e
;2759 
;2760   scaleIt = (!offset0 OR !gain1);
	.debug	# 2760
	ld	a,(ix-3)
	or	a,a
	jr	z,@108
	ld	a,e
	or	a,a
	jr	nz,@109
@108:
	ld	a,1
	jr	@110
@109:
	xor	a
@110:
	ld	(ix-5),a
;2761 
;2762   if (scaleIt)  {
	.debug	# 2762
	or	a,a
	jp	z,@111
;2763     switch (dspType)  {
@112:
	.debug	< @112 @113
	.debug	# 2763
	ld	a,(ix-2)
	jr	@114
;2764       case RT_S32:  fval = (float)((S32)*dspVal);  break;
@116:
	.debug	< @116 @117
	.debug	# 2764
@118:
	ld	hl,(ix+13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ltof##
	jr	@1848
;2765       case RT_U32:  fval = (float)((U32)*dspVal);  break;
	.debug	# 2765
@119:
	ld	hl,(ix+13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ultof##
	jr	@1848
;2766       case RT_F32:  fval = *(float *)dspVal;  break;
	.debug	# 2766
@120:
	ld	hl,(ix+13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
@1848:
	ld	hl,bc
	ld	(ix-15),hl
	ex	de,hl
	ld	(ix-17),hl
	ex	de,hl
;2767     }
	jr	@115
@117:
	.debug	>
;2768     if (!offset0)  fval -= offset;
@114:
	cp	0x2
	jr	z,@118
	cp	0x3
	jr	z,@119
	cp	0x4
	jr	z,@120
@115:
	.debug	# 2768
	ld	a,(ix-3)
	or	a,a
	jr	nz,@121
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	call	__fsub##
	ld	hl,bc
	ld	(ix-15),hl
	ex	de,hl
	ld	(ix-17),hl
	ex	de,hl
;2769     if (!gain1)  fval = fval * gain;
@121:
	.debug	# 2769
	ld	a,(ix-4)
	or	a,a
	jr	nz,@122
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-9)
	ex	de,hl
	ld	hl,(ix-7)
	ld	bc,hl
	call	__fmlt##
	ld	hl,bc
	ld	(ix-15),hl
	ex	de,hl
	ld	(ix-17),hl
	ex	de,hl
;2770     *(float *)dspVal = fval;  dspType = RT_F32;
@122:
	.debug	# 2770
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	ld	hl,(ix+13)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	(ix-2),0x4
;2771   }
@113:
	.debug	>
;2772 
;2773 
;2774 //--- Make sure the DSP format is the same type as the ModBus format ---
;2775 //--- (i.e. both are 16 or 32-bit integers or both are 32-bit floats) ---
;2776   if ((dspType == DT_F32) != (mbType == DT_F32))  {
@111:
	.debug	# 2776
	ld	a,(ix-2)
	sub	a,4
	ld	a,0
	jr	nz,@123
	inc	a
@123:
	ld	hl,(ix-1)
	ld	e,0x4
	ld	h,a
	ld	a,l
	ld	l,h
	sub	a,e
	ld	a,0
	jr	nz,@124
	inc	a
@124:
	sub	a,l
	jp	z,@125
;2777     if (mbType == DT_F32)  {  // non-float to float
@126:
	.debug	< @126 @127
	.debug	# 2777
	ld	a,(ix-1)
	sub	a,4
	jr	nz,@128
;2778       if (dspType == DT_S32)  {  // signed or unsigned?
@129:
	.debug	< @129 @130
	.debug	# 2778
	ld	a,(ix-2)
	sub	a,2
	jr	nz,@131
;2779         *(float *)dspVal = (float)((S32)*dspVal);  dspType = DT_F32;  }
@132:
	.debug	< @132 @133
	.debug	# 2779
	ld	hl,(ix+13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ltof##
	jr	@1847
@133:
	.debug	>
;2780       else  {
@131:
;2781         *(float *)dspVal = (float)((U32)*dspVal);  dspType = DT_F32;  }
@135:
	.debug	< @135 @136
	.debug	# 2781
	ld	hl,(ix+13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ultof##
@1847:
	ld	hl,(ix+13)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	a,0x4
	ld	(ix-2),a
@136:
	.debug	>
;2782     }
@130:
	.debug	>
;2783     else  {  // float to non-float
	jr	@137
@128:
;2784       fval = *(float *)dspVal;
@138:
	.debug	< @138 @139
	.debug	# 2784
	ld	hl,(ix+13)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-15),hl
	ex	de,hl
	ld	(ix-17),hl
	ex	de,hl
;2785       if ((mbType == DT_S16) OR (mbType == DT_S32)) { // signed or unsigned
	.debug	# 2785
	ld	a,(ix-1)
	or	a,a
	jr	z,@140
	sub	a,2
	jr	nz,@141
@140:
;2786         *(S32 *)dspVal = (S32) fval;  dspType = DT_S32; }
@142:
	.debug	< @142 @143
	.debug	# 2786
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	call	__ftol##
	ld	hl,(ix+13)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	a,0x2
	ld	(ix-2),a
@143:
	.debug	>
;2787       else  {
	jr	@144
@141:
;2788         *(U32 *)dspVal = (U32) fval;  dspType = DT_U32; }
@145:
	.debug	< @145 @146
	.debug	# 2788
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	call	__ftol##
	ld	hl,(ix+13)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	(ix-2),0x3
@146:
	.debug	>
;2789     }
@144:
@139:
	.debug	>
;2790   }
@137:
@127:
	.debug	>
;2791 
;2792   if (mbReg->numRegs < 2)  // ModBus is 16-bit int, DSP is 32-bit int
@125:
	.debug	# 2792
	ld	hl,(ix+5)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	sub	a,2
	jr	nc,@147
;2793     *(uint *)mbVal = (uint)(*dspVal);
	.debug	# 2793
	ld	hl,(ix+13)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2794   else  // both are 32-bits (either float or long ints)
;2795     memcpy(mbVal, dspVal, 4);
	jr	@148
@147:
	.debug	# 2795
	ld	hl,0x4
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+7)
	push	hl
	call	_memcpy
	add	sp,6
;2796 }
@148:
@96:
	.debug	} @96 2796

@95	equ	17
	ld	sp,ix
	pop	ix
	lret
@97	equ	19
;2797 
;2798 
;2799 //-------------------------------------------------------------------------
;2800 //  Convert a ModBus register value to the specified DSP register format
;2801 //-------------------------------------------------------------------------
;2802 void mb2dsp(RegInfo *mbReg, S16 *mbVal,
;2803             const WR_DSP_REG far *dspReg, ulong *dspVal)
;2804 {
$mb2dsp::
	.debug	G $mb2dsp 88 9
	.debug	{ $mb2dsp 88 2802 @151 @150
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-16
	.debug	A mbReg 5 38
	.debug	A mbVal 7 85
	.debug	A dspReg 9 89
	.debug	A dspVal 13 87
;2805   uchar  dspType = dspReg->type;
	.debug	L dspType -1 3
	.debug	# 2805
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	(ix-1),a
	.seg	FARCODE
;2806   bool  offset0, gain1, scaleIt;
	.debug	L offset0 -2 3
	.debug	L gain1 -3 3
	.debug	L scaleIt -4 3
;2807   float  gain, offset, fval;
	.debug	L gain -8 10
	.debug	L offset -12 10
	.debug	L fval -16 10
;2808 
;2809 
;2810 //--- determine if the value needs to be scaled ---
;2811   offset = (dspReg->offset ? *dspReg->offset : 0.0);  // NULL == no offset
	.debug	# 2811
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@152
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@153
@152:
	ld	de,0
	ld	c,e
	ld	b,e
@153:
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;2812   gain = (dspReg->gain ? *dspReg->gain : 1.0);  // NULL == no gain
	.debug	# 2812
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	z,@154
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@155
@154:
	ld	de,0
	ld	bc,0x3f80
@155:
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;2813 
;2814   if (gain == 0.0)  gain = 1.0;
	.debug	# 2814
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	nz,@156
	ld	de,0
	ld	hl,0x3f80
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;2815 
;2816   offset0 = (offset == 0.0);  gain1 = (gain == 1.0);
@156:
	.debug	# 2816
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	a,b
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	ld	de,0
	jr	nz,@157
	inc	e
@157:
	ld	(ix-2),e
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x3f80
	call	__fequ##
	ld	de,0
	jr	nz,@158
	inc	e
@158:
	ld	(ix-3),e
;2817 
;2818   scaleIt = (!offset0 OR !gain1);
	.debug	# 2818
	ld	a,(ix-2)
	or	a,a
	jr	z,@159
	ld	a,e
	or	a,a
	jr	nz,@160
@159:
	ld	a,1
	jr	@161
@160:
	xor	a
@161:
	ld	(ix-4),a
;2819 
;2820   if (scaleIt)  {
	.debug	# 2820
	or	a,a
	jr	z,@162
;2821     fval = mb2float(mbVal, mbReg);
@163:
	.debug	< @163 @164
	.debug	# 2821
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$mb2float
	add	sp,4
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
;2822     if (!gain1)  fval = fval / gain;
	.debug	# 2822
	ld	a,(ix-3)
	or	a,a
	jr	nz,@165
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__fdiv##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
;2823     if (!offset0)  fval += offset;
@165:
	.debug	# 2823
	ld	a,(ix-2)
	or	a,a
	jr	nz,@166
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__fadd##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
;2824   }
@166:
@164:
	.debug	>
;2825 
;2826 //--- convert either the scaled or unscaled ModBus value to the DSP format 
;2827   switch (dspType)  {
@162:
	.debug	# 2827
	ld	a,(ix-1)
	jp	@167
;2828     case RT_S32:
@169:
	.debug	< @169 @170
;2829       if (scaleIt)
	.debug	# 2829
@171:
	ld	a,(ix-4)
	or	a,a
	jr	z,@172
;2830         *(S32 *)dspVal = (S32)fval;
	.debug	# 2830
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__ftol##
	ld	hl,(ix+13)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2831       else
;2832         *(S32 *)dspVal = mb2S32(mbVal, mbReg);
	jr	@173
@172:
	.debug	# 2832
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$mb2S32
	add	sp,4
	ld	hl,(ix+13)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2833       break;
@173:
	.debug	# 2833
;2834 
;2835     case RT_U32:
	jp	@168
;2836       if (scaleIt)
	.debug	# 2836
@174:
	ld	a,(ix-4)
	or	a,a
	jr	z,@175
;2837         *(U32 *)dspVal = (U32)fval;
	.debug	# 2837
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__ftol##
	ld	hl,(ix+13)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2838       else
;2839         *(U32 *)dspVal = mb2U32(mbVal, mbReg);
	jr	@168
@175:
	.debug	# 2839
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$mb2U32
	add	sp,4
	ld	hl,(ix+13)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2840       break;
	.debug	# 2840
;2841 
;2842     case RT_F32:
	jr	@168
;2843       if (scaleIt)
	.debug	# 2843
@177:
	ld	a,(ix-4)
	or	a,a
	jr	z,@178
;2844         *(float *)dspVal = fval;
	.debug	# 2844
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	jr	@1846
;2845       else
;2846         *(float *)dspVal = mb2float(mbVal, mbReg);
@178:
	.debug	# 2846
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$mb2float
	add	sp,4
	jr	@1846
;2847       break;
	.debug	# 2847
;2848 
;2849     case RT_PHASE:
;2850       if (scaleIt)
	.debug	# 2850
@180:
	ld	a,(ix-4)
	or	a,a
	jr	z,@181
;2851         *dspVal = (ulong)(fval / PhaseConvFactor);
	.debug	# 2851
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	jr	@1845
;2852       else
;2853         *dspVal = (ulong)(mb2float(mbVal, mbReg) / PhaseConvFactor);
@181:
	.debug	# 2853
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix+7)
	push	hl
	lcall	$mb2float
	add	sp,4
@1845:
	push	bc
	push	de
	ld	de,0
	ld	bc,0x33b4
	call	__fdiv##
	call	__ftol##
@1846:
	ld	hl,(ix+13)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2854       break;
	.debug	# 2854
;2855   }
	jr	@168
@170:
	.debug	>
;2856 
;2857 }
@167:
	cp	0x2
	jp	z,@171
	cp	0x3
	jp	z,@174
	cp	0x4
	jr	z,@177
	cp	0x63
	jr	z,@180
@168:
@150:
	.debug	} @150 2857

@149	equ	16
	ld	sp,ix
	pop	ix
	lret
@151	equ	18
;2858 
;2859 
;2860 //=========================================================================
;2861 //  Functions referenced in the Modbus register definitions to handle write
;2862 //  to specific global values defined as ModBus registers
;2863 //=========================================================================
;2864 
;2865 //-------------------------------------------------------------------------
;2866 //  Got a new value for one of the registers that mirrors one of the DSP's 
;2867 //  registers.  In response, we check the new value against the range of va
;2868 //  given for the DSP register and modify the ModBus register value if need
;2869 //
;2870 //  The writeMode specified for the DSP register determines when the new va
;2871 //  is written to the DSP as follows:
;2872 //
;2873 //  WM_ONCE:
;2874 //     The value must be written just once ASAP.  Writing to one of these D
;2875 //     registers triggers some action on the part of the DSP, so the regist
;2876 //     must not be written to except in response to a write to the correspo
;2877 //     ModBus register.  The most common use of this mode by the DSP is to
;2878 //     copy some related values to a table (possibly including the value ju
;2879 //     written, or using the new value as an index in to the table?) as par
;2880 //     of a calibration process.
;2881 //
;2882 //  WM_EVERY:
;2883 //     The value represents some run-time setting and can be written to the
;2884 //     repeatedly without causing a problem.  While writing such values to 
;2885 //     DSP just once would be sufficient if the the DSP never rebooted, suc
;2886 //     values are not retained by the DSP across a reboot.  For that reason
;2887 //     these values are resent to the DSP each pass through the application
;2888 //     main loop (i.e. by the applic task).  The result is that if the DSP
;2889 //     restarts, or if a write should fail one time, the correct settings w
;2890 //     still be quickly (re)asserted.
;2891 //
;2892 //-------------------------------------------------------------------------
;2893 bool MB_DSP_REG(SetRegFuncParams)
;2894 {
	.align	4
$$MB_DSP_REG::
	ex	(sp),iy
$MB_DSP_REG::
	.debug	G $MB_DSP_REG 90 9
	.debug	{ $MB_DSP_REG 90 2893 @185 @184
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-48
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
;2895   uint  ui;
	.debug	L ui -2 7
;2896   RegInfo *mbRegInfo = (RegInfo *)info;
	.debug	L mbRegInfo -4 38
	.debug	# 2896
	ld	hl,(ix+5)
	ld	(ix-4),hl
	.seg	FARCODE
;2897   ulong  dspVal;
	.debug	L dspVal -8 9
;2898   float  fval;
	.debug	L fval -12 10
;2899   const WR_DSP_REG far *dspReg = wrDSPregs;
	.debug	L dspReg -16 89
	.debug	# 2899
	ld	de,word (phys _wrDSPregs)
	ld	c,phys _wrDSPregs >> 16
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	.seg	FARCODE
;2900   char  temp[32];
	.debug	L temp -48 91
;2901 
;2902 
;2903   for (ui=0; ui<NUM_WR_DSP_REGS; ++ui,++dspReg)  {
@186:
	.debug	< @186 @187
	.debug	# 2903
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@188:
	ld	hl,(ix-2)
	ld	de,0x44
	or	a,a
	sbc	hl,de
	jp	nc,@189
;2904     if (dspReg->mbReg != mbRegInfo)  continue;
@191:
	.debug	< @191 @192
	.debug	# 2904
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x5
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-4)
	or	a,a
	sbc	hl,de
	jp	nz,@190
;2905 
;2906   //--- if a phase value, then make sure it is within the range 0 to 360 --
;2907     if (dspReg->type == RT_PHASE)  {
	.debug	# 2907
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	sub	a,99
	jp	nz,@194
;2908       fval = mb2float(newVal, mbRegInfo);
@195:
	.debug	< @195 @196
	.debug	# 2908
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$mb2float
	add	sp,4
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;2909       if ((fval < 0.0) OR (fval >= 360.0))  {
	.debug	# 2909
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	m,@197
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x43b4
	call	__fsub##
	jp	m,@198
@197:
;2910         while (fval < 0.0)  fval += 360.0;
@199:
	.debug	< @199 @200
@201:
	.debug	# 2910
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	jp	p,@202
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x43b4
	call	__fadd##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;2911         while (fval >= 360.0)  fval -= 360.0;
	jr	@201
@202:
@203:
	.debug	# 2911
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x43b4
	call	__fsub##
	jp	m,@204
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0xc3b4
	call	__fadd##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;2912         float2mb(newVal, mbRegInfo, fval);
	jr	@203
@204:
	.debug	# 2912
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$float2mb
	add	sp,8
;2913       }
@200:
	.debug	>
;2914     }
@198:
@196:
	.debug	>
;2915 
;2916   //--- check the new value against the specified range of allowed values -
;2917     if (dspReg->minVal != dspReg->maxVal)  {
@194:
	.debug	# 2917
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xb
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__fequ##
	jp	z,@205
;2918       fval = mb2float(newVal, mbRegInfo);
@206:
	.debug	< @206 @207
	.debug	# 2918
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$mb2float
	add	sp,4
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;2919       if (fval < dspReg->minVal)  float2mb(newVal, mbRegInfo, dspReg->minVa
	.debug	# 2919
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__fsubr##
	jp	p,@208
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$float2mb
	add	sp,8
;2920       if (fval > dspReg->maxVal)  float2mb(newVal, mbRegInfo, dspReg->maxVa
@208:
	.debug	# 2920
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xb
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__fsubr##
	jp	m,@209
	jr	z,@209
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xb
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$float2mb
	add	sp,8
;2921     }
@209:
@207:
	.debug	>
;2922 
;2923     if (mbRegInfo->flags & LogChanges)
@205:
	.debug	# 2923
	ld	hl,(ix-4)
	ld	de,0xd
	add	hl,de
	ld	a,(hl)
	and	a,2
	jr	z,@210
;2924       printf("new value for DSP reg: 0x%08lX: %.32s\r\n",
;2925              dspReg->id, fmtRegVal(mbRegInfo, newVal, 0, temp) );
	.debug	# 2925
	ld	hl,-48+@183
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$fmtRegVal
	add	sp,8
	push	hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	de,word (phys @1+2626)
	ld	c,phys @1+2626 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;2926 
;2927   //--- write the value to the DSP now? ---
;2928     if (dspReg->writeMode == WM_ONCE)  {
@210:
	.debug	# 2928
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xf
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	nz,@211
;2929       mb2dsp(mbRegInfo, newVal, dspReg, &dspVal);
@212:
	.debug	< @212 @213
	.debug	# 2929
	ld	hl,-8+@183
	add	hl,sp
	push	hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$mb2dsp
	add	sp,10
;2930       if (writeDSPReg(dspReg->id, dspVal, true) < 0)  return false;
	.debug	# 2930
	ld	hl,0x1
	push	hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	lcall	$writeDSPReg
	add	sp,10
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@214
	xor	a,a
	jp	@184
;2931     }
@214:
@213:
	.debug	>
;2932 
;2933   //--- update the modbus register value using the new value ---
;2934   // NOTE:  Can't use setMBReg() since that would just call this func again
;2935     switch (mbRegInfo->dataType)  {
@211:
	.debug	# 2935
	ld	hl,(ix-4)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	jr	@215
;2936       case DT_S16:  setS16(_SetRegFuncParams_);  break;
@217:
	.debug	< @217 @218
	.debug	# 2936
@219:
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setS16
	jr	@1844
;2937       case DT_U16:  setU16(_SetRegFuncParams_);  break;
	.debug	# 2937
@220:
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setU16
	jr	@1844
;2938       case DT_S32:  setS32(_SetRegFuncParams_);  break;
	.debug	# 2938
@221:
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setS32
	jr	@1844
;2939       case DT_U32:  setU32(_SetRegFuncParams_);  break;
	.debug	# 2939
@222:
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setU32
	jr	@1844
;2940       case DT_F32:  setF32(_SetRegFuncParams_);  break;
	.debug	# 2940
@223:
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setF32
@1844:
	add	sp,8
;2941     }
	jr	@189
@218:
	.debug	>
;2942     break;
@215:
	or	a,a
	jr	z,@219
	cp	0x1
	jr	z,@220
	cp	0x2
	jr	z,@221
	cp	0x3
	jr	z,@222
	cp	0x4
	jr	z,@223
	jr	@189
@216:
	.debug	# 2942
;2943   }
	jr	@189
@192:
	.debug	>
;2944 
;2945   return true;
@190:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	jp	@188
@189:
@187:
	.debug	>
	.debug	# 2945
	ld	a,0x1
;2946 }
@184:
	.debug	} @184 2946

@183	equ	48
	ld	sp,ix
	pop	ix
	lret
@185	equ	50
;2947 
;2948 //-------------------------------------------------------------------------
;2949 //  process a new value for "cmdBitsAppl"
;2950 //-------------------------------------------------------------------------
;2951 bool MB_cmdBitsAppl(SetRegFuncParams)
;2952 {
	.align	4
$$MB_cmdBitsAppl::
	ex	(sp),iy
$MB_cmdBitsAppl::
	.debug	G $MB_cmdBitsAppl 90 9
	.debug	{ $MB_cmdBitsAppl 90 2951 @226 @225
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
;2953   ulong newFmt = 0;
	.debug	L newFmt -4 9
	.debug	# 2953
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;2954 
;2955   cmdBitsAppl = MB_VAL(ulong);
	.debug	# 2955
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	(_cmdBitsAppl),de
	ld	(_cmdBitsAppl+2),bc
;2956 
;2957 //--- This is the older version of the bit-mapped cmds, so we translate ---
;2958 //--- the best we can in to the newer ones and pass them on ---
;2959 
;2960   if (cmdBitsAppl & OLDC_AMPL_OPEN_LOOP)  newFmt |= CMD_AMPL_PID_OFF;
	.debug	# 2960
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@227
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	set	0,e
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2961   if (cmdBitsAppl & OLDC_AMPL_CLOSED_LOOP)  newFmt |= CMD_AMPL_PID_ON;
@227:
	.debug	# 2961
	ld	de,(_cmdBitsAppl)
	ld	bc,(_cmdBitsAppl+2)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@228
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	set	1,e
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2962 
;2963   if (cmdBitsAppl & OLDC_PHASE_OPEN_LOOP)  newFmt |= CMD_PHASE_CTL_OFF;
@228:
	.debug	# 2963
	ld	de,(_cmdBitsAppl)
	ld	bc,(_cmdBitsAppl+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@229
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	set	2,e
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2964   if (cmdBitsAppl & OLDC_PHASE_CLOSED_LOOP)  newFmt |= CMD_PHASE_CTL_PID;
@229:
	.debug	# 2964
	ld	de,(_cmdBitsAppl)
	ld	bc,(_cmdBitsAppl+2)
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@230
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	set	3,e
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2965 
;2966   if (cmdBitsAppl & OLDC_AMPL_TUNE_RUN)  newFmt |= CMD_RF_PULSING_ON;
@230:
	.debug	# 2966
	ld	de,(_cmdBitsAppl)
	ld	bc,(_cmdBitsAppl+2)
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@231
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	set	6,e
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2967   if (cmdBitsAppl & OLDC_AMPL_TUNE_STOP)  newFmt |= CMD_RF_PULSING_OFF;
@231:
	.debug	# 2967
	ld	de,(_cmdBitsAppl)
	ld	bc,(_cmdBitsAppl+2)
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@232
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	set	7,e
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2968   if (cmdBitsAppl & OLDC_PHASE_TUNE_RUN)  newFmt |= CMD_RF_PULSING_ON;
@232:
	.debug	# 2968
	ld	de,(_cmdBitsAppl)
	ld	bc,(_cmdBitsAppl+2)
	push	bc
	push	de
	ld	de,0x40
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@233
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	set	6,e
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2969   if (cmdBitsAppl & OLDC_PHASE_TUNE_STOP)  newFmt |= CMD_RF_PULSING_OFF;
@233:
	.debug	# 2969
	ld	de,(_cmdBitsAppl)
	ld	bc,(_cmdBitsAppl+2)
	push	bc
	push	de
	ld	de,0x80
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@234
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	set	7,e
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2970 
;2971   if (cmdBitsAppl & OLDC_CAV_TUNER_ON)  newFmt |= CMD_AFC_ON;
@234:
	.debug	# 2971
	ld	de,(_cmdBitsAppl)
	ld	bc,(_cmdBitsAppl+2)
	push	bc
	push	de
	ld	de,0x1000
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@235
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	set	4,d
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2972   if (cmdBitsAppl & OLDC_CAV_TUNER_OFF)  newFmt |= CMD_AFC_OFF;
@235:
	.debug	# 2972
	ld	de,(_cmdBitsAppl)
	ld	bc,(_cmdBitsAppl+2)
	push	bc
	push	de
	ld	de,0x2000
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@236
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	set	5,d
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;2973 
;2974   SetMBReg(setDSPState, 0, U32, newFmt);
@236:
	.debug	# 2974
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_setDSPState_RegInfo
	push	hl
	lcall	$setRegU32
	add	sp,8
;2975 
;2976   return true;
	.debug	# 2976
	ld	a,0x1
;2977 }
@225:
	.debug	} @225 2977

@224	equ	4
	ld	sp,ix
	pop	ix
	lret
@226	equ	6
;2978 
;2979 //-------------------------------------------------------------------------
;2980 //  process a new value for "setAtten"
;2981 //-------------------------------------------------------------------------
;2982 bool MB_setAtten(SetRegFuncParams)
;2983 {
	.align	4
$$MB_setAtten::
	ex	(sp),iy
$MB_setAtten::
	.debug	G $MB_setAtten 90 9
	.debug	{ $MB_setAtten 90 2982 @239 @238
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
;2984   setAtten = MB_VAL(U16);
	.debug	# 2984
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(_setAtten),hl
;2985 
;2986 //  SetMBReg(fwdAtten, 0, U16, setAtten);
;2987 //  SetMBReg(reflAtten, 0, U16, setAtten);
;2988 //  SetMBReg(cavAtten, 0, U16, setAtten);
;2989 
;2990   return true;
	.debug	# 2990
	ld	a,0x1
;2991 }
@238:
	.debug	} @238 2991

@237	equ	0
	pop	ix
	lret
@239	equ	2
;2992 
;2993 //-------------------------------------------------------------------------
;2994 //  process a new value for "setDSPState"
;2995 //-------------------------------------------------------------------------
;2996 bool MB_setDSPState(SetRegFuncParams)
;2997 {
	.align	4
$$MB_setDSPState::
	ex	(sp),iy
$MB_setDSPState::
	.debug	G $MB_setDSPState 90 9
	.debug	{ $MB_setDSPState 90 2996 @242 @241
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
;2998   uint  i;
	.debug	L i -2 7
;2999   ulong  mask, cmdBits;
	.debug	L mask -6 9
	.debug	L cmdBits -10 9
;3000 
;3001 
;3002   cmdBits = MB_VAL(ulong);
	.debug	# 3002
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;3003 
;3004 //--- setDSPState contains cmd bits in groups:  i.e. one bit is asserted to
;3005 //--- enable a state, the other to disable it.  None set within a group ---
;3006 //--- means do not change the current state for the group. ---
;3007 
;3008 //--- Writing of values to the DSP is handled primarily by the application 
;3009 //--- task.  To avoid slowing down the task that called this function ---
;3010 //--- waiting for access to the DSP interface, we just keep track of the --
;3011 //--- most recent setting for each group of bits.  That way the actual ---
;3012 //--- writing of the bits (whenever it happens) will always use the last --
;3013 //--- setting for each group, and we have a record of what state the DSP --
;3014 //--- should be in any given time (and a way to re-assert that state if ---
;3015 //--- the DSP is reset) ---
;3016 
;3017   for (i=0; SetDSPStateMasks[i]; ++i)  {
@243:
	.debug	< @243 @244
	.debug	# 3017
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@245:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_SetDSPStateMasks
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jr	z,@246
;3018     mask = SetDSPStateMasks[i];
@248:
	.debug	< @248 @249
	.debug	# 3018
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_SetDSPStateMasks
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;3019     if (cmdBits & mask) setDSPState = (setDSPState & ~mask) | (cmdBits & ma
	.debug	# 3019
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@250
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__lnot##
	push	bc
	push	de
	ld	de,(_setDSPState)
	ld	bc,(_setDSPState+2)
	call	__land##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__land##
	call	__lor##
	ld	(_setDSPState),de
	ld	(_setDSPState+2),bc
;3020   }
@250:
@249:
	.debug	>
;3021 
;3022 //--- Also, log a message showing what bits were set each time we get a new
;3023 //--- value ---
;3024   for (i=0,mask=1; i<32; ++i,mask<<=1)  if (cmdBits & mask)
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@245
@246:
@244:
	.debug	>
@251:
	.debug	< @251 @252
	.debug	# 3024
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
@253:
	ld	hl,(ix-2)
	ld	de,0x20
	or	a,a
	sbc	hl,de
	jr	nc,@254
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@256
;3025     fprintf(DiagLog, "setDSPstate: Set: %ls\n", SetDSPStateDesc[i]);
	.debug	# 3025
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_SetDSPStateDesc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @1+2666)
	ld	c,phys @1+2666 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;3026 
;3027 
;3028   return true;
@256:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	jr	@253
@254:
@252:
	.debug	>
	.debug	# 3028
	ld	a,0x1
;3029 }
@241:
	.debug	} @241 3029

@240	equ	10
	ld	sp,ix
	pop	ix
	lret
@242	equ	12
;3030 
;3031 //-------------------------------------------------------------------------
;3032 //  process a new value for "setAFCsOnOff"
;3033 //-------------------------------------------------------------------------
;3034 bool MB_setAFCsOnOff(SetRegFuncParams)
;3035 {
	.align	4
$$MB_setAFCsOnOff::
	ex	(sp),iy
$MB_setAFCsOnOff::
	.debug	G $MB_setAFCsOnOff 90 9
	.debug	{ $MB_setAFCsOnOff 90 3034 @259 @258
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
;3036   uint  i;
	.debug	L i -2 7
;3037   ulong  mask, cmdBits;
	.debug	L mask -6 9
	.debug	L cmdBits -10 9
;3038 
;3039 
;3040   cmdBits = MB_VAL(ulong);
	.debug	# 3040
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;3041 
;3042 //--- setAFCState contains cmd bits in groups:  i.e. one bit is asserted to
;3043 //--- enable a state, the other to disable it.  None set within a group ---
;3044 //--- means do not change the current state for the group. ---
;3045 
;3046 //--- Writing of values to the DSP is handled primarily by the application 
;3047 //--- task.  To avoid slowing down the task that called this function ---
;3048 //--- waiting for access to the DSP interface, we just keep track of the --
;3049 //--- most recent setting for each group of bits.  That way the actual ---
;3050 //--- writing of the bits (whenever it happens) will always use the last --
;3051 //--- setting for each group, and we have a record of what state the DSP --
;3052 //--- should be in any given time (and a way to re-assert that state if ---
;3053 //--- the DSP is reset) ---
;3054 
;3055   for (i=0,mask=3; i<10; ++i,mask<<=2)   if (cmdBits & mask)
@260:
	.debug	< @260 @261
	.debug	# 3055
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	de,0x3
	ld	c,d
	ld	b,d
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
@262:
	ld	hl,(ix-2)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	nc,@263
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@265
;3056     setAFCsOnOff = (setAFCsOnOff & ~mask) | (cmdBits & mask);
	.debug	# 3056
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__lnot##
	push	bc
	push	de
	ld	de,(_setAFCsOnOff)
	ld	bc,(_setAFCsOnOff+2)
	call	__land##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__land##
	call	__lor##
	ld	(_setAFCsOnOff),de
	ld	(_setAFCsOnOff+2),bc
;3057 
;3058   for (i=0,mask=1; i<20; ++i,mask<<=1)
@265:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,0x2
	call	__lshl##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	jr	@262
@263:
@261:
	.debug	>
@266:
	.debug	< @266 @267
	.debug	# 3058
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
@268:
	ld	hl,(ix-2)
	ld	de,0x14
	or	a,a
	sbc	hl,de
	jr	nc,@269
;3059     if (cmdBits & mask)  fprintf(DiagLog, "Set: %ls\n", SetAFCsOnOffDesc[i]
	.debug	# 3059
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@271
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_SetAFCsOnOffDesc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @1+2679)
	ld	c,phys @1+2679 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;3060 
;3061   return true;
@271:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	jr	@268
@269:
@267:
	.debug	>
	.debug	# 3061
	ld	a,0x1
;3062 }
@258:
	.debug	} @258 3062

@257	equ	10
	ld	sp,ix
	pop	ix
	lret
@259	equ	12
;3063 
;3064 //-------------------------------------------------------------------------
;3065 //  process a new value for "cmdBitsAppl3"
;3066 //-------------------------------------------------------------------------
;3067 bool MB_cmdBitsAppl3(SetRegFuncParams)
;3068 {
	.align	4
$$MB_cmdBitsAppl3::
	ex	(sp),iy
$MB_cmdBitsAppl3::
	.debug	G $MB_cmdBitsAppl3 90 9
	.debug	{ $MB_cmdBitsAppl3 90 3067 @274 @273
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
;3069   uint  cmdBits;
	.debug	L cmdBits -2 7
;3070   ulong  dummy;
	.debug	L dummy -6 9
;3071 
;3072 //NOTE:  Save ONLY those bits that indicate an ongoing state.  Bits that
;3073 //       are a one time command (like resetting the DSP) must NOT be
;3074 //       saved after acting on them.
;3075 
;3076   cmdBits = (uint) MB_VAL(ulong);
	.debug	# 3076
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(ix-2),hl
;3077 
;3078 
;3079   if (cmdBits & CMD_RESET_DSP)  {
	.debug	# 3079
	ld	de,0x1
	and	hl,de
	jr	z,@275
;3080     if (getLockDSP(5000) <= 0)  return false;
@276:
	.debug	< @276 @277
	.debug	# 3080
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	lcall	$getLockDSP
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@287
	jr	c,@287
;3081     resetDSP();
	.debug	# 3081
	lcall	$resetDSP
;3082     releaseLockDSP();
	.debug	# 3082
	lcall	$releaseLockDSP
;3083   }
@277:
	.debug	>
;3084 
;3085   if (hdwType != HT_PHASE_CTLR)  {  // no longer supported on actual hdw
@275:
	.debug	# 3085
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jp	z,@280
;3086     if (cmdBits & CMD_CALC_CTF)  {
@281:
	.debug	< @281 @282
	.debug	# 3086
	ld	hl,(ix-2)
	dec	e
	and	hl,de
	jp	z,@283
;3087       if (getLockDSP(5000) <= 0)  return false;
@284:
	.debug	< @284 @285
	.debug	# 3087
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	lcall	$getLockDSP
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@287
	jr	nc,@286
@287:
	xor	a,a
	jp	@273
;3088       if (calcStartTimeCTF == 0)  {
@286:
	.debug	# 3088
	ld	de,(_calcStartTimeCTF)
	ld	bc,(_calcStartTimeCTF+2)
	ld	hl,bc
	or	hl,de
	jp	nz,@288
;3089         fprintf(DiagLog, "Starting CTF calculation...\n");
@289:
	.debug	< @289 @290
	.debug	# 3089
	ld	de,word (phys @1+2689)
	ld	c,phys @1+2689 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;3090         readDSPReg(CalcCTF, &dummy);
	.debug	# 3090
	ld	hl,-6+@272
	add	hl,sp
	push	hl
	ld	de,0x216
	ld	bc,0x10
	push	bc
	push	de
	lcall	$readDSPReg
	add	sp,6
;3091         calcStartTimeCTF = GetMS();  percentCTF = 0;
	.debug	# 3091
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_calcStartTimeCTF),de
	ld	(_calcStartTimeCTF+2),bc
	bool	hl
	ld	l,h
	ld	(_percentCTF),hl
;3092       }
@290:
	.debug	>
;3093       releaseLockDSP();
@288:
	.debug	# 3093
	lcall	$releaseLockDSP
;3094     }
@285:
	.debug	>
;3095   }
@283:
@282:
	.debug	>
;3096 
;3097   return true;
@280:
	.debug	# 3097
	ld	a,0x1
;3098 }
@273:
	.debug	} @273 3098

@272	equ	6
	ld	sp,ix
	pop	ix
	lret
@274	equ	8
;3099 
;3100 
;3101 //-------------------------------------------------------------------------
;3102 //  process a new value for an amplitude value that needs to be checked
;3103 //  against maxAmplSet
;3104 //-------------------------------------------------------------------------
;3105 bool MB_maxAmpl(SetRegFuncParams)
;3106 {
	.align	4
$$MB_maxAmpl::
	ex	(sp),iy
$MB_maxAmpl::
	.debug	G $MB_maxAmpl 90 9
	.debug	{ $MB_maxAmpl 90 3105 @293 @292
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
;3107   if (REG->dataType != DT_F32)  return false;
	.debug	# 3107
	ld	hl,(ix+5)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	sub	a,4
	jr	z,@294
	xor	a,a
	jr	@292
;3108 
;3109   if (MB_VAL(F32) > maxAmplSet)  MB_VAL(F32) = maxAmplSet;
@294:
	.debug	# 3109
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,(_maxAmplSet)
	ld	bc,(_maxAmplSet+2)
	call	__fsub##
	jp	m,@295
	jr	z,@295
	ld	de,(_maxAmplSet)
	ld	bc,(_maxAmplSet+2)
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3110 
;3111   return setF32(_SetRegFuncParams_);
@295:
	.debug	# 3111
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setF32
	add	sp,8
;3112 }
@292:
	.debug	} @292 3112

@291	equ	0
	pop	ix
	lret
@293	equ	2
;3113 
;3114 
;3115 //-------------------------------------------------------------------------
;3116 //  process a new value for "oldPulseFreq"
;3117 //-------------------------------------------------------------------------
;3118 bool MB_oldPulseFreq(SetRegFuncParams)
;3119 {
	.align	4
$$MB_oldPulseFreq::
	ex	(sp),iy
$MB_oldPulseFreq::
	.debug	G $MB_oldPulseFreq 90 9
	.debug	{ $MB_oldPulseFreq 90 3118 @298 @297
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
;3120   float  newPulseFreq;
	.debug	L newPulseFreq -4 10
;3121 
;3122 
;3123   oldPulseFreq = MB_VAL(U16);
	.debug	# 3123
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(_oldPulseFreq),hl
;3124 
;3125   newPulseFreq = (float) oldPulseFreq;
	.debug	# 3125
	ex	de,hl
	call	__uitof##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3126 
;3127   return SetMBReg(pulseFreq, 0, F32, newPulseFreq);
	.debug	# 3127
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_pulseFreq_RegInfo
	push	hl
	lcall	$setRegF32
	add	sp,8
;3128 }
@297:
	.debug	} @297 3128

@296	equ	4
	ld	sp,ix
	pop	ix
	lret
@298	equ	6
;3129 
;3130 
;3131 //-------------------------------------------------------------------------
;3132 //  process a new value for "dspProgNum"
;3133 //-------------------------------------------------------------------------
;3134 bool MB_dspProgNum(SetRegFuncParams)
;3135 {
	.align	4
$$MB_dspProgNum::
	ex	(sp),iy
$MB_dspProgNum::
	.debug	G $MB_dspProgNum 90 9
	.debug	{ $MB_dspProgNum 90 3134 @301 @300
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
;3136   if (MB_VAL(uint) > 3)  return false;
	.debug	# 3136
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	c,@302
	jr	z,@302
	xor	a,a
	jr	@300
;3137 
;3138   dspProgNum = MB_VAL(uint);  return true;
@302:
	.debug	# 3138
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(_dspProgNum),hl
	ld	a,0x1
;3139 }
@300:
	.debug	} @300 3139

@299	equ	0
	pop	ix
	lret
@301	equ	2
;3140 
;3141 //-------------------------------------------------------------------------
;3142 //  process a new value for pllInitIdx register
;3143 //-------------------------------------------------------------------------
;3144 /*
;3145 bool MB_pllInitIdx(SetRegFuncParams)
;3146 {
;3147   uint  ui = MB_VAL(uint);
;3148 
;3149   if (ui > PLLInitIdxMax)  ui = PLLInitIdxMax;
;3150 
;3151   _EnterCritical_();  pllInitIdx = ui;  _ExitCritical_();
;3152 
;3153   return true;
;3154 }
;3155 */
;3156 
;3157 //-------------------------------------------------------------------------
;3158 //  process a new value for one of the xxxGain registers
;3159 //-------------------------------------------------------------------------
;3160 bool MB_setGain(SetRegFuncParams)
;3161 {
	.align	4
$$MB_setGain::
	ex	(sp),iy
$MB_setGain::
	.debug	G $MB_setGain 90 9
	.debug	{ $MB_setGain 90 3160 @305 @304
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
;3162   if (REG->dataType != DT_F32)  return false;
	.debug	# 3162
	ld	hl,(ix+5)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	sub	a,4
	jr	nz,@1843
;3163 
;3164   if (MB_VAL(float) == 0.0)  return false;
	.debug	# 3164
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	a,(hl)
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	nz,@307
@1843:
	xor	a,a
	jr	@304
;3165 
;3166   return setF32(_SetRegFuncParams_);
@307:
	.debug	# 3166
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setF32
	add	sp,8
;3167 }
@304:
	.debug	} @304 3167

@303	equ	0
	pop	ix
	lret
@305	equ	2
;3168 
;3169 
;3170 //-------------------------------------------------------------------------
;3171 //  process a new value for a register with a phase value
;3172 //-------------------------------------------------------------------------
;3173 bool MB_setPhase(SetRegFuncParams)
;3174 {
$MB_setPhase::
	.debug	G $MB_setPhase 90 9
	.debug	{ $MB_setPhase 90 3173 @310 @309
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
;3175   if (REG->dataType != DT_F32)  return false;
	.debug	# 3175
	ld	hl,(ix+5)
	ld	de,0xa
	add	hl,de
	ld	a,(hl)
	sub	a,4
	jr	z,@311
	xor	a,a
	jp	@309
;3176 
;3177   if (MB_VAL(float) < -720.0)  MB_VAL(float) = -360.0;
@311:
	.debug	# 3177
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0
	ld	bc,0xc434
	call	__fsub##
	jp	p,@312
	ld	de,0
	ld	bc,0xc3b4
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3178   if (MB_VAL(float) >  720.0)  MB_VAL(float) =  360.0;
@312:
	.debug	# 3178
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4434
	call	__fsub##
	jp	m,@313
	jr	z,@313
	ld	de,0
	ld	bc,0x43b4
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3179 
;3180   while (MB_VAL(float) < -360.0)  MB_VAL(float) += 360.0;
@313:
@314:
	.debug	# 3180
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0
	ld	bc,0xc3b4
	call	__fsub##
	jp	p,@315
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x43b4
	call	__fadd##
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3181   while (MB_VAL(float) >  360.0)  MB_VAL(float) -= 360.0;
	jr	@314
@315:
@316:
	.debug	# 3181
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x43b4
	call	__fsub##
	jp	m,@317
	jr	z,@317
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0
	ld	bc,0xc3b4
	call	__fadd##
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3182 
;3183   return setF32(_SetRegFuncParams_);
	jr	@316
@317:
	.debug	# 3183
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	bool	hl
	ld	l,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$setF32
	add	sp,8
;3184 }
@309:
	.debug	} @309 3184

@308	equ	0
	pop	ix
	lret
@310	equ	2
;3185 
;3186 
;3187 //-------------------------------------------------------------------------
;3188 //
;3189 //-------------------------------------------------------------------------
;3190 int _nearcall PV_UpdateVal(PV_OP_Params)
;3191 {
	.align	4
$$PV_UpdateVal::
	ex	(sp),iy
$PV_UpdateVal::
	.debug	G $PV_UpdateVal 92 9
	.debug	{ $PV_UpdateVal 92 3190 @320 @319
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A pv 5 93
;3192   //finish:  Need to update pv->newEvents and pv->val for any non-waveform
;3193   //         PVs that don't do it elsewhere
;3194 
;3195 //  printf("PV_UpdateVal(%ls)\r\n", pv->pvInfo.name);  //tdebug
;3196 
;3197   return -1;
	.debug	# 3197
	ld	hl,0xffff
;3198 }
@319:
	.debug	} @319 3198

@318	equ	0
	pop	ix
	lret
@320	equ	2
;3199 
;3200 //-------------------------------------------------------------------------
;3201 //
;3202 //-------------------------------------------------------------------------
;3203 int _nearcall PV_LockVal(PV_Lock_Params)
;3204 {
	.align	4
$$PV_LockVal::
	ex	(sp),iy
$PV_LockVal::
	.debug	G $PV_LockVal 94 9
	.debug	{ $PV_LockVal 94 3203 @323 @322
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A pv 5 93
	.debug	A lockMode 7 6
	.debug	A lockType 9 6
;3205   //finish:  Implement locking for non-waveform values
;3206 
;3207 //tdebug
;3208 //  printf("\r\nPV_LockVal(%ls, %d, %d)\r\n", pv->pvInfo.name, lockMode, lo
;3209 
;3210   return 0;
	.debug	# 3210
	bool	hl
	ld	l,h
;3211 }
@322:
	.debug	} @322 3211

@321	equ	0
	pop	ix
	lret
@323	equ	2
;3212 
;3213 //-------------------------------------------------------------------------
;3214 //
;3215 //-------------------------------------------------------------------------
;3216 int _nearcall PV_SendVal(PV_RW_Params)
;3217 {
	.align	4
$$PV_SendVal::
	ex	(sp),iy
$PV_SendVal::
	.debug	G $PV_SendVal 95 9
	.debug	{ $PV_SendVal 95 3216 @326 @325
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-13
	.debug	A id 5 6
	.debug	A numElems 7 7
	.debug	A conInfo 9 80
	.debug	A copyFunc 11 96
;3218   PV_Info  pvInfo;
	.debug	L pvInfo -13 98
;3219 
;3220 
;3221   //finish:  call (*copyFunc)(void *conInfo, void far *from, uint count)
;3222   //         as needed to send PV value
;3223 
;3224   if (!pvGetInfo(id, &pvInfo))  pvInfo.name = "<invalid>";
	.debug	# 3224
	ld	hl,-13+@324
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$pvGetInfo
	add	sp,4
	bool	hl
	jr	nz,@327
	ld	de,word (phys @1+2718)
	ld	c,phys @1+2718 >> 16
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
;3225 
;3226   printf("PV_SendVal(%ls)\r\n", pvInfo.name);  //tdebug
@327:
	.debug	# 3226
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+2728)
	ld	c,phys @1+2728 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3227 
;3228   return -1;
	.debug	# 3228
	ld	hl,0xffff
;3229 }
@325:
	.debug	} @325 3229

@324	equ	13
	ld	sp,ix
	pop	ix
	lret
@326	equ	15
;3230 
;3231 //-------------------------------------------------------------------------
;3232 //
;3233 //-------------------------------------------------------------------------
;3234 int _nearcall PV_RcvVal(PV_RW_Params)
;3235 {
	.align	4
$$PV_RcvVal::
	ex	(sp),iy
$PV_RcvVal::
	.debug	G $PV_RcvVal 95 9
	.debug	{ $PV_RcvVal 95 3234 @330 @329
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-13
	.debug	A id 5 6
	.debug	A numElems 7 7
	.debug	A conInfo 9 80
	.debug	A copyFunc 11 96
;3236   PV_Info  pvInfo;
	.debug	L pvInfo -13 98
;3237 
;3238 
;3239   //finish:  call (*copyFunc)(void *conInfo, void far *from, uint count)
;3240   //         as needed to get new PV value
;3241   //         (probably need more info so we know how big a payload is in
;3242   //         the message that caused this call)
;3243 
;3244   if (!pvGetInfo(id, &pvInfo))  pvInfo.name = "<invalid>";
	.debug	# 3244
	ld	hl,-13+@328
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$pvGetInfo
	add	sp,4
	bool	hl
	jr	nz,@331
	ld	de,word (phys @1+2718)
	ld	c,phys @1+2718 >> 16
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
;3245 
;3246   printf("PV_RcvVal(%ls)\r\n", pvInfo.name);  //tdebug
@331:
	.debug	# 3246
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+2746)
	ld	c,phys @1+2746 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3247 
;3248   return -1;
	.debug	# 3248
	ld	hl,0xffff
;3249 }
@329:
	.debug	} @329 3249

@328	equ	13
	ld	sp,ix
	pop	ix
	lret
@330	equ	15
;3250 
;3251 
;3252 //-------------------------------------------------------------------------
;3253 //  If newer data available, update the copy of a PV's value that is sent t
;3254 //  external clients (and update the newEvents flag indicating what events 
;3255 //  new data applies to).
;3256 //-------------------------------------------------------------------------
;3257 int _nearcall PV_UpdateValWF(PV_OP_Params)
;3258 {
	.align	4
$$PV_UpdateValWF::
	ex	(sp),iy
$PV_UpdateValWF::
	.debug	G $PV_UpdateValWF 92 9
	.debug	{ $PV_UpdateValWF 92 3257 @334 @333
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-21
	.debug	A pv 5 93
;3259   bool noChange;
	.debug	L noChange -1 3
;3260   int  stat;
	.debug	L stat -3 6
;3261   uint  src, cpy, numBytes, srcLockID, cpyLockID;
	.debug	L src -5 7
	.debug	L cpy -7 7
	.debug	L numBytes -9 7
	.debug	L srcLockID -11 7
	.debug	L cpyLockID -13 7
;3262   char far  *srcBuf, *cpyBuf;
	.debug	L srcBuf -17 50
	.debug	L cpyBuf -21 50
;3263 
;3264 
;3265   if ((src = WF_IDX(pv->val) - 1) >= NUM_WAVEFORMS*2)  return -1;
	.debug	# 3265
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys _waveformData)
	ld	c,phys _waveformData >> 16
	call	__lsub##
	ld	a,0x2
	call	__lshr##
	ld	a,0xa
	call	__lshr##
	dec	de
	ex	de,hl
	ld	(ix-5),hl
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jp	nc,@339
;3266   cpy = src + 1;
	.debug	# 3266
	ld	hl,(ix-5)
	inc	hl
	ld	(ix-7),hl
;3267 
;3268 //--- Don't even TRY to get the locks unless we KNOW there is new data ---
;3269   _EnterCritical_();
	.debug	# 3269
	ipset	2
;3270   noChange = (dataTimeMS[cpy] == dataTimeMS[src]);
	.debug	# 3270
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeMS
	add	hl,de
	ex	de,hl
	ld	hl,(ix-5)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_dataTimeMS
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	ld	de,0
	jr	nz,@336
	inc	e
@336:
	ld	(ix-1),e
;3271   _ExitCritical_();
	.debug	# 3271
	ipres
;3272   if (noChange)  return 0;
	.debug	# 3272
	ld	a,e
	or	a,a
	jr	z,@337
	bool	hl
	ld	l,h
	jp	@333
;3273 
;3274 
;3275   srcBuf = (char far *) waveformData[src];    srcLockID = WAVE_DATA_0 + src
@337:
	.debug	# 3275
	ld	hl,(ix-5)
	ex	de,hl
	ld	bc,0
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _waveformData)
	ld	c,phys _waveformData >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-15),hl
	ex	de,hl
	ld	(ix-17),hl
	ex	de,hl
	ld	hl,(ix-5)
	inc	hl
	ld	(ix-11),hl
;3276   cpyBuf = (char far *) waveformData[cpy];    cpyLockID = WAVE_DATA_0 + cpy
	.debug	# 3276
	ld	hl,(ix-7)
	ex	de,hl
	ld	bc,0
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _waveformData)
	ld	c,phys _waveformData >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-19),hl
	ex	de,hl
	ld	(ix-21),hl
	ex	de,hl
	ld	hl,(ix-7)
	inc	hl
	ld	(ix-13),hl
;3277 
;3278 
;3279 //--- Get a lock on the dest/cpy buffer so it won't change while we are ---
;3280 //--- accessing (and possibly updating) it ---
;3281 
;3282   if (getLock(cpyLockID, 0) <= 0)  return -1;  // try to get lock on dest b
	.debug	# 3282
	ld	de,0
	ld	c,e
	ld	b,e
	push	bc
	push	de
	push	hl
	lcall	$getLock
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@339
	jr	nc,@338
@339:
	ld	hl,0xffff
	jp	@333
;3283 
;3284 //--- If the timestamps for the source and destination buffers are ---
;3285 //--- different, then update the contents and timestamp for the ---
;3286 //--- destination buffer.  NOTE that we don't really care about the ---
;3287 //--- possibility of the src date/time changing during the check as ---
;3288 //--- all we really care about is whether or not it IS different. ---
;3289 
;3290   stat = 0;
@338:
	.debug	# 3290
	bool	hl
	ld	l,h
	ld	(ix-3),hl
;3291   if (dataTimeMS[cpy] != dataTimeMS[src])  do {
	.debug	# 3291
	ld	hl,(ix-7)
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeMS
	add	hl,de
	ex	de,hl
	ld	hl,(ix-5)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_dataTimeMS
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	jp	z,@340
;3292     if (getLock(srcLockID, 0) <= 0)  { stat = -1;  break; }  // try to get 
@344:
	.debug	< @344 @345
	.debug	# 3292
	ld	de,0
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix-11)
	push	hl
	lcall	$getLock
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@347
	jr	nc,@346
@347:
@348:
	.debug	< @348 @349
	ld	hl,0xffff
	ld	(ix-3),hl
	jp	@342
@349:
	.debug	>
;3293 
;3294     numBytes = numDataPoints[src]<<2;
@346:
	.debug	# 3294
	ld	hl,(ix-5)
	add	hl,hl
	ld	de,_numDataPoints
	add	hl,de
	ld	hl,(hl)
	add	hl,hl
	add	hl,hl
	ld	(ix-9),hl
;3295 
;3296     fmemcpy(cpyBuf, srcBuf, numBytes);
	.debug	# 3296
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;3297     numDataPoints[cpy] = numDataPoints[src];
	.debug	# 3297
	ld	hl,(ix-5)
	add	hl,hl
	ld	de,_numDataPoints
	add	hl,de
	ex	de,hl
	ld	hl,(ix-7)
	add	hl,hl
	ld	bc,de
	ld	de,_numDataPoints
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3298     dataTimeSecs[cpy] = dataTimeSecs[src];
	.debug	# 3298
	ld	hl,(ix-5)
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeSecs
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-7)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_dataTimeSecs
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3299     dataTimeMS[cpy] = dataTimeMS[src];
	.debug	# 3299
	ld	hl,(ix-5)
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeMS
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-7)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_dataTimeMS
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3300 
;3301     releaseLock(srcLockID);  // release lock on src buffer
	.debug	# 3301
	ld	hl,(ix-11)
	push	hl
	lcall	$releaseLock
	pop	de
;3302 
;3303     pv->pvInfo.size = numBytes;
	.debug	# 3303
	ld	hl,(ix+5)
	ld	de,0x5
	add	hl,de
	ex	de,hl
	ld	hl,(ix-9)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3304     pv->pvInfo.numElems = numDataPoints[src];
	.debug	# 3304
	ld	hl,(ix-5)
	add	hl,hl
	ld	de,_numDataPoints
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x9
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3305 
;3306     pv->newEvents |= DBE_VALUE;
	.debug	# 3306
	ld	hl,(ix+5)
	ld	de,0x13
	add	hl,de
	ld	a,(hl)
	or	a,1
	ld	(hl),a
;3307 
;3308     if (ShowDebugMsgs)  //tdebug
	.debug	# 3308
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x800
	and	hl,de
	jr	z,@350
;3309       printf("Updated copy of PV val: [%ls]\r\n", pv->pvInfo.name);  //tdeb
	.debug	# 3309
	ld	hl,(ix+5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @1+2763)
	ld	c,phys @1+2763 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3310   } while (0);
@350:
@345:
	.debug	>
	.debug	# 3310
;3311 
;3312   releaseLock(cpyLockID);
@342:
@340:
	.debug	# 3312
	ld	hl,(ix-13)
	push	hl
	lcall	$releaseLock
	pop	de
;3313 
;3314   return stat;
	.debug	# 3314
	ld	hl,(ix-3)
;3315 }
@333:
	.debug	} @333 3315

@332	equ	21
	ld	sp,ix
	pop	ix
	lret
@334	equ	23
;3316 
;3317 
;3318 //-------------------------------------------------------------------------
;3319 //  Attempt to obtain or release a read or write lock on a waveform PV.
;3320 //
;3321 //  Returns the depth of the lock or < 0 if not successsful.
;3322 //
;3323 //  For lockMode LM_TryLock, a return value < 0 and errno == EAGAIN means
;3324 //  it could not get the lock w/o blocking.
;3325 //-------------------------------------------------------------------------
;3326 int _nearcall PV_LockWave(PV_Lock_Params)
;3327 {
	.align	4
$$PV_LockWave::
	ex	(sp),iy
$PV_LockWave::
	.debug	G $PV_LockWave 94 9
	.debug	{ $PV_LockWave 94 3326 @353 @352
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A pv 5 93
	.debug	A lockMode 7 6
	.debug	A lockType 9 6
;3328   uint  src, cpy, lockID;
	.debug	L src -2 7
	.debug	L cpy -4 7
	.debug	L lockID -6 7
;3329 
;3330 
;3331 //tdebug
;3332 //  printf("\r\nLock PV val: [%ls]  mode:[%d]  type:[%d]\r\n",
;3333 //         pv->pvInfo.name, lockMode, lockType);
;3334 
;3335   if ((src = WF_IDX(pv->val) - 1) >= NUM_WAVEFORMS*2)  return -1;
	.debug	# 3335
	ld	hl,(ix+5)
	ld	de,0xd
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys _waveformData)
	ld	c,phys _waveformData >> 16
	call	__lsub##
	ld	a,0x2
	call	__lshr##
	ld	a,0xa
	call	__lshr##
	dec	de
	ex	de,hl
	ld	(ix-2),hl
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	nc,@361
;3336   cpy = src + 1;
	.debug	# 3336
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-4),hl
;3337 
;3338   switch (lockType)  {
	.debug	# 3338
	ld	hl,(ix+9)
	jr	@355
;3339     case LT_READ:  lockID = WAVE_DATA_0 + cpy;  break;
@357:
	.debug	< @357 @358
	.debug	# 3339
@359:
	ld	hl,(ix-4)
	jr	@1842
;3340     case LT_WRITE:  lockID = WAVE_DATA_0 + src;  break;
	.debug	# 3340
@360:
	ld	hl,(ix-2)
@1842:
	inc	hl
	ld	(ix-6),hl
;3341     default:  return -1;
	jr	@356
	.debug	# 3341
@361:
	ld	hl,0xffff
	jr	@352
;3342   }
@358:
	.debug	>
;3343 
;3344   switch (lockMode)  {
@355:
	ex	de,hl
	ld	a,d
	or	a,e
	jr	z,@359
	ld	hl,0xffffffff
	add	hl,de
	bool	hl
	jr	z,@360
	jr	@361
@356:
	.debug	# 3344
	ld	hl,(ix+7)
	jr	@362
;3345     case LM_Unlock:    return releaseLock(lockID);
@364:
	.debug	< @364 @365
	.debug	# 3345
@366:
	ld	hl,(ix-6)
	push	hl
	lcall	$releaseLock
	pop	de
	jr	@352
;3346     case LM_WaitLock:  return getLock(lockID, 5000);
	.debug	# 3346
@367:
	ld	de,0x1388
	ld	bc,0
	jr	@1841
;3347     case LM_TryLock:   return getLock(lockID, 0);
	.debug	# 3347
@368:
	ld	de,0
	ld	c,e
	ld	b,e
@1841:
	push	bc
	push	de
	ld	hl,(ix-6)
	push	hl
	lcall	$getLock
	add	sp,6
	jr	@352
;3348   }
@365:
	.debug	>
;3349 
;3350   return -1;
@362:
	ex	de,hl
	ld	a,d
	or	a,e
	jr	z,@366
	ld	hl,0xffffffff
	add	hl,de
	bool	hl
	jr	z,@367
	ld	hl,0xfffffffe
	add	hl,de
	bool	hl
	jr	z,@368
@363:
	.debug	# 3350
	ld	hl,0xffff
;3351 }
@352:
	.debug	} @352 3351

@351	equ	6
	ld	sp,ix
	pop	ix
	lret
@353	equ	8
;3352 
;3353 
;3354 //-------------------------------------------------------------------------
;3355 
;3356 
;3357 #define SharedFuncs
;3358 #include <sharedAppl.c>
;3359 
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
$initModBusRegs::
	.debug	G $initModBusRegs 99 9
	.debug	{ $initModBusRegs 99 454 @371 @370
	.debug	# 456
	ld	hl,0x64
	ld	(_C0ChanMult),hl
	ld	l,0x1
	ld	(_NumC0Chans),hl
	.debug	# 457
	ld	l,0x64
	ld	(_R3ChanMult),hl
	ld	l,0x1
	ld	(_NumR3Chans),hl
	.debug	# 458
	ld	hl,0x190
	ld	(_R4ChanMult),hl
	ld	hl,0x1
	ld	(_NumR4Chans),hl
	.debug	# 460
	lcall	$pvInitLists
	bool	hl
	jr	z,@372
@373:
	.debug	< @373 @374
	.debug	# 461
	ld	a,0x1
	ld	(_doShutdown),a
	.debug	# 462
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@375
	ld	a,0x1
	ld	(_runBackup),a
	ld	(_doReboot),a
@375:
@374:
	.debug	>
@372:
@370:
	.debug	} @370 464

@369	equ	0
	lret
@371	equ	0
	.align	4
$$MB_timeZone::
	ex	(sp),iy
$MB_timeZone::
	.debug	G $MB_timeZone 90 9
	.debug	{ $MB_timeZone 90 470 @378 @377
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
	.debug	L intVal -2 6
	.debug	# 474
	ld	hl,(ix+9)
	ld	hl,(hl)
	ld	(ix-2),hl
	.debug	# 476
	ld	de,0x7ff4
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@379
	ld	hl,(ix-2)
	ld	de,0x800c
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@380
	jr	z,@380
@379:
	xor	a,a
	jr	@377
@380:
	.debug	# 478
	ld	hl,(ix-2)
	ld	(_timeZone),hl
	.debug	# 479
	ld	a,(_startupComplete)
	or	a,a
	jr	z,@381
	push	hl
	ld	de,word (phys @1+2795)
	ld	c,phys @1+2795 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
@381:
	.debug	# 481
	ipset	2
	.debug	# 482
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	d,0
	ld	e,(ix+7)
	ex	de,hl
	add	hl,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix+9)
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	.debug	# 483
	ipres
	.debug	# 485
	ld	a,0x1
@377:
	.debug	} @377 486

@376	equ	2
	ld	sp,ix
	pop	ix
	lret
@378	equ	4
	.align	4
$$MB_cmdBitsStd::
	ex	(sp),iy
$MB_cmdBitsStd::
	.debug	G $MB_cmdBitsStd 90 9
	.debug	{ $MB_cmdBitsStd 90 494 @384 @383
	ld	hl,-132
	call	__fent##
	.debug	A info 5 80
	.debug	A chanNum 7 3
	.debug	A newVal 9 80
	.debug	A eventsfd 11 6
	.debug	L cmdBits -4 9
	.debug	L buf -132 100
	.debug	# 503
	ld	hl,(ix+9)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.debug	# 505
	push	bc
	push	de
	ld	de,0x1
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@385
	ld	a,0x1
	ld	(_doReboot),a
	ld	(_doShutdown),a
@385:
	.debug	# 507
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@386
	ld	a,0x1
	ld	(_doShutdown),a
@386:
	.debug	# 509
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@387
	.debug	# 510
	ld	hl,0x1
	push	hl
	ld	hl,_devDataFile
	push	hl
	ld	hl,0x80
	push	hl
	ld	hl,-126+@382
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
@387:
	.debug	# 511
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@388
	ld	hl,_devDataFile
	push	hl
	lcall	$loadParamsMsg
	pop	de
@388:
	.debug	# 513
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@389
	.debug	# 514
	ld	hl,0x1
	push	hl
	ld	hl,_hdwCfgFile
	push	hl
	ld	hl,0x80
	push	hl
	ld	hl,-126+@382
	add	hl,sp
	push	hl
	lcall	$saveParams
	add	sp,8
@389:
	.debug	# 515
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@390
	ld	hl,_hdwCfgFile
	push	hl
	lcall	$loadParamsMsg
	pop	de
@390:
	.debug	# 523
	ld	a,0x1
@383:
	.debug	} @383 524

@382	equ	132
	ld	sp,ix
	pop	ix
	lret
@384	equ	134
$rwIO::
	.debug	G $rwIO 99 9
	.debug	{ $rwIO 99 531 @393 @392
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-28
	.bseg
@394:
	.ds	2
	.debug	S ioTicks @394 6
	.seg	FARCODE
	.debug	L ui -2 7
	.debug	L chgdMask -4 7
	.debug	L chgBit -6 7
	.debug	L aout -10 101
	.debug	L update -12 70
	.debug	L startTicks -16 9
	.debug	L endTicks -20 9
	.debug	L rwStartTicks -24 9
	.debug	L rwEndTicks -28 9
	.debug	# 541
	ld	hl,(@394)
	inc	hl
	ld	(@394),hl
	.debug	# 543
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	.debug	# 546
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	inc	l
	ld	(ix-6),hl
	.debug	# 547
	ld	de,(_DAC_Mask)
	ld	bc,(_DAC_Mask+2)
	ld	hl,bc
	or	hl,de
	jp	z,@395
@396:
	.debug	< @396 @397
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@398:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jp	nc,@399
@401:
	.debug	< @401 @402
	.debug	# 548
	ld	hl,(ix-2)
	ld	de,_updateAOut
	add	hl,de
	ld	(ix-12),hl
	.debug	# 550
	ld	hl,(ix-2)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nc,@403
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_lastSetVal
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fequ##
	jr	z,@404
@405:
	.debug	< @405 @406
	.debug	# 551
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_lastSetVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-12)
	ld	(hl),0x1
@406:
	.debug	>
@404:
@403:
	.debug	# 553
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaOut
	add	hl,de
	ex	de,hl
	call	__farcvp##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	.debug	# 554
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_lastAnaOut
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fequ##
	jr	z,@407
	ld	hl,(ix-12)
	ld	(hl),0x1
@407:
	.debug	# 556
	ld	hl,(ix-12)
	ld	a,(hl)
	or	a,a
	jp	z,@400
	.debug	# 557
	xor	a,a
	ld	(hl),a
	.debug	# 559
	ld	hl,(ix-2)
	ld	de,_dacForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@409
	.debug	# 560
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_dacForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
	jr	@410
@409:
	.debug	# 562
	ld	hl,(ix-2)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@411
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_setGain
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fdivr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_setOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fadd##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@411:
@410:
	.debug	# 563
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fsubr##
	jp	p,@412
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMin
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@412:
	.debug	# 564
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fsubr##
	jp	m,@413
	jr	z,@413
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_aoutMax
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farst4p##
@413:
	.debug	# 565
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_lastAnaOut
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	.debug	# 567
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld4##
	call	__fdivr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fadd##
	call	__ftol##
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_dacRaw
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	hl,de
	ld	(ix-4),hl
@402:
	.debug	>
@400:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	add	hl,hl
	ld	(ix-6),hl
	jp	@398
@399:
@397:
	.debug	>
@395:
	.debug	# 571
	ld	hl,(_hdwType)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@414
	ld	hl,(@394)
	ld	e,0x1f
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@415
	ld	b,a
@416:
	add	hl,hl
	djnz	@416
@415:
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	hl,de
	ld	(ix-4),hl
@414:
	.debug	# 574
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastReadTime),hl
	.debug	# 575
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	.debug	# 576
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	ld	hl,bc
	or	hl,de
	jr	z,@417
	push	bc
	push	de
	lcall	$readAnalogInputs
	add	sp,4
@417:
	.debug	# 577
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	.debug	# 578
	lcall	$ReadDigInputs
	ld	(_digitalIn),de
	ld	(_digitalIn+2),bc
	.debug	# 579
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	ld	(_readTicks),de
	.debug	# 582
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	.debug	# 583
	ld	de,(_DAC_Mask)
	ld	bc,(_DAC_Mask+2)
	ld	hl,bc
	or	hl,de
	jr	z,@418
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	d,h
	ld	e,l
	ld	bc,(_DAC_Mask+2)
	call	__land##
	push	bc
	push	de
	lcall	$writeAnalogOutputs
	add	sp,4
@418:
	.debug	# 584
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	.debug	# 585
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
	.debug	# 586
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	ld	(_writeTicks),de
	.debug	# 589
	ld	de,(_ADC_Mask)
	ld	bc,(_ADC_Mask+2)
	ld	hl,bc
	or	hl,de
	jp	z,@419
@420:
	.debug	< @420 @421
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@422:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jp	nc,@423
@425:
	.debug	< @425 @426
	.debug	# 590
	ld	hl,(ix-2)
	ld	de,_updateAIn
	add	hl,de
	ld	(ix-12),hl
	.debug	# 591
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	hl,(hl)
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@427
@428:
	.debug	< @428 @429
	.debug	# 592
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	ld	bc,de
	ld	de,_lastadcRaw
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-12)
	ld	(hl),0x1
@429:
	.debug	>
@427:
	.debug	# 593
	ld	hl,(ix-12)
	ld	a,(hl)
	or	a,a
	jp	z,@424
	.debug	# 594
	xor	a,a
	ld	(hl),a
	.debug	# 595
	ld	hl,(ix-2)
	ld	de,_adcForced
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@431
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_adcForcedVal
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@432
@431:
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_adcRaw
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__uitof##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
@432:
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_anaIn
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	.debug	# 596
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@433
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_readOffset
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsubr##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_readGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_readVal
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@433:
	.debug	# 597
	ld	hl,(ix-2)
	ld	de,_newRdg
	add	hl,de
	ld	a,0x1
	ld	(hl),a
@426:
	.debug	>
@424:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@422
@423:
@421:
	.debug	>
@419:
	.debug	# 601
	lcall	$updateAvgsADC
	.debug	# 604
	lcall	$clockTicks
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
	.debug	# 606
	push	bc
	push	de
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	call	__lsub##
	ld	(_rwTicks),de
@392:
	.debug	} @392 607

@391	equ	28
	ld	sp,ix
	pop	ix
	lret
@393	equ	30
$logDigIOChgs::
	.debug	G $logDigIOChgs 102 9
	.debug	{ $logDigIOChgs 102 613 @436 @435
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-20
	.debug	A firstTime 5 3
	.debug	L ui -2 7
	.debug	L offset -4 7
	.debug	L digInChgs -8 9
	.debug	# 616
	ld	de,(_curState)
	ld	bc,(_curState+2)
	push	bc
	push	de
	ld	de,(_prevState)
	ld	bc,(_prevState+2)
	call	__lxor##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	.seg	FARCODE
	.debug	L digOutChgs -12 9
	.debug	# 617
	ld	de,(_curState+4)
	ld	bc,(_curState+6)
	push	bc
	push	de
	ld	de,(_prevState+4)
	ld	bc,(_prevState+6)
	call	__lxor##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	.seg	FARCODE
	.debug	L mask -16 9
	.debug	L msg -20 50
	.debug	# 622
	ld	a,(ix+5)
	or	a,a
	jr	z,@437
	ld	de,word (phys @1+2819)
	ld	c,phys @1+2819 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@437:
	.debug	# 625
	ld	a,(ix+5)
	or	a,a
	jr	nz,@438
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	or	hl,de
	jp	z,@439
@438:
@440:
	.debug	< @440 @441
	.debug	# 626
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-2),hl
@442:
	ld	hl,(ix-2)
	ld	de,(_NumApplDIN)
	or	a,a
	sbc	hl,de
	jp	nc,@443
@445:
	.debug	< @445 @446
	.debug	# 627
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@447
	ld	a,(ix+5)
	or	a,a
	jr	z,@448
@447:
@449:
	.debug	< @449 @450
	.debug	# 628
	ld	hl,(ix-2)
	add	hl,hl
	ld	(ix-4),hl
	ld	de,(_curState)
	ld	bc,(_curState+2)
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@451
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
@451:
	.debug	# 629
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ld	de,_digInDescr
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	.debug	# 630
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@452
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+2864)
	ld	c,phys @1+2864 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
@452:
@450:
	.debug	>
@448:
	.debug	# 632
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@446:
	.debug	>
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@442
@443:
@441:
	.debug	>
@439:
	.debug	# 635
	ld	a,(ix+5)
	or	a,a
	jr	z,@453
	ld	de,word (phys @1+2870)
	ld	c,phys @1+2870 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@453:
	.debug	# 637
	ld	a,(ix+5)
	or	a,a
	jr	nz,@454
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	or	hl,de
	jp	z,@455
@454:
@456:
	.debug	< @456 @457
	.debug	# 638
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-2),hl
@458:
	ld	hl,(ix-2)
	ld	de,(_NumApplDOUT)
	or	a,a
	sbc	hl,de
	jp	nc,@459
@461:
	.debug	< @461 @462
	.debug	# 639
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@463
	ld	a,(ix+5)
	or	a,a
	jr	z,@464
@463:
@465:
	.debug	< @465 @466
	.debug	# 640
	ld	hl,(ix-2)
	add	hl,hl
	ld	(ix-4),hl
	ld	de,(_curState+4)
	ld	bc,(_curState+6)
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@467
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
@467:
	.debug	# 641
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ld	de,_digOutDescr
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	.debug	# 642
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@468
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+2864)
	ld	c,phys @1+2864 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
@468:
@466:
	.debug	>
@464:
	.debug	# 644
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	a,0x1
	call	__lshl##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@462:
	.debug	>
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@458
@459:
@457:
	.debug	>
@455:
	.debug	# 647
	ld	a,(ix+5)
	or	a,a
	jr	z,@469
	ld	de,word (phys @1+2495)
	ld	c,phys @1+2495 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
@469:
@435:
	.debug	} @435 648

@434	equ	20
	ld	sp,ix
	pop	ix
	lret
@436	equ	22
	.align	4
$$EVENT_RestoredParamFile::
	ex	(sp),iy
$EVENT_RestoredParamFile::
	.debug	G $EVENT_RestoredParamFile 103 9
	.debug	{ $EVENT_RestoredParamFile 103 654 @472 @471
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A event 5 104
	.debug	L idx -2 7
	.debug	L paramFile -4 64
	.debug	# 660
	ld	hl,(ix+5)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-2),hl
	.debug	# 661
	add	hl,hl
	ld	de,_paramFiles
	add	hl,de
	ld	hl,(hl)
	ld	(ix-4),hl
	.debug	# 663
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+2916)
	ld	c,phys @1+2916 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
	.debug	# 665
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,0x100
	push	hl
	ld	hl,_applBuf
	push	hl
	lcall	$loadParams
	add	sp,8
@471:
	.debug	} @471 666

@470	equ	4
	ld	sp,ix
	pop	ix
	lret
@472	equ	6
	.align	4
$$hostNameRestore::
	ex	(sp),iy
$hostNameRestore::
	.debug	G $hostNameRestore 106 9
	.debug	{ $hostNameRestore 106 671 @475 @474
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A curVal 5 107
	.debug	A newVal 9 70
	.debug	A count 11 7
	.debug	# 673
	ld	hl,(ix+9)
	push	hl
	call	_strlen
	pop	de
	push	hl
	ld	hl,(ix+9)
	push	hl
	lcall	$SetHostName
	add	sp,4
@474:
	.debug	} @474 674

@473	equ	0
	pop	ix
	lret
@475	equ	2
	.align	4
$$ReadSetCalibsRestore::
	ex	(sp),iy
$ReadSetCalibsRestore::
	.debug	G $ReadSetCalibsRestore 106 9
	.debug	{ $ReadSetCalibsRestore 106 679 @478 @477
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A curVal 5 107
	.debug	A newVal 9 70
	.debug	A count 11 7
	.debug	L ui -2 7
	.debug	# 684
	call	_KLOCK
	ld	hl,(ix+11)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	call	_KUNLOCK
@479:
	.debug	< @479 @480
	.debug	# 687
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@481:
	ld	hl,(ix-2)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@482
	ld	hl,(ix-2)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@481
@482:
@480:
	.debug	>
@484:
	.debug	< @484 @485
	.debug	# 688
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@486:
	ld	hl,(ix-2)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@487
	ld	hl,(ix-2)
	push	hl
	lcall	$newDACCalib
	pop	hl
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@486
@487:
@485:
	.debug	>
@477:
	.debug	} @477 689

@476	equ	2
	ld	sp,ix
	pop	ix
	lret
@478	equ	4
$setApplDTM::
	.debug	G $setApplDTM 99 9
	.debug	{ $setApplDTM 99 694 @491 @490
	.debug	# 696
	ld	hl,@2+129
	push	hl
	ld	hl,@2+138
	push	hl
	ld	de,word (phys @1+2948)
	ld	c,phys @1+2948 >> 16
	push	bc
	push	de
	ld	de,word (phys _applDTM)
	ld	c,phys _applDTM >> 16
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
	.debug	# 698
	ld	hl,@2+129
	push	hl
	ld	hl,@2+138
	push	hl
	lcall	$compileTime
	add	sp,4
	ld	(_applVersTime),de
	ld	(_applVersTime+2),bc
@490:
	.debug	} @490 699

@489	equ	0
	lret
@491	equ	0
$saveApplState::
	.debug	G $saveApplState 78 9
	.debug	{ $saveApplState 78 709 @494 @493
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	L dataSize -2 7
	.debug	L ptr -6 50
	.debug	L hdr -10 108
	.debug	# 716
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@495
	ld	hl,0xffff
	jp	@493
@495:
	.debug	# 718
	call	_KLOCK
	.debug	# 720
	ld	de,word (phys @1+2954)
	ld	c,phys @1+2954 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
	.debug	# 722
	ld	hl,(_ApplStateDataSize)
	ld	(ix-2),hl
	.debug	# 724
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.debug	# 726
	ld	de,0x8
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_prevState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.debug	# 727
	ld	de,0x8
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_curState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.debug	# 728
	ld	de,0x8
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_nextState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.debug	# 730
	ld	de,0x4
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,_setVal
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.debug	# 732
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.debug	# 734
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-2)
	call	__farst2##
	.debug	# 735
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$memCRC16
	add	sp,8
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-10)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst2##
	.debug	# 736
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
	.debug	# 743
	call	_KUNLOCK
	.debug	# 745
	bool	hl
	ld	l,h
@493:
	.debug	} @493 746

@492	equ	10
	ld	sp,ix
	pop	ix
	lret
@494	equ	12
$restoreApplState::
	.debug	G $restoreApplState 78 9
	.debug	{ $restoreApplState 78 764 @498 @497
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	L dataSize -2 7
	.debug	L ptr -6 50
	.debug	L hdr -10 108
	.debug	# 771
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@499
	ld	hl,0xffff
	jp	@497
@499:
	.debug	# 773
	ld	hl,(_ApplStateDataSize)
	ld	(ix-2),hl
	ld	de,(_stateDataBuf)
	ld	bc,(_stateDataBuf+2)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	.debug	# 777
	call	__farld2##
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	z,@500
	ld	hl,0x1
	jp	@497
@500:
	.debug	# 778
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__lsub##
	push	bc
	push	de
	ld	de,0x3c
	ld	c,d
	ld	b,d
	call	__lsub##
	jr	c,@501
	jr	z,@501
	ld	hl,0x2
	jp	@497
@501:
	.debug	# 779
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.debug	# 780
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	b,0
	push	bc
	push	de
	lcall	$memCRC16
	add	sp,8
	pop	de
	or	a,a
	sbc	hl,de
	jr	z,@502
	ld	hl,0x3
	jp	@497
@502:
	.debug	# 782
	ld	de,0x8
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_prevState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.debug	# 783
	ld	de,0x8
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_curState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.debug	# 784
	ld	de,0x8
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_nextState
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.debug	# 786
	ld	de,0x4
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,_setVal
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.debug	# 795
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState),de
	ld	(_nextState+2),bc
	ld	(_curState),de
	ld	(_curState+2),bc
	.debug	# 796
	ld	de,(_curState+4)
	ld	bc,(_curState+6)
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	.debug	# 798
	ld	de,word (phys @1+2981)
	ld	c,phys @1+2981 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	.debug	# 800
	bool	hl
	ld	l,h
@497:
	.debug	} @497 801

@496	equ	10
	ld	sp,ix
	pop	ix
	lret
@498	equ	12
$setGenericLabels::
	.debug	G $setGenericLabels 99 9
	.debug	{ $setGenericLabels 99 806 @505 @504
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	L ui -2 7
@506:
	.debug	< @506 @507
	.debug	# 810
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@508:
	ld	hl,(ix-2)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@509
@511:
	.debug	< @511 @512
	.debug	# 811
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	.debug	# 812
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+3021)
	ld	c,phys @1+3021 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _ainLabel)
	ld	c,phys _ainLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
@512:
	.debug	>
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@508
@509:
@507:
	.debug	>
@513:
	.debug	< @513 @514
	.debug	# 814
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@515:
	ld	hl,(ix-2)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@516
@518:
	.debug	< @518 @519
	.debug	# 815
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	.debug	# 816
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+3028)
	ld	c,phys @1+3028 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _aoutLabel)
	ld	c,phys _aoutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
@519:
	.debug	>
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@515
@516:
@514:
	.debug	>
@520:
	.debug	< @520 @521
	.debug	# 819
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@522:
	ld	hl,(ix-2)
	ld	de,(_NumApplDIN)
	or	a,a
	sbc	hl,de
	jr	nc,@523
@525:
	.debug	< @525 @526
	.debug	# 820
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	.debug	# 821
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+3036)
	ld	c,phys @1+3036 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
@526:
	.debug	>
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@522
@523:
@521:
	.debug	>
@527:
	.debug	< @527 @528
	.debug	# 823
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@529:
	ld	hl,(ix-2)
	ld	de,(_NumApplDOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@530
@532:
	.debug	< @532 @533
	.debug	# 824
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	.debug	# 825
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+3043)
	ld	c,phys @1+3043 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
@533:
	.debug	>
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@529
@530:
@528:
	.debug	>
@534:
	.debug	< @534 @535
	.debug	# 827
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@536:
	ld	hl,(ix-2)
	ld	de,(_NumExtraIn)
	or	a,a
	sbc	hl,de
	jr	nc,@537
@539:
	.debug	< @539 @540
	.debug	# 828
	ld	de,0x18
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	ex	de,hl
	push	bc
	push	de
	ld	d,h
	ld	e,l
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _extraInLabel)
	ld	c,phys _extraInLabel >> 16
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	.debug	# 829
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+3051)
	ld	c,phys @1+3051 >> 16
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x18
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _extraInLabel)
	ld	c,phys _extraInLabel >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,10
@540:
	.debug	>
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@536
@537:
@535:
	.debug	>
@504:
	.debug	} @504 831

@503	equ	2
	ld	sp,ix
	pop	ix
	lret
@505	equ	4
	.debug	I
;3360 
;3361 
;3362 //=========================================================================
;3363 //  Misc Application-specific functions
;3364 //=========================================================================
;3365 
;3366 
;3367 //-------------------------------------------------------------------------
;3368 //  phaseDiff:  compute difference between 2 phases, returning a value betw
;3369 //  -180.0 and +180.0
;3370 //-------------------------------------------------------------------------
;3371 float  phaseDiff(float ph1, float ph2)
;3372 {
$phaseDiff::
	.debug	G $phaseDiff 110 9
	.debug	{ $phaseDiff 110 3371 @543 @542
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ph1 5 10
	.debug	A ph2 9 10
;3373   float diff = ph1 - ph2;
	.debug	L diff -4 10
	.debug	# 3373
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__fsub##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;3374 
;3375   if (diff < -180.0)
	.debug	# 3375
	push	bc
	push	de
	ld	de,0
	ld	bc,0xc334
	call	__fsub##
	jp	p,@544
;3376     diff += 360.0;
	.debug	# 3376
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x43b4
	call	__fadd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3377   else
;3378     if (diff > 180.0)  diff -= 360.0;
	jr	@545
@544:
	.debug	# 3378
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4334
	call	__fsub##
	jp	m,@546
	jr	z,@546
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0xc3b4
	call	__fadd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3379 
;3380   return diff;
@546:
@545:
	.debug	# 3380
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
;3381 }
@542:
	.debug	} @542 3381

@541	equ	4
	ld	sp,ix
	pop	ix
	lret
@543	equ	6
;3382 
;3383 
;3384 //-------------------------------------------------------------------------
;3385 //  "fitofl": Converts a decimal number in fixed point format to floating p
;3386 //-------------------------------------------------------------------------
;3387 float fitofl(long value)
;3388 {
$fitofl::
	.debug	G $fitofl 111 9
	.debug	{ $fitofl 111 3387 @549 @548
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-7
	.debug	A value 5 8
;3389   float out;
	.debug	L out -4 10
;3390   bool neg = value < 0;
	.debug	L neg -5 3
	.debug	# 3390
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	ld	de,0
	jr	nc,@550
	inc	e
@550:
	ld	(ix-5),e
	.seg	FARCODE
;3391   ulong *p = (ulong *)&value;
	.debug	L p -7 87
	.debug	# 3391
	ld	hl,5+@547
	add	hl,sp
	ld	(ix-7),hl
	.seg	FARCODE
;3392 
;3393   if (neg)  value *= -1;
	.debug	# 3393
	ld	a,e
	or	a,a
	jr	z,@551
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xffff
	ld	c,e
	ld	b,e
	call	__ulmlt##
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;3394 
;3395 //finish
;3396   out = (*p) & 0x0000FFFFL;
@551:
	.debug	# 3396
	ld	hl,(ix-7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0xffff
	ld	bc,0
	call	__land##
	call	__ultof##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3397   out /= 65536.0;
	.debug	# 3397
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4780
	call	__fdiv##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3398   out += (float) ((*p) >> 16);
	.debug	# 3398
	ld	hl,(ix-7)
	inc	hl
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	d,(hl)
	ld	e,c
	ld	bc,0
	call	__ultof##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__fadd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3399 
;3400   if (neg)  out *= -1.0;
	.debug	# 3400
	ld	a,(ix-5)
	or	a,a
	jr	z,@552
	push	bc
	push	de
	ld	de,0
	ld	bc,0xbf80
	call	__fmlt##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3401 
;3402   return out;
@552:
	.debug	# 3402
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
;3403 }
@548:
	.debug	} @548 3403

@547	equ	7
	ld	sp,ix
	pop	ix
	lret
@549	equ	9
;3404 
;3405 //-------------------------------------------------------------------------
;3406 //  "fltofi": Converts a decimal number in floating point format to fixed p
;3407 //-------------------------------------------------------------------------
;3408 long fltofi(float value)
;3409 {
$fltofi::
	.debug	G $fltofi 112 9
	.debug	{ $fltofi 112 3408 @555 @554
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-5
	.debug	A value 5 10
;3410   long fixed;
	.debug	L fixed -4 8
;3411   bool neg = (value < 0.0);
	.debug	L neg -5 3
	.debug	# 3411
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__fsub##
	ld	de,0
	jp	p,@556
	inc	e
@556:
	ld	(ix-5),e
	.seg	FARCODE
;3412 
;3413   if (neg)  value *= -1.0;
	.debug	# 3413
	ld	a,e
	or	a,a
	jr	z,@557
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0xbf80
	call	__fmlt##
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;3414 
;3415 //finish
;3416   fixed = (long) value;
@557:
	.debug	# 3416
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ftol##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3417   value -= (float) fixed;
	.debug	# 3417
	call	__ltof##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__fsubr##
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;3418   fixed <<= 16;
	.debug	# 3418
	ld	hl,(ix-4)
	ex	de,hl
	ld	b,d
	ld	c,e
	ld	de,0
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3419   fixed += (long) (65536.0 * value);
	.debug	# 3419
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4780
	call	__fmlt##
	call	__ftol##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3420 
;3421   if (neg)  fixed *= -1;
	.debug	# 3421
	ld	a,(ix-5)
	or	a,a
	jr	z,@558
	push	bc
	push	de
	ld	de,0xffff
	ld	c,e
	ld	b,e
	call	__ulmlt##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3422 
;3423   return fixed;
@558:
	.debug	# 3423
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
;3424 }
@554:
	.debug	} @554 3424

@553	equ	5
	ld	sp,ix
	pop	ix
	lret
@555	equ	7
;3425 
;3426 
;3427 //=========================================================================
;3428 typedef struct {
;3429   fd_t   fromfd;
;3430   bool   eof;
;3431 }  ReadState;
;3432 
;3433 #define RDSTATE ((ReadState *)rdState)
;3434 
;3435 typedef struct {
;3436   uint   progNum;     // 0 - 3
;3437   uint   blkNum;      // 0 - 15
;3438   ulong  ttlWritten;  // ttl bytes written to DSP mem for this program
;3439   ulong  blkWritten;  // # bytes in current block written so far
;3440   bool   showProgress;
;3441 }  WriteState;
;3442 
;3443 #define WRSTATE ((WriteState *)wrState)
;3444 
;3445 #define  DSP_BLK_SIZE  (0x10000L)
;3446 
;3447 
;3448 //-------------------------------------------------------------------------
;3449 //  Read the sepcified # of bytes from a file descriptor.  If the end of th
;3450 //  file is reached, bytes with 0 value are returned instead.
;3451 //
;3452 //  Parameters:
;3453 //    *rdState:  Pointer to ReadState structure that contains the following
;3454 //                 fromfd:  the file descriptor to read from
;3455 //                 eof:  flag to indicate that the End-Of-File was reached
;3456 //    *buf:      pointer to buffer to read the data in to
;3457 //    count:     # of bytes to read (or fill with zeros)
;3458 //
;3459 //  This function is designed to be called by the copyBytes() function whic
;3460 //  provides a generic means of managing the transfer of a stream of bytes.
;3461 //
;3462 //  On return:
;3463 //    rdState values updated as needed
;3464 //    Returns the # of bytes successfully read or set to 0
;3465 //-------------------------------------------------------------------------
;3466 int _nearcall readFromFile(void *rdState, char *buf, int count)
;3467 {
	.align	4
$$readFromFile::
	ex	(sp),iy
$readFromFile::
	.debug	G $readFromFile 113 9
	.debug	{ $readFromFile 113 3466 @561 @560
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A rdState 5 80
	.debug	A buf 7 70
	.debug	A count 9 6
;3468   int  stat;
	.debug	L stat -2 6
;3469 
;3470   if (RDSTATE->eof)  { memset(buf, 0xff, count);  return count; }
	.debug	# 3470
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	a,(hl)
	or	a,a
	jr	z,@562
@563:
	.debug	< @563 @564
	ld	hl,(ix+9)
	push	hl
	ld	hl,0xff
	push	hl
	ld	hl,(ix+7)
	push	hl
	call	_memset
	add	sp,6
	ld	hl,(ix+9)
	jr	@560
@564:
	.debug	>
;3471 
;3472   if ((stat = read(RDSTATE->fromfd, buf, count)) < 0)  return stat;
@562:
	.debug	# 3472
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$read
	add	sp,6
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@565
	ld	hl,(ix-2)
	jr	@560
;3473 
;3474   if (stat < count)  { memset(buf+stat, 0, count-stat);  RDSTATE->eof = tru
@565:
	.debug	# 3474
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	call	__icmp##
	jr	nc,@566
@567:
	.debug	< @567 @568
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	push	hl
	call	_memset
	add	sp,6
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	a,0x1
	ld	(hl),a
@568:
	.debug	>
;3475 
;3476   return count;
@566:
	.debug	# 3476
	ld	hl,(ix+9)
;3477 }
@560:
	.debug	} @560 3477

@559	equ	2
	ld	sp,ix
	pop	ix
	lret
@561	equ	4
;3478 
;3479 //-------------------------------------------------------------------------
;3480 //  Write bytes to the DSP program memory
;3481 //
;3482 //  Parameters:
;3483 //    *wrState:  pointer to WriteState structure that contains the followin
;3484 //                 progNum:  Which program # the block belongs to (0-3)
;3485 //                 blkNum:   64K block # within the program (0-15)
;3486 //                 ttlWritten:  ttl # bytes written so far
;3487 //                 blkWritten:  # bytes written to blkNum block so far
;3488 //    *buf:      pointer to buffer with data to be written
;3489 //    count:     # of bytes to be processed
;3490 //
;3491 //  This function is designed to be called by the copyBytes() function whic
;3492 //  provides a generic means of managing the transfer of a stream of bytes.
;3493 //
;3494 //  NOTE:  count MUST be a multiple of 4!
;3495 //
;3496 //  On return:
;3497 //    wrState values are updated as needed
;3498 //    Returns the # of bytes successfully written
;3499 //-------------------------------------------------------------------------
;3500 int _nearcall writeDSPMem(void *wrState, char *buf, int count)
;3501 {
	.align	4
$$writeDSPMem::
	ex	(sp),iy
$writeDSPMem::
	.debug	G $writeDSPMem 113 9
	.debug	{ $writeDSPMem 113 3500 @571 @570
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-26
	.debug	A wrState 5 80
	.debug	A buf 7 70
	.debug	A count 9 6
;3502   int  i, stat, remain, wrCount;
	.debug	L i -2 6
	.debug	L stat -4 6
	.debug	L remain -6 6
	.debug	L wrCount -8 6
;3503   uint  memBlock;
	.debug	L memBlock -10 7
;3504   uchar  enableLow, enableHigh;
	.debug	L enableLow -11 3
	.debug	L enableHigh -12 3
;3505   ulong  startTime, wordVal, percentDone;
	.debug	L startTime -16 9
	.debug	L wordVal -20 9
	.debug	L percentDone -24 9
;3506   ulong  *ptr;
	.debug	L ptr -26 87
;3507 
;3508 
;3509   if (NotLockOwner(APPL_LOCK))  return -1;
	.debug	# 3509
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	de,(_locks+2)
	or	a,a
	sbc	hl,de
	jp	nz,@1840
;3510 
;3511   ptr = (ulong *)buf;  remain = count;
	.debug	# 3511
	ld	hl,(ix+7)
	ld	(ix-26),hl
	ld	hl,(ix+9)
	ld	(ix-6),hl
;3512 
;3513 
;3514   while (remain)  {
@573:
	.debug	# 3514
	ld	hl,(ix-6)
	bool	hl
	jp	z,@574
;3515     resetWDT();
@575:
	.debug	< @575 @576
	.debug	# 3515
	lcall	$resetWDT
;3516 
;3517   //--- prep DSP for writing next block num as needed ---
;3518     if (WRSTATE->blkWritten == 0)  {
	.debug	# 3518
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jp	nz,@577
;3519       readDSPReg(WriteStatus, &percentDone);
@578:
	.debug	< @578 @579
	.debug	# 3519
	ld	hl,-24+@569
	add	hl,sp
	push	hl
	ld	de,0x214
	ld	bc,0x10
	push	bc
	push	de
	lcall	$readDSPReg
	add	sp,6
;3520       if (percentDone != 100)
	.debug	# 3520
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xff9c
	ld	c,d
	ld	b,d
	call	__ladd##
	jr	z,@580
;3521         printf("DSP reports %ld%% before start of block!\r\n", percentDone)
	.debug	# 3521
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3062)
	ld	c,phys @1+3062 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3522       printf("Program: %d  Block: %d\r\n", WRSTATE->progNum, WRSTATE->blkNu
@580:
	.debug	# 3522
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+3105)
	ld	c,phys @1+3105 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3523       memBlock = (WRSTATE->progNum << 14) | (WRSTATE->blkNum & 0x0f);
	.debug	# 3523
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	h,l
	ld	l,0
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	ld	bc,de
	ld	de,0xf
	and	hl,de
	ld	de,bc
	or	hl,de
	ld	(ix-10),hl
;3524       if (writeDSPRegQuick(WrMemBlock, memBlock))  break;
	.debug	# 3524
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x212
	ld	c,0x10
	push	bc
	push	de
	lcall	$writeDSPRegQuick
	add	sp,8
	bool	hl
	jp	nz,@574
;3525     }
@579:
	.debug	>
;3526 
;3527   //--- write as many bytes as we can in to current block ---
;3528     wrCount = (int) min((ulong)remain, DSP_BLK_SIZE - WRSTATE->blkWritten);
@577:
	.debug	# 3528
	ld	hl,(ix-6)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	ld	hl,(ix+5)
	push	bc
	push	de
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x1
	call	__lsubr##
	call	__lsub##
	jr	z,@583
	jr	nc,@582
@583:
	ld	hl,(ix-6)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	jr	@584
@582:
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x1
	call	__lsubr##
@584:
	ex	de,hl
	ld	(ix-8),hl
;3529 
;3530     enableLow = PGDRShadow & (uchar)(~_DSP_WR_RD);
	.debug	# 3530
	ld	a,(_srPGDR)
	and	a,239
	ld	(ix-11),a
;3531     enableHigh = enableLow | (uchar)_DSP_WR_RD;
	.debug	# 3531
	or	a,16
	ld	(ix-12),a
;3532 
;3533     for (i=0; i<wrCount; i+=4,++ptr)  {
@585:
	.debug	< @585 @586
	.debug	# 3533
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@587:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	call	__icmp##
	jp	nc,@588
;3534       OUTI(PGDR, enableLow);  // signal start of 32-bit packet
@590:
	.debug	< @590 @591
	.debug	# 3534
	ld	a,(ix-11)
	ld	(_srPGDR),a
	ioi ld	(72),a
;3535       wordVal = htonl(*ptr);
	.debug	# 3535
	ld	hl,(ix-26)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
;3536       stat = WriteSPI1((char *)&wordVal, 4);
	.debug	# 3536
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,-16+@569
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrite_
	add	sp,8
	ld	(ix-4),hl
;3537       OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 3537
	ld	a,(ix-12)
	ld	(_srPGDR),a
	ioi ld	(72),a
;3538       if (stat != 4)  return -1;
	.debug	# 3538
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	nz,@1840
;3539     }
@591:
	.debug	>
;3540 
;3541     WRSTATE->blkWritten += (uint) wrCount;
	ld	hl,(ix-2)
	ld	de,0x4
	add	hl,de
	ld	(ix-2),hl
	ld	hl,(ix-26)
	add	hl,de
	ld	(ix-26),hl
	jp	@587
@588:
@586:
	.debug	>
	.debug	# 3541
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	push	hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3542     WRSTATE->ttlWritten += (uint) wrCount;
	.debug	# 3542
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	push	hl
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3543     remain -= (uint) wrCount;
	.debug	# 3543
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-6),hl
;3544 
;3545   //--- if finished a block, wait for the DSP to indicate it has copied it 
;3546   //--- to flash and is ready to accept the next block ---
;3547     if (WRSTATE->blkWritten == DSP_BLK_SIZE)  {
	.debug	# 3547
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0
	ld	bc,0xffff
	call	__ladd##
	jp	nz,@573
;3548       startTime = GetMS();  percentDone = 0;
@594:
	.debug	< @594 @595
	.debug	# 3548
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
;3549       while ((msSince(startTime) < 30000) AND (percentDone != 100))  {
@596:
	.debug	# 3549
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x7530
	ld	bc,0
	call	__lsub##
	jr	nc,@598
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xff9c
	ld	c,d
	ld	b,d
	call	__ladd##
	jr	z,@598
;3550         resetWDT();  sleepMS(100);  readDSPReg(WriteStatus, &percentDone);
@599:
	.debug	< @599 @600
	.debug	# 3550
	lcall	$resetWDT
	ld	de,0x64
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	ld	hl,-24+@569
	add	hl,sp
	push	hl
	ld	de,0x214
	ld	bc,0x10
	push	bc
	push	de
	lcall	$readDSPReg
	add	sp,6
;3551         if (WRSTATE->showProgress)  {
	.debug	# 3551
	ld	hl,(ix+5)
	ld	de,0xc
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@601
;3552           printf("%3ld%%      \r", percentDone);  fflush(stdout);  }
@602:
	.debug	< @602 @603
	.debug	# 3552
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3130)
	ld	c,phys @1+3130 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
@603:
	.debug	>
;3553       }
@601:
@600:
	.debug	>
;3554       if (percentDone != 100)  {
	jp	@596
@598:
	.debug	# 3554
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xff9c
	ld	c,d
	ld	b,d
	call	__ladd##
	jr	z,@604
;3555         printf("DSP not responding: Only %3d%% saved to flash\r\n", percent
@605:
	.debug	< @605 @606
	.debug	# 3555
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3144)
	ld	c,phys @1+3144 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3556         resetDSP();  errno = EIO;  return -1;
	.debug	# 3556
	lcall	$resetDSP
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5
	ld	(hl),e
	inc	hl
	ld	(hl),d
@1840:
	ld	hl,0xffff
	jr	@570
;3557       }
@606:
	.debug	>
;3558       ++WRSTATE->blkNum;  WRSTATE->blkWritten = 0;
@604:
	.debug	# 3558
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	push	hl
	ld	hl,(hl)
	inc	hl
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	e,d
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3559     }
@595:
	.debug	>
;3560 
;3561   }
@576:
	.debug	>
;3562 
;3563   return count - remain;
	jp	@573
@574:
	.debug	# 3563
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
;3564 }
@570:
	.debug	} @570 3564

@569	equ	26
	ld	sp,ix
	pop	ix
	lret
@571	equ	28
;3565 
;3566 //-------------------------------------------------------------------------
;3567 //  Initialize the DSP by copying the specified # of bytes from the source 
;3568 //  to the DSP
;3569 //
;3570 //  Returns 0 on success, < 0 if an error occured (with errno set)
;3571 //-------------------------------------------------------------------------
;3572 int initDSP(fd_t fromfd, uint progNum, ulong ttlBytes, bool showProgress)
;3573 {
$initDSP::
	.debug	G $initDSP 114 9
	.debug	{ $initDSP 114 3572 @609 @608
	ld	hl,-273
	call	__fent##
	.debug	A fromfd 5 6
	.debug	A progNum 7 7
	.debug	A ttlBytes 9 9
	.debug	A showProgress 13 3
;3574   uchar  clockMode = NORM_LOW_LATCH_RISE;  //test
	.debug	L clockMode -1 3
	.debug	# 3574
	xor	a,a
	ld	(ix-1),a
	.seg	FARCODE
;3575   ReadState  readState;
	.debug	L readState -4 115
;3576   WriteState  writeState;
	.debug	L writeState -17 116
;3577   char  buf[256];
	.debug	L buf -273 117
;3578 
;3579 
;3580 //  if (!spi1Port)  return -1;
;3581 
;3582   resetWDT();  // so WatchDog timer doesn't reboot us...
	.debug	# 3582
	lcall	$resetWDT
;3583 
;3584   ttlBytes = ttlBytes + DSP_BLK_SIZE - 1;
	.debug	# 3584
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xffff
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix+11),hl
	ex	de,hl
	ld	(ix+9),hl
	ex	de,hl
;3585   ttlBytes = ttlBytes - (ttlBytes % DSP_BLK_SIZE);
	.debug	# 3585
	push	bc
	push	de
	ld	de,0xffff
	ld	bc,0
	call	__land##
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__lsubr##
	ld	hl,bc
	ld	(ix+11),hl
	ex	de,hl
	ld	(ix+9),hl
	ex	de,hl
;3586 
;3587   printf("Copying %lu bytes to DSP\r\n", ttlBytes);
	.debug	# 3587
	push	bc
	push	de
	ld	de,word (phys @1+3192)
	ld	c,phys @1+3192 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3588 
;3589 //--- make sure the SPI port is not in use by another process ---
;3590   if (getLockDSP(5000) <= 0)  return -1;
	.debug	# 3590
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	lcall	$getLockDSP
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@611
	jr	nc,@610
@611:
	ld	hl,0xffff
	jp	@608
;3591 
;3592   readState.fromfd = fromfd;
@610:
	.debug	# 3592
	ld	hl,(ix+5)
	ld	(ix-4),hl
;3593   readState.eof = false;
	.debug	# 3593
	xor	a,a
	ld	(ix-2),a
;3594 
;3595   writeState.progNum = progNum;
	.debug	# 3595
	ld	hl,(ix+7)
	ld	(ix-17),hl
;3596   writeState.blkNum = 0;
	.debug	# 3596
	bool	hl
	ld	l,h
	ld	(ix-15),hl
;3597   writeState.blkWritten = writeState.ttlWritten = 0;
	.debug	# 3597
	ld	d,h
	ld	e,l
	ld	c,e
	ld	b,e
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
	ld	(ix-7),hl
	ex	de,hl
	ld	(ix-9),hl
	ex	de,hl
;3598   writeState.showProgress = showProgress;
	.debug	# 3598
	ld	a,(ix+13)
	ld	(ix-5),a
;3599 
;3600   if (hdwType == HT_PHASE_CTLR)
	.debug	# 3600
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nz,@612
;3601   //  ioctl(spi1fd, IOC_SET_CLK_MODE, &clockMode);
;3602     _spiConfig_(spi1Port, CLK_1MHz, clockMode);  //test
	.debug	# 3602
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	hl,0xa
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
;3603 
;3604   if (copyBytes(readFromFile, &readState, writeDSPMem, &writeState,
@612:
;3605                 buf, sizeof(buf), ttlBytes, showProgress) != ttlBytes)
	.debug	# 3605
	ld	a,(ix+13)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,0x100
	push	hl
	ld	hl,-265+@607
	add	hl,sp
	push	hl
	ld	hl,-7+@607
	add	hl,sp
	push	hl
	ld	hl,_writeDSPMem
	push	hl
	ld	hl,10+@607
	add	hl,sp
	push	hl
	ld	hl,_readFromFile
	push	hl
	lcall	$copyBytes
	add	sp,18
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__lsub##
	jr	z,@613
;3606     perror("copyBytes");
	.debug	# 3606
	ld	de,word (phys @1+3219)
	ld	c,phys @1+3219 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
;3607   else
;3608     printf("Copied %lu bytes to DSP\r\n", writeState.ttlWritten);
	jr	@614
@613:
	.debug	# 3608
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3229)
	ld	c,phys @1+3229 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3609 
;3610   close(fromfd);
@614:
	.debug	# 3610
	ld	hl,(ix+5)
	push	hl
	lcall	$close
	pop	de
;3611 
;3612   releaseLockDSP();
	.debug	# 3612
	lcall	$releaseLockDSP
;3613 
;3614   return 0;
	.debug	# 3614
	bool	hl
	ld	l,h
;3615 }
@608:
	.debug	} @608 3615

@607	equ	273
	ld	sp,ix
	pop	ix
	lret
@609	equ	275
;3616 
;3617 //-------------------------------------------------------------------------
;3618 //  Wait for FPGA to release SPI bus
;3619 //-------------------------------------------------------------------------
;3620 bool waitFPGA(ulong waitMS)
;3621 {
$waitFPGA::
	.debug	G $waitFPGA 118 9
	.debug	{ $waitFPGA 118 3620 @617 @616
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A waitMS 5 9
;3622   ulong  startTime;
	.debug	L startTime -4 9
;3623 
;3624   startTime = GetMS();
	.debug	# 3624
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;3625   for (;;)  {
@618:
	.debug	< @618 @619
@620:
;3626     resetWDT();  // so WatchDog timer doesn't reboot us...
@623:
	.debug	< @623 @624
	.debug	# 3626
	lcall	$resetWDT
;3627 //if (diagLogInfo->wdtTicks > 10)  //tdebug
;3628 //  printf("=== %lu %u\r\n", msSince(startTime), diagLogInfo->wdtTicks);  /
;3629     digitalIn = ReadDigInputs();
	.debug	# 3629
	lcall	$ReadDigInputs
	ld	(_digitalIn),de
	ld	(_digitalIn+2),bc
;3630     if (BOOL(digitalIn & FPGA_DONE))  return true;
	.debug	# 3630
	push	bc
	push	de
	ld	de,0x800
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@625
	ld	a,0x1
	jr	@626
@625:
	xor	a,a
@626:
	or	a,a
	jp	nz,@1839
;3631     if (msSince(startTime) > waitMS)  break;
	.debug	# 3631
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsub##
	jr	c,@628
	jr	nz,@621
;3632     sleepMS(250);
@628:
	.debug	# 3632
	ld	de,0xfa
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3633   }
@624:
	.debug	>
;3634 
;3635   if (hdwType != HT_PHASE_CTLR)  return true;
	jp	@620
@621:
@619:
	.debug	>
	.debug	# 3635
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@629
@1839:
	ld	a,0x1
	jr	@616
;3636 
;3637   printf("FPGA never released SPI bus\r\n");
@629:
	.debug	# 3637
	ld	de,word (phys @1+3255)
	ld	c,phys @1+3255 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3638 
;3639   return false;
	.debug	# 3639
	xor	a,a
;3640 }
@616:
	.debug	} @616 3640

@615	equ	4
	ld	sp,ix
	pop	ix
	lret
@617	equ	6
;3641 
;3642 //-------------------------------------------------------------------------
;3643 //  Reset the FPGA, causing it to reload its firmware from the EEPROM
;3644 //-------------------------------------------------------------------------
;3645 void _task resetFPGA(int argc, char **argv)
;3646 {
	.align	4
$$resetFPGA::
	ex	(sp),iy
$resetFPGA::
	.debug	G $resetFPGA 119 9
	.debug	{ $resetFPGA 119 3645 @632 @631
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A argc 5 6
	.debug	A argv 7 120
;3647   if (hdwType != HT_PHASE_CTLR)  Exit(-1);
	.debug	# 3647
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@633
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;3648 
;3649   if (getLock(APPL_LOCK, 10000) <= 0)  Exit(-1);
@633:
	.debug	# 3649
	ld	de,0x2710
	ld	bc,0
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	lcall	$getLock
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@635
	jr	nc,@634
@635:
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;3650 
;3651 //--- tell FPGA to release SPI bus ---
;3652   KLOCK();
@634:
	.debug	# 3652
	call	_KLOCK
;3653   ClearBits(Next.digitalOut, FPGA_SPI);  digitalOut = Next.digitalOut;
	.debug	# 3653
	ld	de,(_nextState+4)
	ld	bc,(_nextState+6)
	res	6,d
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
;3654   fpgaInitialized = false;
	.debug	# 3654
	xor	a,a
	ld	(_fpgaInitialized),a
;3655   KUNLOCK();
	.debug	# 3655
	call	_KUNLOCK
;3656   WriteDig();
@636:
	.debug	< @636 @637
	.debug	# 3656
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@637:
	.debug	>
;3657 
;3658 //--- allow FPGA to have the SPI bus again.  This also causes it to reload 
;3659 //--- from the new image in EEPROM (good or bad) ---
;3660   KLOCK();
	.debug	# 3660
	call	_KLOCK
;3661   SetBits(Next.digitalOut, FPGA_SPI);  digitalOut = Next.digitalOut;
	.debug	# 3661
	ld	de,(_nextState+4)
	ld	bc,(_nextState+6)
	set	6,d
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
;3662   KUNLOCK();
	.debug	# 3662
	call	_KUNLOCK
;3663   WriteDig();
@638:
	.debug	< @638 @639
	.debug	# 3663
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@639:
	.debug	>
;3664 
;3665   releaseLock(APPL_LOCK);
	.debug	# 3665
	bool	hl
	ld	l,h
	push	hl
	lcall	$releaseLock
	pop	de
;3666 
;3667 //--- wait for FPGA to load new firmware and release SPI bus ---
;3668   fpgaInitialized = waitFPGA(3000);
	.debug	# 3668
	ld	de,0xbb8
	ld	bc,0
	push	bc
	push	de
	lcall	$waitFPGA
	add	sp,4
	ld	(_fpgaInitialized),a
;3669 
;3670   if (fpgaInitialized)  { printf("FPGA firmware reloaded.\r\n");  Exit(0); 
	.debug	# 3670
	or	a,a
	jr	z,@640
@641:
	.debug	< @641 @642
	ld	de,word (phys @1+3285)
	ld	c,phys @1+3285 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@642:
	.debug	>
;3671 
;3672   Exit(-1);
@640:
	.debug	# 3672
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;3673 }
@631:
	.debug	} @631 3673

@630	equ	0
	pop	ix
	lret
@632	equ	2
;3674 
;3675 
;3676 //-------------------------------------------------------------------------
;3677 //  write and then read specified # of bytes to/from the EEPROM
;3678 //-------------------------------------------------------------------------
;3679 char *writeReadEE(char *send, int sendCount, char *rcv, int rcvCount)
;3680 {
$writeReadEE::
	.debug	G $writeReadEE 121 9
	.debug	{ $writeReadEE 121 3679 @645 @644
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A send 5 70
	.debug	A sendCount 7 6
	.debug	A rcv 9 70
	.debug	A rcvCount 11 6
;3681   EEPROM_Enable();
	.debug	# 3681
	ld	a,(_srPFDR)
	and	a,254
	ld	(_srPFDR),a
	ioi ld	(56),a
;3682 
;3683   WriteSPI2(send, sendCount);
	.debug	# 3683
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,(_spi2Port)
	push	hl
	lcall	$_spiWrite_
	add	sp,8
;3684   if (rcvCount)  ReadSPI2(rcv, rcvCount);
	.debug	# 3684
	ld	hl,(ix+11)
	bool	hl
	jr	z,@646
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+9)
	push	hl
	ld	hl,(_spi2Port)
	push	hl
	lcall	$_spiRead_
	add	sp,8
;3685 
;3686   EEPROM_Disable();
@646:
	.debug	# 3686
	ld	a,(_srPFDR)
	or	a,1
	ld	(_srPFDR),a
	ioi ld	(56),a
;3687 
;3688   return rcv;
	.debug	# 3688
	ld	hl,(ix+9)
;3689 }
@644:
	.debug	} @644 3689

@643	equ	0
	pop	ix
	lret
@645	equ	2
;3690 
;3691 //-------------------------------------------------------------------------
;3692 //  write a single byte command to the EEPROM, and read and return the
;3693 //  value of the status register
;3694 //-------------------------------------------------------------------------
;3695 char writeCmdEE(uchar cmd)
;3696 {
$writeCmdEE::
	.debug	G $writeCmdEE 122 9
	.debug	{ $writeCmdEE 122 3695 @649 @648
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A cmd 5 3
;3697   char  readStatCmd, statReg;
	.debug	L readStatCmd -1 3
	.debug	L statReg -2 3
;3698 
;3699   if (cmd)  writeReadEE(&cmd, 1, NULL, 0);
	.debug	# 3699
	ld	a,(ix+5)
	or	a,a
	jr	z,@650
	bool	hl
	ld	l,h
	push	hl
	push	hl
	inc	l
	push	hl
	ld	hl,11+@647
	add	hl,sp
	push	hl
	lcall	$writeReadEE
	add	sp,8
;3700 
;3701   readStatCmd = EEPROM_RDSR;  writeReadEE(&readStatCmd, 1, &statReg, 1);
@650:
	.debug	# 3701
	ld	(ix-1),0x5
	ld	hl,0x1
	push	hl
	ld	hl,0+@647
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	hl,5+@647
	add	hl,sp
	push	hl
	lcall	$writeReadEE
	add	sp,8
;3702 
;3703   return statReg;
	.debug	# 3703
	ld	a,(ix-2)
;3704 }
@648:
	.debug	} @648 3704

@647	equ	2
	ld	sp,ix
	pop	ix
	lret
@649	equ	4
;3705 
;3706 //-------------------------------------------------------------------------
;3707 const char SectorAddr[11][3] = {
;3708   { 0x00,0x00,0x00 },  //  0
	.seg	CONST
_SectorAddr::
	.db	0
	.db	0
	.db	0
;3709   { 0x01,0x00,0x00 },  //  1
	.db	0x1
	.db	0
	.db	0
;3710   { 0x02,0x00,0x00 },  //  2
	.db	0x2
	.db	0
	.db	0
;3711   { 0x03,0x00,0x00 },  //  3
	.db	0x3
	.db	0
	.db	0
;3712   { 0x04,0x00,0x00 },  //  4
	.db	0x4
	.db	0
	.db	0
;3713   { 0x05,0x00,0x00 },  //  5
	.db	0x5
	.db	0
	.db	0
;3714   { 0x06,0x00,0x00 },  //  6
	.db	0x6
	.db	0
	.db	0
;3715   { 0x07,0x00,0x00 },  //  7
	.db	0x7
	.db	0
	.db	0
;3716   { 0x07,0x80,0x00 },  //  8
	.db	0x7
	.db	0x80
	.db	0
;3717   { 0x07,0xA0,0x00 },  //  9
	.db	0x7
	.db	0xa0
	.db	0
;3718   { 0x07,0xC0,0x00 }   // 10
	.db	0x7
	.db	0xc0
	.db	0
;3719 };
	.debug	G _SectorAddr 123 0
;3720 
;3721 //-------------------------------------------------------------------------
;3722 //  Update the FPGA firmware image in the EEPROM
;3723 //  Returns 0 on success, < 0 if an error occured (with errno set)
;3724 //-------------------------------------------------------------------------
;3725 int updateFPGAfirmware(fd_t fromfd, bool showProgress, bool verify)
;3726 {
	.seg	FARCODE
$updateFPGAfirmware::
	.debug	G $updateFPGAfirmware 125 9
	.debug	{ $updateFPGAfirmware 125 3725 @653 @652
	ld	hl,-579
	call	__fent##
	.debug	A fromfd 5 6
	.debug	A showProgress 7 3
	.debug	A verify 9 3
;3727 #define  BufSize  256  // can't be very large without overflowing the stack
;3728 
;3729   uchar  clockMode = NORM_LOW_LATCH_RISE;
	.debug	L clockMode -1 3
	.debug	# 3729
	xor	a,a
	ld	(ix-1),a
	.seg	FARCODE
;3730   bool  downloadOK;
	.debug	L downloadOK -2 3
;3731   int  i, count;
	.debug	L i -4 6
	.debug	L count -6 6
;3732   ulong  startTime, ttlBytes, fileSize;
	.debug	L startTime -10 9
	.debug	L ttlBytes -14 9
	.debug	L fileSize -18 9
;3733   bool  busy;
	.debug	L busy -19 3
;3734   char  statReg;
	.debug	L statReg -20 3
;3735   struct stat  fsInfo;
	.debug	L fsInfo -62 126
;3736   char  cmdBuf[5];
	.debug	L cmdBuf -67 127
;3737   char  buf[BufSize], buf2[BufSize];
	.debug	L buf -323 117
	.debug	L buf2 -579 117
;3738 
;3739 
;3740   if (hdwType != HT_PHASE_CTLR)  return 0;
	.debug	# 3740
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@654
	bool	hl
	ld	l,h
	jp	@652
;3741 
;3742   if (!spi2Port)  return -1;
@654:
	.debug	# 3742
	ld	hl,(_spi2Port)
	bool	hl
	jr	z,@657
;3743 
;3744   if (getLock(APPL_LOCK, 10000) <= 0)  return -1;
	.debug	# 3744
	ld	de,0x2710
	ld	bc,0
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	lcall	$getLock
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@657
	jr	nc,@656
@657:
	ld	hl,0xffff
	jp	@652
;3745 
;3746 //  ioctl(spi2fd, IOC_SET_CLK_MODE, &clockMode);
;3747   _spiConfig_(spi2Port, CLK_1MHz, clockMode);
@656:
	.debug	# 3747
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	l,0xa
	push	hl
	ld	hl,(_spi2Port)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
;3748 
;3749 //--- tell FPGA to release SPI bus ---
;3750   KLOCK();
	.debug	# 3750
	call	_KLOCK
;3751   ClearBits(Next.digitalOut, FPGA_SPI);  digitalOut = Next.digitalOut;
	.debug	# 3751
	ld	de,(_nextState+4)
	ld	bc,(_nextState+6)
	res	6,d
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
;3752   KUNLOCK();
	.debug	# 3752
	call	_KUNLOCK
;3753   WriteDig();
@658:
	.debug	< @658 @659
	.debug	# 3753
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@659:
	.debug	>
;3754 
;3755   fpgaInitialized = downloadOK = false;
	.debug	# 3755
	xor	a,a
	ld	(ix-2),a
	ld	(_fpgaInitialized),a
;3756 
;3757 //--- make sure EEPROM is ready to accept commands ---
;3758   EEPROM_Disable();  writeCmdEE(EEPROM_WRDI);
	.debug	# 3758
	ld	a,(_srPFDR)
	or	a,1
	ld	(_srPFDR),a
	ioi ld	(56),a
	ld	hl,0x4
	push	hl
	lcall	$writeCmdEE
	pop	hl
;3759 
;3760 //===== erase EEPROM and copy bytes from the file in to it =====
;3761   do {
;3762   //--- read device ID ---
;3763     *cmdBuf = EEPROM_RDID;  writeReadEE(cmdBuf, 1, buf2, 4);
@663:
	.debug	< @663 @664
	.debug	# 3763
	ld	(ix-67),0x9f
	ld	hl,0x4
	push	hl
	ld	hl,-577+@651
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	hl,-61+@651
	add	hl,sp
	push	hl
	lcall	$writeReadEE
	add	sp,8
;3764     printf("  Device ID: %02X %02X %02X %02X\r\n",
;3765            buf2[0], buf2[1], buf2[2], buf2[3] );
	.debug	# 3765
	ld	hl,-576+@651
	add	hl,sp
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,-575+@651
	add	hl,sp
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,-574+@651
	add	hl,sp
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,-573+@651
	add	hl,sp
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @1+3311)
	ld	c,phys @1+3311 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;3766 
;3767   //--- unprotect all sectors ---
;3768     printf("  Unprotecting all sectors...\r\n");
	.debug	# 3768
	ld	de,word (phys @1+3346)
	ld	c,phys @1+3346 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3769     *cmdBuf = EEPROM_UNPR;
	.debug	# 3769
	ld	(ix-67),0x39
;3770     for (i=0; i<11; ++i)  {
@665:
	.debug	< @665 @666
	.debug	# 3770
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@667:
	ld	hl,(ix-4)
	ld	de,0x800b
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@668
;3771       if (! (writeCmdEE(EEPROM_WREN) & 0x02))  break;
@670:
	.debug	< @670 @671
	.debug	# 3771
	ld	hl,0x6
	push	hl
	lcall	$writeCmdEE
	pop	hl
	and	a,2
	jr	z,@668
;3772       memcpy(cmdBuf+1, SectorAddr[i], 3);  writeReadEE(cmdBuf, 4, NULL, 0);
	.debug	# 3772
	ld	hl,0x3
	push	hl
	ld	hl,(ix-4)
	ld	bc,0x3
	ex	de,hl
	mul
	ld	hl,_SectorAddr
	add	hl,bc
	push	hl
	ld	hl,-62+@651
	add	hl,sp
	push	hl
	call	_memcpy
	add	sp,6
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,-61+@651
	add	hl,sp
	push	hl
	lcall	$writeReadEE
	add	sp,8
;3773     }
@671:
	.debug	>
;3774     if (i != 11)  break;
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@667
@668:
@666:
	.debug	>
	.debug	# 3774
	ld	hl,(ix-4)
	ld	de,0xb
	or	a,a
	sbc	hl,de
	jp	nz,@661
;3775 
;3776   //--- erase the EEPROM ---
;3777     printf("  Erasing EEPROM");  *buf = EEPROM_RDSR;
	.debug	# 3777
	ld	de,word (phys @1+3378)
	ld	c,phys @1+3378 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	a,0x5
	ld	hl,-323+@651
	add	hl,sp
	ld	(hl),a
;3778 
;3779     if (! (writeCmdEE(EEPROM_WREN) & 0x02))  break;
	.debug	# 3779
	ld	hl,0x6
	push	hl
	lcall	$writeCmdEE
	pop	hl
	and	a,2
	jp	z,@661
;3780     if (! (statReg = writeCmdEE(EEPROM_ERASE_ALL) & 0x01))  {
	.debug	# 3780
	ld	hl,0x60
	push	hl
	lcall	$writeCmdEE
	pop	hl
	and	a,1
	ld	(ix-20),a
	or	a,a
	jr	nz,@675
;3781       printf("\r\nUnable to initiate Chip Erase: Status: 0x%02X\r\n", statR
@676:
	.debug	< @676 @677
	.debug	# 3781
	bool	hl
	ld	l,a
	push	hl
	ld	de,word (phys @1+3395)
	ld	c,phys @1+3395 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3782       break;
	.debug	# 3782
;3783     }
	jp	@661
@677:
	.debug	>
;3784 
;3785     startTime = GetMS();
@675:
	.debug	# 3785
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;3786     while (msSince(startTime) < 12000)  {
@678:
	.debug	# 3786
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x2ee0
	ld	bc,0
	call	__lsub##
	jr	nc,@679
;3787       if (! (busy = writeCmdEE(0) & 0x01))  break;
@680:
	.debug	< @680 @681
	.debug	# 3787
	bool	hl
	ld	l,h
	push	hl
	lcall	$writeCmdEE
	pop	hl
	and	a,1
	ld	(ix-19),a
	or	a,a
	jr	z,@679
;3788       printf(".");  fflush(stdout);  sleepMS(500);
	.debug	# 3788
	ld	de,word (phys @1+3445)
	ld	c,phys @1+3445 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
	ld	de,0x1f4
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3789     }
@681:
	.debug	>
;3790     printf("\r\n");
	jp	@678
@679:
	.debug	# 3790
	ld	de,word (phys @1+2495)
	ld	c,phys @1+2495 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3791     if (busy)  { printf("Erase timed out\r\n");  break; }
	.debug	# 3791
	ld	a,(ix-19)
	or	a,a
	jr	z,@683
@684:
	.debug	< @684 @685
	ld	de,word (phys @1+3447)
	ld	c,phys @1+3447 >> 16
	jp	@1838
@685:
	.debug	>
;3792 
;3793     if (fstat(fromfd, &fsInfo) < 0)  { perror(NULL);  Exit(-2); }
@683:
	.debug	# 3793
	ld	hl,-62+@651
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$fstat
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@686
@687:
	.debug	< @687 @688
	ld	d,e
	ld	c,e
	ld	b,e
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
@688:
	.debug	>
;3794     fileSize = (ulong)fsInfo.st_size;
@686:
	.debug	# 3794
	ld	hl,(ix-40)
	ex	de,hl
	ld	hl,(ix-38)
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
;3795     printf("  File size: %lu bytes\r\n", fileSize);
	.debug	# 3795
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3465)
	ld	c,phys @1+3465 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3796 
;3797 
;3798   //--- copy the firmware file from the source fd to the EEPROM ---
;3799     printf("  Copying file to EEPROM...\r\n");
	.debug	# 3799
	ld	de,word (phys @1+3490)
	ld	c,phys @1+3490 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3800     ttlBytes = 0;
	.debug	# 3800
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;3801     if (! (writeCmdEE(EEPROM_WREN) & 0x02))  break;
	.debug	# 3801
	ld	hl,0x6
	push	hl
	lcall	$writeCmdEE
	pop	hl
	and	a,2
	jp	z,@661
;3802     memset(cmdBuf, 0, sizeof(cmdBuf));  cmdBuf[0] = EEPROM_SEQ_PROG;
	.debug	# 3802
	ld	hl,0x5
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-63+@651
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
	ld	(ix-67),0xaf
;3803     while ((count = read(fromfd, buf, sizeof(buf))) > 0)  {
@690:
	.debug	# 3803
	ld	hl,0x100
	push	hl
	ld	hl,-321+@651
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$read
	add	sp,6
	ld	(ix-6),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@691
	jp	z,@691
;3804       for (i=0; i<count; ++i)  {
@692:
	.debug	< @692 @693
@694:
	.debug	< @694 @695
	.debug	# 3804
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@696:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	call	__icmp##
	jr	nc,@697
;3805         if (! ttlBytes)  {  // 1st byte requires cmd code and 3 addr bytes
@699:
	.debug	< @699 @700
	.debug	# 3805
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	or	hl,de
	jr	nz,@701
;3806           cmdBuf[4] = *buf;  writeReadEE(cmdBuf, 5, NULL, 0);  }
@702:
	.debug	< @702 @703
	.debug	# 3806
	ld	hl,-323+@651
	add	hl,sp
	ld	a,(hl)
	ld	(ix-63),a
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	l,0x5
	push	hl
	ld	hl,-61+@651
	add	hl,sp
	push	hl
	lcall	$writeReadEE
	add	sp,8
@703:
	.debug	>
;3807         else  {  // subsequent bytes require only cmd code
	jr	@704
@701:
;3808           cmdBuf[1] = buf[i];  writeReadEE(cmdBuf, 2, NULL, 0);  }
@705:
	.debug	< @705 @706
	.debug	# 3808
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,-323+@651
	add	hl,sp
	add	hl,de
	ld	a,(hl)
	ld	(ix-66),a
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	l,0x2
	push	hl
	ld	hl,-61+@651
	add	hl,sp
	push	hl
	lcall	$writeReadEE
	add	sp,8
@706:
	.debug	>
;3809 //        busy = writeCmdEE(0) & 0x01;  if (busy)  break;
;3810         ++ttlBytes;
@704:
	.debug	# 3810
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__linc##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;3811       }
@700:
	.debug	>
;3812       if (busy)  break;
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@696
@697:
@695:
	.debug	>
	.debug	# 3812
	ld	a,(ix-19)
	or	a,a
	jr	nz,@691
;3813       if (showProgress)  { printf("%10lu\r", ttlBytes);  fflush(stdout); }
	.debug	# 3813
	ld	a,(ix+7)
	or	a,a
	jr	z,@708
@709:
	.debug	< @709 @710
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3520)
	ld	c,phys @1+3520 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
@710:
	.debug	>
;3814     }
@708:
@693:
	.debug	>
;3815     writeCmdEE(EEPROM_WRDI);
	jp	@690
@691:
	.debug	# 3815
	ld	hl,0x4
	push	hl
	lcall	$writeCmdEE
	pop	hl
;3816     if (busy OR (ttlBytes != fileSize))
	.debug	# 3816
	ld	a,(ix-19)
	or	a,a
	jr	nz,@711
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	call	__lsub##
	jr	z,@712
@711:
;3817       printf("Error writing to EEPROM\r\n");
	.debug	# 3817
	ld	de,word (phys @1+3527)
	ld	c,phys @1+3527 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3818     else
;3819       if (showProgress)  printf("  Wrote %lu bytes to EEPROM\r\n", ttlBytes
	jr	@713
@712:
	.debug	# 3819
	ld	a,(ix+7)
	or	a,a
	jr	z,@714
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3553)
	ld	c,phys @1+3553 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3820 
;3821   //--- protect all sectors ---
;3822     printf("  Protecting all sectors...\r\n");
@714:
@713:
	.debug	# 3822
	ld	de,word (phys @1+3583)
	ld	c,phys @1+3583 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3823     *cmdBuf = EEPROM_PROT;
	.debug	# 3823
	ld	(ix-67),0x36
;3824     for (i=0; i<11; ++i)  {
@715:
	.debug	< @715 @716
	.debug	# 3824
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@717:
	ld	hl,(ix-4)
	ld	de,0x800b
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@718
;3825       if (! (writeCmdEE(EEPROM_WREN) & 0x02))  break;
@720:
	.debug	< @720 @721
	.debug	# 3825
	ld	hl,0x6
	push	hl
	lcall	$writeCmdEE
	pop	hl
	and	a,2
	jr	z,@718
;3826       memcpy(cmdBuf+1, SectorAddr[i], 3);  writeReadEE(cmdBuf, 4, NULL, 0);
	.debug	# 3826
	ld	hl,0x3
	push	hl
	ld	hl,(ix-4)
	ld	bc,0x3
	ex	de,hl
	mul
	ld	hl,_SectorAddr
	add	hl,bc
	push	hl
	ld	hl,-62+@651
	add	hl,sp
	push	hl
	call	_memcpy
	add	sp,6
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,-61+@651
	add	hl,sp
	push	hl
	lcall	$writeReadEE
	add	sp,8
;3827     }
@721:
	.debug	>
;3828 
;3829 
;3830 
;3831   //--- verify contents of EEPROM ---
;3832     if (verify)  {
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@717
@718:
@716:
	.debug	>
	.debug	# 3832
	ld	a,(ix+9)
	or	a,a
	jp	z,@723
;3833       printf("  Verifying EEPROM copy...\r\n");
@724:
	.debug	< @724 @725
	.debug	# 3833
	ld	de,word (phys @1+3613)
	ld	c,phys @1+3613 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3834 
;3835       if (lseek(fromfd, 0, SEEK_SET) != 0)  {
	.debug	# 3835
	bool	hl
	ld	l,h
	push	hl
	ld	d,h
	ld	e,l
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$lseek
	add	sp,8
	ld	hl,bc
	or	hl,de
	jr	z,@726
;3836         printf("Unable to reset source file pos to verify EEPROM\r\n");  br
@727:
	.debug	< @727 @728
	.debug	# 3836
	ld	de,word (phys @1+3642)
	ld	c,phys @1+3642 >> 16
@1838:
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jp	@661
@728:
	.debug	>
;3837 
;3838       memset(cmdBuf, 0, sizeof(cmdBuf));  cmdBuf[0] = EEPROM_READ;
@726:
	.debug	# 3838
	ld	hl,0x5
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-63+@651
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
	ld	(ix-67),0x3
;3839       EEPROM_Enable();  WriteSPI2(cmdBuf, 4);
	.debug	# 3839
	ld	a,(_srPFDR)
	and	a,254
	ld	(_srPFDR),a
	ioi ld	(56),a
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,-63+@651
	add	hl,sp
	push	hl
	ld	hl,(_spi2Port)
	push	hl
	lcall	$_spiWrite_
	add	sp,8
;3840 
;3841       ttlBytes = 0;
	.debug	# 3841
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;3842 
;3843       while ((count = read(fromfd, buf, sizeof(buf))) > 0)  {
@729:
	.debug	# 3843
	ld	hl,0x100
	push	hl
	ld	hl,-321+@651
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$read
	add	sp,6
	ld	(ix-6),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@730
	jp	z,@730
;3844         ReadSPI2(buf2, count);
@731:
	.debug	< @731 @732
	.debug	# 3844
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-6)
	push	hl
	ld	hl,-575+@651
	add	hl,sp
	push	hl
	ld	hl,(_spi2Port)
	push	hl
	lcall	$_spiRead_
	add	sp,8
;3845         for (i=0; i<count; ++i)  {
@733:
	.debug	< @733 @734
	.debug	# 3845
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@735:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	call	__icmp##
	jr	nc,@736
;3846 //          if (!((uchar)ttlBytes & 0x0f))  printf("\r\n%06lX:", ttlBytes);
;3847 //          printf(" %02X", buf2[i]);
;3848           if (buf[i] != buf2[i])  {
@738:
	.debug	< @738 @739
	.debug	# 3848
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,-323+@651
	add	hl,sp
	add	hl,de
	ld	bc,hl
	ld	hl,-579+@651
	add	hl,sp
	add	hl,de
	ld	a,(hl)
	ld	de,bc
	ex	de,hl
	ld	l,(hl)
	sub	a,l
	jr	z,@740
;3849             printf("Mismatch at offset %lu:  EEPROM: 0x%02X,  File: 0x%02X\
@741:
	.debug	< @741 @742
;3850                    ttlBytes, buf[i], buf2[i]);
	.debug	# 3850
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,-579+@651
	add	hl,sp
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,-321+@651
	add	hl,sp
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3693)
	ld	c,phys @1+3693 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;3851             break;
	.debug	# 3851
;3852           }
	jr	@736
@742:
	.debug	>
;3853           if (++ttlBytes >= fileSize)  break;  //tdebug
@740:
	.debug	# 3853
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__linc##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
	push	bc
	push	de
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	call	__lsub##
	jr	nc,@736
;3854         }
@739:
	.debug	>
;3855         if (showProgress)  { printf("%10lu\r", ttlBytes);  fflush(stdout); 
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@735
@736:
@734:
	.debug	>
	.debug	# 3855
	ld	a,(ix+7)
	or	a,a
	jr	z,@744
@745:
	.debug	< @745 @746
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3520)
	ld	c,phys @1+3520 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
@746:
	.debug	>
;3856         if (ttlBytes >= fileSize)  break;  //tdebug
@744:
	.debug	# 3856
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	call	__lsub##
	jp	c,@729
;3857       }
@732:
	.debug	>
;3858       printf("\r\n");
@730:
	.debug	# 3858
	ld	de,word (phys @1+2495)
	ld	c,phys @1+2495 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3859       EEPROM_Disable();
	.debug	# 3859
	ld	a,(_srPFDR)
	or	a,1
	ld	(_srPFDR),a
	ioi ld	(56),a
;3860 
;3861       if (ttlBytes == fileSize)  {
	.debug	# 3861
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	call	__lsub##
	jr	nz,@748
;3862         downloadOK = true;  printf("Verified %lu bytes\r\n", ttlBytes);  }
@749:
	.debug	< @749 @750
	.debug	# 3862
	ld	a,0x1
	ld	(ix-2),a
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3750)
	ld	c,phys @1+3750 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
@750:
	.debug	>
;3863       else
;3864         printf("Copies do not match!\r\n");
	jr	@751
@748:
	.debug	# 3864
	ld	de,word (phys @1+3771)
	ld	c,phys @1+3771 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3865     }
@751:
@725:
	.debug	>
;3866 
;3867   } while(0);
@723:
@664:
	.debug	>
	.debug	# 3867
;3868 
;3869 
;3870 //--- allow FPGA to have the SPI bus again.  This also causes it to reload 
;3871 //--- from the new image in EEPROM (good or bad) ---
;3872   KLOCK();
@661:
	.debug	# 3872
	call	_KLOCK
;3873   SetBits(Next.digitalOut, FPGA_SPI);  digitalOut = Next.digitalOut;
	.debug	# 3873
	ld	de,(_nextState+4)
	ld	bc,(_nextState+6)
	set	6,d
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
;3874   KUNLOCK();
	.debug	# 3874
	call	_KUNLOCK
;3875   WriteDig();
@752:
	.debug	< @752 @753
	.debug	# 3875
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@753:
	.debug	>
;3876 
;3877   releaseLock(APPL_LOCK);
	.debug	# 3877
	bool	hl
	ld	l,h
	push	hl
	lcall	$releaseLock
	pop	de
;3878 
;3879   if (downloadOK)  printf("FPGA firmware download complete!\r\n");
	.debug	# 3879
	ld	a,(ix-2)
	or	a,a
	jr	z,@754
	ld	de,word (phys @1+3794)
	ld	c,phys @1+3794 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3880 
;3881 //--- wait for FPGA to load new firmware and release SPI bus ---
;3882   fpgaInitialized = waitFPGA(3000);
@754:
	.debug	# 3882
	ld	de,0xbb8
	ld	bc,0
	push	bc
	push	de
	lcall	$waitFPGA
	add	sp,4
	ld	(_fpgaInitialized),a
;3883 
;3884   return 0;
	.debug	# 3884
	bool	hl
	ld	l,h
;3885 }
@652:
	.debug	} @652 3885

@651	equ	579
	ld	sp,ix
	pop	ix
	lret
@653	equ	581
;3886 
;3887 
;3888 //-------------------------------------------------------------------------
;3889 //  Write and Read a group of long integers to/from the DSP
;3890 //
;3891 //  The counts are the # of long (32-bit) words to send/rcv
;3892 //
;3893 //  Returns 0 on success, < 0 if an error
;3894 // ------------------------------------------------------------------------
;3895 //  Exchange of data with the DSP is done using a bi-directional (simultane
;3896 //  send/recv) clocked SPI interface.  All data is exchanged in 32-bit (4-b
;3897 //  packets.  While we are sending a 32-bit packet to the DSP, it is using 
;3898 //  same clock pulses to simultaneously send a 32-bit packet in response.
;3899 //
;3900 //  Each exchange of a 32-bit packet consists of setting the DSP /Enable si
;3901 //  low, writing (while simultaneously reading) 32-bits of data, and then
;3902 //  setting the DSP /Enable signal high.
;3903 //
;3904 //  Due to the way the DSP buffers are set up, all responses from the DSP a
;3905 //  always 2 packets "behind" the ones that contained the commands that the
;3906 //  are a response to.  We can write as many commands as we want in a
;3907 //  sequence of packets, but the response to each one will always be receiv
;3908 //  2 packets later.  Given that we generally want to read the response to
;3909 //  a set of commands as soon as possible, we normally have to add some
;3910 //  dummy or filler packets to the sequence to get the desired response
;3911 //  packets.  For extended responses (like reading of waveform data), we mu
;3912 //  send lots of filler packets to get all the data.
;3913 //-------------------------------------------------------------------------
;3914 
;3915 extern const uchar RevBitTable[];
;3916 
;3917 int readPlot(ulong regNum, ulong far *rcvBuf, uint rcvCount)
;3918 {
$readPlot::
	.debug	G $readPlot 128 9
	.debug	{ $readPlot 128 3917 @757 @756
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
	.debug	A regNum 5 9
	.debug	A rcvBuf 9 129
	.debug	A rcvCount 13 7
;3919   uchar  enableLow, enableHigh;
	.debug	L enableLow -1 3
	.debug	L enableHigh -2 3
;3920   uint  u;
	.debug	L u -4 7
;3921   ulong  xmitWord, rcvWord;
	.debug	L xmitWord -8 9
	.debug	L rcvWord -12 9
;3922 //  uchar *ptr;
;3923 
;3924 
;3925   if (hdwType != HT_PHASE_CTLR)  return 0;
	.debug	# 3925
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@758
	bool	hl
	ld	l,h
	jp	@756
;3926 
;3927   if (!spi1Port)  return -1;
@758:
	.debug	# 3927
	ld	hl,(_spi1Port)
	bool	hl
	jp	z,@1837
;3928 
;3929   if (getLockDSP(1000) <= 0)  return -1;
	.debug	# 3929
	ld	de,0x3e8
	ld	bc,0
	push	bc
	push	de
	lcall	$getLockDSP
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@761
	jr	nc,@760
@761:
	jp	@1837
;3930 
;3931   enableLow = PGDRShadow & (uchar)(~_DSP_WR_RD);
@760:
	.debug	# 3931
	ld	a,(_srPGDR)
	and	a,239
	ld	(ix-1),a
;3932   enableHigh = enableLow | (uchar)_DSP_WR_RD;
	.debug	# 3932
	or	a,16
	ld	(ix-2),a
;3933 
;3934   xmitWord = htonl(regNum);
	.debug	# 3934
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;3935 
;3936   if (_spiLock_(spi1Port))  { releaseLockDSP();  return -1; }
	.debug	# 3936
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiLock_
	pop	de
	bool	hl
	jr	z,@762
@763:
	.debug	< @763 @764
	lcall	$releaseLockDSP
@1837:
	ld	hl,0xffff
	jp	@756
@764:
	.debug	>
;3937 
;3938 /*
;3939   NOTE:  This takes about 80 ms for a 1024 point (4096 byte) waveform,
;3940          but about 50 ms of that is just to do what has to be done for
;3941          each byte:  reverse the bit of the byte being sent, tell the
;3942          CPU to send then rcv a byte, wait for the rcv to finish, and
;3943          reverse the bit order of the rcvd byte.
;3944 
;3945          Minimzing the effect of having to save the whole result to a
;3946          far pointer by using a near buf in root of about 512 bytes
;3947          (and then copying it each time it is filled to the far buffer
;3948          using fmemcpy) shaved off only about 4 ms.
;3949 
;3950          One additional (possibly significant) change might be to
;3951          reverse the bits of the bytes in xmitWord before starting
;3952          the loop, and using a modified vers of the _spiWrRdFast_()
;3953          function that doesn't do this for the transmitted byte.
;3954 
;3955          But keep in mind that, at the 2MHz clock rate we are using,
;3956          even if we could eliminate all pauses (such as the one that
;3957          HAS to be there to toggle the bit that indicates the start
;3958          and end of each 4-byte packet), sending and receiving 4096
;3959          bytes would take over 16 ms.
;3960 
;3961            NOTE:  At 2MHz SPI rate and 44MHz CPU clock rate, each
;3962                   8-bit write/read takes 8 * 44 = 176 CPU clock
;3963                   cycles!  That's a significant # of instructions.
;3964 
;3965                   Any way I could overlap prep for the next byte
;3966                   while waiting to read the result of the prev one?
;3967                   THAT could reduce overhead quite a bit (NOTE:  An
;3968                   interrupt-driven approach could help with this).
;3969 
;3970          Given that we DO have to toggle the start/end signal each
;3971          4 bytes, and we DO have to reverse the bits for each byte
;3972          received, it seems unlikely that we can reduce that 50 ms
;3973          by much.
;3974 
;3975             One thought:  See how much of that 50ms is the bit reversing
;3976             by reversing the sent bytes before we start, and disabling
;3977             the reversing in just the FAST version (so as not to mess up
;3978             anything but the waveform data).  If the reduction in time
;3979             is significant enough, I could put off the reversing of the
;3980             bits until the next pass.  At the very least, this would even
;3981             out the CPU time usage and reduce the max time the applic
;3982             task blocks everything else.
;3983 
;3984 */
;3985 
;3986 //--- pre-reverse the bits in the xmitWord ---
;3987 //  ptr = (char *)&xmitWord;
;3988 //  for (u=0; u<4; ++u,++ptr)  *ptr = RevBitTable[*ptr];
;3989 
;3990 
;3991 //--- "prime the pump":  Ignore the first group of readings ---
;3992   for (u=0; u<RespOffset; ++u)  {
@762:
@765:
	.debug	< @765 @766
	.debug	# 3992
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@767:
	ld	hl,(ix-4)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nc,@768
;3993     OUTI(PGDR, enableLow);  // signal start of 32-bit packet
@770:
	.debug	< @770 @771
	.debug	# 3993
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;3994     _spiWrRdFast_((char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 3994
	ld	hl,0x4
	push	hl
	ld	hl,-10+@755
	add	hl,sp
	push	hl
	ld	hl,-4+@755
	add	hl,sp
	push	hl
	lcall	$_spiWrRdFast_
	add	sp,6
;3995     OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 3995
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;3996   }
@771:
	.debug	>
;3997 //--- save the rest of the readings ---
;3998   for (u=0; u<rcvCount; ++u)  {
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@767
@768:
@766:
	.debug	>
@772:
	.debug	< @772 @773
	.debug	# 3998
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@774:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix+13)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@775
;3999     OUTI(PGDR, enableLow);  // signal start of 32-bit packet
@777:
	.debug	< @777 @778
	.debug	# 3999
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4000     _spiWrRdFast_((char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 4000
	ld	hl,0x4
	push	hl
	ld	hl,-10+@755
	add	hl,sp
	push	hl
	ld	hl,-4+@755
	add	hl,sp
	push	hl
	lcall	$_spiWrRdFast_
	add	sp,6
;4001     OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 4001
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4002     *rcvBuf = rcvWord;  ++rcvBuf;
	.debug	# 4002
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__farst4p##
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix+11),hl
	ex	de,hl
	ld	(ix+9),hl
	ex	de,hl
;4003   }
@778:
	.debug	>
;4004 
;4005 
;4006   _spiUnlock_(spi1Port);
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@774
@775:
@773:
	.debug	>
	.debug	# 4006
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiUnlock_
	pop	de
;4007 
;4008   releaseLockDSP();
	.debug	# 4008
	lcall	$releaseLockDSP
;4009 
;4010   return 0;
	.debug	# 4010
	bool	hl
	ld	l,h
;4011 }
@756:
	.debug	} @756 4011

@755	equ	12
	ld	sp,ix
	pop	ix
	lret
@757	equ	14
;4012 
;4013 //-------------------------------------------------------------------------
;4014 //  For testing purposes:  Replaces actual read of a DSP register value for
;4015 //  hdw platforms other than the actual Phase Controller.
;4016 //-------------------------------------------------------------------------
;4017 ulong fakeRegVal(ulong regNum)
;4018 {
$fakeRegVal::
	.debug	G $fakeRegVal 130 9
	.debug	{ $fakeRegVal 130 4017 @781 @780
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-18
	.debug	A regNum 5 9
;4019   uint  r;
	.debug	L r -2 7
;4020   ulong  rcvWord;
	.debug	L rcvWord -6 9
;4021   F32  fval, percNoise;
	.debug	L fval -10 10
	.debug	L percNoise -14 10
;4022   const RD_DSP_REG far *dspReg;
	.debug	L dspReg -18 86
;4023 
;4024 
;4025   for (r=0,dspReg=rdDSPregs; r<NUM_RD_DSP_REGS; ++r,++dspReg)  {
@782:
	.debug	< @782 @783
	.debug	# 4025
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	de,word (phys _rdDSPregs)
	ld	c,phys _rdDSPregs >> 16
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
@784:
	ld	hl,(ix-2)
	ld	de,0x24
	or	a,a
	sbc	hl,de
	jp	nc,@785
;4026     if (dspReg->id != regNum)  continue;
@787:
	.debug	< @787 @788
	.debug	# 4026
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsub##
	jp	nz,@786
;4027 
;4028     rcvWord = dspReg->typical;
	.debug	# 4028
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xb
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;4029     if (!dspReg->percNoise)  return htonl(rcvWord);
	.debug	# 4029
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xf
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jp	nz,@790
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	jp	@780
;4030 
;4031     percNoise = (F32)dspReg->percNoise * (F32)rand() / (F32)RAND_MAX / 100.
@790:
	.debug	# 4031
	lcall	$rand
	ex	de,hl
	call	__itof##
	push	bc
	push	de
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xf
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	call	__uitof##
	call	__fmlt##
	push	bc
	push	de
	ld	de,0xfe00
	ld	bc,0x46ff
	call	__fdiv##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x42c8
	call	__fdiv##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;4032 
;4033 //    rand()  RAND_MAX
;4034 
;4035     switch (dspReg->type)  {
	.debug	# 4035
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	jr	@791
;4036 
;4037       case RT_S32:
@793:
	.debug	< @793 @794
;4038         rcvWord = (U32)((S32)rcvWord + (S32)(percNoise * rcvWord));
	.debug	# 4038
;4039         break;
	.debug	# 4039
;4040 
;4041       case RT_U32:
;4042         rcvWord += (U32)(percNoise * rcvWord);
	.debug	# 4042
;4043         break;
	.debug	# 4043
;4044 
;4045       case RT_F32:
;4046         fval = *(F32 *)&rcvWord;
	.debug	# 4046
@797:
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;4047         fval += percNoise * fval;
	.debug	# 4047
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__fmlt##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__fadd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;4048         rcvWord = *(ulong *)&fval;
	.debug	# 4048
	jr	@1835
@1836:
;4049         break;
	.debug	# 4049
;4050 
;4051       case RT_PHASE:
;4052         rcvWord += (U32)(percNoise * rcvWord);
	.debug	# 4052
@798:
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__ultof##
	push	bc
	push	de
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	call	__fmlt##
	call	__ftol##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
@1835:
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;4053         break;
	.debug	# 4053
;4054     }
	jr	@792
@794:
	.debug	>
;4055 
;4056     return htonl(rcvWord);
@791:
	cp	0x2
	jr	z,@1836
	cp	0x3
	jr	z,@1836
	cp	0x4
	jr	z,@797
	cp	0x63
	jr	z,@798
@792:
	.debug	# 4056
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	jr	@780
;4057   }
@788:
	.debug	>
;4058 
;4059 //  *((float *)&rcvWord) = 0.1234 + (float)(uint)(GetMS_()>>5 & 0x3F);
;4060 //  return htonl(rcvWord);
;4061 
;4062   return 0xFFFFFFFFL;
@786:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x11
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
	jp	@784
@785:
@783:
	.debug	>
	.debug	# 4062
	ld	de,0xffff
	ld	c,e
	ld	b,e
;4063 }
@780:
	.debug	} @780 4063

@779	equ	18
	ld	sp,ix
	pop	ix
	lret
@781	equ	20
;4064 
;4065 //-------------------------------------------------------------------------
;4066 //  Read the values for the RO DSP registers and update the value of the
;4067 //  corresponding ModBus registers.
;4068 //
;4069 //  Returns 0 on success, < 0 if an error
;4070 // ------------------------------------------------------------------------
;4071 //  See WrRdDSP() above for details on how the DSP interface works
;4072 //-------------------------------------------------------------------------
;4073 int read_DSP_Regs(void)
;4074 {
$read_DSP_Regs::
	.debug	G $read_DSP_Regs 78 9
	.debug	{ $read_DSP_Regs 78 4073 @801 @800
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-24
;4075   uchar  enableLow, enableHigh;
	.debug	L enableLow -1 3
	.debug	L enableHigh -2 3
;4076   uint  i, wordCount;
	.debug	L i -4 7
	.debug	L wordCount -6 7
;4077   ulong  xmitWord, dspVal;
	.debug	L xmitWord -10 9
	.debug	L dspVal -14 9
;4078   RegInfo *mbReg;
	.debug	L mbReg -16 38
;4079   const RD_DSP_REG far *reqReg;
	.debug	L reqReg -20 86
;4080   const RD_DSP_REG far *dspReg;
	.debug	L dspReg -24 86
;4081 
;4082 
;4083   if (getLockDSP(1000) <= 0)  return -1;
	.debug	# 4083
	ld	de,0x3e8
	ld	bc,0
	push	bc
	push	de
	lcall	$getLockDSP
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@803
	jr	nc,@802
@803:
	ld	hl,0xffff
	jp	@800
;4084 
;4085   wordCount = NUM_RD_DSP_REGS + RespOffset;
@802:
	.debug	# 4085
	ld	hl,0x26
	ld	(ix-6),hl
;4086 
;4087   enableLow = PGDRShadow & (uchar)(~_DSP_WR_RD);
	.debug	# 4087
	ld	a,(_srPGDR)
	and	a,239
	ld	(ix-1),a
;4088   enableHigh = enableLow | (uchar)_DSP_WR_RD;
	.debug	# 4088
	or	a,16
	ld	(ix-2),a
;4089 
;4090   for (i=0,reqReg=rdDSPregs; i<wordCount; ++i,++reqReg)  {
@804:
	.debug	< @804 @805
	.debug	# 4090
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	ld	de,word (phys _rdDSPregs)
	ld	c,phys _rdDSPregs >> 16
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
@806:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@807
;4091 
;4092     xmitWord = (i < NUM_RD_DSP_REGS) ? htonl(reqReg->id) : 0;
@809:
	.debug	< @809 @810
	.debug	# 4092
	ld	hl,(ix-4)
	ld	de,0x24
	or	a,a
	sbc	hl,de
	jp	nc,@811
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	call	__farld4##
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	jr	@812
@811:
	ld	de,0
	ld	c,e
	ld	b,e
@812:
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;4093 
;4094     if (hdwType != HT_PHASE_CTLR)
	.debug	# 4094
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@813
;4095       dspVal = (i < RespOffset) ? 0 : fakeRegVal((reqReg-RespOffset)->id);
	.debug	# 4095
	ld	hl,(ix-4)
	dec	e
	or	a,a
	sbc	hl,de
	jr	nc,@814
	bool	hl
	ld	l,h
	jr	@815
@814:
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xffde
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	lcall	$fakeRegVal
	add	sp,4
	jr	@816
@815:
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
@816:
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;4096     else  {
	jr	@817
@813:
;4097       OUTI(PGDR, enableLow);  // signal start of 32-bit packet
@818:
	.debug	< @818 @819
	.debug	# 4097
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4098       _spiWrRd_(spi1Port, (char *)&xmitWord, (char *)&dspVal, 4);
	.debug	# 4098
	ld	hl,0x4
	push	hl
	ld	hl,-12+@799
	add	hl,sp
	push	hl
	ld	hl,-6+@799
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;4099       OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 4099
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4100     }
@819:
	.debug	>
;4101 
;4102     if (i < RespOffset)  continue;  // responses are offset by RespOffset p
@817:
	.debug	# 4102
	ld	hl,(ix-4)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	c,@808
;4103 
;4104     dspReg = reqReg - RespOffset;
	.debug	# 4104
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xffde
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
;4105 
;4106   //--- convert value as needed and update the ModBus register value ---
;4107     mbReg = dspReg->mbReg;  dspVal = ntohl(dspVal);
	.debug	# 4107
	push	bc
	push	de
	ld	de,0x5
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-16),hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;4108     dsp2mb(mbReg, mbReg->regVal, dspReg, &dspVal);
	.debug	# 4108
	ld	hl,-14+@799
	add	hl,sp
	push	hl
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-16)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-16)
	push	hl
	lcall	$dsp2mb
	add	sp,10
;4109   }
@810:
	.debug	>
;4110 
;4111   releaseLockDSP();
@808:
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x11
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
	jp	@806
@807:
@805:
	.debug	>
	.debug	# 4111
	lcall	$releaseLockDSP
;4112 
;4113   return 0;
	.debug	# 4113
	bool	hl
	ld	l,h
;4114 }
@800:
	.debug	} @800 4114

@799	equ	24
	ld	sp,ix
	pop	ix
	lret
@801	equ	26
;4115 
;4116 //-------------------------------------------------------------------------
;4117 //  Send the current values to the DSP for each DSP R/W register that
;4118 //  represents a run-time setting (i.e. onces with writeMode == WM_EVERY).
;4119 //
;4120 //  Returns 0 on success, < 0 if an error
;4121 // ------------------------------------------------------------------------
;4122 //  See WrRdDSP() above for details on how the DSP interface works
;4123 //-------------------------------------------------------------------------
;4124 int write_DSP_Regs(void)
;4125 {
$write_DSP_Regs::
	.debug	G $write_DSP_Regs 78 9
	.debug	{ $write_DSP_Regs 78 4124 @823 @822
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-26
;4126   uchar  enableLow, enableHigh;
	.debug	L enableLow -1 3
	.debug	L enableHigh -2 3
;4127   uint  i;
	.debug	L i -4 7
;4128   ulong  xmitWord, rcvWord, dspVal, regNum;
	.debug	L xmitWord -8 9
	.debug	L rcvWord -12 9
	.debug	L dspVal -16 9
	.debug	L regNum -20 9
;4129   const WR_DSP_REG far *dspReg;
	.debug	L dspReg -24 89
;4130   RegInfo  *mbReg;
	.debug	L mbReg -26 38
;4131 
;4132 
;4133   if (hdwType == HT_PHASE_CTLR)  if (!spi1Port)  return -1;
	.debug	# 4133
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nz,@824
	ld	hl,(_spi1Port)
	bool	hl
	jr	nz,@825
	ld	hl,0xffff
	jp	@822
;4134 
;4135   if (getLockDSP(1000) <= 0)  return -2;
@825:
@824:
	.debug	# 4135
	ld	de,0x3e8
	ld	bc,0
	push	bc
	push	de
	lcall	$getLockDSP
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@827
	jr	nc,@826
@827:
	ld	hl,0xfffe
	jp	@822
;4136 
;4137   enableLow = PGDRShadow & (uchar)(~_DSP_WR_RD);
@826:
	.debug	# 4137
	ld	a,(_srPGDR)
	and	a,239
	ld	(ix-1),a
;4138   enableHigh = enableLow | (uchar)_DSP_WR_RD;
	.debug	# 4138
	or	a,16
	ld	(ix-2),a
;4139 
;4140   for (i=0,dspReg=wrDSPregs; i<NUM_WR_DSP_REGS; ++i,++dspReg)  {
@828:
	.debug	< @828 @829
	.debug	# 4140
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	ld	de,word (phys _wrDSPregs)
	ld	c,phys _wrDSPregs >> 16
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
@830:
	ld	hl,(ix-4)
	ld	de,0x44
	or	a,a
	sbc	hl,de
	jp	nc,@831
;4141     if (dspReg->writeMode != WM_EVERY)  continue;
@833:
	.debug	< @833 @834
	.debug	# 4141
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xf
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	sub	a,1
	jp	nz,@832
;4142 
;4143     regNum = dspReg->id | 1L;
	.debug	# 4143
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	call	__farld4##
	set	0,e
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
;4144 
;4145   //--- convert ModBus value to DSP format ---
;4146     mbReg = dspReg->mbReg;
	.debug	# 4146
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x5
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-26),hl
;4147     mb2dsp(mbReg, mbReg->regVal, dspReg, &dspVal);
	.debug	# 4147
	ld	hl,-16+@821
	add	hl,sp
	push	hl
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-26)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-26)
	push	hl
	lcall	$mb2dsp
	add	sp,10
;4148 
;4149   //--- send the register # in the 1st packet ---
;4150     xmitWord = htonl(regNum);
	.debug	# 4150
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;4151     OUTI(PGDR, enableLow);  // signal start of 32-bit packet
	.debug	# 4151
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4152     _spiWrRd_(spi1Port, (char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 4152
	ld	hl,0x4
	push	hl
	ld	hl,-10+@821
	add	hl,sp
	push	hl
	ld	hl,-4+@821
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;4153     OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 4153
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4154 
;4155   //--- send the value in the 2nd packet ---
;4156     xmitWord = htonl(dspVal);
	.debug	# 4156
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;4157     OUTI(PGDR, enableLow);  // signal start of 32-bit packet
	.debug	# 4157
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4158     _spiWrRd_(spi1Port, (char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 4158
	ld	hl,0x4
	push	hl
	ld	hl,-10+@821
	add	hl,sp
	push	hl
	ld	hl,-4+@821
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;4159     OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 4159
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4160   }
@834:
	.debug	>
;4161 
;4162   releaseLockDSP();
@832:
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	jp	@830
@831:
@829:
	.debug	>
	.debug	# 4162
	lcall	$releaseLockDSP
;4163 
;4164   return 0;
	.debug	# 4164
	bool	hl
	ld	l,h
;4165 }
@822:
	.debug	} @822 4165

@821	equ	26
	ld	sp,ix
	pop	ix
	lret
@823	equ	28
;4166 
;4167 
;4168 //-------------------------------------------------------------------------
;4169 //  write an 8-bit value to the FPGA
;4170 //
;4171 //  Returns 0 on success, -1 if an error
;4172 //-------------------------------------------------------------------------
;4173 int writeFPGAParallel(uchar id, uchar val)
;4174 {
$writeFPGAParallel::
	.debug	G $writeFPGAParallel 131 9
	.debug	{ $writeFPGAParallel 131 4173 @838 @837
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-11
	.debug	A id 5 3
	.debug	A val 7 3
;4175   uchar  i;
	.debug	L i -1 3
;4176   int  stat;
	.debug	L stat -3 6
;4177   ulong  lval, valBits;
	.debug	L lval -7 9
	.debug	L valBits -11 9
;4178 
;4179 
;4180   if (getLock(APPL_LOCK, 5000) <= 0)  return -1;
	.debug	# 4180
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	lcall	$getLock
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@840
	jr	nc,@839
@840:
	ld	hl,0xffff
	jp	@837
;4181 
;4182   stat = -1;
@839:
	.debug	# 4182
	ld	hl,0xffff
	ld	(ix-3),hl
;4183 
;4184   lval = (ulong)val << 8;
	.debug	# 4184
	ld	bc,0
	ld	d,(ix+7)
	ld	e,b
	ld	hl,bc
	ld	(ix-5),hl
	ex	de,hl
	ld	(ix-7),hl
	ex	de,hl
;4185   valBits = ((lval << 6) & 0x300000L) | (lval & 0x003f00L);
	.debug	# 4185
	ld	a,0x6
	call	__lshl##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x30
	call	__land##
	push	bc
	push	de
	ld	hl,(ix-7)
	ex	de,hl
	ld	hl,(ix-5)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3f00
	ld	c,e
	ld	b,e
	call	__land##
	call	__lor##
	ld	hl,bc
	ld	(ix-9),hl
	ex	de,hl
	ld	(ix-11),hl
	ex	de,hl
;4186 
;4187 //--- place value on "bus" ---
;4188   digitalOut = ((digitalOut & 0xcfc0f0L) | valBits) | ((uint)id & 0x0f);
	.debug	# 4188
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	ld	de,0xc0f0
	ld	bc,0xcf
	call	__land##
	push	bc
	push	de
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	call	__lor##
	ld	a,(ix+5)
	bool	hl
	ld	l,a
	push	bc
	push	de
	ld	de,0xf
	and	hl,de
	ex	de,hl
	ld	b,h
	ld	c,h
	call	__lor##
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
;4189   WriteDig();
@841:
	.debug	< @841 @842
	.debug	# 4189
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@842:
	.debug	>
;4190 
;4191 //--- latch the bits into the FPGA ---
;4192   digitalOut |= FPGA_CL1;  WriteDig();
	.debug	# 4192
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	set	3,c
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
@843:
	.debug	< @843 @844
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@844:
	.debug	>
;4193 
;4194 //--- short wait for the FPGA to acknowledge the new value ---
;4195   for (i=0; i<10; ++i)  {
@845:
	.debug	< @845 @846
	.debug	# 4195
	xor	a,a
	ld	(ix-1),a
@847:
	ld	a,(ix-1)
	sub	a,10
	jr	nc,@848
;4196     ReadDig();
@850:
	.debug	< @850 @851
@852:
	.debug	< @852 @853
	.debug	# 4196
	lcall	$ReadDigInputs
	ld	(_digitalIn),de
	ld	(_digitalIn+2),bc
@853:
	.debug	>
;4197     if (digitalIn & FPGA_CL2)  { stat = 0;  break; }
	.debug	# 4197
	push	bc
	push	de
	ld	de,0x1000
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@854
@855:
	.debug	< @855 @856
	bool	hl
	ld	l,h
	ld	(ix-3),hl
	jr	@848
@856:
	.debug	>
;4198   }
@854:
@851:
	.debug	>
;4199 
;4200 //--- reset FPGA "clock" signal ---
;4201   digitalOut &= ~FPGA_CL1;  WriteDig();
	ld	a,(ix-1)
	inc	a
	ld	(ix-1),a
	jr	@847
@848:
@846:
	.debug	>
	.debug	# 4201
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	res	3,c
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
@857:
	.debug	< @857 @858
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@858:
	.debug	>
;4202 
;4203   releaseLock(APPL_LOCK);
	.debug	# 4203
	bool	hl
	ld	l,h
	push	hl
	lcall	$releaseLock
	pop	de
;4204 
;4205   if (stat)
	.debug	# 4205
	ld	hl,(ix-3)
	bool	hl
	jr	z,@859
;4206     printf("FPGA did not acknowledge write of param id %d\r\n", (uint)id);
	.debug	# 4206
	bool	hl
	ld	l,(ix+5)
	push	hl
	ld	de,word (phys @1+3829)
	ld	c,phys @1+3829 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;4207 
;4208   return stat;
@859:
	.debug	# 4208
	ld	hl,(ix-3)
;4209 }
@837:
	.debug	} @837 4209

@836	equ	11
	ld	sp,ix
	pop	ix
	lret
@838	equ	13
;4210 
;4211 
;4212 //-------------------------------------------------------------------------
;4213 //  write bytes to the PLL via a serial port in SPI mode
;4214 //  NOTE:  All data sent out the same port in SPI mode will get clocked in 
;4215 //         the PLL, but the PLL will not do anything with it unless the
;4216 //         PLL's Load Enable signal transitions from high to low
;4217 //-------------------------------------------------------------------------
;4218 int writePLL(char *buf, uint len)
;4219 {
$writePLL::
	.debug	G $writePLL 132 9
	.debug	{ $writePLL 132 4218 @862 @861
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
	.debug	A buf 5 70
	.debug	A len 7 7
;4220   uchar  clockMode = NORM_LOW_LATCH_RISE;
	.debug	L clockMode -1 3
	.debug	# 4220
	xor	a,a
	ld	(ix-1),a
	.seg	FARCODE
;4221 
;4222 
;4223   if (hdwType != HT_PHASE_CTLR)  return 0;
	.debug	# 4223
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@863
	bool	hl
	ld	l,h
	jp	@861
;4224 
;4225   if (!spi1Port)  return -1;
@863:
	.debug	# 4225
	ld	hl,(_spi1Port)
	bool	hl
	jr	z,@866
;4226 
;4227   if (getLock(APPL_LOCK, 5000) <= 0)  return -1;
	.debug	# 4227
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	lcall	$getLock
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@866
	jr	nc,@865
@866:
	ld	hl,0xffff
	jr	@861
;4228 
;4229 //  ioctl(spi1fd, IOC_SET_CLK_MODE, &clockMode);
;4230   _spiConfig_(spi1Port, CLK_1MHz, clockMode);
@865:
	.debug	# 4230
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	l,0xa
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
;4231 
;4232   WriteSPI1(buf, len);  // clock bytes in to PLL
	.debug	# 4232
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrite_
	add	sp,8
;4233 
;4234 //--- set PLL Load Enable pin to load the internal initialization register 
;4235   digitalOut |= PLL_LE;  WriteDig();
	.debug	# 4235
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	set	0,c
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
@867:
	.debug	< @867 @868
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@868:
	.debug	>
;4236 
;4237 //--- reset PLL Load Enable pin to prepare for the next register load ---
;4238   digitalOut &= ~PLL_LE;  WriteDig();
	.debug	# 4238
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	res	0,c
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
@869:
	.debug	< @869 @870
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@870:
	.debug	>
;4239 
;4240   releaseLock(APPL_LOCK);
	.debug	# 4240
	bool	hl
	ld	l,h
	push	hl
	lcall	$releaseLock
	pop	de
;4241 
;4242   return 0;
	.debug	# 4242
	bool	hl
	ld	l,h
;4243 }
@861:
	.debug	} @861 4243

@860	equ	1
	ld	sp,ix
	pop	ix
	lret
@862	equ	3
;4244 
;4245 
;4246 //-------------------------------------------------------------------------
;4247 //  set one of the registers in the high-speed ADC's to the specified value
;4248 //  via a serial port in SPI mode
;4249 //-------------------------------------------------------------------------
;4250 int write_ADCReg(uint regNum, uint regVal)
;4251 {
$write_ADCReg::
	.debug	G $write_ADCReg 133 9
	.debug	{ $write_ADCReg 133 4250 @873 @872
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-3
	.debug	A regNum 5 7
	.debug	A regVal 7 7
;4252   uchar  clockMode = NORM_HIGH_LATCH_FALL;
	.debug	L clockMode -1 3
	.debug	# 4252
	ld	a,0x2
	ld	(ix-1),a
	.seg	FARCODE
;4253   char  buf[2];
	.debug	L buf -3 134
;4254 
;4255 
;4256   if (!spi1Port)  return -1;
	.debug	# 4256
	ld	hl,(_spi1Port)
	bool	hl
	jr	z,@876
;4257 
;4258   if (getLock(APPL_LOCK, 5000) <= 0)  return -1;
	.debug	# 4258
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	lcall	$getLock
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@876
	jr	nc,@875
@876:
	ld	hl,0xffff
	jp	@872
;4259 
;4260   buf[0] = (char) ((regNum << 3) | ((regVal >> 8) & 0x07));
@875:
	.debug	# 4260
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+7)
	ld	l,h
	ld	h,0
	ld	bc,de
	ld	de,0x7
	and	hl,de
	ld	de,bc
	or	hl,de
	ld	(ix-3),l
;4261   buf[1] = (char) regVal;
	.debug	# 4261
	ld	a,(ix+7)
	ld	(ix-2),a
;4262 
;4263 //  ioctl(spi1fd, IOC_SET_CLK_MODE, &clockMode);
;4264   _spiConfig_(spi1Port, CLK_1MHz, clockMode);
	.debug	# 4264
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	l,0xa
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiConfig_
	add	sp,6
;4265 
;4266   digitalOut &= ~_ADC_CS;  WriteDig();  // set ADC /CS low
	.debug	# 4266
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	res	7,d
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
@877:
	.debug	< @877 @878
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@878:
	.debug	>
;4267 
;4268   WriteSPI1(buf, 2);  //write 2 bytes to ADC's
	.debug	# 4268
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x2
	push	hl
	ld	hl,1+@871
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrite_
	add	sp,8
;4269 
;4270   digitalOut |= _ADC_CS;  WriteDig();  // set ADC /CS high
	.debug	# 4270
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	set	7,d
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
@879:
	.debug	< @879 @880
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@880:
	.debug	>
;4271 
;4272   releaseLock(APPL_LOCK);
	.debug	# 4272
	bool	hl
	ld	l,h
	push	hl
	lcall	$releaseLock
	pop	de
;4273 
;4274   return 0;
	.debug	# 4274
	bool	hl
	ld	l,h
;4275 }
@872:
	.debug	} @872 4275

@871	equ	3
	ld	sp,ix
	pop	ix
	lret
@873	equ	5
;4276 
;4277 
;4278 //-------------------------------------------------------------------------
;4279 int write_Config(uint newConfig)
;4280 {
$write_Config::
	.debug	G $write_Config 76 9
	.debug	{ $write_Config 76 4279 @883 @882
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-3
	.debug	A newConfig 5 7
;4281   char  buf[3];
	.debug	L buf -3 124
;4282 
;4283   buf[0] = 0x1f;
	.debug	# 4283
	ld	(ix-3),0x1f
;4284   buf[1] = 0x80;
	.debug	# 4284
	ld	a,0x80
	ld	(ix-2),a
;4285   buf[2] = (0x70 & newConfig << 4) | 0x82;
	.debug	# 4285
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,0x70
	and	hl,de
	ld	e,0x82
	or	hl,de
	ld	(ix-1),l
;4286 
;4287   return  writePLL(buf, 3);
	.debug	# 4287
	ld	hl,0x3
	push	hl
	ld	hl,-1+@881
	add	hl,sp
	push	hl
	lcall	$writePLL
	add	sp,4
;4288 }
@882:
	.debug	} @882 4288

@881	equ	3
	ld	sp,ix
	pop	ix
	lret
@883	equ	5
;4289 
;4290 //-------------------------------------------------------------------------
;4291 //  Read a single 32-bit register value from the DSP
;4292 //
;4293 //  Returns 0 and sets *regVal on success, < 0 if an error
;4294 //-------------------------------------------------------------------------
;4295 int readDSPReg(ulong regNum, ulong *regVal)
;4296 {
$readDSPReg::
	.debug	G $readDSPReg 135 9
	.debug	{ $readDSPReg 135 4295 @886 @885
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-14
	.debug	A regNum 5 9
	.debug	A regVal 9 87
;4297   uchar  enableLow, enableHigh;
	.debug	L enableLow -1 3
	.debug	L enableHigh -2 3
;4298   uint  i, wordCount;
	.debug	L i -4 7
	.debug	L wordCount -6 7
;4299   ulong  xmitWord, rcvWord;  //, respRegNum;
	.debug	L xmitWord -10 9
	.debug	L rcvWord -14 9
;4300 //  char  temp[32];
;4301 
;4302 
;4303   if (getLockDSP(1000) <= 0)  return -1;
	.debug	# 4303
	ld	de,0x3e8
	ld	bc,0
	push	bc
	push	de
	lcall	$getLockDSP
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@888
	jr	nc,@887
@888:
	ld	hl,0xffff
	jp	@885
;4304 
;4305   regNum &= 0xFFFFFFFEL;
@887:
	.debug	# 4305
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	res	0,e
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;4306 
;4307   wordCount = 1 + RespOffset;
	.debug	# 4307
	ld	hl,0x3
	ld	(ix-6),hl
;4308 
;4309   enableLow = PGDRShadow & (uchar)(~_DSP_WR_RD);
	.debug	# 4309
	ld	a,(_srPGDR)
	and	a,239
	ld	(ix-1),a
;4310   enableHigh = enableLow | (uchar)_DSP_WR_RD;
	.debug	# 4310
	or	a,16
	ld	(ix-2),a
;4311 
;4312   xmitWord = htonl(regNum);
	.debug	# 4312
	ld	hl,(ix+7)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;4313 
;4314   for (i=0; i<wordCount; ++i,regNum+=2)  {
@889:
	.debug	< @889 @890
	.debug	# 4314
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@891:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@892
;4315     if (hdwType != HT_PHASE_CTLR)
@894:
	.debug	< @894 @895
	.debug	# 4315
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@896
;4316       rcvWord = (i < RespOffset) ? 0 : fakeRegVal(regNum-2*RespOffset);
	.debug	# 4316
	ld	hl,(ix-4)
	dec	e
	or	a,a
	sbc	hl,de
	jr	nc,@897
	bool	hl
	ld	l,h
	jr	@898
@897:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xfffc
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	lcall	$fakeRegVal
	add	sp,4
	jr	@899
@898:
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
@899:
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;4317     else  {
	jr	@900
@896:
;4318       OUTI(PGDR, enableLow);  // signal start of 32-bit packet
@901:
	.debug	< @901 @902
	.debug	# 4318
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4319       _spiWrRd_(spi1Port, (char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 4319
	ld	hl,0x4
	push	hl
	ld	hl,-12+@884
	add	hl,sp
	push	hl
	ld	hl,-6+@884
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;4320       OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 4320
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4321     }
@902:
	.debug	>
;4322     xmitWord = 0;
@900:
	.debug	# 4322
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;4323   }
@895:
	.debug	>
;4324 
;4325   releaseLockDSP();
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
	jp	@891
@892:
@890:
	.debug	>
	.debug	# 4325
	lcall	$releaseLockDSP
;4326 
;4327   rcvWord = ntohl(rcvWord);
	.debug	# 4327
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;4328 
;4329 //  respRegNum = regNum - (ulong)(RespOffset * 2);
;4330 //  printf("  0x%08LX:  0x%08LX  %12ld  %.32s\r\n",
;4331 //         respRegNum, rcvWord, rcvWord, fmtDSPval(rcvWord, respRegNum, tem
;4332 
;4333   *regVal = rcvWord;
	.debug	# 4333
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4334 
;4335   return 0;
	.debug	# 4335
	bool	hl
	ld	l,h
;4336 }
@885:
	.debug	} @885 4336

@884	equ	14
	ld	sp,ix
	pop	ix
	lret
@886	equ	16
;4337 
;4338 //-------------------------------------------------------------------------
;4339 //  write a single 32-bit register value to the DSP (without any additional
;4340 //  cycles to read a response, which can interfere with any larger sequence
;4341 //  of packets this may be imbedded in).
;4342 //
;4343 //  Returns 0 on success, < 0 if an error
;4344 //-------------------------------------------------------------------------
;4345 int writeDSPRegQuick(ulong regNum, ulong value)
;4346 {
$writeDSPRegQuick::
	.debug	G $writeDSPRegQuick 136 9
	.debug	{ $writeDSPRegQuick 136 4345 @905 @904
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A regNum 5 9
	.debug	A value 9 9
;4347   uchar  enableLow, enableHigh;
	.debug	L enableLow -1 3
	.debug	L enableHigh -2 3
;4348   ulong  xmitWord, rcvWord;
	.debug	L xmitWord -6 9
	.debug	L rcvWord -10 9
;4349 
;4350 
;4351   if (getLockDSP(1000) <= 0)  return -1;
	.debug	# 4351
	ld	de,0x3e8
	ld	bc,0
	push	bc
	push	de
	lcall	$getLockDSP
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@907
	jr	nc,@906
@907:
	ld	hl,0xffff
	jp	@904
;4352 
;4353   enableLow = PGDRShadow & (uchar)(~_DSP_WR_RD);
@906:
	.debug	# 4353
	ld	a,(_srPGDR)
	and	a,239
	ld	(ix-1),a
;4354   enableHigh = enableLow | (uchar)_DSP_WR_RD;
	.debug	# 4354
	or	a,16
	ld	(ix-2),a
;4355 
;4356   regNum |= 1L;
	.debug	# 4356
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	set	0,e
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;4357 
;4358 //--- send the register # in the 1st packet ---
;4359   xmitWord = htonl(regNum);
	.debug	# 4359
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;4360   OUTI(PGDR, enableLow);  // signal start of 32-bit packet
	.debug	# 4360
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4361   _spiWrRd_(spi1Port, (char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 4361
	ld	hl,0x4
	push	hl
	ld	hl,-8+@903
	add	hl,sp
	push	hl
	ld	hl,-2+@903
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;4362   OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 4362
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4363 
;4364 //--- send the value in the 2nd packet ---
;4365   xmitWord = htonl(value);
	.debug	# 4365
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;4366   OUTI(PGDR, enableLow);  // signal start of 32-bit packet
	.debug	# 4366
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4367   _spiWrRd_(spi1Port, (char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 4367
	ld	hl,0x4
	push	hl
	ld	hl,-8+@903
	add	hl,sp
	push	hl
	ld	hl,-2+@903
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;4368   OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 4368
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4369 
;4370   releaseLockDSP();
	.debug	# 4370
	lcall	$releaseLockDSP
;4371 
;4372   return 0;
	.debug	# 4372
	bool	hl
	ld	l,h
;4373 }
@904:
	.debug	} @904 4373

@903	equ	10
	ld	sp,ix
	pop	ix
	lret
@905	equ	12
;4374 
;4375 //-------------------------------------------------------------------------
;4376 //  write a single 32-bit register value to the DSP and read back the echoe
;4377 //  addr and value (which at least lets us know we are talking to the DSP).
;4378 //
;4379 //  Returns 0 on success, < 0 if an error
;4380 //-------------------------------------------------------------------------
;4381 int writeDSPReg(ulong regNum, ulong value, bool showErrs)
;4382 {
$writeDSPReg::
	.debug	G $writeDSPReg 137 9
	.debug	{ $writeDSPReg 137 4381 @910 @909
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A regNum 5 9
	.debug	A value 9 9
	.debug	A showErrs 13 3
;4383   uchar  enableLow, enableHigh;
	.debug	L enableLow -1 3
	.debug	L enableHigh -2 3
;4384   ulong  xmitWord, rcvWord;
	.debug	L xmitWord -6 9
	.debug	L rcvWord -10 9
;4385 
;4386 
;4387   if (getLockDSP(2000) <= 0)  return -1;
	.debug	# 4387
	ld	de,0x7d0
	ld	bc,0
	push	bc
	push	de
	lcall	$getLockDSP
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@912
	jr	nc,@911
@912:
	ld	hl,0xffff
	jp	@909
;4388 
;4389   if (hdwType != HT_PHASE_CTLR)  showErrs = false;
@911:
	.debug	# 4389
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@913
	xor	a,a
	ld	(ix+13),a
;4390 
;4391   enableLow = PGDRShadow & (uchar)(~_DSP_WR_RD);
@913:
	.debug	# 4391
	ld	a,(_srPGDR)
	and	a,239
	ld	(ix-1),a
;4392   enableHigh = enableLow | (uchar)_DSP_WR_RD;
	.debug	# 4392
	or	a,16
	ld	(ix-2),a
;4393 
;4394   regNum |= 1L;
	.debug	# 4394
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	set	0,e
	ld	(ix+7),hl
	ex	de,hl
	ld	(ix+5),hl
	ex	de,hl
;4395 
;4396 //--- send the register # in the 1st packet ---
;4397   xmitWord = htonl(regNum);
	.debug	# 4397
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;4398   OUTI(PGDR, enableLow);  // signal start of 32-bit packet
	.debug	# 4398
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4399   _spiWrRd_(spi1Port, (char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 4399
	ld	hl,0x4
	push	hl
	ld	hl,-8+@908
	add	hl,sp
	push	hl
	ld	hl,-2+@908
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;4400   OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 4400
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4401   if (showFiller)  printf("  [%08lX", ntohl(rcvWord));
	.debug	# 4401
	ld	a,(_showFiller)
	or	a,a
	jp	z,@914
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,word (phys @1+3877)
	ld	c,phys @1+3877 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;4402 
;4403 //--- send the value in the 2nd packet ---
;4404   xmitWord = htonl(value);
@914:
	.debug	# 4404
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;4405   OUTI(PGDR, enableLow);  // signal start of 32-bit packet
	.debug	# 4405
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4406   _spiWrRd_(spi1Port, (char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 4406
	ld	hl,0x4
	push	hl
	ld	hl,-8+@908
	add	hl,sp
	push	hl
	ld	hl,-2+@908
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;4407   OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 4407
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4408   if (showFiller)  printf("  %08lX]\r\n", ntohl(rcvWord));
	.debug	# 4408
	ld	a,(_showFiller)
	or	a,a
	jp	z,@915
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,word (phys @1+3886)
	ld	c,phys @1+3886 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;4409 
;4410 //--- read back the echoed register # ---
;4411   xmitWord = 0;
@915:
	.debug	# 4411
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;4412   OUTI(PGDR, enableLow);  // signal start of 32-bit packet
	.debug	# 4412
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4413   _spiWrRd_(spi1Port, (char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 4413
	ld	hl,0x4
	push	hl
	ld	hl,-8+@908
	add	hl,sp
	push	hl
	ld	hl,-2+@908
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;4414   OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 4414
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4415   rcvWord = ntohl(rcvWord);
	.debug	# 4415
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;4416 
;4417   if (rcvWord != regNum)  {
	.debug	# 4417
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__lsub##
	jr	z,@916
;4418     if (showErrs)
@917:
	.debug	< @917 @918
	.debug	# 4418
	ld	a,(ix+13)
	or	a,a
	jr	z,@919
;4419       printf("  echoed write address error: 0x%08lX  echoed for 0x%08lX\r\n
;4420              rcvWord, regNum);
	.debug	# 4420
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3897)
	ld	c,phys @1+3897 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;4421     releaseLockDSP();  return -2;
@919:
	.debug	# 4421
	lcall	$releaseLockDSP
	ld	hl,0xfffe
	jp	@909
;4422   }
@918:
	.debug	>
;4423 
;4424 //--- read back the echoed value ---
;4425   xmitWord = 0;
@916:
	.debug	# 4425
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;4426   OUTI(PGDR, enableLow);  // signal start of 32-bit packet
	.debug	# 4426
	ld	a,(ix-1)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4427   _spiWrRd_(spi1Port, (char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 4427
	ld	hl,0x4
	push	hl
	ld	hl,-8+@908
	add	hl,sp
	push	hl
	ld	hl,-2+@908
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;4428   OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 4428
	ld	a,(ix-2)
	ld	(_srPGDR),a
	ioi ld	(72),a
;4429   rcvWord = ntohl(rcvWord);
	.debug	# 4429
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;4430 
;4431   if (rcvWord != value)  {
	.debug	# 4431
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__lsub##
	jr	z,@920
;4432     if (showErrs)
@921:
	.debug	< @921 @922
	.debug	# 4432
	ld	a,(ix+13)
	or	a,a
	jr	z,@923
;4433       printf("  echoed value error: 0x%08lX  echoed for 0x%08lX\r\n",
;4434              rcvWord, value);
	.debug	# 4434
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+3957)
	ld	c,phys @1+3957 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;4435     releaseLockDSP();  return -3;
@923:
	.debug	# 4435
	lcall	$releaseLockDSP
	ld	hl,0xfffd
	jr	@909
;4436   }
@922:
	.debug	>
;4437 
;4438   releaseLockDSP();
@920:
	.debug	# 4438
	lcall	$releaseLockDSP
;4439 
;4440   return 0;
	.debug	# 4440
	bool	hl
	ld	l,h
;4441 }
@909:
	.debug	} @909 4441

@908	equ	10
	ld	sp,ix
	pop	ix
	lret
@910	equ	12
;4442 
;4443 //-------------------------------------------------------------------------
;4444 //  initialize various default settings
;4445 //-------------------------------------------------------------------------
;4446 void initDefaults(void)
;4447 {
$initDefaults::
	.debug	G $initDefaults 99 9
	.debug	{ $initDefaults 99 4446 @926 @925
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-96
;4448   char  *initSeq;
	.debug	L initSeq -2 70
;4449   fd_t  fd;
	.debug	L fd -4 6
;4450   off_t  offset;
	.debug	L offset -8 9
;4451   uint  ui, numWrites, numSeqs;
	.debug	L ui -10 7
	.debug	L numWrites -12 7
	.debug	L numSeqs -14 7
;4452   struct stat  fsInfo;
	.debug	L fsInfo -56 126
;4453   char  buf[PLLInitSeqLen];
	.debug	L buf -96 47
;4454 
;4455 
;4456 //--- initialize the PLL, either from a fixed seq or one in a file ---
;4457   fd = open(PLLInitSeqFile, O_RDONLY, 0);
	.debug	# 4457
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	ld	hl,@2+154
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-4),hl
;4458   if (fd < 0)  {
	.debug	# 4458
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@927
;4459     if (pllInitIdx >= NumFixedPLLSeqs)  {
@928:
	.debug	< @928 @929
	.debug	# 4459
	ld	hl,(_pllInitIdx)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	c,@930
;4460       printf("No 'pllInitSeqs' file and pllInitIdx > fixed list size\r\n");
@931:
	.debug	< @931 @932
	.debug	# 4460
	ld	de,word (phys @1+4009)
	ld	c,phys @1+4009 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4461       return;
	.debug	# 4461
;4462     }
	jp	@925
@932:
	.debug	>
;4463     initSeq = (char *) pllInitSeqs[pllInitIdx];
@930:
	.debug	# 4463
	ld	hl,(_pllInitIdx)
	ld	bc,0x28
	ex	de,hl
	mul
	ld	hl,_pllInitSeqs
	add	hl,bc
	ld	(ix-2),hl
;4464   }
@929:
	.debug	>
;4465   else  {
	jp	@933
@927:
;4466     offset = pllInitIdx * PLLInitSeqLen;
@934:
	.debug	< @934 @935
	.debug	# 4466
	ld	hl,(_pllInitIdx)
	ld	bc,0x28
	ex	de,hl
	mul
	ld	de,bc
	ld	hl,0
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;4467     if (fstat(fd, &fsInfo) < 0)  { perror(PLLInitSeqFile);  Exit(-2); }
	.debug	# 4467
	ld	hl,-56+@924
	add	hl,sp
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$fstat
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@936
@937:
	.debug	< @937 @938
	ld	de,word (phys @1+4066)
	ld	c,phys @1+4066 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
@938:
	.debug	>
;4468     numSeqs = (uint)fsInfo.st_size / PLLInitSeqLen;
@936:
	.debug	# 4468
	ld	hl,(ix-34)
	ld	de,0x28
	call	__uidiv##
	ld	(ix-14),hl
;4469     if (pllInitIdx >= numSeqs)  {
	.debug	# 4469
	ld	hl,(_pllInitIdx)
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@939
;4470       printf("pllInitIdx > # of sequences in file 'pllInitSeqs'\r\n");
@940:
	.debug	< @940 @941
	.debug	# 4470
	ld	de,word (phys @1+4078)
	ld	c,phys @1+4078 >> 16
	push	bc
	push	de
	lcall	$farprintf
	jr	@1834
;4471       close(fd);  return;
	.debug	# 4471
;4472     }
@941:
	.debug	>
;4473     if (lseek(fd, offset, SEEK_SET) != offset)  {
@939:
	.debug	# 4473
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	lcall	$lseek
	add	sp,8
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lsub##
	jr	nz,@1833
;4474       perror(PLLInitSeqFile);  close(fd);  return;  }
@943:
	.debug	< @943 @944
	.debug	# 4474
@944:
	.debug	>
;4475     if (read(fd, buf, PLLInitSeqLen) != PLLInitSeqLen)  {
	.debug	# 4475
	ld	hl,0x28
	push	hl
	ld	hl,-94+@924
	add	hl,sp
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$read
	add	sp,6
	ld	de,0x28
	or	a,a
	sbc	hl,de
	jr	z,@945
;4476       printf("Error reading PLL init sequence\r\n");
@946:
	.debug	< @946 @947
	.debug	# 4476
	ld	de,word (phys @1+4130)
	ld	c,phys @1+4130 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4477       perror(PLLInitSeqFile);  close(fd);  return;
	.debug	# 4477
@1833:
	ld	de,word (phys @1+4066)
	ld	c,phys @1+4066 >> 16
	push	bc
	push	de
	lcall	$perror
@1834:
	add	sp,4
	ld	hl,(ix-4)
	push	hl
	lcall	$close
	pop	de
;4478     }
	jr	@925
@947:
	.debug	>
;4479     close(fd);  initSeq = buf;
@945:
	.debug	# 4479
	ld	hl,(ix-4)
	push	hl
	lcall	$close
	pop	de
	ld	hl,-96+@924
	add	hl,sp
	ld	(ix-2),hl
;4480   }
@935:
	.debug	>
;4481 
;4482   numWrites = PLLInitSeqLen / 4;
@933:
	.debug	# 4482
	ld	hl,0xa
	ld	(ix-12),hl
;4483 
;4484   for (ui=0; ui<numWrites; ++ui)  { writePLL(initSeq, 4);  initSeq += 4; }
@948:
	.debug	< @948 @949
	.debug	# 4484
	bool	hl
	ld	l,h
	ld	(ix-10),hl
@950:
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@951
@953:
	.debug	< @953 @954
	ld	hl,0x4
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$writePLL
	add	sp,4
	ld	hl,(ix-2)
	ld	de,0x4
	add	hl,de
	ld	(ix-2),hl
@954:
	.debug	>
;4485 
;4486 
;4487 //--- initialize the ADC ---
;4488   write_ADCReg(0, 0x0400);  write_ADCReg(13, 0x0403);
	ld	hl,(ix-10)
	inc	hl
	ld	(ix-10),hl
	jr	@950
@951:
@949:
	.debug	>
	.debug	# 4488
	ld	hl,0x400
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$write_ADCReg
	add	sp,4
	ld	hl,0x403
	push	hl
	ld	hl,0xd
	push	hl
	lcall	$write_ADCReg
	add	sp,4
;4489 }
@925:
	.debug	} @925 4489

@924	equ	96
	ld	sp,ix
	pop	ix
	lret
@926	equ	98
;4490 
;4491 
;4492 
;4493 //=========================================================================
;4494 //  Event-Handler functions called by the appl task to process event messag
;4495 //=========================================================================
;4496 
;4497 //-------------------------------------------------------------------------
;4498 //  Event-Handler for a request to ...
;4499 //-------------------------------------------------------------------------
;4500 /*
;4501 void EVENT_MyEvent(EventMsg *event)
;4502 {
;4503   uint  idx;
;4504   float  setpoint;
;4505   char  temp[16];
;4506 
;4507 
;4508   idx = event->chanNum;
;4509 
;4510   if (error)  {
;4511     fprintf(DiagLog, "error msg, chan:\n", idx+1);
;4512     return;
;4513   }
;4514 
;4515   setpoint = *((float *)event->data);
;4516 
;4517   fprintf(DiagLog, "New SetPoint for PS%d: %s\n",
;4518      idx+1, fmtFloat(setpoint, 8,3, temp) );
;4519 
;4520   *((float *)((&iSet_1_RegInfo + idx)->regVal)) = setpoint;
;4521 
;4522   anaOut[idx] = ISETtoVolts(idx, setpoint);
;4523 }
;4524 */
;4525 
;4526 
;4527 
;4528 //=========================================================================
;4529 //  Task functions to handle application-specific commands
;4530 //=========================================================================
;4531 
;4532 
;4533 //-------------------------------------------------------------------------
;4534 //  example func to process a command entered via a user shell
;4535 //-------------------------------------------------------------------------
;4536 /*
;4537 void _task miscTest(int argc, char **argv)
;4538 {
;4539   int  idx;
;4540   bool  validCmd;
;4541   // used by EVENT macro
;4542   fd_t  eventsfd = -1;
;4543   EventMsg  eventMsg;
;4544 
;4545 
;4546   validCmd = false;
;4547 
;4548   for (;;)  {
;4549     if (argc < 3)  break;
;4550     if (! isdigit(argv[1][0]))  break;
;4551 
;4552     idx = atoi(argv[1]);
;4553     if ((idx < 1) OR (idx > NumChan))  {
;4554       printf("Invalid chan #\n");  Exit(-2);  }
;4555 
;4556     --idx;  validCmd = true;
;4557 
;4558     if (StriEq(argv[2], "on"))     { EVENT(TurnOn,  idx, NULL, 0);  break; 
;4559     if (StriEq(argv[2], "off"))    { EVENT(TurnOff, idx, NULL, 0);  break; 
;4560     if (StriEq(argv[2], "reset"))  { EVENT(Reset,   idx, NULL, 0);  break; 
;4561 
;4562     validCmd = false;  break;
;4563   }
;4564 
;4565   if (! validCmd)  { printf("Usage:  misc # on|off|reset\r\n");  Exit(-1); 
;4566 
;4567   Exit(0);
;4568 }
;4569 */
;4570 
;4571 
;4572 
;4573 //-------------------------------------------------------------------------
;4574 //  Check for a new header from the client.  If the maxIdleMS indicates how
;4575 //  long to wait to receive the start of the header.
;4576 //
;4577 //  Returns:
;4578 //    0 if nothing is received
;4579 //    The client version if a valid-looking header was received
;4580 //    < 0 if an error occured
;4581 //-------------------------------------------------------------------------
;4582 int checkForHeader(bool sendWaveform[], long maxIdleMS)
;4583 {
$checkForHeader::
	.debug	G $checkForHeader 138 9
	.debug	{ $checkForHeader 138 4582 @957 @956
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-80
	.debug	A sendWaveform 5 70
	.debug	A maxIdleMS 7 8
;4584   uint  u, uw, hdrSize, numWaveforms;
	.debug	L u -2 7
	.debug	L uw -4 7
	.debug	L hdrSize -6 7
	.debug	L numWaveforms -8 7
;4585   int  w, stat, clientVers;
	.debug	L w -10 6
	.debug	L stat -12 6
	.debug	L clientVers -14 6
;4586   char  *ptr;
	.debug	L ptr -16 70
;4587   char  buf[64];
	.debug	L buf -80 139
;4588 
;4589 
;4590 //--- wait a bit to see if we got anything from the client ---
;4591   stat = read_(0, buf, 2, maxIdleMS);
	.debug	# 4591
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,0x2
	push	hl
	ld	hl,-74+@955
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$read_
	add	sp,10
	ld	(ix-12),hl
;4592 
;4593   if (stat != 2)  {
	.debug	# 4593
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@958
;4594     if (stat < 0) {
@959:
	.debug	< @959 @960
	.debug	# 4594
	ld	hl,(ix-12)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@961
;4595       if (errno == EAGAIN)  return 0;
@962:
	.debug	< @962 @963
	.debug	# 4595
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	nz,@964
	bool	hl
	ld	l,h
	jp	@956
;4596       perror("read()");
@964:
	.debug	# 4596
	ld	de,word (phys @1+4164)
	ld	c,phys @1+4164 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
;4597     }
@963:
	.debug	>
;4598     return -1;
@961:
	.debug	# 4598
	jp	@1832
;4599   }
@960:
	.debug	>
;4600 
;4601   if ((hdrSize = ntohs(*(U16 *)buf)) > sizeof(buf))  return -1;
@958:
	.debug	# 4601
	ld	hl,-80+@955
	add	hl,sp
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-6),hl
	ld	de,0x40
	or	a,a
	sbc	hl,de
	jr	c,@965
	jp	nz,@1832
;4602 
;4603   if (hdrSize < 4)  return -1;
@965:
	.debug	# 4603
	ld	hl,(ix-6)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	c,@1832
;4604 
;4605   if (read_(0, buf, hdrSize, 5000) != hdrSize)  { perror("read()");  return
	.debug	# 4605
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	push	hl
	ld	hl,-74+@955
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$read_
	add	sp,10
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@967
@968:
	.debug	< @968 @969
	ld	de,word (phys @1+4164)
	ld	c,phys @1+4164 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	jr	@1832
@969:
	.debug	>
;4606 
;4607   ptr = buf;
@967:
	.debug	# 4607
	ld	hl,-80+@955
	add	hl,sp
	ld	(ix-16),hl
;4608 
;4609   clientVers = getShort(&ptr);
	.debug	# 4609
	ld	hl,-16+@955
	add	hl,sp
	push	hl
	lcall	$getShort
	pop	de
	ld	(ix-14),hl
;4610   numWaveforms = (uint) getShort(&ptr);
	.debug	# 4610
	ld	hl,-16+@955
	add	hl,sp
	push	hl
	lcall	$getShort
	pop	de
	ld	(ix-8),hl
;4611 
;4612   if ((ptr + numWaveforms*2) > (buf + hdrSize))  return -1;
	.debug	# 4612
	add	hl,hl
	ex	de,hl
	ld	hl,(ix-16)
	ex	de,hl
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,hl
	ld	hl,-80+@955
	add	hl,sp
	add	hl,de
	ex	de,hl
	ld	hl,bc
	or	a,a
	sbc	hl,de
	jr	c,@970
	jr	nz,@1832
;4613 
;4614 //--- > 0 means add waveform to list, < 0 means remove it from the list ---
;4615   for (u=0; u<numWaveforms; ++u)  {
@970:
@971:
	.debug	< @971 @972
	.debug	# 4615
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@973:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@974
;4616     w = getShort(&ptr);  uw = abs(w) - 1;
@976:
	.debug	< @976 @977
	.debug	# 4616
	ld	hl,-16+@955
	add	hl,sp
	push	hl
	lcall	$getShort
	pop	de
	ld	(ix-10),hl
	push	hl
	call	_abs
	pop	de
	dec	hl
	ld	(ix-4),hl
;4617     if (uw >= NUM_WAVEFORMS)  return -1;
	.debug	# 4617
	ld	de,0x5
	or	a,a
	sbc	hl,de
	jr	c,@978
@1832:
	ld	hl,0xffff
	jr	@956
;4618     sendWaveform[uw] = (w > 0);
@978:
	.debug	# 4618
	ld	hl,(ix-10)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	ld	h,e
	ld	l,e
	jr	c,@979
	jr	z,@979
	inc	l
@979:
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,hl
	ld	hl,(ix+5)
	add	hl,de
	ld	(hl),c
;4619   }
@977:
	.debug	>
;4620 
;4621   return clientVers;
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@973
@974:
@972:
	.debug	>
	.debug	# 4621
	ld	hl,(ix-14)
;4622 }
@956:
	.debug	} @956 4622

@955	equ	80
	ld	sp,ix
	pop	ix
	lret
@957	equ	82
;4623 
;4624 //-------------------------------------------------------------------------
;4625 //  Task started by inetd to service remote connections that want to repeat
;4626 //  read amplitude and phase waveforms.
;4627 //-------------------------------------------------------------------------
;4628 //  Notes on method to allow clients to "continuously" read amplitude and
;4629 //  phase waveforms:
;4630 //
;4631 //  - When a client wants to repeatedly read the amplitude and phase data a
;4632 //    waveform, it opens a TCP socket connection to the appropriate port an
;4633 //    then repeatedly reads the data as it is sent.
;4634 //
;4635 //  - Each client with such a socket connection will repeatedly receive the
;4636 //    following until one end or the other closes the connection:
;4637 //    - A 12-byte header with 3 32-bit unsigned values in network byte orde
;4638 //      - the seconds portion of the time for the start of the data points
;4639 //      - the nanoseconds portion of the start time
;4640 //      - the # of bytes with data points to follow the header
;4641 //    - The specified # bytes of data.  Each data point is sent as a 16-bit
;4642 //      unsigned phase value followed by a 16-bit unsigned amplitude value.
;4643 //      These values can be converted to engineering units by multiplying
;4644 //      them by the apropriate conversion factor (see the PhaseConvFactor a
;4645 //      AmplConvFactor macros in this file).
;4646 //
;4647 //  - When the amplitude or phase values are being "pulsed" (the setpoint
;4648 //    periodically changed to one of 2 values), the waveform data sent back
;4649 //    will be for a period immeadiately following the change in the setpoin
;4650 //
;4651 //  - When the values are NOT being pulsed, the waveform data sent back wil
;4652 //    simply indicate the amplitude and phase values over a recent interval
;4653 //    with no particular starting point as a reference.
;4654 //
;4655 //-------------------------------------------------------------------------
;4656 void _task readWave(int argc, char **argv)
;4657 {
	.align	4
$$readWave::
	ex	(sp),iy
$readWave::
	.debug	G $readWave 119 9
	.debug	{ $readWave 119 4656 @982 @981
	ld	hl,-298
	call	__fent##
	.debug	A argc 5 6
	.debug	A argv 7 120
;4658   ulong  dataHeader[3];
	.debug	L dataHeader -12 140
;4659   ulong  lastDataTime, startTime;
	.debug	L lastDataTime -16 9
	.debug	L startTime -20 9
;4660   uint  lastSentTime;
	.debug	L lastSentTime -22 7
;4661   U16  src, cpy;
	.debug	L src -24 5
	.debug	L cpy -26 5
;4662   int  stat, dataBytes;
	.debug	L stat -28 6
	.debug	L dataBytes -30 6
;4663   uint  srcLockID, cpyLockID;
	.debug	L srcLockID -32 7
	.debug	L cpyLockID -34 7
;4664   char far  *srcBuf, *cpyBuf;
	.debug	L srcBuf -38 50
	.debug	L cpyBuf -42 50
;4665   char  buf[256];
	.debug	L buf -298 117
;4666 
;4667 
;4668 //--- A short delay if needed in case the client got a connection so quickl
;4669 //--- after we rebooted that the applic task hasn't finished initializing -
;4670   startTime = GetMS();
	.debug	# 4670
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
;4671   while (!applicReady AND (msSince(startTime) < 5000))  sleepMS(200);
@983:
	.debug	# 4671
	ld	a,(_applicReady)
	or	a,a
	jp	nz,@985
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x1388
	ld	bc,0
	call	__lsub##
	jr	nc,@985
	ld	de,0xc8
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;4672   if (!applicReady)  { printf("applic task not ready\r\n");  Exit(-1); }
	jp	@983
@985:
	.debug	# 4672
	ld	a,(_applicReady)
	or	a,a
	jr	nz,@986
@987:
	.debug	< @987 @988
	ld	de,word (phys @1+4171)
	ld	c,phys @1+4171 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@988:
	.debug	>
;4673 
;4674 
;4675   lastDataTime = GetMS();  lastSentTime = GetMS_();
@986:
	.debug	# 4675
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-22),hl
;4676 
;4677 //--- read data index ---
;4678   if (read_(0, (char *)&src, 2, 5000) != 2)  Exit(-1);
	.debug	# 4678
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	ld	hl,0x2
	push	hl
	ld	hl,-18+@980
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$read_
	add	sp,10
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@989
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;4679   src = ntohs(src) & 0xFFFE;
@989:
	.debug	# 4679
	ld	hl,(ix-24)
	ld	a,l
	ld	l,h
	ld	h,a
	res	0,l
	ld	(ix-24),hl
;4680 
;4681   if (src >= NUM_WAVEFORMS*2)  src = 0;
	.debug	# 4681
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	c,@990
	bool	hl
	ld	l,h
	ld	(ix-24),hl
;4682   cpy = src + 1;
@990:
	.debug	# 4682
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-26),hl
;4683 
;4684   fprintf(DiagLog, "New reader for Waveform #: %d\n", src);
	.debug	# 4684
	ld	hl,(ix-24)
	push	hl
	ld	de,word (phys @1+4195)
	ld	c,phys @1+4195 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;4685 
;4686   srcBuf = (char far *) waveformData[src];    srcLockID = WAVE_DATA_0 + src
	.debug	# 4686
	ld	hl,(ix-24)
	ex	de,hl
	ld	bc,0
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _waveformData)
	ld	c,phys _waveformData >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-36),hl
	ex	de,hl
	ld	(ix-38),hl
	ex	de,hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-32),hl
;4687   cpyBuf = (char far *) waveformData[cpy];    cpyLockID = WAVE_DATA_0 + cpy
	.debug	# 4687
	ld	hl,(ix-26)
	ex	de,hl
	ld	bc,0
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _waveformData)
	ld	c,phys _waveformData >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-40),hl
	ex	de,hl
	ld	(ix-42),hl
	ex	de,hl
	ld	hl,(ix-26)
	inc	hl
	ld	(ix-34),hl
;4688 
;4689   for (;;)  {
@991:
	.debug	< @991 @992
@993:
@995:
;4690     _EnterCritical_();  readerRdy[src] = true;  _ExitCritical_();
@996:
	.debug	< @996 @997
	.debug	# 4690
	ipset	2
	ld	hl,(ix-24)
	ld	de,_readerRdy
	add	hl,de
	ld	a,0x1
	ld	(hl),a
	ipres
;4691 
;4692   //--- The next thing we check is to see if we need to update the buffer -
;4693   //--- that holds a copy of the new data. ---
;4694 
;4695   //  The applic process is the one that copies data from the DSP buffers t
;4696   //  global buffers in RAM.  To avoid blocking it for excessive amounts of
;4697   //  time, we minimize the amount of time the buffer it uses is locked by
;4698   //  making a copy of it and using the copy at our more leisurely pace.
;4699   //  (Mearly doing a memory-to-memory copy goes fairly quickly - writing a
;4700   //  copy of that data to a socket could block for some time).
;4701 
;4702   //  Changes that would improve this further:
;4703   //
;4704   //    - Support multiple read-only locks on the copy
;4705   //
;4706   //    - A single task that services multiple clients.  This would mean
;4707   //      only one task for any number of clients.  But to avoid having a
;4708   //      single task running all the time listening for new connections,
;4709   //      I need a way to tell inetd to NOT keep listening for new
;4710   //      connections (or for inetd to hand new connections off to an
;4711   //      existing server task).  I don't know if there is a standard way
;4712   //      to accomplish either of these approachs on a real Linux box.
;4713   //
;4714   //    - Support an arbitrary set of data elements on each connection
;4715   //      (i.e. use the EPICS CA approach including subscriptions)
;4716   //
;4717   //  Of course, once we have EPICS waveform records for these, there
;4718   //  will be at least one open connection all the time.  And if we don't
;4719   //  change to the multipe waveforms per connection approach, there will
;4720   //  be several connections open all the time!
;4721   //
;4722   //  Given the rather limited resources of the current hardware that
;4723   //  DEBROS runs on, the EPICS CA-like approach is really the only
;4724   //  practical one.
;4725 
;4726 
;4727   //--- Get a lock on the dest/cpy buffer so it won't change while we are -
;4728   //--- accessing (and possibly updating) it ---
;4729 
;4730     while (getLock(cpyLockID, 5000) <= 0);  // get lock on dest buffer
@998:
	.debug	# 4730
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-34)
	push	hl
	lcall	$getLock
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@998
	jr	c,@998
;4731 
;4732   //--- If the timestamps for the source and destination buffers are ---
;4733   //--- different, then update the contents and timestamp for the ---
;4734   //--- destination buffer.  NOTE that we don't really care about the ---
;4735   //--- possibility of the src date/time changing during the check as ---
;4736   //--- all we really care about is if it HASN'T changed. ---
;4737 
;4738     if (dataTimeMS[cpy] != dataTimeMS[src])  {
	.debug	# 4738
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeMS
	add	hl,de
	ex	de,hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	bc,de
	ld	de,_dataTimeMS
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	jp	z,@1001
;4739       while (getLock(srcLockID, 5000) <= 0);  // get lock on src buffer
@1002:
	.debug	< @1002 @1003
@1004:
	.debug	# 4739
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-32)
	push	hl
	lcall	$getLock
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@1004
	jr	c,@1004
;4740       fmemcpy(cpyBuf, srcBuf, numDataPoints[src]<<2);
	.debug	# 4740
	ld	hl,(ix-24)
	add	hl,hl
	ld	de,_numDataPoints
	add	hl,de
	ld	hl,(hl)
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-38)
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-42)
	ex	de,hl
	ld	hl,(ix-40)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;4741       numDataPoints[cpy] = numDataPoints[src];
	.debug	# 4741
	ld	hl,(ix-24)
	add	hl,hl
	ld	de,_numDataPoints
	add	hl,de
	ex	de,hl
	ld	hl,(ix-26)
	add	hl,hl
	ld	bc,de
	ld	de,_numDataPoints
	add	hl,de
	ld	de,bc
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;4742       dataTimeSecs[cpy] = dataTimeSecs[src];  dataTimeMS[cpy] = dataTimeMS[
	.debug	# 4742
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeSecs
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_dataTimeSecs
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeMS
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_dataTimeMS
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4743       releaseLock(srcLockID);  // release lock on src buffer
	.debug	# 4743
	ld	hl,(ix-32)
	push	hl
	lcall	$releaseLock
	pop	de
;4744       WAVE_PV(cpy)->newEvents |= DBE_VALUE;
	.debug	# 4744
	ld	hl,(ix-26)
	or	a,a
	rr	hl
	add	hl,hl
	ld	de,_PV_WF_Idx
	add	hl,de
	ld	hl,(hl)
	ld	bc,0x1d
	ex	de,hl
	mul
	ld	hl,_nonRegPVs
	add	hl,bc
	ld	de,0x13
	add	hl,de
	set	0,(hl)
;4745     }
@1003:
	.debug	>
;4746 
;4747   //--- If the destination/copy buffer doesn't have newer data than what we
;4748   //--- last sent to the client, and it has been at least 2 seconds since -
;4749   //--- we sent anything to the client, then send an "empty" waveform ---
;4750   //--- response (this gives the client a way to tell if we died so it ---
;4751   //--- can close its current connection and open a new one if needed) ---
;4752 
;4753     if (!dataTimeMS[cpy] OR (dataTimeMS[cpy] == lastDataTime))  {
@1001:
	.debug	# 4753
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeMS
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jr	z,@1007
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeMS
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	jp	nz,@1008
@1007:
;4754       releaseLock(cpyLockID);
@1009:
	.debug	< @1009 @1010
	.debug	# 4754
	ld	hl,(ix-34)
	push	hl
	lcall	$releaseLock
	pop	de
;4755       if (msSince_(lastSentTime) >= 2000)  {
	.debug	# 4755
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	hl,(ix-22)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	de,0x7d0
	or	a,a
	sbc	hl,de
	jp	c,@1011
;4756 //        fprintf(DiagLog, "sending empty response\n");  //tdebug
;4757         lastSentTime = GetMS_();
@1012:
	.debug	< @1012 @1013
	.debug	# 4757
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-22),hl
;4758         dataHeader[0] = htonl(time(NULL));
	.debug	# 4758
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;4759         dataHeader[1] = htonl((lastSentTime%1000) * 1000000L);
	.debug	# 4759
	ld	hl,(ix-22)
	ld	de,0x3e8
	call	__uidiv##
	ld	bc,0
	push	bc
	push	de
	ld	de,0x4240
	ld	c,0xf
	call	__ulmlt##
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;4760         dataHeader[2] = htonl(0);
	.debug	# 4760
	ld	de,0
	ld	c,e
	ld	b,e
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;4761         if (write_(1, (char *)dataHeader, 12, 1000) != 12)  {
	.debug	# 4761
	ld	de,0x3e8
	ld	bc,0
	push	bc
	push	de
	ld	hl,0xc
	push	hl
	ld	hl,-6+@980
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$write_
	add	sp,10
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jr	z,@1014
;4762           fprintf(DiagLog, "Error writing empty response\n");  break; }
@1015:
	.debug	< @1015 @1016
	.debug	# 4762
	ld	de,word (phys @1+4226)
	ld	c,phys @1+4226 >> 16
	jp	@1831
@1016:
	.debug	>
;4763       }
@1014:
@1013:
	.debug	>
;4764       sleepMS(50);  continue;
@1011:
	.debug	# 4764
	ld	de,0x32
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;4765     }
	jp	@995
@1010:
	.debug	>
;4766 
;4767   //--- We have new data to send ---
;4768     dataBytes = numDataPoints[cpy] * sizeof(ulong);
@1008:
	.debug	# 4768
	ld	hl,(ix-26)
	add	hl,hl
	ld	de,_numDataPoints
	add	hl,de
	ld	hl,(hl)
	add	hl,hl
	add	hl,hl
	ld	(ix-30),hl
;4769 
;4770     dataHeader[0] = htonl(dataTimeSecs[cpy]);
	.debug	# 4770
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeSecs
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;4771     dataHeader[1] = htonl((dataTimeMS[cpy] % 1000) * 1000000L);
	.debug	# 4771
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeMS
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x3e8
	ld	bc,0
	call	__ulmod##
	push	bc
	push	de
	ld	de,0x4240
	ld	bc,0xf
	call	__ulmlt##
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;4772     dataHeader[2] = htonl(dataBytes);
	.debug	# 4772
	ld	hl,(ix-30)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;4773 
;4774     if (write_(1, (char *)dataHeader, 12, 2000) != 12)  {
	.debug	# 4774
	ld	de,0x7d0
	ld	bc,0
	push	bc
	push	de
	ld	hl,0xc
	push	hl
	ld	hl,-6+@980
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$write_
	add	sp,10
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jr	z,@1017
;4775       fprintf(DiagLog, "Error writing the header\n");  break; }
@1018:
	.debug	< @1018 @1019
	.debug	# 4775
	ld	de,word (phys @1+4256)
	ld	c,phys @1+4256 >> 16
@1831:
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
	jp	@994
@1019:
	.debug	>
;4776 
;4777     stat = fwrite_(1, cpyBuf, dataBytes, buf, sizeof(buf), 2000);
@1017:
	.debug	# 4777
	ld	de,0x7d0
	ld	bc,0
	push	bc
	push	de
	ld	hl,0x100
	push	hl
	ld	hl,-292+@980
	add	hl,sp
	push	hl
	ld	hl,(ix-30)
	push	hl
	ld	hl,(ix-42)
	ex	de,hl
	ld	hl,(ix-40)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,0x1
	push	hl
	lcall	$fwrite_
	add	sp,16
	ld	(ix-28),hl
;4778     if (stat != dataBytes)  {
	.debug	# 4778
	ex	de,hl
	ld	hl,(ix-30)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	z,@1020
;4779       fprintf(DiagLog, "Wrote %d of %d bytes\n", stat, dataBytes);  break; 
@1021:
	.debug	< @1021 @1022
	.debug	# 4779
	ld	h,d
	ld	l,e
	push	hl
	ld	hl,(ix-28)
	push	hl
	ld	de,word (phys @1+4282)
	ld	c,phys @1+4282 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
	jr	@994
@1022:
	.debug	>
;4780 
;4781     lastDataTime = dataTimeMS[cpy];  lastSentTime = GetMS_();
@1020:
	.debug	# 4781
	ld	hl,(ix-26)
	add	hl,hl
	add	hl,hl
	ld	de,_dataTimeMS
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-22),hl
;4782 
;4783     releaseLock(cpyLockID);  // release lock on buffer w/ copy of data
	.debug	# 4783
	ld	hl,(ix-34)
	push	hl
	lcall	$releaseLock
	pop	de
;4784 
;4785   //--- CTF connections are not allowed to be continuous ---
;4786     if ((cpy >= WAVE_CTF_P_SRC) AND (cpy <= WAVE_CTF_A_CPY))  Exit(0);
	.debug	# 4786
	ld	hl,(ix-26)
	ld	de,0x6
	or	a,a
	sbc	hl,de
	jr	c,@1024
	ld	hl,(ix-26)
	ld	e,0x9
	or	a,a
	sbc	hl,de
	jr	z,@1025
	jr	nc,@1024
@1025:
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;4787 
;4788     sleepMS(50);
@1024:
	.debug	# 4788
	ld	de,0x32
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;4789   }
@997:
	.debug	>
;4790 
;4791 
;4792 //--- We only get here if there was an error ---
;4793   releaseLock(cpyLockID);
	jp	@993
@994:
@992:
	.debug	>
	.debug	# 4793
	ld	hl,(ix-34)
	push	hl
	lcall	$releaseLock
	pop	de
;4794 
;4795   fprintf(DiagLog, strerror(errno));  fprintf(DiagLog, "\n");
	.debug	# 4795
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$strerror
	pop	hl
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
	ld	de,word (phys @1+2496)
	ld	c,phys @1+2496 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;4796 
;4797   Exit(-1);
	.debug	# 4797
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;4798 }
@981:
	.debug	} @981 4798

@980	equ	298
	ld	sp,ix
	pop	ix
	lret
@982	equ	300
;4799 
;4800 
;4801 //-------------------------------------------------------------------------
;4802 //  auto-calibrate the fwd, refl, or cav atten value by cycling through
;4803 //  the range of atten values for a given pair of V-peak and phase values.
;4804 //-------------------------------------------------------------------------
;4805 void _task autocal(int argc, char **argv)
;4806 {
	.align	4
$$autocal::
	ex	(sp),iy
$autocal::
	.debug	G $autocal 119 9
	.debug	{ $autocal 119 4805 @1028 @1027
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-21
	.debug	A argc 5 6
	.debug	A argv 7 120
;4807   U16  u, curAtten;
	.debug	L u -2 5
	.debug	L curAtten -4 5
;4808   F32  vPeak, phase;
	.debug	L vPeak -8 10
	.debug	L phase -12 10
;4809   byte  flags[3];
	.debug	L flags -15 124
;4810   RegInfo  *reg[3];
	.debug	L reg -21 141
;4811 
;4812 
;4813   if (showHelp(4, argc, argv))  {
	.debug	# 4813
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x4
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1029
;4814     printf("Usage:  autocal fwd|refl|cav <V-peak> <Phase>\r\n");
@1030:
	.debug	< @1030 @1031
	.debug	# 4814
	ld	de,word (phys @1+4304)
	ld	c,phys @1+4304 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4815     Exit(-1);
	.debug	# 4815
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;4816   }
@1031:
	.debug	>
;4817 
;4818   reg[0] = NULL;
@1029:
	.debug	# 4818
	bool	hl
	ld	l,h
	ld	(ix-21),hl
;4819 
;4820   if (StriEq(argv[1], "fwd"))  {
	.debug	# 4820
	ld	hl,@2+166
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1032
;4821     curAtten = fwdAtten;
@1033:
	.debug	< @1033 @1034
	.debug	# 4821
	ld	hl,(_fwdAtten)
	ld	(ix-4),hl
;4822     reg[0] = &fwdAtten_RegInfo;
	.debug	# 4822
	ld	hl,_fwdAtten_RegInfo
	ld	(ix-21),hl
;4823     reg[1] = &fwdMagCalib_RegInfo;
	.debug	# 4823
	ld	hl,_fwdMagCalib_RegInfo
	ld	(ix-19),hl
;4824     reg[2] = &fwdPhaseCalib_RegInfo;
	.debug	# 4824
	ld	hl,_fwdPhaseCalib_RegInfo
	ld	(ix-17),hl
;4825   }  else
@1034:
	.debug	>
;4826   if (StriEq(argv[1], "refl"))  {
	jr	@1035
@1032:
	.debug	# 4826
	ld	hl,@2+170
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1036
;4827     curAtten = reflAtten;
@1037:
	.debug	< @1037 @1038
	.debug	# 4827
	ld	hl,(_reflAtten)
	ld	(ix-4),hl
;4828     reg[0] = &reflAtten_RegInfo;
	.debug	# 4828
	ld	hl,_reflAtten_RegInfo
	ld	(ix-21),hl
;4829     reg[1] = &reflMagCalib_RegInfo;
	.debug	# 4829
	ld	hl,_reflMagCalib_RegInfo
	ld	(ix-19),hl
;4830     reg[2] = &reflPhaseCalib_RegInfo;
	.debug	# 4830
	ld	hl,_reflPhaseCalib_RegInfo
	ld	(ix-17),hl
;4831   }  else
@1038:
	.debug	>
;4832   if (StriEq(argv[1], "cav"))  {
	jr	@1039
@1036:
	.debug	# 4832
	ld	hl,@2+175
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1040
;4833     curAtten = cavAtten;
@1041:
	.debug	< @1041 @1042
	.debug	# 4833
	ld	hl,(_cavAtten)
	ld	(ix-4),hl
;4834     reg[0] = &cavAtten_RegInfo;
	.debug	# 4834
	ld	hl,_cavAtten_RegInfo
	ld	(ix-21),hl
;4835     reg[1] = &cavMagCalib_RegInfo;
	.debug	# 4835
	ld	hl,_cavMagCalib_RegInfo
	ld	(ix-19),hl
;4836     reg[2] = &cavPhaseCalib_RegInfo;
	.debug	# 4836
	ld	hl,_cavPhaseCalib_RegInfo
	ld	(ix-17),hl
;4837   }
@1042:
	.debug	>
;4838 
;4839   if (! reg[0])  {
@1040:
@1039:
@1035:
	.debug	# 4839
	ld	hl,(ix-21)
	bool	hl
	jr	nz,@1043
;4840     printf("Invalid argument: %.32s\r\n", argv[1]);  Exit(-1); }
@1044:
	.debug	< @1044 @1045
	.debug	# 4840
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+4352)
	ld	c,phys @1+4352 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1045:
	.debug	>
;4841 
;4842   vPeak = atof(argv[2]);  phase = atof(argv[3]);
@1043:
	.debug	# 4842
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;4843 
;4844 //--- save the flags value for each register so we can restore it after ---
;4845 //--- temporarily changing it to avoid seeing the normal log messages on --
;4846 //--- the terminal screen ---
;4847   for (u=0; u<3; ++u)  flags[u] = reg[u]->flags;
@1046:
	.debug	< @1046 @1047
	.debug	# 4847
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@1048:
	ld	hl,(ix-2)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nc,@1049
	ld	hl,(ix-2)
	add	hl,hl
	ex	de,hl
	ld	hl,-21+@1026
	add	hl,sp
	add	hl,de
	ld	hl,(hl)
	ld	de,0xd
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,hl
	ld	hl,-15+@1026
	add	hl,sp
	add	hl,de
	ld	a,(bc)
	ld	(hl),a
;4848 
;4849 //--- cycle the specified attenuation from 0 to 63, waiting 1 second after 
;4850 //--- each change and then telling the DSP the v-peak and phase values ---
;4851 //--- that it should associate with the current conditions ---
;4852 
;4853   for (u=0; u<64; ++u)  {
	ld	h,d
	ld	l,e
	inc	hl
	ld	(ix-2),hl
	jr	@1048
@1049:
@1047:
	.debug	>
@1051:
	.debug	< @1051 @1052
	.debug	# 4853
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@1053:
	ld	hl,(ix-2)
	ld	de,0x40
	or	a,a
	sbc	hl,de
	jp	nc,@1054
;4854     printf("%3d\r", u);  fflush(stdout);
@1056:
	.debug	< @1056 @1057
	.debug	# 4854
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+4378)
	ld	c,phys @1+4378 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
;4855 
;4856     reg[0]->flags &= ~(byte)LogChanges;
	.debug	# 4856
	ld	hl,(ix-21)
	ld	de,0xd
	add	hl,de
	res	1,(hl)
;4857     setRegU16(reg[0], 0, u);
	.debug	# 4857
	ld	hl,(ix-2)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU16
	add	sp,6
;4858     reg[0]->flags = flags[0];
	.debug	# 4858
	ld	hl,(ix-21)
	ld	de,0xd
	add	hl,de
	ld	a,(ix-15)
	ld	(hl),a
;4859 
;4860     sleepMS(1000);
	.debug	# 4860
	ld	de,0x3e8
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;4861 
;4862     reg[1]->flags &= ~(byte)LogChanges;
	.debug	# 4862
	ld	hl,(ix-19)
	ld	de,0xd
	add	hl,de
	res	1,(hl)
;4863     setRegF32(reg[1], 0, vPeak);
	.debug	# 4863
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-19)
	push	hl
	lcall	$setRegF32
	add	sp,8
;4864     reg[1]->flags = flags[1];
	.debug	# 4864
	ld	hl,(ix-19)
	ld	de,0xd
	add	hl,de
	ld	a,(ix-14)
	ld	(hl),a
;4865 
;4866     reg[2]->flags &= ~(byte)LogChanges;
	.debug	# 4866
	ld	hl,(ix-17)
	add	hl,de
	res	1,(hl)
;4867     setRegF32(reg[2], 0, phase);
	.debug	# 4867
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-17)
	push	hl
	lcall	$setRegF32
	add	sp,8
;4868     reg[2]->flags = flags[2];
	.debug	# 4868
	ld	hl,(ix-17)
	ld	de,0xd
	add	hl,de
	ld	a,(ix-13)
	ld	(hl),a
;4869 
;4870     CheckETX();
	.debug	# 4870
	lcall	$CheckETX
;4871   }
@1057:
	.debug	>
;4872   printf("\r\n");
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@1053
@1054:
@1052:
	.debug	>
	.debug	# 4872
	ld	de,word (phys @1+2495)
	ld	c,phys @1+2495 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4873 
;4874   reg[0]->flags &= ~(byte)LogChanges;
	.debug	# 4874
	ld	hl,(ix-21)
	ld	de,0xd
	add	hl,de
	res	1,(hl)
;4875   setRegU16(reg[0], 0, curAtten);
	.debug	# 4875
	ld	hl,(ix-4)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	lcall	$setRegU16
	add	sp,6
;4876   reg[0]->flags = flags[0];
	.debug	# 4876
	ld	hl,(ix-21)
	ld	de,0xd
	add	hl,de
	ld	a,(ix-15)
	ld	(hl),a
;4877 
;4878 
;4879   Exit(0);
	.debug	# 4879
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;4880 }
@1027:
	.debug	} @1027 4880

@1026	equ	21
	ld	sp,ix
	pop	ix
	lret
@1028	equ	23
;4881 
;4882 
;4883 //-------------------------------------------------------------------------
;4884 //  "cmd": set various DSP states
;4885 //-------------------------------------------------------------------------
;4886 void _task cmd(int argc, char **argv)
;4887 {
	.align	4
$$cmd::
	ex	(sp),iy
$cmd::
	.debug	G $cmd 119 9
	.debug	{ $cmd 119 4886 @1060 @1059
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A argc 5 6
	.debug	A argv 7 120
;4888   ulong  bits = 0;
	.debug	L bits -4 9
	.debug	# 4888
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;4889 
;4890 
;4891   if (showHelp(3, argc, argv))  {
	.debug	# 4891
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1061
;4892     printf("Usage:  cmd afc on|off\r\n"
@1062:
	.debug	< @1062 @1063
;4893            "            amplPID on|off\r\n"
;4894            "            phaseCtl off|pid|sel|auto\r\n"
;4895            "            rfPulse on|off\r\n"
;4896            "            tunerPID on|off\r\n"
;4897           );
	.debug	# 4892
	ld	de,word (phys @1+4383)
	ld	c,phys @1+4383 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4898     Exit(-1);
	.debug	# 4898
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;4899   }
@1063:
	.debug	>
;4900 
;4901   do {
@1061:
;4902     if (StriEq(argv[1], "afc"))  {
@1067:
	.debug	< @1067 @1068
	.debug	# 4902
	ld	hl,@2+179
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1069
;4903       if (StriEq(argv[2], "on"))  { bits = CMD_AFC_ON;  break; }
@1070:
	.debug	< @1070 @1071
	.debug	# 4903
	ld	hl,@2+183
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1072
@1073:
	.debug	< @1073 @1074
	ld	de,0x1000
	ld	b,e
	jr	@1830
@1074:
	.debug	>
;4904       if (StriEq(argv[2], "off"))  { bits = CMD_AFC_OFF;  break; }
@1072:
	.debug	# 4904
	ld	hl,@2+186
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1075
@1076:
	.debug	< @1076 @1077
	ld	de,0x2000
	ld	b,e
@1830:
	ld	l,e
	jp	@1827
@1077:
	.debug	>
;4905     }
@1075:
@1071:
	.debug	>
;4906 
;4907     if (StriEq(argv[1], "amplPID"))  {
@1069:
	.debug	# 4907
	ld	hl,@2+190
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1078
;4908       if (StriEq(argv[2], "on"))  { bits = CMD_AMPL_PID_ON;  break; }
@1079:
	.debug	< @1079 @1080
	.debug	# 4908
	ld	hl,@2+183
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1081
@1082:
	.debug	< @1082 @1083
	ld	de,0x2
	jp	@1829
@1083:
	.debug	>
;4909       if (StriEq(argv[2], "off"))  { bits = CMD_AMPL_PID_OFF;  break; }
@1081:
	.debug	# 4909
	ld	hl,@2+186
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1084
@1085:
	.debug	< @1085 @1086
	ld	de,0x1
	jp	@1829
@1086:
	.debug	>
;4910     }
@1084:
@1080:
	.debug	>
;4911 
;4912     if (StriEq(argv[1], "phaseCtl"))  {
@1078:
	.debug	# 4912
	ld	hl,@2+198
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1087
;4913       if (StriEq(argv[2], "off"))  { bits = CMD_PHASE_CTL_OFF;  break; }
@1088:
	.debug	< @1088 @1089
	.debug	# 4913
	ld	hl,@2+186
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1090
@1091:
	.debug	< @1091 @1092
	ld	de,0x4
	jr	@1829
@1092:
	.debug	>
;4914       if (StriEq(argv[2], "pid"))  { bits = CMD_PHASE_CTL_PID;  break; }
@1090:
	.debug	# 4914
	ld	hl,@2+207
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1093
@1094:
	.debug	< @1094 @1095
	ld	de,0x8
	jr	@1829
@1095:
	.debug	>
;4915       if (StriEq(argv[2], "sel"))  { bits = CMD_PHASE_CTL_SEL;  break; }
@1093:
	.debug	# 4915
	ld	hl,@2+211
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1096
@1097:
	.debug	< @1097 @1098
	ld	de,0x10
	jr	@1829
@1098:
	.debug	>
;4916       if (StriEq(argv[2], "auto"))  { bits = CMD_PHASE_CTL_AUTO;  break; }
@1096:
	.debug	# 4916
	ld	hl,@2+215
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1099
@1100:
	.debug	< @1100 @1101
	ld	de,0x20
	jr	@1829
@1101:
	.debug	>
;4917     }
@1099:
@1089:
	.debug	>
;4918 
;4919     if (StriEq(argv[1], "rfPulse"))  {
@1087:
	.debug	# 4919
	ld	hl,@2+220
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1102
;4920       if (StriEq(argv[2], "on"))  { bits = CMD_RF_PULSING_ON;  break; }
@1103:
	.debug	< @1103 @1104
	.debug	# 4920
	ld	hl,@2+183
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1105
@1106:
	.debug	< @1106 @1107
	ld	de,0x40
@1829:
	ld	b,d
	jr	@1828
@1107:
	.debug	>
;4921       if (StriEq(argv[2], "off"))  { bits = CMD_RF_PULSING_OFF;  break; }
@1105:
	.debug	# 4921
	ld	hl,@2+186
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1108
@1109:
	.debug	< @1109 @1110
	ld	de,0x80
	ld	b,d
@1828:
	ld	l,d
	jr	@1827
@1110:
	.debug	>
;4922     }
@1108:
@1104:
	.debug	>
;4923 
;4924     if (StriEq(argv[1], "tunerPID"))  {
@1102:
	.debug	# 4924
	ld	hl,@2+228
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1111
;4925       if (StriEq(argv[2], "on"))  { bits = CMD_TUNER_PID_ON;  break; }
@1112:
	.debug	< @1112 @1113
	.debug	# 4925
	ld	hl,@2+183
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1114
@1115:
	.debug	< @1115 @1116
	ld	d,h
	ld	e,h
	ld	hl,0x2
@1827:
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	jr	@1065
@1116:
	.debug	>
;4926       if (StriEq(argv[2], "off"))  { bits = CMD_TUNER_PID_OFF;  break; }
@1114:
	.debug	# 4926
	ld	hl,@2+186
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1117
@1118:
	.debug	< @1118 @1119
	ld	d,h
	ld	e,h
	ld	hl,0x1
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
@1119:
	.debug	>
;4927     }
@1117:
@1113:
	.debug	>
;4928 
;4929   } while (false);
@1111:
@1068:
	.debug	>
	.debug	# 4929
;4930 
;4931 
;4932   if (bits)
@1065:
	.debug	# 4932
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	or	hl,de
	jr	z,@1120
;4933     SetMBReg(setDSPState, 0, U32, bits);
	.debug	# 4933
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_setDSPState_RegInfo
	push	hl
	lcall	$setRegU32
	add	sp,8
;4934   else
;4935     printf("Invalid parameters\r\n");
	jr	@1121
@1120:
	.debug	# 4935
	ld	de,word (phys @1+4532)
	ld	c,phys @1+4532 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4936 
;4937   Exit(0);
@1121:
	.debug	# 4937
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;4938 }
@1059:
	.debug	} @1059 4938

@1058	equ	4
	ld	sp,ix
	pop	ix
	lret
@1060	equ	6
;4939 
;4940 
;4941 
;4942 //-------------------------------------------------------------------------
;4943 //  "config": set the configuration register (values 0-7)
;4944 //-------------------------------------------------------------------------
;4945 void _task setConfig(int argc, char **argv)
;4946 {
	.align	4
$$setConfig::
	ex	(sp),iy
$setConfig::
	.debug	G $setConfig 119 9
	.debug	{ $setConfig 119 4945 @1124 @1123
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A argc 5 6
	.debug	A argv 7 120
;4947   int  newConfig;
	.debug	L newConfig -2 6
;4948 
;4949 
;4950   if (showHelp(2, argc, argv))  {
	.debug	# 4950
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1125
;4951     printf("Usage:  config #  (# = 0-7)\r\n");  Exit(-1); }
@1126:
	.debug	< @1126 @1127
	.debug	# 4951
	ld	de,word (phys @1+4553)
	ld	c,phys @1+4553 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1127:
	.debug	>
;4952 
;4953   newConfig = atoi(argv[1]);
@1125:
	.debug	# 4953
	ld	hl,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-2),hl
;4954 
;4955   if ((newConfig < 0) OR (newConfig > 7))  {
	.debug	# 4955
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@1128
	ld	hl,(ix-2)
	ld	e,0x7
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@1129
	jr	z,@1129
@1128:
;4956     printf("Configuration command out of valid range:  %s\r\n", argv[1]);
@1130:
	.debug	< @1130 @1131
	.debug	# 4956
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+4583)
	ld	c,phys @1+4583 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;4957     Exit(-2);
	.debug	# 4957
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
;4958   }
@1131:
	.debug	>
;4959 
;4960   printf("Configuring register\r\n");
@1129:
	.debug	# 4960
	ld	de,word (phys @1+4631)
	ld	c,phys @1+4631 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4961 
;4962   write_Config(newConfig);
	.debug	# 4962
	ld	hl,(ix-2)
	push	hl
	lcall	$write_Config
	pop	de
;4963 
;4964   Exit(0);
	.debug	# 4964
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;4965 }
@1123:
	.debug	} @1123 4965

@1122	equ	2
	ld	sp,ix
	pop	ix
	lret
@1124	equ	4
;4966 
;4967 
;4968 //-------------------------------------------------------------------------
;4969 //  "read": picks ADC to send to DAC output (1-4)
;4970 //-------------------------------------------------------------------------
;4971 void _task selectADC(int argc, char **argv)
;4972 {
	.align	4
$$selectADC::
	ex	(sp),iy
$selectADC::
	.debug	G $selectADC 119 9
	.debug	{ $selectADC 119 4971 @1134 @1133
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A argc 5 6
	.debug	A argv 7 120
;4973   int  newADCVal;
	.debug	L newADCVal -2 6
;4974 
;4975 
;4976   if (showHelp(2, argc, argv))  {
	.debug	# 4976
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1135
;4977     printf("Usage:  read #  (# = 1-4)\r\n");  Exit(-1); }
@1136:
	.debug	< @1136 @1137
	.debug	# 4977
	ld	de,word (phys @1+4654)
	ld	c,phys @1+4654 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1137:
	.debug	>
;4978 
;4979   newADCVal = atoi(argv[1]) - 1;
@1135:
	.debug	# 4979
	ld	hl,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	dec	hl
	ld	(ix-2),hl
;4980 
;4981   if ((newADCVal < 0) OR (newADCVal > 3))  {
	.debug	# 4981
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@1138
	ld	hl,(ix-2)
	ld	e,0x3
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@1139
	jr	z,@1139
@1138:
;4982     printf("%s is not a valid ADC #: Select 1-4\r\n", argv[1]);
@1140:
	.debug	< @1140 @1141
	.debug	# 4982
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+4682)
	ld	c,phys @1+4682 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;4983     Exit(-2);
	.debug	# 4983
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
;4984   }
@1141:
	.debug	>
;4985 
;4986   printf("Changing to ADC %d for readings\r\n", newADCVal + 1);
@1139:
	.debug	# 4986
	ld	hl,(ix-2)
	inc	hl
	push	hl
	ld	de,word (phys @1+4720)
	ld	c,phys @1+4720 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;4987 
;4988   writeFPGAParallel(1, (uchar)newADCVal);
	.debug	# 4988
	bool	hl
	ld	l,(ix-2)
	push	hl
	ld	l,0x1
	push	hl
	lcall	$writeFPGAParallel
	add	sp,4
;4989 
;4990   Exit(0);
	.debug	# 4990
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;4991 }
@1133:
	.debug	} @1133 4991

@1132	equ	2
	ld	sp,ix
	pop	ix
	lret
@1134	equ	4
;4992 
;4993 //-------------------------------------------------------------------------
;4994 //  "setadcreg": set the value of one of the registers in the ADC
;4995 //-------------------------------------------------------------------------
;4996 void _task setADCReg(int argc, char **argv)
;4997 {
	.align	4
$$setADCReg::
	ex	(sp),iy
$setADCReg::
	.debug	G $setADCReg 119 9
	.debug	{ $setADCReg 119 4996 @1144 @1143
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A argc 5 6
	.debug	A argv 7 120
;4998   uint  regNum, regVal;
	.debug	L regNum -2 7
	.debug	L regVal -4 7
;4999 
;5000 
;5001   if (showHelp(3, argc, argv))  {
	.debug	# 5001
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1145
;5002     printf("Usage:  setadcreg reg# value  (reg# = 0-31)\r\n");  Exit(-1); }
@1146:
	.debug	< @1146 @1147
	.debug	# 5002
	ld	de,word (phys @1+4754)
	ld	c,phys @1+4754 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1147:
	.debug	>
;5003 
;5004   regNum = (uint) ATOI(argv[1]);  regVal = (uint) ATOI(argv[2]);
@1145:
	.debug	# 5004
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-2),hl
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-4),hl
;5005 
;5006   if (regNum > 31)  {
	.debug	# 5006
	ld	hl,(ix-2)
	ld	de,0x1f
	or	a,a
	sbc	hl,de
	jr	c,@1148
	jr	z,@1148
;5007     printf("%s is not a valid ADC register #: Use 0-31\r\n", argv[1]);
@1149:
	.debug	< @1149 @1150
	.debug	# 5007
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+4800)
	ld	c,phys @1+4800 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;5008     Exit(-2);
	.debug	# 5008
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
;5009   }
@1150:
	.debug	>
;5010   if (regVal > 0x07FF)  {
@1148:
	.debug	# 5010
	ld	hl,(ix-4)
	ld	de,0x7ff
	or	a,a
	sbc	hl,de
	jr	c,@1151
	jr	z,@1151
;5011     printf("%s is not a valid ADC register value: Use 0-0x7FF\r\n", argv[2]
@1152:
	.debug	< @1152 @1153
	.debug	# 5011
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+4845)
	ld	c,phys @1+4845 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;5012     Exit(-2);
	.debug	# 5012
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
;5013   }
@1153:
	.debug	>
;5014 
;5015   printf("Setting ADC reg %u to %03X\r\n", regNum, regVal);
@1151:
	.debug	# 5015
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+4897)
	ld	c,phys @1+4897 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;5016 
;5017   write_ADCReg(regNum, regVal);
	.debug	# 5017
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$write_ADCReg
	add	sp,4
;5018 
;5019   Exit(0);
	.debug	# 5019
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;5020 }
@1143:
	.debug	} @1143 5020

@1142	equ	4
	ld	sp,ix
	pop	ix
	lret
@1144	equ	6
;5021 
;5022 //-------------------------------------------------------------------------
;5023 //  "defaults": initialize FPGA settings to default values
;5024 //-------------------------------------------------------------------------
;5025 void _task defaults(int argc, char **argv)
;5026 {
	.align	4
$$defaults::
	ex	(sp),iy
$defaults::
	.debug	G $defaults 119 9
	.debug	{ $defaults 119 5025 @1156 @1155
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A argc 5 6
	.debug	A argv 7 120
;5027   initDefaults();  Exit(0);
	.debug	# 5027
	lcall	$initDefaults
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;5028 }
@1155:
	.debug	} @1155 5028

@1154	equ	0
	pop	ix
	lret
@1156	equ	2
;5029 
;5030 
;5031 
;5032 //-------------------------------------------------------------------------
;5033 //  "progdsp": load a program in to the DSP
;5034 //-------------------------------------------------------------------------
;5035 void _task progDSP(int argc, char **argv)
;5036 {
	.align	4
$$progDSP::
	ex	(sp),iy
$progDSP::
	.debug	G $progDSP 119 9
	.debug	{ $progDSP 119 5035 @1159 @1158
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-48
	.debug	A argc 5 6
	.debug	A argv 7 120
;5037   int  fromfd;
	.debug	L fromfd -2 6
;5038   uint progNum;
	.debug	L progNum -4 7
;5039   char  *fileName;
	.debug	L fileName -6 70
;5040   struct stat  fsInfo;
	.debug	L fsInfo -48 126
;5041 
;5042 
;5043   if (showHelp(3, argc, argv))  {
	.debug	# 5043
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1160
;5044     printf("Usage:  progdsp prog# file\r\n");  Exit(-1);  }
@1161:
	.debug	< @1161 @1162
	.debug	# 5044
	ld	de,word (phys @1+4926)
	ld	c,phys @1+4926 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1162:
	.debug	>
;5045 
;5046   progNum = ATOI(argv[1]);  fileName = argv[2];
@1160:
	.debug	# 5046
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-4),hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-6),hl
;5047 
;5048   if (progNum > 3)  { printf("prog# must be 0-3\r\n");  Exit(-1); }
	.debug	# 5048
	ld	hl,(ix-4)
	dec	e
	or	a,a
	sbc	hl,de
	jr	c,@1163
	jr	z,@1163
@1164:
	.debug	< @1164 @1165
	ld	de,word (phys @1+4955)
	ld	c,phys @1+4955 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1165:
	.debug	>
;5049 
;5050   if ((fromfd = open(fileName, O_RDONLY, 0)) < 0)  {
@1163:
	.debug	# 5050
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	ld	hl,(ix-6)
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@1166
;5051     perror(fileName);  Exit(-1); }
@1167:
	.debug	< @1167 @1168
	.debug	# 5051
	ld	hl,(ix-6)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1168:
	.debug	>
;5052 
;5053   if (fstat(fromfd, &fsInfo))  { perror(argv[1]);  Exit(-1); }
@1166:
	.debug	# 5053
	ld	hl,-48+@1157
	add	hl,sp
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$fstat
	add	sp,4
	bool	hl
	jr	z,@1169
@1170:
	.debug	< @1170 @1171
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1171:
	.debug	>
;5054 
;5055   initDSP(fromfd, progNum, (ulong)fsInfo.st_size, true);
@1169:
	.debug	# 5055
	ld	hl,0x1
	push	hl
	ld	hl,(ix-26)
	ex	de,hl
	ld	hl,(ix-24)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$initDSP
	add	sp,10
;5056 
;5057   close(fromfd);  Exit(0);
	.debug	# 5057
	ld	hl,(ix-2)
	push	hl
	lcall	$close
	pop	de
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;5058 }
@1158:
	.debug	} @1158 5058

@1157	equ	48
	ld	sp,ix
	pop	ix
	lret
@1159	equ	50
;5059 
;5060 //-------------------------------------------------------------------------
;5061 //  "restartdsp": reset the DSP and run specified program # (0-3)
;5062 //-------------------------------------------------------------------------
;5063 void _task restartDSP(int argc, char **argv)
;5064 {
	.align	4
$$restartDSP::
	ex	(sp),iy
$restartDSP::
	.debug	G $restartDSP 119 9
	.debug	{ $restartDSP 119 5063 @1174 @1173
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A argc 5 6
	.debug	A argv 7 120
;5065   uint progNum;
	.debug	L progNum -2 7
;5066 
;5067   if (showHelp(2, argc, argv))  {
	.debug	# 5067
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1175
;5068     printf("Usage:  restartdsp prog#\r\n");  Exit(-1);  }
@1176:
	.debug	< @1176 @1177
	.debug	# 5068
	ld	de,word (phys @1+4975)
	ld	c,phys @1+4975 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1177:
	.debug	>
;5069 
;5070   progNum = ATOI(argv[1]);
@1175:
	.debug	# 5070
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-2),hl
;5071 
;5072   if (progNum > 3)  { printf("prog# must be 0-3\r\n");  Exit(-1); }
	.debug	# 5072
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	c,@1178
	jr	z,@1178
@1179:
	.debug	< @1179 @1180
	ld	de,word (phys @1+4955)
	ld	c,phys @1+4955 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1180:
	.debug	>
;5073 
;5074   dspProgNum = progNum;
@1178:
	.debug	# 5074
	ld	hl,(ix-2)
	ld	(_dspProgNum),hl
;5075 
;5076   resetDSP();  Exit(0);
	.debug	# 5076
	lcall	$resetDSP
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;5077 }
@1173:
	.debug	} @1173 5077

@1172	equ	2
	ld	sp,ix
	pop	ix
	lret
@1174	equ	4
;5078 
;5079 
;5080 //-------------------------------------------------------------------------
;5081 //  "setfpgafirm": load a new FPGA firmware file in to the serial EEPROM
;5082 //-------------------------------------------------------------------------
;5083 void _task setFPGAfirm(int argc, char **argv)
;5084 {
	.align	4
$$setFPGAfirm::
	ex	(sp),iy
$setFPGAfirm::
	.debug	G $setFPGAfirm 119 9
	.debug	{ $setFPGAfirm 119 5083 @1183 @1182
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-7
	.debug	A argc 5 6
	.debug	A argv 7 120
;5085   int  i, fromfd;
	.debug	L i -2 6
	.debug	L fromfd -4 6
;5086   bool  verify = false;
	.debug	L verify -5 3
	.debug	# 5086
	xor	a,a
	ld	(ix-5),a
	.seg	FARCODE
;5087   char  *fileName;
	.debug	L fileName -7 70
;5088 
;5089 
;5090   if (showHelp(1, argc, argv))  {
	.debug	# 5090
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1184
;5091     printf("\nusage:  setfpgafirm [-v] [fileName]\r\n");  Exit(-1); }
@1185:
	.debug	< @1185 @1186
	.debug	# 5091
	ld	de,word (phys @1+5002)
	ld	c,phys @1+5002 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1186:
	.debug	>
;5092 
;5093   fileName = FPGA_Prog_File;
@1184:
	.debug	# 5093
	ld	hl,@2+237
	ld	(ix-7),hl
;5094   for (i=1; i<argc; ++i)  {
@1187:
	.debug	< @1187 @1188
	.debug	# 5094
	ld	hl,0x1
	ld	(ix-2),hl
@1189:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	call	__icmp##
	jr	nc,@1190
;5095     if (argv[i][0] != '-')  { fileName = argv[i];  continue; }
@1192:
	.debug	< @1192 @1193
	.debug	# 5095
	ld	hl,(ix-2)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	hl,(hl)
	ld	a,(hl)
	sub	a,45
	jr	z,@1194
@1195:
	.debug	< @1195 @1196
	ld	hl,(ix-2)
	add	hl,hl
	add	hl,de
	ld	hl,(hl)
	ld	(ix-7),hl
	jr	@1191
@1196:
	.debug	>
;5096     if (StrEq(argv[i], "-v"))  verify = true;
@1194:
	.debug	# 5096
	ld	hl,@2+252
	push	hl
	ld	hl,(ix-2)
	add	hl,hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strcmp
	add	sp,4
	bool	hl
	jr	nz,@1197
	ld	(ix-5),0x1
;5097   }
@1197:
@1193:
	.debug	>
;5098 
;5099   if ((fromfd = open(fileName, O_RDONLY, 0)) < 0)  {
@1191:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@1189
@1190:
@1188:
	.debug	>
	.debug	# 5099
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	ld	hl,(ix-7)
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-4),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@1198
;5100     perror(fileName);  Exit(-1); }
@1199:
	.debug	< @1199 @1200
	.debug	# 5100
	ld	hl,(ix-7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1200:
	.debug	>
;5101 
;5102   printf("\r\nDownloading %.40s to EEPROM\r\n", fileName);
@1198:
	.debug	# 5102
	ld	hl,(ix-7)
	push	hl
	ld	de,word (phys @1+5041)
	ld	c,phys @1+5041 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;5103 
;5104   updateFPGAfirmware(fromfd, true, verify);
	.debug	# 5104
	bool	hl
	ld	l,(ix-5)
	push	hl
	ld	l,0x1
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$updateFPGAfirmware
	add	sp,6
;5105 
;5106   close(fromfd);  Exit(0);
	.debug	# 5106
	ld	hl,(ix-4)
	push	hl
	lcall	$close
	pop	de
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;5107 }
@1182:
	.debug	} @1182 5107

@1181	equ	7
	ld	sp,ix
	pop	ix
	lret
@1183	equ	9
;5108 
;5109 
;5110 //-------------------------------------------------------------------------
;5111 //  "setpllreg": set the value of one of the registers in the clock ctlr/PL
;5112 //-------------------------------------------------------------------------
;5113 void _task setPLLReg(int argc, char **argv)
;5114 {
	.align	4
$$setPLLReg::
	ex	(sp),iy
$setPLLReg::
	.debug	G $setPLLReg 119 9
	.debug	{ $setPLLReg 119 5113 @1203 @1202
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A argc 5 6
	.debug	A argv 7 120
;5115   uint  regNum;
	.debug	L regNum -2 7
;5116   ulong  regVal;
	.debug	L regVal -6 9
;5117   char  buf[4];
	.debug	L buf -10 142
;5118 
;5119 
;5120   if (showHelp(3, argc, argv))  {
	.debug	# 5120
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1204
;5121     printf("Usage:  setpllreg reg# value  (reg# = 0-15)\r\n");  Exit(-1); }
@1205:
	.debug	< @1205 @1206
	.debug	# 5121
	ld	de,word (phys @1+5073)
	ld	c,phys @1+5073 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1206:
	.debug	>
;5122 
;5123   regNum = (uint) ATOI(argv[1]);  regVal = (ulong) ATOL(argv[2]);
@1204:
	.debug	# 5123
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-2),hl
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$strtol
	add	sp,6
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;5124 
;5125   if (regNum > 15)  {
	.debug	# 5125
	ld	hl,(ix-2)
	ld	de,0xf
	or	a,a
	sbc	hl,de
	jr	c,@1207
	jr	z,@1207
;5126     printf("%s is not a valid ADC register #: Use 0-31\r\n", argv[1]);
@1208:
	.debug	< @1208 @1209
	.debug	# 5126
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+4800)
	ld	c,phys @1+4800 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;5127     Exit(-2);
	.debug	# 5127
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
;5128   }
@1209:
	.debug	>
;5129   if (regVal > 0x0FFFFFFFL)  {
@1207:
	.debug	# 5129
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xffff
	ld	bc,0xfff
	call	__lsub##
	jr	c,@1210
	jr	z,@1210
;5130     printf("%s is not a valid PLL register value: Use 0-0x0FFFFFFF\r\n",
@1211:
	.debug	< @1211 @1212
;5131             argv[2]);
	.debug	# 5131
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+5119)
	ld	c,phys @1+5119 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;5132     Exit(-2);
	.debug	# 5132
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
;5133   }
@1212:
	.debug	>
;5134 
;5135   buf[0] = (uchar)(regVal >> 20);
@1210:
	.debug	# 5135
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,0x14
	call	__ulshr##
	ld	(ix-10),e
;5136   buf[1] = (uchar)(regVal >> 12);
	.debug	# 5136
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,0xc
	call	__ulshr##
	ld	(ix-9),e
;5137   buf[2] = (uchar)(regVal >> 4);
	.debug	# 5137
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,0x4
	call	__ulshr##
	ld	(ix-8),e
;5138   buf[3] = (uchar)(regVal << 4) | (uchar)regNum;
	.debug	# 5138
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,0x4
	call	__lshl##
	ld	a,(ix-2)
	or	a,e
	ld	(ix-7),a
;5139 
;5140   printf("Setting PLL reg %u to %08lX\r\n", regNum, regVal);
	.debug	# 5140
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+5176)
	ld	c,phys @1+5176 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;5141 
;5142   writePLL(buf, 4);
	.debug	# 5142
	ld	hl,0x4
	push	hl
	ld	hl,-8+@1201
	add	hl,sp
	push	hl
	lcall	$writePLL
	add	sp,4
;5143 
;5144   Exit(0);
	.debug	# 5144
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;5145 }
@1202:
	.debug	} @1202 5145

@1201	equ	10
	ld	sp,ix
	pop	ix
	lret
@1203	equ	12
;5146 
;5147 //=========================================================================
;5148 //  Generic structure to handle application-specific presentation of the
;5149 //  digital and analog input/output values.  Code to handle additional
;5150 //  formatting that cannot be handled in this generic manner should be
;5151 //  placed in the showState() task routine.
;5152 //=========================================================================
;5153 
;5154 //-------------------------------------------------------------------------
;5155 _nearcall char *fmtPhaseMode(DispElem far *elem, char *buf)
;5156 {
	.align	4
$$fmtPhaseMode::
	ex	(sp),iy
$fmtPhaseMode::
	.debug	G $fmtPhaseMode 143 9
	.debug	{ $fmtPhaseMode 143 5155 @1215 @1214
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A elem 5 144
	.debug	A buf 9 70
;5157   return (char *) PhaseModeDesc[ELEM_VAL(uint)];
	.debug	# 5157
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__farld2##
	ex	de,hl
	add	hl,hl
	ld	de,_PhaseModeDesc
	add	hl,de
	ld	hl,(hl)
;5158 }
@1214:
	.debug	} @1214 5158

@1213	equ	0
	pop	ix
	lret
@1215	equ	2
;5159 
;5160 //-------------------------------------------------------------------------
;5161 _nearcall char *fmtAFC(DispElem far *elem, char *buf)
;5162 {
	.align	4
$$fmtAFC::
	ex	(sp),iy
$fmtAFC::
	.debug	G $fmtAFC 143 9
	.debug	{ $fmtAFC 143 5161 @1218 @1217
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
	.debug	A elem 5 144
	.debug	A buf 9 70
;5163   bool isOn = statusBitsAFC & (1 << elem->prec);
	.debug	L isOn -1 3
	.debug	# 5163
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xc
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	a,e
	ld	hl,0x1
	or	a,a
	jr	z,@1219
	ld	b,a
@1220:
	add	hl,hl
	djnz	@1220
@1219:
	ld	de,(_statusBitsAFC)
	and	hl,de
	ld	(ix-1),l
	.seg	FARCODE
;5164   return (isOn ? "ON " : "OFF");
	.debug	# 5164
	ld	a,l
	or	a,a
	jr	z,@1221
	ld	hl,@2+255
	jr	@1217
@1221:
	ld	hl,@2+259
;5165 }
@1217:
	.debug	} @1217 5165

@1216	equ	1
	ld	sp,ix
	pop	ix
	lret
@1218	equ	3
;5166 
;5167 //-------------------------------------------------------------------------
;5168 _nearcall char *fmtWarming(DispElem far *elem, char *buf)
;5169 {
	.align	4
$$fmtWarming::
	ex	(sp),iy
$fmtWarming::
	.debug	G $fmtWarming 143 9
	.debug	{ $fmtWarming 143 5168 @1226 @1225
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A elem 5 144
	.debug	A buf 9 70
;5170   return (ELEM_VAL(bool) ? " WARM  " : "WARMING");
	.debug	# 5170
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@1227
	ld	hl,@2+263
	jr	@1225
@1227:
	ld	hl,@2+271
;5171 }
@1225:
	.debug	} @1225 5171

@1224	equ	0
	pop	ix
	lret
@1226	equ	2
;5172 
;5173 //-------------------------------------------------------------------------
;5174 _nearcall char *fmtRamping(DispElem far *elem, char *buf)
;5175 {
	.align	4
$$fmtRamping::
	ex	(sp),iy
$fmtRamping::
	.debug	G $fmtRamping 143 9
	.debug	{ $fmtRamping 143 5174 @1232 @1231
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A elem 5 144
	.debug	A buf 9 70
;5176   return (ELEM_VAL(bool) ? "RAMPING" : "STEADY ");
	.debug	# 5176
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@1233
	ld	hl,@2+279
	jr	@1231
@1233:
	ld	hl,@2+287
;5177 }
@1231:
	.debug	} @1231 5177

@1230	equ	0
	pop	ix
	lret
@1232	equ	2
;5178 
;5179 //-------------------------------------------------------------------------
;5180 _nearcall char *fmtLocked(DispElem far *elem, char *buf)
;5181 {
	.align	4
$$fmtLocked::
	ex	(sp),iy
$fmtLocked::
	.debug	G $fmtLocked 143 9
	.debug	{ $fmtLocked 143 5180 @1238 @1237
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A elem 5 144
	.debug	A buf 9 70
;5182   return (ELEM_VAL(bool) ? "LOCKED  " : "UNLOCKED");
	.debug	# 5182
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@1239
	ld	hl,@2+295
	jr	@1237
@1239:
	ld	hl,@2+304
;5183 }
@1237:
	.debug	} @1237 5183

@1236	equ	0
	pop	ix
	lret
@1238	equ	2
;5184 //-------------------------------------------------------------------------
;5185   const char far DevStateStr[] = {
;5186 "--INPUTS--  Max  Ampl   Phase Atten   -------- RF State --------   ---DSP-
;5187 "Forward:  ##.## ##.## -###.##  ##     WarmLevel: #.##      ###     Load: #
;5188 "Reflected:##.## ##.## -###.##  ##     WarmMS:   #####    #######   Temp:##
;5189 "Cavity:   ##.## ##.## -###.##  ##     RampMS:   #####    #######   Prog ID
;5190 "Reference:      ##.## -###.##                                      Errs:##
;5191 "Setpoints:##.## ##.## -###.##         CavLocked: ########\r\n"
;5192 "\r\n"
;5193 "<########>   -Freq-  -Phase-    -TUNE-  -Ampl-  -Phase-   Pulsing: ###\r\n
;5194 "AFC_0: ###   ####.#  -###.##    State:  ###### ########   Pulse Rate:###.#
;5195 "AFC_1: ###   ####.#  -###.##    Pulsed:   #.##  -###.##   SearchAmpl: #.##
;5196 "AFC_2: ###   ####.#  -###.##\r\n"
;5197 "AFC_3: ###   ####.#  -###.##      --RF-- -Tuner-  ---- Tuner -----\r\n"
;5198 "AFC_4: ###   ####.#  -###.##    P: #.###  #.###   State:    ######    CTF:
;5199 "AFC_5: ###   ####.#  -###.##    I: #.###  #.###   Piezo:    -#####    FFT:
;5200 "AFC_6: ###   ####.#  -###.##    D: #.###  #.###   Stepper:-#######\r\n"
;5201 "AFC_7: ###   ####.#  -###.##\r\n"
;5202 "AFC_8: ###   ####.#  -###.##\r\n"
;5203 "AFC_9: ###   ####.#  -###.##\r\n"
;5204 "\r\n"
;5205   };
	.seg	FARCONST
_DevStateStr::
	.db	"--INPUTS--  Max  Ampl   Phase Atten   -------- RF State --------   ---DSP---",13,10,"Forward"
	.db	":  ##.## ##.## -###.##  ##     WarmLevel: #.##      ###     Load: ###%%",13,10,"Reflected:##"
	.db	".## ##.## -###.##  ##     WarmMS:   #####    #######   Temp:##.#C",13,10,"Cavity:   ##.## ##"
	.db	".## -###.##  ##     RampMS:   #####    #######   Prog ID: #",13,10,"Reference:      ##.## -#"
	.db	"##.##                                      Errs:#####",13,10,"Setpoints:##.## ##.## -###.## "
	.db	"        CavLocked: ########",13,10,13,10,"<########>   -Freq-  -Phase-    -TUNE-  -Ampl-  -Phase"
	.db	"-   Pulsing: ###",13,10,"AFC_0: ###   ####.#  -###.##    State:  ###### ########   Pulse Rat"
	.db	"e:###.##",13,10,"AFC_1: ###   ####.#  -###.##    Pulsed:   #.##  -###.##   SearchAmpl: #.##",13
	.db	10,"AFC_2: ###   ####.#  -###.##",13,10,"AFC_3: ###   ####.#  -###.##      --RF-- -Tuner-  ---"
	.db	"- Tuner -----",13,10,"AFC_4: ###   ####.#  -###.##    P: #.###  #.###   State:    ######    "
	.db	"CTF:###%%",13,10,"AFC_5: ###   ####.#  -###.##    I: #.###  #.###   Piezo:    -#####    FFT:"
	.db	"###%%",13,10,"AFC_6: ###   ####.#  -###.##    D: #.###  #.###   Stepper:-#######",13,10,"AFC_7: ##"
	.db	"#   ####.#  -###.##",13,10,"AFC_8: ###   ####.#  -###.##",13,10,"AFC_9: ###   ####.#  -###.##",13,10,13,10,0
	.debug	G _DevStateStr 146 8
;5206 
;5207 const DispElem  far dispElems[] = {
;5208   { 10, 3,  VFPV(maxFwdAmpl),    BLUE,  fmtF32, 5,2 },
_dispElems::
	.db	0xa
	.db	0x3
	.dl	phys _maxFwdAmpl
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x2
;5209   { 10, 4,  VFPV(maxReflAmpl),   BLUE,  fmtF32, 5,2 },
	.db	0xa
	.db	0x4
	.dl	phys _maxReflAmpl
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x2
;5210   { 10, 5,  VFPV(maxCavAmpl),    BLUE,  fmtF32, 5,2 },
	.db	0xa
	.db	0x5
	.dl	phys _maxCavAmpl
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x2
;5211 
;5212   { 10, 7,  VFPV(maxOutAmpl), BLUE,  fmtF32, 5,2 },
	.db	0xa
	.db	0x7
	.dl	phys _maxOutAmpl
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x2
;5213 
;5214   { 16, 3,  VFPV(fwdAmpl),  BLUE,  fmtF32, 5,2 },
	.db	0x10
	.db	0x3
	.dl	phys _fwdAmpl
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x2
;5215   { 16, 4,  VFPV(reflAmpl), BLUE,  fmtF32, 5,2 },
	.db	0x10
	.db	0x4
	.dl	phys _reflAmpl
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x2
;5216   { 16, 5,  VFPV(cavAmpl),  BLUE,  fmtF32, 5,2 },
	.db	0x10
	.db	0x5
	.dl	phys _cavAmpl
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x2
;5217   { 16, 6,  VFPV(refAmpl),  BLUE,  fmtF32, 5,2 },
	.db	0x10
	.db	0x6
	.dl	phys _refAmpl
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x2
;5218   { 16, 7,  VFPV(amplSet),  BLUE,  fmtF32, 5,2 },
	.db	0x10
	.db	0x7
	.dl	phys _amplSet
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x2
;5219 
;5220   { 22, 3,  VFPV(fwdPhase),  BLUE,  fmtF32, 7,2 },
	.db	0x16
	.db	0x3
	.dl	phys _fwdPhase
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5221   { 22, 4,  VFPV(reflPhase), BLUE,  fmtF32, 7,2 },
	.db	0x16
	.db	0x4
	.dl	phys _reflPhase
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5222   { 22, 5,  VFPV(cavPhase),  BLUE,  fmtF32, 7,2 },
	.db	0x16
	.db	0x5
	.dl	phys _cavPhase
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5223   { 22, 6,  VFPV(refPhase),  BLUE,  fmtF32, 7,2 },
	.db	0x16
	.db	0x6
	.dl	phys _refPhase
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5224   { 22, 7,  VFPV(phaseSet),  BLUE,  fmtF32, 7,2 },
	.db	0x16
	.db	0x7
	.dl	phys _phaseSet
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5225 
;5226   { 31, 3,  VFPV(fwdAtten),   BLUE,  fmtU16, 2,2 },
	.db	0x1f
	.db	0x3
	.dl	phys _fwdAtten
	.dw	@2+313
	.dw	word _fmtU16
	.dw	0x2
	.dw	0x2
;5227   { 31, 4,  VFPV(reflAtten),  BLUE,  fmtU16, 2,2 },
	.db	0x1f
	.db	0x4
	.dl	phys _reflAtten
	.dw	@2+313
	.dw	word _fmtU16
	.dw	0x2
	.dw	0x2
;5228   { 31, 5,  VFPV(cavAtten),   BLUE,  fmtU16, 2,2 },
	.db	0x1f
	.db	0x5
	.dl	phys _cavAtten
	.dw	@2+313
	.dw	word _fmtU16
	.dw	0x2
	.dw	0x2
;5229 
;5230   { 59, 3,  VFPV(rfIsOn), BLUE,  fmtBool, 3, FMT_ON_OFF },
	.db	0x3b
	.db	0x3
	.dl	phys _rfIsOn
	.dw	@2+313
	.dw	word _fmtBool
	.dw	0x3
	.dw	0x2
;5231   { 57, 4,  VFPV(rfAtWarm), BLUE,  fmtWarming, 7,7 },
	.db	0x39
	.db	0x4
	.dl	phys _rfAtWarm
	.dw	@2+313
	.dw	word _fmtWarming
	.dw	0x7
	.dw	0x7
;5232   { 57, 5,  VFPV(rfRamping), BLUE,  fmtRamping, 7,7 },
	.db	0x39
	.db	0x5
	.dl	phys _rfRamping
	.dw	@2+313
	.dw	word _fmtRamping
	.dw	0x7
	.dw	0x7
;5233 
;5234   { 49, 7,  VFPV(cavLocked), BLUE,  fmtLocked, 8,8 },
	.db	0x31
	.db	0x7
	.dl	phys _cavLocked
	.dw	@2+313
	.dw	word _fmtLocked
	.dw	0x8
	.dw	0x8
;5235 
;5236   { 49, 3,  VFPV(warmLevel),  BLUE,  fmtF32, 4,2 },
	.db	0x31
	.db	0x3
	.dl	phys _warmLevel
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x4
	.dw	0x2
;5237   { 48, 4,  VFPV(warmMS),     BLUE,  fmtU16, 5,5 },
	.db	0x30
	.db	0x4
	.dl	phys _warmMS
	.dw	@2+313
	.dw	word _fmtU16
	.dw	0x5
	.dw	0x5
;5238   { 48, 5,  VFPV(rampMS),     BLUE,  fmtU16, 5,5 },
	.db	0x30
	.db	0x5
	.dl	phys _rampMS
	.dw	@2+313
	.dw	word _fmtU16
	.dw	0x5
	.dw	0x5
;5239 
;5240   { 73, 3,  VFPV(dspLoad),     BLUE,  fmtU16, 3,3 },
	.db	0x49
	.db	0x3
	.dl	phys _dspLoad
	.dw	@2+313
	.dw	word _fmtU16
	.dw	0x3
	.dw	0x3
;5241   { 72, 4,  VFPV(dspTemp),     BLUE,  fmtF32, 4,1 },
	.db	0x48
	.db	0x4
	.dl	phys _dspTemp
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x4
	.dw	0x1
;5242   { 76, 5,  VFPV(curProgNum),  BLUE,  fmtU16, 1,1 },
	.db	0x4c
	.db	0x5
	.dl	phys _curProgNum
	.dw	@2+313
	.dw	word _fmtU16
	.dw	0x1
	.dw	0x1
;5243   { 72, 6,  VFPV(romProgErrs), BLUE,  fmtU16, 5,5 },
	.db	0x48
	.db	0x6
	.dl	phys _romProgErrs
	.dw	@2+313
	.dw	word _fmtU16
	.dw	0x5
	.dw	0x5
;5244 
;5245   {  1, 9,  VFPV(afcEnabled), BLUE,  fmtBool, 8, FMT_ENA_DISABLED },
	.db	0x1
	.db	0x9
	.dl	phys _afcEnabled
	.dw	@2+313
	.dw	word _fmtBool
	.dw	0x8
	.dw	0x4
;5246 
;5247   {  7,10,  VFPV(statusBitsAFC), BLUE,  fmtAFC, 3, 0 },
	.db	0x7
	.db	0xa
	.dl	phys _statusBitsAFC
	.dw	@2+313
	.dw	word _fmtAFC
	.dw	0x3
	.dw	0
;5248   {  7,11,  VFPV(statusBitsAFC), BLUE,  fmtAFC, 3, 1 },
	.db	0x7
	.db	0xb
	.dl	phys _statusBitsAFC
	.dw	@2+313
	.dw	word _fmtAFC
	.dw	0x3
	.dw	0x1
;5249   {  7,12,  VFPV(statusBitsAFC), BLUE,  fmtAFC, 3, 2 },
	.db	0x7
	.db	0xc
	.dl	phys _statusBitsAFC
	.dw	@2+313
	.dw	word _fmtAFC
	.dw	0x3
	.dw	0x2
;5250   {  7,13,  VFPV(statusBitsAFC), BLUE,  fmtAFC, 3, 3 },
	.db	0x7
	.db	0xd
	.dl	phys _statusBitsAFC
	.dw	@2+313
	.dw	word _fmtAFC
	.dw	0x3
	.dw	0x3
;5251   {  7,14,  VFPV(statusBitsAFC), BLUE,  fmtAFC, 3, 4 },
	.db	0x7
	.db	0xe
	.dl	phys _statusBitsAFC
	.dw	@2+313
	.dw	word _fmtAFC
	.dw	0x3
	.dw	0x4
;5252   {  7,15,  VFPV(statusBitsAFC), BLUE,  fmtAFC, 3, 5 },
	.db	0x7
	.db	0xf
	.dl	phys _statusBitsAFC
	.dw	@2+313
	.dw	word _fmtAFC
	.dw	0x3
	.dw	0x5
;5253   {  7,16,  VFPV(statusBitsAFC), BLUE,  fmtAFC, 3, 6 },
	.db	0x7
	.db	0x10
	.dl	phys _statusBitsAFC
	.dw	@2+313
	.dw	word _fmtAFC
	.dw	0x3
	.dw	0x6
;5254   {  7,17,  VFPV(statusBitsAFC), BLUE,  fmtAFC, 3, 7 },
	.db	0x7
	.db	0x11
	.dl	phys _statusBitsAFC
	.dw	@2+313
	.dw	word _fmtAFC
	.dw	0x3
	.dw	0x7
;5255   {  7,18,  VFPV(statusBitsAFC), BLUE,  fmtAFC, 3, 8 },
	.db	0x7
	.db	0x12
	.dl	phys _statusBitsAFC
	.dw	@2+313
	.dw	word _fmtAFC
	.dw	0x3
	.dw	0x8
;5256   {  7,19,  VFPV(statusBitsAFC), BLUE,  fmtAFC, 3, 9 },
	.db	0x7
	.db	0x13
	.dl	phys _statusBitsAFC
	.dw	@2+313
	.dw	word _fmtAFC
	.dw	0x3
	.dw	0x9
;5257 
;5258   { 13,10,  VFPV(afcFreq0),  BLUE,  fmtF32, 6,1 },
	.db	0xd
	.db	0xa
	.dl	phys _afcFreq0
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x1
;5259   { 13,11,  VFPV(afcFreq1),  BLUE,  fmtF32, 6,1 },
	.db	0xd
	.db	0xb
	.dl	phys _afcFreq1
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x1
;5260   { 13,12,  VFPV(afcFreq2),  BLUE,  fmtF32, 6,1 },
	.db	0xd
	.db	0xc
	.dl	phys _afcFreq2
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x1
;5261   { 13,13,  VFPV(afcFreq3),  BLUE,  fmtF32, 6,1 },
	.db	0xd
	.db	0xd
	.dl	phys _afcFreq3
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x1
;5262   { 13,14,  VFPV(afcFreq4),  BLUE,  fmtF32, 6,1 },
	.db	0xd
	.db	0xe
	.dl	phys _afcFreq4
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x1
;5263   { 13,15,  VFPV(afcFreq5),  BLUE,  fmtF32, 6,1 },
	.db	0xd
	.db	0xf
	.dl	phys _afcFreq5
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x1
;5264   { 13,16,  VFPV(afcFreq6),  BLUE,  fmtF32, 6,1 },
	.db	0xd
	.db	0x10
	.dl	phys _afcFreq6
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x1
;5265   { 13,17,  VFPV(afcFreq7),  BLUE,  fmtF32, 6,1 },
	.db	0xd
	.db	0x11
	.dl	phys _afcFreq7
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x1
;5266   { 13,18,  VFPV(afcFreq8),  BLUE,  fmtF32, 6,1 },
	.db	0xd
	.db	0x12
	.dl	phys _afcFreq8
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x1
;5267   { 13,19,  VFPV(afcFreq9),  BLUE,  fmtF32, 6,1 },
	.db	0xd
	.db	0x13
	.dl	phys _afcFreq9
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x1
;5268 
;5269   { 21,10,  VFPV(afcPhase0),  BLUE,  fmtF32, 7,2 },
	.db	0x15
	.db	0xa
	.dl	phys _afcPhase0
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5270   { 21,11,  VFPV(afcPhase1),  BLUE,  fmtF32, 7,2 },
	.db	0x15
	.db	0xb
	.dl	phys _afcPhase1
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5271   { 21,12,  VFPV(afcPhase2),  BLUE,  fmtF32, 7,2 },
	.db	0x15
	.db	0xc
	.dl	phys _afcPhase2
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5272   { 21,13,  VFPV(afcPhase3),  BLUE,  fmtF32, 7,2 },
	.db	0x15
	.db	0xd
	.dl	phys _afcPhase3
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5273   { 21,14,  VFPV(afcPhase4),  BLUE,  fmtF32, 7,2 },
	.db	0x15
	.db	0xe
	.dl	phys _afcPhase4
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5274   { 21,15,  VFPV(afcPhase5),  BLUE,  fmtF32, 7,2 },
	.db	0x15
	.db	0xf
	.dl	phys _afcPhase5
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5275   { 21,16,  VFPV(afcPhase6),  BLUE,  fmtF32, 7,2 },
	.db	0x15
	.db	0x10
	.dl	phys _afcPhase6
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5276   { 21,17,  VFPV(afcPhase7),  BLUE,  fmtF32, 7,2 },
	.db	0x15
	.db	0x11
	.dl	phys _afcPhase7
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5277   { 21,18,  VFPV(afcPhase8),  BLUE,  fmtF32, 7,2 },
	.db	0x15
	.db	0x12
	.dl	phys _afcPhase8
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5278   { 21,19,  VFPV(afcPhase9),  BLUE,  fmtF32, 7,2 },
	.db	0x15
	.db	0x13
	.dl	phys _afcPhase9
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5279 
;5280   { 40,10,  VFPV(amplPIDisON), BLUE,  fmtBool, 6, FMT_CLOSED_OPEN },
	.db	0x28
	.db	0xa
	.dl	phys _amplPIDisON
	.dw	@2+313
	.dw	word _fmtBool
	.dw	0x6
	.dw	0x3
;5281   { 42,11,  VFPV(pulsedAmplSet),  BLUE,  fmtF32, 4,2 },
	.db	0x2a
	.db	0xb
	.dl	phys _pulsedAmplSet
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x4
	.dw	0x2
;5282 
;5283   { 47,10,  VFPV(phaseMode), BLUE,  fmtPhaseMode, 8,8 },
	.db	0x2f
	.db	0xa
	.dl	phys _phaseMode
	.dw	@2+313
	.dw	word _fmtPhaseMode
	.dw	0x8
	.dw	0x8
;5284   { 48,11,  VFPV(pulsedPhaseSet),    BLUE,  fmtF32, 7,2 },
	.db	0x30
	.db	0xb
	.dl	phys _pulsedPhaseSet
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x7
	.dw	0x2
;5285 
;5286   { 67, 9,  VFPV(rfPulsing),  BLUE,  fmtBool, 3, FMT_ON_OFF },
	.db	0x43
	.db	0x9
	.dl	phys _rfPulsing
	.dw	@2+313
	.dw	word _fmtBool
	.dw	0x3
	.dw	0x2
;5287   { 69,10,  VFPV(pulseFreq),  BLUE,  fmtF32, 6,2 },
	.db	0x45
	.db	0xa
	.dl	phys _pulseFreq
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x6
	.dw	0x2
;5288   { 70,11,  VFPV(freqSearchAmpl),  BLUE,  fmtF32, 4,2 },
	.db	0x46
	.db	0xb
	.dl	phys _freqSearchAmpl
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x4
	.dw	0x2
;5289 
;5290   { 35,14,  VFPV(rf_P),  BLUE,  fmtF32, 5,3 },
	.db	0x23
	.db	0xe
	.dl	phys _rf_P
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x3
;5291   { 35,15,  VFPV(rf_I),  BLUE,  fmtF32, 5,3 },
	.db	0x23
	.db	0xf
	.dl	phys _rf_I
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x3
;5292   { 35,16,  VFPV(rf_D),  BLUE,  fmtF32, 5,3 },
	.db	0x23
	.db	0x10
	.dl	phys _rf_D
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x3
;5293 
;5294   { 42,14,  VFPV(tuner_P),  BLUE,  fmtF32, 5,3 },
	.db	0x2a
	.db	0xe
	.dl	phys _tuner_P
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x3
;5295   { 42,15,  VFPV(tuner_I),  BLUE,  fmtF32, 5,3 },
	.db	0x2a
	.db	0xf
	.dl	phys _tuner_I
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x3
;5296   { 42,16,  VFPV(tuner_D),  BLUE,  fmtF32, 5,3 },
	.db	0x2a
	.db	0x10
	.dl	phys _tuner_D
	.dw	@2+313
	.dw	word _fmtF32
	.dw	0x5
	.dw	0x3
;5297 
;5298   { 60,14,  VFPV(tunerPIDisON),    BLUE,  fmtBool, 6, FMT_CLOSED_OPEN },
	.db	0x3c
	.db	0xe
	.dl	phys _tunerPIDisON
	.dw	@2+313
	.dw	word _fmtBool
	.dw	0x6
	.dw	0x3
;5299   { 60,15,  VFPV(piezoReadPos),    BLUE,  fmtS16,  6,6 },
	.db	0x3c
	.db	0xf
	.dl	phys _piezoReadPos
	.dw	@2+313
	.dw	word _fmtS16
	.dw	0x6
	.dw	0x6
;5300   { 58,16,  VFPV(stepperReadPos),  BLUE,  fmtS32,  8,8 },
	.db	0x3a
	.db	0x10
	.dl	phys _stepperReadPos
	.dw	@2+313
	.dw	word _fmtS32
	.dw	0x8
	.dw	0x8
;5301 
;5302   { 74,14,  VFPV(percentCTF),  BLUE,  fmtU16, 3,3 },
	.db	0x4a
	.db	0xe
	.dl	phys _percentCTF
	.dw	@2+313
	.dw	word _fmtU16
	.dw	0x3
	.dw	0x3
;5303   { 74,15,  VFPV(percentFFT),   BLUE,  fmtU16, 3,3 },
	.db	0x4a
	.db	0xf
	.dl	phys _percentFFT
	.dw	@2+313
	.dw	word _fmtU16
	.dw	0x3
	.dw	0x3
;5304 
;5305   { 0,0, NULL, NULL, NULL, 0,0 }
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;5306 };
	.debug	G _dispElems 147 8
;5307 
;5308 //bool  rfAtWarm, rfRamping, cavLocked
;5309 
;5310 
;5311 //--- ATTR_NAME macros currently defined in fcntl.h ---
;5312 const DigDispElem far digInElems[] = {
;5313 //{ xx,yy,  BIT_MASK,          "0STR"  ,ATTR_NAME,  "1STR"  ,ATTR_NAME },
;5314 
;5315   { 0,0, 0, NULL,NULL, NULL,NULL }
_digInElems::
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;5316 };
	.debug	G _digInElems 148 8
;5317 
;5318 const DigDispElem far digOutElems[] = {
;5319 //{ xx,yy,  BIT_MASK,      "0STR"  ,ATTR_NAME,  "1STR" ,ATTR_NAME },
;5320 
;5321   { 0,0,  0,  NULL,NULL,  NULL,NULL }
_digOutElems::
	.db	0
	.db	0
	.dw	0, 0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;5322 };
	.debug	G _digOutElems 148 8
;5323 
;5324 
;5325 //-------------------------------------------------------------------------
;5326 //  "state":  Show continuously updated state of the system
;5327 //-------------------------------------------------------------------------
;5328 void _task showState(int argc, char **argv)
;5329 {
	.seg	FARCODE
	.align	4
$$showState::
	ex	(sp),iy
$showState::
	.debug	G $showState 119 9
	.debug	{ $showState 119 5328 @1244 @1243
	ld	hl,-129
	call	__fent##
	.debug	A argc 5 6
	.debug	A argv 7 120
;5330   bool  blinkOff;
	.debug	L blinkOff -1 3
;5331   char  temp[128];
	.debug	L temp -129 100
;5332 
;5333 
;5334   printf(clsCmd);  blinkOff = false;
	.debug	# 5334
	ld	hl,_clsCmd
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	xor	a,a
	ld	(ix-1),a
;5335 
;5336   CursorTo(0, 2);  printf(DevStateStr);
	.debug	# 5336
	ld	hl,0x1
	push	hl
	ld	l,0x3
	push	hl
	ld	de,word (phys @1+5206)
	ld	c,phys @1+5206 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	de,word (phys _DevStateStr)
	ld	c,phys _DevStateStr >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;5337 
;5338   for (;;)  {
@1245:
	.debug	< @1245 @1246
@1247:
;5339     CursorTo(0, 0);  blinkOff = !blinkOff;
@1250:
	.debug	< @1250 @1251
	.debug	# 5339
	ld	hl,0x1
	push	hl
	push	hl
	ld	de,word (phys @1+5206)
	ld	c,phys @1+5206 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	a,(ix-1)
	or	a,a
	ld	a,0
	jr	nz,@1252
	inc	a
@1252:
	ld	(ix-1),a
;5340 
;5341     stdHeader();  displayElems((DispElem far *)dispElems, blinkOff, temp);
	.debug	# 5341
	lcall	$stdHeader
	ld	hl,-129+@1242
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _dispElems)
	ld	c,phys _dispElems >> 16
	push	bc
	push	de
	lcall	$displayElems
	add	sp,8
;5342 
;5343     displayDigElems(digitalIn, (DigDispElem far *)digInElems, blinkOff, tem
	.debug	# 5343
	ld	hl,-129+@1242
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _digInElems)
	ld	c,phys _digInElems >> 16
	push	bc
	push	de
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	push	bc
	push	de
	lcall	$displayDigElems
	add	sp,12
;5344     displayDigElems(digitalOut, (DigDispElem far *)digOutElems, blinkOff, t
	.debug	# 5344
	ld	hl,-129+@1242
	add	hl,sp
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	de,word (phys _digOutElems)
	ld	c,phys _digOutElems >> 16
	push	bc
	push	de
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$displayDigElems
	add	sp,12
;5345 
;5346     CursorTo(0,22);  fflush(stdout);  CheckETX();  sleepMS(500);
	.debug	# 5346
	ld	hl,0x1
	push	hl
	ld	l,0x17
	push	hl
	ld	de,word (phys @1+5206)
	ld	c,phys @1+5206 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
	lcall	$CheckETX
	ld	de,0x1f4
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;5347   }
@1251:
	.debug	>
;5348 
;5349 }
	jp	@1247
@1246:
	.debug	>
@1243:
	.debug	} @1243 5349

@1242	equ	129
	ld	sp,ix
	pop	ix
	lret
@1244	equ	131
;5350 
;5351 //-------------------------------------------------------------------------
;5352 //  return a string with a human-readable format for the specified DSP valu
;5353 //-------------------------------------------------------------------------
;5354 char *dspVal2Str(ulong dspVal, uchar dspType, char *buf)
;5355 {
$dspVal2Str::
	.debug	G $dspVal2Str 150 9
	.debug	{ $dspVal2Str 150 5354 @1255 @1254
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A dspVal 5 9
	.debug	A dspType 9 3
	.debug	A buf 11 70
;5356   float  fval;
	.debug	L fval -4 10
;5357 
;5358   switch (dspType)  {
	.debug	# 5358
	ld	a,(ix+9)
	jr	@1256
;5359     case DT_S32:
@1258:
	.debug	< @1258 @1259
;5360       sprintf(buf, "%12ld", (S32)dspVal);  break;
	.debug	# 5360
@1260:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+5219)
	ld	c,phys @1+5219 >> 16
	jr	@1826
;5361 
;5362     case DT_U32:
;5363       sprintf(buf, "%12lu", (U32)dspVal);  break;
	.debug	# 5363
@1261:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+5225)
	ld	c,phys @1+5225 >> 16
@1826:
	push	bc
	push	de
	ld	hl,(ix+11)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
;5364 
;5365     case DT_F32:
	jr	@1257
;5366       Engineering(*(float *)&dspVal, 6, buf);  break;
	.debug	# 5366
@1262:
	ld	hl,(ix+11)
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	jr	@1825
;5367 
;5368     case RT_PHASE:
;5369       fval = (float)dspVal * PhaseConvFactor;
	.debug	# 5369
@1263:
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	call	__ultof##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x33b4
	call	__fmlt##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;5370       Engineering(fval, 6, buf);  break;
	.debug	# 5370
	ld	hl,(ix+11)
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix-2)
@1825:
	ld	bc,hl
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
;5371   }
	jr	@1257
@1259:
	.debug	>
;5372 
;5373 
;5374   return buf;
@1256:
	cp	0x2
	jr	z,@1260
	cp	0x3
	jr	z,@1261
	cp	0x4
	jr	z,@1262
	cp	0x63
	jr	z,@1263
@1257:
	.debug	# 5374
	ld	hl,(ix+11)
;5375 }
@1254:
	.debug	} @1254 5375

@1253	equ	4
	ld	sp,ix
	pop	ix
	lret
@1255	equ	6
;5376 
;5377 //-------------------------------------------------------------------------
;5378 //  Check the list of known DSP registers against the specified register ID
;5379 //  If it matches one of the known registers, then format the provided DSP
;5380 //  value based on the expected data format.  Otherwise, format the value a
;5381 //  a float.
;5382 //-------------------------------------------------------------------------
;5383 char *fmtDSPval(ulong dspVal, ulong regNum, char *buf)
;5384 {
$fmtDSPval::
	.debug	G $fmtDSPval 151 9
	.debug	{ $fmtDSPval 151 5383 @1266 @1265
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-17
	.debug	A dspVal 5 9
	.debug	A regNum 9 9
	.debug	A buf 13 70
;5385   uchar  dspType = DT_F32;
	.debug	L dspType -1 3
	.debug	# 5385
	ld	(ix-1),0x4
	.seg	FARCODE
;5386   uint  i, j;
	.debug	L i -3 7
	.debug	L j -5 7
;5387   const RD_DSP_REG far *rdReg;
	.debug	L rdReg -9 86
;5388   const WR_DSP_REG far *wrReg;
	.debug	L wrReg -13 89
;5389   const char far *name = NULL;
	.debug	L name -17 50
	.debug	# 5389
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-15),hl
	ex	de,hl
	ld	(ix-17),hl
	ex	de,hl
	.seg	FARCODE
;5390 
;5391 
;5392   for (i=0,rdReg=rdDSPregs; i<NUM_RD_DSP_REGS; ++i,++rdReg)  {
@1267:
	.debug	< @1267 @1268
	.debug	# 5392
	ld	(ix-3),hl
	ld	de,word (phys _rdDSPregs)
	ld	c,phys _rdDSPregs >> 16
	ld	l,c
	ld	(ix-7),hl
	ex	de,hl
	ld	(ix-9),hl
	ex	de,hl
@1269:
	ld	hl,(ix-3)
	ld	de,0x24
	or	a,a
	sbc	hl,de
	jr	nc,@1270
;5393     if (rdReg->id != regNum)  continue;
@1272:
	.debug	< @1272 @1273
	.debug	# 5393
	ld	hl,(ix-9)
	ex	de,hl
	ld	hl,(ix-7)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__lsub##
	jr	nz,@1271
;5394     name = rdReg->mbReg->name;  dspType = rdReg->type;  break;
	.debug	# 5394
	ld	hl,(ix-9)
	ex	de,hl
	ld	hl,(ix-7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x5
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-15),hl
	ex	de,hl
	ld	(ix-17),hl
	ex	de,hl
	ld	hl,(ix-9)
	ex	de,hl
	ld	hl,(ix-7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	(ix-1),a
;5395   }
	jr	@1270
@1273:
	.debug	>
;5396 
;5397   if (! name)  for (i=0,wrReg=wrDSPregs; i<NUM_WR_DSP_REGS; ++i,++wrReg)  {
@1271:
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	ld	hl,(ix-9)
	ex	de,hl
	ld	hl,(ix-7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x11
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-7),hl
	ex	de,hl
	ld	(ix-9),hl
	ex	de,hl
	jp	@1269
@1270:
@1268:
	.debug	>
	.debug	# 5397
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jp	nz,@1275
@1276:
	.debug	< @1276 @1277
	bool	hl
	ld	l,h
	ld	(ix-3),hl
	ld	de,word (phys _wrDSPregs)
	ld	c,phys _wrDSPregs >> 16
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
@1278:
	ld	hl,(ix-3)
	ld	de,0x44
	or	a,a
	sbc	hl,de
	jr	nc,@1279
;5398     if (wrReg->id != regNum)  continue;
@1281:
	.debug	< @1281 @1282
	.debug	# 5398
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	call	__lsub##
	jr	nz,@1280
;5399     name = wrReg->mbReg->name;  dspType = wrReg->type;  break;
	.debug	# 5399
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x5
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-15),hl
	ex	de,hl
	ld	(ix-17),hl
	ex	de,hl
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	(ix-1),a
;5400   }
	jr	@1279
@1282:
	.debug	>
;5401 
;5402   if (name)  {
@1280:
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	ld	hl,(ix-13)
	ex	de,hl
	ld	hl,(ix-11)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-11),hl
	ex	de,hl
	ld	(ix-13),hl
	ex	de,hl
	jp	@1278
@1279:
@1277:
	.debug	>
@1275:
	.debug	# 5402
	ld	hl,(ix-17)
	ex	de,hl
	ld	hl,(ix-15)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@1284
;5403     strcpyfn(buf, name);
@1285:
	.debug	< @1285 @1286
	.debug	# 5403
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+13)
	push	hl
	call	_strcpyfn
	add	sp,6
;5404     for (j=strlen(buf); j<16; ++j)  buf[j] = ' ';
@1287:
	.debug	< @1287 @1288
	.debug	# 5404
	ld	hl,(ix+13)
	push	hl
	call	_strlen
	pop	de
	ld	(ix-5),hl
@1289:
	ld	hl,(ix-5)
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	nc,@1290
	ld	hl,(ix-5)
	ex	de,hl
	ld	hl,(ix+13)
	ex	de,hl
	add	hl,de
	ld	a,0x20
	ld	(hl),a
;5405     buf[15] = ' ';
	ld	hl,(ix-5)
	inc	hl
	ld	(ix-5),hl
	jr	@1289
@1290:
@1288:
	.debug	>
	.debug	# 5405
	ld	hl,(ix+13)
	ld	de,0xf
	add	hl,de
	ld	a,0x20
	ld	(hl),a
;5406     dspVal2Str(dspVal, dspType, buf+16);
	.debug	# 5406
	ld	hl,(ix+13)
	inc	e
	add	hl,de
	push	hl
	bool	hl
	ld	l,(ix-1)
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$dspVal2Str
	add	sp,8
;5407   }
@1286:
	.debug	>
;5408   else  {
	jr	@1292
@1284:
;5409     sprintf(buf, "%14ld  ", dspVal);
@1293:
	.debug	< @1293 @1294
	.debug	# 5409
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+5231)
	ld	c,phys @1+5231 >> 16
	push	bc
	push	de
	ld	hl,(ix+13)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
;5410     dspVal2Str(dspVal, DT_F32, buf+16);
	.debug	# 5410
	ld	hl,(ix+13)
	ld	de,0x10
	add	hl,de
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	lcall	$dspVal2Str
	add	sp,8
;5411   }
@1294:
	.debug	>
;5412 
;5413   return buf;
@1292:
	.debug	# 5413
	ld	hl,(ix+13)
;5414 }
@1265:
	.debug	} @1265 5414

@1264	equ	17
	ld	sp,ix
	pop	ix
	lret
@1266	equ	19
;5415 
;5416 //-------------------------------------------------------------------------
;5417 //  "dspcalib": calibrate gain/offset for conversion to/from certain DSP
;5418 //  values and Engineering units.
;5419 //
;5420 //  The value to calibrate is specified by giving the name of a ModBus
;5421 //  register value.  If the register is referenced in one of the DSP regist
;5422 //  tables, and there is a gain and offset value listed for it, then the
;5423 //  gain and offset can be calibrated by running the device at 2 different
;5424 //  states and providing the actual (measured) value for each state.
;5425 //
;5426 //  NOTE that some calibrations apply to more than one register, so changin
;5427 //  them for one can affect other readings/settings.
;5428 //-------------------------------------------------------------------------
;5429 void _task dspcalib(int argc, char **argv)
;5430 {
	.align	4
$$dspcalib::
	ex	(sp),iy
$dspcalib::
	.debug	G $dspcalib 119 9
	.debug	{ $dspcalib 119 5429 @1297 @1296
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-101
	.debug	A argc 5 6
	.debug	A argv 7 120
;5431   bool  foundReg;
	.debug	L foundReg -1 3
;5432   uint  ui;
	.debug	L ui -3 7
;5433   float  *gain, *offset;
	.debug	L gain -5 152
	.debug	L offset -7 152
;5434   float  mbVal, egu[2], raw[2];
	.debug	L mbVal -11 10
	.debug	L egu -19 153
	.debug	L raw -27 153
;5435   const RD_DSP_REG far *rdReg;
	.debug	L rdReg -31 86
;5436   const WR_DSP_REG far *wrReg;
	.debug	L wrReg -35 89
;5437   RegInfo *mbReg;
	.debug	L mbReg -37 38
;5438   char  temp[64];
	.debug	L temp -101 139
;5439 
;5440 
;5441   if (showHelp(2, argc, argv))  {
	.debug	# 5441
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1298
;5442     printf("\r\n Usage:  dspcalib <regName>\r\n");  Exit(-1); }
@1299:
	.debug	< @1299 @1300
	.debug	# 5442
	ld	de,word (phys @1+5239)
	ld	c,phys @1+5239 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1300:
	.debug	>
;5443 
;5444 
;5445   foundReg = false;
@1298:
	.debug	# 5445
	xor	a,a
	ld	(ix-1),a
;5446 
;5447 //--- check RO DSP register list ---
;5448   for (rdReg=rdDSPregs,ui=0; ui<NUM_RD_DSP_REGS; ++ui,++rdReg)  {
@1301:
	.debug	< @1301 @1302
	.debug	# 5448
	ld	de,word (phys _rdDSPregs)
	ld	c,phys _rdDSPregs >> 16
	ld	hl,bc
	ld	(ix-29),hl
	ex	de,hl
	ld	(ix-31),hl
	ex	de,hl
	bool	hl
	ld	l,h
	ld	(ix-3),hl
@1303:
	ld	hl,(ix-3)
	ld	de,0x24
	or	a,a
	sbc	hl,de
	jp	nc,@1304
;5449     mbReg = rdReg->mbReg;  strcpyfn(temp, mbReg->name);
@1306:
	.debug	< @1306 @1307
	.debug	# 5449
	ld	hl,(ix-31)
	ex	de,hl
	ld	hl,(ix-29)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x5
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-37),hl
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,-97+@1295
	add	hl,sp
	push	hl
	call	_strcpyfn
	add	sp,6
;5450     if (stricmp(temp, argv[1]))  continue;
	.debug	# 5450
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,-99+@1295
	add	hl,sp
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1305
;5451     gain = rdReg->gain;  offset = rdReg->offset;
	.debug	# 5451
	ld	hl,(ix-31)
	ex	de,hl
	ld	hl,(ix-29)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-5),hl
	ld	hl,(ix-31)
	ex	de,hl
	ld	hl,(ix-29)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x9
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-7),hl
;5452     foundReg = true;  break;
	.debug	# 5452
	ld	a,0x1
	ld	(ix-1),a
;5453   }
	jr	@1304
@1307:
	.debug	>
;5454 
;5455 //--- check RW DSP register list ---
;5456   if (!foundReg)  for (wrReg=wrDSPregs,ui=0; ui<NUM_WR_DSP_REGS; ++ui,++wrR
@1305:
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	ld	hl,(ix-31)
	ex	de,hl
	ld	hl,(ix-29)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x11
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-29),hl
	ex	de,hl
	ld	(ix-31),hl
	ex	de,hl
	jp	@1303
@1304:
@1302:
	.debug	>
	.debug	# 5456
	ld	a,(ix-1)
	or	a,a
	jp	nz,@1309
@1310:
	.debug	< @1310 @1311
	ld	de,word (phys _wrDSPregs)
	ld	c,phys _wrDSPregs >> 16
	ld	hl,bc
	ld	(ix-33),hl
	ex	de,hl
	ld	(ix-35),hl
	ex	de,hl
	bool	hl
	ld	l,h
	ld	(ix-3),hl
@1312:
	ld	hl,(ix-3)
	ld	de,0x44
	or	a,a
	sbc	hl,de
	jp	nc,@1313
;5457     mbReg = wrReg->mbReg;  strcpyfn(temp, mbReg->name);
@1315:
	.debug	< @1315 @1316
	.debug	# 5457
	ld	hl,(ix-35)
	ex	de,hl
	ld	hl,(ix-33)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x5
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-37),hl
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,-97+@1295
	add	hl,sp
	push	hl
	call	_strcpyfn
	add	sp,6
;5458     if (stricmp(temp, argv[1]))  continue;
	.debug	# 5458
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,-99+@1295
	add	hl,sp
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1314
;5459     gain = wrReg->gain;  offset = wrReg->offset;
	.debug	# 5459
	ld	hl,(ix-35)
	ex	de,hl
	ld	hl,(ix-33)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-5),hl
	ld	hl,(ix-35)
	ex	de,hl
	ld	hl,(ix-33)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x12
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-7),hl
;5460     foundReg = true;  break;
	.debug	# 5460
	ld	a,0x1
	ld	(ix-1),a
;5461   }
	jr	@1313
@1316:
	.debug	>
;5462 
;5463   if (!foundReg)  {
@1314:
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	ld	hl,(ix-35)
	ex	de,hl
	ld	hl,(ix-33)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x14
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-33),hl
	ex	de,hl
	ld	(ix-35),hl
	ex	de,hl
	jp	@1312
@1313:
@1311:
	.debug	>
@1309:
	.debug	# 5463
	ld	a,(ix-1)
	or	a,a
	jr	nz,@1318
;5464     printf("\r\n Register not related to a DSP value\r\n");  Exit(-2); }
@1319:
	.debug	< @1319 @1320
	.debug	# 5464
	ld	de,word (phys @1+5271)
	ld	c,phys @1+5271 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xfffe
	push	hl
	lcall	$Exit
	pop	hl
@1320:
	.debug	>
;5465 
;5466   if (!gain AND !offset)  {
@1318:
	.debug	# 5466
	ld	hl,(ix-5)
	bool	hl
	jr	nz,@1322
	ld	hl,(ix-7)
	bool	hl
	jr	nz,@1322
;5467     printf("\r\n Value does not require conversion\r\n");  Exit(-3); }
@1323:
	.debug	< @1323 @1324
	.debug	# 5467
	ld	de,word (phys @1+5312)
	ld	c,phys @1+5312 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xfffd
	push	hl
	lcall	$Exit
	pop	hl
@1324:
	.debug	>
;5468 
;5469 
;5470   printf("\r\n Existing:");
@1322:
	.debug	# 5470
	ld	de,word (phys @1+5351)
	ld	c,phys @1+5351 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;5471   if (gain)  printf("  Gain: %s", Engineering(*gain, 6, temp));
	.debug	# 5471
	ld	hl,(ix-5)
	bool	hl
	jr	z,@1325
	ld	hl,-101+@1295
	add	hl,sp
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix-5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	de,word (phys @1+5364)
	ld	c,phys @1+5364 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;5472   if (offset)  printf("  Offset: %s", Engineering(*offset, 6, temp));
@1325:
	.debug	# 5472
	ld	hl,(ix-7)
	bool	hl
	jr	z,@1326
	ld	hl,-101+@1295
	add	hl,sp
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix-7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	de,word (phys @1+5375)
	ld	c,phys @1+5375 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;5473   printf("\r\n\n");
@1326:
	.debug	# 5473
	ld	de,word (phys @1+3017)
	ld	c,phys @1+3017 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;5474 
;5475 //--- get real EGU and DSP values for two test points ---
;5476   for (ui=0; ui<2; ++ui)  {
@1327:
	.debug	< @1327 @1328
	.debug	# 5476
	bool	hl
	ld	l,h
	ld	(ix-3),hl
@1329:
	ld	hl,(ix-3)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nc,@1330
;5477     printf(" Test point %u:  Enter measured/actual value for %ls: ",
@1332:
	.debug	< @1332 @1333
;5478            ui+1, mbReg->name);
	.debug	# 5478
	ld	hl,(ix-37)
	ld	e,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-3)
	inc	hl
	push	hl
	ld	de,word (phys @1+5388)
	ld	c,phys @1+5388 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;5479     GETS(temp);  if (!*temp)  Exit(-4);
	.debug	# 5479
	bool	hl
	ld	l,h
	push	hl
	push	hl
	push	hl
	ld	hl,-95+@1295
	add	hl,sp
	push	hl
	lcall	$Gets
	add	sp,8
	ld	a,(ix-101)
	or	a,a
	jr	nz,@1334
	ld	hl,0xfffc
	push	hl
	lcall	$Exit
	pop	hl
;5480     egu[ui] = atof(temp);  mbVal = mb2float(mbReg->regVal, mbReg);
@1334:
	.debug	# 5480
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-99+@1295
	add	hl,sp
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,(ix-3)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ex	de,hl
	ld	hl,-15+@1295
	add	hl,sp
	add	hl,de
	pop	de
	pop	bc
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-37)
	push	hl
	ld	hl,(hl)
	push	hl
	lcall	$mb2float
	add	sp,4
	ld	hl,bc
	ld	(ix-9),hl
	ex	de,hl
	ld	(ix-11),hl
	ex	de,hl
;5481     if (gain)  if (*gain != 0.0)  mbVal = mbVal / *gain;
	.debug	# 5481
	ld	hl,(ix-5)
	bool	hl
	jr	z,@1335
	ld	hl,(ix-5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	a,(hl)
	and	a,7Fh
	or	a,c
	or	a,d
	or	a,e
	jr	z,@1336
	ld	hl,(ix-5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	call	__fdivr##
	ld	hl,bc
	ld	(ix-9),hl
	ex	de,hl
	ld	(ix-11),hl
	ex	de,hl
;5482     if (offset)  mbVal += *offset;
@1336:
@1335:
	.debug	# 5482
	ld	hl,(ix-7)
	bool	hl
	jr	z,@1337
	ld	hl,(ix-7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	call	__fadd##
	ld	hl,bc
	ld	(ix-9),hl
	ex	de,hl
	ld	(ix-11),hl
	ex	de,hl
;5483     raw[ui] = mbVal;
@1337:
	.debug	# 5483
	ld	hl,(ix-3)
	add	hl,hl
	add	hl,hl
	ex	de,hl
	ld	hl,-27+@1295
	add	hl,sp
	add	hl,de
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	ld	hl,(ix-11)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;5484   }
@1333:
	.debug	>
;5485 
;5486   if ((raw[0] == raw[1]) OR (egu[0] == egu[1]))  {
	ld	hl,(ix-3)
	inc	hl
	ld	(ix-3),hl
	jp	@1329
@1330:
@1328:
	.debug	>
	.debug	# 5486
	ld	hl,(ix-27)
	ex	de,hl
	ld	hl,(ix-25)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-23)
	ex	de,hl
	ld	hl,(ix-21)
	ld	bc,hl
	call	__fequ##
	jr	z,@1338
	ld	hl,(ix-19)
	ex	de,hl
	ld	hl,(ix-17)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-15)
	ex	de,hl
	ld	hl,(ix-13)
	ld	bc,hl
	call	__fequ##
	jr	nz,@1339
@1338:
;5487     printf("\r\n Unusable calibration data\r\n");  Exit(-4); }
@1340:
	.debug	< @1340 @1341
	.debug	# 5487
	ld	de,word (phys @1+5443)
	ld	c,phys @1+5443 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xfffc
	push	hl
	lcall	$Exit
	pop	hl
@1341:
	.debug	>
;5488 
;5489   KLOCK();
@1339:
	.debug	# 5489
	call	_KLOCK
;5490   if (gain)  *gain = (egu[1] - egu[0]) / (raw[1] - raw[0]);
	.debug	# 5490
	ld	hl,(ix-5)
	bool	hl
	jr	z,@1342
	ld	hl,(ix-15)
	ex	de,hl
	ld	hl,(ix-13)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-19)
	ex	de,hl
	ld	hl,(ix-17)
	ld	bc,hl
	call	__fsub##
	push	bc
	push	de
	ld	hl,(ix-23)
	ex	de,hl
	ld	hl,(ix-21)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-27)
	ex	de,hl
	ld	hl,(ix-25)
	ld	bc,hl
	call	__fsub##
	call	__fdiv##
	ld	hl,(ix-5)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;5491   if (offset)  *offset = raw[0] - (gain ? egu[0]/(*gain) : raw[1]);
@1342:
	.debug	# 5491
	ld	hl,(ix-7)
	bool	hl
	jr	z,@1343
	ld	hl,(ix-5)
	bool	hl
	jr	z,@1344
	ld	hl,(ix-5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-19)
	ex	de,hl
	ld	hl,(ix-17)
	ld	bc,hl
	call	__fdivr##
	jr	@1345
@1344:
	ld	hl,(ix-23)
	ex	de,hl
	ld	hl,(ix-21)
	ld	bc,hl
@1345:
	push	bc
	push	de
	ld	hl,(ix-27)
	ex	de,hl
	ld	hl,(ix-25)
	ld	bc,hl
	call	__fsubr##
	ld	hl,(ix-7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;5492   KUNLOCK();
@1343:
	.debug	# 5492
	call	_KUNLOCK
;5493 
;5494   printf("\r\n New:");
	.debug	# 5494
	ld	de,word (phys @1+5474)
	ld	c,phys @1+5474 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;5495   if (gain)  printf("  Gain: %s", Engineering(*gain, 6,temp));
	.debug	# 5495
	ld	hl,(ix-5)
	bool	hl
	jr	z,@1346
	ld	hl,-101+@1295
	add	hl,sp
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix-5)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	de,word (phys @1+5364)
	ld	c,phys @1+5364 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;5496   if (offset)  printf("  Offset: %s", Engineering(*offset, 6, temp));
@1346:
	.debug	# 5496
	ld	hl,(ix-7)
	bool	hl
	jr	z,@1347
	ld	hl,-101+@1295
	add	hl,sp
	push	hl
	ld	hl,0x6
	push	hl
	ld	hl,(ix-7)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$Engineering
	add	sp,8
	push	hl
	ld	de,word (phys @1+5375)
	ld	c,phys @1+5375 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;5497   printf("\r\n\n");
@1347:
	.debug	# 5497
	ld	de,word (phys @1+3017)
	ld	c,phys @1+3017 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;5498 
;5499   Exit(0);
	.debug	# 5499
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;5500 }
@1296:
	.debug	} @1296 5500

@1295	equ	101
	ld	sp,ix
	pop	ix
	lret
@1297	equ	103
;5501 
;5502 //-------------------------------------------------------------------------
;5503 //  "dspio": command to enable/disable normal communication with the DSP
;5504 //-------------------------------------------------------------------------
;5505 void _task dspio(int argc, char **argv)
;5506 {
	.align	4
$$dspio::
	ex	(sp),iy
$dspio::
	.debug	G $dspio 119 9
	.debug	{ $dspio 119 5505 @1350 @1349
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-1
	.debug	A argc 5 6
	.debug	A argv 7 120
;5507   bool  val;
	.debug	L val -1 3
;5508 
;5509 
;5510   if (showHelp(3, argc, argv))  {
	.debug	# 5510
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1351
;5511     printf("Usage:  dspio <read|write|filler|waves> <on|off>\r\n");  Exit(-
@1352:
	.debug	< @1352 @1353
	.debug	# 5511
	ld	de,word (phys @1+5482)
	ld	c,phys @1+5482 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1353:
	.debug	>
;5512 
;5513   if (StriEq("on", argv[2]))  val = true;  else
@1351:
	.debug	# 5513
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,@2+183
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1354
	ld	a,0x1
	ld	(ix-1),a
;5514   if (StriEq("off", argv[2])) val = false;  else  {
	jr	@1355
@1354:
	.debug	# 5514
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,@2+186
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1356
	xor	a,a
	ld	(ix-1),a
	jr	@1357
@1356:
;5515     printf("invalid option\r\n");  Exit(-1);  }
@1358:
	.debug	< @1358 @1359
	.debug	# 5515
	ld	de,word (phys @1+5533)
	ld	c,phys @1+5533 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1359:
	.debug	>
;5516 
;5517   if (StriEq("read", argv[1]))    { autoReadDSP = val;   Exit(0); }
@1357:
@1355:
	.debug	# 5517
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,@2+315
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1360
@1361:
	.debug	< @1361 @1362
	ld	a,(ix-1)
	ld	(_autoReadDSP),a
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@1362:
	.debug	>
;5518   if (StriEq("write", argv[1]))   { autoWriteDSP = val;  Exit(0); }
@1360:
	.debug	# 5518
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,@2+320
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1363
@1364:
	.debug	< @1364 @1365
	ld	a,(ix-1)
	ld	(_autoWriteDSP),a
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@1365:
	.debug	>
;5519   if (StriEq("filler", argv[1]))  { showFiller = val;    Exit(0); }
@1363:
	.debug	# 5519
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,@2+326
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1366
@1367:
	.debug	< @1367 @1368
	ld	a,(ix-1)
	ld	(_showFiller),a
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@1368:
	.debug	>
;5520   if (StriEq("waves", argv[1]))   { readWaves = val;     Exit(0); }
@1366:
	.debug	# 5520
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,@2+333
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@1369
@1370:
	.debug	< @1370 @1371
	ld	a,(ix-1)
	ld	(_readWaves),a
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@1371:
	.debug	>
;5521 
;5522   printf("invalid option\r\n");  Exit(-1);
@1369:
	.debug	# 5522
	ld	de,word (phys @1+5533)
	ld	c,phys @1+5533 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;5523 }
@1349:
	.debug	} @1349 5523

@1348	equ	1
	ld	sp,ix
	pop	ix
	lret
@1350	equ	3
;5524 
;5525 
;5526 //-------------------------------------------------------------------------
;5527 //  "dspread": command to read one or more 32-bit values from the DSP
;5528 //-------------------------------------------------------------------------
;5529 void _task dspRead(int argc, char **argv)
;5530 {
	.align	4
$$dspRead::
	ex	(sp),iy
$dspRead::
	.debug	G $dspRead 119 9
	.debug	{ $dspRead 119 5529 @1374 @1373
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-88
	.debug	A argc 5 6
	.debug	A argv 7 120
;5531   ulong  regNum;
	.debug	L regNum -4 9
;5532   uchar  enableLow, enableHigh;
	.debug	L enableLow -5 3
	.debug	L enableHigh -6 3
;5533   uint  i, count, wordCount;
	.debug	L i -8 7
	.debug	L count -10 7
	.debug	L wordCount -12 7
;5534   ulong  xmitWord, rcvWord, respRegNum;
	.debug	L xmitWord -16 9
	.debug	L rcvWord -20 9
	.debug	L respRegNum -24 9
;5535   char  temp[64];
	.debug	L temp -88 139
;5536 
;5537 
;5538   if (showHelp(3, argc, argv))  {
	.debug	# 5538
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1375
;5539     printf("Usage:  dspread <reg> <count>\r\n");  Exit(-1); }
@1376:
	.debug	< @1376 @1377
	.debug	# 5539
	ld	de,word (phys @1+5550)
	ld	c,phys @1+5550 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1377:
	.debug	>
;5540 
;5541   if (hdwType == HT_PHASE_CTLR)
@1375:
	.debug	# 5541
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nz,@1378
;5542     if (!spi1Port)  { fprintf(DiagLog, "SPI port not open!\r\n");  Exit(-1)
	.debug	# 5542
	ld	hl,(_spi1Port)
	bool	hl
	jr	nz,@1379
@1380:
	.debug	< @1380 @1381
	ld	de,word (phys @1+5582)
	ld	c,phys @1+5582 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1381:
	.debug	>
;5543 
;5544   regNum = ATOUL(argv[1]) & 0xFFFFFFFEL;
@1379:
@1378:
	.debug	# 5544
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$strtoul
	add	sp,6
	res	0,e
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;5545   count = (uint) ATOI(argv[2]);
	.debug	# 5545
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(ix-10),hl
;5546 
;5547   if (getLockDSP(5000) <= 0)  Exit(-1);
	.debug	# 5547
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	lcall	$getLockDSP
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@1383
	jr	nc,@1382
@1383:
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;5548 
;5549   wordCount = count + RespOffset;
@1382:
	.debug	# 5549
	ld	hl,(ix-10)
	inc	hl
	inc	hl
	ld	(ix-12),hl
;5550 
;5551   enableLow = PGDRShadow & (uchar)(~_DSP_WR_RD);
	.debug	# 5551
	ld	a,(_srPGDR)
	and	a,239
	ld	(ix-5),a
;5552   enableHigh = enableLow | (uchar)_DSP_WR_RD;
	.debug	# 5552
	or	a,16
	ld	(ix-6),a
;5553 
;5554   for (i=0; i<wordCount; ++i,regNum+=2)  {
@1384:
	.debug	< @1384 @1385
	.debug	# 5554
	bool	hl
	ld	l,h
	ld	(ix-8),hl
@1386:
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@1387
;5555     xmitWord = (i >= count) ? 0 : htonl(regNum);
@1389:
	.debug	< @1389 @1390
	.debug	# 5555
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@1391
	bool	hl
	ld	l,h
	jp	@1392
@1391:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	jr	@1393
@1392:
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
@1393:
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
;5556 
;5557     if (hdwType != HT_PHASE_CTLR)
	.debug	# 5557
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	z,@1394
;5558       rcvWord = (i < RespOffset) ? 0 : fakeRegVal(regNum-2*RespOffset);
	.debug	# 5558
	ld	hl,(ix-8)
	dec	e
	or	a,a
	sbc	hl,de
	jr	nc,@1395
	bool	hl
	ld	l,h
	jr	@1396
@1395:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xfffc
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	lcall	$fakeRegVal
	add	sp,4
	jr	@1397
@1396:
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
@1397:
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
;5559     else  {
	jr	@1398
@1394:
;5560       OUTI(PGDR, enableLow);  // signal start of 32-bit packet
@1399:
	.debug	< @1399 @1400
	.debug	# 5560
	ld	a,(ix-5)
	ld	(_srPGDR),a
	ioi ld	(72),a
;5561       _spiWrRd_(spi1Port, (char *)&xmitWord, (char *)&rcvWord, 4);
	.debug	# 5561
	ld	hl,0x4
	push	hl
	ld	hl,-18+@1372
	add	hl,sp
	push	hl
	ld	hl,-12+@1372
	add	hl,sp
	push	hl
	ld	hl,(_spi1Port)
	push	hl
	lcall	$_spiWrRd_
	add	sp,8
;5562       OUTI(PGDR, enableHigh);  // signal end of 32-bit packet
	.debug	# 5562
	ld	a,(ix-6)
	ld	(_srPGDR),a
	ioi ld	(72),a
;5563     }
@1400:
	.debug	>
;5564     if (i < RespOffset)  {
@1398:
	.debug	# 5564
	ld	hl,(ix-8)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nc,@1401
;5565       if (showFiller)  printf("  filler: 0x%08lX\r\n", ntohl(rcvWord));
@1402:
	.debug	< @1402 @1403
	.debug	# 5565
	ld	a,(_showFiller)
	or	a,a
	jp	z,@1388
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,word (phys @1+5603)
	ld	c,phys @1+5603 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;5566       continue;
	.debug	# 5566
;5567     }
	jp	@1388
@1403:
	.debug	>
;5568 
;5569     rcvWord = ntohl(rcvWord);
@1401:
	.debug	# 5569
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
;5570 
;5571     respRegNum = regNum - (ulong)(RespOffset * 2);
	.debug	# 5571
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xfffc
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
;5572 
;5573     printf("  0x%08LX:  0x%08LX  %.32s\r\n",
;5574            respRegNum, rcvWord, fmtDSPval(rcvWord, respRegNum, temp));
	.debug	# 5574
	ld	hl,-88+@1372
	add	hl,sp
	push	hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmtDSPval
	add	sp,10
	push	hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+5623)
	ld	c,phys @1+5623 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,14
;5575   }
@1390:
	.debug	>
;5576   printf("\r\n");
@1388:
	ld	hl,(ix-8)
	inc	hl
	ld	(ix-8),hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	jp	@1386
@1387:
@1385:
	.debug	>
	.debug	# 5576
	ld	de,word (phys @1+2495)
	ld	c,phys @1+2495 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;5577 
;5578   releaseLockDSP();
	.debug	# 5578
	lcall	$releaseLockDSP
;5579 
;5580   Exit(0);
	.debug	# 5580
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;5581 }
@1373:
	.debug	} @1373 5581

@1372	equ	88
	ld	sp,ix
	pop	ix
	lret
@1374	equ	90
;5582 
;5583 //-------------------------------------------------------------------------
;5584 //  "dspwrite": command to write a value to the DSP
;5585 //-------------------------------------------------------------------------
;5586 void _task dspWrite(int argc, char **argv)
;5587 {
	.align	4
$$dspWrite::
	ex	(sp),iy
$dspWrite::
	.debug	G $dspWrite 119 9
	.debug	{ $dspWrite 119 5586 @1407 @1406
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A argc 5 6
	.debug	A argv 7 120
;5588   ulong  regNum, setVal;
	.debug	L regNum -4 9
	.debug	L setVal -8 9
;5589 
;5590 
;5591   if (showHelp(3, argc, argv))  {
	.debug	# 5591
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x3
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@1408
;5592     printf("Usage:  dspwrite <reg> <value> [-f]\r\n");  Exit(-1); }
@1409:
	.debug	< @1409 @1410
	.debug	# 5592
	ld	de,word (phys @1+5652)
	ld	c,phys @1+5652 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1410:
	.debug	>
;5593 
;5594   if (!spi1Port)  { fprintf(DiagLog, "SPI port not open!\r\n");  Exit(-1); 
@1408:
	.debug	# 5594
	ld	hl,(_spi1Port)
	bool	hl
	jr	nz,@1411
@1412:
	.debug	< @1412 @1413
	ld	de,word (phys @1+5582)
	ld	c,phys @1+5582 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@1413:
	.debug	>
;5595 
;5596   regNum = ATOUL(argv[1]) | 1L;
@1411:
	.debug	# 5596
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$strtoul
	add	sp,6
	set	0,e
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;5597 
;5598   if (strstr(argv[2], "."))
	.debug	# 5598
	ld	hl,@2+339
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strstr
	add	sp,4
	bool	hl
	jr	z,@1414
;5599     *(float *)&setVal = atof(argv[2]);
	.debug	# 5599
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_strtod
	add	sp,4
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;5600   else
;5601     setVal = ATOUL(argv[2]);
	jr	@1415
@1414:
	.debug	# 5601
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$strtoul
	add	sp,6
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;5602 
;5603   printf("  write 0x%08lX to 0x%08lX\r\n", setVal, regNum);
@1415:
	.debug	# 5603
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+5690)
	ld	c,phys @1+5690 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;5604 
;5605   writeDSPReg(regNum, setVal, true);
	.debug	# 5605
	ld	hl,0x1
	push	hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	lcall	$writeDSPReg
	add	sp,10
;5606 
;5607   //NOTE:  Can't just read back the result to check if it worked because
;5608   //       reading from some registers triggers events and processing
;5609   //       within the DSP.
;5610 
;5611   Exit(0);
	.debug	# 5611
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;5612 }
@1406:
	.debug	} @1406 5612

@1405	equ	8
	ld	sp,ix
	pop	ix
	lret
@1407	equ	10
;5613 
;5614 
;5615 //-------------------------------------------------------------------------
;5616 //  Function to read the data from one of the DSP's data buffers that conta
;5617 //  new waveform data for the Phase and Amplitude values surrounding a rece
;5618 //  change to the Phase and/or Amplitude setpoints.
;5619 //-------------------------------------------------------------------------
;5620 int readWaveform(ulong bufID)
;5621 {
$readWaveform::
	.debug	G $readWaveform 77 9
	.debug	{ $readWaveform 77 5620 @1418 @1417
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-38
	.debug	A bufID 5 9
;5622   static uint readCount;  //test
	.bseg
@1419:
	.ds	2
	.debug	S readCount @1419 7
	.seg	FARCODE
;5623   ulong far  *buf;
	.debug	L buf -4 129
;5624   uint  w, lockID;
	.debug	L w -6 7
	.debug	L lockID -8 7
;5625   U32  u32;
	.debug	L u32 -12 9
;5626   float  fval;
	.debug	L fval -16 10
;5627   ulong  regNum, ackBits, val, count, countReg;
	.debug	L regNum -20 9
	.debug	L ackBits -24 9
	.debug	L val -28 9
	.debug	L count -32 9
	.debug	L countReg -36 9
;5628 
;5629 
;5630   ackBits = setDSPState;
	.debug	# 5630
	ld	de,(_setDSPState)
	ld	bc,(_setDSPState+2)
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
;5631 
;5632   switch (bufID)  {
	.debug	# 5632
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	jp	@1420
;5633     case Rd_L_Buf:
@1422:
	.debug	< @1422 @1423
;5634       w = WAVE_AP_L_SRC;  ackBits |= CMD_L_DATA_READ;  countReg = 0;
	.debug	# 5634
@1424:
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	set	2,d
	jr	@1824
;5635       break;
	.debug	# 5635
;5636 
;5637     case Rd_T_Buf:
;5638       w = WAVE_AP_T_SRC;  ackBits |= CMD_T_DATA_READ;  countReg = 0;
	.debug	# 5638
@1425:
	ld	hl,0x2
	ld	(ix-6),hl
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	set	3,d
@1824:
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	jr	@1823
;5639       break;
	.debug	# 5639
;5640 
;5641     case AmplFFT:
;5642       w = WAVE_FFT_SRC;  ackBits |= CMD_FFT_DATA_READ;  countReg = SizeFFT;
	.debug	# 5642
@1426:
	ld	hl,0x4
	ld	(ix-6),hl
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	set	6,d
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	ld	de,0x224
	ld	hl,0x10
	jr	@1823
;5643       break;
	.debug	# 5643
;5644 
;5645     case PhaseCTF:
;5646       if (hdwType == HT_PHASE_CTLR)  return -1;
	.debug	# 5646
@1427:
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jp	z,@1440
;5647       w = WAVE_CTF_P_SRC;  ackBits = 0;  countReg = SizeCTF;
	.debug	# 5647
	ld	hl,0x6
	ld	(ix-6),hl
	ld	d,h
	ld	e,h
	ld	b,e
	ld	l,e
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	ld	de,0x21c
	ld	l,0x10
	jr	@1823
;5648       break;
	.debug	# 5648
;5649 
;5650     case AmplCTF:
;5651       if (hdwType == HT_PHASE_CTLR)  return -1;
	.debug	# 5651
@1429:
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jp	z,@1440
;5652       w = WAVE_CTF_A_SRC;  ackBits = 0;  countReg = SizeCTF;
	.debug	# 5652
	ld	hl,0x8
	ld	(ix-6),hl
	ld	d,h
	ld	e,h
	ld	b,e
	ld	l,e
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	ld	de,0x21c
	ld	l,0x10
@1823:
	ld	(ix-34),hl
	ex	de,hl
	ld	(ix-36),hl
	ex	de,hl
;5653       break;
	.debug	# 5653
;5654 
;5655     default:
	jr	@1421
;5656       return -1;
	.debug	# 5656
@1431:
	jp	@1440
;5657   }
@1423:
	.debug	>
;5658 
;5659   if (msSince_(lastWaveReadTime[w]) < 500)  return -1;
@1420:
	ld	hl,0xfffffdf6
	add	hl,de
	bool	hl
	jr	nz,@1432
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jp	z,@1424
@1432:
	ld	hl,0xfffffdf4
	add	hl,de
	bool	hl
	jr	nz,@1433
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jp	z,@1425
@1433:
	ld	hl,0xfffffde2
	add	hl,de
	bool	hl
	jr	nz,@1434
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jr	z,@1427
@1434:
	ld	hl,0xfffffde0
	add	hl,de
	bool	hl
	jr	nz,@1435
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jr	z,@1429
@1435:
	ld	hl,0xfffffdda
	add	hl,de
	bool	hl
	jr	nz,@1431
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jp	z,@1426
	jr	@1431
@1421:
	.debug	# 5659
	ld	hl,(ix-6)
	add	hl,hl
	ld	de,_lastWaveReadTime
	add	hl,de
	ld	hl,(hl)
	ld	de,(__TimerMilliSeconds+4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	de,0x1f4
	or	a,a
	sbc	hl,de
	jr	c,@1440
;5660 
;5661   if (msSince_(lastReadPlotTime) < 200)  return -1;
	.debug	# 5661
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastReadPlotTime)
	or	a,a
	sbc	hl,de
	ld	de,0xc8
	or	a,a
	sbc	hl,de
	jr	c,@1440
;5662 
;5663 //  fprintf(DiagLog, "readWaveform(w=%d)\n", w);  //tdebug
;5664 
;5665   buf = waveformData[w];  lockID = WAVE_DATA_0 + w;
	.debug	# 5665
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,0
	ld	a,0xc
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _waveformData)
	ld	c,phys _waveformData >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-8),hl
;5666 
;5667   regNum = bufID;
	.debug	# 5667
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
;5668 
;5669 
;5670   if (getLock(lockID, 0) <= 0)  return -1;
	.debug	# 5670
	ld	de,0
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix-8)
	push	hl
	lcall	$getLock
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@1440
	jr	nc,@1439
@1440:
	ld	hl,0xffff
	jp	@1417
;5671 
;5672   if (readWaves)  {
@1439:
	.debug	# 5672
	ld	a,(_readWaves)
	or	a,a
	jp	z,@1441
;5673 
;5674   //--- get the # of long words in the waveform ---
;5675     if (countReg)  {
@1442:
	.debug	< @1442 @1443
	.debug	# 5675
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	or	hl,de
	jp	z,@1444
;5676       if (hdwType == HT_PHASE_CTLR)
@1445:
	.debug	< @1445 @1446
	.debug	# 5676
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nz,@1447
;5677         readDSPReg(countReg, &count);
	.debug	# 5677
	ld	hl,-32+@1416
	add	hl,sp
	push	hl
	ld	hl,(ix-36)
	ex	de,hl
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	lcall	$readDSPReg
	add	sp,6
;5678       else  {
	jr	@1448
@1447:
;5679         switch (bufID)  {
@1449:
	.debug	< @1449 @1450
	.debug	# 5679
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	jr	@1451
;5680           case Rd_L_Buf:  case Rd_T_Buf:  count = 1024;  break;
@1453:
	.debug	< @1453 @1454
	.debug	# 5680
@1455:
@1456:
	ld	de,0x400
	ld	c,e
	ld	b,e
	ld	hl,bc
	jr	@1822
;5681           case AmplFFT:                   count = 1001;  break;
	.debug	# 5681
@1457:
	ld	de,0x3e9
	jr	@1821
;5682           case PhaseCTF:  case AmplCTF:   count = 1000;  break;
	.debug	# 5682
@1458:
@1459:
	ld	de,0x3e8
@1821:
	ld	hl,0
@1822:
	ld	(ix-30),hl
	ex	de,hl
	ld	(ix-32),hl
	ex	de,hl
;5683         }
	jr	@1452
@1454:
	.debug	>
;5684       }
@1451:
	ld	hl,0xfffffdf6
	add	hl,de
	bool	hl
	jr	nz,@1460
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jr	z,@1455
@1460:
	ld	hl,0xfffffdf4
	add	hl,de
	bool	hl
	jr	nz,@1461
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jr	z,@1456
@1461:
	ld	hl,0xfffffde2
	add	hl,de
	bool	hl
	jr	nz,@1462
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jr	z,@1458
@1462:
	ld	hl,0xfffffde0
	add	hl,de
	bool	hl
	jr	nz,@1463
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jr	z,@1459
@1463:
	ld	hl,0xfffffdda
	add	hl,de
	bool	hl
	jr	nz,@1452
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jr	z,@1457
@1452:
@1450:
	.debug	>
;5685       if (count > MaxDataPoints)  count = MaxDataPoints;
@1448:
	.debug	# 5685
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x400
	ld	c,e
	ld	b,e
	call	__lsub##
	jr	c,@1465
	jr	z,@1465
	ld	de,0x400
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-30),hl
	ex	de,hl
	ld	(ix-32),hl
	ex	de,hl
;5686       numDataPoints[w] = (uint) count;
@1465:
	.debug	# 5686
	ld	hl,(ix-6)
	add	hl,hl
	ld	de,_numDataPoints
	add	hl,de
	ex	de,hl
	ld	hl,(ix-32)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;5687     }
@1446:
	.debug	>
;5688 
;5689 //--- read specified DSP buffer with waveform data ---
;5690     readPlot(regNum, buf, numDataPoints[w]);  lastReadPlotTime = GetMS_();
@1444:
	.debug	# 5690
	ld	hl,(ix-6)
	add	hl,hl
	ld	de,_numDataPoints
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	lcall	$readPlot
	add	sp,10
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastReadPlotTime),hl
;5691 
;5692     if (hdwType != HT_PHASE_CTLR)  {  // generate a simple waveform
	.debug	# 5692
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jp	z,@1466
;5693       readCount += 5;  val = readCount;
@1467:
	.debug	< @1467 @1468
	.debug	# 5693
	ld	hl,(@1419)
	ld	e,0x5
	add	hl,de
	ld	(@1419),hl
	ex	de,hl
	ld	b,h
	ld	l,h
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
;5694       for (uint u=0; u<numDataPoints[w]; ++u)  {
@1469:
	.debug	< @1469 @1470
	.debug	L u -38 7
	.debug	# 5694
	ld	(ix-38),hl
	.seg	FARCODE
@1471:
	ld	hl,(ix-6)
	add	hl,hl
	ld	de,_numDataPoints
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix-38)
	or	a,a
	sbc	hl,de
	jp	nc,@1472
;5695         val = ++val & 0xff;
@1474:
	.debug	< @1474 @1475
	.debug	# 5695
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__linc##
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0xff
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
;5696 
;5697         switch (bufID)  {
	.debug	# 5697
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	jp	@1476
;5698           case Rd_L_Buf:  // 2 16-bit LSB 1st values for Ampl and Phase
@1478:
	.debug	< @1478 @1479
;5699           case Rd_T_Buf:  // ampl: raw ADC rdg, phase: int mult of 360/2^16
	.debug	# 5699
@1480:
;5700             u32 = (val << 16) | (~val & 0xff);  buf[u] = htonl(u32);  break
	.debug	# 5700
@1481:
	ld	hl,(ix-28)
	ex	de,hl
	ld	b,d
	ld	c,e
	ld	de,0
	push	bc
	push	de
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__lnot##
	push	bc
	push	de
	ld	de,0xff
	ld	c,d
	ld	b,d
	call	__land##
	call	__lor##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	jp	@1820
;5701 
;5702           case AmplFFT:  // Amplitude FFT (32-bit IEEE float)
;5703             fval = (float) val / 256.0;  buf[u] = htonl(*((ulong *)&fval));
	.debug	# 5703
@1482:
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__ultof##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4380
	call	__fdiv##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	jp	@1820
;5704 
;5705           case PhaseCTF:  // Phase CTF (expr as int mult of 360/2^32)
;5706             u32 = ~(val << 24);  buf[u] = htonl(u32);  break;
	.debug	# 5706
@1483:
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	b,e
	ld	de,0
	ld	c,e
	call	__lnot##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	jp	@1820
;5707 
;5708           case AmplCTF:  // Ampl CTF (32-bit IEEE float) (?)
;5709   //          u32 = val << 24;  buf[u] = htonl(u32);  break;
;5710             fval = (float) val / 256.0;  buf[u] = htonl(*((ulong *)&fval));
	.debug	# 5710
@1484:
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__ultof##
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4380
	call	__fdiv##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
@1820:
	ld	hl,(ix-38)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x2
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__ladd##
	call	__farst4p##
;5711         }
	jr	@1477
@1479:
	.debug	>
;5712       }
@1476:
	ld	hl,0xfffffdf6
	add	hl,de
	bool	hl
	jr	nz,@1485
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jp	z,@1480
@1485:
	ld	hl,0xfffffdf4
	add	hl,de
	bool	hl
	jr	nz,@1486
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jp	z,@1481
@1486:
	ld	hl,0xfffffde2
	add	hl,de
	bool	hl
	jr	nz,@1487
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jp	z,@1483
@1487:
	ld	hl,0xfffffde0
	add	hl,de
	bool	hl
	jr	nz,@1488
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jp	z,@1484
@1488:
	ld	hl,0xfffffdda
	add	hl,de
	bool	hl
	jr	nz,@1477
	ld	hl,0xfffffff0
	add	hl,bc
	bool	hl
	jp	z,@1482
@1477:
@1475:
	.debug	>
;5713     }
	ld	hl,(ix-38)
	inc	hl
	ld	(ix-38),hl
	jp	@1471
@1472:
@1470:
	.debug	>
@1468:
	.debug	>
;5714 
;5715   //--- let DSP know it is OK to write to the buffer again ---
;5716     if (ackBits)  writeDSPRegQuick(SetDSPState, ackBits);
@1466:
	.debug	# 5716
	ld	hl,(ix-24)
	ex	de,hl
	ld	hl,(ix-22)
	ld	bc,hl
	or	hl,de
	jr	z,@1490
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x200
	ld	bc,0x10
	push	bc
	push	de
	lcall	$writeDSPRegQuick
	add	sp,8
;5717 
;5718     _EnterCritical_();
@1490:
	.debug	# 5718
	ipset	2
;5719     dataTimeSecs[w] = time(NULL);  dataTimeMS[w] = GetMS();
	.debug	# 5719
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	ld	hl,(ix-6)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_dataTimeSecs
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,(ix-6)
	add	hl,hl
	add	hl,hl
	push	de
	ld	de,_dataTimeMS
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;5720     _ExitCritical_();
	.debug	# 5720
	ipres
;5721 
;5722     lastWaveReadTime[w] = GetMS_();
	.debug	# 5722
	ld	hl,(ix-6)
	add	hl,hl
	ld	de,_lastWaveReadTime
	add	hl,de
	ld	de,(__TimerMilliSeconds+4)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;5723   }
@1443:
	.debug	>
;5724 
;5725   releaseLock(lockID);
@1441:
	.debug	# 5725
	ld	hl,(ix-8)
	push	hl
	lcall	$releaseLock
	pop	de
;5726 
;5727   return 0;
	.debug	# 5727
	bool	hl
	ld	l,h
;5728 }
@1417:
	.debug	} @1417 5728

@1416	equ	38
	ld	sp,ix
	pop	ix
	lret
@1418	equ	40
;5729 
;5730 
;5731 
;5732 //-------------------------------------------------------------------------
;5733 void ForceDigOut(uchar bitNum, uchar val)
;5734 {
$ForceDigOut::
	.debug	G $ForceDigOut 154 9
	.debug	{ $ForceDigOut 154 5733 @1493 @1492
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A bitNum 5 3
	.debug	A val 7 3
;5735   ulong  mask;
	.debug	L mask -4 9
;5736 
;5737   mask = 1L << bitNum;
	.debug	# 5737
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	a,(ix+5)
	call	__lshl##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;5738   forcedDigOutMask |= mask;  forcedDigOutBits &= ~mask;
	.debug	# 5738
	ld	de,(_forcedDigOutMask)
	ld	bc,(_forcedDigOutMask+2)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lor##
	ld	(_forcedDigOutMask),de
	ld	(_forcedDigOutMask+2),bc
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lnot##
	push	bc
	push	de
	ld	de,(_forcedDigOutBits)
	ld	bc,(_forcedDigOutBits+2)
	call	__land##
	ld	(_forcedDigOutBits),de
	ld	(_forcedDigOutBits+2),bc
;5739   if (val)  forcedDigOutBits |= mask;
	.debug	# 5739
	ld	a,(ix+7)
	or	a,a
	jr	z,@1494
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lor##
	ld	(_forcedDigOutBits),de
	ld	(_forcedDigOutBits+2),bc
;5740 
;5741   WriteDig();
@1494:
@1495:
	.debug	< @1495 @1496
	.debug	# 5741
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@1496:
	.debug	>
;5742 }
@1492:
	.debug	} @1492 5742

@1491	equ	4
	ld	sp,ix
	pop	ix
	lret
@1493	equ	6
;5743 
;5744 //-------------------------------------------------------------------------
;5745 void ReleaseDigOut(uchar bitNum)
;5746 {
$ReleaseDigOut::
	.debug	G $ReleaseDigOut 102 9
	.debug	{ $ReleaseDigOut 102 5745 @1499 @1498
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A bitNum 5 3
;5747   forcedDigOutMask &= ~(1L << bitNum);
	.debug	# 5747
	ld	de,0x1
	ld	c,d
	ld	b,d
	ld	a,(ix+5)
	call	__lshl##
	call	__lnot##
	push	bc
	push	de
	ld	de,(_forcedDigOutMask)
	ld	bc,(_forcedDigOutMask+2)
	call	__land##
	ld	(_forcedDigOutMask),de
	ld	(_forcedDigOutMask+2),bc
;5748   forcedDigOutBits &= forcedDigOutMask;
	.debug	# 5748
	ld	de,(_forcedDigOutBits)
	ld	bc,(_forcedDigOutBits+2)
	push	bc
	push	de
	ld	de,(_forcedDigOutMask)
	ld	bc,(_forcedDigOutMask+2)
	call	__land##
	ld	(_forcedDigOutBits),de
	ld	(_forcedDigOutBits+2),bc
;5749 
;5750   WriteDig();
@1500:
	.debug	< @1500 @1501
	.debug	# 5750
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@1501:
	.debug	>
;5751 }
@1498:
	.debug	} @1498 5751

@1497	equ	0
	pop	ix
	lret
@1499	equ	2
;5752 
;5753 //=========================================================================
;5754 //  reset the DSP
;5755 //=========================================================================
;5756 void resetDSP(void)
;5757 {
$resetDSP::
	.debug	G $resetDSP 99 9
	.debug	{ $resetDSP 99 5756 @1504 @1503
;5758   if (getLock(APPL_LOCK, 5000) <= 0)  return;
	.debug	# 5758
	ld	de,0x1388
	ld	bc,0
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	lcall	$getLock
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@1506
	jr	nc,@1505
@1506:
;5759 
;5760   dspProgNum &= 0x03;
	jp	@1503
@1505:
	.debug	# 5760
	ld	hl,(_dspProgNum)
	ld	de,0x3
	and	hl,de
	ld	(_dspProgNum),hl
;5761 
;5762   fprintf(DiagLog, "*** Reset DSP with %u errors ***\n", dspComErrors);
	.debug	# 5762
	ld	hl,(_dspComErrors)
	push	hl
	ld	de,word (phys @1+5719)
	ld	c,phys @1+5719 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;5763   fprintf(DiagLog, "Run program # %d\r\n", dspProgNum);
	.debug	# 5763
	ld	hl,(_dspProgNum)
	push	hl
	ld	de,word (phys @1+5753)
	ld	c,phys @1+5753 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,8
;5764 
;5765   prepForReset();
	.debug	# 5765
	lcall	$prepForReset
;5766 
;5767 //--- assert program # to run after reset ---
;5768   KLOCK();
	.debug	# 5768
	call	_KLOCK
;5769   ClearBits(digitalOut, READY_LED);
	.debug	# 5769
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	res	2,d
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
;5770   Next.digitalOut = digitalOut =
;5771     (digitalOut & 0x3FFFFFL) | ((ulong)dspProgNum << 22);
	.debug	# 5771
	push	bc
	push	de
	ld	de,0xffff
	ld	bc,0x3f
	call	__land##
	ld	hl,(_dspProgNum)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x16
	call	__lshl##
	call	__lor##
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
;5772   KUNLOCK();
	.debug	# 5772
	call	_KUNLOCK
;5773   WriteDig();
@1507:
	.debug	< @1507 @1508
	.debug	# 5773
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@1508:
	.debug	>
;5774 
;5775 //--- reset the DSP ---
;5776   ForceDigOut(8, 0);  // force DO-08 (_RESET_DSP) low
	.debug	# 5776
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x8
	push	hl
	lcall	$ForceDigOut
	add	sp,4
;5777   resetWDT();  sleepMS(500);  // hold it for 0.5 seconds
	.debug	# 5777
	lcall	$resetWDT
	ld	de,0x1f4
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;5778   ForceDigOut(8, 1);  // force DO-08 (_RESET_DSP) back high
	.debug	# 5778
	ld	hl,0x1
	push	hl
	ld	l,0x8
	push	hl
	lcall	$ForceDigOut
	add	sp,4
;5779   ReleaseDigOut(8);   // release the bit
	.debug	# 5779
	ld	hl,0x8
	push	hl
	lcall	$ReleaseDigOut
	pop	hl
;5780   resetWDT();  sleepMS(500);
	.debug	# 5780
	lcall	$resetWDT
	ld	de,0x1f4
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;5781 
;5782   KLOCK();  SetBits(Next.digitalOut, READY_LED);  KUNLOCK();
	.debug	# 5782
	call	_KLOCK
	ld	de,(_nextState+4)
	ld	bc,(_nextState+6)
	set	2,d
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
	call	_KUNLOCK
;5783 
;5784   _EnterCritical_();  dspComErrors = 0;  _ExitCritical_();
	.debug	# 5784
	ipset	2
	bool	hl
	ld	l,h
	ld	(_dspComErrors),hl
	ipres
;5785 
;5786   releaseLock(APPL_LOCK);
	.debug	# 5786
	push	hl
	lcall	$releaseLock
	pop	de
;5787 }
@1503:
	.debug	} @1503 5787

@1502	equ	0
	lret
@1504	equ	0
;5788 
;5789 //-------------------------------------------------------------------------
;5790 
;5791 //=========================================================================
;5792 //  Copy the "cur" state from last time to "prev", and update "cur"
;5793 //=========================================================================
;5794 //  Just before this function is called, readings were taken of the current
;5795 //  state of the hardware, and any changes to the output states specified b
;5796 //  the last pass were applied (just after taking the readings).
;5797 //
;5798 //  This func first copies "cur" to "prev" and then "next" to "cur" which d
;5799 //  2 things for us:
;5800 //
;5801 //    - We have a copy of the controller's logical state from the last pass
;5802 //      (so we can determine what has changed)
;5803 //
;5804 //    - We have a copy of values set by other tasks indicating events/reque
;5805 //      that happend/were made since the beginning of the last pass
;5806 //
;5807 //  We then reset the values (as needed) that are set by other tasks to
;5808 //  indicate events and requests, and update the current state based on the
;5809 //  readings just taken and the requests and events communicated by other
;5810 //  tasks.
;5811 //
;5812 //  All of this is in preperation for the updateNextState() function, which
;5813 //  implements the main "decision making" portion of the application logic,
;5814 //  determining what the next state should be based on the latest condition
;5815 //  (as determined by the updateCurState() function).
;5816 //
;5817 //=========================================================================
;5818 void updateCurState(void)
;5819 {
$updateCurState::
	.debug	G $updateCurState 99 9
	.debug	{ $updateCurState 99 5818 @1511 @1510
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-16
;5820   uint  x;
	.debug	L x -2 7
;5821   ulong  maxWait1, maxWait2, elapsed;  //test
	.debug	L maxWait1 -6 9
	.debug	L maxWait2 -10 9
	.debug	L elapsed -14 9
;5822   PV_Desc  *pv;  //tdebug
	.debug	L pv -16 93
;5823   static time_t  lastChg;  //tdebug
	.bseg
@1512:
	.ds	4
	.debug	S lastChg @1512 9
	.seg	FARCODE
;5824   static uint  check1st = 0;
	.dseg
@1513:
	.dw	0
	.debug	S check1st @1513 7
	.seg	FARCODE
;5825 
;5826 
;5827 
;5828   if (current != applTask)  return;
	.debug	# 5828
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@1510
;5829 
;5830 //-----------------------------------------------------------------
;5831 // The following conditions exist at this point:
;5832 // - The inputs have just been read
;5833 // - The outputs were just set to values computed during the last pass
;5834 // - "cur" contains the state the inputs were in at the START of
;5835 //   of the previous pass, and the state the outputs were in DURING
;5836 //   the previous pass
;5837 // - "next" contains the values that the outputs were just set
;5838 //   to and any "input" values that were changed by other tasks
;5839 //------------------------------------------------------------------
;5840 
;5841 // Now we update the values in "Next" that are based solely on the
;5842 // state of the hardware inputs we just read and values maintained by
;5843 // by other tasks (basically, we deal with READINGS here: Values that
;5844 // we need but are not written to "Next" by another task)
;5845 
;5846 //  Next.processTime = GetMS();  curTime = time(NULL);
;5847 
;5848 //  msSincePrev = msSince(Cur.processTime);
;5849 
;5850   Next.digitalIn = digitalIn;
	.debug	# 5850
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState),de
	ld	(_nextState+2),bc
;5851 
;5852 
;5853 // Note that a copy is done (rather than just switching pointer values) to
;5854 // insure all values are set in both the source and destination.  If we
;5855 // simply kept pointers and swapped the pointer values, then EVERY value
;5856 // would have to be updated independently by the code, which is a pain to
;5857 // program, adds overhead and code, and is a VERY easy way to introduce odd
;5858 // bugs.  Overall, copying everything here is actually faster overall,
;5859 // simpler, and much safer.
;5860 
;5861   Prev = Cur;  Cur = Next;
	.debug	# 5861
	ld	hl,_curState
	ld	de,_prevState
	push	hl
	ld	bc,8
	ldir
	pop	hl
	ld	hl,_nextState
	ld	de,_curState
	push	hl
	ld	bc,8
	ldir
	pop	hl
;5862 
;5863 //--- At this point the Cur copy contains what the inputs were at the start
;5864 //--- of this pass, and the Prev copy contains the output values from the -
;5865 //--- the previous pass (i.e. the output values that resulted in the input 
;5866 //--- values in Cur) ---
;5867 
;5868 
;5869 //--------------------------------------------------------------------
;5870 // Next we update the rest of the "cur" values needed by the control
;5871 // logic (the ones that do NOT come from "next" values set by other
;5872 // tasks)
;5873 //
;5874 // NOTES:
;5875 //  - This portion of the logic has order-of-execution dependencies,
;5876 //    so be sure that all values referenced in an expression are ones
;5877 //    set before they are used.
;5878 //
;5879 //  - References to "prev" values are always safe since they are just
;5880 //    a copy of values from the last pass
;5881 //--------------------------------------------------------------------
;5882 
;5883   //--- log msgs for bit chgs only if not starving other processes for cycl
;5884   if (applLoopTime < 8)  logDigIOChgs(false);
	.debug	# 5884
	ld	hl,(_applLoopTime)
	ld	de,0x8
	or	a,a
	sbc	hl,de
	jr	nc,@1515
	bool	hl
	ld	l,h
	push	hl
	lcall	$logDigIOChgs
	pop	hl
;5885 
;5886 
;5887 //APPLCODE
;5888   if (!fpgaInitialized)  return;
@1515:
	.debug	# 5888
	ld	a,(_fpgaInitialized)
	or	a,a
	jp	z,@1510
;5889 
;5890   if (!autoReadDSP AND !autoWriteDSP)  return;
	.debug	# 5890
	ld	a,(_autoReadDSP)
	or	a,a
	jr	nz,@1518
	ld	a,(_autoWriteDSP)
	or	a,a
	jp	z,@1510
;5891 
;5892   if (getLockDSP(10) <= 0)  return;
@1518:
	.debug	# 5892
	ld	de,0xa
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$getLockDSP
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	z,@1520
	jr	nc,@1519
@1520:
;5893 
;5894 
;5895 //--- Amplitude and phase waveform data is read as a single stream of ---
;5896 //--- 32-bit values, where 16 of each 32 bits is an amplitude value and ---
;5897 //--- the other 16 is a phase value.  When operating in "pulsed" mode ---
;5898 //--- (where the Amplitude and/or Phase setpoints are being toggled ---
;5899 //--- between 2 values), the waveform data is updated based on when ---
;5900 //--- the change happens, and it provides data surrounding the "leading" --
;5901 //--- edge and the "trailing" edge.  When not operating in pulsed mode, ---
;5902 //--- the exact timing of the updates to the buffers is not known. ---
;5903 
;5904 //--- The FFT waveform is 32-bits per value and, like the Ampl/Phase data -
;5905 //--- is updated by the DSP whenever we tell it we have finished reading --
;5906 //--- the last copy in its buffer ---
;5907 
;5908 //--- In each case, status bits from the DSP indicate when the buffers ---
;5909 //--- have new data, and we need to read the data then tell the DSP that --
;5910 //--- we have done so and that it may write new data to the buffers ---
;5911 
;5912   if (hdwType == HT_PHASE_CTLR)  {  //test
	jp	@1510
@1519:
	.debug	# 5912
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nz,@1521
;5913     maxWait1 = 2000;  maxWait2 = 10000;  }
@1522:
	.debug	< @1522 @1523
	.debug	# 5913
	ld	de,0x7d0
	ld	hl,0
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x2710
	ld	b,h
	ld	c,l
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
@1523:
	.debug	>
;5914   else  {
	jr	@1524
@1521:
;5915     maxWait1 = 500;  maxWait2 = 2000;  }
@1525:
	.debug	< @1525 @1526
	.debug	# 5915
	ld	de,0x1f4
	ld	hl,0
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	ld	de,0x7d0
	ld	b,h
	ld	c,l
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
@1526:
	.debug	>
;5916 
;5917   if (!calcStartTimeCTF)  {
@1524:
	.debug	# 5917
	ld	de,(_calcStartTimeCTF)
	ld	bc,(_calcStartTimeCTF+2)
	ld	hl,bc
	or	hl,de
	jp	nz,@1527
;5918   //--- Rotate the order we use to check for new waveform data and do not -
;5919   //--- read more than one each pass ---
;5920     for (x=0; x<3; ++x)  {
@1528:
	.debug	< @1528 @1529
@1530:
	.debug	< @1530 @1531
	.debug	# 5920
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@1532:
	ld	hl,(ix-2)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jp	nc,@1533
;5921       if (++check1st >= 3)  check1st = 0;
@1535:
	.debug	< @1535 @1536
	.debug	# 5921
	ld	hl,(@1513)
	inc	hl
	ld	(@1513),hl
	or	a,a
	sbc	hl,de
	jr	c,@1537
	bool	hl
	ld	l,h
	ld	(@1513),hl
;5922 
;5923       if (check1st == 0)  if (NEW_L_DATA
@1537:
	.debug	# 5923
	ld	hl,(@1513)
	bool	hl
	jr	nz,@1538
;5924           OR (msSince_(lastWaveReadTime[WAVE_AP_L_SRC]) > maxWait1))
	.debug	# 5924
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0x40
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@1539
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastWaveReadTime)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__lsub##
	jr	c,@1540
	jr	z,@1540
@1539:
;5925         if (!readWaveform(Rd_L_Buf))  { lastDSPioTime = GetMS_();   break; 
	.debug	# 5925
	ld	de,0x20a
	ld	bc,0x10
	push	bc
	push	de
	lcall	$readWaveform
	add	sp,4
	bool	hl
	jp	z,@1819
@1542:
	.debug	< @1542 @1543
@1543:
	.debug	>
;5926 
;5927       if (check1st == 1)  if (NEW_T_DATA
@1540:
@1538:
	.debug	# 5927
	ld	hl,(@1513)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@1544
;5928           OR (msSince_(lastWaveReadTime[WAVE_AP_T_SRC]) > maxWait1))
	.debug	# 5928
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0x80
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@1545
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastWaveReadTime+4)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__lsub##
	jr	c,@1546
	jr	z,@1546
@1545:
;5929         if (!readWaveform(Rd_T_Buf))  { lastDSPioTime = GetMS_();   break; 
	.debug	# 5929
	ld	de,0x20c
	ld	bc,0x10
	push	bc
	push	de
	lcall	$readWaveform
	add	sp,4
	bool	hl
	jr	z,@1819
@1548:
	.debug	< @1548 @1549
@1549:
	.debug	>
;5930 
;5931       if (check1st == 2)  if (FFT_DATA_VALID
@1546:
@1544:
	.debug	# 5931
	ld	hl,(@1513)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	nz,@1550
;5932           OR (msSince_(lastWaveReadTime[WAVE_FFT_SRC]) > maxWait2))
	.debug	# 5932
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0x8000
	ld	c,e
	ld	b,e
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	nz,@1551
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastWaveReadTime+8)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__lsub##
	jr	c,@1552
	jr	z,@1552
@1551:
;5933         if (!readWaveform(AmplFFT))   { lastDSPioTime = GetMS_();   break; 
	.debug	# 5933
	ld	de,0x226
	ld	bc,0x10
	push	bc
	push	de
	lcall	$readWaveform
	add	sp,4
	bool	hl
	jr	nz,@1553
@1554:
	.debug	< @1554 @1555
@1819:
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastDSPioTime),hl
	jr	@1533
@1555:
	.debug	>
;5934     }
@1553:
@1552:
@1550:
@1536:
	.debug	>
;5935   }
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@1532
@1533:
@1531:
	.debug	>
@1529:
	.debug	>
;5936 
;5937 
;5938 //--- The CTF waveforms take around 40 secs to compute and interferes with 
;5939 //--- the other waveforms (the DSP can't do them while computing the CTF) -
;5940 //--- There is a separate Amplitude and Phase waveform, each one composed -
;5941 //--- of 32-bits for each data point.  The waveforms are computed once ---
;5942 //--- each time we ask for them, and the DSP provides a status register ---
;5943 //--- to indicate how far along it is in calculating them ---
;5944 //    NOTE:  No longer implemented in the "real" hardware - but left here
;5945 //           for use in testing manually (re)armed waveforms
;5946 
;5947 //--- check to see if we should start a new calc for the CTF waveform ---
;5948   if ( (readerRdy[WAVE_CTF_P_SRC] OR readerRdy[WAVE_CTF_A_SRC])
@1527:
;5949       AND (calcStartTimeCTF == 0) )  {
	.debug	# 5949
	ld	a,(_readerRdy+6)
	or	a,a
	jr	nz,@1560
	ld	a,(_readerRdy+8)
	or	a,a
	jr	z,@1559
@1560:
	ld	de,(_calcStartTimeCTF)
	ld	bc,(_calcStartTimeCTF+2)
	ld	hl,bc
	or	hl,de
	jr	nz,@1559
;5950     readerRdy[WAVE_CTF_P_SRC] = readerRdy[WAVE_CTF_A_SRC] = false;
@1561:
	.debug	< @1561 @1562
	.debug	# 5950
	xor	a,a
	ld	(_readerRdy+8),a
	ld	(_readerRdy+6),a
;5951   }
@1562:
	.debug	>
;5952 
;5953 //--- for test purposes only ---
;5954   if (hdwType != HT_PHASE_CTLR)
@1559:
	.debug	# 5954
	ld	hl,(_hdwType)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jp	z,@1563
;5955     if (!calcStartTimeCTF)
	.debug	# 5955
	ld	de,(_calcStartTimeCTF)
	ld	bc,(_calcStartTimeCTF+2)
	ld	hl,bc
	or	hl,de
	jr	nz,@1564
;5956       percentCTF = 100;
	.debug	# 5956
	ld	hl,0x64
	ld	(_percentCTF),hl
;5957     else  {
	jp	@1565
@1564:
;5958       elapsed = msSince(calcStartTimeCTF);
@1566:
	.debug	< @1566 @1567
	.debug	# 5958
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_calcStartTimeCTF)
	ld	bc,(_calcStartTimeCTF+2)
	call	__lsub##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;5959       percentCTF = (elapsed < 40000) ? (U16)(elapsed / 400) : 100;
	.debug	# 5959
	push	bc
	push	de
	ld	de,0x9c40
	ld	bc,0
	call	__lsub##
	jr	nc,@1568
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x190
	ld	bc,0
	call	__uldiv##
	ex	de,hl
	jr	@1569
@1568:
	ld	hl,0x64
@1569:
	ld	(_percentCTF),hl
;5960     }
@1567:
	.debug	>
;5961 
;5962 //--- Check to see if a pending CTF calc has completed ---
;5963   if (calcStartTimeCTF)  do  {
@1565:
@1563:
	.debug	# 5963
	ld	de,(_calcStartTimeCTF)
	ld	bc,(_calcStartTimeCTF+2)
	ld	hl,bc
	or	hl,de
	jp	z,@1570
;5964     if (msSince(calcStartTimeCTF) > 60000)  {
@1574:
	.debug	< @1574 @1575
	.debug	# 5964
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_calcStartTimeCTF)
	ld	bc,(_calcStartTimeCTF+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0xea60
	ld	bc,0
	call	__lsub##
	jr	c,@1576
	jr	z,@1576
;5965       printf("CTF calc never finished\n");  calcStartTimeCTF = 0;  break; }
@1577:
	.debug	< @1577 @1578
	.debug	# 5965
	ld	de,word (phys @1+5772)
	ld	c,phys @1+5772 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_calcStartTimeCTF),de
	ld	(_calcStartTimeCTF+2),bc
	jp	@1572
@1578:
	.debug	>
;5966     if (msSince(calcStartTimeCTF) < 2000)  break;
@1576:
	.debug	# 5966
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_calcStartTimeCTF)
	ld	bc,(_calcStartTimeCTF+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x7d0
	ld	bc,0
	call	__lsub##
	jp	c,@1572
;5967     if (percentCTF != 100)  break;
	.debug	# 5967
	ld	hl,(_percentCTF)
	ld	de,0x64
	or	a,a
	sbc	hl,de
	jp	nz,@1572
;5968     fprintf(DiagLog, "Finished CTF calculation\n");
	.debug	# 5968
	ld	de,word (phys @1+5797)
	ld	c,phys @1+5797 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;5969     startCTFWaitTime = GetMS();  calcStartTimeCTF = 0;
	.debug	# 5969
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(_startCTFWaitTime),de
	ld	(_startCTFWaitTime+2),bc
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_calcStartTimeCTF),de
	ld	(_calcStartTimeCTF+2),bc
;5970   }  while(0);
@1575:
	.debug	>
	.debug	# 5970
;5971 
;5972 //--- Wait 2 seconds after CTF calc finished before reading it ---
;5973   if (startCTFWaitTime)  if (msSince(startCTFWaitTime) > 2000)  {
@1572:
@1570:
	.debug	# 5973
	ld	de,(_startCTFWaitTime)
	ld	bc,(_startCTFWaitTime+2)
	ld	hl,bc
	or	hl,de
	jp	z,@1581
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(_startCTFWaitTime)
	ld	bc,(_startCTFWaitTime+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x7d0
	ld	bc,0
	call	__lsub##
	jr	c,@1582
	jr	z,@1582
;5974     if (msSince_(lastDSPioTime) > 20)  {
@1583:
	.debug	< @1583 @1584
	.debug	# 5974
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastDSPioTime)
	or	a,a
	sbc	hl,de
	ld	de,0x14
	or	a,a
	sbc	hl,de
	jr	c,@1585
	jr	z,@1585
;5975       readWaveform(PhaseCTF);  readWaveform(AmplCTF);
@1586:
	.debug	< @1586 @1587
	.debug	# 5975
	ld	de,0x21e
	ld	bc,0x10
	push	bc
	push	de
	lcall	$readWaveform
	add	sp,4
	ld	de,0x220
	ld	bc,0x10
	push	bc
	push	de
	lcall	$readWaveform
	add	sp,4
;5976       startCTFWaitTime = 0;  lastDSPioTime = GetMS_();
	.debug	# 5976
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_startCTFWaitTime),de
	ld	(_startCTFWaitTime+2),bc
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastDSPioTime),hl
;5977     }
@1587:
	.debug	>
;5978   }
@1585:
@1584:
	.debug	>
;5979 
;5980 
;5981 /*
;5982   Reading waveforms and doing the periodic I/O to/from the DSP are both
;5983   lengthy processes, so we minimize latency on the rest of the system
;5984   by not allowing them both to happen in the same pass.
;5985 */
;5986   if (msSince_(lastDSPioTime) > 20)  {
@1582:
@1581:
	.debug	# 5986
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastDSPioTime)
	or	a,a
	sbc	hl,de
	ld	de,0x14
	or	a,a
	sbc	hl,de
	jp	c,@1588
	jp	z,@1588
;5987 
;5988     ilkRatioGain = fwdAmplGain / reflAmplGain;
@1589:
	.debug	< @1589 @1590
	.debug	# 5988
	ld	de,(_fwdAmplGain)
	ld	bc,(_fwdAmplGain+2)
	push	bc
	push	de
	ld	de,(_reflAmplGain)
	ld	bc,(_reflAmplGain+2)
	call	__fdiv##
	ld	(_ilkRatioGain),de
	ld	(_ilkRatioGain+2),bc
;5989     ilkRatioOffset = 0;  //finish - what to set this to?
	.debug	# 5989
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_ilkRatioOffset),de
	ld	(_ilkRatioOffset+2),bc
;5990 
;5991     maxOutAmplGain = cavAmplGain * feedFwdGain;
	.debug	# 5991
	ld	de,(_cavAmplGain)
	ld	bc,(_cavAmplGain+2)
	push	bc
	push	de
	ld	de,(_feedFwdGain)
	ld	bc,(_feedFwdGain+2)
	call	__fmlt##
	ld	(_maxOutAmplGain),de
	ld	(_maxOutAmplGain+2),bc
;5992     maxOutAmplOffset = 0;  //finish - what to set this to?
	.debug	# 5992
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_maxOutAmplOffset),de
	ld	(_maxOutAmplOffset+2),bc
;5993 
;5994     if (autoReadDSP)   if (!read_DSP_Regs())   lastDSPioTime = GetMS_();
	.debug	# 5994
	ld	a,(_autoReadDSP)
	or	a,a
	jr	z,@1591
	lcall	$read_DSP_Regs
	bool	hl
	jr	nz,@1592
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastDSPioTime),hl
;5995     if (autoWriteDSP)  if (!write_DSP_Regs())  lastDSPioTime = GetMS_();
@1592:
@1591:
	.debug	# 5995
	ld	a,(_autoWriteDSP)
	or	a,a
	jr	z,@1593
	lcall	$write_DSP_Regs
	bool	hl
	jr	nz,@1594
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastDSPioTime),hl
;5996 
;5997     if (dspLoad > 999)  dspLoad = 999;
@1594:
@1593:
	.debug	# 5997
	ld	hl,(_dspLoad)
	ld	de,0x3e7
	or	a,a
	sbc	hl,de
	jr	c,@1595
	jr	z,@1595
	ld	h,d
	ld	l,e
	ld	(_dspLoad),hl
;5998     if (dspTemp > 99.9)  dspTemp = 99.9;
@1595:
	.debug	# 5998
	ld	de,(_dspTemp)
	ld	bc,(_dspTemp+2)
	push	bc
	push	de
	ld	de,0xcccd
	ld	bc,0x42c7
	call	__fsub##
	jp	m,@1596
	jr	z,@1596
	ld	de,0xcccd
	ld	bc,0x42c7
	ld	(_dspTemp),de
	ld	(_dspTemp+2),bc
;5999 
;6000     if (percentFFT > 999)  percentFFT = 999;
@1596:
	.debug	# 6000
	ld	hl,(_percentFFT)
	ld	de,0x3e7
	or	a,a
	sbc	hl,de
	jr	c,@1597
	jr	z,@1597
	ld	h,d
	ld	l,e
	ld	(_percentFFT),hl
;6001     if (percentCTF > 999)  percentCTF = 999;
@1597:
	.debug	# 6001
	ld	hl,(_percentCTF)
	ld	de,0x3e7
	or	a,a
	sbc	hl,de
	jr	c,@1598
	jr	z,@1598
	ld	h,d
	ld	l,e
	ld	(_percentCTF),hl
;6002 
;6003     dspTempInt = (uint) dspTemp;
@1598:
	.debug	# 6003
	ld	de,(_dspTemp)
	ld	bc,(_dspTemp+2)
	call	__ftol##
	ld	(_dspTempInt),de
;6004 
;6005     rfIsOn = BOOL(RF_ON);
	.debug	# 6005
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1599
	ld	a,0x1
	jr	@1600
@1599:
	xor	a,a
@1600:
	ld	(_rfIsOn),a
;6006     rfPulsing = BOOL(RF_PULSES);
	.debug	# 6006
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1601
	ld	a,0x1
	jr	@1602
@1601:
	xor	a,a
@1602:
	ld	(_rfPulsing),a
;6007     tunerPIDisON = BOOL(TUNER_PID_ON);
	.debug	# 6007
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0x20
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1603
	ld	a,0x1
	jr	@1604
@1603:
	xor	a,a
@1604:
	ld	(_tunerPIDisON),a
;6008     curProgNum = (uint) CUR_PROG_NUM;
	.debug	# 6008
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	ld	e,d
	ld	d,c
	ld	c,b
	ld	b,0
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	call	__land##
	ld	(_curProgNum),de
;6009     rfAtWarm = BOOL(RF_OUT_WARM);
	.debug	# 6009
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x1
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1605
	ld	a,0x1
	jr	@1606
@1605:
	xor	a,a
@1606:
	ld	(_rfAtWarm),a
;6010     rfRamping = BOOL(OUT_RAMPING);
	.debug	# 6010
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x2
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1607
	ld	a,0x1
	jr	@1608
@1607:
	xor	a,a
@1608:
	ld	(_rfRamping),a
;6011     afcEnabled = BOOL(AFC_ON);
	.debug	# 6011
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1609
	ld	a,0x1
	jr	@1610
@1609:
	xor	a,a
@1610:
	ld	(_afcEnabled),a
;6012     cavLocked = BOOL(CAV_LOCKED);
	.debug	# 6012
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x8
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1611
	ld	a,0x1
	jr	@1612
@1611:
	xor	a,a
@1612:
	ld	(_cavLocked),a
;6013     amplPIDisON = BOOL(AMPL_PID_ON);
	.debug	# 6013
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x10
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1613
	ld	a,0x1
	jr	@1614
@1613:
	xor	a,a
@1614:
	ld	(_amplPIDisON),a
;6014     phaseMode = (uint) PHASE_MODE;
	.debug	# 6014
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	ld	a,0x15
	call	__ulshr##
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__land##
	ld	(_phaseMode),de
;6015 
;6016   }
@1590:
	.debug	>
;6017 
;6018 
;6019   releaseLockDSP();
@1588:
	.debug	# 6019
	lcall	$releaseLockDSP
;6020 
;6021 
;6022 //tdebug - forced periodic change to pvStrTest for testing interface
;6023   if (TIME() - lastChg >= 5)  {
	.debug	# 6023
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	push	bc
	push	de
	ld	de,(@1512)
	ld	bc,(@1512+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x5
	ld	c,d
	ld	b,d
	call	__lsub##
	jp	c,@1615
;6024     pv = PV_DESC(pvStrTest);
@1616:
	.debug	< @1616 @1617
	.debug	# 6024
	ld	hl,_nonRegPVs
	ld	(ix-16),hl
;6025     farsprintf(pv->val, "..%lu..", TIME());
	.debug	# 6025
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	push	bc
	push	de
	ld	de,word (phys @1+5823)
	ld	c,phys @1+5823 >> 16
	push	bc
	push	de
	ld	hl,(ix-16)
	ld	de,0xd
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,12
;6026     pv->pvInfo.size = pv->pvInfo.elemSize = (uint) fstrlen(pv->val) + 1;
	.debug	# 6026
	ld	hl,(ix-16)
	ld	de,0xd
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	call	_fstrlen
	add	sp,4
	inc	de
	ld	hl,(ix-16)
	ld	bc,de
	ld	de,0x7
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-16)
	ld	e,0x5
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;6027     pv->newEvents |= DBE_VALUE;
	.debug	# 6027
	ld	hl,(ix-16)
	ld	e,0x13
	add	hl,de
	set	0,(hl)
;6028     lastChg = TIME();
	.debug	# 6028
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	(@1512),de
	ld	(@1512+2),bc
;6029   }
@1617:
	.debug	>
;6030 
;6031 
;6032 }
@1615:
@1510:
	.debug	} @1510 6032

@1509	equ	16
	ld	sp,ix
	pop	ix
	lret
@1511	equ	18
;6033 
;6034 
;6035 //=========================================================================
;6036 //  Now we update the values in "next" based on the "cur" and "prev"
;6037 //  values.
;6038 //=========================================================================
;6039 //  All values changed by updateNextState() are "outputs" from this func.
;6040 //  All other values referenced in this function are "inputs" to this func.
;6041 //
;6042 //  All the values in "next" provide information about the next logical sta
;6043 //  for the controller:  Values to be applied during the next pass of the
;6044 //  control logic.  All "next" values fall in to one of 2 categories:
;6045 //
;6046 //    - They are set/updated ONLY by this function (which is executed only
;6047 //      by the "applic" task)
;6048 //
;6049 //    - They are set ONLY by other tasks (within a lock), and possibly
;6050 //      reset/cleared by the "applic" task in updateCurState() (after copyi
;6051 //      "next" to "cur")
;6052 //
;6053 //
;6054 //  All values that act as input to this func must fall in to one of these
;6055 //  categories:
;6056 //
;6057 //    - "prev" values
;6058 //
;6059 //    - "cur" values updated directly by statements in updateCurState()
;6060 //
;6061 //    - "cur" values updated indirectly by updateCurState() due to the copy
;6062 //      of "next" to "cur", which includes the values in "next" that are
;6063 //      set by other tasks
;6064 //
;6065 //    - a shared/global value that is the equivalent of a "cur" value but
;6066 //      for which we don't need to track changes
;6067 //
;6068 //
;6069 //  All "outputs" from this function must be altered ONLY within this funct
;6070 //
;6071 //  All "inputs" to this function must NEVER be altered within this functio
;6072 //
;6073 //  Each output value (or VERY small "set" of ouput values) must be updated
;6074 //  in a single, self-contained block of code.  NO output may be referenced
;6075 //  OR altered in ANOTHER block of code:  This is a declarative style of
;6076 //  programming and has multiple advantages:
;6077 //
;6078 //     - There are no order-of-execution dependencies across nodes/blocks
;6079 //       within a pass.  They can be executed in any order and the result
;6080 //       will be the same (get used to it - this method will be the norm as
;6081 //       computer languages and hardware add support for atomic transaction
;6082 //       and computers evolve in to neural-net-like processor arrays - FPGA
;6083 //       are just the beginning of this trend).
;6084 //
;6085 //     - Encapsulating all logic for an output within a single node/block
;6086 //       leaves just one place to start when tracking a problem backward fr
;6087 //       the result (far simpler than guessing at the possible causes and
;6088 //       trying to work forward, looking for paths to the observed result).
;6089 //
;6090 //     - Drastically reduces the complexity of the code by greatly reducing
;6091 //       the number of possible paths through the code.  This simplifies
;6092 //       testing and verification processes.
;6093 //
;6094 //  Each node/block-of-code should be prefaced with the following informati
;6095 //   - The names of the values it modifies
;6096 //   - A descr of the meaning of the values and the logic used to set them
;6097 //   - A list of the values that serve as "inputs" to the node
;6098 //
;6099 //=========================================================================
;6100 void updateNextState(void)
;6101 {
$updateNextState::
	.debug	G $updateNextState 99 9
	.debug	{ $updateNextState 99 6100 @1620 @1619
;6102   if (current != applTask)  return;
	.debug	# 6102
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
;6103 
;6104 }
@1619:
	.debug	} @1619 6104

@1618	equ	0
	lret
@1620	equ	0
;6105 
;6106 
;6107 //=========================================================================
;6108 //  Next we update output signal values to be written to the outputs at
;6109 //  the beginning of the next pass (just after the inputs are read).
;6110 //=========================================================================
;6111 void updateOutputState(void)
;6112 {
$updateOutputState::
	.debug	G $updateOutputState 99 9
	.debug	{ $updateOutputState 99 6111 @1624 @1623
;6113 //  digitalOut = 0;
;6114 
;6115   if (rfIsOn)
	.debug	# 6115
	ld	a,(_rfIsOn)
	or	a,a
	jr	z,@1625
;6116     SetBits(Next.digitalOut, ON_OFF_LED);
	.debug	# 6116
	ld	de,(_nextState+4)
	ld	bc,(_nextState+6)
	set	3,d
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
;6117   else
;6118     ClearBits(Next.digitalOut, ON_OFF_LED);
	jr	@1626
@1625:
	.debug	# 6118
	ld	de,(_nextState+4)
	ld	bc,(_nextState+6)
	res	3,d
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
;6119 
;6120 //APPLCODE
;6121 
;6122 }
@1626:
@1623:
	.debug	} @1623 6122

@1622	equ	0
	lret
@1624	equ	0
;6123 
;6124 
;6125 //=========================================================================
;6126 // The last thing we do is update values read by other tasks
;6127 //=========================================================================
;6128 // IMPORTANT NOTES and WARNINGS:
;6129 //
;6130 //   To avoid concurrency issues, other tasks need to use locks when readin
;6131 //   values set here.  But be careful to keep such locks short to avoid
;6132 //   delaying the timing of the main application task.  If necessary, split
;6133 //   such code in to sections, getting and releasing the lock(s) in each
;6134 //   section to avoid increasing latency for the main application task.
;6135 //
;6136 //   Values in the "next" instance of the application state fall in to 2
;6137 //   categories:  Inputs and Outputs.
;6138 //
;6139 //   The "next" Outputs are those that may be changed in updateOutputState(
;6140 //   The reset are Inputs, and may be changed by other tasks within a lock.
;6141 //
;6142 //   Since each pass through the application logic starts by setting
;6143 //   cur = next, any "next" values set by other tasks become part of the
;6144 //   "cur" instance used by the rest of the applic logic.  Because the
;6145 //   "applic" task at a higher priority than any other real-time task, the
;6146 //   changes to "next" values by other tasks can ONLY happen between passes
;6147 //   through the applic logic loop.
;6148 //
;6149 //   NOTES:
;6150 //     - Some of these "next" input values values must be initialized in
;6151 //       updateCurState() in order to tell when a value is set by another
;6152 //       task.  For example, if we have a boolean flag that is set when we
;6153 //       get an ON command, then (after its "next" value is copied to "cur"
;6154 //       we have to clear the flag in order to tell if another ON command i
;6155 //       received between passes.
;6156 //
;6157 //     - As with reads to these values, other tasks must use locks when
;6158 //       writing to the "next" input values to insure they are not preempte
;6159 //       by the "applic" task in the middle of a write.
;6160 //
;6161 //=========================================================================
;6162 void updateExternals(void)
;6163 {
$updateExternals::
	.debug	G $updateExternals 99 9
	.debug	{ $updateExternals 99 6162 @1629 @1628
;6164   if (current != applTask)  return;
	.debug	# 6164
	ld	hl,(_applTask)
	ld	de,(_current)
	or	a,a
	sbc	hl,de
	jp	nz,@1628
;6165 
;6166 
;6167   digInBits = Cur.digitalIn;
	.debug	# 6167
	ld	de,(_curState)
	ld	bc,(_curState+2)
	ld	(_digInBits),de
	ld	(_digInBits+2),bc
;6168   digOutBits = Cur.digitalOut;
	.debug	# 6168
	ld	de,(_curState+4)
	ld	bc,(_curState+6)
	ld	(_digOutBits),de
	ld	(_digOutBits+2),bc
;6169 
;6170 //--- set bits in older statusBitsAppl format ---
;6171   statusBitsAppl = statusBitsDSP & 0x0000FFC8L;
	.debug	# 6171
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0xffc8
	ld	bc,0
	call	__land##
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;6172   if (RF_PULSES)  statusBitsAppl |= (OLD_PHASE_PULSES | OLD_AMPL_PULSES);
	.debug	# 6172
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0x10
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1631
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	4,e
	set	5,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;6173   if (AFC_ON)  statusBitsAppl |= OLD_AFC_ON;
@1631:
	.debug	# 6173
	ld	de,(_statusBitsDSP)
	ld	bc,(_statusBitsDSP+2)
	push	bc
	push	de
	ld	de,0
	ld	bc,0x4
	call	__land##
	ld	hl,bc
	or	hl,de
	jr	z,@1632
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	set	2,e
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;6174   statusBitsAppl |= (ulong)statusBitsAFC << 16;
@1632:
	.debug	# 6174
	ld	hl,(_statusBitsAFC)
	ex	de,hl
	ld	b,d
	ld	c,e
	ld	de,0
	push	bc
	push	de
	ld	de,(_statusBitsAppl)
	ld	bc,(_statusBitsAppl+2)
	call	__lor##
	ld	(_statusBitsAppl),de
	ld	(_statusBitsAppl+2),bc
;6175 
;6176 //APPLCODE
;6177 }
@1628:
	.debug	} @1628 6177

@1627	equ	0
	lret
@1629	equ	0
;6178 
;6179 
;6180 //=========================================================================
;6181 _nearcall float readGetRaw(uint ui)  {
	.align	4
$$readGetRaw::
	ex	(sp),iy
$readGetRaw::
	.debug	G $readGetRaw 155 9
	.debug	{ $readGetRaw 155 6181 @1635 @1634
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
;6182   return (ui < NumHdwADC ? anaIn[ui] : 0.0);  }
	.debug	# 6182
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@1636
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_anaIn
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@1634
@1636:
	ld	de,0
	ld	c,e
	ld	b,e
@1634:
	.debug	} @1634 6182

@1633	equ	0
	pop	ix
	lret
@1635	equ	2
;6183 
;6184 _nearcall float readMinRaw(uint ui)  {
	.align	4
$$readMinRaw::
	ex	(sp),iy
$readMinRaw::
	.debug	G $readMinRaw 155 9
	.debug	{ $readMinRaw 155 6184 @1640 @1639
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
;6185   return (ui < NumHdwADC) ? (adcMinRaw(ui) - adcOffset[ui]) * adcGain[ui] :
	.debug	# 6185
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@1641
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMinRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@1639
@1641:
	ld	de,0
	ld	c,e
	ld	b,e
@1639:
	.debug	} @1639 6185

@1638	equ	0
	pop	ix
	lret
@1640	equ	2
;6186 
;6187 _nearcall float readMaxRaw(uint ui)  {
	.align	4
$$readMaxRaw::
	ex	(sp),iy
$readMaxRaw::
	.debug	G $readMaxRaw 155 9
	.debug	{ $readMaxRaw 155 6187 @1645 @1644
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
;6188   return (ui < NumHdwADC) ? (adcMaxRaw(ui) - adcOffset[ui]) * adcGain[ui] :
	.debug	# 6188
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@1646
	ld	hl,(ix+5)
	push	hl
	lcall	$adcMaxRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_adcGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@1644
@1646:
	ld	de,0xcccd
	ld	bc,0x411c
@1644:
	.debug	} @1644 6188

@1643	equ	0
	pop	ix
	lret
@1645	equ	2
;6189 
;6190 _nearcall void readDefaults(uint ui, float *gain, float *offset)  {
	.align	4
$$readDefaults::
	ex	(sp),iy
$readDefaults::
	.debug	G $readDefaults 156 9
	.debug	{ $readDefaults 156 6190 @1650 @1649
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
	.debug	A gain 7 152
	.debug	A offset 9 152
;6191   *gain = 1.0;  *offset = 0.0; }
	.debug	# 6191
	ld	de,0
	ld	bc,0x3f80
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	c,e
	ld	b,e
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@1649:
	.debug	} @1649 6191

@1648	equ	0
	pop	ix
	lret
@1650	equ	2
;6192 
;6193 _nearcall void readCalibPoints(uint ui, float *low, float *high)  {
	.align	4
$$readCalibPoints::
	ex	(sp),iy
$readCalibPoints::
	.debug	G $readCalibPoints 156 9
	.debug	{ $readCalibPoints 156 6193 @1653 @1652
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
	.debug	A low 7 152
	.debug	A high 9 152
;6194   *low = -9.5;  *high = 9.5; }
	.debug	# 6194
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@1652:
	.debug	} @1652 6194

@1651	equ	0
	pop	ix
	lret
@1653	equ	2
;6195 
;6196 _nearcall char *readUnits(uint ui, char *buf)  { return "V"; }
	.align	4
$$readUnits::
	ex	(sp),iy
$readUnits::
	.debug	G $readUnits 157 9
	.debug	{ $readUnits 157 6196 @1656 @1655
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
	.debug	A buf 7 70
	.debug	# 6196
	ld	hl,@2+341
@1655:
	.debug	} @1655 6196

@1654	equ	0
	pop	ix
	lret
@1656	equ	2
;6197 
;6198 
;6199 //=========================================================================
;6200 _nearcall float setGetRaw(uint ui)  {
	.align	4
$$setGetRaw::
	ex	(sp),iy
$setGetRaw::
	.debug	G $setGetRaw 155 9
	.debug	{ $setGetRaw 155 6200 @1659 @1658
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
;6201   return (ui < NumHdwADC ? anaOut[ui] : 0.0);  }
	.debug	# 6201
	ld	hl,(ix+5)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@1660
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	ld	de,_anaOut
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	jr	@1658
@1660:
	ld	de,0
	ld	c,e
	ld	b,e
@1658:
	.debug	} @1658 6201

@1657	equ	0
	pop	ix
	lret
@1659	equ	2
;6202 
;6203 _nearcall float setMinRaw(uint ui)  {
	.align	4
$$setMinRaw::
	ex	(sp),iy
$setMinRaw::
	.debug	G $setMinRaw 155 9
	.debug	{ $setMinRaw 155 6203 @1664 @1663
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
;6204   return (ui < NumHdwDAC) ? (dacMinRaw(ui) - dacOffset[ui]) * dacGain[ui] :
	.debug	# 6204
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@1665
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMinRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@1663
@1665:
	ld	de,0
	ld	c,e
	ld	b,e
@1663:
	.debug	} @1663 6204

@1662	equ	0
	pop	ix
	lret
@1664	equ	2
;6205 
;6206 _nearcall float setMaxRaw(uint ui)  {
	.align	4
$$setMaxRaw::
	ex	(sp),iy
$setMaxRaw::
	.debug	G $setMaxRaw 155 9
	.debug	{ $setMaxRaw 155 6206 @1669 @1668
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
;6207   return (ui < NumHdwDAC) ? (dacMaxRaw(ui) - dacOffset[ui]) * dacGain[ui] :
	.debug	# 6207
	ld	hl,(ix+5)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@1670
	ld	hl,(ix+5)
	push	hl
	lcall	$dacMaxRaw
	pop	hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacOffset
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fsub##
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	push	bc
	push	de
	ld	de,_dacGain
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fmlt##
	jr	@1668
@1670:
	ld	de,0xcccd
	ld	bc,0x411c
@1668:
	.debug	} @1668 6207

@1667	equ	0
	pop	ix
	lret
@1669	equ	2
;6208 
;6209 _nearcall void setDefaults(uint ui, float *gain, float *offset)  {
	.align	4
$$setDefaults::
	ex	(sp),iy
$setDefaults::
	.debug	G $setDefaults 156 9
	.debug	{ $setDefaults 156 6209 @1674 @1673
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
	.debug	A gain 7 152
	.debug	A offset 9 152
;6210   *gain = 1.0;  *offset = 0.0;  }
	.debug	# 6210
	ld	de,0
	ld	bc,0x3f80
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	c,e
	ld	b,e
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@1673:
	.debug	} @1673 6210

@1672	equ	0
	pop	ix
	lret
@1674	equ	2
;6211 
;6212 _nearcall void setCalibPoints(uint ui, float *low, float *high)  {
	.align	4
$$setCalibPoints::
	ex	(sp),iy
$setCalibPoints::
	.debug	G $setCalibPoints 156 9
	.debug	{ $setCalibPoints 156 6212 @1677 @1676
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
	.debug	A low 7 152
	.debug	A high 9 152
;6213   *low = -9.5;  *high = 9.5;  }
	.debug	# 6213
	ld	de,0
	ld	bc,0xc118
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	b,0x41
	ld	hl,(ix+9)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@1676:
	.debug	} @1676 6213

@1675	equ	0
	pop	ix
	lret
@1677	equ	2
;6214 
;6215 _nearcall char *setUnits(uint ui, char *buf)  { return "V"; }
	.align	4
$$setUnits::
	ex	(sp),iy
$setUnits::
	.debug	G $setUnits 157 9
	.debug	{ $setUnits 157 6215 @1680 @1679
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ui 5 7
	.debug	A buf 7 70
	.debug	# 6215
	ld	hl,@2+341
@1679:
	.debug	} @1679 6215

@1678	equ	0
	pop	ix
	lret
@1680	equ	2
;6216 
;6217 
;6218 //=========================================================================
;6219 //  Set default labels for all the I/O signals
;6220 //=========================================================================
;6221 void setDefaultLabels(void)
;6222 {
$setDefaultLabels::
	.debug	G $setDefaultLabels 99 9
	.debug	{ $setDefaultLabels 99 6221 @1683 @1682
;6223   printf("Setting default labels for I/O signals\r\n");
	.debug	# 6223
	ld	de,word (phys @1+5831)
	ld	c,phys @1+5831 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;6224 
;6225 //--- set application-appropriate default labels ---
;6226 //APPLCODE
;6227 
;6228   fstrcpy(dinLabel[0],  "ID0");
	.debug	# 6228
	ld	de,word (phys @1+5872)
	ld	c,phys @1+5872 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel)
	ld	c,phys _dinLabel >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6229   fstrcpy(dinLabel[1],  "ID1");
	.debug	# 6229
	ld	de,word (phys @1+5876)
	ld	c,phys @1+5876 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+24)
	ld	c,phys _dinLabel+24 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6230   fstrcpy(dinLabel[2],  "ID2");
	.debug	# 6230
	ld	de,word (phys @1+5880)
	ld	c,phys @1+5880 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+48)
	ld	c,phys _dinLabel+48 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6231   fstrcpy(dinLabel[3],  "ID3");
	.debug	# 6231
	ld	de,word (phys @1+5884)
	ld	c,phys @1+5884 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+72)
	ld	c,phys _dinLabel+72 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6232 
;6233   fstrcpy(dinLabel[4],  "ID4");
	.debug	# 6233
	ld	de,word (phys @1+5888)
	ld	c,phys @1+5888 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+96)
	ld	c,phys _dinLabel+96 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6234   fstrcpy(dinLabel[5],  "ID5");
	.debug	# 6234
	ld	de,word (phys @1+5892)
	ld	c,phys @1+5892 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+120)
	ld	c,phys _dinLabel+120 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6235   fstrcpy(dinLabel[6],  "ID6");
	.debug	# 6235
	ld	de,word (phys @1+5896)
	ld	c,phys @1+5896 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+144)
	ld	c,phys _dinLabel+144 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6236   fstrcpy(dinLabel[7],  "ID7");
	.debug	# 6236
	ld	de,word (phys @1+5900)
	ld	c,phys @1+5900 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+168)
	ld	c,phys _dinLabel+168 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6237 
;6238   fstrcpy(dinLabel[8],  "DSP_GP1");
	.debug	# 6238
	ld	de,word (phys @1+5904)
	ld	c,phys @1+5904 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+192)
	ld	c,phys _dinLabel+192 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6239   fstrcpy(dinLabel[9],  "DSP_GP2");
	.debug	# 6239
	ld	de,word (phys @1+5912)
	ld	c,phys @1+5912 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+216)
	ld	c,phys _dinLabel+216 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6240   fstrcpy(dinLabel[10],  "unused");
	.debug	# 6240
	ld	de,word (phys @1+5920)
	ld	c,phys @1+5920 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+240)
	ld	c,phys _dinLabel+240 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6241   fstrcpy(dinLabel[11],  "FPGA_DONE");
	.debug	# 6241
	ld	de,word (phys @1+5927)
	ld	c,phys @1+5927 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+264)
	ld	c,phys _dinLabel+264 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6242 
;6243   fstrcpy(dinLabel[12],  "unused");
	.debug	# 6243
	ld	de,word (phys @1+5920)
	ld	c,phys @1+5920 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+288)
	ld	c,phys _dinLabel+288 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6244   fstrcpy(dinLabel[13],  "unused");
	.debug	# 6244
	ld	de,word (phys @1+5920)
	ld	c,phys @1+5920 >> 16
	push	bc
	push	de
	ld	de,word (phys _dinLabel+312)
	ld	c,phys _dinLabel+312 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6245 
;6246 
;6247   fstrcpy(doutLabel[0], "DSP_GP5");
	.debug	# 6247
	ld	de,word (phys @1+5937)
	ld	c,phys @1+5937 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel)
	ld	c,phys _doutLabel >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6248   fstrcpy(doutLabel[1], "DSP_GP6");
	.debug	# 6248
	ld	de,word (phys @1+5945)
	ld	c,phys @1+5945 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+24)
	ld	c,phys _doutLabel+24 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6249   fstrcpy(doutLabel[2], "DSP_GP7");
	.debug	# 6249
	ld	de,word (phys @1+5953)
	ld	c,phys @1+5953 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+48)
	ld	c,phys _doutLabel+48 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6250   fstrcpy(doutLabel[3], "DSP_GP8");
	.debug	# 6250
	ld	de,word (phys @1+5961)
	ld	c,phys @1+5961 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+72)
	ld	c,phys _doutLabel+72 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6251 
;6252   fstrcpy(doutLabel[4], "_DSP_WR_RD");
	.debug	# 6252
	ld	de,word (phys @1+5969)
	ld	c,phys @1+5969 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+96)
	ld	c,phys _doutLabel+96 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6253   fstrcpy(doutLabel[5], "DSP_GP9");
	.debug	# 6253
	ld	de,word (phys @1+5980)
	ld	c,phys @1+5980 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+120)
	ld	c,phys _doutLabel+120 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6254   fstrcpy(doutLabel[6], "DSP_GP10");
	.debug	# 6254
	ld	de,word (phys @1+5988)
	ld	c,phys @1+5988 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+144)
	ld	c,phys _doutLabel+144 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6255   fstrcpy(doutLabel[7], "DSP_GP11");
	.debug	# 6255
	ld	de,word (phys @1+5997)
	ld	c,phys @1+5997 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+168)
	ld	c,phys _doutLabel+168 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6256 
;6257   fstrcpy(doutLabel[8], "_RESET_DSP");
	.debug	# 6257
	ld	de,word (phys @1+6006)
	ld	c,phys @1+6006 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+192)
	ld	c,phys _doutLabel+192 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6258   fstrcpy(doutLabel[9], "ActivityLED");
	.debug	# 6258
	ld	de,word (phys @1+6017)
	ld	c,phys @1+6017 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+216)
	ld	c,phys _doutLabel+216 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6259   fstrcpy(doutLabel[10], "READY_LED");
	.debug	# 6259
	ld	de,word (phys @1+6029)
	ld	c,phys @1+6029 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+240)
	ld	c,phys _doutLabel+240 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6260   fstrcpy(doutLabel[11], "ON_OFF_LED");
	.debug	# 6260
	ld	de,word (phys @1+6039)
	ld	c,phys @1+6039 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+264)
	ld	c,phys _doutLabel+264 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6261 
;6262   fstrcpy(doutLabel[12], "DSP_NMI");
	.debug	# 6262
	ld	de,word (phys @1+6050)
	ld	c,phys @1+6050 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+288)
	ld	c,phys _doutLabel+288 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6263   fstrcpy(doutLabel[13], "unused");
	.debug	# 6263
	ld	de,word (phys @1+5920)
	ld	c,phys @1+5920 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+312)
	ld	c,phys _doutLabel+312 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6264   fstrcpy(doutLabel[14], "FPGA_SPI");
	.debug	# 6264
	ld	de,word (phys @1+6058)
	ld	c,phys @1+6058 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+336)
	ld	c,phys _doutLabel+336 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6265   fstrcpy(doutLabel[15], "_ADC_CS");
	.debug	# 6265
	ld	de,word (phys @1+6067)
	ld	c,phys @1+6067 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+360)
	ld	c,phys _doutLabel+360 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6266 
;6267   fstrcpy(doutLabel[16], "PLL_LE");
	.debug	# 6267
	ld	de,word (phys @1+6075)
	ld	c,phys @1+6075 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+384)
	ld	c,phys _doutLabel+384 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6268   fstrcpy(doutLabel[17], "_EEPROM_CS");
	.debug	# 6268
	ld	de,word (phys @1+6082)
	ld	c,phys @1+6082 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+408)
	ld	c,phys _doutLabel+408 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6269   fstrcpy(doutLabel[18], "--n/a--");
	.debug	# 6269
	ld	de,word (phys @1+6093)
	ld	c,phys @1+6093 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+432)
	ld	c,phys _doutLabel+432 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6270   fstrcpy(doutLabel[19], "FPGA_CL1");
	.debug	# 6270
	ld	de,word (phys @1+6101)
	ld	c,phys @1+6101 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+456)
	ld	c,phys _doutLabel+456 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6271 
;6272   fstrcpy(doutLabel[20], "--n/a--");
	.debug	# 6272
	ld	de,word (phys @1+6093)
	ld	c,phys @1+6093 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+480)
	ld	c,phys _doutLabel+480 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6273   fstrcpy(doutLabel[21], "unused");
	.debug	# 6273
	ld	de,word (phys @1+5920)
	ld	c,phys @1+5920 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+504)
	ld	c,phys _doutLabel+504 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6274   fstrcpy(doutLabel[22], "DSP_GP3");
	.debug	# 6274
	ld	de,word (phys @1+6110)
	ld	c,phys @1+6110 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+528)
	ld	c,phys _doutLabel+528 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6275   fstrcpy(doutLabel[23], "DSP_GP4");
	.debug	# 6275
	ld	de,word (phys @1+6118)
	ld	c,phys @1+6118 >> 16
	push	bc
	push	de
	ld	de,word (phys _doutLabel+552)
	ld	c,phys _doutLabel+552 >> 16
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;6276 
;6277 }
@1682:
	.debug	} @1682 6277

@1681	equ	0
	lret
@1683	equ	0
;6278 
;6279 
;6280 //=========================================================================
;6281 //  This function is called to force software configurable values to defaul
;6282 //  values.
;6283 //=========================================================================
;6284 void setDefaultConfig(void)
;6285 {
$setDefaultConfig::
	.debug	G $setDefaultConfig 99 9
	.debug	{ $setDefaultConfig 99 6284 @1686 @1685
;6286   printf("Setting in-RAM device config to default values\r\n");
	.debug	# 6286
	ld	de,word (phys @1+6126)
	ld	c,phys @1+6126 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;6287 
;6288 //===== set default values for persistent data values =====
;6289 //APPLCODE
;6290 
;6291 //--- default values for application-specific data elements ---
;6292   rf_P = 0.9;   tuner_P = 0.9;
	.debug	# 6292
	ld	de,0x6666
	ld	bc,0x3f66
	ld	(_rf_P),de
	ld	(_rf_P+2),bc
	ld	(_tuner_P),de
	ld	(_tuner_P+2),bc
;6293   rf_I = 0.1;   tuner_I = 0.1;
	.debug	# 6293
	ld	de,0xcccd
	ld	bc,0x3dcc
	ld	(_rf_I),de
	ld	(_rf_I+2),bc
	ld	(_tuner_I),de
	ld	(_tuner_I+2),bc
;6294   rf_D = 0.01;  tuner_D = 0.01;
	.debug	# 6294
	ld	de,0xd70a
	ld	bc,0x3c23
	ld	(_rf_D),de
	ld	(_rf_D+2),bc
	ld	(_tuner_D),de
	ld	(_tuner_D+2),bc
;6295 
;6296   pulseFreq = 10;  trigPos = 128;
	.debug	# 6296
	ld	de,0
	ld	bc,0x4120
	ld	(_pulseFreq),de
	ld	(_pulseFreq+2),bc
	ld	hl,0x80
	ld	(_trigPos),hl
;6297 
;6298   fwdAtten = reflAtten = cavAtten = 0;
	.debug	# 6298
	bool	hl
	ld	l,h
	ld	(_cavAtten),hl
	ld	(_reflAtten),hl
	ld	(_fwdAtten),hl
;6299 
;6300   pulse_ramp = 0;  warmMS = rampMS = 0;
	.debug	# 6300
	ld	c,e
	ld	b,e
	ld	(_pulse_ramp),de
	ld	(_pulse_ramp+2),bc
	ld	(_rampMS),hl
	ld	(_warmMS),hl
;6301 
;6302   pllInitIdx = 1;
	.debug	# 6302
	inc	l
	ld	(_pllInitIdx),hl
;6303 
;6304   ilkRatioGain = maxOutAmplGain = feedFwdGain = maxAmplSet =
;6305   fwdAmplGain = fwdPhaseGain = reflAmplGain = reflPhaseGain =
;6306   cavAmplGain = cavPhaseGain = refAmplGain = refPhaseGain = 1.0;
	.debug	# 6306
	ld	bc,0x3f80
	ld	(_refPhaseGain),de
	ld	(_refPhaseGain+2),bc
	ld	(_refAmplGain),de
	ld	(_refAmplGain+2),bc
	ld	(_cavPhaseGain),de
	ld	(_cavPhaseGain+2),bc
	ld	(_cavAmplGain),de
	ld	(_cavAmplGain+2),bc
	ld	(_reflPhaseGain),de
	ld	(_reflPhaseGain+2),bc
	ld	(_reflAmplGain),de
	ld	(_reflAmplGain+2),bc
	ld	(_fwdPhaseGain),de
	ld	(_fwdPhaseGain+2),bc
	ld	(_fwdAmplGain),de
	ld	(_fwdAmplGain+2),bc
	ld	(_maxAmplSet),de
	ld	(_maxAmplSet+2),bc
	ld	(_feedFwdGain),de
	ld	(_feedFwdGain+2),bc
	ld	(_maxOutAmplGain),de
	ld	(_maxOutAmplGain+2),bc
	ld	(_ilkRatioGain),de
	ld	(_ilkRatioGain+2),bc
;6307 
;6308   ilkRatioOffset = maxOutAmplOffset =
;6309   fwdAmplOffset = fwdPhaseOffset = reflAmplOffset = reflPhaseOffset =
;6310   cavAmplOffset = cavPhaseOffset = refAmplOffset = refPhaseOffset = 0.0;
	.debug	# 6310
	ld	c,e
	ld	b,e
	ld	(_refPhaseOffset),de
	ld	(_refPhaseOffset+2),bc
	ld	(_refAmplOffset),de
	ld	(_refAmplOffset+2),bc
	ld	(_cavPhaseOffset),de
	ld	(_cavPhaseOffset+2),bc
	ld	(_cavAmplOffset),de
	ld	(_cavAmplOffset+2),bc
	ld	(_reflPhaseOffset),de
	ld	(_reflPhaseOffset+2),bc
	ld	(_reflAmplOffset),de
	ld	(_reflAmplOffset+2),bc
	ld	(_fwdPhaseOffset),de
	ld	(_fwdPhaseOffset+2),bc
	ld	(_fwdAmplOffset),de
	ld	(_fwdAmplOffset+2),bc
	ld	(_maxOutAmplOffset),de
	ld	(_maxOutAmplOffset+2),bc
	ld	(_ilkRatioOffset),de
	ld	(_ilkRatioOffset+2),bc
;6311 
;6312   amplSet = pulsedAmplSet = pulsedAmplSet = pulsedPhaseSet = warmLevel =
;6313   feedFwdPhase = 0.0;
	.debug	# 6313
	ld	(_feedFwdPhase),de
	ld	(_feedFwdPhase+2),bc
	ld	(_warmLevel),de
	ld	(_warmLevel+2),bc
	ld	(_pulsedPhaseSet),de
	ld	(_pulsedPhaseSet+2),bc
	ld	(_pulsedAmplSet),de
	ld	(_pulsedAmplSet+2),bc
	ld	(_pulsedAmplSet),de
	ld	(_pulsedAmplSet+2),bc
	ld	(_amplSet),de
	ld	(_amplSet+2),bc
;6314 
;6315   cavHighIlkLevel = fwdHighIlkLevel = 999.0;
	.debug	# 6315
	ld	de,0xc000
	ld	bc,0x4479
	ld	(_fwdHighIlkLevel),de
	ld	(_fwdHighIlkLevel+2),bc
	ld	(_cavHighIlkLevel),de
	ld	(_cavHighIlkLevel+2),bc
;6316 }
@1685:
	.debug	} @1685 6316

@1684	equ	0
	lret
@1686	equ	0
;6317 
;6318 //=========================================================================
;6319 //  This function should be called to prepare for a DSP or ZWorld reset
;6320 //=========================================================================
;6321 void prepForReset(void)
;6322 {
$prepForReset::
	.debug	G $prepForReset 99 9
	.debug	{ $prepForReset 99 6321 @1689 @1688
;6323 //finish  writeSetDSPState(CMD_RF_OFF);
;6324 
;6325 // do something more MB_setDSPState(...)
;6326 }
@1688:
	.debug	} @1688 6326

@1687	equ	0
	lret
@1689	equ	0
;6327 
;6328 //=========================================================================
;6329 //  This function is called by the application loop just before a shutdown.
;6330 //  The appliation must do whatever is necessary for a clean shutdown and
;6331 //  then exit
;6332 //=========================================================================
;6333 void applicShutdown(void)
;6334 {
$applicShutdown::
	.debug	G $applicShutdown 99 9
	.debug	{ $applicShutdown 99 6333 @1692 @1691
;6335   printf("Application prepping for shutdown\r\n");  fflush(stdout);
	.debug	# 6335
	ld	de,word (phys @1+6175)
	ld	c,phys @1+6175 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
;6336 
;6337   prepForReset();
	.debug	# 6337
	lcall	$prepForReset
;6338 
;6339   Exit(0);
	.debug	# 6339
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;6340 }
@1691:
	.debug	} @1691 6340

@1690	equ	0
	lret
@1692	equ	0
;6341 
;6342 //=========================================================================
;6343 //  This is the highest priority task, usually resumed at a regular interva
;6344 //  so that it can do what it needs and sleep again until the start of the
;6345 //  next interval.
;6346 //=========================================================================
;6347 void _task applic(int argc, char **argv)
;6348 {
	.align	4
$$applic::
	ex	(sp),iy
$applic::
	.debug	G $applic 119 9
	.debug	{ $applic 119 6347 @1695 @1694
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-120
	.debug	A argc 5 6
	.debug	A argv 7 120
;6349   #define SharedApplLocals
;6350   #include <sharedAppl.c>
;6351 
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.debug	L idleMS -4 9
	.debug	L secs -8 9
	.debug	L nanoSecs -12 9
	.debug	L terminateTime -16 9
	.debug	L startTime -20 9
	.debug	L u -22 7
	.debug	L ui -24 7
	.debug	L intTime -26 7
	.debug	L idleInterval -28 7
	.debug	L numBytes -30 7
	.debug	L ms -32 7
	.debug	L loopCountdown -34 7
	.debug	L stat -36 6
	.debug	L eventsfd -38 6
	.debug	L argv_ -44 158
	.debug	L sigSet -48 9
	.debug	L reg -50 38
	.debug	I
;6352 //--- add local variable definitions here ---
;6353   int  clockRate;
	.debug	L clockRate -52 6
;6354 //  fd_t  fpgaProgfd;
;6355   LockData  *lock, *endLocks;
	.debug	L lock -54 74
	.debug	L endLocks -56 74
;6356 
;6357   #define SharedApplLocals2
;6358   #include <sharedAppl.c>
;6359 
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.debug	L buf -120 139
	.debug	I
;6360 
;6361 
;6362   #define SharedApplInit
;6363   #include <sharedAppl.c>
;6364 
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.debug	# 866
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_prevState
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_curState
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x2
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_nextState
	push	hl
	call	_memset
	add	sp,6
	.debug	# 868
	bool	hl
	ld	l,h
	ld	(_numScopeRegs),hl
	.debug	# 870
	lcall	$resetWDT
	.debug	# 873
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_ADC_Mask),de
	ld	(_ADC_Mask+2),bc
	ld	(_DAC_Mask),de
	ld	(_DAC_Mask+2),bc
	.debug	# 876
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
@1696:
	.debug	< @1696 @1697
	.debug	# 880
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1698:
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@1699
@1701:
	.debug	< @1701 @1702
	.debug	# 881
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_adcOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_adcGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$adcDefaults
	add	sp,6
	.debug	# 882
	ld	hl,(ix-24)
	add	hl,hl
	ld	de,_lastadcRaw
	add	hl,de
	ld	de,0xbad
	ld	(hl),e
	inc	hl
	ld	(hl),d
	.debug	# 883
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
@1702:
	.debug	>
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1698
@1699:
@1697:
	.debug	>
@1703:
	.debug	< @1703 @1704
	.debug	# 885
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1705:
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@1706
@1708:
	.debug	< @1708 @1709
	.debug	# 886
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_dacOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_dacGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$dacDefaults
	add	sp,6
	.debug	# 887
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
@1709:
	.debug	>
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1705
@1706:
@1704:
	.debug	>
@1710:
	.debug	< @1710 @1711
	.debug	# 889
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1712:
	ld	hl,(ix-24)
	ld	de,(_NumApplAIN)
	or	a,a
	sbc	hl,de
	jr	nc,@1713
@1715:
	.debug	< @1715 @1716
	.debug	# 890
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$readDefaults
	add	sp,6
	.debug	# 891
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_readVal
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	.debug	# 892
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	z,@1718
	jr	nc,@1717
@1718:
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
@1717:
@1716:
	.debug	>
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1712
@1713:
@1711:
	.debug	>
@1719:
	.debug	< @1719 @1720
	.debug	# 894
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1721:
	ld	hl,(ix-24)
	ld	de,(_NumApplAOUT)
	or	a,a
	sbc	hl,de
	jr	nc,@1722
@1724:
	.debug	< @1724 @1725
	.debug	# 895
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setOffset
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setGain
	add	hl,de
	push	hl
	ld	hl,(ix-24)
	push	hl
	lcall	$setDefaults
	add	sp,6
	.debug	# 896
	ld	hl,(ix-24)
	add	hl,hl
	add	hl,hl
	ld	de,_setVal
	add	hl,de
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	.debug	# 897
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	z,@1727
	jr	nc,@1726
@1727:
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
@1726:
@1725:
	.debug	>
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1721
@1722:
@1720:
	.debug	>
	.debug	# 900
	lcall	$setGenericLabels
	.debug	# 904
	ld	de,0x4000
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-46),hl
	ex	de,hl
	ld	(ix-48),hl
	ex	de,hl
	push	hl
	ld	hl,-46+@1693
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$sigprocmask
	add	sp,6
	.debug	# 906
	ld	de,word (phys @1+6211)
	ld	c,phys @1+6211 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	.debug	# 908
	lcall	$initModBusRegs
	.debug	# 910
	ld	hl,0x2f
	ld	(_devType),hl
	.debug	# 915
	ld	hl,_netmask
	push	hl
	ld	hl,@2+343
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ptoh
	add	sp,6
	.debug	# 916
	ld	hl,_gateway
	push	hl
	ld	hl,@2+355
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ptoh
	add	sp,6
	.debug	# 920
	bool	hl
	ld	l,h
	push	hl
	ld	hl,@2+367
	push	hl
	lcall	$mkfifo
	add	sp,4
	.debug	# 921
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x21
	push	hl
	ld	hl,@2+367
	push	hl
	lcall	$open
	add	sp,6
	ld	(ix-38),hl
	.debug	# 924
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastIdleTime),hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_lastIdleMS),de
	ld	(_lastIdleMS+2),bc
	.debug	# 930
	bool	hl
	ld	l,h
	ld	(_ctlLoopTicks),hl
	ld	(_lastCtlLoopTime),hl
	.debug	# 932
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	.debug	# 935
	lcall	$setDefaultLabels
	lcall	$setDefaultConfig
	.debug	# 938
	lcall	$initIOvalues
	.debug	# 953
	ld	de,word (phys _prevLogInfo+116)
	ld	c,phys _prevLogInfo+116 >> 16
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,a
	jr	z,@1728
@1729:
	.debug	< @1729 @1730
	.debug	# 954
	lcall	$restoreApplState
	ld	(ix-36),hl
	.debug	# 955
	bool	hl
	jr	z,@1731
@1732:
	.debug	< @1732 @1733
	.debug	# 957
	ld	hl,(ix-36)
	push	hl
	ld	de,word (phys @1+6236)
	ld	c,phys @1+6236 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	.debug	# 958
	ld	a,(_runningPrimary)
	or	a,a
	jr	z,@1734
	xor	a,a
	ld	(_runBackup),a
@1734:
	.debug	# 959
	ld	hl,0x1
	push	hl
	lcall	$REBOOT
	pop	hl
@1733:
	.debug	>
@1731:
	.debug	# 961
	ld	a,0x1
	ld	(_restoredApplState),a
@1730:
	.debug	>
@1728:
	.debug	# 965
	ld	hl,0x100
	push	hl
	ld	hl,_applBuf
	push	hl
	lcall	$initParamModule
	add	sp,4
	.debug	# 968
	ld	a,(_restoredApplState)
	or	a,a
	jr	nz,@1735
@1736:
	.debug	< @1736 @1737
	.debug	# 969
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_nextState),de
	ld	(_nextState+2),bc
	ld	(_curState),de
	ld	(_curState+2),bc
	ld	(_prevState),de
	ld	(_prevState+2),bc
	.debug	# 970
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
	ld	(_curState+4),de
	ld	(_curState+6),bc
	ld	(_prevState+4),de
	ld	(_prevState+6),bc
@1737:
	.debug	>
@1735:
	.debug	# 974
	bool	hl
	ld	l,h
	push	hl
	lcall	$startNetUp
	pop	de
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
@1738:
	.debug	# 975
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x2710
	ld	bc,0
	call	__lsub##
	jr	nc,@1740
	bool	hl
	ld	l,h
	push	hl
	lcall	$ifpending
	pop	de
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@1740
	.debug	# 976
	lcall	$resetWDT
	jp	@1738
@1740:
	.debug	# 977
	bool	hl
	ld	l,h
	push	hl
	lcall	$ifpending
	pop	de
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	z,@1741
	.debug	# 978
	ld	de,word (phys @1+6295)
	ld	c,phys @1+6295 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jr	@1742
@1741:
	.debug	# 980
	bool	hl
	ld	l,h
	push	hl
	lcall	$showNetState
	pop	hl
@1742:
@1743:
	.debug	< @1743 @1744
	.debug	# 983
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1745:
	ld	hl,(ix-24)
	ld	de,(_NumHdwADC)
	or	a,a
	sbc	hl,de
	jr	nc,@1746
	ld	hl,(ix-24)
	push	hl
	lcall	$newADCCalib
	pop	hl
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1745
@1746:
@1744:
	.debug	>
@1748:
	.debug	< @1748 @1749
	.debug	# 984
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1750:
	ld	hl,(ix-24)
	ld	de,(_NumHdwDAC)
	or	a,a
	sbc	hl,de
	jr	nc,@1751
	ld	hl,(ix-24)
	push	hl
	lcall	$newDACCalib
	pop	hl
	.debug	I
;6365   _EnterCritical_();  SchedMS = 20;  _ExitCritical_();
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1750
@1751:
@1749:
	.debug	>
	.debug	# 6365
	ipset	2
	ld	hl,0x14
	ld	(_SchedMS),hl
	ipres
;6366 
;6367 //--- add application initialization code here ---
;6368 
;6369   autoReadDSP = autoWriteDSP = readWaves = true;  showFiller = false;
	.debug	# 6369
	ld	a,0x1
	ld	(_readWaves),a
	ld	(_autoWriteDSP),a
	ld	(_autoReadDSP),a
	xor	a,a
	ld	(_showFiller),a
;6370 
;6371   rfq_t1_feedback_RegInfo.flags ^= LogChanges;
	.debug	# 6371
	ld	a,(_rfq_t1_feedback_RegInfo+13)
	xor	a,2
	ld	(_rfq_t1_feedback_RegInfo+13),a
;6372   rfq_t2_feedback_RegInfo.flags ^= LogChanges;
	.debug	# 6372
	ld	a,(_rfq_t2_feedback_RegInfo+13)
	xor	a,2
	ld	(_rfq_t2_feedback_RegInfo+13),a
;6373   devStat1_RegInfo.flags ^= LogChanges;
	.debug	# 6373
	ld	a,(_devStat1_RegInfo+13)
	xor	a,2
	ld	(_devStat1_RegInfo+13),a
;6374 
;6375   rfq_t1_output_RegInfo.flags ^= LogChanges;
	.debug	# 6375
	ld	a,(_rfq_t1_output_RegInfo+13)
	xor	a,2
	ld	(_rfq_t1_output_RegInfo+13),a
;6376   rfq_t2_output_RegInfo.flags ^= LogChanges;
	.debug	# 6376
	ld	a,(_rfq_t2_output_RegInfo+13)
	xor	a,2
	ld	(_rfq_t2_output_RegInfo+13),a
;6377   devCtl1_RegInfo.flags ^= LogChanges;
	.debug	# 6377
	ld	a,(_devCtl1_RegInfo+13)
	xor	a,2
	ld	(_devCtl1_RegInfo+13),a
;6378 
;6379   devRdSet1_RegInfo.flags ^= LogChanges;
	.debug	# 6379
	ld	a,(_devRdSet1_RegInfo+13)
	xor	a,2
	ld	(_devRdSet1_RegInfo+13),a
;6380   devRdSet2_RegInfo.flags ^= LogChanges;
	.debug	# 6380
	ld	a,(_devRdSet2_RegInfo+13)
	xor	a,2
	ld	(_devRdSet2_RegInfo+13),a
;6381   devRdCtl1_RegInfo.flags ^= LogChanges;
	.debug	# 6381
	ld	a,(_devRdCtl1_RegInfo+13)
	xor	a,2
	ld	(_devRdCtl1_RegInfo+13),a
;6382 
;6383 
;6384 //--- initialize the locks ---
;6385   endLocks = locks + NUM_LOCKS;
	.debug	# 6385
	ld	hl,_locks+286
	ld	(ix-56),hl
;6386   for (lock=locks; lock<endLocks; ++lock)  {
@1753:
	.debug	< @1753 @1754
	.debug	# 6386
	ld	hl,_locks
	ld	(ix-54),hl
@1755:
	ld	hl,(ix-54)
	ex	de,hl
	ld	hl,(ix-56)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@1756
;6387     lock->count = 0;  lock->owner = 0;
@1758:
	.debug	< @1758 @1759
	.debug	# 6387
	ld	hl,(ix-54)
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-54)
	inc	hl
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;6388     sem_init(&lock->sem, true, 1);
	.debug	# 6388
	ld	hl,0x1
	push	hl
	push	hl
	ld	hl,(ix-54)
	ld	e,0x4
	add	hl,de
	push	hl
	lcall	$sem_init
	add	sp,6
;6389   }
@1759:
	.debug	>
;6390 
;6391 
;6392   dspProgNum = 0;
	ld	hl,(ix-54)
	ld	de,0x1a
	add	hl,de
	ld	(ix-54),hl
	jr	@1755
@1756:
@1754:
	.debug	>
	.debug	# 6392
	bool	hl
	ld	l,h
	ld	(_dspProgNum),hl
;6393 
;6394 
;6395   fpgaInitialized = pulseAmpl = pulsePhase = false;
	.debug	# 6395
	xor	a,a
	ld	(_pulsePhase),a
	ld	(_pulseAmpl),a
	ld	(_fpgaInitialized),a
;6396 
;6397 //--- set defaults for # of data points in each waveform ---
;6398   FBZERO(waveformData);  BZERO(readerRdy);
	.debug	# 6398
	ld	de,0xa000
	ld	c,e
	ld	b,e
	push	bc
	push	de
	push	hl
	ld	de,word (phys _waveformData)
	ld	c,phys _waveformData >> 16
	push	bc
	push	de
	call	_fmemset
	add	sp,10
	ld	hl,0xa
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_readerRdy
	push	hl
	call	_memset
	add	sp,6
;6399   BZERO(dataTimeSecs);  BZERO(dataTimeMS);
	.debug	# 6399
	ld	hl,0x28
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_dataTimeSecs
	push	hl
	call	_memset
	add	sp,6
	ld	hl,0x28
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_dataTimeMS
	push	hl
	call	_memset
	add	sp,6
;6400   for (ui=0; ui<NUM_WAVEFORMS*2; ++ui)  {
@1760:
	.debug	< @1760 @1761
	.debug	# 6400
	bool	hl
	ld	l,h
	ld	(ix-24),hl
@1762:
	ld	hl,(ix-24)
	ld	de,0xa
	or	a,a
	sbc	hl,de
	jr	nc,@1763
;6401     numDataPoints[ui] = MaxDataPoints;
@1765:
	.debug	< @1765 @1766
	.debug	# 6401
	ld	hl,(ix-24)
	add	hl,hl
	ld	de,_numDataPoints
	add	hl,de
	ld	de,0x400
	ld	(hl),e
	inc	hl
	ld	(hl),d
;6402     lastWaveReadTime[ui] = GetMS_();
	.debug	# 6402
	ld	hl,(ix-24)
	add	hl,hl
	ld	de,_lastWaveReadTime
	add	hl,de
	ld	de,(__TimerMilliSeconds+4)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;6403   }
@1766:
	.debug	>
;6404 
;6405 //--- open serial ports for SPI connections ---
;6406   clockRate = CLK_2MHz;
	ld	hl,(ix-24)
	inc	hl
	ld	(ix-24),hl
	jr	@1762
@1763:
@1761:
	.debug	>
	.debug	# 6406
	ld	hl,0x5
	ld	(ix-52),hl
;6407 
;6408   spi1fd = open("/dev/spi1", O_WRONLY, 0660);  spi1Port = NULL;
	.debug	# 6408
	ld	hl,0x1b0
	push	hl
	ld	hl,0x2
	push	hl
	ld	hl,@2+378
	push	hl
	lcall	$open
	add	sp,6
	ld	(_spi1fd),hl
	bool	hl
	ld	l,h
	ld	(_spi1Port),hl
;6409   printf("spi1fd: %d\r\n", spi1fd);
	.debug	# 6409
	ld	hl,(_spi1fd)
	push	hl
	ld	de,word (phys @1+6336)
	ld	c,phys @1+6336 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;6410   if (spi1fd < 0)
	.debug	# 6410
	ld	hl,(_spi1fd)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@1767
;6411     printf("*** Unable to open '/dev/spi1' ***\r\n");
	.debug	# 6411
	ld	de,word (phys @1+6349)
	ld	c,phys @1+6349 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;6412   else  {
	jr	@1768
@1767:
;6413     ioctl(spi1fd, IOC_SET_CLK_RATE, &clockRate);
@1769:
	.debug	< @1769 @1770
	.debug	# 6413
	ld	hl,-52+@1693
	add	hl,sp
	push	hl
	ld	hl,0x44c
	push	hl
	ld	hl,(_spi1fd)
	push	hl
	lcall	$ioctl
	add	sp,6
;6414     spi1Port = _FileFromFD_(spi1fd)->ioDev;
	.debug	# 6414
	ld	hl,(_spi1fd)
	push	hl
	lcall	$_FileFromFD_
	pop	hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	(_spi1Port),de
;6415   }
@1770:
	.debug	>
;6416 
;6417   spi2fd = open("/dev/spi2", O_WRONLY, 0660);  spi2Port = NULL;
@1768:
	.debug	# 6417
	ld	hl,0x1b0
	push	hl
	ld	hl,0x2
	push	hl
	ld	hl,@2+388
	push	hl
	lcall	$open
	add	sp,6
	ld	(_spi2fd),hl
	bool	hl
	ld	l,h
	ld	(_spi2Port),hl
;6418   printf("spi2fd: %d\r\n", spi2fd);
	.debug	# 6418
	ld	hl,(_spi2fd)
	push	hl
	ld	de,word (phys @1+6386)
	ld	c,phys @1+6386 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;6419   if (spi2fd < 0)
	.debug	# 6419
	ld	hl,(_spi2fd)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@1771
;6420     printf("*** Unable to open '/dev/spi2' ***\r\n");
	.debug	# 6420
	ld	de,word (phys @1+6399)
	ld	c,phys @1+6399 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;6421   else  {
	jr	@1772
@1771:
;6422     ioctl(spi2fd, IOC_SET_CLK_RATE, &clockRate);
@1773:
	.debug	< @1773 @1774
	.debug	# 6422
	ld	hl,-52+@1693
	add	hl,sp
	push	hl
	ld	hl,0x44c
	push	hl
	ld	hl,(_spi2fd)
	push	hl
	lcall	$ioctl
	add	sp,6
;6423     spi2Port = _FileFromFD_(spi2fd)->ioDev;
	.debug	# 6423
	ld	hl,(_spi2fd)
	push	hl
	lcall	$_FileFromFD_
	pop	hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	(_spi2Port),de
;6424   }
@1774:
	.debug	>
;6425 
;6426 
;6427 
;6428 
;6429 //--- initialize the ADC's and the PLL ---
;6430   initDefaults();
@1772:
	.debug	# 6430
	lcall	$initDefaults
;6431 
;6432 //--- toggle FPGA SPI bus bit so it reloads from the EEPROM ---
;6433   printf("reloading FPGA from EEPROM...\r\n");
	.debug	# 6433
	ld	de,word (phys @1+6436)
	ld	c,phys @1+6436 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;6434   ClearBits(digitalOut, FPGA_SPI);  WriteDig();
	.debug	# 6434
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	res	6,d
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
@1775:
	.debug	< @1775 @1776
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@1776:
	.debug	>
;6435   SetBits(digitalOut, FPGA_SPI);  WriteDig();
	.debug	# 6435
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	set	6,d
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
@1777:
	.debug	< @1777 @1778
	push	bc
	push	de
	lcall	$WriteDigOutputs
	add	sp,4
@1778:
	.debug	>
;6436 //--- wait for FPGA to load new firmware and release SPI bus ---
;6437   fpgaInitialized = waitFPGA(3000);
	.debug	# 6437
	ld	de,0xbb8
	ld	bc,0
	push	bc
	push	de
	lcall	$waitFPGA
	add	sp,4
	ld	(_fpgaInitialized),a
;6438 
;6439   digitalOut |= _EEPROM_CS;
	.debug	# 6439
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	set	1,c
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
;6440 
;6441 
;6442   #define SharedApplInit2
;6443   #include <sharedAppl.c>
;6444 
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
	.debug	# 993
	lcall	$resetWDT
	.debug	# 996
	ld	hl,0x1
	push	hl
	lcall	$logDigIOChgs
	pop	hl
	.debug	# 999
	ld	hl,@2+398
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	.debug	# 1000
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@1693
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,_inetd
	push	hl
	lcall	$createProc
	add	sp,14
	.debug	# 1002
	ld	hl,@2+404
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	.debug	# 1003
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@1693
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x7
	push	hl
	ld	hl,_configd
	push	hl
	lcall	$createProc
	add	sp,14
	.debug	# 1005
	ld	hl,@2+412
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	.debug	# 1006
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@1693
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0x4
	push	hl
	ld	hl,_backupd
	push	hl
	lcall	$createProc
	add	sp,14
	.debug	# 1008
	ld	hl,@2+420
	ld	(ix-44),hl
	bool	hl
	ld	l,h
	ld	(ix-42),hl
	.debug	# 1009
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-38+@1693
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0xb
	push	hl
	ld	hl,_ca_tcpd
	push	hl
	lcall	$createProc
	add	sp,14
	.debug	# 1012
	ld	hl,0x5dc
	ld	(ix-34),hl
	.debug	# 1014
	lcall	$resetWDT
	.debug	# 1016
	bool	hl
	ld	l,h
	ld	(_applicTicks),hl
	.debug	# 1018
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-26),hl
	bool	hl
	ld	l,h
	ld	(_applLoopTime),hl
	.debug	# 1020
	lcall	$xavail
	push	bc
	push	de
	ld	de,word (phys @1+6468)
	ld	c,phys @1+6468 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
	.debug	# 1035
	ld	a,0x1
	ld	(_startupComplete),a
	.debug	I
;6445 
;6446   lastDSPioTime = GetMS_();
	.debug	# 6446
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastDSPioTime),hl
;6447 
;6448   calcStartTimeCTF = startCTFWaitTime = 0;
	.debug	# 6448
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_startCTFWaitTime),de
	ld	(_startCTFWaitTime+2),bc
	ld	(_calcStartTimeCTF),de
	ld	(_calcStartTimeCTF+2),bc
;6449 
;6450 //  resetDSP();
;6451 
;6452 //===================================================
;6453 //===== start loop that runs once per timer msg =====
;6454 //===================================================
;6455 
;6456 //--- The following loop is run at a periodic interval (normally 100 times 
;6457 //--- per second, or every 10ms).  The application process normally ---
;6458 //--- consists of reading the current state of the digital and analog ---
;6459 //--- inputs, changing the state of the analog and digital outputs to the -
;6460 //--- values computed during the previous pass, then computing new values -
;6461 //--- for the outputs and updating values that outside clients can view ---
;6462 //--- (currently accessable as a set of ModBus registers) ---
;6463 
;6464   SetBits(Next.digitalOut, READY_LED);
	.debug	# 6464
	ld	de,(_nextState+4)
	ld	bc,(_nextState+6)
	set	2,d
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
;6465 
;6466   for (;;)  {
@1779:
	.debug	< @1779 @1780
@1781:
;6467     #define SharedApplLoopStart
;6468     #include <sharedAppl.c>
;6469 
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
@1784:
	.debug	< @1784 @1785
	.debug	# 1046
	ld	hl,(_applicTicks)
	inc	hl
	ld	(_applicTicks),hl
	.debug	# 1052
	ld	hl,(ix-34)
	bool	hl
	jr	z,@1786
	.debug	# 1053
	ld	hl,(ix-34)
	dec	hl
	ld	(ix-34),hl
	bool	hl
	jr	nz,@1787
	xor	a,a
	ld	(_runBackup),a
@1787:
@1786:
	.debug	# 1056
	lcall	$resetWDT
	.debug	# 1058
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	hl,(ix-26)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(_applLoopTime),hl
	.debug	# 1063
	ld	hl,(_current)
	ld	de,0x13
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
	lcall	$schedule
	.debug	# 1069
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-26),hl
	.debug	# 1072
	ipset	2
	ld	a,(_intTicks)
	bool	hl
	ld	l,a
	ld	(_latency),hl
	ipres
	.debug	# 1078
	ld	hl,(_ctlLoopTicks)
	inc	hl
	ld	(_ctlLoopTicks),hl
	.debug	# 1079
	ld	hl,(ix-26)
	ld	de,(_lastCtlLoopTime)
	or	a,a
	sbc	hl,de
	ld	de,0x7d0
	or	a,a
	sbc	hl,de
	jr	c,@1788
@1789:
	.debug	< @1789 @1790
	.debug	# 1080
	ld	hl,(_ctlLoopTicks)
	or	a,a
	rr	hl
	ld	(_ctlLoopTicksPerSec),hl
	.debug	# 1081
	bool	hl
	ld	l,h
	ld	(_ctlLoopTicks),hl
	ld	hl,(ix-26)
	ld	(_lastCtlLoopTime),hl
@1790:
	.debug	>
	.debug	I
;6470   //--- read the current state of the analog and digital Input signals, and
;6471   //--- write the values computed at the end of the last pass ---
;6472     digitalOut = Next.digitalOut;  rwIO();
@1788:
	.debug	# 6472
	ld	de,(_nextState+4)
	ld	bc,(_nextState+6)
	ld	(_digitalOut),de
	ld	(_digitalOut+2),bc
	lcall	$rwIO
;6473 
;6474   //--- limit DSP communication to aprox 20 times per second ---
;6475     if (msSince_(lastDSPioTime) >= 50)  {
	.debug	# 6475
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastDSPioTime)
	or	a,a
	sbc	hl,de
	ld	de,0x32
	or	a,a
	sbc	hl,de
	jr	c,@1791
;6476 
;6477     //--- process next event message (if any) ---
;6478       processMsg(eventsfd, (EventMsg *)buf, sizeof(buf));
@1792:
	.debug	< @1792 @1793
	.debug	# 6478
	ld	hl,0x40
	push	hl
	ld	hl,-118+@1693
	add	hl,sp
	push	hl
	ld	hl,(ix-38)
	push	hl
	lcall	$processMsg
	add	sp,6
;6479 
;6480     //--- update the current state and determine the next state ---
;6481       updateCurState();  updateNextState();
	.debug	# 6481
	lcall	$updateCurState
	lcall	$updateNextState
;6482       updateOutputState();  updateExternals();
	.debug	# 6482
	lcall	$updateOutputState
	lcall	$updateExternals
;6483     }
@1793:
	.debug	>
;6484 
;6485     #define SharedApplLoopEnd
;6486     #include <sharedAppl.c>
	.debug	I 'C:\work\dev\Rabbit_ST\appl\_shared_\sharedAppl.c' 17 3 10 5 12 32
@1791:
	.debug	# 1093
	lcall	$ReadDeviceID
	ld	(_deviceID),de
	ld	(_deviceID+2),bc
	.debug	# 1096
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastIdleTime)
	or	a,a
	sbc	hl,de
	ld	(ix-28),hl
	ld	de,0xbb8
	or	a,a
	sbc	hl,de
	jr	c,@1794
@1795:
	.debug	< @1795 @1796
	.debug	# 1097
	ld	hl,(_idleTask)
	ld	de,0xd3
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.debug	# 1098
	push	bc
	push	de
	ld	de,(_lastIdleMS)
	ld	bc,(_lastIdleMS+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x64
	ld	c,d
	ld	b,d
	call	__ulmlt##
	ld	hl,(ix-28)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__uldiv##
	ld	(_percentIdle),de
	.debug	# 1099
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	(_lastIdleMS),de
	ld	(_lastIdleMS+2),bc
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastIdleTime),hl
@1796:
	.debug	>
@1794:
	.debug	# 1102
	ld	hl,(_devType)
	ld	(_devType_),hl
	.debug	# 1103
	ld	de,(_deviceID)
	ld	bc,(_deviceID+2)
	ld	(_deviceID_),de
	ld	(_deviceID_+2),bc
	.debug	# 1104
ipset 3
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
ipres
	ld	(_upSecs),de
	ld	(_upSecs+2),bc
	.debug	# 1105
	ld	hl,(_percentIdle)
	ld	(_percentIdle_),hl
	.debug	# 1107
	ld	hl,(_timeZone)
	ld	(_timeZone_),hl
	.debug	# 1108
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	ld	(_curTime),de
	ld	(_curTime+2),bc
	.debug	# 1110
	ld	de,(_digitalIn)
	ld	bc,(_digitalIn+2)
	ld	(_digInBits),de
	ld	(_digInBits+2),bc
	.debug	# 1111
	ld	de,(_digitalOut)
	ld	bc,(_digitalOut+2)
	ld	(_digOutBits),de
	ld	(_digOutBits+2),bc
	.debug	# 1113
	ld	hl,-48+@1693
	add	hl,sp
	push	hl
	lcall	$sigpending
	pop	de
	bool	hl
	jp	nz,@1797
	ld	l,0xf
	push	hl
	ld	hl,-46+@1693
	add	hl,sp
	push	hl
	lcall	$sigismember
	add	sp,4
	bool	hl
	jp	z,@1798
	.debug	# 1114
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	or	hl,de
	jp	nz,@1799
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@1799:
@1798:
@1797:
	.debug	# 1116
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	or	hl,de
	jp	z,@1801
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__lsub##
	push	bc
	push	de
	ld	de,0x1f40
	ld	bc,0
	call	__lsub##
	jr	c,@1801
	jr	z,@1801
	lcall	$applicShutdown
@1801:
	.debug	# 1119
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,0x40
	and	hl,de
	jr	z,@1802
	.debug	# 1120
	ld	de,(_nextState+4)
	ld	bc,(_nextState+6)
	res	1,d
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
	jr	@1803
@1802:
	.debug	# 1122
	ld	de,(_nextState+4)
	ld	bc,(_nextState+6)
	set	1,d
	ld	(_nextState+4),de
	ld	(_nextState+6),bc
@1803:
	.debug	# 1126
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	ld	a,e
	or	a,d
	or	a,c
	jp	z,@1804
@1805:
	.debug	< @1805 @1806
	.debug	# 1129
	ipset	2
	.debug	# 1130
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	ld	hl,(_milliTicks)
	ld	(ix-32),hl
	.debug	# 1131
	ipres
	.debug	# 1134
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x4240
	ld	c,0xf
	call	__ulmlt##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	.debug	# 1135
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
	.debug	# 1136
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
@1807:
	.debug	< @1807 @1808
	.debug	# 1138
	bool	hl
	ld	l,h
	ld	(ix-22),hl
	ld	hl,(_scopeList)
	ld	(ix-50),hl
@1809:
	ld	hl,(ix-22)
	ld	de,(_numScopeRegs)
	or	a,a
	sbc	hl,de
	jp	nc,@1810
@1812:
	.debug	< @1812 @1813
	.debug	# 1139
	ld	hl,(ix-50)
	ld	de,0xb
	add	hl,de
	ld	a,(hl)
	bool	hl
	ld	l,a
	add	hl,hl
	ld	(ix-30),hl
	.debug	# 1140
	ld	e,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@1814
	.debug	# 1141
	ld	hl,(ix-50)
	ld	hl,(hl)
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst2##
	jp	@1815
@1814:
	.debug	# 1143
	ld	hl,(ix-50)
	ld	hl,(hl)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__farst4p##
@1815:
	.debug	# 1144
	ld	hl,(ix-30)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,(_capturePtr)
	ld	bc,(_capturePtr+2)
	call	__ladd##
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
@1813:
	.debug	>
	ld	hl,(ix-22)
	inc	hl
	ld	(ix-22),hl
	add	hl,hl
	ld	de,_scopeList
	add	hl,de
	ld	hl,(hl)
	ld	(ix-50),hl
	jp	@1809
@1810:
@1808:
	.debug	>
	.debug	# 1146
	ld	de,(_captureCount)
	ld	bc,(_captureCount+2)
	call	__linc##
	ld	(_captureCount),de
	ld	(_captureCount+2),bc
	.debug	# 1148
	ld	hl,(_captureIdx)
	inc	hl
	ld	(_captureIdx),hl
	ld	de,(_scopeBufSampleSize)
	or	a,a
	sbc	hl,de
	jr	nz,@1816
@1817:
	.debug	< @1817 @1818
	.debug	# 1149
	bool	hl
	ld	l,h
	ld	(_captureIdx),hl
	ld	de,(_scopeBuf)
	ld	bc,(_scopeBuf+2)
	ld	(_capturePtr),de
	ld	(_capturePtr+2),bc
@1818:
	.debug	>
@1816:
@1806:
	.debug	>
@1804:
	.debug	# 1152
	ld	a,0x1
	ld	(_applicReady),a
	.debug	I
;6487   }
@1785:
	.debug	>
;6488 
;6489 }
	jp	@1781
@1780:
	.debug	>
@1694:
	.debug	} @1694 6489

@1693	equ	120
	ld	sp,ix
	pop	ix
	lret
@1695	equ	122
;6490 
;6491 
;6492 //=========================================================================
;6493 
;6494 const CmdInfo far applCmds[] = {
;6495   { "autocal",     autocal,     "calibrate fwd, refl, or cav Atten value" }
	.seg	CONST
_applCmds::
	.dw	word (phys @1+6487)
	.dw	phys @1+6487 >> 16
	.dw	word _autocal
	.dw	word (phys @1+6495)
	.dw	phys @1+6495 >> 16
;6496   { "cmd",         cmd,         "control DSP state" },
	.dw	word (phys @1+6535)
	.dw	phys @1+6535 >> 16
	.dw	word _cmd
	.dw	word (phys @1+6539)
	.dw	phys @1+6539 >> 16
;6497   { "config",      setConfig,   "set the output MUXOUT (values 0-7)" },
	.dw	word (phys @1+6557)
	.dw	phys @1+6557 >> 16
	.dw	word _setConfig
	.dw	word (phys @1+6564)
	.dw	phys @1+6564 >> 16
;6498   { "defaults",    defaults,    "set FPGA params to default values" },
	.dw	word (phys @1+6599)
	.dw	phys @1+6599 >> 16
	.dw	word _defaults
	.dw	word (phys @1+6608)
	.dw	phys @1+6608 >> 16
;6499   { "dspcalib",    dspcalib,    "calibrate gain/offset for DSP/EGU conversi
	.dw	word (phys @1+6642)
	.dw	phys @1+6642 >> 16
	.dw	word _dspcalib
	.dw	word (phys @1+6651)
	.dw	phys @1+6651 >> 16
;6500   { "dspio",       dspio,       "enable/disable normal com with DSP" },
	.dw	word (phys @1+6696)
	.dw	phys @1+6696 >> 16
	.dw	word _dspio
	.dw	word (phys @1+6702)
	.dw	phys @1+6702 >> 16
;6501   { "dspread",     dspRead,     "read values from the DSP" },
	.dw	word (phys @1+6737)
	.dw	phys @1+6737 >> 16
	.dw	word _dspRead
	.dw	word (phys @1+6745)
	.dw	phys @1+6745 >> 16
;6502   { "dspwrite",    dspWrite,    "write a value to the DSP" },
	.dw	word (phys @1+6770)
	.dw	phys @1+6770 >> 16
	.dw	word _dspWrite
	.dw	word (phys @1+6779)
	.dw	phys @1+6779 >> 16
;6503   { "progdsp",     progDSP,     "Load program in to DSP" },
	.dw	word (phys @1+6804)
	.dw	phys @1+6804 >> 16
	.dw	word _progDSP
	.dw	word (phys @1+6812)
	.dw	phys @1+6812 >> 16
;6504   { "restartdsp",  restartDSP,  "Restart DSP and run specified program #" }
	.dw	word (phys @1+6835)
	.dw	phys @1+6835 >> 16
	.dw	word _restartDSP
	.dw	word (phys @1+6846)
	.dw	phys @1+6846 >> 16
;6505   { "read",        selectADC,   "picks ADC to send to DAC output (1-4)" },
	.dw	word (phys @1+6740)
	.dw	phys @1+6740 >> 16
	.dw	word _selectADC
	.dw	word (phys @1+6886)
	.dw	phys @1+6886 >> 16
;6506   { "resetfpga",   resetFPGA,   "Reload the FPGA firmware from EEPROM" },
	.dw	word (phys @1+6924)
	.dw	phys @1+6924 >> 16
	.dw	word _resetFPGA
	.dw	word (phys @1+6934)
	.dw	phys @1+6934 >> 16
;6507   { "setadcreg",   setADCReg,   "set value of an ADC register" },
	.dw	word (phys @1+6971)
	.dw	phys @1+6971 >> 16
	.dw	word _setADCReg
	.dw	word (phys @1+6981)
	.dw	phys @1+6981 >> 16
;6508   { "setfpgafirm", setFPGAfirm, "Update and reload FPGA firmware image" },
	.dw	word (phys @1+7010)
	.dw	phys @1+7010 >> 16
	.dw	word _setFPGAfirm
	.dw	word (phys @1+7022)
	.dw	phys @1+7022 >> 16
;6509   { "setpllreg",   setPLLReg,   "Set value of a PLL register" },
	.dw	word (phys @1+7060)
	.dw	phys @1+7060 >> 16
	.dw	word _setPLLReg
	.dw	word (phys @1+7070)
	.dw	phys @1+7070 >> 16
;6510   { "state",       showState,   "Show state of controller" }
	.dw	word (phys @1+6551)
	.dw	phys @1+6551 >> 16
	.dw	word _showState
	.dw	word (phys @1+7098)
	.dw	phys @1+7098 >> 16
;6511 };
	.debug	G _applCmds 159 8
;6512 
;6513 int const NumApplCmds = ( sizeof(applCmds) / sizeof(CmdInfo) );
_NumApplCmds::
	.dw	0x10
	.debug	G _NumApplCmds 6 0
;6514 
;6515 //-------------------------------------------------------------------------
;6516 #endif
;6517 
;6518 // progdsp 0 /srfs/RFController2.0.bin
;6519 // setfpgafirm /srfs/llrf2.0.bin
	.extern	$time 161
	.extern	_memcpy 162
	.extern	_memset 163
	.extern	_strcmp 164
	.extern	_stricmp 164
	.extern	_strlen 165
	.extern	_strstr 166
	.extern	$fmemcpy 167
	.extern	_fmemset 168
	.extern	_fstrcpy 169
	.extern	_fstrlen 170
	.extern	_strcpyfn 171
	.extern	$clockTicks 172
	.extern	$getShort 173
	.extern	$memCRC16 174
	.extern	$Engineering 175
	.extern	$stdHeader 99
	.extern	$showNetState 176
	.extern	$CheckETX 78
	.extern	$compileTime 177
	.extern	$fwrite_ 178
	.extern	$write_ 179
	.extern	$read_ 179
	.extern	$copyBytes 180
	.extern	$processMsg 181
	.extern	$inet_ptoh 182
	.extern	_clsCmd 183
	.extern	$sigismember 184
	.extern	$sigprocmask 185
	.extern	$sigpending 186
	.extern	_tasks 187
	.extern	_current 72
	.extern	_idleTask 72
	.extern	_applTask 72
	.extern	_SchedMS 7
	.cseg
_schedule:
	pop	iy
	lcall	$$schedule
	.extern	$$schedule
	.extern	$schedule 99
	.extern	__stdio 188
	.extern	$farfprintf 190
	.extern	$farprintf 191
	.extern	$farsprintf 192
	.extern	_srPFDR 3
	.extern	_srPGDR 3
	.extern	__TimerSeconds 9
	.extern	__TimerMilliSeconds 193
	.extern	$xavail 172
	.extern	_abs 194
	.extern	$rand 78
	.extern	_strtod 195
	.extern	$strtol 196
	.extern	$strtoi 197
	.extern	$strtoul 198
	.extern	_updateAIn 183
	.extern	_updateAOut 183
	.extern	_adcGain 199
	.extern	_adcOffset 199
	.extern	_dacGain 199
	.extern	_dacOffset 199
	.extern	_aoutMin 199
	.extern	_aoutMax 199
	.extern	_anaIn 199
	.extern	_anaOut 199
	.extern	_lastAnaOut 199
	.extern	_adcRaw 200
	.extern	_dacRaw 200
	.extern	_lastadcRaw 200
	.extern	_newRdg 183
	.extern	_adcForced 183
	.extern	_dacForced 183
	.extern	_adcForcedVal 199
	.extern	_dacForcedVal 199
	.extern	_NumHdwADC 7
	.extern	_NumHdwDAC 7
	.bseg
_readGain::
	.ds	4
	.debug	G _readGain 201 0
_readOffset::
	.ds	4
	.debug	G _readOffset 201 0
_setGain::
	.ds	4
	.debug	G _setGain 201 0
_setOffset::
	.ds	4
	.debug	G _setOffset 201 0
_readVal::
	.ds	4
	.debug	G _readVal 201 0
_setVal::
	.ds	4
	.debug	G _setVal 201 0
_lastSetVal::
	.ds	4
	.debug	G _lastSetVal 201 0
	.extern	_digitalIn 9
	.extern	_digitalOut 9
	.extern	_forcedDigOutMask 9
	.extern	_forcedDigOutBits 9
	.defseg	FARBSS
	.seg	FARBSS
_ainLabel::
	.ds	24
	.debug	G _ainLabel 202 8
_aoutLabel::
	.ds	24
	.debug	G _aoutLabel 202 8
_dinLabel::
	.ds	336
	.debug	G _dinLabel 203 8
_doutLabel::
	.ds	576
	.debug	G _doutLabel 204 8
_extraInLabel::
	.ds	768
	.debug	G _extraInLabel 205 8
	.extern	$initIOvalues 99
	.extern	$ReadDigInputs 172
	.extern	$WriteDigOutputs 206
	.extern	$ReadDeviceID 172
	.cseg
_newDACCalib:
	pop	iy
	lcall	$$newDACCalib
	.extern	$$newDACCalib
	.extern	$newDACCalib 207
_newADCCalib:
	pop	iy
	lcall	$$newADCCalib
	.extern	$$newADCCalib
	.extern	$newADCCalib 207
	.extern	$writeAnalogOutputs 206
	.extern	$readAnalogInputs 206
	.extern	$updateAvgsADC 99
	.extern	$_FileFromFD_ 208
	.extern	$open 211
	.extern	$close 194
	.extern	$read 212
	.extern	$lseek 213
	.extern	$fflush 214
	.extern	$ioctl 215
	.extern	_KLOCK 99
	.extern	_KUNLOCK 99
	.extern	$resetWDT 99
	.extern	$_activeTaskIdx_ 194
	.extern	_hostName 91
	.bseg
_ctlLoopTicksPerSec::
	.ds	2
	.debug	G _ctlLoopTicksPerSec 7 0
	.extern	_prevLogInfo 216
	.extern	_runBackup 3
	.extern	_runningPrimary 3
	.extern	_doReboot 3
	.extern	_doShutdown 3
	.extern	_diagLog 189
	.extern	_intTicks 3
	.extern	_milliTicks 7
	.extern	_hdwResetTime 9
	.extern	_applicTicks 7
	.extern	_deviceID 9
	.extern	_devType 7
	.extern	_hdwType 7
	.extern	_percentIdle 7
	.extern	_timeZone 6
	.extern	$REBOOT 102
	.extern	$createProc 217
	.extern	$sleepMS 130
	.extern	$msToTicks 130
	.extern	$Gets 218
	.extern	$Exit 176
	.extern	$SetHostName 219
	.extern	$sem_wait_ 220
	.extern	$sem_init 221
	.extern	$sem_post 222
_C0ChanMult::
	.ds	2
	.debug	G _C0ChanMult 7 0
_NumC0Chans::
	.ds	2
	.debug	G _NumC0Chans 7 0
_R3ChanMult::
	.ds	2
	.debug	G _R3ChanMult 7 0
_NumR3Chans::
	.ds	2
	.debug	G _NumR3Chans 7 0
_R4ChanMult::
	.ds	2
	.debug	G _R4ChanMult 7 0
_NumR4Chans::
	.ds	2
	.debug	G _NumR4Chans 7 0
	.extern	$setRegU16 223
	.extern	$setRegU32 224
	.extern	$setRegF32 225
	.extern	_numScopeRegs 7
	.extern	_captureIdx 7
	.extern	_scopeBufSampleSize 7
	.extern	_captureCount 9
	.extern	_scopeList 226
	.extern	_scopeBuf 50
	.extern	_capturePtr 50
	.cseg
_setS16:
	pop	iy
	lcall	$$setS16
	.extern	$$setS16
	.extern	$setS16 90
_setU16:
	pop	iy
	lcall	$$setU16
	.extern	$$setU16
	.extern	$setU16 90
_setS32:
	pop	iy
	lcall	$$setS32
	.extern	$$setS32
	.extern	$setS32 90
_setU32:
	pop	iy
	lcall	$$setU32
	.extern	$$setU32
	.extern	$setU32 90
_setF32:
	pop	iy
	lcall	$$setF32
	.extern	$$setF32
	.extern	$setF32 90
	.extern	$fmtRegVal 227
	.extern	$pvInitLists 78
_modbusTCPd:
	pop	iy
	lcall	$$modbusTCPd
	.extern	$$modbusTCPd
	.extern	$modbusTCPd 119
	.extern	$pvGetInfo 228
	.bseg
_DoNothing::
	.ds	1
	.debug	G _DoNothing 3 0
	.cseg
_setCoil:
	pop	iy
	lcall	$$setCoil
	.extern	$$setCoil
	.extern	$setCoil 229
	.bseg
_dlmVersTime::
	.ds	4
	.debug	G _dlmVersTime 9 0
_dlmVersTime_ChgEventVal::
	.ds	4
	.debug	G _dlmVersTime_ChgEventVal 9 0
_dlmVersTime_MinChg::
	.ds	4
	.debug	G _dlmVersTime_MinChg 9 0
_rtosVersTime::
	.ds	4
	.debug	G _rtosVersTime 9 0
_rtosVersTime_ChgEventVal::
	.ds	4
	.debug	G _rtosVersTime_ChgEventVal 9 0
_rtosVersTime_MinChg::
	.ds	4
	.debug	G _rtosVersTime_MinChg 9 0
_applVersTime::
	.ds	4
	.debug	G _applVersTime 9 0
_applVersTime_ChgEventVal::
	.ds	4
	.debug	G _applVersTime_ChgEventVal 9 0
_applVersTime_MinChg::
	.ds	4
	.debug	G _applVersTime_MinChg 9 0
_devType_::
	.ds	2
	.debug	G _devType_ 5 0
_devType__ChgEventVal::
	.ds	2
	.debug	G _devType__ChgEventVal 5 0
_devType__MinChg::
	.ds	2
	.debug	G _devType__MinChg 5 0
_deviceID_::
	.ds	4
	.debug	G _deviceID_ 9 0
_deviceID__ChgEventVal::
	.ds	4
	.debug	G _deviceID__ChgEventVal 9 0
_deviceID__MinChg::
	.ds	4
	.debug	G _deviceID__MinChg 9 0
_upSecs::
	.ds	4
	.debug	G _upSecs 9 0
_upSecs_ChgEventVal::
	.ds	4
	.debug	G _upSecs_ChgEventVal 9 0
_upSecs_MinChg::
	.ds	4
	.debug	G _upSecs_MinChg 9 0
_percentIdle_::
	.ds	2
	.debug	G _percentIdle_ 5 0
_percentIdle__ChgEventVal::
	.ds	2
	.debug	G _percentIdle__ChgEventVal 5 0
_percentIdle__MinChg::
	.ds	2
	.debug	G _percentIdle__MinChg 5 0
_numChans::
	.ds	2
	.debug	G _numChans 5 0
_numChans_ChgEventVal::
	.ds	2
	.debug	G _numChans_ChgEventVal 5 0
_numChans_MinChg::
	.ds	2
	.debug	G _numChans_MinChg 5 0
_coilChanMult::
	.ds	2
	.debug	G _coilChanMult 5 0
_coilChanMult_ChgEventVal::
	.ds	2
	.debug	G _coilChanMult_ChgEventVal 5 0
_coilChanMult_MinChg::
	.ds	2
	.debug	G _coilChanMult_MinChg 5 0
_reg3ChanMult::
	.ds	2
	.debug	G _reg3ChanMult 5 0
_reg3ChanMult_ChgEventVal::
	.ds	2
	.debug	G _reg3ChanMult_ChgEventVal 5 0
_reg3ChanMult_MinChg::
	.ds	2
	.debug	G _reg3ChanMult_MinChg 5 0
_reg4ChanMult::
	.ds	2
	.debug	G _reg4ChanMult 5 0
_reg4ChanMult_ChgEventVal::
	.ds	2
	.debug	G _reg4ChanMult_ChgEventVal 5 0
_reg4ChanMult_MinChg::
	.ds	2
	.debug	G _reg4ChanMult_MinChg 5 0
_digInBits::
	.ds	4
	.debug	G _digInBits 9 0
_digInBits_ChgEventVal::
	.ds	4
	.debug	G _digInBits_ChgEventVal 9 0
_digInBits_MinChg::
	.ds	4
	.debug	G _digInBits_MinChg 9 0
_statusBitsStdA::
	.ds	2
	.debug	G _statusBitsStdA 5 0
_statusBitsStdA_ChgEventVal::
	.ds	2
	.debug	G _statusBitsStdA_ChgEventVal 5 0
_statusBitsStdA_MinChg::
	.ds	2
	.debug	G _statusBitsStdA_MinChg 5 0
_statusBitsStdB::
	.ds	2
	.debug	G _statusBitsStdB 5 0
_statusBitsStdB_ChgEventVal::
	.ds	2
	.debug	G _statusBitsStdB_ChgEventVal 5 0
_statusBitsStdB_MinChg::
	.ds	2
	.debug	G _statusBitsStdB_MinChg 5 0
_statusBitsAppl::
	.ds	4
	.debug	G _statusBitsAppl 9 0
_statusBitsAppl_ChgEventVal::
	.ds	4
	.debug	G _statusBitsAppl_ChgEventVal 9 0
_statusBitsAppl_MinChg::
	.ds	4
	.debug	G _statusBitsAppl_MinChg 9 0
_fwdAmpl::
	.ds	4
	.debug	G _fwdAmpl 10 0
_fwdAmpl_ChgEventVal::
	.ds	4
	.debug	G _fwdAmpl_ChgEventVal 10 0
_fwdAmpl_MinChg::
	.ds	4
	.debug	G _fwdAmpl_MinChg 10 0
_reflAmpl::
	.ds	4
	.debug	G _reflAmpl 10 0
_reflAmpl_ChgEventVal::
	.ds	4
	.debug	G _reflAmpl_ChgEventVal 10 0
_reflAmpl_MinChg::
	.ds	4
	.debug	G _reflAmpl_MinChg 10 0
_cavAmpl::
	.ds	4
	.debug	G _cavAmpl 10 0
_cavAmpl_ChgEventVal::
	.ds	4
	.debug	G _cavAmpl_ChgEventVal 10 0
_cavAmpl_MinChg::
	.ds	4
	.debug	G _cavAmpl_MinChg 10 0
_refAmpl::
	.ds	4
	.debug	G _refAmpl 10 0
_refAmpl_ChgEventVal::
	.ds	4
	.debug	G _refAmpl_ChgEventVal 10 0
_refAmpl_MinChg::
	.ds	4
	.debug	G _refAmpl_MinChg 10 0
_fwdPhase::
	.ds	4
	.debug	G _fwdPhase 10 0
_fwdPhase_ChgEventVal::
	.ds	4
	.debug	G _fwdPhase_ChgEventVal 10 0
_fwdPhase_MinChg::
	.ds	4
	.debug	G _fwdPhase_MinChg 10 0
_reflPhase::
	.ds	4
	.debug	G _reflPhase 10 0
_reflPhase_ChgEventVal::
	.ds	4
	.debug	G _reflPhase_ChgEventVal 10 0
_reflPhase_MinChg::
	.ds	4
	.debug	G _reflPhase_MinChg 10 0
_cavPhase::
	.ds	4
	.debug	G _cavPhase 10 0
_cavPhase_ChgEventVal::
	.ds	4
	.debug	G _cavPhase_ChgEventVal 10 0
_cavPhase_MinChg::
	.ds	4
	.debug	G _cavPhase_MinChg 10 0
_refPhase::
	.ds	4
	.debug	G _refPhase 10 0
_refPhase_ChgEventVal::
	.ds	4
	.debug	G _refPhase_ChgEventVal 10 0
_refPhase_MinChg::
	.ds	4
	.debug	G _refPhase_MinChg 10 0
_dspLoad::
	.ds	2
	.debug	G _dspLoad 5 0
_dspLoad_ChgEventVal::
	.ds	2
	.debug	G _dspLoad_ChgEventVal 5 0
_dspLoad_MinChg::
	.ds	2
	.debug	G _dspLoad_MinChg 5 0
_dspTempInt::
	.ds	2
	.debug	G _dspTempInt 5 0
_dspTempInt_ChgEventVal::
	.ds	2
	.debug	G _dspTempInt_ChgEventVal 5 0
_dspTempInt_MinChg::
	.ds	2
	.debug	G _dspTempInt_MinChg 5 0
_dspTemp::
	.ds	4
	.debug	G _dspTemp 10 0
_dspTemp_ChgEventVal::
	.ds	4
	.debug	G _dspTemp_ChgEventVal 10 0
_dspTemp_MinChg::
	.ds	4
	.debug	G _dspTemp_MinChg 10 0
_unused_30043::
	.ds	4
	.debug	G _unused_30043 10 0
_unused_30043_ChgEventVal::
	.ds	4
	.debug	G _unused_30043_ChgEventVal 10 0
_unused_30043_MinChg::
	.ds	4
	.debug	G _unused_30043_MinChg 10 0
_unused_30045::
	.ds	4
	.debug	G _unused_30045 10 0
_unused_30045_ChgEventVal::
	.ds	4
	.debug	G _unused_30045_ChgEventVal 10 0
_unused_30045_MinChg::
	.ds	4
	.debug	G _unused_30045_MinChg 10 0
_unused_30047::
	.ds	4
	.debug	G _unused_30047 10 0
_unused_30047_ChgEventVal::
	.ds	4
	.debug	G _unused_30047_ChgEventVal 10 0
_unused_30047_MinChg::
	.ds	4
	.debug	G _unused_30047_MinChg 10 0
_unused_30049::
	.ds	4
	.debug	G _unused_30049 10 0
_unused_30049_ChgEventVal::
	.ds	4
	.debug	G _unused_30049_ChgEventVal 10 0
_unused_30049_MinChg::
	.ds	4
	.debug	G _unused_30049_MinChg 10 0
_unused_30051::
	.ds	4
	.debug	G _unused_30051 10 0
_unused_30051_ChgEventVal::
	.ds	4
	.debug	G _unused_30051_ChgEventVal 10 0
_unused_30051_MinChg::
	.ds	4
	.debug	G _unused_30051_MinChg 10 0
_unused_30053::
	.ds	4
	.debug	G _unused_30053 10 0
_unused_30053_ChgEventVal::
	.ds	4
	.debug	G _unused_30053_ChgEventVal 10 0
_unused_30053_MinChg::
	.ds	4
	.debug	G _unused_30053_MinChg 10 0
_unused_30055::
	.ds	4
	.debug	G _unused_30055 10 0
_unused_30055_ChgEventVal::
	.ds	4
	.debug	G _unused_30055_ChgEventVal 10 0
_unused_30055_MinChg::
	.ds	4
	.debug	G _unused_30055_MinChg 10 0
_unused_30057::
	.ds	4
	.debug	G _unused_30057 10 0
_unused_30057_ChgEventVal::
	.ds	4
	.debug	G _unused_30057_ChgEventVal 10 0
_unused_30057_MinChg::
	.ds	4
	.debug	G _unused_30057_MinChg 10 0
_unused_30059::
	.ds	4
	.debug	G _unused_30059 10 0
_unused_30059_ChgEventVal::
	.ds	4
	.debug	G _unused_30059_ChgEventVal 10 0
_unused_30059_MinChg::
	.ds	4
	.debug	G _unused_30059_MinChg 10 0
_percentCTF::
	.ds	2
	.debug	G _percentCTF 5 0
_percentCTF_ChgEventVal::
	.ds	2
	.debug	G _percentCTF_ChgEventVal 5 0
_percentCTF_MinChg::
	.ds	2
	.debug	G _percentCTF_MinChg 5 0
_percentFFT::
	.ds	2
	.debug	G _percentFFT 5 0
_percentFFT_ChgEventVal::
	.ds	2
	.debug	G _percentFFT_ChgEventVal 5 0
_percentFFT_MinChg::
	.ds	2
	.debug	G _percentFFT_MinChg 5 0
_latency::
	.ds	2
	.debug	G _latency 5 0
_latency_ChgEventVal::
	.ds	2
	.debug	G _latency_ChgEventVal 5 0
_latency_MinChg::
	.ds	2
	.debug	G _latency_MinChg 5 0
_tcpTickTime::
	.ds	2
	.debug	G _tcpTickTime 5 0
_tcpTickTime_ChgEventVal::
	.ds	2
	.debug	G _tcpTickTime_ChgEventVal 5 0
_tcpTickTime_MinChg::
	.ds	2
	.debug	G _tcpTickTime_MinChg 5 0
_applLoopTime::
	.ds	2
	.debug	G _applLoopTime 5 0
_applLoopTime_ChgEventVal::
	.ds	2
	.debug	G _applLoopTime_ChgEventVal 5 0
_applLoopTime_MinChg::
	.ds	2
	.debug	G _applLoopTime_MinChg 5 0
_maxFwdAmpl::
	.ds	4
	.debug	G _maxFwdAmpl 10 0
_maxFwdAmpl_ChgEventVal::
	.ds	4
	.debug	G _maxFwdAmpl_ChgEventVal 10 0
_maxFwdAmpl_MinChg::
	.ds	4
	.debug	G _maxFwdAmpl_MinChg 10 0
_maxReflAmpl::
	.ds	4
	.debug	G _maxReflAmpl 10 0
_maxReflAmpl_ChgEventVal::
	.ds	4
	.debug	G _maxReflAmpl_ChgEventVal 10 0
_maxReflAmpl_MinChg::
	.ds	4
	.debug	G _maxReflAmpl_MinChg 10 0
_maxCavAmpl::
	.ds	4
	.debug	G _maxCavAmpl 10 0
_maxCavAmpl_ChgEventVal::
	.ds	4
	.debug	G _maxCavAmpl_ChgEventVal 10 0
_maxCavAmpl_MinChg::
	.ds	4
	.debug	G _maxCavAmpl_MinChg 10 0
_maxOutAmpl::
	.ds	4
	.debug	G _maxOutAmpl 10 0
_maxOutAmpl_ChgEventVal::
	.ds	4
	.debug	G _maxOutAmpl_ChgEventVal 10 0
_maxOutAmpl_MinChg::
	.ds	4
	.debug	G _maxOutAmpl_MinChg 10 0
_statusBitsDSP::
	.ds	4
	.debug	G _statusBitsDSP 9 0
_statusBitsDSP_ChgEventVal::
	.ds	4
	.debug	G _statusBitsDSP_ChgEventVal 9 0
_statusBitsDSP_MinChg::
	.ds	4
	.debug	G _statusBitsDSP_MinChg 9 0
_statusBitsAFC::
	.ds	2
	.debug	G _statusBitsAFC 5 0
_statusBitsAFC_ChgEventVal::
	.ds	2
	.debug	G _statusBitsAFC_ChgEventVal 5 0
_statusBitsAFC_MinChg::
	.ds	2
	.debug	G _statusBitsAFC_MinChg 5 0
_writeStatus::
	.ds	2
	.debug	G _writeStatus 5 0
_writeStatus_ChgEventVal::
	.ds	2
	.debug	G _writeStatus_ChgEventVal 5 0
_writeStatus_MinChg::
	.ds	2
	.debug	G _writeStatus_MinChg 5 0
_sizeCTF::
	.ds	2
	.debug	G _sizeCTF 5 0
_sizeCTF_ChgEventVal::
	.ds	2
	.debug	G _sizeCTF_ChgEventVal 5 0
_sizeCTF_MinChg::
	.ds	2
	.debug	G _sizeCTF_MinChg 5 0
_sizeFFT::
	.ds	2
	.debug	G _sizeFFT 5 0
_sizeFFT_ChgEventVal::
	.ds	2
	.debug	G _sizeFFT_ChgEventVal 5 0
_sizeFFT_MinChg::
	.ds	2
	.debug	G _sizeFFT_MinChg 5 0
_romProgErrs::
	.ds	2
	.debug	G _romProgErrs 5 0
_romProgErrs_ChgEventVal::
	.ds	2
	.debug	G _romProgErrs_ChgEventVal 5 0
_romProgErrs_MinChg::
	.ds	2
	.debug	G _romProgErrs_MinChg 5 0
_piezoReadPos::
	.ds	2
	.debug	G _piezoReadPos 4 0
_piezoReadPos_ChgEventVal::
	.ds	2
	.debug	G _piezoReadPos_ChgEventVal 4 0
_piezoReadPos_MinChg::
	.ds	2
	.debug	G _piezoReadPos_MinChg 4 0
_unused_30082::
	.ds	2
	.debug	G _unused_30082 4 0
_unused_30082_ChgEventVal::
	.ds	2
	.debug	G _unused_30082_ChgEventVal 4 0
_unused_30082_MinChg::
	.ds	2
	.debug	G _unused_30082_MinChg 4 0
_kernelLoopTime::
	.ds	2
	.debug	G _kernelLoopTime 5 0
_kernelLoopTime_ChgEventVal::
	.ds	2
	.debug	G _kernelLoopTime_ChgEventVal 5 0
_kernelLoopTime_MinChg::
	.ds	2
	.debug	G _kernelLoopTime_MinChg 5 0
_stepperReadPos::
	.ds	4
	.debug	G _stepperReadPos 8 0
_stepperReadPos_ChgEventVal::
	.ds	4
	.debug	G _stepperReadPos_ChgEventVal 8 0
_stepperReadPos_MinChg::
	.ds	4
	.debug	G _stepperReadPos_MinChg 8 0
_timeZone_::
	.ds	2
	.debug	G _timeZone_ 4 0
_timeZone__ChgEventVal::
	.ds	2
	.debug	G _timeZone__ChgEventVal 4 0
_timeZone__MinChg::
	.ds	2
	.debug	G _timeZone__MinChg 4 0
	.cseg
_MB_timeZone:
	pop	iy
	lcall	$$MB_timeZone
	.bseg
_curTime::
	.ds	4
	.debug	G _curTime 9 0
_curTime_ChgEventVal::
	.ds	4
	.debug	G _curTime_ChgEventVal 9 0
_curTime_MinChg::
	.ds	4
	.debug	G _curTime_MinChg 9 0
_ipAddr::
	.ds	4
	.debug	G _ipAddr 9 0
_ipAddr_ChgEventVal::
	.ds	4
	.debug	G _ipAddr_ChgEventVal 9 0
_ipAddr_MinChg::
	.ds	4
	.debug	G _ipAddr_MinChg 9 0
_netmask::
	.ds	4
	.debug	G _netmask 9 0
_netmask_ChgEventVal::
	.ds	4
	.debug	G _netmask_ChgEventVal 9 0
_netmask_MinChg::
	.ds	4
	.debug	G _netmask_MinChg 9 0
_gateway::
	.ds	4
	.debug	G _gateway 9 0
_gateway_ChgEventVal::
	.ds	4
	.debug	G _gateway_ChgEventVal 9 0
_gateway_MinChg::
	.ds	4
	.debug	G _gateway_MinChg 9 0
_setACoil::
	.ds	2
	.debug	G _setACoil 230 0
_setACoil_ChgEventVal::
	.ds	2
	.debug	G _setACoil_ChgEventVal 230 0
_setACoil_MinChg::
	.ds	2
	.debug	G _setACoil_MinChg 230 0
_resetACoil::
	.ds	2
	.debug	G _resetACoil 230 0
_resetACoil_ChgEventVal::
	.ds	2
	.debug	G _resetACoil_ChgEventVal 230 0
_resetACoil_MinChg::
	.ds	2
	.debug	G _resetACoil_MinChg 230 0
_digOutBits::
	.ds	4
	.debug	G _digOutBits 9 0
_digOutBits_ChgEventVal::
	.ds	4
	.debug	G _digOutBits_ChgEventVal 9 0
_digOutBits_MinChg::
	.ds	4
	.debug	G _digOutBits_MinChg 9 0
_cmdBitsStd::
	.ds	4
	.debug	G _cmdBitsStd 9 0
_cmdBitsStd_ChgEventVal::
	.ds	4
	.debug	G _cmdBitsStd_ChgEventVal 9 0
_cmdBitsStd_MinChg::
	.ds	4
	.debug	G _cmdBitsStd_MinChg 9 0
	.cseg
_MB_cmdBitsStd:
	pop	iy
	lcall	$$MB_cmdBitsStd
	.bseg
_cmdBitsAppl::
	.ds	4
	.debug	G _cmdBitsAppl 9 0
_cmdBitsAppl_ChgEventVal::
	.ds	4
	.debug	G _cmdBitsAppl_ChgEventVal 9 0
_cmdBitsAppl_MinChg::
	.ds	4
	.debug	G _cmdBitsAppl_MinChg 9 0
	.cseg
_MB_cmdBitsAppl:
	pop	iy
	lcall	$$MB_cmdBitsAppl
	.bseg
_setAtten::
	.ds	2
	.debug	G _setAtten 5 0
_setAtten_ChgEventVal::
	.ds	2
	.debug	G _setAtten_ChgEventVal 5 0
_setAtten_MinChg::
	.ds	2
	.debug	G _setAtten_MinChg 5 0
	.cseg
_MB_setAtten:
	pop	iy
	lcall	$$MB_setAtten
	.bseg
_trigPos::
	.ds	2
	.debug	G _trigPos 5 0
_trigPos_ChgEventVal::
	.ds	2
	.debug	G _trigPos_ChgEventVal 5 0
_trigPos_MinChg::
	.ds	2
	.debug	G _trigPos_MinChg 5 0
	.cseg
_MB_DSP_REG:
	pop	iy
	lcall	$$MB_DSP_REG
	.bseg
_cmdBitsAppl3::
	.ds	2
	.debug	G _cmdBitsAppl3 5 0
_cmdBitsAppl3_ChgEventVal::
	.ds	2
	.debug	G _cmdBitsAppl3_ChgEventVal 5 0
_cmdBitsAppl3_MinChg::
	.ds	2
	.debug	G _cmdBitsAppl3_MinChg 5 0
	.cseg
_MB_cmdBitsAppl3:
	pop	iy
	lcall	$$MB_cmdBitsAppl3
	.bseg
_phaseSet::
	.ds	4
	.debug	G _phaseSet 10 0
_phaseSet_ChgEventVal::
	.ds	4
	.debug	G _phaseSet_ChgEventVal 10 0
_phaseSet_MinChg::
	.ds	4
	.debug	G _phaseSet_MinChg 10 0
_amplSet::
	.ds	4
	.debug	G _amplSet 10 0
_amplSet_ChgEventVal::
	.ds	4
	.debug	G _amplSet_ChgEventVal 10 0
_amplSet_MinChg::
	.ds	4
	.debug	G _amplSet_MinChg 10 0
	.cseg
_MB_maxAmpl:
	pop	iy
	lcall	$$MB_maxAmpl
	.bseg
_oldPulseFreq::
	.ds	2
	.debug	G _oldPulseFreq 5 0
_oldPulseFreq_ChgEventVal::
	.ds	2
	.debug	G _oldPulseFreq_ChgEventVal 5 0
_oldPulseFreq_MinChg::
	.ds	2
	.debug	G _oldPulseFreq_MinChg 5 0
	.cseg
_MB_oldPulseFreq:
	pop	iy
	lcall	$$MB_oldPulseFreq
	.bseg
_rf_P::
	.ds	4
	.debug	G _rf_P 10 0
_rf_P_ChgEventVal::
	.ds	4
	.debug	G _rf_P_ChgEventVal 10 0
_rf_P_MinChg::
	.ds	4
	.debug	G _rf_P_MinChg 10 0
_rf_I::
	.ds	4
	.debug	G _rf_I 10 0
_rf_I_ChgEventVal::
	.ds	4
	.debug	G _rf_I_ChgEventVal 10 0
_rf_I_MinChg::
	.ds	4
	.debug	G _rf_I_MinChg 10 0
_rf_D::
	.ds	4
	.debug	G _rf_D 10 0
_rf_D_ChgEventVal::
	.ds	4
	.debug	G _rf_D_ChgEventVal 10 0
_rf_D_MinChg::
	.ds	4
	.debug	G _rf_D_MinChg 10 0
_unusedreg2::
	.ds	4
	.debug	G _unusedreg2 10 0
_unusedreg2_ChgEventVal::
	.ds	4
	.debug	G _unusedreg2_ChgEventVal 10 0
_unusedreg2_MinChg::
	.ds	4
	.debug	G _unusedreg2_MinChg 10 0
_pulsedAmplSet::
	.ds	4
	.debug	G _pulsedAmplSet 10 0
_pulsedAmplSet_ChgEventVal::
	.ds	4
	.debug	G _pulsedAmplSet_ChgEventVal 10 0
_pulsedAmplSet_MinChg::
	.ds	4
	.debug	G _pulsedAmplSet_MinChg 10 0
_tuner_P::
	.ds	4
	.debug	G _tuner_P 10 0
_tuner_P_ChgEventVal::
	.ds	4
	.debug	G _tuner_P_ChgEventVal 10 0
_tuner_P_MinChg::
	.ds	4
	.debug	G _tuner_P_MinChg 10 0
_tuner_I::
	.ds	4
	.debug	G _tuner_I 10 0
_tuner_I_ChgEventVal::
	.ds	4
	.debug	G _tuner_I_ChgEventVal 10 0
_tuner_I_MinChg::
	.ds	4
	.debug	G _tuner_I_MinChg 10 0
_tuner_D::
	.ds	4
	.debug	G _tuner_D 10 0
_tuner_D_ChgEventVal::
	.ds	4
	.debug	G _tuner_D_ChgEventVal 10 0
_tuner_D_MinChg::
	.ds	4
	.debug	G _tuner_D_MinChg 10 0
_unusedreg3::
	.ds	4
	.debug	G _unusedreg3 10 0
_unusedreg3_ChgEventVal::
	.ds	4
	.debug	G _unusedreg3_ChgEventVal 10 0
_unusedreg3_MinChg::
	.ds	4
	.debug	G _unusedreg3_MinChg 10 0
_pulsedPhaseSet::
	.ds	4
	.debug	G _pulsedPhaseSet 10 0
_pulsedPhaseSet_ChgEventVal::
	.ds	4
	.debug	G _pulsedPhaseSet_ChgEventVal 10 0
_pulsedPhaseSet_MinChg::
	.ds	4
	.debug	G _pulsedPhaseSet_MinChg 10 0
_setAFCsOnOff::
	.ds	4
	.debug	G _setAFCsOnOff 9 0
_setAFCsOnOff_ChgEventVal::
	.ds	4
	.debug	G _setAFCsOnOff_ChgEventVal 9 0
_setAFCsOnOff_MinChg::
	.ds	4
	.debug	G _setAFCsOnOff_MinChg 9 0
	.cseg
_MB_setAFCsOnOff:
	pop	iy
	lcall	$$MB_setAFCsOnOff
	.bseg
_afcFreq0::
	.ds	4
	.debug	G _afcFreq0 10 0
_afcFreq0_ChgEventVal::
	.ds	4
	.debug	G _afcFreq0_ChgEventVal 10 0
_afcFreq0_MinChg::
	.ds	4
	.debug	G _afcFreq0_MinChg 10 0
_afcFreq1::
	.ds	4
	.debug	G _afcFreq1 10 0
_afcFreq1_ChgEventVal::
	.ds	4
	.debug	G _afcFreq1_ChgEventVal 10 0
_afcFreq1_MinChg::
	.ds	4
	.debug	G _afcFreq1_MinChg 10 0
_afcFreq2::
	.ds	4
	.debug	G _afcFreq2 10 0
_afcFreq2_ChgEventVal::
	.ds	4
	.debug	G _afcFreq2_ChgEventVal 10 0
_afcFreq2_MinChg::
	.ds	4
	.debug	G _afcFreq2_MinChg 10 0
_afcFreq3::
	.ds	4
	.debug	G _afcFreq3 10 0
_afcFreq3_ChgEventVal::
	.ds	4
	.debug	G _afcFreq3_ChgEventVal 10 0
_afcFreq3_MinChg::
	.ds	4
	.debug	G _afcFreq3_MinChg 10 0
_afcFreq4::
	.ds	4
	.debug	G _afcFreq4 10 0
_afcFreq4_ChgEventVal::
	.ds	4
	.debug	G _afcFreq4_ChgEventVal 10 0
_afcFreq4_MinChg::
	.ds	4
	.debug	G _afcFreq4_MinChg 10 0
_afcFreq5::
	.ds	4
	.debug	G _afcFreq5 10 0
_afcFreq5_ChgEventVal::
	.ds	4
	.debug	G _afcFreq5_ChgEventVal 10 0
_afcFreq5_MinChg::
	.ds	4
	.debug	G _afcFreq5_MinChg 10 0
_afcFreq6::
	.ds	4
	.debug	G _afcFreq6 10 0
_afcFreq6_ChgEventVal::
	.ds	4
	.debug	G _afcFreq6_ChgEventVal 10 0
_afcFreq6_MinChg::
	.ds	4
	.debug	G _afcFreq6_MinChg 10 0
_afcFreq7::
	.ds	4
	.debug	G _afcFreq7 10 0
_afcFreq7_ChgEventVal::
	.ds	4
	.debug	G _afcFreq7_ChgEventVal 10 0
_afcFreq7_MinChg::
	.ds	4
	.debug	G _afcFreq7_MinChg 10 0
_afcFreq8::
	.ds	4
	.debug	G _afcFreq8 10 0
_afcFreq8_ChgEventVal::
	.ds	4
	.debug	G _afcFreq8_ChgEventVal 10 0
_afcFreq8_MinChg::
	.ds	4
	.debug	G _afcFreq8_MinChg 10 0
_afcFreq9::
	.ds	4
	.debug	G _afcFreq9 10 0
_afcFreq9_ChgEventVal::
	.ds	4
	.debug	G _afcFreq9_ChgEventVal 10 0
_afcFreq9_MinChg::
	.ds	4
	.debug	G _afcFreq9_MinChg 10 0
_warmLevel::
	.ds	4
	.debug	G _warmLevel 10 0
_warmLevel_ChgEventVal::
	.ds	4
	.debug	G _warmLevel_ChgEventVal 10 0
_warmLevel_MinChg::
	.ds	4
	.debug	G _warmLevel_MinChg 10 0
_warmMS::
	.ds	2
	.debug	G _warmMS 5 0
_warmMS_ChgEventVal::
	.ds	2
	.debug	G _warmMS_ChgEventVal 5 0
_warmMS_MinChg::
	.ds	2
	.debug	G _warmMS_MinChg 5 0
_rampMS::
	.ds	2
	.debug	G _rampMS 5 0
_rampMS_ChgEventVal::
	.ds	2
	.debug	G _rampMS_ChgEventVal 5 0
_rampMS_MinChg::
	.ds	2
	.debug	G _rampMS_MinChg 5 0
_dspComErrors::
	.ds	2
	.debug	G _dspComErrors 5 0
_dspComErrors_ChgEventVal::
	.ds	2
	.debug	G _dspComErrors_ChgEventVal 5 0
_dspComErrors_MinChg::
	.ds	2
	.debug	G _dspComErrors_MinChg 5 0
_dspProgNum::
	.ds	2
	.debug	G _dspProgNum 5 0
_dspProgNum_ChgEventVal::
	.ds	2
	.debug	G _dspProgNum_ChgEventVal 5 0
_dspProgNum_MinChg::
	.ds	2
	.debug	G _dspProgNum_MinChg 5 0
	.cseg
_MB_dspProgNum:
	pop	iy
	lcall	$$MB_dspProgNum
	.bseg
_pllInitIdx::
	.ds	2
	.debug	G _pllInitIdx 5 0
_pllInitIdx_ChgEventVal::
	.ds	2
	.debug	G _pllInitIdx_ChgEventVal 5 0
_pllInitIdx_MinChg::
	.ds	2
	.debug	G _pllInitIdx_MinChg 5 0
_rfq_t1_feedback::
	.ds	4
	.debug	G _rfq_t1_feedback 10 0
_rfq_t1_feedback_ChgEventVal::
	.ds	4
	.debug	G _rfq_t1_feedback_ChgEventVal 10 0
_rfq_t1_feedback_MinChg::
	.ds	4
	.debug	G _rfq_t1_feedback_MinChg 10 0
_rfq_t2_feedback::
	.ds	4
	.debug	G _rfq_t2_feedback 10 0
_rfq_t2_feedback_ChgEventVal::
	.ds	4
	.debug	G _rfq_t2_feedback_ChgEventVal 10 0
_rfq_t2_feedback_MinChg::
	.ds	4
	.debug	G _rfq_t2_feedback_MinChg 10 0
_devStat1::
	.ds	2
	.debug	G _devStat1 5 0
_devStat1_ChgEventVal::
	.ds	2
	.debug	G _devStat1_ChgEventVal 5 0
_devStat1_MinChg::
	.ds	2
	.debug	G _devStat1_MinChg 5 0
_rfq_t1_output::
	.ds	4
	.debug	G _rfq_t1_output 10 0
_rfq_t1_output_ChgEventVal::
	.ds	4
	.debug	G _rfq_t1_output_ChgEventVal 10 0
_rfq_t1_output_MinChg::
	.ds	4
	.debug	G _rfq_t1_output_MinChg 10 0
_rfq_t2_output::
	.ds	4
	.debug	G _rfq_t2_output 10 0
_rfq_t2_output_ChgEventVal::
	.ds	4
	.debug	G _rfq_t2_output_ChgEventVal 10 0
_rfq_t2_output_MinChg::
	.ds	4
	.debug	G _rfq_t2_output_MinChg 10 0
_devCtl1::
	.ds	2
	.debug	G _devCtl1 5 0
_devCtl1_ChgEventVal::
	.ds	2
	.debug	G _devCtl1_ChgEventVal 5 0
_devCtl1_MinChg::
	.ds	2
	.debug	G _devCtl1_MinChg 5 0
_devRdSet1::
	.ds	4
	.debug	G _devRdSet1 10 0
_devRdSet1_ChgEventVal::
	.ds	4
	.debug	G _devRdSet1_ChgEventVal 10 0
_devRdSet1_MinChg::
	.ds	4
	.debug	G _devRdSet1_MinChg 10 0
_devRdSet2::
	.ds	4
	.debug	G _devRdSet2 10 0
_devRdSet2_ChgEventVal::
	.ds	4
	.debug	G _devRdSet2_ChgEventVal 10 0
_devRdSet2_MinChg::
	.ds	4
	.debug	G _devRdSet2_MinChg 10 0
_devRdCtl1::
	.ds	2
	.debug	G _devRdCtl1 5 0
_devRdCtl1_ChgEventVal::
	.ds	2
	.debug	G _devRdCtl1_ChgEventVal 5 0
_devRdCtl1_MinChg::
	.ds	2
	.debug	G _devRdCtl1_MinChg 5 0
_piezoSetPos::
	.ds	2
	.debug	G _piezoSetPos 4 0
_piezoSetPos_ChgEventVal::
	.ds	2
	.debug	G _piezoSetPos_ChgEventVal 4 0
_piezoSetPos_MinChg::
	.ds	2
	.debug	G _piezoSetPos_MinChg 4 0
_unused_40091::
	.ds	2
	.debug	G _unused_40091 4 0
_unused_40091_ChgEventVal::
	.ds	2
	.debug	G _unused_40091_ChgEventVal 4 0
_unused_40091_MinChg::
	.ds	2
	.debug	G _unused_40091_MinChg 4 0
_fwdAtten::
	.ds	2
	.debug	G _fwdAtten 5 0
_fwdAtten_ChgEventVal::
	.ds	2
	.debug	G _fwdAtten_ChgEventVal 5 0
_fwdAtten_MinChg::
	.ds	2
	.debug	G _fwdAtten_MinChg 5 0
_reflAtten::
	.ds	2
	.debug	G _reflAtten 5 0
_reflAtten_ChgEventVal::
	.ds	2
	.debug	G _reflAtten_ChgEventVal 5 0
_reflAtten_MinChg::
	.ds	2
	.debug	G _reflAtten_MinChg 5 0
_cavAtten::
	.ds	2
	.debug	G _cavAtten 5 0
_cavAtten_ChgEventVal::
	.ds	2
	.debug	G _cavAtten_ChgEventVal 5 0
_cavAtten_MinChg::
	.ds	2
	.debug	G _cavAtten_MinChg 5 0
_freqSearchAmpl::
	.ds	4
	.debug	G _freqSearchAmpl 10 0
_freqSearchAmpl_ChgEventVal::
	.ds	4
	.debug	G _freqSearchAmpl_ChgEventVal 10 0
_freqSearchAmpl_MinChg::
	.ds	4
	.debug	G _freqSearchAmpl_MinChg 10 0
_cavLowIlkLevel::
	.ds	4
	.debug	G _cavLowIlkLevel 10 0
_cavLowIlkLevel_ChgEventVal::
	.ds	4
	.debug	G _cavLowIlkLevel_ChgEventVal 10 0
_cavLowIlkLevel_MinChg::
	.ds	4
	.debug	G _cavLowIlkLevel_MinChg 10 0
_cavLowIlkTime::
	.ds	4
	.debug	G _cavLowIlkTime 10 0
_cavLowIlkTime_ChgEventVal::
	.ds	4
	.debug	G _cavLowIlkTime_ChgEventVal 10 0
_cavLowIlkTime_MinChg::
	.ds	4
	.debug	G _cavLowIlkTime_MinChg 10 0
_dvdt_IlkRate::
	.ds	4
	.debug	G _dvdt_IlkRate 10 0
_dvdt_IlkRate_ChgEventVal::
	.ds	4
	.debug	G _dvdt_IlkRate_ChgEventVal 10 0
_dvdt_IlkRate_MinChg::
	.ds	4
	.debug	G _dvdt_IlkRate_MinChg 10 0
_vv_IlkRatio::
	.ds	4
	.debug	G _vv_IlkRatio 10 0
_vv_IlkRatio_ChgEventVal::
	.ds	4
	.debug	G _vv_IlkRatio_ChgEventVal 10 0
_vv_IlkRatio_MinChg::
	.ds	4
	.debug	G _vv_IlkRatio_MinChg 10 0
_fwdCavOffset::
	.ds	4
	.debug	G _fwdCavOffset 10 0
_fwdCavOffset_ChgEventVal::
	.ds	4
	.debug	G _fwdCavOffset_ChgEventVal 10 0
_fwdCavOffset_MinChg::
	.ds	4
	.debug	G _fwdCavOffset_MinChg 10 0
_feedFwdPhase::
	.ds	4
	.debug	G _feedFwdPhase 10 0
_feedFwdPhase_ChgEventVal::
	.ds	4
	.debug	G _feedFwdPhase_ChgEventVal 10 0
_feedFwdPhase_MinChg::
	.ds	4
	.debug	G _feedFwdPhase_MinChg 10 0
_feedFwdGain::
	.ds	4
	.debug	G _feedFwdGain 10 0
_feedFwdGain_ChgEventVal::
	.ds	4
	.debug	G _feedFwdGain_ChgEventVal 10 0
_feedFwdGain_MinChg::
	.ds	4
	.debug	G _feedFwdGain_MinChg 10 0
_ctfCalcRate::
	.ds	4
	.debug	G _ctfCalcRate 10 0
_ctfCalcRate_ChgEventVal::
	.ds	4
	.debug	G _ctfCalcRate_ChgEventVal 10 0
_ctfCalcRate_MinChg::
	.ds	4
	.debug	G _ctfCalcRate_MinChg 10 0
_fwdMagCalib::
	.ds	4
	.debug	G _fwdMagCalib 10 0
_fwdMagCalib_ChgEventVal::
	.ds	4
	.debug	G _fwdMagCalib_ChgEventVal 10 0
_fwdMagCalib_MinChg::
	.ds	4
	.debug	G _fwdMagCalib_MinChg 10 0
_fwdPhaseCalib::
	.ds	4
	.debug	G _fwdPhaseCalib 10 0
_fwdPhaseCalib_ChgEventVal::
	.ds	4
	.debug	G _fwdPhaseCalib_ChgEventVal 10 0
_fwdPhaseCalib_MinChg::
	.ds	4
	.debug	G _fwdPhaseCalib_MinChg 10 0
_reflMagCalib::
	.ds	4
	.debug	G _reflMagCalib 10 0
_reflMagCalib_ChgEventVal::
	.ds	4
	.debug	G _reflMagCalib_ChgEventVal 10 0
_reflMagCalib_MinChg::
	.ds	4
	.debug	G _reflMagCalib_MinChg 10 0
_reflPhaseCalib::
	.ds	4
	.debug	G _reflPhaseCalib 10 0
_reflPhaseCalib_ChgEventVal::
	.ds	4
	.debug	G _reflPhaseCalib_ChgEventVal 10 0
_reflPhaseCalib_MinChg::
	.ds	4
	.debug	G _reflPhaseCalib_MinChg 10 0
_cavMagCalib::
	.ds	4
	.debug	G _cavMagCalib 10 0
_cavMagCalib_ChgEventVal::
	.ds	4
	.debug	G _cavMagCalib_ChgEventVal 10 0
_cavMagCalib_MinChg::
	.ds	4
	.debug	G _cavMagCalib_MinChg 10 0
_cavPhaseCalib::
	.ds	4
	.debug	G _cavPhaseCalib 10 0
_cavPhaseCalib_ChgEventVal::
	.ds	4
	.debug	G _cavPhaseCalib_ChgEventVal 10 0
_cavPhaseCalib_MinChg::
	.ds	4
	.debug	G _cavPhaseCalib_MinChg 10 0
_outMagCalib::
	.ds	4
	.debug	G _outMagCalib 10 0
_outMagCalib_ChgEventVal::
	.ds	4
	.debug	G _outMagCalib_ChgEventVal 10 0
_outMagCalib_MinChg::
	.ds	4
	.debug	G _outMagCalib_MinChg 10 0
_outPhaseCalib::
	.ds	4
	.debug	G _outPhaseCalib 10 0
_outPhaseCalib_ChgEventVal::
	.ds	4
	.debug	G _outPhaseCalib_ChgEventVal 10 0
_outPhaseCalib_MinChg::
	.ds	4
	.debug	G _outPhaseCalib_MinChg 10 0
_ctfTunerAmpl::
	.ds	4
	.debug	G _ctfTunerAmpl 10 0
_ctfTunerAmpl_ChgEventVal::
	.ds	4
	.debug	G _ctfTunerAmpl_ChgEventVal 10 0
_ctfTunerAmpl_MinChg::
	.ds	4
	.debug	G _ctfTunerAmpl_MinChg 10 0
_setDSPState::
	.ds	4
	.debug	G _setDSPState 9 0
_setDSPState_ChgEventVal::
	.ds	4
	.debug	G _setDSPState_ChgEventVal 9 0
_setDSPState_MinChg::
	.ds	4
	.debug	G _setDSPState_MinChg 9 0
	.cseg
_MB_setDSPState:
	pop	iy
	lcall	$$MB_setDSPState
	.bseg
_fwdAmplGain::
	.ds	4
	.debug	G _fwdAmplGain 10 0
_fwdAmplGain_ChgEventVal::
	.ds	4
	.debug	G _fwdAmplGain_ChgEventVal 10 0
_fwdAmplGain_MinChg::
	.ds	4
	.debug	G _fwdAmplGain_MinChg 10 0
	.cseg
_MB_setGain:
	pop	iy
	lcall	$$MB_setGain
	.bseg
_fwdAmplOffset::
	.ds	4
	.debug	G _fwdAmplOffset 10 0
_fwdAmplOffset_ChgEventVal::
	.ds	4
	.debug	G _fwdAmplOffset_ChgEventVal 10 0
_fwdAmplOffset_MinChg::
	.ds	4
	.debug	G _fwdAmplOffset_MinChg 10 0
_fwdPhaseGain::
	.ds	4
	.debug	G _fwdPhaseGain 10 0
_fwdPhaseGain_ChgEventVal::
	.ds	4
	.debug	G _fwdPhaseGain_ChgEventVal 10 0
_fwdPhaseGain_MinChg::
	.ds	4
	.debug	G _fwdPhaseGain_MinChg 10 0
_fwdPhaseOffset::
	.ds	4
	.debug	G _fwdPhaseOffset 10 0
_fwdPhaseOffset_ChgEventVal::
	.ds	4
	.debug	G _fwdPhaseOffset_ChgEventVal 10 0
_fwdPhaseOffset_MinChg::
	.ds	4
	.debug	G _fwdPhaseOffset_MinChg 10 0
_reflAmplGain::
	.ds	4
	.debug	G _reflAmplGain 10 0
_reflAmplGain_ChgEventVal::
	.ds	4
	.debug	G _reflAmplGain_ChgEventVal 10 0
_reflAmplGain_MinChg::
	.ds	4
	.debug	G _reflAmplGain_MinChg 10 0
_reflAmplOffset::
	.ds	4
	.debug	G _reflAmplOffset 10 0
_reflAmplOffset_ChgEventVal::
	.ds	4
	.debug	G _reflAmplOffset_ChgEventVal 10 0
_reflAmplOffset_MinChg::
	.ds	4
	.debug	G _reflAmplOffset_MinChg 10 0
_reflPhaseGain::
	.ds	4
	.debug	G _reflPhaseGain 10 0
_reflPhaseGain_ChgEventVal::
	.ds	4
	.debug	G _reflPhaseGain_ChgEventVal 10 0
_reflPhaseGain_MinChg::
	.ds	4
	.debug	G _reflPhaseGain_MinChg 10 0
_reflPhaseOffset::
	.ds	4
	.debug	G _reflPhaseOffset 10 0
_reflPhaseOffset_ChgEventVal::
	.ds	4
	.debug	G _reflPhaseOffset_ChgEventVal 10 0
_reflPhaseOffset_MinChg::
	.ds	4
	.debug	G _reflPhaseOffset_MinChg 10 0
_cavAmplGain::
	.ds	4
	.debug	G _cavAmplGain 10 0
_cavAmplGain_ChgEventVal::
	.ds	4
	.debug	G _cavAmplGain_ChgEventVal 10 0
_cavAmplGain_MinChg::
	.ds	4
	.debug	G _cavAmplGain_MinChg 10 0
_cavAmplOffset::
	.ds	4
	.debug	G _cavAmplOffset 10 0
_cavAmplOffset_ChgEventVal::
	.ds	4
	.debug	G _cavAmplOffset_ChgEventVal 10 0
_cavAmplOffset_MinChg::
	.ds	4
	.debug	G _cavAmplOffset_MinChg 10 0
_cavPhaseGain::
	.ds	4
	.debug	G _cavPhaseGain 10 0
_cavPhaseGain_ChgEventVal::
	.ds	4
	.debug	G _cavPhaseGain_ChgEventVal 10 0
_cavPhaseGain_MinChg::
	.ds	4
	.debug	G _cavPhaseGain_MinChg 10 0
_cavPhaseOffset::
	.ds	4
	.debug	G _cavPhaseOffset 10 0
_cavPhaseOffset_ChgEventVal::
	.ds	4
	.debug	G _cavPhaseOffset_ChgEventVal 10 0
_cavPhaseOffset_MinChg::
	.ds	4
	.debug	G _cavPhaseOffset_MinChg 10 0
_refAmplGain::
	.ds	4
	.debug	G _refAmplGain 10 0
_refAmplGain_ChgEventVal::
	.ds	4
	.debug	G _refAmplGain_ChgEventVal 10 0
_refAmplGain_MinChg::
	.ds	4
	.debug	G _refAmplGain_MinChg 10 0
_refAmplOffset::
	.ds	4
	.debug	G _refAmplOffset 10 0
_refAmplOffset_ChgEventVal::
	.ds	4
	.debug	G _refAmplOffset_ChgEventVal 10 0
_refAmplOffset_MinChg::
	.ds	4
	.debug	G _refAmplOffset_MinChg 10 0
_refPhaseGain::
	.ds	4
	.debug	G _refPhaseGain 10 0
_refPhaseGain_ChgEventVal::
	.ds	4
	.debug	G _refPhaseGain_ChgEventVal 10 0
_refPhaseGain_MinChg::
	.ds	4
	.debug	G _refPhaseGain_MinChg 10 0
_refPhaseOffset::
	.ds	4
	.debug	G _refPhaseOffset 10 0
_refPhaseOffset_ChgEventVal::
	.ds	4
	.debug	G _refPhaseOffset_ChgEventVal 10 0
_refPhaseOffset_MinChg::
	.ds	4
	.debug	G _refPhaseOffset_MinChg 10 0
_pulseFreq::
	.ds	4
	.debug	G _pulseFreq 10 0
_pulseFreq_ChgEventVal::
	.ds	4
	.debug	G _pulseFreq_ChgEventVal 10 0
_pulseFreq_MinChg::
	.ds	4
	.debug	G _pulseFreq_MinChg 10 0
_afcPhase0::
	.ds	4
	.debug	G _afcPhase0 10 0
_afcPhase0_ChgEventVal::
	.ds	4
	.debug	G _afcPhase0_ChgEventVal 10 0
_afcPhase0_MinChg::
	.ds	4
	.debug	G _afcPhase0_MinChg 10 0
_afcPhase1::
	.ds	4
	.debug	G _afcPhase1 10 0
_afcPhase1_ChgEventVal::
	.ds	4
	.debug	G _afcPhase1_ChgEventVal 10 0
_afcPhase1_MinChg::
	.ds	4
	.debug	G _afcPhase1_MinChg 10 0
_afcPhase2::
	.ds	4
	.debug	G _afcPhase2 10 0
_afcPhase2_ChgEventVal::
	.ds	4
	.debug	G _afcPhase2_ChgEventVal 10 0
_afcPhase2_MinChg::
	.ds	4
	.debug	G _afcPhase2_MinChg 10 0
_afcPhase3::
	.ds	4
	.debug	G _afcPhase3 10 0
_afcPhase3_ChgEventVal::
	.ds	4
	.debug	G _afcPhase3_ChgEventVal 10 0
_afcPhase3_MinChg::
	.ds	4
	.debug	G _afcPhase3_MinChg 10 0
_afcPhase4::
	.ds	4
	.debug	G _afcPhase4 10 0
_afcPhase4_ChgEventVal::
	.ds	4
	.debug	G _afcPhase4_ChgEventVal 10 0
_afcPhase4_MinChg::
	.ds	4
	.debug	G _afcPhase4_MinChg 10 0
_afcPhase5::
	.ds	4
	.debug	G _afcPhase5 10 0
_afcPhase5_ChgEventVal::
	.ds	4
	.debug	G _afcPhase5_ChgEventVal 10 0
_afcPhase5_MinChg::
	.ds	4
	.debug	G _afcPhase5_MinChg 10 0
_afcPhase6::
	.ds	4
	.debug	G _afcPhase6 10 0
_afcPhase6_ChgEventVal::
	.ds	4
	.debug	G _afcPhase6_ChgEventVal 10 0
_afcPhase6_MinChg::
	.ds	4
	.debug	G _afcPhase6_MinChg 10 0
_afcPhase7::
	.ds	4
	.debug	G _afcPhase7 10 0
_afcPhase7_ChgEventVal::
	.ds	4
	.debug	G _afcPhase7_ChgEventVal 10 0
_afcPhase7_MinChg::
	.ds	4
	.debug	G _afcPhase7_MinChg 10 0
_afcPhase8::
	.ds	4
	.debug	G _afcPhase8 10 0
_afcPhase8_ChgEventVal::
	.ds	4
	.debug	G _afcPhase8_ChgEventVal 10 0
_afcPhase8_MinChg::
	.ds	4
	.debug	G _afcPhase8_MinChg 10 0
_afcPhase9::
	.ds	4
	.debug	G _afcPhase9 10 0
_afcPhase9_ChgEventVal::
	.ds	4
	.debug	G _afcPhase9_ChgEventVal 10 0
_afcPhase9_MinChg::
	.ds	4
	.debug	G _afcPhase9_MinChg 10 0
_maxAmplSet::
	.ds	4
	.debug	G _maxAmplSet 10 0
_maxAmplSet_ChgEventVal::
	.ds	4
	.debug	G _maxAmplSet_ChgEventVal 10 0
_maxAmplSet_MinChg::
	.ds	4
	.debug	G _maxAmplSet_MinChg 10 0
_rfq_manTuneSet::
	.ds	4
	.debug	G _rfq_manTuneSet 10 0
_rfq_manTuneSet_ChgEventVal::
	.ds	4
	.debug	G _rfq_manTuneSet_ChgEventVal 10 0
_rfq_manTuneSet_MinChg::
	.ds	4
	.debug	G _rfq_manTuneSet_MinChg 10 0
_rfq_t1_offset::
	.ds	4
	.debug	G _rfq_t1_offset 10 0
_rfq_t1_offset_ChgEventVal::
	.ds	4
	.debug	G _rfq_t1_offset_ChgEventVal 10 0
_rfq_t1_offset_MinChg::
	.ds	4
	.debug	G _rfq_t1_offset_MinChg 10 0
_rfq_t2_offset::
	.ds	4
	.debug	G _rfq_t2_offset 10 0
_rfq_t2_offset_ChgEventVal::
	.ds	4
	.debug	G _rfq_t2_offset_ChgEventVal 10 0
_rfq_t2_offset_MinChg::
	.ds	4
	.debug	G _rfq_t2_offset_MinChg 10 0
_pulse_ramp::
	.ds	4
	.debug	G _pulse_ramp 9 0
_pulse_ramp_ChgEventVal::
	.ds	4
	.debug	G _pulse_ramp_ChgEventVal 9 0
_pulse_ramp_MinChg::
	.ds	4
	.debug	G _pulse_ramp_MinChg 9 0
_stepperSetPos::
	.ds	4
	.debug	G _stepperSetPos 8 0
_stepperSetPos_ChgEventVal::
	.ds	4
	.debug	G _stepperSetPos_ChgEventVal 8 0
_stepperSetPos_MinChg::
	.ds	4
	.debug	G _stepperSetPos_MinChg 8 0
_cavHighIlkLevel::
	.ds	4
	.debug	G _cavHighIlkLevel 10 0
_cavHighIlkLevel_ChgEventVal::
	.ds	4
	.debug	G _cavHighIlkLevel_ChgEventVal 10 0
_cavHighIlkLevel_MinChg::
	.ds	4
	.debug	G _cavHighIlkLevel_MinChg 10 0
_fwdHighIlkLevel::
	.ds	4
	.debug	G _fwdHighIlkLevel 10 0
_fwdHighIlkLevel_ChgEventVal::
	.ds	4
	.debug	G _fwdHighIlkLevel_ChgEventVal 10 0
_fwdHighIlkLevel_MinChg::
	.ds	4
	.debug	G _fwdHighIlkLevel_MinChg 10 0
_numDataPoints::
	.ds	20
	.debug	G _numDataPoints 231 0
	.seg	FARBSS
_waveformData::
	.ds	40960
	.debug	G _waveformData 232 8
	.bseg
_dataTimeMS::
	.ds	40
	.debug	G _dataTimeMS 234 0
_dataTimeSecs::
	.ds	40
	.debug	G _dataTimeSecs 234 0
_lastWaveReadTime::
	.ds	20
	.debug	G _lastWaveReadTime 231 0
_readerRdy::
	.ds	10
	.debug	G _readerRdy 235 0
_lastReadPlotTime::
	.ds	2
	.debug	G _lastReadPlotTime 7 0
_startCTFWaitTime::
	.ds	4
	.debug	G _startCTFWaitTime 9 0
	.cseg
_PV_UpdateVal:
	pop	iy
	lcall	$$PV_UpdateVal
_PV_LockVal:
	pop	iy
	lcall	$$PV_LockVal
_PV_SendVal:
	pop	iy
	lcall	$$PV_SendVal
_PV_RcvVal:
	pop	iy
	lcall	$$PV_RcvVal
_PV_UpdateValWF:
	pop	iy
	lcall	$$PV_UpdateValWF
_PV_LockWave:
	pop	iy
	lcall	$$PV_LockWave
	.extern	$ifpending 194
	.extern	$startNetUp 194
	.extern	$mkfifo 219
	.extern	$fstat 236
	.extern	$perror 237
	.extern	$strerror 238
	.extern	_hdwCfgParams 239
	.extern	$initParamModule 132
	.extern	$saveParams 240
	.extern	$loadParams 240
	.extern	$loadParamsMsg 241
_backupd:
	pop	iy
	lcall	$$backupd
	.extern	$$backupd
	.extern	$backupd 119
	.extern	_srfsIPAddr 9
	.extern	_srfsAltAddr 9
	.extern	$_spiConfig_ 242
	.extern	$_spiRead_ 243
	.extern	$_spiWrite_ 243
	.extern	$_spiWrRd_ 244
	.extern	$_spiLock_ 245
	.extern	$_spiWrRdFast_ 246
	.extern	$_spiUnlock_ 245
_ca_tcpd:
	pop	iy
	lcall	$$ca_tcpd
	.extern	$$ca_tcpd
	.extern	$ca_tcpd 119
_inetd:
	pop	iy
	lcall	$$inetd
	.extern	$$inetd
	.extern	$inetd 119
	.extern	$showHelp 247
	.extern	$displayElems 248
	.extern	$displayDigElems 249
_fmtF32:
	pop	iy
	lcall	$$fmtF32
	.extern	$$fmtF32
	.extern	$fmtF32 143
_fmtU16:
	pop	iy
	lcall	$$fmtU16
	.extern	$$fmtU16
	.extern	$fmtU16 143
_fmtS16:
	pop	iy
	lcall	$$fmtS16
	.extern	$$fmtS16
	.extern	$fmtS16 143
_fmtS32:
	pop	iy
	lcall	$$fmtS32
	.extern	$$fmtS32
	.extern	$fmtS32 143
_fmtBool:
	pop	iy
	lcall	$$fmtBool
	.extern	$$fmtBool
	.extern	$fmtBool 143
	.seg	FARBSS
_applDTM::
	.ds	32
	.debug	G _applDTM 91 8
	.bseg
_ctlLoopTicks::
	.ds	2
	.debug	G _ctlLoopTicks 7 0
_lastCtlLoopTime::
	.ds	2
	.debug	G _lastCtlLoopTime 7 0
_lastReadTime::
	.ds	2
	.debug	G _lastReadTime 7 0
_readTicks::
	.ds	2
	.debug	G _readTicks 7 0
_writeTicks::
	.ds	2
	.debug	G _writeTicks 7 0
_rwTicks::
	.ds	2
	.debug	G _rwTicks 7 0
_ADC_Mask::
	.ds	4
	.debug	G _ADC_Mask 9 0
_DAC_Mask::
	.ds	4
	.debug	G _DAC_Mask 9 0
_stateDataBuf::
	.ds	4
	.debug	G _stateDataBuf 107 0
	.cseg
_EVENT_RestoredParamFile:
	pop	iy
	lcall	$$EVENT_RestoredParamFile
_adcMinRaw:
	pop	iy
	lcall	$$adcMinRaw
	.extern	$$adcMinRaw
	.extern	$adcMinRaw 155
_adcMaxRaw:
	pop	iy
	lcall	$$adcMaxRaw
	.extern	$$adcMaxRaw
	.extern	$adcMaxRaw 155
_adcDefaults:
	pop	iy
	lcall	$$adcDefaults
	.extern	$$adcDefaults
	.extern	$adcDefaults 156
_dacMinRaw:
	pop	iy
	lcall	$$dacMinRaw
	.extern	$$dacMinRaw
	.extern	$dacMinRaw 155
_dacMaxRaw:
	pop	iy
	lcall	$$dacMaxRaw
	.extern	$$dacMaxRaw
	.extern	$dacMaxRaw 155
_dacDefaults:
	pop	iy
	lcall	$$dacDefaults
	.extern	$$dacDefaults
	.extern	$dacDefaults 156
_readGetRaw:
	pop	iy
	lcall	$$readGetRaw
_readMinRaw:
	pop	iy
	lcall	$$readMinRaw
_readMaxRaw:
	pop	iy
	lcall	$$readMaxRaw
_readDefaults:
	pop	iy
	lcall	$$readDefaults
_readCalibPoints:
	pop	iy
	lcall	$$readCalibPoints
_setGetRaw:
	pop	iy
	lcall	$$setGetRaw
_setMinRaw:
	pop	iy
	lcall	$$setMinRaw
_setMaxRaw:
	pop	iy
	lcall	$$setMaxRaw
_setDefaults:
	pop	iy
	lcall	$$setDefaults
_setCalibPoints:
	pop	iy
	lcall	$$setCalibPoints
_applic:
	pop	iy
	lcall	$$applic
_tsh:
	pop	iy
	lcall	$$tsh
	.extern	$$tsh
	.extern	$tsh 119
_configd:
	pop	iy
	lcall	$$configd
	.extern	$$configd
	.extern	$configd 119
_fastdatad:
	pop	iy
	lcall	$$fastdatad
	.extern	$$fastdatad
	.extern	$fastdatad 119
_ReadSetCalibsRestore:
	pop	iy
	lcall	$$ReadSetCalibsRestore
_hostNameRestore:
	pop	iy
	lcall	$$hostNameRestore
_readWave:
	pop	iy
	lcall	$$readWave
	.bseg
_prevState::
	.ds	8
	.debug	G _prevState 250 0
_curState::
	.ds	8
	.debug	G _curState 250 0
_nextState::
	.ds	8
	.debug	G _nextState 250 0
_calcStartTimeCTF::
	.ds	4
	.debug	G _calcStartTimeCTF 9 0
_ilkRatioGain::
	.ds	4
	.debug	G _ilkRatioGain 10 0
_ilkRatioOffset::
	.ds	4
	.debug	G _ilkRatioOffset 10 0
_maxOutAmplGain::
	.ds	4
	.debug	G _maxOutAmplGain 10 0
_maxOutAmplOffset::
	.ds	4
	.debug	G _maxOutAmplOffset 10 0
_lastIdleMS:
	.ds	4
	.debug	F _lastIdleMS 9 0
_lastIdleTime:
	.ds	2
	.debug	F _lastIdleTime 7 0
_applBuf::
	.ds	256
	.debug	G _applBuf 117 0
_locks::
	.ds	286
	.debug	G _locks 251 0
_spi1fd::
	.ds	2
	.debug	G _spi1fd 6 0
_spi2fd::
	.ds	2
	.debug	G _spi2fd 6 0
_spi1Port::
	.ds	2
	.debug	G _spi1Port 252 0
_spi2Port::
	.ds	2
	.debug	G _spi2Port 252 0
_fpgaInitialized::
	.ds	1
	.debug	G _fpgaInitialized 3 0
_pulseAmpl::
	.ds	1
	.debug	G _pulseAmpl 3 0
_pulsePhase::
	.ds	1
	.debug	G _pulsePhase 3 0
_ADCVal::
	.ds	2
	.debug	G _ADCVal 7 0
_autoReadDSP::
	.ds	1
	.debug	G _autoReadDSP 3 0
_autoWriteDSP::
	.ds	1
	.debug	G _autoWriteDSP 3 0
_showFiller::
	.ds	1
	.debug	G _showFiller 3 0
_readWaves::
	.ds	1
	.debug	G _readWaves 3 0
_rfIsOn::
	.ds	1
	.debug	G _rfIsOn 3 0
_rfPulsing::
	.ds	1
	.debug	G _rfPulsing 3 0
_tunerPIDisON::
	.ds	1
	.debug	G _tunerPIDisON 3 0
_rfAtWarm::
	.ds	1
	.debug	G _rfAtWarm 3 0
_rfRamping::
	.ds	1
	.debug	G _rfRamping 3 0
_afcEnabled::
	.ds	1
	.debug	G _afcEnabled 3 0
_cavLocked::
	.ds	1
	.debug	G _cavLocked 3 0
_amplPIDisON::
	.ds	1
	.debug	G _amplPIDisON 3 0
_curProgNum::
	.ds	2
	.debug	G _curProgNum 7 0
_phaseMode::
	.ds	2
	.debug	G _phaseMode 7 0
_lastDSPioTime::
	.ds	2
	.debug	G _lastDSPioTime 7 0
	.cseg
_readFromFile:
	pop	iy
	lcall	$$readFromFile
_writeDSPMem:
	pop	iy
	lcall	$$writeDSPMem
_resetFPGA:
	pop	iy
	lcall	$$resetFPGA
_autocal:
	pop	iy
	lcall	$$autocal
_cmd:
	pop	iy
	lcall	$$cmd
_setConfig:
	pop	iy
	lcall	$$setConfig
_selectADC:
	pop	iy
	lcall	$$selectADC
_setADCReg:
	pop	iy
	lcall	$$setADCReg
_defaults:
	pop	iy
	lcall	$$defaults
_progDSP:
	pop	iy
	lcall	$$progDSP
_restartDSP:
	pop	iy
	lcall	$$restartDSP
_setFPGAfirm:
	pop	iy
	lcall	$$setFPGAfirm
_setPLLReg:
	pop	iy
	lcall	$$setPLLReg
_fmtPhaseMode:
	pop	iy
	lcall	$$fmtPhaseMode
_fmtAFC:
	pop	iy
	lcall	$$fmtAFC
_fmtWarming:
	pop	iy
	lcall	$$fmtWarming
_fmtRamping:
	pop	iy
	lcall	$$fmtRamping
_fmtLocked:
	pop	iy
	lcall	$$fmtLocked
_showState:
	pop	iy
	lcall	$$showState
_dspcalib:
	pop	iy
	lcall	$$dspcalib
_dspio:
	pop	iy
	lcall	$$dspio
_dspRead:
	pop	iy
	lcall	$$dspRead
_dspWrite:
	pop	iy
	lcall	$$dspWrite
	.debug	T	49000320000A00050001004600000008636F696C56616C00030002
	.debug	T	0008636F696C4E756D0032000300056E616D6500FE0007000C
	.debug	T	736574436F696C46756E63000300090006666C61677300
	.debug	T	AD0003210014000C000100550000000772656756616C0005000200
	.debug	T	077265674E756D0032000400056E616D6500FF0008000B7365
	.debug	T	7452656746756E630003000A00096461746154797065000300
	.debug	T	0B00086E756D526567730003000C000777724D61736B000300
	.debug	T	0D0006666C6167730003000E000C636865636B4576656E7473
	.debug	T	0003000F000E6576656E74734F63637572656400500010000B
	.debug	T	6C61737443686756616C0050001200076D696E43686700
	.debug	T	0900012200160003001600
	.debug	T	0900012300040024000200
	.debug	T	070000240002002000
	.debug	T	0900012500AC0026005600
	.debug	T	070000260002002100
	.debug	T	090001270096012600CB00
	.debug	T	0900012800CB0029000700
	.debug	T	8A000329001D0009000950565F446573635F006200000007707649
	.debug	T	6E666F006B000D000476616C00070011000876616C53697A65
	.debug	T	00030013000A6E65774576656E747300030014000E6576656E
	.debug	T	74734F63637572656400000115000A75706461746556616C00
	.debug	T	01011700086C6F636B56616C00020119000873656E6456616C
	.debug	T	0002011B000772637656616C00
	.debug	T	0900012A000A0007000500
	.debug	T	0900012B00110003001100
	.debug	T	0900012C00070003000700
	.debug	T	1D00032D000600020001000900000005626175640006000400056D
	.debug	T	6F646500
	.debug	T	0900012E0078002F000300
	.debug	T	0900012F00280003002800
	.debug	T	09000130000E0003000E00
	.debug	T	0900013100700032001C00
	.debug	T	070008320004000300
	.debug	T	0900013300180003001800
	.debug	T	0900013400C00032003000
	.debug	T	0900013500010003000100
	.debug	T	09000136005A0037000500
	.debug	T	820003370012000900010046000000087372764E616D6500070002
	.debug	T	0005706F727400030004000970726F746F636F6C0003010500
	.debug	T	0970726F634D61696E0003000700097072696F726974790006
	.debug	T	0008000664657666640050000A000A636667506172616D7300
	.debug	T	06000C00086C6173744572720009000E000C6C617374457272
	.debug	T	54696D6500
	.debug	T	0900013800180009000600
	.debug	T	0900013900800032002000
	.debug	T	0900013A0010043B004100
	.debug	T	4900033B001000060001000400000003696400040002000573697A
	.debug	T	650004000400056772616E006B00060005646174610032000A
	.debug	T	00056E616D650004010E000B726573746F726556616C00
	.debug	T	0900013C0060003B000600
	.debug	T	0900013D0010003B000100
	.debug	T	7200033E003100080001004600000009626173654E616D65000300
	.debug	T	02000963617465676F7279000501030007706172616D730006
	.debug	T	0107000B7772697465436F756E740006002700036664000701
	.debug	T	29000962626D43616368650007002D000A636163686553697A
	.debug	T	650007002F00076F666673657400
	.debug	T	0900013F00060040000300
	.debug	T	070000400002003E00
	.debug	T	0900014100640242002400
	.debug	T	580003420011000700010009000000036964000300040005747970
	.debug	T	650026000500066D625265670098000700056761696E009800
	.debug	T	0900076F66667365740009000B00087479706963616C000700
	.debug	T	0F000A706572634E6F69736500
	.debug	T	0900014300500544004400
	.debug	T	630003440014000800010009000000036964000300040005747970
	.debug	T	650026000500066D62526567000A000700076D696E56616C00
	.debug	T	0A000B00076D617856616C0003000F000A77726974654D6F64
	.debug	T	650098001000056761696E0098001200076F666673657400
	.debug	T	0900014500100046000800
	.debug	T	070000460002000300
	.debug	T	0F00024700020006000700000009000200
	.debug	T	070000480002004900
	.debug	T	7702034900E8002D000C7461736B5F737472756374000901000006
	.debug	T	737461636B00090102000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C6872000A010F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465004800150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630078001A0005617267760064001C0005617267
	.debug	T	73000B019C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773000301B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74003200D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	0700004A0002004B00
	.debug	T	2800034B001A00030001000600000006636F756E74000600020006
	.debug	T	6F776E6572000C0104000473656D00
	.debug	T	0B00024C000100060007000000
	.debug	T	0B00024D000100060009000000
	.debug	T	0B00024E000100060001000000
	.debug	T	0F00024F0002000A005000000026000200
	.debug	T	070000500002000100
	.debug	T	0F00025100020008005000000026000200
	.debug	T	0F00025200020009005000000026000200
	.debug	T	13000253000300010050000000260002000A000400
	.debug	T	17000254000400010026000000550002005600040057000800
	.debug	T	070000550002000400
	.debug	T	070008560004004200
	.debug	T	070000570002000900
	.debug	T	17000258000400010026000000550002005900040057000800
	.debug	T	070008590004004400
	.debug	T	1700025A000400030050000000030002005000040006000600
	.debug	T	0900015B00200003002000
	.debug	T	0B00025C00010006005D000000
	.debug	T	0700005D0002002900
	.debug	T	1300025E00030006005D0000000600020006000400
	.debug	T	1700025F000400060006000000070002005000040060000600
	.debug	T	070000600002006100
	.debug	T	130002610003000600500000006B00020007000600
	.debug	T	52000362000D000600010032000000056E616D6500030004000964
	.debug	T	6174615479706500070005000573697A65000700070009656C
	.debug	T	656D53697A650007000900096E756D456C656D730007000B00
	.debug	T	06666C61677300
	.debug	T	0B000263000100010001000000
	.debug	T	0900016400800003008000
	.debug	T	070008650004000A00
	.debug	T	0B000266000100010003000000
	.debug	T	0B000267000100010068000000
	.debug	T	070000680002006900
	.debug	T	3C000369001600040001000700000008646174614C656E00500002
	.debug	T	000A6576656E7446756E630006000400086368616E4E756D00
	.debug	T	0D010600056461746100
	.debug	T	1300026A00030001006B0000004600040007000600
	.debug	T	0700086B0004000100
	.debug	T	0700086C0004006D00
	.debug	T	2F00036D0008000300010007000000096461746153697A65000700
	.debug	T	02000463726300090004000A726573657454696D6500
	.debug	T	0F00026E0002000A000A0000000A000400
	.debug	T	0B00026F0001000A0008000000
	.debug	T	0B00027000010008000A000000
	.debug	T	130002710003000600500000004600020006000400
	.debug	T	17000272000400060006000000070002000900040003000800
	.debug	T	1E00037300030002000100060000000766726F6D66640003000200
	.debug	T	04656F6600
	.debug	T	54000374000D0005000100070000000870726F674E756D00070002
	.debug	T	0007626C6B4E756D00090004000B74746C5772697474656E00
	.debug	T	090008000B626C6B5772697474656E0003000C000D73686F77
	.debug	T	50726F677265737300
	.debug	T	0900017500000103000001
	.debug	T	0B000276000100030009000000
	.debug	T	0F00027700020001000600000078000200
	.debug	T	070000780002004600
	.debug	T	17000279000400460046000000060002004600040006000600
	.debug	T	0B00027A000100030003000000
	.debug	T	0900017B0021007C000B00
	.debug	T	0900017C00030003000300
	.debug	T	1300027D0003000600060000000300020003000400
	.debug	T	BB00037E002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	0900017F00050003000500
	.debug	T	130002800003000600090000008100040007000800
	.debug	T	070008810004000900
	.debug	T	0B000282000100090009000000
	.debug	T	0F00028300020006000300000003000200
	.debug	T	0F00028400020006004600000007000200
	.debug	T	0F00028500020006000700000007000200
	.debug	T	0900018600020003000200
	.debug	T	0F00028700020006000900000057000400
	.debug	T	0F00028800020006000900000009000400
	.debug	T	130002890003000600090000000900040003000800
	.debug	T	0F00028A00020006004600000008000200
	.debug	T	0900018B00400003004000
	.debug	T	0900018C000C0009000300
	.debug	T	0900018D00060026000300
	.debug	T	0900018E00040003000400
	.debug	T	0F00028F00020046009000000046000400
	.debug	T	070008900004009100
	.debug	T	56000391000E0007000A44697370456C656D5F0003000000027800
	.debug	T	030001000279006B0002000476616C00460006000661747472
	.debug	T	73000E01080008666D7446756E630006000A00067769647468
	.debug	T	0006000C00057072656300
	.debug	T	09000192004E0403004E04
	.debug	T	0900019300440491004E00
	.debug	T	09000194000E0095000100
	.debug	T	4B000395000E000700010003000000027800030001000279000900
	.debug	T	0200056D61736B004600060005737472300046000800066174
	.debug	T	7472300046000A0005737472310046000C0006617474723100
	.debug	T	130002960003004600090000000300040046000600
	.debug	T	130002970003004600090000000900040046000800
	.debug	T	070000980002000A00
	.debug	T	090001990008000A000200
	.debug	T	0F00029A00020001000300000003000200
	.debug	T	0B00029B0001000A0007000000
	.debug	T	1300029C0003000100070000009800020098000400
	.debug	T	0F00029D00020046000700000046000200
	.debug	T	0900019E00060046000300
	.debug	T	0900019F00A000A0001000
	.debug	T	2F0003A0000A00030001003200000008636D644E616D6500030104
	.debug	T	000970726F634D61696E003200060006646573637200
	.debug	T	0B0002A1000100090057000000
	.debug	T	130002A20003005000500000005000020007000400
	.debug	T	130002A30003005000500000000600020007000400
	.debug	T	0F0002A400020006004600000046000200
	.debug	T	0B0002A5000100060046000000
	.debug	T	0F0002A600020046004600000046000200
	.debug	T	130002A70003006B006B0000006B00040009000800
	.debug	T	130002A80003006B006B0000000600040009000600
	.debug	T	0F0002A900020001003200000032000400
	.debug	T	0B0002AA000100090032000000
	.debug	T	0F0002AB00020001004600000032000200
	.debug	T	0B0002AC000100090001000000
	.debug	T	0B0002AD000100040078000000
	.debug	T	0F0002AE00020007000900000009000400
	.debug	T	130002AF00030046000A0000000600040046000600
	.debug	T	0B0002B0000100010006000000
	.debug	T	0F0002B100020009004600000046000200
	.debug	T	1F0002B20006000600060000003200020006000600460008000700
	.debug	T	0A0009000C00
	.debug	T	170002B3000400060006000000500002000600040008000600
	.debug	T	270002B400080009000F010000500002000F010400500006004600
	.debug	T	080006000A0009000C0003001000
	.debug	T	130002B50003000100060000006800020006000400
	.debug	T	130002B60003000600060000004600020050000400
	.debug	T	090001B700000003000000
	.debug	T	0F0002B800020006005700000006000200
	.debug	T	130002B90003000600060000005700020057000400
	.debug	T	0B0002BA000100060057000000
	.debug	T	090001BB00000049000000
	.debug	T	070000BC000200BD00
	.debug	T	540003BD000C000600010010010000065F5F6F7574001201020005
	.debug	T	5F5F696E0013010400085F5F77726974650013010600075F5F
	.debug	T	726561640006000800085F5F756E6765740050000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	130002BE0003000600BC000000320002000D000000
	.debug	T	0F0002BF0002000600320000000D000000
	.debug	T	130002C0000300060032000000320004000D000000
	.debug	T	090001C100080009000200
	.debug	T	0B0002C2000100060006000000
	.debug	T	0F0002C30002000B004600000078000200
	.debug	T	130002C40003000800460000007800020006000400
	.debug	T	130002C50003000600460000007800020006000400
	.debug	T	130002C60003000900460000007800020006000400
	.debug	T	090001C70000000A000000
	.debug	T	090001C800000007000000
	.debug	T	090001C90004000A000100
	.debug	T	090001CA00180033000100
	.debug	T	090001CB00500133000E00
	.debug	T	090001CC00400233001800
	.debug	T	090001CD00000333002000
	.debug	T	0B0002CE000100010009000000
	.debug	T	0B0002CF000100010007000000
	.debug	T	0B0002D0000100D10006000000
	.debug	T	070008D1000400D200
	.debug	T	0B0103D200270013000100060000000A6F70656E436F756E740015
	.debug	T	01020008696F46756E6373005000040006696F446576001701
	.debug	T	06000B776169745175657565730006000A0006666C61677300
	.debug	T	06000C00056D6F64650009000E000A72656164436F756E7400
	.debug	T	060012000D7264496E50726F67726573730006001400077264
	.debug	T	53746174000600160006726445727200030018000D646F6E74
	.debug	T	43616C6C5265616400090019000B7772697465436F756E7400
	.debug	T	06001D000D7772496E50726F67726573730006001F00077772
	.debug	T	53746174000600210006777245727200030023000E646F6E74
	.debug	T	43616C6C5772697465000300240004656F6600030025000669
	.debug	T	7374747900030026000773686172656400
	.debug	T	130002D30003000600460000000600020006000400
	.debug	T	130002D40003000600060000005000020006000400
	.debug	T	130002D50003000900060000000900020006000600
	.debug	T	0B0002D60001000600BC000000
	.debug	T	130002D70003000600060000000600020050000400
	.debug	T	270103D800F900140001000900000008696E666F4B657900090004
	.debug	T	00086262436F756E74000700080006746F4964780007000A00
	.debug	T	0866726F6D4964780003000C0008777261707065640003000D
	.debug	T	000D63746C6453687574646F776E0007000E00097764745469
	.debug	T	636B730009001000087365636F6E647300070014000A6D696C
	.debug	T	6C69536563730009001600076D7354696D650018011A000866
	.debug	T	696C6C6572310006006A0003747A0009006C000D6864775265
	.debug	T	73657454696D6500090070000B7265626F6F7454696D650003
	.debug	T	0074000D646964536F6674526573657400090075000C646967
	.debug	T	4F7574537461746500090079000972746F7356657273000900
	.debug	T	7D000D74696D65725365636F6E647300090081000B696E7649
	.debug	T	6E666F4B657900190185000866696C6C65723200
	.debug	T	230002D90007000600030100000300020006000400780006000600
	.debug	T	080006000A0006000C00
	.debug	T	170002DA000400460046000000460002000700040007000600
	.debug	T	0F0002DB00020006004600000006000200
	.debug	T	0F0002DC00020006001A01000009000200
	.debug	T	130002DD00030006001A0100000600020007000400
	.debug	T	0B0002DE00010006001A010000
	.debug	T	130002DF0003000300260000000300020005000400
	.debug	T	130002E00003000300260000000300020009000400
	.debug	T	130002E1000300030026000000030002000A000400
	.debug	T	090001E200200026001000
	.debug	T	170002E3000400460026000000550002000700040046000600
	.debug	T	0F0002E40002000600060000001B010200
	.debug	T	170002E5000400030050000000030002000300040006000600
	.debug	T	090001E600020005000100
	.debug	T	090001E700140007000A00
	.debug	T	090001E80000A0E9000A00
	.debug	T	090001E900001009000004
	.debug	T	090001EA00280009000A00
	.debug	T	090001EB000A0003000A00
	.debug	T	0F0002EC0002000600060000001C010200
	.debug	T	0B0002ED000100010032000000
	.debug	T	0B0002EE000100320006000000
	.debug	T	090001EF0000003B000000
	.debug	T	170002F0000400060046000000070002004000040003000600
	.debug	T	0B0002F1000100060040000000
	.debug	T	130002F20003000600500000000300020003000400
	.debug	T	170002F3000400060050000000460002000600040003000600
	.debug	T	170002F4000400060050000000460002004600040006000600
	.debug	T	0B0002F5000100060050000000
	.debug	T	130002F60003000600460000004600020006000400
	.debug	T	130002F70003000300060000000600020078000400
	.debug	T	130002F80003000100900000000300040046000600
	.debug	T	170002F90004000100090000001D0104000300080046000A00
	.debug	T	280003FA00080002000100090000000A6469676974616C496E0009
	.debug	T	0004000B6469676974616C4F757400
	.debug	T	090001FB001E014B000B00
	.debug	T	070000FC000200FD00
	.debug	T	E70003FD001800110001000300000006696E557365000300010005
	.debug	T	706F7274005000020005734465760003000400056D6F646500
	.debug	T	0300050008666C6F7743746C000300060007636C6F73656400
	.debug	T	0300070008706B744D6F646500090008000962617564526174
	.debug	T	650003000C0008636C6B4D6F64650006000D0007636C6B4469
	.debug	T	760003000F000B7365724461746152656700030010000A7365
	.debug	T	7243746C52656700030011000B736572537461745265670003
	.debug	T	0012000A73657245787452656700460013000A705368457874
	.debug	T	52656700030015000754415452656700460016000A70544154
	.debug	T	736852656700
	.debug	T	070000FE000200E500
	.debug	T	070000FF0002005A00
	.debug	T	070000000102005C00
	.debug	T	070000010102005E00
	.debug	T	070000020102005F00
	.debug	T	070000030102007700
	.debug	T	070000040102006A00
	.debug	T	070008050104003B00
	.debug	T	0900010601200007001000
	.debug	T	070008070104000801
	.debug	T	33000308010A0004000100090000000574696D6500070004000573
	.debug	T	697A6500070006000864657654797065000700080004637263
	.debug	T	00
	.debug	T	070000090102000700
	.debug	T	0700000A0102006B00
	.debug	T	2800030B0104000100125F5F776169745F71756575655F68656164
	.debug	T	001E010000096C6973744865616400
	.debug	T	6800030C0116000800010032000000056E616D65000B010400076F
	.debug	T	70656E6564000B010800076C6F636B6564000B010C0008626C
	.debug	T	6F636B6564000300100009756E6C696E6B6564000300110006
	.debug	T	696E55736500060012000676616C75650050001400076D7941
	.debug	T	64647200
	.debug	T	0900010D01100003001000
	.debug	T	0700000E0102008F00
	.debug	T	0700000F0102007100
	.debug	T	070000100102001101
	.debug	T	0F00021101020006000300000050000200
	.debug	T	07000012010200F500
	.debug	T	070000130102001401
	.debug	T	130002140103000800320000000800040050000800
	.debug	T	070000150102001601
	.debug	T	64000316011000080001001F0100000572656164001F0102000677
	.debug	T	72697465001201040006636C6F73650020010600066C736565
	.debug	T	6B00220108000666737461740024010A0006696F63746C0026
	.debug	T	010C000664657363720028010E000A67657451756575657300
	.debug	T	28000317010400020001002A0100000A726561645175657565002A
	.debug	T	0102000B7772697465517565756500
	.debug	T	0900011801500003005000
	.debug	T	0900011901740003007400
	.debug	T	0700001A0102000C01
	.debug	T	0700001B0102006200
	.debug	T	0700001C0102007E00
	.debug	T	0700081D0104009500
	.debug	T	2600031E01040002000A6C6973745F68656164002B010000056E65
	.debug	T	7874002B010200057072657600
	.debug	T	0700001F010200F300
	.debug	T	070000200102002101
	.debug	T	130002210103000900500000000900020006000600
	.debug	T	070000220102002301
	.debug	T	0F0002230102000600500000001C010200
	.debug	T	070000240102002501
	.debug	T	130002250103000600500000000600020050000400
	.debug	T	070000260102002701
	.debug	T	130002270103004600500000004600020006000400
	.debug	T	070000280102002901
	.debug	T	0F0002290102000600500000002C010200
	.debug	T	0700002A0102000B01
	.debug	T	0700002B0102001E01
	.debug	T	0700082C0104001701
	.seg	CONST
@2:
	.db	"readWave",0,"console",0,"fastdatad",0,"modbusTCPd",0,"tsh",0,"settings",0,"devData",0,"hdwcfg",0,"    OPEN",0,"     PID",0," "
	.db	"    SEL",0,"????????",0,"FREQSRCH",0,"PID/AUTO",0,"SEL/AUTO",0,"16:39:10",0,"Fri Jan 11 2013",0,"pllInitSeqs",0,"fwd",0
	.db	"refl",0,"cav",0,"afc",0,"on",0,"off",0,"amplPID",0,"phaseCtl",0,"pid",0,"sel",0,"auto",0,"rfPulse",0,"tunerPID",0,"/srfs/llrf.bin",0,"-v",0
	.db	"ON ",0,"OFF",0," WARM  ",0,"WARMING",0,"RAMPING",0,"STEADY ",0,"LOCKED  ",0,"UNLOCKED",0,34,0,"read",0,"write",0,"filler",0,"waves",0,"."
	.db	0,"V",0,"255.255.0.0",0,"192.168.0.1",0,"fifoEvents",0,"/dev/spi1",0,"/dev/spi2",0,"inetd",0,"configd",0,"backupd",0,"ca_tc"
	.db	"pd",0
	.seg	FARCONST
@1:
	.db	"DoNothing",0,"dlmVersTime",0,"rtosVersTime",0,"applVersTime",0,"devType_",0,"deviceID_",0,"upSecs",0,"percentIdle"
	.db	"_",0,"numChans",0,"coilChanMult",0,"reg3ChanMult",0,"reg4ChanMult",0,"digInBits",0,"statusBitsStdA",0,"statusBits"
	.db	"StdB",0,"statusBitsAppl",0,"fwdAmpl",0,"reflAmpl",0,"cavAmpl",0,"refAmpl",0,"fwdPhase",0,"reflPhase",0,"cavPhase",0,"refP"
	.db	"hase",0,"dspLoad",0,"dspTempInt",0,"dspTemp",0,"unused_30043",0,"unused_30045",0,"unused_30047",0,"unused_30049",0,"u"
	.db	"nused_30051",0,"unused_30053",0,"unused_30055",0,"unused_30057",0,"unused_30059",0,"percentCTF",0,"percentFFT"
	.db	0,"latency",0,"tcpTickTime",0,"applLoopTime",0,"maxFwdAmpl",0,"maxReflAmpl",0,"maxCavAmpl",0,"maxOutAmpl",0,"status"
	.db	"BitsDSP",0,"statusBitsAFC",0,"writeStatus",0,"sizeCTF",0,"sizeFFT",0,"romProgErrs",0,"piezoReadPos",0,"unused_300"
	.db	"82",0,"kernelLoopTime",0,"stepperReadPos",0,"timeZone_",0,"curTime",0,"ipAddr",0,"netmask",0,"gateway",0,"setACoil",0,"re"
	.db	"setACoil",0,"digOutBits",0,"cmdBitsStd",0,"cmdBitsAppl",0,"setAtten",0,"trigPos",0,"cmdBitsAppl3",0,"phaseSet",0,"amp"
	.db	"lSet",0,"oldPulseFreq",0,"rf_P",0,"rf_I",0,"rf_D",0,"unusedreg2",0,"pulsedAmplSet",0,"tuner_P",0,"tuner_I",0,"tuner_D",0,"unu"
	.db	"sedreg3",0,"pulsedPhaseSet",0,"setAFCsOnOff",0,"afcFreq0",0,"afcFreq1",0,"afcFreq2",0,"afcFreq3",0,"afcFreq4",0,"afcF"
	.db	"req5",0,"afcFreq6",0,"afcFreq7",0,"afcFreq8",0,"afcFreq9",0,"warmLevel",0,"warmMS",0,"rampMS",0,"dspComErrors",0,"dspProg"
	.db	"Num",0,"pllInitIdx",0,"rfq_t1_feedback",0,"rfq_t2_feedback",0,"devStat1",0,"rfq_t1_output",0,"rfq_t2_output",0,"d"
	.db	"evCtl1",0,"devRdSet1",0,"devRdSet2",0,"devRdCtl1",0,"piezoSetPos",0,"unused_40091",0,"fwdAtten",0,"reflAtten",0,"cavA"
	.db	"tten",0,"freqSearchAmpl",0,"cavLowIlkLevel",0,"cavLowIlkTime",0,"dvdt_IlkRate",0,"vv_IlkRatio",0,"fwdCavOffse"
	.db	"t",0,"feedFwdPhase",0,"feedFwdGain",0,"ctfCalcRate",0,"fwdMagCalib",0,"fwdPhaseCalib",0,"reflMagCalib",0,"reflPha"
	.db	"seCalib",0,"cavMagCalib",0,"cavPhaseCalib",0,"outMagCalib",0,"outPhaseCalib",0,"ctfTunerAmpl",0,"setDSPState",0
	.db	"fwdAmplGain",0,"fwdAmplOffset",0,"fwdPhaseGain",0,"fwdPhaseOffset",0,"reflAmplGain",0,"reflAmplOffset",0,"ref"
	.db	"lPhaseGain",0,"reflPhaseOffset",0,"cavAmplGain",0,"cavAmplOffset",0,"cavPhaseGain",0,"cavPhaseOffset",0,"refA"
	.db	"mplGain",0,"refAmplOffset",0,"refPhaseGain",0,"refPhaseOffset",0,"pulseFreq",0,"afcPhase0",0,"afcPhase1",0,"afcPh"
	.db	"ase2",0,"afcPhase3",0,"afcPhase4",0,"afcPhase5",0,"afcPhase6",0,"afcPhase7",0,"afcPhase8",0,"afcPhase9",0,"maxAmplSet"
	.db	0,"rfq_manTuneSet",0,"rfq_t1_offset",0,"rfq_t2_offset",0,"pulse_ramp",0,"stepperSetPos",0,"cavHighIlkLevel",0
	.db	"fwdHighIlkLevel",0,"pvStrTest",0,"AmplPhaseLead",0,"AmplPhaseTrail",0,"CTF_Phase",0,"CTF_Ampl",0,"Ampl-PID Of"
	.db	"f",0,"Ampl-PID On",0,"Phase-PID Off",0,"Phase-PID On",0,"SEL mode enabled",0,"Auto Phase-PID/SEL mode",0,"RF "
	.db	"Pulsing On",0,"RF Pulsing Off",0,"AFC/Cavity Tuner On",0,"AFC/Cavity Tuner Off",0,"Tuner-PID Off",0,"Tune"
	.db	"r-PID On",0,"AFC_0 On",0,"AFC_0 Off",0,"AFC_1 On",0,"AFC_1 Off",0,"AFC_2 On",0,"AFC_2 Off",0,"AFC_3 On",0,"AFC_3 Off",0
	.db	"AFC_4 On",0,"AFC_4 Off",0,"AFC_5 On",0,"AFC_5 Off",0,"AFC_6 On",0,"AFC_6 Off",0,"AFC_7 On",0,"AFC_7 Off",0,"AFC_8 On",0
	.db	"AFC_8 Off",0,"AFC_9 On",0,"AFC_9 Off",0,"timeZone",0,"srfsIPAddr",0,"ainLabel",0,"aoutLabel",0,"dinLabel",0,"doutLabe"
	.db	"l",0,"readGain",0,"readOffset",0,"setGain",0,"setOffset",0,"hostName",0,"srfsAltAddr",0,"extraInLabel",0,"Lock %d sti"
	.db	"ll held by %.15s[%d], count %d",13,10,0,"*** releaseLock(%u): Invalid lock ID ***",10,0,"*** releas"
	.db	"eLock(%u): Lock owned by: %u ***",10,0,"*** releaseLock(%u) with count of %u ***",10,0,"new value"
	.db	" for DSP reg: 0x%08lX: %.32s",13,10,0,"setDSPstate: Set: %ls",10,0,"Starting CTF calculation...",10,0,"<i"
	.db	"nvalid>",0,"PV_SendVal(%ls)",13,10,0,"PV_RcvVal(%ls)",13,10,0,"Updated copy of PV val: [%ls]",13,10,0,"new timezo"
	.db	"ne value: %d",10,0,13,10,"===== Initial Digital Input states =====",13,10,0,"%ls",13,10,0,13,10,"===== Initial Digi"
	.db	"tal Output states =====",13,10,0,"restore from param file: %.24s",10,0,"%s %s",0,"*** Saving ApplState "
	.db	"***",13,10,0,13,10,"*** Restored Application State ***",13,10,10,0,"AIN-%u",0,"AOUT-%u",0,"DIN-%u",0,"DOUT-%u",0,"ExtraIN-%"
	.db	"u",0,"DSP reports %ld%% before start of block!",13,10,0,"Program: %d  Block: %d",13,10,0,"%3ld%%      ",13,0,"D"
	.db	"SP not responding: Only %3d%% saved to flash",13,10,0,"Copying %lu bytes to DSP",13,10,0,"copyBytes",0,"C"
	.db	"opied %lu bytes to DSP",13,10,0,"FPGA never released SPI bus",13,10,0,"FPGA firmware reloaded.",13,10,0,"  De"
	.db	"vice ID: %02X %02X %02X %02X",13,10,0,"  Unprotecting all sectors...",13,10,0,"  Erasing EEPROM",0,13,10,"Una"
	.db	"ble to initiate Chip Erase: Status: 0x%02X",13,10,0,".",0,"Erase timed out",13,10,0,"  File size: %lu byt"
	.db	"es",13,10,0,"  Copying file to EEPROM...",13,10,0,"%10lu",13,0,"Error writing to EEPROM",13,10,0,"  Wrote %lu bytes"
	.db	" to EEPROM",13,10,0,"  Protecting all sectors...",13,10,0,"  Verifying EEPROM copy...",13,10,0,"Unable to res"
	.db	"et source file pos to verify EEPROM",13,10,0,"Mismatch at offset %lu:  EEPROM: 0x%02X,  File:"
	.db	" 0x%02X",13,10,0,"Verified %lu bytes",13,10,0,"Copies do not match!",13,10,0,"FPGA firmware download complete"
	.db	"!",13,10,0,"FPGA did not acknowledge write of param id %d",13,10,0,"  [%08lX",0,"  %08lX]",13,10,0,"  echoed writ"
	.db	"e address error: 0x%08lX  echoed for 0x%08lX",13,10,0,"  echoed value error: 0x%08lX  echoed "
	.db	"for 0x%08lX",13,10,0,"No 'pllInitSeqs' file and pllInitIdx > fixed list size",13,10,0,"pllInitSeqs",0,"pl"
	.db	"lInitIdx > # of sequences in file 'pllInitSeqs'",13,10,0,"Error reading PLL init sequence",13,10,0,"r"
	.db	"ead()",0,"applic task not ready",13,10,0,"New reader for Waveform #: %d",10,0,"Error writing empty resp"
	.db	"onse",10,0,"Error writing the header",10,0,"Wrote %d of %d bytes",10,0,"Usage:  autocal fwd|refl|cav <V"
	.db	"-peak> <Phase>",13,10,0,"Invalid argument: %.32s",13,10,0,"%3d",13,0,"Usage:  cmd afc on|off",13,10,"            a"
	.db	"mplPID on|off",13,10,"            phaseCtl off|pid|sel|auto",13,10,"            rfPulse on|off",13,10,"  "
	.db	"          tunerPID on|off",13,10,0,"Invalid parameters",13,10,0,"Usage:  config #  (# = 0-7)",13,10,0,"Config"
	.db	"uration command out of valid range:  %s",13,10,0,"Configuring register",13,10,0,"Usage:  read #  (# ="
	.db	" 1-4)",13,10,0,"%s is not a valid ADC #: Select 1-4",13,10,0,"Changing to ADC %d for readings",13,10,0,"Usage"
	.db	":  setadcreg reg# value  (reg# = 0-31)",13,10,0,"%s is not a valid ADC register #: Use 0-31",13,10
	.db	0,"%s is not a valid ADC register value: Use 0-0x7FF",13,10,0,"Setting ADC reg %u to %03X",13,10,0,"Usa"
	.db	"ge:  progdsp prog# file",13,10,0,"prog# must be 0-3",13,10,0,"Usage:  restartdsp prog#",13,10,0,10,"usage:  set"
	.db	"fpgafirm [-v] [fileName]",13,10,0,13,10,"Downloading %.40s to EEPROM",13,10,0,"Usage:  setpllreg reg# val"
	.db	"ue  (reg# = 0-15)",13,10,0,"%s is not a valid PLL register value: Use 0-0x0FFFFFFF",13,10,0,"Setting "
	.db	"PLL reg %u to %08lX",13,10,0,27,"[%02d;%02dH",0,"%12ld",0,"%12lu",0,"%14ld  ",0,13,10," Usage:  dspcalib <regName>",13
	.db	10,0,13,10," Register not related to a DSP value",13,10,0,13,10," Value does not require conversion",13,10,0,13,10," "
	.db	"Existing:",0,"  Gain: %s",0,"  Offset: %s",0," Test point %u:  Enter measured/actual value for %l"
	.db	"s: ",0,13,10," Unusable calibration data",13,10,0,13,10," New:",0,"Usage:  dspio <read|write|filler|waves> <o"
	.db	"n|off>",13,10,0,"invalid option",13,10,0,"Usage:  dspread <reg> <count>",13,10,0,"SPI port not open!",13,10,0,"  fill"
	.db	"er: 0x%08lX",13,10,0,"  0x%08LX:  0x%08LX  %.32s",13,10,0,"Usage:  dspwrite <reg> <value> [-f]",13,10,0,"  wr"
	.db	"ite 0x%08lX to 0x%08lX",13,10,0,"*** Reset DSP with %u errors ***",10,0,"Run program # %d",13,10,0,"CTF cal"
	.db	"c never finished",10,0,"Finished CTF calculation",10,0,"..%lu..",0,"Setting default labels for I/O si"
	.db	"gnals",13,10,0,"ID0",0,"ID1",0,"ID2",0,"ID3",0,"ID4",0,"ID5",0,"ID6",0,"ID7",0,"DSP_GP1",0,"DSP_GP2",0,"unused",0,"FPGA_DONE",0,"DSP_GP5",0,"DSP_"
	.db	"GP6",0,"DSP_GP7",0,"DSP_GP8",0,"_DSP_WR_RD",0,"DSP_GP9",0,"DSP_GP10",0,"DSP_GP11",0,"_RESET_DSP",0,"ActivityLED",0,"READY"
	.db	"_LED",0,"ON_OFF_LED",0,"DSP_NMI",0,"FPGA_SPI",0,"_ADC_CS",0,"PLL_LE",0,"_EEPROM_CS",0,"--n/a--",0,"FPGA_CL1",0,"DSP_GP3",0,"D"
	.db	"SP_GP4",0,"Setting in-RAM device config to default values",13,10,0,"Application prepping for shut"
	.db	"down",13,10,0,"applic process started",13,10,0,"*** restoreApplState() failed (%d):  Doing CPU reset "
	.db	"***",13,10,0,13,10,"***** Network did not come up! *****",13,10,0,"spi1fd: %d",13,10,0,"*** Unable to open '/dev/"
	.db	"spi1' ***",13,10,0,"spi2fd: %d",13,10,0,"*** Unable to open '/dev/spi2' ***",13,10,0,"reloading FPGA from EEP"
	.db	"ROM...",13,10,0,"free memory: %ld",13,10,0,"autocal",0,"calibrate fwd, refl, or cav Atten value",0,"cmd",0,"contr"
	.db	"ol DSP state",0,"config",0,"set the output MUXOUT (values 0-7)",0,"defaults",0,"set FPGA params to de"
	.db	"fault values",0,"dspcalib",0,"calibrate gain/offset for DSP/EGU conversion",0,"dspio",0,"enable/disab"
	.db	"le normal com with DSP",0,"dspread",0,"read values from the DSP",0,"dspwrite",0,"write a value to the"
	.db	" DSP",0,"progdsp",0,"Load program in to DSP",0,"restartdsp",0,"Restart DSP and run specified program "
	.db	"#",0,"picks ADC to send to DAC output (1-4)",0,"resetfpga",0,"Reload the FPGA firmware from EEPRO"
	.db	"M",0,"setadcreg",0,"set value of an ADC register",0,"setfpgafirm",0,"Update and reload FPGA firmware "
	.db	"image",0,"setpllreg",0,"Set value of a PLL register",0,"Show state of controller",0
	.end
