	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\daemons\epics_cad.c' 12 20 12 6 8 32
;1 //----- epics_cad.c ----- 08/01/12 -----(03/02/10)-----
;2 
;3 //  Typical diag msgs output settings:   diag msgs epics_cad 0x13a
;4 
;5 /*=========================================================================
;6   Copyright (c) 2010-2012, NSCL and Mark Davis.  All rights reserved.
;7  --------------------------------------------------------------------------
;8   Process to provide access to data elements via EPICS Channel Access proto
;9 
;10   The basic operation of this process is as follows:
;11 
;12     Task that handles all UDP traffic:
;13 
;14       - Generate beacon packets
;15 
;16       - Listen for and respond to CA SEARCH packets
;17 
;18     Task that handles all TCP traffic:
;19 
;20       - Listen for and establish new Virtual Circuit connections on request
;21 
;22       - Process commands received on each Virtual Circuit
;23 
;24       - Maintain lists of Virtual Circuits, Channels, and Subscriptions
;25 
;26       - Periodically check for events that apply to each Subscription and s
;27         out messages as needed
;28 
;29 ===========================================================================
;30   Version log (most recent first):
;31 
;32 
;33   2012-08-01 - Mark Davis
;34                - Tweaked settings and modified code to reduce overhead of
;35                  ca_tcpd task, especially when there are no clients with
;36                  subscriptions.
;37 
;38   2012-07-30 - Mark Davis
;39                - ca_udpd now sleeps during the loop if the processing of UD
;40                  packets is disabled.  Prior to this, the CPU usage would
;41                  actually increase when processing of packets was disabled.
;42                - ca_tcpd now sleeps at least one tick each pass.
;43                - Improved handling of various cas command options to proper
;44                  deal with having, none, one, or both the TCP and UDP servi
;45                  tasks running.
;46 
;47   2012-07-27 - Mark Davis
;48                - Added support for "pending" subscription msgs when the loc
;49                  the PV value cannot be obtained without blocking.
;50 
;51   2012-06-14 - Mark Davis
;52                - Modified to use a separate process to listen for and respo
;53                  to UDP packets.
;54 
;55   2012-04-24 - Mark Davis
;56                - Actual # of data elements is now returned for CREATE_CHAN 
;57 
;58   2012-04-19 - Mark Davis
;59                - The "cas stats" command now uses a new line for each secon
;60                  counts so you can see the history.
;61 
;62   2012-03-27 - Mark Davis
;63                - Began work on changes to support PV values that are NOT
;64                  defined via the REG3 and REG4 macros.
;65 
;66   2012-02-29 - Mark Davis
;67                - Fixed the logic for the temporary boosting of the limit on
;68                  time spent each cycle processing UDP packets (so it will
;69                  actually DO it now).  The boost is now controlled by two
;70                  separate values that specify the period (over multiple cyc
;71                  that the limit is boosted, and the amount the limit is fir
;72                  increased by (which decreases linearly over time).
;73                - Added anychg option to generate event monitor msgs when th
;74                  is any change at all for a value
;75 
;76   2012-02-28 - Mark Davis
;77                - Added the summary option to the cas command.
;78                - Modified code so it deals with the fact that sendto() does
;79                  currently support blocking mode.
;80 
;81   2012-02-21 - Mark Davis
;82                - Like the UDP case, consecutive outgoing messages for a giv
;83                  TCP connection are now accumulated in the outgoing packet
;84                  buffer first to help minimize the number of packets that a
;85                  actually used to send them over the physical link layer (a
;86                  the overhead and delays caused by multiple write calls whe
;87                  we don't buffer them ourselves).
;88 
;89   2012-02-17 - Mark Davis
;90                - Added ability to disable reception and processing of UDP
;91                  packets, to generate event monitor msgs for all subscripti
;92                  or just ones that have changed, and to set the max rate at
;93                  which event monitor msgs are generated.
;94 
;95   2012-02-09 - Mark Davis
;96                - All basic functions working.  UDP packets are now read and
;97                  processed (for a specified small set of allowed clients) i
;98                  sufficient numbers that clients can reconnect fairly quick
;99                - Some simple optimzations added, more to come.
;100 
;101   2012-02-06 - Mark Davis
;102                - Writes working
;103 
;104   2012-02-02 - Mark Davis
;105                - Basic search, connection, channel creation, reads, and
;106                  subscription mechanisms working.
;107                - STS (status) and TIME extended data formats functioning.
;108 
;109   2012-01-20 - Mark Davis
;110                - Started filling out the basic functionality.
;111 
;112   2010-03-02 - Mark Davis
;113                - Initial skeleton to provide a starting point, using pieces
;114                  of code copied from configd.c
;115 
;116 ===========================================================================
;117                      NOTES on efficiency and limitations
;118 ===========================================================================
;119 
;120   The Rabbit modules DEBROS currently runs on are relatively slow and very
;121   limited in resources.  We therefore have to limit the number of simultane
;122   connections we allow.  We also limit our processing of packets to those t
;123   came from an address in a list, which provides two important features:
;124 
;125     - We effectively reserve a connection for each client that MUST be able
;126       to connect so they never find us out of available connections.  In
;127       general, the addresses are those of machines running the EPICS gatewa
;128       software, which can service hundreds of clients simultaneously rather
;129       than just the few that the controller is limited to.
;130 
;131     - We eliminate the overhead of processing every UDP packet we receive,
;132       allowing us to concentrate on ones from clients we wish to allow to
;133       connect.
;134 
;135   In a large system such as the NSCL, there are frequently many unconnected
;136   channels, which results in lots of CA broadcast packets from the IOCs and
;137   gateways that are periodically searching for them.
;138 
;139   The controllers DEBROS is running on at the time of this writing simply
;140   cannot read, much less process, every one of these packets.  And while th
;141   the CA protocol is designed to deal with some loss of packets, if a serve
;142   misses too many of the ones meant for it, then clients won't be able to
;143   discover it is the source of the channels it is looking for and so won't
;144   open a connection to it.
;145 
;146   While there is no (practical) way for this service to limit the reception
;147   (and reading) of UDP packets from all clients, we CAN avoid PROCESSING on
;148   from addresses that are not in the list.  This greatly reduces the time
;149   spent on the packets we wish to ignore, allowing us to read and process
;150   more of the ones we need to.
;151 
;152   The end result:  Even with the limitations of the current hardware, we ar
;153   able to catch and process enough of the packets from the clients in the
;154   list that they are able to discover what channels we service and open
;155   a connection to access those channels in a reasonably short period.
;156 
;157   NOTES:
;158 
;159      Two ways that connections can be established with even less delay:
;160 
;161      - The CA protocol supports the concept of name servers, where machines
;162        can respond to SEARCH requests for channels that are served by other
;163        machines.  Even a low-end PC running Linux will be able to capture
;164        and respond to far more UDP packets with SEARCH requests than a
;165        Rabbit-based controller, which would provide a faster and more
;166        reliable means for the clients to discover the IP address of the
;167        controller that serves a group of channels.
;168 
;169      - Limiting the processing of broadcast packets to a small number of
;170        gateways means clients can use the name of a controller and the PVs
;171        it serves and read the data "through" one of the gateways.  While
;172        this can be handy for diagnostic purposes, the primary use of the
;173        CA service on the controllers will likely be for an EPICS SIOC to ge
;174        the data it needs using event monitors (subscriptions) on the channe
;175        the controller provides.  These channels could be created via the
;176        gateways, but the SIOC could also simply skip the discovery stage an
;177        open a virtual circuit directly to the controller, getting the
;178        address for the controller from a PV in an EPICS record.
;179 
;180  __________________________________________________________________________
;181 
;182   Small vs Large PV values:
;183 
;184      PV's come in 2 varieties:
;185 
;186         - Small, simple numeric values are defined via ModBus register macr
;187           These macros not only create a RegInfo structure that describes t
;188           value, but also declare a global variable that contains the value
;189 
;190         - Larger values are defined elsewhere (often as arrays) and kept tr
;191           of by a PV_Desc structure created using macros like PV_STRING and
;192           PV_ARRAY.  At present, the declaration of the global variable is
;193           separate from the PV_xxx macros used to track them.
;194 
;195      Both the RegInfo and PV_Desc structures contain an eventsOccured mask
;196      which is used by the CA_ProcessSubscriptions() func to determine which
;197      PV values have changed since it was last called.  The processing of
;198      subscriptions starts with a call to pvCheckAllEvents() which updates
;199      the eventsOccured masks for all the PVs at once.
;200 
;201 
;202      For the smaller PVs, the eventsOccured mask is updated by keeping a
;203      copy of the last value sent to CA clients and comparing it to the
;204      current value.  Because these values are so small, they never have
;205      to be locked for more than a moment, so locking can be kept simple
;206      and efficient by using a critical section.
;207 
;208 
;209      For the larger PV values, this approach is generally not practical
;210      for one or more of the following reasons:
;211 
;212         - Memory usage:  Keeping a separate copy means doubling the amount
;213           of memory required for the value.
;214 
;215         - Detecting a change:  Even if the memory is available, comparing
;216           hundres or thousands of bytes each time pvCheckAllEvents() is
;217           called would require too many CPU cycles.
;218 
;219         - Lock interval:  Larger values require more time to examine, copy,
;220           and/or update.  This means the method used to lock the value duri
;221           such operations has to be far more selective than the use of a
;222           critical section or even disabling the scheduler.
;223 
;224 
;225      To make matters more complex, how each of these issues is addressed
;226      affects the others:
;227 
;228 
;229         Memory usage vs locking and delays:
;230 
;231            Keeping a separate copy of a large value means increased memory
;232            usage, but can significantly reduce how long and how often the
;233            value needs to be locked.
;234 
;235            The "live" value has to be locked against changes whenever it is
;236            being updated or being read.  A separate copy (or lack of one)
;237            has no affect on how LONG we need to hold the lock during the
;238            process of updating the value.  However, it DOES have an affect
;239            on how OFTEN and how LONG we need to lock the value to read it.
;240 
;241            If we have a separate copy, then the "live" PV value only has to
;242            be locked long enough to test and (possibly) update the copy.
;243            Once the copy is updated, it can be read as long and as often as
;244            needed without interfering with the updating of the live value.
;245 
;246            If we don't have a separate copy, then the value has to be locke
;247            for however long it takes to send each new value to each client
;248            that has a subscription to the value.
;249 
;250            If the value is fairly small (e.g. a string), then this may
;251            not be a significant issue.  But for larger values (especially
;252            those larger than a single ethernet packet), sending the value t
;253            just ONE client requires far more CPU time than a simple buffer-
;254            to-buffer copy.  More time means a higher likelihood of being
;255            pre-empted, causing the lock to be held even longer.  And if it
;256            needs to be sent to multiple clients, then it just multiplies
;257            the problem.
;258 
;259            The bottom line:  Separate copies can use up precious memory, bu
;260            not using them can result in MUCH longer and more frequent delay
;261            for any process that updates the value (which is usually the
;262            main applic code, the one task that often must NOT be delayed).
;263 
;264 
;265         Detecting a change vs memory usage vs code complexity:
;266 
;267            Comparing the current value with the last one sent makes the
;268            detection of a change very simple and does not require any
;269            changes to any other code.  But for larger values, this not only
;270            requires much more memory, but requires too much CPU time.
;271 
;272            The only other option is to make the code that changes the value
;273            responsible for updating some smaller values that can be used
;274            to quickly detect that the value has changed.  One of these
;275            values is the newEvents bitmask in the PV_Desc structure.  In
;276            addition to this, another value that serves to uniquely identify
;277            the value (usually a counter or a date/time stamp) is helpful
;278            or required to support this process.
;279 
;280            Example:
;281              The PhaseCtlr controller has 2 copies of each of its waveform
;282              values.  Each copy has its own lock and time stamp.
;283 
;284              The applic task updates the 1st copy whenever the DSP has new
;285              data for the waveform and the buffer is not locked by another
;286              task.  The 2nd copy is updated by whichever task is the first
;287              to get a lock on both copies and finds that the time stamps
;288              for the copies are different.  The function called to do this
;289              also sets the appropriate bit in the newEvents mask for the
;290              value whenever it updates the 2nd copy.
;291 
;292            This approach requires that any code that changes the value also
;293            updates a smaller value (generally a counter or date/time stamp)
;294            that uniquely identifies the value.  But this small increase in
;295            complexity means we now have two small values that can be quickl
;296            compared to detect a change without the need for obtaining one o
;297            more locks.
;298 
;299 
;300         Locking delays:
;301 
;302            One thing that can't be eliminated for larger values is the need
;303            to use a finer-grained locking method.  Critical sections and
;304            even the "BKL" (Big Kernel Lock) approach are OK (and even have
;305            some advantages) when the timeframe is VERY small.  But disablin
;306            the operating system long enough to copy hundreds or thousands o
;307            bytes is definitely NOT a practical approach.
;308 
;309            A more appropriate method for these longer timeframe locks is to
;310            use semaphores.  One of the useful features of the standard Unix
;311            Linux semaphore API is the ability to NOT block when attempting
;312            to get a lock.  What this means for the CA server is that it can
;313            avoid delaying the processing of other values when it tries to
;314            process one that is currently locked by another task.
;315 
;316            This is, of course, not an ideal solution.  It means that it
;317            can take longer for clients to be informed of a change in a PV's
;318            value.  But the alternative is to ALLOW the CA server task to
;319            block whenever it needs to process a new value, which can cause
;320            delays of indeterminate length for the processing of ALL the
;321            not-yet processed new values.
;322 
;323            Where practical, the tasks that update the values can also use
;324            this same try-again-later approach to avoid delays.  But of
;325            course this is only practical if the task that needs to update
;326            the locked value can get the information needed to do so at a
;327            later time without causing other delays or problems.
;328 
;329            For example, if the data for the locked PV is in the middle of a
;330            stream of data for many PVs, then the task would either have to
;331            stop reading the stream until it got the lock (which is just
;332            another way to block waiting to get the lock), or read the
;333            data and store it somewhere until it could get the lock.
;334 
;335            But no matter how many values you can save, or how long you can
;336            save them for, eventually you could run out of space and have
;337            to deal with the same problem:  Either stop reading and wait
;338            for the lock, or loose one of the not-yet-processed values.
;339 
;340            The PhaseCtlr uses the try-again-later approach by simply not
;341            reading the newest data from the DSP until it can lock the
;342            buffer it saves the new data in.  But that just means the proble
;343            has been pushed down one more level, as the DSP will not generat
;344            a newer value until the one in it ITS buffer has been read.
;345 
;346            The bottom line:  Whether or not the try-again-later approach
;347            is/can be used, the fact is that values will generally change
;348            much faster than we can process them.  The advantage of the
;349            try-again-later approach is that it processes as many changes
;350            as it can as fast as it can, so it actually minimizes this
;351            problem.
;352 
;353 
;354        When considering all these issues, you should also keep in mind that
;355        EPICS itself and the CA protocol are a "best-effort" design.  There
;356        is no way that either can guarantee that every change to every value
;357        will be seen, transmitted, received, and processed by every entity
;358        that uses the values.
;359 
;360        The bottom line is that each entity has to work with the information
;361        it has at any given moment.  For any 2 entities, even ones using the
;362        same set of variables, this information will frequently be slightly
;363        different for any given instant in time.  But EPICS is designed to
;364        minimize these differences as much as possible and provide the lates
;365        information to each entity as quickly as possible.
;366 
;367 ===========================================================================
;368 
;369   TO-DO List
;370 
;371   ====================
;372    CONCURRENCY ISSUES
;373   ====================
;374 
;375 
;376   ===================
;377    EFFICIENCY ISSUES
;378   ===================
;379 
;380    - Use a global (shared by all connections) array of CA_Sub objects and
;381      replace the connection-specific array of CA_Sub objects with an index
;382      (or pointer) to a CA_Sub object in the global array.  This should allo
;383      me to have fewer (total) CA_Sub objects and avoid lots of unused ones
;384      in EACH CA_Con object (particulary the ones that aren't in use, in whi
;385      case ALL the CA_Sub objects for that connection are unused).
;386 
;387 
;388    - Is it possible to block on read from a UDP socket?  If so, this could
;389      improve response times for SEARCH messages.
;390 
;391         NOTE:  I don't currently use the callback mechanism for UDP sockets
;392         so that would probably need to be added properly support blocking f
;393         UDP sockets.  In fact, at the moment, I suspect if you did a blocki
;394         read on a UDP socket that it could block the caller forever if the
;395         socket stayed open and no data was received and no error occured.
;396 
;397 
;398    - Currently the throughput bottleneck caused by larger PV values is redu
;399      by limiting the # of bytes of extended PV data we allow each pass.  Bu
;400      even with this limit in place supporting larger values significantly
;401      slows down throughput.
;402 
;403      Originally I figured I would have 2 separate processes and have
;404      one of them relegated to handling all the larger values.  But that
;405      adds considerable complexity and there is a much simpler alternative
;406      that would be just about as effective (although it does require the
;407      cooperation of the client).
;408 
;409      To avoid having the larger PV values slow down the rate at which the
;410      service can send updates to the smaller values, the larger PV values
;411      must be handled by a separate connection for each client.
;412 
;413      The service can enforce this by not accepting the creation of
;414      channels for the larger PVs on the same connection as the smaller
;415      PVs.  One way this might still be usable by standard CA clients that
;416      don't know about this arrangement would be to use different IP
;417      addresses for the 2 connections so the client would not try to create
;418      channels for both the larger and smaller PVs on the same connection
;419      (I am assuming that clients generally use a single connection for
;420      all PVs hosted by the same IP address).
;421 
;422      As long as all the larger PVs support a lock whose scope is just
;423      that value, then the CA service can spread the sending of the larger
;424      values across multiple passes, processing the smaller ones as fast
;425      as it can on the separate connections.  (Spreading the sending of
;426      a single value across multiple passes avoids blocking the single
;427      CA server task, which slows down throughput for all connections).
;428 
;429      An extenstion of this approach COULD even be applied to the smaller
;430      values:  The service could check the status of a connection and not
;431      write the next value to a socket if it would block in doing so (just
;432      mark the subscription pending if it can't be sent without blocking).
;433      The current value for the same PV could still be written to other
;434      connections for other clients as soon as they have room.
;435 
;436      Of course, this assumes I can check how much space is left in the
;437      output buffer for an arbitrary fd (something DEBROS supports, but
;438      how portable is this really?).  BUT: If I have the memory for one
;439      respPkt[] for each connection, then I could test how empty IT is.
;440      That is completely portable, and provides the advantage of buffered
;441      output for each connection.
;442 
;443      In this way, each client gets updates as fast as the service can
;444      write them and the throughput for each client is primarily a function
;445      of how many PVs it has subscribed to.  Of course, there are a limited
;446      # of CPU cycles to go around, and the network library has an upper
;447      limit on the total # of bytes that can be pumped out even if they are
;448      split up amoung all the output buffers, but this approach would at
;449      least minimize the affect one client can have on any single client.
;450 
;451      The one downside, of course, is that the more PVs any given client
;452      has subscribed to the fewer updates per second it will get for any
;453      given channel.  But it is very unlikely that ANY client will actually
;454      see ALL the changes to a value unless the change threshold is set
;455      fairly high.  That is a built-in limitation to CA itself, and one
;456      that is simply not practical to avoid.  Any attempt to insure all
;457      clients see the same sequence of values just means you ensure all
;458      clients get updates at the rate of the slowest or busiest connection.
;459      And that just means that, instead of some clients missing fewer of
;460      the changes, they ALL miss the same (large) # of changes as the
;461      slowest/busiest connection.
;462 
;463    NOTES about this approach:
;464 
;465      The "slowest-common-denominator" effect just discussed still DOES
;466      apply to some degree to the connections for the  larger PV values.
;467 
;468      Locks on the larger PV values will often exist across 2 or more
;469      passes.  This means that, as long as a read lock exists for any single
;470      connection, a PV value cannot be updated.
;471 
;472      What this means is that if one client has only a few subscriptions
;473      on larger PV values, and other clients have several that overlap
;474      them, there is a much higher chance that there will be at least one
;475      read-only lock on a value.  Which means the write-lock necessary
;476      to update the value will take longer to get, and so the value will
;477      be updated less frequenly.
;478 
;479      So even though a client has only a few subscriptions, updates to
;480      those values can be delayed due to the number of other clients that
;481      subscribe to the same values.
;482 
;483      Of course, the subscription logic doesn't sit around waiting for a
;484      value to change.  It always sends any updated values for subscriptions
;485      that it can get a read-only lock on.  If a value is locked for writing
;486      (meaning it could change in the middle of a read) it simply moves to t
;487      next value in a client's list.  It NEVER blocks if it doesn't HAVE to.
;488      It will always look for the next productive thing it can do (which
;489      generally means writing any new values for PVs it CAN get a read-only
;490      lock on).
;491 
;492      The likely result is that each client will get a different subset of
;493      all the values the PVs have gone through.  So long as we mark a
;494      subscription as pending when we can't send a new value, there there
;495      is little chance that any given client will NOT get an updated value
;496      for a PV shortly after it has changed.  It may have changed multiple
;497      times since the last value that was sent, but each client with a
;498      subscription will at least get the current value not long after the
;499      first change in a series of changes.
;500 
;501 
;502   - If I have one respPkt[] per connection, I could modify the way
;503     subscriptions are handled so it writes the same msg to the respPkt[]
;504     for each connection that has an identical subscription (although that
;505     would have to include the # elements, the dbrType, etc).  But in
;506     the scenario this service will be used, this probably rarely happens,
;507     so it is probably is of no use (and may actually ADD overhead).
;508 
;509 
;510   Question:  Is there a standard Unix/Linux method to avoiding
;511              buffer-to-buffer copying when calling functions like
;512              send()?  Unless such functions are smart enough to
;513              avoid this when called with close to a packet's worth
;514              of bytes, they most likely do what my sendRespPkt()
;515              func does (add more to the existing buffer until it
;516              is full and then send it and start filling it again -
;517              but with the naggle logic thrown in as well).
;518 
;519              If there was a way to let the user-space code tell
;520              some equivalent of send() to immediately process the
;521              contents of the buffer it passed a pointer to (i.e.
;522              skip the buffering part), that could be very handy.
;523 
;524              Of course, while it reduces the overhead of doing
;525              buffer-to-buffer copies, it also more tightly binds
;526              the timing of the application code to the timing
;527              of the network layer.  Something that buffering
;528              helps to smooth out, allowing the user-space code
;529              to do something productive while the network stack
;530              handles sending the data queued up in a buffer
;531              in the background.
;532 
;533 
;534 
;535   - Test response times to make sure WRITES are processed quickly enough fo
;536     tuning using knob controls.
;537 
;538 
;539   - When sending updates for subscriptions, is there any way I can take
;540     advantage of the fact that I pretty much KNOW I am generating a bunch
;541     of event messages?  Filling in as many fields as possible in the resp
;542     message is one thing that comes to mind, although that is such a small
;543     portion of the CPU cycles that I doubt it would be significant.  Also
;544     keep in mind that the dbrType for each subscription can be different.
;545 
;546 
;547   - Regarding reconnect times after rebooting a controller:
;548 
;549        How about this:  Have a separate service (based on this code) act as
;550        a directory service.  If I had a CA server task running on a Linux
;551        box and using the option in the SEARCH request to return the IP
;552        address of a server, then IT could respond to the requests that the
;553        controllers are missing and tell the clients the IP address of the
;554        controllers.
;555 
;556        Note that such a service would not need any configuration files.  It
;557        could keep track of the existence and the health of the DEBROS
;558        controllers using the broadcasts they are already doing for the
;559        smartConfig configuration management service.
;560 
;561        NOTE:  Unless they had a list of PVs by controller type, they would
;562        have to be based strictly on the host/record name portion of the PV
;563        name.  And if I wanted a controller to respond to other names, then
;564        this external service WOULD need to know about those names.  What
;565        would probably be best would be to able to query the controllers
;566        for a list of the PV names they host.
;567 
;568        Question:  Are there not passive servers out there like this already
;569        But CA servers respond directly to the client that sent a query, so
;570        how would such a server see the responses needed to build and mainta
;571        a database of PV names?  Even if you assumed it read the raw socket
;572        data, the response packets would not normally be forwarded to the
;573        server by the switch it was connected to.  So how DO they work?
;574 
;575        Possibilities:
;576          - I was wrong about there being "passive" servers that discover PV
;577            names just be being plugged in to the network.
;578 
;579          - They work by being "proxies" or "gateways" to the CA servers.  I
;580            all search requests are sent to the name servers, and only the
;581            name servers send the queries to the CA servers, then the name
;582            servers would know what the PV names are and which ones are (or
;583            at least recently were) "alive".
;584 
;585            This could be done either by having the name servers literally b
;586            gateways between the CA clients and servers, or by configuring
;587            network switches so the CA servers don't get any such broadcast
;588            messages from anything but the name servers.
;589 
;590          - They are semi-passive:  They get the list of PVs from the EPICS
;591            database.  This wouldn't tell them what IP address to associate
;592            with each PV, but they would know what PVs are defined (and
;593            possibly more depending on how much they understand of the
;594            configuration of each record).  And they could always create
;595            channels for each of the PVs to keep tabs on which ones are "liv
;596                    ----------------------------------------
;597 
;598 
;599 ==========================
;600  UNFINISHED FUNCTIONALITY
;601 ==========================
;602 
;603   - ca_udpd task should sleep most the time when the processing of UDP
;604     packets is disabled.
;605 
;606 
;607   - Add numElems to the detailed list of subscriptions
;608 
;609 
;610   - Add the allowedClients[] list to the persistent variables stored in
;611     the devData file
;612 
;613 
;614   - Need to save and restore the minChg values for all PVs (this will be
;615     done in another module)
;616 
;617 
;618   - Add support for different output levels to the "cas state" option:
;619       - Default lists each connect and # of channels and subscriptions
;620       - Next level shows list of channels and # subscriptions on each
;621       - Next level shows everything (including IDs for each channel
;622         and subscription)
;623 
;624 
;625   - Make the cas add and del options sub-commands to the list option
;626 
;627 
;628   - When deleting an address from the allowedClients[] list, add option
;629     to shutdown any connections from that address
;630 
;631 
;632   - Option to not allow TCP connections from addresses not in the
;633     allowedClients[] list
;634 
;635 
;636   - Provide a means for each application to specify what value is used for
;637     the VAL field
;638 
;639 
;640   - Support extended types as much as possible.
;641 
;642     NOTE: The DBR_GR_ENUM and DBR_CTRL_ENUM formats seem rather impractical
;643     for use with subscriptions/monitors for any PV that changes value very
;644     often (because they include 416 bytes of string data with each msg).
;645 
;646 
;647   - What should I do about DOUBLEs (64-bit floats)?  Return error responses
;648     saying that format is not supported?  Always use 32-bit float formats
;649     in our responses and assume the client will deal with that fact that we
;650     responded using a format other than the one it requested?  Even though 
;651     can avoid use of the double formats in our own code, there may be
;652     applications that we want to occasionaly use and connect directly to th
;653     controller with, and THEY may not handle a response in a 32-bit float
;654     format when they requested a 64-bit one.
;655 
;656 
;657 ===========================================================================
;658 
;659 
;660 #include <common.h>
;661 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;662 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;663 #include <unistd.h>
;664 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;665 #include <sys/socket.h>
;666 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
;667 #include <sys/stat.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;668 #include <fcntl.h>
;669 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;670 #include <sys/modbus.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\modbus.h' 21 56 10 7 12 32
	.debug	I
;671 #include <sys/epics_cad.h>
;672 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\epics_cad.h' 8 56 9 31 7 32
	.debug	I
;673 
;674 #include <netinet/in.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
;675 #include <arpa/inet.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\arpa\inet.h' 14 56 20 12 3 27
	.debug	I
;676 #include <errno.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\errno.h' 22 0 10 11 8 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I
	.debug	I
;677 #include <stdio.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
;678 #include <services.h>
;679 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\services.h' 2 22 6 20 2 29
	.debug	I
;680 #include <string.h>
;681 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
;682 #include <time.h>
;683 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
;684 #include <tsh.h>
;685 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\tsh.h' 3 45 16 21 3 28
	.debug	I
;686 #include <poll.h>
;687 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\poll.h' 23 17 10 30 4 30
	.debug	I
;688 #include <busybox.h>
;689 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\busybox.h' 23 57 14 6 3 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\backup.h' 9 9 8 10 9 32
	.debug	I
	.debug	I
;690 #include <ctype.h>
;691 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\ctype.h' 22 48 13 9 7 24
	.debug	I
;692 
;693 
;694 #define  CA_MAX_CONS       4
;695 #define  CA_MAX_SUBSCR    64
;696 #define  CA_MAX_CHANS     64
;697 
;698 #define  USER_NAME_LEN    24
;699 #define  HOST_NAME_LEN    24
;700 
;701 
;702 
;703 #define  IPPORT_USERRESERVED  5000
;704 
;705 
;706 #define CA_MAJOR_VERSION       4
;707 #define CA_MINOR_VERSION      11
;708 #define CAS_PROTO_VERSION    411
;709 
;710 
;711 #define CA_PORT_BASE      IPPORT_USERRESERVED + 56U
;712 #define CA_SERVER_PORT    (CA_PORT_BASE + CA_MAJOR_VERSION * 2u)
;713 #define CA_REPEATER_PORT  (CA_PORT_BASE + CA_MAJOR_VERSION * 2u + 1u)
;714 
;715 #define EPICS_CAS_BEACON_PORT   5065  // dest port for UDP beacon packets
;716 
;717 #define CA_INIT_BEACON_PERIOD    25   // initial time between beacons (in m
;718 #define CA_MAX_BEACON_PERIOD  15000   // max time between beacons (in ms)
;719                                          //  must be < 65500
;720 
;721 
;722 #define DONT_REPLY    5u
;723 #define DO_REPLY     10u
;724 
;725 
;726 
;727 
;728 
;729 #ifdef RABBIT
;730   #include <sys/farprintf.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;731   #include <SHD_DLM.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;732   extern ulong  applVersTime, rtosVersTime, srfsIPAddr;
;733 #endif
;734 
;735 
;736 // This is the lower limit that can be set via the "cas events ###" cmd.
;737 // It is the shortest allowed interval between testing for changes to PVs w
;738 // active subscriptions.  This determines the maximum rate at which READ_NO
;739 // messages are sent to clients.  Smaller values result in lower latency an
;740 // more frequent messages, but can drastically increase CPU usage.
;741 #define  MIN_EVENT_PERIOD  20u
;742 
;743 // The default value for the minimum # of ms that must pass between testing
;744 // changes in and generation of event messages for channels that have event
;745 // monitors.  Smaller values mean faster updates but higher CPU usage.
;746 // This value can be changed using the "cas events ###" command.
;747 #define  CA_EVENT_PERIOD  125
;748 
;749 
;750 // The MINIMUM # of ms between iterations of ca_tcpd's main loop.  This set
;751 // an UPPER limit on how frequently the main loop executes.  It has no effe
;752 // when the processing of messages during a pass takes longer than this.
;753 // Larger values reduce CPU usage but can increase response time.
;754 #define  MIN_LOOP_TIME    50u
;755 
;756 // All the read and write operations on TCP socket connections in this modu
;757 // use the following idle timeouts.  These value specify the max # of ms a
;758 // blocking read or write can be idle (i.e. no additional bytes received or
;759 // written) without returning a timeout error.  Note that, as long as no SI
;760 // idle period exceeds this value, the operation will continue to block unt
;761 // it has successfully read or written the requested # of bytes.  So succes
;762 // reads and writes CAN block for much longer than these values, so long as
;763 // progress doesn't stop for a period exceeding these values.
;764 #define  RD_TIMEOUT   2000u
;765 //#define  WR_TIMEOUT   2000u
;766 
;767 // The # of ms to wait after all connections are closed and before exiting 
;768 // process to help insure the connections are cleanly closed
;769 #define  CAS_STOP_WAIT_TIME   2500
;770 
;771 // The # of ms to wait after the last failed attempt to create a new listen
;772 // socket.  This reduces wasted CPU time and the number of error messages i
;773 // the syslog when there is a problem (e.g. being out of socket buffers).
;774 #define  LISTEN_RETRY    30000
;775 
;776 
;777 // This sets the size of the input and output buffers used read UDP packets
;778 // and accumulate response packets for both UDP and TCP connections.  It mu
;779 // be large enough to hold the largest UDP packet that we might receive and
;780 // to hold all the responses to it.  To avoid fragementation, it should als
;781 // not be LARGER than the largest block of data that will sent in a single
;782 // link-layer (Ethernet) packet  In general, the value we want is the MSS
;783 // value used by the TCP layer.  While this can vary depending upon several
;784 // factors, the most commonly used value is probably 1460, which is the
;785 // computed as follows:
;786 //
;787 //   MSS:  Max Segment Size (refers only to the data portion of the packet)
;788 //   MTU:  Max Transmission Unit (usually 1500 for Ethernet)
;789 //   IPh:  Header size for IP packet (20)
;790 //   TCPh: Header size for TCP packet (commonly 20, but can be larger)
;791 //
;792 //   MSS = MTU - IPh - TCPh = 1500 - 20 - 20 = 1460
;793 //
;794 #define  IO_BUF_SIZE   1460   // set to most commonly used MSS
;795 
;796 
;797 
;798 
;799 typedef  struct in_addr      IN_ADDR;    // IPv4 addr in network byte order
;800 typedef  struct sockaddr    *SAP;        // pointer to type, port, addr str
;801 typedef  struct sockaddr_in  SAI;        // type, port, addr struct
;802 
;803 typedef  struct ether_addr  EtherAddr;
;804 
;805 
;806 //--- to make code more readable ---
;807 #define S16_(ptr)   (*(S16 *)(ptr))
;808 #define U16_(ptr)   (*(U16 *)(ptr))
;809 #define S32_(ptr)   (*(S32 *)(ptr))
;810 #define U32_(ptr)   (*(U32 *)(ptr))
;811 #define F32_(ptr)   (*(F32 *)(ptr))
;812 
;813 
;814 
;815 /*
;816  * !! Dont use this - it may vanish in the future !!
;817  *
;818  * Provided only for backwards compatibility with
;819  * db_access.h
;820  *
;821  */
;822 #define MAX_STRING_SIZE 40
;823 typedef char            epicsOldString[MAX_STRING_SIZE];
;824 
;825 // These are part of the protocol spec and must NOT be changed !!!
;826 #define MAX_UNITS_SIZE         8
;827 #define MAX_ENUM_STRING_SIZE  26
;828 #define MAX_ENUM_STATES       16
;829 
;830 typedef char            epicsInt8;
;831 typedef unsigned char   epicsUInt8;
;832 typedef short           epicsInt16;
;833 typedef unsigned short  epicsUInt16;
;834 typedef epicsUInt16     epicsEnum16;
;835 typedef long int        epicsInt32;
;836 typedef unsigned long   epicsUInt32;
;837 typedef float           epicsFloat32;
;838 typedef double          epicsFloat64;
;839 typedef unsigned long   epicsIndex;
;840 typedef epicsInt32      epicsStatus;
;841 
;842 
;843 typedef epicsOldString  dbr_string_t;
;844 typedef epicsUInt8      dbr_char_t;
;845 typedef epicsInt16      dbr_short_t;
;846 typedef epicsUInt16     dbr_ushort_t;
;847 typedef epicsInt16      dbr_int_t;
;848 typedef epicsUInt16     dbr_enum_t;
;849 typedef epicsInt32      dbr_long_t;
;850 typedef epicsUInt32     dbr_ulong_t;
;851 typedef epicsFloat32    dbr_float_t;
;852 typedef epicsFloat64    dbr_double_t;
;853 
;854 typedef epicsUInt16     dbr_put_ackt_t;
;855 typedef epicsUInt16     dbr_put_acks_t;
;856 typedef epicsOldString  dbr_stsack_string_t;
;857 typedef epicsOldString  dbr_class_name_t;
;858 
;859 
;860 typedef struct epicsTimeStamp {
;861     epicsUInt32    secPastEpoch;   /* seconds since 0000 Jan 1, 1990 */
;862     epicsUInt32    nsec;           /* nanoseconds within second */
;863 } epicsTimeStamp;
;864 
;865 
;866 // Compound types for CA messages that include a PV value
;867 
;868 //! CA basic data types  (just the Value)
;869 #define DBR_STRING          0
;870 #define DBR_SHORT           1
;871 #define DBR_INT            DBR_SHORT
;872 #define DBR_FLOAT           2
;873 #define DBR_ENUM            3
;874 #define DBR_CHAR            4
;875 #define DBR_LONG            5
;876 #define DBR_DOUBLE          6
;877 
;878   // Status:  Status + Alarm Severity + Value
;879 #define DBR_STS_STRING      7
;880 #define DBR_STS_SHORT       8
;881 #define DBR_STS_INT        DBR_STS_SHORT
;882 #define DBR_STS_FLOAT       9
;883 #define DBR_STS_ENUM       10
;884 #define DBR_STS_CHAR       11
;885 #define DBR_STS_LONG       12
;886 #define DBR_STS_DOUBLE     13
;887 
;888   // Time:  Status + Alarm Severity + Time Stamp + Value
;889 #define DBR_TIME_STRING    14
;890 #define DBR_TIME_SHORT     15
;891 #define DBR_TIME_INT       DBR_TIME_SHORT
;892 #define DBR_TIME_FLOAT     16
;893 #define DBR_TIME_ENUM      17
;894 #define DBR_TIME_CHAR      18
;895 #define DBR_TIME_LONG      19
;896 #define DBR_TIME_DOUBLE    20
;897 
;898   // Graphical:  Status + Alarm Severity + Alarm/Warn limits + Value
;899 #define DBR_GR_STRING      21
;900 #define DBR_GR_SHORT       22
;901 #define DBR_GR_INT         DBR_GR_SHORT
;902 #define DBR_GR_FLOAT       23
;903 #define DBR_GR_ENUM        24
;904 #define DBR_GR_CHAR        25
;905 #define DBR_GR_LONG        26
;906 #define DBR_GR_DOUBLE      27
;907 
;908   // Control:  Status + Alarm Severity + Alarm/Warn limits + Ctl limits + V
;909 #define DBR_CTRL_STRING    28
;910 #define DBR_CTRL_SHORT     29
;911 #define DBR_CTRL_INT       DBR_CTRL_SHORT
;912 #define DBR_CTRL_FLOAT     30
;913 #define DBR_CTRL_ENUM      31
;914 #define DBR_CTRL_CHAR      32
;915 #define DBR_CTRL_LONG      33
;916 #define DBR_CTRL_DOUBLE    34
;917 
;918   // Extra:
;919 #define DBR_PUT_ACKT       35    // 16-bit value
;920 #define DBR_PUT_ACKS       36    // 16-bit value
;921 #define DBR_STSACK_STRING  37    // 40-char string value
;922 #define DBR_CLASS_NAME     38    // 40-char string value
;923 
;924 #define LAST_BUFFER_TYPE  DBR_CLASS_NAME
;925 
;926 #define VALID_DB_REQ(x)    (((x) >= 0) AND ((x) <= LAST_BUFFER_TYPE))
;927 #define INVALID_DB_REQ(x)  (((x) <  0) OR  ((x) >  LAST_BUFFER_TYPE))
;928 
;929 
;930 #define  EXT_TYPE_NONE    0
;931 #define  EXT_TYPE_STS     1
;932 #define  EXT_TYPE_TIME    2
;933 #define  EXT_TYPE_GR      3
;934 #define  EXT_TYPE_CTRL    4
;935 #define  EXT_TYPE_EXTRA   5
;936 
;937 
;938 const far char far *baseTypeName[] = {
;939   "STRING", "SHORT", "FLOAT", "ENUM", "CHAR", "LONG", "DOUBLE" };
	.dseg
_baseTypeName::
	.dw	word (phys @1)
	.dw	phys @1 >> 16
	.dw	word (phys @1+7)
	.dw	phys @1+7 >> 16
	.dw	word (phys @1+13)
	.dw	phys @1+13 >> 16
	.dw	word (phys @1+19)
	.dw	phys @1+19 >> 16
	.dw	word (phys @1+24)
	.dw	phys @1+24 >> 16
	.dw	word (phys @1+29)
	.dw	phys @1+29 >> 16
	.dw	word (phys @1+34)
	.dw	phys @1+34 >> 16
	.debug	G _baseTypeName 32 0
;940 
;941 const far char far *extTypeName[] = {
;942   "", "STS", "TIME", "GR", "CTRL", "EXTRA" };
_extTypeName::
	.dw	word (phys @1+6)
	.dw	phys @1+6 >> 16
	.dw	word (phys @1+41)
	.dw	phys @1+41 >> 16
	.dw	word (phys @1+45)
	.dw	phys @1+45 >> 16
	.dw	word (phys @1+50)
	.dw	phys @1+50 >> 16
	.dw	word (phys @1+53)
	.dw	phys @1+53 >> 16
	.dw	word (phys @1+58)
	.dw	phys @1+58 >> 16
	.debug	G _extTypeName 34 0
;943 
;944 
;945 //--- conversion from base DBR value types to PV interface types ---
;946 
;947 typedef struct {
;948   uint  pvType;  // PV data type equiv to base DBR type
;949   uint  size;    // The size of the DBR data type
;950   bool  reorder; // Do the bytes need to be reordered (from host to network
;951 }  TypeData;
;952 
;953 const far TypeData dbfToPV[] = {
;954   { DT_STR,  40,  false },  // DBR_STRING
	.defseg	FARCONST
	.seg	FARCONST
_dbfToPV::
	.dw	0x5
	.dw	0x28
	.db	0
;955   { DT_U16,   2,  true  },  // DBR_SHORT
	.dw	0x1
	.dw	0x2
	.db	0x1
;956   { DT_F32,   4,  true  },  // DBR_FLOAT
	.dw	0x4
	.dw	0x4
	.db	0x1
;957   { DT_U16,   2,  true  },  // DBR_ENUM
	.dw	0x1
	.dw	0x2
	.db	0x1
;958   { DT_U16,   2,  true  },  // DBR_CHAR
	.dw	0x1
	.dw	0x2
	.db	0x1
;959   { DT_U32,   4,  true  },  // DBR_LONG
	.dw	0x3
	.dw	0x4
	.db	0x1
;960   { DT_F32,   8,  true  }   // DBR_DOUBLE
	.dw	0x4
	.dw	0x8
	.db	0x1
;961 };
	.debug	G _dbfToPV 35 8
;962 
;963 
;964 const far uint  pvTypeToDBF[] = {
;965   DBR_SHORT,  //  DT_S16  16-bit signed integer
_pvTypeToDBF::
	.dw	0x1
;966   DBR_SHORT,  //  DT_U16  16-bit unsigned integer
	.dw	0x1
;967   DBR_LONG,   //  DT_S32  32-bit signed integer
	.dw	0x5
;968   DBR_LONG,   //  DT_U32  32-bit unsigned integer
	.dw	0x5
;969   DBR_FLOAT,  //  DT_F32  32-bit IEEE Float
	.dw	0x2
;970   DBR_STRING, //  DT_STR  null-terminated string (for conversions only)
	.dw	0
;971   DBR_CHAR,   //  DT_U8   8-bit unsigned integer
	.dw	0x4
;972   DBR_CHAR    //  DT_S8   8-bit signed integer
;973 };
	.dw	0x4
	.debug	G _pvTypeToDBF 37 8
;974 
;975 
;976 //--- The offset of the data value in each of the extended type structures 
;977 const far uint  dbrValOffset[] = {
;978 // STR SHRT  FLT ENUM CHAR LONG  DBL
;979     0,   0,   0,   0,   0,   0,   0,  // EXT_TYPE_NONE
_dbrValOffset::
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
	.dw	0
;980     4,   4,   4,   4,   5,   4,   8,  // EXT_TYPE_STS
	.dw	0x4
	.dw	0x4
	.dw	0x4
	.dw	0x4
	.dw	0x5
	.dw	0x4
	.dw	0x8
;981    12,  14,  12,  14,  15,  12,  16,  // EXT_TYPE_TIME
	.dw	0xc
	.dw	0xe
	.dw	0xc
	.dw	0xe
	.dw	0xf
	.dw	0xc
	.dw	0x10
;982     0,  24,  40, 422,  19,  36,  64,  // EXT_TYPE_GR
	.dw	0
	.dw	0x18
	.dw	0x28
	.dw	0x1a6
	.dw	0x13
	.dw	0x24
	.dw	0x40
;983     0,  28,  48, 422,  21,  44,  80,  // EXT_TYPE_CTRL
	.dw	0
	.dw	0x1c
	.dw	0x30
	.dw	0x1a6
	.dw	0x15
	.dw	0x2c
	.dw	0x50
;984     0,   0,   8,   0                  // EXT_TYPE_EXTRA
	.dw	0
	.dw	0
	.dw	0x8
;985 };
	.dw	0
	.debug	G _dbrValOffset 38 8
;986 
;987 
;988 
;989 //===== VALUES WITH STATUS STRUCTURES =====
;990 
;991 /* structure for a  string status field */
;992 struct dbr_sts_string {      // DBR_STS_STRING
;993   dbr_short_t   status;            /* status of value */
;994   dbr_short_t   severity;          /* severity of alarm */
;995   dbr_string_t  value;             /* current value */
;996 };
;997 
;998 /* structure for a short status field */
;999 struct dbr_sts_short {       // DBR_STS_SHORT, DBR_STS_INT
;1000   dbr_short_t  status;             /* status of value */
;1001   dbr_short_t  severity;           /* severity of alarm */
;1002   dbr_short_t  value;              /* current value */
;1003 };
;1004 
;1005 /* structure for a  float status field */
;1006 struct dbr_sts_float {       // DBR_STS_FLOAT
;1007   dbr_short_t  status;             /* status of value */
;1008   dbr_short_t  severity;           /* severity of alarm */
;1009   dbr_float_t  value;              /* current value */
;1010 };
;1011 
;1012 /* structure for a  enum status field */
;1013 struct dbr_sts_enum {        // DBR_STS_ENUM
;1014   dbr_short_t  status;             /* status of value */
;1015   dbr_short_t  severity;           /* severity of alarm */
;1016   dbr_enum_t   value;              /* current value */
;1017 };
;1018 
;1019 /* structure for a char status field */
;1020 struct dbr_sts_char {        // DBR_STS_CHAR
;1021   dbr_short_t  status;             /* status of value */
;1022   dbr_short_t  severity;           /* severity of alarm */
;1023   dbr_char_t   RISC_pad;           /* RISC alignment */
;1024   dbr_char_t   value;              /* current value */
;1025 };
;1026 
;1027 /* structure for a long status field */
;1028 struct dbr_sts_long {        // DBR_STS_LONG
;1029   dbr_short_t  status;             /* status of value */
;1030   dbr_short_t  severity;           /* severity of alarm */
;1031   dbr_long_t   value;              /* current value */
;1032 };
;1033 
;1034 /* structure for a double status field */
;1035 struct dbr_sts_double {      // DBR_STS_DOUBLE
;1036   dbr_short_t   status;            /* status of value */
;1037   dbr_short_t   severity;          /* severity of alarm */
;1038   dbr_long_t    RISC_pad;          /* RISC alignment */
;1039   dbr_double_t  value;             /* current value */
;1040 };
;1041 
;1042 
;1043 //===== VALUES WITH STATUS AND TIME STRUCTURES =====
;1044 
;1045 /* structure for a  string time field */
;1046 struct dbr_time_string {     // DBR_TIME_STRING
;1047   dbr_short_t     status;          /* status of value */
;1048   dbr_short_t     severity;        /* severity of alarm */
;1049   epicsTimeStamp  stamp;           /* time stamp */
;1050   dbr_string_t    value;           /* current value */
;1051 };
;1052 
;1053 /* structure for an short time field */
;1054 struct dbr_time_short {      // DBR_TIME_SHORT, DBR_TIME_INT
;1055   dbr_short_t     status;          /* status of value */
;1056   dbr_short_t     severity;        /* severity of alarm */
;1057   epicsTimeStamp  stamp;           /* time stamp */
;1058   dbr_short_t     RISC_pad;        /* RISC alignment */
;1059   dbr_short_t     value;           /* current value */
;1060 };
;1061 
;1062 /* structure for a  float time field */
;1063 struct dbr_time_float {      // DBR_TIME_FLOAT
;1064   dbr_short_t     status;          /* status of value */
;1065   dbr_short_t     severity;        /* severity of alarm */
;1066   epicsTimeStamp  stamp;           /* time stamp */
;1067   dbr_float_t     value;           /* current value */
;1068 };
;1069 
;1070 /* structure for a  enum time field */
;1071 struct dbr_time_enum {       // DBR_TIME_ENUM
;1072   dbr_short_t     status;          /* status of value */
;1073   dbr_short_t     severity;        /* severity of alarm */
;1074   epicsTimeStamp  stamp;           /* time stamp */
;1075   dbr_short_t     RISC_pad;        /* RISC alignment */
;1076   dbr_enum_t      value;           /* current value */
;1077 };
;1078 
;1079 /* structure for a char time field */
;1080 struct dbr_time_char {       // DBR_TIME_CHAR
;1081   dbr_short_t     status;          /* status of value */
;1082   dbr_short_t     severity;        /* severity of alarm */
;1083   epicsTimeStamp  stamp;           /* time stamp */
;1084   dbr_short_t     RISC_pad0;       /* RISC alignment */
;1085   dbr_char_t      RISC_pad1;       /* RISC alignment */
;1086   dbr_char_t      value;           /* current value */
;1087 };
;1088 
;1089 /* structure for a long time field */
;1090 struct dbr_time_long {       // DBR_TIME_LONG
;1091   dbr_short_t     status;          /* status of value */
;1092   dbr_short_t     severity;        /* severity of alarm */
;1093   epicsTimeStamp  stamp;           /* time stamp */
;1094   dbr_long_t      value;           /* current value */
;1095 };
;1096 
;1097 /* structure for a double time field */
;1098 struct dbr_time_double {     // DBR_TIME_DOUBLE
;1099   dbr_short_t     status;          /* status of value */
;1100   dbr_short_t     severity;        /* severity of alarm */
;1101   epicsTimeStamp  stamp;           /* time stamp */
;1102   dbr_long_t      RISC_pad;        /* RISC alignment */
;1103   dbr_double_t    value;           /* current value */
;1104 };
;1105 
;1106 
;1107 //===== VALUES WITH STATUS AND GRAPHIC STRUCTURES =====
;1108 
;1109 /* structure for a graphic string */
;1110   /* not implemented; use struct dbr_sts_string */
;1111 
;1112 /* structure for a graphic short field */
;1113 struct dbr_gr_short {        // DBR_GR_SHORT, DBR_GR_INT
;1114   dbr_short_t  status;             /* status of value */
;1115   dbr_short_t  severity;           /* severity of alarm */
;1116   char    units[MAX_UNITS_SIZE];   /* units of value */
;1117   dbr_short_t  upper_disp_limit;   /* upper limit of graph */
;1118   dbr_short_t  lower_disp_limit;   /* lower limit of graph */
;1119   dbr_short_t  upper_alarm_limit;
;1120   dbr_short_t  upper_warning_limit;
;1121   dbr_short_t  lower_warning_limit;
;1122   dbr_short_t  lower_alarm_limit;
;1123   dbr_short_t  value;              /* current value */
;1124 };
;1125 
;1126 /* structure for a graphic floating point field */
;1127 struct dbr_gr_float {        // DBR_GR_FLOAT
;1128   dbr_short_t  status;             /* status of value */
;1129   dbr_short_t  severity;           /* severity of alarm */
;1130   dbr_short_t  precision;          /* number of decimal places */
;1131   dbr_short_t  RISC_pad0;          /* RISC alignment */
;1132   char    units[MAX_UNITS_SIZE];   /* units of value */
;1133   dbr_float_t  upper_disp_limit;   /* upper limit of graph */
;1134   dbr_float_t  lower_disp_limit;   /* lower limit of graph */
;1135   dbr_float_t  upper_alarm_limit;
;1136   dbr_float_t  upper_warning_limit;
;1137   dbr_float_t  lower_warning_limit;
;1138   dbr_float_t  lower_alarm_limit;
;1139   dbr_float_t  value;              /* current value */
;1140 };
;1141 
;1142 /* structure for a graphic enumeration field */
;1143 struct dbr_gr_enum {         // DBR_GR_ENUM
;1144   dbr_short_t  status;             /* status of value */
;1145   dbr_short_t  severity;           /* severity of alarm */
;1146   dbr_short_t  no_str;             /* number of strings */
;1147   char    strs[MAX_ENUM_STATES][MAX_ENUM_STRING_SIZE];  /* state strings */
;1148   dbr_enum_t   value;              /* current value */
;1149 };
;1150 
;1151 /* structure for a graphic char field */
;1152 struct dbr_gr_char {         // DBR_GR_CHAR
;1153   dbr_short_t  status;             /* status of value */
;1154   dbr_short_t  severity;           /* severity of alarm */
;1155   char    units[MAX_UNITS_SIZE];   /* units of value */
;1156   dbr_char_t   upper_disp_limit;   /* upper limit of graph */
;1157   dbr_char_t   lower_disp_limit;   /* lower limit of graph */
;1158   dbr_char_t   upper_alarm_limit;
;1159   dbr_char_t   upper_warning_limit;
;1160   dbr_char_t   lower_warning_limit;
;1161   dbr_char_t   lower_alarm_limit;
;1162   dbr_char_t   RISC_pad;           /* RISC alignment */
;1163   dbr_char_t   value;              /* current value */
;1164 };
;1165 
;1166 /* structure for a graphic long field */
;1167 struct dbr_gr_long {         // DBR_GR_LONG
;1168   dbr_short_t  status;             /* status of value */
;1169   dbr_short_t  severity;           /* severity of alarm */
;1170   char    units[MAX_UNITS_SIZE];   /* units of value */
;1171   dbr_long_t   upper_disp_limit;   /* upper limit of graph */
;1172   dbr_long_t   lower_disp_limit;   /* lower limit of graph */
;1173   dbr_long_t   upper_alarm_limit;
;1174   dbr_long_t   upper_warning_limit;
;1175   dbr_long_t   lower_warning_limit;
;1176   dbr_long_t   lower_alarm_limit;
;1177   dbr_long_t   value;              /* current value */
;1178 };
;1179 
;1180 /* structure for a graphic double field */
;1181 struct dbr_gr_double {       // DBR_GR_DOUBLE
;1182   dbr_short_t  status;             /* status of value */
;1183   dbr_short_t  severity;           /* severity of alarm */
;1184   dbr_short_t  precision;          /* number of decimal places */
;1185   dbr_short_t  RISC_pad0;          /* RISC alignment */
;1186   char    units[MAX_UNITS_SIZE];   /* units of value */
;1187   dbr_double_t  upper_disp_limit;  /* upper limit of graph */
;1188   dbr_double_t  lower_disp_limit;  /* lower limit of graph */
;1189   dbr_double_t  upper_alarm_limit;
;1190   dbr_double_t  upper_warning_limit;
;1191   dbr_double_t  lower_warning_limit;
;1192   dbr_double_t  lower_alarm_limit;
;1193   dbr_double_t  value;             /* current value */
;1194 };
;1195 
;1196 
;1197 
;1198 //===== VALUES WITH STATUS, GRAPHIC and CONTROL STRUCTURES =====
;1199 
;1200 /* structure for a control string */
;1201   /* not implemented; use struct dbr_sts_string */
;1202 
;1203 /* structure for a control integer */
;1204 struct dbr_ctrl_short {      // DBR_CTRL_SHORT, DBR_CTRL_INT
;1205   dbr_short_t  status;             /* status of value */
;1206   dbr_short_t  severity;           /* severity of alarm */
;1207   char    units[MAX_UNITS_SIZE];   /* units of value */
;1208   dbr_short_t  upper_disp_limit;   /* upper limit of graph */
;1209   dbr_short_t  lower_disp_limit;   /* lower limit of graph */
;1210   dbr_short_t  upper_alarm_limit;
;1211   dbr_short_t  upper_warning_limit;
;1212   dbr_short_t  lower_warning_limit;
;1213   dbr_short_t  lower_alarm_limit;
;1214   dbr_short_t  upper_ctrl_limit;   /* upper control limit */
;1215   dbr_short_t  lower_ctrl_limit;   /* lower control limit */
;1216   dbr_short_t  value;              /* current value */
;1217 };
;1218 
;1219 /* structure for a control floating point field */
;1220 struct dbr_ctrl_float {      // DBR_CTRL_FLOAT
;1221   dbr_short_t  status;             /* status of value */
;1222   dbr_short_t  severity;           /* severity of alarm */
;1223   dbr_short_t  precision;          /* number of decimal places */
;1224   dbr_short_t  RISC_pad;           /* RISC alignment */
;1225   char    units[MAX_UNITS_SIZE];   /* units of value */
;1226   dbr_float_t  upper_disp_limit;   /* upper limit of graph */
;1227   dbr_float_t  lower_disp_limit;   /* lower limit of graph */
;1228   dbr_float_t  upper_alarm_limit;
;1229   dbr_float_t  upper_warning_limit;
;1230   dbr_float_t  lower_warning_limit;
;1231   dbr_float_t  lower_alarm_limit;
;1232   dbr_float_t  upper_ctrl_limit;   /* upper control limit */
;1233   dbr_float_t  lower_ctrl_limit;   /* lower control limit */
;1234   dbr_float_t  value;              /* current value */
;1235 };
;1236 
;1237 /* structure for a control enumeration field */
;1238 struct dbr_ctrl_enum {       // DBR_CTRL_ENUM
;1239   dbr_short_t  status;             /* status of value */
;1240   dbr_short_t  severity;           /* severity of alarm */
;1241   dbr_short_t  no_str;             /* number of strings */
;1242   char  strs[MAX_ENUM_STATES][MAX_ENUM_STRING_SIZE];  /* state strings */
;1243   dbr_enum_t   value;              /* current value */
;1244 };
;1245 
;1246 /* structure for a control char field */
;1247 struct dbr_ctrl_char {       // DBR_CTRL_CHAR
;1248   dbr_short_t  status;             /* status of value */
;1249   dbr_short_t  severity;           /* severity of alarm */
;1250   char    units[MAX_UNITS_SIZE];   /* units of value */
;1251   dbr_char_t   upper_disp_limit;   /* upper limit of graph */
;1252   dbr_char_t   lower_disp_limit;   /* lower limit of graph */
;1253   dbr_char_t   upper_alarm_limit;
;1254   dbr_char_t   upper_warning_limit;
;1255   dbr_char_t   lower_warning_limit;
;1256   dbr_char_t   lower_alarm_limit;
;1257   dbr_char_t   upper_ctrl_limit;   /* upper control limit */
;1258   dbr_char_t   lower_ctrl_limit;   /* lower control limit */
;1259   dbr_char_t   RISC_pad;           /* RISC alignment */
;1260   dbr_char_t   value;              /* current value */
;1261 };
;1262 
;1263 /* structure for a control long field */
;1264 struct dbr_ctrl_long {       // DBR_CTRL_LONG
;1265   dbr_short_t  status;             /* status of value */
;1266   dbr_short_t  severity;           /* severity of alarm */
;1267   char    units[MAX_UNITS_SIZE];   /* units of value */
;1268   dbr_long_t   upper_disp_limit;   /* upper limit of graph */
;1269   dbr_long_t   lower_disp_limit;   /* lower limit of graph */
;1270   dbr_long_t   upper_alarm_limit;
;1271   dbr_long_t   upper_warning_limit;
;1272   dbr_long_t   lower_warning_limit;
;1273   dbr_long_t   lower_alarm_limit;
;1274   dbr_long_t   upper_ctrl_limit;   /* upper control limit */
;1275   dbr_long_t   lower_ctrl_limit;   /* lower control limit */
;1276   dbr_long_t   value;              /* current value */
;1277 };
;1278 
;1279 /* structure for a control double field */
;1280 struct dbr_ctrl_double {     // DBR_CTRL_DOUBLE
;1281   dbr_short_t   status;            /* status of value */
;1282   dbr_short_t   severity;          /* severity of alarm */
;1283   dbr_short_t   precision;         /* number of decimal places */
;1284   dbr_short_t   RISC_pad0;         /* RISC alignment */
;1285   char    units[MAX_UNITS_SIZE];   /* units of value */
;1286   dbr_double_t  upper_disp_limit;  /* upper limit of graph */
;1287   dbr_double_t  lower_disp_limit;  /* lower limit of graph */
;1288   dbr_double_t  upper_alarm_limit;
;1289   dbr_double_t  upper_warning_limit;
;1290   dbr_double_t  lower_warning_limit;
;1291   dbr_double_t  lower_alarm_limit;
;1292   dbr_double_t  upper_ctrl_limit;  /* upper control limit */
;1293   dbr_double_t  lower_ctrl_limit;  /* lower control limit */
;1294   dbr_double_t  value;             /* current value */
;1295 };
;1296 
;1297 
;1298 //===== MISC =====
;1299 
;1300 /* structure for a  string status and ack field */
;1301 struct dbr_stsack_string {   // DBR_STSACK_STRING
;1302   dbr_ushort_t  status;            /* status of value */
;1303   dbr_ushort_t  severity;          /* severity of alarm */
;1304   dbr_ushort_t  ackt;              /* ack transient? */
;1305   dbr_ushort_t  acks;              /* ack severity */
;1306   dbr_string_t  value;             /* current value */
;1307 };
;1308 
;1309 
;1310 // CA Access Rights
;1311 #define CA_NO_ACCESS          0
;1312 #define CA_READ_ACCESS        1
;1313 #define CA_WRITE_ACCESS       2
;1314 #define CA_READ_WRITE_ACCESS  3
;1315 
;1316 
;1317 
;1318 //--- Bitmasks settable via the "diag msgs" command.  These generate ---
;1319 //--- diagnostic messages that are written to syslog ---
;1320 #define  ShowUDPPkts  (DiagFlags_ & 0x01)
;1321 #define  ShowTCPPkts  (DiagFlags_ & 0x02)
;1322 #define  ShowUDPCmds  (DiagFlags_ & 0x04)
;1323 #define  ShowTCPCmds  (DiagFlags_ & 0x08)
;1324 
;1325 #define  ShowSearch   (DiagFlags_ & 0x10)
;1326 #define  ShowCons     (DiagFlags_ & 0x20)
;1327 #define  ShowEvents   (DiagFlags_ & 0x40)
;1328 
;1329 
;1330 
;1331 
;1332 /*
;1333 //--- Info about a CA Channel ---
;1334 typedef struct  {
;1335   uint  pvid;  // PV ID value returned by pvGetID()  (0xFFFF ==> unused)
;1336   ulong  cid;  // client value provided by the client
;1337 } CA_Chan;
;1338 */
;1339 
;1340 typedef  uint  PVID;
;1341 typedef  uint  SID;
;1342 
;1343 #define  CHAN_UNUSED  ((PVID)(-1))
;1344 #define  SID_UNUSED   ((SID)(-1))
;1345 
;1346 
;1347 //--- Info about a CA Subscription ---
;1348 typedef struct  {
;1349   SID sid;         // chan SID (idx in to CA_Con.chans[])  (0xFFFF ==> unus
;1350   ulong subID;     // SubscriptionID provided by the client
;1351   uchar monMask;   // monitor mask provided by the client
;1352   uchar dbrType;   // format for asynchronous event messages
;1353   uint  numElems;  // # of elements
;1354 } CA_Sub;
;1355 
;1356 //--- Info about a CA connection (Virtual Circuit) ---
;1357 typedef struct  {
;1358   fd_t   fd;                       // fd for connection; <0 means unused en
;1359   bool   subEnabled;               // Subscriptions enabled/disabled flag
;1360   PVID   chans[CA_MAX_CHANS];      // pvIDs for open Chans: (0xFFFF ==> unu
;1361   uint   maxChanNum;               // largest index (+1) used in chans[]
;1362   CA_Sub subs[CA_MAX_SUBSCR];      // list of Subscriptions
;1363   uint   maxSubNum;                // largest index (+1) used in subs[]
;1364   char   hostName[HOST_NAME_LEN];  // host name provided by client
;1365   char   userName[USER_NAME_LEN];  // user name provided by client
;1366   SAI    in_Addr;                  // client addr
;1367 } CA_Con;
;1368 
;1369 CA_Con far caCons[CA_MAX_CONS];
;1370 
;1371 
;1372 
;1373 typedef struct  {
;1374   fd_t   fd;          // socket fd to read from/write to
;1375   uint   type;        // specifies what (if any) I/O buffers to use
;1376   CA_Con far *con;    // NULL for UDP connection
;1377   bool   showCmds;
;1378   bool   versRespPending;
;1379 } ConInfo;
;1380 
;1381 //--- values for ConInfo.type ---
;1382 #define  UDP_CON  0    // use rcvdPkt[] and respPktUDP[] to buffer input/ou
;1383 #define  TCP_BUF  1    // use respPktTCP[] to buffer output
;1384 #define  TCP_DIR  2    // read/write directly from/to ConInfo.fd
;1385 
;1386 
;1387 //--- rcv and send buffers for UDP messages ---
;1388 uchar far rcvdPkt[IO_BUF_SIZE];  // for msgs rcvd in a UDP broadcast packet
;1389 uint  rcvdPktSize;        // size of packet currently in rcvdPkt
;1390 uint  nextRcvdPktByte;    // offset of next unused byte in rcvdPkt[]
;1391 
;1392 uchar far respPktUDP[IO_BUF_SIZE];  // buffer for msgs sent to a client via
;1393 uint  respPktUsedUDP;        // # bytes used/ready to send
;1394 SAI  respAddrUDP;            // ptr to net address to send respPkt to
;1395 
;1396 
;1397 //--- send buffer for smaller PV values ---
;1398 uchar far respPktTCP[IO_BUF_SIZE];  // buffer for msgs sent to a client via
;1399 uint  respPktUsedTCP;        // # bytes used/ready to send
;1400 
;1401 
;1402 
;1403 //--- List of IP addresses for which we will process UDP packets ---
;1404 ulong  allowedClients[CA_MAX_CONS];  // stored in network-byte order
;1405 
;1406 
;1407 
;1408 
;1409 typedef struct caMsgHdr {
;1410   U16  cmd;    // see values below
;1411   U16  size;   // # bytes sent after header that are part of this msg
;1412   U16  fld3;   // msg dependent
;1413   U16  fld4;   // msg dependent
;1414   U32  fld5;   // msg dependent
;1415   U32  fld6;   // msg dependent
;1416   //---------- end of header -------------
;1417   uchar  data[128];   // for faster responses when payload is small enough
;1418   int    dataSize;    // # of bytes in data[]
;1419 }  CA_MsgHdr;
;1420 
;1421 
;1422 // max # payload size that will fit in the CA_MsgHdr structure.  For payloa
;1423 // larger than this (e.g. arrays, waveform data, long strings), the reading
;1424 // and writing of the payload has to be handled separately from the msg hea
;1425 #define  MAX_MSG_DATA    ( sizeof(((CA_MsgHdr *)0)->data) )
;1426 
;1427 
;1428 //--- CA_MsgHdr.cmd values (msg types) ---
;1429 #define CA_PROTO_VERSION         0u   // set minor version and priority (us
;1430 #define CA_PROTO_EVENT_ADD       1u   // add an event
;1431 #define CA_PROTO_EVENT_CANCEL    2u   // cancel an event
;1432 #define CA_PROTO_READ            3u   // --- depricated ---
;1433 #define CA_PROTO_WRITE           4u   // write a channel value
;1434 #define CA_PROTO_SNAPSHOT        5u   // --- obsolete ---
;1435 #define CA_PROTO_SEARCH          6u   // IOC channel search
;1436 #define CA_PROTO_BUILD           7u   // --- obsolete ---
;1437 #define CA_PROTO_EVENTS_OFF      8u   // flow control
;1438 #define CA_PROTO_EVENTS_ON       9u   // flow control
;1439 #define CA_PROTO_READ_SYNC       10u  // --- depricated ---
;1440 #define CA_PROTO_ERROR           11u  // an operation failed
;1441 #define CA_PROTO_CLEAR_CHANNEL   12u  // free chan resources
;1442 #define CA_PROTO_RSRV_IS_UP      13u  // CA server has joined the net
;1443 #define CA_PROTO_NOT_FOUND       14u  // channel not found
;1444 #define CA_PROTO_READ_NOTIFY     15u  // add a one shot event
;1445 #define CA_PROTO_READ_BUILD      16u  // --- obsolete ---
;1446 #define REPEATER_CONFIRM         17u  // registration confirmation
;1447 #define CA_PROTO_CREATE_CHAN     18u  // client creates channel in server
;1448 #define CA_PROTO_WRITE_NOTIFY    19u  // notify after write chan value
;1449 #define CA_PROTO_CLIENT_NAME     20u  // CA V4.1 identify client
;1450 #define CA_PROTO_HOST_NAME       21u  // CA V4.1 identify client
;1451 #define CA_PROTO_ACCESS_RIGHTS   22u  // CA V4.2 asynch access rights chg
;1452 #define CA_PROTO_ECHO            23u  // CA V4.3 connection verify
;1453 #define REPEATER_REGISTER        24u  // register for repeater fan out
;1454 #define CA_PROTO_SIGNAL          25u  // --- obsolete ---
;1455 #define CA_PROTO_CREATE_CH_FAIL  26u  // unable to create chan resource in 
;1456 #define CA_PROTO_SERVER_DISCONN  27u  // server deletes PV (or channel)
;1457 
;1458 #define CA_PROTO_LAST_CMMD  CA_PROTO_SERVER_DISCONN
;1459 
;1460 
;1461 
;1462 // prototypes for funcs to process CA commands
;1463 #define  CMD_FUNC_ARGS   ConInfo *ci, CA_MsgHdr *msg
;1464 
;1465 #define  PROTO_CMD_FUNC(name)    int name(CMD_FUNC_ARGS)
;1466 
;1467 PROTO_CMD_FUNC( CA_Version       );
;1468 PROTO_CMD_FUNC( CA_EventAdd      );
;1469 PROTO_CMD_FUNC( CA_EventCancel   );
;1470 PROTO_CMD_FUNC( CA_Write         );
;1471 PROTO_CMD_FUNC( CA_Search        );
;1472 PROTO_CMD_FUNC( CA_EventsOff     );
;1473 PROTO_CMD_FUNC( CA_EventsOn      );
;1474 PROTO_CMD_FUNC( CA_ClearChannel  );
;1475 PROTO_CMD_FUNC( CA_ReadNotify    );
;1476 PROTO_CMD_FUNC( CA_CreateChan    );
;1477 PROTO_CMD_FUNC( CA_ClientName    );
;1478 PROTO_CMD_FUNC( CA_HostName      );
;1479 PROTO_CMD_FUNC( CA_Echo          );
;1480 
;1481 PROTO_CMD_FUNC( ProtocolError    );
;1482 
;1483 
;1484 typedef int (* CA_CmdFunc)(CMD_FUNC_ARGS);
;1485 
;1486 const far CA_CmdFunc  cmdFuncs[] = {
;1487   CA_Version,
_cmdFuncs::
	.dw	word _CA_Version
;1488   CA_EventAdd,
	.dw	word _CA_EventAdd
;1489   CA_EventCancel,
	.dw	word _CA_EventCancel
;1490   CA_ReadNotify,   // CA_Read (depricated)
	.dw	word _CA_ReadNotify
;1491   CA_Write,
	.dw	word _CA_Write
;1492   ProtocolError,   // CA_Snapshot (obsolete)
	.dw	word _ProtocolError
;1493   CA_Search,
	.dw	word _CA_Search
;1494   ProtocolError,   // CA_Build (obsolete)
	.dw	word _ProtocolError
;1495   CA_EventsOff,
	.dw	word _CA_EventsOff
;1496   CA_EventsOn,
	.dw	word _CA_EventsOn
;1497   ProtocolError,   // CA_ReadSync (depricated)
	.dw	word _ProtocolError
;1498   ProtocolError,   // CA_Error  (not sent by clients)
	.dw	word _ProtocolError
;1499   CA_ClearChannel,
	.dw	word _CA_ClearChannel
;1500   ProtocolError,   // CA_RsrvIsUp  (not sent by clients)
	.dw	word _ProtocolError
;1501   ProtocolError,   // CA_NotFound  (not sent by clients)
	.dw	word _ProtocolError
;1502   CA_ReadNotify,
	.dw	word _CA_ReadNotify
;1503   ProtocolError,   // CA_ReadBuild (obsolete)
	.dw	word _ProtocolError
;1504   ProtocolError,   // RepeaterConfirm  (shouldn't be sent to DEBROS)
	.dw	word _ProtocolError
;1505   CA_CreateChan,
	.dw	word _CA_CreateChan
;1506   CA_Write,        // CA_WriteNotify uses same func as CA_Write
	.dw	word _CA_Write
;1507   CA_ClientName,
	.dw	word _CA_ClientName
;1508   CA_HostName,
	.dw	word _CA_HostName
;1509   ProtocolError,   // CA_AccessRights  (not sent by clients)
	.dw	word _ProtocolError
;1510   CA_Echo,
	.dw	word _CA_Echo
;1511   ProtocolError,   // RepeaterRegister  (shouldn't be sent to DEBROS)
	.dw	word _ProtocolError
;1512   ProtocolError,   // CA_Signal (obsolete)
	.dw	word _ProtocolError
;1513   ProtocolError,   // CA_CreateChFail  (not sent by clients)
	.dw	word _ProtocolError
;1514   ProtocolError,   // CA_ServerDisconn  (not sent by clients)
	.dw	word _ProtocolError
;1515 };
	.debug	G _cmdFuncs 39 8
;1516 
;1517 
;1518 //------------------------- from EPICS caerr.h --------------------------
;1519 
;1520 /*  CA Status Code Definitions   */
;1521 
;1522 #define CA_K_WARNING    0   /* unsuccessful */
;1523 #define CA_K_SUCCESS    1   /* successful */
;1524 #define CA_K_ERROR      2   /* failed- continue */
;1525 #define CA_K_INFO       3   /* successful */
;1526 #define CA_K_SEVERE     4   /* failed- quit */
;1527 #define CA_K_FATAL  CA_K_ERROR | CA_K_SEVERE
;1528 
;1529 #define CA_M_MSG_NO     0x0000FFF8
;1530 #define CA_M_SEVERITY   0x00000007
;1531 #define CA_M_LEVEL      0x00000003
;1532 #define CA_M_SUCCESS    0x00000001
;1533 #define CA_M_ERROR      0x00000002
;1534 #define CA_M_SEVERE     0x00000004
;1535 
;1536 #define CA_S_MSG_NO     0x0D
;1537 #define CA_S_SEVERITY   0x03
;1538 
;1539 #define CA_V_MSG_NO     0x03
;1540 #define CA_V_SEVERITY   0x00
;1541 #define CA_V_SUCCESS    0x00
;1542 
;1543 /* Define MACROS to extract/insert individual fields from a status value */
;1544 
;1545 #define CA_EXTRACT_MSG_NO(code)    ( ((code) & CA_M_MSG_NO )  >> CA_V_MSG_N
;1546 #define CA_EXTRACT_SEVERITY(code)  ( ((code) & CA_M_SEVERITY) >> CA_V_SEVER
;1547 #define CA_EXTRACT_SUCCESS(code)   ( ((code) & CA_M_SUCCESS ) >> CA_V_SUCCE
;1548 
;1549 #define CA_INSERT_MSG_NO(code)     ( ((code)<< CA_V_MSG_NO)   &  CA_M_MSG_N
;1550 #define CA_INSERT_SEVERITY(code)   ( ((code)<< CA_V_SEVERITY) &  CA_M_SEVER
;1551 #define CA_INSERT_SUCCESS(code)    ( ((code)<< CA_V_SUCCESS)  &  CA_M_SUCCE
;1552 
;1553 #define DEFMSG(SEVERITY, NUMBER)  
;1554                     ( CA_INSERT_SEVERITY(SEVERITY) | CA_INSERT_MSG_NO(NUMBE
;1555 
;1556 /*
;1557  * In the lines below "defunct" indicates that current release
;1558  * servers and client library will not return this error code, but
;1559  * servers on earlier releases that communicate with current clients
;1560  * might still generate exceptions with these error constants
;1561  */
;1562 #define ECA_NORMAL          DEFMSG(CA_K_SUCCESS,    0) /* success */
;1563 #define ECA_MAXIOC          DEFMSG(CA_K_ERROR,      1) /* defunct */
;1564 #define ECA_UKNHOST         DEFMSG(CA_K_ERROR,      2) /* defunct */
;1565 #define ECA_UKNSERV         DEFMSG(CA_K_ERROR,      3) /* defunct */
;1566 #define ECA_SOCK            DEFMSG(CA_K_ERROR,      4) /* defunct */
;1567 #define ECA_CONN            DEFMSG(CA_K_WARNING,    5) /* defunct */
;1568 #define ECA_ALLOCMEM        DEFMSG(CA_K_WARNING,    6)
;1569 #define ECA_UKNCHAN         DEFMSG(CA_K_WARNING,    7) /* defunct */
;1570 #define ECA_UKNFIELD        DEFMSG(CA_K_WARNING,    8) /* defunct */
;1571 #define ECA_TOLARGE         DEFMSG(CA_K_WARNING,    9)
;1572 #define ECA_TIMEOUT         DEFMSG(CA_K_WARNING,   10)
;1573 #define ECA_NOSUPPORT       DEFMSG(CA_K_WARNING,   11) /* defunct */
;1574 #define ECA_STRTOBIG        DEFMSG(CA_K_WARNING,   12) /* defunct */
;1575 #define ECA_DISCONNCHID     DEFMSG(CA_K_ERROR,     13) /* defunct */
;1576 #define ECA_BADTYPE         DEFMSG(CA_K_ERROR,     14)
;1577 #define ECA_CHIDNOTFND      DEFMSG(CA_K_INFO,      15) /* defunct */
;1578 #define ECA_CHIDRETRY       DEFMSG(CA_K_INFO,      16) /* defunct */
;1579 #define ECA_INTERNAL        DEFMSG(CA_K_FATAL,     17)
;1580 #define ECA_DBLCLFAIL       DEFMSG(CA_K_WARNING,   18) /* defunct */
;1581 #define ECA_GETFAIL         DEFMSG(CA_K_WARNING,   19)
;1582 #define ECA_PUTFAIL         DEFMSG(CA_K_WARNING,   20)
;1583 #define ECA_ADDFAIL         DEFMSG(CA_K_WARNING,   21) /* defunct */
;1584 #define ECA_BADCOUNT        DEFMSG(CA_K_WARNING,   22)
;1585 #define ECA_BADSTR          DEFMSG(CA_K_ERROR,     23)
;1586 #define ECA_DISCONN         DEFMSG(CA_K_WARNING,   24)
;1587 #define ECA_DBLCHNL         DEFMSG(CA_K_WARNING,   25)
;1588 #define ECA_EVDISALLOW      DEFMSG(CA_K_ERROR,     26)
;1589 #define ECA_BUILDGET        DEFMSG(CA_K_WARNING,   27) /* defunct */
;1590 #define ECA_NEEDSFP         DEFMSG(CA_K_WARNING,   28) /* defunct */
;1591 #define ECA_OVEVFAIL        DEFMSG(CA_K_WARNING,   29) /* defunct */
;1592 #define ECA_BADMONID        DEFMSG(CA_K_ERROR,     30)
;1593 #define ECA_NEWADDR         DEFMSG(CA_K_WARNING,   31) /* defunct */
;1594 #define ECA_NEWCONN         DEFMSG(CA_K_INFO,      32) /* defunct */
;1595 #define ECA_NOCACTX         DEFMSG(CA_K_WARNING,   33) /* defunct */
;1596 #define ECA_DEFUNCT         DEFMSG(CA_K_FATAL,     34) /* defunct */
;1597 #define ECA_EMPTYSTR        DEFMSG(CA_K_WARNING,   35) /* defunct */
;1598 #define ECA_NOREPEATER      DEFMSG(CA_K_WARNING,   36) /* defunct */
;1599 #define ECA_NOCHANMSG       DEFMSG(CA_K_WARNING,   37) /* defunct */
;1600 #define ECA_DLCKREST        DEFMSG(CA_K_WARNING,   38) /* defunct */
;1601 #define ECA_SERVBEHIND      DEFMSG(CA_K_WARNING,   39) /* defunct */
;1602 #define ECA_NOCAST          DEFMSG(CA_K_WARNING,   40) /* defunct */
;1603 #define ECA_BADMASK         DEFMSG(CA_K_ERROR,     41)
;1604 #define ECA_IODONE          DEFMSG(CA_K_INFO,      42)
;1605 #define ECA_IOINPROGRESS    DEFMSG(CA_K_INFO,      43)
;1606 #define ECA_BADSYNCGRP      DEFMSG(CA_K_ERROR,     44)
;1607 #define ECA_PUTCBINPROG     DEFMSG(CA_K_ERROR,     45)
;1608 #define ECA_NORDACCESS      DEFMSG(CA_K_WARNING,   46)
;1609 #define ECA_NOWTACCESS      DEFMSG(CA_K_WARNING,   47)
;1610 #define ECA_ANACHRONISM     DEFMSG(CA_K_ERROR,     48)
;1611 #define ECA_NOSEARCHADDR    DEFMSG(CA_K_WARNING,   49)
;1612 #define ECA_NOCONVERT       DEFMSG(CA_K_WARNING,   50)
;1613 #define ECA_BADCHID         DEFMSG(CA_K_ERROR,     51)
;1614 #define ECA_BADFUNCPTR      DEFMSG(CA_K_ERROR,     52)
;1615 #define ECA_ISATTACHED      DEFMSG(CA_K_WARNING,   53)
;1616 #define ECA_UNAVAILINSERV   DEFMSG(CA_K_WARNING,   54)
;1617 #define ECA_CHANDESTROY     DEFMSG(CA_K_WARNING,   55)
;1618 #define ECA_BADPRIORITY     DEFMSG(CA_K_ERROR,     56)
;1619 #define ECA_NOTTHREADED     DEFMSG(CA_K_ERROR,     57)
;1620 #define ECA_16KARRAYCLIENT  DEFMSG(CA_K_WARNING,   58)
;1621 #define ECA_CONNSEQTMO      DEFMSG(CA_K_WARNING,   59)
;1622 #define ECA_UNRESPTMO       DEFMSG(CA_K_WARNING,   60)
;1623 
;1624 
;1625 
;1626 //----------------- Platform-specific definitions ---------------
;1627 
;1628 
;1629 #define  SleepSec(sec)                sleep(sec)
;1630 #define  SleepMS(ms)                  sleepMS(ms)
;1631 #define  Socket(domain, type, prot)   socket(domain, type, prot)
;1632 //#define  Close(sock)                  close(sock)
;1633 
;1634 #ifdef RABBIT
;1635   #define  Sethostname(nam)  SetHostName((nam), strlen(nam))
;1636   #define  SIN_ADDR  sin_addr
;1637 #else  //finish
;1673 
;1674 //-------------------------------------------------------------------------
;1675 //  Global variables
;1676 //-------------------------------------------------------------------------
;1677 
;1678 
;1679 char  servName[HostNameLen];
;1680 int  servNameLen;
;1681 bool  servNameMatch;  // last call to getPVID() matched at least the servNa
;1682 
;1683 
;1684 bool  processUDP = true;
	.dseg
_processUDP::
	.db	0x1
	.debug	G _processUDP 3 0
;1685 
;1686 //--- Values for valChgMode, which determines what criteria is used to ---
;1687 //--- generate event monitor messages for channels ---
;1688 #define  VCM_PERIODIC    0   // at a fixed rate even if no change in value
;1689 #define  VCM_THRESHOLD   1   // only if change exceeds the set threshold
;1690 #define  VCM_ANY         2   // for any change, no matter how small
;1691 
;1692 uint  valChgMode = VCM_THRESHOLD;
_valChgMode::
	.dw	0x1
	.debug	G _valChgMode 7 0
;1693 
;1694 static const char *chgModeDesc[] = { "periodic", "threshold", "anychg" };
	.defseg	CONST
	.seg	CONST
_chgModeDesc:
	.dw	@2
	.dw	@2+9
	.dw	@2+19
	.debug	F _chgModeDesc 42 0
;1695 
;1696 
;1697 uint  eventPeriod = CA_EVENT_PERIOD;  // default # ms between sending Event
	.dseg
_eventPeriod::
	.dw	0x7d
	.debug	G _eventPeriod 7 0
;1698 
;1699 ulong  beaconID;
;1700 
;1701 uint  numUDPPkts, numProcPkts, numSearchMsgs, numEvents, numWrites, numPSub
;1702       udpPktRate, procPktRate, searchMsgRate, eventsRate, writesRate, psubR
;1703 
;1704 uint  consecutivePkts;  //tdebug
;1705 
;1706 uint  lastBeaconTime;
;1707 
;1708 PID  ca_tcp_pid = 0, ca_udp_pid = 0;
_ca_tcp_pid::
	.dw	0
	.debug	G _ca_tcp_pid 6 0
_ca_udp_pid::
	.dw	0
	.debug	G _ca_udp_pid 6 0
;1709 
;1710 ulong  epochTimeSecs, epochTimeNS;
;1711 
;1712 
;1713 //-------------------------------------------------------------------------
;1714 //  Show/log msg about the connection currently being processed.
;1715 //-------------------------------------------------------------------------
;1716 void conMsg(int fd, const char far *msg)
;1717 {
	.defseg	FARCODE
	.seg	FARCODE
$conMsg::
	.debug	G $conMsg 44 9
	.debug	{ $conMsg 44 1716 @5 @4
	ld	hl,-134
	call	__fent##
	.debug	A fd 5 6
	.debug	A msg 7 33
;1718   FDEV  far *file;
	.debug	L file -4 45
;1719   void  *ioDev;
	.debug	L ioDev -6 47
;1720   char  buf[128];
	.debug	L buf -134 48
;1721 
;1722 
;1723   file = _FileFromFD_(fd);  ioDev = File_Dev(file);
	.debug	# 1723
	ld	hl,(ix+5)
	push	hl
	lcall	$_FileFromFD_
	pop	hl
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-6),hl
;1724   file->ioFuncs->descr(ioDev, buf, sizeof(buf));
	.debug	# 1724
	ld	hl,0x80
	push	hl
	ld	hl,-132+@3
	add	hl,sp
	push	hl
	ld	hl,(ix-6)
	push	hl
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	bc,de
	ld	de,0xc
	ex	de,hl
	add	hl,bc
	ld	hl,(hl)
	ex	de,hl
	call	__callde##
	add	sp,6
;1725 
;1726   printf("\r\n%ls on fd: %d (GFD: %d)\r\n%.128s\n\n", msg, fd, GFD(fd), buf
	.debug	# 1726
	ld	hl,-134+@3
	add	hl,sp
	push	hl
	ld	hl,(_userPix)
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	add	hl,hl
	ld	de,_FD
	add	hl,de
	ex	de,hl
	ld	hl,(ix+5)
	add	hl,hl
	add	hl,hl
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,0
	push	bc
	push	de
	ld	de,word (phys _fileTbl)
	ld	c,phys _fileTbl >> 16
	call	__lsub##
	ld	hl,0x27
	ex	de,hl
	call	__uidiv##
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+64)
	ld	c,phys @1+64 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,14
;1727 }
@4:
	.debug	} @4 1727

@3	equ	134
	ld	sp,ix
	pop	ix
	lret
@5	equ	136
;1728 
;1729 
;1730 //-------------------------------------------------------------------------
;1731 void closeCon(ConInfo *ci)
;1732 {
$closeCon::
	.debug	G $closeCon 49 9
	.debug	{ $closeCon 49 1731 @8 @7
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ci 5 50
;1733   conMsg(ci->fd,
;1734          (errno == ENOLINK) ?
;1735             "Connection closed" : "*** Closing due to error ***");
	.debug	# 1735
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0x43
	or	a,a
	sbc	hl,de
	jr	nz,@9
	ld	hl,@2+26
	jr	@10
@9:
	ld	hl,@2+44
@10:
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$conMsg
	add	sp,6
;1736 
;1737   close(ci->fd);
	.debug	# 1737
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$close
	pop	de
;1738 
;1739   if (ci->con)  ci->con->fd = -1;
	.debug	# 1739
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@12
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,0xffff
	call	__farst2##
;1740 }
@12:
@7:
	.debug	} @7 1740

@6	equ	0
	pop	ix
	lret
@8	equ	2
;1741 
;1742 
;1743 //-------------------------------------------------------------------------
;1744 //  Return the next 'numBytes' bytes of msg data for the specified connecti
;1745 //
;1746 //  Uses global variables:
;1747 //     nextRcvdPktByte, rcvdPktSize,
;1748 //
;1749 //  Returns the # of bytes actually read (which may be < numBytes) or < 0 i
;1750 //  an error.
;1751 //-------------------------------------------------------------------------
;1752 int readBytes(ConInfo *ci, char *buf, int numBytes, long timeout)
;1753 {
$readBytes::
	.debug	G $readBytes 52 9
	.debug	{ $readBytes 52 1752 @15 @14
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A ci 5 50
	.debug	A buf 7 43
	.debug	A numBytes 9 6
	.debug	A timeout 11 8
;1754   uint  bytesLeft;
	.debug	L bytesLeft -2 7
;1755 
;1756 
;1757   if (numBytes < 1)  { errno = EINVAL;  return -1; }
	.debug	# 1757
	ld	hl,(ix+9)
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@16
@17:
	.debug	< @17 @18
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
	jr	@1008
@18:
	.debug	>
;1758 
;1759 //--- if not a UDP connection, read it directly from the socket ---
;1760   if (ci->type != UDP_CON)  return read_(ci->fd, buf, numBytes, timeout);
@16:
	.debug	# 1760
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	bool	hl
	jr	z,@19
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix+13)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+9)
	push	hl
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$read_
	add	sp,10
	jp	@14
;1761 
;1762 
;1763 //--- Otherwise, copy from the next unprocessed bytes in rcvdPkt[] ---
;1764   if (nextRcvdPktByte > rcvdPktSize)  { errno = ENODATA;  return -1; }
@19:
	.debug	# 1764
	ld	hl,(_nextRcvdPktByte)
	ld	de,(_rcvdPktSize)
	or	a,a
	sbc	hl,de
	jr	c,@20
	jr	z,@20
@21:
	.debug	< @21 @22
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x3d
	jr	@1008
@22:
	.debug	>
;1765 
;1766   bytesLeft = rcvdPktSize - nextRcvdPktByte;
@20:
	.debug	# 1766
	ld	hl,(_rcvdPktSize)
	ld	de,(_nextRcvdPktByte)
	or	a,a
	sbc	hl,de
	ld	(ix-2),hl
;1767 
;1768   if (bytesLeft < numBytes)  numBytes = bytesLeft;
	.debug	# 1768
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@23
	ld	hl,(ix-2)
	ld	(ix+9),hl
;1769 
;1770   if (!numBytes)  { errno = EAGAIN;  return -1; }
@23:
	.debug	# 1770
	ld	hl,(ix+9)
	bool	hl
	jr	nz,@24
@25:
	.debug	< @25 @26
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xb
@1008:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@14
@26:
	.debug	>
;1771 
;1772   fmemcpy(buf, rcvdPkt+nextRcvdPktByte, numBytes);
@24:
	.debug	# 1772
	ld	hl,(ix+9)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(_nextRcvdPktByte)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys _rcvdPkt)
	ld	c,phys _rcvdPkt >> 16
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;1773   nextRcvdPktByte += numBytes;
	.debug	# 1773
	ld	hl,(_nextRcvdPktByte)
	ex	de,hl
	ld	hl,(ix+9)
	ex	de,hl
	add	hl,de
	ld	(_nextRcvdPktByte),hl
;1774 
;1775   return numBytes;
	.debug	# 1775
	ld	h,d
	ld	l,e
;1776 }
@14:
	.debug	} @14 1776

@13	equ	2
	ld	sp,ix
	pop	ix
	lret
@15	equ	4
;1777 
;1778 
;1779 //-------------------------------------------------------------------------
;1780 //  Send a response to a msg rcvd via UDP or TCP
;1781 //-------------------------------------------------------------------------
;1782 int sendResp(ConInfo *ci, uchar far *buf, uint count)
;1783 {
$sendResp::
	.debug	G $sendResp 53 9
	.debug	{ $sendResp 53 1782 @29 @28
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-86
	.debug	A ci 5 50
	.debug	A buf 7 33
	.debug	A count 11 7
;1784   int  stat, addrLen;
	.debug	L stat -2 6
	.debug	L addrLen -4 6
;1785   SAP  addr;
	.debug	L addr -6 54
;1786   char  temp[64], addrStr[16];
	.debug	L temp -70 56
	.debug	L addrStr -86 57
;1787 
;1788 
;1789   if (ci->type == UDP_CON)  {
	.debug	# 1789
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	bool	hl
	jr	nz,@30
;1790     addr = (SAP)&respAddrUDP;  addrLen = sizeof(SAI);  }
@31:
	.debug	< @31 @32
	.debug	# 1790
	ld	hl,_respAddrUDP
	ld	(ix-6),hl
	ld	hl,0xe
	ld	(ix-4),hl
@32:
	.debug	>
;1791   else {
	jr	@33
@30:
;1792     addr = NULL;  addrLen = 0;  }
@34:
	.debug	< @34 @35
	.debug	# 1792
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	ld	(ix-4),hl
@35:
	.debug	>
;1793 
;1794 
;1795   while (count > 0)  {
@33:
@36:
	.debug	# 1795
	ld	hl,(ix+11)
	ld	de,0
	or	a,a
	sbc	hl,de
	jp	c,@37
	jp	z,@37
;1796     stat = sendto(ci->fd, buf, count, 0, addr, addrLen);
@38:
	.debug	< @38 @39
	.debug	# 1796
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-6)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$sendto
	add	sp,14
	ld	(ix-2),hl
;1797 
;1798     if (stat == count)  break;
	.debug	# 1798
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	z,@37
;1799 
;1800     if (stat < 0)  {
	.debug	# 1800
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@41
;1801       if (errno == EAGAIN)  { sleepMS(5);  continue; }
@42:
	.debug	< @42 @43
	.debug	# 1801
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	nz,@44
@45:
	.debug	< @45 @46
	ld	e,0x5
	jp	@1007
@46:
	.debug	>
;1802       inet_ntop(AF_INET, &addr->SIN_ADDR, addrStr, sizeof(addrStr));
@44:
	.debug	# 1802
	ld	hl,0x10
	push	hl
	ld	hl,-84+@27
	add	hl,sp
	push	hl
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ntop
	add	sp,8
;1803       sprintf(temp, "\n*** %s:%u: sendto(%d, x, %d, ...)",
;1804               addrStr, ntohs(addr->sin_port), ci->fd, count);
	.debug	# 1804
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	push	hl
	ld	hl,-80+@27
	add	hl,sp
	push	hl
	ld	de,word (phys @1+100)
	ld	c,phys @1+100 >> 16
	push	bc
	push	de
	ld	hl,-58+@27
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$farsprintf
	add	sp,16
;1805       perror(temp);  printf("\n");  return -1;
	.debug	# 1805
	ld	hl,-70+@27
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	de,word (phys @1+98)
	ld	c,phys @1+98 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jr	@1006
;1806     }
@43:
	.debug	>
;1807 
;1808     if (!stat)  { sleepMS(5);  continue; }
@41:
	.debug	# 1808
	ld	hl,(ix-2)
	bool	hl
	jr	nz,@47
@48:
	.debug	< @48 @49
	ld	de,0x5
@1007:
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	jp	@36
@49:
	.debug	>
;1809 
;1810     // send some but not all, but UDP packets must NOT be fragmented!!!
;1811     if (ci->type == UDP_CON)  { errno = EMSGSIZE;  return -1; }
@47:
	.debug	# 1811
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	bool	hl
	jr	nz,@50
@51:
	.debug	< @51 @52
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x5a
	ld	(hl),e
	inc	hl
	ld	(hl),d
@1006:
	ld	hl,0xffff
	jr	@28
@52:
	.debug	>
;1812 
;1813     buf += (uint)stat;  count -= stat;
@50:
	.debug	# 1813
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix+9),hl
	ex	de,hl
	ld	(ix+7),hl
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix+11),hl
;1814   }
@39:
	.debug	>
;1815 
;1816   return 0;
	jp	@36
@37:
	.debug	# 1816
	bool	hl
	ld	l,h
;1817 }
@28:
	.debug	} @28 1817

@27	equ	86
	ld	sp,ix
	pop	ix
	lret
@29	equ	88
;1818 
;1819 
;1820 //-------------------------------------------------------------------------
;1821 //  Send the contents of the outgoing packet buffer, which contains one or
;1822 //  more messages (either responses to one or more request messages or
;1823 //  periodically generated event monitor messages with new values).
;1824 //
;1825 //  Note that if the responses are for requests received via a UDP broadcas
;1826 //  packet, then we must send the response to the address and port that the
;1827 //  packet was sent from.  For TCP, the socket is already connected and it
;1828 //  is considered an error to specify the destination (since it cannot be
;1829 //  anything other than the address it is already connected to).
;1830 //
;1831 //  Returns 0 on success, < 0 if an error
;1832 //-------------------------------------------------------------------------
;1833 int sendRespPkt(ConInfo *ci)
;1834 {
$sendRespPkt::
	.debug	G $sendRespPkt 58 9
	.debug	{ $sendRespPkt 58 1833 @55 @54
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A ci 5 50
;1835   int  fd;
	.debug	L fd -2 6
;1836   static int  so_setBcast = true, so_clearBcast = false;
	.dseg
@56:
	.dw	0x1
	.debug	S so_setBcast @56 6
	.seg	FARCODE
	.dseg
@57:
	.dw	0
	.debug	S so_clearBcast @57 6
	.seg	FARCODE
;1837 
;1838 
;1839   fd = ci->fd;
	.debug	# 1839
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(ix-2),hl
;1840 
;1841   if (fd < 0)  { errno = EBADF;  return -1; }
	.debug	# 1841
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@58
@59:
	.debug	< @59 @60
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jp	@1004
@60:
	.debug	>
;1842 
;1843   errno = 0;
@58:
	.debug	# 1843
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
;1844 
;1845 
;1846 //--- if not UDP, send the contents of the shorter-msg TCP resp buffer ---
;1847   if (ci->type != UDP_CON)  {
	.debug	# 1847
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	bool	hl
	jr	z,@61
;1848     if (sendResp(ci, respPktTCP, respPktUsedTCP))  return -1;
@62:
	.debug	< @62 @63
	.debug	# 1848
	ld	hl,(_respPktUsedTCP)
	push	hl
	ld	de,word (phys _respPktTCP)
	ld	c,phys _respPktTCP >> 16
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$sendResp
	add	sp,8
	bool	hl
	jr	nz,@1004
;1849     respPktUsedTCP = 0;  return 0;
	.debug	# 1849
	bool	hl
	ld	l,h
	ld	(_respPktUsedTCP),hl
	jr	@54
;1850   }
@63:
	.debug	>
;1851 
;1852 
;1853 //--- For UDP packets, we need to temporarily disable broadcast mode ---
;1854   if (setsockopt(fd, SOL_SOCKET, SO_BROADCAST,
@61:
;1855                 (char *)&so_clearBcast, sizeof(so_clearBcast)) < 0)  {
	.debug	# 1855
	ld	hl,0x2
	push	hl
	ld	hl,@57
	push	hl
	ld	hl,0x6
	push	hl
	ld	l,0x1
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setsockopt
	add	sp,10
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@1005
;1856       perror("UDP setsockopt()");  return -1;  }
@66:
	.debug	< @66 @67
	.debug	# 1856
@67:
	.debug	>
;1857 
;1858 //--- send the contents of the UDP resp buffer ---
;1859   if (sendResp(ci, respPktUDP, respPktUsedUDP))  return -1;
	.debug	# 1859
	ld	hl,(_respPktUsedUDP)
	push	hl
	ld	de,word (phys _respPktUDP)
	ld	c,phys _respPktUDP >> 16
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$sendResp
	add	sp,8
	bool	hl
	jr	nz,@1004
;1860   respPktUsedUDP = 0;
	.debug	# 1860
	bool	hl
	ld	l,h
	ld	(_respPktUsedUDP),hl
;1861 
;1862 //--- Restore broadcast mode ---
;1863   if (setsockopt(fd, SOL_SOCKET, SO_BROADCAST,
;1864                  (char *)&so_setBcast, sizeof(so_setBcast)) < 0)  {
	.debug	# 1864
	ld	l,0x2
	push	hl
	ld	hl,@56
	push	hl
	ld	hl,0x6
	push	hl
	ld	l,0x1
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setsockopt
	add	sp,10
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@69
;1865       perror("UDP setsockopt()");  return -1;  }
@70:
	.debug	< @70 @71
	.debug	# 1865
@1005:
	ld	de,word (phys @1+135)
	ld	c,phys @1+135 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
@1004:
	ld	hl,0xffff
	jr	@54
@71:
	.debug	>
;1866 
;1867   return 0;
@69:
	.debug	# 1867
	bool	hl
	ld	l,h
;1868 }
@54:
	.debug	} @54 1868

@53	equ	2
	ld	sp,ix
	pop	ix
	lret
@55	equ	4
;1869 
;1870 
;1871 //-------------------------------------------------------------------------
;1872 //  Process bytes to be sent to the client either by sending them now or
;1873 //  adding them to a buffer that will be sent when it is full or on demand 
;1874 //  a call to flushResps().
;1875 //
;1876 //  Returns 0 on success, < 0 if an error
;1877 //-------------------------------------------------------------------------
;1878 int _nearcall addToRespPkt(ConInfo *ci, void far *buf, uint numBytes)
;1879 {
	.align	4
$$addToRespPkt::
	ex	(sp),iy
$addToRespPkt::
	.debug	G $addToRespPkt 59 9
	.debug	{ $addToRespPkt 59 1878 @74 @73
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ci 5 50
	.debug	A buf 7 60
	.debug	A numBytes 11 7
;1880   uint  count, unused;
	.debug	L count -2 7
	.debug	L unused -4 7
;1881 
;1882 
;1883   switch (ci->type)  {
	.debug	# 1883
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	jp	@75
;1884 
;1885   /*---------------------------------------------------------------------*
;1886     For UDP, we MUST accumulate msgs in a buffer because we have to be
;1887     sent in 1 packet.  If there isn't enough space left, it is an error.
;1888   *----------------------------------------------------------------------*/
;1889     case UDP_CON:
@77:
	.debug	< @77 @78
;1890       if (numBytes > sizeof(respPktUDP) - respPktUsedUDP)  return -1;
	.debug	# 1890
@79:
	ld	hl,0x5b4
	ld	de,(_respPktUsedUDP)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix+11)
	or	a,a
	sbc	hl,de
	jr	c,@80
	jp	nz,@1003
;1891       fmemcpy(respPktUDP + respPktUsedUDP, buf, numBytes);
@80:
	.debug	# 1891
	ld	hl,(ix+11)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(_respPktUsedUDP)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys _respPktUDP)
	ld	c,phys _respPktUDP >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;1892       respPktUsedUDP += numBytes;  return 0;
	.debug	# 1892
	ld	hl,(_respPktUsedUDP)
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	add	hl,de
	ld	(_respPktUsedUDP),hl
	jp	@85
;1893 
;1894   /*---------------------------------------------------------------------*
;1895     For TCP connections that are using only smaller PVs, the outgoing
;1896     msgs consist mostly of new values for subscriptions, which means we
;1897     generate a whole bunch of small msgs fairly quickly.  In this case,
;1898     we add the msgs to a buffer and flush it as needed.  For these shorter
;1899     messages, this is worth the extra overhead for 2 reasons:
;1900 
;1901       - It minimizes the # of calls to the socket layer
;1902       - It minimizes the # of packets the responses are sent in
;1903 
;1904     The naggle algorithm in the network stack helps with the second issue,
;1905     but we generally don't process or generate msgs fast enough for it to
;1906     be very effective, so a series of messages still tends to get broken
;1907     up in to multiple packets (and more packets means more CPU time spent
;1908     sending them).
;1909 
;1910     The end result:  Even though we add another buffer to the sequence of
;1911     buffer-to-buffer copies that occurs before a msg is actually sent, the
;1912     result is still greater throughput and less CPU time than if we don't.
;1913   *----------------------------------------------------------------------*/
;1914     case TCP_BUF:
;1915       unused = sizeof(respPktTCP) - respPktUsedTCP;
	.debug	# 1915
@81:
	ld	hl,0x5b4
	ld	de,(_respPktUsedTCP)
	or	a,a
	sbc	hl,de
	ld	(ix-4),hl
;1916       for (;;)  {
@82:
	.debug	< @82 @83
@84:
;1917         count = (numBytes > unused) ? unused : numBytes;
@87:
	.debug	< @87 @88
	.debug	# 1917
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@89
	jr	z,@89
	ld	h,d
	ld	l,e
	jr	@90
@89:
	ld	hl,(ix+11)
@90:
	ld	(ix-2),hl
;1918         fmemcpy(respPktTCP + respPktUsedTCP, buf, count);
	.debug	# 1918
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(_respPktUsedTCP)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys _respPktTCP)
	ld	c,phys _respPktTCP >> 16
	call	__ladd##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;1919         respPktUsedTCP += count;
	.debug	# 1919
	ld	hl,(_respPktUsedTCP)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	add	hl,de
	ld	(_respPktUsedTCP),hl
;1920         if (! (numBytes -= count))  break;  // nothing left to copy
	.debug	# 1920
	ld	hl,(ix+11)
	or	a,a
	sbc	hl,de
	ld	(ix+11),hl
	bool	hl
	jr	z,@85
;1921         if (sendRespPkt(ci))  return -1;  // buffer must be full, so send i
	.debug	# 1921
	ld	hl,(ix+5)
	push	hl
	lcall	$sendRespPkt
	pop	de
	bool	hl
	jr	z,@92
@1003:
	ld	hl,0xffff
	jr	@73
;1922         unused = sizeof(respPktTCP);  // buffer now empty
@92:
	.debug	# 1922
	ld	hl,0x5b4
	ld	(ix-4),hl
;1923         buf = (uchar far *)buf + count;  // but still more to copy to it
	.debug	# 1923
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix+9),hl
	ex	de,hl
	ld	(ix+7),hl
	ex	de,hl
;1924       }
@88:
	.debug	>
;1925       return 0;
	jp	@84
@85:
@83:
	.debug	>
	.debug	# 1925
	bool	hl
	ld	l,h
	jr	@73
;1926 
;1927   /*---------------------------------------------------------------------*
;1928     The last case is connections that use larger PV values.  For these,
;1929     copying the data to another buffer rather than just writing directly
;1930     to the socket just uses up more memory with no gain.  Depending on the
;1931     size of the messages, it can result in a net loss to add another
;1932     buffer-to-buffer copy for each message.  So for this case, we just
;1933     write the data directly to the socket.
;1934   *----------------------------------------------------------------------*/
;1935     case TCP_DIR:
;1936       return sendResp(ci, buf, numBytes);
	.debug	# 1936
@93:
	ld	hl,(ix+11)
	push	hl
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$sendResp
	add	sp,8
	jr	@73
;1937   }
@78:
	.debug	>
;1938 
;1939 
;1940   return -1;
@75:
	ex	de,hl
	ld	a,d
	or	a,e
	jp	z,@79
	ld	hl,0xffffffff
	add	hl,de
	bool	hl
	jp	z,@81
	ld	hl,0xfffffffe
	add	hl,de
	bool	hl
	jr	z,@93
@76:
	.debug	# 1940
	ld	hl,0xffff
;1941 }
@73:
	.debug	} @73 1941

@72	equ	4
	ld	sp,ix
	pop	ix
	lret
@74	equ	6
;1942 
;1943 
;1944 //-------------------------------------------------------------------------
;1945 //  "skip over" the specified number of bytes in the current msg data strea
;1946 //  The main purpose of this is to skip over the payload for a msg so we ar
;1947 //  ready to process the next msg.
;1948 //
;1949 //  Returns the # of bytes actually skipped (which may be < numBytes) or < 
;1950 //  if an error.
;1951 //-------------------------------------------------------------------------
;1952 int skipMsgBytes(ConInfo *ci, int numBytes)
;1953 {
$skipMsgBytes::
	.debug	G $skipMsgBytes 61 9
	.debug	{ $skipMsgBytes 61 1952 @96 @95
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A ci 5 50
	.debug	A numBytes 7 6
;1954   int  avail, count;
	.debug	L avail -2 6
	.debug	L count -4 6
;1955 
;1956 
;1957   if (numBytes < 1)  return 0;
	.debug	# 1957
	ld	hl,(ix+7)
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@97
	bool	hl
	ld	l,h
	jr	@95
;1958 
;1959   if (ShowErrors OR ci->showCmds)
@97:
	.debug	# 1959
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	nz,@98
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@99
@98:
;1960     printf("*** skipping %d payload bytes ***\n", numBytes);
	.debug	# 1960
	ld	hl,(ix+7)
	push	hl
	ld	de,word (phys @1+152)
	ld	c,phys @1+152 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1961 
;1962   if (ci->type != UDP_CON)  return skipBytes(ci->fd, numBytes, RD_TIMEOUT);
@99:
	.debug	# 1962
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	bool	hl
	jr	z,@100
	ld	de,0x7d0
	ld	b,h
	ld	c,h
	push	bc
	push	de
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	lcall	$skipBytes
	add	sp,8
	jr	@95
;1963 
;1964 //--- NOTE: rcvdPkt is used ONLY for UDP packets ---
;1965   avail = rcvdPktSize - nextRcvdPktByte;
@100:
	.debug	# 1965
	ld	hl,(_rcvdPktSize)
	ld	de,(_nextRcvdPktByte)
	or	a,a
	sbc	hl,de
	ld	(ix-2),hl
;1966 
;1967   count = (avail > numBytes) ? avail : numBytes;
	.debug	# 1967
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__icmp##
	jr	c,@101
	jr	z,@101
	ld	hl,(ix-2)
	jr	@102
@101:
	ld	hl,(ix+7)
@102:
	ld	(ix-4),hl
;1968 
;1969   nextRcvdPktByte += count;  return count;
	.debug	# 1969
	ld	hl,(_nextRcvdPktByte)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	add	hl,de
	ld	(_nextRcvdPktByte),hl
	ld	h,d
	ld	l,e
;1970 }
@95:
	.debug	} @95 1970

@94	equ	4
	ld	sp,ix
	pop	ix
	lret
@96	equ	6
;1971 
;1972 
;1973 //-------------------------------------------------------------------------
;1974 //  Check the PV name for a name of the form host.field, where the host par
;1975 //  must match the hostname and the field one of the values in the lists of
;1976 //  values exposed to external clients.
;1977 //
;1978 //  If a match is found, it returns a value >= 0 that is used to reference 
;1979 //  value in many of the other PV interface functions.  If no match is foun
;1980 //  or there is an error, it returns < 0.
;1981 //-------------------------------------------------------------------------
;1982 int getPVID(char *pvName, int pvNameLen)
;1983 {
$getPVID::
	.debug	G $getPVID 62 9
	.debug	{ $getPVID 62 1982 @105 @104
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A pvName 5 43
	.debug	A pvNameLen 7 6
;1984   char  *fldName;
	.debug	L fldName -2 43
;1985 
;1986 
;1987   fldName = NULL;  servNameMatch = false;
	.debug	# 1987
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	xor	a,a
	ld	(_servNameMatch),a
;1988 
;1989 //--- first part of PV name must match the hostname ---
;1990   if (strnicmp(servName, pvName, servNameLen))  return -1;
	.debug	# 1990
	ld	hl,(_servNameLen)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,_servName
	push	hl
	call	_strnicmp
	add	sp,6
	bool	hl
	jr	nz,@1002
;1991 
;1992 //--- if ALL we have is the host name then assume a fld name of "VAL" ---
;1993   if (pvNameLen == servNameLen)
	.debug	# 1993
	ld	hl,(ix+7)
	ld	de,(_servNameLen)
	or	a,a
	sbc	hl,de
	jr	nz,@107
;1994     fldName = "VAL";
	.debug	# 1994
	ld	hl,@2+73
	ld	(ix-2),hl
;1995 //--- otherwise the rest must be a '.' followed by a field name ---
;1996   else
;1997     if (pvName[servNameLen] == '.')  fldName = pvName + servNameLen + 1;
	jr	@108
@107:
	.debug	# 1997
	ld	hl,(_servNameLen)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	ld	a,(hl)
	sub	a,46
	jr	nz,@109
	ld	hl,(_servNameLen)
	add	hl,de
	inc	hl
	ld	(ix-2),hl
;1998 
;1999   if (!fldName)  return -1;
@109:
@108:
	.debug	# 1999
	ld	hl,(ix-2)
	bool	hl
	jr	nz,@110
@1002:
	ld	hl,0xffff
	jr	@104
;2000 
;2001   servNameMatch = true;
@110:
	.debug	# 2001
	ld	a,0x1
	ld	(_servNameMatch),a
;2002 
;2003   return pvGetID(fldName);
	.debug	# 2003
	ld	hl,(ix-2)
	push	hl
	lcall	$pvGetID
	pop	de
;2004 }
@104:
	.debug	} @104 2004

@103	equ	2
	ld	sp,ix
	pop	ix
	lret
@105	equ	4
;2005 
;2006 
;2007 
;2008 
;2009 //-------------------------------------------------------------------------
;2010 //  Send a CA_PROTO_ERROR msg over a TCP connection
;2011 //
;2012 //  REturns 0 on success, < 0 if an error
;2013 //-------------------------------------------------------------------------
;2014 int sendErrResp(ConInfo *ci, CA_MsgHdr *msg, ulong cid,
;2015                 int errCode, const char far *descr)
;2016 {
$sendErrResp::
	.debug	G $sendErrResp 63 9
	.debug	{ $sendErrResp 63 2014 @113 @112
	ld	hl,-152
	call	__fent##
	.debug	A ci 5 50
	.debug	A msg 7 64
	.debug	A cid 9 9
	.debug	A errCode 13 6
	.debug	A descr 15 33
;2017   int  count;
	.debug	L count -2 6
;2018   uint  descrLen;
	.debug	L descrLen -4 7
;2019   CA_MsgHdr  resp, *msgCopy;
	.debug	L resp -150 65
	.debug	L msgCopy -152 64
;2020 
;2021 
;2022   if (ShowErrors)
	.debug	# 2022
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@114
;2023     printf("*** Error: fd:%d  cmd:[%2d]  CID:0x%08lX  code:%04X\n"
;2024            "           %ls\n", ci->fd, msg->cmd, cid, errCode, descr);
	.debug	# 2023
	ld	hl,(ix+15)
	ex	de,hl
	ld	hl,(ix+17)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+13)
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+187)
	ld	c,phys @1+187 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,18
;2025 
;2026   descrLen = (uint) fstrlen(descr);
@114:
	.debug	# 2026
	ld	hl,(ix+15)
	ex	de,hl
	ld	hl,(ix+17)
	ld	bc,hl
	push	bc
	push	de
	call	_fstrlen
	add	sp,4
	ex	de,hl
	ld	(ix-4),hl
;2027   if (descrLen > MAX_MSG_DATA-17)  descrLen = MAX_MSG_DATA - 17;
	.debug	# 2027
	ld	de,0x6f
	or	a,a
	sbc	hl,de
	jr	c,@115
	jr	z,@115
	ld	h,d
	ld	l,e
	ld	(ix-4),hl
;2028 
;2029   resp.cmd = htons(CA_PROTO_ERROR);
@115:
	.debug	# 2029
	ld	hl,0xb
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-150+@111
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2030   resp.size = htons(16 + descrLen + 1);
	.debug	# 2030
	ld	hl,(ix-4)
	ld	de,0x10
	add	hl,de
	inc	hl
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-148+@111
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2031   resp.fld3 = 0;
	.debug	# 2031
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-146+@111
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2032   resp.fld4 = 0;
	.debug	# 2032
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-144+@111
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2033   resp.fld5 = htonl(cid);
	.debug	# 2033
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-142+@111
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2034   resp.fld6 = htonl(errCode);
	.debug	# 2034
	ld	hl,(ix+13)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-138+@111
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2035 
;2036   msgCopy = (CA_MsgHdr *)resp.data;
	.debug	# 2036
	ld	hl,-134+@111
	add	hl,sp
	ex	de,hl
	ld	hl,-152+@111
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2037 
;2038   msgCopy->cmd  = htons(msg->cmd);
	.debug	# 2038
	ld	hl,(ix+7)
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-152+@111
	add	hl,sp
	ld	hl,(hl)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2039   msgCopy->size = htons(msg->size);
	.debug	# 2039
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-152+@111
	add	hl,sp
	ld	hl,(hl)
	inc	hl
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2040   msgCopy->fld3 = htons(msg->fld3);
	.debug	# 2040
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-152+@111
	add	hl,sp
	ld	hl,(hl)
	ld	bc,de
	ld	de,0x4
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2041   msgCopy->fld4 = htons(msg->fld4);
	.debug	# 2041
	ld	hl,(ix+7)
	ld	e,0x6
	add	hl,de
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-152+@111
	add	hl,sp
	ld	hl,(hl)
	ld	bc,de
	ld	de,0x6
	add	hl,de
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2042   msgCopy->fld5 = htonl(msg->fld5);
	.debug	# 2042
	ld	hl,(ix+7)
	ld	e,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-152+@111
	add	hl,sp
	ld	hl,(hl)
	push	de
	ld	de,0x8
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2043   msgCopy->fld6 = htonl(msg->fld6);
	.debug	# 2043
	ld	hl,(ix+7)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-152+@111
	add	hl,sp
	ld	hl,(hl)
	push	de
	ld	de,0xc
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2044 
;2045   fmemcpy(msgCopy->data, descr, descrLen);
	.debug	# 2045
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+15)
	ex	de,hl
	ld	hl,(ix+17)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,-144+@111
	add	hl,sp
	ld	hl,(hl)
	ld	de,0x10
	add	hl,de
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;2046   msgCopy->data[descrLen] = 0;
	.debug	# 2046
	ld	hl,-152+@111
	add	hl,sp
	ld	hl,(hl)
	ld	de,0x10
	add	hl,de
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	add	hl,de
	xor	a,a
	ld	(hl),a
;2047 
;2048   count = resp.size + 16;
	.debug	# 2048
	ld	hl,-148+@111
	add	hl,sp
	ld	hl,(hl)
	ld	de,0x10
	add	hl,de
	ld	(ix-2),hl
;2049 
;2050   return addToRespPkt(ci, &resp, count);
	.debug	# 2050
	push	hl
	ld	hl,-148+@111
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
;2051 }
@112:
	.debug	} @112 2051

@111	equ	152
	ld	sp,ix
	pop	ix
	lret
@113	equ	154
;2052 
;2053 //-------------------------------------------------------------------------
;2054 //  send a beacon out using the UDP socket configured for broadcast
;2055 //-------------------------------------------------------------------------
;2056 int sendBeacon(int fd)
;2057 {
$sendBeacon::
	.debug	G $sendBeacon 66 9
	.debug	{ $sendBeacon 66 2056 @118 @117
	ld	hl,-171
	call	__fent##
	.debug	A fd 5 6
;2058   IFConfig  ifConfig;
	.debug	L ifConfig -25 67
;2059   CA_MsgHdr  resp;
	.debug	L resp -171 65
;2060 
;2061 
;2062   getIFConfig(IF_ETH0, &ifConfig);
	.debug	# 2062
	ld	hl,-25+@116
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$getIFConfig
	add	sp,4
;2063 
;2064   resp.cmd  = htons(CA_PROTO_RSRV_IS_UP);
	.debug	# 2064
	ld	hl,0xd
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-171+@116
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2065   resp.size = 0;
	.debug	# 2065
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-169+@116
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2066   resp.fld3 = htons(CA_MINOR_VERSION);  // doco says THIS should be the por
	.debug	# 2066
	ld	hl,0xb
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-167+@116
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2067   resp.fld4 = htons(CA_SERVER_PORT);    // doco says it MUST be 0!
	.debug	# 2067
	ld	hl,0x13c8
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-165+@116
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2068   resp.fld5 = htonl(beaconID);
	.debug	# 2068
	ld	de,(_beaconID)
	ld	bc,(_beaconID+2)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-163+@116
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2069   resp.fld6 = htonl(ifConfig.ipAddr);
	.debug	# 2069
	ld	hl,(ix-25)
	ex	de,hl
	ld	hl,(ix-23)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-159+@116
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2070 
;2071   if (sendBCastPkt(&fd, EPICS_CAS_BEACON_PORT, ifConfig.bcAddr,
;2072                    (char far *)&resp, 16))  {
	.debug	# 2072
	ld	hl,0x10
	push	hl
	ld	hl,-169+@116
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,0x13c9
	push	hl
	ld	hl,17+@116
	add	hl,sp
	push	hl
	lcall	$sendBCastPkt
	add	sp,14
	bool	hl
	jr	z,@119
;2073     perror("sendBCastPkt()");  return -1; }
@120:
	.debug	< @120 @121
	.debug	# 2073
	ld	de,word (phys @1+255)
	ld	c,phys @1+255 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xffff
	jr	@117
@121:
	.debug	>
;2074 
;2075   lastBeaconTime = GetMS_();  ++beaconID;
@119:
	.debug	# 2075
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastBeaconTime),hl
	ld	de,(_beaconID)
	ld	bc,(_beaconID+2)
	call	__linc##
	ld	(_beaconID),de
	ld	(_beaconID+2),bc
;2076 
;2077   return 0;
	.debug	# 2077
	bool	hl
	ld	l,h
;2078 }
@117:
	.debug	} @117 2078

@116	equ	171
	ld	sp,ix
	pop	ix
	lret
@118	equ	173
;2079 
;2080 
;2081 //-------------------------------------------------------------------------
;2082 //  Validate the values that are required for a sendValue() call.
;2083 //
;2084 //  Returns 0 if they are all valid, < 0 if they are not.
;2085 //
;2086 //  If the ConInfo is valid but the dbrType or sid are not, it sends a
;2087 //  response with the BADTYPE or BADCHID status code.
;2088 //-------------------------------------------------------------------------
;2089 int validateParams(ConInfo *ci, uint cmd, ulong eventID,
;2090                    uint dbrType, uint numElems, SID sid)
;2091 {
$validateParams::
	.debug	G $validateParams 68 9
	.debug	{ $validateParams 68 2089 @124 @123
	ld	hl,-171
	call	__fent##
	.debug	A ci 5 50
	.debug	A cmd 7 7
	.debug	A eventID 9 9
	.debug	A dbrType 13 7
	.debug	A numElems 15 7
	.debug	A sid 17 7
;2092   PVID  pvid;
	.debug	L pvid -2 7
;2093   uint  statusCode = ECA_NORMAL;
	.debug	L statusCode -4 7
	.debug	# 2093
	ld	hl,0x1
	ld	(ix-4),hl
	.seg	FARCODE
;2094   PVID far  *chan;
	.debug	L chan -8 69
;2095   PV_Info  pvInfo;
	.debug	L pvInfo -21 70
;2096   CA_MsgHdr  resp;
	.debug	L resp -167 65
;2097   CA_Con far *con;
	.debug	L con -171 71
;2098 
;2099 
;2100 //--- Verify ConInfo refers to a TCP (Virtual Circuit) connection ---
;2101   con = ci->con;  if (!con)  return -1;
	.debug	# 2101
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,-171+@122
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,-171+@122
	add	hl,sp
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@125
	ld	hl,0xffff
	jp	@123
;2102 
;2103 
;2104 //--- Verify dbrType is valid and doesn't exceed our limits ---
;2105   if (dbrType > LAST_BUFFER_TYPE)
@125:
	.debug	# 2105
	ld	hl,(ix+13)
	ld	de,0x26
	or	a,a
	sbc	hl,de
	jr	c,@126
	jr	z,@126
;2106     statusCode = ECA_BADTYPE;
	.debug	# 2106
	ld	hl,0x72
	ld	(ix-4),hl
;2107   else
;2108     if (dbrValOffset[dbrType] > sizeof(CA_MsgHdr) - 32)  {
	jr	@127
@126:
	.debug	# 2108
	ld	hl,(ix+13)
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _dbrValOffset)
	ld	c,phys _dbrValOffset >> 16
	call	__ladd##
	call	__farld2##
	ld	hl,0x72
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@128
	jr	z,@128
;2109       if (ShowErrors)
@129:
	.debug	< @129 @130
	.debug	# 2109
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@131
;2110         printf("*** Extended data type exceeds our capabilities ***\n");
	.debug	# 2110
	ld	de,word (phys @1+270)
	ld	c,phys @1+270 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2111       statusCode = ECA_UNAVAILINSERV;
@131:
	.debug	# 2111
	ld	hl,0x1b0
	ld	(ix-4),hl
;2112     }
@130:
	.debug	>
;2113 
;2114 
;2115 //--- Make sure SID is valid and get internal PV ID ---
;2116   if (sid >= con->maxChanNum)  {
@128:
@127:
	.debug	# 2116
	ld	hl,-171+@122
	add	hl,sp
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x83
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+17)
	or	a,a
	sbc	hl,de
	jr	c,@132
;2117     pvid = CHAN_UNUSED;  chan = NULL; }
@133:
	.debug	< @133 @134
	.debug	# 2117
	ld	hl,0xffff
	ld	(ix-2),hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
@134:
	.debug	>
;2118   else  {
	jr	@135
@132:
;2119     chan = con->chans + sid;
@136:
	.debug	< @136 @137
	.debug	# 2119
	ld	hl,-171+@122
	add	hl,sp
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+17)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;2120     if ((pvid = *chan) == CHAN_UNUSED)  chan = NULL;
	.debug	# 2120
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@138
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;2121   }
@138:
@137:
	.debug	>
;2122 
;2123   if (!chan)
@135:
	.debug	# 2123
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@139
;2124     statusCode = ECA_BADCHID;
	.debug	# 2124
	ld	hl,0x19a
	ld	(ix-4),hl
;2125   else
;2126     if (pvGetInfo(pvid, &pvInfo))  statusCode = ECA_BADCHID;
	jr	@140
@139:
	.debug	# 2126
	ld	hl,-21+@122
	add	hl,sp
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$pvGetInfo
	add	sp,4
	bool	hl
	jr	z,@141
	ld	hl,0x19a
	ld	(ix-4),hl
;2127 
;2128 
;2129 //--- return 0 if ci, dbrType, and sid are all valid and usable ---
;2130   if (statusCode != ECA_NORMAL)  return 0;
@141:
@140:
	.debug	# 2130
	ld	hl,(ix-4)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@142
	bool	hl
	ld	l,h
	jp	@123
;2131 
;2132 
;2133 //--- Send msg with the error code ---
;2134   resp.cmd  = htons(cmd);
@142:
	.debug	# 2134
	ld	hl,(ix+7)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-167+@122
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2135   resp.size = 0;
	.debug	# 2135
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-165+@122
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2136   resp.fld3 = htons(dbrType);
	.debug	# 2136
	ld	hl,(ix+13)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-163+@122
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2137   resp.fld4 = htons(numElems);
	.debug	# 2137
	ld	hl,(ix+15)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-161+@122
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2138   resp.fld5 = htonl(statusCode);   // Doco says SID, but that is wrong!!! *
	.debug	# 2138
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,0
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-159+@122
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2139   resp.fld6 = htonl(eventID);
	.debug	# 2139
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-155+@122
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2140 
;2141   addToRespPkt(ci, &resp, 16);
	.debug	# 2141
	ld	hl,0x10
	push	hl
	ld	hl,-165+@122
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
;2142 
;2143   return -1;
	.debug	# 2143
	ld	hl,0xffff
;2144 }
@123:
	.debug	} @123 2144

@122	equ	171
	ld	sp,ix
	pop	ix
	lret
@124	equ	173
;2145 
;2146 
;2147 //-------------------------------------------------------------------------
;2148 //  Send the value of an existing channel.  Used for READ_NOTIFY msgs and f
;2149 //  immediate response to and subsequently generated EVENT_ADD msgs.
;2150 //
;2151 //  The eventID is either the subscription ID from an EVENT_ADD msg or the
;2152 //  IOID from a READ_NOTIFY msg.
;2153 //
;2154 //  WARNING:  The ci, dbrType, and sid values must all have been previously
;2155 //            validated (by validateParams() or equivalent checks).
;2156 //            Validation was removed from this function to reduce overhead 
;2157 //            the most frequent use:  To send updates for subscriptions.
;2158 //
;2159 //  Returns 0 on success, < 0 if an error
;2160 //-------------------------------------------------------------------------
;2161 int sendValue(ConInfo *ci, uint cmd, ulong eventID,
;2162               uint dbrType, uint numElems, SID sid)
;2163 {
$sendValue::
	.debug	G $sendValue 68 9
	.debug	{ $sendValue 68 2161 @145 @144
	ld	hl,-201
	call	__fent##
	.debug	A ci 5 50
	.debug	A cmd 7 7
	.debug	A eventID 9 9
	.debug	A dbrType 13 7
	.debug	A numElems 15 7
	.debug	A sid 17 7
;2164   bool  sendRaw;
	.debug	L sendRaw -1 3
;2165   PVID  pvid;
	.debug	L pvid -3 7
;2166   uint  payloadSize, count, baseType, extType, statusCode, dataOffset,
	.debug	L payloadSize -5 7
	.debug	L count -7 7
	.debug	L baseType -9 7
	.debug	L extType -11 7
	.debug	L statusCode -13 7
	.debug	L dataOffset -15 7
;2167         hdrPlusDataSize, payloadFill;
	.debug	L hdrPlusDataSize -17 7
	.debug	L payloadFill -19 7
;2168   uchar  *ptr;
	.debug	L ptr -21 43
;2169   PVID far  *chan;
	.debug	L chan -25 69
;2170   div_t  qr;
	.debug	L qr -29 73
;2171   TypeData  typeData;
	.debug	L typeData -34 36
;2172   PV_Info  pvInfo;
	.debug	L pvInfo -47 70
;2173   CA_MsgHdr  resp;
	.debug	L resp -193 65
;2174   CA_Con far *con;
	.debug	L con -197 71
;2175 
;2176   if (ShowEvents OR ci->showCmds)  printf("    dbrType:%2u\n", dbrType);  /
	.debug	# 2176
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x40
	and	hl,de
	jr	nz,@146
	ld	hl,(ix+5)
	ld	e,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@147
@146:
	ld	hl,(ix+13)
	push	hl
	ld	de,word (phys @1+323)
	ld	c,phys @1+323 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2177 
;2178 //--- extract the base and extended types from the dbrType ---
;2179   qr = div(dbrType, 7);  baseType = qr.rem;  extType = qr.quot;
@147:
	.debug	# 2179
	ld	hl,0x7
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	hl,-197+@143
	add	hl,sp
	push	hl
	call	_div
	add	sp,6
	ex	de,hl
	ld	hl,-29+@143
	add	hl,sp
	ex	de,hl
	push	hl
	ld	bc,4
	ldir
	pop	hl
	ld	hl,(ix-27)
	ld	(ix-9),hl
	ld	hl,(ix-29)
	ld	(ix-11),hl
;2180 #ifdef RABBIT
;2181   if (baseType == DBR_DOUBLE)  baseType = DBR_FLOAT;
	.debug	# 2181
	ld	hl,(ix-9)
	ld	de,0x6
	or	a,a
	sbc	hl,de
	jr	nz,@148
	ld	hl,0x2
	ld	(ix-9),hl
;2182 #endif
;2183   if (extType > EXT_TYPE_TIME)  extType = EXT_TYPE_STS;
@148:
	.debug	# 2183
	ld	hl,(ix-11)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jr	c,@149
	jr	z,@149
	ld	hl,0x1
	ld	(ix-11),hl
;2184   dbrType = extType * 7 + baseType;
@149:
	.debug	# 2184
	ld	hl,(ix-11)
	ld	bc,0x7
	ex	de,hl
	mul
	ld	hl,(ix-9)
	add	hl,bc
	ld	(ix+13),hl
;2185 
;2186   if (ShowEvents OR ci->showCmds)  printf("    dbrType:%2u\n", dbrType);  /
	.debug	# 2186
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x40
	and	hl,de
	jr	nz,@150
	ld	hl,(ix+5)
	ld	e,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@151
@150:
	ld	hl,(ix+13)
	push	hl
	ld	de,word (phys @1+323)
	ld	c,phys @1+323 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2187 
;2188 //--- all this must have been validated before by call to validateParams() 
;2189   con = ci->con;  chan = con->chans + sid;  pvid = *chan;
@151:
	.debug	# 2189
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,-197+@143
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,-197+@143
	add	hl,sp
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+17)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	call	__ladd##
	ld	hl,bc
	ld	(ix-23),hl
	ex	de,hl
	ld	(ix-25),hl
	ex	de,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-3),hl
;2190   pvGetInfo(pvid, &pvInfo);
	.debug	# 2190
	ld	hl,-47+@143
	add	hl,sp
	push	hl
	ld	hl,(ix-3)
	push	hl
	lcall	$pvGetInfo
	add	sp,4
;2191 
;2192 
;2193   statusCode = ECA_NORMAL;  sendRaw = false;
	.debug	# 2193
	ld	hl,0x1
	ld	(ix-13),hl
	xor	a,a
	ld	(ix-1),a
;2194 
;2195   payloadSize = 0;  ptr = resp.data;
	.debug	# 2195
	ld	l,h
	ld	(ix-5),hl
	ld	hl,-177+@143
	add	hl,sp
	ld	(ix-21),hl
;2196 
;2197 //--- All extended DBR_xxx data structs start with status and severity ---
;2198   if (extType)  {
	.debug	# 2198
	ld	hl,(ix-11)
	bool	hl
	jp	z,@152
;2199     U16_(ptr) = htons(0);  ptr += 2;  // status
@153:
	.debug	< @153 @154
	.debug	# 2199
	bool	hl
	ld	l,h
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,(ix-21)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-21)
	inc	hl
	inc	hl
	ld	(ix-21),hl
;2200     U16_(ptr) = htons(0);  ptr += 2;  // severity
	.debug	# 2200
	bool	hl
	ld	l,h
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,(ix-21)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-21)
	inc	hl
	inc	hl
	ld	(ix-21),hl
;2201     if (extType == EXT_TYPE_TIME)  {
	.debug	# 2201
	ld	hl,(ix-11)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@155
;2202       U32_(ptr) = htonl(epochTimeSecs);  ptr += 4;
@156:
	.debug	< @156 @157
	.debug	# 2202
	ld	de,(_epochTimeSecs)
	ld	bc,(_epochTimeSecs+2)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,(ix-21)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-21)
	ld	de,0x4
	add	hl,de
	ld	(ix-21),hl
;2203       U32_(ptr) = htonl(epochTimeNS);  ptr += 4;
	.debug	# 2203
	ld	de,(_epochTimeNS)
	ld	bc,(_epochTimeNS+2)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,(ix-21)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-21)
	ld	de,0x4
	add	hl,de
	ld	(ix-21),hl
;2204     }
@157:
	.debug	>
;2205   }
@155:
@154:
	.debug	>
;2206 
;2207 //--- Add any filler bytes needed ---
;2208   dataOffset = dbrValOffset[dbrType];
@152:
	.debug	# 2208
	ld	hl,(ix+13)
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _dbrValOffset)
	ld	c,phys _dbrValOffset >> 16
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-15),hl
;2209   count = dataOffset - (ptr - resp.data);
	.debug	# 2209
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,-177+@143
	add	hl,sp
	ex	de,hl
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix-15)
	or	a,a
	sbc	hl,de
	ld	(ix-7),hl
;2210   while (count)  { --count;  *ptr++ = 0; }
@158:
	.debug	# 2210
	ld	hl,(ix-7)
	bool	hl
	jr	z,@159
@160:
	.debug	< @160 @161
	ld	hl,(ix-7)
	dec	hl
	ld	(ix-7),hl
	ld	hl,(ix-21)
	inc	hl
	ld	(ix-21),hl
	dec	hl
	xor	a,a
	ld	(hl),a
@161:
	.debug	>
;2211 
;2212 //--- Can't return more elements than we have ---
;2213   if (numElems > pvInfo.numElems)  numElems = pvInfo.numElems;
	jr	@158
@159:
	.debug	# 2213
	ld	hl,(ix+15)
	ex	de,hl
	ld	hl,(ix-38)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@162
	jr	z,@162
	ld	h,d
	ld	l,e
	ld	(ix+15),hl
;2214 
;2215   /*-----------------------------------------------------------------------
;2216    NOTE:
;2217        For PVs with larger data values, we cannot simply copy the entire
;2218        value to the message buffer and send it all at once.  To handle
;2219        such values we need to send the header first then call a function
;2220        to get the PV's current value (in pieces if necessary).  But the
;2221        header tells the client how big the payload for the message is,
;2222        which means we have to know NOW how many bytes will be sent.
;2223 
;2224        If the current PV value is not simply stored in a buffer, and/or we
;2225        need to convert it to a format the client requested (or at least to
;2226        something it can deal with), determining the correct value for the
;2227        size may not be practical.  For example, if the value can only be
;2228        determined by actually doing the conversion, then we might have to
;2229        do it once now (to compute the correct size value) and again later
;2230        after we have sent the message header.
;2231 
;2232        As even simple conversions can take a lot of CPU cycles for larger
;2233        data sets, this is generally not a practical solution.  And if the
;2234        result could be different each time, then there may not BE a way
;2235        to determine the size the value will be the next time we read it.
;2236 
;2237        So, for PVs whose values that are too large to handle by simply
;2238        copying the value to the message buffer, there must be a way to
;2239        determine its current size in the format we will be sending it in.
;2240 
;2241        And because even simple conversions take far more CPU time than
;2242        a direct buffer-to-buffer copy, conversion is not currently
;2243        supported for these larger PV values.  Such conversion COULD be
;2244        supported by providing a function to call that returns the size
;2245        given the format we WILL send it in.  But for now, we are only
;2246        handling sending such values in their "native" format and leaving
;2247        it up to the client to deal with any conversion.
;2248    ----------------------------------------------------------------------*/
;2249 
;2250   do  {
@162:
;2251 
;2252   //--- Is the value something we shouldn't attempt to or is too costly ---
;2253   //--- to convert? ---
;2254 
;2255 //    msgSpaceLeft = resp.data + sizeof(resp.data) - ptr - 8;
;2256 //    if ((numElems > 1) OR (pvInfo.size > msgSpaceLeft))  {
;2257 
;2258     if ((numElems > 1) OR (pvInfo.flags & PV_SEND_RAW))  {
@166:
	.debug	< @166 @167
	.debug	# 2258
	ld	hl,(ix+15)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@170
	jr	nc,@168
@170:
	ld	hl,(ix-36)
	ld	e,0x4
	and	hl,de
	jp	z,@169
@168:
;2259       dbrType = pvTypeToDBF[pvInfo.dataType] + extType * 7;
@171:
	.debug	< @171 @172
	.debug	# 2259
	ld	a,(ix-43)
	bool	hl
	ld	l,a
	add	hl,hl
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys _pvTypeToDBF)
	ld	c,phys _pvTypeToDBF >> 16
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-11)
	ld	bc,0x7
	ex	de,hl
	push	hl
	mul
	pop	hl
	add	hl,bc
	ld	(ix+13),hl
;2260       if (ShowEvents OR ci->showCmds)  printf("    dbrType:%2u\n", dbrType)
	.debug	# 2260
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x40
	and	hl,de
	jr	nz,@173
	ld	hl,(ix+5)
	ld	e,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@174
@173:
	ld	hl,(ix+13)
	push	hl
	ld	de,word (phys @1+323)
	ld	c,phys @1+323 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2261       hdrPlusDataSize = ptr - resp.data + numElems * pvInfo.elemSize;  // s
@174:
	.debug	# 2261
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,-177+@143
	add	hl,sp
	ex	de,hl
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix-40)
	ex	de,hl
	ld	bc,hl
	ld	hl,(ix+15)
	push	hl
	push	bc
	pop	hl
	pop	bc
	push	hl
	mul
	pop	hl
	add	hl,bc
	ld	(ix-17),hl
;2262       payloadSize = (hdrPlusDataSize + 7) & 0xFFF8; // must be mult of 8
	.debug	# 2262
	ld	de,0x7
	add	hl,de
	ld	de,0xfff8
	and	hl,de
	ld	(ix-5),hl
;2263       payloadFill = payloadSize - hdrPlusDataSize;  sendRaw = true;
	.debug	# 2263
	ex	de,hl
	ld	hl,(ix-17)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-19),hl
	ld	a,0x1
	ld	(ix-1),a
;2264       break;
	.debug	# 2264
;2265     }
	jp	@164
@172:
	.debug	>
;2266 
;2267   // (NOTE: The rest of this block is skipped for large or complex values)
;2268 
;2269   //--- Add the current value for the PV converted to the requested format 
;2270     typeData = dbfToPV[baseType];
@169:
	.debug	# 2270
	ld	hl,(ix-9)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x5
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dbfToPV)
	ld	c,phys _dbfToPV >> 16
	call	__ladd##
	ld	hl,-34+@143
	add	hl,sp
	push	bc
	push	de
	ex	de,hl
	call	__farcvp##
	ld	hl,5
	call	__farcopy##
	add	sp,4
;2271     if (pvGetVal(pvid, typeData.pvType, typeData.size, ptr, CUR_VALUE) < 0)
	.debug	# 2271
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-21)
	push	hl
	ld	hl,(ix-32)
	push	hl
	ld	hl,(ix-34)
	push	hl
	ld	hl,(ix-3)
	push	hl
	lcall	$pvGetVal
	add	sp,10
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@175
;2272       if (ShowErrors)  printf("*** Unable to get or convert data ***\n");
@176:
	.debug	< @176 @177
	.debug	# 2272
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@178
	ld	de,word (phys @1+340)
	ld	c,phys @1+340 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2273       payloadSize = 0;  numElems = 0;  ptr = resp.data;
@178:
	.debug	# 2273
	bool	hl
	ld	l,h
	ld	(ix-5),hl
	ld	(ix+15),hl
	ld	hl,-177+@143
	add	hl,sp
	ld	(ix-21),hl
;2274       statusCode = ECA_INTERNAL;  break;
	.debug	# 2274
	ld	hl,0x8e
	ld	(ix-13),hl
;2275     }
	jp	@164
@177:
	.debug	>
;2276 
;2277   //--- reorder the bytes if necessary ---
;2278     if (typeData.reorder)  {
@175:
	.debug	# 2278
	ld	a,(ix-30)
	or	a,a
	jp	z,@179
;2279       if (typeData.size == 2)
@180:
	.debug	< @180 @181
	.debug	# 2279
	ld	hl,(ix-32)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@182
;2280         U16_(ptr) = htons(U16_(ptr));
	.debug	# 2280
	ld	hl,(ix-21)
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,(ix-21)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2281       else
;2282         U32_(ptr) = htonl(U32_(ptr));
	jp	@183
@182:
	.debug	# 2282
	ld	hl,(ix-21)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,(ix-21)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2283     }
@183:
@181:
	.debug	>
;2284 
;2285     ptr += typeData.size;
@179:
	.debug	# 2285
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-21)
	ex	de,hl
	add	hl,de
	ld	(ix-21),hl
;2286 
;2287 
;2288   //--- Compute total payload size (before filling out to mult of 8) ---
;2289     payloadSize = ptr - resp.data;
	.debug	# 2289
	ex	de,hl
	ld	hl,-177+@143
	add	hl,sp
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-5),hl
;2290 
;2291   //--- Add filler until we have a multiple of 8 ---
;2292     while (payloadSize & 7)  { ++payloadSize;  *ptr++ = 0; }
@184:
	.debug	# 2292
	ld	hl,(ix-5)
	ld	de,0x7
	and	hl,de
	jr	z,@185
@186:
	.debug	< @186 @187
	ld	hl,(ix-5)
	inc	hl
	ld	(ix-5),hl
	ld	hl,(ix-21)
	inc	hl
	ld	(ix-21),hl
	dec	hl
	xor	a,a
	ld	(hl),a
@187:
	.debug	>
;2293 
;2294   } while (0);
	jr	@184
@185:
@167:
	.debug	>
	.debug	# 2294
;2295 
;2296 
;2297   if (ShowEvents OR ci->showCmds OR ((statusCode != ECA_NORMAL) AND ShowErr
@164:
	.debug	# 2297
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x40
	and	hl,de
	jr	nz,@188
	ld	hl,(ix+5)
	ld	e,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@188
	ld	hl,(ix-13)
	ld	e,0x1
	or	a,a
	sbc	hl,de
	jr	z,@189
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@189
@188:
;2298     printf("    Sending: dbrType:%2u  #elem:%u  payload: %u  SID:%3u  event
;2299            dbrType, numElems, payloadSize, (uint)sid, eventID, statusCode, 
	.debug	# 2299
	ld	hl,(ix-47)
	ex	de,hl
	ld	hl,(ix-45)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-3)
	push	hl
	ld	hl,(ix-13)
	push	hl
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+17)
	push	hl
	ld	hl,(ix-5)
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix+13)
	push	hl
	ld	de,word (phys @1+379)
	ld	c,phys @1+379 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,24
;2300 
;2301 
;2302 //--- Send msg with an error code or as a prefix for the PV's current value
;2303 //--- If the value is already part of the payload, then it gets sent too. -
;2304   resp.cmd  = htons(cmd);
@189:
	.debug	# 2304
	ld	hl,(ix+7)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-193+@143
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2305   resp.size = htons(payloadSize);
	.debug	# 2305
	ld	hl,(ix-5)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-191+@143
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2306   resp.fld3 = htons(dbrType);
	.debug	# 2306
	ld	hl,(ix+13)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-189+@143
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2307   resp.fld4 = htons(numElems);
	.debug	# 2307
	ld	hl,(ix+15)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-187+@143
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2308   resp.fld5 = htonl(statusCode);   // Doco says SID, but that is wrong!!! *
	.debug	# 2308
	ld	hl,(ix-13)
	ex	de,hl
	ld	bc,0
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-185+@143
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2309   resp.fld6 = htonl(eventID);
	.debug	# 2309
	ld	hl,(ix+9)
	ex	de,hl
	ld	hl,(ix+11)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-181+@143
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2310 
;2311   count = ptr - (uchar *)&resp;
	.debug	# 2311
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,-193+@143
	add	hl,sp
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-7),hl
;2312 
;2313   if (addToRespPkt(ci, &resp, count))  return -1;
	.debug	# 2313
	push	hl
	ld	hl,-191+@143
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jr	nz,@1001
;2314 
;2315   if (!sendRaw OR (statusCode != ECA_NORMAL))  return 0;
	.debug	# 2315
	ld	a,(ix-1)
	or	a,a
	jr	z,@194
	ld	hl,(ix-13)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@195
@194:
	bool	hl
	ld	l,h
	jr	@144
;2316 
;2317 
;2318 /*
;2319   If we  got to this point, the PV was not small and simple enough to be
;2320   handled by mearly copying its value to the fixed size buffer and doing
;2321   whatever data conversion is required.  We have sent the header and any
;2322   extended data structure prefix, but we still need to send the PV's value
;2323   as the remainder of the payload.
;2324 
;2325   This is done by passing the PV layer a pointer to a func it must call to
;2326   send the data (in this case, addToRespPkt).  The function does not return
;2327   until it has processed all the bytes provided or an error occurs, so the 
;2328   layer can call it once with a pointer to the whole PV value, or multiple
;2329   times, each time with a pointer to the next piece of the PV value.  This
;2330   avoids the need for another buffer large enough to hold the entire value.
;2331   And in cases where it is not too costly, the PV layer could even generate
;2332   or transform the value a piece at a time (again, without the need for a
;2333   single large buffer to hold the entire result).
;2334 
;2335   NOTE that, for the current version of this module, the CA data service wi
;2336   be blocked for however long it takes to send the value.  If the size and/
;2337   number of PVs grows to the point where this "blocking" approach becomes a
;2338   performance issue, the method will need to be changed to work more like
;2339   the NSCL DirectCA module which runs on the IOCs and never blocks during a
;2340   read or write, minimizing the effect any one connection can have on all t
;2341   others.  This is achieved by keeping track of the state of each connectio
;2342   and allowing the reading or writing of a single message to span multiple
;2343   passes.
;2344 
;2345   Of course, the downside to the non-blocking approach is that it increases
;2346   the time that larger or more complex values will be locked, which can
;2347   affect the performance of other processes (including the main application
;2348   task, which usually does have some important timing constraints).
;2349 */
;2350 
;2351   if (pvCopyVal(pvid, numElems, (void *)ci, addToRespPkt))  return -1;
@195:
	.debug	# 2351
	ld	hl,_addToRespPkt
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,(ix+15)
	push	hl
	ld	hl,(ix-3)
	push	hl
	lcall	$pvCopyVal
	add	sp,8
	bool	hl
	jr	nz,@1001
;2352 
;2353 //--- Add filler if needed (computed earlier to insure the payload size is 
;2354 //--- a multiple of 8 bytes, as required by the protocol) ---
;2355   if (payloadFill)  {
	.debug	# 2355
	ld	hl,(ix-19)
	bool	hl
	jr	z,@197
;2356     memset(resp.data, 0, payloadFill);
@198:
	.debug	< @198 @199
	.debug	# 2356
	ld	hl,(ix-19)
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-173+@143
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
;2357     if (addToRespPkt(ci, resp.data, payloadFill))  return -1;
	.debug	# 2357
	ld	hl,(ix-19)
	push	hl
	ld	hl,-175+@143
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jr	z,@200
@1001:
	ld	hl,0xffff
	jr	@144
;2358   }
@200:
@199:
	.debug	>
;2359 
;2360   return 0;
@197:
	.debug	# 2360
	bool	hl
	ld	l,h
;2361 }
@144:
	.debug	} @144 2361

@143	equ	201
	ld	sp,ix
	pop	ix
	lret
@145	equ	203
;2362 
;2363 
;2364 //-------------------------------------------------------------------------
;2365 //  Send the CA protocol version # we are using
;2366 //-------------------------------------------------------------------------
;2367 int sendVersion(ConInfo *ci)
;2368 {
$sendVersion::
	.debug	G $sendVersion 58 9
	.debug	{ $sendVersion 58 2367 @203 @202
	ld	hl,-146
	call	__fent##
	.debug	A ci 5 50
;2369   CA_MsgHdr  resp;
	.debug	L resp -146 65
;2370 
;2371 
;2372   memset(&resp, 0, sizeof(resp));
	.debug	# 2372
	ld	hl,0x92
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-142+@201
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
;2373 
;2374   resp.cmd  = htons(CA_PROTO_VERSION);
	.debug	# 2374
	bool	hl
	ld	l,h
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-146+@201
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2375   resp.fld4 = htons(CA_MINOR_VERSION);
	.debug	# 2375
	ld	hl,0xb
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-140+@201
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2376 
;2377   if (addToRespPkt(ci, &resp, 16))  return -1;
	.debug	# 2377
	ld	hl,0x10
	push	hl
	ld	hl,-144+@201
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jr	z,@204
	ld	hl,0xffff
	jr	@202
;2378 
;2379   ci->versRespPending = false;
@204:
	.debug	# 2379
	ld	hl,(ix+5)
	ld	de,0x9
	add	hl,de
	xor	a,a
	ld	(hl),a
;2380 
;2381   return 0;
	.debug	# 2381
	bool	hl
	ld	l,h
;2382 }
@202:
	.debug	} @202 2382

@201	equ	146
	ld	sp,ix
	pop	ix
	lret
@203	equ	148
;2383 
;2384 
;2385 //=========================================================================
;2386 //************  funcs to handle specific CA protocol messages  ************
;2387 //=========================================================================
;2388 
;2389 //-------------------------------------------------------------------------
;2390 //  CA_PROTO_VERSION:  Send the version of the protocol this server is usin
;2391 //-------------------------------------------------------------------------
;2392 PROTO_CMD_FUNC( CA_Version )
;2393 PROTO_CMD_FUNC( CA_Version )
	.align	4
$$CA_Version::
	ex	(sp),iy
$CA_Version::
	.debug	G $CA_Version 41 9
	.debug	{ $CA_Version 41 2392 @207 @206
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ci 5 50
	.debug	A msg 7 64
;2394 
;2395   if (ci->showCmds)
	.debug	# 2395
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@208
;2396     printf("VERSION: Client:4.%d  Server:4.%d\n",
;2397            msg->fld4, CA_MINOR_VERSION);
	.debug	# 2397
	ld	hl,0xb
	push	hl
	ld	hl,(ix+7)
	ld	e,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+482)
	ld	c,phys @1+482 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;2398 
;2399   ci->versRespPending = true;
@208:
	.debug	# 2399
	ld	hl,(ix+5)
	ld	de,0x9
	add	hl,de
	ld	a,0x1
	ld	(hl),a
;2400 
;2401 //--- All UDP broadcast packets with SEARCH msgs start with a VERSION msg, 
;2402 //--- so we must NOT respond to a VERSION request rcvd via UDP broadcast. -
;2403 //--- If all the CA servers did this, then every client would be bombarded 
;2404 //--- with VERSION msg responses from all the CA servers. ---
;2405   if (ci->type == UDP_CON)  return 0;
	.debug	# 2405
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	bool	hl
	jr	nz,@209
	bool	hl
	ld	l,h
	jr	@206
;2406 
;2407   return sendVersion(ci);
@209:
	.debug	# 2407
	ld	hl,(ix+5)
	push	hl
	lcall	$sendVersion
	pop	de
;2408 }
@206:
	.debug	} @206 2408

@205	equ	0
	pop	ix
	lret
@207	equ	2
;2409 
;2410 //-------------------------------------------------------------------------
;2411 //  CA_PROTO_EVENT_ADD:  Create or Update a subscription on an existing cha
;2412 //-------------------------------------------------------------------------
;2413 PROTO_CMD_FUNC( CA_EventAdd )
;2414 PROTO_CMD_FUNC( CA_EventAdd )
	.align	4
$$CA_EventAdd::
	ex	(sp),iy
$CA_EventAdd::
	.debug	G $CA_EventAdd 41 9
	.debug	{ $CA_EventAdd 41 2413 @212 @211
	ld	hl,-196
	call	__fent##
	.debug	A ci 5 50
	.debug	A msg 7 64
;2415   time_t  curSecs;
	.debug	L curSecs -4 9
;2416   int  stat;
	.debug	L stat -6 6
;2417   uint  pvid, curMS, u, dbrType, numElems, monMask, newSubNum, maxSubNum,
	.debug	L pvid -8 7
	.debug	L curMS -10 7
	.debug	L u -12 7
	.debug	L dbrType -14 7
	.debug	L numElems -16 7
	.debug	L monMask -18 7
	.debug	L newSubNum -20 7
	.debug	L maxSubNum -22 7
;2418         errCode = 0;
	.debug	L errCode -24 7
	.debug	# 2418
	bool	hl
	ld	l,h
	ld	(ix-24),hl
	.seg	FARCODE
;2419   SID  sid;
	.debug	L sid -26 7
;2420   ulong  subID;
	.debug	L subID -30 9
;2421   CA_Sub far  *sub, *newSub;
	.debug	L sub -34 74
	.debug	L newSub -38 74
;2422   PVID far  *chan = NULL;
	.debug	L chan -42 69
	.debug	# 2422
	ld	d,h
	ld	e,l
	ld	b,e
	ld	(ix-40),hl
	ex	de,hl
	ld	(ix-42),hl
	ex	de,hl
	.seg	FARCODE
;2423   CA_Con far *con;
	.debug	L con -46 71
;2424   CA_MsgHdr  resp;
	.debug	L resp -192 65
;2425   const char far *errMsg = "ERROR";
	.debug	L errMsg -196 33
	.debug	# 2425
	ld	de,word (phys @1+517)
	ld	c,phys @1+517 >> 16
	ld	hl,-196+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	.seg	FARCODE
;2426 
;2427 
;2428   con = ci->con;
	.debug	# 2428
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-44),hl
	ex	de,hl
	ld	(ix-46),hl
	ex	de,hl
;2429 
;2430   dbrType = msg->fld3;
	.debug	# 2430
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-14),hl
;2431   numElems = msg->fld4;
	.debug	# 2431
	ld	hl,(ix+7)
	ld	e,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-16),hl
;2432   sid = (SID) msg->fld5;
	.debug	# 2432
	ld	hl,(ix+7)
	ld	e,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	inc	hl
	ex	de,hl
	ld	(ix-26),hl
;2433   subID = msg->fld6;
	.debug	# 2433
	ld	hl,(ix+7)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-28),hl
	ex	de,hl
	ld	(ix-30),hl
	ex	de,hl
;2434 
;2435   monMask = ntohs(U16_(msg->data + 12));
	.debug	# 2435
	ld	hl,(ix+7)
	ld	de,0x10
	add	hl,de
	ld	e,0xc
	add	hl,de
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-18),hl
;2436 
;2437   if (!monMask OR (monMask != monMask & DBE_MASK_BITS))  {
	.debug	# 2437
	bool	hl
	jr	z,@213
	ld	hl,(ix-18)
	ex	de,hl
	ld	h,d
	ld	l,e
	or	a,a
	sbc	hl,de
	jr	z,@215
	ld	hl,1
@215:
	ld	de,0x7
	and	hl,de
	jr	z,@214
@213:
;2438     if (ShowErrors OR ci->showCmds)  errMsg = "Invalid Mask";
@216:
	.debug	< @216 @217
	.debug	# 2438
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	nz,@218
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@219
@218:
	ld	de,word (phys @1+523)
	ld	c,phys @1+523 >> 16
	ld	hl,-196+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2439     errCode = ECA_BADMASK;
@219:
	.debug	# 2439
	ld	hl,0x14a
	ld	(ix-24),hl
;2440   }
@217:
	.debug	>
;2441 
;2442   if (dbrType > LAST_BUFFER_TYPE)  {
@214:
	.debug	# 2442
	ld	hl,(ix-14)
	ld	de,0x26
	or	a,a
	sbc	hl,de
	jr	c,@220
	jr	z,@220
;2443     if (ShowErrors OR ci->showCmds)  errMsg = "Invalid DBR type";
@221:
	.debug	< @221 @222
	.debug	# 2443
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	nz,@223
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@224
@223:
	ld	de,word (phys @1+536)
	ld	c,phys @1+536 >> 16
	ld	hl,-196+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2444     errCode = ECA_BADTYPE;
@224:
	.debug	# 2444
	ld	hl,0x72
	ld	(ix-24),hl
;2445   }
@222:
	.debug	>
;2446 
;2447   if (sid < con->maxChanNum)  chan = con->chans + sid;
@220:
	.debug	# 2447
	ld	hl,(ix-46)
	ex	de,hl
	ld	hl,(ix-44)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x83
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-26)
	or	a,a
	sbc	hl,de
	jr	nc,@225
	ld	hl,(ix-46)
	ex	de,hl
	ld	hl,(ix-44)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-26)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	call	__ladd##
	ld	hl,bc
	ld	(ix-40),hl
	ex	de,hl
	ld	(ix-42),hl
	ex	de,hl
;2448 
;2449   if (!chan OR (*chan == CHAN_UNUSED))  {
@225:
	.debug	# 2449
	ld	hl,(ix-42)
	ex	de,hl
	ld	hl,(ix-40)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@226
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__farld2##
	ld	hl,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@227
@226:
;2450     if (ShowErrors OR ci->showCmds)  errMsg = "Invalid SID";
@228:
	.debug	< @228 @229
	.debug	# 2450
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	nz,@230
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@231
@230:
	ld	de,word (phys @1+553)
	ld	c,phys @1+553 >> 16
	ld	hl,-196+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2451     errCode = ECA_BADCHID;
@231:
	.debug	# 2451
	ld	hl,0x19a
	ld	(ix-24),hl
;2452   }
@229:
	.debug	>
;2453 
;2454 //--- find an unused subscription slot or one with a matching ID ---
;2455   newSub = NULL;  maxSubNum = con->maxSubNum;
@227:
	.debug	# 2455
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-36),hl
	ex	de,hl
	ld	(ix-38),hl
	ex	de,hl
	ld	hl,(ix-46)
	ex	de,hl
	ld	hl,(ix-44)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x305
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-22),hl
;2456   for (u=0,sub=con->subs; u<maxSubNum; ++u,++sub)  {
@232:
	.debug	< @232 @233
	.debug	# 2456
	bool	hl
	ld	l,h
	ld	(ix-12),hl
	ld	hl,(ix-46)
	ex	de,hl
	ld	hl,(ix-44)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x85
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-32),hl
	ex	de,hl
	ld	(ix-34),hl
	ex	de,hl
@234:
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-22)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@235
;2457     if (!newSub)  if (sub->sid == CHAN_UNUSED)  newSub = sub;  // 1st unuse
@237:
	.debug	< @237 @238
	.debug	# 2457
	ld	hl,(ix-38)
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@239
	ld	hl,(ix-34)
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	call	__farld2##
	ld	hl,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@240
	ld	hl,(ix-34)
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	ld	(ix-36),hl
	ex	de,hl
	ld	(ix-38),hl
	ex	de,hl
;2458     if (sub->subID == subID)  {  // ID matches existing subscription ID
@240:
@239:
	.debug	# 2458
	ld	hl,(ix-34)
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-30)
	ex	de,hl
	ld	hl,(ix-28)
	ld	bc,hl
	call	__lsub##
	jr	nz,@241
;2459       if (sub->sid != sid)  {
@242:
	.debug	< @242 @243
	.debug	# 2459
	ld	hl,(ix-34)
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	call	__farld2##
	ld	hl,(ix-26)
	or	a,a
	sbc	hl,de
	jr	z,@235
;2460         if (ShowErrors OR ci->showCmds)  errMsg = "SIDs don't match";
@245:
	.debug	< @245 @246
	.debug	# 2460
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	nz,@247
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@248
@247:
	ld	de,word (phys @1+565)
	ld	c,phys @1+565 >> 16
	ld	hl,-196+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2461         errCode = ECA_BADCHID;
@248:
	.debug	# 2461
	ld	hl,0x19a
	ld	(ix-24),hl
;2462       }
@246:
	.debug	>
;2463       break;
	.debug	# 2463
;2464     }
	jr	@235
@243:
	.debug	>
;2465   }
@241:
@238:
	.debug	>
;2466   if (u == maxSubNum)  {  // no matching existing subscription
	ld	hl,(ix-12)
	inc	hl
	ld	(ix-12),hl
	ld	hl,(ix-34)
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-32),hl
	ex	de,hl
	ld	(ix-34),hl
	ex	de,hl
	jp	@234
@235:
@233:
	.debug	>
	.debug	# 2466
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-22)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@249
;2467     if (!newSub AND (maxSubNum < CA_MAX_SUBSCR))  newSub = sub;
@250:
	.debug	< @250 @251
	.debug	# 2467
	ld	hl,(ix-38)
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@253
	ld	hl,(ix-22)
	ld	de,0x40
	or	a,a
	sbc	hl,de
	jr	nc,@253
	ld	hl,(ix-34)
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	ld	(ix-36),hl
	ex	de,hl
	ld	(ix-38),hl
	ex	de,hl
;2468     sub = NULL;
@253:
	.debug	# 2468
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-32),hl
	ex	de,hl
	ld	(ix-34),hl
	ex	de,hl
;2469   }
@251:
	.debug	>
;2470 
;2471 
;2472 //--- No free slot and no match? ---
;2473   if (!newSub AND !sub)  {
@249:
	.debug	# 2473
	ld	hl,(ix-38)
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@255
	ld	hl,(ix-34)
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@255
;2474     if (ShowErrors OR ci->showCmds)  errMsg = "Max Subscriptions exceeded";
@256:
	.debug	< @256 @257
	.debug	# 2474
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	nz,@258
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@259
@258:
	ld	de,word (phys @1+582)
	ld	c,phys @1+582 >> 16
	ld	hl,-196+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2475     errCode = ECA_ALLOCMEM;
@259:
	.debug	# 2475
	ld	hl,0x30
	ld	(ix-24),hl
;2476   }
@257:
	.debug	>
;2477 
;2478 
;2479   if (ci->showCmds OR (errCode AND ShowErrors))  {
@255:
	.debug	# 2479
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@260
	ld	hl,(ix-24)
	bool	hl
	jr	z,@261
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@261
@260:
;2480     printf("EVENT_ADD: mask:0x%02X  dbrType:%2u", monMask, dbrType);
@265:
	.debug	< @265 @266
	.debug	# 2480
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix-18)
	push	hl
	ld	de,word (phys @1+609)
	ld	c,phys @1+609 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;2481     if (errCode)  printf("*** %ls ***\n", errMsg);
	.debug	# 2481
	ld	hl,(ix-24)
	bool	hl
	jr	z,@267
	ld	hl,-196+@210
	add	hl,sp
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @1+645)
	ld	c,phys @1+645 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;2482     if (ci->showCmds)  printf("\n");
@267:
	.debug	# 2482
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@268
	ld	de,word (phys @1+98)
	ld	c,phys @1+98 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2483   }
@268:
@266:
	.debug	>
;2484 
;2485 
;2486   if (errCode)  {
@261:
	.debug	# 2486
	ld	hl,(ix-24)
	bool	hl
	jp	z,@269
;2487     resp.cmd = htons(CA_PROTO_EVENT_ADD);
@270:
	.debug	< @270 @271
	.debug	# 2487
	ld	l,0x1
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-192+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2488     resp.size = 0;
	.debug	# 2488
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-190+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2489     resp.fld3 = htons(dbrType);
	.debug	# 2489
	ld	hl,(ix-14)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-188+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2490     resp.fld4 = 0;
	.debug	# 2490
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-186+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2491     resp.fld5 = htonl(errCode);
	.debug	# 2491
	ld	hl,(ix-24)
	ex	de,hl
	ld	b,h
	ld	c,l
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-184+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2492     resp.fld6 = htonl(subID);
	.debug	# 2492
	ld	hl,(ix-30)
	ex	de,hl
	ld	hl,(ix-28)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-180+@210
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2493 
;2494     if (addToRespPkt(ci, &resp, 16))  return -1;
	.debug	# 2494
	ld	hl,0x10
	push	hl
	ld	hl,-190+@210
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jp	nz,@1000
;2495 
;2496     return 0;
	.debug	# 2496
	bool	hl
	ld	l,h
	jp	@211
;2497   }
@271:
	.debug	>
;2498 
;2499 
;2500 //--- update existing or add new subscription ---
;2501   if (sub)  {  // existing
@269:
	.debug	# 2501
	ld	hl,(ix-34)
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@273
;2502     sub->monMask = monMask;
@274:
	.debug	< @274 @275
	.debug	# 2502
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,(ix-18)
	call	__farst1##
;2503     sub->dbrType = dbrType;
	.debug	# 2503
	ld	hl,(ix-34)
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,(ix-14)
	call	__farst1##
;2504     sub->numElems = numElems;
	.debug	# 2504
	ld	hl,(ix-34)
	ex	de,hl
	ld	hl,(ix-32)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-16)
	call	__farst2##
;2505   }
@275:
	.debug	>
;2506   else  {  // new
	jp	@276
@273:
;2507     newSub->sid = sid;
@277:
	.debug	< @277 @278
	.debug	# 2507
	ld	hl,(ix-38)
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	ld	hl,(ix-26)
	call	__farst2##
;2508     newSub->subID = subID;
	.debug	# 2508
	ld	hl,(ix-38)
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-30)
	ex	de,hl
	ld	hl,(ix-28)
	ld	bc,hl
	call	__farst4d##
;2509     newSub->monMask = monMask;
	.debug	# 2509
	ld	hl,(ix-38)
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,(ix-18)
	call	__farst1##
;2510     newSub->dbrType = dbrType;
	.debug	# 2510
	ld	hl,(ix-38)
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,(ix-14)
	call	__farst1##
;2511     newSub->numElems = numElems;
	.debug	# 2511
	ld	hl,(ix-38)
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-16)
	call	__farst2##
;2512     // track largest subscription # used
;2513     newSubNum = (uint)(newSub - con->subs) + 1;
	.debug	# 2513
	ld	hl,(ix-46)
	ex	de,hl
	ld	hl,(ix-44)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x85
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-38)
	ex	de,hl
	ld	hl,(ix-36)
	ld	bc,hl
	call	__lsubr##
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ldiv##
	inc	de
	ex	de,hl
	ld	(ix-20),hl
;2514     if (newSubNum > con->maxSubNum)  con->maxSubNum = newSubNum;
	.debug	# 2514
	ld	hl,(ix-46)
	ex	de,hl
	ld	hl,(ix-44)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x305
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-20)
	or	a,a
	sbc	hl,de
	jr	c,@279
	jr	z,@279
	ld	hl,(ix-46)
	ex	de,hl
	ld	hl,(ix-44)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x305
	ld	bc,0
	call	__ladd##
	ld	hl,(ix-20)
	call	__farst2##
;2515   }
@279:
@278:
	.debug	>
;2516 
;2517 
;2518 //--- update the mask used to generate subscription event msgs ---
;2519   pvCheckEvents(*chan, monMask);
@276:
	.debug	# 2519
	ld	hl,(ix-18)
	push	hl
	ld	hl,(ix-42)
	ex	de,hl
	ld	hl,(ix-40)
	ld	bc,hl
	call	__farld2##
	push	de
	ex	de,hl
	lcall	$pvCheckEvents
	add	sp,4
;2520 
;2521 //--- send a msg with the PV's current value ---
;2522   _EnterCritical_();  curSecs = TIME();  curMS = milliTicks;  _ExitCritical
	.debug	# 2522
	ipset	2
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(_milliTicks)
	ld	(ix-10),hl
	ipres
;2523   epochTimeSecs = curSecs - 631152000lu; // EPICS uses 1990-01-01 00:00:00
	.debug	# 2523
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6280
	ld	bc,0xda61
	call	__ladd##
	ld	(_epochTimeSecs),de
	ld	(_epochTimeSecs+2),bc
;2524   epochTimeNS = curMS * 1000000lu;
	.debug	# 2524
	ld	hl,(ix-10)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x4240
	ld	c,0xf
	call	__ulmlt##
	ld	(_epochTimeNS),de
	ld	(_epochTimeNS+2),bc
;2525 
;2526   pvid = *chan;
	.debug	# 2526
	ld	hl,(ix-42)
	ex	de,hl
	ld	hl,(ix-40)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-8),hl
;2527 
;2528   if (pvLockVal(pvid, LM_WaitLock, LT_READ) < 0)  return -1;
	.debug	# 2528
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	ld	hl,(ix-8)
	push	hl
	lcall	$pvLockVal
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@280
@1000:
	ld	hl,0xffff
	jr	@211
;2529   stat = sendValue(ci, CA_PROTO_EVENT_ADD, subID, dbrType, numElems, sid);
@280:
	.debug	# 2529
	ld	hl,(ix-26)
	push	hl
	ld	hl,(ix-16)
	push	hl
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix-30)
	ex	de,hl
	ld	hl,(ix-28)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,0x1
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$sendValue
	add	sp,14
	ld	(ix-6),hl
;2530   pvLockVal(pvid, LM_Unlock, LT_READ);
	.debug	# 2530
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix-8)
	push	hl
	lcall	$pvLockVal
	add	sp,6
;2531 
;2532   return stat;
	.debug	# 2532
	ld	hl,(ix-6)
;2533 }
@211:
	.debug	} @211 2533

@210	equ	196
	ld	sp,ix
	pop	ix
	lret
@212	equ	198
;2534 
;2535 
;2536 //-------------------------------------------------------------------------
;2537 //  CA_PROTO_EVENT_CANCEL:  Remove an event subscription created by an earl
;2538 //  EVENT_ADD msg.
;2539 //-------------------------------------------------------------------------
;2540 PROTO_CMD_FUNC( CA_EventCancel )
;2541 PROTO_CMD_FUNC( CA_EventCancel )
	.align	4
$$CA_EventCancel::
	ex	(sp),iy
$CA_EventCancel::
	.debug	G $CA_EventCancel 41 9
	.debug	{ $CA_EventCancel 41 2540 @283 @282
	ld	hl,-164
	call	__fent##
	.debug	A ci 5 50
	.debug	A msg 7 64
;2542   uint  u, maxSubNum;  //, dbrType, numElems;
	.debug	L u -2 7
	.debug	L maxSubNum -4 7
;2543   SID  sid;
	.debug	L sid -6 7
;2544   ulong  subID;
	.debug	L subID -10 9
;2545   CA_Sub far  *sub;
	.debug	L sub -14 74
;2546   CA_Con far *con;
	.debug	L con -18 71
;2547   CA_MsgHdr  resp;
	.debug	L resp -164 65
;2548 
;2549 
;2550   con = ci->con;
	.debug	# 2550
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
;2551 
;2552 //  dbrType = msg->fld3;
;2553 //  numElems = msg->fld4;
;2554   sid = (SID) msg->fld5;
	.debug	# 2554
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	inc	hl
	ex	de,hl
	ld	(ix-6),hl
;2555   subID = msg->fld6;
	.debug	# 2555
	ld	hl,(ix+7)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;2556 
;2557   if (ci->showCmds)
	.debug	# 2557
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@284
;2558     printf("EVENT_CANCEL:  SID:0x%04X  subID:0x%08lX\r\n", sid, subID);
	.debug	# 2558
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-6)
	push	hl
	ld	de,word (phys @1+658)
	ld	c,phys @1+658 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;2559 
;2560 //--- Locate the subscription in the list for this connection ---
;2561   maxSubNum = con->maxSubNum;
@284:
	.debug	# 2561
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x305
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-4),hl
;2562   for (u=0,sub=con->subs; u<maxSubNum; ++u,++sub)
@285:
	.debug	< @285 @286
	.debug	# 2562
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x85
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
@287:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@288
;2563     if (sub->subID == subID)  break;
	.debug	# 2563
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__lsub##
	jr	z,@288
;2564 
;2565 //--- No subscription with the specified ID? ---
;2566   if (u == maxSubNum)
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
	jr	@287
@288:
@286:
	.debug	>
	.debug	# 2566
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@291
;2567     return sendErrResp(ci, msg, (ulong)(-1), ECA_BADMONID, "Invalid subID")
	.debug	# 2567
	ld	de,word (phys @1+701)
	ld	c,phys @1+701 >> 16
	push	bc
	push	de
	ld	hl,0xf2
	push	hl
	ld	de,0xffff
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$sendErrResp
	add	sp,14
	jp	@282
;2568 
;2569 //--- send resp, which uses the EVENT_ADD cmd and values from the subscrip 
;2570   resp.cmd = htons(CA_PROTO_EVENT_ADD);
@291:
	.debug	# 2570
	ld	hl,0x1
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-164+@281
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2571   resp.size = 0;
	.debug	# 2571
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-162+@281
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2572   resp.fld3 = htons(sub->dbrType);
	.debug	# 2572
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	bool	hl
	ld	l,a
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-160+@281
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2573   resp.fld4 = 0;
	.debug	# 2573
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-158+@281
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2574   resp.fld5 = htonl(sid);
	.debug	# 2574
	ld	hl,(ix-6)
	ex	de,hl
	ld	b,h
	ld	c,l
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-156+@281
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2575   resp.fld6 = htonl(subID);
	.debug	# 2575
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-152+@281
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2576 
;2577 //--- clear the subscription ---
;2578   fmemset(sub, 0xff, sizeof(CA_Sub));
	.debug	# 2578
	ld	de,0xa
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,0xff
	push	hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;2579 
;2580   if (addToRespPkt(ci, &resp, 16))  return -1;
	.debug	# 2580
	ld	hl,0x10
	push	hl
	ld	hl,-162+@281
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jr	z,@292
	ld	hl,0xffff
	jr	@282
;2581 
;2582   return 0;
@292:
	.debug	# 2582
	bool	hl
	ld	l,h
;2583 }
@282:
	.debug	} @282 2583

@281	equ	164
	ld	sp,ix
	pop	ix
	lret
@283	equ	166
;2584 
;2585 
;2586 
;2587 //-------------------------------------------------------------------------
;2588 //  CA_PROTO_WRITE and CA_PROTO_WRITE_NOTIFY:
;2589 //-------------------------------------------------------------------------
;2590 PROTO_CMD_FUNC( CA_Write )
;2591 PROTO_CMD_FUNC( CA_Write )
	.align	4
$$CA_Write::
	ex	(sp),iy
$CA_Write::
	.debug	G $CA_Write 41 9
	.debug	{ $CA_Write 41 2590 @295 @294
	ld	hl,-191
	call	__fent##
	.debug	A ci 5 50
	.debug	A msg 7 64
;2592   bool  notify;
	.debug	L notify -1 3
;2593   uint  pvid, dbrType, numElems, baseType, errCode = 0; //, extType;
	.debug	L pvid -3 7
	.debug	L dbrType -5 7
	.debug	L numElems -7 7
	.debug	L baseType -9 7
	.debug	L errCode -11 7
	.debug	# 2593
	bool	hl
	ld	l,h
	ld	(ix-11),hl
	.seg	FARCODE
;2594   SID  sid;
	.debug	L sid -13 7
;2595   uchar  *ptr;
	.debug	L ptr -15 43
;2596   PVID far  *chan = NULL;
	.debug	L chan -19 69
	.debug	# 2596
	ld	d,h
	ld	e,l
	ld	(ix-17),hl
	ex	de,hl
	ld	(ix-19),hl
	ex	de,hl
	.seg	FARCODE
;2597   CA_Con far *con;
	.debug	L con -23 71
;2598   const char far *errMsg = "ERROR";
	.debug	L errMsg -27 33
	.debug	# 2598
	ld	de,word (phys @1+517)
	ld	c,phys @1+517 >> 16
	ld	l,c
	ld	(ix-25),hl
	ex	de,hl
	ld	(ix-27),hl
	ex	de,hl
	.seg	FARCODE
;2599 //  div_t  qr;
;2600   TypeData  typeData;
	.debug	L typeData -32 36
;2601   PV_Info  pvInfo;
	.debug	L pvInfo -45 70
;2602   CA_MsgHdr  resp;
	.debug	L resp -191 65
;2603 
;2604 
;2605   con = ci->con;
	.debug	# 2605
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-21),hl
	ex	de,hl
	ld	(ix-23),hl
	ex	de,hl
;2606 
;2607   dbrType = msg->fld3;
	.debug	# 2607
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-5),hl
;2608   numElems = msg->fld4;
	.debug	# 2608
	ld	hl,(ix+7)
	ld	e,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-7),hl
;2609   sid = (SID) msg->fld5;
	.debug	# 2609
	ld	hl,(ix+7)
	ld	e,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	(ix-13),hl
;2610 
;2611   notify = (msg->cmd == CA_PROTO_WRITE_NOTIFY);  // is a response expected?
	.debug	# 2611
	ld	hl,(ix+7)
	ld	hl,(hl)
	ld	de,0x13
	or	a,a
	sbc	hl,de
	ld	h,d
	ld	l,d
	jr	nz,@296
	inc	l
@296:
	ld	(ix-1),l
;2612 
;2613   ++numWrites;
	.debug	# 2613
	ld	hl,(_numWrites)
	inc	hl
	ld	(_numWrites),hl
;2614 
;2615   if (dbrType > LAST_BUFFER_TYPE)  {
	.debug	# 2615
	ld	hl,(ix-5)
	ld	de,0x26
	or	a,a
	sbc	hl,de
	jr	c,@297
	jr	z,@297
;2616     errMsg = "Invalid DBR type";  errCode = ECA_BADTYPE; }
@298:
	.debug	< @298 @299
	.debug	# 2616
	ld	de,word (phys @1+536)
	ld	c,phys @1+536 >> 16
	ld	hl,bc
	ld	(ix-25),hl
	ex	de,hl
	ld	(ix-27),hl
	ex	de,hl
	ld	hl,0x72
	ld	(ix-11),hl
@299:
	.debug	>
;2617   else  {
	jr	@300
@297:
;2618 //    qr = div(dbrType, 7);  baseType = qr.rem;  extType = qr.quot;
;2619     baseType = dbrType % 7;
@301:
	.debug	< @301 @302
	.debug	# 2619
	ld	hl,(ix-5)
	ld	de,0x7
	call	__uidiv##
	ex	de,hl
	ld	(ix-9),hl
;2620     ptr = msg->data + dbrValOffset[dbrType];
	.debug	# 2620
	ld	hl,(ix-5)
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _dbrValOffset)
	ld	c,phys _dbrValOffset >> 16
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+7)
	ld	bc,de
	ld	de,0x10
	add	hl,de
	add	hl,bc
	ld	(ix-15),hl
;2621   }
@302:
	.debug	>
;2622 
;2623   chan = (sid < con->maxChanNum) ? con->chans + sid : NULL;
@300:
	.debug	# 2623
	ld	hl,(ix-23)
	ex	de,hl
	ld	hl,(ix-21)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x83
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-13)
	or	a,a
	sbc	hl,de
	jr	nc,@303
	ld	hl,(ix-23)
	ex	de,hl
	ld	hl,(ix-21)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-13)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	call	__ladd##
	jr	@304
@303:
	ld	de,0
	ld	c,e
	ld	b,e
@304:
	ld	hl,bc
	ld	(ix-17),hl
	ex	de,hl
	ld	(ix-19),hl
	ex	de,hl
;2624   pvid = chan ? *chan : CHAN_UNUSED;
	.debug	# 2624
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@305
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	jr	@306
@305:
	ld	hl,0xffff
@306:
	ld	(ix-3),hl
;2625 
;2626   if (pvid == CHAN_UNUSED)  { errMsg = "Invalid SID";  errCode = ECA_BADCHI
	.debug	# 2626
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@307
@308:
	.debug	< @308 @309
	ld	de,word (phys @1+553)
	ld	c,phys @1+553 >> 16
	ld	hl,bc
	ld	(ix-25),hl
	ex	de,hl
	ld	(ix-27),hl
	ex	de,hl
	ld	hl,0x19a
	ld	(ix-11),hl
@309:
	.debug	>
;2627 
;2628   if (ci->showCmds OR (errCode AND ShowErrors))  {
@307:
	.debug	# 2628
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@310
	ld	hl,(ix-11)
	bool	hl
	jr	z,@311
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@311
@310:
;2629     if (pvGetInfo(pvid, &pvInfo))  pvInfo.name = "<invalid>";
@315:
	.debug	< @315 @316
	.debug	# 2629
	ld	hl,-45+@293
	add	hl,sp
	push	hl
	ld	hl,(ix-3)
	push	hl
	lcall	$pvGetInfo
	add	sp,4
	bool	hl
	jr	z,@317
	ld	de,word (phys @1+715)
	ld	c,phys @1+715 >> 16
	ld	hl,bc
	ld	(ix-43),hl
	ex	de,hl
	ld	(ix-45),hl
	ex	de,hl
;2630     printf("WRITE%s:  dbrType:%2u  numElems:%u  SID:3u  pvID:%3d [%ls]\n",
@317:
;2631            notify ? "_NOTIFY" : "", dbrType, numElems, sid, pvid, pvInfo.na
	.debug	# 2631
	ld	hl,(ix-45)
	ex	de,hl
	ld	hl,(ix-43)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-3)
	push	hl
	ld	hl,(ix-13)
	push	hl
	ld	hl,(ix-7)
	push	hl
	ld	hl,(ix-5)
	push	hl
	ld	a,(ix-1)
	or	a,a
	jr	z,@318
	ld	hl,@2+77
	jr	@319
@318:
	ld	hl,@2+8
@319:
	push	hl
	ld	de,word (phys @1+725)
	ld	c,phys @1+725 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,18
;2632   }
@316:
	.debug	>
;2633 
;2634   if (msg->dataSize != msg->size)  {
@311:
	.debug	# 2634
	ld	hl,(ix+7)
	ld	de,0x90
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@321
;2635     if (skipMsgBytes(ci, msg->size) != msg->size)  return -1;
@322:
	.debug	< @322 @323
	.debug	# 2635
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$skipMsgBytes
	add	sp,4
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jp	nz,@999
;2636     errCode = ECA_PUTFAIL;  errMsg = "Invalid dataSize";
	.debug	# 2636
	ld	hl,0xa0
	ld	(ix-11),hl
	ld	de,word (phys @1+785)
	ld	c,phys @1+785 >> 16
	ld	hl,bc
	ld	(ix-25),hl
	ex	de,hl
	ld	(ix-27),hl
	ex	de,hl
;2637   }
@323:
	.debug	>
;2638 
;2639   if (!errCode)  {
@321:
	.debug	# 2639
	ld	hl,(ix-11)
	bool	hl
	jp	nz,@325
;2640     typeData = dbfToPV[baseType];
@326:
	.debug	< @326 @327
	.debug	# 2640
	ld	hl,(ix-9)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x5
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _dbfToPV)
	ld	c,phys _dbfToPV >> 16
	call	__ladd##
	ld	hl,-32+@293
	add	hl,sp
	push	bc
	push	de
	ex	de,hl
	call	__farcvp##
	ld	hl,5
	call	__farcopy##
	add	sp,4
;2641   //--- reorder the bytes if necessary ---
;2642     if (typeData.reorder)  {
	.debug	# 2642
	ld	a,(ix-28)
	or	a,a
	jp	z,@328
;2643       if (typeData.size == 2)
@329:
	.debug	< @329 @330
	.debug	# 2643
	ld	hl,(ix-30)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	jp	nz,@331
;2644         U16_(ptr) = htons(U16_(ptr));
	.debug	# 2644
	ld	hl,(ix-15)
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,(ix-15)
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2645       else
;2646         U32_(ptr) = htonl(U32_(ptr));
	jp	@332
@331:
	.debug	# 2646
	ld	hl,(ix-15)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,(ix-15)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2647     }
@332:
@330:
	.debug	>
;2648   //finish:  must handle values > size of CA_MsgHdr.data[]
;2649     if (pvSetVal(pvid, typeData.pvType, typeData.size, ptr))  {
@328:
	.debug	# 2649
	ld	hl,(ix-15)
	push	hl
	ld	hl,(ix-30)
	push	hl
	ld	hl,(ix-32)
	push	hl
	ld	hl,(ix-3)
	push	hl
	lcall	$pvSetVal
	add	sp,8
	bool	hl
	jr	z,@333
;2650       errCode = ECA_PUTFAIL;  errMsg = "Unable to set or convert data"; }
@334:
	.debug	< @334 @335
	.debug	# 2650
	ld	l,0xa0
	ld	(ix-11),hl
	ld	de,word (phys @1+802)
	ld	c,phys @1+802 >> 16
	ld	hl,bc
	ld	(ix-25),hl
	ex	de,hl
	ld	(ix-27),hl
	ex	de,hl
@335:
	.debug	>
;2651   }
@333:
@327:
	.debug	>
;2652 
;2653   if (errCode AND (ci->showCmds OR ShowErrors))
@325:
	.debug	# 2653
	ld	hl,(ix-11)
	bool	hl
	jr	z,@337
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@340
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@337
@340:
;2654     printf("*** %ls ***\n", errMsg);
	.debug	# 2654
	ld	hl,(ix-27)
	ex	de,hl
	ld	hl,(ix-25)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+645)
	ld	c,phys @1+645 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;2655 
;2656   if (notify)  {
@337:
	.debug	# 2656
	ld	a,(ix-1)
	or	a,a
	jp	z,@341
;2657     resp.cmd = htons(msg->cmd);
@342:
	.debug	< @342 @343
	.debug	# 2657
	ld	hl,(ix+7)
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-191+@293
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2658     resp.size = 0;
	.debug	# 2658
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-189+@293
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2659     resp.fld3 = htons(dbrType);
	.debug	# 2659
	ld	hl,(ix-5)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-187+@293
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2660     resp.fld4 = htons(numElems);
	.debug	# 2660
	ld	hl,(ix-7)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-185+@293
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2661     resp.fld5 = htonl(errCode ? errCode : ECA_NORMAL);
	.debug	# 2661
	ld	hl,(ix-11)
	bool	hl
	jr	z,@344
	ld	hl,(ix-11)
	jr	@345
@344:
	ld	hl,0x1
@345:
	ex	de,hl
	ld	bc,0
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-183+@293
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2662     resp.fld6 = htonl(msg->fld6);
	.debug	# 2662
	ld	hl,(ix+7)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-179+@293
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2663 
;2664     if (addToRespPkt(ci, &resp, 16))  return -1;
	.debug	# 2664
	ld	hl,0x10
	push	hl
	ld	hl,-189+@293
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jr	z,@346
@999:
	ld	hl,0xffff
	jr	@294
;2665   }
@346:
@343:
	.debug	>
;2666 
;2667   return 0;
@341:
	.debug	# 2667
	bool	hl
	ld	l,h
;2668 }
@294:
	.debug	} @294 2668

@293	equ	191
	ld	sp,ix
	pop	ix
	lret
@295	equ	193
;2669 
;2670 
;2671 //-------------------------------------------------------------------------
;2672 //  CA_PROTO_SEARCH:  Check to see if this server has the specified PV name
;2673 //-------------------------------------------------------------------------
;2674 PROTO_CMD_FUNC( CA_Search )
;2675 PROTO_CMD_FUNC( CA_Search )
	.align	4
$$CA_Search::
	ex	(sp),iy
$CA_Search::
	.debug	G $CA_Search 41 9
	.debug	{ $CA_Search 41 2674 @349 @348
	ld	hl,-157
	call	__fent##
	.debug	A ci 5 50
	.debug	A msg 7 64
;2676   bool udpPacket;
	.debug	L udpPacket -1 3
;2677   int  pvid, respLen, cliVers;
	.debug	L pvid -3 6
	.debug	L respLen -5 6
	.debug	L cliVers -7 6
;2678   ulong  cid;
	.debug	L cid -11 9
;2679   CA_MsgHdr  resp;
	.debug	L resp -157 65
;2680 
;2681 
;2682   cliVers = msg->fld4;
	.debug	# 2682
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	ld	(ix-7),hl
;2683   cid = msg->fld5;
	.debug	# 2683
	ld	hl,(ix+7)
	ld	e,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-9),hl
	ex	de,hl
	ld	(ix-11),hl
	ex	de,hl
;2684 
;2685   udpPacket = (ci->type == UDP_CON);
	.debug	# 2685
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	bool	hl
	ld	l,h
	jr	nz,@350
	inc	l
@350:
	ld	(ix-1),l
;2686 
;2687   ++numSearchMsgs;
	.debug	# 2687
	ld	hl,(_numSearchMsgs)
	inc	hl
	ld	(_numSearchMsgs),hl
;2688 
;2689 
;2690 //--- check PV name to see if it matches any of the ones we provide ---
;2691   pvid = getPVID(msg->data, msg->size);  // >= 0 if a match is found
	.debug	# 2691
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+7)
	ld	de,0x10
	add	hl,de
	push	hl
	lcall	$getPVID
	add	sp,4
	ld	(ix-3),hl
;2692 
;2693 
;2694   if (ci->showCmds OR (ShowSearch AND servNameMatch))  {
	.debug	# 2694
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@351
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x10
	and	hl,de
	jr	z,@352
	ld	a,(_servNameMatch)
	or	a,a
	jr	z,@352
@351:
;2695     if (!ci->showCmds)  printf("  fd:%d  cmd:[%2u]  ", ci->fd, msg->cmd);
@356:
	.debug	< @356 @357
	.debug	# 2695
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@358
	ld	hl,(ix+7)
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+832)
	ld	c,phys @1+832 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;2696     printf("SEARCH: %s_REPLY  CAVers:4.%d  CID:0x%08lX  pvID:%3d  [%s]\n",
@358:
;2697            (msg->fld3 == DO_REPLY) ? "DO" : "DONT",
;2698            cliVers, cid, pvid, msg->data);
	.debug	# 2698
	ld	hl,(ix+7)
	ld	de,0x10
	add	hl,de
	push	hl
	ld	hl,(ix-3)
	push	hl
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-7)
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	e,0xa
	or	a,a
	sbc	hl,de
	jr	nz,@359
	ld	hl,@2+85
	jr	@360
@359:
	ld	hl,@2+88
@360:
	push	hl
	ld	de,word (phys @1+853)
	ld	c,phys @1+853 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;2699   }
@357:
	.debug	>
;2700 
;2701 
;2702   respLen = 0;
@352:
	.debug	# 2702
	bool	hl
	ld	l,h
	ld	(ix-5),hl
;2703 
;2704   if (pvid >= 0)  {
	.debug	# 2704
	ld	hl,(ix-3)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@362
;2705     if (ci->versRespPending)  if (sendVersion(ci))  return -1;
@363:
	.debug	< @363 @364
	.debug	# 2705
	ld	hl,(ix+5)
	ld	de,0x9
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@365
	ld	hl,(ix+5)
	push	hl
	lcall	$sendVersion
	pop	de
	bool	hl
	jp	nz,@998
;2706 
;2707     resp.cmd  = htons(CA_PROTO_SEARCH);
@365:
	.debug	# 2707
	ld	hl,0x6
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-157+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2708     resp.size = htons(8);   // payload size
	.debug	# 2708
	ld	hl,0x8
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-155+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2709     resp.fld3 = htons(CA_SERVER_PORT);
	.debug	# 2709
	ld	hl,0x13c8
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-153+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2710     resp.fld4 = 0;
	.debug	# 2710
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-151+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2711     resp.fld5 = (ulong)(-1);
	.debug	# 2711
	ld	de,0xffff
	ld	c,e
	ld	b,e
	ld	hl,-149+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2712     resp.fld6 = htonl(cid);
	.debug	# 2712
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-145+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2713 
;2714     memset(resp.data, 0, 8);
	.debug	# 2714
	ld	hl,0x8
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-137+@347
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
;2715     U16_(resp.data) = htons(CA_MINOR_VERSION);
	.debug	# 2715
	ld	hl,0xb
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-141+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2716     respLen = 24;
	.debug	# 2716
	ld	hl,0x18
	ld	(ix-5),hl
;2717   }
@364:
	.debug	>
;2718   else  {
	jp	@367
@362:
;2719     if (!udpPacket AND (msg->fld3 == DO_REPLY))  {
@368:
	.debug	< @368 @369
	.debug	# 2719
	ld	a,(ix-1)
	or	a,a
	jp	nz,@371
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	e,0xa
	or	a,a
	sbc	hl,de
	jp	nz,@371
;2720       resp.cmd  = htons(CA_PROTO_NOT_FOUND);
@372:
	.debug	< @372 @373
	.debug	# 2720
	ld	hl,0xe
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-157+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2721       resp.size = 0;
	.debug	# 2721
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-155+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2722       resp.fld3 = htons(DO_REPLY);
	.debug	# 2722
	ld	hl,0xa
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-153+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2723       resp.fld4 = htons(cliVers);
	.debug	# 2723
	ld	hl,(ix-7)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-151+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2724       resp.fld5 = htonl(cid);
	.debug	# 2724
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-149+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2725       resp.fld6 = htonl(cid);
	.debug	# 2725
	ld	hl,(ix-11)
	ex	de,hl
	ld	hl,(ix-9)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-145+@347
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2726 
;2727       respLen = 16;
	.debug	# 2727
	ld	hl,0x10
	ld	(ix-5),hl
;2728     }
@373:
	.debug	>
;2729   }
@371:
@369:
	.debug	>
;2730 
;2731   if (respLen)  if (addToRespPkt(ci, &resp, respLen))  return -1;
@367:
	.debug	# 2731
	ld	hl,(ix-5)
	bool	hl
	jr	z,@374
	ld	hl,(ix-5)
	push	hl
	ld	hl,-155+@347
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jr	z,@375
@998:
	ld	hl,0xffff
	jr	@348
;2732 
;2733   return 0;
@375:
@374:
	.debug	# 2733
	bool	hl
	ld	l,h
;2734 }
@348:
	.debug	} @348 2734

@347	equ	157
	ld	sp,ix
	pop	ix
	lret
@349	equ	159
;2735 
;2736 
;2737 //-------------------------------------------------------------------------
;2738 //  CA_PROTO_EVENTS_OFF:
;2739 //-------------------------------------------------------------------------
;2740 PROTO_CMD_FUNC( CA_EventsOff )
;2741 PROTO_CMD_FUNC( CA_EventsOff )
	.align	4
$$CA_EventsOff::
	ex	(sp),iy
$CA_EventsOff::
	.debug	G $CA_EventsOff 41 9
	.debug	{ $CA_EventsOff 41 2740 @378 @377
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ci 5 50
	.debug	A msg 7 64
;2742   if (ci->showCmds)  printf("EVENTS_OFF:\n");
	.debug	# 2742
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@379
	ld	de,word (phys @1+913)
	ld	c,phys @1+913 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2743 
;2744   ci->con->subEnabled = false;
@379:
	.debug	# 2744
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	xor	a,a
	call	__farst1##
;2745 
;2746   return 0;
	.debug	# 2746
	bool	hl
	ld	l,h
;2747 }
@377:
	.debug	} @377 2747

@376	equ	0
	pop	ix
	lret
@378	equ	2
;2748 
;2749 
;2750 //-------------------------------------------------------------------------
;2751 //  CA_PROTO_EVENTS_ON:
;2752 //-------------------------------------------------------------------------
;2753 PROTO_CMD_FUNC( CA_EventsOn )
;2754 PROTO_CMD_FUNC( CA_EventsOn )
	.align	4
$$CA_EventsOn::
	ex	(sp),iy
$CA_EventsOn::
	.debug	G $CA_EventsOn 41 9
	.debug	{ $CA_EventsOn 41 2753 @382 @381
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ci 5 50
	.debug	A msg 7 64
;2755   if (ci->showCmds)  printf("EVENTS_ON:\n");
	.debug	# 2755
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@383
	ld	de,word (phys @1+926)
	ld	c,phys @1+926 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2756 
;2757   ci->con->subEnabled = true;
@383:
	.debug	# 2757
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,0x1
	call	__farst1##
;2758 
;2759   return 0;
	.debug	# 2759
	bool	hl
	ld	l,h
;2760 }
@381:
	.debug	} @381 2760

@380	equ	0
	pop	ix
	lret
@382	equ	2
;2761 
;2762 
;2763 //-------------------------------------------------------------------------
;2764 //  CA_PROTO_CLEAR_CHANNEL:
;2765 //-------------------------------------------------------------------------
;2766 PROTO_CMD_FUNC( CA_ClearChannel )
;2767 PROTO_CMD_FUNC( CA_ClearChannel )
	.align	4
$$CA_ClearChannel::
	ex	(sp),iy
$CA_ClearChannel::
	.debug	G $CA_ClearChannel 41 9
	.debug	{ $CA_ClearChannel 41 2766 @386 @385
	ld	hl,-189
	call	__fent##
	.debug	A ci 5 50
	.debug	A msg 7 64
;2768   uint  u, pvid, maxSubNum, errCode = 0;
	.debug	L u -2 7
	.debug	L pvid -4 7
	.debug	L maxSubNum -6 7
	.debug	L errCode -8 7
	.debug	# 2768
	bool	hl
	ld	l,h
	ld	(ix-8),hl
	.seg	FARCODE
;2769   SID  sid;
	.debug	L sid -10 7
;2770   ulong  cid;
	.debug	L cid -14 9
;2771   PVID far  *chan;
	.debug	L chan -18 69
;2772   CA_Sub far  *sub;
	.debug	L sub -22 74
;2773   CA_Con far *con;
	.debug	L con -26 71
;2774   PV_Info  pvInfo;
	.debug	L pvInfo -39 70
;2775   const char far *errMsg = "ERROR";
	.debug	L errMsg -43 33
	.debug	# 2775
	ld	de,word (phys @1+517)
	ld	c,phys @1+517 >> 16
	ld	hl,bc
	ld	(ix-41),hl
	ex	de,hl
	ld	(ix-43),hl
	ex	de,hl
	.seg	FARCODE
;2776   CA_MsgHdr  resp;
	.debug	L resp -189 65
;2777 
;2778 
;2779   con = ci->con;
	.debug	# 2779
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-24),hl
	ex	de,hl
	ld	(ix-26),hl
	ex	de,hl
;2780 
;2781   sid = (SID) msg->fld5;
	.debug	# 2781
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	inc	hl
	ex	de,hl
	ld	(ix-10),hl
;2782   cid = msg->fld6;
	.debug	# 2782
	ld	hl,(ix+7)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;2783 
;2784 
;2785   chan = (sid < con->maxChanNum) ? con->chans + sid : NULL;
	.debug	# 2785
	ld	hl,(ix-26)
	ex	de,hl
	ld	hl,(ix-24)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x83
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-10)
	or	a,a
	sbc	hl,de
	jr	nc,@387
	ld	hl,(ix-26)
	ex	de,hl
	ld	hl,(ix-24)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-10)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	call	__ladd##
	jr	@388
@387:
	ld	de,0
	ld	c,e
	ld	b,e
@388:
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
;2786   pvid = chan ? *chan : CHAN_UNUSED;
	.debug	# 2786
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@389
	ld	h,b
	ld	l,c
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	jr	@390
@389:
	ld	hl,0xffff
@390:
	ld	(ix-4),hl
;2787 
;2788   if (pvid == CHAN_UNUSED)  {
	.debug	# 2788
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@391
;2789     if (ShowErrors OR ci->showCmds)  errMsg = "Invalid SID";
@392:
	.debug	< @392 @393
	.debug	# 2789
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	nz,@394
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@395
@394:
	ld	de,word (phys @1+553)
	ld	c,phys @1+553 >> 16
	ld	hl,bc
	ld	(ix-41),hl
	ex	de,hl
	ld	(ix-43),hl
	ex	de,hl
;2790     errCode = ECA_BADCHID;
@395:
	.debug	# 2790
	ld	hl,0x19a
	ld	(ix-8),hl
;2791   }
@393:
	.debug	>
;2792 
;2793   if (ci->showCmds OR (errCode AND ShowErrors))  {
@391:
	.debug	# 2793
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@396
	ld	hl,(ix-8)
	bool	hl
	jr	z,@397
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@397
@396:
;2794     if (pvGetInfo(pvid, &pvInfo))  pvInfo.name = "<invalid>";
@401:
	.debug	< @401 @402
	.debug	# 2794
	ld	hl,-39+@384
	add	hl,sp
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$pvGetInfo
	add	sp,4
	bool	hl
	jr	z,@403
	ld	de,word (phys @1+715)
	ld	c,phys @1+715 >> 16
	ld	hl,bc
	ld	(ix-37),hl
	ex	de,hl
	ld	(ix-39),hl
	ex	de,hl
;2795     printf("CLEAR_CHANNEL:  SID:0x%04X  CID:0x%08lX  pvID:%3d [%ls]\n",
@403:
;2796            sid, cid, pvid, pvInfo.name);
	.debug	# 2796
	ld	hl,(ix-39)
	ex	de,hl
	ld	hl,(ix-37)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-10)
	push	hl
	ld	de,word (phys @1+938)
	ld	c,phys @1+938 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;2797     if (errCode)  printf("*** %ls ***\n", errMsg);
	.debug	# 2797
	ld	hl,(ix-8)
	bool	hl
	jr	z,@404
	ld	hl,(ix-43)
	ex	de,hl
	ld	hl,(ix-41)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+645)
	ld	c,phys @1+645 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;2798   }
@404:
@402:
	.debug	>
;2799 
;2800   if (errCode)  return sendErrResp(ci, msg, cid, errCode, errMsg);
@397:
	.debug	# 2800
	ld	hl,(ix-8)
	bool	hl
	jr	z,@405
	ld	hl,(ix-43)
	ex	de,hl
	ld	hl,(ix-41)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	push	hl
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$sendErrResp
	add	sp,14
	jp	@385
;2801 
;2802 //--- free all subscriptions for the channel ---
;2803   maxSubNum = con->maxSubNum;
@405:
	.debug	# 2803
	ld	hl,(ix-26)
	ex	de,hl
	ld	hl,(ix-24)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x305
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-6),hl
;2804   for (u=0,sub=con->subs; u<maxSubNum; ++u,++sub)
@406:
	.debug	< @406 @407
	.debug	# 2804
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,(ix-26)
	ex	de,hl
	ld	hl,(ix-24)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x85
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
@408:
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nc,@409
;2805     if (sub->sid == sid)  sub->sid = SID_UNUSED;
	.debug	# 2805
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	call	__farld2##
	ld	hl,(ix-10)
	or	a,a
	sbc	hl,de
	jr	nz,@411
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	ld	hl,0xffff
	call	__farst2##
;2806 
;2807 //--- free up the channel ---
;2808   *chan = CHAN_UNUSED;
@411:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
	jr	@408
@409:
@407:
	.debug	>
	.debug	# 2808
	ld	hl,0xffff
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	ld	hl,(ix-18)
	ex	de,hl
	call	__farst2##
;2809 
;2810   resp.cmd = htons(msg->cmd);
	.debug	# 2810
	ld	hl,(ix+7)
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-189+@384
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2811   resp.size = 0;
	.debug	# 2811
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-187+@384
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2812   resp.fld3 = 0;
	.debug	# 2812
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-185+@384
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2813   resp.fld4 = 0;
	.debug	# 2813
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-183+@384
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2814   resp.fld5 = htonl(sid);
	.debug	# 2814
	ld	hl,(ix-10)
	ex	de,hl
	ld	b,h
	ld	c,l
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-181+@384
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2815   resp.fld6 = htonl(cid);
	.debug	# 2815
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-177+@384
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2816 
;2817   if (addToRespPkt(ci, &resp, 16))  return -1;
	.debug	# 2817
	ld	hl,0x10
	push	hl
	ld	hl,-187+@384
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jr	z,@412
	ld	hl,0xffff
	jr	@385
;2818 
;2819   return 0;
@412:
	.debug	# 2819
	bool	hl
	ld	l,h
;2820 }
@385:
	.debug	} @385 2820

@384	equ	189
	ld	sp,ix
	pop	ix
	lret
@386	equ	191
;2821 
;2822 
;2823 //-------------------------------------------------------------------------
;2824 //  CA_PROTO_READ_NOTIFY:  Respond with the current value of a channel
;2825 //-------------------------------------------------------------------------
;2826 PROTO_CMD_FUNC( CA_ReadNotify )
;2827 PROTO_CMD_FUNC( CA_ReadNotify )
	.align	4
$$CA_ReadNotify::
	ex	(sp),iy
$CA_ReadNotify::
	.debug	G $CA_ReadNotify 41 9
	.debug	{ $CA_ReadNotify 41 2826 @415 @414
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-22
	.debug	A ci 5 50
	.debug	A msg 7 64
;2828   int  stat;
	.debug	L stat -2 6
;2829   uint  pvid, curMS, dbrType;
	.debug	L pvid -4 7
	.debug	L curMS -6 7
	.debug	L dbrType -8 7
;2830   time_t  curSecs;
	.debug	L curSecs -12 9
;2831   SID  sid;
	.debug	L sid -14 7
;2832   PVID far  *chan;
	.debug	L chan -18 69
;2833   CA_Con far *con;
	.debug	L con -22 71
;2834 
;2835 
;2836   if (ci->showCmds)  printf("READ_NOTIFY:\n");
	.debug	# 2836
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@416
	ld	de,word (phys @1+995)
	ld	c,phys @1+995 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2837 
;2838   dbrType = msg->fld3;
@416:
	.debug	# 2838
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	(ix-8),hl
;2839   sid = (SID) msg->fld5;
	.debug	# 2839
	ld	hl,(ix+7)
	ld	e,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	inc	hl
	ex	de,hl
	ld	(ix-14),hl
;2840 
;2841   if (validateParams(ci, CA_PROTO_READ_NOTIFY, msg->fld6, dbrType,
;2842                      msg->fld4, sid))  return 0;
	.debug	# 2842
	push	hl
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-8)
	push	hl
	ld	hl,(ix+7)
	ld	e,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,0xf
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$validateParams
	add	sp,14
	bool	hl
	jr	z,@417
	bool	hl
	ld	l,h
	jp	@414
;2843 
;2844 //--- get pvid ---
;2845   con = ci->con;  chan = con->chans + sid;  pvid = *chan;
@417:
	.debug	# 2845
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-14)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	call	__ladd##
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-4),hl
;2846 
;2847 
;2848   _EnterCritical_();  curSecs = TIME();  curMS = milliTicks;  _ExitCritical
	.debug	# 2848
	ipset	2
	ld	de,(_hdwResetTime)
	ld	bc,(_hdwResetTime+2)
	push	bc
	push	de
	ld	de,(__TimerSeconds)
	ld	bc,(__TimerSeconds+2)
	call	__ladd##
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	ld	hl,(_milliTicks)
	ld	(ix-6),hl
	ipres
;2849   epochTimeSecs = curSecs - 631152000lu; // EPICS uses 1990-01-01 00:00:00
	.debug	# 2849
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6280
	ld	bc,0xda61
	call	__ladd##
	ld	(_epochTimeSecs),de
	ld	(_epochTimeSecs+2),bc
;2850   epochTimeNS = curMS * 1000000lu;
	.debug	# 2850
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x4240
	ld	c,0xf
	call	__ulmlt##
	ld	(_epochTimeNS),de
	ld	(_epochTimeNS+2),bc
;2851 
;2852   if (pvLockVal(pvid, LM_WaitLock, LT_READ) < 0)  return -1;
	.debug	# 2852
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$pvLockVal
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@418
	ld	hl,0xffff
	jr	@414
;2853   stat = sendValue(ci, CA_PROTO_READ_NOTIFY, msg->fld6, dbrType, msg->fld4,
@418:
	.debug	# 2853
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix+7)
	ld	de,0x6
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-8)
	push	hl
	ld	hl,(ix+7)
	ld	e,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,0xf
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$sendValue
	add	sp,14
	ld	(ix-2),hl
;2854   pvLockVal(pvid, LM_Unlock, LT_READ);
	.debug	# 2854
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$pvLockVal
	add	sp,6
;2855 
;2856   return stat;
	.debug	# 2856
	ld	hl,(ix-2)
;2857 }
@414:
	.debug	} @414 2857

@413	equ	22
	ld	sp,ix
	pop	ix
	lret
@415	equ	24
;2858 
;2859 
;2860 //-------------------------------------------------------------------------
;2861 //  CA_PROTO_CREATE_CHAN:  Client is requesting a new channel for a PV
;2862 //-------------------------------------------------------------------------
;2863 PROTO_CMD_FUNC( CA_CreateChan )
;2864 PROTO_CMD_FUNC( CA_CreateChan )
	.align	4
$$CA_CreateChan::
	ex	(sp),iy
$CA_CreateChan::
	.debug	G $CA_CreateChan 41 9
	.debug	{ $CA_CreateChan 41 2863 @421 @420
	ld	hl,-179
	call	__fent##
	.debug	A ci 5 50
	.debug	A msg 7 64
;2865 
;2866   int  pvid;
	.debug	L pvid -2 6
;2867   SID  sid;
	.debug	L sid -4 7
;2868   uint  dbrType, newChanNum;
	.debug	L dbrType -6 7
	.debug	L newChanNum -8 7
;2869   ulong  cid;
	.debug	L cid -12 9
;2870   PVID far  *chan;
	.debug	L chan -16 69
;2871   CA_Con far *con;
	.debug	L con -20 71
;2872   PV_Info  pvInfo;
	.debug	L pvInfo -33 70
;2873   CA_MsgHdr  resp;
	.debug	L resp -179 65
;2874 
;2875 
;2876   con = ci->con;
	.debug	# 2876
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
;2877 
;2878   sid = SID_UNUSED;
	.debug	# 2878
	ld	hl,0xffff
	ld	(ix-4),hl
;2879   cid = msg->fld5;
	.debug	# 2879
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;2880 
;2881 //--- If we have the requested PV, then find an unused channel slot for it 
;2882   if ((pvid = getPVID(msg->data, msg->size)) >= 0)  {
	.debug	# 2882
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+7)
	ld	de,0x10
	add	hl,de
	push	hl
	lcall	$getPVID
	add	sp,4
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@422
;2883     for (sid=0,chan=con->chans; sid<CA_MAX_CHANS; ++sid,++chan)
@423:
	.debug	< @423 @424
@425:
	.debug	< @425 @426
	.debug	# 2883
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@427:
	ld	hl,(ix-4)
	ld	de,0x40
	or	a,a
	sbc	hl,de
	jr	nc,@428
;2884       if (*chan == CHAN_UNUSED)  break;  // indicates an unused chan
	.debug	# 2884
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	call	__farld2##
	ld	hl,0xffff
	or	a,a
	sbc	hl,de
	jr	z,@428
;2885     if (sid == CA_MAX_CHANS)  { sid = SID_UNUSED;  chan = NULL; }
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	ld	hl,(ix-16)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
	jr	@427
@428:
@426:
	.debug	>
	.debug	# 2885
	ld	hl,(ix-4)
	ld	de,0x40
	or	a,a
	sbc	hl,de
	jr	nz,@431
@432:
	.debug	< @432 @433
	ld	hl,0xffff
	ld	(ix-4),hl
	ld	e,d
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-14),hl
	ex	de,hl
	ld	(ix-16),hl
	ex	de,hl
@433:
	.debug	>
;2886   }
@431:
@424:
	.debug	>
;2887 
;2888   if (ci->showCmds)
@422:
	.debug	# 2888
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@434
;2889     printf("CREATE_CHAN:  Client Vers:4.%ld  CID:0x%08lX  SID:0x%04X  pvID:
;2890            msg->fld6, cid, sid, pvid, msg->data);
	.debug	# 2890
	ld	hl,(ix+7)
	ld	e,0x10
	add	hl,de
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,word (phys @1+1009)
	ld	c,phys @1+1009 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,18
;2891 
;2892 
;2893 //--- No matching PV name or out of available channels? ---
;2894   if ((pvid < 0) OR (sid == SID_UNUSED) OR pvGetInfo(pvid, &pvInfo)) {
@434:
	.debug	# 2894
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@435
	ld	hl,(ix-4)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	z,@435
	ld	hl,-33+@419
	add	hl,sp
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$pvGetInfo
	add	sp,4
	bool	hl
	jp	z,@436
@435:
;2895     resp.cmd  = htons(CA_PROTO_CREATE_CH_FAIL);
@437:
	.debug	< @437 @438
	.debug	# 2895
	ld	hl,0x1a
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-179+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2896     resp.size = 0;
	.debug	# 2896
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-177+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2897     resp.fld3 = 0;
	.debug	# 2897
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-175+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2898     resp.fld4 = 0;
	.debug	# 2898
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-173+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2899     resp.fld5 = htonl(cid);
	.debug	# 2899
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-171+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2900     resp.fld6 = 0;
	.debug	# 2900
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,-167+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2901 
;2902     if (addToRespPkt(ci, &resp, 16))  return -1;
	.debug	# 2902
	ld	hl,0x10
	push	hl
	ld	hl,-177+@419
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jp	nz,@997
;2903 
;2904     return 0;
	.debug	# 2904
	bool	hl
	ld	l,h
	jp	@420
;2905   }
@438:
	.debug	>
;2906 
;2907 
;2908 
;2909 //--- If all is well, we send an ACCESS_RIGHTS msg first ---
;2910   resp.cmd  = htons(CA_PROTO_ACCESS_RIGHTS);
@436:
	.debug	# 2910
	ld	hl,0x16
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-179+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2911   resp.size = 0;
	.debug	# 2911
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-177+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2912   resp.fld3 = 0;
	.debug	# 2912
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-175+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2913   resp.fld4 = 0;
	.debug	# 2913
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-173+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2914   resp.fld5 = htonl(cid);
	.debug	# 2914
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-171+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2915   resp.fld6 = htonl(pvInfo.flags & 3);
	.debug	# 2915
	ld	hl,(ix-22)
	ld	de,0x3
	and	hl,de
	ex	de,hl
	ld	b,h
	ld	c,h
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-167+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2916 
;2917 //  if (ci->showCmds)
;2918 //    printf("  fd:%d  cmd:[22]  sending: ACCESS_RIGHTS:\n", fd);
;2919 
;2920   if (addToRespPkt(ci, &resp, 16))  return -1;
	.debug	# 2920
	ld	hl,0x10
	push	hl
	ld	hl,-177+@419
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jp	nz,@997
;2921 
;2922 
;2923   dbrType = pvTypeToDBF[pvInfo.dataType];
	.debug	# 2923
	ld	a,(ix-29)
	bool	hl
	ld	l,a
	add	hl,hl
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,word (phys _pvTypeToDBF)
	ld	c,phys _pvTypeToDBF >> 16
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-6),hl
;2924 
;2925 //--- And then we respond with the SID for the channel ---
;2926   resp.cmd  = htons(CA_PROTO_CREATE_CHAN);
	.debug	# 2926
	ld	hl,0x12
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-179+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2927   resp.size = 0;
	.debug	# 2927
	bool	hl
	ld	l,h
	ex	de,hl
	ld	hl,-177+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2928   resp.fld3 = htons(dbrType);
	.debug	# 2928
	ld	hl,(ix-6)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-175+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2929   resp.fld4 = htons(pvInfo.numElems);
	.debug	# 2929
	ld	hl,(ix-24)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-173+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;2930   resp.fld5 = htonl(cid);
	.debug	# 2930
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-171+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2931   resp.fld6 = htonl(sid);
	.debug	# 2931
	ld	hl,(ix-4)
	ex	de,hl
	ld	bc,0
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-167+@419
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;2932 
;2933   *chan = pvid;
	.debug	# 2933
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix-14)
	ld	bc,hl
	ld	hl,(ix-16)
	ex	de,hl
	call	__farst2##
;2934 //  chan->cid = msg->fld5;
;2935 
;2936   newChanNum = sid + 1;
	.debug	# 2936
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-8),hl
;2937   if (newChanNum > con->maxChanNum)  con->maxChanNum = newChanNum;
	.debug	# 2937
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x83
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-8)
	or	a,a
	sbc	hl,de
	jr	c,@441
	jr	z,@441
	ld	hl,(ix-20)
	ex	de,hl
	ld	hl,(ix-18)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x83
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-8)
	call	__farst2##
;2938 
;2939   if (addToRespPkt(ci, &resp, 16))  return -1;
@441:
	.debug	# 2939
	ld	hl,0x10
	push	hl
	ld	hl,-177+@419
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jr	z,@442
@997:
	ld	hl,0xffff
	jr	@420
;2940 
;2941   return 0;
@442:
	.debug	# 2941
	bool	hl
	ld	l,h
;2942 }
@420:
	.debug	} @420 2942

@419	equ	179
	ld	sp,ix
	pop	ix
	lret
@421	equ	181
;2943 
;2944 
;2945 //-------------------------------------------------------------------------
;2946 //  CA_PROTO_CLIENT_NAME:  Client sent a user name for the connection
;2947 //-------------------------------------------------------------------------
;2948 PROTO_CMD_FUNC( CA_ClientName )
;2949 PROTO_CMD_FUNC( CA_ClientName )
	.align	4
$$CA_ClientName::
	ex	(sp),iy
$CA_ClientName::
	.debug	G $CA_ClientName 41 9
	.debug	{ $CA_ClientName 41 2948 @445 @444
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A ci 5 50
	.debug	A msg 7 64
;2950   uint  count;
	.debug	L count -2 7
;2951   CA_Con far *con;
	.debug	L con -6 71
;2952 
;2953 
;2954   con = ci->con;
	.debug	# 2954
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;2955 
;2956   if (ci->showCmds)  printf("CLIENT_NAME: ");
	.debug	# 2956
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@446
	ld	de,word (phys @1+1085)
	ld	c,phys @1+1085 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2957 
;2958   if (!msg->dataSize)  {
@446:
	.debug	# 2958
	ld	hl,(ix+7)
	ld	de,0x90
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@447
;2959     if (skipMsgBytes(ci, msg->size) != msg->size)  return -1;
@448:
	.debug	< @448 @449
	.debug	# 2959
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$skipMsgBytes
	add	sp,4
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@450
	ld	hl,0xffff
	jp	@444
;2960     printf("<too long>\n");  return 0;
@450:
	.debug	# 2960
	ld	de,word (phys @1+1099)
	ld	c,phys @1+1099 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	bool	hl
	ld	l,h
	jp	@444
;2961   }
@449:
	.debug	>
;2962 
;2963   if (ci->showCmds)  printf("[%s]\n", msg->data);
@447:
	.debug	# 2963
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@451
	ld	hl,(ix+7)
	ld	e,0x10
	add	hl,de
	push	hl
	ld	de,word (phys @1+907)
	ld	c,phys @1+907 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2964 
;2965   count = (msg->dataSize >= USER_NAME_LEN) ? USER_NAME_LEN : msg->dataSize;
@451:
	.debug	# 2965
	ld	hl,(ix+7)
	ld	de,0x90
	add	hl,de
	ld	hl,(hl)
	ld	de,0x8018
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@452
	ld	hl,0x18
	jr	@453
@452:
	ld	hl,(ix+7)
	ld	de,0x90
	add	hl,de
	ld	hl,(hl)
@453:
	ld	(ix-2),hl
;2966 
;2967   if (con)  {
	.debug	# 2967
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@454
;2968     fmemcpy(con->userName, msg->data, count);
@455:
	.debug	< @455 @456
	.debug	# 2968
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	de,0x10
	add	hl,de
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x31f
	ld	bc,0
	call	__ladd##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;2969     con->userName[count-1] = 0;  // insure trailing termination char
	.debug	# 2969
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x31f
	ld	bc,0
	call	__ladd##
	ld	hl,(ix-2)
	dec	hl
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__ladd##
	xor	a,a
	call	__farst1##
;2970   }
@456:
	.debug	>
;2971 
;2972   return 0;
@454:
	.debug	# 2972
	bool	hl
	ld	l,h
;2973 }
@444:
	.debug	} @444 2973

@443	equ	6
	ld	sp,ix
	pop	ix
	lret
@445	equ	8
;2974 
;2975 
;2976 //-------------------------------------------------------------------------
;2977 //  CA_PROTO_HOST_NAME:  Client sent a host name for the connection
;2978 //-------------------------------------------------------------------------
;2979 PROTO_CMD_FUNC( CA_HostName )
;2980 PROTO_CMD_FUNC( CA_HostName )
	.align	4
$$CA_HostName::
	ex	(sp),iy
$CA_HostName::
	.debug	G $CA_HostName 41 9
	.debug	{ $CA_HostName 41 2979 @459 @458
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A ci 5 50
	.debug	A msg 7 64
;2981   uint  count;
	.debug	L count -2 7
;2982   CA_Con far *con;
	.debug	L con -6 71
;2983 
;2984 
;2985   con = ci->con;
	.debug	# 2985
	ld	hl,(ix+5)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;2986 
;2987   if (ci->showCmds)  printf("HOST_NAME: ");
	.debug	# 2987
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@460
	ld	de,word (phys @1+1111)
	ld	c,phys @1+1111 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;2988 
;2989   if (!msg->dataSize)  {
@460:
	.debug	# 2989
	ld	hl,(ix+7)
	ld	de,0x90
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@461
;2990     if (skipMsgBytes(ci, msg->size) != msg->size)  return -1;
@462:
	.debug	< @462 @463
	.debug	# 2990
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$skipMsgBytes
	add	sp,4
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@464
	ld	hl,0xffff
	jp	@458
;2991     printf("<too long>\n");  return 0;
@464:
	.debug	# 2991
	ld	de,word (phys @1+1099)
	ld	c,phys @1+1099 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	bool	hl
	ld	l,h
	jp	@458
;2992   }
@463:
	.debug	>
;2993 
;2994   if (ci->showCmds)  printf("[%s]\n", msg->data);
@461:
	.debug	# 2994
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@465
	ld	hl,(ix+7)
	ld	e,0x10
	add	hl,de
	push	hl
	ld	de,word (phys @1+907)
	ld	c,phys @1+907 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;2995 
;2996   count = (msg->dataSize >= HOST_NAME_LEN) ? HOST_NAME_LEN : msg->dataSize;
@465:
	.debug	# 2996
	ld	hl,(ix+7)
	ld	de,0x90
	add	hl,de
	ld	hl,(hl)
	ld	de,0x8018
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@466
	ld	hl,0x18
	jr	@467
@466:
	ld	hl,(ix+7)
	ld	de,0x90
	add	hl,de
	ld	hl,(hl)
@467:
	ld	(ix-2),hl
;2997 
;2998   if (con) {
	.debug	# 2998
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@468
;2999     fmemcpy(con->hostName, msg->data, count);
@469:
	.debug	< @469 @470
	.debug	# 2999
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	de,0x10
	add	hl,de
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x307
	ld	bc,0
	call	__ladd##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;3000     con->hostName[count-1] = 0;  // insure trailing termination char
	.debug	# 3000
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x307
	ld	bc,0
	call	__ladd##
	ld	hl,(ix-2)
	dec	hl
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__ladd##
	xor	a,a
	call	__farst1##
;3001   }
@470:
	.debug	>
;3002 
;3003   return 0;
@468:
	.debug	# 3003
	bool	hl
	ld	l,h
;3004 }
@458:
	.debug	} @458 3004

@457	equ	6
	ld	sp,ix
	pop	ix
	lret
@459	equ	8
;3005 
;3006 
;3007 //-------------------------------------------------------------------------
;3008 //  CA_PROTO_ECHO:  Just send back an ECHO msg
;3009 //-------------------------------------------------------------------------
;3010 PROTO_CMD_FUNC( CA_Echo )
;3011 PROTO_CMD_FUNC( CA_Echo )
	.align	4
$$CA_Echo::
	ex	(sp),iy
$CA_Echo::
	.debug	G $CA_Echo 41 9
	.debug	{ $CA_Echo 41 3010 @473 @472
	ld	hl,-146
	call	__fent##
	.debug	A ci 5 50
	.debug	A msg 7 64
;3012   CA_MsgHdr  resp;
	.debug	L resp -146 65
;3013 
;3014 
;3015   if (ci->showCmds)  printf("ECHO\n");
	.debug	# 3015
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@474
	ld	de,word (phys @1+1123)
	ld	c,phys @1+1123 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3016 
;3017   if (ci->type == UDP_CON)  return 0;
@474:
	.debug	# 3017
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	bool	hl
	jr	nz,@475
	bool	hl
	ld	l,h
	jp	@472
;3018 
;3019   memset(&resp, 0, sizeof(resp));
@475:
	.debug	# 3019
	ld	hl,0x92
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-142+@471
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
;3020 
;3021   resp.cmd  = htons(CA_PROTO_ECHO);
	.debug	# 3021
	ld	hl,0x17
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-146+@471
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3022 
;3023   if (addToRespPkt(ci, &resp, 16))  return -1;
	.debug	# 3023
	ld	hl,0x10
	push	hl
	ld	hl,-144+@471
	add	hl,sp
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix+5)
	push	hl
	lcall	$addToRespPkt
	add	sp,8
	bool	hl
	jr	z,@476
	ld	hl,0xffff
	jr	@472
;3024 
;3025   return 0;
@476:
	.debug	# 3025
	bool	hl
	ld	l,h
;3026 }
@472:
	.debug	} @472 3026

@471	equ	146
	ld	sp,ix
	pop	ix
	lret
@473	equ	148
;3027 
;3028 
;3029 //-------------------------------------------------------------------------
;3030 //  We received a command that we shouldn't have
;3031 //-------------------------------------------------------------------------
;3032 PROTO_CMD_FUNC( ProtocolError )
;3033 PROTO_CMD_FUNC( ProtocolError )
	.align	4
$$ProtocolError::
	ex	(sp),iy
$ProtocolError::
	.debug	G $ProtocolError 41 9
	.debug	{ $ProtocolError 41 3032 @479 @478
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ci 5 50
	.debug	A msg 7 64
;3034   if (ci->showCmds OR ShowErrors)
	.debug	# 3034
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	nz,@480
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@481
@480:
;3035     printf("*** Protocol Error:  Unexpected command ***\n");
	.debug	# 3035
	ld	de,word (phys @1+1129)
	ld	c,phys @1+1129 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3036 
;3037   if (msg->dataSize != msg->size)
@481:
	.debug	# 3037
	ld	hl,(ix+7)
	ld	de,0x90
	add	hl,de
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@482
;3038     if (skipMsgBytes(ci, msg->size) != msg->size)  return -1;
	.debug	# 3038
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$skipMsgBytes
	add	sp,4
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	inc	de
	inc	de
	ex	de,hl
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@483
	ld	hl,0xffff
	jr	@478
;3039 
;3040   return 0;
@483:
@482:
	.debug	# 3040
	bool	hl
	ld	l,h
;3041 }
@478:
	.debug	} @478 3041

@477	equ	0
	pop	ix
	lret
@479	equ	2
;3042 
;3043 
;3044 
;3045 
;3046 
;3047 //=========================================================================
;3048 // ************* Funcs to manage reading and dispatching of msgs **********
;3049 //=========================================================================
;3050 
;3051 //-------------------------------------------------------------------------
;3052 //  Process the CA msgs just read (from a UDP socket) or available to read
;3053 //  (from a TCP socket).
;3054 //
;3055 //  NOTES:
;3056 //    - ci->con will be NULL for msgs received via UDP!!!
;3057 //
;3058 //  Returns the # of messages read or < 0 if an error.
;3059 //-------------------------------------------------------------------------
;3060 int CA_ProcessMsgs(ConInfo  *ci)
;3061 {
$CA_ProcessMsgs::
	.debug	G $CA_ProcessMsgs 58 9
	.debug	{ $CA_ProcessMsgs 58 3060 @486 @485
	ld	hl,-152
	call	__fent##
	.debug	A ci 5 50
;3062   int  stat, fd;
	.debug	L stat -2 6
	.debug	L fd -4 6
;3063   uint  numMsgs = 0;
	.debug	L numMsgs -6 7
	.debug	# 3063
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	.seg	FARCODE
;3064   CA_MsgHdr  msg;
	.debug	L msg -152 65
;3065 
;3066 
;3067 
;3068   fd = ci->fd;
	.debug	# 3068
	ld	hl,(ix+5)
	ld	hl,(hl)
	ld	(ix-4),hl
;3069 
;3070   for (;;)  {
@487:
	.debug	< @487 @488
@489:
@491:
;3071 
;3072   //--- read the header for the next msg ---
;3073     stat = readBytes(ci, (char *)&msg, 16, 0);
@492:
	.debug	< @492 @493
	.debug	# 3073
	ld	de,0
	ld	c,e
	ld	b,e
	push	bc
	push	de
	ld	hl,0x10
	push	hl
	ld	hl,-146+@484
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$readBytes
	add	sp,10
	ld	(ix-2),hl
;3074 
;3075   //--- did we get enough bytes for the header? ---
;3076     if (stat != 16)  {
	.debug	# 3076
	ld	de,0x10
	or	a,a
	sbc	hl,de
	jr	z,@494
;3077       if ((stat < 0) AND (errno == EAGAIN))  return numMsgs;
@495:
	.debug	< @495 @496
	.debug	# 3077
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@498
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	nz,@498
	ld	hl,(ix-6)
	jp	@485
;3078       if ((stat > 0) AND (stat < 16))
@498:
	.debug	# 3078
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@500
	jr	z,@500
	ld	hl,(ix-2)
	ld	e,0x10
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@500
;3079         conMsg(fd, "*** Incomplete msg ***");
	.debug	# 3079
	ld	de,word (phys @1+1174)
	ld	c,phys @1+1174 >> 16
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	lcall	$conMsg
	add	sp,6
;3080       else
;3081         perror("readBytes()");
	jr	@501
@500:
	.debug	# 3081
	ld	de,word (phys @1+1197)
	ld	c,phys @1+1197 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
;3082       return -1;
@501:
	.debug	# 3082
	jp	@527
;3083     }
@496:
	.debug	>
;3084 
;3085   //--- convert values from network to host format ---
;3086     msg.cmd  = ntohs(msg.cmd);
@494:
	.debug	# 3086
	ld	hl,-152+@484
	add	hl,sp
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-152+@484
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3087     msg.size = ntohs(msg.size);
	.debug	# 3087
	ld	hl,-150+@484
	add	hl,sp
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-150+@484
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3088     msg.fld3 = ntohs(msg.fld3);
	.debug	# 3088
	ld	hl,-148+@484
	add	hl,sp
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-148+@484
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3089     msg.fld4 = ntohs(msg.fld4);
	.debug	# 3089
	ld	hl,-146+@484
	add	hl,sp
	ld	hl,(hl)
	ld	a,l
	ld	l,h
	ld	h,a
	ex	de,hl
	ld	hl,-146+@484
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3090     msg.fld5 = ntohl(msg.fld5);
	.debug	# 3090
	ld	hl,-144+@484
	add	hl,sp
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-144+@484
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3091     msg.fld6 = ntohl(msg.fld6);
	.debug	# 3091
	ld	hl,-140+@484
	add	hl,sp
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,-140+@484
	add	hl,sp
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;3092 
;3093     *msg.data = 0;  msg.dataSize = 0;
	.debug	# 3093
	xor	a,a
	ld	hl,-136+@484
	add	hl,sp
	ld	(hl),a
	bool	hl
	ld	l,h
	ld	(ix-8),hl
;3094 
;3095   //--- if the payload will fit in the msg buffer, then read it now ---
;3096     if (msg.size)  {
	.debug	# 3096
	ld	hl,-150+@484
	add	hl,sp
	ld	hl,(hl)
	bool	hl
	jp	z,@502
;3097       if (msg.size < sizeof(msg.data))  {
@503:
	.debug	< @503 @504
	.debug	# 3097
	ld	hl,-150+@484
	add	hl,sp
	ld	hl,(hl)
	ld	de,0x80
	or	a,a
	sbc	hl,de
	jr	nc,@505
;3098         if (readBytes(ci, msg.data, msg.size, RD_TIMEOUT) != msg.size) {
@506:
	.debug	< @506 @507
	.debug	# 3098
	ld	de,0x7d0
	ld	bc,0
	push	bc
	push	de
	ld	hl,-146+@484
	add	hl,sp
	ld	hl,(hl)
	push	hl
	ld	hl,-130+@484
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$readBytes
	add	sp,10
	ex	de,hl
	ld	hl,-150+@484
	add	hl,sp
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@508
;3099           perror("reading payload");  return -1; }
@509:
	.debug	< @509 @510
	.debug	# 3099
	ld	de,word (phys @1+1209)
	ld	c,phys @1+1209 >> 16
	jr	@996
@510:
	.debug	>
;3100         msg.data[msg.size] = 0;  msg.dataSize = msg.size;
@508:
	.debug	# 3100
	ld	hl,-150+@484
	add	hl,sp
	ld	hl,(hl)
	ex	de,hl
	ld	hl,-136+@484
	add	hl,sp
	add	hl,de
	xor	a,a
	ld	(hl),a
	ld	hl,-150+@484
	add	hl,sp
	ld	hl,(hl)
	ld	(ix-8),hl
;3101       }
@507:
	.debug	>
;3102       else
;3103         if ((msg.cmd != CA_PROTO_WRITE)
	jr	@511
@505:
;3104             AND (msg.cmd != CA_PROTO_WRITE_NOTIFY))  {
	.debug	# 3104
	ld	hl,-152+@484
	add	hl,sp
	ld	hl,(hl)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	z,@513
	ld	hl,-152+@484
	add	hl,sp
	ld	hl,(hl)
	ld	e,0x13
	or	a,a
	sbc	hl,de
	jr	z,@513
;3105           if (skipMsgBytes(ci, msg.size) != msg.size)  {
@514:
	.debug	< @514 @515
	.debug	# 3105
	ld	hl,-150+@484
	add	hl,sp
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$skipMsgBytes
	add	sp,4
	ex	de,hl
	ld	hl,-150+@484
	add	hl,sp
	ld	hl,(hl)
	or	a,a
	sbc	hl,de
	jr	z,@516
;3106             perror("skipMsgBytes()");  return -1; }
@517:
	.debug	< @517 @518
	.debug	# 3106
	ld	de,word (phys @1+1225)
	ld	c,phys @1+1225 >> 16
@996:
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	jp	@527
@518:
	.debug	>
;3107         }
@516:
@515:
	.debug	>
;3108     }
@513:
@511:
@504:
	.debug	>
;3109 
;3110 
;3111     if (ci->showCmds)
@502:
	.debug	# 3111
	ld	hl,(ix+5)
	ld	de,0x8
	add	hl,de
	ld	a,(hl)
	or	a,a
	jr	z,@519
;3112       printf("  fd:%d  cmd:[%2u]  data:%2u: ", fd, msg.cmd, msg.size);
	.debug	# 3112
	ld	hl,-150+@484
	add	hl,sp
	ld	hl,(hl)
	push	hl
	ld	hl,-150+@484
	add	hl,sp
	ld	hl,(hl)
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	de,word (phys @1+1240)
	ld	c,phys @1+1240 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,10
;3113 
;3114     if (msg.cmd > CA_PROTO_LAST_CMMD)  {
@519:
	.debug	# 3114
	ld	hl,-152+@484
	add	hl,sp
	ld	hl,(hl)
	ld	de,0x1b
	or	a,a
	sbc	hl,de
	jr	c,@520
	jr	z,@520
;3115       if (ShowErrors)
@521:
	.debug	< @521 @522
	.debug	# 3115
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@523
;3116         printf("*** Ignoring Invalid CA cmd: [%2u] ***\n", msg.cmd);
	.debug	# 3116
	ld	hl,-152+@484
	add	hl,sp
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+1271)
	ld	c,phys @1+1271 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3117       skipMsgBytes(ci, msg.size);  ++numMsgs;  continue;
@523:
	.debug	# 3117
	ld	hl,-150+@484
	add	hl,sp
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$skipMsgBytes
	add	sp,4
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
;3118     }
	jp	@491
@522:
	.debug	>
;3119 
;3120     if ((*cmdFuncs[msg.cmd])(ci, &msg) < 0)  {
@520:
	.debug	# 3120
	ld	hl,-152+@484
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	ex	de,hl
	ld	hl,-148+@484
	add	hl,sp
	ld	hl,(hl)
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	de,word (phys _cmdFuncs)
	ld	c,phys _cmdFuncs >> 16
	call	__ladd##
	call	__farld2##
	call	__callde##
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@524
;3121       if (ShowErrors)  perror("*** ERROR ***");
@525:
	.debug	< @525 @526
	.debug	# 3121
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x100
	and	hl,de
	jr	z,@527
	ld	de,word (phys @1+1311)
	ld	c,phys @1+1311 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
;3122       return -1;
@527:
	.debug	# 3122
	ld	hl,0xffff
	jr	@485
;3123     }
@526:
	.debug	>
;3124 
;3125     ++numMsgs;
@524:
	.debug	# 3125
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
;3126   }
@493:
	.debug	>
;3127 
;3128 }
	jp	@489
@488:
	.debug	>
@485:
	.debug	} @485 3128

@484	equ	152
	ld	sp,ix
	pop	ix
	lret
@486	equ	154
;3129 
;3130 
;3131 //-------------------------------------------------------------------------
;3132 //  Create a UDP listener socket
;3133 //
;3134 //  Returns the new socket fd on success, or < 0 on error
;3135 //-------------------------------------------------------------------------
;3136 int  CA_CreateUDPListener(void)
;3137 {
$CA_CreateUDPListener::
	.debug	G $CA_CreateUDPListener 76 9
	.debug	{ $CA_CreateUDPListener 76 3136 @530 @529
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-43
;3138   int  fd;
	.debug	L fd -2 6
;3139   int  fflags;
	.debug	L fflags -4 6
;3140   SAI  locAddr;
	.debug	L locAddr -18 55
;3141   IFConfig  curConfig;
	.debug	L curConfig -43 67
;3142 
;3143   static int  so_broadcast = TRUE;
	.dseg
@531:
	.dw	0x1
	.debug	S so_broadcast @531 6
	.seg	FARCODE
;3144   static ulong  lastErrTime = (-LISTEN_RETRY);
	.dseg
@532:
	.dw	0xffff8ad0, 0xffff
	.debug	S lastErrTime @532 9
	.seg	FARCODE
;3145 
;3146 
;3147 //--- avoid generating lots of pointless error msgs if the network is down 
;3148   getIFConfig(IF_ETH0, &curConfig);
	.debug	# 3148
	ld	hl,-43+@528
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$getIFConfig
	add	sp,4
;3149   if (curConfig.state != IF_UP)  return -1;
	.debug	# 3149
	ld	a,(ix-19)
	sub	a,2
	jp	nz,@994
;3150 
;3151   if (msSince(lastErrTime) < LISTEN_RETRY)  return -1;
	.debug	# 3151
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(@532)
	ld	bc,(@532+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x7530
	ld	bc,0
	call	__lsub##
	jp	c,@994
;3152 
;3153   if ((fd = Socket(AF_INET, SOCK_DGRAM, 0)) < 0)  {
	.debug	# 3153
	bool	hl
	ld	l,h
	push	hl
	inc	l
	push	hl
	ld	l,0x2
	push	hl
	lcall	$socket
	add	sp,6
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@535
;3154     perror("UDP socket() error");  lastErrTime = GetMS();  return -1; }
@536:
	.debug	< @536 @537
	.debug	# 3154
	ld	de,word (phys @1+1325)
	ld	c,phys @1+1325 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	jp	@995
@537:
	.debug	>
;3155 
;3156   if ((setsockopt(fd, SOL_SOCKET, SO_BROADCAST,
@535:
;3157                     (char *)&so_broadcast, sizeof(so_broadcast)) ) < 0)  {
	.debug	# 3157
	ld	hl,0x2
	push	hl
	ld	hl,@531
	push	hl
	ld	hl,0x6
	push	hl
	ld	l,0x1
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setsockopt
	add	sp,10
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@538
;3158     perror("UDP setsockopt()");  close(fd);
@539:
	.debug	< @539 @540
	.debug	# 3158
	ld	de,word (phys @1+135)
	ld	c,phys @1+135 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,(ix-2)
	push	hl
	lcall	$close
	pop	de
;3159     lastErrTime = GetMS();  return -1;
	.debug	# 3159
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
@995:
	ld	(@532),de
	ld	(@532+2),bc
	jp	@994
;3160   }
@540:
	.debug	>
;3161 
;3162 //--- settings for local "addr" for socket to receive broadcasts ---
;3163   locAddr.sin_family = AF_INET;
@538:
	.debug	# 3163
	ld	hl,0x2
	ld	(ix-18),hl
;3164   locAddr.sin_port   = htons(CA_SERVER_PORT);
	.debug	# 3164
	ld	hl,0x13c8
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-16),hl
;3165   locAddr.SIN_ADDR   = htonl(INADDR_ANY);  //htonl(bcIPv4);
	.debug	# 3165
	ld	de,0
	ld	c,e
	ld	b,e
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;3166 
;3167   if (bind(fd, (SAP)&locAddr, sizeof(locAddr)) < 0)  {
	.debug	# 3167
	ld	hl,0xe
	push	hl
	ld	hl,-16+@528
	add	hl,sp
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$bind
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@541
;3168     perror("UDP bind() error");
@542:
	.debug	< @542 @543
	.debug	# 3168
	ld	de,word (phys @1+1344)
	ld	c,phys @1+1344 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
;3169     lastErrTime = GetMS();  close(fd);  return -1;
	.debug	# 3169
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(@532),de
	ld	(@532+2),bc
	ld	hl,(ix-2)
	push	hl
	lcall	$close
	pop	de
@994:
	ld	hl,0xffff
	jr	@529
;3170   }
@543:
	.debug	>
;3171 
;3172 //--- make socket non-blocking ---
;3173   fflags = fcntl(fd, F_GETFL, 0);
@541:
	.debug	# 3173
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$fcntl
	add	sp,6
	ld	(ix-4),hl
;3174   fcntl(fd, F_SETFL, fflags | O_NONBLOCK);
	.debug	# 3174
	set	5,l
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$fcntl
	add	sp,6
;3175 
;3176   lastErrTime = 0;
	.debug	# 3176
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(@532),de
	ld	(@532+2),bc
;3177 
;3178   printf("Created UDP listener on fd:%d  port %d\r\n", fd, CA_SERVER_PORT);
	.debug	# 3178
	ld	hl,0x13c8
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1361)
	ld	c,phys @1+1361 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3179 
;3180   return fd;
	.debug	# 3180
	ld	hl,(ix-2)
;3181 }
@529:
	.debug	} @529 3181

@528	equ	43
	ld	sp,ix
	pop	ix
	lret
@530	equ	45
;3182 
;3183 
;3184 //-------------------------------------------------------------------------
;3185 //  Create a TCP listener socket
;3186 //
;3187 //  Returns the new socket fd on success, or < 0 on error
;3188 //-------------------------------------------------------------------------
;3189 int CA_CreateTCPListener(void)
;3190 {
$CA_CreateTCPListener::
	.debug	G $CA_CreateTCPListener 76 9
	.debug	{ $CA_CreateTCPListener 76 3189 @546 @545
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-43
;3191   int  fd;
	.debug	L fd -2 6
;3192   int  fflags;
	.debug	L fflags -4 6
;3193   SAI  locAddr;
	.debug	L locAddr -18 55
;3194   IFConfig  curConfig;
	.debug	L curConfig -43 67
;3195 
;3196   static ulong  lastErrTime = (-LISTEN_RETRY);
	.dseg
@547:
	.dw	0xffff8ad0, 0xffff
	.debug	S lastErrTime @547 9
	.seg	FARCODE
;3197 
;3198 
;3199 //--- avoid generating lots of pointless error msgs if the network is down 
;3200   getIFConfig(IF_ETH0, &curConfig);
	.debug	# 3200
	ld	hl,-43+@544
	add	hl,sp
	push	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$getIFConfig
	add	sp,4
;3201   if (curConfig.state != IF_UP)  return -1;
	.debug	# 3201
	ld	a,(ix-19)
	sub	a,2
	jp	nz,@992
;3202 
;3203   if (msSince(lastErrTime) < LISTEN_RETRY)  return -1;
	.debug	# 3203
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	push	bc
	push	de
	ld	de,(@547)
	ld	bc,(@547+2)
	call	__lsub##
	push	bc
	push	de
	ld	de,0x7530
	ld	bc,0
	call	__lsub##
	jp	c,@992
;3204 
;3205   if ((fd = socket(AF_INET, SOCK_STREAM, 0)) < 0)  {
	.debug	# 3205
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x2
	push	hl
	push	hl
	lcall	$socket
	add	sp,6
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@550
;3206     perror("TCP listener socket() error");  lastErrTime = GetMS();  return 
@551:
	.debug	< @551 @552
	.debug	# 3206
	ld	de,word (phys @1+1402)
	ld	c,phys @1+1402 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	jp	@993
@552:
	.debug	>
;3207 
;3208   locAddr.sin_family = AF_INET;
@550:
	.debug	# 3208
	ld	hl,0x2
	ld	(ix-18),hl
;3209   locAddr.sin_port   = htons(CA_SERVER_PORT);
	.debug	# 3209
	ld	hl,0x13c8
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-16),hl
;3210   locAddr.SIN_ADDR   = htonl(INADDR_ANY);
	.debug	# 3210
	ld	de,0
	ld	c,e
	ld	b,e
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	hl,bc
	ld	(ix-12),hl
	ex	de,hl
	ld	(ix-14),hl
	ex	de,hl
;3211 
;3212   if (bind(fd, (SAP) &locAddr, sizeof(locAddr)) < 0)  {
	.debug	# 3212
	ld	hl,0xe
	push	hl
	ld	hl,-16+@544
	add	hl,sp
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$bind
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@553
;3213     perror("TCP listener bind() error");
@554:
	.debug	< @554 @555
	.debug	# 3213
	ld	de,word (phys @1+1430)
	ld	c,phys @1+1430 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
;3214     lastErrTime = GetMS();  close(fd);  return -1;
	.debug	# 3214
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
	ld	(@547),de
	ld	(@547+2),bc
	ld	hl,(ix-2)
	push	hl
	lcall	$close
	pop	de
	jp	@992
;3215   }
@555:
	.debug	>
;3216 
;3217   if (listen(fd, 2) < 0)  {
@553:
	.debug	# 3217
	ld	hl,0x2
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$listen
	add	sp,4
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@556
;3218     perror("listen()");  close(fd);  lastErrTime = GetMS();  return -1; }
@557:
	.debug	< @557 @558
	.debug	# 3218
	ld	de,word (phys @1+1456)
	ld	c,phys @1+1456 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,(ix-2)
	push	hl
	lcall	$close
	pop	de
ipset 3
	ld	de,(__TimerMilliSeconds+4)
	ld	bc,(__TimerMilliSeconds+6)
ipres
@993:
	ld	(@547),de
	ld	(@547+2),bc
@992:
	ld	hl,0xffff
	jr	@545
@558:
	.debug	>
;3219 
;3220 //--- make socket non-blocking ---
;3221   fflags = fcntl(fd, F_GETFL, 0);
@556:
	.debug	# 3221
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x3
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$fcntl
	add	sp,6
	ld	(ix-4),hl
;3222   fcntl(fd, F_SETFL, fflags | O_NONBLOCK);
	.debug	# 3222
	set	5,l
	push	hl
	ld	hl,0x4
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$fcntl
	add	sp,6
;3223 
;3224   lastErrTime = 0;
	.debug	# 3224
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(@547),de
	ld	(@547+2),bc
;3225 
;3226   printf("Created TCP listener on fd:%d  port %d\r\n", fd, CA_SERVER_PORT);
	.debug	# 3226
	ld	hl,0x13c8
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1465)
	ld	c,phys @1+1465 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3227 
;3228   return fd;
	.debug	# 3228
	ld	hl,(ix-2)
;3229 }
@545:
	.debug	} @545 3229

@544	equ	43
	ld	sp,ix
	pop	ix
	lret
@546	equ	45
;3230 
;3231 
;3232 //-------------------------------------------------------------------------
;3233 //  Check for new connections on the specified listening TCP socket.
;3234 //
;3235 //  Returns:
;3236 //    1 if a new connection established
;3237 //    0 if no new connection
;3238 //   -1 if there was a problem with the listening socket
;3239 //-------------------------------------------------------------------------
;3240 int CA_CheckNewConnections(fd_t fd)
;3241 {
$CA_CheckNewConnections::
	.debug	G $CA_CheckNewConnections 66 9
	.debug	{ $CA_CheckNewConnections 66 3240 @561 @560
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-24
	.debug	A fd 5 6
;3242   uint  u;
	.debug	L u -2 7
;3243   int  newfd;
	.debug	L newfd -4 6
;3244   int  addrLen;
	.debug	L addrLen -6 6
;3245   CA_Con far  *con;
	.debug	L con -10 71
;3246   SAI  remAddr;
	.debug	L remAddr -24 55
;3247 
;3248 
;3249   addrLen = sizeof(remAddr);
	.debug	# 3249
	ld	hl,0xe
	ld	(ix-6),hl
;3250 
;3251   newfd = accept(fd, (SAP)&remAddr, &addrLen);
	.debug	# 3251
	ld	hl,-6+@559
	add	hl,sp
	push	hl
	ld	hl,-22+@559
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$accept
	add	sp,6
	ld	(ix-4),hl
;3252 
;3253   if (newfd < 0)  {
	.debug	# 3253
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@562
;3254     if (errno == EAGAIN)  return 0;
@563:
	.debug	< @563 @564
	.debug	# 3254
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jp	z,@991
;3255     perror("accept()");  return -1;
	.debug	# 3255
	ld	de,word (phys @1+1506)
	ld	c,phys @1+1506 >> 16
	push	bc
	push	de
	lcall	$perror
	add	sp,4
	ld	hl,0xffff
	jp	@560
;3256   }
@564:
	.debug	>
;3257 
;3258   /* if (ShowCons) */  conMsg(newfd, "New Virtual Circuit");
@562:
	.debug	# 3258
	ld	de,word (phys @1+1515)
	ld	c,phys @1+1515 >> 16
	push	bc
	push	de
	ld	hl,(ix-4)
	push	hl
	lcall	$conMsg
	add	sp,6
;3259 
;3260 
;3261 //--- find an unused slot for the new connection ---
;3262   for (u=0; u<CA_MAX_CONS; ++u)  {
@566:
	.debug	< @566 @567
	.debug	# 3262
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@568:
	ld	hl,(ix-2)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	nc,@569
;3263     con = caCons + u;
@571:
	.debug	< @571 @572
	.debug	# 3263
	ld	hl,(ix-2)
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	ld	de,0x345
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _caCons)
	ld	c,phys _caCons >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;3264     if (con->fd >= 0)  continue;
	.debug	# 3264
	call	__farld2##
	ld	hl,0x8000
	ex	de,hl
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	nc,@570
;3265     FBZERO(con);
	.debug	# 3265
	ld	de,0x4
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;3266     fstrcpy(con->hostName, "<unknown>");
	.debug	# 3266
	ld	de,word (phys @1+1535)
	ld	c,phys @1+1535 >> 16
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x307
	ld	bc,0
	call	__ladd##
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3267     fstrcpy(con->userName, "<unknown>");
	.debug	# 3267
	ld	de,word (phys @1+1535)
	ld	c,phys @1+1535 >> 16
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x31f
	ld	bc,0
	call	__ladd##
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;3268     fmemset(con->chans, 0xff, sizeof(con->chans));
	.debug	# 3268
	ld	de,0x80
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,0xff
	push	hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;3269     fmemset(con->subs, 0xff, sizeof(con->subs));
	.debug	# 3269
	ld	de,0x280
	ld	bc,0
	push	bc
	push	de
	ld	hl,0xff
	push	hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x85
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;3270     con->fd = newfd;
	.debug	# 3270
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-4)
	call	__farst2##
;3271     con->in_Addr = remAddr;
	.debug	# 3271
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x337
	ld	bc,0
	call	__ladd##
	ld	hl,-24+@559
	add	hl,sp
	push	bc
	push	de
	ex	de,hl
	call	__farcvp##
	ld	hl,14
	call	__farcopyr##
	add	sp,4
;3272     break;
	.debug	# 3272
;3273   }
	jr	@569
@572:
	.debug	>
;3274 
;3275   if (u >= CA_MAX_CONS)  {
@570:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@568
@569:
@567:
	.debug	>
	.debug	# 3275
	ld	hl,(ix-2)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	c,@574
;3276     printf("*** Max CA connections exceeded ***\n");
@575:
	.debug	< @575 @576
	.debug	# 3276
	ld	de,word (phys @1+1545)
	ld	c,phys @1+1545 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3277     close(newfd);  return 0;
	.debug	# 3277
	ld	hl,(ix-4)
	push	hl
	lcall	$close
	pop	de
@991:
	bool	hl
	ld	l,h
	jr	@560
;3278   }
@576:
	.debug	>
;3279 
;3280   return newfd;
@574:
	.debug	# 3280
	ld	hl,(ix-4)
;3281 }
@560:
	.debug	} @560 3281

@559	equ	24
	ld	sp,ix
	pop	ix
	lret
@561	equ	26
;3282 
;3283 
;3284 //-------------------------------------------------------------------------
;3285 //  Check for and respond to any msgs received via UDP.
;3286 //
;3287 //  Returns the number of msgs processed or < 0 if an error.
;3288 //-------------------------------------------------------------------------
;3289 int CA_ProcessUDPPackets(int fd)
;3290 {
$CA_ProcessUDPPackets::
	.debug	G $CA_ProcessUDPPackets 66 9
	.debug	{ $CA_ProcessUDPPackets 66 3289 @579 @578
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fd 5 6
;3291 
;3292 
;3293   return 0;
	.debug	# 3293
	bool	hl
	ld	l,h
;3294 }
@578:
	.debug	} @578 3294

@577	equ	0
	pop	ix
	lret
@579	equ	2
;3295 
;3296 
;3297 //-------------------------------------------------------------------------
;3298 //  Process any commands received on existing open connections
;3299 //
;3300 //  Returns the # of currently open connections or < 0 if an error
;3301 //-------------------------------------------------------------------------
;3302 int CA_ProcessTCPCmds(void)
;3303 {
$CA_ProcessTCPCmds::
	.debug	G $CA_ProcessTCPCmds 76 9
	.debug	{ $CA_ProcessTCPCmds 76 3302 @582 @581
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-58
;3304   int  unreadBytes;
	.debug	L unreadBytes -2 6
;3305   uint  u, numCons = 0;
	.debug	L u -4 7
	.debug	L numCons -6 7
	.debug	# 3305
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	.seg	FARCODE
;3306   CA_Con far  *con;
	.debug	L con -10 71
;3307   SAI  respAddrTCP;
	.debug	L respAddrTCP -24 55
;3308   ConInfo  ci;
	.debug	L ci -34 51
;3309   char  temp[24];
	.debug	L temp -58 77
;3310 
;3311 
;3312 //--- check each connection for unread data and process any found ---
;3313   for (u=0,con=caCons; u<CA_MAX_CONS; ++u,++con)  {
@583:
	.debug	< @583 @584
	.debug	# 3313
	ld	(ix-4),hl
	ld	de,word (phys _caCons)
	ld	c,phys _caCons >> 16
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
@585:
	ld	hl,(ix-4)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	nc,@586
;3314     if ((ci.fd = con->fd) < 0)  continue;
@588:
	.debug	< @588 @589
	.debug	# 3314
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-34),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@587
;3315 
;3316     ci.type = TCP_BUF;  //finish
	.debug	# 3316
	ld	hl,0x1
	ld	(ix-32),hl
;3317     ci.con = con;
	.debug	# 3317
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	(ix-28),hl
	ex	de,hl
	ld	(ix-30),hl
	ex	de,hl
;3318     ci.showCmds = ShowTCPCmds;
	.debug	# 3318
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x8
	and	hl,de
	ld	(ix-26),l
;3319     ci.versRespPending = false;
	.debug	# 3319
	xor	a,a
	ld	(ix-25),a
;3320 
;3321     unreadBytes = 0;
	.debug	# 3321
	bool	hl
	ld	l,h
	ld	(ix-2),hl
;3322     if (ioctl(ci.fd, FIONREAD, &unreadBytes))  { closeCon(&ci);  continue; 
	.debug	# 3322
	ld	hl,-2+@580
	add	hl,sp
	push	hl
	ld	hl,0x541b
	push	hl
	ld	hl,(ix-34)
	push	hl
	lcall	$ioctl
	add	sp,6
	bool	hl
	jr	z,@591
@592:
	.debug	< @592 @593
	ld	hl,-34+@580
	add	hl,sp
	push	hl
	lcall	$closeCon
	pop	hl
	jp	@587
@593:
	.debug	>
;3323 
;3324     ++numCons;
@591:
	.debug	# 3324
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
;3325 
;3326     if (!unreadBytes)  continue;
	.debug	# 3326
	ld	hl,(ix-2)
	bool	hl
	jp	z,@587
;3327 
;3328     respAddrTCP = con->in_Addr;  respPktUsedTCP = 0;
	.debug	# 3328
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x337
	ld	bc,0
	call	__ladd##
	ld	hl,-24+@580
	add	hl,sp
	push	bc
	push	de
	ex	de,hl
	call	__farcvp##
	ld	hl,14
	call	__farcopy##
	add	sp,4
	bool	hl
	ld	l,h
	ld	(_respPktUsedTCP),hl
;3329 
;3330   //--- got some data, so process whatever msgs the client sent ---
;3331     if (ShowTCPPkts)  {
	.debug	# 3331
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x2
	and	hl,de
	jp	z,@595
;3332       printf("\n=== got data on fd %d (con %u) from: %s:%u via TCP ===\n",
@596:
	.debug	< @596 @597
;3333              ci.fd, (uint)(con-caCons),
;3334              inet_ntop(AF_INET, &respAddrTCP.SIN_ADDR, temp, sizeof(temp)),
;3335              ntohs(respAddrTCP.sin_port) );
	.debug	# 3335
	ld	hl,(ix-22)
	ld	a,l
	ld	l,h
	ld	h,a
	push	hl
	ld	hl,0x18
	push	hl
	ld	hl,-54+@580
	add	hl,sp
	push	hl
	ld	hl,-14+@580
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ntop
	add	sp,8
	push	hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys _caCons)
	ld	c,phys _caCons >> 16
	call	__lsub##
	push	bc
	push	de
	ld	de,0x345
	ld	bc,0
	call	__ldiv##
	push	de
	ld	hl,(ix-34)
	push	hl
	ld	de,word (phys @1+1582)
	ld	c,phys @1+1582 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;3336     }
@597:
	.debug	>
;3337 
;3338     if (CA_ProcessMsgs(&ci) < 0)  {
@595:
	.debug	# 3338
	ld	hl,-34+@580
	add	hl,sp
	push	hl
	lcall	$CA_ProcessMsgs
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@598
;3339       closeCon(&ci);  --numCons;  respPktUsedTCP = 0; }
@599:
	.debug	< @599 @600
	.debug	# 3339
	ld	hl,-34+@580
	add	hl,sp
	push	hl
	lcall	$closeCon
	pop	hl
	ld	hl,(ix-6)
	dec	hl
	ld	(ix-6),hl
	bool	hl
	ld	l,h
	ld	(_respPktUsedTCP),hl
@600:
	.debug	>
;3340 
;3341     if (respPktUsedTCP)  if (sendRespPkt(&ci))  {
@598:
	.debug	# 3341
	ld	hl,(_respPktUsedTCP)
	bool	hl
	jr	z,@601
	ld	hl,-34+@580
	add	hl,sp
	push	hl
	lcall	$sendRespPkt
	pop	de
	bool	hl
	jr	z,@602
;3342       closeCon(&ci);  --numCons;  respPktUsedTCP = 0; }
@603:
	.debug	< @603 @604
	.debug	# 3342
	ld	hl,-34+@580
	add	hl,sp
	push	hl
	lcall	$closeCon
	pop	hl
	ld	hl,(ix-6)
	dec	hl
	ld	(ix-6),hl
	bool	hl
	ld	l,h
	ld	(_respPktUsedTCP),hl
@604:
	.debug	>
;3343 
;3344     if (ShowTCPPkts OR ShowTCPCmds)  printf("\n");
@602:
@601:
	.debug	# 3344
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x2
	and	hl,de
	jr	nz,@605
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x8
	and	hl,de
	jr	z,@606
@605:
	ld	de,word (phys @1+98)
	ld	c,phys @1+98 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3345   }
@606:
@589:
	.debug	>
;3346 
;3347   return numCons;
@587:
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x345
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
	jp	@585
@586:
@584:
	.debug	>
	.debug	# 3347
	ld	hl,(ix-6)
;3348 }
@581:
	.debug	} @581 3348

@580	equ	58
	ld	sp,ix
	pop	ix
	lret
@582	equ	60
;3349 
;3350 
;3351 //-------------------------------------------------------------------------
;3352 //  Test for changes to any of the PVs with open subscriptions and generate
;3353 //  messages for each client subscribed to the changed values.
;3354 //-------------------------------------------------------------------------
;3355 int CA_ProcessSubscriptions(void)
;3356 {
$CA_ProcessSubscriptions::
	.debug	G $CA_ProcessSubscriptions 76 9
	.debug	{ $CA_ProcessSubscriptions 76 3355 @609 @608
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-60
;3357   bool  checkForChg;
	.debug	L checkForChg -1 3
;3358   int  events, stat;
	.debug	L events -3 6
	.debug	L stat -5 6
;3359   uint  u, s, curMS, maxSubNum;
	.debug	L u -7 7
	.debug	L s -9 7
	.debug	L curMS -11 7
	.debug	L maxSubNum -13 7
;3360   SID  sid;
	.debug	L sid -15 7
;3361   PVID  pvid;
	.debug	L pvid -17 7
;3362   time_t  curSecs;
	.debug	L curSecs -21 9
;3363   CA_Con far  *con;
	.debug	L con -25 71
;3364   PVID far  *chan, *chans;
	.debug	L chan -29 69
	.debug	L chans -33 69
;3365   CA_Sub far  *sub;
	.debug	L sub -37 74
;3366   PV_Info  pvInfo;
	.debug	L pvInfo -50 70
;3367   ConInfo  ci;
	.debug	L ci -60 51
;3368   static ulong  lastBugMsgTime = 0;
	.dseg
@610:
	.dw	0, 0
	.debug	S lastBugMsgTime @610 9
	.seg	FARCODE
;3369 
;3370 
;3371   if (ShowDebugMsgs)  printf("\r\n--- ProcessSubscriptions ---\r\n");  //td
	.debug	# 3371
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	de,0x800
	and	hl,de
	jr	z,@611
	ld	de,word (phys @1+1639)
	ld	c,phys @1+1639 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3372 
;3373 //--- Update the event masks for all PVs with at least one subscription and
;3374 //--- clear the events to check for the next time. ---
;3375   checkForChg = valChgMode != VCM_PERIODIC;
@611:
	.debug	# 3375
	ld	hl,(_valChgMode)
	bool	hl
	jr	z,@612
	ld	l,0x1
@612:
	ld	(ix-1),l
;3376   if (checkForChg)  pvCheckAllEvents(&curSecs, &curMS, valChgMode == VCM_AN
	.debug	# 3376
	ld	a,l
	or	a,a
	jr	z,@613
	ld	hl,(_valChgMode)
	ld	de,0x2
	or	a,a
	sbc	hl,de
	ld	h,d
	ld	l,d
	jr	nz,@614
	inc	l
@614:
	push	hl
	ld	hl,-9+@607
	add	hl,sp
	push	hl
	ld	hl,-17+@607
	add	hl,sp
	push	hl
	lcall	$pvCheckAllEvents
	add	sp,6
;3377 
;3378 // ----- From recent changes/patch to EPICS code -----
;3379 // The EPICS epoch begins midnight first thing on 1st January 1990 and is i
;3380 // We convert all EPICS timestamps to the Python epoch.  This is not define
;3381 // the language documentation but in practice is the ANSI epoch, midnight 1
;3382 // January 1970.  Strictly we should compute
;3383 //   EPICS_epoch = calendar.timegm((1990, 1, 1, 0, 0, 0, 0, 0, 0))
;3384 // but that pulls in an extra module dependency and the number is constant:
;3385 // EPICS_epoch = 631152000             # Seconds from 1970 to 1990
;3386 
;3387   //--- set timestamp to be used for any READ_NOTIFY msgs we generate ---
;3388   epochTimeSecs = curSecs - 631152000lu; // EPICS uses 1990-01-01 00:00:00
@613:
	.debug	# 3388
	ld	hl,(ix-21)
	ex	de,hl
	ld	hl,(ix-19)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6280
	ld	bc,0xda61
	call	__ladd##
	ld	(_epochTimeSecs),de
	ld	(_epochTimeSecs+2),bc
;3389   epochTimeNS = curMS * 1000000lu;
	.debug	# 3389
	ld	hl,(ix-11)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x4240
	ld	c,0xf
	call	__ulmlt##
	ld	(_epochTimeNS),de
	ld	(_epochTimeNS+2),bc
;3390 
;3391 //--- Check the updated event mask for each subscription's PV.  Note that -
;3392 //--- pvCheckEvents() also adds to the events that need to be checked the -
;3393 //--- next time. ---
;3394   for (u=0,con=caCons; u<CA_MAX_CONS; ++u,++con)  {
@615:
	.debug	< @615 @616
	.debug	# 3394
	bool	hl
	ld	l,h
	ld	(ix-7),hl
	ld	de,word (phys _caCons)
	ld	c,phys _caCons >> 16
	ld	hl,bc
	ld	(ix-23),hl
	ex	de,hl
	ld	(ix-25),hl
	ex	de,hl
@617:
	ld	hl,(ix-7)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	nc,@618
;3395     if ((ci.fd = con->fd) < 0)  continue;
@620:
	.debug	< @620 @621
	.debug	# 3395
	ld	hl,(ix-25)
	ex	de,hl
	ld	hl,(ix-23)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-60),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@619
;3396 
;3397     respPktUsedTCP = 0;  //respAddrTCP = con->in_Addr;
	.debug	# 3397
	bool	hl
	ld	l,h
	ld	(_respPktUsedTCP),hl
;3398 
;3399     ci.type = TCP_BUF;  //finish
	.debug	# 3399
	inc	l
	ld	(ix-58),hl
;3400     ci.con = con;
	.debug	# 3400
	ld	hl,(ix-25)
	ex	de,hl
	ld	hl,(ix-23)
	ld	bc,hl
	ld	(ix-54),hl
	ex	de,hl
	ld	(ix-56),hl
	ex	de,hl
;3401     ci.showCmds = ci.versRespPending = false;  //finish
	.debug	# 3401
	xor	a,a
	ld	(ix-51),a
	ld	(ix-52),a
;3402 
;3403     chans = con->chans;  maxSubNum = con->maxSubNum;
	.debug	# 3403
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-31),hl
	ex	de,hl
	ld	(ix-33),hl
	ex	de,hl
	ld	hl,(ix-25)
	ex	de,hl
	ld	hl,(ix-23)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x305
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-13),hl
;3404 
;3405     for (s=0,sub=con->subs; s<maxSubNum; ++s,++sub)  {
@623:
	.debug	< @623 @624
	.debug	# 3405
	bool	hl
	ld	l,h
	ld	(ix-9),hl
	ld	hl,(ix-25)
	ex	de,hl
	ld	hl,(ix-23)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x85
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-35),hl
	ex	de,hl
	ld	(ix-37),hl
	ex	de,hl
@625:
	ld	hl,(ix-9)
	ex	de,hl
	ld	hl,(ix-13)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@626
;3406       if ((sid = sub->sid) == SID_UNUSED)  continue;
@628:
	.debug	< @628 @629
	.debug	# 3406
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-15),hl
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jp	z,@627
;3407 
;3408       chan = chans + sid;  pvid = *chan;
	.debug	# 3408
	ld	hl,(ix-15)
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	push	bc
	push	de
	ld	hl,(ix-33)
	ex	de,hl
	ld	hl,(ix-31)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-27),hl
	ex	de,hl
	ld	(ix-29),hl
	ex	de,hl
	call	__farld2##
	ex	de,hl
	ld	(ix-17),hl
;3409 
;3410       //finish:  If subscr is "pending", then don't bother checking for a c
;3411       if (checkForChg AND !(sub->monMask & DBE_PENDING))  {
	.debug	# 3411
	ld	a,(ix-1)
	or	a,a
	jp	z,@632
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	and	a,128
	jr	nz,@632
;3412         if (!(events = pvCheckEvents(pvid, sub->monMask & ~DBE_PENDING)))  
@633:
	.debug	< @633 @634
	.debug	# 3412
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	and	a,127
	bool	hl
	ld	l,a
	push	hl
	ld	hl,(ix-17)
	push	hl
	lcall	$pvCheckEvents
	add	sp,4
	ld	(ix-3),hl
	bool	hl
	jp	z,@627
;3413         if (events < 0)  if (msSince_(lastBugMsgTime) > 600000u)  {
	.debug	# 3413
	ld	hl,(ix-3)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@636
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(@610)
	or	a,a
	sbc	hl,de
	ld	de,0x27c0
	or	a,a
	sbc	hl,de
	jr	c,@637
	jr	z,@637
;3414           printf("*** Invalid subscr SID or chan pvID: SID:%u  pvID:%u ***\
@638:
	.debug	< @638 @639
;3415                  sid, *chan);
	.debug	# 3415
	ld	hl,(ix-29)
	ex	de,hl
	ld	hl,(ix-27)
	ld	bc,hl
	call	__farld2##
	push	de
	ld	hl,(ix-15)
	push	hl
	ld	de,word (phys @1+1672)
	ld	c,phys @1+1672 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3416           lastBugMsgTime = GetMS_();  continue;
	.debug	# 3416
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	bc,0
	ld	(@610),de
	ld	(@610+2),bc
;3417         }
	jp	@627
@639:
	.debug	>
;3418       }
@637:
@636:
@634:
	.debug	>
;3419 
;3420       if (ShowEvents)  {
@632:
	.debug	# 3420
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x40
	and	hl,de
	jr	z,@640
;3421         if (pvGetInfo(pvid, &pvInfo))  pvInfo.name = "<invalid>";
@641:
	.debug	< @641 @642
	.debug	# 3421
	ld	hl,-50+@607
	add	hl,sp
	push	hl
	ld	hl,(ix-17)
	push	hl
	lcall	$pvGetInfo
	add	sp,4
	bool	hl
	jr	z,@643
	ld	de,word (phys @1+715)
	ld	c,phys @1+715 >> 16
	ld	hl,bc
	ld	(ix-48),hl
	ex	de,hl
	ld	(ix-50),hl
	ex	de,hl
;3422         printf("Events: %u  Con:%u  SubID:0x%08lX  [%ls]\n",
@643:
;3423                events, u, sub->subID, pvInfo.name);
	.debug	# 3423
	ld	hl,(ix-50)
	ex	de,hl
	ld	hl,(ix-48)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-7)
	push	hl
	ld	hl,(ix-3)
	push	hl
	ld	de,word (phys @1+1730)
	ld	c,phys @1+1730 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;3424       }
@642:
	.debug	>
;3425 
;3426       if (pvLockVal(pvid, LM_TryLock, LT_READ) < 0)  {
@640:
	.debug	# 3426
	bool	hl
	ld	l,h
	push	hl
	ld	l,0x2
	push	hl
	ld	hl,(ix-17)
	push	hl
	lcall	$pvLockVal
	add	sp,6
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@644
;3427         sub->monMask |= DBE_PENDING;  //mark subscr msg as "pending"
@645:
	.debug	< @645 @646
	.debug	# 3427
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	or	a,128
	pop	bc
	call	__farst1##
;3428         if (ShowEvents)
	.debug	# 3428
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x40
	and	hl,de
	jr	z,@647
;3429           printf("*** subscr msg pending [%ls] ***\n", pvInfo.name);
	.debug	# 3429
	ld	hl,(ix-50)
	ex	de,hl
	ld	hl,(ix-48)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+1772)
	ld	c,phys @1+1772 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3430         continue;
@647:
	.debug	# 3430
;3431       }
	jp	@627
@646:
	.debug	>
;3432 //      if (pvLockVal(pvid, LM_WaitLock, LT_READ) < 0)  {
;3433 //        printf("*** Unable to get lock on PV [%ls] ***\n", pvInfo.name);
;3434 //        continue;
;3435 //      }
;3436       stat = sendValue(&ci, CA_PROTO_EVENT_ADD, sub->subID,
@644:
;3437                        sub->dbrType, sub->numElems, sid);
	.debug	# 3437
	ld	hl,(ix-15)
	push	hl
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,0x1
	push	hl
	ld	hl,-48+@607
	add	hl,sp
	push	hl
	lcall	$sendValue
	add	sp,14
	ld	(ix-5),hl
;3438 
;3439       if (sub->monMask & DBE_PENDING)  {
	.debug	# 3439
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	and	a,128
	jr	z,@648
;3440         sub->monMask &= ~DBE_PENDING;
@649:
	.debug	< @649 @650
	.debug	# 3440
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	and	a,127
	pop	bc
	call	__farst1##
;3441         if (ShowEvents AND !stat)
	.debug	# 3441
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x40
	and	hl,de
	jr	z,@652
	ld	hl,(ix-5)
	bool	hl
	jr	nz,@652
;3442           printf("*** pending subscr msg sent [%ls] ***\n", pvInfo.name);
	.debug	# 3442
	ld	hl,(ix-50)
	ex	de,hl
	ld	hl,(ix-48)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @1+1806)
	ld	c,phys @1+1806 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3443       }
@652:
@650:
	.debug	>
;3444 
;3445       pvLockVal(pvid, LM_Unlock, LT_READ);
@648:
	.debug	# 3445
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix-17)
	push	hl
	lcall	$pvLockVal
	add	sp,6
;3446 
;3447       if (stat)  {
	.debug	# 3447
	ld	hl,(ix-5)
	bool	hl
	jr	z,@653
;3448         closeCon(&ci);
@654:
	.debug	< @654 @655
	.debug	# 3448
	ld	hl,-60+@607
	add	hl,sp
	push	hl
	lcall	$closeCon
	pop	hl
;3449         if (ci.type == TCP_BUF)  respPktUsedTCP = 0;
	.debug	# 3449
	ld	hl,(ix-58)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@626
	bool	hl
	ld	l,h
	ld	(_respPktUsedTCP),hl
;3450         break;
	.debug	# 3450
;3451       }
	jr	@626
@655:
	.debug	>
;3452 
;3453       ++numEvents;
@653:
	.debug	# 3453
	ld	hl,(_numEvents)
	inc	hl
	ld	(_numEvents),hl
;3454     }
@629:
	.debug	>
;3455 
;3456     if ((ci.type == TCP_BUF) AND respPktUsedTCP)
@627:
	ld	hl,(ix-9)
	inc	hl
	ld	(ix-9),hl
	ld	hl,(ix-37)
	ex	de,hl
	ld	hl,(ix-35)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-35),hl
	ex	de,hl
	ld	(ix-37),hl
	ex	de,hl
	jp	@625
@626:
@624:
	.debug	>
	.debug	# 3456
	ld	hl,(ix-58)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@658
	ld	hl,(_respPktUsedTCP)
	bool	hl
	jr	z,@658
;3457       if (sendRespPkt(&ci))  closeCon(&ci);
	.debug	# 3457
	ld	hl,-60+@607
	add	hl,sp
	push	hl
	lcall	$sendRespPkt
	pop	de
	bool	hl
	jr	z,@659
	ld	hl,-60+@607
	add	hl,sp
	push	hl
	lcall	$closeCon
	pop	hl
;3458   }
@659:
@658:
@621:
	.debug	>
;3459 
;3460   ++numPSub;
@619:
	ld	hl,(ix-7)
	inc	hl
	ld	(ix-7),hl
	ld	hl,(ix-25)
	ex	de,hl
	ld	hl,(ix-23)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x345
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-23),hl
	ex	de,hl
	ld	(ix-25),hl
	ex	de,hl
	jp	@617
@618:
@616:
	.debug	>
	.debug	# 3460
	ld	hl,(_numPSub)
	inc	hl
	ld	(_numPSub),hl
;3461 
;3462   return 0;
	.debug	# 3462
	bool	hl
	ld	l,h
;3463 }
@608:
	.debug	} @608 3463

@607	equ	60
	ld	sp,ix
	pop	ix
	lret
@609	equ	62
;3464 
;3465 //-------------------------------------------------------------------------
;3466 void zeroCounts(void)
;3467 {
$zeroCounts::
	.debug	G $zeroCounts 78 9
	.debug	{ $zeroCounts 78 3466 @662 @661
;3468   numUDPPkts = numProcPkts = numSearchMsgs = numEvents = numWrites = numPSu
;3469   udpPktRate = procPktRate = searchMsgRate = eventsRate = writesRate =
;3470   psubRate = 0;
	.debug	# 3470
	bool	hl
	ld	l,h
	ld	(_psubRate),hl
	ld	(_writesRate),hl
	ld	(_eventsRate),hl
	ld	(_searchMsgRate),hl
	ld	(_procPktRate),hl
	ld	(_udpPktRate),hl
	ld	(_numPSub),hl
	ld	(_numWrites),hl
	ld	(_numEvents),hl
	ld	(_numSearchMsgs),hl
	ld	(_numProcPkts),hl
	ld	(_numUDPPkts),hl
;3471 }
@661:
	.debug	} @661 3471

@660	equ	0
	lret
@662	equ	0
;3472 
;3473 
;3474 //-------------------------------------------------------------------------
;3475 //  DEBROS implementation of the EPICS Channel Access (CA) protocol service
;3476 //-------------------------------------------------------------------------
;3477 void _task ca_udpd(int argc, char **argv)
;3478 {
	.align	4
$$ca_udpd::
	ex	(sp),iy
$ca_udpd::
	.debug	G $ca_udpd 79 9
	.debug	{ $ca_udpd 79 3477 @665 @664
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-48
	.debug	A argc 5 6
	.debug	A argv 7 80
;3479   int  stat;
	.debug	L stat -2 6
;3480   uint  u, loopCount, beaconPeriod;
	.debug	L u -4 7
	.debug	L loopCount -6 7
	.debug	L beaconPeriod -8 7
;3481   sigset_t  sigSet;
	.debug	L sigSet -12 9
;3482   socklen_t  addrLen;
	.debug	L addrLen -14 6
;3483   ConInfo  ci;
	.debug	L ci -24 51
;3484   uchar  temp[24];
	.debug	L temp -48 77
;3485 
;3486 
;3487   if (ca_udp_pid AND (_activeTaskIdx_(ca_udp_pid) >= 0))  {
	.debug	# 3487
	ld	hl,(_ca_udp_pid)
	bool	hl
	jr	z,@667
	ld	hl,(_ca_udp_pid)
	push	hl
	lcall	$_activeTaskIdx_
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@667
;3488     printf("\r\n  CA %s service already running: pid: %d\r\n",
@668:
	.debug	< @668 @669
;3489            "UDP", ca_udp_pid);
	.debug	# 3489
	ld	hl,(_ca_udp_pid)
	push	hl
	ld	hl,@2+93
	push	hl
	ld	de,word (phys @1+1845)
	ld	c,phys @1+1845 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3490     Exit(-1);
	.debug	# 3490
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;3491   }
@669:
	.debug	>
;3492 
;3493   printf("  CA UDP pid: %u\r\n", ca_udp_pid = getpid());
@667:
	.debug	# 3493
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	(_ca_udp_pid),hl
	push	hl
	ld	de,word (phys @1+1890)
	ld	c,phys @1+1890 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3494 
;3495 
;3496 //--- If the list of allowed clients is blank, add the EPICS gateways ---
;3497 //finish:  Get values from a file stored on the server?
;3498   if (!allowedClients[0])  {
	.debug	# 3498
	ld	de,(_allowedClients)
	ld	bc,(_allowedClients+2)
	ld	hl,bc
	or	hl,de
	jp	nz,@670
;3499     allowedClients[0] = htonl(0xC0A80405lu);  // 192.168.4.5
@671:
	.debug	< @671 @672
	.debug	# 3499
	ld	de,0x405
	ld	bc,0xc0a8
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	(_allowedClients),de
	ld	(_allowedClients+2),bc
;3500     allowedClients[1] = htonl(0xC0A80406lu);  // 192.168.4.6
	.debug	# 3500
	ld	de,0x406
	ld	bc,0xc0a8
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	ld	(_allowedClients+4),de
	ld	(_allowedClients+6),bc
;3501   }
@672:
	.debug	>
;3502 
;3503 
;3504 //--- block Terminate signal so we can send a packet just before exiting --
;3505   sigSet = sigmask(SIGTERM);  sigprocmask(SIG_BLOCK, &sigSet, NULL);
@670:
	.debug	# 3505
	ld	de,0x4000
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
	push	hl
	ld	hl,-10+@663
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$sigprocmask
	add	sp,6
;3506 
;3507   redirectStdio();  // so printf, perror, etc don't end up in data stream
	.debug	# 3507
	lcall	$redirectStdio
;3508   close(0);  close(1);  close(2);  // in case this was started from a shell
	.debug	# 3508
	bool	hl
	ld	l,h
	push	hl
	lcall	$close
	pop	de
	ld	hl,0x1
	push	hl
	lcall	$close
	pop	de
	ld	hl,0x2
	push	hl
	lcall	$close
	pop	de
;3509 
;3510   beaconPeriod = CA_INIT_BEACON_PERIOD;  lastBeaconTime = GetMS_();
	.debug	# 3510
	ld	hl,0x19
	ld	(ix-8),hl
	ld	hl,(__TimerMilliSeconds+4)
	ld	(_lastBeaconTime),hl
;3511 
;3512   beaconID = 0;  loopCount = 0xff;
	.debug	# 3512
	ld	de,0
	ld	c,e
	ld	b,e
	ld	(_beaconID),de
	ld	(_beaconID+2),bc
	ld	hl,0xff
	ld	(ix-6),hl
;3513 
;3514   ci.fd = -1;
	.debug	# 3514
	ld	h,l
	ld	(ix-24),hl
;3515   ci.type = UDP_CON;
	.debug	# 3515
	bool	hl
	ld	l,h
	ld	(ix-22),hl
;3516   ci.con = NULL;
	.debug	# 3516
	ld	(ix-18),hl
	ex	de,hl
	ld	(ix-20),hl
	ex	de,hl
;3517   ci.showCmds = false;
	.debug	# 3517
	xor	a,a
	ld	(ix-16),a
;3518 
;3519 
;3520 //===== main processing loop =====
;3521   for (;;)  {
@673:
	.debug	< @673 @674
@675:
@677:
;3522 
;3523     ci.versRespPending = false;
@678:
	.debug	< @678 @679
	.debug	# 3523
	xor	a,a
	ld	(ix-15),a
;3524 
;3525   //--- update our copy of the hostname occasionally ---
;3526     if (! (++loopCount & 0xff))  {
	.debug	# 3526
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	ld	h,0
	bool	hl
	jr	nz,@680
;3527       gethostname(servName, sizeof(servName));
@681:
	.debug	< @681 @682
	.debug	# 3527
	ld	l,0x20
	push	hl
	ld	hl,_servName
	push	hl
	lcall	$gethostname
	add	sp,4
;3528       servNameLen = strlen(servName);
	.debug	# 3528
	ld	hl,_servName
	push	hl
	call	_strlen
	pop	de
	ld	(_servNameLen),hl
;3529     }
@682:
	.debug	>
;3530 
;3531   //--- Check for a pending Terminate signal.  If we get a new one, ---
;3532   //--- then close all our connections and exit ---
;3533     if (sigpending(&sigSet) == 0)  if (sigismember(&sigSet, SIGTERM))  {
@680:
	.debug	# 3533
	ld	hl,-12+@663
	add	hl,sp
	push	hl
	lcall	$sigpending
	pop	de
	bool	hl
	jr	nz,@683
	ld	l,0xf
	push	hl
	ld	hl,-10+@663
	add	hl,sp
	push	hl
	lcall	$sigismember
	add	sp,4
	bool	hl
	jr	z,@684
;3534       printf("=== CA UDP server shutting down ===\n");
@685:
	.debug	< @685 @686
	.debug	# 3534
	ld	de,word (phys @1+1909)
	ld	c,phys @1+1909 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3535     //--- close UDP connection ---
;3536       if (ci.fd >= 0)  { close(ci.fd);  ci.fd = -1; }
	.debug	# 3536
	ld	hl,(ix-24)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@687
@688:
	.debug	< @688 @689
	ld	hl,(ix-24)
	push	hl
	lcall	$close
	pop	de
	ld	hl,0xffff
	ld	(ix-24),hl
@689:
	.debug	>
;3537     //--- wait for just a bit to help insure connections close gracefully -
;3538       sleepMS(CAS_STOP_WAIT_TIME);  ca_tcp_pid = 0;  Exit(0);
@687:
	.debug	# 3538
	ld	de,0x9c4
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	bool	hl
	ld	l,h
	ld	(_ca_tcp_pid),hl
	push	hl
	lcall	$Exit
	pop	hl
;3539     }
@686:
	.debug	>
;3540 
;3541 
;3542   //--- (re)create or close UDP broadcast socket as needed ---
;3543     if (processUDP)  {
@684:
@683:
	.debug	# 3543
	ld	a,(_processUDP)
	or	a,a
	jr	z,@690
;3544       if (ci.fd < 0)  ci.fd = CA_CreateUDPListener(); }
@691:
	.debug	< @691 @692
	.debug	# 3544
	ld	hl,(ix-24)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@694
	lcall	$CA_CreateUDPListener
	ld	(ix-24),hl
@692:
	.debug	>
;3545     else  {
	jr	@694
@690:
;3546       if (ci.fd >= 0)  { close(ci.fd);  ci.fd = -1; }
@695:
	.debug	< @695 @696
	.debug	# 3546
	ld	hl,(ix-24)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@697
@698:
	.debug	< @698 @699
	ld	hl,(ix-24)
	push	hl
	lcall	$close
	pop	de
	ld	hl,0xffff
	ld	(ix-24),hl
@699:
	.debug	>
;3547       sleepMS(200);  continue;
@697:
	.debug	# 3547
	ld	de,0xc8
	jp	@989
;3548     }
@696:
	.debug	>
;3549 
;3550 
;3551   /*
;3552     Clients use UDP broadcast packets to discover the server that hosts a P
;3553     and to monitor the state of servers.  For clients to establish and main
;3554     connections to a server, the server must respond to packets with search
;3555     requests for its PVs in a timely manner.  Given the limitations of the
;3556     hardware this code currently runs on, this is a bit of a challenge.
;3557 
;3558     UDP packets with SEARCH requests are generally numerous and quite frequ
;3559     The current hardware simply doesn't have the ability to capture and pro
;3560     ALL the UDP packets.
;3561 
;3562     The first line of defense against this onslaught of packets is to limit
;3563     we process based on a list of allowed client addresses.  We can't stop 
;3564     reception of broadcast packets based on their content, but by ignoring 
;3565     from addresses not in a short list we free up CPU time to deal with the
;3566 
;3567     This selective processing is a big help.  There are still a lot of pack
;3568     that we never even see, but if we spend enough time each cycle on proce
;3569     the ones we aren't deliberately ignoring, clients are generally able to
;3570     connect new channels quickly, and reconnect disconnected ones without t
;3571     long a delay.  But this still requires more CPU time than we can afford
;3572     spend (or even have available in some cases).
;3573 
;3574     The second method used to try to limit CPU usage while still allowing c
;3575     to (re)connect in a timely manner is to TEMPORARILY increase the amount
;3576     CPU time we allow for this processing.  The code that decides when to d
;3577     is based on the following theories about when packets of interest are m
;3578     likely to occur:
;3579 
;3580       - Beacons affect when and how often a client with disconnected channe
;3581         sends search requests
;3582 
;3583       - Search requests for PVs with the same record name are grouped toget
;3584         In the same packet where possible, but across multiple packets when
;3585         necessary.  In the later case, this means if we received a packet w
;3586         requests for PVs we host, then it is possible another one followed 
;3587         but we missed it.  In that case we want to increase the probability
;3588         that we won't miss it the next time.
;3589 
;3590     The max time we will process UDP packets each call is a descreasing val
;3591     based on how long it has been since the most recent occurance of one of
;3592     these events.
;3593 
;3594     NOTE that because we are using only 16-bit ms values, this will  will
;3595     "wrap-around" aprox once per minute, which is actually useful as insura
;3596     for clients with disconnected channels that didn't get reconnected foll
;3597     the boost triggered by the most recent event.
;3598   */
;3599 
;3600     errno = 0;
@694:
	.debug	# 3600
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
;3601 
;3602     rcvdPktSize = nextRcvdPktByte = respPktUsedUDP = 0;
	.debug	# 3602
	bool	hl
	ld	l,h
	ld	(_respPktUsedUDP),hl
	ld	(_nextRcvdPktByte),hl
	ld	(_rcvdPktSize),hl
;3603 
;3604   //--- check for a packet ---
;3605     addrLen = sizeof(respAddrUDP);
	.debug	# 3605
	ld	hl,0xe
	ld	(ix-14),hl
;3606     stat = recvfrom(ci.fd, rcvdPkt, sizeof(rcvdPkt), 0,
;3607                     (SAP)&respAddrUDP, &addrLen );
	.debug	# 3607
	ld	hl,-14+@663
	add	hl,sp
	push	hl
	ld	hl,_respAddrUDP
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,0x5b4
	push	hl
	ld	de,word (phys _rcvdPkt)
	ld	c,phys _rcvdPkt >> 16
	push	bc
	push	de
	ld	hl,(ix-24)
	push	hl
	lcall	$recvfrom
	add	sp,14
	ld	(ix-2),hl
;3608 
;3609     if (stat == 0)  {
	.debug	# 3609
	bool	hl
	jr	nz,@700
;3610       printf("UDP SEARCH socket closed by other end\r\n");
@701:
	.debug	< @701 @702
	.debug	# 3610
	ld	de,word (phys @1+1946)
	ld	c,phys @1+1946 >> 16
	push	bc
	push	de
	lcall	$farprintf
	jr	@990
;3611       close(ci.fd);  ci.fd = -1;  sleepMS(100);  continue;
	.debug	# 3611
;3612     }
@702:
	.debug	>
;3613 
;3614     if (stat < 0)  {
@700:
	.debug	# 3614
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@703
;3615       if (errno == EAGAIN)  { sleepMS(10);  continue; }
@704:
	.debug	< @704 @705
	.debug	# 3615
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	hl,(hl)
	ld	e,0xb
	or	a,a
	sbc	hl,de
	jr	nz,@706
@707:
	.debug	< @707 @708
	dec	e
	jp	@989
@708:
	.debug	>
;3616       perror("recvfrom()");
@706:
	.debug	# 3616
	ld	de,word (phys @1+1986)
	ld	c,phys @1+1986 >> 16
	push	bc
	push	de
	lcall	$perror
@990:
	add	sp,4
;3617       close(ci.fd);  ci.fd = -1;  sleepMS(100);  continue;
	.debug	# 3617
	jp	@988
;3618     }
@705:
	.debug	>
;3619 
;3620   //--- got a packet ---
;3621     ++numUDPPkts;
@703:
	.debug	# 3621
	ld	hl,(_numUDPPkts)
	inc	hl
	ld	(_numUDPPkts),hl
;3622 
;3623   //--- Ignore the packet unless it is from one of our allowed clients. ---
;3624   //--- This "filtering" is required to avoid missing so many packets that 
;3625   //--- clients often cannot reconnect. ---
;3626     for (u=0; u<CA_MAX_CONS; ++u)
@709:
	.debug	< @709 @710
	.debug	# 3626
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@711:
	ld	hl,(ix-4)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@712
;3627       if (allowedClients[u] == respAddrUDP.SIN_ADDR)  break;
	.debug	# 3627
	ld	hl,(ix-4)
	add	hl,hl
	add	hl,hl
	ld	de,_allowedClients
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	de,(_respAddrUDP+4)
	ld	bc,(_respAddrUDP+6)
	call	__lsub##
	jr	z,@712
;3628     if (u == CA_MAX_CONS)  continue;
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jr	@711
@712:
@710:
	.debug	>
	.debug	# 3628
	ld	hl,(ix-4)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	z,@677
;3629 
;3630     ++numProcPkts;
	.debug	# 3630
	ld	hl,(_numProcPkts)
	inc	hl
	ld	(_numProcPkts),hl
;3631 
;3632     if (ShowUDPPkts)
	.debug	# 3632
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x1
	and	hl,de
	jr	z,@716
;3633       printf("=== %d byte packet from: %s via UDP ===\n",
;3634              stat,
;3635              inet_ntop(AF_INET, &respAddrUDP.SIN_ADDR, temp, sizeof(temp)) 
	.debug	# 3635
	ld	hl,0x18
	push	hl
	ld	hl,-46+@663
	add	hl,sp
	push	hl
	ld	hl,_respAddrUDP+4
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ntop
	add	sp,8
	push	hl
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+1997)
	ld	c,phys @1+1997 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3636 
;3637     rcvdPktSize = stat;
@716:
	.debug	# 3637
	ld	hl,(ix-2)
	ld	(_rcvdPktSize),hl
;3638 
;3639     if (processUDP AND (ci.fd >= 0))  {
	.debug	# 3639
	ld	a,(_processUDP)
	or	a,a
	jr	z,@718
	ld	hl,(ix-24)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@718
;3640       ci.showCmds = ShowUDPCmds;
@719:
	.debug	< @719 @720
	.debug	# 3640
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x4
	and	hl,de
	ld	(ix-16),l
;3641       if (CA_ProcessMsgs(&ci) < 0)  {
	.debug	# 3641
	ld	hl,-24+@663
	add	hl,sp
	push	hl
	lcall	$CA_ProcessMsgs
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@988
;3642         close(ci.fd);  ci.fd = -1;  sleepMS(100);  continue; }
@722:
	.debug	< @722 @723
	.debug	# 3642
@723:
	.debug	>
;3643     }
@720:
	.debug	>
;3644 
;3645     if (ShowUDPPkts OR ShowUDPCmds)  printf("\n");
@718:
	.debug	# 3645
	ld	hl,(_current)
	ld	de,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x1
	and	hl,de
	jr	nz,@724
	ld	hl,(_current)
	ld	e,0xae
	add	hl,de
	ld	hl,(hl)
	ld	e,0x4
	and	hl,de
	jr	z,@725
@724:
	ld	de,word (phys @1+98)
	ld	c,phys @1+98 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3646 
;3647     if (respPktUsedUDP)  if (sendRespPkt(&ci))  {
@725:
	.debug	# 3647
	ld	hl,(_respPktUsedUDP)
	bool	hl
	jr	z,@726
	ld	hl,-24+@663
	add	hl,sp
	push	hl
	lcall	$sendRespPkt
	pop	de
	bool	hl
	jr	z,@727
;3648       close(ci.fd);  ci.fd = -1;  sleepMS(100);  continue; }
@728:
	.debug	< @728 @729
	.debug	# 3648
@988:
	ld	hl,(ix-24)
	push	hl
	lcall	$close
	pop	de
	ld	hl,0xffff
	ld	(ix-24),hl
	ld	de,0x64
@989:
	ld	c,d
	ld	b,d
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	jp	@677
@729:
	.debug	>
;3649 
;3650 
;3651   //--- Announce our own existence occasionally ---
;3652     if (ci.fd < 0)
@727:
@726:
	.debug	# 3652
	ld	hl,(ix-24)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@730
;3653       beaconPeriod = CA_INIT_BEACON_PERIOD;
	.debug	# 3653
	ld	hl,0x19
	ld	(ix-8),hl
;3654     else
;3655       if (msSince_(lastBeaconTime) >= beaconPeriod)
	jr	@731
@730:
	.debug	# 3655
	ld	hl,(__TimerMilliSeconds+4)
	ld	de,(_lastBeaconTime)
	or	a,a
	sbc	hl,de
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@732
;3656         if (sendBeacon(ci.fd) < 0)  {
	.debug	# 3656
	ld	hl,(ix-24)
	push	hl
	lcall	$sendBeacon
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@733
;3657           ci.fd = -1;  beaconPeriod = CA_INIT_BEACON_PERIOD; }
@734:
	.debug	< @734 @735
	.debug	# 3657
	ld	hl,0xffff
	ld	(ix-24),hl
	ld	hl,0x19
	ld	(ix-8),hl
@735:
	.debug	>
;3658         else
;3659           if ((beaconPeriod *= 2) > CA_MAX_BEACON_PERIOD)
	jr	@736
@733:
	.debug	# 3659
	ld	hl,(ix-8)
	add	hl,hl
	ld	(ix-8),hl
	ld	de,0x3a98
	or	a,a
	sbc	hl,de
	jr	c,@737
	jr	z,@737
;3660             beaconPeriod = CA_MAX_BEACON_PERIOD;
	.debug	# 3660
	ld	h,d
	ld	l,e
	ld	(ix-8),hl
;3661   }
@737:
@736:
@732:
@731:
@679:
	.debug	>
;3662 
;3663 }
	jp	@675
@674:
	.debug	>
@664:
	.debug	} @664 3663

@663	equ	48
	ld	sp,ix
	pop	ix
	lret
@665	equ	50
;3664 
;3665 
;3666 
;3667 //-------------------------------------------------------------------------
;3668 //  DEBROS implementation of the EPICS Channel Access (CA) protocol service
;3669 //-------------------------------------------------------------------------
;3670 void _task ca_tcpd(int argc, char **argv)
;3671 {
	.align	4
$$ca_tcpd::
	ex	(sp),iy
$ca_tcpd::
	.debug	G $ca_tcpd 79 9
	.debug	{ $ca_tcpd 79 3670 @740 @739
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-28
	.debug	A argc 5 6
	.debug	A argv 7 80
;3672   int  tcpfd;
	.debug	L tcpfd -2 6
;3673   int  stat;
	.debug	L stat -4 6
;3674   uint  u, numCons, loopTime, startLoopTime, lastTestedEvents, lastSampleTi
	.debug	L u -6 7
	.debug	L numCons -8 7
	.debug	L loopTime -10 7
	.debug	L startLoopTime -12 7
	.debug	L lastTestedEvents -14 7
	.debug	L lastSampleTime -16 7
;3675         loopCount, sleepTime;
	.debug	L loopCount -18 7
	.debug	L sleepTime -20 7
;3676   sigset_t  sigSet;
	.debug	L sigSet -24 9
;3677   CA_Con far  *con;
	.debug	L con -28 71
;3678 
;3679 
;3680   if (ca_tcp_pid AND (_activeTaskIdx_(ca_tcp_pid) >= 0))  {
	.debug	# 3680
	ld	hl,(_ca_tcp_pid)
	bool	hl
	jr	z,@742
	ld	hl,(_ca_tcp_pid)
	push	hl
	lcall	$_activeTaskIdx_
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@742
;3681     printf("\r\n  CA %s service already running: pid: %d\r\n",
@743:
	.debug	< @743 @744
;3682            "TCP", ca_tcp_pid);
	.debug	# 3682
	ld	hl,(_ca_tcp_pid)
	push	hl
	ld	hl,@2+97
	push	hl
	ld	de,word (phys @1+1845)
	ld	c,phys @1+1845 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3683     Exit(-1);
	.debug	# 3683
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;3684   }
@744:
	.debug	>
;3685 
;3686   printf("  CA TCP pid: %u\r\n", ca_tcp_pid = getpid());
@742:
	.debug	# 3686
	ld	hl,(_current)
	ld	de,0xb4
	add	hl,de
	ld	hl,(hl)
	ld	(_ca_tcp_pid),hl
	push	hl
	ld	de,word (phys @1+2038)
	ld	c,phys @1+2038 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3687 
;3688 
;3689 //--- block Terminate signal so we can send a packet just before exiting --
;3690   sigSet = sigmask(SIGTERM);  sigprocmask(SIG_BLOCK, &sigSet, NULL);
	.debug	# 3690
	ld	de,0x4000
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
	push	hl
	ld	hl,-22+@738
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	lcall	$sigprocmask
	add	sp,6
;3691 
;3692   redirectStdio();  // so printf, perror, etc don't end up in data stream
	.debug	# 3692
	lcall	$redirectStdio
;3693   close(0);  close(1);  close(2);  // in case this was started from a shell
	.debug	# 3693
	bool	hl
	ld	l,h
	push	hl
	lcall	$close
	pop	de
	ld	hl,0x1
	push	hl
	lcall	$close
	pop	de
	ld	hl,0x2
	push	hl
	lcall	$close
	pop	de
;3694 
;3695   lastTestedEvents = 0;
	.debug	# 3695
	bool	hl
	ld	l,h
	ld	(ix-14),hl
;3696 
;3697   tcpfd = -1;  numCons = 0;
	.debug	# 3697
	ld	hl,0xffff
	ld	(ix-2),hl
	bool	hl
	ld	l,h
	ld	(ix-8),hl
;3698 
;3699 //--- initialize connection data ---
;3700   for (u=0; u<CA_MAX_CONS; ++u)  {
@745:
	.debug	< @745 @746
	.debug	# 3700
	ld	(ix-6),hl
@747:
	ld	hl,(ix-6)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	nc,@748
;3701     con = caCons + u;
@750:
	.debug	< @750 @751
	.debug	# 3701
	ld	hl,(ix-6)
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	ld	de,0x345
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _caCons)
	ld	c,phys _caCons >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
;3702     fmemset(con, 0, sizeof(CA_Con));
	.debug	# 3702
	ld	de,0x345
	ld	bc,0
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;3703     fmemset(con->chans, 0xff, sizeof(con->chans));
	.debug	# 3703
	ld	de,0x80
	ld	c,d
	ld	b,d
	push	bc
	push	de
	ld	hl,0xff
	push	hl
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;3704     fmemset(con->subs, 0xff, sizeof(con->subs));
	.debug	# 3704
	ld	de,0x280
	ld	bc,0
	push	bc
	push	de
	ld	hl,0xff
	push	hl
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x85
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;3705     con->fd = -1;
	.debug	# 3705
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	ld	hl,0xffff
	call	__farst2##
;3706   }
@751:
	.debug	>
;3707 
;3708   zeroCounts();
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	jp	@747
@748:
@746:
	.debug	>
	.debug	# 3708
	lcall	$zeroCounts
;3709 
;3710   lastSampleTime = GetMS_();  loopCount = 0xff;
	.debug	# 3710
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-16),hl
	ld	hl,0xff
	ld	(ix-18),hl
;3711 
;3712 
;3713 //===== main processing loop =====
;3714   for (;;)  {
@752:
	.debug	< @752 @753
@754:
;3715     startLoopTime = GetMS_();
@757:
	.debug	< @757 @758
	.debug	# 3715
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-12),hl
;3716 
;3717     if (msSince_(lastSampleTime) >= 1000u)  {
	.debug	# 3717
	ex	de,hl
	ld	hl,(ix-16)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	de,0x3e8
	or	a,a
	sbc	hl,de
	jr	c,@759
;3718       udpPktRate = numUDPPkts;  procPktRate = numProcPkts;
@760:
	.debug	< @760 @761
	.debug	# 3718
	ld	hl,(_numUDPPkts)
	ld	(_udpPktRate),hl
	ld	hl,(_numProcPkts)
	ld	(_procPktRate),hl
;3719       searchMsgRate = numSearchMsgs;  eventsRate = numEvents;
	.debug	# 3719
	ld	hl,(_numSearchMsgs)
	ld	(_searchMsgRate),hl
	ld	hl,(_numEvents)
	ld	(_eventsRate),hl
;3720       writesRate = numWrites;  psubRate = numPSub;
	.debug	# 3720
	ld	hl,(_numWrites)
	ld	(_writesRate),hl
	ld	hl,(_numPSub)
	ld	(_psubRate),hl
;3721       numUDPPkts = numProcPkts = numSearchMsgs = numEvents = numWrites =
;3722          numPSub = 0;
	.debug	# 3722
	bool	hl
	ld	l,h
	ld	(_numPSub),hl
	ld	(_numWrites),hl
	ld	(_numEvents),hl
	ld	(_numSearchMsgs),hl
	ld	(_numProcPkts),hl
	ld	(_numUDPPkts),hl
;3723       lastSampleTime = GetMS_();
	.debug	# 3723
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-16),hl
;3724     }
@761:
	.debug	>
;3725 
;3726 
;3727   //--- Check for a pending Terminate signal.  If we get a new one, ---
;3728   //--- then close all our connections and exit ---
;3729     if (sigpending(&sigSet) == 0)  if (sigismember(&sigSet, SIGTERM))  {
@759:
	.debug	# 3729
	ld	hl,-24+@738
	add	hl,sp
	push	hl
	lcall	$sigpending
	pop	de
	bool	hl
	jp	nz,@762
	ld	l,0xf
	push	hl
	ld	hl,-22+@738
	add	hl,sp
	push	hl
	lcall	$sigismember
	add	sp,4
	bool	hl
	jp	z,@763
;3730       printf("=== CA TCP server shutting down ===\n");
@764:
	.debug	< @764 @765
	.debug	# 3730
	ld	de,word (phys @1+2057)
	ld	c,phys @1+2057 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3731     //--- close all connections ----
;3732       if (tcpfd >= 0)  { close(tcpfd);  tcpfd = -1; }
	.debug	# 3732
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@766
@767:
	.debug	< @767 @768
	ld	hl,(ix-2)
	push	hl
	lcall	$close
	pop	de
	ld	hl,0xffff
	ld	(ix-2),hl
@768:
	.debug	>
;3733       for (u=0; u<CA_MAX_CONS; ++u)  {
@766:
@769:
	.debug	< @769 @770
	.debug	# 3733
	bool	hl
	ld	l,h
	ld	(ix-6),hl
@771:
	ld	hl,(ix-6)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@772
;3734         con = caCons + u;
@774:
	.debug	< @774 @775
	.debug	# 3734
	ld	hl,(ix-6)
	ex	de,hl
	ld	b,h
	ld	c,h
	push	bc
	push	de
	ld	de,0x345
	call	__ulmlt##
	push	bc
	push	de
	ld	de,word (phys _caCons)
	ld	c,phys _caCons >> 16
	call	__ladd##
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
;3735         if (con->fd < 0)  continue;
	.debug	# 3735
	call	__farld2##
	ld	hl,0x8000
	ex	de,hl
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@773
;3736         close(con->fd);  con->fd = -1;
	.debug	# 3736
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__farld2##
	push	de
	ex	de,hl
	lcall	$close
	pop	de
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	ld	hl,0xffff
	call	__farst2##
;3737       }
@775:
	.debug	>
;3738       zeroCounts();
@773:
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	jr	@771
@772:
@770:
	.debug	>
	.debug	# 3738
	lcall	$zeroCounts
;3739     //--- wait for just a bit to help insure connections close gracefully -
;3740       sleepMS(CAS_STOP_WAIT_TIME);  ca_tcp_pid = 0;  Exit(0);
	.debug	# 3740
	ld	de,0x9c4
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
	bool	hl
	ld	l,h
	ld	(_ca_tcp_pid),hl
	push	hl
	lcall	$Exit
	pop	hl
;3741     }
@765:
	.debug	>
;3742 
;3743 
;3744   //--- update our copy of the hostname occasionally ---
;3745     if (! (++loopCount & 0xff))  {
@763:
@762:
	.debug	# 3745
	ld	hl,(ix-18)
	inc	hl
	ld	(ix-18),hl
	ld	h,0
	bool	hl
	jr	nz,@777
;3746       gethostname(servName, sizeof(servName));
@778:
	.debug	< @778 @779
	.debug	# 3746
	ld	l,0x20
	push	hl
	ld	hl,_servName
	push	hl
	lcall	$gethostname
	add	sp,4
;3747       servNameLen = strlen(servName);
	.debug	# 3747
	ld	hl,_servName
	push	hl
	call	_strlen
	pop	de
	ld	(_servNameLen),hl
;3748     }
@779:
	.debug	>
;3749 
;3750 
;3751   //--- Check for commands rcvd on the Virtual Circuits ---
;3752     if ((stat = CA_ProcessTCPCmds()) >= 0)  numCons = stat;
@777:
	.debug	# 3752
	lcall	$CA_ProcessTCPCmds
	ld	(ix-4),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@780
	ld	hl,(ix-4)
	ld	(ix-8),hl
;3753 
;3754 //    if (consecutivePkts > 1)  printf("=== %u ===\n", consecutivePkts);  /
;3755 
;3756   //--- Check for new Virtual Circuit requests ---
;3757     if (tcpfd >= 0)
@780:
	.debug	# 3757
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@781
;3758       if (CA_CheckNewConnections(tcpfd) < 0)  { close(tcpfd);  tcpfd = -1; 
	.debug	# 3758
	ld	hl,(ix-2)
	push	hl
	lcall	$CA_CheckNewConnections
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@782
@783:
	.debug	< @783 @784
	ld	hl,(ix-2)
	push	hl
	lcall	$close
	pop	de
	ld	hl,0xffff
	ld	(ix-2),hl
@784:
	.debug	>
;3759 
;3760 
;3761   //--- Check for events that apply to one or more Subscriptions and send -
;3762   //--- msgs as needed on the corresponding Virtual Circuits ---
;3763     if (numCons)  if (msSince_(lastTestedEvents) >= eventPeriod)  {
@782:
@781:
	.debug	# 3763
	ld	hl,(ix-8)
	bool	hl
	jr	z,@785
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	hl,(ix-14)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	de,(_eventPeriod)
	or	a,a
	sbc	hl,de
	jr	c,@786
;3764       lastTestedEvents = GetMS_();  CA_ProcessSubscriptions(); }
@787:
	.debug	< @787 @788
	.debug	# 3764
	ld	hl,(__TimerMilliSeconds+4)
	ld	(ix-14),hl
	lcall	$CA_ProcessSubscriptions
@788:
	.debug	>
;3765 
;3766 
;3767   //--- Close or (re)open the TCP listening socket as needed ---
;3768     if (numCons >= CA_MAX_CONS)  {
@786:
@785:
	.debug	# 3768
	ld	hl,(ix-8)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	c,@789
;3769       if (tcpfd >= 0)  { close(tcpfd);  tcpfd = -1; }  }
@790:
	.debug	< @790 @791
	.debug	# 3769
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@795
@793:
	.debug	< @793 @794
	ld	hl,(ix-2)
	push	hl
	lcall	$close
	pop	de
	ld	hl,0xffff
	ld	(ix-2),hl
@794:
	.debug	>
@791:
	.debug	>
;3770     else
;3771       if (tcpfd < 0)  tcpfd = CA_CreateTCPListener();
	jr	@795
@789:
	.debug	# 3771
	ld	hl,(ix-2)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@796
	lcall	$CA_CreateTCPListener
	ld	(ix-2),hl
;3772 
;3773 
;3774   //--- In case we don't have any Virtual Circuits to do a blocked read on,
;3775   //--- or there is a problem that would otherwise let this loop use all --
;3776   //--- non-idle CPU cycles, we put a limit on how often this loop can run 
;3777     if (numCons)  {
@796:
@795:
	.debug	# 3777
	ld	hl,(ix-8)
	bool	hl
	jr	z,@797
;3778       loopTime = msSince_(startLoopTime);
@798:
	.debug	< @798 @799
	.debug	# 3778
	ld	hl,(__TimerMilliSeconds+4)
	ex	de,hl
	ld	hl,(ix-12)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-10),hl
;3779       sleepTime = (loopTime < MIN_LOOP_TIME ? MIN_LOOP_TIME - loopTime : 5)
	.debug	# 3779
	ld	de,0x32
	or	a,a
	sbc	hl,de
	jr	nc,@800
	ld	hl,(ix-10)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	@801
@800:
	ld	hl,0x5
@801:
	ld	(ix-20),hl
;3780     }
@799:
	.debug	>
;3781     else
;3782       sleepTime = 50;
	jr	@802
@797:
	.debug	# 3782
	ld	hl,0x32
	ld	(ix-20),hl
;3783     sleepMS(sleepTime);
@802:
	.debug	# 3783
	ld	hl,(ix-20)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3784   }
@758:
	.debug	>
;3785 
;3786 }
	jp	@754
@753:
	.debug	>
@739:
	.debug	} @739 3786

@738	equ	28
	ld	sp,ix
	pop	ix
	lret
@740	equ	30
;3787 
;3788 
;3789 
;3790 //-------------------------------------------------------------------------
;3791 //  Show some basic statistics for the CA server
;3792 //-------------------------------------------------------------------------
;3793 void CA_showStats(void)
;3794 {
$CA_showStats::
	.debug	G $CA_showStats 78 9
	.debug	{ $CA_showStats 78 3793 @805 @804
;3795   printf("\r\n"
;3796          "Counts for the previous second:\r\n"
;3797          "\r\n"
;3798          "  UDP pkts    Search Msgs    Events   ProcSub    Writes \r\n"
;3799         //  ###/###         ###         ###       ###       ###
;3800          );
	.debug	# 3795
	ld	de,word (phys @1+2094)
	ld	c,phys @1+2094 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3801 
;3802 
;3803   for (;;)  {
@806:
	.debug	< @806 @807
@808:
;3804     printf("  %3u/%3u         %3u         %3u       %3u       %3u \r\n",
@811:
	.debug	< @811 @812
;3805            procPktRate, udpPktRate, searchMsgRate, eventsRate, psubRate,
;3806            writesRate);
	.debug	# 3806
	ld	hl,(_writesRate)
	push	hl
	ld	hl,(_psubRate)
	push	hl
	ld	hl,(_eventsRate)
	push	hl
	ld	hl,(_searchMsgRate)
	push	hl
	ld	hl,(_udpPktRate)
	push	hl
	ld	hl,(_procPktRate)
	push	hl
	ld	de,word (phys @1+2190)
	ld	c,phys @1+2190 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,16
;3807     fflush(stdout);
	.debug	# 3807
	ld	hl,(__stdio)
	push	hl
	lcall	$fflush
	pop	de
;3808 
;3809     CheckETX();  sleepMS(990);
	.debug	# 3809
	lcall	$CheckETX
	ld	de,0x3de
	ld	bc,0
	push	bc
	push	de
	lcall	$sleepMS
	add	sp,4
;3810   }
@812:
	.debug	>
;3811 
;3812 }
	jr	@808
@807:
	.debug	>
@804:
	.debug	} @804 3812

@803	equ	0
	lret
@805	equ	0
;3813 
;3814 
;3815 //-------------------------------------------------------------------------
;3816 //  Show the state of the CA server
;3817 //
;3818 //               Circuits   Channels  Subscriptions
;3819 //               --------   --------  -------------
;3820 //  levels:  0:    count      count       count        <not implemented yet
;3821 //           1:    list       count       count
;3822 //           2:    list       list        count        <not implemented yet
;3823 //           3:    list       list        list
;3824 //-------------------------------------------------------------------------
;3825 void CA_showStatus(int level)
;3826 {
$CA_showStatus::
	.debug	G $CA_showStatus 81 9
	.debug	{ $CA_showStatus 81 3825 @815 @814
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-77
	.debug	A level 5 6
;3827   uint  u, w, baseType, extType, port, chanCount, subCount;
	.debug	L u -2 7
	.debug	L w -4 7
	.debug	L baseType -6 7
	.debug	L extType -8 7
	.debug	L port -10 7
	.debug	L chanCount -12 7
	.debug	L subCount -14 7
;3828   SID  sid;
	.debug	L sid -16 7
;3829   div_t  qr;
	.debug	L qr -20 73
;3830   ulong  in_Addr;
	.debug	L in_Addr -24 9
;3831   CA_Con far  *con;
	.debug	L con -28 71
;3832   PVID far  *chan;
	.debug	L chan -32 69
;3833   CA_Sub far  *sub;
	.debug	L sub -36 74
;3834   char  temp[24];
	.debug	L temp -60 77
;3835   PV_Info  pvInfo;
	.debug	L pvInfo -73 70
;3836 
;3837 
;3838 
;3839   for (u=0,con=caCons; u<CA_MAX_CONS; ++u,++con)  {
@816:
	.debug	< @816 @817
	.debug	# 3839
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	de,word (phys _caCons)
	ld	c,phys _caCons >> 16
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
@818:
	ld	hl,(ix-2)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jp	nc,@819
;3840     if (con->fd < 0)  continue;
@821:
	.debug	< @821 @822
	.debug	# 3840
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__farld2##
	ld	hl,0x8000
	ex	de,hl
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@820
;3841 
;3842     in_Addr = con->in_Addr.SIN_ADDR;  // IPv4 addr in network byte order
	.debug	# 3842
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x337
	ld	bc,0
	call	__ladd##
	push	bc
	push	de
	ld	de,0x4
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	ld	(ix-22),hl
	ex	de,hl
	ld	(ix-24),hl
	ex	de,hl
;3843     port = ntohs(con->in_Addr.sin_port);
	.debug	# 3843
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x337
	ld	bc,0
	call	__ladd##
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	a,l
	ld	l,h
	ld	h,a
	ld	(ix-10),hl
;3844 
;3845     printf("\r\n"
;3846            "  ===== Virtual Circuit: %d =====\r\n"
;3847            "    fd: %d   IP: %s:%u\r\n"
;3848            "    Host: [%ls]   User: [%ls]\r\n",
;3849            u, con->fd,
;3850            inet_ntop(AF_INET, &in_Addr, temp, sizeof(temp)), port,
;3851            con->hostName, con->userName );
	.debug	# 3851
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x31f
	ld	bc,0
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x307
	ld	bc,0
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-10)
	push	hl
	ld	hl,0x18
	push	hl
	ld	hl,-48+@813
	add	hl,sp
	push	hl
	ld	hl,-10+@813
	add	hl,sp
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ntop
	add	sp,8
	push	hl
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	call	__farld2##
	push	de
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @1+2247)
	ld	c,phys @1+2247 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,20
;3852 
;3853     if (level > 1)  printf(
	.debug	# 3853
	ld	hl,(ix+5)
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@824
	jr	z,@824
;3854            "    ----- Channels -----\r\n");
	.debug	# 3854
	ld	de,word (phys @1+2340)
	ld	c,phys @1+2340 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3855 
;3856 //    printf("    maxChanNum:%u   maxSubNum:%u\r\n\n",  //tdebug
;3857 //           con->maxChanNum, con->maxSubNum );
;3858 
;3859     chanCount = subCount = 0;
@824:
	.debug	# 3859
	bool	hl
	ld	l,h
	ld	(ix-14),hl
	ld	(ix-12),hl
;3860 
;3861     for (sid=0,chan=con->chans; sid<con->maxChanNum; ++sid,++chan)  {
@825:
	.debug	< @825 @826
	.debug	# 3861
	ld	(ix-16),hl
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x3
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-30),hl
	ex	de,hl
	ld	(ix-32),hl
	ex	de,hl
@827:
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x83
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-16)
	or	a,a
	sbc	hl,de
	jp	nc,@828
;3862       if (*chan == CHAN_UNUSED)  continue;
@830:
	.debug	< @830 @831
	.debug	# 3862
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	call	__farld2##
	ld	hl,0xffff
	or	a,a
	sbc	hl,de
	jp	z,@829
;3863 
;3864       if (level >= 2)  {
	.debug	# 3864
	ld	hl,(ix+5)
	ld	de,0x8002
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@833
;3865         if (pvGetInfo(*chan, &pvInfo))  pvInfo.name = "<invalid>";
@834:
	.debug	< @834 @835
	.debug	# 3865
	ld	hl,-73+@813
	add	hl,sp
	push	hl
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	call	__farld2##
	push	de
	ex	de,hl
	lcall	$pvGetInfo
	add	sp,4
	bool	hl
	jr	z,@836
	ld	de,word (phys @1+715)
	ld	c,phys @1+715 >> 16
	ld	hl,bc
	ld	(ix-71),hl
	ex	de,hl
	ld	(ix-73),hl
	ex	de,hl
;3866         printf("    Chan:  SID:0x%04X  pvID:%3d  [%ls]\r\n",
@836:
;3867                sid, *chan, pvInfo.name );
	.debug	# 3867
	ld	hl,(ix-73)
	ex	de,hl
	ld	hl,(ix-71)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	call	__farld2##
	push	de
	ld	hl,(ix-16)
	push	hl
	ld	de,word (phys @1+2367)
	ld	c,phys @1+2367 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;3868       }
@835:
	.debug	>
;3869       ++chanCount;
@833:
	.debug	# 3869
	ld	hl,(ix-12)
	inc	hl
	ld	(ix-12),hl
;3870 
;3871       for (w=0,sub=con->subs; w<con->maxSubNum; ++w,++sub)  {
@837:
	.debug	< @837 @838
	.debug	# 3871
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x85
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-34),hl
	ex	de,hl
	ld	(ix-36),hl
	ex	de,hl
@839:
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x305
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-4)
	or	a,a
	sbc	hl,de
	jp	nc,@840
;3872         if (sub->sid != sid)  continue;
@842:
	.debug	< @842 @843
	.debug	# 3872
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	call	__farld2##
	ld	hl,(ix-16)
	or	a,a
	sbc	hl,de
	jp	nz,@841
;3873 
;3874         if (level >= 3)  {
	.debug	# 3874
	ld	hl,(ix+5)
	ld	de,0x8003
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jp	c,@845
;3875           qr = div(sub->dbrType, 7);  baseType = qr.rem;  extType = qr.quot
@846:
	.debug	< @846 @847
	.debug	# 3875
	ld	hl,0x7
	push	hl
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x7
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	hl,-73+@813
	add	hl,sp
	push	hl
	call	_div
	add	sp,6
	ex	de,hl
	ld	hl,-20+@813
	add	hl,sp
	ex	de,hl
	push	hl
	ld	bc,4
	ldir
	pop	hl
	ld	hl,(ix-18)
	ld	(ix-6),hl
	ld	hl,(ix-20)
	ld	(ix-8),hl
;3876           printf("         subID:0x%08lX  mask:%2u  dbrType:DBR_%ls_%ls  #e
;3877                  sub->subID, sub->monMask,
;3878                  baseTypeName[baseType], extTypeName[extType],
;3879                  sub->numElems );
	.debug	# 3879
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x8
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	push	de
	ld	hl,(ix-8)
	add	hl,hl
	add	hl,hl
	ld	de,_extTypeName
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-6)
	add	hl,hl
	add	hl,hl
	ld	de,_baseTypeName
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	push	hl
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,word (phys @1+2408)
	ld	c,phys @1+2408 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,20
;3880         }
@847:
	.debug	>
;3881         ++subCount;
@845:
	.debug	# 3881
	ld	hl,(ix-14)
	inc	hl
	ld	(ix-14),hl
;3882       }
@843:
	.debug	>
;3883 
;3884       if (level >= 2)  printf("\n");
@841:
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	ld	hl,(ix-36)
	ex	de,hl
	ld	hl,(ix-34)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0xa
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-34),hl
	ex	de,hl
	ld	(ix-36),hl
	ex	de,hl
	jp	@839
@840:
@838:
	.debug	>
	.debug	# 3884
	ld	hl,(ix+5)
	ld	de,0x8002
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@848
	ld	de,word (phys @1+98)
	ld	c,phys @1+98 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3885     }
@848:
@831:
	.debug	>
;3886 
;3887     if (level == 1)
@829:
	ld	hl,(ix-16)
	inc	hl
	ld	(ix-16),hl
	ld	hl,(ix-32)
	ex	de,hl
	ld	hl,(ix-30)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-30),hl
	ex	de,hl
	ld	(ix-32),hl
	ex	de,hl
	jp	@827
@828:
@826:
	.debug	>
	.debug	# 3887
	ld	hl,(ix+5)
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@849
;3888       printf("    %u Channels, %u Subscriptions\r\n", chanCount, subCount);
	.debug	# 3888
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix-12)
	push	hl
	ld	de,word (phys @1+2475)
	ld	c,phys @1+2475 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3889   }
@849:
@822:
	.debug	>
;3890 
;3891   Exit(0);
@820:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-28)
	ex	de,hl
	ld	hl,(ix-26)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x345
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-26),hl
	ex	de,hl
	ld	(ix-28),hl
	ex	de,hl
	jp	@818
@819:
@817:
	.debug	>
	.debug	# 3891
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;3892 }
@814:
	.debug	} @814 3892

@813	equ	77
	ld	sp,ix
	pop	ix
	lret
@815	equ	79
;3893 
;3894 
;3895 //-------------------------------------------------------------------------
;3896 //  Show a list of the client address for which we will process UDP packets
;3897 //-------------------------------------------------------------------------
;3898 void showAllowedList(void)
;3899 {
$showAllowedList::
	.debug	G $showAllowedList 78 9
	.debug	{ $showAllowedList 78 3898 @852 @851
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-24
;3900   uint  u;
	.debug	L u -2 7
;3901   ulong  *pAddr;
	.debug	L pAddr -4 82
;3902   char  temp[20];
	.debug	L temp -24 83
;3903 
;3904 
;3905   printf("\r\n  Allowed SEARCH clients:\r\n");
	.debug	# 3905
	ld	de,word (phys @1+2511)
	ld	c,phys @1+2511 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3906 
;3907   for (u=0,pAddr=allowedClients; *pAddr AND u<CA_MAX_CONS; ++u,++pAddr)  {
@853:
	.debug	< @853 @854
	.debug	# 3907
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,_allowedClients
	ld	(ix-4),hl
@855:
	ld	hl,(ix-4)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jr	z,@857
	ld	hl,(ix-2)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@857
;3908     if (!inet_ntop(AF_INET, pAddr, temp, sizeof(allowedClients[0])))
@860:
	.debug	< @860 @861
	.debug	# 3908
	ld	h,d
	ld	l,e
	push	hl
	ld	hl,-22+@850
	add	hl,sp
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_ntop
	add	sp,8
	bool	hl
	jr	nz,@862
;3909       printf("    ?.?.?.?\r\n");
	.debug	# 3909
	ld	de,word (phys @1+2541)
	ld	c,phys @1+2541 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3910     else
;3911       printf("    %s\r\n", temp);
	jr	@863
@862:
	.debug	# 3911
	ld	hl,-24+@850
	add	hl,sp
	push	hl
	ld	de,word (phys @1+2555)
	ld	c,phys @1+2555 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3912   }
@863:
@861:
	.debug	>
;3913 
;3914   printf("\r\n");
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-4)
	ld	de,0x4
	add	hl,de
	ld	(ix-4),hl
	jr	@855
@857:
@854:
	.debug	>
	.debug	# 3914
	ld	de,word (phys @1+698)
	ld	c,phys @1+698 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3915 }
@851:
	.debug	} @851 3915

@850	equ	24
	ld	sp,ix
	pop	ix
	lret
@852	equ	26
;3916 
;3917 //-------------------------------------------------------------------------
;3918 //  Command to manage the DEBROS EPICS Channel Access (CA) protocol service
;3919 //-------------------------------------------------------------------------
;3920 void _task cas(int argc, char **argv)
;3921 {
	.align	4
$$cas::
	ex	(sp),iy
$cas::
	.debug	G $cas 79 9
	.debug	{ $cas 79 3920 @866 @865
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-16
	.debug	A argc 5 6
	.debug	A argv 7 80
;3922   uint  u, v;
	.debug	L u -2 7
	.debug	L v -4 7
;3923   ulong  *pAddr;
	.debug	L pAddr -6 82
;3924   ulong  ipAddr;
	.debug	L ipAddr -10 9
;3925   char  *argv_[3];
	.debug	L argv_ -16 42
;3926 
;3927 
;3928   if (showHelp(2, argc, argv))  {
	.debug	# 3928
	ld	hl,(ix+7)
	push	hl
	ld	hl,(ix+5)
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$showHelp
	add	sp,6
	or	a,a
	jr	z,@867
;3929     printf("\nusage: cas start|stop|chans|stats|summary\r\n"
@868:
	.debug	< @868 @869
;3930              "           clist\r\n"
;3931              "           add <client_addr>\r\n"
;3932              "           del <client_addr>|all\r\n"
;3933              "           queries respond|ignore\r\n"
;3934              "           events anychg|threshold|periodic|<period in ms>\r\
;3935           );
	.debug	# 3929
	ld	de,word (phys @1+2564)
	ld	c,phys @1+2564 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3936     Exit(-1);
	.debug	# 3936
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;3937   }
@869:
	.debug	>
;3938 
;3939 
;3940 //--- see if any previous instances died ---
;3941   if (ca_tcp_pid AND (_activeTaskIdx_(ca_tcp_pid) < 0))  ca_tcp_pid = 0;
@867:
	.debug	# 3941
	ld	hl,(_ca_tcp_pid)
	bool	hl
	jr	z,@871
	ld	hl,(_ca_tcp_pid)
	push	hl
	lcall	$_activeTaskIdx_
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@871
	bool	hl
	ld	l,h
	ld	(_ca_tcp_pid),hl
;3942   if (ca_udp_pid AND (_activeTaskIdx_(ca_udp_pid) < 0))  ca_udp_pid = 0;
@871:
	.debug	# 3942
	ld	hl,(_ca_udp_pid)
	bool	hl
	jr	z,@873
	ld	hl,(_ca_udp_pid)
	push	hl
	lcall	$_activeTaskIdx_
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@873
	bool	hl
	ld	l,h
	ld	(_ca_udp_pid),hl
;3943 
;3944 
;3945 
;3946 //=== show a summary of the state of the CA service ===
;3947   if (fstrcmp(argv[1], "summary") == 0)  {
@873:
	.debug	# 3947
	ld	de,word (phys @1+2786)
	ld	c,phys @1+2786 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jp	nz,@874
;3948 
;3949     printf("\r\n");
@875:
	.debug	< @875 @876
	.debug	# 3949
	ld	de,word (phys @1+698)
	ld	c,phys @1+698 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;3950 
;3951     if (!ca_tcp_pid)
	.debug	# 3951
	ld	hl,(_ca_tcp_pid)
	bool	hl
	jr	nz,@877
;3952       printf("  CA %s service not running\r\n", "TCP");
	.debug	# 3952
	ld	hl,@2+97
	push	hl
	ld	de,word (phys @1+2794)
	ld	c,phys @1+2794 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3953     else  {
	jp	@878
@877:
;3954       printf("  CA %s service pid: %d\r\n", "TCP", ca_tcp_pid);
@879:
	.debug	< @879 @880
	.debug	# 3954
	ld	hl,(_ca_tcp_pid)
	push	hl
	ld	hl,@2+97
	push	hl
	ld	de,word (phys @1+2824)
	ld	c,phys @1+2824 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3955 
;3956       if (!ca_udp_pid)
	.debug	# 3956
	ld	hl,(_ca_udp_pid)
	bool	hl
	jr	nz,@881
;3957         printf("  CA %s service not running\r\n\n", "UDP");
	.debug	# 3957
	ld	hl,@2+93
	push	hl
	ld	de,word (phys @1+2850)
	ld	c,phys @1+2850 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3958       else  {
	jr	@882
@881:
;3959         printf("  CA %s service pid: %d\r\n", "UDP", ca_udp_pid);
@883:
	.debug	< @883 @884
	.debug	# 3959
	ld	hl,(_ca_udp_pid)
	push	hl
	ld	hl,@2+93
	push	hl
	ld	de,word (phys @1+2824)
	ld	c,phys @1+2824 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3960 
;3961         showAllowedList();
	.debug	# 3961
	lcall	$showAllowedList
;3962 
;3963         printf("  %s SEARCH requests\r\n",
;3964                processUDP ? "responding to" : "ignoring" );
	.debug	# 3964
	ld	a,(_processUDP)
	or	a,a
	jr	z,@885
	ld	hl,@2+101
	jr	@886
@885:
	ld	hl,@2+115
@886:
	push	hl
	ld	de,word (phys @1+2881)
	ld	c,phys @1+2881 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;3965       }
@884:
	.debug	>
;3966 
;3967       printf("  Event monitors: %s every %u ms\r\n",
@882:
;3968              chgModeDesc[valChgMode], eventPeriod);
	.debug	# 3968
	ld	hl,(_eventPeriod)
	push	hl
	ld	hl,(_valChgMode)
	add	hl,hl
	ld	de,_chgModeDesc
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	de,word (phys @1+2904)
	ld	c,phys @1+2904 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3969 
;3970       CA_showStatus(1);
	.debug	# 3970
	ld	hl,0x1
	push	hl
	lcall	$CA_showStatus
	pop	hl
;3971     }
@880:
	.debug	>
;3972 
;3973     Exit(0);
@878:
	.debug	# 3973
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;3974   }
@876:
	.debug	>
;3975 
;3976 
;3977 //===== start the CA server =====
;3978   if (fstrcmp(argv[1], "start") == 0)  {
@874:
	.debug	# 3978
	ld	de,word (phys @1+2939)
	ld	c,phys @1+2939 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jp	nz,@888
;3979     if (ca_tcp_pid)
@889:
	.debug	< @889 @890
	.debug	# 3979
	ld	hl,(_ca_tcp_pid)
	bool	hl
	jr	z,@891
;3980       printf("\r\n  CA %s service already running: pid: %d\r\n",
;3981              "TCP", ca_tcp_pid);
	.debug	# 3981
	ld	hl,(_ca_tcp_pid)
	push	hl
	ld	hl,@2+97
	push	hl
	ld	de,word (phys @1+1845)
	ld	c,phys @1+1845 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3982     else  {
	jr	@892
@891:
;3983       argv_[0] = "ca_tcpd";  argv_[1] = NULL;
@893:
	.debug	< @893 @894
	.debug	# 3983
	ld	hl,@2+124
	ld	(ix-16),hl
	bool	hl
	ld	l,h
	ld	(ix-14),hl
;3984       createProc(ca_tcpd, CA_TCPD_PRIORITY, 1, argv_, 0, 1, 2);
	.debug	# 3984
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-10+@864
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0xb
	push	hl
	ld	hl,_ca_tcpd
	push	hl
	lcall	$createProc
	add	sp,14
;3985     }
@894:
	.debug	>
;3986     if (ca_udp_pid)
@892:
	.debug	# 3986
	ld	hl,(_ca_udp_pid)
	bool	hl
	jr	z,@895
;3987       printf("\r\n  CA %s service already running: pid: %d\r\n",
;3988              "UDP", ca_udp_pid);
	.debug	# 3988
	ld	hl,(_ca_udp_pid)
	push	hl
	ld	hl,@2+93
	push	hl
	ld	de,word (phys @1+1845)
	ld	c,phys @1+1845 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;3989     else  {
	jr	@896
@895:
;3990       argv_[0] = "ca_udpd";  argv_[1] = NULL;
@897:
	.debug	< @897 @898
	.debug	# 3990
	ld	hl,@2+132
	ld	(ix-16),hl
	bool	hl
	ld	l,h
	ld	(ix-14),hl
;3991       createProc(ca_udpd, CA_UDPD_PRIORITY, 1, argv_, 0, 1, 2);
	.debug	# 3991
	ld	l,0x2
	push	hl
	dec	l
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-10+@864
	add	hl,sp
	push	hl
	ld	hl,0x1
	push	hl
	ld	l,0xc
	push	hl
	ld	hl,_ca_udpd
	push	hl
	lcall	$createProc
	add	sp,14
;3992     }
@898:
	.debug	>
;3993     Exit(0);
@896:
	.debug	# 3993
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;3994   }
@890:
	.debug	>
;3995 
;3996 
;3997 //===== stop the CA server =====
;3998   if (fstrcmp(argv[1], "stop") == 0)  {
@888:
	.debug	# 3998
	ld	de,word (phys @1+2945)
	ld	c,phys @1+2945 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@899
;3999     if (!ca_tcp_pid AND !ca_udp_pid)  {
@900:
	.debug	< @900 @901
	.debug	# 3999
	ld	hl,(_ca_tcp_pid)
	bool	hl
	jr	nz,@903
	ld	hl,(_ca_udp_pid)
	bool	hl
	jr	nz,@903
;4000       printf("\r\n  services are not running.\r\n");  Exit(-1); }
@904:
	.debug	< @904 @905
	.debug	# 4000
	ld	de,word (phys @1+2950)
	ld	c,phys @1+2950 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@905:
	.debug	>
;4001     printf("Terminating CA server(s)\r\n");
@903:
	.debug	# 4001
	ld	de,word (phys @1+2982)
	ld	c,phys @1+2982 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;4002     if (ca_udp_pid)  kill(ca_udp_pid, SIGTERM);
	.debug	# 4002
	ld	hl,(_ca_udp_pid)
	bool	hl
	jr	z,@906
	ld	l,0xf
	push	hl
	ld	hl,(_ca_udp_pid)
	push	hl
	lcall	$kill
	add	sp,4
;4003     if (ca_tcp_pid)  kill(ca_tcp_pid, SIGTERM);
@906:
	.debug	# 4003
	ld	hl,(_ca_tcp_pid)
	bool	hl
	jr	z,@907
	ld	l,0xf
	push	hl
	ld	hl,(_ca_tcp_pid)
	push	hl
	lcall	$kill
	add	sp,4
;4004     Exit(0);
@907:
	.debug	# 4004
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;4005   }
@901:
	.debug	>
;4006 
;4007 
;4008 //===== show the state of the CA server =====
;4009   if (fstrcmp(argv[1], "chans") == 0)  {
@899:
	.debug	# 4009
	ld	de,word (phys @1+3009)
	ld	c,phys @1+3009 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@908
;4010     if (!ca_tcp_pid)  {
@909:
	.debug	< @909 @910
	.debug	# 4010
	ld	hl,(_ca_tcp_pid)
	bool	hl
	jr	nz,@911
;4011       printf("\r\n  service is not running.\r\n");  Exit(-1); }
@912:
	.debug	< @912 @913
	.debug	# 4011
	ld	de,word (phys @1+3015)
	ld	c,phys @1+3015 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@913:
	.debug	>
;4012     CA_showStatus(3);  Exit(0);
@911:
	.debug	# 4012
	ld	hl,0x3
	push	hl
	lcall	$CA_showStatus
	pop	hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;4013   }
@910:
	.debug	>
;4014 
;4015 
;4016 //===== show stats for CA server =====
;4017   if (fstrcmp(argv[1], "stats") == 0)  {
@908:
	.debug	# 4017
	ld	de,word (phys @1+3045)
	ld	c,phys @1+3045 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@914
;4018     if (!ca_tcp_pid)  {
@915:
	.debug	< @915 @916
	.debug	# 4018
	ld	hl,(_ca_tcp_pid)
	bool	hl
	jr	nz,@917
;4019       printf("\r\n  service is not running.\r\n");  Exit(-1); }
@918:
	.debug	< @918 @919
	.debug	# 4019
	ld	de,word (phys @1+3015)
	ld	c,phys @1+3015 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@919:
	.debug	>
;4020     CA_showStats();  Exit(0);
@917:
	.debug	# 4020
	lcall	$CA_showStats
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;4021   }
@916:
	.debug	>
;4022 
;4023 
;4024 //===== show the current list of allowed client addresses =====
;4025   if (fstrcmp(argv[1], "clist") == 0)  {  showAllowedList();  Exit(0);  }
@914:
	.debug	# 4025
	ld	de,word (phys @1+3051)
	ld	c,phys @1+3051 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@920
@921:
	.debug	< @921 @922
	lcall	$showAllowedList
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@922:
	.debug	>
;4026 
;4027 
;4028   if (argc < 3)  { printf("Invalid or incomplete cmd\r\n");  Exit(-1); }
@920:
	.debug	# 4028
	ld	hl,(ix+5)
	ld	de,0x8003
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@923
@924:
	.debug	< @924 @925
	ld	de,word (phys @1+3057)
	ld	c,phys @1+3057 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@925:
	.debug	>
;4029 
;4030 
;4031 
;4032 //===== add an addr to the list of allowed client addresses =====
;4033   if (fstrcmp(argv[1], "add") == 0)  {
@923:
	.debug	# 4033
	ld	de,word (phys @1+3085)
	ld	c,phys @1+3085 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jp	nz,@926
;4034     inet_pton(AF_INET, argv[2], &ipAddr);
@927:
	.debug	< @927 @928
	.debug	# 4034
	ld	hl,-10+@864
	add	hl,sp
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_pton
	add	sp,6
;4035     if (!ipAddr)  { printf("Invalid address\r\n");  Exit(-1); }
	.debug	# 4035
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	or	hl,de
	jr	nz,@929
@930:
	.debug	< @930 @931
	ld	de,word (phys @1+3089)
	ld	c,phys @1+3089 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@931:
	.debug	>
;4036 
;4037     KLOCK();
@929:
	.debug	# 4037
	call	_KLOCK
;4038     for (u=0,pAddr=allowedClients; u<CA_MAX_CONS; ++u,++pAddr)
@932:
	.debug	< @932 @933
	.debug	# 4038
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,_allowedClients
	ld	(ix-6),hl
@934:
	ld	hl,(ix-2)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@935
;4039       if (!*pAddr)  { *pAddr = ipAddr;  KUNLOCK();  Exit(0); }
	.debug	# 4039
	ld	hl,(ix-6)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jr	nz,@937
@938:
	.debug	< @938 @939
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-6)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	call	_KUNLOCK
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@939:
	.debug	>
;4040 
;4041     KUNLOCK();
@937:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	(ix-6),hl
	jr	@934
@935:
@933:
	.debug	>
	.debug	# 4041
	call	_KUNLOCK
;4042     printf("Max # of allowed clients already set\r\n");  Exit(-1);
	.debug	# 4042
	ld	de,word (phys @1+3107)
	ld	c,phys @1+3107 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;4043   }
@928:
	.debug	>
;4044 
;4045 
;4046 //===== remove an addr from the list of allowed client addresses =====
;4047   if (fstrcmp(argv[1], "del") == 0)  {
@926:
	.debug	# 4047
	ld	de,word (phys @1+3146)
	ld	c,phys @1+3146 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jp	nz,@940
;4048     if (fstrcmp(argv[2], "all") == 0)  { BZERO(allowedClients);  Exit(0); }
@941:
	.debug	< @941 @942
	.debug	# 4048
	ld	de,word (phys @1+3150)
	ld	c,phys @1+3150 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@943
@944:
	.debug	< @944 @945
	ld	l,0x10
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_allowedClients
	push	hl
	call	_memset
	add	sp,6
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@945:
	.debug	>
;4049 
;4050     inet_pton(AF_INET, argv[2], &ipAddr);
@943:
	.debug	# 4050
	ld	hl,-10+@864
	add	hl,sp
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,0x2
	push	hl
	lcall	$inet_pton
	add	sp,6
;4051     if (!ipAddr)  { printf("Invalid address\r\n");  Exit(-1); }
	.debug	# 4051
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	or	hl,de
	jr	nz,@946
@947:
	.debug	< @947 @948
	ld	de,word (phys @1+3089)
	ld	c,phys @1+3089 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
@948:
	.debug	>
;4052 
;4053     // if found, slide the rest of the list down one and zero the last entr
;4054     KLOCK();
@946:
	.debug	# 4054
	call	_KLOCK
;4055     for (u=0,pAddr=allowedClients; *pAddr AND u<CA_MAX_CONS; ++u,++pAddr)  
@949:
	.debug	< @949 @950
	.debug	# 4055
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	ld	hl,_allowedClients
	ld	(ix-6),hl
@951:
	ld	hl,(ix-6)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	or	hl,de
	jr	z,@953
	ld	hl,(ix-2)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@953
;4056       if (*pAddr != ipAddr)  continue;
@956:
	.debug	< @956 @957
	.debug	# 4056
	ld	hl,(ix-6)
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	call	__lsub##
	jr	nz,@955
;4057       for (v=u; v<CA_MAX_CONS-1; ++v,++pAddr)  *pAddr = pAddr[1];
@959:
	.debug	< @959 @960
	.debug	# 4057
	ld	hl,(ix-2)
	ld	(ix-4),hl
@961:
	ld	hl,(ix-4)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nc,@962
	ld	hl,(ix-6)
	inc	e
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-6)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;4058       *pAddr = 0;  KUNLOCK();  Exit(0);
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	(ix-6),hl
	jr	@961
@962:
@960:
	.debug	>
	.debug	# 4058
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,(ix-6)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	call	_KUNLOCK
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;4059     }
@957:
	.debug	>
;4060 
;4061     KUNLOCK();  printf("Addr not in list\r\n");  Exit(-1);
@955:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	(ix-6),hl
	jp	@951
@953:
@950:
	.debug	>
	.debug	# 4061
	call	_KUNLOCK
	ld	de,word (phys @1+3154)
	ld	c,phys @1+3154 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;4062   }
@942:
	.debug	>
;4063 
;4064 
;4065 //===== enable/disable UDP bcast pkt processing (used for SEARCH queries) =
;4066   if (fstrcmp(argv[1], "queries") == 0)  {
@940:
	.debug	# 4066
	ld	de,word (phys @1+3173)
	ld	c,phys @1+3173 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@964
;4067     if (fstrcmp(argv[2], "respond") == 0)  { processUDP = true;  Exit(0); }
@965:
	.debug	< @965 @966
	.debug	# 4067
	ld	de,word (phys @1+3181)
	ld	c,phys @1+3181 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@967
@968:
	.debug	< @968 @969
	ld	a,0x1
	ld	(_processUDP),a
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@969:
	.debug	>
;4068     if (fstrcmp(argv[2], "ignore") == 0)  { processUDP = false;  Exit(0); }
@967:
	.debug	# 4068
	ld	de,word (phys @1+3189)
	ld	c,phys @1+3189 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@970
@971:
	.debug	< @971 @972
	xor	a,a
	ld	(_processUDP),a
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@972:
	.debug	>
;4069   }
@970:
@966:
	.debug	>
;4070 
;4071 
;4072 //===== set event processing parameters =====
;4073   if (fstrcmp(argv[1], "events") == 0)  {
@964:
	.debug	# 4073
	ld	de,word (phys @1+3196)
	ld	c,phys @1+3196 >> 16
	push	bc
	push	de
	ld	hl,(ix+7)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jp	nz,@973
;4074     for (u=0; u<3; ++u)
@974:
	.debug	< @974 @975
@976:
	.debug	< @976 @977
	.debug	# 4074
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@978:
	ld	hl,(ix-2)
	ld	de,0x3
	or	a,a
	sbc	hl,de
	jr	nc,@979
;4075       if (StriEq(argv[2], chgModeDesc[u]))  { valChgMode = u;  Exit(0); }
	.debug	# 4075
	ld	hl,(ix-2)
	add	hl,hl
	ld	de,_chgModeDesc
	add	hl,de
	ld	hl,(hl)
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	call	_stricmp
	add	sp,4
	bool	hl
	jr	nz,@981
@982:
	.debug	< @982 @983
	ld	hl,(ix-2)
	ld	(_valChgMode),hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
@983:
	.debug	>
;4076     if (isdigit(*argv[2]))  {
@981:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@978
@979:
@977:
	.debug	>
	.debug	# 4076
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	ld	a,(hl)
	bool	hl
	ld	l,a
	push	hl
	call	_isdigit
	pop	de
	bool	hl
	jr	z,@984
;4077       if ((eventPeriod = ATOI(argv[2])) < MIN_EVENT_PERIOD)
@985:
	.debug	< @985 @986
	.debug	# 4077
	bool	hl
	ld	l,h
	push	hl
	push	hl
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	hl,(hl)
	push	hl
	lcall	$strtoi
	add	sp,6
	ld	(_eventPeriod),hl
	ld	de,0x14
	or	a,a
	sbc	hl,de
	jr	nc,@987
;4078         eventPeriod = MIN_EVENT_PERIOD;
	.debug	# 4078
	ld	h,d
	ld	l,e
	ld	(_eventPeriod),hl
;4079       printf("Event monitor period now %u ms\r\n", eventPeriod);  Exit(0);
@987:
	.debug	# 4079
	ld	hl,(_eventPeriod)
	push	hl
	ld	de,word (phys @1+3203)
	ld	c,phys @1+3203 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	bool	hl
	ld	l,h
	push	hl
	lcall	$Exit
	pop	hl
;4080     }
@986:
	.debug	>
;4081   }
@984:
@975:
	.debug	>
;4082 
;4083 
;4084   printf("\r\nInvalid option\r\n");  Exit(-1);
@973:
	.debug	# 4084
	ld	de,word (phys @1+3236)
	ld	c,phys @1+3236 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,0xffff
	push	hl
	lcall	$Exit
	pop	hl
;4085 }
@865:
	.debug	} @865 4085

@864	equ	16
	ld	sp,ix
	pop	ix
	lret
@866	equ	18
;4086 
;4087 //-------------------------------------------------------------------------
;4088 
	.extern	_memset 84
	.extern	_stricmp 85
	.extern	_strlen 86
	.extern	_strnicmp 87
	.extern	$fmemcpy 88
	.extern	_fmemset 89
	.extern	_fstrcmp 90
	.extern	_fstrcpy 91
	.extern	_fstrlen 92
	.extern	$redirectStdio 76
	.extern	$CheckETX 76
	.extern	$skipBytes 93
	.extern	$read_ 94
	.extern	$sendBCastPkt 95
	.extern	$sigismember 96
	.extern	$sigprocmask 97
	.extern	$sigpending 98
	.extern	_current 99
	.extern	_userPix 6
	.extern	__stdio 101
	.extern	$farprintf 103
	.extern	$farsprintf 104
	.extern	__TimerSeconds 9
	.extern	__TimerMilliSeconds 105
	.extern	_div 106
	.extern	$strtoi 107
	.extern	_fileTbl 108
	.extern	_FD 109
	.extern	$_FileFromFD_ 111
	.extern	$close 66
	.extern	$fcntl 112
	.extern	$fflush 113
	.extern	$ioctl 114
	.extern	_KLOCK 78
	.extern	_KUNLOCK 78
	.extern	$_activeTaskIdx_ 66
	.extern	_milliTicks 7
	.extern	_hdwResetTime 9
	.extern	$createProc 115
	.extern	$sleepMS 116
	.extern	$kill 117
	.extern	$Exit 81
	.extern	$gethostname 118
	.extern	$getIFConfig 119
	.extern	$accept 120
	.extern	$bind 121
	.extern	$listen 117
	.extern	$recvfrom 122
	.extern	$sendto 123
	.extern	$socket 112
	.extern	$setsockopt 124
	.extern	$pvGetID 86
	.extern	$pvGetInfo 125
	.extern	$pvLockVal 112
	.extern	$pvGetVal 126
	.extern	$pvSetVal 127
	.extern	$pvCopyVal 128
	.extern	$pvCheckAllEvents 129
	.extern	$pvCheckEvents 130
	.cseg
_ca_tcpd:
	pop	iy
	lcall	$$ca_tcpd
_ca_udpd:
	pop	iy
	lcall	$$ca_udpd
_cas:
	pop	iy
	lcall	$$cas
	.extern	$inet_ntop 131
	.extern	$inet_pton 132
	.extern	$perror 133
	.extern	$showHelp 134
	.extern	_isdigit 66
	.defseg	FARBSS
	.seg	FARBSS
_caCons::
	.ds	3348
	.debug	G _caCons 135 8
_rcvdPkt::
	.ds	1460
	.debug	G _rcvdPkt 136 8
	.bseg
_rcvdPktSize::
	.ds	2
	.debug	G _rcvdPktSize 7 0
_nextRcvdPktByte::
	.ds	2
	.debug	G _nextRcvdPktByte 7 0
	.seg	FARBSS
_respPktUDP::
	.ds	1460
	.debug	G _respPktUDP 136 8
	.bseg
_respPktUsedUDP::
	.ds	2
	.debug	G _respPktUsedUDP 7 0
_respAddrUDP::
	.ds	14
	.debug	G _respAddrUDP 55 0
	.seg	FARBSS
_respPktTCP::
	.ds	1460
	.debug	G _respPktTCP 136 8
	.bseg
_respPktUsedTCP::
	.ds	2
	.debug	G _respPktUsedTCP 7 0
_allowedClients::
	.ds	16
	.debug	G _allowedClients 137 0
	.cseg
_CA_Version:
	pop	iy
	lcall	$$CA_Version
_CA_EventAdd:
	pop	iy
	lcall	$$CA_EventAdd
_CA_EventCancel:
	pop	iy
	lcall	$$CA_EventCancel
_CA_Write:
	pop	iy
	lcall	$$CA_Write
_CA_Search:
	pop	iy
	lcall	$$CA_Search
_CA_EventsOff:
	pop	iy
	lcall	$$CA_EventsOff
_CA_EventsOn:
	pop	iy
	lcall	$$CA_EventsOn
_CA_ClearChannel:
	pop	iy
	lcall	$$CA_ClearChannel
_CA_ReadNotify:
	pop	iy
	lcall	$$CA_ReadNotify
_CA_CreateChan:
	pop	iy
	lcall	$$CA_CreateChan
_CA_ClientName:
	pop	iy
	lcall	$$CA_ClientName
_CA_HostName:
	pop	iy
	lcall	$$CA_HostName
_CA_Echo:
	pop	iy
	lcall	$$CA_Echo
_ProtocolError:
	pop	iy
	lcall	$$ProtocolError
	.bseg
_servName::
	.ds	32
	.debug	G _servName 138 0
_servNameLen::
	.ds	2
	.debug	G _servNameLen 6 0
_servNameMatch::
	.ds	1
	.debug	G _servNameMatch 3 0
_beaconID::
	.ds	4
	.debug	G _beaconID 9 0
_numUDPPkts::
	.ds	2
	.debug	G _numUDPPkts 7 0
_numProcPkts::
	.ds	2
	.debug	G _numProcPkts 7 0
_numSearchMsgs::
	.ds	2
	.debug	G _numSearchMsgs 7 0
_numEvents::
	.ds	2
	.debug	G _numEvents 7 0
_numWrites::
	.ds	2
	.debug	G _numWrites 7 0
_numPSub::
	.ds	2
	.debug	G _numPSub 7 0
_udpPktRate::
	.ds	2
	.debug	G _udpPktRate 7 0
_procPktRate::
	.ds	2
	.debug	G _procPktRate 7 0
_searchMsgRate::
	.ds	2
	.debug	G _searchMsgRate 7 0
_eventsRate::
	.ds	2
	.debug	G _eventsRate 7 0
_writesRate::
	.ds	2
	.debug	G _writesRate 7 0
_psubRate::
	.ds	2
	.debug	G _psubRate 7 0
_consecutivePkts::
	.ds	2
	.debug	G _consecutivePkts 7 0
_lastBeaconTime::
	.ds	2
	.debug	G _lastBeaconTime 7 0
_epochTimeSecs::
	.ds	4
	.debug	G _epochTimeSecs 9 0
_epochTimeNS::
	.ds	4
	.debug	G _epochTimeNS 9 0
	.cseg
_addToRespPkt:
	pop	iy
	lcall	$$addToRespPkt
	.debug	T	09000120001C0021000700
	.debug	T	070008210004000300
	.debug	T	0900012200180021000600
	.debug	T	0900012300230024000700
	.debug	T	2C0003240005000300010007000000077076547970650007000200
	.debug	T	0573697A6500030004000872656F7264657200
	.debug	T	0900012500100007000800
	.debug	T	09000126004E0007002700
	.debug	T	0900012700380028001C00
	.debug	T	070000280002002900
	.debug	T	0F00022900020006003200000040000200
	.debug	T	0900012A0006002B000300
	.debug	T	0700002B0002000300
	.debug	T	0F00022C00020001000600000021000200
	.debug	T	0700082D0004002E00
	.debug	T	0B01032E00270013000100060000000A6F70656E436F756E74008B
	.debug	T	00020008696F46756E6373002F00040006696F446576008D00
	.debug	T	06000B776169745175657565730006000A0006666C61677300
	.debug	T	06000C00056D6F64650009000E000A72656164436F756E7400
	.debug	T	060012000D7264496E50726F67726573730006001400077264
	.debug	T	53746174000600160006726445727200030018000D646F6E74
	.debug	T	43616C6C5265616400090019000B7772697465436F756E7400
	.debug	T	06001D000D7772496E50726F67726573730006001F00077772
	.debug	T	53746174000600210006777245727200030023000E646F6E74
	.debug	T	43616C6C5772697465000300240004656F6600030025000669
	.debug	T	7374747900030026000773686172656400
	.debug	T	0700002F0002000100
	.debug	T	0900013000800003008000
	.debug	T	0B000231000100010032000000
	.debug	T	070000320002003300
	.debug	T	47000333000A000500010006000000036664000700020005747970
	.debug	T	65004700040004636F6E00030008000973686F77436D647300
	.debug	T	0300090010766572735265737050656E64696E6700
	.debug	T	170002340004000600320000002B0002000600040008000600
	.debug	T	130002350003000600320000002100020007000600
	.debug	T	070000360002003700
	.debug	T	41000337000E00040009736F636B61646472000500000007735F74
	.debug	T	797065000500020007735F706F7274000900040005735F6970
	.debug	T	008E00080009735F73706172657300
	.debug	T	0900013800400003004000
	.debug	T	0900013900100003001000
	.debug	T	0B00023A000100060032000000
	.debug	T	1300023B0003000600320000003C00020007000600
	.debug	T	0700083C0004000100
	.debug	T	0F00023D00020006003200000006000200
	.debug	T	0F00023E00020006002B00000006000200
	.debug	T	1B00023F0005000600320000004000020009000400060008002100
	.debug	T	0A00
	.debug	T	070000400002004100
	.debug	T	6400034100920008000963614D7367486472000500000004636D64
	.debug	T	00050002000573697A65000500040005666C64330005000600
	.debug	T	05666C6434000900080005666C64350009000C0005666C6436
	.debug	T	003000100005646174610006009000096461746153697A6500
	.debug	T	0B000242000100060006000000
	.debug	T	5C0003430019000700010009000000076970416464720009000400
	.debug	T	076263416464720009000800086E65746D61736B0009000C00
	.debug	T	0867617465776179008E001000086D61634164647200070016
	.debug	T	00046D7475000300180006737461746500
	.debug	T	1F0002440006000600320000000700020009000400070008000700
	.debug	T	0A0007000C00
	.debug	T	070008450004000700
	.debug	T	52000346000D000600010021000000056E616D6500030004000964
	.debug	T	6174615479706500070005000573697A65000700070009656C
	.debug	T	656D53697A650007000900096E756D456C656D730007000B00
	.debug	T	06666C61677300
	.debug	T	070008470004004800
	.debug	T	7E000348004503090001000600000003666400030002000B737562
	.debug	T	456E61626C6564008F000300066368616E7300070083000B6D
	.debug	T	61784368616E4E756D0090008500057375627300070005030A
	.debug	T	6D61785375624E756D004D00070309686F73744E616D65004D
	.debug	T	001F0309757365724E616D65003700370308696E5F41646472
	.debug	T	00
	.debug	T	1C00034900040002000100060000000571756F7400060002000472
	.debug	T	656D00
	.debug	T	0700084A0004004B00
	.debug	T	4500034B000A000500010007000000047369640009000200067375
	.debug	T	6249440003000600086D6F6E4D61736B000300070008646272
	.debug	T	547970650007000800096E756D456C656D7300
	.debug	T	0B00024C000100060001000000
	.debug	T	0900014D00180003001800
	.debug	T	0B00024E000100010001000000
	.debug	T	0F00024F00020001000600000050000200
	.debug	T	070000500002002B00
	.debug	T	0B000251000100010006000000
	.debug	T	070000520002000900
	.debug	T	0900015300140003001400
	.debug	T	130002540003002F002F0000000600020007000400
	.debug	T	0F00025500020006002B0000002B000200
	.debug	T	0B00025600010006002B000000
	.debug	T	1300025700030006002B0000002B00020007000400
	.debug	T	130002580003003C003C0000003C00040009000800
	.debug	T	130002590003003C003C0000000600040009000600
	.debug	T	0F00025A00020006002100000021000400
	.debug	T	0F00025B00020001002100000021000400
	.debug	T	0B00025C000100090021000000
	.debug	T	1300025D0003000600060000000600020009000400
	.debug	T	1700025E0004000600060000002F0002000600040008000600
	.debug	T	1B00025F0005000600910000000600020009000400210008000600
	.debug	T	0C00
	.debug	T	0F00026000020006005200000006000200
	.debug	T	130002610003000600060000005200020052000400
	.debug	T	0B000262000100060052000000
	.debug	T	070000630002006400
	.debug	T	7702036400E8002D000C7461736B5F737472756374009200000006
	.debug	T	737461636B00920002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C68720093000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465006300150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630050001A0005617267760030001C0005617267
	.debug	T	730094009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773009500B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74002100D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	070000650002006600
	.debug	T	54000366000C000600010096000000065F5F6F7574009800020005
	.debug	T	5F5F696E009A000400085F5F7772697465009A000600075F5F
	.debug	T	726561640006000800085F5F756E676574002F000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	0F0002670002000600210000000D000000
	.debug	T	13000268000300060021000000210004000D000000
	.debug	T	0900016900080009000200
	.debug	T	0F00026A00020049000600020006000400
	.debug	T	1300026B00030006002B0000005000020006000400
	.debug	T	0900016C00C0092E004000
	.debug	T	0900016D0000056E001400
	.debug	T	0900016E0040002D001000
	.debug	T	0B00026F0001002D0006000000
	.debug	T	130002700003000600060000000600020006000400
	.debug	T	0B000271000100060065000000
	.debug	T	13000272000300060006000000060002002F000400
	.debug	T	230002730007000600950000000300020006000400500006000600
	.debug	T	080006000A0006000C00
	.debug	T	0B000274000100090009000000
	.debug	T	0F00027500020006000600000006000200
	.debug	T	0F0002760002002B002B00000006000200
	.debug	T	0F0002770002000600060000009C000200
	.debug	T	130002780003000600060000003600020091000400
	.debug	T	130002790003000600060000003600020006000400
	.debug	T	1F00027A0006000600060000003C00020006000600060008003600
	.debug	T	0A0091000C00
	.debug	T	1F00027B0006000600060000003C00020006000600060008003600
	.debug	T	0A0006000C00
	.debug	T	1B00027C00050006000600000006000200060004002F0006000600
	.debug	T	0800
	.debug	T	0F00027D0002000600060000009D000200
	.debug	T	1B00027E00050006000600000007000200070004002F0006000700
	.debug	T	0800
	.debug	T	1700027F00040006000600000007000200070004002F000600
	.debug	T	17000280000400060006000000070002002F0004009E000600
	.debug	T	130002810003000100520000009200020003000400
	.debug	T	0F00028200020006000600000007000200
	.debug	T	170002830004002B00060000002F0002002B00040006000600
	.debug	T	130002840003000600060000002B0002002F000400
	.debug	T	0B000285000100010021000000
	.debug	T	130002860003000300060000000600020050000400
	.debug	T	0900018700140D48000400
	.debug	T	0900018800B4050300B405
	.debug	T	0900018900100009000400
	.debug	T	0900018A00200003002000
	.debug	T	0700008B0002008C00
	.debug	T	6400038C00100008000100A0000000057265616400A00002000677
	.debug	T	72697465009800040006636C6F736500A2000600066C736565
	.debug	T	6B00A400080006667374617400A6000A0006696F63746C00A8
	.debug	T	000C0006646573637200AA000E000A67657451756575657300
	.debug	T	2800038D00040002000100AC0000000A72656164517565756500AC
	.debug	T	0002000B7772697465517565756500
	.debug	T	0900018E00060003000600
	.debug	T	0900018F00800007004000
	.debug	T	090001900080024B004000
	.debug	T	070000910002000600
	.debug	T	070000920002000700
	.debug	T	070000930002003C00
	.debug	T	280003940004000100125F5F776169745F71756575655F68656164
	.debug	T	00AD000000096C6973744865616400
	.debug	T	070000950002004F00
	.debug	T	070000960002009700
	.debug	T	0F0002970002000600030000002F000200
	.debug	T	070000980002009900
	.debug	T	0B00029900010006002F000000
	.debug	T	0700009A0002009B00
	.debug	T	1300029B000300080021000000080004002F000800
	.debug	T	0700009C0002004300
	.debug	T	0700009D0002004600
	.debug	T	0700009E0002009F00
	.debug	T	1300029F00030006002F0000003C00020007000600
	.debug	T	070000A0000200A100
	.debug	T	170002A100040006002F0000002B0002000600040003000600
	.debug	T	070000A2000200A300
	.debug	T	130002A300030009002F0000000900020006000600
	.debug	T	070000A4000200A500
	.debug	T	0F0002A500020006002F000000AE000200
	.debug	T	070000A6000200A700
	.debug	T	130002A700030006002F000000060002002F000400
	.debug	T	070000A8000200A900
	.debug	T	130002A90003002B002F0000002B00020006000400
	.debug	T	070000AA000200AB00
	.debug	T	0F0002AB00020006002F000000B0000200
	.debug	T	070000AC0002009400
	.debug	T	260003AD00040002000A6C6973745F6865616400B1000000056E65
	.debug	T	787400B1000200057072657600
	.debug	T	070000AE000200AF00
	.debug	T	BB0003AF002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	070008B00004008D00
	.debug	T	070000B1000200AD00
	.seg	CONST
@2:
	.db	"periodic",0,"threshold",0,"anychg",0,"Connection closed",0,"*** Closing due to error ***",0,"VAL",0,"_NOTIFY",0
	.db	"DO",0,"DONT",0,"UDP",0,"TCP",0,"responding to",0,"ignoring",0,"ca_tcpd",0,"ca_udpd",0
	.seg	FARCONST
@1:
	.db	"STRING",0,"SHORT",0,"FLOAT",0,"ENUM",0,"CHAR",0,"LONG",0,"DOUBLE",0,"STS",0,"TIME",0,"GR",0,"CTRL",0,"EXTRA",0,13,10,"%ls on fd: %d (GFD:"
	.db	" %d)",13,10,"%.128s",10,10,0,10,"*** %s:%u: sendto(%d, x, %d, ...)",0,"UDP setsockopt()",0,"*** skipping %d pa"
	.db	"yload bytes ***",10,0,"*** Error: fd:%d  cmd:[%2d]  CID:0x%08lX  code:%04X",10,"           %ls",10
	.db	0,"sendBCastPkt()",0,"*** Extended data type exceeds our capabilities ***",10,0,"    dbrType:%2u",10
	.db	0,"*** Unable to get or convert data ***",10,0,"    Sending: dbrType:%2u  #elem:%u  payload: "
	.db	"%u  SID:%3u  eventID:0x%08lX  status:%u  pvID:%3d [%ls]",10,10,0,"VERSION: Client:4.%d  Serve"
	.db	"r:4.%d",10,0,"ERROR",0,"Invalid Mask",0,"Invalid DBR type",0,"Invalid SID",0,"SIDs don't match",0,"Max Subscrip"
	.db	"tions exceeded",0,"EVENT_ADD: mask:0x%02X  dbrType:%2u",0,"*** %ls ***",10,0,"EVENT_CANCEL:  SID:0x"
	.db	"%04X  subID:0x%08lX",13,10,0,"Invalid subID",0,"<invalid>",0,"WRITE%s:  dbrType:%2u  numElems:%u  SID"
	.db	":3u  pvID:%3d [%ls]",10,0,"Invalid dataSize",0,"Unable to set or convert data",0,"  fd:%d  cmd:[%2u"
	.db	"]  ",0,"SEARCH: %s_REPLY  CAVers:4.%d  CID:0x%08lX  pvID:%3d  [%s]",10,0,"EVENTS_OFF:",10,0,"EVENTS_O"
	.db	"N:",10,0,"CLEAR_CHANNEL:  SID:0x%04X  CID:0x%08lX  pvID:%3d [%ls]",10,0,"READ_NOTIFY:",10,0,"CREATE_CHA"
	.db	"N:  Client Vers:4.%ld  CID:0x%08lX  SID:0x%04X  pvID:%3d [%.32s]",10,0,"CLIENT_NAME: ",0,"<too "
	.db	"long>",10,0,"HOST_NAME: ",0,"ECHO",10,0,"*** Protocol Error:  Unexpected command ***",10,0,"*** Incomplete "
	.db	"msg ***",0,"readBytes()",0,"reading payload",0,"skipMsgBytes()",0,"  fd:%d  cmd:[%2u]  data:%2u: ",0,"***"
	.db	" Ignoring Invalid CA cmd: [%2u] ***",10,0,"*** ERROR ***",0,"UDP socket() error",0,"UDP bind() erro"
	.db	"r",0,"Created UDP listener on fd:%d  port %d",13,10,0,"TCP listener socket() error",0,"TCP listener b"
	.db	"ind() error",0,"listen()",0,"Created TCP listener on fd:%d  port %d",13,10,0,"accept()",0,"New Virtual Ci"
	.db	"rcuit",0,"<unknown>",0,"*** Max CA connections exceeded ***",10,0,10,"=== got data on fd %d (con %u) "
	.db	"from: %s:%u via TCP ===",10,0,13,10,"--- ProcessSubscriptions ---",13,10,0,"*** Invalid subscr SID or c"
	.db	"han pvID: SID:%u  pvID:%u ***",10,0,"Events: %u  Con:%u  SubID:0x%08lX  [%ls]",10,0,"*** subscr m"
	.db	"sg pending [%ls] ***",10,0,"*** pending subscr msg sent [%ls] ***",10,0,13,10,"  CA %s service alread"
	.db	"y running: pid: %d",13,10,0,"  CA UDP pid: %u",13,10,0,"=== CA UDP server shutting down ===",10,0,"UDP SEAR"
	.db	"CH socket closed by other end",13,10,0,"recvfrom()",0,"=== %d byte packet from: %s via UDP ===",10,0," "
	.db	" CA TCP pid: %u",13,10,0,"=== CA TCP server shutting down ===",10,0,13,10,"Counts for the previous seco"
	.db	"nd:",13,10,13,10,"  UDP pkts    Search Msgs    Events   ProcSub    Writes ",13,10,0,"  %3u/%3u         %"
	.db	"3u         %3u       %3u       %3u ",13,10,0,13,10,"  ===== Virtual Circuit: %d =====",13,10,"    fd: %d"
	.db	"   IP: %s:%u",13,10,"    Host: [%ls]   User: [%ls]",13,10,0,"    ----- Channels -----",13,10,0,"    Chan:  S"
	.db	"ID:0x%04X  pvID:%3d  [%ls]",13,10,0,"         subID:0x%08lX  mask:%2u  dbrType:DBR_%ls_%ls  #"
	.db	"elems:%u",13,10,0,"    %u Channels, %u Subscriptions",13,10,0,13,10,"  Allowed SEARCH clients:",13,10,0,"    ?.?."
	.db	"?.?",13,10,0,"    %s",13,10,0,10,"usage: cas start|stop|chans|stats|summary",13,10,"           clist",13,10,"       "
	.db	"    add <client_addr>",13,10,"           del <client_addr>|all",13,10,"           queries respond|"
	.db	"ignore",13,10,"           events anychg|threshold|periodic|<period in ms>",13,10,0,"summary",0,"  CA %s "
	.db	"service not running",13,10,0,"  CA %s service pid: %d",13,10,0,"  CA %s service not running",13,10,10,0,"  %s S"
	.db	"EARCH requests",13,10,0,"  Event monitors: %s every %u ms",13,10,0,"start",0,"stop",0,13,10,"  services are not r"
	.db	"unning.",13,10,0,"Terminating CA server(s)",13,10,0,"chans",0,13,10,"  service is not running.",13,10,0,"stats",0,"clist",0
	.db	"Invalid or incomplete cmd",13,10,0,"add",0,"Invalid address",13,10,0,"Max # of allowed clients already se"
	.db	"t",13,10,0,"del",0,"all",0,"Addr not in list",13,10,0,"queries",0,"respond",0,"ignore",0,"events",0,"Event monitor period now"
	.db	" %u ms",13,10,0,13,10,"Invalid option",13,10,0
	.end
