	.objcmt	Softools, Inc. ** Control Cross-C Globally Optimizing Compiler ** Version 2.18.00
	.objcmt	Copyright (c) 1989 - 2003, Softools, Inc.  All rights reserved.
	.debug	P 5
	.debug	X 11 10
	.debug	X 12 10
	.debug	N 'C:\work\dev\Rabbit_ST\rtos\fs\file_io.c' 22 24 12 18 10 32
;1 //----- file_io.c ----- 10/01/12 -----(xx/xx/xx)-----
;2 
;3 //----- original code from SHDesigns -----
;4 
;5 //--- modifications, additions, and reformatting by Mark Davis, NSCL ---
;6 
;7 //-------------------------------------------------------------------------
;8 // NOTE:  Locking needed to avoid concurrency issues for many of the basic
;9 //        functions (lke reading, writing, etc) is handled by the "wrapper"
;10 //        flashFile.c module which provides the standard fcntl API
;11 //-------------------------------------------------------------------------
;12 
;13 //-------------------------------------------------------------------------
;14 //  Update Log (most recent first)
;15 //
;16 //  Entries marked with (*) indicates a change that addresses possible
;17 //  stability/reliability issues or fixes a bug that can cause the system
;18 //  to crash or otherwise malfunction.
;19 //
;20 //  2012-10-01 - Mark Davis (*)
;21 //               - Fixes to avoid an error when the next free block happens
;22 //                 to be block # 0.  Prior to this, loadBuffer() (used by t
;23 //                 read and write functions) would return an error (with er
;24 //                 set to ENOSPC) if it allocated another block and got # 0
;25 //
;26 //  2011-01-26 - Mark Davis
;27 //               - getIPAddr() and setIPAddr() changed to readIPAddr() and
;28 //                 writeIPAddr()
;29 //
;30 //  2010-12-17 - Mark Davis (*)
;31 //               - fflush_file() now sets the FFLAG_UPDATED bit in the file
;32 //                 flags value if new data is written to the file.  Earlier
;33 //                 changes prior to this one resulted in a file's date/time
;34 //                 being updated only if writes to the file caused its size
;35 //                 to increase.
;36 //
;37 //  2010-07-06 - Mark Davis (*)
;38 //               - ffile_fsck() now checks to see if the # of sectors for t
;39 //                 flash device is > MAX_BLK_NUM.
;40 //               - References to MAX_BLK_NUM now replaced with references t
;41 //                 to the actual # of blocks in the flash (which is stored
;42 //                 in config_table->num_blocks).  Prior to this it appeared
;43 //                 to be possible to use block #'s that exceeded the actual
;44 //                 number of blocks in the file system.
;45 //
;46 //  2010-06-29 - Mark Davis
;47 //               - Added log message for memory allocation calls
;48 //
;49 //  2010-06-07 - Mark Davis (*)
;50 //               - Fixed problems caused by earlier simplification to how t
;51 //                 sector cache (sector_buff) is handled for each open file
;52 //                 In particular, writes always started at the beginning of
;53 //                 the file rather than the current positon (e.g. if the fi
;54 //                 was opened with O_APPEND or an lseek was done).
;55 //
;56 //  2010-03-31 - Mark Davis
;57 //               - Removed the unnecessary critical section from write_bloc
;58 //                 and update_config()
;59 //
;60 //  2010-03-31 - Mark Davis
;61 //               - fflush_file() no longer updates the date/time for the fi
;62 //                 as this is now handled in ffile_write() (because doing i
;63 //                 in fflush_file() often sets the time to one that is late
;64 //                 than the last change).
;65 //
;66 //  2010-03-30 - Mark Davis
;67 //               - ffile_write() now modifies the date/time for the file if
;68 //                 any bytes were processed.  Previously the date/time valu
;69 //                 was only updated when the file was closed.
;70 //
;71 //  2010-03-22 - Mark Davis
;72 //               - ffile_create() now sets the date so a file that is creat
;73 //                 but not written to will have a valid date/time stamp.
;74 //
;75 //  2010-03-13 - Mark Davis (*)
;76 //               - Added reset of watchdog timer before calls to WriteFlash
;77 //                 It appeared that multiple calls in rapid sequence was
;78 //                 enough to cause a watchdog timer reset.
;79 //               - The return status of a call to WriteFlash() is now check
;80 //                 and an error logged if there is a problem.
;81 //               - Added either the use of the scheduler lock or a check fo
;82 //                 one in several functions where the lock should be in eff
;83 //                 to avoid possible concurrency issues.
;84 //
;85 //  2009-03-16 - Mark Davis
;86 //               - ffile_fstat() now checks for an invalid date/time
;87 //               - expanded ipset critical area in write_block()
;88 //               - added ipset critical area to update_config()
;89 //
;90 //  2009-03-12 - Mark Davis
;91 //               - A file can no longer be deleted if it is already open
;92 //
;93 //  2008-04-30 - Mark Davis
;94 //               - changes to make seek work properly and so all funcs can
;95 //                 properly use the data in the sector buffer after EOF is
;96 //                 reached.
;97 //
;98 //  2008-01-15 - Mark Davis
;99 //               - some cleanup and commenting of code done while examining
;100 //                 for potential concurrency issues
;101 //
;102 //  2007-08-03 - Mark Davis
;103 //               - added ffile_setName() and ffile_getName()
;104 //
;105 //  2006-xx-xx - Mark Davis
;106 //               - original modifications
;107 //
;108 //-------------------------------------------------------------------------
;109 
;110 #include <common.h>
;111 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stddef.h' 21 20 12 5 6 22
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\math.h' 19 23 18 21 9 21
	.debug	I
	.debug	I
;112 #include <sys/types.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
;113 #include <unistd.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\unistd.h' 5 0 10 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\signal.h' 6 21 8 17 3 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\dummy.h' 25 58 21 12 10 27
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\list.h' 21 49 15 26 7 30
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdio.h' 22 16 12 9 4 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDblock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\FlashBlock.h' 5 10 16 30 11 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Flash.h' 0 55 21 17 7 26
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stdlib.h' 2 30 16 6 7 24
	.debug	I
	.debug	# 109
_LIN2SEG	.macro

	.debug	# 110
add hl,hl

	.debug	# 111
rla

	.debug	# 112
add hl,hl

	.debug	# 113
rla

	.debug	# 114
add hl,hl

	.debug	# 115
rla

	.debug	# 116
add hl,hl

	.debug	# 117
rla

	.debug	# 118
sub 0x0E

	.debug	# 119
or a

	.debug	# 120
rr hl

	.debug	# 121
scf

	.debug	# 122
rr hl

	.debug	# 123
scf

	.debug	# 124
rr hl

	.debug	# 125
scf

	.debug	# 126
rr hl

	.debug	# 127
.endm

	.cseg
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\hdwdefs.h' 20 2 12 27 10 31
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\sched.h' 3 49 6 8 6 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\ioctl.h' 2 15 10 21 5 30
	.debug	I
	.debug	I
	.debug	I
;114 #include <sys/stat.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\stat.h' 0 48 10 31 3 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\time.h' 15 48 18 10 12 22
	.debug	I
	.debug	I
;115 #include <utime.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\utime.h' 29 54 20 12 3 27
	.debug	I
;116 #include <fcntl.h>
;117 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\fcntl.h' 29 48 12 5 12 32
	.debug	I
;118 #include <stcpip.h>
;119 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dcrtcp.h' 1 9 9 21 2 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp_config.h' 9 28 14 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\neterrno.h' 26 24 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errors.h' 25 8 15 18 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppp.h' 4 42 22 17 6 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ppplink.h' 18 1 2 19 9 26
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\chat.h' 12 7 15 6 10 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\Rabbit.h' 24 40 11 19 5 30
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\net.h' 21 21 9 7 3 32
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pktdrv.h' 16 19 17 14 3 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\arp.h' 21 56 14 30 7 24
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ip.h' 16 35 12 25 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\udp.h' 23 23 20 4 3 30
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\tcp.h' 14 5 18 19 4 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bootp.h' 2 16 3 7 2 26
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\bsdname.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\icmp.h' 2 44 0 17 5 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\dns.h' 18 15 17 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\servlist.h' 7 29 16 30 7 24
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\igmp.h' 10 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\smtp.h' 0 54 12 2 8 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\http.h' 28 52 16 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\limits.h' 1 13 9 26 5 19
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\pool.h' 10 58 16 7 1 25
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\errno.h' 16 4 11 6 2 29
	.debug	I
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\mib.h' 28 3 18 15 4 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\snmp.h' 22 42 15 4 11 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_client.h' 9 41 20 10 2 24
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ftp_server.h' 5 50 18 7 1 25
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\zserver.h' 26 57 12 10 1 25
	.debug	I
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip\ethernet.h' 21 56 23 21 3 26
	.debug	I
	.debug	I
	.debug	I
;120 #include "string.h"
;121 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\string.h' 26 27 14 2 6 25
	.debug	I
;122 #include <SHD_DLM.h>
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\SHD_DLM.h' 7 53 11 8 2 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\socket.h' 2 54 9 7 6 32
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\netinet\in.h' 15 56 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\stcpip.h' 10 19 7 30 6 29
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\limits.h' 25 24 9 6 6 32
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\linux\wait.h' 10 13 9 20 4 32
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMIII.h' 3 21 14 4 6 30
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\ZWIDblock.h' 29 54 20 12 3 27
	.debug	I
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\SoftoolsIDBlock.h' 18 52 15 4 6 26
	.debug	I
	.debug	I
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\types.h' 26 55 13 6 4 32
	.debug	I
	.debug	I
;123 #include <DLMiii.h>
;124 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\fs\DLMiii.h' 3 21 14 4 6 30
	.debug	I
;125 #include <rabbit.h>
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\rabbit.h' 24 40 11 19 5 30
	.debug	I
;126 #include <dcdefs.h>
;127 
	.debug	I 'C:\Program Files (x86)\Softools WinIDE\Rabbit 1.70\Include\dcdefs.h' 18 42 23 19 7 26
	.debug	I
;128 #include <sys/farprintf.h>
;129 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\sys\farprintf.h' 5 43 7 29 11 27
	.debug	I
;130 
;131 //#define DOPEN_FILES 4  // moved to SHD_DLM.h
;132 
;133 //--- state of currently opened files ---
;134 //--- The ffile "handles" are indexes in to this list ---
;135 FILE_DATA  openFiles[DOPEN_FILES];
;136 
;137 ulong  param_start = 0l;
	.dseg
_param_start::
	.dw	0, 0
	.debug	G _param_start 9 0
;138 ushort  sector_size;
;139 
;140 //=========================================================================
;141 //      ---------  !!!!! WARNING !!!!!    !!!!! WARNING !!!!!  ------------
;142 //
;143 //   The following table is used by both the Bootloader/Download Manager
;144 //   and the application/OS!
;145 //
;146 //                !!!!! Do NOT change the structure at all !!!!!
;147 //=========================================================================
;148 //  This pointer is changed to a buffer allocated by init_file_data()
;149 CONFIG_TABLE far *config_table = (CONFIG_TABLE far *)0l;
_config_table::
	.dw	0, 0
	.debug	G _config_table 32 0
;150 
;151 
;152 
;153 //-------------------------------------------------------------------------
;154 //  Initialize the flash file system
;155 //-------------------------------------------------------------------------
;156 int init_file_data(void)
;157 {
	.defseg	FARCODE
	.seg	FARCODE
$init_file_data::
	.debug	G $init_file_data 34 9
	.debug	{ $init_file_data 34 156 @3 @2
;158   static char file_init = 0;
	.dseg
@4:
	.db	0
	.debug	S file_init @4 3
	.seg	FARCODE
;159 
;160   KLOCK();
	.debug	# 160
	call	_KLOCK
;161 
;162   if (file_init)  {
	.debug	# 162
	ld	a,(@4)
	or	a,a
	jr	z,@5
;163     if (config_table->key != CONFIG_KEY)  {
@6:
	.debug	< @6 @7
	.debug	# 163
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0xf52
	ld	bc,0
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,0xaa56
	ld	bc,0x531
	call	__ladd##
	jr	z,@8
;164       postMortem("Flash File driver data corrupted");  Exit(-666); }
@9:
	.debug	< @9 @10
	.debug	# 164
	ld	de,word (phys @11)
	ld	c,phys @11 >> 16
	push	bc
	push	de
	lcall	$postMortem
	add	sp,4
	ld	hl,0xfd66
	push	hl
	lcall	$Exit
	pop	hl
@10:
	.debug	>
;165     KUNLOCK();  return 1;
@8:
	.debug	# 165
	call	_KUNLOCK
	ld	hl,0x1
	jp	@2
;166   }
@7:
	.debug	>
;167 
;168   GetFlashDeviceEnd((FlDWord )0x0l, &sector_size);
@5:
	.debug	# 168
	ld	hl,_sector_size
	push	hl
	ld	de,0
	ld	c,e
	ld	b,e
	push	bc
	push	de
	lcall	$GetFlashDeviceEnd
	add	sp,6
;169   printf("Flash Sector Size: %u\r\n", sector_size);
	.debug	# 169
	ld	hl,(_sector_size)
	push	hl
	ld	de,word (phys @11+33)
	ld	c,phys @11+33 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;170 
;171   memset(openFiles, 0, sizeof(openFiles));
	.debug	# 171
	ld	hl,0x58
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,_openFiles
	push	hl
	call	_memset
	add	sp,6
;172 
;173   if (!config_table)  {
	.debug	# 173
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@12
;174     fprintf(DiagLog, "For flash file FAT:\r\n");
@13:
	.debug	< @13 @14
	.debug	# 174
	ld	de,word (phys @11+57)
	ld	c,phys @11+57 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;175     config_table = (CONFIG_TABLE far *) xalloc(sizeof(CONFIG_TABLE));
	.debug	# 175
	ld	de,0xf5a
	ld	bc,0
	push	bc
	push	de
	lcall	$xalloc
	add	sp,4
	ld	(_config_table),de
	ld	(_config_table+2),bc
;176   }
@14:
	.debug	>
;177 
;178   if (!config_table)  {
@12:
	.debug	# 178
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@15
;179     fprintf(DiagLog, "*** Unable to initialize Flash File driver ***\r\n");
@16:
	.debug	< @16 @17
	.debug	# 179
	ld	de,word (phys @11+79)
	ld	c,phys @11+79 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;180     KUNLOCK();  return 0;
	.debug	# 180
	call	_KUNLOCK
	bool	hl
	ld	l,h
	jp	@2
;181   }
@17:
	.debug	>
;182 
;183   param_start = 0xc000l;  // where to start search from
@15:
	.debug	# 183
	ld	de,0xc000
	ld	c,e
	ld	b,e
	ld	(_param_start),de
	ld	(_param_start+2),bc
;184 
;185   while (config_table AND !file_init)  {
@18:
	.debug	# 185
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	ld	a,e
	or	a,d
	or	a,c
	jr	z,@20
	ld	a,(@4)
	or	a,a
	jr	nz,@20
;186     ReadFlash((FlByte const far *)param_start, (FlByte far *)config_table,
@21:
	.debug	< @21 @22
;187               sizeof(CONFIG_TABLE));
	.debug	# 187
	ld	de,0xf5a
	ld	bc,0
	push	bc
	push	de
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,(_param_start)
	ld	bc,(_param_start+2)
	push	bc
	push	de
	lcall	$ReadFlash
	add	sp,12
;188     if (config_table->key == CONFIG_KEY)  { file_init = 1;  break; }
	.debug	# 188
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0xf52
	ld	bc,0
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,0xaa56
	ld	bc,0x531
	call	__ladd##
	jr	nz,@23
@24:
	.debug	< @24 @25
	ld	a,0x1
	ld	(@4),a
	jr	@20
@25:
	.debug	>
;189     param_start += 0x1000;  // 4k alignment
@23:
	.debug	# 189
	ld	de,(_param_start)
	ld	bc,(_param_start+2)
	push	bc
	push	de
	ld	de,0x1000
	ld	c,e
	ld	b,e
	call	__ladd##
	ld	(_param_start),de
	ld	(_param_start+2),bc
;190     if (param_start >= 0x20000l)  break;  // if not found in 128k then exit
	.debug	# 190
	push	bc
	push	de
	ld	de,0
	ld	bc,0x2
	call	__lsub##
	jp	c,@18
;191   }
@22:
	.debug	>
;192 
;193   KUNLOCK();
@20:
	.debug	# 193
	call	_KUNLOCK
;194 
;195   if (file_init)
	.debug	# 195
	ld	a,(@4)
	or	a,a
	jr	z,@27
;196     printf("in-flash CONFIG_TABLE found at: 0x%lX\r\n", param_start);
	.debug	# 196
	ld	de,(_param_start)
	ld	bc,(_param_start+2)
	push	bc
	push	de
	ld	de,word (phys @11+128)
	ld	c,phys @11+128 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;197 
;198   return file_init;
@27:
	.debug	# 198
	ld	a,(@4)
	bool	hl
	ld	l,a
;199 }
@2:
	.debug	} @2 199

@1	equ	0
	lret
@3	equ	0
;200 
;201 //-------------------------------------------------------------------------
;202 //  Checks to see that the provided handle refers to a currently opened fil
;203 //
;204 //  Returns a pointer to the FILE_DATA structure for the open file on succe
;205 //  or NULL if there is an error.
;206 //
;207 //  If the handle is valid, then the addr of the FILE_ENTRY structure for t
;208 //  file is also returned in the file argument (if it is not NULL).
;209 //-------------------------------------------------------------------------
;210 FILE_DATA *validHandle(int handle, FILE_ENTRY far **filePtr)
;211 {
$validHandle::
	.debug	G $validHandle 35 9
	.debug	{ $validHandle 35 210 @30 @29
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A handle 5 6
	.debug	A filePtr 7 38
;212   FILE_DATA  *fileState;
	.debug	L fileState -2 36
;213   FILE_ENTRY far *file;
	.debug	L file -6 39
;214   unsigned  fatIdx;
	.debug	L fatIdx -8 7
;215 
;216 
;217   if (!init_file_data())  return NULL;
	.debug	# 217
	lcall	$init_file_data
	bool	hl
	jp	z,@554
;218 
;219   if ((handle < 0) OR (handle >= DOPEN_FILES))  return NULL;
	.debug	# 219
	ld	hl,(ix+5)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@554
	ld	hl,(ix+5)
	ld	e,0x4
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@554
;220 
;221   fileState = openFiles + handle;
	.debug	# 221
	ld	hl,(ix+5)
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ld	(ix-2),hl
;222 
;223   if (!(fileState->flags & FFLAG_OPEN))  return NULL;
	.debug	# 223
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	ld	e,0x1
	and	hl,de
	jr	z,@554
;224 
;225   fatIdx = fileState->fatIdx;
	.debug	# 225
	ld	hl,(ix-2)
	ld	hl,(hl)
	ld	(ix-8),hl
;226 
;227   if (fatIdx >= MAX_FILES)  return NULL;
	.debug	# 227
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jr	nc,@554
;228 
;229   file = config_table->files + fatIdx;
	.debug	# 229
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-8)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;230 
;231   if (!(file->flags & FILE_ACTIVE))  return NULL;
	.debug	# 231
	push	bc
	push	de
	ld	de,0x66
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x1
	and	hl,de
	jr	nz,@36
@554:
	bool	hl
	ld	l,h
	jr	@29
;232 
;233   if (filePtr)  *filePtr = file;
@36:
	.debug	# 233
	ld	hl,(ix+7)
	bool	hl
	jr	z,@37
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	ld	hl,(ix+7)
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;234 
;235   return fileState;
@37:
	.debug	# 235
	ld	hl,(ix-2)
;236 }
@29:
	.debug	} @29 236

@28	equ	8
	ld	sp,ix
	pop	ix
	lret
@30	equ	10
;237 
;238 
;239 //-------------------------------------------------------------------------
;240 //  Return the next block in a linked list of blocks
;241 //-------------------------------------------------------------------------
;242 static ushort getNextBlock(ushort curBlockNum)
;243 {
$getNextBlock:
	.debug	F $getNextBlock 41 9
	.debug	{ $getNextBlock 41 242 @40 @39
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A curBlockNum 5 5
;244   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 244
	ld	a,(__disabled)
	or	a,a
	jr	nz,@41
	ld	de,word (phys @11+168)
	ld	c,phys @11+168 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;245 
;246   init_file_data();
@41:
	.debug	# 246
	lcall	$init_file_data
;247 
;248   if (curBlockNum >= config_table->num_blocks)  return EOF_BLK;
	.debug	# 248
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61a
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+5)
	or	a,a
	sbc	hl,de
	jr	c,@42
	ld	hl,0xffff
	jr	@39
;249 
;250   return config_table->nextBlock[curBlockNum];
@42:
	.debug	# 250
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61e
	ld	bc,0
	call	__ladd##
	ld	hl,(ix+5)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	call	__ladd##
	call	__farld2##
	ex	de,hl
;251 }
@39:
	.debug	} @39 251

@38	equ	0
	pop	ix
	lret
@40	equ	2
;252 
;253 //-------------------------------------------------------------------------
;254 //  Set the "next" block for the specified block
;255 //-------------------------------------------------------------------------
;256 static void setNextBlock(ushort blockNum, ushort nxt)
;257 {
$setNextBlock:
	.debug	F $setNextBlock 42 9
	.debug	{ $setNextBlock 42 256 @45 @44
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A blockNum 5 5
	.debug	A nxt 7 5
;258   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 258
	ld	a,(__disabled)
	or	a,a
	jr	nz,@46
	ld	de,word (phys @11+181)
	ld	c,phys @11+181 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;259 
;260   init_file_data();
@46:
	.debug	# 260
	lcall	$init_file_data
;261 
;262   if (blockNum >= config_table->num_blocks)  return;
	.debug	# 262
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61a
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+5)
	or	a,a
	sbc	hl,de
	jr	nc,@44
;263   if ((nxt >= config_table->num_blocks) AND (nxt != EOF_BLK))  nxt = EOF_BL
	.debug	# 263
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61a
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+7)
	or	a,a
	sbc	hl,de
	jr	c,@49
	ld	hl,(ix+7)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	z,@49
	ld	h,d
	ld	l,e
	ld	(ix+7),hl
;264 
;265   config_table->nextBlock[blockNum] = nxt;
@49:
	.debug	# 265
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61e
	ld	bc,0
	call	__ladd##
	ld	hl,(ix+5)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	call	__ladd##
	ld	hl,(ix+7)
	call	__farst2##
;266 }
@44:
	.debug	} @44 266

@43	equ	0
	pop	ix
	lret
@45	equ	2
;267 
;268 //-------------------------------------------------------------------------
;269 //  Return the index/# of the next unused block/sector in flash
;270 //  Returns (uint)-1 if no unused blocks/sectors
;271 //-------------------------------------------------------------------------
;272 static ushort get_freeblock(void)
;273 {
$get_freeblock:
	.debug	F $get_freeblock 43 9
	.debug	{ $get_freeblock 43 272 @52 @51
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
;274   ushort far *blocks = config_table->nextBlock;
	.debug	L blocks -4 44
	.debug	# 274
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61e
	ld	bc,0
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;275   ushort blockNum = 0;
	.debug	L blockNum -6 5
	.debug	# 275
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	.seg	FARCODE
;276 
;277   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 277
	ld	a,(__disabled)
	or	a,a
	jr	nz,@53
	ld	de,word (phys @11+194)
	ld	c,phys @11+194 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;278 
;279   init_file_data();
@53:
	.debug	# 279
	lcall	$init_file_data
;280 
;281   while (blockNum < config_table->num_blocks)  {
@54:
	.debug	# 281
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61a
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-6)
	or	a,a
	sbc	hl,de
	jr	nc,@55
;282     if (*blocks == 0)  return blockNum;
@56:
	.debug	< @56 @57
	.debug	# 282
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__farld2##
	ld	a,e
	or	a,d
	jr	nz,@58
	ld	hl,(ix-6)
	jr	@51
;283     blocks++;  blockNum++;
@58:
	.debug	# 283
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x2
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
;284   }
@57:
	.debug	>
;285 
;286   return (uint)-1;
	jr	@54
@55:
	.debug	# 286
	ld	hl,0xffff
;287 }
@51:
	.debug	} @51 287

@50	equ	6
	ld	sp,ix
	pop	ix
	lret
@52	equ	8
;288 
;289 //-------------------------------------------------------------------------
;290 //  Read a sector from flash in to the provided buffer
;291 //-------------------------------------------------------------------------
;292 static void read_block(unsigned block, char far * buff)
;293 {
$read_block:
	.debug	F $read_block 45 9
	.debug	{ $read_block 45 292 @61 @60
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A block 5 7
	.debug	A buff 7 46
;294   ulong addr;
	.debug	L addr -4 9
;295 
;296   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 296
	ld	a,(__disabled)
	or	a,a
	jr	nz,@62
	ld	de,word (phys @11+208)
	ld	c,phys @11+208 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;297 
;298   init_file_data();
@62:
	.debug	# 298
	lcall	$init_file_data
;299 
;300   addr = (ulong)block * sector_size;
	.debug	# 300
	ld	hl,(ix+5)
	ex	de,hl
	ld	bc,0
	ld	hl,(_sector_size)
	push	bc
	push	de
	ex	de,hl
	call	__ulmlt##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;301 //printf("ReadFlash(%lu, [%lu], %u)\r\n", (ulong)addr, (ulong)buff, sector_
;302 //fflush(stdout);
;303   ReadFlash((FlByte const far *)(addr), (FlByte far *)buff, sector_size);
	.debug	# 303
	ld	hl,(_sector_size)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	lcall	$ReadFlash
	add	sp,12
;304 }
@60:
	.debug	} @60 304

@59	equ	4
	ld	sp,ix
	pop	ix
	lret
@61	equ	6
;305 
;306 //-------------------------------------------------------------------------
;307 //  Copy an updated block of a file to flash
;308 //-------------------------------------------------------------------------
;309 static void  write_block(unsigned blockNum, char far * buff)
;310 {
$write_block:
	.debug	F $write_block 45 9
	.debug	{ $write_block 45 309 @65 @64
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A blockNum 5 7
	.debug	A buff 7 46
;311   int  stat;
	.debug	L stat -2 6
;312   ulong addr = blockNum;
	.debug	L addr -6 9
	.debug	# 312
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,0
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.seg	FARCODE
;313   FlDWord  badAddr;
	.debug	L badAddr -10 9
;314 
;315   // sector #'s are always > 0
;316   if (!blockNum OR (blockNum >= config_table->num_blocks))  return;
	.debug	# 316
	ld	h,d
	ld	l,e
	bool	hl
	jr	z,@66
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61a
	ld	b,h
	ld	c,h
	call	__ladd##
	call	__farld2##
	ld	hl,(ix+5)
	or	a,a
	sbc	hl,de
	jr	c,@67
@66:
;317 
;318   addr *= sector_size;  // avoid "= blockNum * sector_size" as that looses 
	jp	@64
@67:
	.debug	# 318
	ld	hl,(_sector_size)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__ulmlt##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;319 
;320   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 320
	ld	a,(__disabled)
	or	a,a
	jr	nz,@68
	ld	de,word (phys @11+219)
	ld	c,phys @11+219 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;321 
;322   init_file_data();
@68:
	.debug	# 322
	lcall	$init_file_data
;323 
;324   WDT_2S();
	.debug	# 324
  ld  a,0x5A
  ioi ld  (0x08),a
;325 
;326   _FlashUnlock = ~addr;
	.debug	# 326
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__lnot##
	ld	(__FlashUnlock),de
	ld	(__FlashUnlock+2),bc
;327 
;328   stat = WriteFlash((FlByte const far *)addr, (FlByte far *)buff, sector_si
	.debug	# 328
	ld	hl,(_sector_size)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	lcall	$WriteFlash
	add	sp,12
	ld	(ix-2),hl
;329 
;330   if (stat)  badAddr = FlashError();
	.debug	# 330
	bool	hl
	jr	z,@69
	lcall	$FlashError
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;331 
;332   if (stat)
@69:
	.debug	# 332
	ld	hl,(ix-2)
	bool	hl
	jr	z,@70
;333     fprintf(DiagLog, "***** Error writing to flash address: %06lX *****\r\n
;334             badAddr);
	.debug	# 334
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @11+231)
	ld	c,phys @11+231 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;335 }
@70:
@64:
	.debug	} @64 335

@63	equ	10
	ld	sp,ix
	pop	ix
	lret
@65	equ	12
;336 
;337 //-------------------------------------------------------------------------
;338 //  copy the entire config_table to flash
;339 //-------------------------------------------------------------------------
;340 static void  update_config(void)
;341 {
$update_config:
	.debug	F $update_config 47 9
	.debug	{ $update_config 47 340 @73 @72
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
;342   int  stat;
	.debug	L stat -2 6
;343   FlDWord  badAddr;
	.debug	L badAddr -6 9
;344 
;345 
;346   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 346
	ld	a,(__disabled)
	or	a,a
	jr	nz,@74
	ld	de,word (phys @11+283)
	ld	c,phys @11+283 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;347 
;348   init_file_data();
@74:
	.debug	# 348
	lcall	$init_file_data
;349 
;350   WDT_2S();
	.debug	# 350
  ld  a,0x5A
  ioi ld  (0x08),a
;351 
;352   _FlashUnlock = ~param_start;
	.debug	# 352
	ld	de,(_param_start)
	ld	bc,(_param_start+2)
	call	__lnot##
	ld	(__FlashUnlock),de
	ld	(__FlashUnlock+2),bc
;353 
;354   stat = WriteFlash((FlByte const far *)param_start,
;355                     (FlByte far *)config_table, sizeof(CONFIG_TABLE));
	.debug	# 355
	ld	de,0xf5a
	ld	bc,0
	push	bc
	push	de
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,(_param_start)
	ld	bc,(_param_start+2)
	push	bc
	push	de
	lcall	$WriteFlash
	add	sp,12
	ld	(ix-2),hl
;356 
;357   if (stat)  badAddr = FlashError();
	.debug	# 357
	bool	hl
	jr	z,@75
	lcall	$FlashError
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;358 
;359   if (stat)
@75:
	.debug	# 359
	ld	hl,(ix-2)
	bool	hl
	jr	z,@76
;360     fprintf(DiagLog, "***** Error writing to flash address: %06lX *****\r\n
;361             badAddr);
	.debug	# 361
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @11+231)
	ld	c,phys @11+231 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,10
;362 }
@76:
@72:
	.debug	} @72 362

@71	equ	6
	ld	sp,ix
	pop	ix
	lret
@73	equ	8
;363 
;364 
;365 //-------------------------------------------------------------------------
;366 //  Return the number of bytes in unused sectors of flash
;367 //-------------------------------------------------------------------------
;368 long int ffile_free(void)
;369 {
$ffile_free::
	.debug	G $ffile_free 48 9
	.debug	{ $ffile_free 48 368 @79 @78
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
;370   unsigned  i;
	.debug	L i -2 7
;371   long int  free = 0l;
	.debug	L free -6 8
	.debug	# 371
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
	.seg	FARCODE
;372 
;373   if (!init_file_data())  return FERR_NOXMEM;
	.debug	# 373
	lcall	$init_file_data
	bool	hl
	jr	nz,@80
	ld	de,0xfffd
	ld	c,d
	ld	b,d
	jr	@78
;374 
;375   KLOCK();
@80:
	.debug	# 375
	call	_KLOCK
;376 
;377   for (i=0; i<config_table->num_blocks; i++)
@81:
	.debug	< @81 @82
	.debug	# 377
	bool	hl
	ld	l,h
	ld	(ix-2),hl
@83:
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61a
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-2)
	or	a,a
	sbc	hl,de
	jr	nc,@84
;378     if (config_table->nextBlock[i] == 0)  free += sector_size;
	.debug	# 378
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61e
	ld	bc,0
	call	__ladd##
	ld	hl,(ix-2)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	call	__ladd##
	call	__farld2##
	ld	a,e
	or	a,d
	jr	nz,@86
	ld	hl,(_sector_size)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;379 
;380   KUNLOCK();
@86:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@83
@84:
@82:
	.debug	>
	.debug	# 380
	call	_KUNLOCK
;381 
;382   return free;
	.debug	# 382
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
;383 }
@78:
	.debug	} @78 383

@77	equ	6
	ld	sp,ix
	pop	ix
	lret
@79	equ	8
;384 
;385 
;386 //-------------------------------------------------------------------------
;387 //  Return the next unused file handle (an index in to the table of opened
;388 //  files).  Returns < 0 if all handles are in use.
;389 //-------------------------------------------------------------------------
;390 static int next_handle(void)
;391 {
$next_handle:
	.debug	F $next_handle 34 9
	.debug	{ $next_handle 34 390 @89 @88
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;392   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 392
	ld	a,(__disabled)
	or	a,a
	jr	nz,@90
	ld	de,word (phys @11+297)
	ld	c,phys @11+297 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;393 
;394   init_file_data();
@90:
	.debug	# 394
	lcall	$init_file_data
;395 
;396   for (int hdl=0; hdl<DOPEN_FILES; hdl++)
@91:
	.debug	< @91 @92
	.debug	L hdl -2 6
	.debug	# 396
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	.seg	FARCODE
@93:
	ld	hl,(ix-2)
	ld	de,0x8004
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@94
;397     if (! openFiles[hdl].flags) return hdl;
	.debug	# 397
	ld	hl,(ix-2)
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	nz,@96
	ld	hl,(ix-2)
	jr	@88
;398 
;399   return FERR_TOOMANYFILES;
@96:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jr	@93
@94:
@92:
	.debug	>
	.debug	# 399
	ld	hl,0xfffe
;400 }
@88:
	.debug	} @88 400

@87	equ	2
	ld	sp,ix
	pop	ix
	lret
@89	equ	4
;401 
;402 //-------------------------------------------------------------------------
;403 //  Return the index for the next unused file entry in the FAT
;404 //-------------------------------------------------------------------------
;405 static int next_file(void)
;406 {
$next_file:
	.debug	F $next_file 34 9
	.debug	{ $next_file 34 405 @99 @98
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
;407   FILE_ENTRY far *file = config_table->files;
	.debug	L file -4 39
	.debug	# 407
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	.seg	FARCODE
;408 
;409   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 409
	ld	a,(__disabled)
	or	a,a
	jr	nz,@100
	ld	de,word (phys @11+309)
	ld	c,phys @11+309 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;410 
;411   init_file_data();
@100:
	.debug	# 411
	lcall	$init_file_data
;412 
;413   for (unsigned j=0; j<MAX_FILES; j++,++file)
@101:
	.debug	< @101 @102
	.debug	L j -6 7
	.debug	# 413
	bool	hl
	ld	l,h
	ld	(ix-6),hl
	.seg	FARCODE
@103:
	ld	hl,(ix-6)
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jr	nc,@104
;414     if ((file->flags & FILE_ACTIVE) == 0)  return j;
	.debug	# 414
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x66
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x1
	and	hl,de
	jr	nz,@106
	ld	hl,(ix-6)
	jr	@98
;415 
;416   return FERR_TOOMANYFILES;
@106:
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x70
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
	jr	@103
@104:
@102:
	.debug	>
	.debug	# 416
	ld	hl,0xfffe
;417 }
@98:
	.debug	} @98 417

@97	equ	6
	ld	sp,ix
	pop	ix
	lret
@99	equ	8
;418 
;419 //-------------------------------------------------------------------------
;420 //  Return the index in the FAT for the specified file name, or < 0 if the
;421 //  file is not found.
;422 //-------------------------------------------------------------------------
;423 int ffile_index(char * name)
;424 {
$ffile_index::
	.debug	G $ffile_index 49 9
	.debug	{ $ffile_index 49 423 @109 @108
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A name 5 50
;425   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 425
	ld	a,(__disabled)
	or	a,a
	jr	nz,@110
	ld	de,word (phys @11+319)
	ld	c,phys @11+319 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;426 
;427   init_file_data();
@110:
	.debug	# 427
	lcall	$init_file_data
;428 
;429   for (unsigned j=0; j<MAX_FILES; j++)
@111:
	.debug	< @111 @112
	.debug	L j -2 7
	.debug	# 429
	bool	hl
	ld	l,h
	ld	(ix-2),hl
	.seg	FARCODE
@113:
	ld	hl,(ix-2)
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jp	nc,@114
;430     if ((config_table->files[j].flags & (FILE_ACTIVE | FILE_SFLASH))
;431                 == (FILE_ACTIVE)
;432         AND fstrcmp(config_table->files[j].name, name) == 0)
	.debug	# 432
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-2)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	push	bc
	push	de
	ld	de,0x66
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x3
	and	hl,de
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	nz,@117
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-2)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	push	bc
	push	de
	call	_fstrcmp
	add	sp,8
	bool	hl
	jr	nz,@117
;433       return j;
	.debug	# 433
	ld	hl,(ix-2)
	jr	@108
;434 
;435   return FERR_NOTFOUND;
@117:
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
	jp	@113
@114:
@112:
	.debug	>
	.debug	# 435
	ld	hl,0xffff
;436 }
@108:
	.debug	} @108 436

@107	equ	2
	ld	sp,ix
	pop	ix
	lret
@109	equ	4
;437 
;438 //-------------------------------------------------------------------------
;439 //  Allocate memory to manage reads/writes from/to the current sector for a
;440 //  open flash file.
;441 //-------------------------------------------------------------------------
;442 void allocBuf(FILE_DATA *fileState)
;443 {
$allocBuf::
	.debug	G $allocBuf 51 9
	.debug	{ $allocBuf 51 442 @120 @119
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fileState 5 36
;444   fprintf(DiagLog, "For sector buf:\r\n");
	.debug	# 444
	ld	de,word (phys @11+331)
	ld	c,phys @11+331 >> 16
	push	bc
	push	de
	ld	hl,_diagLog
	push	hl
	lcall	$farfprintf
	add	sp,6
;445   fileState->sector_buff = xalloc(sector_size);
	.debug	# 445
	ld	hl,(_sector_size)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	lcall	$xalloc
	add	sp,4
	ld	hl,(ix+5)
	push	de
	ld	de,0xc
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;446 }
@119:
	.debug	} @119 446

@118	equ	0
	pop	ix
	lret
@120	equ	2
;447 
;448 
;449 //-------------------------------------------------------------------------
;450 //  If the file's R/W buffer has been altered, then flush it to flash
;451 //-------------------------------------------------------------------------
;452 static void fflush_file(FILE_DATA *fileState)
;453 {
$fflush_file:
	.debug	F $fflush_file 51 9
	.debug	{ $fflush_file 51 452 @123 @122
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A fileState 5 36
;454   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 454
	ld	a,(__disabled)
	or	a,a
	jr	nz,@124
	ld	de,word (phys @11+349)
	ld	c,phys @11+349 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;455 
;456   init_file_data();
@124:
	.debug	# 456
	lcall	$init_file_data
;457 
;458   if (fileState->flags & FFLAG_WRITE)  {
	.debug	# 458
	ld	hl,(ix+5)
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	ld	e,0x2
	and	hl,de
	jr	z,@125
;459     write_block(fileState->curBlkNum, fileState->sector_buff);
@126:
	.debug	< @126 @127
	.debug	# 459
	ld	hl,(ix+5)
	ld	e,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+5)
	inc	hl
	inc	hl
	ld	hl,(hl)
	push	hl
	lcall	$write_block
	add	sp,6
;460     fileState->flags &= ~FFLAG_WRITE;
	.debug	# 460
	ld	hl,(ix+5)
	ld	de,0x14
	add	hl,de
	push	hl
	ld	hl,(hl)
	res	1,l
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;461     fileState->flags |= FFLAG_UPDATED;
	.debug	# 461
	ld	hl,(ix+5)
	ld	de,0x14
	add	hl,de
	push	hl
	ld	hl,(hl)
	set	2,l
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;462   }
@127:
	.debug	>
;463 }
@125:
@122:
	.debug	} @122 463

@121	equ	0
	pop	ix
	lret
@123	equ	2
;464 
;465 //-------------------------------------------------------------------------
;466 //  Load the sector buffer with a copy of the sector that corresponds to th
;467 //  file's current position.  If the buffer already has data in it, and it
;468 //  is newer than the flash, then it is flushed to flash first.
;469 //
;470 //  Returns the block number on success, (uint)-1 if an error
;471 //-------------------------------------------------------------------------
;472 uint loadBuffer(FILE_ENTRY far *file, FILE_DATA *fileState, bool willWrite)
;473 {
$loadBuffer::
	.debug	G $loadBuffer 52 9
	.debug	{ $loadBuffer 52 472 @130 @129
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-12
	.debug	A file 5 39
	.debug	A fileState 9 36
	.debug	A willWrite 11 3
;474   uint  blk, prevBlk;
	.debug	L blk -2 7
	.debug	L prevBlk -4 7
;475   ulong  sectorPos, curPos;
	.debug	L sectorPos -8 9
	.debug	L curPos -12 9
;476 
;477 
;478   blk = fileState->curBlkNum;  // 0 ==> nothing in the cache/buffer
	.debug	# 478
	ld	hl,(ix+9)
	inc	hl
	inc	hl
	ld	hl,(hl)
	ld	(ix-2),hl
;479 
;480 //--- If the sector_buf currently has data in it, then flush it to flash --
;481 //--- if necessary ---
;482   if (blk)  fflush_file(fileState);
	.debug	# 482
	bool	hl
	jr	z,@131
	ld	hl,(ix+9)
	push	hl
	lcall	$fflush_file
	pop	hl
;483 
;484   curPos = fileState->pos;
@131:
	.debug	# 484
	ld	hl,(ix+9)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-10),hl
	ex	de,hl
	ld	(ix-12),hl
	ex	de,hl
;485 
;486 //--- search forward from current sector, or start at the beginning? ---
;487   if (!blk OR (fileState->sectorPos + sector_size < curPos))  {
	.debug	# 487
	ld	hl,(ix-2)
	bool	hl
	jr	z,@132
	ld	hl,(ix+9)
	ld	de,0x8
	add	hl,de
	ld	de,(_sector_size)
	ld	bc,0
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__lsub##
	jr	nc,@133
@132:
;488     blk = file->startblock;  sectorPos = 0;  }
@134:
	.debug	< @134 @135
	.debug	# 488
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x64
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
@135:
	.debug	>
;489   else
;490     sectorPos = fileState->sectorPos;
	jr	@136
@133:
	.debug	# 490
	ld	hl,(ix+9)
	ld	de,0x8
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;491 
;492   prevBlk = blk;
@136:
	.debug	# 492
	ld	hl,(ix-2)
	ld	(ix-4),hl
;493 
;494 //--- scan forward through the list of blocks assigned to the file until we
;495 //--- locate the one that corresponds to the current file position ---
;496   while (blk AND (blk != EOF_BLK))  {
@137:
	.debug	# 496
	ld	hl,(ix-2)
	bool	hl
	jr	z,@139
	ld	hl,(ix-2)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	z,@139
;497     if ((curPos >= sectorPos) AND (curPos < sectorPos + sector_size)) break
@140:
	.debug	< @140 @141
	.debug	# 497
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lsub##
	jr	c,@143
	ld	hl,(_sector_size)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	call	__lsubr##
	jr	c,@139
;498     prevBlk = blk;
@143:
	.debug	# 498
	ld	hl,(ix-2)
	ld	(ix-4),hl
;499     blk = getNextBlock(blk);  sectorPos += sector_size;
	.debug	# 499
	push	hl
	lcall	$getNextBlock
	pop	de
	ld	(ix-2),hl
	ld	hl,(_sector_size)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;500   }
@141:
	.debug	>
;501 //NOTE:  If we reached the end of the file, then sectorPos should == the
;502 //       current size of the file
;503 
;504 //--- If the block we need is already part of the file, then read it in to 
;505 //--- the buffer ---
;506   if (blk AND (blk != EOF_BLK))  {
	jr	@137
@139:
	.debug	# 506
	ld	hl,(ix-2)
	bool	hl
	jr	z,@145
	ld	hl,(ix-2)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	z,@145
;507 //    fprintf(DiagLog, "--- [%d] load sector %u for file %ls\r\n",   //tdeb
;508 //           fileState - openFiles, blk, file->name);  //tdebug
;509     read_block(blk, fileState->sector_buff);
@146:
	.debug	< @146 @147
	.debug	# 509
	ld	hl,(ix+9)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-2)
	push	hl
	lcall	$read_block
	add	sp,6
;510   }
@147:
	.debug	>
;511 //--- If we ran out of blocks, but the caller is about to write to the file
;512 //--- and the we are currently positioned at the end of the file, then ---
;513 //--- then allocate another block, zero it out, and append it to the file -
;514   else  {
	jp	@148
@145:
;515     if ((curPos != sectorPos) OR !willWrite)  { errno = EBADFD;  return 0; 
@149:
	.debug	< @149 @150
	.debug	# 515
	ld	hl,(ix-12)
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lsub##
	jr	nz,@151
	ld	a,(ix+11)
	or	a,a
	jr	nz,@152
@151:
@153:
	.debug	< @153 @154
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x4d
	jr	@553
@154:
	.debug	>
;516     if ((blk = get_freeblock()) == (uint)-1)  { errno = ENOSPC;  return 0; 
@152:
	.debug	# 516
	lcall	$get_freeblock
	ld	(ix-2),hl
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@155
@156:
	.debug	< @156 @157
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x1c
@553:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	bool	hl
	ld	l,h
	jp	@129
@157:
	.debug	>
;517 //    fprintf(DiagLog, "--- [%d] Append sector %u to file: %ls at pos %lu\r
;518 //            fileState - openFiles, blk, file->name, fileState->pos);  //t
;519     if (sectorPos)
@155:
	.debug	# 519
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	or	hl,de
	jr	z,@158
;520       setNextBlock(prevBlk, blk);
	.debug	# 520
	ld	hl,(ix-2)
	push	hl
	ld	hl,(ix-4)
	push	hl
	lcall	$setNextBlock
	add	sp,4
;521     else
;522       file->startblock = blk;
	jr	@159
@158:
	.debug	# 522
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x64
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-2)
	call	__farst2##
;523     setNextBlock(blk, EOF_BLK);  FBZERO(fileState->sector_buff);
@159:
	.debug	# 523
	ld	hl,0xffff
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setNextBlock
	add	sp,4
	ld	de,0x4
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+9)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;524     fileState->flags |= FFLAG_UPDATED;
	.debug	# 524
	ld	hl,(ix+9)
	ld	de,0x14
	add	hl,de
	push	hl
	ld	hl,(hl)
	set	2,l
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;525   }
@150:
	.debug	>
;526 
;527   fileState->buff_ptr = fileState->sector_buff + (curPos - sectorPos);
@148:
	.debug	# 527
	ld	hl,(ix+9)
	ld	de,0xc
	add	hl,de
	ex	de,hl
	ld	hl,(ix-10)
	ld	bc,hl
	ld	hl,(ix-12)
	ex	de,hl
	push	bc
	push	de
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix-8)
	ex	de,hl
	call	__lsub##
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	ld	hl,(ix+9)
	push	de
	ld	de,0x10
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;528   fileState->curBlkNum = blk;  fileState->sectorPos = sectorPos;
	.debug	# 528
	ld	hl,(ix+9)
	inc	hl
	inc	hl
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix+9)
	ld	de,0x8
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;529 
;530   return blk;
	.debug	# 530
	ld	hl,(ix-2)
;531 }
@129:
	.debug	} @129 531

@128	equ	12
	ld	sp,ix
	pop	ix
	lret
@130	equ	14
;532 
;533 
;534 //-------------------------------------------------------------------------
;535 //  Return a handle for the specified file.  Returns < 0 if the file cannot
;536 //  be opened.
;537 //-------------------------------------------------------------------------
;538 int ffile_open(char * name)
;539 {
$ffile_open::
	.debug	G $ffile_open 49 9
	.debug	{ $ffile_open 49 538 @162 @161
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A name 5 50
;540   int hdl, fatIdx;
	.debug	L hdl -2 6
	.debug	L fatIdx -4 6
;541   FILE_DATA  *fileState;  // state of currently opened file
	.debug	L fileState -6 36
;542 
;543 
;544   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 544
	ld	a,(__disabled)
	or	a,a
	jr	nz,@163
	ld	de,word (phys @11+361)
	ld	c,phys @11+361 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;545 
;546   if (!init_file_data())  return FERR_NOXMEM;
@163:
	.debug	# 546
	lcall	$init_file_data
	bool	hl
	jr	z,@552
;547 
;548 //--- get a handle for opening a file ---
;549   hdl = next_handle();  if (hdl < 0)  return hdl;
	.debug	# 549
	lcall	$next_handle
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@165
	ld	hl,(ix-2)
	jp	@161
;550 
;551 //--- get the index in to the FAT for the specified file ---
;552   fatIdx = ffile_index(name);  if (fatIdx < 0)  return fatIdx;
@165:
	.debug	# 552
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_index
	pop	de
	ld	(ix-4),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@166
	ld	hl,(ix-4)
	jp	@161
;553 
;554   fileState = openFiles + hdl;
@166:
	.debug	# 554
	ld	hl,(ix-2)
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ld	(ix-6),hl
;555 
;556 //--- Many (most?) flash memories require erasing an entire sector before -
;557 //--- writing to it, so we allocate a R/W buffer to hold a copy of the ---
;558 //--- "current" sector (i.e. the one corresponding to the last one we read 
;559 //--- from flash).  The 'flags' value for each open file contains bits that
;560 //--- are set if the buffer contains newer data than the flash (FFLAG_WRITE
;561 //--- and if the FAT has been modified (FFLAG_UPDATED) ---
;562   if (!fileState->sector_buff)  allocBuf(fileState);
	.debug	# 562
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@167
	ld	hl,(ix-6)
	push	hl
	lcall	$allocBuf
	pop	hl
;563   if (!fileState->sector_buff)  return FERR_NOXMEM;
@167:
	.debug	# 563
	ld	hl,(ix-6)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@168
@552:
	ld	hl,0xfffd
	jr	@161
;564 
;565 //--- initialize the rest of the file handle ---
;566   fileState->buff_ptr = fileState->sector_buff;
@168:
	.debug	# 566
	ld	hl,(ix-6)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-6)
	push	de
	ld	de,0x10
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;567   fileState->fatIdx = fatIdx;
	.debug	# 567
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;568   fileState->curBlkNum = 0;  // indicates no data in r/w buffer
	.debug	# 568
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
;569   fileState->pos = 0;
	.debug	# 569
	ld	hl,(ix-6)
	ld	e,0x4
	add	hl,de
	ld	e,d
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;570   fileState->flags = FFLAG_OPEN;
	.debug	# 570
	ld	hl,(ix-6)
	ld	de,0x14
	add	hl,de
	ld	de,0x1
	ld	(hl),e
	inc	hl
	ld	(hl),d
;571 
;572   return hdl;
	.debug	# 572
	ld	hl,(ix-2)
;573 }
@161:
	.debug	} @161 573

@160	equ	6
	ld	sp,ix
	pop	ix
	lret
@162	equ	8
;574 
;575 //-------------------------------------------------------------------------
;576 //  Close an open file, flushing any unwritten data from the write buffer
;577 //  and updating the FAT table in flash if any info on the file has changed
;578 //-------------------------------------------------------------------------
;579 void ffile_close(int handle)
;580 {
$ffile_close::
	.debug	G $ffile_close 53 9
	.debug	{ $ffile_close 53 579 @171 @170
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A handle 5 6
;581   FILE_DATA  *fileState;
	.debug	L fileState -2 36
;582 
;583   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 583
	ld	a,(__disabled)
	or	a,a
	jr	nz,@172
	ld	de,word (phys @11+372)
	ld	c,phys @11+372 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;584 
;585   if (!(fileState = validHandle(handle, NULL)))  { errno = EBADF;  return; 
@172:
	.debug	# 585
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$validHandle
	add	sp,4
	ld	(ix-2),hl
	bool	hl
	jr	nz,@173
@174:
	.debug	< @174 @175
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@170
@175:
	.debug	>
;586 
;587   if (fileState->flags & FFLAG_WRITE)  fflush_file(fileState);
@173:
	.debug	# 587
	ld	hl,(ix-2)
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	ld	e,0x2
	and	hl,de
	jr	z,@176
	ld	hl,(ix-2)
	push	hl
	lcall	$fflush_file
	pop	hl
;588   if (fileState->flags & FFLAG_UPDATED)  update_config();
@176:
	.debug	# 588
	ld	hl,(ix-2)
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	ld	e,0x4
	and	hl,de
	jr	z,@177
	lcall	$update_config
;589 
;590 //  if (fileState->sector_buff)  {
;591 //    farfree(fileState->sector_buff);  fileState->sector_buff = NULL;  }
;592 
;593   fileState->flags = 0;
@177:
	.debug	# 593
	ld	hl,(ix-2)
	ld	de,0x14
	add	hl,de
	ld	e,d
	ld	(hl),e
	inc	hl
	ld	(hl),d
;594 }
@170:
	.debug	} @170 594

@169	equ	2
	ld	sp,ix
	pop	ix
	lret
@171	equ	4
;595 
;596 //-------------------------------------------------------------------------
;597 //  Delete a flash file by name.
;598 //
;599 //  Returns 0 on success, < 0 if an error
;600 //-------------------------------------------------------------------------
;601 int ffile_delete(char *name)
;602 {
$ffile_delete::
	.debug	G $ffile_delete 49 9
	.debug	{ $ffile_delete 49 601 @180 @179
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A name 5 50
;603   int  index;
	.debug	L index -2 6
;604 
;605   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 605
	ld	a,(__disabled)
	or	a,a
	jr	nz,@181
	ld	de,word (phys @11+384)
	ld	c,phys @11+384 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;606 
;607   init_file_data();
@181:
	.debug	# 607
	lcall	$init_file_data
;608 
;609   if ((index = ffile_index(name)) < 0)  { ERRNO = ENOENT;  return -1; }
	.debug	# 609
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_index
	pop	de
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@182
@183:
	.debug	< @183 @184
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x2
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@551
@184:
	.debug	>
;610 
;611   if (ffile_delete_index(index) < 0)  return -1;
@182:
	.debug	# 611
	ld	hl,(ix-2)
	push	hl
	lcall	$ffile_delete_index
	pop	de
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@185
@551:
	ld	hl,0xffff
	jr	@179
;612 
;613   return 0;
@185:
	.debug	# 613
	bool	hl
	ld	l,h
;614 }
@179:
	.debug	} @179 614

@178	equ	2
	ld	sp,ix
	pop	ix
	lret
@180	equ	4
;615 
;616 //-------------------------------------------------------------------------
;617 //  Delete the file for the specified file table index
;618 //
;619 //  Returns the index # on success (>= 0), or < 0 if an error;
;620 //-------------------------------------------------------------------------
;621 int ffile_delete_index(int fatIdx)
;622 {
$ffile_delete_index::
	.debug	G $ffile_delete_index 54 9
	.debug	{ $ffile_delete_index 54 621 @188 @187
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A fatIdx 5 6
;623   unsigned block;
	.debug	L block -2 7
;624   FILE_DATA  *fileState;  // state of currently opened file
	.debug	L fileState -4 36
;625   FILE_ENTRY far *file;   // ptr to FAT entry
	.debug	L file -8 39
;626 
;627 
;628   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 628
	ld	a,(__disabled)
	or	a,a
	jr	nz,@189
	ld	de,word (phys @11+397)
	ld	c,phys @11+397 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;629 
;630   if (!init_file_data())  { ERRNO = ENOMEM;  return FERR_NOXMEM; }
@189:
	.debug	# 630
	lcall	$init_file_data
	bool	hl
	jr	nz,@190
@191:
	.debug	< @191 @192
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xfffd
	jp	@187
@192:
	.debug	>
;631 
;632   if ((fatIdx < 0) OR (fatIdx >= MAX_FILES)) { ERRNO = ENOENT;  return -1; 
@190:
	.debug	# 632
	ld	hl,(ix+5)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@193
	ld	hl,(ix+5)
	ld	e,0xc
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@194
@193:
@195:
	.debug	< @195 @196
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x2
	jr	@550
@196:
	.debug	>
;633 
;634 //--- make sure the file is not in use ---
;635   for (uint ui=0; ui<DOPEN_FILES; ++ui)  {
@194:
@197:
	.debug	< @197 @198
	.debug	L ui -10 7
	.debug	# 635
	bool	hl
	ld	l,h
	ld	(ix-10),hl
	.seg	FARCODE
@199:
	ld	hl,(ix-10)
	ld	de,0x4
	or	a,a
	sbc	hl,de
	jr	nc,@200
;636     fileState = openFiles + ui;
@202:
	.debug	< @202 @203
	.debug	# 636
	ld	hl,(ix-10)
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ld	(ix-4),hl
;637     if (!fileState->flags)  continue;  // 0 means unused element in openFil
	.debug	# 637
	ld	de,0x14
	add	hl,de
	ld	hl,(hl)
	bool	hl
	jr	z,@201
;638     if (fileState->fatIdx == fatIdx) { ERRNO = EBUSY;  return -1; }
	.debug	# 638
	ld	hl,(ix-4)
	ld	hl,(hl)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	nz,@205
@206:
	.debug	< @206 @207
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x10
@550:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@187
@207:
	.debug	>
;639   }
@205:
@203:
	.debug	>
;640 
;641   file = config_table->files + (uint)fatIdx;
@201:
	ld	hl,(ix-10)
	inc	hl
	ld	(ix-10),hl
	jr	@199
@200:
@198:
	.debug	>
	.debug	# 641
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+5)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;642 
;643   block = (uint)file->startblock;
	.debug	# 643
	push	bc
	push	de
	ld	de,0x64
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-2),hl
;644 
;645   // FAT will have 0 size
;646   if (file->size)
	.debug	# 646
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,bc
	or	hl,de
	jr	z,@208
;647     while (block AND (block != EOF_BLK))  {
@209:
	.debug	# 647
	ld	hl,(ix-2)
	bool	hl
	jr	z,@211
	ld	hl,(ix-2)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	z,@211
;648       unsigned nxt = getNextBlock(block);
@212:
	.debug	< @212 @213
	.debug	L nxt -10 7
	.debug	# 648
	ld	hl,(ix-2)
	push	hl
	lcall	$getNextBlock
	pop	de
	ld	(ix-10),hl
	.seg	FARCODE
;649       setNextBlock(block, 0);  block = nxt;
	.debug	# 649
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-2)
	push	hl
	lcall	$setNextBlock
	add	sp,4
	ld	hl,(ix-10)
	ld	(ix-2),hl
;650     }
@213:
	.debug	>
;651 
;652   fmemset(file, 0, sizeof(FILE_ENTRY));
	jr	@209
@211:
@208:
	.debug	# 652
	ld	de,0x70
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;653 
;654   if (config_table->backup == fatIdx + 1)  config_table->backup = 0;
	.debug	# 654
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c9
	ld	bc,0
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	hl,(ix+5)
	inc	hl
	ld	d,0
	ld	e,a
	or	a,a
	sbc	hl,de
	jr	nz,@214
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c9
	ld	bc,0
	call	__ladd##
	xor	a,a
	call	__farst1##
;655   if (config_table->primary == fatIdx + 1)  config_table->primary = 0;
@214:
	.debug	# 655
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c8
	ld	bc,0
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	hl,(ix+5)
	inc	hl
	ld	d,0
	ld	e,a
	or	a,a
	sbc	hl,de
	jr	nz,@215
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c8
	ld	bc,0
	call	__ladd##
	xor	a,a
	call	__farst1##
;656 
;657   update_config();
@215:
	.debug	# 657
	lcall	$update_config
;658 
;659   return fatIdx;
	.debug	# 659
	ld	hl,(ix+5)
;660 }
@187:
	.debug	} @187 660

@186	equ	10
	ld	sp,ix
	pop	ix
	lret
@188	equ	12
;661 
;662 //-------------------------------------------------------------------------
;663 //  Create an entry in the file table for a new file, open it, and return t
;664 //  handle for the open file
;665 //-------------------------------------------------------------------------
;666 int ffile_create(char * name)
;667 {
$ffile_create::
	.debug	G $ffile_create 49 9
	.debug	{ $ffile_create 49 666 @218 @217
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A name 5 50
;668   int hdl, idx;
	.debug	L hdl -2 6
	.debug	L idx -4 6
;669   FILE_ENTRY far  *file;  // ptr to FAT entry
	.debug	L file -8 39
;670   FILE_DATA  *fileState;  // state of currently opened file
	.debug	L fileState -10 36
;671 
;672 
;673 //fprintf(DiagLog, "creating file: [%s]\n", name);  //tdebug
;674 
;675   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 675
	ld	a,(__disabled)
	or	a,a
	jr	nz,@219
	ld	de,word (phys @11+416)
	ld	c,phys @11+416 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;676 
;677   if (!init_file_data())  return FERR_NOXMEM;
@219:
	.debug	# 677
	lcall	$init_file_data
	bool	hl
	jp	z,@549
;678 
;679 //--- get a handle for opening a file ---
;680   hdl = next_handle();  if (hdl < 0)  return hdl;
	.debug	# 680
	lcall	$next_handle
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@221
	ld	hl,(ix-2)
	jp	@217
;681 
;682 //fprintf(DiagLog, "Using handle: %d\n", hdl);  //tdebug
;683 
;684 //--- make sure a file with the specified name doesn't already exist ---
;685   idx = ffile_index(name);  if (idx >= 0)  return FERR_FILE_EXISTS;
@221:
	.debug	# 685
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_index
	pop	de
	ld	(ix-4),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@222
	ld	hl,0xfffc
	jp	@217
;686 
;687 //--- get an unused entry in the file table ---
;688   idx = next_file();  if (idx < 0)  return idx;
@222:
	.debug	# 688
	lcall	$next_file
	ld	(ix-4),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@223
	ld	hl,(ix-4)
	jp	@217
;689 
;690 //fprintf(DiagLog, "File Index: %d\n", idx);  //tdebug
;691 
;692   file = config_table->files + (uint) idx;
@223:
	.debug	# 692
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-4)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;693   fileState = openFiles + hdl;
	.debug	# 693
	ld	hl,(ix-2)
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ld	(ix-10),hl
;694 
;695 //--- allocate a buffer for partial sector reads and writes ---
;696   if (!fileState->sector_buff)  allocBuf(fileState);
	.debug	# 696
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@224
	ld	hl,(ix-10)
	push	hl
	lcall	$allocBuf
	pop	hl
;697   if (!fileState->sector_buff)  return FERR_NOXMEM;
@224:
	.debug	# 697
	ld	hl,(ix-10)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	a,e
	or	a,d
	or	a,c
	jr	nz,@225
@549:
	ld	hl,0xfffd
	jp	@217
;698 
;699 //--- initialize the new file table entry and the file handle ---
;700   fmemset(file, 0, sizeof(FILE_ENTRY));
@225:
	.debug	# 700
	ld	de,0x70
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;701   fstrcpy(file->name, name);
	.debug	# 701
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;702   file->flags = FILE_ACTIVE;
	.debug	# 702
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x66
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,0x1
	call	__farst2##
;703   file->date = time(NULL);  //readRTC(NULL);
	.debug	# 703
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6c
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
;704 
;705   fileState->buff_ptr = fileState->sector_buff;
	.debug	# 705
	ld	hl,(ix-10)
	ld	de,0xc
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(ix-10)
	push	de
	ld	de,0x10
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;706   fileState->fatIdx = idx;
	.debug	# 706
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;707   fileState->curBlkNum = 0;
	.debug	# 707
	ld	hl,(ix-10)
	inc	hl
	inc	hl
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
;708   fileState->pos = 0;
	.debug	# 708
	ld	hl,(ix-10)
	ld	e,0x4
	add	hl,de
	ld	e,d
	ld	c,e
	ld	b,e
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;709   fileState->flags = FFLAG_OPEN | FFLAG_UPDATED;
	.debug	# 709
	ld	hl,(ix-10)
	ld	de,0x14
	add	hl,de
	ld	de,0x5
	ld	(hl),e
	inc	hl
	ld	(hl),d
;710 
;711   return hdl;
	.debug	# 711
	ld	hl,(ix-2)
;712 }
@217:
	.debug	} @217 712

@216	equ	10
	ld	sp,ix
	pop	ix
	lret
@218	equ	12
;713 
;714 //-------------------------------------------------------------------------
;715 //  Create an entry in the file table for a new file and return its index
;716 //  in the file table
;717 //-------------------------------------------------------------------------
;718 int ffile_FATLink(char * name)
;719 {
$ffile_FATLink::
	.debug	G $ffile_FATLink 49 9
	.debug	{ $ffile_FATLink 49 718 @228 @227
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A name 5 50
;720   int fatIdx;
	.debug	L fatIdx -2 6
;721   FILE_ENTRY far  *file;  // ptr to FAT entry
	.debug	L file -6 39
;722 
;723 
;724   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 724
	ld	a,(__disabled)
	or	a,a
	jr	nz,@229
	ld	de,word (phys @11+429)
	ld	c,phys @11+429 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;725 
;726   if (!init_file_data())  return FERR_NOXMEM;
@229:
	.debug	# 726
	lcall	$init_file_data
	bool	hl
	jr	nz,@230
	ld	hl,0xfffd
	jp	@227
;727 
;728 //--- make sure a file with the specified name doesn't already exist ---
;729   fatIdx = ffile_index(name);  if (fatIdx >= 0)  return FERR_FILE_EXISTS;
@230:
	.debug	# 729
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_index
	pop	de
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@231
	ld	hl,0xfffc
	jp	@227
;730 
;731 //--- get an unused entry in the file table ---
;732   fatIdx = next_file();  if (fatIdx < 0)  return fatIdx;
@231:
	.debug	# 732
	lcall	$next_file
	ld	(ix-2),hl
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@232
	ld	hl,(ix-2)
	jr	@227
;733 
;734   file = config_table->files + (uint) fatIdx;
@232:
	.debug	# 734
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-2)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;735 
;736 //--- initialize the entry ---
;737   fmemset(file, 0, sizeof(FILE_ENTRY));
	.debug	# 737
	ld	de,0x70
	ld	c,d
	ld	b,d
	push	bc
	push	de
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	call	_fmemset
	add	sp,10
;738   fstrcpy(file->name, name);
	.debug	# 738
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;739   file->flags = FILE_ACTIVE | FILE_SFLASH;
	.debug	# 739
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x66
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,0x3
	call	__farst2##
;740 
;741 //--- save the update FAT to flash ---
;742   update_config();
	.debug	# 742
	lcall	$update_config
;743 
;744   return fatIdx;
	.debug	# 744
	ld	hl,(ix-2)
;745 }
@227:
	.debug	} @227 745

@226	equ	6
	ld	sp,ix
	pop	ix
	lret
@228	equ	8
;746 
;747 //-------------------------------------------------------------------------
;748 //  Return the current size of a currently open file
;749 //
;750 //  Returns >= 0 on success, < 0 if an error
;751 //-------------------------------------------------------------------------
;752 long ffile_size(int handle)
;753 {
$ffile_size::
	.debug	G $ffile_size 55 9
	.debug	{ $ffile_size 55 752 @235 @234
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A handle 5 6
;754   FILE_ENTRY far *file;  // FAT entry for the file
	.debug	L file -4 39
;755 
;756   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 756
	ld	a,(__disabled)
	or	a,a
	jr	nz,@236
	ld	de,word (phys @11+443)
	ld	c,phys @11+443 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;757 
;758   if (!validHandle(handle, &file))  { errno = EBADF;  return -1; }
@236:
	.debug	# 758
	ld	hl,-4+@233
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$validHandle
	add	sp,4
	bool	hl
	jr	nz,@237
@238:
	.debug	< @238 @239
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	de,0xffff
	ld	c,e
	ld	b,e
	jr	@234
@239:
	.debug	>
;759 
;760   return file->size;
@237:
	.debug	# 760
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
;761 }
@234:
	.debug	} @234 761

@233	equ	4
	ld	sp,ix
	pop	ix
	lret
@235	equ	6
;762 
;763 
;764 //-------------------------------------------------------------------------
;765 //  Return the size of a file given its name
;766 //
;767 //  Returns >= 0 on success, < 0 if an error
;768 //-------------------------------------------------------------------------
;769 long ffile_sizen(char * name)
;770 {
$ffile_sizen::
	.debug	G $ffile_sizen 56 9
	.debug	{ $ffile_sizen 56 769 @242 @241
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A name 5 50
;771   long index;
	.debug	L index -4 8
;772 
;773   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 773
	ld	a,(__disabled)
	or	a,a
	jr	nz,@243
	ld	de,word (phys @11+454)
	ld	c,phys @11+454 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;774 
;775   init_file_data();
@243:
	.debug	# 775
	lcall	$init_file_data
;776 
;777   index = ffile_index(name);
	.debug	# 777
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_index
	pop	de
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;778 
;779   if (index < 0)  return -1;
	.debug	# 779
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jr	nc,@244
	ld	de,0xffff
	ld	c,e
	ld	b,e
	jr	@241
;780 
;781   return config_table->files[index].size;
@244:
	.debug	# 781
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x70
	ld	c,d
	ld	b,d
	call	__ulmlt##
	call	__ladd##
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
;782 }
@241:
	.debug	} @241 782

@240	equ	4
	ld	sp,ix
	pop	ix
	lret
@242	equ	6
;783 
;784 //-------------------------------------------------------------------------
;785 //  Return a copy of the name of a file given its FAT index.
;786 //
;787 //  Returns the string "<invalid>" if the FAT index is not valid.
;788 //-------------------------------------------------------------------------
;789 void ffile_name(unsigned int fatIdx, char *name)
;790 {
$ffile_name::
	.debug	G $ffile_name 57 9
	.debug	{ $ffile_name 57 789 @247 @246
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A fatIdx 5 7
	.debug	A name 7 50
;791   char far *ptr;
	.debug	L ptr -4 46
;792   FILE_ENTRY far *file = config_table->files + fatIdx;
	.debug	L file -8 39
	.debug	# 792
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+5)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
	.seg	FARCODE
;793 
;794 
;795   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 795
	ld	a,(__disabled)
	or	a,a
	jr	nz,@248
	ld	de,word (phys @11+466)
	ld	c,phys @11+466 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;796 
;797   init_file_data();
@248:
	.debug	# 797
	lcall	$init_file_data
;798 
;799   if (fatIdx >= MAX_FILES)  ptr = "<invalid>";  else
	.debug	# 799
	ld	hl,(ix+5)
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jr	c,@249
	ld	de,word (phys @11+477)
	ld	c,phys @11+477 >> 16
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;800   if (! (file->flags & FILE_ACTIVE))  ptr = "<invalid>";  else
	jr	@250
@249:
	.debug	# 800
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x66
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x1
	and	hl,de
	jr	nz,@251
	ld	de,word (phys @11+477)
	ld	c,phys @11+477 >> 16
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;801   ptr = file->name;
	jr	@252
@251:
	.debug	# 801
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;802 
;803   fstrcpy(name, ptr);
@252:
@250:
	.debug	# 803
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;804 }
@246:
	.debug	} @246 804

@245	equ	8
	ld	sp,ix
	pop	ix
	lret
@247	equ	10
;805 
;806 //-------------------------------------------------------------------------
;807 //  Return current position for the specified open file
;808 //-------------------------------------------------------------------------
;809 long ffile_tell(int handle)
;810 {
$ffile_tell::
	.debug	G $ffile_tell 55 9
	.debug	{ $ffile_tell 55 809 @255 @254
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A handle 5 6
;811   FILE_DATA *fileState;
	.debug	L fileState -2 36
;812 
;813   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 813
	ld	a,(__disabled)
	or	a,a
	jr	nz,@256
	ld	de,word (phys @11+487)
	ld	c,phys @11+487 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;814 
;815   if (!(fileState = validHandle(handle, NULL)))  { errno = EBADF;  return -
@256:
	.debug	# 815
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$validHandle
	add	sp,4
	ld	(ix-2),hl
	bool	hl
	jr	nz,@257
@258:
	.debug	< @258 @259
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	de,0xffff
	ld	c,e
	ld	b,e
	jr	@254
@259:
	.debug	>
;816 
;817   return fileState->pos;
@257:
	.debug	# 817
	ld	hl,(ix-2)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
;818 }
@254:
	.debug	} @254 818

@253	equ	2
	ld	sp,ix
	pop	ix
	lret
@255	equ	4
;819 
;820 //-------------------------------------------------------------------------
;821 //  Change current file position relative to start, cur pos, or end of file
;822 //  Returns 0 on success or < 0 if an error
;823 //-------------------------------------------------------------------------
;824 int ffile_seek(int handle, long pos, int mode)
;825 {
$ffile_seek::
	.debug	G $ffile_seek 58 9
	.debug	{ $ffile_seek 58 824 @262 @261
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-14
	.debug	A handle 5 6
	.debug	A pos 7 8
	.debug	A mode 11 6
;826   ulong  newPos, sectorPos;
	.debug	L newPos -4 9
	.debug	L sectorPos -8 9
;827   FILE_DATA *fileState;  // state of currently opened file
	.debug	L fileState -10 36
;828   FILE_ENTRY far *file;  // ptr to FAT entry
	.debug	L file -14 39
;829 
;830 
;831   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 831
	ld	a,(__disabled)
	or	a,a
	jr	nz,@263
	ld	de,word (phys @11+498)
	ld	c,phys @11+498 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;832 
;833   if (!(fileState = validHandle(handle, &file)))  {
@263:
	.debug	# 833
	ld	hl,-14+@260
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$validHandle
	add	sp,4
	ld	(ix-10),hl
	bool	hl
	jr	nz,@264
;834     errno = EBADF;  return FERR_SEEK; }
@265:
	.debug	< @265 @266
	.debug	# 834
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jp	@546
@266:
	.debug	>
;835 
;836 //fprintf(DiagLog, "ffile_seek_(%d, %ld, %d), cur pos: %lu)\r\n",  //tdebug
;837 //        handle, pos, mode, fileState->pos);
;838 
;839 //--- Change the position value so it is an offset from the start ---
;840   switch (mode)  {
@264:
	.debug	# 840
	ld	hl,(ix+11)
	jp	@267
;841     case FSEEK_SET:  // pos value is already an offset from the start
@269:
	.debug	< @269 @270
;842       if (pos < 0)  return FERR_SEEK;
	.debug	# 842
@271:
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jp	c,@545
;843       newPos = (ulong) pos;  break;
	.debug	# 843
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	jr	@548
;844 
;845     case FSEEK_END:  // passed value should be offset from end (i.e. < 0)
;846       if (pos > 0)  return FERR_SEEK;
	.debug	# 846
@273:
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0
	ld	c,e
	ld	b,e
	call	__lcmp##
	jr	c,@274
	jp	nz,@545
;847       pos = -pos;
@274:
	.debug	# 847
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	call	__lneg##
	ld	hl,bc
	ld	(ix+9),hl
	ex	de,hl
	ld	(ix+7),hl
	ex	de,hl
;848       newPos = file->size - (ulong)pos;  break;
	.debug	# 848
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	call	__lsub##
	jr	@547
;849 
;850     case FSEEK_CUR:  // passed value is an offset from current position
;851       if (!pos)  return 0; // no move, so just exit
	.debug	# 851
@275:
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	or	hl,de
	jp	z,@544
;852       newPos = pos + fileState->pos;  break;
	.debug	# 852
	ld	hl,(ix-10)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	call	__ladd##
@547:
	ld	hl,bc
@548:
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;853 
;854     default:
	jr	@268
;855       errno = EINVAL;  return FERR_SEEK;
	.debug	# 855
@277:
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
@546:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@545
;856   }
@270:
	.debug	>
;857 
;858 //--- Is the resulting position past the end of the file? ---
;859   if (newPos > file->size)  return FERR_SEEK;
@267:
	ex	de,hl
	ld	a,d
	or	a,e
	jp	z,@271
	ld	hl,0xffffffff
	add	hl,de
	bool	hl
	jr	z,@275
	ld	hl,0xfffffffe
	add	hl,de
	bool	hl
	jp	z,@273
	jr	@277
@268:
	.debug	# 859
	ld	hl,(ix-14)
	ex	de,hl
	ld	hl,(ix-12)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsubr##
	jr	c,@278
	jr	z,@278
@545:
	ld	hl,0xfffb
	jp	@261
;860 
;861 //--- If the R/W buffer doesn't have any data in it, then just update the -
;862 //--- position value ---
;863   if (fileState->curBlkNum == 0)  { fileState->pos = newPos;  return 0; }
@278:
	.debug	# 863
	ld	hl,(ix-10)
	inc	hl
	inc	hl
	ld	hl,(hl)
	bool	hl
	jr	nz,@279
@280:
	.debug	< @280 @281
	ld	hl,(ix-10)
	ld	de,0x4
	jp	@543
@281:
	.debug	>
;864 
;865 
;866 //--- If the new position is outside the current buffer's contents, then --
;867 //--- flush the buffer to flash (if needed) and "clear" the buffer (i.e. --
;868 //--- we set its blockNum to 0 to indicate it does not contain a copy of --
;869 //--- the sector corresponding to the current file position) ---
;870 
;871   sectorPos = fileState->pos - (fileState->buff_ptr - fileState->sector_buf
@279:
	.debug	# 871
	ld	hl,(ix-10)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	bc,hl
	ld	hl,0x10
	add	hl,de
	push	bc
	ld	bc,hl
	ld	hl,0xc
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;872   if ((newPos < sectorPos) OR (newPos >= (sectorPos + sector_size)))  {
	.debug	# 872
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__lsub##
	jr	c,@282
	ld	hl,(_sector_size)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsubr##
	jr	c,@283
@282:
;873     fflush_file(fileState);
@284:
	.debug	< @284 @285
	.debug	# 873
	ld	hl,(ix-10)
	push	hl
	lcall	$fflush_file
	pop	hl
;874     fileState->curBlkNum = 0;  fileState->pos = newPos;  return 0;
	.debug	# 874
	ld	hl,(ix-10)
	inc	hl
	inc	hl
	ld	de,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,(ix-10)
	ld	e,0x4
@543:
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
@544:
	bool	hl
	ld	l,h
	jp	@261
;875   }
@285:
	.debug	>
;876 
;877 //--- The new position is within the buffer, so just update buff_ptr ---
;878   if (fileState->pos >= newPos)
@283:
	.debug	# 878
	ld	hl,(ix-10)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsub##
	jr	c,@286
;879     fileState->buff_ptr -= (fileState->pos - newPos);
	.debug	# 879
	ld	hl,(ix-10)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsub##
	ld	hl,(ix-10)
	push	bc
	push	de
	ld	de,0x10
	add	hl,de
	pop	iy
	pop	af
	push	hl
	push	af
	push	iy
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;880   else
;881     fileState->buff_ptr += (newPos - fileState->pos);
	jr	@287
@286:
	.debug	# 881
	ld	hl,(ix-10)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	call	__lsubr##
	ld	hl,(ix-10)
	push	bc
	push	de
	ld	de,0x10
	add	hl,de
	pop	iy
	pop	af
	push	hl
	push	af
	push	iy
	pop	de
	pop	bc
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;882 
;883   fileState->pos = newPos;
@287:
	.debug	# 883
	ld	hl,(ix-10)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
	ld	hl,(ix-4)
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;884 
;885   return 0;
	.debug	# 885
	bool	hl
	ld	l,h
;886 }
@261:
	.debug	} @261 886

@260	equ	14
	ld	sp,ix
	pop	ix
	lret
@262	equ	16
;887 
;888 //-------------------------------------------------------------------------
;889 //  Read the specified # of bytes from an open file in to the provided buff
;890 //  Returns the # of bytes read.
;891 //-------------------------------------------------------------------------
;892 int ffile_read(int handle, char far * buff, int bytes)
;893 {
$ffile_read::
	.debug	G $ffile_read 59 9
	.debug	{ $ffile_read 59 892 @290 @289
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A handle 5 6
	.debug	A buff 7 46
	.debug	A bytes 11 6
;894   unsigned  numleft, read;
	.debug	L numleft -2 7
	.debug	L read -4 7
;895   FILE_DATA  *fileState;  // state of currently opened file
	.debug	L fileState -6 36
;896   FILE_ENTRY  far *file;  // ptr to FAT entry
	.debug	L file -10 39
;897 
;898 
;899   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 899
	ld	a,(__disabled)
	or	a,a
	jr	nz,@291
	ld	de,word (phys @11+509)
	ld	c,phys @11+509 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;900 
;901   if (!(fileState = validHandle(handle, &file)))  { errno = EBADF;  return 
@291:
	.debug	# 901
	ld	hl,-10+@288
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$validHandle
	add	sp,4
	ld	(ix-6),hl
	bool	hl
	jr	nz,@292
@293:
	.debug	< @293 @294
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jr	@542
@294:
	.debug	>
;902 
;903   if (bytes < 0)  { errno = EINVAL;  return -1; }
@292:
	.debug	# 903
	ld	hl,(ix+11)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@295
@296:
	.debug	< @296 @297
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
@542:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@289
@297:
	.debug	>
;904 
;905   if (bytes == 0)  return 0;
@295:
	.debug	# 905
	ld	hl,(ix+11)
	bool	hl
	jr	nz,@298
	bool	hl
	ld	l,h
	jp	@289
;906 
;907   read = 0;
@298:
	.debug	# 907
	bool	hl
	ld	l,h
	ld	(ix-4),hl
;908 
;909 //printf("ffile_read: pos: %lu  size: %lu  offset:%ld\r\n",
;910 //       fileState->pos, file->size, (long)(fileState->buff_ptr - fileState
;911 
;912   if (fileState->pos + bytes > file->size)
	.debug	# 912
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	call	__lsub##
	jr	c,@299
	jr	z,@299
;913     bytes = (uint)(file->size - fileState->pos);
	.debug	# 913
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,(ix-6)
	push	bc
	push	de
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
	ex	de,hl
	ld	(ix+11),hl
;914   if (!bytes)  return read;
@299:
	.debug	# 914
	ld	hl,(ix+11)
	bool	hl
	jp	z,@541
;915 
;916 //--- If the R/W buffer has no data in it, then read the 1st block of ---
;917 //--- the file from the flash ---
;918   if (fileState->curBlkNum == 0)   // nothing in the R/W buffer yet
	.debug	# 918
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	hl,(hl)
	bool	hl
	jr	nz,@301
;919     if (loadBuffer(file, fileState, false) == (uint)-1)  return -1;
	.debug	# 919
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-6)
	push	hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	lcall	$loadBuffer
	add	sp,8
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@302
	ld	h,d
	ld	l,e
	jp	@289
;920 
;921   while (bytes)  {
@302:
@301:
@303:
	.debug	# 921
	ld	hl,(ix+11)
	bool	hl
	jp	z,@304
;922   //--- If we used up what was in the buffer, read the next sector ---
;923     if (fileState->buff_ptr >= fileState->sector_buff + sector_size)  {
@305:
	.debug	< @305 @306
	.debug	# 923
	ld	hl,(ix-6)
	ld	de,0x10
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xc
	add	hl,de
	ld	de,(_sector_size)
	push	bc
	ld	bc,0
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__fpcmpr##
	jr	c,@307
;924       fflush_file(fileState);  // update flash if cached data newer than fl
@308:
	.debug	< @308 @309
	.debug	# 924
	ld	hl,(ix-6)
	push	hl
	lcall	$fflush_file
	pop	hl
;925       if (loadBuffer(file, fileState, false) == (uint)-1)  return read;
	.debug	# 925
	bool	hl
	ld	l,h
	push	hl
	ld	hl,(ix-6)
	push	hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	lcall	$loadBuffer
	add	sp,8
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@310
@541:
	ld	hl,(ix-4)
	jp	@289
;926     }
@310:
@309:
	.debug	>
;927   //--- how many of the unread bytes are in the current cache/buffer? ---
;928     numleft = sector_size - ((unsigned)fileState->pos & (sector_size-1));
@307:
	.debug	# 928
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	ld	hl,(_sector_size)
	dec	hl
	and	hl,de
	ld	de,(_sector_size)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix-2),hl
;929     if (numleft > bytes)  numleft = bytes;
	.debug	# 929
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@311
	jr	z,@311
	ld	h,d
	ld	l,e
	ld	(ix-2),hl
;930   //--- copy the bytes from the cache and update state of the open file ---
;931     fmemcpy(buff, fileState->buff_ptr, numleft);
@311:
	.debug	# 931
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-6)
	ld	de,0x10
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;932     fileState->buff_ptr += numleft;  buff += numleft ;  //PSM
	.debug	# 932
	ld	hl,(ix-6)
	ld	de,0x10
	add	hl,de
	push	hl
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix+9),hl
	ex	de,hl
	ld	(ix+7),hl
	ex	de,hl
;933     bytes -= numleft;  fileState->pos += numleft;  read += numleft;
	.debug	# 933
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix+11),hl
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	push	hl
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	add	hl,de
	ld	(ix-4),hl
;934   }
@306:
	.debug	>
;935 
;936   return read;
	jp	@303
@304:
	.debug	# 936
	ld	hl,(ix-4)
;937 }
@289:
	.debug	} @289 937

@288	equ	10
	ld	sp,ix
	pop	ix
	lret
@290	equ	12
;938 
;939 //-------------------------------------------------------------------------
;940 //  Write bytes to a file and return the # of bytes written
;941 //-------------------------------------------------------------------------
;942 int ffile_write(int handle, char far *buff, int bytes)
;943 {
$ffile_write::
	.debug	G $ffile_write 59 9
	.debug	{ $ffile_write 59 942 @314 @313
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-10
	.debug	A handle 5 6
	.debug	A buff 7 46
	.debug	A bytes 11 6
;944   unsigned  numleft, wrote = 0;
	.debug	L numleft -2 7
	.debug	L wrote -4 7
	.debug	# 944
	bool	hl
	ld	l,h
	ld	(ix-4),hl
	.seg	FARCODE
;945   FILE_DATA  *fileState; // state of currently opened file
	.debug	L fileState -6 36
;946   FILE_ENTRY far *file;  // ptr to FAT entry
	.debug	L file -10 39
;947 
;948 
;949   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 949
	ld	a,(__disabled)
	or	a,a
	jr	nz,@315
	ld	de,word (phys @11+520)
	ld	c,phys @11+520 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;950 
;951   if (!(fileState = validHandle(handle, &file)))  { errno = EBADF;  return 
@315:
	.debug	# 951
	ld	hl,-10+@312
	add	hl,sp
	push	hl
	ld	hl,(ix+5)
	push	hl
	lcall	$validHandle
	add	sp,4
	ld	(ix-6),hl
	bool	hl
	jr	nz,@316
@317:
	.debug	< @317 @318
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x9
	jr	@540
@318:
	.debug	>
;952 
;953   if (bytes < 0)  { errno = EINVAL;  return -1; }
@316:
	.debug	# 953
	ld	hl,(ix+11)
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@319
@320:
	.debug	< @320 @321
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x16
@540:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jp	@340
@321:
	.debug	>
;954 
;955   if (bytes == 0)  return 0;
@319:
	.debug	# 955
	ld	hl,(ix+11)
	bool	hl
	jr	nz,@322
	bool	hl
	ld	l,h
	jp	@313
;956 
;957   file = config_table->files + fileState->fatIdx;
@322:
	.debug	# 957
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-6)
	ld	hl,(hl)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-8),hl
	ex	de,hl
	ld	(ix-10),hl
	ex	de,hl
;958 
;959   if (!fileState->curBlkNum)   // nothing in R/W buffer at present
	.debug	# 959
	ld	hl,(ix-6)
	inc	hl
	inc	hl
	ld	hl,(hl)
	bool	hl
	jr	nz,@323
;960     if (loadBuffer(file, fileState, true) == (uint)-1)  return -1;
	.debug	# 960
	ld	l,0x1
	push	hl
	ld	hl,(ix-6)
	push	hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	lcall	$loadBuffer
	add	sp,8
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@324
	ld	h,d
	ld	l,e
	jp	@313
;961 
;962   while (bytes)  {
@324:
@323:
@325:
	.debug	# 962
	ld	hl,(ix+11)
	bool	hl
	jp	z,@326
;963     // # of bytes in R/W buffer between the cur pos and the end of the buff
;964     numleft = sector_size - (uint)(fileState->buff_ptr - fileState->sector_
@327:
	.debug	< @327 @328
	.debug	# 964
	ld	hl,(ix-6)
	ld	de,0x10
	add	hl,de
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	ld	bc,hl
	ld	hl,0xc
	add	hl,de
	push	bc
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	pop	hl
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	ld	hl,(_sector_size)
	or	a,a
	sbc	hl,de
	ld	(ix-2),hl
;965 
;966   //--- If some of the bytes belong in the current sector, then copy them -
;967   //--- to the buffer ---
;968     if (numleft)  {
	.debug	# 968
	bool	hl
	jp	z,@329
;969       if (numleft > bytes)  numleft = bytes;
@330:
	.debug	< @330 @331
	.debug	# 969
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+11)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@332
	jr	z,@332
	ld	h,d
	ld	l,e
	ld	(ix-2),hl
;970       fmemcpy(fileState->buff_ptr, buff, numleft);
@332:
	.debug	# 970
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-6)
	ld	de,0x10
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;971       fileState->buff_ptr += numleft;
	.debug	# 971
	ld	hl,(ix-6)
	ld	de,0x10
	add	hl,de
	push	hl
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;972       bytes -= numleft;  buff += numleft;
	.debug	# 972
	ld	hl,(ix+11)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	or	a,a
	sbc	hl,de
	ld	(ix+11),hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix+7)
	ex	de,hl
	ld	hl,(ix+9)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix+9),hl
	ex	de,hl
	ld	(ix+7),hl
	ex	de,hl
;973       fileState->pos += numleft;
	.debug	# 973
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	push	hl
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__ladd##
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;974       if (fileState->pos > file->size)  {
	.debug	# 974
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	ld	hl,(ix-10)
	ex	de,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsubr##
	jr	c,@333
	jr	z,@333
;975         file->size = fileState->pos;  fileState->flags |= FFLAG_UPDATED; }
@334:
	.debug	< @334 @335
	.debug	# 975
	ld	hl,(ix-6)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
	ld	hl,(ix-6)
	ld	de,0x14
	add	hl,de
	push	hl
	ld	hl,(hl)
	set	2,l
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
@335:
	.debug	>
;976       wrote += numleft;  file->date = time(NULL);
@333:
	.debug	# 976
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ex	de,hl
	add	hl,de
	ld	(ix-4),hl
	bool	hl
	ld	l,h
	push	hl
	lcall	$time
	pop	hl
	push	bc
	push	de
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6c
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
;977       fileState->flags |= FFLAG_WRITE;
	.debug	# 977
	ld	hl,(ix-6)
	ld	de,0x14
	add	hl,de
	push	hl
	ld	hl,(hl)
	set	1,l
	pop	de
	ex	de,hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
;978     }
@331:
	.debug	>
;979 
;980   //--- If not done writing, flush the current cache to flash and read the 
;981   //--- next sector ---
;982     if (bytes)  {
@329:
	.debug	# 982
	ld	hl,(ix+11)
	bool	hl
	jr	z,@336
;983       fflush_file(fileState);  // flush cache to flash if newer data than f
@337:
	.debug	< @337 @338
	.debug	# 983
	ld	hl,(ix-6)
	push	hl
	lcall	$fflush_file
	pop	hl
;984       if (loadBuffer(file, fileState, true) == (uint)-1)
	.debug	# 984
	ld	hl,0x1
	push	hl
	ld	hl,(ix-6)
	push	hl
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-8)
	ld	bc,hl
	push	bc
	push	de
	lcall	$loadBuffer
	add	sp,8
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jr	nz,@339
;985         return (wrote ? wrote : -1);
	.debug	# 985
	ld	hl,(ix-4)
	bool	hl
	jr	z,@340
	ld	hl,(ix-4)
	jr	@313
@340:
	ld	hl,0xffff
	jr	@313
;986     }
@339:
@338:
	.debug	>
;987   }
@336:
@328:
	.debug	>
;988 
;989   return wrote;
	jp	@325
@326:
	.debug	# 989
	ld	hl,(ix-4)
;990 }
@313:
	.debug	} @313 990

@312	equ	10
	ld	sp,ix
	pop	ix
	lret
@314	equ	12
;991 
;992 //-------------------------------------------------------------------------
;993 //  Set the primary boot image to the file specified by its FAT index
;994 //-------------------------------------------------------------------------
;995 int ffile_setPrimary(int index)
;996 {
$ffile_setPrimary::
	.debug	G $ffile_setPrimary 54 9
	.debug	{ $ffile_setPrimary 54 995 @344 @343
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A index 5 6
;997   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 997
	ld	a,(__disabled)
	or	a,a
	jr	nz,@345
	ld	de,word (phys @11+532)
	ld	c,phys @11+532 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;998 
;999   if (!init_file_data())  return FERR_NOXMEM;
@345:
	.debug	# 999
	lcall	$init_file_data
	bool	hl
	jr	nz,@346
	ld	hl,0xfffd
	jr	@343
;1000 
;1001   config_table->primary = index + 1;
@346:
	.debug	# 1001
	ld	hl,(ix+5)
	inc	hl
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c8
	ld	bc,0
	call	__ladd##
	ld	a,l
	call	__farst1##
;1002   if (config_table->backup == index + 1)  config_table->backup = 0;
	.debug	# 1002
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c9
	ld	bc,0
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	hl,(ix+5)
	inc	hl
	ld	d,0
	ld	e,a
	or	a,a
	sbc	hl,de
	jr	nz,@347
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c9
	ld	bc,0
	call	__ladd##
	xor	a,a
	call	__farst1##
;1003 
;1004   update_config();
@347:
	.debug	# 1004
	lcall	$update_config
;1005 
;1006   return 0;
	.debug	# 1006
	bool	hl
	ld	l,h
;1007 }
@343:
	.debug	} @343 1007

@342	equ	0
	pop	ix
	lret
@344	equ	2
;1008 
;1009 //-------------------------------------------------------------------------
;1010 //  Set the backup boot image to the file specified by its FAT index
;1011 //-------------------------------------------------------------------------
;1012 int ffile_setBackup(int index)
;1013 {
$ffile_setBackup::
	.debug	G $ffile_setBackup 54 9
	.debug	{ $ffile_setBackup 54 1012 @350 @349
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A index 5 6
;1014   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 1014
	ld	a,(__disabled)
	or	a,a
	jr	nz,@351
	ld	de,word (phys @11+549)
	ld	c,phys @11+549 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1015 
;1016   if (!init_file_data())  return FERR_NOXMEM;
@351:
	.debug	# 1016
	lcall	$init_file_data
	bool	hl
	jr	nz,@352
	ld	hl,0xfffd
	jr	@349
;1017 
;1018   config_table->backup = index +1;
@352:
	.debug	# 1018
	ld	hl,(ix+5)
	inc	hl
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c9
	ld	bc,0
	call	__ladd##
	ld	a,l
	call	__farst1##
;1019   if (config_table->primary == index +1)  config_table->primary = 0;
	.debug	# 1019
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c8
	ld	bc,0
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	a,l
	ld	hl,(ix+5)
	inc	hl
	ld	d,0
	ld	e,a
	or	a,a
	sbc	hl,de
	jr	nz,@353
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c8
	ld	bc,0
	call	__ladd##
	xor	a,a
	call	__farst1##
;1020 
;1021   update_config();
@353:
	.debug	# 1021
	lcall	$update_config
;1022 
;1023   return 0;
	.debug	# 1023
	bool	hl
	ld	l,h
;1024 }
@349:
	.debug	} @349 1024

@348	equ	0
	pop	ix
	lret
@350	equ	2
;1025 
;1026 //-------------------------------------------------------------------------
;1027 //  Return the FAT index of the primary boot image file (or < 0 if no prima
;1028 //  boot image file).
;1029 //-------------------------------------------------------------------------
;1030 int ffile_getPrimary(void)
;1031 {
$ffile_getPrimary::
	.debug	G $ffile_getPrimary 34 9
	.debug	{ $ffile_getPrimary 34 1030 @356 @355
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;1032   int index;
	.debug	L index -2 6
;1033 
;1034   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 1034
	ld	a,(__disabled)
	or	a,a
	jr	nz,@357
	ld	de,word (phys @11+565)
	ld	c,phys @11+565 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1035 
;1036   if (!init_file_data())  return FERR_NOXMEM;
@357:
	.debug	# 1036
	lcall	$init_file_data
	bool	hl
	jr	nz,@358
	ld	hl,0xfffd
	jr	@355
;1037 
;1038   index = config_table->primary;
@358:
	.debug	# 1038
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c8
	ld	bc,0
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	ld	(ix-2),hl
;1039 
;1040   return index - 1;
	.debug	# 1040
	dec	hl
;1041 }
@355:
	.debug	} @355 1041

@354	equ	2
	ld	sp,ix
	pop	ix
	lret
@356	equ	4
;1042 
;1043 //-------------------------------------------------------------------------
;1044 //  Return the FAT index of the backup boot image file (or < 0 if no backup
;1045 //  boot image file).
;1046 //-------------------------------------------------------------------------
;1047 int ffile_getBackup(void)
;1048 {
$ffile_getBackup::
	.debug	G $ffile_getBackup 34 9
	.debug	{ $ffile_getBackup 34 1047 @361 @360
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;1049   int index;
	.debug	L index -2 6
;1050 
;1051   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 1051
	ld	a,(__disabled)
	or	a,a
	jr	nz,@362
	ld	de,word (phys @11+582)
	ld	c,phys @11+582 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1052 
;1053   if (!init_file_data())  return FERR_NOXMEM;
@362:
	.debug	# 1053
	lcall	$init_file_data
	bool	hl
	jr	nz,@363
	ld	hl,0xfffd
	jr	@360
;1054 
;1055   index = config_table->backup;
@363:
	.debug	# 1055
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c9
	ld	bc,0
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	ld	(ix-2),hl
;1056 
;1057   return index - 1;
	.debug	# 1057
	dec	hl
;1058 }
@360:
	.debug	} @360 1058

@359	equ	2
	ld	sp,ix
	pop	ix
	lret
@361	equ	4
;1059 
;1060 //-------------------------------------------------------------------------
;1061 //  Get the index of the binary image marked as the INIT program
;1062 //-------------------------------------------------------------------------
;1063 int ffile_getInit(void)
;1064 {
$ffile_getInit::
	.debug	G $ffile_getInit 34 9
	.debug	{ $ffile_getInit 34 1063 @366 @365
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
;1065   int index;
	.debug	L index -2 6
;1066 
;1067   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 1067
	ld	a,(__disabled)
	or	a,a
	jr	nz,@367
	ld	de,word (phys @11+598)
	ld	c,phys @11+598 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1068 
;1069   if (!init_file_data())  return FERR_NOXMEM;
@367:
	.debug	# 1069
	lcall	$init_file_data
	bool	hl
	jr	nz,@368
	ld	hl,0xfffd
	jr	@365
;1070 
;1071   index = config_table->init;  return index - 1;
@368:
	.debug	# 1071
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x87
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	ld	(ix-2),hl
	dec	hl
;1072 }
@365:
	.debug	} @365 1072

@364	equ	2
	ld	sp,ix
	pop	ix
	lret
@366	equ	4
;1073 
;1074 //-------------------------------------------------------------------------
;1075 //  Set the index of the binary image marked as the INIT program
;1076 //-------------------------------------------------------------------------
;1077 int ffile_setInit(int index)
;1078 {
$ffile_setInit::
	.debug	G $ffile_setInit 54 9
	.debug	{ $ffile_setInit 54 1077 @371 @370
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A index 5 6
;1079   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 1079
	ld	a,(__disabled)
	or	a,a
	jr	nz,@372
	ld	de,word (phys @11+612)
	ld	c,phys @11+612 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1080 
;1081   if (!init_file_data())  return FERR_NOXMEM;
@372:
	.debug	# 1081
	lcall	$init_file_data
	bool	hl
	jr	nz,@373
	ld	hl,0xfffd
	jr	@370
;1082 
;1083   config_table->init = index + 1;  update_config();
@373:
	.debug	# 1083
	ld	hl,(ix+5)
	inc	hl
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x87
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	a,l
	call	__farst1##
	lcall	$update_config
;1084 
;1085   return 0;
	.debug	# 1085
	bool	hl
	ld	l,h
;1086 }
@370:
	.debug	} @370 1086

@369	equ	0
	pop	ix
	lret
@371	equ	2
;1087 
;1088 
;1089 //-------------------------------------------------------------------------
;1090 //
;1091 //-------------------------------------------------------------------------
;1092 void ffile_rename(unsigned int index, char * name)
;1093 {
$ffile_rename::
	.debug	G $ffile_rename 57 9
	.debug	{ $ffile_rename 57 1092 @376 @375
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A index 5 7
	.debug	A name 7 50
;1094   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 1094
	ld	a,(__disabled)
	or	a,a
	jr	nz,@377
	ld	de,word (phys @11+626)
	ld	c,phys @11+626 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1095 
;1096   fstrcpy(config_table->files[index].name, name);  update_config();
@377:
	.debug	# 1096
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+5)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
	lcall	$update_config
;1097 }
@375:
	.debug	} @375 1097

@374	equ	0
	pop	ix
	lret
@376	equ	2
;1098 
;1099 //-------------------------------------------------------------------------
;1100 //
;1101 //-------------------------------------------------------------------------
;1102 int ffile_handle2Index(int handle)
;1103 {
$ffile_handle2Index::
	.debug	G $ffile_handle2Index 54 9
	.debug	{ $ffile_handle2Index 54 1102 @380 @379
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A handle 5 6
;1104   FILE_DATA * fileState = openFiles + handle;  // state of currently opened
	.debug	L fileState -2 36
	.debug	# 1104
	ld	hl,(ix+5)
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ld	(ix-2),hl
	.seg	FARCODE
;1105 
;1106   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 1106
	ld	a,(__disabled)
	or	a,a
	jr	nz,@381
	ld	de,word (phys @11+639)
	ld	c,phys @11+639 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1107 
;1108   return fileState->fatIdx;
@381:
	.debug	# 1108
	ld	hl,(ix-2)
	ld	hl,(hl)
;1109 }
@379:
	.debug	} @379 1109

@378	equ	2
	ld	sp,ix
	pop	ix
	lret
@380	equ	4
;1110 
;1111 
;1112 //=========================================================================
;1113 //============================ NSCL additions =============================
;1114 //=========================================================================
;1115 
;1116 #include <common.h>
;1117 
	.debug	I 'C:\work\dev\Rabbit_ST\rtos\include\common.h' 6 8 9 6 12 32
	.debug	I
;1118 //-------------------------------------------------------------------------
;1119 //  Get info for file given its index in the flash file table.
;1120 //  Returns far ptr to file data if index is for a valid file, NULL if an e
;1121 //-------------------------------------------------------------------------
;1122 FILE_ENTRY far *ffile_info(unsigned idx)
;1123 {
$ffile_info::
	.debug	G $ffile_info 60 9
	.debug	{ $ffile_info 60 1122 @384 @383
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-4
	.debug	A idx 5 7
;1124   FILE_ENTRY  far *file;  // ptr to FAT entry
	.debug	L file -4 39
;1125 
;1126 
;1127   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 1127
	ld	a,(__disabled)
	or	a,a
	jr	nz,@385
	ld	de,word (phys @11+658)
	ld	c,phys @11+658 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1128 
;1129   if (!init_file_data())  { ERRNO = ENOMEM;  return NULL; }
@385:
	.debug	# 1129
	lcall	$init_file_data
	bool	hl
	jr	nz,@386
@387:
	.debug	< @387 @388
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@539
@388:
	.debug	>
;1130 
;1131   if (idx >= MAX_FILES)  return NULL;
@386:
	.debug	# 1131
	ld	hl,(ix+5)
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jr	c,@389
@539:
	ld	e,d
	jr	@538
;1132 
;1133   file = config_table->files + idx;
@389:
	.debug	# 1133
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix+5)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1134 
;1135   if ((file->flags & (FILE_ACTIVE | FILE_SFLASH)) != (FILE_ACTIVE))
	.debug	# 1135
	push	bc
	push	de
	ld	de,0x66
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x3
	and	hl,de
	ld	de,0x1
	or	a,a
	sbc	hl,de
	jr	z,@390
;1136     return NULL;
	.debug	# 1136
	ld	e,d
@538:
	ld	c,e
	ld	b,e
	jr	@383
;1137 
;1138   return file;
@390:
	.debug	# 1138
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-2)
	ld	bc,hl
;1139 }
@383:
	.debug	} @383 1139

@382	equ	4
	ld	sp,ix
	pop	ix
	lret
@384	equ	6
;1140 
;1141 //-------------------------------------------------------------------------
;1142 //  Return info in standard fstat stat struct for an open file
;1143 //-------------------------------------------------------------------------
;1144 int  ffile_fstat(int handle, struct stat *fsbuf)
;1145 {
$ffile_fstat::
	.debug	G $ffile_fstat 61 9
	.debug	{ $ffile_fstat 61 1144 @393 @392
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-8
	.debug	A handle 5 6
	.debug	A fsbuf 7 62
;1146   ulong  testTime;
	.debug	L testTime -4 9
;1147   FILE_ENTRY  far *file;  // ptr to FAT entry
	.debug	L file -8 39
;1148 
;1149 
;1150   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 1150
	ld	a,(__disabled)
	or	a,a
	jr	nz,@394
	ld	de,word (phys @11+669)
	ld	c,phys @11+669 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1151 
;1152   if (!init_file_data())  { ERRNO = ENOMEM;  return -1; }
@394:
	.debug	# 1152
	lcall	$init_file_data
	bool	hl
	jr	nz,@395
@396:
	.debug	< @396 @397
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
	jp	@537
@397:
	.debug	>
;1153 
;1154   if ((uint)handle >= MAX_FILES)  { ERRNO = ENOENT;  return -1; }
@395:
	.debug	# 1154
	ld	hl,(ix+5)
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jr	c,@398
@399:
	.debug	< @399 @400
	ld	hl,(_current)
	ld	e,0xb9
	add	hl,de
	ld	e,0x2
	jr	@537
@400:
	.debug	>
;1155 
;1156   file = config_table->files + openFiles[handle].fatIdx;
@398:
	.debug	# 1156
	ld	hl,(ix+5)
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(hl)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-6),hl
	ex	de,hl
	ld	(ix-8),hl
	ex	de,hl
;1157 
;1158   testTime = file->date & 0xFFFFFF00L;
	.debug	# 1158
	push	bc
	push	de
	ld	de,0x6c
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	de,0xff00
	ld	c,d
	ld	b,d
	call	__land##
	ld	hl,bc
	ld	(ix-2),hl
	ex	de,hl
	ld	(ix-4),hl
	ex	de,hl
;1159   if ((testTime == 0) OR (testTime == 0xFFFFFF00L))  {
	.debug	# 1159
	or	hl,de
	jr	z,@401
	ld	h,b
	ld	l,c
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x100
	ld	c,e
	ld	b,e
	call	__ladd##
	jr	nz,@402
@401:
;1160     ERRNO = EBADFD;  return -1; }
@403:
	.debug	< @403 @404
	.debug	# 1160
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x4d
@537:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@392
@404:
	.debug	>
;1161 
;1162   fsbuf->st_size  = file->size;  // total size in bytes
@402:
	.debug	# 1162
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,(ix+7)
	push	de
	ld	de,0x16
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1163   fsbuf->st_atime = file->date;  // time of last access
	.debug	# 1163
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6c
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,(ix+7)
	push	de
	ld	de,0x1e
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1164   fsbuf->st_mtime = file->date;  // time of last modification
	.debug	# 1164
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6c
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,(ix+7)
	push	de
	ld	de,0x22
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1165   fsbuf->st_ctime = file->date;  // time of last status change
	.debug	# 1165
	ld	hl,(ix-8)
	ex	de,hl
	ld	hl,(ix-6)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6c
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,(ix+7)
	push	de
	ld	de,0x26
	add	hl,de
	pop	de
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1166 
;1167   fsbuf->st_mode = S_IFREG | 00777;
	.debug	# 1167
	ld	hl,(ix+7)
	ld	de,0x8
	add	hl,de
	ld	de,0x81ff
	ld	bc,0
	ld	(hl),e
	inc	hl
	ld	(hl),d
	inc	hl
	ld	(hl),c
	inc	hl
	ld	(hl),b
;1168 
;1169   return 0;
	.debug	# 1169
	bool	hl
	ld	l,h
;1170 }
@392:
	.debug	} @392 1170

@391	equ	8
	ld	sp,ix
	pop	ix
	lret
@393	equ	10
;1171 
;1172 //-------------------------------------------------------------------------
;1173 //  Return the number of bytes the cur pos is from the end of the file
;1174 //-------------------------------------------------------------------------
;1175 long ffile_unread(int handle)
;1176 {
$ffile_unread::
	.debug	G $ffile_unread 55 9
	.debug	{ $ffile_unread 55 1175 @407 @406
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A handle 5 6
;1177   FILE_DATA  *fileState;   // state of currently opened file
	.debug	L fileState -2 36
;1178   FILE_ENTRY  far *entry;  // ptr to FAT entry
	.debug	L entry -6 39
;1179 
;1180 
;1181   if (!KLOCKED())  klockErr(__func__);  //tdebug
	.debug	# 1181
	ld	a,(__disabled)
	or	a,a
	jr	nz,@408
	ld	de,word (phys @11+681)
	ld	c,phys @11+681 >> 16
	push	bc
	push	de
	lcall	$klockErr
	add	sp,4
;1182 
;1183   fileState = openFiles + handle;
@408:
	.debug	# 1183
	ld	hl,(ix+5)
	ld	bc,0x16
	ex	de,hl
	mul
	ld	hl,_openFiles
	add	hl,bc
	ld	(ix-2),hl
;1184   entry = config_table->files + fileState->fatIdx;
	.debug	# 1184
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-2)
	ld	hl,(hl)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;1185 
;1186   return (entry->size - fileState->pos);
	.debug	# 1186
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ld	hl,(ix-2)
	push	bc
	push	de
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	call	__lsub##
;1187 }
@406:
	.debug	} @406 1187

@405	equ	6
	ld	sp,ix
	pop	ix
	lret
@407	equ	8
;1188 
;1189 
;1190 //-------------------------------------------------------------------------
;1191 //  Return the IPv4 the SBC is configured for in host byte order
;1192 //-------------------------------------------------------------------------
;1193 ulong readIPAddr(void)
;1194 {
$readIPAddr::
	.debug	G $readIPAddr 64 9
	.debug	{ $readIPAddr 64 1193 @411 @410
;1195   if (!init_file_data())  { ERRNO = ENOMEM;  return -1; }
	.debug	# 1195
	lcall	$init_file_data
	bool	hl
	jr	nz,@412
@413:
	.debug	< @413 @414
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	de,0xffff
	ld	c,e
	ld	b,e
	jp	@410
@414:
	.debug	>
;1196 
;1197   return ntohl(config_table->IPAddress);
@412:
	.debug	# 1197
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x80
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
;1198 }
@410:
	.debug	} @410 1198

@409	equ	0
	lret
@411	equ	0
;1199 
;1200 
;1201 //-------------------------------------------------------------------------
;1202 //  Change the IPv4 stored in the configuration data.  The address must be 
;1203 //  host byte order.
;1204 //-------------------------------------------------------------------------
;1205 int  writeIPAddr(ulong ipAddr)
;1206 {
$writeIPAddr::
	.debug	G $writeIPAddr 65 9
	.debug	{ $writeIPAddr 65 1205 @417 @416
	push	ix
	ld	ix,0
	add	ix,sp
	.debug	A ipAddr 5 9
;1207   if (!init_file_data())  { ERRNO = ENOMEM;  return -1; }
	.debug	# 1207
	lcall	$init_file_data
	bool	hl
	jr	nz,@418
@419:
	.debug	< @419 @420
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jp	@416
@420:
	.debug	>
;1208 
;1209   config_table->IPAddress = htonl(ipAddr);
@418:
	.debug	# 1209
	ld	hl,(ix+5)
	ex	de,hl
	ld	hl,(ix+7)
	ld	bc,hl
	ex	de,hl
	ld	e,b
	ld	d,c
	ld	b,l
	ld	c,h
	push	bc
	push	de
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x80
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
;1210   update_config();
	.debug	# 1210
	lcall	$update_config
;1211 
;1212   return 0;
	.debug	# 1212
	bool	hl
	ld	l,h
;1213 }
@416:
	.debug	} @416 1213

@415	equ	0
	pop	ix
	lret
@417	equ	2
;1214 
;1215 //-------------------------------------------------------------------------
;1216 //  Return the name of the primary boot image file (or NULL 0 if no primary
;1217 //  boot image file).
;1218 //-------------------------------------------------------------------------
;1219 char *ffile_getPrimaryName(char *name, int nameLen)
;1220 {
$ffile_getPrimaryName::
	.debug	G $ffile_getPrimaryName 66 9
	.debug	{ $ffile_getPrimaryName 66 1219 @423 @422
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A name 5 50
	.debug	A nameLen 7 6
;1221   int index;
	.debug	L index -2 6
;1222 
;1223   if (!init_file_data())  { ERRNO = ENOMEM;  return NULL; }
	.debug	# 1223
	lcall	$init_file_data
	bool	hl
	jr	nz,@424
@425:
	.debug	< @425 @426
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@536
@426:
	.debug	>
;1224 
;1225   index = config_table->primary;
@424:
	.debug	# 1225
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c8
	ld	bc,0
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	ld	(ix-2),hl
;1226   if (index < 1)  return NULL;
	.debug	# 1226
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@427
@536:
	bool	hl
	ld	l,h
	jr	@422
;1227 
;1228   fstrcpy(name, config_table->files[(uint)index-1].name);
@427:
	.debug	# 1228
	ld	hl,(ix-2)
	dec	hl
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1229 
;1230   return name;
	.debug	# 1230
	ld	hl,(ix+5)
;1231 }
@422:
	.debug	} @422 1231

@421	equ	2
	ld	sp,ix
	pop	ix
	lret
@423	equ	4
;1232 
;1233 //-------------------------------------------------------------------------
;1234 //  Return the name of the backup boot image file (or NULL 0 if no backup
;1235 //  boot image file).
;1236 //-------------------------------------------------------------------------
;1237 char *ffile_getBackupName(char *name, int nameLen)
;1238 {
$ffile_getBackupName::
	.debug	G $ffile_getBackupName 66 9
	.debug	{ $ffile_getBackupName 66 1237 @430 @429
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A name 5 50
	.debug	A nameLen 7 6
;1239   int index;
	.debug	L index -2 6
;1240 
;1241   if (!init_file_data())  { ERRNO = ENOMEM;  return NULL; }
	.debug	# 1241
	lcall	$init_file_data
	bool	hl
	jr	nz,@431
@432:
	.debug	< @432 @433
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
	ld	(hl),e
	inc	hl
	ld	(hl),d
	jr	@535
@433:
	.debug	>
;1242 
;1243   index = config_table->backup;
@431:
	.debug	# 1243
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x5c9
	ld	bc,0
	call	__ladd##
	ld	hl,de
	ld	a,c
	ldp	hl,(hl)
	ld	h,0
	ld	(ix-2),hl
;1244   if (index < 1)  return NULL;
	.debug	# 1244
	ld	de,0x8001
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@434
@535:
	bool	hl
	ld	l,h
	jr	@429
;1245 
;1246   fstrcpy(name, config_table->files[(uint)index-1].name);
@434:
	.debug	# 1246
	ld	hl,(ix-2)
	dec	hl
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1247 
;1248   return name;
	.debug	# 1248
	ld	hl,(ix+5)
;1249 }
@429:
	.debug	} @429 1249

@428	equ	2
	ld	sp,ix
	pop	ix
	lret
@430	equ	4
;1250 
;1251 //-------------------------------------------------------------------------
;1252 //  change the name of a file
;1253 //-------------------------------------------------------------------------
;1254 int ffile_rename_(const char *oldpath, const char *newpath)
;1255 {
$ffile_rename_::
	.debug	G $ffile_rename_ 67 9
	.debug	{ $ffile_rename_ 67 1254 @437 @436
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A oldpath 5 50
	.debug	A newpath 7 50
;1256   int index;
	.debug	L index -2 6
;1257 
;1258 //printf("rename(%.16s, %.16s)\r\n", oldpath, newpath);  //tdebug
;1259 
;1260   if (!init_file_data())  { ERRNO = ENOMEM;  return -1; }
	.debug	# 1260
	lcall	$init_file_data
	bool	hl
	jr	nz,@438
@439:
	.debug	< @439 @440
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
	jr	@534
@440:
	.debug	>
;1261 
;1262   KLOCK();
@438:
	.debug	# 1262
	call	_KLOCK
;1263 
;1264   index = ffile_index((char *)oldpath);
	.debug	# 1264
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_index
	pop	de
	ld	(ix-2),hl
;1265   if (index < 0)  { KUNLOCK();  ERRNO = ENOENT;  return -1; }
	.debug	# 1265
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@441
@442:
	.debug	< @442 @443
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x2
@534:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@436
@443:
	.debug	>
;1266 
;1267 //printf("  delete(%.16s)\r\n", newpath);  //tdebug
;1268   ffile_delete((char *)newpath);
@441:
	.debug	# 1268
	ld	hl,(ix+7)
	push	hl
	lcall	$ffile_delete
	pop	de
;1269 
;1270 //fprintf(DiagLog, "  change name of files[%d](%.16s) to %.16s\r\n",  //tde
;1271 //       index, config_table->files[(uint)index].name, newpath);  //tdebug
;1272   fstrcpy(config_table->files[(uint)index].name, newpath);
	.debug	# 1272
	ld	hl,(ix+7)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-2)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	push	bc
	push	de
	call	_fstrcpy
	add	sp,8
;1273 
;1274   update_config();
	.debug	# 1274
	lcall	$update_config
;1275 
;1276   KUNLOCK();  return 0;
	.debug	# 1276
	call	_KUNLOCK
	bool	hl
	ld	l,h
;1277 }
@436:
	.debug	} @436 1277

@435	equ	2
	ld	sp,ix
	pop	ix
	lret
@437	equ	4
;1278 
;1279 
;1280 //-------------------------------------------------------------------------
;1281 //  Set the primary boot image to the file specified by its name
;1282 //-------------------------------------------------------------------------
;1283 int ffile_makePrimary(const char *fileName)
;1284 {
$ffile_makePrimary::
	.debug	G $ffile_makePrimary 49 9
	.debug	{ $ffile_makePrimary 49 1283 @446 @445
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A fileName 5 50
;1285   int  index;
	.debug	L index -2 6
;1286 
;1287 
;1288   if (!init_file_data())  { ERRNO = ENOMEM;  return -1; }
	.debug	# 1288
	lcall	$init_file_data
	bool	hl
	jr	nz,@447
@448:
	.debug	< @448 @449
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
	jr	@533
@449:
	.debug	>
;1289 
;1290   KLOCK();
@447:
	.debug	# 1290
	call	_KLOCK
;1291 
;1292   index = ffile_index((char *)fileName);
	.debug	# 1292
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_index
	pop	de
	ld	(ix-2),hl
;1293   if (index < 0)  { KUNLOCK();  ERRNO = ENOENT;  return -1; }
	.debug	# 1293
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@450
@451:
	.debug	< @451 @452
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x2
@533:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@445
@452:
	.debug	>
;1294 
;1295   ffile_setPrimary(index);
@450:
	.debug	# 1295
	ld	hl,(ix-2)
	push	hl
	lcall	$ffile_setPrimary
	pop	de
;1296 
;1297   KUNLOCK();  return 0;
	.debug	# 1297
	call	_KUNLOCK
	bool	hl
	ld	l,h
;1298 }
@445:
	.debug	} @445 1298

@444	equ	2
	ld	sp,ix
	pop	ix
	lret
@446	equ	4
;1299 
;1300 //-------------------------------------------------------------------------
;1301 //  Set the backup boot image to the file specified by its name
;1302 //-------------------------------------------------------------------------
;1303 int ffile_makeBackup(const char *fileName)
;1304 {
$ffile_makeBackup::
	.debug	G $ffile_makeBackup 49 9
	.debug	{ $ffile_makeBackup 49 1303 @455 @454
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A fileName 5 50
;1305   int  index;
	.debug	L index -2 6
;1306 
;1307   if (!init_file_data())  { ERRNO = ENOMEM;  return -1; }
	.debug	# 1307
	lcall	$init_file_data
	bool	hl
	jr	nz,@456
@457:
	.debug	< @457 @458
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
	jr	@532
@458:
	.debug	>
;1308 
;1309   KLOCK();
@456:
	.debug	# 1309
	call	_KLOCK
;1310 
;1311   index = ffile_index((char *)fileName);
	.debug	# 1311
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_index
	pop	de
	ld	(ix-2),hl
;1312   if (index < 0)  { KUNLOCK();  ERRNO = ENOENT;  return -1; }
	.debug	# 1312
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@459
@460:
	.debug	< @460 @461
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x2
@532:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@454
@461:
	.debug	>
;1313 
;1314   ffile_setBackup(index);
@459:
	.debug	# 1314
	ld	hl,(ix-2)
	push	hl
	lcall	$ffile_setBackup
	pop	de
;1315 
;1316   KUNLOCK();  return 0;
	.debug	# 1316
	call	_KUNLOCK
	bool	hl
	ld	l,h
;1317 }
@454:
	.debug	} @454 1317

@453	equ	2
	ld	sp,ix
	pop	ix
	lret
@455	equ	4
;1318 
;1319 //-------------------------------------------------------------------------
;1320 //  Set date/time stamps on a file
;1321 //-------------------------------------------------------------------------
;1322 int  ffile_utime(const char *fileName, const struct utimbuf *buf)
;1323 {
$ffile_utime::
	.debug	G $ffile_utime 68 9
	.debug	{ $ffile_utime 68 1322 @464 @463
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-6
	.debug	A fileName 5 50
	.debug	A buf 7 69
;1324   int  index;
	.debug	L index -2 6
;1325   FILE_ENTRY  far *file;  // ptr to FAT entry
	.debug	L file -6 39
;1326 
;1327 
;1328   if (!init_file_data())  { ERRNO = ENOMEM;  return -1; }
	.debug	# 1328
	lcall	$init_file_data
	bool	hl
	jr	nz,@465
@466:
	.debug	< @466 @467
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0xc
	jr	@531
@467:
	.debug	>
;1329 
;1330   KLOCK();
@465:
	.debug	# 1330
	call	_KLOCK
;1331 
;1332   index = ffile_index((char *)fileName);
	.debug	# 1332
	ld	hl,(ix+5)
	push	hl
	lcall	$ffile_index
	pop	de
	ld	(ix-2),hl
;1333   if (index < 0)  { KUNLOCK();  ERRNO = ENOENT;  return -1; }
	.debug	# 1333
	ld	de,0x8000
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	nc,@468
@469:
	.debug	< @469 @470
	call	_KUNLOCK
	ld	hl,(_current)
	ld	de,0xb9
	add	hl,de
	ld	e,0x2
@531:
	ld	(hl),e
	inc	hl
	ld	(hl),d
	ld	hl,0xffff
	jr	@463
@470:
	.debug	>
;1334 
;1335   file = config_table->files + (uint)index;
@468:
	.debug	# 1335
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-2)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-4),hl
	ex	de,hl
	ld	(ix-6),hl
	ex	de,hl
;1336 
;1337   file->date = (ulong) buf->modtime;
	.debug	# 1337
	ld	hl,(ix+7)
	ld	de,0x4
	add	hl,de
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	c,(hl)
	inc	hl
	ld	b,(hl)
	push	bc
	push	de
	ld	hl,(ix-6)
	ex	de,hl
	ld	hl,(ix-4)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x6c
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farst4p##
;1338 
;1339   update_config();
	.debug	# 1339
	lcall	$update_config
;1340 
;1341   KUNLOCK();  return 0;
	.debug	# 1341
	call	_KUNLOCK
	bool	hl
	ld	l,h
;1342 }
@463:
	.debug	} @463 1342

@462	equ	6
	ld	sp,ix
	pop	ix
	lret
@464	equ	8
;1343 
;1344 
;1345 //-------------------------------------------------------------------------
;1346 //  set the board name
;1347 //-------------------------------------------------------------------------
;1348 int  ffile_setName(char *newName)
;1349 {
$ffile_setName::
	.debug	G $ffile_setName 49 9
	.debug	{ $ffile_setName 49 1348 @473 @472
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A newName 5 50
;1350   int  len;
	.debug	L len -2 6
;1351 
;1352   if ((len = strlen(newName)) >= BRD_NAME_LEN)  return -1;
	.debug	# 1352
	ld	hl,(ix+5)
	push	hl
	call	_strlen
	pop	de
	ld	(ix-2),hl
	ld	de,0x8080
	add	hl,hl
	ccf
	rr	hl
	sbc	hl,de
	jr	c,@474
	ld	hl,0xffff
	jr	@472
;1353 
;1354   KLOCK();
@474:
	.debug	# 1354
	call	_KLOCK
;1355 
;1356   fmemcpy(config_table->board_name, newName, len);
	.debug	# 1356
	ld	hl,(ix-2)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
;1357   config_table->board_name[(uint)len] = 0;
	.debug	# 1357
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	ld	hl,(ix-2)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__ladd##
	xor	a,a
	call	__farst1##
;1358 
;1359   update_config();
	.debug	# 1359
	lcall	$update_config
;1360 
;1361   KUNLOCK();  return 0;
	.debug	# 1361
	call	_KUNLOCK
	bool	hl
	ld	l,h
;1362 }
@472:
	.debug	} @472 1362

@471	equ	2
	ld	sp,ix
	pop	ix
	lret
@473	equ	4
;1363 
;1364 
;1365 //-------------------------------------------------------------------------
;1366 //  get the board name
;1367 //-------------------------------------------------------------------------
;1368 char *ffile_getName(char *name, int maxLen)
;1369 {
$ffile_getName::
	.debug	G $ffile_getName 66 9
	.debug	{ $ffile_getName 66 1368 @477 @476
	push	ix
	ld	ix,0
	add	ix,sp
	add	sp,-2
	.debug	A name 5 50
	.debug	A maxLen 7 6
;1370   int  len;
	.debug	L len -2 6
;1371 
;1372   KLOCK();
	.debug	# 1372
	call	_KLOCK
;1373 
;1374   if ((len = (uint)fstrlen(config_table->board_name)) >= maxLen)  len = max
	.debug	# 1374
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	call	_fstrlen
	add	sp,4
	ex	de,hl
	ld	(ix-2),hl
	ex	de,hl
	ld	hl,(ix+7)
	ex	de,hl
	call	__icmp##
	jr	c,@478
	ld	hl,(ix+7)
	dec	hl
	ld	(ix-2),hl
;1375 
;1376   fmemcpy(name, config_table->board_name, len);  name[len] = 0;
@478:
	.debug	# 1376
	ld	hl,(ix-2)
	ex	de,hl
	ld	a,d
	rlca
	sbc	a,a
	ld	c,a
	ld	b,a
	push	bc
	push	de
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	hl,(ix+5)
	ex	de,hl
	call	__farcvp##
	push	bc
	push	de
	lcall	$fmemcpy
	add	sp,12
	ld	hl,(ix-2)
	ex	de,hl
	ld	hl,(ix+5)
	ex	de,hl
	add	hl,de
	xor	a,a
	ld	(hl),a
;1377 
;1378   KUNLOCK();  return name;
	.debug	# 1378
	call	_KUNLOCK
	ld	hl,(ix+5)
;1379 }
@476:
	.debug	} @476 1379

@475	equ	2
	ld	sp,ix
	pop	ix
	lret
@477	equ	4
;1380 
;1381 
;1382 //-------------------------------------------------------------------------
;1383 //  check the integrity of the file system
;1384 //
;1385 //  Note that if the file system is altered while this is running the resul
;1386 //  may be incorrect.
;1387 //
;1388 //  Returns the # of errors found.
;1389 //
;1390 //  The repair parameter is currently ignored...
;1391 //-------------------------------------------------------------------------
;1392 int ffile_fsck(bool repair)
;1393 {
$ffile_fsck::
	.debug	G $ffile_fsck 71 9
	.debug	{ $ffile_fsck 71 1392 @481 @480
	ld	hl,-171
	call	__fent##
	.debug	A repair 5 3
;1394   int  numErrs;
	.debug	L numErrs -2 6
;1395   uint  ui, numBlks, ttlBlks, usedBlks, freeBlks, rsvdBlks;
	.debug	L ui -4 7
	.debug	L numBlks -6 7
	.debug	L ttlBlks -8 7
	.debug	L usedBlks -10 7
	.debug	L freeBlks -12 7
	.debug	L rsvdBlks -14 7
;1396   ulong  spaceUsed, usedBytes, freeBytes, rsvdBytes;
	.debug	L spaceUsed -18 9
	.debug	L usedBytes -22 9
	.debug	L freeBytes -26 9
	.debug	L rsvdBytes -30 9
;1397   ushort  blkNum, nextBlk, sectorSize;
	.debug	L blkNum -32 5
	.debug	L nextBlk -34 5
	.debug	L sectorSize -36 5
;1398   uchar  mask;
	.debug	L mask -37 3
;1399   uchar *chkdFlag;
	.debug	L chkdFlag -39 50
;1400   FILE_ENTRY far *file;  // ptr to FAT entry
	.debug	L file -43 39
;1401   uchar chkdBlocks[MAX_BLK_NUM/8];
	.debug	L chkdBlocks -171 72
;1402 
;1403 
;1404   BZERO(chkdBlocks);  numErrs = usedBlks = freeBlks = rsvdBlks = 0;
	.debug	# 1404
	ld	hl,0x80
	push	hl
	bool	hl
	ld	l,h
	push	hl
	ld	hl,-167+@479
	add	hl,sp
	push	hl
	call	_memset
	add	sp,6
	bool	hl
	ld	l,h
	ld	(ix-14),hl
	ld	(ix-12),hl
	ld	(ix-10),hl
	ld	(ix-2),hl
;1405 
;1406   ttlBlks = config_table->num_blocks;  sectorSize = config_table->sector_si
	.debug	# 1406
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61a
	ld	b,h
	ld	c,l
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-8),hl
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61c
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-36),hl
;1407 
;1408   printf("\r\n%u bytes/sector,  %u sectors,  Total %lu bytes\r\n",
;1409          config_table->sector_size, config_table->num_blocks,
;1410          (ulong) ttlBlks * sectorSize );
	.debug	# 1410
	ld	hl,(ix-8)
	ex	de,hl
	ld	bc,0
	ld	hl,(ix-36)
	push	bc
	push	de
	ex	de,hl
	call	__ulmlt##
	push	bc
	push	de
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61a
	ld	bc,0
	call	__ladd##
	call	__farld2##
	push	de
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61c
	ld	bc,0
	call	__ladd##
	call	__farld2##
	push	de
	ld	de,word (phys @11+694)
	ld	c,phys @11+694 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,12
;1411 
;1412   if (config_table->num_blocks > MAX_BLK_NUM)  {
	.debug	# 1412
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61a
	ld	bc,0
	call	__ladd##
	call	__farld2##
	ld	hl,0x400
	ex	de,hl
	or	a,a
	sbc	hl,de
	jr	c,@482
	jr	z,@482
;1413     printf("# sectors > MAX_BLK_NUM (%u)\r\n", MAX_BLK_NUM);  ++numErrs; }
@483:
	.debug	< @483 @484
	.debug	# 1413
	ld	h,d
	ld	l,e
	push	hl
	ld	de,word (phys @11+745)
	ld	c,phys @11+745 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
@484:
	.debug	>
;1414 
;1415 
;1416 //--- verify each file entry by following the linked list of blocks ---
;1417   for (ui=0; ui<MAX_FILES; ++ui)  {
@482:
@485:
	.debug	< @485 @486
	.debug	# 1417
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@487:
	ld	hl,(ix-4)
	ld	de,0xc
	or	a,a
	sbc	hl,de
	jp	nc,@488
;1418     file = config_table->files + ui;
@490:
	.debug	< @490 @491
	.debug	# 1418
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x88
	ld	c,d
	ld	b,d
	call	__ladd##
	ld	hl,(ix-4)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	de,0x70
	call	__ulmlt##
	call	__ladd##
	ld	hl,bc
	ld	(ix-41),hl
	ex	de,hl
	ld	(ix-43),hl
	ex	de,hl
;1419     printf("\r\nentry %2u: ", ui);
	.debug	# 1419
	ld	hl,(ix-4)
	push	hl
	ld	de,word (phys @11+776)
	ld	c,phys @11+776 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1420 
;1421     if ((file->flags & FILE_ACTIVE) == 0)  {
	.debug	# 1421
	ld	hl,(ix-43)
	ex	de,hl
	ld	hl,(ix-41)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x66
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ld	hl,0x1
	and	hl,de
	jr	nz,@492
;1422       printf("<unused>\r\n");  continue; }
@493:
	.debug	< @493 @494
	.debug	# 1422
	ld	de,word (phys @11+790)
	ld	c,phys @11+790 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	jp	@489
@494:
	.debug	>
;1423 
;1424     printf("%ls\r\n", file->name);
@492:
	.debug	# 1424
	ld	hl,(ix-43)
	ex	de,hl
	ld	hl,(ix-41)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @11+801)
	ld	c,phys @11+801 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;1425     spaceUsed = 0;  blkNum = file->startblock;  numBlks = 0;
	.debug	# 1425
	ld	de,0
	ld	c,e
	ld	b,e
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
	ld	hl,(ix-43)
	ex	de,hl
	ld	hl,(ix-41)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x64
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-32),hl
	bool	hl
	ld	l,h
	ld	(ix-6),hl
;1426 
;1427     for (;;)  {
@495:
	.debug	< @495 @496
@497:
;1428       if (blkNum == EOF_BLK)  break;
@500:
	.debug	< @500 @501
	.debug	# 1428
	ld	hl,(ix-32)
	ld	de,0xffff
	or	a,a
	sbc	hl,de
	jp	z,@498
;1429 
;1430       if (!blkNum OR (blkNum >= config_table->num_blocks))  {
	.debug	# 1430
	ld	hl,(ix-32)
	bool	hl
	jr	z,@503
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61a
	ld	b,h
	ld	c,h
	call	__ladd##
	call	__farld2##
	ld	hl,(ix-32)
	or	a,a
	sbc	hl,de
	jr	c,@504
@503:
;1431         printf("  Invalid sector # %u\r\n", blkNum);  ++numErrs; }
@505:
	.debug	< @505 @506
	.debug	# 1431
	ld	hl,(ix-32)
	push	hl
	ld	de,word (phys @11+807)
	ld	c,phys @11+807 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
@506:
	.debug	>
;1432 
;1433       ++numBlks;
@504:
	.debug	# 1433
	ld	hl,(ix-6)
	inc	hl
	ld	(ix-6),hl
;1434 
;1435       chkdFlag = chkdBlocks + (blkNum >> 3);  mask = 1 << (blkNum & 7);
	.debug	# 1435
	ld	hl,(ix-32)
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ex	de,hl
	ld	hl,-171+@479
	add	hl,sp
	add	hl,de
	ld	(ix-39),hl
	ld	hl,(ix-32)
	ld	de,0x7
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@507
	ld	b,a
@508:
	add	hl,hl
	djnz	@508
@507:
	ld	(ix-37),l
;1436       if (*chkdFlag & mask)  {
	.debug	# 1436
	ld	hl,(ix-39)
	ld	a,(hl)
	ld	hl,(ix-37)
	and	a,l
	jr	z,@509
;1437         printf("  Cross-linked sector # %u\r\n", blkNum);  ++numErrs; }
@510:
	.debug	< @510 @511
	.debug	# 1437
	ld	hl,(ix-32)
	push	hl
	ld	de,word (phys @11+831)
	ld	c,phys @11+831 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
@511:
	.debug	>
;1438 
;1439       *chkdFlag |= mask;  spaceUsed += sectorSize;
@509:
	.debug	# 1439
	ld	hl,(ix-39)
	ld	a,(hl)
	ld	hl,(ix-37)
	or	a,l
	ld	hl,(ix-39)
	ld	(hl),a
	ld	hl,(ix-36)
	ex	de,hl
	ld	bc,0
	push	bc
	push	de
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	call	__ladd##
	ld	hl,bc
	ld	(ix-16),hl
	ex	de,hl
	ld	(ix-18),hl
	ex	de,hl
;1440       blkNum = config_table->nextBlock[blkNum];
	.debug	# 1440
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61e
	ld	bc,0
	call	__ladd##
	ld	hl,(ix-32)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-32),hl
;1441     }
@501:
	.debug	>
;1442     printf("  %3d sectors:  Size: %6lu   on disk: %6lu\r\n",
	jp	@497
@498:
@496:
	.debug	>
;1443            numBlks, file->size, spaceUsed);
	.debug	# 1443
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-43)
	ex	de,hl
	ld	hl,(ix-41)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-6)
	push	hl
	ld	de,word (phys @11+860)
	ld	c,phys @11+860 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,14
;1444 
;1445     usedBlks += numBlks;
	.debug	# 1445
	ld	hl,(ix-10)
	ex	de,hl
	ld	hl,(ix-6)
	ex	de,hl
	add	hl,de
	ld	(ix-10),hl
;1446 
;1447     if ((spaceUsed >= file->size) AND ((spaceUsed - file->size) <= sectorSi
	.debug	# 1447
	ld	hl,(ix-43)
	ex	de,hl
	ld	hl,(ix-41)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	call	__lsubr##
	jr	c,@513
	ld	hl,(ix-43)
	ex	de,hl
	ld	hl,(ix-41)
	ld	bc,hl
	push	bc
	push	de
	ld	de,0x68
	ld	c,d
	ld	b,d
	call	__ladd##
	call	__farld4##
	push	bc
	push	de
	ld	hl,(ix-18)
	ex	de,hl
	ld	hl,(ix-16)
	ld	bc,hl
	call	__lsubr##
	ld	hl,(ix-36)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	call	__lsub##
	jr	z,@489
	jr	c,@489
;1448       continue;
	.debug	# 1448
;1449 
;1450     printf("  Size error\r\n");  ++numErrs;
@513:
	.debug	# 1450
	ld	de,word (phys @11+905)
	ld	c,phys @11+905 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
;1451   }
@491:
	.debug	>
;1452   printf("\r\n");
@489:
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jp	@487
@488:
@486:
	.debug	>
	.debug	# 1452
	ld	de,word (phys @11+54)
	ld	c,phys @11+54 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,4
;1453 
;1454 
;1455 //--- check all the unused blocks ---
;1456   for (ui=0; ui<ttlBlks; ++ui)  {
@515:
	.debug	< @515 @516
	.debug	# 1456
	bool	hl
	ld	l,h
	ld	(ix-4),hl
@517:
	ld	hl,(ix-4)
	ex	de,hl
	ld	hl,(ix-8)
	ex	de,hl
	or	a,a
	sbc	hl,de
	jp	nc,@518
;1457     chkdFlag = chkdBlocks + (ui >> 3);  mask = 1 << (ui & 7);
@520:
	.debug	< @520 @521
	.debug	# 1457
	ld	hl,(ix-4)
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	or	a,a
	rr	hl
	ex	de,hl
	ld	hl,-171+@479
	add	hl,sp
	add	hl,de
	ld	(ix-39),hl
	ld	hl,(ix-4)
	ld	de,0x7
	and	hl,de
	ld	a,l
	ld	hl,0x1
	or	a,a
	jr	z,@522
	ld	b,a
@523:
	add	hl,hl
	djnz	@523
@522:
	ld	(ix-37),l
;1458     if (*chkdFlag & mask)  continue;
	.debug	# 1458
	ld	hl,(ix-39)
	ld	a,(hl)
	ld	hl,(ix-37)
	and	a,l
	jr	nz,@519
;1459     nextBlk = config_table->nextBlock[ui];
	.debug	# 1459
	ld	de,(_config_table)
	ld	bc,(_config_table+2)
	push	bc
	push	de
	ld	de,0x61e
	ld	bc,0
	call	__ladd##
	ld	hl,(ix-4)
	push	bc
	push	de
	ex	de,hl
	ld	bc,0
	ld	a,0x1
	call	__lshl##
	call	__ladd##
	call	__farld2##
	ex	de,hl
	ld	(ix-34),hl
;1460     if (!nextBlk) { ++freeBlks;  continue; }
	.debug	# 1460
	bool	hl
	jr	nz,@525
@526:
	.debug	< @526 @527
	ld	hl,(ix-12)
	inc	hl
	ld	(ix-12),hl
	jr	@519
@527:
	.debug	>
;1461     if ((nextBlk & 0xfffe) == 0xfffe)  { ++rsvdBlks;  continue; }
@525:
	.debug	# 1461
	ld	hl,(ix-34)
	res	0,l
	ld	de,0xfffe
	or	a,a
	sbc	hl,de
	jr	nz,@528
@529:
	.debug	< @529 @530
	ld	hl,(ix-14)
	inc	hl
	ld	(ix-14),hl
	jr	@519
@530:
	.debug	>
;1462     printf("Unused sector # %4u linked to sector # %4u\r\n", ui, nextBlk);
@528:
	.debug	# 1462
	ld	hl,(ix-34)
	push	hl
	ld	hl,(ix-4)
	push	hl
	ld	de,word (phys @11+920)
	ld	c,phys @11+920 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,8
;1463     ++numErrs;
	.debug	# 1463
	ld	hl,(ix-2)
	inc	hl
	ld	(ix-2),hl
;1464   }
@521:
	.debug	>
;1465 
;1466 
;1467   usedBytes = (ulong) usedBlks * sectorSize;
@519:
	ld	hl,(ix-4)
	inc	hl
	ld	(ix-4),hl
	jp	@517
@518:
@516:
	.debug	>
	.debug	# 1467
	ld	hl,(ix-10)
	ex	de,hl
	ld	bc,0
	ld	hl,(ix-36)
	push	bc
	push	de
	ex	de,hl
	call	__ulmlt##
	ld	hl,bc
	ld	(ix-20),hl
	ex	de,hl
	ld	(ix-22),hl
	ex	de,hl
;1468   freeBytes = (ulong) freeBlks * sectorSize;
	.debug	# 1468
	ld	hl,(ix-12)
	ex	de,hl
	ld	bc,0
	ld	hl,(ix-36)
	push	bc
	push	de
	ex	de,hl
	call	__ulmlt##
	ld	hl,bc
	ld	(ix-24),hl
	ex	de,hl
	ld	(ix-26),hl
	ex	de,hl
;1469   rsvdBytes = (ulong) rsvdBlks * sectorSize;
	.debug	# 1469
	ld	hl,(ix-14)
	ex	de,hl
	ld	bc,0
	ld	hl,(ix-36)
	push	bc
	push	de
	ex	de,hl
	call	__ulmlt##
	ld	hl,bc
	ld	(ix-28),hl
	ex	de,hl
	ld	(ix-30),hl
	ex	de,hl
;1470 
;1471   printf(" used: %6lu bytes (%4u blocks)\r\n"
;1472          " rsvd: %6lu bytes (%4u blocks)\r\n"
;1473          " free: %6lu bytes (%4u blocks)\r\n",
;1474           usedBytes, usedBlks, rsvdBytes, rsvdBlks, freeBytes, freeBlks );
	.debug	# 1474
	ld	hl,(ix-12)
	push	hl
	ld	hl,(ix-26)
	ex	de,hl
	ld	hl,(ix-24)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-14)
	push	hl
	ld	hl,(ix-30)
	ex	de,hl
	ld	hl,(ix-28)
	ld	bc,hl
	push	bc
	push	de
	ld	hl,(ix-10)
	push	hl
	ld	hl,(ix-22)
	ex	de,hl
	ld	hl,(ix-20)
	ld	bc,hl
	push	bc
	push	de
	ld	de,word (phys @11+965)
	ld	c,phys @11+965 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,22
;1475 
;1476   printf("\r\n %d errors\r\n\n", numErrs);
	.debug	# 1476
	ld	hl,(ix-2)
	push	hl
	ld	de,word (phys @11+1062)
	ld	c,phys @11+1062 >> 16
	push	bc
	push	de
	lcall	$farprintf
	add	sp,6
;1477 
;1478   return numErrs;
	.debug	# 1478
	ld	hl,(ix-2)
;1479 }
@480:
	.debug	} @480 1479

@479	equ	171
	ld	sp,ix
	pop	ix
	lret
@481	equ	173
;1480 
;1481 
;1482 //-------------------------------------------------------------------------
;1483 
	.extern	$time 73
	.extern	_memset 74
	.extern	_strlen 49
	.extern	$fmemcpy 76
	.extern	_fmemset 78
	.extern	_fstrcmp 79
	.extern	_fstrcpy 80
	.extern	_fstrlen 81
	.extern	__disabled 3
	.extern	_current 82
	.extern	$farfprintf 84
	.extern	$farprintf 85
	.extern	__FlashUnlock 9
	.extern	$GetFlashDeviceEnd 86
	.extern	$WriteFlash 87
	.extern	$ReadFlash 88
	.extern	$FlashError 64
	.extern	$xalloc 89
	.extern	$klockErr 90
	.extern	_KLOCK 47
	.extern	_KUNLOCK 47
	.extern	_diagLog 91
	.extern	$postMortem 90
	.extern	$Exit 53
	.bseg
_openFiles::
	.ds	88
	.debug	G _openFiles 92 0
_sector_size::
	.ds	2
	.debug	G _sector_size 5 0
	.debug	T	070008200004002100
	.debug	T	89010321005A0F1B000100480000000B626F6172645F6E616D6500
	.debug	T	090080000A495041646472657373000500840005706F727400
	.debug	T	0300860006666C616773000300870005696E6974005D008800
	.debug	T	0666696C6573000300C805087072696D617279000300C90507
	.debug	T	6261636B7570005E00CA050A696E69745F61646472005E00F2
	.debug	T	050A696E69745F646174610005001A060B6E756D5F626C6F63
	.debug	T	6B730005001C060C736563746F725F73697A65005F001E060A
	.debug	T	6E657874426C6F636B0060001E0E0B6D6F64656D5F696E6974
	.debug	T	0009006A0E0A636F6D6D5F626175640009006E0E097365725F
	.debug	T	62617564006100720E0D70686F6E655F6E756D626572000300
	.debug	T	920E0B636F6D6D5F666C616773000300930E0A636F6D6D5F70
	.debug	T	6F7274000300940E097365725F706F7274000300950E0A7365
	.debug	T	725F666C616773000900960E0876657273696F6E0062009A0E
	.debug	T	0773666C617368006300A70E0A5A574944426C6F636B006400
	.debug	T	2B0F0A53544944426C6F636B000900520F046B657900090056
	.debug	T	0F105A5755736572426C6F636B4164647200
	.debug	T	0B000222000100060001000000
	.debug	T	0F00022300020024000600000026000200
	.debug	T	070000240002002500
	.debug	T	660003250016000700010007000000076661744964780007000200
	.debug	T	0A637572426C6B4E756D000900040004706F7300090008000A
	.debug	T	736563746F72506F73002E000C000C736563746F725F627566
	.debug	T	66002E00100009627566665F707472000600140006666C6167
	.debug	T	7300
	.debug	T	070000260002002700
	.debug	T	070008270004002800
	.debug	T	420003280070000500010065000000056E616D6500050064000B73
	.debug	T	74617274626C6F636B000500660006666C6167730009006800
	.debug	T	0573697A650009006C00056461746500
	.debug	T	0B000229000100050005000000
	.debug	T	0F00022A00020001000500000005000200
	.debug	T	0B00022B000100050001000000
	.debug	T	0700082C0004000500
	.debug	T	0F00022D0002000100070000002E000200
	.debug	T	0700082E0004000300
	.debug	T	0B00022F000100010001000000
	.debug	T	0B000230000100080001000000
	.debug	T	0B000231000100060032000000
	.debug	T	070000320002000300
	.debug	T	0B000233000100010024000000
	.debug	T	130002340003000700270000002400040003000600
	.debug	T	0B000235000100010006000000
	.debug	T	0B000236000100060006000000
	.debug	T	0B000237000100080006000000
	.debug	T	0B000238000100080032000000
	.debug	T	0F00023900020001000700000032000200
	.debug	T	1300023A0003000600060000000800020006000600
	.debug	T	1300023B0003000600060000002E00020006000600
	.debug	T	0B00023C000100270007000000
	.debug	T	0F00023D0002000600060000003E000200
	.debug	T	0700003E0002003F00
	.debug	T	BB00033F002A000D00057374617400090000000773745F64657600
	.debug	T	090004000773745F696E6F00090008000873745F6D6F646500
	.debug	T	06000C000973745F6E6C696E6B0006000E000773745F756964
	.debug	T	00060010000773745F67696400090012000873745F72646576
	.debug	T	00090016000873745F73697A650006001A000B73745F626C6B
	.debug	T	73697A650006001C000A73745F626C6F636B730009001E0009
	.debug	T	73745F6174696D6500090022000973745F6D74696D65000900
	.debug	T	26000973745F6374696D6500
	.debug	T	0B000240000100090001000000
	.debug	T	0B000241000100060009000000
	.debug	T	0F00024200020032003200000006000200
	.debug	T	0F00024300020006003200000032000200
	.debug	T	0F00024400020006003200000045000200
	.debug	T	070000450002004600
	.debug	T	290003460008000200087574696D62756600090000000761637469
	.debug	T	6D650009000400086D6F6474696D6500
	.debug	T	0B000247000100060003000000
	.debug	T	0900014800800003008000
	.debug	T	0B000249000100090066000000
	.debug	T	1300024A0003004B004B0000000600020007000400
	.debug	T	0700004B0002000100
	.debug	T	1300024C0003004D004D0000004D00040009000800
	.debug	T	0700084D0004000100
	.debug	T	1300024E0003004D004D0000000600040009000600
	.debug	T	0F00024F00020006002E0000002E000400
	.debug	T	0F00025000020001002E0000002E000400
	.debug	T	0B00025100010009002E000000
	.debug	T	070000520002005300
	.debug	T	7702035300E8002D000C7461736B5F737472756374006700000006
	.debug	T	737461636B00670002000C737461636B5F7374617274000700
	.debug	T	04000B737461636B5F73697A65000300060005737365670003
	.debug	T	0007000773746B6C6C7200030008000773746B686C72000300
	.debug	T	09000677707361720007000A0008777073616C68720003000C
	.debug	T	000677707362720007000D0008777073626C68720068000F00
	.debug	T	064644536574000300110009757365436F756E740003001200
	.debug	T	08636C61696D65640007001300067374617465005200150007
	.debug	T	6D794164647200030017000A7A65726F416674657200060018
	.debug	T	0005617267630069001A0005617267760048001C0005617267
	.debug	T	73006A009C0007776169745173000900A0000C7369675F7065
	.debug	T	6E64696E67000900A4000C7369675F626C6F636B6564000600
	.debug	T	A8000E707265656D70745F636F756E74000300AA0006696E55
	.debug	T	7365000300AB000565786974000300AC000A6C6F675374646F
	.debug	T	7574000300AD000B7265646972537464696F000900AE000A64
	.debug	T	696167466C616773006B00B2000970726F634D61696E000600
	.debug	T	B40004706964000600B6000570706964000300B80009707269
	.debug	T	6F72697479000600B900086C617374457272000900BB000873
	.debug	T	746172746564000900BF000C6C617374526573756D65640009
	.debug	T	00C3000C6C61737453746F70706564000900C7000C6C617374
	.debug	T	52756E6E696E67000900CB000D726573756D65645469636B73
	.debug	T	000900CF000A7469636B7355736564000900D300076D735573
	.debug	T	6564000300D700096F7574436F756E74002E00D800076F7574
	.debug	T	507472000900DC000B736C6565705469636B73000900E0000D
	.debug	T	736C65657053746172746564000900E4000D74696D656F7574
	.debug	T	5469636B7300
	.debug	T	1300025400030006006D0000002E0002000D000000
	.debug	T	0F00025500020006002E0000000D000000
	.debug	T	0F0002560002000900090000006E000400
	.debug	T	1300025700030006002E0000002E00040009000800
	.debug	T	1300025800030001002E0000002E00040009000800
	.debug	T	0B0002590001002E0009000000
	.debug	T	0B00025A00010001002E000000
	.debug	T	5400035B000C00060001006F000000065F5F6F7574007100020005
	.debug	T	5F5F696E0073000400085F5F77726974650073000600075F5F
	.debug	T	726561640006000800085F5F756E676574004B000A000B5F5F
	.debug	T	757365724461746100
	.debug	T	0900015C00580025000400
	.debug	T	0900015D00400528000C00
	.debug	T	0900015E00280003002800
	.debug	T	0900015F00000805000004
	.debug	T	09000160004C0003004C00
	.debug	T	0900016100200003002000
	.debug	T	58000362000D00060001000300000005706F727400030001000863
	.debug	T	735F706F727400030002000863735F6D61736B00090003000C
	.debug	T	73746172745F626C6F636B00090007000573697A650005000B
	.debug	T	000B626C6F636B5F73697A6500
	.debug	T	D50103630084001E000100060000000D7461626C6556657273696F
	.debug	T	6E00060002000A70726F64756374494400060004000976656E
	.debug	T	646F72494400750006000A74696D657374616D700008000D00
	.debug	T	08666C617368494400060011000A666C617368547970650006
	.debug	T	0013000A666C61736853697A6500060015000B736563746F72
	.debug	T	53697A6500060017000B6E756D536563746F72730006001900
	.debug	T	0B666C61736853706565640008001B0009666C617368324944
	.debug	T	0006001F000B666C617368325479706500060021000B666C61
	.debug	T	73683253697A6500060023000C736563746F723253697A6500
	.debug	T	060025000C6E756D32536563746F727300060027000C666C61
	.debug	T	736832537065656400080029000672616D49440006002D0008
	.debug	T	72616D53697A650006002F000972616D537065656400060031
	.debug	T	0006637075494400080033000C6372797374616C4672657100
	.debug	T	76003700086D6163416464720077003D000D73657269616C4E
	.debug	T	756D62657200780055000C70726F647563744E616D65007900
	.debug	T	730009726573657276656400080074000C6964426C6F636B53
	.debug	T	697A6500060078000E75736572426C6F636B53697A65000600
	.debug	T	7A000D75736572426C6F636B4C6F630006007C000B6964426C
	.debug	T	6F636B4352430076007E00076D61726B657200
	.debug	T	7B0003640027000800010009000000066D6167696300030004000A
	.debug	T	626C6F636B53697A6500050005000B696E436865636B73756D
	.debug	T	00030007000E76657273696F6E4E756D626572000300080009
	.debug	T	76656E646F72494400050009000A70726F647563744944007A
	.debug	T	000B00086D616341646472007B00170006666C61736800
	.debug	T	0900016500640003006400
	.debug	T	070000660002000900
	.debug	T	070000670002000700
	.debug	T	070000680002004D00
	.debug	T	070000690002003200
	.debug	T	2800036A0004000100125F5F776169745F71756575655F68656164
	.debug	T	007D000000096C6973744865616400
	.debug	T	0700006B0002006C00
	.debug	T	0F00026C00020001000600000069000200
	.debug	T	0700006D0002005B00
	.debug	T	0700006E0002000500
	.debug	T	0700006F0002007000
	.debug	T	0F0002700002000600030000004B000200
	.debug	T	070000710002007200
	.debug	T	0B00027200010006004B000000
	.debug	T	070000730002007400
	.debug	T	1300027400030008002E000000080004004B000800
	.debug	T	0900017500070003000700
	.debug	T	0900017600060003000600
	.debug	T	0900017700180003001800
	.debug	T	09000178001E0003001E00
	.debug	T	0900017900010003000100
	.debug	T	0900017A000C0076000200
	.debug	T	0900017B0010007C000200
	.debug	T	4400037C000800040001000500000008666C617368494400050002
	.debug	T	000A666C6173685479706500050004000A666C61736853697A
	.debug	T	6500050006000B6E756D536563746F727300
	.debug	T	2600037D00040002000A6C6973745F68656164007E000000056E65
	.debug	T	7874007E000200057072657600
	.debug	T	0700007E0002007D00
	.defseg	FARCONST
	.seg	FARCONST
@11:
	.db	"Flash File driver data corrupted",0,"Flash Sector Size: %u",13,10,0,"For flash file FAT:",13,10,0,"*** Un"
	.db	"able to initialize Flash File driver ***",13,10,0,"in-flash CONFIG_TABLE found at: 0x%lX",13,10,0,"ge"
	.db	"tNextBlock",0,"setNextBlock",0,"get_freeblock",0,"read_block",0,"write_block",0,"***** Error writing to f"
	.db	"lash address: %06lX *****",13,10,0,"update_config",0,"next_handle",0,"next_file",0,"ffile_index",0,"For secto"
	.db	"r buf:",13,10,0,"fflush_file",0,"ffile_open",0,"ffile_close",0,"ffile_delete",0,"ffile_delete_index",0,"ffile_cre"
	.db	"ate",0,"ffile_FATLink",0,"ffile_size",0,"ffile_sizen",0,"ffile_name",0,"<invalid>",0,"ffile_tell",0,"ffile_seek",0,"f"
	.db	"file_read",0,"ffile_write",0,"ffile_setPrimary",0,"ffile_setBackup",0,"ffile_getPrimary",0,"ffile_getBack"
	.db	"up",0,"ffile_getInit",0,"ffile_setInit",0,"ffile_rename",0,"ffile_handle2Index",0,"ffile_info",0,"ffile_fstat"
	.db	0,"ffile_unread",0,13,10,"%u bytes/sector,  %u sectors,  Total %lu bytes",13,10,0,"# sectors > MAX_BLK_"
	.db	"NUM (%u)",13,10,0,13,10,"entry %2u: ",0,"<unused>",13,10,0,"%ls",13,10,0,"  Invalid sector # %u",13,10,0,"  Cross-linked sect"
	.db	"or # %u",13,10,0,"  %3d sectors:  Size: %6lu   on disk: %6lu",13,10,0,"  Size error",13,10,0,"Unused sector #"
	.db	" %4u linked to sector # %4u",13,10,0," used: %6lu bytes (%4u blocks)",13,10," rsvd: %6lu bytes (%4u "
	.db	"blocks)",13,10," free: %6lu bytes (%4u blocks)",13,10,0,13,10," %d errors",13,10,10,0
	.end
